prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4413
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4413 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4413
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110305503123364007')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'fr'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4413)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112715'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4413)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4413)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('D\00E9connexion')
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>unistr('Se d\00E9connecter d''Application Express')
,p_list_text_09=>'O'
,p_list_text_10=>'logout exit quit :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4413)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Cr\00E9er une application sur une feuille de calcul')
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>unistr('Importez vos fichiers Excel ou CSV et cr\00E9ez une application')
,p_list_text_09=>'O'
,p_list_text_10=>'excel csv xsl xslx spreadsheet data paste load import'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4413)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Page d''accueil Oracle APEX'
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>unistr('page d''accueil d\00E9marrer ')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4413)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Parcourir les ic\00F4nes Police APEX')
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('Parcourez les ic\00F4nes Police APEX, ajoutez des modificateurs et copiez le code CSS ou HTML dont vous avez besoin.')
,p_list_text_09=>'O'
,p_list_text_10=>unistr('Graphiques de la biblioth\00E8que d''ic\00F4nes Police APEX')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4413)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4413)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Exporter une application'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>'Exporter l''application {APP_ID} sous forme de fichier SQL'
,p_list_text_09=>'O'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4413)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Listes inutilis\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4413)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4413)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4413)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4413)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4413)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4413)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4413)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4413)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4413)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4413)
,p_theme_id=>1
,p_name=>'One Level Tabs.fr'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4413)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4413)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4413)
,p_theme_id=>1
,p_name=>'Printer Friendly.fr'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4413)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4413)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4413)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4413)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4413)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4413)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4413)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4413)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4413)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4413)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4413)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4413)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4413)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4413)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4413)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4413)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>'Dialogue de recherche'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>'Rechercher'
,p_close_button_text=>'Fermer'
,p_next_button_text=>'Suivant >'
,p_prev_button_text=>unistr('< Pr\00E9c\00E9dent')
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Ligne(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4413)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4413)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4413)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845082469305424)
,p_name=>'2DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 2D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847137987305425)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'fr'
,p_message_text=>'A courbes de colonnes 2D'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845195258305424)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'fr'
,p_message_text=>'En anneau 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846915252305425)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 2D, horizontales, empil\00E9es (%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845296971305424)
,p_name=>'2DLINE'
,p_message_language=>'fr'
,p_message_text=>'A courbes 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845381793305424)
,p_name=>'2DPIE'
,p_message_language=>'fr'
,p_message_text=>'A secteurs 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846736204305425)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 2D, empil\00E9es (%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845411392305424)
,p_name=>'3DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847070473305425)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 3D, horizontales, empil\00E9es (%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845577026305424)
,p_name=>'3DPIE'
,p_message_language=>'fr'
,p_message_text=>'A secteurs 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846856193305425)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 3D, empil\00E9es (%)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614963549306024)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('0 \00E9l\00E9ment pour l''insertion dans le dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614728518306024)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('0 \00E9l\00E9ment pour la mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615109034306024)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('0 \00E9l\00E9ment pour la mise \00E0 jour du dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615533321306025)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('0 colonne d''\00E9tat pour l''insertion dans le dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615776873306025)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('0 colonne d''\00E9tat pour la mise \00E0 jour du dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614664399306024)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier %0 \00E9l\00E9ments pour la mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615339188306024)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('0 colonne d''\00E9tat pour la mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614861316306024)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier %0 \00E9l\00E9ments pour l''insertion dans le dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615067582306024)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier %0 \00E9l\00E9ments pour la mise \00E0 jour du dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615468638306025)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier %0 colonnes d''\00E9tat pour l''insertion dans le dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615260630306024)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier %0 colonnes d''\00E9tat pour la mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615643547306025)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier %0 colonnes d''\00E9tat pour la mise \00E0 jour du dictionnaire d''attributs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407373090305867)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392558584305857)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'fr'
,p_message_text=>unistr('<span class="fielddata"> Impossible de r\00E9organiser car les s\00E9quences de r\00E9gions ne sont pas uniques.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392611535305857)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'fr'
,p_message_text=>unistr('<span class="fielddata">Impossible de r\00E9organiser car les s\00E9quences de boutons ne sont pas uniques.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392789798305857)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'fr'
,p_message_text=>unistr('<span class="fielddata">Impossible de r\00E9organiser car les s\00E9quences de barres de navigation ne sont pas uniques.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392852547305857)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'fr'
,p_message_text=>unistr('<span class="fielddata"> Impossible de r\00E9organiser car les s\00E9quences d''\00E9l\00E9ments de r\00E9gion ne sont pas uniques.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461784890305909)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976481813305527)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Modifier l''application : %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366068578305837)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le format de date indiqu\00E9 n''est pas valide. Le calendrier requiert une date au format YYYYMMDD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412094189305871)
,p_name=>'4000_TREE'
,p_message_language=>'fr'
,p_message_text=>'Arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461849357305909)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''espace de travail'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256429387305755)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le nom du sch\00E9ma \00E0 cr\00E9er. Choisissez'),
unistr('         un mot de passe pour ce sch\00E9ma et s\00E9lectionnez les tablespaces par d\00E9faut'),
'         et temporaire.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256553474305755)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom d''un sch\00E9ma existant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256610807305755)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque vous avez termin\00E9, cliquez sur <strong>Suivant</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126770861305641)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer les tablespaces et les fichiers de donn\00E9es associ\00E9s : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126603506305640)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer les utilisateurs de base de donn\00E9es : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990548689306323)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal des activit\00E9s de service Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838673955305419)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal de synchronisation REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839499829305420)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal d''automatisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250321776305750)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal des activit\00E9s de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889264271305457)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal de connexions \00E0 Access')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249857707305750)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'fr'
,p_message_text=>'Demandes de modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249918820305750)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'fr'
,p_message_text=>'Demandes runtime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249640925305750)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'fr'
,p_message_text=>'Demandes d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252110366305751)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de l''historique du processeur de commandes SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252068175305751)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal d''ex\00E9cution du fichier de contr\00F4le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251976459305751)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de journal d''ex\00E9cution de fichier de script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252268818305752)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es des archives SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253942899305753)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'fr'
,p_message_text=>'Informations sur le fichier journal actif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254075467305753)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de journal en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254195365305753)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'fr'
,p_message_text=>'Horodatage de journal en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254741400305753)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'fr'
,p_message_text=>'Heures jusqu''au prochain changement de fichier de journalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254363036305753)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'fr'
,p_message_text=>'Intervalle en jours (constante)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254644376305753)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Prochain changement de fichier de journalisation pr\00E9vu pour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255092108305754)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal des activit\00E9s de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255264044305754)
,p_name=>'4050_71_CLICK'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal des clics')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256062459305754)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de l''historique du processeur de commandes SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255938496305754)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal d''ex\00E9cution du fichier de contr\00F4le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255781755305754)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de journal d''ex\00E9cution de fichier de script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256108912305754)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es des archives SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256233121305754)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'L''espace de travail %1 contient %2 applications et %3 utilisateurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256330336305754)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal des clics')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437444614305890)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications \00E9chantillon et de productivit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437569835305890)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'fr'
,p_message_text=>unistr('Feuilles Web \00E9chantillon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436781073305889)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre d''espaces de travail'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183848344305683)
,p_name=>'4350_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183974466305683)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Modifier l''application'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903714745305468)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'fr'
,p_message_text=>'Oracle Database Express Edition 2 Day DBA.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903867760305468)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'fr'
,p_message_text=>'Oracle Database Express Edition 2 Day Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903687369305468)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Express 2 Day Plus Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903955476305468)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'fr'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus Java Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904003516305468)
,p_name=>'4500 800 HD NET'
,p_message_language=>'fr'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus .NET Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904109682305468)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'fr'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus PHP Developer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904286123305468)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce document traite des t\00E2ches d''administration courantes au jour le jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904396904305468)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'fr'
,p_message_text=>'Ce document explique comment tirer parti de l''environnement Oracle Database Express Edition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904408161305468)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce document fournit une s\00E9rie de tutoriels qui d\00E9crivent comment construire des applications Web centr\00E9es sur une base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904685136305469)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce document fournit un tutoriel qui vous explique comment utiliser Java et JDBC pour vous connecter \00E0 Oracle Database XE et comment d\00E9velopper une application Java simple qui acc\00E8de aux donn\00E9es et les modifie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904747211305469)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce document d\00E9crit les fonctionnalit\00E9s-cl\00E9s d''Oracle Data Provider for .NET et d''Oracle Developer Tools for Visual Studio .NET. Il traite de l''installation et de la configuration, vous explique comment construire des applications de base au moyen d''O')
||unistr('racle Data Provider for .NET et d''Oracle Developer Tools for Visual Studio .NET et comment cr\00E9er et utiliser les proc\00E9dures stock\00E9es PL/SQL et .NET.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904582426305468)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce document fournit un tutoriel qui vous explique comment t\00E9l\00E9charger et installer Apache et les pilotes Zend Core PHP et comment utiliser PHP pour vous connecter \00E0 Oracle Database XE puis pour d\00E9velopper une application simple qui acc\00E8de aux donn\00E9es')
||' et les modifie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875232316305446)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875135768305446)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875487139305446)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307004358305794)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875830687305447)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875976865305447)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'fr'
,p_message_text=>'Grouper par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875320193305446)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'fr'
,p_message_text=>'Objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875713925305447)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875548350305447)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'fr'
,p_message_text=>'Type de tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875691209305447)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'fr'
,p_message_text=>'Ordre de tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878425731305449)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'fr'
,p_message_text=>'Jointure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872260669305444)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez ici pour s\00E9lectionner une colonne pour la jointure.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878895949305449)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Un maximum de 60 colonnes peut \00EAtre s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872187722305444)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872009302305444)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'fr'
,p_message_text=>'Afficher/Masquer les colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878576535305449)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'fr'
,p_message_text=>'vers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871075007305443)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats de %0, ex\00E9cution %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127347409305641)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0 la requ\00EAte initiale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886226659305455)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les %0 premi\00E8res colonnes sont affich\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334679617305814)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334592691305814)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'fr'
,p_message_text=>'kilo-octets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334460151305814)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9ga-octets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907047632305470)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('App Builder utilise les valeurs par d\00E9faut de l''interface utilisateur pour remplir les valeurs initiales des propri\00E9t\00E9s de r\00E9gion et d''\00E9l\00E9ment, ce qui assure une coh\00E9rence entre les pages dans une ou plusieurs applications.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937125904305497)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'fr'
,p_message_text=>'Cette application requiert l''activation des cookies.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937028844305497)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>'Cette application requiert l''activation de JavaScript.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364393644305836)
,p_name=>'ABOUT'
,p_message_language=>'fr'
,p_message_text=>'A propos de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057823133306375)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Confirmez l''ajout des %0 utilisateurs suivants \00E0 l''espace de travail.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375847728305844)
,p_name=>'ACCEPTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Accept\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343907994305821)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'fr'
,p_message_text=>unistr('Destinataire de l''accessibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342021159305820)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'fr'
,p_message_text=>unistr('Impact de l''accessibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344385525305821)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Statut d''accessibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108762272306413)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Accessibilit\00E9 test\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017508278305559)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Droits d''administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883815977305453)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Page d''administration de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296243440305784)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'fr'
,p_message_text=>'Administrateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401146299305863)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le affect\00E9 aux administrateurs d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884045801305453)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Administration des applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884633605305453)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884522470305453)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifiez le mode de contr\00F4le d''acc\00E8s \00E0 cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885639620305454)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de traiter la demande de d\00E9finition du mode d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885709448305454)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mode d''application d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017992321305559)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez pas vous supprimer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018056206305559)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas vous enlever le privil\00E8ge d''administration.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883953416305453)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296154855305784)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Droits de contribution'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296354589305784)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'fr'
,p_message_text=>'Contributeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401280194305863)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le affect\00E9 aux contributeurs d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336819424305816)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les param\00E8tres d''application suivants seront cr\00E9\00E9s :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296487447305784)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les r\00F4les d''acc\00E8s aux applications suivants seront cr\00E9\00E9s :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901236639305466)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Les mod\00E8les d''autorisation suivants seront cr\00E9\00E9s :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957061587305512)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de contr\00F4le d''acc\00E8s. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956950210305512)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er les tables de contr\00F4le d''acc\00E8s. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019301073305560)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez saisir un nom utilisateur en double.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017606348305559)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('contr\00F4le d''acc\00E8s - modification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885355888305454)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des crit\00E8res de requ\00EAte sans distinction entre les majuscules et les minuscules, puis cliquez sur <strong>OK</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885440381305454)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''obtenir le mode d''administration de l''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885246352305454)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re modification par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884969240305454)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de contr\00F4le d''acc\00E8s (ACL)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884147614305453)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s complet \00E0 tous ; liste de contr\00F4le d''acc\00E8s non utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884285572305453)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s restreint. Seuls les utilisateurs d\00E9finis dans la liste de contr\00F4le d''acc\00E8s sont autoris\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884311437305453)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s public en lecture seule. Privil\00E8ges de modification et d''administration contr\00F4l\00E9s par la liste de contr\00F4le d''acc\00E8s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884477460305453)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s administratif uniquement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885570993305454)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 effectuer cette op\00E9ration.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885114626305454)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336710398305816)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Droits de lecteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336618493305816)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'fr'
,p_message_text=>'Lecteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401306617305863)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le affect\00E9 aux lecteurs d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902012263305466)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifiez les noms utilisateur correspondant \00E0 ce mod\00E8le d''authentification de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884760294305453)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le mode d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983100357305532)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation des pages de contr\00F4le d''acc\00E8s a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296567250305785)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser un r\00F4le de contr\00F4le d''acc\00E8s existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901992733305466)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser un mod\00E8le d''autorisation existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901192174305466)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Utiliser une table existante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017723849305559)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('contr\00F4le d''acc\00E8s - vue')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904921053305469)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590622084306006)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu de compte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324565985305807)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ception confirm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324766706305807)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ception confirm\00E9e, aucune action')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385260201305851)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993845985306326)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der au tableau de bord')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993923848306326)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der \00E0 la surveillance de l''activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993423712306326)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'fr'
,p_message_text=>'Ajouter/Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993752908306326)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Administration lors de l''ex\00E9cution de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992622790306325)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'fr'
,p_message_text=>'Administration depuis App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993327505306325)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Annotations (fichiers, balises, remarques)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992370758306325)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('Authentification du compte Application Express sans liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992293530306325)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('Authentification avec liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993008375306325)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier l''acc\00E8s SQL et les objets sugg\00E9r\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997063666306329)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Une fois l''authentification aupr\00E8s d''une application effectu\00E9e, le contr\00F4le d''acc\00E8s indique les op\00E9rations que les utilisateurs sont autoris\00E9s \00E0 effectuer dans l''application. La table ci-dessous identifie les diff\00E9rents droits accord\00E9s aux utilisateu')
||unistr('rs en fonction de l''authentification utilis\00E9e dans cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994066787306326)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer la liste de contr\00F4le d''acc\00E8s (ACL)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993129142306325)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter et visualiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992832017306325)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour les propri\00E9t\00E9s d''application')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610186032306021)
,p_name=>'ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991741332306324)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres du menu Actions')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913401652305475)
,p_name=>'ACTIVE'
,p_message_language=>'fr'
,p_message_text=>'Actif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303539766305791)
,p_name=>'ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345279826305822)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('R\00E9capitulatif de l''activit\00E9'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545890027305969)
,p_name=>'ADDED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajout\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988165848306322)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajout\00E9 \00E0 la liste des \00E9l\00E9ments \00E0 purger')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603034903306015)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations suppl\00E9mentaires demand\00E9es')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263355779305760)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un argument'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253775196305753)
,p_name=>'ADD_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une colonne :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451089341305901)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>'Ajouter la colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092987652305616)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une contrainte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251867984305751)
,p_name=>'ADD_MORE...'
,p_message_language=>'fr'
,p_message_text=>'Ajouter d''autres...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317633446305802)
,p_name=>'ADD_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456107807305905)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une interface utilisateur'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459631555305907)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajuster l''espace provisionn\00E9 de %0 Mo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250506814305750)
,p_name=>'ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Admin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839391062305419)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur de la banni\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839128658305419)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer la banni\00E8re d''environnement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839294228305419)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de banni\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258520301305756)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de banni\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897397781305463)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'fr'
,p_message_text=>'Administrateur d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345099321305822)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'fr'
,p_message_text=>'Administrateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257287917305755)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer les adresses \00E9lectroniques des administrateurs')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409599236305869)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Accessibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919808790305480)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920101842305480)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>'Performances'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920220623305480)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'fr'
,p_message_text=>unistr('Assurance qualit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919951488305480)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920369006305480)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisabilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920070156305480)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514573123305947)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment "%1" est prot\00E9g\00E9 et ne peut pas \00EAtre d\00E9fini via un appel AJAX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514656762305947)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment "%1" est prot\00E9g\00E9 et ne peut pas \00EAtre d\00E9fini via un appel AJAX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543988144305968)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment "%1" est prot\00E9g\00E9 et ne peut pas \00EAtre d\00E9fini via un appel AJAX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946292172305504)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe de sch\00E9ma SYS manquant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650200859306050)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisation des API WWV_FLOW (utiliser des API APEX \00E0 la place)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600520017306013)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne %0 n''existe pas dans l''instruction SQL de source de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929997244305489)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne %0 de l''\00E9tat interactif n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927664799305487)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'%0 n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907939344305471)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne %0 n''existe pas dans l''instruction SQL de source de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680313532306079)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'La colonne %0 du panneau tabulaire n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927707725305487)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ne peut pas \00EAtre r\00E9f\00E9renc\00E9 comme nom d''\00E9l\00E9ment d''application/de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062991980306378)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le processus d''application Fonction callback AJAX n''est pas prot\00E9g\00E9 par un mod\00E8le d''autorisation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062597591306378)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>unistr('La page n''est pas prot\00E9g\00E9e par un mod\00E8le d''autorisation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928626432305488)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('La page cible %1 (dans l''application %0) n''a aucun mod\00E8le d''autorisation d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064222876306379)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'fr'
,p_message_text=>unistr('L''autorisation de cette page est diff\00E9rente de l''autorisation "%1" de la page parent %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928721989305488)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'fr'
,p_message_text=>unistr('L''autorisation "%0" sur la page cible est diff\00E9rente de "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927295379305486)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'%0 n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927142188305486)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de v\00E9rifier la syntaxe de variable attach\00E9e. Erreur : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927311887305486)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ne peut pas \00EAtre r\00E9f\00E9renc\00E9 avec la syntaxe de variable attach\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929322737305489)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Branchement inconditionnel avant les autres branchements'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062375578306378)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9criture automatique est d\00E9finie sur Activ\00E9 pour une page contenant des \00E9l\00E9ments de mot de passe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062492276306378)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''option Cache autorise le navigateur \00E0 mettre en m\00E9moire cache des donn\00E9es confidentielles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862060992306215)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'fr'
,p_message_text=>unistr('L''option Imbriquer dans des cadres rend l''application vuln\00E9rable aux attaques de d\00E9tournement de clics.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862117241306215)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''option Mode d''\00E9chappement HTML proc\00E8de uniquement \00E0 l''\00E9chappement d''un ensemble limit\00E9 de caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850672708305428)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'fr'
,p_message_text=>unistr('Les \00E9l\00E9ments doivent utiliser des caract\00E8res sp\00E9ciaux d''\00E9chappement pour \00E9viter les attaques de scriptage inter-site (XSS).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869195540306221)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''en-t\00EAte de demande HTTP "Referer" peut \00EAtre \00E0 l''origine de la fuite d''informations de session sensibles vers des tiers.'),
unistr('Les applications doivent d\00E9finir "Referrer Policy" sur "strict-origin".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866734262305440)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ID trouv\00E9 dans les attributs de bouton, pour un bouton r\00E9f\00E9renc\00E9 dans une action dynamique (%0). '),
'',
unistr('La d\00E9finition d''un ID dans les attributs de bouton emp\00EAche le fonctionnement des actions dynamiques r\00E9f\00E9ren\00E7ant le bouton. Envisagez la suppression de cet ID car le bouton g\00E9n\00E9rera un ID par d\00E9faut.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866867089305440)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le mod\00E8le de bouton utilis\00E9 par un bouton, lui-m\00EAme r\00E9f\00E9renc\00E9 dans une action dynamique (%0), ne contient pas la cha\00EEne de substitution #BUTTON_ID#.'),
'',
unistr('Mod\00E8le :'),
'%1',
'',
unistr('Ajoutez la cha\00EEne de substitution #BUTTON_ID# \00E0 ce mod\00E8le ou choisissez un mod\00E8le de bouton contenant d\00E9j\00E0 la cha\00EEne #BUTTON_ID#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870149979305443)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action de bouton n''est pas de type D\00E9fini par une action dynamique pour un bouton r\00E9f\00E9renc\00E9 dans une action dynamique (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876213294305447)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('Le bouton (%0) contient une action de type D\00E9fini par une action dynamique, mais aucune action dynamique correspondante ne r\00E9f\00E9rence ce bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928374455305487)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'fr'
,p_message_text=>'La page Effacer le cache %0 n''est pas la page en cours ou la page cible %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927006027305486)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'%0 n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036188919306359)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur d''attribut est obsol\00E8te.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038675767306361)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Ce type de composant est en phase d''abandon.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514751763305947)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments prot\00E9g\00E9s dans les appels AJAX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946197734305504)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me de code (APEX interne)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925169729305484)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences d\00E9claratives d''\00E9l\00E9ments d''application, d''\00E9l\00E9ments de page, de colonnes ou de filtres d''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062262407306378)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>'Autorisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924831650305484)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences avec syntaxe de variable attach\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926296870305485)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>'Branchement inconditionnel avant les autres branchements'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062764170306378)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de s\00E9curit\00E9 de navigateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866644124305440)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'fr'
,p_message_text=>'Le bouton n''est pas compatible avec les actions dynamiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876050786305447)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences incoh\00E9rentes entre les actions dynamiques et les boutons')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925428477305484)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro de la page Effacer le cache est le m\00EAme que celui de la page cible ou en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924756730305484)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences avec syntaxe de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036054592306358)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeurs d''attribut obsol\00E8tes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925754077305484)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'fr'
,p_message_text=>'Les processus d''extraction, DML et MR* sont valides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926175381305485)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID d''application cod\00E9 en dur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321875031305805)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment de page poss\00E8de un texte d''aide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409371674305869)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'fr'
,p_message_text=>'La page a un titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433590738305887)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'fr'
,p_message_text=>unistr('Du texte alternatif d''image est d\00E9fini pour l''\00E9l\00E9ment Afficher l''image')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861869295306215)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs d''application pouvant \00EAtre verrouill\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924980140305484)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment r\00E9f\00E9renc\00E9 est sur la page en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925019211305484)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment r\00E9f\00E9renc\00E9 est l''\00E9l\00E9ment de page de la page cible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410016766305869)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment de page n''entra\00EEne aucune modification de contexte inattendue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410744888305870)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment de page poss\00E8de un libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926406428305485)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Longueur de l''\00E9l\00E9ment ou du nom de colonne de panneau tabulaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925206357305484)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences d''\00E9l\00E9ment de page dans une cha\00EEne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925356094305484)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro de page r\00E9f\00E9renc\00E9 existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409698789305869)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion a un en-t\00EAte de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926624843305485)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9tat suit l''ordre par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062864487306378)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>'Protection de statut de session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925874099305485)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'fr'
,p_message_text=>'Utilisation incorrecte de la syntaxe de substitution'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924636698305484)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences avec syntaxe de substitution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925616398305484)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'fr'
,p_message_text=>unistr('L''autorisation de page cible est \00E9galement d\00E9finie pour le composant en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409870333305869)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de th\00E8me test\00E9 en mati\00E8re d''accessibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504664282305940)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''interface utilisateur inclut la compatibilit\00E9 avec JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926315642305485)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment ou colonne associ\00E9 des validations')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925545209305484)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'fr'
,p_message_text=>'Est un code SQL ou PL/SQL valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926038239305485)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier la propri\00E9t\00E9 Clob')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100925944371305485)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction V utilis\00E9e dans les instructions SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926550267305485)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le bouton r\00E9f\00E9renc\00E9 dans l''op\00E9ration Lors de l''activation du bouton existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928919300305488)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'fr'
,p_message_text=>'Erreur de compilation - %0 Instruction : %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929279391305488)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Le lien contient l''ID d''application en cours sous forme de valeur cod\00E9e en dur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321728284305804)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun texte d''aide d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409453319305869)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('La page n''a pas de titre. L''utilisation de titres de page significatifs est importante en mati\00E8re d''accessibilit\00E9, afin d''aider les utilisateurs \00E0 comprendre le contenu et l''objectif de la page en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433621702305887)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne contient pas le texte alternatif requis pour l''image. Un texte adapt\00E9 \00E0 cet usage doit d\00E9crire de mani\00E8re ad\00E9quate le contenu de l''image et ne doit dupliquer aucune information visible sur la page affich\00E9e dans le contexte de l''image (af')
||unistr('in d''\00E9viter toute duplication). Remarque : si l''image est fournie par des utilisateurs, le texte alternatif de l''image doit l''\00EAtre aussi, avec des conseils appropri\00E9s qui aideront vos utilisateurs \00E0 fournir un texte de haute qualit\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861965609306215)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''option Syntaxe d''API d''ex\00E9cution autorise la modification d''espace de travail et d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927425812305486)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''est pas un \00E9l\00E9ment de la page %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927515082305486)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''est pas un \00E9l\00E9ment de la page cible %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410192510305870)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le param\00E8tre ''Action de page lors de la s\00E9lection'' de l''\00E9l\00E9ment de page peut entra\00EEner une modification de contexte inattendue pour l''utilisateur. Envisagez de basculer sur ''Aucune'' afin d''\00E9viter toute modification de contexte et de remplacer la fonc')
||unistr('tionnalit\00E9 par Actions dynamiques ou Listes de valeurs en cascade (si vous devez rester sur la m\00EAme page). Envisagez \00E9galement de fournir des informations \00E0 l''utilisateur afin qu''il sache ce qu''il se passera, par exemple en ajoutant ''Lance une nouvel')
||unistr('le page'' dans le libell\00E9. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433407706305887)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez d\00E9finir un libell\00E9 pour l''\00E9l\00E9ment. Si vous pr\00E9f\00E9rez que le libell\00E9 ne soit pas visible, vous pouvez tout de m\00EAme d\00E9finir un libell\00E9, puis s\00E9lectionner le mod\00E8le de libell\00E9 ''Masqu\00E9''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410889018305870)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment d\00E9finit une valeur ''Valeur de r\00E9serve'', mais aucun libell\00E9. Un texte de r\00E9serve ne doit pas \00EAtre utilis\00E9 uniquement pour libeller l''\00E9l\00E9ment, car il entra\00EEne des probl\00E8mes d''accessibilit\00E9. Pour optimiser l''accessibilit\00E9, vous devez d\00E9finir u')
||unistr('n libell\00E9 d''\00E9l\00E9ment. Si vous pr\00E9f\00E9rez que le libell\00E9 ne soit pas visible, vous pouvez tout de m\00EAme d\00E9finir un libell\00E9, puis s\00E9lectionner le mod\00E8le de libell\00E9 ''Masqu\00E9''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929675869305489)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom contient %0 caract\00E8res, alors que la limite maximale autoris\00E9e est de 30 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927882213305487)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''existe peut-\00EAtre pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100927948305305487)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''est peut-\00EAtre pas un \00E9l\00E9ment de page ou d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928278118305487)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'La page Effacer le cache %1 (dans l''application %0) n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928027041305487)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'La page %0 n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928126707305487)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'La page cible %1 (dans l''application %0) n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336974238305816)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion Activation/d\00E9sactivation de colonne ne comporte pas de colonne dont la valeur Utiliser comme en-t\00EAte de ligne est d\00E9finie sur Oui. La colonne En-t\00EAte de ligne doit \00EAtre la colonne qui identifie au mieux la ligne en cours (par exemple, le no')
||unistr('m d''un client dans un \00E9tat d''informations sur les clients).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337007041305816)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion Reflux ne comporte pas de colonne dont la valeur pour Utiliser comme en-t\00EAte de ligne est d\00E9finie sur Oui. La colonne En-t\00EAte de ligne doit \00EAtre la colonne qui identifie au mieux la ligne en cours (par exemple, le nom d''un client dans un \00E9t')
||'at d''informations sur les clients).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409796388305869)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion de ce panneau tabulaire n''a pas de colonne dont la valeur de "Utiliser comme en-t\00EAte de ligne" est d\00E9finie sur Oui. La colonne En-t\00EAte de ligne doit \00EAtre la colonne qui identifie au mieux la ligne en cours (par exemple, le nom d''un client d')
||unistr('ans une table d''informations sur les clients). Ces informations sont ensuite utilis\00E9es lors de l''affichage du panneau tabulaire, afin de fournir un libell\00E9 unique pour les champs de panneau de chaque ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929845661305489)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''existe aucun ordre par d\00E9faut pour l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862232239306215)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''option Fonction de hachage de signet est d\00E9finie sur un algorithme h\00E9rit\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862320363306216)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('La protection de statut de session est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062680847306378)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Sur une page avec un processus d''extraction, vous devez utiliser la protection d''acc\00E8s de page et l''activer pour les \00E9l\00E9ments que vous transmettez via l''URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899435268305464)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion contient une URL "f?p" qui n''a pas \00E9t\00E9 transmise par APEX_UTIL.PREPARE_URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929060669305488)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Injection SQL possible d\00E9tect\00E9e. %0 est utilis\00E9 avec la syntaxe de substitution dans le code SQL et PL/SQL, ou le nom de table de processus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926856107305486)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'%0 n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926917730305486)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ne peut pas \00EAtre r\00E9f\00E9renc\00E9 avec la syntaxe de substitution.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928876114305488)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('La page cible %1 (dans l''application %0) a un mod\00E8le d''autorisation d\00E9fini, mais le composant en cours n''en a pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409949428305869)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''accessibilit\00E9 du style de th\00E8me en cours de l''application n''a pas \00E9t\00E9 test\00E9e. Vous pouvez basculer vers un style de th\00E8me dont la valeur de l''attribut Accessibilit\00E9 test\00E9e est d\00E9finie sur Oui ou, si votre style de th\00E8me en cours a \00E9t\00E9 test\00E9, d\00E9fini')
||unistr('r la valeur de l''attribut Accessibilit\00E9 test\00E9e sur Oui dans vos param\00E8tres de th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504849092305940)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''interface utilisateur inclut la migration jQuery. La migration jQuery vous aide \00E0 migrer vers une version plus r\00E9cente de jQuery en restaurant les API enlev\00E9es, et affiche des avertissements dans la console du navigateur lorsque des API enlev\00E9es ou')
||unistr(' en phase d''abandon sont utilis\00E9es. Elle inclut un fichier JavaScript suppl\00E9mentaire sur chaque page de votre application. Pour l''enlever, consultez le guide de mise \00E0 niveau de la migration jQuery afin d''obtenir plus de d\00E9tails sur les API qui doive')
||unistr('nt \00EAtre modifi\00E9es puis, lorsque vous \00EAtes certain que vous ne vous appuyez plus sur aucune de ces API, d\00E9finissez Inclure la migration jQuery sur Non.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504757635305940)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''interface utilisateur inclut des fonctions JavaScript APEX en phase d''abandon ou qui ne sont plus prises en charge. Elle inclut un fichier JavaScript suppl\00E9mentaire sur chaque page de votre application. Pour l''enlever, consultez la section ''Fonctio')
||unistr('nnalit\00E9s en phase d''abandon'' dans les notes de version, dans laquelle vous trouverez des instructions permettant de v\00E9rifier les d\00E9pendances \00E0 des fonctionnalit\00E9s en phase d''abandon ou qui ne sont plus prises en charge, afin qu''\00E0 terme votre applicat')
||'ion n''en contienne plus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929583949305489)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ou la colonne associ\00E9 n''est pas d\00E9fini, mais l''emplacement d''affichage du message d''erreur en a besoin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929431298305489)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ou la colonne associ\00E9 n''est pas \00E9gal \00E0 la valeur "%0" indiqu\00E9e dans l''expression de validation 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928477907305487)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'fr'
,p_message_text=>'Erreur de compilation - %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100928520962305488)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun code SQL ou PL/SQL d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100926778394305486)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('Est sup\00E9rieur \00E0 32 767. Seuls les 32 767 premiers caract\00E8res sont v\00E9rifi\00E9s. Longueur : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929137371305488)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contient l''appel de fonction V/NV/DV dans l''instruction SQL (cela peut entra\00EEner des probl\00E8mes de performances).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100929771549305489)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le bouton r\00E9f\00E9renc\00E9 n''existe plus.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309495872305795)
,p_name=>'AFTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256776564305755)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'fr'
,p_message_text=>'Accord manquant'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050874042305583)
,p_name=>'ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653081621306052)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'fr'
,p_message_text=>'Autoriser la construction de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594473244306009)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Autorisez l''installation d''applications \00E9chantillon et de productivit\00E9.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496227165305934)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'fr'
,p_message_text=>'Autoriser l''utilisation des services RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653197637306052)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'Autoriser l''utilisation de SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653373398306052)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser l''utilisation du d\00E9veloppement d''\00E9quipe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652961211306052)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'fr'
,p_message_text=>'Autoriser la purge de l''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653227462306052)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'fr'
,p_message_text=>'Autoriser Websheet Development'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070067147305599)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'Toutes les applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887275447305455)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'fr'
,p_message_text=>'- Tout - '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887062450305455)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Toutes les cat\00E9gories')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887355860305455)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'fr'
,p_message_text=>unistr('- Toutes les cat\00E9gories -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655692112306054)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'fr'
,p_message_text=>'Tous les jalons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435074547305888)
,p_name=>'ALL_RELEASES'
,p_message_language=>'fr'
,p_message_text=>'Toutes les versions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074449605305602)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'fr'
,p_message_text=>'tous les fichiers statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073090207305601)
,p_name=>'ALL_THEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('tous les th\00E8mes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673743854306074)
,p_name=>'ALL_TYPES'
,p_message_language=>'fr'
,p_message_text=>'Tous les types'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674157130306075)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'fr'
,p_message_text=>'- Tous les types -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070153487305599)
,p_name=>'ALL_USERS'
,p_message_language=>'fr'
,p_message_text=>'Tous les utilisateurs'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058023017306375)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur dispose d\00E9j\00E0 d''un compte APEX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047998635306367)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur existe d\00E9j\00E0 dans l''espace de travail')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014395262306342)
,p_name=>'ALWAYS'
,p_message_language=>'fr'
,p_message_text=>'Toujours'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324393279305806)
,p_name=>'ANALYSIS'
,p_message_language=>'fr'
,p_message_text=>'Analyse de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324439635305806)
,p_name=>'ANALYZE'
,p_message_language=>'fr'
,p_message_text=>'Analyse par %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452090596305901)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Analyse \00E0 l''aide de la m\00E9thode %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071978889305601)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'fr'
,p_message_text=>'bloc anonyme'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933002938305493)
,p_name=>'ANSWERS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ponses')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899147737305464)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'fr'
,p_message_text=>unistr('(N''importe quel d\00E9veloppeur)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100094900306407)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'fr'
,p_message_text=>'Modifications d''application:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099915730306407)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'fr'
,p_message_text=>'Heure :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104060794306410)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'fr'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100167500306407)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page: '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856740646306211)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un appel d''API a \00E9t\00E9 interdit.'),
'Contactez l''administrateur.',
unistr('Des d\00E9tails relatifs \00E0 cet incident sont disponibles via l''ID de d\00E9bogage "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958382016305513)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'fr'
,p_message_text=>unistr('L''appel d''API "%0" n''est plus pris en charge dans la version %1 d''Application Express. Pour obtenir des d\00E9tails concernant cet incident, vous pouvez utiliser l''ID de d\00E9bogage "%2".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334282422305814)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'fr'
,p_message_text=>'La valeur #LABEL# n''existe pas dans la liste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611437673306022)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les branchements en affichage seul ne sont pas pris en charge si l''attribut de page Recharger apr\00E8s soumission est d\00E9fini sur Seulement en cas de succ\00E8s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076138307305604)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement du branchement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865494743305439)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement du calcul.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056224272305587)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de la condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107756063305626)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de condition "%0" inconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861460821305436)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment d''exploration de fichiers %0 doit utiliser la table APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838861976305419)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'fr'
,p_message_text=>'Le type de chargement "Fusionner" n''est pas pris en charge pour le chargement dans les collections.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992053919306324)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de chargement Fusionner requiert au moins une colonne de cl\00E9 primaire dans le profil de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991849737306324)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''analyser la requ\00EAte SQL de chargement de la source : %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991976361306324)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL de chargement de la source doit renvoyer une valeur VARCHAR2, CLOB ou BLOB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269159382305764)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Dans l''application %0, la page de bo\00EEte de dialogue %1 ne peut pas \00EAtre affich\00E9e. Assurez-vous que le mod\00E8le de page utilis\00E9 sur la page %1 est du type Page de bo\00EEte de dialogue, avec le code appropri\00E9 d\00E9fini pour l''initialisation de bo\00EEte de dialogu')
||unistr('e JavaScript, ainsi que la fermeture et l''annulation de bo\00EEte de dialogue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089026968306398)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Copyright &copy; %0, Tous droits r\00E9serv\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089806029306399)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088955076306398)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est un message g\00E9n\00E9r\00E9 par le syst\00E8me. N''y r\00E9pondez pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097463182306405)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'fr'
,p_message_text=>'Environnement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108052178306413)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur Oracle Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090435543306399)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'fr'
,p_message_text=>'Mise en route'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089108862306398)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'fr'
,p_message_text=>'Bonjour %0,'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090124113306399)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097539642306405)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Emp\00EAcher la purge de l''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090371271306399)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour emp\00EAcher la purge de votre espace de travail, cliquez sur le bouton ci-dessous et suivez les instructions \00E0 l''\00E9cran. Si vous n''effectuez aucune action d''ici %0 jour(s), votre espace de travail sera automatiquement enlev\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097230047306404)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune action n''est n\00E9cessaire si vous n''avez plus besoin de votre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097781660306405)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre espace de travail va \00EAtre purg\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097044288306404)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre espace de travail %0 n''a montr\00E9 aucune activit\00E9 r\00E9cente et sera bient\00F4t purg\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096906022306404)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : votre espace de travail "%0" va \00EAtre purg\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097375337306404)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'fr'
,p_message_text=>'Date de purge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098004822306405)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'fr'
,p_message_text=>'Terminez votre demande d''espace de travail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097849649306405)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre espace de travail "%0" est pr\00EAt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098153670306405)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre espace de travail "%0" a \00E9t\00E9 approuv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097903914306405)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre demande d''espace de travail a \00E9t\00E9 refus\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089736358306399)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097630535306405)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089658225306399)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089255195306398)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande d''espace de travail approuv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089929405306399)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur le bouton ci-dessous pour terminer le processus d''approbation et d\00E9finir le mot de passe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089410597306399)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre demande d''espace de travail a \00E9t\00E9 approuv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090075405306399)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur le bouton ci-dessous pour d\00E9marrer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090239541306399)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre espace de travail est pr\00EAt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089312505306398)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande d''espace de travail refus\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102089552936306399)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sol\00E9, votre demande d''espace de travail a \00E9t\00E9 refus\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865835624305439)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les t\00E9l\00E9chargements ne sont pas pris en charge lorsque l''attribut de page "Recharger apr\00E8s soumission" est d\00E9fini sur "Seulement en cas de succ\00E8s". Modifiez l''attribut de page "Recharger apr\00E8s soumission" sur "Toujours" ou utilisez un processus avant')
||unistr(' en-t\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399670598305862)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'fr'
,p_message_text=>'Mis en file d''attente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399716436305862)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Envoy\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895689434305462)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es d''informations en retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895779363305462)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es d''informations en retour ouvertes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895821441305462)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234861905305739)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Groupe "%0" introuvable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069874535306384)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'fr'
,p_message_text=>'Visualiser la documentation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977744522305528)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''en-t\00EAte HTTP %0 a \00E9t\00E9 envoy\00E9 deux fois, il pourrait s''agir d''une attaque.'),
'<ul>',
unistr('<li>Premi\00E8re valeur : "%1"</li>'),
unistr('<li>Deuxi\00E8me valeur : "%2"</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014957985305557)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('La prise en charge de l''impression doit \00EAtre de type STANDARD, ADVANCED, APEX_LISTENER, AOP ou NONE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015047420305557)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever le premier sch\00E9ma provisionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918302042305479)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'ID d''application non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434462320305888)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910606752305473)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre z\00E9ro ou un entier positif.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015118824305557)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de port non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462186874305909)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'ID d''abonnement non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015218231305557)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'fr'
,p_message_text=>unistr('Le chemin de portefeuille doit figurer dans le fichier d''application Forms : <chemin du syst\00E8me de fichiers>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094106503305617)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'L''espace de travail est introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094015125305617)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''espace de travail non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119413072305635)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur ne doit pas \00EAtre sup\00E9rieure \00E0 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029868184305568)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur "%1" du param\00E8tre d''instance "%0" ne correspond pas \00E0 l''expression r\00E9guli\00E8re "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029769846305568)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le param\00E8tre d''instance "%0" doit avoir une valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015383905305557)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre d''instance introuvable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458275627305906)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865539380305439)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe (pour authentification par rapport au r\00E9f\00E9rentiel de comptes utilisateur de l''espace de travail uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650655924306050)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe (pour authentification par rapport au r\00E9f\00E9rentiel de comptes utilisateur de l''espace de travail uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543867971305968)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe (pour authentification par rapport au r\00E9f\00E9rentiel de comptes utilisateur de l''espace de travail uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949853143305507)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe (pour authentification par rapport au r\00E9f\00E9rentiel de comptes utilisateur de l''espace de travail uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173010457305675)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe (pour authentification par rapport au r\00E9f\00E9rentiel de comptes utilisateur de l''espace de travail uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458151439305906)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe (pour authentification par rapport au r\00E9f\00E9rentiel de comptes utilisateur de l''espace de travail uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017201674305558)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le protocole du serveur d''impression doit \00EAtre HTTP ou HTTPS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017392577305558)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma n''existe pas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017455009305559)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma est restreint')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890745665305458)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890540030305458)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'L''application n''existe plus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695487555306090)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'fr'
,p_message_text=>'Affecter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092359969305615)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ces jointes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022431879306348)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'fr'
,p_message_text=>'Cartes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896149594305462)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ferm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892612040305459)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Comment\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892539100305459)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'fr'
,p_message_text=>'commentaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896280742305462)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277672123305771)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me %0 cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867245654305440)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867024884305440)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>'Voulez-vous supprimer ce commentaire ?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679878303306079)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer le probl\00E8me')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876906834305448)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Voulez-vous supprimer ce probl\00E8me ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894294879305460)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'fr'
,p_message_text=>'Document'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893141591305460)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'fr'
,p_message_text=>'Documents'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867131585305440)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807978565306174)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'fr'
,p_message_text=>'Modifier un commentaire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808085660306174)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier le probl\00E8me')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891349951305458)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application indiqu\00E9e n''existe pas dans cet espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891763366305459)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de la tentative de suppression du commentaire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891684304305459)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Commentaire introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891906624305459)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892038465305459)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la tentative de marquage du probl\00E8me pour suppression.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891417846305458)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La page indiqu\00E9e n''existe pas dans cet espace de travail ni dans l''application fournie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891877546305459)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur n''est pas autoris\00E9 \00E0 supprimer ce commentaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892193202305459)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur n''est pas autoris\00E9 \00E0 supprimer ce probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891576816305458)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur n''est pas autoris\00E9 \00E0 modifier la visibilit\00E9 de ce commentaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901412926306248)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Un probl\00E8me s''est produit lors de la v\00E9rification de la taille des fichiers. Contactez l''administrateur syst\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901388686306248)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('La taille d''un des fichiers est sup\00E9rieure \00E0 la limite maximale de %0 octets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901219863306248)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('La taille du fichier est sup\00E9rieure \00E0 la limite maximale de %0 octets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867364397305440)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'fr'
,p_message_text=>'Masquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894015733305460)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892935677305460)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'fr'
,p_message_text=>'Images'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890303850305458)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('un probl\00E8me non trouv\00E9 dans le syst\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839745196305420)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter une pr\00E9f\00E9rence pour l''utilisateur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892798302305459)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'fr'
,p_message_text=>'Joindre des fichiers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892406353305459)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ferm\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026323988306351)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893799004305460)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'fr'
,p_message_text=>'est vide.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893563804305460)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'fr'
,p_message_text=>'Un de ces fichiers est'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892367998305459)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894809246305461)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer d\00E9finitivement les \00E9l\00E9ments s\00E9lectionn\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680722731306079)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'fr'
,p_message_text=>'Purger tout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894778945305461)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9tablir la s\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892815655305459)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de r\00E9ponse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893607349305460)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'fr'
,p_message_text=>unistr('trop volumineux pour \00EAtre t\00E9l\00E9charg\00E9. <br>Les fichiers ne doivent pas d\00E9passer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893939574305460)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'fr'
,p_message_text=>'Types de fichier pris en charge : '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876365101306230)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un mod\00E8le de r\00E9ponse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893409088305460)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'fr'
,p_message_text=>'Ce fichier est'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893853908305460)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'n''est pas un type de fichier pris en charge.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623257873306030)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'fr'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623846732306031)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me li\00E9 \00E0 la documentation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623339170306030)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande d''am\00E9lioration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623474314306030)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande de fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623757476306030)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me li\00E9 \00E0 l''installation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623617558306030)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me li\00E9 aux performances')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623558015306030)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me li\00E9 \00E0 la s\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623929584306031)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me li\00E9 \00E0 la formation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624655529306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'fr'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624366702306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'fr'
,p_message_text=>'CSS / HTML'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624489406306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'fr'
,p_message_text=>'Actions dynamiques/JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624163682306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'fr'
,p_message_text=>unistr('Base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624760779306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Int\00E9gration syst\00E8me externe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624250404306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Int\00E9gration REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624512027306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624070697306031)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'fr'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623113013306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Cat\00E9gorie affect\00E9e au probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622216691306029)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Cat\00E9gorie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101623086703306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Zone fonctionnelle affect\00E9e par le probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622384116306029)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'fr'
,p_message_text=>'Zone fonctionnelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622995618306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Importance accord\00E9e au probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622431482306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'fr'
,p_message_text=>'Importance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622826706306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Efforts mis en oeuvre pour r\00E9soudre le probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622537611306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'fr'
,p_message_text=>'Niveau d''effort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622774847306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Avancement par rapport au probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622630768306030)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'fr'
,p_message_text=>'Progression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625114992306031)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Non trait\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624841539306031)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'fr'
,p_message_text=>'Critique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101624990808306031)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'fr'
,p_message_text=>'Important'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625034091306031)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625245588306032)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pas de r\00E9solution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625343855306032)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'fr'
,p_message_text=>'Correction facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625514514306032)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Efforts de d\00E9veloppement importants')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625418981306032)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Efforts mod\00E9r\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625972554306032)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'fr'
,p_message_text=>'Correction impossible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626032687306032)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625745876306032)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations compl\00E9mentaires requises')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625808970306032)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'fr'
,p_message_text=>'En attente d''un tiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101625622604306032)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'fr'
,p_message_text=>'En cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636165228306040)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce groupe de libell\00E9s ne peut pas \00EAtre supprim\00E9, car au moins un de ses membres est affect\00E9 \00E0 un probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895930118305462)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100892264309305459)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'fr'
,p_message_text=>unistr('A marqu\00E9 le doublon de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680282850306079)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'fr'
,p_message_text=>'Destinataires'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680106930306079)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680619211306079)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'fr'
,p_message_text=>'Jalons'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680022954306079)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890192131305457)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'fr'
,p_message_text=>'jalons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626450465306033)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'fr'
,p_message_text=>'Blocage du code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626640677306033)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'fr'
,p_message_text=>'Version finale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626508531306033)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'fr'
,p_message_text=>'Gel IU'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894620138305461)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 a ajout\00E9 un commentaire \00E0 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838755394305419)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('a \00E9t\00E9 modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643713449306045)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le probl\00E8me num\00E9ro %0 dans l''espace de travail %1 a \00E9t\00E9 modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901152215306248)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun libell\00E9 n''a \00E9t\00E9 d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896062467305462)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouvert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893344387305460)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'fr'
,p_message_text=>'Autre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890828246305458)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890660272305458)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'La page n''existe plus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019920732306346)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Purger tout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695588186306090)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890475720305458)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'fr'
,p_message_text=>unistr('A enlev\00E9 l''association d''application et de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891177323305458)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe enlev\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994644628306326)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Voulez-vous remplacer le commentaire en cours par ce mod\00E8le ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996670312306328)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bonjour ! ',
'',
unistr('C''est votre tout premier probl\00E8me. Vous pouvez cr\00E9er des probl\00E8mes afin de suivre des t\00E2ches, des fonctionnalit\00E9s, des bugs et des informations en retour pour tous vos projets APEX. Vous pouvez ajouter des libell\00E9s \00E0 des probl\00E8mes, ajouter des destin')
||unistr('ataires, d\00E9finir des jalons et m\00EAme appliquer un formatage \00E0 l''aide des raccourcis Markdown.  '),
'',
'Voici un exemple de ce que permet Markdown :'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996532311306328)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Bienvenue dans le d\00E9veloppement d''\00E9quipe dans Oracle APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695603156306090)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891232516305458)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le statut sur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867546742305441)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Afficher les actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996440634306328)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'fr'
,p_message_text=>'Afficher plus...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890957190305458)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'fr'
,p_message_text=>unistr('Abonn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901518792306248)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'fr'
,p_message_text=>'%0 dans l''espace de travail %1 comporte %2 nouvelles notifications.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619735460306028)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le utilis\00E9 pour consigner un bug.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619623562306028)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619594938306027)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Comportement attendu**',
unistr('- Dites-nous ce qui doit se produire \00E0 votre avis.'),
'',
'',
'**Comportement en cours**',
'- Dites-nous ce qui se produit.',
'',
'',
unistr('**Personnes affect\00E9es**'),
unistr('- Dites-nous qui/ce qui est affect\00E9. '),
'',
'**Solution possible**',
unistr('- Si vous le pouvez, proposez une mani\00E8re de r\00E9soudre le bug.'),
'',
unistr('**Etapes \00E0 reproduire**'),
unistr('- Indiquez une s\00E9rie d''\00E9tapes claires \00E0 reproduire, avec des captures d''\00E9cran et des fragments de code si n\00E9cessaire.'),
'1.',
'2.',
'3.',
'',
'**Contexte**',
unistr('- Que tentiez-vous de faire quand le bug s''est produit. Le bug ne se produit-il que dans certaines circonstances, \00E0 des moments pr\00E9cis de la journ\00E9e, etc.'),
'',
'**Environnement**',
'',
'- Version : ',
'- Plate-forme : ',
unistr('- Sous-syst\00E8me :'),
'',
'______',
'',
unistr('_**Remarque :** pour associer un probl\00E8me \00E0 une application et/ou une page, consignez tout d''abord le probl\00E8me, puis utilisez la liste d\00E9roulante **ACTIONS** pour associer l''application et la page._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620898313306028)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Un bug a \00E9t\00E9 signal\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620734194306028)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Bug signal\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620908862306028)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un **bug** a \00E9t\00E9 enregistr\00E9 dans le syst\00E8me externe appropri\00E9.'),
'',
unistr('- Syst\00E8me de suivi des bugs : '),
'- ID du bug : ',
'- URL du bug : ',
'',
'Commentaires :'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619960679306028)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le utilis\00E9 pour consigner une demande de fonctionnalit\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619878092306028)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de demande de fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620022943306028)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**R\00E9capitulatif de la fonctionnalit\00E9**'),
unistr(' - Donnez, en un paragraphe, un aper\00E7u g\00E9n\00E9ral de la fonctionnalit\00E9 demand\00E9e.'),
'',
'',
'**Contexte**',
unistr(' - Cette demande est-elle en rapport avec une situation ou un processus sp\00E9cifique ? Par exemple, "C''est toujours frustrant de [...]"'),
'',
'',
unistr(' - Fournissez d''\00E9ventuelles informations compl\00E9mentaires, y compris des captures d''\00E9cran, des cas d''emploi, etc.'),
'',
'',
unistr('**Solution privil\00E9gi\00E9e**'),
unistr('- D\00E9crivez pr\00E9cis\00E9ment la solution que vous aimeriez voir mise en oeuvre.'),
'',
'',
'**Autres solutions**',
unistr('- D\00E9crivez les autres solutions ou fonctionnalit\00E9s envisag\00E9es, ou les solutions de contournement utilis\00E9es.'),
'',
'',
'______',
unistr('_**Remarque :** pour associer un probl\00E8me \00E0 une application et/ou une page, consignez tout d''abord le probl\00E8me, puis utilisez la liste d\00E9roulante **ACTIONS** pour associer l''application et la page._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621112025306029)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Une demande de fonctionnalit\00E9 a \00E9t\00E9 enregistr\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621061949306029)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande de fonctionnalit\00E9 enregistr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621200708306029)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Une **demande de fonctionnalit\00E9** a \00E9t\00E9 enregistr\00E9e dans le syst\00E8me externe appropri\00E9.'),
'',
unistr('- Syst\00E8me de suivi des fonctionnalit\00E9s : '),
unistr('- ID de la fonctionnalit\00E9 : '),
unistr('- URL de la d\00E9finition de la fonctionnalit\00E9 : '),
'',
'Commentaires :'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622040059306029)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Une action de suivi est n\00E9cessaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621962970306029)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'fr'
,p_message_text=>'Action de suivi requise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101622102032306029)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Effectuez les actions suivantes : ',
'',
'1.',
'2.',
'3.',
'4.',
'',
'Commentaires : '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620249112306028)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le utilis\00E9 pour poser une question de proc\00E9dure.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620178216306028)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620312633306028)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Question**',
unistr('- Enoncez votre question ou votre demande aussi bri\00E8vement que possible.'),
'',
unistr('**Contexte g\00E9n\00E9ral**'),
'- Que tentez-vous de faire ? ',
'',
'',
unistr('- O\00F9 avez-vous regard\00E9 ou qui avez-vous contact\00E9 pour trouver une r\00E9ponse ? '),
'',
'',
'**Environnement** ',
unistr('Cette question est-elle propre \00E0 un environnement, \00E0 un langage de programmation ou \00E0 un autre \00E9l\00E9ment ?'),
'',
'______',
unistr('_**Remarque :** pour associer un probl\00E8me \00E0 une application et/ou une page, consignez tout d''abord le probl\00E8me, puis utilisez la liste d\00E9roulante **ACTIONS** pour associer l''application et la page._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621749076306029)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rence \00E0 un probl\00E8me connu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621638191306029)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me connu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621858600306029)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Apr\00E8s examen, il s''av\00E8re que ce probl\00E8me est d\00E9j\00E0 connu. Consultez les d\00E9tails ci-dessous.'),
'',
unistr('- Syst\00E8me de suivi des bugs : '),
'- ID du bug : ',
'- URL du bug : ',
'',
'Commentaires : '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621425422306029)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande d''informations compl\00E9mentaires.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621335996306029)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'fr'
,p_message_text=>'Plus d''informations requises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101621555627306029)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**Des informations compl\00E9mentaires sont requises pour ce probl\00E8me :**'),
'',
unistr('Merci de fournir les informations demand\00E9es ci-dessous. Sans ces informations, il sera difficile de classifier le probl\00E8me et de poursuivre sa r\00E9solution.'),
'',
'',
'Commentaires :'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620589467306028)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce probl\00E8me ne sera pas trait\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620459462306028)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'fr'
,p_message_text=>'Sans traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101620642676306028)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Apr\00E8s r\00E9flexion, **aucune action ult\00E9rieure ne sera entreprise concernant ce probl\00E8me**. '),
'',
'Commentaires :'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894319839305461)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'fr'
,p_message_text=>'Fichier texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893243139305460)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890011430305457)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('ce probl\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644814247306046)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('a ajout\00E9 la pi\00E8ce jointe %0 \00E0 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643831821306045)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'fr'
,p_message_text=>unistr('a ajout\00E9 %0 \00E0 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645426487306046)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'fr'
,p_message_text=>unistr('a ajout\00E9 %0 \00E0 %1 %2				')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644039181306045)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('a affect\00E9 %0 \00E0 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644433168306046)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'fr'
,p_message_text=>unistr('a associ\00E9 %0 \00E0 %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894535204305461)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'fr'
,p_message_text=>unistr('a modifi\00E9 un commentaire pour %0	%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092201623305615)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('probl\00E8me %0 %1 modifi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645315353306046)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce probl\00E8me a \00E9t\00E9 masqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644220560306045)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'fr'
,p_message_text=>unistr('a marqu\00E9 %0 en tant que doublon de %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645261475306046)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'fr'
,p_message_text=>'A ouvert %0 par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644943845306046)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('a enlev\00E9 la pi\00E8ce jointe %0 de %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643946910306045)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'fr'
,p_message_text=>unistr('a enlev\00E9 %0 de %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645591903306046)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'fr'
,p_message_text=>unistr('a enlev\00E9 %0 de %1 %2 			')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645099146306046)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'fr'
,p_message_text=>unistr('a d\00E9fini le statut de %0 sur %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644691959306046)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'fr'
,p_message_text=>unistr('a abonn\00E9 \00E0 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644138982306045)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('a annul\00E9 l''affectation de %0 de %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644537276306046)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'fr'
,p_message_text=>unistr('a enlev\00E9 l''association d''application et de page de %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644380907306046)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'fr'
,p_message_text=>unistr('a annul\00E9 le marquage de %0 en tant que doublon de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101644715224306046)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'fr'
,p_message_text=>unistr('a annul\00E9 l''abonnement \00E0 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645164230306046)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'fr'
,p_message_text=>unistr('a marqu\00E9 le doublon de %0 %1 par %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100890284724305457)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non affect\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867477835305441)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100891044723305458)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non abonn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679960379306079)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894175152305460)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'fr'
,p_message_text=>'Fichier ZIP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100893025114305460)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers ZIP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851368503305429)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''est pas un \00E9l\00E9ment d''adresse g\00E9ocod\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989613902306323)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment %0 introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880007357306232)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le checksum de page permet de d\00E9terminer facilement si la m\00EAme page est d\00E9ploy\00E9e ailleurs. Vous pouvez comparer ce checksum afin de d\00E9terminer s''il existe une correspondance.	Les modifications apport\00E9es aux composants partag\00E9s utilis\00E9s sur cette page')
||unistr(' ne seront pas refl\00E9t\00E9es dans ce checksum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035640925306358)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'fr'
,p_message_text=>'A propos de cette application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035444254306358)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035535953306358)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection du style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868064379305441)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Seules les polices de type CFF (Compact Font Format) avec une seule police sont autoris\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868192062305441)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Seules les polices de type CFF (Compact Font Format) avec un seul op\00E9rateur Top DICT sont autoris\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868207827305441)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Seules les polices de type CFF (Compact Font Format) avec le format Type 2 CharString sont autoris\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880444709305450)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'La police est introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880391790305450)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'fr'
,p_message_text=>'Seules les tables cmap au format 4 et 12 sont prises en charge.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880780191305450)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'fr'
,p_message_text=>'Orientation de page non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880593988305450)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le PDF n''est pas initialis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880295178305450)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune sous-table cmap valide n''a \00E9t\00E9 trouv\00E9e dans la police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880690676305450)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Le PDF ne comporte aucune page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315643419305800)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur interne est survenue lors de la cr\00E9ation du fichier PDF.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886089594305454)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Une r\00E9gion modifiable non valide (\00E0 ligne unique) est affect\00E9e au processus "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874117907305446)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''obtenir la valeur de la cl\00E9 primaire suivante ou pr\00E9c\00E9dente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543624307305967)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Le service Web est introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081470355305608)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur de traitement du processus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900700317305465)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Application Express n''a pas pu traiter la demande en raison de limitations de ressources de session de base de donn\00E9es. R\00E9essayez plus tard.'),
'<p/>',
unistr('Pour obtenir des d\00E9tails concernant cet incident, vous pouvez utiliser l''ID de d\00E9bogage "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874927659305446)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''erreur suivante est survenue lors du d\00E9ploiement de l''application : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877640827305448)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application %0 a \00E9t\00E9 d\00E9ploy\00E9e sur le serveur distant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881313570305451)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application %0 a \00E9t\00E9 d\00E9ploy\00E9e comme %1 vers le serveur distant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515897492305948)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'fr'
,p_message_text=>'Echec de l''authentification pour le service SQL compatible REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901036488305466)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de l''authentification. La liste de valeurs utilise une source de donn\00E9es de type SQL compatible REST qui fait r\00E9f\00E9rence \00E0 des informations d''identification Web non valides. Vous ne pourrez pas modifier les informations de colonne de cette liste')
||unistr(' de valeurs. V\00E9rifiez les informations d''identification d''authentification. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022167074306348)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la communication. Un probl\00E8me s''est produit lors de l''appel de la source de donn\00E9es de type SQL compatible REST r\00E9f\00E9renc\00E9e par la liste de valeurs (LOV). Vous ne pourrez pas modifier les informations de colonne de la liste de valeurs. V\00E9rifi')
||unistr('ez que la source de donn\00E9es de type SQL compatible REST fonctionne correctement et que les informations d''identification d''authentification correspondantes sont correctes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517172291305949)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur sur le serveur distant : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491913921305931)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Instance SQL compatible REST ORDS indiqu\00E9e introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097714652305619)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le serveur a envoy\00E9 une redirection vers : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392222324305856)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('L''instruction SQL est sup\00E9rieure \00E0 32,767 octets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410990658305870)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bonjour, Application Express ! Vous \00EAtes connect\00E9 en tant que #USER#.'),
unistr('L''horodatage de la base de donn\00E9e locale est : #SYSDATE#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636085728306040)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous modifiez l''alias du sch\00E9ma par d\00E9faut de l''espace de travail. En d\00E9finissant cet alias, vous modifiez \00E9galement le pr\00E9fixe de chemin au niveau de l''espace de travail. Cela aura une incidence sur l''URL des services RESTful bas\00E9s sur APEX que vous')
||unistr(' avez peut-\00EAtre d\00E9finie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389945315305855)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 r\00E9f\00E9rences')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627392500306033)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'fr'
,p_message_text=>'Utilitaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627423705306033)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Utilitaires d''application \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634875108306039)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aller \00E0 la page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634701327306039)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der aux composants partag\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627544503306033)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'fr'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627627975306034)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2ches d''App Builder > ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627733386306034)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627869064306034)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C El\00E9ments d''application \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627923866306034)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'fr'
,p_message_text=>'Logique d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628026302306034)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628120285306034)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Mod\00E8les d''authentification de s\00E9curit\00E9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628237577306034)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628339279306034)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Mod\00E8les d''autorisation de s\00E9curit\00E9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628422520306034)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'fr'
,p_message_text=>'Chemins de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628586569306034)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Chemins de navigation \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628674257306034)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628701708306034)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Options de construction \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628878766306034)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101628908827306034)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Param\00E8tres de composant \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629097237306035)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Calculs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629110830306035)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Calculs d''application \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629233421306035)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un \00E9l\00E9ment d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629301377306035)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un mod\00E8le d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629483751306035)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une option de construction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629547780306035)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un calcul d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629638664306035)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un mod\00E8le de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629777777306035)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un module d''extension')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629830790306035)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101629900833306035)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er des informations d''identification Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630087565306035)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finitions de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630123612306035)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C D\00E9finitions de chargement des donn\00E9es \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630235705306035)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'fr'
,p_message_text=>unistr('Sources de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630375561306036)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs de d\00E9finition')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630446698306036)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630545768306036)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630649169306036)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Mises en page d''\00E9tat \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630741222306036)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'fr'
,p_message_text=>unistr('Services Web h\00E9rit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630853354306036)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Services Web h\00E9rit\00E9s \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101630928142306036)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'fr'
,p_message_text=>'Listes de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631071144306036)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Listes de navigation classiques \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631165011306036)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631217210306036)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Liste de valeurs (LOV) \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631333470306036)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631481234306036)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'fr'
,p_message_text=>'Autres composants'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631501568306036)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'fr'
,p_message_text=>'Modules d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631631338306036)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Modules d''extension \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631794597306037)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631815051306037)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Processus d''application \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101631909384306037)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAtes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632075025306037)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Requ\00EAtes d''\00E9tat \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632170290306037)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'fr'
,p_message_text=>'Etats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632262771306037)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632333591306037)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C SQL compatible REST \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632498896306037)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632548662306037)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>'Protection de statut de session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632636353306037)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir la protection de statut d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632872270306037)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Composants partag\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632902280306037)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633097665306037)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'Raccourcis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633107412306038)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Raccourcis \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633268311306038)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'fr'
,p_message_text=>unistr('Onglets (h\00E9rit\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633391365306038)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633464319306038)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Mod\00E8les d''IU \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633572328306038)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8mes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633669416306038)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Th\00E8mes d''IU \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633743962306038)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'fr'
,p_message_text=>'Interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633861860306038)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101633943285306038)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Informations d''identification Web de s\00E9curit\00E9 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634023852306038)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634107306306038)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9dez \00E0 : Composants partag\00E9s \005C Sources de donn\00E9es REST \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634258529306038)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634375598306038)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un objet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634479135306038)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er %LIST_ITEM_NAME% dans SQL Workshop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634520327306039)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'fr'
,p_message_text=>'Editeur de script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634603534306039)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2ches de SQL Workshop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093447136306402)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment de page %0 repose sur une colonne de base de donn\00E9es, mais l''attribut ''Source utilis\00E9e'' est d\00E9fini sur ''Uniquement lorsque la valeur en cours dans le statut de session est NULL''. Ceci est tr\00E8s dangereux et peut entra\00EEner l''\00E9crasement accide')
||unistr('ntel des donn\00E9es lors de l''affichage et de l''enregistrement de plusieurs enregistrements. D\00E9finissez toujours ''Source utilis\00E9e'' sur ''Toujours, en rempla\00E7ant les valeurs existantes dans le statut de session''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030761987306354)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''acc\00E8s au statut de session est d\00E9sactiv\00E9. La tentative de lecture/\00E9criture a \00E9t\00E9 bloqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914103194305476)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Tentative d''enregistrement de l''\00E9l\00E9ment %0 dans le statut de session lors du traitement de l''affichage. L''\00E9l\00E9ment a une protection de niveau "Interne uniquement".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906918968305470)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'fr'
,p_message_text=>unistr('Tentative d''enregistrement de l''\00E9l\00E9ment %0 dans le statut de session lors du traitement de l''acceptation. L''\00E9l\00E9ment a une protection de niveau "Interne uniquement" ou n''est pas un \00E9l\00E9ment de panneau pouvant \00EAtre envoy\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906704842305470)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le checksum calcul\00E9 sur la demande, l''effacement du cache, les noms d''argument et les valeurs d''argument (%0) ne concordent pas avec le checksum transmis \00E0 la proc\00E9dure d''affichage (%1).'),
'',
'Remarque : les utilisateurs finals obtiennent un message d''erreur distinct.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906291798305470)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Tentative d''enregistrement de l''\00E9l\00E9ment %0 dans l''\00E9tat de session au cours du traitement de l''affichage. Le niveau de protection de l''\00E9l\00E9ment est :'),
'  %1',
'',
unistr('Aucun checksum n''a \00E9t\00E9 transmis ou celui qui a \00E9t\00E9 transmis conviendrait \00E0 un \00E9l\00E9ment de niveau de protection "%2".'),
'',
unistr('Remarque : les utilisateurs finals obtiennent un message d''erreur diff\00E9rent.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081275291305607)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1022 Impossible d''enregistrer les attributs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850847938305428)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'fr'
,p_message_text=>'Impossible de convertir la valeur SDO_GEOMETRY en GeoJSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848321564305426)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'fr'
,p_message_text=>'Impossible de convertir du texte en objet SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849579663305427)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ne contient pas de donn\00E9es GeoJSON valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865165496305439)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du calcul de la valeur par d\00E9faut de la colonne #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866030824305440)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement du processus de suppression multiligne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108262282305627)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de checksum ("FCS") est obligatoire ; elle n''a pas \00E9t\00E9 indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108443628305627)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune valeur de cl\00E9 primaire n''a \00E9t\00E9 indiqu\00E9e. Au moins une ligne doit \00EAtre indiqu\00E9e pour que les mises \00E0 jour puissent avoir lieu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109270853305628)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune valeur secondaire n''a \00E9t\00E9 indiqu\00E9e pour la colonne de cl\00E9 secondaire identifi\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248897894305749)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'fr'
,p_message_text=>unistr('aucune donn\00E9e trouv\00E9e dans le panneau tabulaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108173497305627)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de cl\00E9 primaire n''a pas \00E9t\00E9 indiqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109143667305628)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de cl\00E9 secondaire identifi\00E9e ne se trouve pas dans la liste SELECT de la requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108008345305627)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de table n''est pas indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107994411305627)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le propri\00E9taire de la table n''est pas indiqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129198937305642)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du traitement du processus de mise \00E0 jour multiligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889398684305457)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de copier le th\00E8me "%0" dans l''application "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086960782306397)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le th\00E8me import\00E9 n''est pas compatible avec le th\00E8me en cours.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069065338306383)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro de th\00E8me n''est pas valide ou le th\00E8me pas un th\00E8me d''interface utilisateur en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029807154306354)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Des colonnes de cl\00E9 primaire et de cl\00E9 parent sont requises pour calculer la hi\00E9rarchie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029952610306354)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes de niveau de noeud et de statut de noeud requises lorsque la hi\00E9rarchie n''est pas calcul\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048233299306368)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>'Apparence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807215615306174)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021718391305562)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mode fonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021828530305562)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807118763306173)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode clair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450638141305900)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une interface utilisateur dans la liste ci-dessous :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452905236305902)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 - S\00E9lection d''une interface utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992487913305539)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s non autoris\00E9 (variable de package de groupe de s\00E9curit\00E9 non d\00E9finie).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992811603305539)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''extraire les informations utilisateur. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978601415305528)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur %0 a besoin du privil\00E8ge ADMIN pour r\00E9aliser cette op\00E9ration.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992781559305539)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur %0 n''a pas indiqu\00E9 d''adresse \00E9lectronique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948597106305506)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s non autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992638615305539)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>'L''utilisateur %0 n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907622513305471)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Une r\00E9gion modifiable non valide (\00E0 ligne unique) est affect\00E9e \00E0 la validation "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081338127305608)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de la validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031199281306355)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Application Express ne peut pas calculer un profil de donn\00E9es \00E0 partir des donn\00E9es de r\00E9ponse de type : %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497801476305935)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'fr'
,p_message_text=>'Table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497797707305935)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017741160306345)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'fr'
,p_message_text=>'L''expression de filtre n''est pas une expression JSON valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010953081306340)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'fr'
,p_message_text=>'Le filtre n''est pas pris en charge par Oracle REST Data Services.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389804575305855)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le param\00E8tre d''URL de pagination "%0" est en conflit avec un param\00E8tre de source REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492760008305931)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'fr'
,p_message_text=>unistr('HTTP 200 : Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492816710305931)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'fr'
,p_message_text=>unistr('HTTP 201 : Cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492254059305931)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'fr'
,p_message_text=>'HTTP 400 : Demande incorrecte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492046168305931)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'fr'
,p_message_text=>unistr('HTTP 401 : Non autoris\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492341593305931)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'fr'
,p_message_text=>'HTTP 403 : Interdit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492106159305931)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'fr'
,p_message_text=>'HTTP 404 : Introuvable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492424376305931)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'fr'
,p_message_text=>unistr('HTTP 405 : M\00E9thode non autoris\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850134703305428)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'fr'
,p_message_text=>'HTTP 407 : Authentification par proxy obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850403061305428)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'fr'
,p_message_text=>'HTTP 409 : Conflit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850285856305428)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'fr'
,p_message_text=>unistr('HTTP 412 : Echec de la condition pr\00E9alable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850316178305428)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'fr'
,p_message_text=>unistr('HTTP 428 : Condition pr\00E9alable obligatoire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492596270305931)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'fr'
,p_message_text=>'HTTP 500 : Erreur interne du serveur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492623150305931)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'fr'
,p_message_text=>'HTTP 502 : Passerelle incorrecte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031535003306355)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'fr'
,p_message_text=>'HTTP 503 : Service non disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031644655306355)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'fr'
,p_message_text=>'HTTP 504 : Expiration de la passerelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873760938306228)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'fr'
,p_message_text=>unistr('La source de donn\00E9es REST a renvoy\00E9 une erreur HTTP : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491826352305931)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es REST introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047699750305581)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le s\00E9lecteur de ligne "%0" n''a s\00E9lectionn\00E9 aucun tableau d''objets \00E0 traiter comme une table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047746525305581)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le s\00E9lecteur de ligne "%0" n''a s\00E9lectionn\00E9 aucun objet \00E0 traiter comme une ligne unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853353593305430)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('La limite de d\00E9bit de source de donn\00E9es REST (%0 demandes en %1 secondes) a \00E9t\00E9 d\00E9pass\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842379374305422)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'fr'
,p_message_text=>unistr('La limite de d\00E9bit de source de donn\00E9es REST (%0 demandes en %1 secondes) a \00E9t\00E9 d\00E9pass\00E9e et le temps d''attente n\00E9cessaire est trop long.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873686833306228)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'fr'
,p_message_text=>unistr('Le param\00E8tre IN de source REST obligatoire "%0" de type "%1" doit avoir une valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791610866306162)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le corps de r\00E9ponse est trop volumineux pour \00EAtre affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457037190305905)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le service REST ORDS h\00E9rit\00E9 utilise une petite taille de page fixe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856997142305433)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- Cet appel d''API synchronise les colonnes de table avec le profil de donn\00E9es de la source '),
unistr('-- de donn\00E9es REST de mani\00E8re dynamique en ex\00E9cutant des instructions ALTER TABLE. '),
unistr('-- Si un type de donn\00E9es de colonne ne peut pas \00EAtre modifi\00E9 avec ALTER TABLE, un message '),
unistr('-- d''erreur est g\00E9n\00E9r\00E9.'),
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855826171305432)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les modifications apport\00E9es au profil de donn\00E9es ne peuvent pas \00EAtre appliqu\00E9es automatiquement. Les colonnes de table locale doivent \00EAtre ajust\00E9es manuellement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857072351305433)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- A partir de %0, ex\00E9cutera :'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855096132305431)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'fr'
,p_message_text=>unistr('La m\00E9thode de synchronisation Fusionner requiert qu''une cl\00E9 primaire soit d\00E9finie dans le profil de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855337147305432)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('La table locale et le profil de donn\00E9es n''ont pas de colonnes communes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841922208305421)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Travail abandonn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855509898305432)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'fr'
,p_message_text=>'Echec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855634258305432)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Incomplet (nombre maximal de demandes d\00E9pass\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855746450305432)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Travail d\00E9j\00E0 en cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842804363305422)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'fr'
,p_message_text=>unistr('En cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842917871305422)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'fr'
,p_message_text=>unistr('Programm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855451119305432)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855197820305431)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Etape de synchronisation %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855251851305432)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'fr'
,p_message_text=>'%0 (nouveau)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339972525305818)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9ration de test')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411013381305870)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9lai d''expiration d\00E9pass\00E9 lors de l''extraction de toutes les donn\00E9es de source REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386919952305853)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les filtres SQL locaux en cours requi\00E8rent un trop grand nombre de demandes de page suivante au service REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456983680305905)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('La taille de page fixe pour le service REST ORDS h\00E9rit\00E9 est inconnue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163385441305668)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Branchement sur la page d''administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137857452305649)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159467716305665)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'fr'
,p_message_text=>'Mis en commentaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143986148305653)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144200452305654)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'fr'
,p_message_text=>'Ajouter %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144678343305654)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter plusieurs utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144796190305654)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144824251305654)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter des utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143644160305653)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'fr'
,p_message_text=>'Appliquer les modifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143734419305653)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143853674305653)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143504586305653)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132846932305645)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144020745305653)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer ce qui est coch\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144172332305653)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144358904305654)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132668626305645)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'fr'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133370806305645)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Charger les donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144455691305654)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir une session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133023109305645)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132993056305645)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132795051305645)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133199063305645)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133216629305645)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Soumettre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144908897305654)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Soumettre les informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101144552764305654)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('Voir les d\00E9tails')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137739585305649)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156980680305663)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149377730305657)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137592104305649)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148345404305657)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'fr'
,p_message_text=>unistr('Activit\00E9 par heure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147613688305656)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'fr'
,p_message_text=>'Sessions d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137446038305648)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136614341305648)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'fr'
,p_message_text=>'Automatisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147241407305656)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps moyen \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146629776305655)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148231645305656)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'fr'
,p_message_text=>'Contexte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145535439305655)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145289662305654)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147551261305656)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs distincts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136420137305648)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146390601305655)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ecoul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149265620305657)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146990389305655)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136523162305648)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'fr'
,p_message_text=>'Erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149102870305657)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Lignes d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145060914305654)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137166357305648)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136922347305648)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149591536305657)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistr\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148039167305656)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Vues de page compl\00E8te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146824194305655)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherche d''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145663942305655)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145950607305655)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147175131305656)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps maximal \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147337470305656)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps m\00E9dian \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148730143305657)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Message'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148881236305657)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de message'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147048863305656)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps minimal \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148621638305657)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'fr'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146746488305655)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Nombre de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148166975305656)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'fr'
,p_message_text=>'Occurrence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146400233305655)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148403034305657)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146516391305655)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146041286305655)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147713432305656)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147981328305656)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page partielle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148969936305657)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de la cl\00E9 primaire ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137075334305648)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'fr'
,p_message_text=>'Evaluation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149490184305657)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'fr'
,p_message_text=>'Raison'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137244001305648)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ponse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101148570725305657)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'fr'
,p_message_text=>'Lignes extraites'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136816647305648)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'fr'
,p_message_text=>unistr('Programm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136716822305648)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145119270305654)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149062800305657)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes de r\00E9ussite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146289312305655)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'fr'
,p_message_text=>'Horodatage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147896896305656)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Nombre total de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145474063305654)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145333897305654)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101146148501305655)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145872880305655)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137347977305648)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'fr'
,p_message_text=>'Agent utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101145707608305655)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101147496091305656)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Performances pond\00E9r\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130080540305643)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte de dialogue ferm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142958698305653)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Annuler la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143431965305653)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Modifier les filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143091783305653)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un bouton - Bo\00EEte de dialogue ferm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143183382305653)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier un \00E9tat - Bo\00EEte de dialogue ferm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143222308305653)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Effectuez la recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101143387198305653)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132514293305645)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Jeu de caract\00E8res de fichier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132101045305645)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155720648305662)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Lorsque le contr\00F4le d''acc\00E8s est activ\00E9, les administrateurs ont la possibilit\00E9 de restreindre l''acc\00E8s \00E0 certaines fonctionnalit\00E9s d''application pour les utilisateurs authentifi\00E9s. Cette application prend en charge les 3 r\00F4les suivants : Lecteur, C')
||'ontributeur et Administrateur.<p>',
'<ul>',
unistr('  <li>Les <strong>lecteurs</strong> disposent d''un acc\00E8s en lecture seule \00E0 toutes les informations et peuvent \00E9galement consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>contributeurs</strong> peuvent cr\00E9er, modifier et supprimer des informations et consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>administrateurs</strong>, outre les capacit\00E9s des contributeurs, peuvent \00E9galement ex\00E9cuter la configuration de l''application.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155593600305662)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Tous les utilisateurs authentifi\00E9s peuvent acc\00E9der \00E0 cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155694713305662)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez <strong>Non</strong> si tous les utilisateurs sont d\00E9finis dans la liste de contr\00F4le d''acc\00E8s. S\00E9lectionnez <strong>Oui</strong> si les utilisateurs authentifi\00E9s ne figurant pas dans la liste de contr\00F4le d''acc\00E8s peuvent \00E9galement utiliser')
||' cette application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153854687305661)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formats date/nombre \00E0 utiliser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153949974305661)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez de fournir des masques de format personnalis\00E9s ou d''en utiliser des standard.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156364011305662)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155381363305662)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'fr'
,p_message_text=>'Automatisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154036498305661)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'fr'
,p_message_text=>unistr('Jeu de caract\00E8res de fichier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152847181305660)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier/coller les donn\00E9es d\00E9limit\00E9es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154160602305661)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'fr'
,p_message_text=>unistr('Symbole mon\00E9taire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154234298305661)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Si vos donn\00E9es contiennent un symbole mon\00E9taire international, saisissez-le ici. Par exemple, si vos donn\00E9es comportent "&euro;1,234.56" ou "&yen;1,234.56", saisissez "&euro;" ou "&yen;". Si vous ne le faites pas, les donn\00E9es ne se chargeront pas cor')
||'rectement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152529043305660)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Importer \00E0 partir de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154560279305661)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Marque d\00E9cimale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154697614305661)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La marque d\00E9cimale s\00E9pare la partie enti\00E8re de la partie d\00E9cimale des nombres.</p>'),
unistr('<p>La marque d\00E9cimale peut \00EAtre tout caract\00E8re mono-octet diff\00E9rent du s\00E9parateur de groupes. Ce peut \00EAtre un espace mais non un caract\00E8re num\00E9rique, ni aucun des caract\00E8res suivants :</p>'),
'<ul class="noIndent">',
'<li>plus (+)</li>',
'<li>tiret (-)</li> ',
unistr('<li>signe inf\00E9rieur (<)</li>'),
unistr('<li>signe sup\00E9rieur (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131764744305644)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156447502305663)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer les pi\00E8ces jointes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153102350305660)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Eventuellement d\00E9limit\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132083062305644)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un caract\00E8re d\00E9limiteur. Vous pouvez utiliser ce caract\00E8re pour d\00E9limiter le d\00E9but et la fin d''une valeur de donn\00E9es. Si vous indiquez un caract\00E8re d\00E9limiteur, Data Workshop ne tient pas compte des espaces figurant avant le d\00E9but ou la fin ')
||unistr('d''une valeur de donn\00E9es. Vous pouvez \00E9galement utiliser cette option pour entourer une valeur du caract\00E8re d\00E9limiteur choisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156287183305662)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Exp\00E9rience')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153527845305660)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes en \00E9chec :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132208541305645)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156591558305663)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152653063305660)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152756472305660)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom du fichier \00E0 t\00E9l\00E9charger vers le serveur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153200035305660)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cochez cette case si la premi\00E8re ligne des donn\00E9es contient des noms de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154309835305661)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur de groupes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154465225305661)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le s\00E9parateur de groupes est un caract\00E8re qui s\00E9pare les groupes d''entiers, par exemple les milliers et les millions.</p>'),
unistr('<p> Il peut \00EAtre repr\00E9sent\00E9 par n''importe quel caract\00E8re. Le caract\00E8re indiqu\00E9 doit \00EAtre mono-octet, et le s\00E9parateur de groupes doit \00EAtre diff\00E9rent de toute marque d\00E9cimale. Le caract\00E8re peut \00EAtre un espace, mais il ne peut pas \00EAtre repr\00E9sent\00E9 par u')
||unistr('n caract\00E8re num\00E9rique ni l''un des caract\00E8res suivants :</p>'),
'<ul class="noIndent">',
'<li>signe plus (+)</li>',
'<li>trait d''union (-)</li> ',
'<li>symbole plus petit que (<)</li>',
'<li>symbole plus grand que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153368301305660)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes ins\00E9r\00E9es :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132367361305645)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131927491305644)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156684602305663)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'fr'
,p_message_text=>'Evaluation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152306316305659)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9moriser le nom utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152460352305660)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si vous cochez cette case, l''application enregistre votre nom utilisateur dans un cookie de navigateur persistant nomm\00E9 "LOGIN_USERNAME_COOKIE".'),
unistr('Lors de votre prochain acc\00E8s \00E0 la page de connexion,'),
unistr('cette valeur est automatiquement renseign\00E9e dans le champ de nom utilisateur.'),
'</p>',
'<p>',
unistr('Si vous d\00E9sactivez cette case \00E0 cocher et que votre nom utilisateur est d\00E9j\00E0 enregistr\00E9 dans le cookie,'),
'l''application le remplace par une valeur vide.',
unistr('Vous pouvez \00E9galement utiliser les outils de d\00E9veloppement de votre navigateur pour enlever enti\00E8rement le cookie.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156783430305663)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ponse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153630035305660)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne(s) \00E0 r\00E9viser :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131526358305644)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131619321305644)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'fr'
,p_message_text=>'Rechercher...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152975594305660)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153033506305660)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifiez le caract\00E8re s\00E9parateur de colonnes. Utilisez <code>\005Ct</code> pour une s\00E9paration par des tabulations.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153767512305660)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les param\00E8tres avanc\00E9s pour le chargement des donn\00E9es : Symbole mon\00E9taire, Caract\00E8res d\00E9cimaux, Encodage de fichier ou Formats de date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155496689305662)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101132451200305645)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155044469305661)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence de th\00E8me de l''utilisateur final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155122804305662)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Si cette option est s\00E9lectionn\00E9e, les utilisateurs finals peuvent choisir leur propre style de th\00E8me \00E0 l''aide du lien Personnaliser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154898642305661)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de th\00E8me du bureau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154926133305661)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le style de th\00E8me par d\00E9faut s''applique \00E0 tous les utilisateurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101154751563305661)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'fr'
,p_message_text=>'Tranche de temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101153472709305660)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes mises \00E0 jour :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131897619305644)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155807813305662)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'fr'
,p_message_text=>'Noms utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156048571305662)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des noms utilisateur s\00E9par\00E9s par des virgules, des points-virgules ou des caract\00E8res non imprimables. Les noms utilisateurs existants ou en double sont automatiquement ignor\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155901418305662)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'fr'
,p_message_text=>'Saisir les noms utilisateur ici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156106153305662)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format de nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101156855163305663)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'fr'
,p_message_text=>'Agent utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101155201506305662)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'fr'
,p_message_text=>'Visualiser comme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134543025305646)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134434227305646)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats d''activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159190401305665)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'fr'
,p_message_text=>'Administration des applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134307110305646)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>'Configuration de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134752660305646)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tats de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134679746305646)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159005604305664)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134865525305647)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tat sur les travaux')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158977842305664)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159237946305665)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134247540305646)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'fr'
,p_message_text=>'Interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159365104305665)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer le composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135090468305647)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135191598305647)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9connexion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134913227305647)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'fr'
,p_message_text=>'Etape %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157144317305663)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes d''\00E9tat par page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158631558305664)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ception confirm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158076985305664)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158825253305664)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ferm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157392893305663)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'fr'
,p_message_text=>'Copier/coller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157612985305663)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'fr'
,p_message_text=>'Utiliser les masques de format d''application standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157720939305664)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquer des formats personnalis\00E9s pour les colonnes t\00E9l\00E9charg\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158160342305664)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresses \00E9lectroniques')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157802016305664)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser les utilisateurs finals \00E0 choisir le style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157481644305663)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('La premi\00E8re ligne contient des noms de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158449447305664)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('N\00E9gatif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158354356305664)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'fr'
,p_message_text=>'Neutre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158536348305664)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Aucune action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158726615305664)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouvert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101158237887305664)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'fr'
,p_message_text=>'Positif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157962686305664)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter une page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157502092305663)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser les param\00E8tres avanc\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157274010305663)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger un fichier vers le serveur (d\00E9limitation par des virgules (*.csv) ou des tabulations)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161275496305666)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Tableau de bord des activit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135798606305647)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter plusieurs utilisateurs - Etape %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135901243305647)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter plusieurs utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160852768305666)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160921773305666)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La page d''administration permet aux propri\00E9taires de l''application (administrateurs) de configurer l''application et de tenir \00E0 jour les donn\00E9es communes qu''elle utilise.'),
unistr('En s\00E9lectionnant l''un des param\00E8tres disponibles, les administrateurs peuvent potentiellement modifier l''affichage de l''application et/ou les fonctions disponibles pour les utilisateurs finals.</p>'),
unistr('<p>L''acc\00E8s \00E0 cette page doit \00EAtre exclusivement limit\00E9 aux administrateurs.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161476099305666)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal des automatisations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161555803305666)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif du journal des automatisations.</p>'),
unistr('<p>Consultez les informations consign\00E9es \00E0 propos des ex\00E9cutions d''automatisation pr\00E9c\00E9dentes : le journal contient les horodatages de d\00E9but et de fin ainsi que les d\00E9tails relatifs aux lignes trait\00E9es (sans et avec erreurs). Effectuez une analyse de')
||unistr('scendante jusqu''\00E0 Messages pour obtenir les messages individuels des lignes trait\00E9es.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161169297305666)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les param\00E8tres de configuration vous permettent de rendre des fonctionnalit\00E9s sp\00E9cifiques disponibles (activ\00E9es) ou indisponibles (d\00E9sactiv\00E9es) pour les utilisateurs finals.</p>'),
unistr('<p>Si une fonction sp\00E9cifique n''est pas int\00E9gralement pr\00EAte ou n\00E9cessite d''\00EAtre enlev\00E9e temporairement, cliquez sur <strong>D\00E9sactiv\00E9</strong>.'),
unistr('Une fois qu''elle doit \00EAtre rendue disponible, cliquez simplement sur <strong>Activ\00E9</strong>.</p>'),
unistr('<p><em><strong>Remarque :</strong> les modifications apport\00E9es ici ne seront pas refl\00E9t\00E9es pour les utilisateurs finals individuels qui ex\00E9cutent actuellement l''application. Lorsque l''utilisateur final se d\00E9connecte, puis se reconnecte, le param\00E8tre ')
||unistr('r\00E9vis\00E9 de la fonction sera appel\00E9.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162547112305667)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Configurer le contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162639978305667)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez l''option appropri\00E9e pour tous les utilisateurs authentifi\00E9s.<br>'),
unistr('Si vous s\00E9lectionnez <strong>Non</strong>, l''application sera plus s\00E9curis\00E9e, car seuls les utilisateurs sp\00E9cifi\00E9s peuvent y acc\00E9der.'),
unistr('Toutefois, si votre application compte de nombreux utilisateurs, tenir \00E0 jour les utilisateurs peut s''av\00E9rer complexe, et vous pr\00E9f\00E9rerez peut-\00EAtre choisir <strong>Oui</strong> et entrer uniquement des administrateurs d''application, et \00E9ventuellement')
||' des contributeurs.<br>',
unistr('Si vous s\00E9lectionnez <strong>Oui</strong>, vous devez \00E9galement indiquer le mode de traitement des utilisateurs qui ne figurent pas sur la liste des utilisateurs.</p>'),
unistr('<p>Indiquez si une adresse \00E9lectronique ou une valeur alphanum\00E9rique est requise pour les noms utilisateur.<br>'),
unistr('G\00E9n\00E9ralement, vous devrez d\00E9finir ce param\00E8tre sur <strong>Adresse \00E9lectronique</strong> si votre application utilise (ou sera configur\00E9e pour utiliser) un mod\00E8le d''authentification centralis\00E9 tel qu''Oracle Access Manager ou l''acc\00E8s avec connexion un')
||'ique.</p>',
unistr('<p><em><strong>Remarque :</strong> cette application prend en charge les 3 niveaux d''acc\00E8s suivants : Lecteur, Contributeur et Administrateur.'),
'<ul>',
unistr('  <li>Les <strong>lecteurs</strong> disposent d''un acc\00E8s en lecture seule \00E0 toutes les informations et peuvent \00E9galement consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>contributeurs</strong> peuvent cr\00E9er, modifier et supprimer des informations et consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>administrateurs</strong>, outre les capacit\00E9s des contributeurs, peuvent \00E9galement ex\00E9cuter la configuration de l''application en acc\00E9dant \00E0 sa section Administration.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162027731305667)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal des erreurs de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162182872305667)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif de toutes les erreurs inattendues consign\00E9es par cette application.</p>'),
unistr('<p>Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires. Pour r\00E9tablir les para')
||unistr('m\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162838564305667)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162940968305667)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''informations en retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163010207305668)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p><strong>Activer les pi\00E8ces jointes :</strong> si l''option est d\00E9finie sur Oui, les utilisateurs pourront t\00E9l\00E9charger une pi\00E8ce jointe et l''ajouter \00E0 leurs informations en retour.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135823135305647)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour soumises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135580155305647)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'fr'
,p_message_text=>'Page globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135258717305647)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159910629305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cliquez sur l''ic\00F4ne des informations en retour ( <span class="fa fa-comment-o" aria-hidden="true"></span>) dans la barre de navigation, \00E0 partir de n''importe quelle page de l''application, afin de transmettre des informations en retour aux administ')
||'rateurs de l''application.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159722200305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Il s''agit de la page d''accueil de l''application. Cliquez sur les cartes pour acc\00E9der aux diff\00E9rentes pages de l''application, ou utilisez le menu de navigation sur le c\00F4t\00E9 de la page.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160391681305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cliquez sur la liste d\00E9roulante de votre nom dans la barre de navigation pour vous d\00E9connecter de l''application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160237135305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cliquez sur le menu utilisateur (<span class="fa fa-user" aria-hidden="true"></span>) dans la barre de navigation pour mettre \00E0 jour votre pr\00E9f\00E9rence de fuseau horaire et vous d\00E9connecter de l''application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159660576305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159817194305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Il s''agit de la page d''accueil de l''application. Cliquez sur les cartes pour acc\00E9der aux diff\00E9rentes pages de l''application, ou utilisez le menu de navigation en haut de la page.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160177943305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cliquez sur le menu utilisateur (<span class="fa fa-user" aria-hidden="true"></span>) dans la barre de navigation (en haut \00E0 droite de la page) pour acc\00E9der \00E0 votre profil utilisateur et vous d\00E9connecter de l''application.<br>'),
unistr('Si vous cliquez sur <strong>Afficher mon profil</strong>, vous pouvez ensuite cliquer sur <strong>Mettre \00E0 jour le profil</strong> pour entrer vos d\00E9tails personnels et t\00E9l\00E9charger une photo ou un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160091575305665)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cliquez sur le menu utilisateur (<span class="fa fa-user" aria-hidden="true"></span>) dans la barre de navigation pour acc\00E9der \00E0 votre profil utilisateur, mettre \00E0 jour votre pr\00E9f\00E9rence de fuseau horaire et vous d\00E9connecter de l''application.<br>'),
unistr('Si vous cliquez sur <strong>Afficher mon profil</strong>, vous pouvez ensuite cliquer sur <strong>Mettre \00E0 jour le profil</strong> pour entrer vos d\00E9tails personnels et t\00E9l\00E9charger une photo ou un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160507828305666)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez ins\00E9rer, mettre \00E0 jour et supprimer des donn\00E9es directement dans cette grille interactive.<br>'),
unistr('  Ins\00E9rez une nouvelle ligne en cliquant sur le bouton Ajouter une ligne.<br>'),
unistr('  Cliquez deux fois dans une cellule, ou cliquez sur le bouton <strong>Modifier</strong> pour mettre \00E0 jour les valeurs de donn\00E9es, comme lorsque vous modifiez des donn\00E9es dans une feuille de calcul.</p>'),
'',
unistr('<p>Utilisez le menu Actions de ligne ( <span class="fa fa-bars" aria-hidden="true"></span> ) en haut de l''\00E9tat pour dupliquer, supprimer, actualiser ou r\00E9tablir les lignes s\00E9lectionn\00E9es.<br> '),
unistr('  Utilisez le menu Actions de ligne sur les lignes individuelles pour acc\00E9der \00E9galement \00E0 la vue monoligne ou pour ajouter une nouvelle ligne.</p>'),
'',
unistr('<p>Pour rechercher des donn\00E9es, entrez un terme de recherche dans la bo\00EEte de dialogue de recherche, ou cliquez sur les en-t\00EAtes de colonne pour limiter les enregistrements renvoy\00E9s.</p>'),
'',
unistr('<p>Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Actions</strong>. Ainsi, vous pouvez s\00E9lectionner les colonnes \00E0 afficher/masquer et leur ordre d''affichage, mais aussi de nombreuses fonctions relatives aux donn\00E9es et')
||unistr(' aux formats. Vous pouvez \00E9galement d\00E9finir une vue suppl\00E9mentaire des donn\00E9es \00E0 l''aide de l''option de graphique.</p>'),
'',
unistr('<p>Pour enregistrer vos personnalisations, s\00E9lectionnez l''\00E9tat, ou cliquez sur le bouton de t\00E9l\00E9chargement pour d\00E9charger les donn\00E9es.<p>'),
'',
'<p>Pour plus d''informations, cliquez sur Aide au bas du menu Actions.</p> ',
'',
unistr('<p>Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160603360305666)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour rechercher des donn\00E9es, entrez un terme de recherche dans la bo\00EEte de dialogue de recherche, ou cliquez sur les en-t\00EAtes de colonne pour limiter les enregistrements renvoy\00E9s.</p>'),
'',
unistr('<p>Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Actions</strong>. Ainsi, vous pouvez s\00E9lectionner les colonnes \00E0 afficher/masquer et leur ordre d''affichage, mais aussi de nombreuses fonctions relatives aux donn\00E9es et')
||unistr(' aux formats. Vous pouvez \00E9galement d\00E9finir des vues de donn\00E9es suppl\00E9mentaires \00E0 l''aide de l''option de graphique.</p>'),
'',
unistr('<p>Pour enregistrer vos personnalisations, s\00E9lectionnez l''\00E9tat ou cliquez sur le bouton de t\00E9l\00E9chargement pour d\00E9charger les donn\00E9es.<p>'),
'<br>',
'<p>Pour plus d''informations, cliquez sur Aide au bas du menu Actions.</p>',
'',
unistr('<p>Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160423195305666)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour rechercher des donn\00E9es, entrez un terme de recherche dans la bo\00EEte de dialogue de recherche, ou cliquez sur les en-t\00EAtes de colonne pour limiter les enregistrements renvoy\00E9s.</p>'),
'',
unistr('<p>Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Actions</strong>. Ainsi, vous pouvez s\00E9lectionner les colonnes \00E0 afficher/masquer et leur s\00E9quence d''affichage, mais aussi de nombreuses fonctions relatives aux donn\00E9es')
||unistr(' et aux formats. Vous pouvez \00E9galement d\00E9finir des vues de donn\00E9es suppl\00E9mentaires \00E0 l''aide des options Graphique, Grouper par et Permuter.</p>'),
'',
unistr('<p>Pour enregistrer vos personnalisations, s\00E9lectionnez l''\00E9tat ou cliquez sur le bouton de t\00E9l\00E9chargement pour d\00E9charger les donn\00E9es. Entrez votre adresse \00E9lectronique et l''intervalle de temps dans l''abonnement selon lequel envoyer les donn\00E9es r\00E9guli')
||unistr('\00E8rement.<p>'),
'',
'<p>Pour plus d''informations, cliquez sur Aide au bas du menu Actions.</p>',
'',
unistr('<p>Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135321411305647)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'fr'
,p_message_text=>'Page de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135429179305647)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'fr'
,p_message_text=>'%0 - Connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162218533305667)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'fr'
,p_message_text=>'Messages de journalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163181997305668)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer les informations en retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163216175305668)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les informations en retour peuvent \00EAtre saisies par les utilisateurs finals \00E0 partir de n''importe quelle page normale dans l''application.</p>'),
unistr('<p>Cet \00E9tat affiche les informations en retour saisies, les r\00E9ponses transmises par les administrateurs et le statut des informations en retour.</p>'),
unistr('<p>Cliquez sur l''ic\00F4ne de modification (crayon jaune) pour saisir une r\00E9ponse ou mettre \00E0 jour le statut des informations en retour.</p>'),
unistr('<p><em><strong>Remarque :</strong> si des destinataires ont \00E9t\00E9 d\00E9finis pour les informations en retour, ces derniers seront \00E9galement envoy\00E9s par courriel aux adresses \00E9lectroniques figurant dans la liste des destinataires des informations en retour')
||'.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162369426305667)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer l''acc\00E8s utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162489802305667)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat des utilisateurs de l''application et du niveau d''acc\00E8s octroy\00E9.</p>'),
unistr('<p>Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires.<br>'),
unistr('Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>'),
unistr('<p>Cliquez sur l''ic\00F4ne de modification (crayon jaune) pour modifier les d\00E9tails et le niveau d''acc\00E8s de l''utilisateur, ou pour supprimer ce dernier.</p>'),
unistr('<p>Pour ajouter un nouvel utilisateur et son niveau d''acc\00E8s, cliquez sur <strong>Ajouter un utilisateur</strong>, en haut de l''\00E9tat.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101162713632305667)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez ce formulaire pour entrer des utilisateurs et leur adresse \00E9lectronique, et d\00E9finir leur niveau d''acc\00E8s.'),
unistr('Les param\00E8tres d\00E9finis dans <em>Configurer le contr\00F4le d''acc\00E8s</em> d\00E9termineront si le nom utilisateur doit \00EAtre leur adresse \00E9lectronique ou s''il peut s''agir de n''importe quelle entr\00E9e alphanum\00E9rique.</p>'),
unistr('<p>Cette application prend en charge les 3 niveaux d''acc\00E8s suivants : Lecteur, Contributeur et Administrateur.</p>'),
'<ul>',
unistr('  <li>Les <strong>lecteurs</strong> disposent d''un acc\00E8s en lecture seule \00E0 toutes les informations et peuvent \00E9galement consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>contributeurs</strong> peuvent cr\00E9er, modifier et supprimer des informations et consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>administrateurs</strong>, outre les capacit\00E9s des contributeurs, peuvent \00E9galement ex\00E9cuter la configuration de l''application en acc\00E9dant \00E0 sa section Administration.</li>'),
'</ul>',
unistr('<p>Lorsque vous modifiez un utilisateur existant, vous pouvez verrouiller son compte, ce qui l''emp\00EAchera d''acc\00E9der \00E0 l''application.</p>'),
unistr('<p><em><strong>Remarque :</strong>   si vous utilisez des comptes Oracle Application Express, les utilisateurs entr\00E9s ici doivent \00E9galement \00EAtre d\00E9finis en tant qu''utilisateurs finals par un administrateur d''espace de travail, qui peut aussi d\00E9finir ')
||'leur mot de passe.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101160792401305666)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La page d''\00E9tat affiche les enregistrements principaux dans un s\00E9lecteur sur le c\00F4t\00E9 de la page. '),
unistr('  S\00E9lectionnez un enregistrement pour voir l''enregistrement ma\00EEtre et les enregistrements d\00E9tails d\00E9finis.<br> '),
unistr('  Cliquez sur l''ic\00F4ne de modification (<span class="fa fa-pencil-square-o" aria-hidden="true"></span>) pour modifier l''enregistrement ma\00EEtre.'),
unistr('  Pour les enregistrements d\00E9tails, cliquez sur l''ic\00F4ne en forme de crayon, au d\00E9but de chaque ligne, pour les modifier.</p>'),
unistr('<p>Pour limiter les donn\00E9es affich\00E9es dans le s\00E9lecteur, saisissez un terme de recherche dans la bo\00EEte de dialogue de recherche.</p>'),
'',
unistr('<p>Pour ajouter un nouvel enregistrement ma\00EEtre, cliquez sur <strong>Cr\00E9er</strong> en haut de la page.'),
unistr('  Pour les enregistrements d\00E9tails, cliquez sur l''ic\00F4ne plus (+) situ\00E9e en haut de la r\00E9gion de d\00E9tails pour ajouter un enregistrement d\00E9tails.</p>'),
'',
unistr('<p>Cliquez sur <strong>R\00E9initialiser</strong> en haut de la page pour r\00E9tablir les param\00E8tres par d\00E9faut de la page, en enlevant tous les termes de recherche pr\00E9c\00E9demment d\00E9finis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161863855305667)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>'Performances de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161959869305667)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif des performances et de la popularit\00E9 de la page. L''\00E9tat est tri\00E9 par <strong>Performances pond\00E9r\00E9es</strong> qui sont calcul\00E9es en multipliant le temps \00E9coul\00E9 m\00E9dian et le nombre de vues de page.</p>'),
unistr('<p>S\00E9lectionnez la tranche de temps de g\00E9n\00E9ration d''\00E9tat (par d\00E9faut = 1 jour) en haut de la page si n\00E9cessaire.<br>'),
unistr('Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires. Pour r\00E9tablir les param\00E8t')
||unistr('res par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161678286305666)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161727089305667)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif des vues de page les plus r\00E9centes.</p>'),
unistr('<p>S\00E9lectionnez la tranche de temps de g\00E9n\00E9ration d''\00E9tat (par d\00E9faut = 1 jour) en haut de la page si n\00E9cessaire.<br>'),
unistr('Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires. Pour r\00E9tablir les param\00E8t')
||unistr('res par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161026949305666)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le sch\00E9ma de couleur par d\00E9faut utilis\00E9 pour afficher l''application.</p>'),
unistr('<p>Si l''option <strong>Autoriser les utilisateurs finals \00E0 choisir un style de th\00E8me</strong> est s\00E9lectionn\00E9e, chaque utilisateur final peut choisir parmi les styles de th\00E8me disponibles en cliquant sur le lien <em>Personnaliser</em> dans l''angle in')
||unistr('f\00E9rieur gauche de la page d''accueil.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101135619642305647)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'fr'
,p_message_text=>'Principaux utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101161366268305666)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cet \00E9tat et ce graphique pour afficher les utilisateurs comportant le plus de vues de page pour la tanche de temps sp\00E9cifi\00E9e.</p>'),
unistr('<p>S\00E9lectionnez la tranche de temps de g\00E9n\00E9ration d''\00E9tat (par d\00E9faut = 1 jour) et choisissez l''ic\00F4ne d''\00E9tat ou de graphique en haut de la page.</p>'),
unistr('<p>Pour l''\00E9tat interactif, utilisez le champ de recherche ou s\00E9lectionnez l''en-t\00EAte de colonne <strong>Utilisateur</strong> pour s\00E9lectionner un utilisateur sp\00E9cifique. Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Ac')
||unistr('tions</strong>, telles que les colonnes affich\00E9es/masqu\00E9es, les lignes par page, les filtres, etc. Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151774260305659)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter des utilisateurs \00E0 la liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151829623305659)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateurs ajout\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150029460305658)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Effacer le cache des pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133674890305646)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Fermer la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151695512305659)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er des collections')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133922050305646)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Supprimer les informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134096837305646)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations en retour supprim\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151556433305659)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'fr'
,p_message_text=>'Traiter le panneau %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152272563305659)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'fr'
,p_message_text=>'Obtenir l''ID de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151209310305659)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Obtenir les d\00E9tails du journal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150579182305658)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'fr'
,p_message_text=>unistr('Obtenir la valeur de la cl\00E9 primaire suivante ou pr\00E9c\00E9dente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149962827305658)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'fr'
,p_message_text=>'Obtenir le cookie de nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149653844305657)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 - Enregistrer les donn\00E9es de grille interactive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151436636305659)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'fr'
,p_message_text=>'Initialiser le panneau %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150442118305658)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133738666305646)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Charger les donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150602761305658)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec du chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133825602305646)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9pondre aux informations en retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133461941305646)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149748769305658)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la recherche d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101133575080305646)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151388743305659)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de contr\00F4le d''acc\00E8s enregistr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151067755305659)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151186921305659)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de configuration mises \00E0 jour. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152158726305659)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer le param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101149832380305658)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le cookie de nom utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101151908677305659)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Soumettre les informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101152044800305659)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour soumises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150166159305658)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('#MRD_COUNT# ligne(s) supprim\00E9e(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150206716305658)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise \00E0 jour appliqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150335521305658)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('#MRU_COUNT# ligne(s) mise(s) \00E0 jour, #MRI_COUNT# ligne(s) ins\00E9r\00E9e(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150928064305658)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer la pr\00E9f\00E9rence de style de l''utilisateur final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101134196491305646)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''apparence de l''application enregistr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150745702305658)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer le style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101150820112305658)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''apparence de l''application enregistr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140427334305651)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140379974305651)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Actions de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142151467305652)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'fr'
,p_message_text=>unistr('Configuration du contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140529375305651)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations sur la liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140177408305650)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats d''activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131146637305644)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Administration des applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139907128305650)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>'Configuration de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141981053305652)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution d''automatisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130213640305643)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139044038305650)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'fr'
,p_message_text=>'Boutons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131069867305644)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139898010305650)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>'Configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140268994305651)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>'Configurer l''apparence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130584993305643)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139478347305650)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrements en \00E9chec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139514733305650)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrements modifi\00E9s par un autre utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139337217305650)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Progression de l''assistant Chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130804967305644)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de lignes pour cet \00E9tat est de %0 lignes. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements dans votre requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130775151305643)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140994699305651)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tats de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142326886305652)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Exceptions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140690392305651)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131447724305644)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour soumises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141667129305652)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142877906305653)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion d''\00E9l\00E9ment de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130636037305643)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'fr'
,p_message_text=>'Panneau sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142798828305652)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments masqu\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141134261305651)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de la page Horaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139284996305650)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'fr'
,p_message_text=>'Informations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141039855305651)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tat sur les travaux')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140733569305651)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de langue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141473273305652)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141593219305652)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune activit\00E9 n''a \00E9t\00E9 trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139671811305650)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrements ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142049317305652)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'fr'
,p_message_text=>'Messages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141251365305651)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages les plus actives'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130948456305644)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130498167305643)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun enregistrement s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139722789305650)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun enregistrement s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142524488305652)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'fr'
,p_message_text=>'Il n''existe aucun utilisateur valide - Infos sur la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142645761305652)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun nouvel utilisateur valide trouv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141322849305651)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreurs r\00E9centes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130305959305643)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131287440305644)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101130100759305643)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141718065305652)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'fr'
,p_message_text=>'Principaux utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101141817380305652)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique des principaux utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101131361581305644)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 utilisateurs \00E0 ajouter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140899261305651)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat sur le nombre d''utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101140012208305650)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'fr'
,p_message_text=>'Interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142455950305652)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'fr'
,p_message_text=>'Il existe des utilisateurs valides - Infos sur la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101142256967305652)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'fr'
,p_message_text=>'Conteneur d''assistant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101139122633305650)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'Progression d''assistant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101159527282305665)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'fr'
,p_message_text=>'Version %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101157031217305663)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'fr'
,p_message_text=>unistr('Etes-vous s\00FBr de vouloir quitter cette page sans l''enregistrer ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137612427305649)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ligne(s) mise(s) \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138800867305649)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Au moins une information en retour doit \00EAtre indiqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138969901305650)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Fournissez des informations en retour sur votre exp\00E9rience.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138642346305649)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de vous enlever vous-m\00EAme en tant qu''administrateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138733022305649)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas enlever votre propre r\00F4le d''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138136608305649)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #COLUMN_HEADER# doit \00EAtre une date valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101137925853305649)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'fr'
,p_message_text=>'La valeur #COLUMN_HEADER# doit comporter une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138049012305649)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #COLUMN_HEADER# doit \00EAtre num\00E9rique.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138264147305649)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #COLUMN_HEADER# doit \00EAtre une valeur d''horodatage valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136248895305648)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 doit \00EAtre une date valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138469750305649)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# doit \00EAtre une date valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138364190305649)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Le champ #LABEL# doit contenir une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101138579744305649)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# doit \00EAtre un horodatage valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136012604305647)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'%0 non NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136122451305648)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 doit \00EAtre num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101136311052305648)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 doit \00EAtre un horodatage valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053594272306372)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de grille interactive ''%0'' indiqu\00E9e pour l''action dynamique ''#COMPONENT_NAME#'' n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053759867306372)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'fr'
,p_message_text=>unistr('Le processus ''%0'' a g\00E9n\00E9r\00E9 ''%1'' lors du verrouillage de ligne. Cette erreur peut survenir lorsque le processus \00E9met une instruction SELECT FOR UPDATE sur une vue complexe avec un d\00E9clencheur instead-of, pour verrouiller la ligne. D\00E9finissez l''attribu')
||'t de processus Verrouiller la ligne sur Non ou Code PL/SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053631863306372)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le processus ''%0'' a g\00E9n\00E9r\00E9 ''%1'' lors de l''ex\00E9cution d''une commande DML. Cette erreur peut survenir si une colonne repose sur une agr\00E9gation ou sur une expression SQL. D\00E9finissez l''attribut de colonne Requ\00EAte uniquement sur Oui pour exclure la colonne')
||' des instructions INSERT et UPDATE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675380080306075)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne ma\00EEtre-d\00E9tail ''%0'' ne contient aucune valeur. Assurez-vous que le processus ''%1'' est ex\00E9cut\00E9 apr\00E8s le processus correspondant de la r\00E9gion ma\00EEtre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035857328306358)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne ma\00EEtre n''est d\00E9finie pour la grille interactive ''%0'', ce qui est obligatoire pour la relation ma\00EEtre-d\00E9tail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450214814305900)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne de cl\00E9 primaire n''est d\00E9finie pour la grille interactive ''%0'', ce qui est obligatoire pour la modification ou dans une relation ma\00EEtre-d\00E9tail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013257792306341)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour une grille interactive modifiable, l''attribut de page Recharger apr\00E8s soumission doit \00EAtre d\00E9fini sur Seulement en cas de succ\00E8s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984223295306319)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'fr'
,p_message_text=>'Editeur de code : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984357069306319)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984442824306319)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de couleur : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984539403306319)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'fr'
,p_message_text=>'Modifier un composant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984631975306319)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'fr'
,p_message_text=>' (Erreur)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984764523306319)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984146314306319)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984800716306319)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun r\00E9sultat trouv\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984909749306319)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun r\00E9sultat. Essayez de rechercher toutes les propri\00E9t\00E9s en cliquant sur le bouton Afficher tout ci-dessus.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985033310306319)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s du filtre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985193838306319)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'fr'
,p_message_text=>'%0 (non valide)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985208368306319)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985331343306319)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985421220306320)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Les composants s\00E9lectionn\00E9s n''ont aucune propri\00E9t\00E9 en commun.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986627872306320)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun composant n''est actuellement s\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985558752306320)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985637200306320)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Epingler le filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985775900306320)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection rapide : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985862778306320)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Effacer la s\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101985937064306320)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Obligatoire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986097465306320)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986143172306320)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986205821306320)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'fr'
,p_message_text=>' (La valeur varie)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986372708306320)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986461270306320)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'fr'
,p_message_text=>' (Avertissement)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986559973306320)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013341073306341)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour un panneau tabulaire, l''attribut de page Recharger apr\00E8s soumission doit \00EAtre d\00E9fini sur Toujours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792916017306163)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID statique de r\00E9gion doit \00EAtre indiqu\00E9, car la page contient plusieurs grilles interactives.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018197046305559)
,p_name=>'APEXIR_3D'
,p_message_language=>'fr'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128652504305642)
,p_name=>'APEXIR_ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610863589306021)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Ajouter l''abonnement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267612677305763)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Les agr\00E9gats s''affichent apr\00E8s chaque commande BREAK et \00E0 la fin de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183539760305683)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129083524305642)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011076662306340)
,p_name=>'APEXIR_AREA'
,p_message_language=>'fr'
,p_message_text=>'En aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608660279306020)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'fr'
,p_message_text=>'Noir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129305354305642)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235234230305739)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043297202306364)
,p_name=>'APEXIR_DAY'
,p_message_language=>'fr'
,p_message_text=>'jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163576557305668)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer ce qui est coch\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267937277305764)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'fr'
,p_message_text=>'Voulez-vous effectuer cette action de suppression ?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246947663305748)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018316285305559)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996022767305541)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'fr'
,p_message_text=>'Anneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867614900305441)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es uniquement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018230294305559)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'fr'
,p_message_text=>unistr('- Ne pas agr\00E9ger -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994254386306326)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier l''autre valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246883299305748)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'fr'
,p_message_text=>'Activer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267765456305763)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter la demande de Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597900307306011)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de fonction %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608740102306020)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'fr'
,p_message_text=>'Gris'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995815874305541)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence lorsque')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543732969305968)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599702340306013)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez <a href=''%0''>ici</a> pour g\00E9rer votre abonnement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268584010305764)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es suppl\00E9mentaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013932851305554)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'fr'
,p_message_text=>unistr('- Nouvelle cat\00E9gorie -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163643138305668)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune agr\00E9gation d\00E9finie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091762137305615)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'fr'
,p_message_text=>'Aucune information de colonne disponible.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163793171305668)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun calcul d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043131810306364)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'fr'
,p_message_text=>'- Aucune date de fin -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096853236306404)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une colonne de ligne diff\00E9rente. L''expression ou le lien HTML dans la colonne de ligne contient une colonne d\00E9finie en tant que colonne de pivot ou d''agr\00E9gat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128783095305642)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Enlever un agr\00E9gat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497451765305934)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de colonnes d''affichage de l''\00E9tat a \00E9t\00E9 atteint. Cliquez sur S\00E9lectionner des colonnes dans le menu Actions pour r\00E9duire la liste de colonnes d''affichage de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102907978305623)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'fr'
,p_message_text=>'Tri des lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866987172305440)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de colonnes d''affichage de l''\00E9tat a \00E9t\00E9 atteint. Cliquez sur S\00E9lectionner des colonnes dans le menu Actions pour r\00E9duire la liste de colonnes d''affichage de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163412853305668)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer en tant que valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995934666305541)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une cat\00E9gorie -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268689109305764)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Les colonnes calcul\00E9es sont pr\00E9c\00E9d\00E9es par **.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043011935306364)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une colonne de tri -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268415007305764)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042917478306364)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de tri %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597855898306011)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Unit\00E9 de fin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267865185305764)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non autoris\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245186977305746)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('L''en-t\00EAte de colonne doit \00EAtre unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043340909306364)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'fr'
,p_message_text=>'semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864298420305438)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'fr'
,p_message_text=>'Services d''administration Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994530375306326)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune authentification n''est configur\00E9e pour cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306820847305794)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de base de donn\00E9es suivants seront %0 dans le sch\00E9ma s\00E9lectionn\00E9 :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306988513305794)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de base de donn\00E9es suivants ont \00E9t\00E9 %0 :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682054445306080)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('Faire d\00E9filer vers le bas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682132547306080)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'fr'
,p_message_text=>unistr('Faire d\00E9filer jusqu''en haut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870356379305443)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994102494306326)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'fr'
,p_message_text=>'Modifier une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461930956305909)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Objets non valides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047334663306367)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Il n''existe aucune page homologue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997444248306329)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets \00E0 cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997686038306329)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'fr'
,p_message_text=>'Supprimer des tables'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997803713306329)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Supprimer les objets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616884358306025)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'fr'
,p_message_text=>'Supprimer des tables'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616165543306025)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'fr'
,p_message_text=>unistr('Ces objets seront cr\00E9\00E9s dans le sch\00E9ma <strong>%0</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997993333306329)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'fr'
,p_message_text=>unistr('Ces objets existent d\00E9j\00E0 dans le sch\00E9ma <strong>%0</strong> et sont utilis\00E9es par d''autres espaces de travail. Si vous continuez, les objets de feuille Web existants appartenant \00E0 <strong>%0</strong> seront associ\00E9s \00E0 cet espace de travail \00E9galement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998020656306329)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le sch\00E9ma \00E0 utiliser pour ces objets :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998149798306329)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'fr'
,p_message_text=>unistr('Tables existantes \00E0 utiliser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998913477306330)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de base de donn\00E9es de feuille Web seront r\00E9utilis\00E9s \00E0 l''aide des informations suivantes. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616295698306025)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'fr'
,p_message_text=>unistr('Si vous souhaitez cr\00E9er ces objets de feuille Web dans un nouveau sch\00E9ma, utilisez l''assistant <a href=%0>Demander un sch\00E9ma de base de donn\00E9es</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616328048306025)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour ex\00E9cuter les feuilles Web, les objets suivants sont obligatoires :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616455777306025)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de base de donn\00E9es de feuille Web seront cr\00E9\00E9s \00E0 l''aide des informations suivantes. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616526197306025)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'fr'
,p_message_text=>unistr('Tables \00E0 cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616629341306025)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point d''enlever des objets de base de donn\00E9es de feuille Web. Ceci entra\00EEnera la suppression de ces objets et des donn\00E9es internes contenant les composants de feuille Web de votre espace de travail. Voulez-vous continuer ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616984034306026)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez corriger les objets non valides suivants pour pouvoir ex\00E9cuter les feuilles Web correctement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997566150306329)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point d''enlever les d\00E9finitions de feuille Web pour cet espace de travail. Les objets de base de donn\00E9es de feuille Web sont \00E9galement utilis\00E9s dans d''autres espaces de travail et ne seront pas supprim\00E9s. Les enregistrements associ\00E9s')
||unistr(' \00E0 cet espace de travail seront supprim\00E9s. Voulez-vous continuer ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617003259306026)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617115247306026)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type d''objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616717301306025)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997305564306329)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets existants \00E0 utiliser')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919623535305480)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Calculs d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919511780305480)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455753798305904)
,p_name=>'APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516734262305948)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'fr'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371427301305841)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition de calcul d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374265842305843)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371585633305841)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition de processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302538182305789)
,p_name=>'APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437080814305890)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'fr'
,p_message_text=>'Applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345618990305822)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Activit\00E9 de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383609571305850)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381711939305849)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Application supprim\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864024351305438)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppement d''applications')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382612648305849)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'fr'
,p_message_text=>'Identifie l''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342442362305820)
,p_name=>'APPLICATION_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242331442305744)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''application est r\00E9serv\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242277955305744)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''application doit \00EAtre un entier positif.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657061819306055)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'fr'
,p_message_text=>'Images d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411764308305871)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945542621305503)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914448041305476)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Application : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383587070305850)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046924184306367)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'fr'
,p_message_text=>'Noms d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493476675305932)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'fr'
,p_message_text=>'ID de remplacement d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381280970305848)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046894457306367)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020900728305561)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381498767305848)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457377694305905)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Version de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879159344305449)
,p_name=>'APPLICATION_X'
,p_message_language=>'fr'
,p_message_text=>'Application %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330036615305811)
,p_name=>'APPROVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Approuv\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387833022305853)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation de l''application a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049400170306369)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Application mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912300000305475)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'fr'
,p_message_text=>unistr('Application de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912460047305475)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Application \00E9chantillon ou de productivit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408685727305868)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'fr'
,p_message_text=>unistr('Feuille Web \00E9chantillon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912221219305474)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'fr'
,p_message_text=>'Application Web'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329539594305810)
,p_name=>'ARCHIVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Archiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914747651305476)
,p_name=>'ARCHIVELOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Archivage de journaux : Activ\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165601704305669)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'fr'
,p_message_text=>'Les arguments doivent avoir un checksum.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253293264305752)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''argument'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253459759305752)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type d''argument'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323717947305806)
,p_name=>'ASAP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E8s que possible')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321044070305804)
,p_name=>'ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('Affect\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018504574305559)
,p_name=>'ASSIGNEE'
,p_message_language=>'fr'
,p_message_text=>'Destinataire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069104104306383)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Affecter %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074509705305602)
,p_name=>'ASSOCIATED'
,p_message_language=>'fr'
,p_message_text=>unistr('associ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020155094305560)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s associ\00E9es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350846122305826)
,p_name=>'ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076981483306389)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'fr'
,p_message_text=>'A risque'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046085644305580)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de faire migrer les options d''authentification personnalis\00E9e de cette application vers un mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045585273305579)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode d''authentification en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045907693305580)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction d''authentification personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045676836305580)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045844060305580)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'fr'
,p_message_text=>'URL de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045727309305580)
,p_name=>'AUTH.NONE'
,p_message_language=>'fr'
,p_message_text=>'aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051093263305583)
,p_name=>'AUTHENTICATION'
,p_message_language=>'fr'
,p_message_text=>'Authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372440690305842)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Fonction d''authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372176258305842)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066093359305594)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de supprimer un mod\00E8le d''authentification pour l''application %0. Si l''application n''utilise pas actuellement l''authentification SCHEME ou si le mod\00E8le consid\00E9r\00E9 n''est pas le mod\00E8le d''authentification en cours, la suppression n''')
||unistr('a pas d''incidence sur le fonctionnement de l''application. Si l''application utilise l''authentification SCHEME et que ce mod\00E8le est le mod\00E8le d''authentification en cours, l''application va continuer \00E0 fonctionner avec l''authentification SCHEME, mais ell')
||unistr('e utilisera un mod\00E8le d''authentification par d\00E9faut. Ce dernier utilisera une page de connexion int\00E9gr\00E9e avec v\00E9rification des informations d''identification "porte ouverte" (autrement dit,  tout le monde sera autoris\00E9 \00E0 ex\00E9cuter l''application). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068042497305598)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur le bouton Rendre en cours pour que votre application utilise ce mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544086646305968)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'fr'
,p_message_text=>'Comptes Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860636347305435)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'fr'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544187560305968)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544467273305968)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'fr'
,p_message_text=>'Aucune authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544211533305968)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Comptes de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805858739306172)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Variable d''en-t\00EAte HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544685953305968)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544365182305968)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'fr'
,p_message_text=>'Annuaire LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544567230305968)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification porte ouverte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838527098305419)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'fr'
,p_message_text=>'Connexion SAML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889107084305457)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'fr'
,p_message_text=>'Connexion sociale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412759940305871)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372080510305842)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860773928305436)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'fr'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879386188305449)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL Existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879482231305449)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction PL/SQL renvoyant une valeur bool\00E9enne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234995884305739)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Est dans un r\00F4le ou un groupe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235035084305739)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''est pas dans un r\00F4le ou un groupe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879568361305449)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''\00E9l\00E9ment dans Expression 1 = Expression 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879687157305450)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment dans Expression1 est NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879746090305450)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment dans Expression 1 est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879846222305450)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''\00E9l\00E9ment dans Expression 1 != Expression 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879951210305450)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL N''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880092114305450)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la pr\00E9f\00E9rence dans Expression 1 = Expression 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880133601305450)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la pr\00E9f\00E9rence dans Expression 1 != Expression 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931275839305491)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Effectuer l''\00E9valuation pour chaque vue de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931386709305491)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Effectuer l''\00E9valuation une fois par session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883050404305452)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte expir\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882970352305452)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883360408305452)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre maximal de tentatives de connexion d\00E9pass\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883421551305452)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur interne inconnue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883260251305452)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'fr'
,p_message_text=>unistr('Premi\00E8re utilisation du mot de passe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883195964305452)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe incorrect'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882795829305452)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Authentification normale, r\00E9ussie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882873613305452)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur inconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977681371305528)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Nom d''espace de travail inconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987752468305535)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'fr'
,p_message_text=>'Nom d''espace de travail inconnu : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108760402305627)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Instruction de validation (commit) non applicable. Toutes les instructions sont valid\00E9es automatiquement.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806814262306173)
,p_name=>'AUTOMATIONS'
,p_message_language=>'fr'
,p_message_text=>'Automatisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806968742306173)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Action d''automatisation'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437693569305890)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode de provisionnement'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858262226305434)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Premier \00E9l\00E9ment')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459151373305907)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'fr'
,p_message_text=>unistr('Disponibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887454350305455)
,p_name=>'AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594006197306009)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Accessible aux d\00E9veloppeurs uniquement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593912930306009)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'fr'
,p_message_text=>unistr('Disponible avec la barre d''outils de d\00E9veloppeur')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346424826305823)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'fr'
,p_message_text=>'Temps moyen d''affichage (secondes)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327991885305809)
,p_name=>'BAR_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 barres')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645798506306047)
,p_name=>'BASIC'
,p_message_language=>'fr'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901333095305466)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppeur de base')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309374498305795)
,p_name=>'BEFORE'
,p_message_language=>'fr'
,p_message_text=>'Avant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052263182306370)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant l''entr\00E9e de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068220321306382)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'fr'
,p_message_text=>'Avant le premier'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375340810305844)
,p_name=>'BIND_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 Bind')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374749272305844)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Variable attach\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374857567305844)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de variable attach\00E9e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389332096305854)
,p_name=>'BLACK_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte noir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864674283305439)
,p_name=>'BLANK'
,p_message_language=>'fr'
,p_message_text=>'Vierge'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350085058305825)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495102573305933)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913314015305475)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495562934305933)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495246783305933)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495388789305933)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'fr'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495411603305933)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'fr'
,p_message_text=>'Incorporation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351047000305826)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>'Format BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350563511305826)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('BLOB - Derni\00E8re colonne mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349923475305825)
,p_name=>'BLOB_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Table BLOB'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389209032305854)
,p_name=>'BLUE_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte bleu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366450398305837)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition de branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935043481305495)
,p_name=>'BRANCHES'
,p_message_language=>'fr'
,p_message_text=>'Branchements'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129566777305643)
,p_name=>'BREADCRUMB'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310075903305796)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310176190305796)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom long de chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129692244305643)
,p_name=>'BREADCRUMBS'
,p_message_language=>'fr'
,p_message_text=>'Chemins de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398105979305861)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411926226305871)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242646301305744)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages de chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317529483305801)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991644736305538)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation de le chemin de navigation a r\00E9ussi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312687277305798)
,p_name=>'BROWSE_ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne d''exploration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312470062305798)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'fr'
,p_message_text=>'Parcourir un package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253072453305752)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Parcourir une table'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844349735305423)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Listes de contr\00F4le d''acc\00E8s d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840605738305420)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Calculs d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888916013305457)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Une erreur est survenue lors de la sauvegarde de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840791801305421)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840959675305421)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'fr'
,p_message_text=>'Processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888619547305456)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'fr'
,p_message_text=>unistr('Application %0 restaur\00E9e \00E0 partir de la r\00E9vision %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840505462305420)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651498498306051)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s d''application : modifi\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394715020305858)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841604291305421)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841743445305421)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843378507305422)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'fr'
,p_message_text=>'Chemins de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843459315305423)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840842912305421)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843620566305423)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843532988305423)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de calendrier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394502718305858)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'fr'
,p_message_text=>'Composants'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805778032306172)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805619523306172)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 modifi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805529451306172)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'fr'
,p_message_text=>'%0 nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842046113305422)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848507106305427)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844874916305424)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852754740305430)
,p_name=>'BU.DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852863792305430)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppeurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842210138305422)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889085651305457)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'Sauvegarde de l''application en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843967226305423)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394955994305858)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re sauvegarde : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394420560305858)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re mise \00E0 jour : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841080078305421)
,p_name=>'BU.LISTS'
,p_message_language=>'fr'
,p_message_text=>'Listes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843802801305423)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888761422305456)
,p_name=>'BU.LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841362579305421)
,p_name=>'BU.LOVS'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844281369305423)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de liste de valeurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848407851305426)
,p_name=>'BU.MESSAGES'
,p_message_language=>'fr'
,p_message_text=>'Messages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852639260305430)
,p_name=>'BU.MODIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 modifi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841575551305421)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394676753305858)
,p_name=>'BU.NEW'
,p_message_language=>'fr'
,p_message_text=>'%0 nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843254738305422)
,p_name=>'BU.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805457796306172)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805342170306172)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 modifi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805201243306172)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'fr'
,p_message_text=>'%0 nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841421028305421)
,p_name=>'BU.PLUGINS'
,p_message_language=>'fr'
,p_message_text=>'Modules d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843738427305423)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848741141305427)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'fr'
,p_message_text=>'Enlever des serveurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844690759305423)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844199097305423)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349701846305825)
,p_name=>'BU.RESTORED'
,p_message_language=>'fr'
,p_message_text=>unistr('Application restaur\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879055792305449)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Application restaur\00E9e \00E0 partir de la r\00E9vision de sauvegarde %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842795661305422)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844542154305423)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAtes partag\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842185424305422)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'Raccourcis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842455232305422)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers d''application statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842521005305422)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers d''espace de travail statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885977527305454)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif des modifications non disponible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844012485305423)
,p_name=>'BU.TABS'
,p_message_language=>'fr'
,p_message_text=>'Onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100842661527305422)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'fr'
,p_message_text=>'Messages texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841219908305421)
,p_name=>'BU.THEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8mes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844449145305423)
,p_name=>'BU.TREES'
,p_message_language=>'fr'
,p_message_text=>'Arborescences'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888830779305456)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841148890305421)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'fr'
,p_message_text=>'Attributs d''interface utilisateur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100841814314305421)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844703674305424)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'fr'
,p_message_text=>'Services Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848688005305427)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'fr'
,p_message_text=>unistr('Sources de donn\00E9es REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868552940305441)
,p_name=>'BUFFER CACHE'
,p_message_language=>'fr'
,p_message_text=>'Cache de tampon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324212640305806)
,p_name=>'BUG'
,p_message_language=>'fr'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347503886305824)
,p_name=>'BUGS'
,p_message_language=>'fr'
,p_message_text=>'Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368925023305839)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('bugs attribu\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406110691305867)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Bugs affect\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897134599305463)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Bugs ferm\00E9s (%0/%1) :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674609362306075)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage de bugs ferm\00E9s (%0/%1) :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406290086305867)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Bugs non affect\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406321839305867)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'fr'
,p_message_text=>'Aucune date de correction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675053741306075)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'fr'
,p_message_text=>unistr('Bugs : %1 sur %0 ferm\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073545605306386)
,p_name=>'BUG_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Bug : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362654600305835)
,p_name=>'BUILD QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Construire une requ\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852464482305429)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852334210305429)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852271898305429)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852555055305430)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852184677305429)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456736507305905)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'fr'
,p_message_text=>'Modules d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454199881305903)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'fr'
,p_message_text=>'[Non pris en charge]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653480499306052)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Message d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058232229305589)
,p_name=>'BUILD_OPTION'
,p_message_language=>'fr'
,p_message_text=>'Option de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503705722305939)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Option de construction : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072260513306385)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Statut de construction : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504523056305940)
,p_name=>'BUILD_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Version du build'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400089751305862)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''\00E9tat int\00E9gr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308610369305795)
,p_name=>'BUTTON'
,p_message_language=>'fr'
,p_message_text=>'bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496834413305934)
,p_name=>'BUTTON.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876749074305447)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Les attributs du bouton s\00E9lectionn\00E9 ne doivent pas contenir d''ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876667362305447)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('Le bouton s\00E9lectionn\00E9 doit comporter une action de type D\00E9fini par une action dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876838293305448)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Le bouton s\00E9lectionn\00E9 utilise un mod\00E8le de bouton qui ne contient pas la cha\00EEne de substitution #BUTTON_ID#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496688937305934)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935213856305495)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('La page doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913931001305476)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte d''\00E9tat doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912023746305474)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('La demande de bouton doit \00EAtre indiqu\00E9e pour tous les types de source de demande de bouton, sauf si le type de source de demande de bouton est Toujours NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912793398305475)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer le type de source de demande de bouton.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935325433305496)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'fr'
,p_message_text=>unistr('La cible d''URL doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878799364305449)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque l''action est de type D\00E9fini par une action dynamique, les attributs de bouton ne doivent pas contenir d''ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936419574305497)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer l''image.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936527063305497)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer le style.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936386150305496)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mod\00E8le doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878685792305449)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque le style de bouton est bas\00E9 sur un mod\00E8le et que l''action est de type D\00E9fini par une action dynamique, le mod\00E8le de bouton s\00E9lectionn\00E9 doit contenir la cha\00EEne de substitution #BUTTON_ID#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866542906305440)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de supprimer le bouton car il est r\00E9f\00E9renc\00E9 dans une action dynamique (page : %0, action dynamique : ''%1'', action : ''%2'', attribut : ''El\00E9ment affect\00E9'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866431763305440)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de supprimer le bouton car il est r\00E9f\00E9renc\00E9 dans une action dynamique (page : %0, action dynamique : ''%1'', attribut : ''Quand'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496796640305934)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Soumettre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101492912336305931)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'fr'
,p_message_text=>'A utiliser dans un attribut "onclick"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496185635305934)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'fr'
,p_message_text=>'A utiliser dans un attribut "href"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935121205305495)
,p_name=>'BUTTONS'
,p_message_language=>'fr'
,p_message_text=>'Boutons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375789943305844)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs de bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072043634306385)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Bouton : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380019794305847)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de bouton')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932429345305492)
,p_name=>'BYTES'
,p_message_language=>'fr'
,p_message_text=>'octets'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323858745305806)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'fr'
,p_message_text=>'Au prochain patch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323956682305806)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'fr'
,p_message_text=>'A la prochaine version'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146609785306442)
,p_name=>'CA.ABOUT'
,p_message_language=>'fr'
,p_message_text=>'A propos de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112983661306417)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'fr'
,p_message_text=>'A propos de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112881661306416)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Inclure une page A propos de cette application qui contient une description de l''application, sa version et un nombre de pages.',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035849100305572)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'fr'
,p_message_text=>'Conteneur de contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146821188306442)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'A propos de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146924631306442)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Le texte concernant cette application peut \00EAtre ins\00E9r\00E9 ici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146540830306442)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'fr'
,p_message_text=>'A propos de cette page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157748570306453)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'fr'
,p_message_text=>unistr('A propos de la version b\00EAta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995700788305541)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de vous enlever vous-m\00EAme en tant qu''administrateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995696241305541)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas enlever votre propre r\00F4le d''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113251544306417)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149190000306444)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Actions de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138653633306436)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Configuration du contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111656282306416)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer l''autorisation utilisateur bas\00E9e sur les r\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113322408306417)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incorporer l''authentification utilisateur bas\00E9e sur les r\00F4les dans votre application.'),
unistr('Les utilisateurs peuvent \00EAtre d\00E9finis en tant qu''administrateurs, contributeurs ou lecteurs.'),
unistr('Vous pouvez ensuite facilement d\00E9finir diff\00E9rents acc\00E8s en fonction des diff\00E9rents r\00F4les pour divers composants au sein de votre application, tels que des pages, des entr\00E9es de menu, des r\00E9gions, des colonnes, des \00E9l\00E9ments, des boutons, etc.</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>R\00E9gion de page administrative comportant des liens permettant d''acc\00E9der aux fonctions de contr\00F4le</li>'),
unistr('<li>Table d''utilisateurs permettant de g\00E9rer le contr\00F4le d''acc\00E8s</li>'),
unistr('<li>Page de configuration permettant de d\00E9finir le niveau d''acc\00E8s des utilisateurs authentifi\00E9s</li>'),
unistr('<li>Page de configuration permettant d''indiquer si les noms utilisateur sont des adresses \00E9lectroniques ou non</li>'),
unistr('<li>Page de gestion de l''acc\00E8s des utilisateurs permettant de signaler et de modifier l''acc\00E8s utilisateur</li>'),
'<li>Page d''ajout d''utilisateur permettant d''ajouter un seul utilisateur</li>',
'<li>Page d''ajout de plusieurs utilisateurs permettant d''ajouter plusieurs utilisateurs (noms utilisateur de messagerie uniquement)</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137535304306435)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138271089306435)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de r\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967366096305520)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137686005306435)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995206096305541)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ception confirm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148984027306443)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations sur la liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149625724306444)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ges insuffisants, l''utilisateur n''est pas un administrateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149700849306444)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 afficher cette application, car vous ne disposez pas des droits d''acc\00E8s ou votre compte a \00E9t\00E9 verrouill\00E9. Contactez l''administrateur de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149801790306444)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ges insuffisants, l''utilisateur n''est pas un contributeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139319150306436)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de contr\00F4le d''acc\00E8s enregistr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144090599306440)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'fr'
,p_message_text=>'HTML de bouton d''action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142953713306439)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''action')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143060042306439)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'fr'
,p_message_text=>'Lien d''action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145626215306441)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'fr'
,p_message_text=>'HTML de lien d''action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131145536306430)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136687894306434)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'fr'
,p_message_text=>unistr('Activit\00E9 par heure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169806864306465)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Tableau de bord des activit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113437293306417)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tats d''activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112605518306416)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclure l''activit\00E9 utilisateur et les \00E9tats d''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113589036306417)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inclure de nombreux \00E9tats relatifs \00E0 l''activit\00E9 des utilisateurs finals de votre application. Identifier les utilisateurs les plus actifs, les pages les plus visit\00E9es, les performances des pages et les erreurs g\00E9n\00E9r\00E9es afin de mieux comprendre l''u')
||unistr('tilisation de votre application en vue d''apporter des am\00E9liorations.</p>'),
unistr('<p>Comprend les \00E9l\00E9ments suivants :'),
'<ul>',
'<li>Etat sur les principaux utilisateurs</li>',
'<li>Etat sur le journal des erreurs de l''application</li>',
unistr('<li>Performances de page, activit\00E9 et performances par page</li>'),
unistr('<li>Etat sur l''activit\00E9 de l''application par page</li>'),
unistr('<li>Etat d\00E9taill\00E9 sur les vues de page</li>'),
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359645726305832)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but r\00E9elle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148829901306443)
,p_name=>'CA.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144204285306440)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter un mod\00E8le de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160767237306457)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'fr'
,p_message_text=>'Ajouter plusieurs utilisateurs - Etape 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147159636306442)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter un nouvel \00E9l\00E9ment %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130174793306429)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035789143306358)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138302546306435)
,p_name=>'CA.ADD.USER'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161132490306458)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter des utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115053963306418)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Ajout de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115593007306419)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Pour ajouter une page \00E0 votre application, cliquez sur <strong>Ajouter une page</strong>. S\00E9lectionnez ensuite un type de page (vierge, graphique, formulaire, \00E9tat, etc.) et d\00E9finissez ses attributs. Vous pouvez \00E9galement \00EAtre amen\00E9 \00E0 indiquer une')
||unistr(' table ou une vue valide. Utilisez SQL Workshop pour pr\00E9parer les objets de base de donn\00E9es dans votre espace de travail.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145069427306440)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358905857305832)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations suppl\00E9mentaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138074860306435)
,p_name=>'CA.ADDRESS'
,p_message_language=>'fr'
,p_message_text=>'Adresse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118265990306421)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118886478306421)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le niveau d''acc\00E8s des utilisateurs authentifi\00E9s de cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117355757306420)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats d''activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118322149306421)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120039854306422)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'fr'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118760009306421)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'fr'
,p_message_text=>'Administrateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392141605305856)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>'Configuration de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491776068305930)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'fr'
,p_message_text=>'Interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153635628306449)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'fr'
,p_message_text=>'Administration des applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153774704306449)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer le composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116905983306420)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection du style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117094045306420)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir la pr\00E9sentation par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116647319306419)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116591610306419)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer ou d\00E9sactiver des fonctionnalit\00E9s de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117652828306420)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal des erreurs de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117780195306420)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat des erreurs consign\00E9es par cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117151763306420)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117248198306420)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le nom d''application et une br\00E8ve description')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116763461306419)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises \00E0 jour de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116878224306420)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Tenir \00E0 jour la liste des mises \00E0 jour de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116205519306419)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>'Configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118686016306421)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'fr'
,p_message_text=>'Contributeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168672293306464)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'fr'
,p_message_text=>'Tableau de bord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168584722306463)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Consulter les mesures d''activit\00E9 d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121766779306423)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'fr'
,p_message_text=>unistr('Fuseau horaire par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121840632306423)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le fuseau horaire par d\00E9faut pour cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119563657306422)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121912530306423)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de messagerie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122055250306423)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquer si le courriel doit \00EAtre envoy\00E9 et, le cas \00E9ch\00E9ant, le destinataire de la r\00E9ponse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119035180306421)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119355001306421)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''informations en retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119484047306421)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez si les pi\00E8ces jointes doivent \00EAtre autoris\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119137551306421)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour des utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119237322306421)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat de l''ensemble des informations en retour envoy\00E9es par les utilisateurs de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119693471306422)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119707790306422)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer les mod\00E8les de courriels HTML et CSS utilis\00E9s par cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116347351306419)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'fr'
,p_message_text=>'Notifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116495243306419)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'fr'
,p_message_text=>'Afficher les notifications sur la page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154352161306450)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page d''administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036443116306359)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal des automatisations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036504531306359)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat des messages et des ex\00E9cutions d''automatisation consign\00E9s par cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117841791306420)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>'Performances de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117957571306420)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat de l''activit\00E9 et des performances par page d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118014876306420)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118107972306420)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat de chaque vue de page par utilisateur comportant la date d''acc\00E8s et le temps \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118575584306421)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'fr'
,p_message_text=>'Lecteurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161810179306458)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Envoyer un courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161967321306458)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Envoyer un courriel bas\00E9 sur un mod\00E8le \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117406271306420)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'fr'
,p_message_text=>'Principaux utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102117509333306420)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat des vues de page consolid\00E9es par utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118498078306421)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102118934000306421)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier les param\00E8tres de contr\00F4le d''acc\00E8s et d\00E9sactiver le contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119849754306422)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal de courriels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102119969334306422)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher le journal des courriels envoy\00E9s par cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127443547305641)
,p_name=>'CA.ADVANCED'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Avanc\00E9</strong> : d\00E9veloppez pour voir les options avanc\00E9es.'),
'    <ul>',
unistr('      <li><strong>D\00E9finir comme page d''accueil</strong> : d\00E9finir cette page comme page d''accueil de l''application.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Toute page pr\00E9c\00E9demment d\00E9finie comme page d''accueil sera mise \00E0 jour.</li>'),
unistr('      <li><strong>D\00E9finir comme page d''administration</strong> : ajoutez cette page sous Administration plut\00F4t qu''en tant que page normale dans l''application. Pour y acc\00E9der, cliquez sur Administration dans le menu principal et s\00E9lectionnez-la dans l')
||'a liste Administration des applications.<br>',
unistr('        <em><strong>Remarque :</strong> une page ne peut pas \00EAtre \00E0 la fois une page d''accueil et une page sous Administration.</em></li>'),
'      &nbsp;<br>',
unistr('      <li><strong>Aide de la page</strong> : saisissez du texte \00E0 ajouter au texte d''aide de la page.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014501120305555)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Avanc\00E9</strong> : d\00E9veloppez pour voir les options avanc\00E9es.'),
'    <ul>',
unistr('      <li><strong>Aide de la page</strong> : saisissez le texte \00E0 ajouter au texte d''aide de la page.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154734397306450)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres avanc\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154876944306450)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>D\00E9finissez des param\00E8tres suppl\00E9mentaires de d\00E9finition, de s\00E9curit\00E9 et de globalisation. Ces param\00E8tres peuvent \00EAtre appliqu\00E9s lors de la cr\00E9ation de l''application et peuvent \00E9galement \00EAtre modifi\00E9s une fois l''application cr\00E9\00E9e.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156764446306452)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Pour obtenir plus d''informations, lisez l''aide d''\00E9l\00E9ment ( <span class="fa fa-question-circle" aria-hidden="true"></span> ) de chaque param\00E8tre.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162577849306459)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s lignes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143907877306440)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s lignes - HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147073274306442)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'fr'
,p_message_text=>'Toutes les colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143127854306439)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser le d\00E9sabonnement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352552605305827)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser les ex\00E9cutions en mode restreint')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136564829306434)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal des erreurs de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132440688306431)
,p_name=>'CA.APP.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402576446305864)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Indique si le contr\00F4le d''acc\00E8s est activ\00E9 ou non')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402655490305864)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Niveau d''acc\00E8s par d\00E9faut attribu\00E9 aux utilisateurs authentifi\00E9s qui ne figurent pas dans la liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132802050306431)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de l''application mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132642198306431)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Br\00E8ve description')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132771344306431)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le texte entr\00E9 ici est affich\00E9 en dessous du nom de l''application sur la page d''accueil de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122187044306423)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>'Apparence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122286102306423)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>D\00E9finissez le sch\00E9ma de couleur (style de th\00E8me) par d\00E9faut de l''application, l''emplacement de la navigation et l''ic\00F4ne utilis\00E9e pour l''application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141659492306438)
,p_name=>'CA.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128739054306428)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>'Apparence de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122719702306424)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122894929306424)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cliquez sur <strong>Choisir une nouvelle ic\00F4ne</strong> pour s\00E9lectionner la couleur de l''ic\00F4ne et l''une des ic\00F4nes disponibles. Votre s\00E9lection est affich\00E9e sur la page d''accueil de l''application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123183573306424)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123215860306424)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez un identificateur num\00E9rique unique pour votre application. Ce champ contient un identificateur g\00E9n\00E9r\00E9 automatiquement par d\00E9faut.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142220895306438)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134443105306433)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'fr'
,p_message_text=>'Sessions d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113017102306417)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111982255306416)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le nom d''application et une br\00E8ve description')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113137995306417)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Autoriser les administrateurs de l''application \00E0 mettre \00E0 jour diff\00E9rents param\00E8tres, tels que le nom de l''application et sa description, le fuseau horaire par d\00E9faut, etc.</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Panneau et entr\00E9e de liste de page administrative</li>'),
unistr('<li>Possibilit\00E9 de d\00E9finir le nom de l''application</li>'),
unistr('<li>Possibilit\00E9 de d\00E9finir le sous-titre de r\00E9gion Hero de la page d''accueil</li>'),
unistr('<li>Possibilit\00E9 de d\00E9finir les destinataires des commentaires, si cette fonction est utilis\00E9e</li>'),
unistr('<li>Possibilit\00E9 de d\00E9finir le fuseau horaire par d\00E9faut de l''application</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167663595306463)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169416797306464)
,p_name=>'CA.APPLY'
,p_message_language=>'fr'
,p_message_text=>'Appliquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171273775306466)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Application des valeurs par d\00E9faut d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127968733306428)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'fr'
,p_message_text=>'Appliquer les modifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169275662306464)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Appliquer des filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489829929305929)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Application cr\00E9\00E9e \00E0 l''aide de l''assistant Cr\00E9ation d''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491196405305930)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer le param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173430811306468)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229359587305735)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre de pi\00E8ces jointes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173585679306468)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229265827305735)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('Taille de pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169521856306465)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs par d\00E9faut de l''attribut sont d\00E9j\00E0 d\00E9finies pour l''\00E9l\00E9ment %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138703148306436)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Tous les utilisateurs authentifi\00E9s peuvent acc\00E9der \00E0 cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123971402306425)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'fr'
,p_message_text=>'Authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124069322306425)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez le mode d''authentification souhait\00E9e pour les utilisateurs dans votre application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355296123305829)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'fr'
,p_message_text=>'Suppression automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037175449306359)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution d''automatisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135109918306433)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps moyen \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399827901305862)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0 l''\00E9tat sur les travaux')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230091220305735)
,p_name=>'CA.BCC'
,p_message_language=>'fr'
,p_message_text=>'CCI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162437979306459)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'fr'
,p_message_text=>'Avant lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143849761306440)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'fr'
,p_message_text=>'Avant lignes - HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145394866306441)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>'Avant lignes - Contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120680052306422)
,p_name=>'CA.BLANK'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page vierge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120732689306422)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page vierge en tant qu''espace r\00E9serv\00E9. Une fois l''application cr\00E9\00E9e, vous pouvez facilement cr\00E9er des r\00E9gions sur la page dans le concepteur de page.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de page</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('<!--  <li><strong>Inclure une navigation de page</strong> : cochez cette option pour afficher une liste des cartes de toutes les autres pages d\00E9finies dans votre application.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Cette option est g\00E9n\00E9ralement utilis\00E9e sur la page d''accueil de votre application.</li>'),
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154025214306450)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de base d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154184337306450)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le mod\00E8le de base r\00E9pertorie la d\00E9finition d''application au format JSON.</p>'),
unistr('<p>La premi\00E8re fois que vous acc\00E9dez \00E0 cet \00E9cran, la d\00E9finition d''application en cours est transform\00E9e en document JSON et est affich\00E9e. Vous pouvez modifier le document afin de mettre \00E0 jour les propri\00E9t\00E9s d''application, puis cliquer sur <strong>App')
||unistr('liquer le mod\00E8le de base</strong> pour modifier les d\00E9tails d''application en cours.</p>'),
'<p>&nbsp;</p>',
unistr('<p>Si vous devez cr\00E9er un grand nombre de pages similaires, copier le code JSON appropri\00E9 pour une page, le coller plusieurs fois et y apporter quelques modifications est consid\00E9rablement plus rapide que d''utiliser manuellement l''option <strong>Ajout')
||'er une page</strong> pour chaque page.</p>',
unistr('<p>Cliquez sur <strong>Charger un mod\00E8le de base pr\00E9c\00E9dent</strong> pour remplacer le mod\00E8le de base par la d\00E9finition d''une application pr\00E9c\00E9demment g\00E9n\00E9r\00E9e. Vous pouvez ainsi it\00E9rer tr\00E8s facilement une conception d''application en ajoutant des pages')
||unistr(' suppl\00E9mentaires, en modifiant les fonctionnalit\00E9s ou en r\00E9glant les param\00E8tres, avant de reg\00E9n\00E9rer l''application.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142757389306439)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte Corps1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142809060306439)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte Corps2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162833608306459)
,p_name=>'CA.BOTH'
,p_message_language=>'fr'
,p_message_text=>'Les deux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129134386306429)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Branchement sur la page d''administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126046925305640)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de boutons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128849785306428)
,p_name=>'CA.BUTTONS'
,p_message_language=>'fr'
,p_message_text=>'Boutons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121323985306423)
,p_name=>'CA.CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121436711306423)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui affiche un calendrier.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de la page</strong> (obligatoire) : indiquez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Table ou vue</strong> (obligatoire) : s\00E9lectionnez l''objet de base de donn\00E9es du calendrier.</li>'),
unistr('  <li><strong>Colonne d''affichage</strong> (obligatoire) : s\00E9lectionnez dans la table ou la vue la colonne \00E0 afficher dans les \00E9v\00E9nements de calendrier.</li>'),
unistr('  <li><strong>Colonne de date de d\00E9but</strong> (obligatoire) : s\00E9lectionnez dans la table ou la vue la colonne de date \00E0 utiliser en tant que date de d\00E9but pour les \00E9v\00E9nements de calendrier.</li>'),
unistr('  <li><strong>Colonne de date de fin</strong> : s\00E9lectionnez dans la table ou la vue la colonne de date \00E0 utiliser en tant que date de fin pour les \00E9v\00E9nements de calendrier.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Si la date de fin est sp\00E9cifi\00E9e, les \00E9v\00E9nements bas\00E9s sur la dur\00E9e seront affich\00E9s. </li>'),
unistr('  <li><strong>Afficher l''heure</strong> : s\00E9lectionnez <strong>Oui</strong> pour afficher la p\00E9riode des \00E9v\00E9nements et activer \00E9galement les vues de calendrier Hebdomadaire et Quotidienne. S\00E9lectionnez <strong>Non</strong> pour afficher uniquement le')
||unistr('s dates des \00E9v\00E9nements.</li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127811180306428)
,p_name=>'CA.CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129778808306429)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Annuler la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107086635305626)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'fr'
,p_message_text=>'Annuler Modal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139679260306436)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez pas enlever les droits d''administration de votre propre enregistrement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170466509306466)
,p_name=>'CA.CARD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170343283306465)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui affiche des cartes.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de page</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Table ou vue</strong> (obligatoire) : s\00E9lectionnez l''objet de base de donn\00E9es pour la carte.</li>'),
unistr('  <li><strong>Titre de carte</strong> (obligatoire) : s\00E9lectionnez la colonne dans la table ou la vue \00E0 utiliser comme titre pour la carte.</li>'),
unistr('  <li><strong>Colonne de description</strong> (obligatoire) : s\00E9lectionnez la colonne dans la table ou la vue \00E0 utiliser comme description pour la carte.</li>'),
unistr('  <li><strong>Colonne de texte suppl\00E9mentaire</strong> : s\00E9lectionnez la colonne dans la table ou la vue \00E0 utiliser comme description secondaire pour la carte.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168944670306464)
,p_name=>'CA.CARDS'
,p_message_language=>'fr'
,p_message_text=>'Cartes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169084408306464)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue Cartes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230116943305735)
,p_name=>'CA.CC'
,p_message_language=>'fr'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490598936305930)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Modifier les filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120411682306422)
,p_name=>'CA.CHART'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120596745306422)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui affiche un graphique \00E0 aires, \00E0 barres, \00E0 courbes ou \00E0 secteurs.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de la page</strong> (obligatoire) : indiquez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Type de graphique</strong> : s\00E9lectionnez le type de graphique \00E0 afficher [<strong>A aires</strong>, <strong>A barres</strong>, <strong>A courbes</strong>, <strong>A secteurs</strong>].</li>'),
unistr('  <li><strong>Table ou vue</strong> (obligatoire) : s\00E9lectionnez l''objet de base de donn\00E9es du graphique.</li>'),
unistr('  <li><strong>Colonne de libell\00E9</strong> (obligatoire) : s\00E9lectionnez dans la table ou la vue la colonne \00E0 utiliser en tant que libell\00E9 du graphique.</li>'),
unistr('  <li><strong>Agr\00E9gation de valeurs</strong> : s\00E9lectionnez la mani\00E8re dont la colonne de valeurs doit \00EAtre affich\00E9e ou agr\00E9g\00E9e<br>'),
'      &nbsp;&nbsp;&nbsp;[Column Value, Sum, Count].</li>',
unistr('  <li><strong>Colonne de valeurs</strong> (obligatoire) : s\00E9lectionnez dans la table ou la vue une colonne num\00E9rique \00E0 utiliser pour calculer les valeurs de graphique affich\00E9es.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120818204306422)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>Exemples</h3>',
unistr('<p>Consultez les exemples pour savoir comment utiliser les diff\00E9rents types d''<strong>agr\00E9gation</strong> :</p>'),
unistr('<p><strong>Exemple 1 :</strong> Afficher un graphique sur les employ\00E9s comportant le num\00E9ro d''employ\00E9 du responsable pour chaque employ\00E9.'),
'<code><ul>',
unistr('  <li>Table ou vue - S\00E9lectionnez EMP.</li>'),
unistr('  <li>Colonne de libell\00E9 - S\00E9lectionnez ENAME.</li>'),
unistr('  <li>Agr\00E9gation - S\00E9lectionnez <u><strong>Valeur de colonne</strong></u>.</li>'),
unistr('  <li>Colonne de valeurs - S\00E9lectionnez MGR.</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>Exemple 2 :</strong> Afficher un graphique sur les employ\00E9s comportant le salaire total pour chaque poste.'),
'<code><ul>',
unistr('  <li>Table ou vue - S\00E9lectionnez EMP.</li>'),
unistr('  <li>Colonne de libell\00E9 - S\00E9lectionnez JOB.</li>'),
unistr('  <li>Agr\00E9gation - S\00E9lectionnez <u><strong>Somme</strong></u>.</li>'),
unistr('  <li>Colonne de valeurs - S\00E9lectionnez SAL.</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>Exemple 3 :</strong> Afficher un graphique sur les employ\00E9s comportant le nombre d''employ\00E9s dans chaque service.'),
'<code><ul>',
unistr('  <li>Table ou vue - S\00E9lectionnez EMP.</li>'),
unistr('  <li>Colonne de libell\00E9 - S\00E9lectionnez DEPTNO.</li>'),
unistr('  <li>Agr\00E9gation - S\00E9lectionnez <u><strong>Nombre</strong></u>.</li>'),
unistr('  <li>Colonne de valeurs - S\00E9lectionnez EMPNO.</li>'),
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357210362305831)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'fr'
,p_message_text=>'ID de client'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173667575306468)
,p_name=>'CA.CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995133683305540)
,p_name=>'CA.CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ferm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171680205306467)
,p_name=>'CA.COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148648096306443)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'fr'
,p_message_text=>'Colonne 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148774580306443)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'fr'
,p_message_text=>'Colonne 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136097338306434)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167471852306463)
,p_name=>'CA.COMMENTS'
,p_message_language=>'fr'
,p_message_text=>'Commentaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133742691306432)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138541456306436)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Configurer le contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128932182306428)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>'Configurer l''apparence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129059104306429)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>L''apparence de votre application est d\00E9finie par le style de th\00E8me.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132321742306431)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de configuration mises \00E0 jour. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114204876306418)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>'Options de configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112507721306416)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer ou d\00E9sactiver des fonctionnalit\00E9s de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114307853306418)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permet aux administrateurs de l''application d''activer ou de d\00E9sactiver des fonctionnalit\00E9s sp\00E9cifiques dans l''application. Cette fonction est tr\00E8s utile si vous s\00E9lectionnez des fonctionnalit\00E9s qui requi\00E8rent des efforts suppl\00E9mentaires en mati\00E8re')
||unistr(' de d\00E9veloppement pour qu''elles puissent \00EAtre utilis\00E9es par les utilisateurs finals.<br>'),
unistr('Cette fonction peut \00E9galement \00EAtre \00E9tendue \00E0 des fonctionnalit\00E9s propres \00E0 l''application. Si les d\00E9veloppeurs d\00E9finissent des options de construction suppl\00E9mentaires et les associent \00E0 des fonctionnalit\00E9s sp\00E9cifiques dans l''application, elles peuvent')
||unistr(' alors \00EAtre ajout\00E9es aux param\00E8tres de configuration pour les administrateurs. Par exemple, dans l''application Suivi des clients, les administrateurs peuvent activer ou d\00E9sactiver les fonctionnalit\00E9s telles que Contacts, Chargement des donn\00E9es, G\00E9ogr')
||'aphie, et plus encore.',
'</p>',
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Possibilit\00E9 d''activer ou de d\00E9sactiver les fonctionnalit\00E9s de l''application</li>'),
unistr('<li>Utilisation de cette fonction pour permettre la s\00E9lection des fonctionnalit\00E9s par d\00E9ploiement</li>'),
unistr('<li>Prise en charge du regroupement des param\00E8tres d''application associ\00E9s</li>'),
unistr('<li>Permet aux d\00E9veloppeurs d''application de contr\00F4ler les composants \00E0 l''aide d''options de construction</li>'),
'<li>Disponible sur la page d''administration</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352191825305827)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom des informations d''identification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352248979305827)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire des informations d''identification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018634271306345)
,p_name=>'CA.CONTEXT'
,p_message_language=>'fr'
,p_message_text=>'Contexte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139027992306436)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'fr'
,p_message_text=>'Contributeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359172312305832)
,p_name=>'CA.CPU.USED'
,p_message_language=>'fr'
,p_message_text=>unistr('UC utilis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147531785306442)
,p_name=>'CA.CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152655007306449)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de la page d''administration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150214530306444)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151369011306445)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation des calculs de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150682899306445)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de l''ic\00F4ne de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151286215306445)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''\00E9l\00E9ments d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151433044306445)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de processus d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027741219306352)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de param\00E8tres d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157593842306452)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401060950305863)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de r\00F4les d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150878679306445)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de mod\00E8les d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151698411306445)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page vierge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150777017306445)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''options de construction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152010301306446)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de calendrier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163828012306460)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de la page de cartes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151827198306445)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152333233306446)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page d''\00E9tat classique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151930096306446)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de tableau de bord')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150100168306444)
,p_name=>'CA.CREATE.END'
,p_message_language=>'fr'
,p_message_text=>'Finalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171181783306466)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de recherche \00E0 facets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152980468306449)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de fonctionnalit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168455234306463)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de contenu filtr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151739187306445)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150383696306444)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page globale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152504077306449)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de la liste de navigation de la page d''accueil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152463095306446)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de la page de grille interactive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152275780306446)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page d''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861693827305436)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de carte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157274785306452)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de pages ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151050683306445)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de barres de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154230209306450)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''un groupe de pages')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152829612306449)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution de la traduction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152755804306449)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution de la traduction pour %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102152138248306446)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de la page d''\00E9tat et de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157444942306452)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrement du mod\00E8le de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151136821306445)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''un raccourci')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102151538180306445)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de connexion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861392361305436)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page de filtres intelligents')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150015345306444)
,p_name=>'CA.CREATE.START'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150497117306444)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de scripts d''objet de prise en charge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150992004306445)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de messages texte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163995319306460)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de la page de cadre temporel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171300170306466)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''une page d''assistant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131671271306430)
,p_name=>'CA.CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131717440306430)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120158489306422)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''application ...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352884409305827)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom des informations d''identification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359064848305832)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire des informations d''identification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132237449306431)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153243693306449)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442057832305893)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser un th\00E8me personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442160132305893)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Basculez l''assistant pour utiliser un th\00E8me personnalis\00E9 au lieu du th\00E8me universel.</p>'),
'',
unistr('<p>S\00E9lectionnez un th\00E8me d''espace de travail pour l''application. S''il prend en charge les styles de th\00E8me, le style peut \00E9galement \00EAtre utilis\00E9.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106714904305626)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me personnalis\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153829270306450)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de tableau de bord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017633020306345)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'fr'
,p_message_text=>'Graphique %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153930324306450)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page de tableau de bord avec plusieurs graphiques.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de page</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
'  </ul>',
'</ul>',
'  &nbsp;<br>',
unistr('<p>Chaque graphique (Graphique 1, Graphique 2, Graphique 3 et Graphique 4) est d\00E9fini par d\00E9faut sur des types de graphique diff\00E9rents et reposent sur des <em>donn\00E9es \00E9chantillon</em>. '),
'  Ainsi, vous n''avez pas besoin de saisir d''autres informations pour ajouter cette page.',
unistr('  Toutefois, vous pouvez personnaliser chaque graphique en rempla\00E7ant les valeurs par d\00E9faut par vos propres s\00E9lections.<br>'),
'  Pour personnaliser un graphique, indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de graphique</strong> (obligatoire) : saisissez le nom du graphique.</li>',
unistr('  <li><strong>Type de graphique</strong> : s\00E9lectionnez le type de graphique \00E0 afficher [<strong>A aires</strong>, <strong>A barres</strong>, <strong>A courbes</strong>, <strong>A secteurs</strong>].</li>'),
unistr('  <li><strong>Table ou vue</strong> (obligatoire) : s\00E9lectionnez l''objet de base de donn\00E9es du graphique.</li>'),
unistr('  <li><strong>Colonne de libell\00E9</strong> (obligatoire) : s\00E9lectionnez dans la table ou la vue la colonne \00E0 utiliser en tant que libell\00E9 du graphique.</li>'),
unistr('  <li><strong>Agr\00E9gation de valeurs</strong> : s\00E9lectionnez la mani\00E8re dont la colonne de valeurs doit \00EAtre affich\00E9e ou agr\00E9g\00E9e.<br>'),
'      &nbsp;&nbsp;&nbsp;[Valeur de colonne, Somme, Nombre].</li>',
unistr('  <li><strong>Colonne de valeurs</strong> (obligatoire) : s\00E9lectionnez dans la table ou la vue une colonne num\00E9rique \00E0 utiliser pour calculer les valeurs de graphique affich\00E9es.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164517197306460)
,p_name=>'CA.DATATYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165606745306461)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'fr'
,p_message_text=>'Masque de format de date '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132927283306431)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fuseau horaire par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133063489306431)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Fuseau horaire par d\00E9faut mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154674846306450)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeurs par d\00E9faut d''attribut d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154926086306450)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le document JSON permet d''exercer un contr\00F4le pr\00E9cis sur la g\00E9n\00E9ration des noms de colonne d''\00E9tat et de formulaire, des masques de format, etc. Vous pouvez \00E9galement d\00E9finir des listes de valeurs et d''autres composants partag\00E9s. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170971768306466)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'fr'
,p_message_text=>'Attribut de liste de valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171098447306466)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ajoutez un attribut de liste de valeurs. Les listes de valeurs peuvent \00EAtre utilis\00E9es dans les d\00E9finitions de colonne de table.</p>'),
'<p>Indiquez les attributs suivants :',
'  <ul>',
'    <li><strong>Nom</strong> (obligatoire) : saisissez le nom de la liste de valeurs.</li>',
unistr('    <li><strong>Type</strong> : s\00E9lectionnez le type de la liste de valeurs [Structur\00E9e, Dynamique, Statique].<br>'),
unistr('      Pour le type <u>Structur\00E9e</u> : '),
'      <ul>',
unistr('          <li><strong>Table</strong> (obligatoire) : s\00E9lectionnez la table ou la vue sur laquelle fonder la liste de valeurs.</li>'),
unistr('          <li><strong>Colonne d''affichage</strong> (obligatoire) : s\00E9lectionnez la colonne \00E0 afficher pour les utilisateurs finals.</li>'),
unistr('          <li><strong>Colonne de cl\00E9</strong> (obligatoire) : s\00E9lectionnez la valeur de colonne \00E0 renvoyer. Il s''agit en g\00E9n\00E9ral de la cl\00E9 primaire de la table.</li>'),
'      </ul>',
'      &nbsp;<br>',
'      Pour le type <u>Dynamique</u> :',
'      <ul>',
unistr('          <li><strong>Requ\00EAte SQL</strong> (obligatoire) : saisissez une instruction SQL SELECT valide qui renvoie deux valeurs (valeur d''affichage et valeur renvoy\00E9e).</li>'),
'      </ul>',
'      &nbsp;<br>',
'      Pour le type <u>Statique</u> :',
'      <ul>',
'          <li><strong>Liste de valeurs statique</strong> (obligatoire) : entrez une liste statique valide du formulaire :',
'          <ul>',
unistr('            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>Liste affich\00E9e dans l''ordre saisi</li>'),
unistr('            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>Liste organis\00E9e par ordre alphab\00E9tique</li>'),
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>La valeur d''affichage et la valeur renvoy\00E9e sont identiques</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172190174306467)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172292088306467)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Modifiez les attributs pour tous les \00E9tats.</p>'),
'<p>Indiquez les attributs suivants :',
'  <ul>',
unistr('    <li><strong>Lignes par page</strong> : entrez le nombre de lignes d''\00E9tat \00E0 afficher par d\00E9faut.</li>'),
unistr('    <li><strong>M\00E9thode de pagination</strong> : s\00E9lectionnez le mode d''affichage de la pagination d''\00E9tat.</li>'),
unistr('    <li><strong>Masque de format num\00E9rique</strong> : entrez le masque de format \00E0 appliquer aux \00E9l\00E9ments et colonnes de nombres.</li>'),
unistr('    <li><strong>Masque de format de date</strong> : entrez le masque de format \00E0 appliquer aux \00E9l\00E9ments et colonnes de dates.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171926827306467)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'fr'
,p_message_text=>'Attributs de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171727601306467)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Attributs de colonne de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171887836306467)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Modifiez les attributs de la colonne de table s\00E9lectionn\00E9e.</p>'),
'<p>Indiquez les attributs suivants :',
'  <ul>',
unistr('    <li><strong>Table</strong> (Afficher uniquement) : table associ\00E9e.</li>'),
unistr('    <li><strong>Colonne</strong> (Afficher uniquement) : colonne par rapport \00E0 laquelle les attributs sont d\00E9finis.</li>'),
unistr('    <li><strong>Libell\00E9</strong> : indiquez le libell\00E9 \00E0 utiliser dans les en-t\00EAtes de rapport et les libell\00E9s de formulaire.</li>'),
unistr('    <li><strong>Contr\00F4le de formulaire</strong> : s\00E9lectionnez un type d''\00E9l\00E9ment \00E0 utiliser dans les formulaires.</li>'),
unistr('    <li><strong>Liste de valeurs</strong> : s\00E9lectionnez une liste de valeurs existantes \00E0 utiliser pour afficher des noms conviviaux appropri\00E9s.</li>'),
unistr('    <li><strong>Masque de format</strong> : indiquez un masque de format appropri\00E9 en fonction du type de colonne (texte, nombre, date, etc.).</li>'),
unistr('    <li><strong>Valeur par d\00E9faut statique</strong> : indiquez une valeur par d\00E9faut de texte pour la colonne.</li>'),
unistr('    <li><strong>Inclure dans les formulaires</strong> : cliquez sur Oui si la colonne doit \00EAtre incluse dans des formulaires.</li>'),
unistr('    <li><strong>Inclure dans les \00E9tats</strong> : cliquez sur Oui si la colonne doit \00EAtre incluse dans des \00E9tats.</li>'),
unistr('    <li><strong>Obligatoire</strong> : cliquez sur Oui si les donn\00E9es doivent \00EAtre saisies dans cette colonne sur les formulaires.</li>'),
unistr('    <li><strong>Aide</strong> : saisissez le texte d''aide qui est ajout\00E9 \00E0 l''attribut d''aide de l''\00E9l\00E9ment.</li>'),
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172041114306467)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Modifiez les attributs pour la table s\00E9lectionn\00E9e.</p>'),
'<p>Indiquez les attributs suivants :',
'  <ul>',
unistr('    <li><strong>Table</strong> (Afficher uniquement) : table associ\00E9e.</li>'),
unistr('    <li><strong>Libell\00E9, Singulier</strong> (obligatoire) : indiquez le libell\00E9 \00E0 utiliser dans les pages de formulaire.</li>'),
unistr('    <li><strong>Libell\00E9, Pluriel</strong> (obligatoire) : indiquez le libell\00E9 \00E0 utiliser dans les en-t\00EAtes de r\00E9gion et dans les noms de page.</li>'),
unistr('    <li><strong>Colonne d''affichage principale</strong> : s\00E9lectionnez la premi\00E8re colonne \00E0 afficher, dans les r\00E9gions de carte par exemple.</li>'),
unistr('    <li><strong>Colonne d''affichage secondaire</strong> : s\00E9lectionnez la deuxi\00E8me colonne \00E0 afficher, dans les r\00E9gions de carte par exemple.</li>'),
unistr('    <li><strong>Colonne de cl\00E9 primaire</strong> : s\00E9lectionnez la colonne de cl\00E9 primaire unique pour la table.</li>'),
'    <li><strong>Description</strong> : saisissez la description de la table.</li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352683836305827)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'fr'
,p_message_text=>unistr('Suppression diff\00E9r\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166251725306462)
,p_name=>'CA.DEFINITION'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149990431306444)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sinstallation termin\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130274537306429)
,p_name=>'CA.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149508712306444)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'fr'
,p_message_text=>'Voulez-vous effectuer cette action de suppression ?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115880369306419)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'fr'
,p_message_text=>'Voulez-vous supprimer cette page ?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140014305306437)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'fr'
,p_message_text=>'Supprimer la photo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130993238306430)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148179416306443)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148009800306443)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129293831306429)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de th\00E8me du bureau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129320105306429)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Le style de th\00E8me par d\00E9faut s''applique \00E0 tous les utilisateurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353007035305828)
,p_name=>'CA.DESTINATION'
,p_message_language=>'fr'
,p_message_text=>'Destination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353100290305828)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de destination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106836857305626)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Boutons de bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144598392306440)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9partir les courriels')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163043757306459)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine si les courriels doivent \00EAtre envoy\00E9s \00E0 partir de la structure de courriel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130767194306430)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher \00E0 partir du')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130674354306430)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence d''affichage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130857243306430)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'fr'
,p_message_text=>'Afficher jusqu''au'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164756967306461)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134325132306432)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs distincts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147600209306442)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154549391306450)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Faire glisser pour r\00E9organiser la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127506641305641)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr('  <li><strong>Lien d''analyse descendante</strong> : d\00E9veloppez pour voir les attributs permettant de d\00E9finir un lien d''analyse descendante.'),
'&nbsp;<br>',
unistr('    <em><strong>Remarque :</strong> un lien d''analyse descendante appara\00EEt uniquement si la page actuelle est bas\00E9e sur une table ou une vue, si son type d''\00E9tat est Etat interactif, et si vous avez d\00E9fini un \00E9tat (Etat interactif) ou une page ma\00EEtre ')
||unistr('d\00E9tails (Ma\00EEtre-d\00E9tails).</em>'),
'  <ul>',
unistr('    <li><strong>Colonne de lien</strong> : s\00E9lectionnez la colonne \00E0 remplacer par une colonne de lien dans l''\00E9tat.</li>'),
unistr('    <li><strong>Cl\00E9 de lien</strong> : s\00E9lectionnez la colonne de cl\00E9 de lien (cl\00E9 \00E9trang\00E8re) utilis\00E9e pour identifier l''enregistrement sp\00E9cifique dans la page \00E0 laquelle il est li\00E9.</li>'),
unistr('    <li><strong>Lien vers la page</strong> : s\00E9lectionnez l''\00E9tat ou la page de panneau vers laquelle le lien pointe.</li>'),
unistr('    <li><strong>Cl\00E9 cible</strong> : s\00E9lectionnez la colonne de cl\00E9 cible (cl\00E9 primaire) dans la table sur laquelle repose la page d''\00E9tat, vers laquelle le lien pointe.'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133421883306432)
,p_name=>'CA.ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ecoul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116072180306419)
,p_name=>'CA.EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Structure de courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162635088306459)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresses \00E9lectroniques')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172600499306467)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115994963306419)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter la possibilit\00E9 de configurer et d''envoyer des courriels')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102116104803306419)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incluez la possibilit\00E9 d''envoyer des courriels \00E0 partir de votre application. Gr\00E2ce au mod\00E8le de courriel, envoyez des courriels professionnels aux utilisateurs. Les courriels envoy\00E9s sont consign\00E9s de mani\00E8re \00E0 ce que les administrateurs puissent')
||unistr(' suivre l''activit\00E9 de messagerie.</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Syst\00E8me de mod\00E8les de courriel HTML extensible</li>'),
'<li>Package PL/SQL pour l''envoi de courriels via des packages APEX</li>',
unistr('<li>Journalisation de l''activit\00E9 et des statuts des courriels</li>'),
unistr('<li>Interface utilisateur d''administration permettant de g\00E9rer les mod\00E8les</li>'),
'<li>Interface utilisateur d''administration permettant d''afficher les journaux de courriels</li>',
'<li>Interface utilisateur d''administration permettant d''envoyer des courriels</li>',
'</ul>',
'</p>',
unistr('<p><em>Remarque : cette fonctionnalit\00E9 est activ\00E9e en cas de s\00E9lection de l''option Informations en retour</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168337627306463)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Exp\00E9diteur du courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143508495306439)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal de courriels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173224377306468)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tails de param\00E8tre de messagerie obligatoires.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172767979306467)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''adresse d''exp\00E9diteur n''est pas une adresse valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164222478306460)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''adresse d''exp\00E9diteur n''est pas une adresse valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163465421306460)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Courriel trait\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230440237305736)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tats de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402768401305864)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat de tous les courriels mis en file d''attente d''envoi et de ceux d\00E9j\00E0 envoy\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144492996306440)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de messagerie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144886820306440)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de messagerie mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168795829306464)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut de courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144928094306440)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tails du mod\00E8le de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651166656306050)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'fr'
,p_message_text=>unistr('Coupure programm\00E9e pour #SERVICE_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449492966305899)
,p_name=>'CA.EMAIL2'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143497197306439)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Courriels envoy\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172822235306468)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer les pi\00E8ces jointes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358141182305831)
,p_name=>'CA.ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355382535305829)
,p_name=>'CA.END.DATE'
,p_message_language=>'fr'
,p_message_text=>'Date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145566359306441)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s lignes - Contenu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036832592306359)
,p_name=>'CA.ENDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160566418306457)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Saisir les noms utilisateur ici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134078504306432)
,p_name=>'CA.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136356212306434)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'fr'
,p_message_text=>'Trace des erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136210842306434)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'fr'
,p_message_text=>'Code d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135551173306433)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Message d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359863642305832)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro d''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358840745305832)
,p_name=>'CA.ERRORS'
,p_message_language=>'fr'
,p_message_text=>'Erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037085274306359)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Lignes d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355730194305830)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''\00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355863885305830)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Agent de la file d''attente des \00E9v\00E9nements')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355981416305830)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de la file d''attente des \00E9v\00E9nements')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356046357305830)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de la file d''attente des \00E9v\00E9nements')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355691377305829)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E8gle d''\00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160853493306457)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Exceptions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173706240306468)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Exp\00E9rience')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357849639305831)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre d''\00E9checs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132010896306431)
,p_name=>'CA.FEATURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806671706306173)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Version de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806781360306173)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490993020305930)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter des utilisateurs \00E0 la liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490762590305930)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der \00E0 l''\00E9tape suivante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490807809305930)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er des collections')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490627387305930)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Impossible de modifier le dernier administrateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806355133306173)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490483538305930)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune activit\00E9 n''a \00E9t\00E9 trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806515188306173)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'fr'
,p_message_text=>'Raison'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491037960305930)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Au moins une information en retour doit \00EAtre indiqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491341900305930)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'fr'
,p_message_text=>'Obtenir l''ID de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489922175305929)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer le style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490014184305929)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer la pr\00E9f\00E9rence de style de l''utilisateur final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806404495306173)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120234425306422)
,p_name=>'CA.FEATURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120359699306422)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Les fonctionnalit\00E9s s''appliquent au niveau de l''application et sont g\00E9n\00E9ralement ajout\00E9es une fois par application. Choisissez les fonctionnalit\00E9s \00E0 inclure avec votre application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114119137306417)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112138403306416)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser les utilisateurs \00E0 fournir des commentaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114087144306417)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fournir un m\00E9canisme permettant aux utilisateurs finals de publier des commentaires g\00E9n\00E9raux \00E0 l''attention des administrateurs et des d\00E9veloppeurs de l''application. Ces publications comportent des informations utiles relatives \00E0 l''\00E9tat de session ')
||unistr('permettant de d\00E9terminer la provenance des informations en retour de l''utilisateur final. L''existence d''une boucle d''informations en retour aussi simple favorise la communication entre la communaut\00E9 d''utilisateurs et les propri\00E9taires de l''applicatio')
||unistr('n, ce qui entra\00EEne une am\00E9lioration significative de la satisfaction de l''utilisateur final.</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Possibilit\00E9 pour les utilisateurs finals de donner leur avis en cliquant sur une ic\00F4ne dans la barre de navigation</li>'),
unistr('<li>Etat administratif relatif \00E0 l''affichage et \00E0 la mise \00E0 jour des informations en retour</li>'),
'<li>Les informations en retour indiqueront l''utilisateur, la date et l''heure ainsi que les informations sur l''agent utilisateur</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174101389306469)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fournissez des informations en retour sur votre exp\00E9rience.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173108301306468)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Envoyer \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172589201306467)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''informations en retour')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141529062306438)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''informations en retour mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173345914306468)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour soumises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355437453305829)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de contr\00F4leur de fichier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355587386305829)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire du contr\00F4leur de fichier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013612450305554)
,p_name=>'CA.FILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013734269305554)
,p_name=>'CA.FILED.BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistr\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168864681306464)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Filtrer l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145965575306441)
,p_name=>'CA.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171564592306466)
,p_name=>'CA.FINISH'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140268791306437)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9nom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352446733305827)
,p_name=>'CA.FLAGS'
,p_message_language=>'fr'
,p_message_text=>'Indicateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121639256306423)
,p_name=>'CA.FORM'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de formulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121569927306423)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui affiche une page de formulaire permettant aux utilisateurs finals de tenir les donn\00E9es \00E0 jour.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de page</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Table</strong> (obligatoire) : s\00E9lectionnez la table du formulaire.</li>'),
unistr('<li><strong>Inclure l''\00E9tat</strong> (obligatoire) : s\00E9lectionnez cette option pour cr\00E9er un \00E9tat et un panneau. La premi\00E8re page est un \00E9tat interactif. Chaque ligne contient un lien vers un panneau dans lequel les utilisateurs peuvent mettre \00E0 jour ')
||'l''enregistrement. </li>',
'  &nbsp;<br>',
unistr('<li><strong>Avanc\00E9</strong> : d\00E9veloppez pour voir les options avanc\00E9es.'),
'     <ul>',
unistr('      <li><strong>Aide de la page</strong> : saisissez le texte \00E0 ajouter au texte d''aide de la page.</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126161551305640)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion d''\00E9l\00E9ment de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147819698306443)
,p_name=>'CA.FORM.ON'
,p_message_language=>'fr'
,p_message_text=>'Panneau sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160327267306457)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'fr'
,p_message_text=>'Le type de formulaire n''est pas un type valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166777544306462)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'fr'
,p_message_text=>'Masque de format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165780556306461)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131453412306430)
,p_name=>'CA.FROM'
,p_message_language=>'fr'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144645400306440)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse de l''exp\00E9diteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168236654306463)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre de messagerie "Adresse d''exp\00E9diteur"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164107739306460)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique de l''exp\00E9diteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164087416306460)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'fr'
,p_message_text=>unistr('Exp\00E9diteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857071466306211)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'fr'
,p_message_text=>'%0 - Recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134994852306433)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Vues de page compl\00E8te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143687965306439)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'fr'
,p_message_text=>unistr('HTML de mod\00E8le complet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165290333306461)
,p_name=>'CA.FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114546194306418)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Recherche globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112324670306416)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'fr'
,p_message_text=>'Fournir une fonction de recherche dans l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114407812306418)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Autoriser les utilisateurs finals \00E0 rechercher du texte dans des tables ou des vues cl\00E9s dans l''application. La page de recherche avanc\00E9e inclut des filtres permettant aux utilisateurs finals d''affiner les r\00E9sultats plus facilement.<br>'),
unistr('Cette fonctionnalit\00E9 tr\00E8s puissante n\00E9cessite un effort de d\00E9veloppement afin de d\00E9finir le texte SQL (selon les exemples fournis).</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Affiche une ic\00F4ne de recherche dans la barre d''en-t\00EAte</li>'),
unistr('<li>Inclut une page de r\00E9sultats de recherche d\00E9taill\00E9e comportant un filtre dans la barre lat\00E9rale</li>'),
unistr('<li>N\00E9cessite l''impl\00E9mentation de SQL par un d\00E9veloppeur pour d\00E9finir la recherche de l''application</li>'),
unistr('<li>Inclut des donn\00E9es \00E9chantillon pour l''illustration</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357196136305831)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'fr'
,p_message_text=>'ID unique global'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489562643305929)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'fr'
,p_message_text=>'Page globale - Bureau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106971349305626)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der \00E0 la page d''administration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121104045306423)
,p_name=>'CA.GRID'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de grille interactive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121269019306423)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui s''affiche sous forme de grille interactive semblable \00E0 une feuille de calcul. Si elle peut \00EAtre modifi\00E9e, les utilisateurs peuvent modifier plusieurs lignes directement sur la page (c''est-\00E0-dire, lorsque l''option Autoriser la mo')
||unistr('dification est activ\00E9e).</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de la page</strong> (obligatoire) : indiquez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Type de requ\00EAte</strong> : s\00E9lectionnez la source de l''\00E9tat [<strong>Table ou vue</strong> ou <strong>Requ\00EAte SQL</strong>].<br>'),
'    <strong>Table ou vue</strong> :',
'    <ul>',
unistr('      <li><strong>Table ou vue</strong> (obligatoire) : s\00E9lectionnez l''objet de base de donn\00E9es de la grille.</li>'),
'    </ul>',
unistr('    <strong>Requ\00EAte SQL</strong> :'),
'    <ul>',
unistr('      <li><strong>Requ\00EAte SQL</strong> (obligatoire) : entrez une instruction SQL valide qui renvoie des colonnes distinctes.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>Type de grille</strong> : indiquez si les utilisateurs finals sont autoris\00E9s \00E0 modifier les lignes dans la grille [<strong>Autoriser la modification</strong> ou <strong>Lecture seule</strong>]. Pour autoriser la modification, s\00E9lectionn')
||'ez <strong>Autoriser la modification</strong>.</li>',
'  &nbsp;<br>',
unistr('  <em><strong>Avertissement :</strong> si vous s\00E9lectionnez le type de requ\00EAte <strong>Requ\00EAte SQL</strong> et le type de grille <strong>Autoriser la modification</strong>, et que votre requ\00EAte associe au moins deux tables, la grille interactive g\00E9n\00E9')
||unistr('r\00E9e \00E9chouera lorsque les utilisateurs tenteront de mettre \00E0 jour les enregistrements.'),
unistr('Par ailleurs, si vous s\00E9lectionnez le type de grille <strong>Autoriser la modification</strong> et que la requ\00EAte (ou la table ou vue s\00E9lectionn\00E9e) utilise une vue qui ne peut pas \00EAtre mise \00E0 jour, la grille interactive g\00E9n\00E9r\00E9e \00E9chouera lorsque les u')
||unistr('tilisateurs tenteront de mettre \00E0 jour les enregistrements.</em><br>'),
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146496370306442)
,p_name=>'CA.HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036658021306359)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif du journal des automatisations.</p>'),
unistr('<p>Consultez les informations consign\00E9es \00E0 propos des ex\00E9cutions d''automatisation pr\00E9c\00E9dentes : le journal contient les horodatages de d\00E9but et de fin ainsi que les d\00E9tails relatifs aux lignes trait\00E9es (sans et avec erreurs). Effectuez une analyse de')
||unistr('scendante jusqu''\00E0 Messages pour obtenir les messages individuels des lignes trait\00E9es.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138852043306436)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez <strong>Non</strong> si tous les utilisateurs sont d\00E9finis dans la liste de contr\00F4le d''acc\00E8s. S\00E9lectionnez <strong>Oui</strong> si les utilisateurs authentifi\00E9s ne figurant pas dans la liste de contr\00F4le d''acc\00E8s peuvent \00E9galement utiliser')
||' cette application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132564452306431)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le texte entr\00E9 ici est utilis\00E9 dans l''ensemble de l''application, plus particuli\00E8rement, dans l''angle sup\00E9rieur gauche de chaque page. La modification prendra effet imm\00E9diatement pour l''administrateur qui l''applique, mais elle ne sera visible par les ')
||unistr('autres utilisateurs que lors de la prochaine session (c''est-\00E0-dire lors de leur prochaine connexion).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127173290306427)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cliquez sur l''ic\00F4ne des informations en retour ( <span class="fa fa-comment-o" aria-hidden="true"></span>) dans la barre de navigation, \00E0 partir de n''importe quelle page de l''application, afin de transmettre des informations en retour aux administ')
||'rateurs de l''application.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126834882306427)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Il s''agit de la page d''accueil de l''application. Cliquez sur les cartes pour acc\00E9der aux diff\00E9rentes pages de l''application, ou utilisez le menu de navigation sur le c\00F4t\00E9 de la page.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127020446306427)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Il s''agit de la page d''accueil de l''application. Cliquez sur les cartes pour acc\00E9der aux diff\00E9rentes pages de l''application, ou utilisez le menu de navigation en haut de la page.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127220969306427)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez un terme de recherche dans le champ <strong>Application de recherche</strong> sur cette page, ou cliquez sur l''ic\00F4ne de recherche (<span class="fa fa-search" aria-hidden="true"></span>) dans la barre de navigation \00E0 partir de n''importe quel')
||'le page pour rechercher le terme dans votre application.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127538304306427)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cliquez sur la liste d\00E9roulante de votre nom dans la barre de navigation pour vous d\00E9connecter de l''application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127442676306427)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cliquez sur le menu utilisateur (<span class="fa fa-user" aria-hidden="true"></span>) dans la barre de navigation pour mettre \00E0 jour votre pr\00E9f\00E9rence de fuseau horaire et vous d\00E9connecter de l''application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126993275306427)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127654029306427)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cliquez sur le menu utilisateur (<span class="fa fa-user" aria-hidden="true"></span>) dans la barre de navigation (en haut \00E0 droite de la page) pour acc\00E9der \00E0 votre profil utilisateur et vous d\00E9connecter de l''application.<br>'),
unistr('Si vous cliquez sur <strong>Afficher mon profil</strong>, vous pouvez ensuite cliquer sur <strong>Mettre \00E0 jour le profil</strong> pour entrer vos d\00E9tails personnels et t\00E9l\00E9charger une photo ou un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127320339306427)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cliquez sur le menu utilisateur (<span class="fa fa-user" aria-hidden="true"></span>) dans la barre de navigation pour acc\00E9der \00E0 votre profil utilisateur, mettre \00E0 jour votre pr\00E9f\00E9rence de fuseau horaire et vous d\00E9connecter de l''application.<br>'),
unistr('Si vous cliquez sur <strong>Afficher mon profil</strong>, vous pouvez ensuite cliquer sur <strong>Mettre \00E0 jour le profil</strong> pour entrer vos d\00E9tails personnels et t\00E9l\00E9charger une photo ou un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153426914306449)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour rechercher des donn\00E9es, entrez un terme de recherche dans la bo\00EEte de dialogue de recherche, ou cliquez sur les en-t\00EAtes de colonne pour limiter les enregistrements renvoy\00E9s.</p>'),
'',
unistr('<p>Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Actions</strong>. Ainsi, vous pouvez s\00E9lectionner les colonnes \00E0 afficher/masquer et leur ordre d''affichage, mais aussi de nombreuses fonctions relatives aux donn\00E9es et')
||unistr(' aux formats. Vous pouvez \00E9galement d\00E9finir des vues de donn\00E9es suppl\00E9mentaires \00E0 l''aide de l''option de graphique.</p>'),
'',
unistr('<p>Pour enregistrer vos personnalisations, s\00E9lectionnez l''\00E9tat ou cliquez sur le bouton de t\00E9l\00E9chargement pour d\00E9charger les donn\00E9es.<p>'),
'<br>',
'<p>Pour plus d''informations, cliquez sur Aide au bas du menu Actions.</p>',
'',
unistr('<p>Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153377311306449)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez ins\00E9rer, mettre \00E0 jour et supprimer des donn\00E9es directement dans cette grille interactive.<br>'),
unistr('  Ins\00E9rez une nouvelle ligne en cliquant sur le bouton Ajouter une ligne.<br>'),
unistr('  Cliquez deux fois dans une cellule, ou cliquez sur le bouton <strong>Modifier</strong> pour mettre \00E0 jour les valeurs de donn\00E9es, comme lorsque vous modifiez des donn\00E9es dans une feuille de calcul.</p>'),
'',
unistr('<p>Utilisez le menu Actions de ligne ( <span class="fa fa-bars" aria-hidden="true"></span> ) en haut de l''\00E9tat pour dupliquer, supprimer, actualiser ou r\00E9tablir les lignes s\00E9lectionn\00E9es.<br> '),
unistr('  Utilisez le menu Actions de ligne sur les lignes individuelles pour acc\00E9der \00E9galement \00E0 la vue monoligne ou pour ajouter une nouvelle ligne.</p>'),
'',
unistr('<p>Pour rechercher des donn\00E9es, entrez un terme de recherche dans la bo\00EEte de dialogue de recherche, ou cliquez sur les en-t\00EAtes de colonne pour limiter les enregistrements renvoy\00E9s.</p>'),
'',
unistr('<p>Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Actions</strong>. Ainsi, vous pouvez s\00E9lectionner les colonnes \00E0 afficher/masquer et leur ordre d''affichage, mais aussi de nombreuses fonctions relatives aux donn\00E9es et')
||unistr(' aux formats. Vous pouvez \00E9galement d\00E9finir une vue suppl\00E9mentaire des donn\00E9es \00E0 l''aide de l''option de graphique.</p>'),
'',
unistr('<p>Pour enregistrer vos personnalisations, s\00E9lectionnez l''\00E9tat, ou cliquez sur le bouton de t\00E9l\00E9chargement pour d\00E9charger les donn\00E9es.<p>'),
'',
'<p>Pour plus d''informations, cliquez sur Aide au bas du menu Actions.</p> ',
'',
unistr('<p>Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126792791306427)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour rechercher des donn\00E9es, entrez un terme de recherche dans la bo\00EEte de dialogue de recherche, ou cliquez sur les en-t\00EAtes de colonne pour limiter les enregistrements renvoy\00E9s.</p>'),
'',
unistr('<p>Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Actions</strong>. Ainsi, vous pouvez s\00E9lectionner les colonnes \00E0 afficher/masquer et leur s\00E9quence d''affichage, mais aussi de nombreuses fonctions relatives aux donn\00E9es')
||unistr(' et aux formats. Vous pouvez \00E9galement d\00E9finir des vues de donn\00E9es suppl\00E9mentaires \00E0 l''aide des options Graphique, Grouper par et Permuter.</p>'),
'',
unistr('<p>Pour enregistrer vos personnalisations, s\00E9lectionnez l''\00E9tat ou cliquez sur le bouton de t\00E9l\00E9chargement pour d\00E9charger les donn\00E9es. Entrez votre adresse \00E9lectronique et l''intervalle de temps dans l''abonnement selon lequel envoyer les donn\00E9es r\00E9guli')
||unistr('\00E8rement.<p>'),
'',
'<p>Pour plus d''informations, cliquez sur Aide au bas du menu Actions.</p>',
'',
unistr('<p>Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161327782306458)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La page d''\00E9tat affiche les enregistrements principaux dans un s\00E9lecteur sur le c\00F4t\00E9 de la page. '),
unistr('  S\00E9lectionnez un enregistrement pour voir l''enregistrement ma\00EEtre et les enregistrements d\00E9tails d\00E9finis.<br> '),
unistr('  Cliquez sur l''ic\00F4ne de modification (<span class="fa fa-pencil-square-o" aria-hidden="true"></span>) pour modifier l''enregistrement ma\00EEtre.'),
unistr('  Pour les enregistrements d\00E9tails, cliquez sur l''ic\00F4ne en forme de crayon, au d\00E9but de chaque ligne, pour les modifier.</p>'),
unistr('<p>Pour limiter les donn\00E9es affich\00E9es dans le s\00E9lecteur, saisissez un terme de recherche dans la bo\00EEte de dialogue de recherche.</p>'),
'',
unistr('<p>Pour ajouter un nouvel enregistrement ma\00EEtre, cliquez sur <strong>Cr\00E9er</strong> en haut de la page.'),
unistr('  Pour les enregistrements d\00E9tails, cliquez sur l''ic\00F4ne plus (+) situ\00E9e en haut de la r\00E9gion de d\00E9tails pour ajouter un enregistrement d\00E9tails.</p>'),
'',
unistr('<p>Cliquez sur <strong>R\00E9initialiser</strong> en haut de la page pour r\00E9tablir les param\00E8tres par d\00E9faut de la page, en enlevant tous les termes de recherche pr\00E9c\00E9demment d\00E9finis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124785001306425)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La page d''administration permet aux propri\00E9taires de l''application (administrateurs) de configurer l''application et de tenir \00E0 jour les donn\00E9es communes qu''elle utilise.'),
unistr('En s\00E9lectionnant l''un des param\00E8tres disponibles, les administrateurs peuvent potentiellement modifier l''affichage de l''application et/ou les fonctions disponibles pour les utilisateurs finals.</p>'),
unistr('<p>L''acc\00E8s \00E0 cette page doit \00EAtre exclusivement limit\00E9 aux administrateurs.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125917476306426)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez l''option appropri\00E9e pour tous les utilisateurs authentifi\00E9s.<br>'),
unistr('Si vous s\00E9lectionnez <strong>Non</strong>, l''application sera plus s\00E9curis\00E9e, car seuls les utilisateurs sp\00E9cifi\00E9s peuvent y acc\00E9der.'),
unistr('Toutefois, si votre application compte de nombreux utilisateurs, tenir \00E0 jour les utilisateurs peut s''av\00E9rer complexe, et vous pr\00E9f\00E9rerez peut-\00EAtre choisir <strong>Oui</strong> et entrer uniquement des administrateurs d''application, et \00E9ventuellement')
||' des contributeurs.<br>',
unistr('Si vous s\00E9lectionnez <strong>Oui</strong>, vous devez \00E9galement indiquer le mode de traitement des utilisateurs qui ne figurent pas sur la liste des utilisateurs.</p>'),
unistr('<p>Indiquez si une adresse \00E9lectronique ou une valeur alphanum\00E9rique est requise pour les noms utilisateur.<br>'),
unistr('G\00E9n\00E9ralement, vous devrez d\00E9finir ce param\00E8tre sur <strong>Adresse \00E9lectronique</strong> si votre application utilise (ou sera configur\00E9e pour utiliser) un mod\00E8le d''authentification centralis\00E9 tel qu''Oracle Access Manager ou l''acc\00E8s avec connexion un')
||'ique.</p>',
unistr('<p><em><strong>Remarque :</strong> cette application prend en charge les 3 niveaux d''acc\00E8s suivants : Lecteur, Contributeur et Administrateur.'),
'<ul>',
unistr('  <li>Les <strong>lecteurs</strong> disposent d''un acc\00E8s en lecture seule \00E0 toutes les informations et peuvent \00E9galement consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>contributeurs</strong> peuvent cr\00E9er, modifier et supprimer des informations et consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>administrateurs</strong>, outre les capacit\00E9s des contributeurs, peuvent \00E9galement ex\00E9cuter la configuration de l''application en acc\00E9dant \00E0 sa section Administration.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126171800306426)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez ce formulaire pour entrer des utilisateurs et leur adresse \00E9lectronique, et d\00E9finir leur niveau d''acc\00E8s.'),
unistr('Les param\00E8tres d\00E9finis dans <em>Configurer le contr\00F4le d''acc\00E8s</em> d\00E9termineront si le nom utilisateur doit \00EAtre leur adresse \00E9lectronique ou s''il peut s''agir de n''importe quelle entr\00E9e alphanum\00E9rique.</p>'),
unistr('<p>Cette application prend en charge les 3 niveaux d''acc\00E8s suivants : Lecteur, Contributeur et Administrateur.</p>'),
'<ul>',
unistr('  <li>Les <strong>lecteurs</strong> disposent d''un acc\00E8s en lecture seule \00E0 toutes les informations et peuvent \00E9galement consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>contributeurs</strong> peuvent cr\00E9er, modifier et supprimer des informations et consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>administrateurs</strong>, outre les capacit\00E9s des contributeurs, peuvent \00E9galement ex\00E9cuter la configuration de l''application en acc\00E9dant \00E0 sa section Administration.</li>'),
'</ul>',
unistr('<p>Lorsque vous modifiez un utilisateur existant, vous pouvez verrouiller son compte, ce qui l''emp\00EAchera d''acc\00E9der \00E0 l''application.</p>'),
unistr('<p><em><strong>Remarque :</strong>   si vous utilisez des comptes Oracle Application Express, les utilisateurs entr\00E9s ici doivent \00E9galement \00EAtre d\00E9finis en tant qu''utilisateurs finals par un administrateur d''espace de travail, qui peut aussi d\00E9finir ')
||'leur mot de passe.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126036232306426)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat des utilisateurs de l''application et du niveau d''acc\00E8s octroy\00E9.</p>'),
unistr('<p>Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires.<br>'),
unistr('Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>'),
unistr('<p>Cliquez sur l''ic\00F4ne de modification (crayon jaune) pour modifier les d\00E9tails et le niveau d''acc\00E8s de l''utilisateur, ou pour supprimer ce dernier.</p>'),
unistr('<p>Pour ajouter un nouvel utilisateur et son niveau d''acc\00E8s, cliquez sur <strong>Ajouter un utilisateur</strong>, en haut de l''\00E9tat.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139588505306436)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Lorsque le contr\00F4le d''acc\00E8s est activ\00E9, les administrateurs ont la possibilit\00E9 de restreindre l''acc\00E8s \00E0 certaines fonctionnalit\00E9s d''application pour les utilisateurs authentifi\00E9s. Cette application prend en charge les 3 r\00F4les suivants : Lecteur, C')
||'ontributeur et Administrateur.<p>',
'<ul>',
unistr('  <li>Les <strong>lecteurs</strong> disposent d''un acc\00E8s en lecture seule \00E0 toutes les informations et peuvent \00E9galement consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>contributeurs</strong> peuvent cr\00E9er, modifier et supprimer des informations et consulter les \00E9tats.</li>'),
unistr('  <li>Les <strong>administrateurs</strong>, outre les capacit\00E9s des contributeurs, peuvent \00E9galement ex\00E9cuter la configuration de l''application.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160420185306457)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des noms utilisateur s\00E9par\00E9s par des virgules, des points-virgules ou des caract\00E8res non imprimables. Les noms utilisateurs existants ou en double sont automatiquement ignor\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124981045306425)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les param\00E8tres de configuration vous permettent de rendre des fonctionnalit\00E9s sp\00E9cifiques disponibles (activ\00E9es) ou indisponibles (d\00E9sactiv\00E9es) pour les utilisateurs finals.</p>'),
unistr('<p>Si une fonction sp\00E9cifique n''est pas int\00E9gralement pr\00EAte ou n\00E9cessite d''\00EAtre enlev\00E9e temporairement, cliquez sur <strong>D\00E9sactiv\00E9</strong>.'),
unistr('Une fois qu''elle doit \00EAtre rendue disponible, cliquez simplement sur <strong>Activ\00E9</strong>.</p>'),
unistr('<p><em><strong>Remarque :</strong> les modifications apport\00E9es ici ne seront pas refl\00E9t\00E9es pour les utilisateurs finals individuels qui ex\00E9cutent actuellement l''application. Lorsque l''utilisateur final se d\00E9connecte, puis se reconnecte, le param\00E8tre ')
||unistr('r\00E9vis\00E9 de la fonction sera appel\00E9.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125048750306426)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le sch\00E9ma de couleur par d\00E9faut utilis\00E9 pour afficher l''application.</p>'),
unistr('<p>Si l''option <strong>Autoriser les utilisateurs finals \00E0 choisir un style de th\00E8me</strong> est s\00E9lectionn\00E9e, chaque utilisateur final peut choisir parmi les styles de th\00E8me disponibles en cliquant sur le lien <em>Personnaliser</em> dans l''angle in')
||unistr('f\00E9rieur gauche de la page d''accueil.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125648651306426)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif de toutes les erreurs inattendues consign\00E9es par cette application.</p>'),
unistr('<p>Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires. Pour r\00E9tablir les para')
||unistr('m\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125584849306426)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cet \00E9tat et ce graphique pour afficher les utilisateurs comportant le plus de vues de page pour la tanche de temps sp\00E9cifi\00E9e.</p>'),
unistr('<p>S\00E9lectionnez la tranche de temps de g\00E9n\00E9ration d''\00E9tat (par d\00E9faut = 1 jour) et choisissez l''ic\00F4ne d''\00E9tat ou de graphique en haut de la page.</p>'),
unistr('<p>Pour l''\00E9tat interactif, utilisez le champ de recherche ou s\00E9lectionnez l''en-t\00EAte de colonne <strong>Utilisateur</strong> pour s\00E9lectionner un utilisateur sp\00E9cifique. Vous pouvez ex\00E9cuter de nombreuses fonctions en cliquant sur le bouton <strong>Ac')
||unistr('tions</strong>, telles que les colonnes affich\00E9es/masqu\00E9es, les lignes par page, les filtres, etc. Pour r\00E9tablir les param\00E8tres par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125712973306426)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif des performances et de la popularit\00E9 de la page. L''\00E9tat est tri\00E9 par <strong>Performances pond\00E9r\00E9es</strong> qui sont calcul\00E9es en multipliant le temps \00E9coul\00E9 m\00E9dian et le nombre de vues de page.</p>'),
unistr('<p>S\00E9lectionnez la tranche de temps de g\00E9n\00E9ration d''\00E9tat (par d\00E9faut = 1 jour) en haut de la page si n\00E9cessaire.<br>'),
unistr('Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires. Pour r\00E9tablir les param\00E8t')
||unistr('res par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125854925306426)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page fournit un \00E9tat interactif des vues de page les plus r\00E9centes.</p>'),
unistr('<p>S\00E9lectionnez la tranche de temps de g\00E9n\00E9ration d''\00E9tat (par d\00E9faut = 1 jour) en haut de la page si n\00E9cessaire.<br>'),
unistr('Pour trier et filtrer les donn\00E9es, cliquez sur les en-t\00EAtes de colonne, ou cliquez sur le bouton <strong>Actions</strong> pour personnaliser l''affichage des colonnes et de nombreuses fonctionnalit\00E9s avanc\00E9es suppl\00E9mentaires. Pour r\00E9tablir les param\00E8t')
||unistr('res par d\00E9faut de l''\00E9tat interactif, cliquez sur le bouton <strong>R\00E9initialiser</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124887966306425)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les notifications sont affich\00E9es sur la page d''accueil, lorsque cette fonction est activ\00E9e.</p>'),
unistr('<p>Cet \00E9tat affiche les notifications d\00E9finies et la dur\00E9e d''affichage.</p>'),
unistr('<p>Cliquez sur l''ic\00F4ne de modification (crayon jaune) pour modifier une notification existante ou cliquez sur <strong>Ajouter une notification</strong> pour ins\00E9rer une nouvelle notification.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125173682306426)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nom de l''application et une br\00E8ve description.</p>'),
unistr('<p>Le nom de l''application est affich\00E9 sur la page d''accueil. La br\00E8ve description figure en dessous du nom de l''application.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125373309306426)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les informations en retour peuvent \00EAtre saisies par les utilisateurs finals \00E0 partir de n''importe quelle page normale dans l''application.</p>'),
unistr('<p>Cet \00E9tat affiche les informations en retour saisies, les r\00E9ponses transmises par les administrateurs et le statut des informations en retour.</p>'),
unistr('<p>Cliquez sur l''ic\00F4ne de modification (crayon jaune) pour saisir une r\00E9ponse ou mettre \00E0 jour le statut des informations en retour.</p>'),
unistr('<p><em><strong>Remarque :</strong> si des destinataires ont \00E9t\00E9 d\00E9finis pour les informations en retour, ces derniers seront \00E9galement envoy\00E9s par courriel aux adresses \00E9lectroniques figurant dans la liste des destinataires des informations en retour')
||'.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141433432306438)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la liste des adresses \00E9lectroniques s\00E9par\00E9es par une virgule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125476883306426)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('<p><strong>Activer les pi\00E8ces jointes :</strong> si l''option est d\00E9finie sur Oui, les utilisateurs pourront t\00E9l\00E9charger une pi\00E8ce jointe et l''ajouter \00E0 leurs informations en retour.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126499666306427)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page r\00E9pertorie les mod\00E8les de courriel d\00E9finis et le nombre de fois o\00F9 le mod\00E8le a \00E9t\00E9 r\00E9f\00E9renc\00E9 dans les courriels envoy\00E9s.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126253309306426)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page r\00E9pertorie les courriels envoy\00E9s.</p>'),
unistr('<p>Pour afficher plus de d\00E9tails sur les courriels envoy\00E9s, cliquez sur l''ic\00F4ne en forme de loupe.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126395990306427)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour d\00E9finir un mod\00E8le de courriel, indiquez les champs suivants :</p>'),
'<ul>',
unistr('  <li><strong>Nom de mod\00E8le</strong> (obligatoire) - Saisissez un nom explicite pour le mod\00E8le.</li>'),
unistr('  <li><strong>Mod\00E8le HTML</strong> (obligatoire) - Saisissez le code HTML utilis\00E9 pour construire le courriel envoy\00E9 aux destinataires qui autorisent la distribution de courriels HTML.'),
'    Les valeurs de substitution incluent :',
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong> - Valeur remplac\00E9e par le nom de l''application</li>'),
unistr('        <li><strong>#BODY1#</strong> - Valeur remplac\00E9e par la valeur transmise en tant que p_body1_text</li> '),
unistr('        <li><strong>#TABLE#</strong> - Valeur remplac\00E9e par la valeur transmise en tant que p_table_content, \00E0 l''aide de HTML de table ouverte, HTML de ligne de table et HTML de table ferm\00E9e</li> '),
unistr('        <li><strong>#BODY2#</strong> - Valeur remplac\00E9e par la valeur transmise en tant que p_body2_text</li> '),
unistr('        <li><strong>#ACTION#</strong> - Valeur remplac\00E9e par la valeur transmise en tant que p_action_label et p_action_link, \00E0 l''aide du mod\00E8le Lien de l''action</li>'),
'     </ul></li>',
unistr('  <li><strong>Mod\00E8le de texte brut</strong> (obligatoire) - Entrez le texte brut utilis\00E9 pour construire le courriel envoy\00E9 aux destinataires qui n''acceptent pas les courriels HTML. Il utilise les m\00EAmes valeurs de substitution que le mod\00E8le HTML, sau')
||'f #TABLE# et #ACTION# qui s''affichent en tant que texte brut.</li>',
'<ul>',
unistr('<p>Des mod\00E8les HTML suppl\00E9mentaires permettent des courriels plus avanc\00E9s. Ces \00E9l\00E9ments incluent :</p>'),
'<ul>',
unistr('  <li><strong>Avant lignes</strong> - Saisissez le code HTML permettant de remplacer #TABLE# dans le mod\00E8le HTML. Uniquement utilis\00E9 si p_table_content est transmis.</li>'),
unistr('  <li><strong>Mod\00E8le de ligne</strong> - Saisissez le code HTML permettant d''afficher chaque ligne de la table. Cela inclut l''ouverture/la fermeture de ligne et l''ouverture/la fermeture de donn\00E9es \00E0 l''aide des valeurs de substitution #LABEL# et #VALU')
||unistr('E#. Uniquement utilis\00E9 si p_table_content est transmis.</li>'),
unistr('  <li><strong>Apr\00E8s lignes</strong> - Saisissez le code HTML permettant de fermer la table ou la balise div. Uniquement utilis\00E9 si p_table_content est transmis.</li>'),
unistr('  <li><strong>HTML de lien d''action</strong> - Saisissez le code HTML permettant de remplacer #ACTION# dans le mod\00E8le HTML. Il doit contenir #ACTION_LINK# et #ACTION_TEXT#. Uniquement utilis\00E9 si p_action_label et p_action_link sont transmis.</li>'),
'</ul>',
unistr('<p><em><strong>Remarque :</strong> utilisez les entr\00E9es du <strong>mod\00E8le par d\00E9faut</strong> comme exemple pour d\00E9velopper votre propre mod\00E8le. Le mod\00E8le par d\00E9faut utilise toutes les variables de substitution que vous pouvez inclure ou non dans vot')
||unistr('re propre mod\00E8le de courriel.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126548007306427)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Activez ou d\00E9sactivez l''envoi de courriels en s\00E9lectionnant l''une des options de <strong>r\00E9partition de courriels</strong>.</p>'),
unistr('<p>Indiquez l''<strong>exp\00E9diteur des courriels</strong> \00E0 l''aide de l''adresse \00E9lectronique du contact principal pour les probl\00E8mes d''application. Cette valeur peut \00EAtre utilis\00E9e ou \00E9cras\00E9e lors de l''utilisation de la fonctionnalit\00E9 de messagerie.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144765033306440)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Il s''agit de l''adresse d''exp\00E9diteur qui sera utilis\00E9e pour envoyer les courriels. Elle peut \00EAtre \00E9cras\00E9e lors de l''utilisation de la fonctionnalit\00E9 de messagerie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162027879306458)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Renseignez les \00E9l\00E9ments suivants et cliquez sur [Envoyer un courriel]. Tous les courriels envoy\00E9s sont consign\00E9s dans le journal de courriels.'),
'    <ul>',
unistr('        <li><strong>De</strong> : si une "adresse d''exp\00E9diteur" est d\00E9finie dans les param\00E8tres de messagerie, l''adresse \00E9lectronique constitue une option d''exp\00E9dition. Si l''application utilise des adresses \00E9lectroniques comme noms utilisateur, vous ')
||unistr('pouvez choisir d''envoyer des courriels \00E0 partir de votre adresse \00E9lectronique. Enfin, l''exp\00E9diteur peut \00EAtre identique au destinataire.</li>'),
unistr('        <li><strong>Envoyer \00E0</strong> : si cette application utilise des adresses \00E9lectroniques comme noms utilisateur, vous pouvez choisir d''envoyer des courriels aux adresses \00E9lectroniques et/ou aux utilisateurs.</li>'),
unistr('        <li><strong>Adresses \00E9lectroniques</strong> : liste d''adresses \00E9lectroniques s\00E9par\00E9es par des virgules pour recevoir le courriel. Les adresses non valides ne sont pas incluses.</li>'),
unistr('        <li><strong>R\00F4le</strong> : envoyez un courriel \00E0 tous les utilisateurs d''un r\00F4le s\00E9lectionn\00E9 ou \00E0 tous les utilisateurs d\00E9finis. La liste de s\00E9lection inclut une liste de r\00F4les et le nombre d''utilisateurs dot\00E9s de ce r\00F4le.</li>'),
unistr('        <li><strong>Mod\00E8le</strong> : s\00E9lectionnez le mod\00E8le de courriel \00E0 utiliser pour cr\00E9er le corps du courriel.</li>'),
'        <li><strong>Objet</strong> : objet du courriel.</li>',
unistr('        <li><strong>Corps de courriel</strong> : texte \00E0 inclure en tant que corps du courriel.</li>'),
unistr('        <li><strong>Autoriser le d\00E9sabonnement</strong> : certains courriels doivent \00EAtre envoy\00E9s m\00EAme si l''utilisateur a choisi de se d\00E9sabonner de la r\00E9ception des courriels. Cela inclut les messages de coupure, etc. Cet indicateur sp\00E9cifie si un d')
||unistr('\00E9sabonnement est possible pour le courriel ou si l''envoi est effectu\00E9 ind\00E9pendamment des pr\00E9f\00E9rences de l''utilisateur.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163756022306460)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Renseignez les \00E9l\00E9ments suivants et cliquez sur [Envoyer un courriel]. Tous les courriels envoy\00E9s sont consign\00E9s dans le journal de courriels.'),
'    <ul>',
unistr('        <li><strong>De</strong> - Si une "adresse d''exp\00E9diteur" est d\00E9finie dans les param\00E8tres de messagerie, l''adresse \00E9lectronique constitue une option d''exp\00E9dition. Sinon, l''exp\00E9diteur peut \00EAtre identique au destinataire.</li>'),
unistr('        <li><strong>Adresses \00E9lectroniques</strong> - Liste d''adresses \00E9lectroniques s\00E9par\00E9es par des virgules pour recevoir le courriel. Les adresses non valides ne sont pas incluses.</li>'),
unistr('        <li><strong>Mod\00E8le</strong> - S\00E9lectionnez le mod\00E8le de courriel \00E0 utiliser pour cr\00E9er le corps du courriel.</li>'),
'        <li><strong>Objet</strong> - Objet du courriel.</li>',
unistr('        <li><strong>Corps de courriel</strong> - Texte \00E0 inclure en tant que corps du courriel.</li>'),
unistr('        <li><strong>Autoriser le d\00E9sabonnement</strong> - Certains courriels doivent \00EAtre envoy\00E9s m\00EAme si l''utilisateur a choisi de se d\00E9sabonner de la r\00E9ception des courriels. Cela inclut les messages de coupure, etc. Cet indicateur sp\00E9cifie si un d')
||unistr('\00E9sabonnement est possible pour le courriel ou si l''envoi est effectu\00E9 ind\00E9pendamment des pr\00E9f\00E9rences de l''utilisateur.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102125257845306426)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le fuseau horaire par d\00E9faut pour tous les utilisateurs de cette application.</p>'),
unistr('<p>Les utilisateurs individuels peuvent remplacer ce param\00E8tre en cliquant sur leur nom utilisateur (en haut \00E0 droite) et en s\00E9lectionnant <strong>Pr\00E9f\00E9rences</strong>. Ils peuvent \00E9galement cliquer sur le lien de fuseau horaire affich\00E9 en bas de la ')
||'page d''accueil.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141145861306438)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page n''est pas accessible directement via l''interface utilisateur. Elle sert \00E0 faciliter le t\00E9l\00E9chargement de la photo de profil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140880343306437)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'fr'
,p_message_text=>unistr('La page de profil utilisateur vous permet de consulter les informations pertinentes concernant un utilisateur sur un \00E9cran unique facile \00E0 utiliser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140570906306437)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9chargez une photo pr\00E9sentant un rapport hauteur/largeur carr\00E9, sinon elle risque d''\00EAtre d\00E9form\00E9e. Taille d''image recommand\00E9e : 250 x 250 pixels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102126662868306427)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ce formulaire vous permet de mettre \00E0 jour vos d\00E9tails personnels et de t\00E9l\00E9charger une photo ou un avatar.</p>'),
unistr('<p>Pour t\00E9l\00E9charger une image, cliquez sur <strong>Parcourir</strong> ou effectuez un glisser-d\00E9placer de l''image sur le bouton.<br>'),
unistr('T\00E9l\00E9chargez une photo avec un rapport hauteur/largeur carr\00E9, sinon elle risque d''\00EAtre d\00E9form\00E9e. Taille d''image recommand\00E9e : 250 x 250 pixels.</p>'),
'<p>Pour enlever l''image, cliquez sur <strong>Supprimer la photo</strong>.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146748588306442)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ensemble du texte d''aide de l''application est accessible \00E0 partir de cette page. Les liens figurant dans la r\00E9gion "Documentation" fournissent une explication bien plus approfondie des fonctions et fonctionnalit\00E9s de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102127707995306428)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvez d\00E9finir les pr\00E9f\00E9rences d''application pour votre compte \00E0 partir de cette page. Les pr\00E9f\00E9rences peuvent avoir une incidence sur diff\00E9rents aspects de l''application tels que le fuseau horaire. Cliquez sur les ic\00F4nes d''aide au niveau des \00E9l')
||unistr('\00E9ments pour savoir \00E0 quoi correspond chaque pr\00E9f\00E9rence.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230558063305736)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cet \00E9tat pr\00E9sente tous les courriels en attente d''envoi et ceux d\00E9j\00E0 envoy\00E9s.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352004321305827)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cet \00E9tat comprend tous les travaux s\00E9lectionn\00E9s pour \00EAtre surveill\00E9s par cette application. Vous pouvez obtenir plus de d\00E9tails sur chaque travail en cliquant sur son nom.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358628249305832)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Cet \00E9tat comprend les d\00E9tails d''ex\00E9cution concernant les travaux s\00E9lectionn\00E9s pour \00EAtre surveill\00E9s par cette application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112046557306416)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'fr'
,p_message_text=>'Ajouter la page A propos de cette application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128461481306428)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez cette option sur Non si vous ne voulez pas recevoir de courriels de cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161544560306458)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un terme de recherche dans la bo\00EEte de dialogue de recherche et cliquez sur <strong>Rechercher</strong>.<br>'),
unistr('Cliquez sur n''importe quel en-t\00EAte de r\00E9sultat pour acc\00E9der \00E0 l''enregistrement sp\00E9cifique.</p>'),
unistr('<p>Pour limiter la recherche, d\00E9s\00E9lectionnez des sources, ce qui enl\00E8ve l''\00E9tat des r\00E9sultats de recherche.</p>'),
unistr('<p>Cliquez sur <strong>R\00E9initialiser</strong> pour enlever le terme de recherche en cours et s\00E9lectionner toutes les sources.</p> ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128201982306428)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez votre fuseau horaire pr\00E9f\00E9r\00E9 \00E0 utiliser dans l''ensemble de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126470058305640)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments masqu\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148336169306443)
,p_name=>'CA.HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102154465047306450)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169705107306465)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de la page Horaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229646929305735)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille du corps HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145173059306441)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141826953306438)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('En cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165983611306461)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'fr'
,p_message_text=>'Inclure dans les formulaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165845749306461)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclure dans les \00E9tats')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102150573049306445)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'fr'
,p_message_text=>'Installation de scripts d''objet de prise en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352728392305827)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''instance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353901389305828)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'fr'
,p_message_text=>'Affectation d''instance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124268834306425)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bienvenue dans cet aper\00E7u disponible uniquement sur le cloud d''une nouvelle m\00E9thode am\00E9lior\00E9e permettant de cr\00E9er une application plus compl\00E8te. L''assistant Cr\00E9ation d''application standard vous permet uniquement de s\00E9lectionner les pages \00E0 g\00E9n\00E9rer')
||unistr(', tandis que cet assistant vous donne \00E9galement l''opportunit\00E9 de pr\00E9charger rapidement de nombreuses fonctions suppl\00E9mentaires dans votre application.</p>'),
unistr('<p>Les applications g\00E9n\00E9r\00E9es \00E0 l''aide de cet assistant seront int\00E9gralement prises en charge et peuvent \00E9galement inclure des objets de prise en charge pour les fonctions s\00E9lectionn\00E9es, telles que le contr\00F4le d''acc\00E8s, la structure des courriels, les ')
||'informations en retour, etc.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124446181306425)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Commencez par indiquer le nom de l''application. Ensuite, ajoutez au moins une page \00E0 votre application. S\00E9lectionnez les fonctions que vous souhaitez inclure. Faites des choix concernant l''apparence de l''application, puis passez en revue les param')
||unistr('\00E8tres.<br>'),
unistr('C''est tr\00E8s simple : il vous suffit de cliquer sur <strong>Cr\00E9er une application</strong>.</p>'),
unistr('<p>Cliquez sur <strong>Afficher le mod\00E8le de base</strong> pour r\00E9utiliser le mod\00E8le d''une application g\00E9n\00E9r\00E9e pr\00E9c\00E9demment ou pour r\00E9pliquer rapidement des pages.</p>'),
unistr('<p><em><strong>Remarque :</strong> chaque section et chaque \00E9l\00E9ment Ajouter une page comportent une aide d\00E9taill\00E9e pour vous accompagner.</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124348149306425)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure d''utilisation de l''assistant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157912396306453)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les probl\00E8mes importants survenant lors de la publication sont r\00E9pertori\00E9s ci-dessous :'),
'<ol>',
unistr('  <li>L''assistant Cr\00E9er une application \00E0 partir du mod\00E8le de base n''est pas traduit.</li>'),
unistr('  <li>Les applications traduites g\00E9n\00E9r\00E9es avec cet assistant ne sont que partiellement traduites.</li>'),
unistr('  <li>L''analyse descendante d''\00E9tat n''autorise qu''une seule colonne d''analyse descendante.</li>'),
unistr('  <li>Les pages d''\00E9tat de filtre ne peuvent pas \00EAtre g\00E9n\00E9r\00E9es.</li>'),
unistr('  <li>La fonctionnalit\00E9 de messagerie fournit l''API de bas niveau, mais n''inclut toujours pas de fonctionnalit\00E9s de messagerie de niveau sup\00E9rieur.</li>'),
unistr('  <li>La g\00E9n\00E9ration d''une application \00E0 partir d''un mod\00E8le de base qui r\00E9f\00E9rence des tables manquantes \00E9chouera avec une erreur.</li>'),
unistr('  <li>Param\00E8tres avanc\00E9s - Les formats de date ne sont pas appliqu\00E9s \00E0 l''application g\00E9n\00E9r\00E9e.</li>'),
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157851090306453)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8mes connus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124692044306425)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Version %0.</p>',
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124553935306425)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tails de version')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102124163735306425)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une application \00E0 partir de l''assistant Mod\00E8le de base {Aper\00E7u uniquement sur le cloud}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135754030306434)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'fr'
,p_message_text=>'Adresse IP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133968306306432)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherche d''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136996143306434)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherches d''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164375050306460)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356753369305830)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358223130305831)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'fr'
,p_message_text=>'Classe de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357387247305831)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ateur du travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358492200305831)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354959075305829)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Priorit\00E9 de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351992012305827)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tat sur les travaux')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392014029305856)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Visualiser le statut et les d\00E9tails d''ex\00E9cution des travaux qui prennent en charge cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358547892305832)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tails d''ex\00E9cution de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357414733305831)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'fr'
,p_message_text=>'Style du travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357542213305831)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'fr'
,p_message_text=>'Sous-nom du travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356823216305830)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353585258305828)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'fr'
,p_message_text=>'Poids du travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164840231306461)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166627877306462)
,p_name=>'CA.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165197408306461)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166820092306462)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 au pluriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166548559306462)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 au singulier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123361916306424)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123401765306424)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la langue principale de cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157393366306452)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La langue principale r\00E9git la langue utilis\00E9e pour afficher les pages et les composants g\00E9n\00E9r\00E9s dans App Builder. La s\00E9lection de plusieurs traductions permet aux utilisateurs finals de choisir la langue d''affichage de l''application d''ex\00E9cution.</')
||'p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489709849305929)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de langue')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140328050306437)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357630615305831)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e de la derni\00E8re ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357740499305831)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date du dernier d\00E9marrage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170179716306465)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166052048306461)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161405475306458)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Charger le mod\00E8le de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360036885305833)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'fr'
,p_message_text=>'Consigner la date dans le journal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360122260305833)
,p_name=>'CA.LOG.ID'
,p_message_language=>'fr'
,p_message_text=>'ID de journal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354252210305828)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'fr'
,p_message_text=>'Niveau de journalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037458260306360)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'fr'
,p_message_text=>'Messages de journalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127609043305641)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Colonnes de recherche</strong> : d\00E9veloppez pour voir des attributs de d\00E9finition d''une recherche sur une autre table. Utilisez les colonnes de recherche pour remplacer les identificateurs par une colonne d''affichage, par exemple pour af')
||unistr('ficher le nom du d\00E9partement \00E0 la place de son num\00E9ro.<br>'),
unistr('<em><strong>Remarque :</strong> les colonnes de recherche apparaissent uniquement si la page en cours est bas\00E9e sur une table ou une vue et a des contraintes de cl\00E9 \00E9trang\00E8re sur une autre table.'),
'  <ul>',
unistr('    <li><strong>Cl\00E9 de recherche</strong> : s\00E9lectionnez la colonne qui sera modifi\00E9e pour g\00E9n\00E9rer la colonne d''affichage.</li>'),
unistr('    <li><strong>Colonne d''affichage</strong> : s\00E9lectionnez la colonne (dans la table de consultation) \00E0 afficher.</li>'),
'    &nbsp;<br>',
unistr('    <em><strong>Remarque :</strong> s\00E9lectionnez uniquement les colonnes qui ont une r\00E9f\00E9rence \00E0 une autre table (via une cl\00E9 \00E9trang\00E8re).</em></li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144358983306440)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer les mod\00E8les de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142316884306438)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer les informations en retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138414015306436)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer l''acc\00E8s utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170747970306466)
,p_name=>'CA.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter une page ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170898390306466)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui affiche une page ma\00EEtre-d\00E9tail pour permettre aux utilisateurs finals de visualiser et de tenir \00E0 jour les donn\00E9es.<br>'),
'&nbsp;</p>',
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de page</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Type de page</strong> : s\00E9lectionnez le type de page [C\00F4te \00E0 c\00F4te, Empil\00E9].<br>'),
unistr('    <strong>C\00F4te \00E0 c\00F4te</strong> : <br>'),
unistr('<em>Ma\00EEtre-d\00E9tail de page utilisant une mise en page c\00F4te \00E0 c\00F4te et des r\00E9gions d''\00E9tat avec des fen\00EAtres de modification modales.</em>'),
'    <ul>',
unistr('      <li><strong>Table</strong> (obligatoire) : s\00E9lectionnez la table ma\00EEtre pour la page.</li>'),
unistr('      <li><strong>Colonne d''affichage principale</strong> (obligatoire) : s\00E9lectionnez la colonne \00E0 afficher dans la liste des enregistrements ma\00EEtre.</li>'),
unistr('      <li><strong>Colonne d''affichage secondaire</strong> (obligatoire) : s\00E9lectionnez la colonne descriptive \00E0 afficher dans la liste des enregistrements ma\00EEtre, sous la colonne d''affichage principale.</li>'),
unistr('      <li><strong>Table de d\00E9tails 1</strong> (obligatoire) : s\00E9lectionnez la premi\00E8re table de d\00E9tails pour la page.</li>'),
unistr('      <li><strong>Table de d\00E9tails 2</strong> - s\00E9lectionnez la deuxi\00E8me table de d\00E9tails pour la page.</li>'),
unistr('      <li><strong>Table de d\00E9tails 3</strong> - s\00E9lectionnez la troisi\00E8me table de d\00E9tails pour la page.</li>'),
unistr('      <li><strong>Table de d\00E9tails 4</strong> - s\00E9lectionnez la quatri\00E8me table de d\00E9tails pour la page.</li>'),
'    </ul>',
unistr('   <strong>Empil\00E9</strong> : <br>'),
unistr('<em>Ma\00EEtre-d\00E9tail de page utilisant des grilles interactives modifiables.</em>'),
'    <ul>',
unistr('      <li><strong>Table</strong> (obligatoire) : s\00E9lectionnez la table ma\00EEtre pour la grille interactive modifiable.</li>'),
unistr('      <li><strong>Table de d\00E9tails</strong> (obligatoire) : s\00E9lectionnez la table de d\00E9tails pour la page.</li>'),
unistr('      <em><strong>Remarque :</strong> une seule table de d\00E9tails (grille interactive modifiable) peut \00EAtre ajout\00E9e \00E0 l''aide de l''assistant. Vous pouvez ajouter facilement d''autres tables de d\00E9tails une fois la g\00E9n\00E9ration termin\00E9e.</em>'),
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489609110305929)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrements ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134683985306433)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps maximal \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354701281305829)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre maximal d''\00E9checs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354312288305829)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e maximale de l''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354880510305829)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre maximal d''ex\00E9cutions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165045376306461)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'fr'
,p_message_text=>'Nombre maximum de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168085499306463)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'fr'
,p_message_text=>'Largeur maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158620105306453)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159050405306454)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'fr'
,p_message_text=>'Ajouter %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158561788306453)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Appliquer des filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159432749306454)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur de date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159575434306454)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'fr'
,p_message_text=>'Valeur de date 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158707893306453)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158104151306453)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158015049306453)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159116721306454)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Aucun filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158486169306453)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun enregistrement s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158384963306453)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun enregistrement trouv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158915287306453)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158860784306453)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102158262110306453)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159257038306454)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159345697306454)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'fr'
,p_message_text=>'Valeur 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134198174306432)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps m\00E9dian \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143266107306439)
,p_name=>'CA.MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Message'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037267629306359)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de message'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167532615306463)
,p_name=>'CA.METRIC'
,p_message_language=>'fr'
,p_message_text=>'Mesure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135062159306433)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps minimal \00E9coul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137887189306435)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9phone portable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133609095306432)
,p_name=>'CA.MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147412005306442)
,p_name=>'CA.MORE'
,p_message_language=>'fr'
,p_message_text=>'Plus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137093018306434)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'fr'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169908865306465)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages les plus actives'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127703267305641)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'fr'
,p_message_text=>'Etats multiples'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127803516305641)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cochez des noms de table ou de vue. Vous pouvez \00E9galement cocher la case de l''en-t\00EAte pour s\00E9lectionner ou d\00E9s\00E9lectionner tous les objets de base de donn\00E9es de la liste.</p>'),
unistr('<p>Une page avec \00E9tat interactif sera ajout\00E9e pour chaque objet de base de donn\00E9es coch\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131026180306430)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# doit \00EAtre un horodatage valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167339531306462)
,p_name=>'CA.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122550983306424)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122607905306424)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si le menu est affich\00E9 sur le c\00F4t\00E9 de l''application ou dans la partie sup\00E9rieure de celle-ci.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174028651306469)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('N\00E9gatif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173972834306468)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'fr'
,p_message_text=>'Neutre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160000259306454)
,p_name=>'CA.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354591873305829)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de l''ex\00E9cution suivante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353426584305828)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'fr'
,p_message_text=>'Environnement NLS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442492245305894)
,p_name=>'CA.NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141958892306438)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'fr'
,p_message_text=>'Aucune action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153585179306449)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Il n''y a pas d''aide pour cette page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126526630305640)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'fr'
,p_message_text=>'Il n''existe aucun utilisateur valide - Infos sur la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161027858306458)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun nouvel utilisateur valide trouv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157178852306452)
,p_name=>'CA.NONE'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138121875306435)
,p_name=>'CA.NOTE'
,p_message_language=>'fr'
,p_message_text=>'Remarque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113658133306417)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Notifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112482318306416)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'fr'
,p_message_text=>'Afficher les notifications sur la page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113766402306417)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permet aux administrateurs de l''application d''indiquer des alertes (en jaune) ou des erreurs (en rouge) visibles par tous les utilisateurs finals sur la page d''accueil de l''application. Cette fonctionnalit\00E9 est utile pour relayer des informations ')
||unistr('importantes \00E0 votre communaut\00E9 d''utilisateurs finals.</p>'),
'<p>Comprend les composants suivants :<ul>',
unistr('<li>Possibilit\00E9 de d\00E9finir les notifications</li>'),
'<li>Affichage des notifications sur la page d''accueil de l''application</li>',
unistr('<li>Possibilit\00E9 de contr\00F4ler la fen\00EAtre de dur\00E9e d''affichage de la notification</li>'),
'<li>Prise en charge du codage couleur des notifications par type</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130338988306429)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133860237306432)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'fr'
,p_message_text=>'Nombre de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356665199305830)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'fr'
,p_message_text=>'Nombre d''arguments'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353274908305828)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'fr'
,p_message_text=>'Nombre de destinations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165562936306461)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Masque de format num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135313373306433)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'fr'
,p_message_text=>'Occurrence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102174285057306469)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez pas effectuer cette action sans un autre administrateur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142128534306438)
,p_name=>'CA.OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouvert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115133370306418)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Organisation des pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115433079306418)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Organisez les pages selon l''ordre dans lequel vous souhaitez qu''elles apparaissent dans votre application. <br>',
unistr('Pour r\00E9organiser les pages dans la liste, cliquez sur l''ic\00F4ne <em>Menu</em> ( <span class="fa fa-bars" aria-hidden="true"></span> ) \00E0 la fin de chaque liste de pages en maintenant le bouton de la souris enfonc\00E9, puis faites un glisser-d\00E9placer de cet')
||'te page vers le haut ou vers le bas.</p>',
unistr('<p>La page d''accueil est toujours affich\00E9e en premier et ne peut pas \00EAtre d\00E9plac\00E9e.<br>'),
unistr('Les pages administratives apparaissent toujours au bas de la liste. Cet ordre r\00E9git leur ordre d''apparition dans la liste Administration des applications sur la page Administration.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358721080305832)
,p_name=>'CA.OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Sortie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359967329305833)
,p_name=>'CA.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133553804306432)
,p_name=>'CA.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136731963306434)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149273187306444)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135884219306434)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491469061305930)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier l''enregistrement ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491603550305930)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Effectuez la recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133127610306432)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148509682306443)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135225540306433)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>'Performances de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160155976306454)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'fr'
,p_message_text=>'Le type de page "%0" n''est pas un type valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134555807306433)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115613569306419)
,p_name=>'CA.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115704038306419)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9finissez les pages \00E0 inclure dans votre application initiale. Vous devez d\00E9finir au moins une page pour pouvoir cr\00E9er votre application.</p>'),
unistr('<p>Vous pouvez enrichir votre application en cr\00E9ant autant de pages que vous le souhaitez \00E0 l''aide de cet assistant. Une fois votre application cr\00E9\00E9e, utilisez l''assistant Cr\00E9er une page pour ajouter des pages.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165497342306461)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode de pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134805118306433)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page partielle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140637105306437)
,p_name=>'CA.PHOTO'
,p_message_language=>'fr'
,p_message_text=>'Photo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141233302306438)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Photo supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140737328306437)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de photo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140491587306437)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9chargement de photo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037320385306359)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de la cl\00E9 primaire ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145297207306441)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de texte brut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173888291306468)
,p_name=>'CA.POSITIVE'
,p_message_language=>'fr'
,p_message_text=>'Positif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128048898306428)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rences')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102171420048306466)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166101536306462)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''affichage principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167021500306462)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167142256306462)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'fr'
,p_message_text=>'Table parent principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135420039306433)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128624174306428)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence de messagerie mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491277324305930)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'fr'
,p_message_text=>'Extraire la ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037524438306360)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Obtenir les d\00E9tails du journal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129877189306429)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''apparence de l''application enregistr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128510278306428)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence de fuseau horaire mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141062734306438)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9chargement de photo de profil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356968509305830)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de programme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357027313305830)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire du programme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869944985305442)
,p_name=>'CA.PWA'
,p_message_language=>'fr'
,p_message_text=>'Installer une application Web progressive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869883559305442)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'fr'
,p_message_text=>'Rendez l''installation de votre application possible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870016552305442)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les applications Web progressives sont des applications Web fiables, dot\00E9es de fonctionnalit\00E9s et pouvant \00EAtre install\00E9es. Elles donnent l''impression d''applications con\00E7ues pour la plate-forme sur laquelle elles sont utilis\00E9es.</p>'),
'<p>L''activation de cette option :</p>',
'<ul>',
unistr('<li>permet d''ajouter une nouvelle entr\00E9e de barre de navigation : Installer l''application,</li>'),
'<li>permet aux utilisateurs d''installer cette application APEX sur leurs appareils.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865937731305439)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'fr'
,p_message_text=>'Installer l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166417491306462)
,p_name=>'CA.QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353749675305828)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencher des \00E9v\00E9nements')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995490348305541)
,p_name=>'CA.RATING'
,p_message_language=>'fr'
,p_message_text=>'Evaluation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102138993000306436)
,p_name=>'CA.READERS'
,p_message_language=>'fr'
,p_message_text=>'Lecteurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128311266306428)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'fr'
,p_message_text=>'Recevoir des courriels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170066321306465)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreurs r\00E9centes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806123353306173)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806288568306173)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130574361306430)
,p_name=>'CA.RED'
,p_message_language=>'fr'
,p_message_text=>'Rouge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102144109051306440)
,p_name=>'CA.REFERENCED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490334375305929)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer la page d''administration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107676798305626)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer \00E0 la fermeture de la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101491556544305930)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130086652306429)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion de boutons')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129937850306429)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion d''\00E9l\00E9ment de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135919172306434)
,p_name=>'CA.REGION.ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147924781306443)
,p_name=>'CA.RELEASE'
,p_message_language=>'fr'
,p_message_text=>'Version %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115203668306418)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Suppression de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102115382617306418)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Pour s\00E9lectionner la page, cliquez sur <strong>Modifier</strong>, puis, pour enlever une page de votre application, cliquez sur <strong>Supprimer la page</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358387212305831)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Intervalle de r\00E9p\00E9tition')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230227622305735)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9pondre \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102121093009306423)
,p_name=>'CA.REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter une page d''\00E9tat')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102120920073306423)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui affiche un \00E9tat interactif ou classique.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de page</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Type de requ\00EAte</strong> : s\00E9lectionnez la source de l''\00E9tat [<strong>Table ou vue</strong> ou <strong>Requ\00EAte SQL</strong>] :<br>'),
'    <strong>Table ou vue</strong> :',
'    <ul>',
unistr('      <li>Table ou vue (Obligatoire) : s\00E9lectionnez l''objet de base de donn\00E9es de l''\00E9tat.</li>'),
unistr('      <li>Inclure le formulaire : s\00E9lectionnez cette option pour g\00E9n\00E9rer une page de formulaire associ\00E9e permettant aux utilisateurs de tenir \00E0 jour les valeurs de table.</li>'),
'    </ul>',
unistr('    <strong>Requ\00EAte SQL</strong> :'),
'    <ul>',
unistr('      <li>Requ\00EAte SQL (obligatoire) : saisissez une instruction SQL valide qui renvoie des colonnes distinctes.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>Type d''\00E9tat</strong> : s\00E9lectionnez le type d''\00E9tat (<strong>Etat interactif</strong> ou <strong>Etat classique</strong>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112769177306416)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'fr'
,p_message_text=>'%0 avec le formulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995328922306327)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'fr'
,p_message_text=>'%0 - Etat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169198629306464)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167713985306463)
,p_name=>'CA.REPORTS'
,p_message_language=>'fr'
,p_message_text=>'Etats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359746334305832)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but demand\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167956846306463)
,p_name=>'CA.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146023042306441)
,p_name=>'CA.RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142009535306438)
,p_name=>'CA.RESOLVED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9solu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141731451306438)
,p_name=>'CA.RESPONSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ponse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355006868305829)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Red\00E9marrer en cas d''\00E9chec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101355118449305829)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Red\00E9marrer en cas de r\00E9cup\00E9ration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352342108305827)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Peut \00EAtre red\00E9marr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354674703305829)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de nouvelles tentatives'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162931098306459)
,p_name=>'CA.ROLE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136133068306434)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145476484306441)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162302760306459)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'fr'
,p_message_text=>unistr('HTML de mod\00E8le de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163604551306460)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'fr'
,p_message_text=>'Contenu des lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136880280306434)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'fr'
,p_message_text=>'Lignes extraites'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102165325899306461)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'fr'
,p_message_text=>'Lignes par page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101357958133305831)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre d''ex\00E9cutions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359525038305832)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e de l''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354481884305829)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'fr'
,p_message_text=>'Limite de la programmation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356447675305830)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de programmation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356514459305830)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de la programmation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356309587305830)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de programmation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123556761306424)
,p_name=>'CA.SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123696870306425)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>S\00E9lectionnez le sch\00E9ma de base de donn\00E9es qui stocke les objets de base de donn\00E9es \00E0 utiliser dans cette application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164417015306460)
,p_name=>'CA.SCOPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Port\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146189867306441)
,p_name=>'CA.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146270949306441)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Rechercher une application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102146309446306441)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'fr'
,p_message_text=>'Dialogue de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169385332306464)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Filtres de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153078224306449)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cette page est g\00E9n\00E9r\00E9e \00E0 partir de la liste des composants partag\00E9s nomm\00E9e Tables recherch\00E9es.'),
'',
unistr('Toutes les pages Etat interactif g\00E9n\00E9r\00E9es initialement \00E0 partir de l''assistant Cr\00E9er une application sont automatiquement ajout\00E9es \00E0 la liste. '),
unistr('Pour ajouter vos propres tables \00E0 la liste et acc\00E9der aux composants partag\00E9s, s\00E9lectionnez Listes, puis cliquez sur Tables recherch\00E9es.'),
'  Saisissez les attributs suivants :',
unistr('    Entr\00E9e : Libell\00E9 d''entr\00E9e de liste - saisissez le nom d''affichage de la table.'),
unistr('    Cible : Page - s\00E9lectionnez la page appropri\00E9e \00E0 laquelle acc\00E9der (un \00E9tat interactif de pr\00E9f\00E9rence)'),
unistr('    Cible : Effacer le cache - saisissez les pages \00E0 effacer (g\00E9n\00E9ralement le m\00EAme nombre que celui entr\00E9 sous Page).'),
unistr('       Si vous acc\00E9dez \00E0 une page Etat interactif, ajoutez CIR,RIR pour effacer tout filtre existant, etc.'),
unistr('    Cible : D\00E9finir ces \00E9l\00E9ments - s\00E9lectionnez (ou saisissez) l''\00E9l\00E9ment de page appropri\00E9 \00E0 renseigner.'),
unistr('       Si vous acc\00E9dez \00E0 une page Etat interactif, saisissez IR_[COLUMN_NAME].'),
'    Cible : Avec ces valeurs - saisissez =PK=',
unistr('    Attributs d\00E9finis par l''utilisateur : 1 - saisissez le nom de table \00E0 rechercher en majuscules.'),
unistr('    Attributs d\00E9finis par l''utilisateur : 2 - saisissez le nom de colonne principale en majuscules.'),
unistr('    Attributs d\00E9finis par l''utilisateur : 3 (facultatif) - liste de colonnes \00E0 rechercher, s\00E9par\00E9es par des virgules.'),
unistr('       Si aucune colonne n''est indiqu\00E9e, toutes les colonnes de texte (varchar2) et CLOB sont recherch\00E9es.'),
'',
unistr('Remarque : les utilisateurs voient la liste des tables disponibles \00E0 rechercher uniquement si plusieurs tables sont r\00E9pertori\00E9es.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145877198306441)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats de la recherche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166966925306462)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''affichage secondaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142468122306439)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229577319305735)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but de l''envoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229903978305735)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre d''envois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229419593305735)
,p_name=>'CA.SEND.END'
,p_message_language=>'fr'
,p_message_text=>'Fin de l''envoi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229886522305735)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur d''envoi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172946305306468)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'fr'
,p_message_text=>'Envoyer des courriels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102173079663306468)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine si des courriels doivent \00EAtre envoy\00E9s lors de la r\00E9ception de nouvelles informations en retour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102169664419306465)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'fr'
,p_message_text=>'Adresse d''envoi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162194317306458)
,p_name=>'CA.SEND.TO'
,p_message_language=>'fr'
,p_message_text=>unistr('Envoyer \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147732708306443)
,p_name=>'CA.SERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359465268305832)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'fr'
,p_message_text=>'ID de session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164681208306460)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'fr'
,p_message_text=>'Protection de statut de session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122976906306424)
,p_name=>'CA.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123043089306424)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Sp\00E9cifiez les param\00E8tres utilis\00E9s dans la g\00E9n\00E9ration de l''application.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147344041306442)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'fr'
,p_message_text=>'Afficher tout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107184051305626)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher/Masquer la port\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148463070306443)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'fr'
,p_message_text=>'Afficher le fuseau horaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102148228603306443)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir une session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149472339306444)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'fr'
,p_message_text=>'Fermer la session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359322357305832)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'fr'
,p_message_text=>'PID esclave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353396057305828)
,p_name=>'CA.SOURCE'
,p_message_language=>'fr'
,p_message_text=>'Source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160216269306454)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'fr'
,p_message_text=>'Le type de source n''est pas un type valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102153188766306449)
,p_name=>'CA.SOURCES'
,p_message_language=>'fr'
,p_message_text=>'Sources'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356275574305830)
,p_name=>'CA.START.DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036767060306359)
,p_name=>'CA.STARTED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101358087196305831)
,p_name=>'CA.STATE'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167873086306463)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut statique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102132191646306431)
,p_name=>'CA.STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354002500305828)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'fr'
,p_message_text=>unistr('Arr\00EAt \00E0 la fermeture de la fen\00EAtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101354197501305828)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Sortie d''emplacement de stockage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142672530306439)
,p_name=>'CA.SUBJECT'
,p_message_language=>'fr'
,p_message_text=>'Objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102141395894306438)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Soumettre les informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036931974306359)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes de r\00E9ussite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102164976650306461)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Visualisation sugg\00E9r\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156815980306452)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Objets de prise en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156914295306452)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Saisissez le code dans le script d''installation, g\00E9n\00E9ralement pour cr\00E9er ou manipuler des objets de base de donn\00E9es ou effectuer des insertions/mises \00E0 jour/suppressions sur des enregistrements existants. Saisissez le code dans le script de d\00E9sins')
||unistr('tallation, g\00E9n\00E9ralement pour enlever (supprimer) des objets de base de donn\00E9es. Ces scripts sont incorpor\00E9s dans les objets de prise en charge afin que les m\00EAmes mises \00E0 jour soient r\00E9alis\00E9es dans vos environnements de test et de production lorsque v')
||'ous exportez l''application.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157025812306452)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez dans le script d''installation des instructions SQL et/ou PL/SQL valides qui sont ex\00E9cut\00E9es lors de l''import de l''application.</p>'),
unistr('<p>Si vous voulez que les instructions soient \00E9galement ex\00E9cut\00E9es dans l''environnement en cours, et pas uniquement lorsque l''application est import\00E9e dans un autre environnement, cliquez sur <strong>Ex\00E9cuter lors de la cr\00E9ation de l''application</stro')
||'ng>.</p>',
unistr('<p>Saisissez dans le script de d\00E9sinstallation des instructions SQL et/ou PL/SQL qui sont ex\00E9cut\00E9es lors de la suppression de l''application d''App Builder.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353650559305828)
,p_name=>'CA.SYSTEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Syst\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102166368535306462)
,p_name=>'CA.TABLE'
,p_message_language=>'fr'
,p_message_text=>'Table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123708100306425)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe d''objet de structure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102123852787306425)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez un pr\00E9fixe d''objet \00E0 utiliser dans l''application. Certaines fonctions ajoutent ce pr\00E9fixe aux objets de base de donn\00E9es qu''elles cr\00E9ent (y compris les packages et les tables).</p>'),
unistr('<p>Avertissement : assurez-vous que vous indiquez un pr\00E9fixe unique qui n''est pas utilis\00E9 par d''autres applications. S''il n''est pas unique, l''application est susceptible de g\00E9n\00E9rer des erreurs lors de sa cr\00E9ation et de ne pas fonctionner correctement')
||'.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102167242952306462)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162209873306459)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102145722366306441)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce nom de mod\00E8le est d\00E9j\00E0 attribu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102142585133306439)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131275503306430)
,p_name=>'CA.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229796101305735)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille du corps de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143732955306440)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de texte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129447828306429)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence de th\00E8me de l''utilisateur final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129659252306429)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Si cette option est s\00E9lectionn\00E9e, les utilisateurs finals peuvent choisir leur propre style de th\00E8me \00E0 l''aide du lien Personnaliser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102129525710306429)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser les utilisateurs finals \00E0 choisir le style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113807996306417)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection du style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102112286969306416)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour la pr\00E9sentation par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102113941470306417)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permet aux administrateurs de s\00E9lectionner un sch\00E9ma de couleur (style de th\00E8me) par d\00E9faut pour l''application. Les administrateurs peuvent \00E9galement d\00E9cider de permettre aux utilisateurs finals de choisir leur propre style de th\00E8me. Il suffit aux')
||unistr(' utilisateurs finals de cliquer sur le bouton <em>Personnaliser</em> situ\00E9 en bas de la page d''accueil, et de choisir parmi les styles de th\00E8me disponibles. Par exemple, les utilisateurs souffrant d''une d\00E9ficience visuelle pourront pr\00E9f\00E9rer le style ')
||unistr('de th\00E8me <em>Vista</em> qui pr\00E9sente un contraste de couleurs tr\00E8s marqu\00E9.</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Possibilit\00E9 pour les administrateurs de d\00E9finir le style de th\00E8me par d\00E9faut</li>'),
unistr('<li>Possibilit\00E9 pour les utilisateurs finals de s\00E9lectionner diff\00E9rents styles de th\00E8me</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122301822306424)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102122450479306424)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le style de th\00E8me par d\00E9faut utilis\00E9 pour afficher l''application.</p>'),
unistr('<p>Le style peut facilement \00EAtre remplac\00E9 par un autre style pr\00E9d\00E9fini ou modifi\00E9 suite \00E0 la g\00E9n\00E9ration. Pour modifier le style, ex\00E9cutez l''application, puis cliquez sur <strong>Theme Roller</strong> dans la barre d''outils de d\00E9veloppeur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102136449771306434)
,p_name=>'CA.TIME'
,p_message_language=>'fr'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102128127494306428)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'fr'
,p_message_text=>'Fuseau horaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114942085306418)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'fr'
,p_message_text=>'Prise en charge de fuseaux horaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111879735306416)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le fuseau horaire par d\00E9faut et celui de l''utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114683316306418)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Autoriser les utilisateurs finals \00E0 d\00E9finir leur fuseau horaire local. Cette fonction est importante si les tables de votre application utilisent des types de date d\00E9pendant des fuseaux horaires (tels que TIMESTAMP WITH LOCAL TIME ZONE) afin que l')
||unistr('es \00E9tats et les entr\00E9es de donn\00E9es indiquent l''emplacement des utilisateurs finals.</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Possibilit\00E9 pour les administrateurs de d\00E9finir le fuseau horaire par d\00E9faut</li>'),
unistr('<li>Possibilit\00E9 pour les utilisateurs finals de s\00E9lectionner leur pr\00E9f\00E9rence de fuseau horaire</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170217608306465)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'fr'
,p_message_text=>'Tranche de temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170527826306466)
,p_name=>'CA.TIMELINE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une page de cadre temporel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102170614196306466)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une page qui affiche une chronologie, particuli\00E8rement utile pour afficher les mises \00E0 jour.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de page</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Table ou vue</strong> (obligatoire) : s\00E9lectionnez l''objet de base de donn\00E9es pour la chronologie.</li>'),
unistr('  <li><strong>Nom utilisateur</strong> (obligatoire) : s\00E9lectionnez la colonne dans la table ou la vue \00E0 utiliser en tant qu''utilisateur affich\00E9 pour les entr\00E9es de la chronologie.</li>'),
unistr('  <li><strong>Date</strong> (obligatoire) : s\00E9lectionnez la colonne dans la table ou la vue \00E0 utiliser en tant que date pour les entr\00E9es de la chronologie.</li>'),
unistr('  <li><strong>Nom d''\00E9v\00E9nement</strong> (obligatoire) : s\00E9lectionnez la colonne dans la table ou la vue \00E0 utiliser comme titre pour les entr\00E9es de la chronologie.</li>'),
unistr('  <li><strong>Description</strong> : s\00E9lectionnez la colonne dans la table ou la vue \00E0 utiliser comme description pour les entr\00E9es de la chronologie.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133338525306432)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'fr'
,p_message_text=>'Horodatage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137985938306435)
,p_name=>'CA.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230312575305735)
,p_name=>'CA.TO'
,p_message_language=>'fr'
,p_message_text=>'A'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137132341306435)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'fr'
,p_message_text=>'Principaux utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137284288306435)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique des principaux utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134777227306433)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'fr'
,p_message_text=>'Nombre total de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139176384306436)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le par d\00E9faut pour les utilisateurs ne figurant pas dans la liste de contr\00F4le d''acc\00E8s :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131347671306430)
,p_name=>'CA.TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441851089305893)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeurs par d\00E9faut d''interface utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441934569305893)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez des valeurs par d\00E9faut pour les param\00E8tres d''interface utilisateur, tels que le nombre de lignes par page, et ajoutez la liste des d\00E9finitions de valeur. Ces param\00E8tres sont utilis\00E9s lors de la g\00E9n\00E9ration de composants au sein de l''applica')
||'tion. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131505924306430)
,p_name=>'CA.UNTIL'
,p_message_language=>'fr'
,p_message_text=>'A'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490169514305929)
,p_name=>'CA.UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140931035306437)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour le profil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131842811306431)
,p_name=>'CA.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102131991368306431)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102133246209306432)
,p_name=>'CA.USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159760865306454)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'fr'
,p_message_text=>'Ajouter plusieurs utilisateurs - Etape 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159894216306454)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'fr'
,p_message_text=>'Ajouter plusieurs utilisateurs - Etape 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159984781306454)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter plusieurs utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102135667769306433)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'fr'
,p_message_text=>'Agent utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149063453306443)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat sur le nombre d''utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137448768306435)
,p_name=>'CA.USER.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139989915306437)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'fr'
,p_message_text=>'Profil utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114872928306418)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'fr'
,p_message_text=>'Profils utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111712213306416)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser les utilisateurs \00E0 mettre \00E0 jour leur profil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102114704622306418)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Autoriser les utilisateurs finals \00E0 indiquer des informations suppl\00E9mentaires les concernant, y compris une image ou un avatar, pour personnaliser leur compte.</p>'),
'<p>Comprend les composants suivants :',
'<ul>',
unistr('<li>Page de configuration permettant aux utilisateurs finals de param\00E9trer leur profil</li>'),
unistr('<li>Possibilit\00E9 de t\00E9l\00E9charger une photo/un avatar</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102140144728306437)
,p_name=>'CA.USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139258048306436)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format de nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160603065306457)
,p_name=>'CA.USERNAMES'
,p_message_language=>'fr'
,p_message_text=>'Noms utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449388717305899)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format de nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161252126306458)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateurs ajout\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102162727057306459)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateurs par r\00F4le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102143335582306439)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs inclus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102160972532306458)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateurs \00E0 ajouter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139441635306436)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Format de nom utilisateur mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126379260305640)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'fr'
,p_message_text=>'Il existe des utilisateurs valides - Infos sur la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155078118306450)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''application existe d\00E9j\00E0 ou est r\00E9serv\00E9 pour une autre application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396631035305860)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom d''application doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163344330306459)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Doit fournir les adresses \00E9lectroniques auxquelles envoyer le courriel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163180883306459)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Doit fournir les adresses \00E9lectroniques ou s\00E9lectionner un ensemble d''utilisateurs auquel envoyer le courriel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163248680306459)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Doit s\00E9lectionner un ensemble d''utilisateurs auquel envoyer le courriel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155124035306450)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Le pr\00E9fixe de table ne doit pas comporter plus de six caract\00E8res, doit commencer par une lettre et ne doit contenir que des lettres, des nombres et des traits de soulignement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155290447306451)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un autre pr\00E9fixe de table. Les objets de base de donn\00E9es suivants existent d\00E9j\00E0 : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139858994306437)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le format d''adresse \00E9lectronique du nom utilisateur n''est pas valide. Reportez-vous au format de nom utilisateur de l''application ci-dessous.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102139796538306437)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier le format de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137377604306435)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'fr'
,p_message_text=>'Visualiser comme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102157665318306452)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher le mod\00E8le de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102147246748306442)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('Voir les d\00E9tails')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102163589265306460)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Visualiser les param\00E8tres de messagerie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102149360469306444)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'fr'
,p_message_text=>'Afficher mon profil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102134263977306432)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Performances pond\00E9r\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102168196040306463)
,p_name=>'CA.WIDTH'
,p_message_language=>'fr'
,p_message_text=>'Largeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172383705306467)
,p_name=>'CA.WIZARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er des pages d''assistant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126220773305640)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'fr'
,p_message_text=>'Conteneur d''assistant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102172481513306467)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cr\00E9ez une collection de pages \00E0 utiliser en tant qu''assistant. Les assistants sont g\00E9n\00E9ralement utilis\00E9s pour la saisie de donn\00E9es dans plusieurs \00E9tapes.</p>'),
'<p>Indiquez les attributs suivants :</p>',
'<ul>',
'  <li><strong>Nom de l''assistant</strong> (obligatoire) : saisissez le nom de la page.</li>',
unistr('  <li><strong>D\00E9finir l''ic\00F4ne</strong> : s\00E9lectionnez une ic\00F4ne \00E0 afficher dans le menu de navigation pour cette page.</li>'),
unistr('  <li><strong>Mode de page</strong> (obligatoire) : d\00E9terminez si les \00E9tapes de l''assistant seront affich\00E9es comme des pages modales ou normales. S\00E9lectionnez <strong>Page modale</strong> ou <strong>Pleine page</strong>.</li>'),
unistr('  <li><strong>Etape 1 ... 8</strong> : saisissez le nom de la page pour les \00E9tapes de l''assistant.<br><em><strong>Remarque :</strong> les \00E9tapes 5 \00E0 8 s''affichent \00E0 mesure qu''un nom est saisi pour chaque \00E9tape pr\00E9c\00E9dente.</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102137708188306435)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9phone professionnel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102130485890306430)
,p_name=>'CA.YELLOW'
,p_message_language=>'fr'
,p_message_text=>'Jaune'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442364180305894)
,p_name=>'CA.YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995310704305541)
,p_name=>'CACHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis en m\00E9moire cache')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898545664305464)
,p_name=>'CACHE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cache cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886119354305454)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonction de suppression des donn\00E9es est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871180042305443)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonction d''ajout de donn\00E9es est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871265095305443)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonction de mise \00E0 jour des donn\00E9es est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024012921305564)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023957892305563)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910346251305473)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Calendrier simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928299631306269)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier une entr\00E9e de calendrier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859617338305435)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Calendrier instantan\00E9 pour %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991078521305538)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du calendrier a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380611061305848)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de calendrier h\00E9rit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910277577305473)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243681577305745)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de calendrier trouv\00E9 lors de la tentative de copie depuis l''application %0 et l''ID de mod\00E8le %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382038613305849)
,p_name=>'CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866189471305440)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions de carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614029927306024)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'fr'
,p_message_text=>'Feuilles de style CSS'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461477030305908)
,p_name=>'CHANGES'
,p_message_language=>'fr'
,p_message_text=>'Modifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038590971306360)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'fr'
,p_message_text=>'Modifier authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377329070305845)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier la taille de la base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377152731305845)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'fr'
,p_message_text=>'Demande de modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590885372306006)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Modifier l''espace de travail'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350609426305826)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de jeu de caract\00E8res')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072219106305601)
,p_name=>'CHART'
,p_message_language=>'fr'
,p_message_text=>'graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854971251305431)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La requ\00EAte de graphique n''est pas valide : %0<br><br>'),
'Utilisez la syntaxe suivante :',
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
'<tr><td>LABEL</td><td>Texte accompagnant la barre</td></tr>',
unistr('<tr><td>VALUE</td><td>Colonne num\00E9rique d\00E9finissant la taille de la barre</td></tr>'),
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019831262305560)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Requ\00EAte de graphique non valide.<br /><br /> Utilisez la syntaxe suivante : <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>Colonne num\00E9rique d\00E9finissant la valeur de cadran.</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>Colonne num\00E9rique d\00E9finissant la valeur maximale de cadran.</td>'),
'</tr>',
'<tr>',
'<td>LOW (facultatif)</td>',
unistr('<td>Colonne num\00E9rique d\00E9finissant la valeur minimale pr\00E9c\00E9dente de cadran.</td>'),
'</tr>',
'<tr>',
'<td>HIGH (facultatif)</td>',
unistr('<td>Colonne num\00E9rique d\00E9finissant la valeur maximale pr\00E9c\00E9dente de cadran.</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086624624305611)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Type de graphique non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854872675305431)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Echec de l''analyse de la requ\00EAte SQL.'),
'<p>%0</p>',
unistr('Certaines requ\00EAtes ne peuvent \00EAtre lanc\00E9es que lorsque votre application est en cours d''ex\00E9cution. Si la syntaxe de votre requ\00EAte est correcte, vous pouvez enregistrer celle-ci sans validation (voir les options sous la source de la requ\00EAte).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078103164306390)
,p_name=>'CHART_DEGREES'
,p_message_language=>'fr'
,p_message_text=>unistr('degr\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328145085305809)
,p_name=>'CHART_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Graphique de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886690789305455)
,p_name=>'CHART_SERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie de graphiques')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373865904305843)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de s\00E9rie de graphiques %0 pour %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982842598305531)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du graphique a r\00E9ussi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331972038305812)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Checksum requis - niveau application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165004477305669)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'fr'
,p_message_text=>'Checksum requis - niveau session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164959852305669)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'fr'
,p_message_text=>'Checksum requis - niveau utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164804083305669)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Checksum requis - niveau application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078946461306391)
,p_name=>'CHECK_ALL'
,p_message_language=>'fr'
,p_message_text=>'Cocher tout'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317492372305801)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier classique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320167009305803)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat classique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018667885305559)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat classique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317821447305802)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'fr'
,p_message_text=>'Arborescence classique'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315757521305800)
,p_name=>'CLEAN_UP'
,p_message_language=>'fr'
,p_message_text=>'Nettoyer la page'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881455919305451)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'fr'
,p_message_text=>'Commande CLEAR'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325054834305807)
,p_name=>'CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ferm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370680976305841)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ferm\00E9 au cours des 7 derniers jours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123740127305638)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'fr'
,p_message_text=>unistr('Fermer la fen\00EAtre')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859169487306213)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mode d''accessibilit\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155375207306451)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156374846306451)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156297226306451)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution automatique')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983958788306318)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'fr'
,p_message_text=>'Indentation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155686307306451)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille de retrait'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155877453306451)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'fr'
,p_message_text=>'Espaces d''insertions de tabulation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859240872306213)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment %0 n''existe pas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860342484306214)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'fr'
,p_message_text=>'Mini-carte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860247542306214)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'fr'
,p_message_text=>'Seulement si > 100 lignes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102159650504306454)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Concepteur de requ\00EAtes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156489656306452)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9tablir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156064859306451)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155993859306451)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les num\00E9ros de ligne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155427398306451)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher la r\00E8gle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860121017306214)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'fr'
,p_message_text=>'Afficher les suggestions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155739301306451)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille de tabulation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102155578203306451)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860070490306214)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859987692306214)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonc\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859761904306214)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'fr'
,p_message_text=>unistr('Contraste \00E9lev\00E9 fonc\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859844887306214)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'fr'
,p_message_text=>'Clair'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859690859306213)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'fr'
,p_message_text=>'Transformer la casse du code'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156513080306452)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859465544306213)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859580958306213)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156122944306451)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'fr'
,p_message_text=>'Valider'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102156620113306452)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Validation effectu\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859380659306213)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les caract\00E8res non imprimables')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262841278305760)
,p_name=>'COLLAPSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894410603305461)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'fr'
,p_message_text=>'Combinaison de couleurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083854013305609)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'fr'
,p_message_text=>'Analogique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083448277305609)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'fr'
,p_message_text=>unistr('Compl\00E9mentaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084014622305609)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleurs compl\00E9mentaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083985620305609)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'fr'
,p_message_text=>'Monotone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083559394305609)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'fr'
,p_message_text=>unistr('Fractionnement compl\00E9mentaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083764101305609)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9trade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083631271305609)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'fr'
,p_message_text=>'Triade'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071850965306385)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Nom d''affichage : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255313976305754)
,p_name=>'COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de colonne'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443562913305895)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Tous les utilisateurs authentifi\00E9s peuvent acc\00E9der \00E0 cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443678036305895)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Seuls les utilisateurs d\00E9finis dans la liste de contr\00F4le d''acc\00E8s de l''application peuvent acc\00E9der \00E0 l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443739738305895)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de param\00E8tre de contr\00F4le d''acc\00E8s inattendue : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887566339305455)
,p_name=>'COMING_SOON'
,p_message_language=>'fr'
,p_message_text=>unistr('Bient\00F4t disponible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255803480305754)
,p_name=>'COMMENT'
,p_message_language=>'fr'
,p_message_text=>'Commentaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124829520305639)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'fr'
,p_message_text=>unistr('La compilation a \00E9chou\00E9, ligne <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456070340305904)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'fr'
,p_message_text=>unistr('La compilation a \00E9chou\00E9, ligne %0 (%2). Les num\00E9ros de ligne associ\00E9s aux erreurs de compilation concernent la premi\00E8re instruction BEGIN. Seule la compilation des d\00E9clencheurs de base de donn\00E9es est affect\00E9e.<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124750438305639)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le code PL/SQL a \00E9t\00E9 compil\00E9 avec succ\00E8s (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322499828305805)
,p_name=>'COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329407893305810)
,p_name=>'COMPLETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336316171305815)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9/Aucun probl\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371116357305841)
,p_name=>'COMPONENT'
,p_message_language=>'fr'
,p_message_text=>'Composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499252229305936)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Nom du composant : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690216494306086)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Composant non activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986440925305534)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Le composant a \00E9t\00E9 cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069509366306383)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif de composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934994053305495)
,p_name=>'COMPUTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Calculs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393391618305857)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Les composants d''application ont \00E9t\00E9 install\00E9s.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125344495305639)
,p_name=>'CONDITIONAL'
,p_message_language=>'fr'
,p_message_text=>'Conditionnel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241030093305743)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315205659305800)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'fr'
,p_message_text=>'toujours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046812127305580)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046273000305580)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046336060305580)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E9l\00E9ment/colonne = valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046441624305580)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E9l\00E9ment/colonne NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860498628306214)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E9l\00E9ment/colonne NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046924426305580)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'fr'
,p_message_text=>'jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047015191305581)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'fr'
,p_message_text=>'aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046671071305580)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'fr'
,p_message_text=>'page dans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046729319305580)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'fr'
,p_message_text=>'la page n''est pas dans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046543921305580)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'fr'
,p_message_text=>'demande=e1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057979785305588)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de condition'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278287140305771)
,p_name=>'CONFIRM'
,p_message_language=>'fr'
,p_message_text=>'Confirmer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847356632305426)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Deux pages ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847269901305425)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Trois pages ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032791055305570)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom r\00E9el')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322217894305805)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''agr\00E9gation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322354908305805)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctions d''agr\00E9gation \00E0 utiliser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030102959305568)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043666765305578)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043721957305578)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'fr'
,p_message_text=>unistr('Langue par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043545541305578)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940515284305500)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Arborescence de r\00E9sultats \00E0 communiquer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940668199305500)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de r\00E9sultats \00E0 communiquer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043861221305578)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'fr'
,p_message_text=>'Authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497320153305934)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'fr'
,p_message_text=>'Branchement sur une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246551777305747)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de section (BREAK)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032585916305570)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'fr'
,p_message_text=>'Branchement de bouton %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032463921305570)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''affichage du bouton %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867834053305441)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer l''ajout de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867736194305441)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer la fonction de glisser-d\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445878473305897)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'fr'
,p_message_text=>'Annuler le branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497117138305934)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 du bouton Annuler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489234478305929)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'fr'
,p_message_text=>'Distinction maj/min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123203680305638)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 \00E0 modifier la requ\00EAte d''\00E9tat interactif. Si vous avez enlev\00E9 des colonnes de la requ\00EAte, les filtres, les r\00E8gles de mise en \00E9vidence et autres param\00E8tres d''\00E9tat r\00E9f\00E9ren\00E7ant ces colonnes seront d\00E9sactiv\00E9s. Validez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033679540305571)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'fr'
,p_message_text=>'Axe de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382481852305849)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'fr'
,p_message_text=>'A cadran'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382545097305849)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'fr'
,p_message_text=>unistr('A cadran (\00E0 secteurs)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034385580305571)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'fr'
,p_message_text=>'A barres horizontales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034516653305571)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'fr'
,p_message_text=>'A courbes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033863097305571)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Masque num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034414936305571)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'fr'
,p_message_text=>'A secteurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033589866305571)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte de graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033752894305571)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'fr'
,p_message_text=>'Echelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034640875305571)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'fr'
,p_message_text=>'En nuage de points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034137071305571)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034016384305571)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033977665305571)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034216348305571)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'fr'
,p_message_text=>'A barres verticales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940746466305500)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom d''ensemble de r\00E9sultats temporaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030940443305569)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246378307305747)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAtes de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409003475305869)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446077977305897)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'fr'
,p_message_text=>'Nom(s) de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043235809305578)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser le tri d''en-t\00EAtes de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167260982305671)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la copie d''une application avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041813995305577)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la copie d''une page avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031493565305569)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'fr'
,p_message_text=>unistr('Un nouveau jeu d''onglets, "%0", sera cr\00E9\00E9 et utilis\00E9 par cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043458007305578)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une application avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035915173305572)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page de calendrier avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039193095305575)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page d''\00E9tat d''analsye descendante avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092081643305615)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page d''\00E9tat interactif avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042193043305577)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page d''\00E9tat avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050508695306369)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une application de base de donn\00E9es utilisant le m\00EAme ID qu''une application de base de donn\00E9es existante dans l''espace de travail en cours. L''application de base de donn\00E9es existante sera supprim\00E9e et remplac\00E9e par la n')
||unistr('ouvelle application de base de donn\00E9es. Confirmez vos s\00E9lections. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405914226305866)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation de pages de panneau et de vue de liste avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321995271305805)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page de panneau et d''une page d''\00E9tat avec des pages d''analyse. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035510841305572)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''un panneau sur une requ\00EAte SQL avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035419155305572)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''un panneau sur une proc\00E9dure stock\00E9e avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035371554305572)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''un panneau sur une page de table avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911099866305474)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''un panneau sur une page de r\00E9f\00E9rence de service Web avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951232026305508)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''un panneau et d''un \00E9tat sur une page de r\00E9f\00E9rence de service Web avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349541277305825)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page Carte avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100844981712305424)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation de pages ma\00EEtre-d\00E9tail avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037111699305573)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une r\00E9gion de chemin de navigation et d''une option de chemin de navigation avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328290057305809)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un mode')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035161970305572)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099524898306406)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099696318306406)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un nom de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037996059305574)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation de pages de panneau et d''\00E9tat avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046467835306366)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041951668305577)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page d''\00E9tat avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035641291305572)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page de graphique \00E0 barres HTML avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041560150305577)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page r\00E9capitulative avec les attributs suivants. Cliquez sur le bouton Ajouter d''autres pour ajouter d''autres \00E9l\00E9ments provenant d''autres pages et/ou d''autres r\00E9gions. Cliquez sur Fin pour cr\00E9er les \00E9l\00E9ments r\00E9capi')
||'tulatifs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035758530305572)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page de graphique SVG avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035021377305572)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page de panneau tabulaire avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036237796305573)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une page d''arborescence avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101035249543305572)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''un assistant avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050471195306369)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une application Web utilisant le m\00EAme ID qu''une application Web existante dans l''espace de travail en cours. L''application Web existante sera supprim\00E9e et remplac\00E9e par la nouvelle application Web. Confirmez vos s\00E9lect')
||'ions. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243059535305745)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de lien')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987129703306321)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de d\00E9finition de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057513008306374)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette d\00E9finition de chargement des donn\00E9es sera recr\00E9\00E9e avec les recherches de table et les r\00E8gles de transformation existantes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489313336305929)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036067907305573)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328326697305809)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''authentification par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034911948305572)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039828420305575)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''affichage de %0 d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847713549305426)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne(s) d''affichage d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041404999305576)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de chemin de navigation d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040657539305576)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Table d\00E9tail %0 - ORDER BY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039321536305575)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de d\00E9tail %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847642698305426)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Table d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039693825305575)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de table d\00E9tail %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039473594305575)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''onglet d\00E9tail %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446392075305897)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de t\00E9l\00E9chargement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033078476305570)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408709168305869)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de t\00E9l\00E9chargement 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408808382305869)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de t\00E9l\00E9chargement 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037334274305573)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107189937306412)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Modifier une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107277563306412)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Modifier le nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232923245305737)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Sortie CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233639282305738)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Sortie d''impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234259672305738)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer le tri d''en-t\00EAtes de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280177598305772)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Une r\00E9gion sera ajout\00E9e \00E0 la page Administration existante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445958439305897)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'fr'
,p_message_text=>'Terminer le branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038415991305574)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page de panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038530907305574)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de page de panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038749250305575)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''onglet de page de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038671963305574)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets de page de panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328466898305809)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Importer des composants partag\00E9s depuis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675235115306075)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclure le calendrier personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847954731305426)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclure l''\00E9tat ma\00EEtre ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041176470305576)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'fr'
,p_message_text=>'Inclure un chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032211598305570)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''information')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032345794305570)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte par d\00E9faut d''information')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911223245305474)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940973854305500)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940841022305500)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre de r\00E9gion de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034736038305572)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E9rer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032056394305569)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446276798305897)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne renvoy\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445161975305896)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne 1 de cl\00E9 de recherche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445207017305896)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445343933305897)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036164652305573)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408944766305869)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de la recherche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446185372305897)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Table de consultation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848030676305426)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9sentation ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847500459305426)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne(s) d''affichage ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847850329305426)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Atteindre l''enregistrement ma\00EEtre par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100847429100305426)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Table ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246444919305747)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Nombre maximal de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242886035305745)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Lignes par page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099115030305620)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037617748305574)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'fr'
,p_message_text=>'Lien de chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041279211305576)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'fr'
,p_message_text=>'Racine de chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037422274305574)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037774945305574)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte de chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913759306305476)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la mise \00E0 niveau du graphique HTML vers un nouveau graphique HTML5. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066189438306381)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la mise \00E0 niveau de jsTree vers une nouvelle arborescence. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023878459305563)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La mise \00E0 niveau des graphiques SVG sera r\00E9alis\00E9e avec les restrictions suivantes :  '),
'<ul>',
'<li>',
unistr('Seuls les formats num\00E9riques d\00E9finis dans les cha\00EEnes de format des axes seront migr\00E9s. Les formats de date et d''heure seront ignor\00E9s.'),
'</li>',
'<li>',
unistr('Les \00E9l\00E9ments de format num\00E9rique contenant les \00E9l\00E9ments suivants seront migr\00E9s :'),
'<br />',
'0, 9, D, G, , (virgule), . (point), $, C, L, FM',
'</li>',
'<li>',
unistr('Le libell\00E9 de chaque s\00E9rie du graphique Flash sera d\00E9termin\00E9 \00E0 partir de l''alias de colonne de chaque s\00E9rie.  '),
unistr('C''est l\00E0 une diff\00E9rence par rapport aux graphiques SVG, o\00F9 le libell\00E9 de chaque s\00E9rie \00E9tait d\00E9termin\00E9 \00E0 partir de l''attribut Nom de s\00E9rie.'),
'</li>',
'<li>',
unistr('Les graphiques \00E0 cadran Flash affichent les valeurs elles-m\00EAmes et non des pourcentages.'),
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987800810305535)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la mise \00E0 niveau du graphique SVG vers un graphique HTML5. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046209130306366)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044170907305578)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657520849306055)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste de menu de navigation'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339704069305818)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Une nouvelle page Administration sera ajout\00E9e, Page :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123447527305638)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Nouvelles colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032812301305570)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouveau mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496978747305934)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 du bouton Suivant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031380222305569)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun jeu d''onglets n''a \00E9t\00E9 s\00E9lectionn\00E9 pour cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031984709305569)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911303720305474)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de sortie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033284773305570)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030289922305568)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043970769305578)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030377706305568)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031223351305569)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039790637305575)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes d''affichage parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037828652305574)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041393777305576)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'fr'
,p_message_text=>'Colonne de chemin de navigation parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039912449305575)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'fr'
,p_message_text=>'Table parent - ORDER BY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039227317305575)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039560753305575)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de table parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031842309305569)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''onglet parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031799149305569)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123122781305638)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma d''analyse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129885596305643)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9ration de page partielle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497035482305934)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 du bouton Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031120154305569)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038805447305575)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243198746305745)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format de sortie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246675935305747)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de lien d''impression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243262392305745)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Impression d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033165776305570)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242901140305745)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032156383305570)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030452587305568)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037286293305573)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123351568305638)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes enlev\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038956739305575)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262973255305760)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Impl\00E9mentation d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038098264305574)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038146129305574)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038364352305574)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''onglet de page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101038240443305574)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>unistr('Jeu d''onglets de page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941153721305500)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941035730305500)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre de r\00E9gion d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042254462305577)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943616220305502)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de version de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042422201305577)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : HTML (standard)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042755027305577)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : aspect 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042853217305577)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : aspect 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122969442305638)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : aspect 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123093151305638)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : aspect 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941696255305500)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : aspect 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042520435305577)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : \00E9tat vertical')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042978722305578)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'fr'
,p_message_text=>'export : CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043034260305578)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'fr'
,p_message_text=>'export : XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042622724305577)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : \00E9tat vertical, aspect 1 (inclure les colonnes Null)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122711838305638)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : \00E9tat vertical, aspect 2 (exclure les colonnes Null)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122887385305638)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'fr'
,p_message_text=>unistr('valeur par d\00E9faut : \00E9tat vertical, aspect  2 (inclure les colonnes Null)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446407396305897)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de la r\00E8gle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446603175305897)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446737533305898)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de r\00E8gle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886388406305455)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 l''ex\00E9cution du script suivant. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037596587305574)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042348263305577)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'fr'
,p_message_text=>'Option de tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033427425305570)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129781452305643)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277824324305771)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Plusieurs pages seront cr\00E9\00E9es, \00E0 partir de la page :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101033344974305570)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de proc\00E9dure stock\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124676093305639)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de proc\00E9dure stock\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497225795305934)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 du bouton Fin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061552108306377)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Abonner le th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032614675305570)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom sugg\00E9r\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322056883305805)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'fr'
,p_message_text=>'Table/vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322121107305805)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capituler colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508360189305942)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'fr'
,p_message_text=>'Recherches de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030877192305569)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030728525305568)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608409793306019)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E8gle de transformation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446846577305898)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E8gles de transformation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123665720305638)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de table/vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123592423305638)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de table/vue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044014795305578)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'fr'
,p_message_text=>'Onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031658992305569)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement, les informations de jeu d''onglets sont incompl\00E8tes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030640671305568)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''onglet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101042099833305577)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''onglet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030571257305568)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043115106305578)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('mod\00E8le :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036808731305573)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Bas\00E9e sur un nouvel \00E9l\00E9ment avec liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036536680305573)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'fr'
,p_message_text=>'Nombre maximum de niveaux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036359386305573)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036729434305573)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte d''arborescence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036966332305573)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('A partir d''une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036601039305573)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'fr'
,p_message_text=>unistr('Arborescence de d\00E9part')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101037035678305573)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101036447763305573)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type d''arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044281446305579)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044339226305579)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'fr'
,p_message_text=>'Bleu et ocre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044467556305579)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'fr'
,p_message_text=>'Rouge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044559813305579)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu fonc\00E9 et gris clair')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044625620305579)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'fr'
,p_message_text=>'Marron clair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044709567305579)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'fr'
,p_message_text=>unistr('Rouge fonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044862079305579)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'fr'
,p_message_text=>'Bleu et Ocre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101044902437305579)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'fr'
,p_message_text=>'Bleu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045003053305579)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031028103305569)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes modifiables'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101034814931305572)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101031531727305569)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'fr'
,p_message_text=>'Cette page utilisera le jeu d''onglets existant "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911137373305474)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rence de service Web, op\00E9ration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101039093431305575)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'fr'
,p_message_text=>'Clause WHERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312530207305798)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne de confirmation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322813813305805)
,p_name=>'CONFIRMED'
,p_message_language=>'fr'
,p_message_text=>unistr('Confirm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323129901305806)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'fr'
,p_message_text=>unistr('Confirm\00E9 par QA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243453124305745)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de section (BREAK)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243372423305745)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format d''impression'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350796981305826)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'fr'
,p_message_text=>'Disposition du contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383494601305850)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'fr'
,p_message_text=>unistr('Contenu trait\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161621146306458)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'fr'
,p_message_text=>'Contributeurs'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076293906306388)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'fr'
,p_message_text=>'Nouvel ID statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122540752305637)
,p_name=>'COPY_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Copier l''action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987622096305535)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application a \00E9t\00E9 copi\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101969884305622)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur au cours de l''ex\00E9cution de copy_button : %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167833250305671)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier les attributs de d\00E9finition d''objet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962782739305516)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'fr'
,p_message_text=>'Copier une application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406708375305867)
,p_name=>'COPY_FEATURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier la fonctionnalit\00E9 : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167412696305671)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548349190305973)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Bas\00E9 sur l''application mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167557238305671)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier \00E0 partir d''un nom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991406055305538)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier une entr\00E9e de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102384207305623)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur au cours de l''ex\00E9cution de copy_named_lov : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102234792305623)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'fr'
,p_message_text=>'L''ID de liste de valeurs (LOV) "%0" est introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102144940305622)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de liste de valeurs (LOV) "%0" n''est pas num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388228526305854)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier \00E0 partir d''une page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388334522305854)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Copier vers une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387338253305853)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une autorisation -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387284610305853)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une liste -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387189722305853)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une liste de valeurs -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451581275305901)
,p_name=>'COPY_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Copier %0 dans la table %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167696717305671)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Copier vers une application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167748458305671)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'fr'
,p_message_text=>'Copier vers un nom'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074327061305602)
,p_name=>'CORE'
,p_message_language=>'fr'
,p_message_text=>'principal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517392754305949)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517482407305949)
,p_name=>'CREATE OBJECT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un objet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406464828305867)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9\00E9 au cours des 7 derniers jours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962822509305516)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('A partir d''un mod\00E8le d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989924883306323)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'fr'
,p_message_text=>'Graphiques en chandelier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989706593306323)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphiques \00E0 colonnes 2D et 3D, \00E0 barres et \00E0 barres empil\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990456664306323)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphiques \00E0 cadran (pourcentage)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989831571306323)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphiques \00E0 secteurs et en anneau 2D et 3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990122251306323)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'fr'
,p_message_text=>'Graphiques de Gantt des projets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990306908306323)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphiques \00E0 plages 2D et 3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990294890306323)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'fr'
,p_message_text=>'Graphiques de Gantt de ressources'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990000965306323)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'fr'
,p_message_text=>'Graphiques en nuage de points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067716539305597)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'fr'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067590279305597)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('Fl\00E8che vers le bas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067656533305597)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Fl\00E8che vers la droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067380403305595)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067497260305596)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'fr'
,p_message_text=>'Conditions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067882384305597)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'fr'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067921019305597)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Aper\00E7u de condition')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407184236305867)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur le bouton Accorder des privil\00E8ges, ci-dessous, pour accorder ces privil\00E8ges maintenant \00E0 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406959107305867)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ne dispose pas du privil\00E8ge CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE ou CREATE PROCEDURE, et ne pourra pas installer l''application de d\00E9monstration.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407007328305867)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 ne dispose pas de privil\00E8ge d''ex\00E9cution sur CTX_DOC et CTX_DDL, et ne pourra pas installer la d\00E9monstration de l''allocution d''ouverture pr\00E9sidentielle. Affectez les autorisations suivantes en tant qu''utilisateur privil\00E9gi\00E9 : '),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650968321306050)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un bouton - Bo\00EEte de dialogue ferm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883737915305453)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une liste dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124453885305639)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une liste de valeurs (LOV) dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861741959305436)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'fr'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900852340305465)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542019568305966)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Authentification Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407579131305868)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'fr'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046357839306366)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste de menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542107353305966)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Aucune authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541725976305966)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'fr'
,p_message_text=>'Aucun onglet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541889932305966)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'fr'
,p_message_text=>'Un niveau d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407604088305868)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'fr'
,p_message_text=>unistr('SSO (Acc\00E8s avec connexion unique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541979087305966)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'fr'
,p_message_text=>'Deux niveaux d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962663671305516)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'fr'
,p_message_text=>'A partir d''une feuille de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856346832305432)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les composants de la page globale sont affich\00E9s sur toutes les pages si le point d''affichage de leur r\00E9gion est contenu dans le mod\00E8le de page s\00E9lectionn\00E9. Les attributs d''affichage conditionnel peuvent servir \00E0 supprimer l''affichage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093058670305616)
,p_name=>'CREATE_INDEX'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un index')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266305295305762)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('aucune r\00E9gion associ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074021322305602)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ez une nouvelle page de connexion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069418737305599)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0 l''assistant Cr\00E9ation de table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068950096305598)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'fr'
,p_message_text=>'Parcourir un package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068831380305598)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le package "%0" a \00E9t\00E9 cr\00E9\00E9 dans le sch\00E9ma "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069519379305599)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la cr\00E9ation de la table "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069309614305599)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069180664305598)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069297918305598)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069050180305598)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil de SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064649668305593)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun \00E9l\00E9ment trouv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064258355305593)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064580652305593)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Invite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064332147305593)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064451703305593)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('cliquez ici pour d\00E9finir une r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062323481305592)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062469153305592)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068780936305598)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068595850305598)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068477185305598)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter un script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068196865305598)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le script de cr\00E9ation de la table %0 a \00E9t\00E9 cr\00E9\00E9 dans le r\00E9f\00E9rentiel de scripts SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068211585305598)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der au r\00E9f\00E9rentiel de scripts')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068650664305598)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101068381512305598)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil de SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497939584305935)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau tabulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064114559306379)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une t\00E2che \00E0 effectuer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452144562305902)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er le d\00E9clencheur %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398442211305861)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets de base de donn\00E9es de feuille Web cr\00E9\00E9s.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101352978262305827)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire des informations d''identification')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317315915305801)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240729514305743)
,p_name=>'CURRENT'
,p_message_language=>'fr'
,p_message_text=>'En cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309853121305796)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309535331305796)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de panneau en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084198569305610)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''aide sur un \00E9l\00E9ment en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309695830305796)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro d''identification d''\00E9l\00E9ment en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309718419305796)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de libell\00E9 d''\00E9l\00E9ment en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365485136305837)
,p_name=>'CURRENT TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050736973305583)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057523976305588)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591078224306006)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID pouvant \00EAtre utilis\00E9 sur un \00E9l\00E9ment de conteneur qui encapsule le champ en cours, dans l''attribut Avant le libell\00E9 et l''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068826602306383)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''aide sur un \00E9l\00E9ment en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019247553305560)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'fr'
,p_message_text=>'Jalon en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056607368305587)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334143420305814)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours ne contient pas d''\00E9l\00E9ments.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305497542305793)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'fr'
,p_message_text=>'Personnaliser un lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865007171306218)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications personnalis\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882639844305452)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppeur d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097833078305619)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019405489305560)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez votre ID utilisateur (n''importe quelle cha\00EEne) pour cette session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019528743305560)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'fr'
,p_message_text=>'Saisissez votre nom utilisateur et votre mot de passe %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019678351305560)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez votre nom utilisateur et votre mot de passe pour v\00E9rification par l''h\00F4te LDAP : %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019777781305560)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez votre nom utilisateur et votre mot de passe de sch\00E9ma de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675543364306076)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Recharger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680532671306079)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'fr'
,p_message_text=>'Date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680470465306079)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453032856305902)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Lorsque l''action True est D\00E9finir une valeur et que le type d\00E9fini est Instruction SQL, vous devez d\00E9finir les \00E9l\00E9ments affect\00E9s dans le m\00EAme ordre que celui de la colonne de l''instruction SQL. L''instruction SQL que vous avez d\00E9finie \00E9tait la suiv')
||'ante :</p>',
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250621882305750)
,p_name=>'DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516985510305948)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>unistr('Atelier de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105777312305625)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les %0 colonnes ont toutes \00E9t\00E9 automatiquement mises en correspondance avec la table %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106542227305626)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('<b id="incompl_success_row_count"></b> nouvelles lignes ont \00E9t\00E9 ajout\00E9es \00E0 la fin des donn\00E9es de la table <code>%0</code>. <b class="u-danger-text" id="incompl_fail_row_count"></b> lignes ont \00E9t\00E9 rejet\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106160646305625)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('<b id="success_row_count"></b> nouvelles lignes ont \00E9t\00E9 ajout\00E9es \00E0 la fin des donn\00E9es de la table <code>%0</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106305668305625)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('<b id="err_success_row_count"></b> nouvelles lignes ont \00E9t\00E9 ajout\00E9es \00E0 la fin des donn\00E9es de la table <code>%0</code>. <b class="u-danger-text" id="err_fail_row_count"></b> lignes ont \00E9t\00E9 rejet\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858873691305434)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un fichier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853438406305430)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mapping de colonne doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896431233305462)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Configuration enregistr\00E9e.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858425819305434)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Profil de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858552054305434)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes de profil de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857894274305433)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105836379305625)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez le mapping de colonne afin de charger ces donn\00E9es dans la table %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858358905305434)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858726431305434)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'fr'
,p_message_text=>unistr('Glisser et d\00E9placer le fichier ici ou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858684516305434)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'fr'
,p_message_text=>'Formats pris en charge : CSV, XLSX, TXT, XML, JSON'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514997837305947)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ex\00E9cution du travail de chargement des donn\00E9es s''est arr\00EAt\00E9e de mani\00E8re inattendue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457870780305906)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Travail de chargement des donn\00E9es dans l''espace de travail %0 : chargement dans la table %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858022586305434)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichier charg\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105936108305625)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 colonnes sur %1 ont \00E9t\00E9 automatiquement mises en correspondance avec la table %2. Configurez les %3 colonnes restantes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496010430305933)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es coll\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106621750305626)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es de la table <code>%0</code> ont \00E9t\00E9 remplac\00E9es par <b id="incompl_success_row_count"></b> nouvelles lignes. <b class="u-danger-text" id="incompl_fail_row_count"></b> lignes ont \00E9t\00E9 rejet\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106291900305625)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es de la table <code>%0</code> ont \00E9t\00E9 remplac\00E9es par <b id="success_row_count"></b> nouvelles lignes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106469157305625)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es de la table <code>%0</code> ont \00E9t\00E9 remplac\00E9es par <b id="err_success_row_count"></b> nouvelles lignes. <b class="u-danger-text" id="err_fail_row_count"></b> lignes ont \00E9t\00E9 rejet\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101106034266305625)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez les colonnes \00E0 charger.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838937736305419)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'fr'
,p_message_text=>'Formats pris en charge %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857991637305433)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger un fichier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858144888305434)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'fr'
,p_message_text=>'Feuille de calcul XLSX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058256557306375)
,p_name=>'DATABASE'
,p_message_language=>'fr'
,p_message_text=>unistr('Base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517582361305949)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'fr'
,p_message_text=>unistr('Navigateur de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003359435306334)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Application de base de donn\00E9es \00E9chantillon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058327329306375)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Application de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902391222305467)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917917785305479)
,p_name=>'DATABASE_APPS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393156299305857)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application <strong>%0</strong> a \00E9t\00E9 install\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295853367305784)
,p_name=>'DATABASE_LINK'
,p_message_language=>'fr'
,p_message_text=>unistr('Lien de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345375355305822)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre d''objets de base de donn\00E9es par type d''objet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348598416305824)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ges de r\00F4le de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913657447305475)
,p_name=>'DATABASE_USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447341123305898)
,p_name=>'DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993217348306325)
,p_name=>'DATA_GRIDS'
,p_message_language=>'fr'
,p_message_text=>unistr('Grilles de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993687606306326)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es de grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980156953306316)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres avanc\00E9s de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993384755305539)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formats date/nombre \00E0 utiliser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993400996305539)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez de fournir des masques de format personnalis\00E9s ou d''en utiliser des standard.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914024981305476)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'fr'
,p_message_text=>unistr('Jeu de caract\00E8res de fichier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506734968305941)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'fr'
,p_message_text=>'Noms de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391274226305856)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'fr'
,p_message_text=>'Alias de noms de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646128644306047)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es ont \00E9t\00E9 t\00E9l\00E9charg\00E9es vers la table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651682094306051)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'fr'
,p_message_text=>'Copier/coller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640554755306043)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier/coller les donn\00E9es d\00E9limit\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022646553306348)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Symbole mon\00E9taire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022795171306349)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Si vos donn\00E9es contiennent un symbole mon\00E9taire international, saisissez-le ici. Par exemple, si vos donn\00E9es comportent "&euro;1,234.56" ou "&yen;1,234.56", saisissez "&euro;" ou "&yen;". Si vous ne le faites pas, les donn\00E9es ne se chargeront pas cor')
||'rectement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918799827305479)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980258894306316)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'fr'
,p_message_text=>'Utiliser les masques de format d''application standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980310644306316)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquer des formats personnalis\00E9s pour les colonnes t\00E9l\00E9charg\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023946984306350)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La marque d\00E9cimale s\00E9pare la partie enti\00E8re de la partie d\00E9cimale des nombres.</p>'),
unistr('<p>La marque d\00E9cimale peut \00EAtre tout caract\00E8re mono-octet diff\00E9rent du s\00E9parateur de groupes. Ce peut \00EAtre un espace mais non un caract\00E8re num\00E9rique, ni aucun des caract\00E8res suivants :</p>'),
'<ul class="noIndent">',
'<li>plus (+)</li>',
'<li>tiret (-)</li> ',
unistr('<li>signe inf\00E9rieur (<)</li>'),
unistr('<li>signe sup\00E9rieur (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023099373306349)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Marque d\00E9cimale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021995462305562)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Un caract\00E8re d\00E9cimal est requis si un s\00E9parateur de groupes est d\00E9fini pour la colonne de table %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391418456305856)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457977009305906)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'fr'
,p_message_text=>'Plusieurs colonnes source sont mises en correspondance avec la colonne de table %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789305135306160)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes en \00E9chec :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004712483306335)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrements en \00E9chec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022209075306348)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom du fichier \00E0 t\00E9l\00E9charger vers le serveur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648769061306049)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('La premi\00E8re ligne contient des noms de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022364712306348)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cochez cette case si la premi\00E8re ligne des donn\00E9es contient des noms de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022593882306348)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'fr'
,p_message_text=>'Globalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022950180306349)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le s\00E9parateur de groupes est un caract\00E8re qui s\00E9pare les groupes d''entiers, par exemple les milliers et les millions.</p>'),
unistr('<p> Il peut \00EAtre repr\00E9sent\00E9 par n''importe quel caract\00E8re. Le caract\00E8re indiqu\00E9 doit \00EAtre mono-octet, et le s\00E9parateur de groupes doit \00EAtre diff\00E9rent de toute marque d\00E9cimale. Le caract\00E8re peut \00EAtre un espace, mais il ne peut pas \00EAtre repr\00E9sent\00E9 par u')
||unistr('n caract\00E8re num\00E9rique ni l''un des caract\00E8res suivants :</p>'),
'<ul class="noIndent">',
'<li>signe plus (+)</li>',
'<li>trait d''union (-)</li> ',
'<li>symbole plus petit que (<)</li>',
'<li>symbole plus grand que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022818564306349)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur de groupes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789130370306160)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes ins\00E9r\00E9es :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019743902306346)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette requ\00EAte renvoie plus de #MAX_ROW_COUNT# lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390111141305855)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrements modifi\00E9s par un autre utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013352971305554)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'fr'
,p_message_text=>'Distinction maj/min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013247853305554)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne unique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612213647306022)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec du chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612317951306022)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Action trait\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636357864306040)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('Importer \00E0 partir de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445552832305897)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Etape 2 - Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070607927306384)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun aper\00E7u de fichier disponible')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021406134306348)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Eventuellement d\00E9limit\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983652177306318)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Progression de l''assistant Chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445740811305897)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Etape 4 - Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391348516305856)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'fr'
,p_message_text=>'Renvoyer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389602405305855)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne(s) \00E0 r\00E9viser :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503879832305939)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate)',
'',
'my_func (',
'    p_1 => :SAL,',
'    p_2 => :COMM)',
'',
unistr('o\00F9 SAL et COMM sont les noms de colonne des donn\00E9es t\00E9l\00E9charg\00E9es'),
'et my_func est la fonction qui renvoie la nouvelle valeur',
unistr('de la colonne pour laquelle cette r\00E8gle de transformation est d\00E9finie.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504069184305939)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
unistr('Le r\00E9sultat renvoy\00E9 sera la nouvelle valeur de la colonne pour laquelle cette r\00E8gle de transformation est d\00E9finie.'),
'',
unistr(':SAL et :COMM renvoient aux noms de colonne SAL et COMM des donn\00E9es t\00E9l\00E9charg\00E9es.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503959518305939)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select depno',
' from dept',
'where dname = :DEPTNAME',
'  and loc   = :LOC',
'',
unistr('o\00F9 :DEPNAME et :LOC renvoient aux noms de colonne DEPNAME et LOC des donn\00E9es t\00E9l\00E9charg\00E9es.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101030097962305568)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'fr'
,p_message_text=>unistr('Dans la colonne de table %0, le m\00EAme caract\00E8re ne peut pas \00EAtre d\00E9fini comme s\00E9parateur de groupes et caract\00E8re d\00E9cimal. Entrez d''autres caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021290502306347)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifiez le caract\00E8re s\00E9parateur de colonnes. Utilisez <code>\005Ct</code> pour une s\00E9paration par des tabulations.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021301594306347)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391506217305856)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979900333306315)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser les param\00E8tres avanc\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980013477306315)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les param\00E8tres avanc\00E9s pour le chargement des donn\00E9es : Symbole mon\00E9taire, Caract\00E8res d\00E9cimaux, Encodage de fichier ou Formats de date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656270233306054)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445440884305897)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Etape 1 - Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058543282306375)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'fr'
,p_message_text=>'(\t pour tabulation)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020057585306347)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne unique %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789242174306160)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes mises \00E0 jour :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099825499306407)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur NULL a \00E9t\00E9 t\00E9l\00E9charg\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651585209306051)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger un fichier vers le serveur (d\00E9limitation par des virgules (*.csv) ou des tabulations)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656497307306054)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656355157306054)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Validation des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445615876305897)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Etape 3 - Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449782599305900)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Les pages de l''assistant Chargement des donn\00E9es ont \00E9t\00E9 cr\00E9\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612436618306022)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec du mapping de table/donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612559590306022)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Action trait\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318566846305802)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'fr'
,p_message_text=>unistr('Mapping de colonne de t\00E9l\00E9chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101043322103305578)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de colonne : colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905125811305469)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Caract\00E8re d\00E9cimal : colonne %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905328792305469)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>'Masque de format : colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905292402305469)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur de groupes : colonne %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905526520305469)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Mettre en correspondance avec : colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092475497305616)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'fr'
,p_message_text=>'Longueur maximale : colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905428733305469)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'fr'
,p_message_text=>'- Colonne non mise en correspondance -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438660110305891)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''attribut de date mise en \00E9vidence %0 saisie pour l''\00E9l\00E9ment %1 ne correspond pas au format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443806263305895)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''attribut de date mise en \00E9vidence %0 saisie pour l''\00E9l\00E9ment %1 n''est pas une date relative.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438882909305891)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''attribut de date maximale %0 saisie pour l''\00E9l\00E9ment %1 ne correspond pas au format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444041098305896)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''attribut de date maximale %0 saisie pour l''\00E9l\00E9ment %1 n''est pas une date relative.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856102125305432)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur d''attribut statique maximal %0 saisie pour l''\00E9l\00E9ment %1 ne correspond pas au format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438798685305891)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''attribut de date minimale %0 saisie pour l''\00E9l\00E9ment %1 ne correspond pas au format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443977007305895)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''attribut de date minimale %0 saisie pour l''\00E9l\00E9ment %1 n''est pas une date relative.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856011108305432)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur d''attribut statique minimal %0 saisie pour l''\00E9l\00E9ment %1 ne correspond pas au format %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545937646305969)
,p_name=>'DATE_ADDED'
,p_message_language=>'fr'
,p_message_text=>'Date d''ajout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990678832306323)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'fr'
,p_message_text=>unistr('Travaux de base de donn\00E9es Oracle APEX avec l''heure de leur derni\00E8re ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368462998305839)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'fr'
,p_message_text=>'jusqu''au jalon final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368511920305839)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'fr'
,p_message_text=>'jusqu''au jalon final de version %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443258336305894)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une classe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996060648306328)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'fr'
,p_message_text=>'Alerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994814664306327)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement d''annulation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996213514306328)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'fr'
,p_message_text=>'Effacer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996116769306328)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>'Confirmer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835590690305417)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Annuler la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835635792305417)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fermer la bo\00EEte de dialogue')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987529442305535)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987416795305535)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'fr'
,p_message_text=>'Activer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987771220306321)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter le code PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987323351305535)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'fr'
,p_message_text=>'Masquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363702474305835)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter le code JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617994717306026)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443312331305895)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'fr'
,p_message_text=>'Enlever la classe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443489624305895)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le style')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600895143306014)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le domaine d''attention')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363698797305835)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir une valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987203704305535)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600939604306014)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Soumettre une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582483378306000)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire l''arborescence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582320335306000)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper l''arborescence')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100884831399305453)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte de base de donn\00E9es')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360382446305833)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Les noms de table et de colonne de base de donn\00E9es respectent les majuscules et les minuscules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460061653305907)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('exception de cr\00E9ation d''objet de BdD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898493658305464)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'fr'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048764127306368)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045475026306366)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'fr'
,p_message_text=>'Tous les types MIME'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048412602306368)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un gestionnaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045798988306366)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une m\00E9thode')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045575146306366)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045655928306366)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052641859306371)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'fr'
,p_message_text=>'Module de service RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048359558306368)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'fr'
,p_message_text=>'Gestionnaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053192751306371)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Variable attach\00E9e de gestionnaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025502368306351)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode de gestionnaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053431451306371)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'fr'
,p_message_text=>'Source de gestionnaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025604782306351)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de source de gestionnaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045223684306365)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052765339306371)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de module'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053222841306371)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe d''URI de module')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045828983306366)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'fr'
,p_message_text=>'Aucune source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045186114306365)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052927422306371)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'fr'
,p_message_text=>'Services RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045374513306365)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053341410306371)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''URI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025494085306351)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'fr'
,p_message_text=>'URI (Uniform Resource Identifier)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052439442306371)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe d''URI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052572637306371)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''URI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025704532306351)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte sur une ligne')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269658674305765)
,p_name=>'DEBUG'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9boguer')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376080446305845)
,p_name=>'DECLINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Refus\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098319597306405)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de bouton de bo\00EEte de dialogue par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098266339306405)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de contenu de bo\00EEte de dialogue par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613140407306023)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Page par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255409219305754)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('tablespace par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257062695305755)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Tablespace par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505559484305940)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le par d\00E9faut')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880894716305450)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini par une action dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671839480306073)
,p_name=>'DEFINED_TABS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette application contient %0 onglets, organis\00E9s en %1 ensembles, et comprend %2 onglets parent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124374232305639)
,p_name=>'DEFINE_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir une liste de valeurs (LOV)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305500619305793)
,p_name=>'DEFINITION'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457739097305906)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Script de d\00E9sinstallation')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976074011305526)
,p_name=>'DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992771547306325)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Supprimer une application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498042395305935)
,p_name=>'DELETE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Supprimer : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101490254947305929)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Supprimer %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908003761305471)
,p_name=>'DELETE_MSG'
,p_message_language=>'fr'
,p_message_text=>'Voulez-vous effectuer cette action de suppression ?'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932335078305492)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'fr'
,p_message_text=>unistr('La vitrine de collections vous permet de stocker des lignes de donn\00E9es afin de les utiliser dans une session Oracle APEX. Cette application de base de donn\00E9es montre comment utiliser le code PL/SQL pour cr\00E9er et g\00E9rer les statuts de session bas\00E9s sur')
||' une collection.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932173882305492)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Application \00E9chantillon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932248195305492)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'fr'
,p_message_text=>unistr('Product Portal est une application \00E9chantillon mettant en \00E9vidence des notions de conception standard. Elle inclut des pages d\00E9di\00E9es aux clients, aux produits et aux commandes, et indique comment utiliser les \00E9tats, les graphiques, les calendriers, l')
||'es cartes et les arborescences.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326431705305808)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9montrable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053118101305585)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemples d''\00E9tats structur\00E9s et de concepts de pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052896095305585)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple de magasin en ligne cr\00E9\00E9 \00E0 l''aide de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053504488305585)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9couvrez l''utilisation d''Oracle Text avec %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053921637305586)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple d''application de suivi de statut de projet cr\00E9\00E9e avec %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053396268305585)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'fr'
,p_message_text=>unistr('Apprenez \00E0 utiliser les services Web avec %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051776072305584)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049672247305582)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049369955305582)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'fr'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053098585305585)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'fr'
,p_message_text=>'Aspect professionnel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051861570305584)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'fr'
,p_message_text=>'Vitrine de collections'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049476886305582)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'fr'
,p_message_text=>'CONTEXT INDEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048833790305582)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de cr\00E9er l''application de d\00E9mo Exemples de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047485997305581)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de (re)cr\00E9er l''application de d\00E9monstration d''aspect professionnel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048931873305582)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de cr\00E9er l''application de d\00E9mo Vitrine de collections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049071965305582)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er ou recr\00E9er dans le sch\00E9ma %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047348253305581)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ez un exemple d''application pour pr\00E9senter les services Web.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047545585305581)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point de cr\00E9er l''application de d\00E9monstration Fans de la coupe du monde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888546392305456)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051538322305584)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Application de d\00E9mo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049931962305583)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'fr'
,p_message_text=>'Il vous reste environ %0 Mo d''espace libre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052377365305584)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'fr'
,p_message_text=>'Installer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052097060305584)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Install\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184021408305683)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point d''installer l''application \00E9chantillon, qui pr\00E9sente les principales fonctionnalit\00E9s de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052917520305585)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'fr'
,p_message_text=>'Installer maintenant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051956749305584)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9couvrez les concepts du chariot d''achats %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493000132305931)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049779245305582)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'fr'
,p_message_text=>unistr('La d\00E9monstration de l''allocution d''ouverture pr\00E9sidentielle requiert environ 7 Mo d''espace disque libre ; son installation dans votre sch\00E9ma peut prendre jusqu''\00E0 deux minutes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183745746305683)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas assez d''espace pour cr\00E9er cette d\00E9monstration. Demandez de l''espace suppl\00E9mentaire en allant dans la page d''administration, dans les services de provisionnement, et en cliquant sur le lien permettant de demander de l''espace suppl\00E9mentair')
||'e. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052227455305584)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non install\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048231646305581)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'fr'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047145412305581)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048198445305581)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049256597305582)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'fr'
,p_message_text=>'Nom d''objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047248182305581)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'n''existe pas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047833030305581)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('S''ils existent d\00E9j\00E0, les objets de base de donn\00E9es suivants seront recr\00E9\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048054674305581)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type d''objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048731766305582)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'fr'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052769213305585)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'fr'
,p_message_text=>'Pet Store'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053401556305585)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Allocutions d''ouverture pr\00E9sidentielles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053720228305585)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'fr'
,p_message_text=>'Suivi de projet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260993711305758)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9installer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052120907305584)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101047938469305581)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048588943305582)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051616521305584)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048390037305581)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'fr'
,p_message_text=>'Table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051444035305584)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat Statut d''installation de l''application de d\00E9monstration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048661164305582)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencheur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493120339305931)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913840263305476)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise \00E0 jour disponible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071423866306385)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez corriger les objets non valides suivants pour pouvoir ex\00E9cuter les feuilles Web correctement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053253546305585)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'fr'
,p_message_text=>'Services Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050096905305583)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur risque de survenir si vous ne recr\00E9ez pas cette d\00E9monstration.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995006916305540)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas assez d''espace pour cr\00E9er cette d\00E9monstration. Demandez de l''espace suppl\00E9mentaire en allant dans la page d''administration et en cliquant sur le ligne Demander des modifications du service en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994938506305540)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application de d\00E9monstration %0 a \00E9t\00E9 cr\00E9\00E9e.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650360938306050)
,p_name=>'DEPRECATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Obsol\00E8te')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946051894305504)
,p_name=>'DERIVED$'
,p_message_language=>'fr'
,p_message_text=>unistr('colonne d\00E9riv\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326397497305808)
,p_name=>'DESIRABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rable')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399180256305861)
,p_name=>'DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455845239305904)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tails')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399245692305862)
,p_name=>'DETAIL_2'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tail 2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897442814305463)
,p_name=>'DEVELOPER'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461294037305908)
,p_name=>'DEVELOPERS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppeurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345936941305822)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif des activit\00E9s de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369771858305840)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854219152305431)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363040840305835)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519194894305950)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'fr'
,p_message_text=>'Effacer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519060342305950)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'fr'
,p_message_text=>'Copier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867455276306220)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'fr'
,p_message_text=>'Personnaliser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545336994305969)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9boguer (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544872294305968)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Niveau de d\00E9bogage par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545016294305968)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations (par d\00E9faut)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545160373305969)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'fr'
,p_message_text=>'Trace d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545270809305969)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'fr'
,p_message_text=>unistr('Trace compl\00E8te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854337709305431)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508267855305942)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'fr'
,p_message_text=>'Des erreurs se sont produites depuis le chargement de la page. Ouvrez la console JavaScript du navigateur pour afficher ces erreurs.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508435968305942)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'fr'
,p_message_text=>'Erreurs JavaScript'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867548006306220)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'fr'
,p_message_text=>'Modifier le logo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582084111305999)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette fonctionnalit\00E9 exige que la fen\00EAtre Application Express App Builder soit ouverte. Voulez-vous ouvrir App Builder dans cette fen\00EAtre ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578170820305997)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de la barre d''outils de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579887242305998)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'fr'
,p_message_text=>'Masquer automatiquement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580018144305998)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Position d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579970699305998)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les ic\00F4nes uniquement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580216689305998)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580178376305998)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'fr'
,p_message_text=>'A gauche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580369447305998)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'fr'
,p_message_text=>'A droite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581644684305999)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514149186305946)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'fr'
,p_message_text=>'Info'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514317080305947)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e des performances de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578210987305997)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Edition rapide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514247401305947)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e d''affichage de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079132064306391)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'fr'
,p_message_text=>'Theme Roller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579771504305998)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Barre d''outils de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320677841305804)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2che de d\00E9veloppement')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488925959305928)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Alerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488849745305928)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Elev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488781418305928)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur faible'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838040607305418)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'fr'
,p_message_text=>unistr('Groupes d''\00E9l\00E9ments de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920495895305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'Applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922805428305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922970281305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922047197305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921937466305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'fr'
,p_message_text=>'Chemins de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108547927306413)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921677213305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Calculs d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921820325305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922102094305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'fr'
,p_message_text=>'Listes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922290563305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922325222305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871626028305444)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922447620305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922540784305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barres de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920558080305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921539337305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'fr'
,p_message_text=>'Branchements'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920944117305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'fr'
,p_message_text=>'Boutons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295378670305784)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'fr'
,p_message_text=>'Graphiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295510160305784)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'fr'
,p_message_text=>'Axes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295456975305784)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921272900305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'fr'
,p_message_text=>'Calculs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962101193305516)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'fr'
,p_message_text=>'Actions dynamiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962240024305516)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'fr'
,p_message_text=>'Action dynamique - Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921031180305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gions de l''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921100960305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920753438305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921495889305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920669481305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861625727306215)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100920824709305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043631302306364)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'fr'
,p_message_text=>'Arborescences'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921335382305481)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'fr'
,p_message_text=>'Validations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922614024305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'fr'
,p_message_text=>'Onglets parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100921704140305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'fr'
,p_message_text=>'Processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069347732306383)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069684352306383)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Rapport sur les instructions de requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069209274306383)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAtes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018302586306345)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923063921305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'Raccourcis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918550436305479)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924528332305484)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'fr'
,p_message_text=>'Substitutions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108220350306413)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Objets de prise en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108316473306413)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'fr'
,p_message_text=>'Options de construction d''objets de prise en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924340896305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'fr'
,p_message_text=>'Prise en charge des objets/validations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924494552305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'fr'
,p_message_text=>'Prise en charge des objets/scripts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100922710307305482)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'fr'
,p_message_text=>'Onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923454058305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923514401305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923642513305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de calendrier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986930272305534)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de grille')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923735908305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923824999305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923948585305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924005390305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de liste de valeurs (LOV) intantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924154822305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100924211913305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923390735305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8mes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911902927305474)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859703728305435)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'fr'
,p_message_text=>unistr('Styles de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351161428305826)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'fr'
,p_message_text=>'Messages texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905746791305469)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'fr'
,p_message_text=>'Traductions dynamiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905873138305469)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'fr'
,p_message_text=>'Texte traduisible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923253213305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'fr'
,p_message_text=>'Arborescences'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100923152490305483)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'fr'
,p_message_text=>'Services Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035259788306358)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4les de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035336287306358)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateurs de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390357437305855)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('Affectation de r\00F4le utilisateur de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848830110305427)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'fr'
,p_message_text=>'Automatisations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849029853305427)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Automatisation - Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071141714306385)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers concat\00E9n\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876389475305447)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargements de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302858873305791)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'fr'
,p_message_text=>unistr('Profils d''analyse de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302945751305791)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes de profil d''analyse de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086520378306396)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Commentaires de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050209775306369)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608329204306019)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Table de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602612586306015)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'fr'
,p_message_text=>unistr('Tables de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602722867306015)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherches de table de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602814449306015)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E8gles de transformation de table de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866285157305440)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'fr'
,p_message_text=>'Pages de calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865202947305439)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'fr'
,p_message_text=>'Cartes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865361116305439)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions de carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579249238305997)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gions de grille interactive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579330505305997)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579452277305997)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'fr'
,p_message_text=>'Groupes de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840226248305420)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'fr'
,p_message_text=>'Cartes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840390790305420)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'fr'
,p_message_text=>'Couches de carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938192934305498)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'fr'
,p_message_text=>'Modules d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938279515305498)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349697563305825)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993152963305539)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940359508305499)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399406654305862)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9rateurs de filtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108458985306413)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049172554306368)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9tadonn\00E9es d''attribut standard de module d''extension')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302724109305789)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'fr'
,p_message_text=>'Serveurs SQL compatibles REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861595887306215)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108146964306413)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'fr'
,p_message_text=>unistr('Groupes d''options de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024435253306350)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'fr'
,p_message_text=>unistr('Groupe d''options de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077677250306390)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'fr'
,p_message_text=>'Positions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077721757306390)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'fr'
,p_message_text=>'Positions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991557317305538)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Points d''affichage de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918418238305479)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'fr'
,p_message_text=>'Interfaces utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303485499305791)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de source REST de composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303110071305791)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'fr'
,p_message_text=>unistr('Sources de donn\00E9es REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303217936305791)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9rations de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303314971305791)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303068726305791)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'fr'
,p_message_text=>'Serveurs distants de source REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849329600305427)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'fr'
,p_message_text=>'Etapes de synchronisation REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849211122305427)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal d''automatisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849484290305427)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal des messages d''automatisation'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051805352306370)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton Suivant d\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051785629306370)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton Pr\00E9c\00E9dent d\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452476853305902)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver le d\00E9clencheur %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057839094305588)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058063112305589)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte de condition d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498107803305935)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Ordre d''affichage : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944340925305503)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107849577306413)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'fr'
,p_message_text=>'Valeur d''affichage : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047131453306367)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047232872306367)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs distincts'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871337420305444)
,p_name=>'DML_FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau DML'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165591336305669)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'fr'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341739060305819)
,p_name=>'DOC_IMPACT'
,p_message_language=>'fr'
,p_message_text=>'Impact de la documentation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342973715305820)
,p_name=>'DOC_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut de documentation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343134893305820)
,p_name=>'DOC_WRITER'
,p_message_language=>'fr'
,p_message_text=>'Auteur de la documentation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230703009305736)
,p_name=>'DOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('Arr\00EAt\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350903828305826)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger le texte de lien')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165259645305669)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne pas mettre \00E0 jour les \00E9l\00E9ments d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165395418305669)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne pas mettre \00E0 jour les \00E9l\00E9ments d''entr\00E9e de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165474035305669)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne pas mettre \00E0 jour les \00E9l\00E9ments non modifiables')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165127245305669)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne pas mettre \00E0 jour les pages')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165955375305670)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne pas mettre \00E0 jour les \00E9l\00E9ments de page')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027984406305566)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'fr'
,p_message_text=>unistr('Glisser-d\00E9placer')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935729869305496)
,p_name=>'DRILLDOWN'
,p_message_language=>'fr'
,p_message_text=>'Analyse descendante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935622011305496)
,p_name=>'DRILLUP'
,p_message_language=>'fr'
,p_message_text=>'Analyse ascendante'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073282539305602)
,p_name=>'DRIVEN'
,p_message_language=>'fr'
,p_message_text=>unistr('pilot\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452279445305902)
,p_name=>'DROP TRIGGER'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer le d\00E9clencheur %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451319899305901)
,p_name=>'DROP_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Supprimer la colonne %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598722960306012)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598595493306012)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de variable attach\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598987132306012)
,p_name=>'DS_HANDLER'
,p_message_language=>'fr'
,p_message_text=>'Gestionnaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599381017306012)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Nombre de questions par page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599130294306012)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('Types MIME autoris\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599253436306012)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('Origines autoris\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598869113306012)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599421398306012)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Contrainte de s\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598653329306012)
,p_name=>'DS_SOURCE'
,p_message_language=>'fr'
,p_message_text=>'Source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599018573306012)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599554494306013)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe d''URI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598261478306012)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''URI')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069785977306384)
,p_name=>'DUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ech\00E9ance')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342788568305820)
,p_name=>'DUE_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date d''\00E9ch\00E9ance')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323242586305806)
,p_name=>'DUPLICATE'
,p_message_language=>'fr'
,p_message_text=>'Dupliquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047843708306367)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur en double dans la liste'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860166439305435)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860031106305435)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions dynamiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870231731305443)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976166943305527)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'fr'
,p_message_text=>'HTML dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026814676305566)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'fr'
,p_message_text=>'Etat interactif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853200494305430)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rence dynamique')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122637431305637)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('La condition que vous ajoutez rend la requ\00EAte non valide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864793889305439)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'fr'
,p_message_text=>'Modifier le groupe de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383399349305850)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Si vous choisissez OK, les modifications non enregistr\00E9es seront perdues.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896730548305462)
,p_name=>'EDIT_ALL'
,p_message_language=>'fr'
,p_message_text=>'Modifier tout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123811033305638)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier tous les attributs de d\00E9finition de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378275688305846)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier tous les \00E9l\00E9ments de cette r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308996807305795)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Modifier l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397900621305861)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>'Modifier un attribut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992970066306325)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'fr'
,p_message_text=>'Modifier l''authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387746858305853)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'fr'
,p_message_text=>'Modifier un composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398071798305861)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier une d\00E9finition de composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489420595305929)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Modifier %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397887983305861)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier une d\00E9finition de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061753203306378)
,p_name=>'EDIT_LOCK'
,p_message_language=>'fr'
,p_message_text=>'Modifier le verrou'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269420761305765)
,p_name=>'EDIT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Modifier une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125986571305640)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Modifier des attributs de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656801282306054)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'fr'
,p_message_text=>'Modifier le profil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674275736306075)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur 0% ne dispose d''aucun privil\00E8ge de mise \00E0 jour des informations d''un autre utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387528848305853)
,p_name=>'EDIT_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier une r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462022545305909)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier la tranche de temps de g\00E9n\00E9ration d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387611977305853)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier des colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651091512306050)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier un \00E9tat - Bo\00EEte de dialogue ferm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377516555305846)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier le message du syst\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612991992306023)
,p_name=>'EDIT_TAB'
,p_message_language=>'fr'
,p_message_text=>'Modifier un onglet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399332378305862)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>'Modifier cet attribut'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251766936305751)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps \00E9coul\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330309168305811)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'fr'
,p_message_text=>unistr('<a href="#MY_APPLICATION_LINK#">Acc\00E9dez \00E0 Mon application et g\00E9rez vos pr\00E9f\00E9rences de messagerie</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337266830305816)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'fr'
,p_message_text=>'<b style="font-size: 24px;">Mon application</b>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451715182305901)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Bonjour #INVITEE#,</strong><br>',
'<br>',
unistr('Ceci est un rappel d''un \00E9v\00E9nement \00E0 venir auquel vous avez \00E9t\00E9 invit\00E9. Les d\00E9tails de cet \00E9v\00E9nement sont indiqu\00E9s ci-dessous :<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Organisateur</th>',
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Date de l''\00E9v\00E9nement</th>'),
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Heure de d\00E9but</th>'),
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Dur\00E9e</th>'),
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Lieu</th>',
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Remarques</th>',
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330282177305811)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Bonjour #CUSTOMER_NAME#</strong>,<br>',
'<br>',
'Merci pour votre commande.<br>',
'<br>',
unistr('<strong>D\00E9tails de la commande</strong><br>'),
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Date de la commande</th>',
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Num\00E9ro de commande</th>'),
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Destinataire</th>',
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">Adresse d''exp\00E9dition</th>'),
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">Articles command\00E9s</th>'),
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Total de la commande</th>',
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('Vous souhaitez modifier votre commande ? <a href="#ORDER_URL#">G\00E9rez votre commande #ORDER_NUMBER# ici.</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651325369306051)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bonjour #SERVICE_USER#,<br>',
'<br>',
unistr('Nous allons bient\00F4t proc\00E9der \00E0 une coupure programm\00E9e du service #SERVICE_NAME#.<br>'),
unistr('Le d\00E9but de cette coupure est pr\00E9vu \00E0 #OUTAGE_START# et le service devrait \00EAtre indisponible pendant #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.<br>'),
'<br>',
unistr('L''op\00E9ration suivante sera effectu\00E9e lors de cette coupure programm\00E9e :<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('Pour tout probl\00E8me relatif \00E0 cette coupure, contactez #OUTAGE_CONTACT#.<br>'),
'<br>',
unistr('Merci de votre compr\00E9hension,<br>'),
'#SERVICE_TEAM#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650770704306050)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'fr'
,p_message_text=>unistr('Rappel d''\00E9v\00E9nement : #EVENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650866625306050)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'fr'
,p_message_text=>unistr('Commande (#ORDER_NUMBER#) confirm\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451983834305901)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bonjour #INVITEE#,',
'',
unistr('Nous vous envoyons ce courriel pour vous rappeler un \00E9v\00E9nement \00E0 venir auquel vous \00EAtes associ\00E9.'),
'',
unistr('Date de l''\00E9v\00E9nement : #EVENT_DATE#'),
unistr('Heure de d\00E9but : #START_TIME#'),
unistr('Dur\00E9e :   #DURATION#'),
'Organisateur :  #ORGANIZER#',
'Lieu :   #LOCATION#',
'URL :        #URL_NAME# (#URL_LINK#)',
'Remarques :      #NOTES#',
'',
unistr('Des d\00E9tails suppl\00E9mentaires sur l''\00E9v\00E9nement sont disponibles ici : #EVENT_LINK#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451823028305901)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bonjour #CUSTOMER_NAME#,',
'',
'Merci pour votre commande.',
'',
unistr('D\00E9tails de la commande'),
'--------------------------------------------------------------------------------',
'  Date de la commande :       #ORDER_DATE#',
unistr('  Num\00E9ro de commande :     #ORDER_NUMBER#'),
'  Destinataire :          #SHIP_TO#',
unistr('  Adresse d''exp\00E9dition : #SHIPPING_ADDRESS_LINE_1#'),
'                    #SHIPPING_ADDRESS_LINE_2#',
unistr('  Articles command\00E9s :    #ITEMS_ORDERED#'),
'  Total de la commande :      #ORDER_TOTAL#',
'--------------------------------------------------------------------------------',
'',
unistr('Vous souhaitez modifier votre commande ? G\00E9rez votre commande #ORDER_NUMBER# ici : #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651200855306050)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Bonjour #SERVICE_USER#,',
'',
unistr('Nous allons bient\00F4t proc\00E9der \00E0 une coupure programm\00E9e du service #SERVICE_NAME#.'),
unistr('Le d\00E9but de cette coupure est pr\00E9vu \00E0 #OUTAGE_START# et le service devrait \00EAtre indisponible pendant #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.'),
'',
unistr('L''op\00E9ration suivante sera effectu\00E9e lors de cette coupure programm\00E9e :'),
'#OUTAGE_REASON#',
'',
unistr('Pour tout probl\00E8me relatif \00E0 cette coupure, contactez #OUTAGE_CONTACT#.'),
'',
unistr('Merci de votre compr\00E9hension,'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381537901305849)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer le d\00E9bogage Oui ou Non')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452311309305902)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer le d\00E9clencheur %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898976079305464)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('La longueur de la valeur \00E0 crypter ne doit pas d\00E9passer 4 000 octets.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897516136305463)
,p_name=>'END_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur final'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320323439305803)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande d''am\00E9lioration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674906157306075)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'fr'
,p_message_text=>unistr('Demandes d''am\00E9lioration : %1 sur %0 ferm\00E9es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322713022305805)
,p_name=>'ENTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863959179305438)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Entrez les informations d''identification des feuilles Web.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310593971305796)
,p_name=>'ENTRY LINK'
,p_message_language=>'fr'
,p_message_text=>unistr('Lien d''entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310437506305796)
,p_name=>'ENTRY TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''entr\00E9e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365811366305837)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page d''erreurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228903000305734)
,p_name=>'ERRORPAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Page d''\00E9v\00E9nement d''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378519153305846)
,p_name=>'ERRORS'
,p_message_language=>'fr'
,p_message_text=>'Erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311705500305797)
,p_name=>'ERROR_ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne d''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068708361306383)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Message d''erreur'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303938992305791)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'fr'
,p_message_text=>unistr('<br><strong>Les donn\00E9es d''\00E9chappement d\00E9passent le maximum autoris\00E9 ; les r\00E9sultats sont tronqu\00E9s \00E0 32 ko</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072497440305601)
,p_name=>'ESCAPE_SC'
,p_message_language=>'fr'
,p_message_text=>unistr('caract\00E8res sp\00E9ciaux d''\00E9chappement')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344170844305821)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'fr'
,p_message_text=>'Estimation des efforts en heures'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598439168306012)
,p_name=>'ETAG_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte ETAG')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598382223306012)
,p_name=>'ETAG_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type ETAG'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320817323305804)
,p_name=>'EVENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655420417306053)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s r\00E9g\00E9n\00E9ration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655726705306054)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Avant soumission de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655387332306053)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant r\00E9g\00E9n\00E9ration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657966025306055)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements du navigateur Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119052263305635)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'fr'
,p_message_text=>'Toucher deux fois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119228218305635)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'fr'
,p_message_text=>'Panoramique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119174641305635)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'fr'
,p_message_text=>'Appuyer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119334076305635)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'fr'
,p_message_text=>'Faire glisser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118972934305635)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'fr'
,p_message_text=>'Toucher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654871186306053)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'fr'
,p_message_text=>'Modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654147717306053)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'fr'
,p_message_text=>'Clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654278277306053)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'fr'
,p_message_text=>'Double-clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653605646306052)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment actif s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653528465306052)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment actif d\00E9s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655034401306053)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'fr'
,p_message_text=>'Saisie de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655142032306053)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'fr'
,p_message_text=>'Activation de la touche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655230960306053)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactivation de la touche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653773430306052)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'fr'
,p_message_text=>'Chargement de la ressource'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654359414306053)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton de la souris enfonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654655032306053)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'fr'
,p_message_text=>'Positionnement de la souris'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654724135306053)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'fr'
,p_message_text=>'Eloignement de la souris'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654505538306053)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placement de la souris')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654493636306053)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton de la souris rel\00E2ch\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862920737305437)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'fr'
,p_message_text=>'Modification de l''orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661263549306058)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'fr'
,p_message_text=>'Chargement de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653820887306052)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'fr'
,p_message_text=>'Redimensionnement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101653934700306052)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9filement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863051377305437)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marrage par d\00E9filement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863153948305437)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'fr'
,p_message_text=>unistr('Arr\00EAt par d\00E9filement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654971799306053)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862113355305437)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'fr'
,p_message_text=>'Faire glisser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862287169305437)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'fr'
,p_message_text=>'Faire glisser vers la gauche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862311394305437)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'fr'
,p_message_text=>'Faire glisser vers la droite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861982838305436)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'fr'
,p_message_text=>'Toucher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862079336305436)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'fr'
,p_message_text=>'Toucher et maintenir la pression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101654046935306052)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9chargement de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862739901305437)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'fr'
,p_message_text=>'Clic virtuel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862831515305437)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annulation par effleurement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862436727305437)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marrage par effleurement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862564096305437)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placement par effleurement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100862629146305437)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Arr\00EAt par effleurement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658184490306055)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de composant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100858955528305434)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859065095305434)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658013555306055)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de structure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235361442305739)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte de dialogue ferm\00E9e ou annul\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387427465305853)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte de dialogue ferm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076663469306389)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s r\00E9g\00E9n\00E9ration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076787607306389)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Avant soumission de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076564866306389)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant r\00E9g\00E9n\00E9ration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305615929305793)
,p_name=>'EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342854001305820)
,p_name=>'EVENT_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro du jalon')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383754064305850)
,p_name=>'EXACT_SUBS'
,p_message_language=>'fr'
,p_message_text=>'Substitutions exactes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497520823305935)
,p_name=>'EXAMPLE_1'
,p_message_language=>'fr'
,p_message_text=>'Exemple 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101497698746305935)
,p_name=>'EXAMPLE_2'
,p_message_language=>'fr'
,p_message_text=>'Exemple 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997754449306329)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple des donn\00E9es contenues dans une colonne de base de donn\00E9es XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047768435306367)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'fr'
,p_message_text=>'Exemple d''URI'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453443830305903)
,p_name=>'EXCLUDE'
,p_message_language=>'fr'
,p_message_text=>'Exclure'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433040264305887)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom du sch\00E9ma existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375083983305844)
,p_name=>'EXISTS'
,p_message_language=>'fr'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930385384305490)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL EXISTE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645678185306046)
,p_name=>'EXPANDED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopp\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043516502306364)
,p_name=>'EXPAND_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper tout')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100995530972305541)
,p_name=>'EXPIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Expir\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309149474305795)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'fr'
,p_message_text=>unistr('Plan d''ex\00E9cution')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305952171305793)
,p_name=>'EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Exporter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614273053306024)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rentiel d''export')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388047277305853)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Export\00E9 \00E0 partir d''un autre espace de travail ou d''une autre application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388145854305853)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Export\00E9 \00E0 partir de l''espace de travail en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457417876305905)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Exporter une application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461632318305909)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilisez ces liens pour t\00E9l\00E9charger cette application et les objets de prise en charge de base de donn\00E9es correspondants pour d\00E9ploiement dans une installation Oracle APEX diff\00E9rente. Les fichiers t\00E9l\00E9charg\00E9s seront des scripts SQL pouvant \00EAtre ex\00E9cu')
||unistr('t\00E9s \00E0 partir de scripts SQL, SQL*Plus ou SQL Developer dans Oracle APEX.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457504968305906)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Exporter des objets de prise en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306274568305793)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export d''application :  '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306419658305793)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export de feuilles de style CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306607188305793)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export de fichier statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306581497305793)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306398678305793)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306729093305794)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export de fichier de script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302693355305789)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeurs par d\00E9faut d''interface utilisateur')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233709289305738)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Calcul d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231715475305736)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233566044305738)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101048402660305582)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les ID d''application compris entre 3000 et 8999 sont r\00E9serv\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931557784305491)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette application a \00E9t\00E9 export\00E9e \00E0 partir de l''espace de travail en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931675623305491)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette application a \00E9t\00E9 export\00E9e \00E0 partir d''un autre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865313453306218)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification de serveur d''impression distant d''application %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865190400306218)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'fr'
,p_message_text=>'Serveur d''impression distant de l''application %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233418216305738)
,p_name=>'F4000.BRANCH'
,p_message_language=>'fr'
,p_message_text=>'Branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247391438305748)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Branchement \00E0 partir de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247569950305748)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Branchement sur une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233016186305737)
,p_name=>'F4000.BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374043264305843)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986833942305534)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109308056305628)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de calendrier.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247942543305748)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011942598306340)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne identifi\00E9 est un mot r\00E9serv\00E9 Oracle. Choisissez un autre nom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375482657305844)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier une entr\00E9e de liste : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261266709305758)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'fr'
,p_message_text=>'Dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945798452305504)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931441581305491)
,p_name=>'F4000.EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Exporter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263413426305760)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'fr'
,p_message_text=>'Corrigez-moi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260844757305758)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'fr'
,p_message_text=>'Pour l''utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260715607305758)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'fr'
,p_message_text=>'Pour session utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247667196305748)
,p_name=>'F4000.FROM'
,p_message_language=>'fr'
,p_message_text=>'de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049549883305582)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'fr'
,p_message_text=>unistr('L''en-t\00EAte doit contenir les balises <strong> &lt;head&gt;</strong> et <strong>&lt;/head&gt;</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049868459305583)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'fr'
,p_message_text=>unistr('La cha\00EEne de substitution <strong>#HEAD#</strong> doit figurer entre les balises <strong> &lt;head&gt;</strong> et <strong>&lt;/head&gt;</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318432029305802)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Le type du fichier "%0" n''est pas valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232740706305737)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232823249305737)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878122607305448)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('SQL h\00E9rit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401422711305863)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265903113305762)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234112933305738)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878087367305448)
,p_name=>'F4000.LOCAL'
,p_message_language=>'fr'
,p_message_text=>'Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234477720305738)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de liste de valeurs (LOV)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247761108305748)
,p_name=>'F4000.MENU'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234378168305738)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277784951305771)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez en s\00E9lectionner au moins un pour copie ou abonnement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233806292305738)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de barre de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164583415305669)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne&nbsp;de&nbsp;barre&nbsp;de&nbsp;navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231694111305736)
,p_name=>'F4000.NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261302381305759)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non r\00E9f\00E9renc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245899555305747)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071205565306385)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>'L''application %0 n''existe pas dans l''espace de travail en cours.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672135616306073)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rification des mises \00E0 jour d\00E9sactiv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270509380305765)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''onglet parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934265340305494)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'fr'
,p_message_text=>'Branchement du bouton Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933883206305494)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''affichage du bouton Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934343011305494)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'fr'
,p_message_text=>'Branchement du bouton Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933964038305494)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''affichage du bouton Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934140900305494)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''affichage du bouton Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934096071305494)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''affichage du bouton Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270606038305766)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page d''arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270775205305766)
,p_name=>'F4000.P119.GO'
,p_message_language=>'fr'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270814111305766)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisation des m\00EAmes mod\00E8les qu''une application existante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073761670306387)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'fr'
,p_message_text=>'Copier %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075452472306388)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les d''autorisation suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075779196306388)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de chemin de navigation suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075815404306388)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de bouton suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075998250306388)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de calendrier suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857577341305433)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les d\00E9finitions de chargement de donn\00E9es suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075347304306388)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de libell\00E9 suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075105553306388)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de liste suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074873494306387)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les listes de valeurs suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075655282306388)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les entr\00E9es de barre de navigation suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074958334306387)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de page suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076013852306388)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les modules d''extension suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076135393306388)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de liste de valeurs instantan\00E9e suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075060487306388)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les de r\00E9gion suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075295246306388)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les mod\00E8les d''\00E9tat suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102075542302306388)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les raccourcis suivants :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434122361305887)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la publication de <strong>%0</strong>. Cette op\00E9ration r\00E9g\00E9n\00E9rera les sources de donn\00E9es REST suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278518300305771)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'fr'
,p_message_text=>'Copie de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073666949306386)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition de recherche restreinte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071384710306385)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101049154057305582)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer au moins un \00E9l\00E9ment pour cr\00E9er une validation NOT NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983580831306318)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'fr'
,p_message_text=>'Serveur d''impression de l''application %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695336840306090)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour les param\00E8tres d''export par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807085634306173)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'fr'
,p_message_text=>'action ='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314787425305799)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'fr'
,p_message_text=>'commentaire='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312824207305798)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilis\00E9 pour ex\00E9cuter le calcul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080117694306392)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichier concat\00E9n\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313469791305798)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'fr'
,p_message_text=>'valeur d''affichage='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080033767306392)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'fr'
,p_message_text=>'file='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313101496305798)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Barre d''ic\00F4nes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313620143305799)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313362086305798)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es de liste de valeurs (LOV)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313223031305798)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'fr'
,p_message_text=>'nom='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312794216305798)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilis\00E9 pour afficher la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314611771305799)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'fr'
,p_message_text=>'Branchement de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313778634305799)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313060037305798)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilis\00E9 pour ex\00E9cuter un processus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312997346305798)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313525575305799)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'fr'
,p_message_text=>unistr('valeur renvoy\00E9e=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076334833306389)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Affecter un nouveau parent \00E0 l''entr\00E9e de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108925247305627)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer au moins une r\00E9gion \00E0 cr\00E9er.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231317213305736)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail ne sera pas cr\00E9\00E9 car il existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231455685305736)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail sera cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077107018306389)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'fr'
,p_message_text=>'Visualiser le verrou'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109015757305627)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer au moins une page pour cr\00E9ation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077277135306389)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page est actuellement d\00E9verrouill\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640617363306043)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271240024305766)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'fr'
,p_message_text=>'Pos.1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271305956305766)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'fr'
,p_message_text=>'Pos.2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271459807305766)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'fr'
,p_message_text=>'Pos.3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271573799305766)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'fr'
,p_message_text=>'Pos.4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869457429305442)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'fr'
,p_message_text=>'Pos.5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438358360305891)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'fr'
,p_message_text=>'Pos.6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438432021305891)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'fr'
,p_message_text=>'Pos.7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438501335305891)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'fr'
,p_message_text=>'Pos.8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271663188305766)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les boutons de pagination et DML requi\00E8rent des noms de bouton sp\00E9cifiques, consultez le texte d''aide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073835141306387)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'fr'
,p_message_text=>'%0 (correspondances de classe)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271745746305766)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'fr'
,p_message_text=>unistr('g\00E9rer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080458575306392)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur d''origine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271806751305766)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'fr'
,p_message_text=>unistr('Cha\00EEne de substitution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271947747305767)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur de substitution'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245292333305746)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">Cette r\00E9gion affiche l''aide sur la page en cours et sur ses \00E9l\00E9ments lorsqu''elle est appel\00E9e \00E0 l''aide de la syntaxe suivante :<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272033901305767)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'fr'
,p_message_text=>'Panneau sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272182667305767)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'fr'
,p_message_text=>'Valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996296619305541)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'fr'
,p_message_text=>'Branchement='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264353327305761)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'fr'
,p_message_text=>'Bouton='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886910658305455)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie de graphiques =')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264587787305761)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'fr'
,p_message_text=>'Calcul='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263969867305760)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'fr'
,p_message_text=>unistr('Sous-texte d''ic\00F4ne=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263885958305760)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'fr'
,p_message_text=>'Image='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264455120305761)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264096320305761)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'fr'
,p_message_text=>'Liste='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996338927305541)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264269145305761)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'fr'
,p_message_text=>'Page='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264666548305761)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'fr'
,p_message_text=>'Processus='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886819333305455)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion =')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261419774305759)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Requis par chaque page de l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263586082305760)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263675330305760)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Calcul d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263764585305760)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264845916305761)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'fr'
,p_message_text=>'Nom d''onglet='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264969678305761)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264111449305761)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'fr'
,p_message_text=>'Texte='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101264799596305761)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'fr'
,p_message_text=>'Validation='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273873450305768)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274403040305768)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'fr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273427136305768)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'fr'
,p_message_text=>unistr('Aspect par d\00E9faut 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273519298305768)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'fr'
,p_message_text=>unistr('Aspect par d\00E9faut 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273653093305768)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'fr'
,p_message_text=>unistr('Aspect par d\00E9faut 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273710414305768)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'fr'
,p_message_text=>unistr('Aspect par d\00E9faut 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272501746305767)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser des boutons de pagination cr\00E9\00E9s de mani\00E8re externe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273332393305768)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'fr'
,p_message_text=>'Aspect standard HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274058903305768)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'fr'
,p_message_text=>'Aspect 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274196530305768)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'fr'
,p_message_text=>'Aspect 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274246176305768)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'fr'
,p_message_text=>'Aspect 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274320100305768)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'fr'
,p_message_text=>'Aspect 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273034825305767)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes X \00E0 Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272711740305767)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'fr'
,p_message_text=>'Plages de lignes 1-15 16-30 dans une liste SELECT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273260380305768)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'fr'
,p_message_text=>'Moteur de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272840586305767)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'fr'
,p_message_text=>'Moteur de recherche 1,2,3,4 (en fonction de la pagination)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273187921305767)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste SELECT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272393297305767)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('d\00E9finir les valeurs par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272463206305767)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'fr'
,p_message_text=>unistr('d\00E9sactiver la pagination')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272916067305767)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'fr'
,p_message_text=>'Utiliser les boutons de pagination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274527975305768)
,p_name=>'F4000.P420.XML'
,p_message_language=>'fr'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101273924065305768)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274655645305769)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rer un lien')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272636718305767)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes de X \00E0 Y (avec liens pr\00E9c\00E9dent et suivant)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099711501306406)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'fr'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398696776305861)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de BdD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398899172305861)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398973169305861)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398737874305861)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398596899305861)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'fr'
,p_message_text=>'texte statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274788414305769)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les boutons DML exigent des noms de bouton sp\00E9cifiques, reportez-vous au texte d''aide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941393175305500)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nouveau module d''extension sera cr\00E9\00E9 dans l''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941273859305500)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le module d''extension existant sera remplac\00E9 dans l''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274833260305769)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'HTML avec raccourcis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275038376305769)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265759736305762)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de bouton par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986782216305534)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de calendrier par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096079360306403)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de graphique par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986543988305534)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page de bo\00EEte de dialogue par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096162480306404)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de panneau par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096500949306404)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion d''\00E9tat interactif par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265673527305762)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de libell\00E9 par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096273566306404)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de liste par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265554615305762)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096756087306404)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de chemin de navigation par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265855728305762)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de chemin de navigation par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095888381306403)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste de barre de navigation par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095523165306403)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste de menu de navigation par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095338084306403)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de libell\00E9 facultatif par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265215684305761)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265365656305762)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096309052306404)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion d''\00E9tat par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265456525305762)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''\00E9tat par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095485010306403)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de libell\00E9 obligatoire par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095781340306403)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste de menu de navigation vers le c\00F4t\00E9 par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096413470306404)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion de panneau tabulaire par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095654760306403)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste de menu de navigation vers le haut par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102096661117306404)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion d''assistant par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265182029305761)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page d''erreur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095986154306403)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page de connexion par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101265047245305761)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page en mode Pour imprimante par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101272228393305767)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'fr'
,p_message_text=>'Etat sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268867886305764)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'fr'
,p_message_text=>'informations d''alerte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269076250305764)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('nouvelle r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268703867305764)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez cr\00E9er au moins une r\00E9gion avant de cr\00E9er un \00E9l\00E9ment de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268996872305764)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser un assistant pour cr\00E9er une nouvelle r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270287192305765)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'fr'
,p_message_text=>unistr('sera tri\00E9 en ordre alphab\00E9tique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270486411305765)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple 4 : liste de valeurs avec variable attach\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270313872305765)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'fr'
,p_message_text=>unistr('tri\00E9 dans l''ordre de cr\00E9ation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269908892305765)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple 2 : liste de valeurs avec les m\00EAmes valeurs d''affichage et de retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362750914305835)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple 5 : la requ\00EAte contient une requ\00EAte imbriqu\00E9e ; vous devez vous assurer que la premi\00E8re clause FROM de la requ\00EAte SQL ne fait pas partie de la requ\00EAte imbriqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269887089305765)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple 1 : liste de valeurs bas\00E9e sur une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270156308305765)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'fr'
,p_message_text=>'Exemple 3 : exemples de liste statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270056942305765)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque vous s\00E9lectionnez la m\00EAme colonne pour l''affichage et pour les valeurs de retour, utilisez un alias de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940282127305499)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'fr'
,p_message_text=>'Afficher Oui / Non, renvoyer O et N'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275651522305769)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s traitement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275335210305769)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Avant les calculs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275572459305769)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Avant traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275484713305769)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'fr'
,p_message_text=>'Avant les validations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946601730305504)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275772872305769)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'fr'
,p_message_text=>'Appliquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943577030305502)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275991983305769)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275821848305769)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Soumettre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276106229305770)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque cette proc\00E9dure sera ex\00E9cut\00E9e, la pagination sera r\00E9initialis\00E9e pour toutes les pages de cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288253098305778)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('AVERTISSEMENT : Vous avez choisi une validation de type Expression r\00E9guli\00E8re, mais votre version de base de donn\00E9es ne prend pas en charge ce type de validation. La validation renverra toujours la valeur TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025133817306350)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les traductions de cette application ne sont actuellement pas activ\00E9es. V\00E9rifiez le param\00E8tre <em>Langue d''application d\00E9riv\00E9e de</em> dans <a href="%0">Attributs de globalisation</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087316285306397)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque le temps maximal d''inactivit\00E9 de session n''est pas d\00E9fini, la valeur de niveau espace de travail ou de niveau instance est utilis\00E9e (actuellement %0 secondes).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087478493306397)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque la dur\00E9e maximale de session n''est pas d\00E9finie, la valeur de niveau espace de travail ou de niveau instance est utilis\00E9e (actuellement %0 secondes).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077807990306390)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'fr'
,p_message_text=>'Nouveau branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388973503305854)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ces composants ont \00E9t\00E9 export\00E9s \00E0 partir d''une autre application ou \00E0 partir d''une application d''un autre espace de travail. Ils ne peuvent pas \00EAtre install\00E9s dans cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392958307305857)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ces fichiers ont \00E9t\00E9 export\00E9s \00E0 partir d''un autre espace de travail. Ils ne peuvent pas \00EAtre install\00E9s dans cet espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077965336306390)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''arriv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078774475306391)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'fr'
,p_message_text=>'Option de copie : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078889321306391)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs existante : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329843727305810)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page a \00E9t\00E9 export\00E9e depuis une autre application ou depuis une application d''un autre espace de travail. Elle ne peut pas \00EAtre install\00E9e dans cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231254597305736)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page a \00E9t\00E9 export\00E9e dans un autre espace de travail \00E0 partir d''une application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231137525305736)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page a \00E9t\00E9 export\00E9e dans l''espace de travail en cours \00E0 partir d''une application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650157496306050)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page est actuellement verrouill\00E9e. Vous ne pouvez pas ex\00E9cuter d''import sur une page verrouill\00E9e. D\00E9verrouillez cette page, puis effectuez l''installation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076424141306389)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Effacer une entr\00E9e parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078211834306390)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner le param\00E8tre %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050107722305583)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez s\00E9lectionner au moins un sch\00E9ma pour copie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078404204306390)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de l''en-t\00EAte HTTP %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078392971306390)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur du param\00E8tre d''entr\00E9e %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078667510306390)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer un en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078548611306390)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer un param\00E8tre : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277923938305771)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'fr'
,p_message_text=>'Feuille de style requise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247081888305748)
,p_name=>'F4000.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261654638305759)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233194390305738)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Calcul de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987927796305535)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action dynamique de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848914552305427)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action dynamique de page - Action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231865861305737)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851175375305428)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Groupe d''\00E9l\00E9ments de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266037454305762)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'fr'
,p_message_text=>'page(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247161247305748)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233229882305738)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Processus de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261505840305759)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261733169305759)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Validation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234038176305738)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248086269305749)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865215929306218)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification de serveur d''impression distant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248659530305749)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'fr'
,p_message_text=>'Publier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232643244305737)
,p_name=>'F4000.REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861745231306215)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247269300305748)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Page(s) et composants associ\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865478242306218)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362555776305835)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878291393305449)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248555628305749)
,p_name=>'F4000.SEED'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9d\00E9finir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233911688305738)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261163978305758)
,p_name=>'F4000.STATIC'
,p_message_language=>'fr'
,p_message_text=>'Statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247849890305748)
,p_name=>'F4000.TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248124540305749)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091990381305615)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de mod\00E8le %0 existe d\00E9j\00E0. Saisissez-en un autre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050274447305583)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de mod\00E8le doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248314232305749)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nouveau th\00E8me sera cr\00E9\00E9 dans l''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248404474305749)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le th\00E8me existant sera remplac\00E9 dans l''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101247482916305748)
,p_name=>'F4000.TO'
,p_message_language=>'fr'
,p_message_text=>'vers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234520875305739)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d''application inconnu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248727401305749)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne modifiable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373929419305843)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Les utilitaires incluent les pages de modification de grille et les \00E9tats dans toutes les pages au sein de l''application s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101233332394305738)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878393843305449)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865598903306218)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231512041305736)
,p_name=>'F4000.YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307683946305794)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'fr'
,p_message_text=>'Date MMDDYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461355118305908)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'Applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013435467305554)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('En tant qu''application dans une table de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266491193305762)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'fr'
,p_message_text=>unistr('En tant qu''application sur des tables de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278024554305771)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette position de bouton ne figure pas dans votre mod\00E8le de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014028211306342)
,p_name=>'F4000_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278323483305771)
,p_name=>'F4000_CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294933871305783)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'fr'
,p_message_text=>'Copier et s''abonner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278679573305771)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'fr'
,p_message_text=>'Format de date non reconnu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946341186305504)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377746398305846)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460428563305908)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le(s) nom(s) de liste de valeurs (LOV) %0 existe(nt) d\00E9j\00E0. Saisissez un nouveau nom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301534721305788)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune s\00E9lection')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257812979305756)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune application associ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889639751305457)
,p_name=>'F4000_OFF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889559967305457)
,p_name=>'F4000_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949936523305507)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de calendrier faisant r\00E9f\00E9rence \00E0 ce mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330732648305811)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'fr'
,p_message_text=>'pages de vue de ce type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059236991305589)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('il n''y a pas d''aide pour cet \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051283296305584)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'fr'
,p_message_text=>'page d''accueil d''authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051166861305584)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier ce mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066711798305595)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la feuille de style CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672246912306073)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La page existe d\00E9j\00E0 dans cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946702751305504)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('La page doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946828606305504)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('La page doit \00EAtre un nombre positif.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946983659305504)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('La page doit \00EAtre un nombre entier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379040072305847)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Importer des mod\00E8les d''autorisation')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328556481305810)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Importer des mod\00E8les d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379179290305847)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'fr'
,p_message_text=>'Importer des barres de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328602341305810)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Importer un th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276574556305770)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Panneau tabulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307312030305794)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Authentification r\00E9ussie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307408171305794)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'fr'
,p_message_text=>'Echec de l''authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299203603305786)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Aucune colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279852706305772)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'fr'
,p_message_text=>'Cette application n''est pas disponible actuellement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028714683305567)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'fr'
,p_message_text=>'Date : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028888094305567)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'fr'
,p_message_text=>unistr('Date, flexible : %0 avec tout s\00E9parateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029516187305568)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'fr'
,p_message_text=>'Format de date non reconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029416707305568)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'fr'
,p_message_text=>'La date doit avoir le format suivant : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028201208305567)
,p_name=>'F4000_P430_IP'
,p_message_language=>'fr'
,p_message_text=>'Adresse IP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029088011305567)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'fr'
,p_message_text=>'Adresse IP non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028347516305567)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de t\00E9l\00E9phone, US: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028407056305567)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de t\00E9l\00E9phone, US flexible : 999.999.9999, (999)-999-9999, 999 999 9999, etc...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029298566305567)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Format de num\00E9ro de t\00E9l\00E9phone non reconnu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029127587305567)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro de t\00E9l\00E9phone doit avoir le format suivant : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028140527305567)
,p_name=>'F4000_P430_URL'
,p_message_language=>'fr'
,p_message_text=>'URL : http(s)://domain/path/doc.(pdf)(html)(etc...)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028906736305567)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'fr'
,p_message_text=>'URL non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028516808305567)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'fr'
,p_message_text=>'Code postal : 99999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028604668305567)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'fr'
,p_message_text=>'Code postal + 4 : 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029328261305567)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le code postal doit avoir le format suivant : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959637395305514)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959772942305514)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959944286305514)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas d''abonn\00E9s \00E0 ce mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959869551305514)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les en cours d''abonnement \00E0 ce mod\00E8le d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014614922305555)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('- aucun mod\00E8le -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275167209305769)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Etat 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279995708305772)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'fr'
,p_message_text=>unistr('Panneau sur une proc\00E9dure stock\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101275276896305769)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Graphique 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279243208305772)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Afficher uniquement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279102740305772)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278893565305772)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Effacer le cache des \00E9l\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278736183305771)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Effacer le cache des pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301879445305789)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279089575305772)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir un \00E9l\00E9ment \00E0 l''aide du corps de fonction PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278946282305772)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Affectation d''\00E9l\00E9ment statique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276034155305770)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('Tous les \00E9l\00E9ments de page qui ne sont pas en m\00E9moire cache pour l''application en cours seront initialis\00E9s \00E0 la valeur Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279646530305772)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279357235305772)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279420985305772)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment diff\00E9rent de z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279571048305772)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307883696305794)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'fr'
,p_message_text=>'Date DDMMYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307761908305794)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de t\00E9l\00E9phone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046197181306366)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'fr'
,p_message_text=>unistr('Objet de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276263298305770)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Dans le navigateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276345404305770)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'fr'
,p_message_text=>'Calendrier 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014888064305557)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'fr'
,p_message_text=>'(contenant la colonne Date ou Horodatage)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494686756305932)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'fr'
,p_message_text=>'Syntaxe : select id, name, date from ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494914598305933)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'fr'
,p_message_text=>'Exemple d''utilisation de la pseudo-colonne ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495078517305933)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'fr'
,p_message_text=>unistr('Exemple d''utilisation de la cl\00E9 primaire de table source')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494763064305933)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'fr'
,p_message_text=>'1. Vous devez inclure au moins deux colonnes, dont une colonne DATE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494869331305933)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'fr'
,p_message_text=>unistr('2. La premi\00E8re colonne doit identifier la colonne de cl\00E9 primaire \00E0 utiliser pour la gestion de l''op\00E9ration de langage de manipulation de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276444019305770)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Panneau 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389571625305855)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'fr'
,p_message_text=>'Manifest d''export de composants    '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330638522305811)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition de page de vue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276640826305770)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Page r\00E9capitulative')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295212638305784)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('cliquer pour d\00E9finir le jeu d''onglets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549345258305974)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mod\00E8le de page prend en charge deux niveaux d''onglets, mais l''onglet standard n''identifie par un jeu d''onglets parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549296868305974)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'fr'
,p_message_text=>'Aucun onglet, cette page n''affichera pas d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549066609305974)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'fr'
,p_message_text=>'Cette page affichera un niveau d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549411943305974)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'fr'
,p_message_text=>'Pages sans onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549519488305974)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'fr'
,p_message_text=>unistr('Au total, %0 pages n''ont aucun onglet d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548954953305974)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Affichage d''onglet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549173509305974)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'fr'
,p_message_text=>'Cette page affichera deux niveaux d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996893009306328)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0 est disponible.</strong> L''instance sera automatiquement mise \00E0 niveau vers <strong>%1</strong>. L''administrateur de l''instance peut lancer la mise \00E0 niveau \00E0 tout moment avant cette date dans les services d''administration.<')
||'/p>',
unistr('<p>Consultez l''<a href="%2" target="_blank" rel="noreferrer">annonce</a> pour en savoir plus sur les nouvelles fonctionnalit\00E9s et am\00E9liorations dans Oracle APEX %0.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996744379306328)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'fr'
,p_message_text=>unistr('<strong>L''instance %0 est en cours de mise \00E0 niveau vers une version plus r\00E9cente.</strong> Les applications ne pourront pas \00EAtre modifi\00E9es pendant un certain temps durant le processus de mise \00E0 niveau. L''acc\00E8s aux applications et \00E0 l''environnement d')
||unistr('e d\00E9veloppement %0 sera interrompu pendant %1 minutes au maximum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958520090305513)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959401469305514)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'fr'
,p_message_text=>unistr('Faire de ce mod\00E8le le mod\00E8le en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959587866305514)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'fr'
,p_message_text=>'rendre en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014435814305555)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'fr'
,p_message_text=>'en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959228894305514)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Faire passer le statut \00E0 Inactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958020750305513)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tails')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958193981305513)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Logique de gestion de session int\00E9gr\00E9e, page de connexion et authentification utilisateur int\00E9gr\00E9es par rapport au r\00E9f\00E9rentiel de comptes internes d''utilisateur de cookie.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958279363305513)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette m\00E9thode a \00E9t\00E9 remplac\00E9e par l''authentification SCHEME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012471158305553)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier des attributs d''authentification obsol\00E8tes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012590460305553)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'fr'
,p_message_text=>unistr('attributs obsol\00E8tes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012666026305553)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'fr'
,p_message_text=>unistr('ou laissez-les en place jusqu''\00E0 ce que vous soyez pr\00EAt \00E0 faire passer la m\00E9thode d''authentification \00E0 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012996179305554)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'fr'
,p_message_text=>unistr('Indique un ou plusieurs attributs d''authentification obsol\00E8tes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013168230305554)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'fr'
,p_message_text=>unistr('ou faites-les migrer vers un mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012152135305553)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959138370305514)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rez les mod\00E8les d''authentification \00E0 l''aide de l''\00E9tat ci-dessus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957925363305513)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014391442305555)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'fr'
,p_message_text=>'(Non modifiable)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959369011305514)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'fr'
,p_message_text=>'(en cours)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012200158305553)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'fr'
,p_message_text=>unistr('(obsol\00E8te)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100959026574305514)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'fr'
,p_message_text=>'(aucun)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958433693305513)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Pages publiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958692049305513)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'fr'
,p_message_text=>'Revoir ou modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958735432305513)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'fr'
,p_message_text=>'ou modifiez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958845194305514)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'fr'
,p_message_text=>'les attributs de gestion de session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100958994473305514)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'fr'
,p_message_text=>unistr('de cette application dans la page des attributs d''application, ou utilisez l''\00E9tat ci-dessus pour cr\00E9er et g\00E9rer les mod\00E8les d''authentification que vous pourrez utiliser lorsque vous ferez passer la m\00E9thode d''authentification \00E0 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012747305305553)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Revoir ou modifier les attributs de gestion de session',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013047447305554)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'fr'
,p_message_text=>'Revoir ou modifier ces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012336337305553)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'fr'
,p_message_text=>unistr('La m\00E9thode d''authentification %0 est obsol\00E8te. Nous vous conseillons de cliquer sur le lien Rendre en cours (figurant ci-dessus) de l''un des mod\00E8les d''authentification de l''application, ou de cr\00E9er un nouveau mod\00E8le d''authentification et de le rendre')
||unistr(' en cours. Sur le plan fonctionnel, le mod\00E8le d''authentification INTERNAL-SETUP \00E9quivaut \00E0 la m\00E9thode %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012826027305553)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilise les mod\00E8les d''authentification pour g\00E9rer l''authentification utilisateur et tous les autres aspects de la gestion de session pour votre application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276919997305770)
,p_name=>'F4000_P805_X'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez indiqu\00E9 une fonction de sentinelle de page dans l''\00E9tape pr\00E9c\00E9dente. Cette fonction assurera la v\00E9rification de session \00E0 chaque page ; il n''est donc pas n\00E9cessaire d''indiquer ici une fonction de v\00E9rification de session. Si ce n''est pas ce q')
||unistr('ue vous voulez, retournez en arri\00E8re dans cet assistant et effectuez des modifications.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015459628305557)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de connexion int\00E9gr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015884207305557)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015515824305557)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'fr'
,p_message_text=>'Page de cette application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015775694305557)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015612734305557)
,p_name=>'F4000_P806_URL'
,p_message_language=>'fr'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101015933971305557)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Utiliser le nom utilisateur et le mot de passe du compte %0 pour l''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901726068305466)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser le nom utilisateur et le mot de passe du compte de base de donn\00E9es pour l''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016039340305558)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne pas v\00E9rifier les informations d''identification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016261934305558)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser ma fonction personnalis\00E9e pour l''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016180489305558)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'fr'
,p_message_text=>'Utiliser un serveur LDAP pour l''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280033071305772)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'- Aucun nom de page -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960675093305515)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fonction d''authentification',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961496904305515)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'fr'
,p_message_text=>'Domaine de cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961219793305515)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961349119305515)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'fr'
,p_message_text=>'Chemin de cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898860597305464)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960424764305515)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'fr'
,p_message_text=>'Cible de session non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960918406305515)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'fr'
,p_message_text=>'Base de recherche LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961040577305515)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modification de nom utilisateur LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960739586305515)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'fr'
,p_message_text=>unistr('H\00F4te LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960851704305515)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'fr'
,p_message_text=>'Port LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961596896305516)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('URL de d\00E9connexion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960164892305515)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960000420305514)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'fr'
,p_message_text=>unistr('(Int\00E9gr\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961637599305516)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('(Authentification de base de donn\00E9es)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960238410305515)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'fr'
,p_message_text=>'Fonction de sentinelle de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961101168305515)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Processus de postauthentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960585605305515)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Processus de pr\00E9authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100960366926305515)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction de v\00E9rification de session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016468704305558)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'fr'
,p_message_text=>unistr('En tant que copie d''un mod\00E8le d''authentification existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016578232305558)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Bas\00E9 sur un mod\00E8le pr\00E9configur\00E9 de la galerie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016357401305558)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Bas\00E9 sur un mod\00E8le pr\00E9configur\00E9 de la galerie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974202958305525)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la r\00E9g\00E9n\00E9ration des mod\00E8les d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961842425305516)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029696997305568)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : vous \00EAtes sur le point de supprimer le mod\00E8le d''authentification en cours de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962079550305516)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961702537305516)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100961983583305516)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017019141305558)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Server Single Sign-On (application partenaire = mon application)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016658651305558)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'fr'
,p_message_text=>'Afficher la page de connexion et utiliser les informations d''identification du compte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016775915305558)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher la page de connexion int\00E9gr\00E9e et utiliser les informations d''identification porte ouverte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016808867305558)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'fr'
,p_message_text=>'Afficher la page de connexion et utiliser les informations d''identification de l''annuaire LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101016901060305558)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Server Single Sign-On (application partenaire = moteur %0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962314866305516)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9thode d''authentification en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974377230305525)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s avec connexion unique SSO (utilisation Oracle uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974418704305525)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Server Single Sign-On (application partenaire = %0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974528752305525)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Server Single Sign-On (application partenaire = mon application)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974627439305525)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de connexion int\00E9gr\00E9e : Utiliser les informations d''identification du compte %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997188307305542)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de connexion nouvellement cr\00E9\00E9e : utiliser les informations d''identification du compte %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997256946305542)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'fr'
,p_message_text=>'Page de connexion existante : utiliser les informations d''identification du compte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974706312305526)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de connexion int\00E9gr\00E9e : Informations d''identification porte ouverte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974856979305526)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de connexion int\00E9gr\00E9e : Utiliser les informations d''identification de l''annuaire LDAP')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996965541305542)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de connexion nouvellement cr\00E9\00E9e : utiliser les informations d''identification de l''annuaire LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997076453305542)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'fr'
,p_message_text=>'Page de connexion existante : utiliser les informations d''identification LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974979673305526)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'fr'
,p_message_text=>unistr('Bas\00E9 sur un mod\00E8le d''authentification de la galerie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017165615305558)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'fr'
,p_message_text=>'Nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053829118305586)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonctionnalit\00E9 d''annulation de %0 utilise une fonctionnalit\00E9 de base de donn\00E9es int\00E9gr\00E9e appel\00E9e "Requ\00EAte Flashback", qui vous permet d''interroger des donn\00E9es \00E0 partir d''une heure donn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101053677639305585)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''heure \00E0 laquelle vous voulez revenir, puis cliquez sur Appliquer pour \00E9crire la source sur la page de modification de r\00E9gion et fermer cette bo\00EEte de dialogue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054026729305586)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Du fait de la valeur du param\00E8tre de base de donn\00E9es "UNDO_RETENTION", vous ne pouvez annuler que les modifications effectu\00E9es au cours des %0 derni\00E8res heures.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054586803305586)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('Confirmer la cr\00E9ation de l''onglet standard dans l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054986682305586)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Un nouveau jeu d''onglets, %0, sera cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054873672305586)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'fr'
,p_message_text=>'La page %0 utilisera le jeu d''onglets existant "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054691745305586)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement, les informations de jeu d''onglets sont incompl\00E8tes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496303411305934)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'fr'
,p_message_text=>'Valeur de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278475503305771)
,p_name=>'F4000_PREV'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266737631305763)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur <strong>Fin</strong> pour cr\00E9er ou \00E9tendre l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266532617305763)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclure des aides \00E0 la navigation par chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266640698305763)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'fr'
,p_message_text=>unistr('Masquer la cl\00E9 primaire dans la page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412221500305871)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'fr'
,p_message_text=>'Raccourci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172848142305675)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101278168473305771)
,p_name=>'F4000_TOP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377876080305846)
,p_name=>'F4000_TREE'
,p_message_language=>'fr'
,p_message_text=>'Arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493201493305931)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930128917305490)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'fr'
,p_message_text=>unistr('Document de r\00E9ponses complet')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940164493305499)
,p_name=>'F400_P107_STEP'
,p_message_language=>'fr'
,p_message_text=>'Etape %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910862486305473)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'fr'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494563175305932)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Accept\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364585070305836)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma sera affect\00E9 \00E0 l''espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364695892305836)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma ne sera pas affect\00E9 \00E0 l''espace de travail pour les raisons suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364124060305836)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma suppl\00E9mentaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259391711305757)
,p_name=>'F4050.ADJUST'
,p_message_language=>'fr'
,p_message_text=>'Ajuster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258638846305756)
,p_name=>'F4050.ALL'
,p_message_language=>'fr'
,p_message_text=>'Tout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494039867305932)
,p_name=>'F4050.APPROVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Approuv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914671287305476)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre demande d''espace de travail a \00E9t\00E9 approuv\00E9e et les informations d''identification ont \00E9t\00E9 envoy\00E9es \00E0 l''adresse \00E9lectronique fournie lors de l''inscription.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332738638305813)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre demande de compte a \00E9t\00E9 approuv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332637648305813)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'fr'
,p_message_text=>unistr('Approuv\00E9 : demande de compte pour %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333191636305813)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 %0 Mo d''espace de stockage suppl\00E9mentaire dans l''espace de travail %1 ; votre demande a \00E9t\00E9 approuv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493757373305932)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('Affect\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005068492306335)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493646860305932)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085243307306395)
,p_name=>'F4050.BROKEN'
,p_message_language=>'fr'
,p_message_text=>'Interrompu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085626311306396)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cha\00EEne bloqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333554375305813)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande de modification approuv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333636921305813)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande de modification rejet\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085162077306395)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364273080305836)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma sera cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494165990305932)
,p_name=>'F4050.DECLINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Refus\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333018414305813)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'fr'
,p_message_text=>unistr('Refus\00E9 : demande de compte pour %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333424926305813)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 %0 Mo d''espace de stockage suppl\00E9mentaire dans l''espace de travail %1 ; votre demande a \00E9t\00E9 rejet\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333266141305813)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 le sch\00E9ma de base de donn\00E9es %0 dans l''espace de travail %1 ; votre demande a \00E9t\00E9 rejet\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333317834305813)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 l''interruption de service pour l''espace de travail %0 ; votre demande a \00E9t\00E9 rejet\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084826954306395)
,p_name=>'F4050.DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910792356305473)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cliquez sur le lien ci-dessous pour terminer le processus d''approbation. Une fois termin\00E9, vous recevrez les informations d''identification de votre espace de travail dans un courriel de suivi.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332903430305813)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cliquez sur le lien ci-dessous pour d\00E9marrer.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085368549306396)
,p_name=>'F4050.FAILED'
,p_message_language=>'fr'
,p_message_text=>'Echec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938478193305498)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'fr'
,p_message_text=>'Cliquez <a href=''%0''>ici</a> pour terminer le processus d''approbation et recevoir vos informations d''identification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248900844305749)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'fr'
,p_message_text=>'Informations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260147431305758)
,p_name=>'F4050.INSTALL'
,p_message_language=>'fr'
,p_message_text=>'Installer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494216934305932)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('En cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258931217305757)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Aucune action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277075780305770)
,p_name=>'F4050.P23.USE'
,p_message_language=>'fr'
,p_message_text=>'Utiliser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088397098306398)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rification des mises \00E0 jour d\00E9sactiv\00E9e pour l''ensemble de l''instance')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277175129305770)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364046651305836)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259232663305757)
,p_name=>'F4050.PROVISION'
,p_message_language=>'fr'
,p_message_text=>'Provisionner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332465779305812)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande de modification approuv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332334396305812)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 le sch\00E9ma de base de donn\00E9es %0 dans l''espace de travail %1 ; votre demande a \00E9t\00E9 approuv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085441404306396)
,p_name=>'F4050.REMOTE'
,p_message_language=>'fr'
,p_message_text=>'Distant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494357301305932)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Demand\00E9(e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258430081305756)
,p_name=>'F4050.RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332503418305812)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : Le sch\00E9ma demand\00E9 est restreint car il s''agit d''un sch\00E9ma Oracle par d\00E9faut ou en raison de r\00E8gles propres au site. Les sch\00E9mas restreints ne peuvent pas \00EAtre affect\00E9s \00E0 des espaces de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084952714306395)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle tentative programm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364434702305836)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Un sch\00E9ma existant sera r\00E9utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085099823306395)
,p_name=>'F4050.RUNNING'
,p_message_language=>'fr'
,p_message_text=>unistr('En cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084765176306395)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'fr'
,p_message_text=>unistr('Programm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332178420305812)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : Le sch\00E9ma demand\00E9 est d\00E9j\00E0 affect\00E9 \00E0 un ou plusieurs espaces de travail. Assurez-vous que les r\00E8gles de s\00E9curit\00E9 du site autorisent l''acc\00E8s au m\00EAme sch\00E9ma par plusieurs espaces de travail avant d''approuver cette demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332081978305812)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : Le sch\00E9ma demand\00E9 existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364774464305836)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364975163305836)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma est r\00E9serv\00E9 et ne peut pas \00EAtre affect\00E9 \00E0 des espaces de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332257741305812)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : Le sch\00E9ma demand\00E9 est restreint car il s''agit d''un sch\00E9ma par d\00E9faut Oracle ou en raison de r\00E8gles propres au site. Si vous continuez, et donc affectez ce sch\00E9ma \00E0 l''espace de travail, vous donnerez aux d\00E9veloppeurs travaillant dans c')
||unistr('et espace de travail un acc\00E8s complet au sch\00E9ma. Assurez-vous que cette action est conforme aux r\00E8gles de s\00E9curit\00E9 de votre site avant d''approuver cette demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101364861680305836)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma est restreint par des r\00E8gles de s\00E9curit\00E9. Les sch\00E9mas restreints ne peuvent pas \00EAtre affect\00E9s \00E0 des espaces de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333793584305813)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Service interrompu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333887811305813)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre service de d\00E9veloppement "%0" a \00E9t\00E9 interrompu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085500215306396)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493898655305932)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'fr'
,p_message_text=>'Suspendu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493999880305932)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101494431373305932)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'fr'
,p_message_text=>'Interrompu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084672466306395)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'Interruption en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259583631305757)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'fr'
,p_message_text=>'Voir une demande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259921958305758)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'fr'
,p_message_text=>'Export d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025989214305565)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil de l''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026037089305565)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Connexion \00E0 l''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329714924305810)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail ne sera pas cr\00E9\00E9 car un espace de travail portant le m\00EAme ID existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329698799305810)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail ne sera pas cr\00E9\00E9 car un espace de travail portant le m\00EAme nom existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102539146305623)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail %0 a \00E9t\00E9 cr\00E9\00E9 dans %1. La confirmation a \00E9t\00E9 envoy\00E9e \00E0 l''adresse \00E9lectronique fournie lors de l''inscription.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931717238305491)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail ne sera pas cr\00E9\00E9 car il existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931811900305492)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail sera cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166993528305670)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'fr'
,p_message_text=>'Nouveau mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166882360305670)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mot de passe du compte utilisateur %0 a \00E9t\00E9 chang\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166795482305670)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre mot de passe a \00E9t\00E9 chang\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049839900306369)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page permet de d\00E9terminer si %0 est mis \00E0 niveau imm\00E9diatement lorsque la prochaine version est disponible ou si la mise \00E0 niveau est diff\00E9r\00E9e de %1 jours au maximum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049907928306369)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur Mettre \00E0 niveau maintenant pour d\00E9marrer d\00E8s maintenant la mise \00E0 niveau plut\00F4t que le %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049595254306369)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le syst\00E8me est \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049608249306369)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'%0 %1 est <a href="%2" target="_blank" rel="noreferrer">disponible</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048613315306368)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E8s qu''une nouvelle version %0 sera disponible, l''instance sera <strong>imm\00E9diatement</strong> mise \00E0 niveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049358551306368)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'fr'
,p_message_text=>unistr('L''instance sera automatiquement mise \00E0 niveau sur <strong>%0</strong>. Cliquez sur l''ic\00F4ne repr\00E9sentant un engrenage pour effectuer la mise \00E0 niveau maintenant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048557989306368)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 mises \00E0 niveau de l''instance sont <strong>diff\00E9r\00E9es</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590540898306006)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 est en cours de mise \00E0 niveau vers %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918666393305479)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateur de base de donn\00E9es %0 cr\00E9\00E9 avec le tablespace par d\00E9faut %1 utilisant le fichier de donn\00E9es %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935455120305496)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'fr'
,p_message_text=>unistr('Espace de travail %0 provisionn\00E9 avec l''administrateur %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067297766305595)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'fr'
,p_message_text=>'Afficher tous les espaces de travail'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058521323305589)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('La longueur de colonne ne peut pas \00EAtre Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058447325305589)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'fr'
,p_message_text=>unistr('La longueur de colonne ne peut pas \00EAtre \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058754235305589)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'fr'
,p_message_text=>unistr('Les noms de colonne ne peuvent pas d\00E9passer %0 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058895267305589)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'Les noms de colonne ne peuvent pas avoir la valeur Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059355274305590)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'fr'
,p_message_text=>unistr('<strong>%0</strong> est d\00E9j\00E0 utilis\00E9 par un objet existant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059510449305590)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('<strong>%0</strong> n''est pas un nom de s\00E9quence valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058171623305589)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de table existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059149196305589)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('<strong>%0</strong> n''est pas un nom de cl\00E9 primaire valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277233515305770)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101248284501305749)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'fr'
,p_message_text=>'Import de feuille de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059042196305589)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'fr'
,p_message_text=>unistr('Les noms de table ne doivent pas d\00E9passer %0 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069721179305599)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('La premi\00E8re ligne contient des noms de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395502265305859)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'fr'
,p_message_text=>'Import de texte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095573543305618)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258256872305756)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'(disponible)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258060801305756)
,p_name=>'F4350.CHANGE'
,p_message_language=>'fr'
,p_message_text=>'Modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433172395305887)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous demandez l''affectation du sch\00E9ma existant %0 \00E0 votre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433286853305887)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous demandez la cr\00E9ation du sch\00E9ma %0 et son affectation \00E0 votre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257723195305755)
,p_name=>'F4350.CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101671842305622)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de l''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258145884305756)
,p_name=>'F4350.CURRENT'
,p_message_language=>'fr'
,p_message_text=>'(en cours)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096042378305618)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'fr'
,p_message_text=>'Date/Heure actuelle (sur le serveur)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095871739305618)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257954700305756)
,p_name=>'F4350.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102731380305623)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation de l''espace de travail est d\00E9sactiv\00E9e temporairement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095462033305618)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma d''h\00F4te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257415365305755)
,p_name=>'F4350.INSERTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E9r\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095934850305618)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence de langue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095301993305618)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'fr'
,p_message_text=>'Heure du dernier DDL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579142569305997)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'fr'
,p_message_text=>'Heure du dernier patch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902287197305467)
,p_name=>'F4350.MORE'
,p_message_language=>'fr'
,p_message_text=>'%0 en plus...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579033316305997)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Version de patch'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095173191305617)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'fr'
,p_message_text=>'Build du produit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626929250306033)
,p_name=>'F4350.RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095285091305618)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Compatibilit\00E9 de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902115617305466)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'(+%0 applications traduites)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257651505305755)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'fr'
,p_message_text=>'Inconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257534937305755)
,p_name=>'F4350.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095629943305618)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095733536305618)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de l''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803876728306171)
,p_name=>'F4350_AJAX'
,p_message_language=>'fr'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803756208306171)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'fr'
,p_message_text=>'Callback d''authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259173785305757)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal des clics :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259009094305757)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es du journal des activit\00E9s de d\00E9veloppeur :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259678889305757)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'fr'
,p_message_text=>'Nombre d''utilisateurs distincts pour l''ensemble des sessions = %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260003040305758)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('aucun utilisateur s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260387418305758)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Il existe %0 pr\00E9f\00E9rences pour les utilisateurs de %1 dans l''espace de travail "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876531891305447)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'fr'
,p_message_text=>unistr('Il existe %0 pr\00E9f\00E9rences pour les utilisateurs de %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258851079305757)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialisez vos pr\00E9f\00E9rences si vous voulez ex\00E9cuter l''application sans valeurs pr\00E9d\00E9finies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933599083305494)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialisez le statut de session si vous souhaitez ex\00E9cuter l''application sans valeurs pr\00E9d\00E9finies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260440753305758)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateur s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259743519305757)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'fr'
,p_message_text=>'Sessions ayant plus de %0 jour(s) = %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259816309305757)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'fr'
,p_message_text=>'Sessions ayant plus de %0 minute(s) = %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258398303305756)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre session est identifi\00E9e par %0 et contient %1 entr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261065539305758)
,p_name=>'F4350_SQL'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260243685305758)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101259495403305757)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'fr'
,p_message_text=>'Le nombre total de sessions pour l''espace de travail "%0" est %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876464073305447)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'fr'
,p_message_text=>'Nombre total de sessions : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260519406305758)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur %0 a %1 pr\00E9f\00E9rences.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101258782145305756)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour l''utilisateur en cours %0, %1 pr\00E9f\00E9rences sont d\00E9finies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101260672301305758)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9mas d''espace de travail')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263188663305760)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence d''affichage dans les panneaux doit avoir une valeur num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263259335305760)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence d''affichage dans les \00E9tats doit avoir une valeur num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066610860305595)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom d''argument <strong>%0</strong> est utilis\00E9 plusieurs fois dans cette fonction.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266287387305762)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ordre d''ex\00E9cution doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266172711305762)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ordre d''ex\00E9cution doit avoir une valeur num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249046759305749)
,p_name=>'F4500.FIND'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277415999305771)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'fr'
,p_message_text=>'Masquer le code SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249405856305750)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'fr'
,p_message_text=>'Agrandir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249304597305749)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer la colonne vers le bas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249253116305749)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer la colonne vers le haut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060377391305590)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un num\00E9ro d''ordre d''ex\00E9cution unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861566332305436)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelles colonnes \00E0 ajouter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059933633305590)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'fr'
,p_message_text=>'<strong>%0</strong> n''est pas un nom d''objet valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059751250305590)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'fr'
,p_message_text=>'<strong>%0</strong> n''est pas un nom de table valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249181234305749)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Aucune image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249530840305750)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'fr'
,p_message_text=>'nullable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362851156305835)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cutions pr\00E9c\00E9dentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066131413305595)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Les noms de colonne <strong>%0</strong> sont utilis\00E9s plusieurs fois dans cette table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066527175305595)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('Au moins un nom de colonne doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066431392305595)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'fr'
,p_message_text=>'Le nom de colonne <strong>%0</strong> n''est pas valide.<br />'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066244564305595)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'fr'
,p_message_text=>unistr('La pr\00E9cision de la colonne <strong>%0</strong> n''est pas valide.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066345374305595)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9chelle de la colonne <strong>%0</strong> n''est pas valide.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916616692305478)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9chelle de la colonne <strong>%0</strong> est obligatoire.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277537797305771)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un synonyme pour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101277392117305770)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'fr'
,p_message_text=>'Afficher le code SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060002235305590)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Table <strong>%0</strong> introuvable dans le sch\00E9ma <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865613314305439)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clarations d''avertissement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262295124305759)
,p_name=>'F4500_BROKEN'
,p_message_language=>'fr'
,p_message_text=>'Interrompu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262775481305760)
,p_name=>'F4500_BYTES'
,p_message_language=>'fr'
,p_message_text=>'Octets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262669428305760)
,p_name=>'F4500_CARD'
,p_message_language=>'fr'
,p_message_text=>'Carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262048482305759)
,p_name=>'F4500_CHECK'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254505411305753)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez pour remplir le champ de requ\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262549504305759)
,p_name=>'F4500_COST'
,p_message_language=>'fr'
,p_message_text=>unistr('Co\00FBt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253879039305753)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de cr\00E9ation a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031956099306355)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets sans valeurs par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031845011306355)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets avec valeurs par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253100032305752)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de suppression a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905688023305469)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'fr'
,p_message_text=>'Etranger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167112328305671)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cl\00E9 \00E9trang\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066949526305595)
,p_name=>'F4500_NATIVE'
,p_message_language=>'fr'
,p_message_text=>'Format de fichier natif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252859071305752)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'fr'
,p_message_text=>'non disponible pour modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262311947305759)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'fr'
,p_message_text=>'non disponible pour recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262166638305759)
,p_name=>'F4500_OF'
,p_message_language=>'fr'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101262445862305759)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'fr'
,p_message_text=>'Optimiseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254833565305753)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242501421305744)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Aucun message d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395453909305859)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'fr'
,p_message_text=>'Les types de colonne VARCHAR n''existent pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939828145305499)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'fr'
,p_message_text=>'Analyse du script en cours - patientez.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886592230305455)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'fr'
,p_message_text=>'Nombre d''instructions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128320281305642)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'fr'
,p_message_text=>'le %0 par %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250233436305750)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Si le script comporte des param\00E8tres, d\00E9finissez-les avant l''ex\00E9cution.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886456504305455)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128290306305642)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille du script en octets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124547458305639)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250446280305750)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409118956305869)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 l''import des scripts suivants. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101409234800305869)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La taille des scripts dont vous avez demand\00E9 l''import d\00E9passe la capacit\00E9 de stockage autoris\00E9e. Contactez l''administrateur %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410268674305870)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Script \00E0 importer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250994816305751)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Aucune erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250788309305750)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'fr'
,p_message_text=>'Num.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230617631305736)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Voir la sortie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311582255305797)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'fr'
,p_message_text=>unistr('Parcourir les s\00E9quences')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311674028305797)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de cr\00E9ation de s\00E9quence a \00E9chou\00E9 pour la raison suivante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311452883305797)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence "%0" a \00E9t\00E9 cr\00E9\00E9e dans le sch\00E9ma "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251133464305751)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'fr'
,p_message_text=>'Instruction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311920844305797)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'fr'
,p_message_text=>unistr('Parcourir les synonymes de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312139311305797)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de cr\00E9ation de synonyme a \00E9chou\00E9 pour la raison suivante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311860342305797)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le synonyme "%0" a \00E9t\00E9 cr\00E9\00E9 dans le sch\00E9ma "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312266310305798)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de cr\00E9ation de package a \00E9chou\00E9 pour la raison suivante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312363451305798)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le package "%0" a \00E9t\00E9 cr\00E9\00E9 dans le sch\00E9ma "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093935767305617)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer dans une feuille de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251444501305751)
,p_name=>'F4500_P25_BY'
,p_message_language=>'fr'
,p_message_text=>'Par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251357409305751)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251251195305751)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907398314305471)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Expir\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907404839305471)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Expir\00E9 et verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907215390305470)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907114518305470)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311353946305797)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration a \00E9chou\00E9 pour la raison suivante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288439586305779)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'fr'
,p_message_text=>unistr('non disponible pour l''insertion de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311215730305797)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Parcourir la vue de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310915063305797)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de cr\00E9ation de vue a \00E9chou\00E9 pour la raison suivante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311072652305797)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil de SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101311123002305797)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('La vue "%0" a \00E9t\00E9 cr\00E9\00E9e dans le sch\00E9ma "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101279786906305772)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'fr'
,p_message_text=>'Obtenir le commentaire de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437398023305890)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Identit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938387676305498)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun type de donn\00E9es indiqu\00E9 pour %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252910360305752)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de table a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250066184305750)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'fr'
,p_message_text=>'Ce fichier comporte %0 instructions.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250152885305750)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur a d\00E9fini le(s) %0 param\00E8tre(s) suivant(s) :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067183027305595)
,p_name=>'F4500_PARSE'
,p_message_language=>'fr'
,p_message_text=>'Analyser ce script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261879142305759)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'fr'
,p_message_text=>'Primaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870718478305443)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rentiel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101067096802305595)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Voir le document en tant que texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101261977201305759)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>'Unique'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111358769306415)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'fr'
,p_message_text=>unistr('Il existe des probl\00E8mes avec la configuration des fichiers statiques dans votre environnement. Consultez la section "Configuring Static File Support" du manuel Application Express Installation Guide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454791166305903)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'fr'
,p_message_text=>unistr('Bienvenue dans Oracle APEX. Connectez-vous \00E0 l''aide du mot de passe administrateur (ADMIN) de votre base de donn\00E9es autonome.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107450092306412)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous recevez ce courriel car vous avez demand\00E9 un espace de travail Oracle APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107310895306412)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'fr'
,p_message_text=>'Action requise : demande de compte pour %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331024676305811)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'fr'
,p_message_text=>unistr('(utilis\00E9 pour l''envoi par courriel de vos informations d''identification)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331253288305811)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez un sch\00E9ma de base de donn\00E9es qui existe actuellement dans votre base Oracle. Pour des raisons de s\00E9curit\00E9, il n''y a pas de liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331174392305811)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom du sch\00E9ma de base de donn\00E9es Oracle dont vous voudriez qu''il soit cr\00E9\00E9 pour votre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330415198305811)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dans la description ci-dessous, expliquez pourquoi vous demandez un sch\00E9ma restreint.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330517630305811)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Dans la description ci-dessous, expliquez pourquoi vous demandez un sch\00E9ma qui est d\00E9j\00E0 utilis\00E9 par d''autres espaces de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330956132305811)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : L''acc\00E8s au sch\00E9ma que vous demandez est restreint pour des raisons de s\00E9curit\00E9. L''administrateur %0 peut refuser votre demande d''affectation de ce sch\00E9ma \00E0 votre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330878908305811)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : Le sch\00E9ma que vous demandez est d\00E9j\00E0 utilis\00E9 par d''autres espaces de travail. L''administrateur %0 peut rejeter votre demande d''affectation de ce sch\00E9ma \00E0 votre espace de travail. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327812330305809)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nouveau sch\00E9ma que vous avez demand\00E9 pour votre espace de travail est un sch\00E9ma par d\00E9faut Oracle, ou est restreint sur votre site pour des raisons de s\00E9curit\00E9 et ne peut pas \00EAtre affect\00E9 \00E0 un espace de travail. L''administrateur du site peut rejet')
||unistr('er votre demande de provisionnement si cela contrevient aux r\00E8gles de s\00E9curit\00E9 du site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327764951305809)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma que vous avez demand\00E9 pour votre espace de travail est d\00E9j\00E0 affect\00E9 \00E0 %0 espace(s) de travail. L''administrateur du site peut rejeter votre demande de provisionnement si cela contrevient aux r\00E8gles de s\00E9curit\00E9 du site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903069803305467)
,p_name=>'F4700P1_A'
,p_message_language=>'fr'
,p_message_text=>unistr('Oracle APEX permet d''acc\00E9der \00E0 une base de donn\00E9es Oracle et \00E0 des outils de d\00E9veloppement de navigateur Web.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903163625305467)
,p_name=>'F4700P1_B'
,p_message_language=>'fr'
,p_message_text=>unistr('Construire des applications Web de mani\00E8re d\00E9clarative')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903251798305467)
,p_name=>'F4700P1_C'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er et g\00E9rer des objets de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903383117305467)
,p_name=>'F4700P1_D'
,p_message_language=>'fr'
,p_message_text=>unistr('Suivre les jalons, les bugs, les fonctionnalit\00E9s et les t\00E2ches \00E0 effectuer<')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041869363306363)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application s''est install\00E9e. N\00E9anmoins, pour l''ex\00E9cuter avec une authentification de compte Application Express, un compte utilisateur Application Express doit \00EAtre configur\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041932861306363)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'fr'
,p_message_text=>unistr('La feuille Web s''est install\00E9e. N\00E9anmoins, pour l''ex\00E9cuter avec une authentification de compte Application Express, un administrateur dot\00E9 d''un compte Application Express doit \00EAtre configur\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395685410305859)
,p_name=>'F4750.VERSION'
,p_message_language=>'fr'
,p_message_text=>'Version'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065944430306381)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de r\00E9initialiser les donn\00E9es \00E9chantillon des services RESTful : le sch\00E9ma <code>%0</code> n''existe pas.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640743761306043)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette application utilise le mod\00E8le d''authentification %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675152783306075)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherche \00E0 facets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648576983306049)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''assistant ne peut pas cr\00E9er de recherche \00E0 facets avec la source de l''\00E9tat. Il n''existe pas de colonnes sur lesquelles effectuer la recherche.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460325986305908)
,p_name=>'FAILURE'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E9chec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251617217305751)
,p_name=>'FAILURES'
,p_message_language=>'fr'
,p_message_text=>'Echecs'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326072403305808)
,p_name=>'FDASH1'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367573863305838)
,p_name=>'FEATURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086388858306396)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taires des fonctionnalit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040032487305575)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'A propos de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040721216305576)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'A propos de cette page d''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040122319305575)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040871812305576)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Incorporez l''authentification utilisateur bas\00E9e sur les r\00F4les dans votre application et g\00E9rez les mappings de nom utilisateur avec les r\00F4les d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040204086305576)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tats d''activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040954827305576)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Incluez de nombreux \00E9tats et graphiques relatifs \00E0 l''activit\00E9 des utilisateurs finals.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040321460305576)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041724683305577)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Autorisez les administrateurs de l''application \00E0 activer ou \00E0 d\00E9sactiver une fonctionnalit\00E9 sp\00E9cifique associ\00E9e \00E0 une option de construction d''Application Express \00E0 partir de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339891440305818)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Les options de construction suivantes seront cr\00E9\00E9es :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400505932305863)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tats de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400691985305863)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclut un \00E9tat sur la file d''attente des courriels APEX_SEND().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457211878305905)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclut un \00E9tat affichant le courriel \00E0 envoyer joint avec le journal des courriels d\00E9j\00E0 envoy\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040426899305576)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041052362305576)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez un m\00E9canisme permettant aux utilisateurs finals de publier des commentaires g\00E9n\00E9raux \00E0 l''intention des administrateurs et des d\00E9veloppeurs de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400728874305863)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ration d''\00E9tat sur les travaux')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400895935305863)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclut un \00E9tat sur les travaux de base de donn\00E9es, avec la capacit\00E9 d''effectuer une analyse descendante sur un travail sp\00E9cifique pour obtenir des d\00E9tails compl\00E9mentaires.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101040523226305576)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection du style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101041682064305577)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Autorisez les administrateurs \00E0 s\00E9lectionner un sch\00E9ma de couleur par d\00E9faut (style de th\00E8me) pour l''application. Les administrateurs ont \00E9galement la possibilit\00E9 d''autoriser les utilisateurs \00E0 choisir leur propre style de th\00E8me. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347756241305824)
,p_name=>'FEATURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655862190306054)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s \00E0 100 %')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404934175305866)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s \00E0 100 % (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370108578305840)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s \00E0 80 %')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898168324305463)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'fr'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896935933305462)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s termin\00E9es (%0/%1) :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898063228305463)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658350422306056)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s pour la version %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405149472305866)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'fr'
,p_message_text=>'Echues (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674429743306075)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage de fonctionnalit\00E9s op\00E9rationnelles (%0/%1) :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405045545305866)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'fr'
,p_message_text=>'Avec les dates (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437250890305890)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Configuration des fonctionnalit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343231404305820)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'fr'
,p_message_text=>'Contributeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404820234305866)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre de fonctionnalit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651855308306051)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 fonctionnalit\00E9s, %1 totalement termin\00E9e(s), dans %2 version(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651904190306051)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 fonctionnalit\00E9s de niveau sup\00E9rieur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652065239306051)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''ont pas de date d''\00E9ch\00E9ance, %1 sont \00E9chues et moins de 80 % sont termin\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652115064306051)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 fonctionnalit\00E9s sont op\00E9rationnelles, %1 ne le sont pas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655568124306054)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 % des fonctionnalit\00E9s sont termin\00E9es \00E0 100 %')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341518851305819)
,p_name=>'FEATURE_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Description de la fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342525602305820)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rabilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073485626306386)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9 : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341159475305819)
,p_name=>'FEATURE_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341274638305819)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de la fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342279744305820)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Priorit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342312551305820)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342108414305820)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'fr'
,p_message_text=>'Balises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086403536306396)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Non affect\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088836502306398)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 consign\00E9 et affect\00E9 \00E0 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367437875305838)
,p_name=>'FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383007148305850)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fournissez ces informations \00E0 consigner dans le journal sous forme d''informations en retour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453552630305903)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'fr'
,p_message_text=>'Tableau de bord des informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347338956305823)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es d''informations en retour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897246323305463)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('%2 entr\00E9es d''informations en retour ouvertes (%0 ferm\00E9es)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382855034305849)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez vos informations en retour et cliquez sur le bouton Soumettre les informations en retour.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674728315306075)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage d''informations en retour ferm\00E9es (%0/%1) :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378093790305846)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type d''informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382983216305850)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'fr'
,p_message_text=>'Identifiez le type d''informations en retour que vous fournissez.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545772985305969)
,p_name=>'FILENAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350411354305826)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de nom de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593129990306008)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Nom du fichier : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348997390305825)
,p_name=>'FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028489051306353)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'fr'
,p_message_text=>'%0 fichiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348470901305824)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'fr'
,p_message_text=>'%0 fichiers, consommation : %1 k'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073240533306386)
,p_name=>'FILE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Fichier : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100876128764305447)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce fichier texte est trop volumineux pour \00EAtre modifi\00E9. Vous devez d''abord le modifier sur votre machine locale, puis le t\00E9l\00E9charger de nouveau vers le serveur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910502402305473)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune session valide n''existe et des fichiers ont \00E9t\00E9 t\00E9l\00E9charg\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910455059305473)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de fichiers t\00E9l\00E9charg\00E9s dans cette demande est sup\00E9rieur au nombre de types d''\00E9l\00E9ment de fichiers d\00E9finis sur cette page.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400969050305863)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Rechercher mon espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881591338305451)
,p_name=>'FIND_TABLES'
,p_message_language=>'fr'
,p_message_text=>'Rechercher des tables'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108692515306413)
,p_name=>'FINISH'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253552318305752)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Premi\00E8re entr\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406645647305867)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de correction \00E9chue')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323065207305805)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corrig\00E9 au cours du d\00E9veloppement')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341330615305819)
,p_name=>'FOCUS_AREA'
,p_message_language=>'fr'
,p_message_text=>'Domaine d''attention'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124022210305639)
,p_name=>'FOOTER'
,p_message_language=>'fr'
,p_message_text=>'Texte de pied de page'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863278346305437)
,p_name=>'FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071953589306385)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Masque de format : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405250300305866)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Panneau et vue de liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405319940305866)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat avec panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241277184305743)
,p_name=>'FORM_ON'
,p_message_language=>'fr'
,p_message_text=>'Panneau dans %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982705233305531)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Panneau sur une table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384510313305851)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du panneau sur une requ\00EAte a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384801719305851)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du panneau et de l''\00E9tat sur une r\00E9f\00E9rence de service Web a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382136811305849)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du panneau a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384602370305851)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation de la page r\00E9capitulative a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384256422305851)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du panneau sur une table a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384731514305851)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du panneau sur une r\00E9f\00E9rence de service Web a r\00E9ussi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931991941305492)
,p_name=>'FORWARD'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441785610305893)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E0 partir du dictionnaire d''attributs')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070237289305599)
,p_name=>'FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331509511305812)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnellement termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321347325305804)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Impl\00E9mentation de fonction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125694082305640)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071655519305600)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381832503305849)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant un curseur de r\00E9f\00E9rence')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374999668305844)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une valeur bool\00E9enne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930750052305490)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction PL/SQL renvoyant une valeur bool\00E9enne')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368627567305839)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'fr'
,p_message_text=>'Futurs jalons'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021139973306347)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021031171306347)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'fr'
,p_message_text=>unistr('Fin de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020975528306347)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374544978305843)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'fr'
,p_message_text=>'Date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374413059305843)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608515530306019)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020664661306347)
,p_name=>'GANTT_DATE'
,p_message_language=>'fr'
,p_message_text=>'Date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020563392306347)
,p_name=>'GANTT_END'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020763967306347)
,p_name=>'GANTT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020877633306347)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'Progression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020336261306347)
,p_name=>'GANTT_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020490846306347)
,p_name=>'GANTT_START'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805978165306173)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'fr'
,p_message_text=>'Collecter les statistiques de la table'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324152466305806)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Commentaire g\00E9n\00E9ral')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674836877306075)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'fr'
,p_message_text=>unistr('Commentaires g\00E9n\00E9raux : %1 sur %0 ferm\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935883287305496)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette table a \00E9t\00E9 cr\00E9\00E9e \00E0 l''aide de l''assistant Table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020229170305561)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifications enregistr\00E9es.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101330195094305811)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er ou modifier une liste de valeurs (LOV) statique')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343498132305821)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'fr'
,p_message_text=>'Destinataire de la globalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341614015305819)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'fr'
,p_message_text=>'Impact de globalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344499224305821)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut de globalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864438243305438)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page globale'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389046782305854)
,p_name=>'GRAY_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte gris'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363940853305836)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'fr'
,p_message_text=>'Masquer des colonnes de mise en page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363857833305836)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'fr'
,p_message_text=>'Afficher les colonnes de mise en page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962539956305516)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de grille')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306044958305793)
,p_name=>'GROUPS'
,p_message_language=>'fr'
,p_message_text=>'Groupes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498588667305935)
,p_name=>'GROUP_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Groupe : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101123961999305638)
,p_name=>'HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''en-t\00EAte')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498378360305935)
,p_name=>'HEADING_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte : %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068907483306383)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''aide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072098806305601)
,p_name=>'HELP_TEXT'
,p_message_language=>'fr'
,p_message_text=>'texte d''aide'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167046335305670)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9 et prot\00E9g\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325233340305807)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Tr\00E8s souhaitable')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027954217306352)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'fr'
,p_message_text=>unistr('Contraste \00E9lev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789573873306161)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer/d\00E9sactiver le contraste \00E9lev\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305851067305793)
,p_name=>'HISTORY'
,p_message_language=>'fr'
,p_message_text=>'Historique'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381618789305849)
,p_name=>'HOME_LINK'
,p_message_language=>'fr'
,p_message_text=>'Lien de page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860369453305435)
,p_name=>'HOME_NAV'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913101148305475)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs :'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099084306305620)
,p_name=>'HORIZONTAL'
,p_message_language=>'fr'
,p_message_text=>'horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845697970305424)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 2D, horizontales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845789772305424)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 3D, horizontales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845891120305424)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 2D, horizontales, avec plage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100845922251305425)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 3D, horizontales, avec plage'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068364605306382)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le actif')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903510424305468)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte HR d\00E9verrouill\00E9.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073182175305601)
,p_name=>'HTML'
,p_message_language=>'fr'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092151123305615)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'HTML avec raccourcis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091893029305615)
,p_name=>'HTML_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934432123305495)
,p_name=>'HTML_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943868995305502)
,p_name=>'HTML_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124225581305639)
,p_name=>'HTML_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943975012305502)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'fr'
,p_message_text=>'HTML/Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071757280305600)
,p_name=>'HTML_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944075016305502)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'Texte HTML avec raccourcis'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068559322306383)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004220051306334)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Indique que le th\00E8me est compatible avec IE 6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411364974305870)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'fr'
,p_message_text=>'Autoriser la modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411467720305870)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'fr'
,p_message_text=>'Lecture seule'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073382063305602)
,p_name=>'IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614183502306024)
,p_name=>'IMAGES'
,p_message_language=>'fr'
,p_message_text=>'Images'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057735857305588)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381068125305848)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe d''image')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318955886305802)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Importer depuis une application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080294997306392)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle valeur pour la cha\00EEne de substitution %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548864956305974)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre fichier import\00E9 se trouve dans le <a href="%0">r\00E9f\00E9rentiel d''export</a>. A moins que vous ne pr\00E9voyiez de l''installer une nouvelle fois, vous devez l''enlever.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254400860305753)
,p_name=>'IN/OUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e/sortie')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870963828305443)
,p_name=>'INACTIVE'
,p_message_language=>'fr'
,p_message_text=>'Inactif'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453396713305902)
,p_name=>'INCLUDE'
,p_message_language=>'fr'
,p_message_text=>'Inclure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072829774306386)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Inclure : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070399890305599)
,p_name=>'INDEX'
,p_message_language=>'fr'
,p_message_text=>'index'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450715940305901)
,p_name=>'INDEX_NOUN'
,p_message_language=>'fr'
,p_message_text=>'Index'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014761862305557)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228766149305734)
,p_name=>'INLINE'
,p_message_language=>'fr'
,p_message_text=>'Incorporation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018228664306345)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''aide incorpor\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228635173305734)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Incorpor\00E9 et dans une notification')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374633523305843)
,p_name=>'INPUT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''entr\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071079948305600)
,p_name=>'INSERT'
,p_message_language=>'fr'
,p_message_text=>unistr('ins\00E9rer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460199624305908)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'fr'
,p_message_text=>'exception d''insertion dans wwv_flow_companies :'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390717335305855)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'fr'
,p_message_text=>'CSS (application)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390535854305855)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image (application)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390934304305856)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'fr'
,p_message_text=>'Fichier statique (application)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899811649305465)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>'Options de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957314202305512)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvent choisir d''inclure les options de construction ci-apr\00E8s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899746129305465)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>'Substitutions d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957240445305512)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvez configurer les attributs ci-apr\00E8s de votre application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900002434305465)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'fr'
,p_message_text=>'Confirmation de l''installation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957505945305512)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Confirmez que vous souhaitez installer les objets de prise en charge de cette application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900462408305465)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Confirmation de la d\00E9sinstallation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100875022224305446)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Script de d\00E9sinstallation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900531840305465)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s de la d\00E9sinstallation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957889601305513)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sinstallation termin\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244763800305746)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Erreur lors de la v\00E9rification de l''installation "%0" :'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244806788305746)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Erreur lors de l''ex\00E9cution du script d''installation "%0":'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899685702305464)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la v\00E9rification d''existence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900229551305465)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'fr'
,p_message_text=>'Echec de la post-installation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957799252305513)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''installation des objets de base de donn\00E9es et des donn\00E9es pr\00E9d\00E9finies a \00E9chou\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307163257305794)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''installeur d''application a d\00E9tect\00E9 que les objets de prise en charge de cette application ont d\00E9j\00E0 \00E9t\00E9 install\00E9s. Les objets doivent \00EAtre enlev\00E9s via SQL Workshop pour que cette application puisse \00EAtre install\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900323323305465)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'fr'
,p_message_text=>'Licence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895543661305461)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'fr'
,p_message_text=>'Erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895411603305461)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900151452305465)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s de la post-installation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957641147305513)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de prise en charge de votre application ont \00E9t\00E9 install\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996669429305542)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Confirmez que vous souhaitez mettre \00E0 niveau les objets de prise en charge de cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996519256305542)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('La mise \00E0 niveau des objets de prise en charge de cette application a \00E9chou\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996109613305541)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''installeur d''application a d\00E9tect\00E9 que les objets de prise en charge de cette application ont d\00E9j\00E0 \00E9t\00E9 install\00E9s. Cet assistant vous guidera tout au long du processus de mise \00E0 niveau de ces objets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996458991305541)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de prise en charge de votre application ont \00E9t\00E9 mis \00E0 niveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899998297305465)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957449006305512)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les validations ci-apr\00E8s seront effectu\00E9es pour v\00E9rifier si votre syst\00E8me est compatible avec cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899565403305464)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'fr'
,p_message_text=>'Bienvenue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100957163630305512)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cet installeur d''application vous guide tout au long du processus de cr\00E9ation des objets de base de donn\00E9es et des donn\00E9es pr\00E9d\00E9finies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390643980305855)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'fr'
,p_message_text=>'CSS (espace de travail)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390448294305855)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'fr'
,p_message_text=>'Image (espace de travail)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390859038305855)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'fr'
,p_message_text=>'Fichier statique (espace de travail)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887852869305456)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Installer l''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391018588305856)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'fr'
,p_message_text=>unistr('Installer une application \00E9chantillon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788920897306160)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'fr'
,p_message_text=>'Accueil des services d''administration d''Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438267227305890)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''instance')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340222885305818)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette instance est en cours d''ex\00E9cution en mode de provisionnement manuel et n''acceptera donc pas de demande de service')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433373977305887)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'fr'
,p_message_text=>'Espace insuffisant pour installer cette application.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321449244305804)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Int\00E9gration termin\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326607560305808)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9connexion de l''int\00E9gration')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317162271305801)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'fr'
,p_message_text=>'Grille interactive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092867913305616)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat interactif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346667130305823)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherches d''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911825716305474)
,p_name=>'INTERNAL'
,p_message_language=>'fr'
,p_message_text=>'Interne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864120951305438)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'fr'
,p_message_text=>'Administration interne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913522003305475)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'fr'
,p_message_text=>'Interne'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240818843305743)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer un nom valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870876141305443)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'fr'
,p_message_text=>'Le fichier n''est pas une archive d''application valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241333096305744)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer un nom de groupe valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932615710305492)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'fr'
,p_message_text=>'L''objet %0 n''est pas valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594527180306009)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'fr'
,p_message_text=>'Vous devez saisir un nom de groupe de pages valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109142938306414)
,p_name=>'INVALID_POSITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Position non valide [Non affich\00E9e]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459874000305907)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de sch\00E9ma non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373697080305843)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e non valide ; la valeur doit \00EAtre un nombre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057929244306375)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 cha\00EEnes sont des noms utilisateur non valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459729710305907)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'fr'
,p_message_text=>'nom d''espace de travail non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400359871305862)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'fr'
,p_message_text=>'Objets de feuille Web non valides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398267188305861)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets de feuille Web non valides corrig\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400477504305862)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de base de donn\00E9es n\00E9cessaires pour cr\00E9er des applications Web ne sont pas valides ou n''existent pas. Contactez l''administrateur de l''espace de travail.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846017707305425)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'fr'
,p_message_text=>unistr('A courbes 2D invers\00E9es')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322909240305805)
,p_name=>'IN_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'En cours'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018701083305560)
,p_name=>'IR_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267155461305763)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267055326305763)
,p_name=>'IR_END_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267420730305763)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat interactif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243572598305745)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Un seul \00E9tat interactif peut \00EAtre affich\00E9 par page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267279065305763)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette bo\00EEte de dialogue s''affiche uniquement pour les d\00E9veloppeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266950558305763)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer un \00E9tat *')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267340430305763)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072485821306386)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Application : %0, page : %1, abonn\00E9 par : %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386271759305852)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La page Etat interactif a \00E9t\00E9 cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101267541691305763)
,p_name=>'IR_UNITS'
,p_message_language=>'fr'
,p_message_text=>unistr('Unit\00E9s')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807668349306174)
,p_name=>'ISSUES'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8mes')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255190898305754)
,p_name=>'IS_WRAPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('est encapsul\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366374923305837)
,p_name=>'ITEM CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944244572305502)
,p_name=>'ITEM NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911570622305474)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Boutons d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093110654306401)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'fr'
,p_message_text=>unistr('ColSpan d''\00E9l\00E9ment en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931028856305491)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''\00E9l\00E9ment dans Expression 1 = Expression 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100931147047305491)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''\00E9l\00E9ment dans Expression 1 != Expression 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930678720305490)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment dans Expression 1 est NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930559858305490)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment dans Expression 1 est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071608464306385)
,p_name=>'ITEM_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988795116305536)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988854560305536)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331632081305812)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Champ de texte avec \00E9criture automatique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617313702306026)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'fr'
,p_message_text=>unistr('Case \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987059093306321)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de couleur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446998823305898)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609540376306020)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de date (Classique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856229277305432)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de date (HTML5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101651796653306051)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611091909306021)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'fr'
,p_message_text=>'Afficher uniquement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650518349306050)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'fr'
,p_message_text=>'Exploration de fichiers...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986862730306321)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657427862306055)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'fr'
,p_message_text=>'Gestionnaire de liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673618130306074)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'fr'
,p_message_text=>'Editeur Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601430393306014)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'fr'
,p_message_text=>'Champ nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602915473306015)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610256221306021)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617285162306026)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'fr'
,p_message_text=>'Groupe de boutons d''option'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363172150305835)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'fr'
,p_message_text=>'Editeur de texte enrichi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609619822306020)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste SELECT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611694689306022)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'fr'
,p_message_text=>'Navette'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877387875305448)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'fr'
,p_message_text=>'Curseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988904713305536)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Arr\00EAter et d\00E9marrer une mise en page de grille (en phase d''abandon)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365199691305836)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'fr'
,p_message_text=>'Zone de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986924722306321)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'fr'
,p_message_text=>'Champ de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877002090305448)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'fr'
,p_message_text=>'Oui/Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938543246305498)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'fr'
,p_message_text=>'Module d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989038229305536)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626382540306033)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'fr'
,p_message_text=>unistr('Evaluation sous forme d''\00E9toiles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989117613305536)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026526245306351)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de texte de conclusion d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026402728306351)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de texte d''introduction d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391663567305856)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'fr'
,p_message_text=>'Ligne 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391721148305856)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'fr'
,p_message_text=>'Ligne 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391863150305856)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'fr'
,p_message_text=>'Ligne 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391913391305856)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'fr'
,p_message_text=>'Ligne 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601365500306014)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur maximale saisie, %0, pour l''\00E9l\00E9ment %1 n''est pas au format num\00E9rique. Si cette valeur contient des d\00E9cimales, indiquez le point comme s\00E9parateur d\00E9cimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601245243306014)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur minimale saisie, %0, pour l''\00E9l\00E9ment %1 n''est pas au format num\00E9rique. Si cette valeur contient des d\00E9cimales, indiquez le point comme s\00E9parateur d\00E9cimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877221345305448)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur d''\00E9tape saisie, %0, pour l''\00E9l\00E9ment %1 n''est pas au format num\00E9rique. Si cette valeur contient des d\00E9cimales, indiquez le point comme s\00E9parateur d\00E9cimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938925278305498)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939005550305498)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'fr'
,p_message_text=>'Exploration de fichiers...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939106546305498)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939261404305499)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9 et prot\00E9g\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939314898305499)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de couleur instantan\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939433181305499)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Champ de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939569336305499)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Champ de texte (d\00E9sactiv\00E9, n''enregistre pas le statut)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939682757305499)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Champ de texte (d\00E9sactiv\00E9, enregistre le statut)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939745971305499)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Champ de texte (soumission de la page lors de l''utilisation d''Entr\00E9e)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316970219305801)
,p_name=>'JET_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique JET'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252389125305752)
,p_name=>'JOB'
,p_message_language=>'fr'
,p_message_text=>'Travail'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318169686305802)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Activation/d\00E9sactivation de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318075007305802)
,p_name=>'JQM REFLOW'
,p_message_language=>'fr'
,p_message_text=>'Etat de reflux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393685291305857)
,p_name=>'JQM_FOOTER'
,p_message_language=>'fr'
,p_message_text=>'Pied de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393533131305857)
,p_name=>'JQM_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320073235305803)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue de liste'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317228106305801)
,p_name=>'JSTREE'
,p_message_language=>'fr'
,p_message_text=>'Arborescence JavaScript'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343399783305821)
,p_name=>'JUSTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Justification'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807726414306174)
,p_name=>'LABELS'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093068746306401)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'fr'
,p_message_text=>unistr('ColSpan de libell\00E9 en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086695829306396)
,p_name=>'LABEL_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de libell\00E9 d''\00E9l\00E9ment en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380190598305848)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045136044305579)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045294741305579)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045464733305579)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le n''est abonn\00E9 \00E0 ce mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101045336217305579)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de libell\00E9 en cours d''abonnement \00E0 ce mod\00E8le')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888309567305456)
,p_name=>'LANGUAGES'
,p_message_language=>'fr'
,p_message_text=>'Langues'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346173111305823)
,p_name=>'LAST_CHANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re modification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253681533305753)
,p_name=>'LAST_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349067783305825)
,p_name=>'LAST_LOGIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re connexion')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865712631305439)
,p_name=>'LAYOUT'
,p_message_language=>'fr'
,p_message_text=>'%0 - Mise en page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902761785305467)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s corps')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242099143305744)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de page apr\00E8s erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241737021305744)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s pied')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308058151305794)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656689111306054)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment post\00E9rieur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591254714306007)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591620669306007)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s le libell\00E9 et l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993034930305539)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232551820305737)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s traitement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241584885305744)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241833980305744)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s soumission')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902697318305467)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'fr'
,p_message_text=>'Avant corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232206301305737)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Avant calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242104876305744)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'fr'
,p_message_text=>'Pied de page avant erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241624890305744)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'fr'
,p_message_text=>'Avant pied'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232104427305737)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656580503306054)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment ant\00E9rieur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591174847306007)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591580916306007)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant le libell\00E9 et l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232460917305737)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Avant traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241485418305744)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232321589305737)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Avant validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301701293305788)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'fr'
,p_message_text=>'branchements'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983792442305532)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'fr'
,p_message_text=>unistr('Au-dessus de la bo\00EEte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983862533305532)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'fr'
,p_message_text=>unistr('Au-dessous de la bo\00EEte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983965084305532)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'fr'
,p_message_text=>'En bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984099192305532)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Changement de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984139787305532)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fermeture de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984280162305532)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'fr'
,p_message_text=>unistr('Copie de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984334705305533)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984454815305533)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Suppression de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984555980305533)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Modification de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984642758305533)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppement de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984743183305533)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le suivant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984867712305533)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100984995972305533)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224930090305732)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295624634305784)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444415984305896)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224141512305731)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224662650305731)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Copier un bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224399306305731)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton Cr\00E9er2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856449956305432)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Position personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444111715305896)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'fr'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444288361305896)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'fr'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224530592305731)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661099220306057)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 vide : #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068608641306383)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le erron\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224246190305731)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton D\00E9velopper')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166248473305670)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444529464305896)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'fr'
,p_message_text=>'Page globale : '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224498185305731)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Bouton Aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656726297306054)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'fr'
,p_message_text=>unistr('Lien d''aide d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661131094306058)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9 : #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166150719305670)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte HTML avec caract\00E8res sp\00E9ciaux d''\00E9chappement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018141168306345)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''aide incorpor\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026748426306352)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte de conclusion d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026637858306351)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''introduction d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224719311305731)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Botuon Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301611761305788)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune r\00E9gion au point d''affichage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444689855305896)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('Boutons et \00E9l\00E9ments de page sans r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334386949305814)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'fr'
,p_message_text=>'Fonctions callback AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591480096306007)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement d''erreur : Apr\00E8s libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591319131306007)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement d''erreur : Avant libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234693304305739)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement de nouvelle instance')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101234756924305739)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'A la soumission et avant calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224815828305731)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444821946305896)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833843751305415)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444984921305896)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'fr'
,p_message_text=>'Corps (#0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101445013497305896)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'fr'
,p_message_text=>'Position #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444359592305896)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447247510305898)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166304536305670)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166634020305670)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte structur\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447131021305898)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'fr'
,p_message_text=>'Soumettre en tant que "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318632033305802)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Sous-r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166564654305670)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951336150305508)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de feuille de style CSS utilis\00E9s par &PRODUCT_NAME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951779461305508)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers et code JavaScript utilis\00E9s par &PRODUCT_NAME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070793890306384)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de feuille de style CSS d\00E9finis au niveau de l''interface utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951960947305508)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers JavaScript d\00E9finis au niveau de l''interface utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397452186305860)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs de bo\00EEte de dialogue, permettant de d\00E9finir les attributs de bo\00EEte de dialogue non pris en charge de mani\00E8re d\00E9clarative')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019874091306346)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS de bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397018595305860)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'fr'
,p_message_text=>unistr('Hauteur de la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397293463305860)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'fr'
,p_message_text=>unistr('Largeur maximale de la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397131588305860)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'fr'
,p_message_text=>unistr('Largeur de la bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091596553306400)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 pour D\00E9velopper/R\00E9duire la navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091629674306400)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 pour D\00E9velopper/R\00E9duire la colonne lat\00E9rale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061088809306377)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Code HTML des ic\00F4nes de favori')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951628060305508)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Feuilles de style CSS cr\00E9\00E9es par les composants \00E0 la vol\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952014481305508)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'fr'
,p_message_text=>unistr('Code JavaScript cr\00E9\00E9 par les composants \00E0 la vol\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397310275305860)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'fr'
,p_message_text=>unistr('Mode de page de bo\00EEte de dialogue (par exemple, True si modal, False si non modal)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951560432305508)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de feuille de style CSS et style intraligne d\00E9finis au niveau de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945234667305503)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600606989306013)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers et code JavaScript d\00E9finis au niveau de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863432711305438)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'fr'
,p_message_text=>'ID de page statique (par exemple, ''P100'')'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859874976305435)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'fr'
,p_message_text=>unistr('Transition utilis\00E9e pour acc\00E9der \00E0 une nouvelle page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396977517305860)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'fr'
,p_message_text=>'URL de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859926164305435)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'fr'
,p_message_text=>unistr('Transition utilis\00E9e pour ouvrir une fen\00EAtre instantan\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400139476305862)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'fr'
,p_message_text=>unistr('URL de la page demand\00E9e par le navigateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070941480306384)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'fr'
,p_message_text=>unistr('Menu de navigation (c\00F4t\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951482789305508)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de feuille de style CSS et style intraligne d\00E9finis dans le mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951849118305508)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers et code JavaScript d\00E9finis dans le mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952101094305509)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de feuille de style CSS d\00E9finis au niveau du th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079798655306391)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers JavaScript d\00E9finis au niveau du th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079883844306391)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de feuille de style CSS d\00E9finis au niveau du style de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070832302306384)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'fr'
,p_message_text=>'Menu de navigation (haut)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397593250305860)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d\00E9clencheur (par exemple, l''\00E9l\00E9ment DOM en cours)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010545802305552)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'fr'
,p_message_text=>'action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600784751306014)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments affect\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007548686305550)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglets d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003547234305547)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'fr'
,p_message_text=>'vers le bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007124624305549)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre de corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002948182305546)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un branchement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003642895305547)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006285287305549)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'fr'
,p_message_text=>'Modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005309457305548)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007668202305550)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'fr'
,p_message_text=>'Images d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002789157305546)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un calcul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005976817305548)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'fr'
,p_message_text=>'Copier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005112627305548)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005209708305548)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005890916305548)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004973375305548)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005064255305548)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005671532305548)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermeture de panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005520396305548)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouverture de panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006740045305549)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Notification globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005765434305548)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003782363305547)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006591183305549)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006007601305548)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006674464305549)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007456980305549)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglets parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006155184305549)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002621328305546)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un processus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002512338305546)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er une r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101005463728305548)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007290845305549)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004868623305548)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007310011305549)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006925671305549)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Message de succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006840185305549)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007046859305549)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002823853305546)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er une validation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002404851305546)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'fr'
,p_message_text=>'avertissement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447841995305898)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068179509306382)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de chemin de navigation (\00E9chappement des caract\00E8res HTML)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658423446306056)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Lors de l''\00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008055812305550)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895346885305461)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'fr'
,p_message_text=>'Branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000898643305545)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'fr'
,p_message_text=>'Branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449275289305899)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action de branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985384738305533)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Branchement sur une fonction renvoyant une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985477955305533)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'fr'
,p_message_text=>'Branchement sur une fonction renvoyant une URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985018189305533)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'fr'
,p_message_text=>'Branchement sur une acceptation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985141814305533)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Branchement sur une page identifi\00E9e par un \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011072025305552)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'fr'
,p_message_text=>unistr('Aller \00E0 la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985584687305533)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Branchement sur une proc\00E9dure PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985228821305533)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Branchement sur une URL identifi\00E9e par un \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447932742305898)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'fr'
,p_message_text=>'Option de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999594885305544)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Boutons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010999015305552)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448640891305899)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action de bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626866646306033)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter les validations')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004430735305547)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Boutons sans r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449049455305899)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte de graphique')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448945549305899)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067923175306382)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS de composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999765414305544)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Calculs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011660865305553)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'fr'
,p_message_text=>'Calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999824497305544)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La page 0 n''admet pas les calculs. Les calculs \00E0 effectuer dans chaque page doivent \00EAtre g\00E9r\00E9s au niveau application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448323553305899)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010655437305552)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'fr'
,p_message_text=>'condition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447674858305898)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'fr'
,p_message_text=>'Expression 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447726458305898)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'fr'
,p_message_text=>'Expression 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447569043305898)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de condition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997893935305542)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Copier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997639749305542)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066027197306381)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d\00E9riv\00E9 du message texte interne <em>APEX.CURRENT_PROGRESS</em> (valeur par d\00E9faut : <em>Progression</em>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008545386305550)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010821585305552)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448702856305899)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'fr'
,p_message_text=>'Afficher en tant que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999392492305544)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'fr'
,p_message_text=>'Point&nbsp;d''affichage&nbsp;'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996902535306328)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Actions dynamiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997702485305542)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895232904305461)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'fr'
,p_message_text=>'Modifier la page dans Application Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982926925305532)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier les attributs de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983515512305532)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page d''erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010703608305552)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'fr'
,p_message_text=>'exp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002379182305546)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'fr'
,p_message_text=>'Aucun branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002084434305546)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Aucun calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001849063305545)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune page s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002176197305546)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Aucun processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001935163305545)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101002265886305546)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Aucune validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008184955305550)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de pied')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009466806305551)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermeture de panneau HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008949346305551)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouverture de panneau HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008421937305550)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'fr'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000356024305544)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La page globale n''admet ni les branchements, ni les calculs, ni les processus, ni les validations. Les calculs et les processus \00E0 ex\00E9cuter dans chaque page doivent \00EAtre g\00E9r\00E9s au niveau application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660825077306057)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'fr'
,p_message_text=>'Colonne de grille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379712407305847)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'fr'
,p_message_text=>'ColSpan de grille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007989756305550)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983353134305532)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'fr'
,p_message_text=>'Incorporation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983223251305532)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Incorporation+Notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998578346305543)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999612308305544)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331745398305812)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004750411305548)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre d''\00E9l\00E9ments d\00E9passe la valeur maximale autoris\00E9e de 200.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448885641305899)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869027005305442)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'fr'
,p_message_text=>'Listes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052351286306371)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'fr'
,p_message_text=>'ID de liste unique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983639719305532)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'fr'
,p_message_text=>'Emplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027676709305566)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'fr'
,p_message_text=>'Listes de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868988284305442)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'fr'
,p_message_text=>'Chemins de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660929794306057)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011286796305552)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'fr'
,p_message_text=>'Navigue vers la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001569749305545)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre&nbsp;de&nbsp;navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326734319305808)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'fr'
,p_message_text=>'Menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985978761305534)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'fr'
,p_message_text=>'jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379458863305847)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marrer une nouvelle grille')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379653400305847)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marrer une nouvelle colonne de grille')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379563746305847)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marrer une nouvelle ligne de grille')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007816403305550)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985672044305533)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'fr'
,p_message_text=>'aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983496146305532)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009068668305551)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'fr'
,p_message_text=>'Message de notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000991271305545)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'fr'
,p_message_text=>'La page "%0" ne comporte pas de branchements.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004558084305547)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'La page "%0" ne comporte pas de boutons.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004609784305547)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('La page "%0" ne comporte pas d''\00E9l\00E9ments.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869271494305442)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune liste utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027742432305566)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune liste de valeurs partag\00E9e n''est utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869355618305442)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun chemin de navigation utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001641578305545)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'fr'
,p_message_text=>'L''application "%0" ne comporte pas de barre de navigation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000010149305544)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Il n''y a pas de calculs de chargement (Onload) pour la page "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000269326305544)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Il n''y a pas de processus de chargement (Onload) pour la page "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000454386305544)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de calculs \00E0 la soumission (onSubmit) pour la page "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000717274305545)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de processus \00E0 la soumission (onSubmit) pour la page "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997491589305542)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune page s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001185202305545)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'fr'
,p_message_text=>'Aucun onglet de niveau parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999450320305544)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('La page "%0" ne comporte pas de r\00E9gions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001441309305545)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'La page %0 ne comporte pas de jeu d''onglets.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027834974305566)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000606125305545)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'La page "%0" ne comporte pas de validations.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100983033676305532)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 \00E9l\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997536767305542)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998345072305543)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998966535305543)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'fr'
,p_message_text=>'Authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998717288305543)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>'Autorisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009244395305551)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009300247305551)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre de corps de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998860798305543)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'fr'
,p_message_text=>'Option de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008820899305550)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998157873305543)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998005507305543)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Page introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008646247305550)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'fr'
,p_message_text=>'Chargement (Onload) de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999040232305543)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'fr'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999113573305543)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998696018305543)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998434068305543)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100998220469305543)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008724326305550)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'fr'
,p_message_text=>'Titre de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001045809305545)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglets parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000176905305544)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011554193305552)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999990676305544)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La page 0 n''admet pas les processus. Les processus \00E0 ex\00E9cuter dans chaque page doivent \00EAtre g\00E9r\00E9s au niveau application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449125545305899)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011110618305552)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'fr'
,p_message_text=>unistr('Aller \00E0 la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008386761305550)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068089145306382)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9 \00E0 partir de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100999292711305543)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011903700305553)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320275428305803)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859490724305435)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319059402305803)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de r\00E9gion unique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378316958305846)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009541858305551)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313904654305799)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314089719305799)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314165298305799)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314238485305799)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314323932305799)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314499278305799)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314571537305799)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009629906305551)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009798481305551)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009852305305551)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009942652305551)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010028972305551)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010188428305551)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010299742305552)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101313810920305799)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319183206305803)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID statique de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660738859306057)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985877035305534)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'fr'
,p_message_text=>'condition standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001293242305545)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglets&nbsp;standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101008261805305550)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'fr'
,p_message_text=>'Substitution'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319843359305803)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Sous-r\00E9gions - Mod\00E8le d''entr\00E9e d''en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319952229305803)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Sous-r\00E9gions - Mod\00E8le d''en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319702255305803)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Sous-r\00E9gions - Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319505383305803)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Sous-r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319608202305803)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAtes de sous-r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319482285305803)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es d''en-t\00EAte de sous-r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319283346305803)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID statique de sous-r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101319327460305803)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre de sous-r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101009112503305551)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Message de succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868780708305442)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau tabulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001356061305545)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006368867305549)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026959975305566)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003429634305547)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un branchement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003917435305547)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003181749305546)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un calcul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004110050305547)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003227178305546)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er un processus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003063883305546)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er une r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003331737305547)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('cr\00E9er une validation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004084390305547)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'modifier un bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004268234305547)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'fr'
,p_message_text=>'modifier un bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101004395783305547)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('modifier un \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101003834049305547)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('titre de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448552500305899)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition WHEN'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448445653305899)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100985776197305534)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'fr'
,p_message_text=>'Inconditionnel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101000511839305544)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Validations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011450063305552)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'fr'
,p_message_text=>'Validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626746100306033)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Toujours ex\00E9cuter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448101106305899)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'fr'
,p_message_text=>'Expression de validation 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448298752305899)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'fr'
,p_message_text=>'Expression de validation 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101448031715305898)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997968965305543)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447437178305898)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'fr'
,p_message_text=>'Lors de l''activation du bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101007710537305550)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166486042305670)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL modifiable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128473795305642)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101444747844305896)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'fr'
,p_message_text=>'Validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125450989305640)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'fr'
,p_message_text=>'Jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168128331305671)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372633241305842)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Fonction de modification de nom utilisateur LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885035154305454)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'fr'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100903499140305468)
,p_name=>'LEARN MORE'
,p_message_language=>'fr'
,p_message_text=>'En savoir plus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021301678305561)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'fr'
,p_message_text=>'En savoir plus sur Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021157030305561)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'fr'
,p_message_text=>'En savoir plus sur App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101029961508305568)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'fr'
,p_message_text=>'En savoir plus sur le concepteur de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021267372305561)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'fr'
,p_message_text=>unistr('En savoir plus sur les applications de productivit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021002558305561)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'En savoir plus sur SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626110497306032)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'fr'
,p_message_text=>'Pour plus d''informations sur les feuilles Web, cliquez ici'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435289716305888)
,p_name=>'LEFT'
,p_message_language=>'fr'
,p_message_text=>'A gauche'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079699890306391)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Calendrier h\00E9rit\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910123805305473)
,p_name=>'LINES'
,p_message_language=>'fr'
,p_message_text=>'Lignes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675442428306075)
,p_name=>'LINK'
,p_message_language=>'fr'
,p_message_text=>'Lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945994274305504)
,p_name=>'LINK$'
,p_message_language=>'fr'
,p_message_text=>'lien de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347168622305823)
,p_name=>'LINKS'
,p_message_language=>'fr'
,p_message_text=>'Liens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073130931306386)
,p_name=>'LINK_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Lien : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452787039305902)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'fr'
,p_message_text=>unistr('Lier \00E0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101266886981305763)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('renvoie vers l''\00E9l\00E9ment de cette page %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072994041305601)
,p_name=>'LIST'
,p_message_language=>'fr'
,p_message_text=>'liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371634727305841)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''\00E9l\00E9ment de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368118312305839)
,p_name=>'LIST OF VALUES'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941494983305500)
,p_name=>'LISTVIEW'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405464933305866)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Le panneau et la vue de liste ont \00E9t\00E9 cr\00E9\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411876565305871)
,p_name=>'LIST_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111509510306415)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 d''entr\00E9e de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399943151305862)
,p_name=>'LIST_INITCAP'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516383847305948)
,p_name=>'LIST_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316802227305801)
,p_name=>'LIST_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion de liste ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380271959305848)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092639951305616)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128123037305642)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'fr'
,p_message_text=>'Utilisation de la liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405729861305866)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs de page de vue de liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406048151305867)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de page de vue de liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405623112305866)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Page de visualisation des listes'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058665628306375)
,p_name=>'LOAD_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Charger les donn\00E9es')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455116691305904)
,p_name=>'LOCK'
,p_message_language=>'fr'
,p_message_text=>'Verrouiller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543136547305967)
,p_name=>'LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240915091305743)
,p_name=>'LOCKED BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Verrouill\00E9 par : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061478570306377)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 verrouill\00E9 par %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061622753306377)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'fr'
,p_message_text=>'Verrouiller le script'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101253323333305752)
,p_name=>'LOG'
,p_message_language=>'fr'
,p_message_text=>'Journal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381102302305848)
,p_name=>'LOGGING'
,p_message_language=>'fr'
,p_message_text=>'Journalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449591478305900)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9moriser le nom utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449654676305900)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si vous cochez cette case, l''application enregistre votre nom utilisateur dans un cookie de navigateur persistant nomm\00E9 "LOGIN_USERNAME_COOKIE".'),
unistr('Lors de votre prochain acc\00E8s \00E0 la page de connexion,'),
unistr('cette valeur est automatiquement renseign\00E9e dans le champ de nom utilisateur.'),
'</p>',
'<p>',
unistr('Si vous d\00E9sactivez cette case \00E0 cocher et que votre nom utilisateur est d\00E9j\00E0 enregistr\00E9 dans le cookie,'),
'l''application le remplace par une valeur vide.',
unistr('Vous pouvez \00E9galement utiliser les outils de d\00E9veloppement de votre navigateur pour enlever enti\00E8rement le cookie.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380932754305848)
,p_name=>'LOGIN_URL'
,p_message_language=>'fr'
,p_message_text=>'URL de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380809149305848)
,p_name=>'LOGO'
,p_message_language=>'fr'
,p_message_text=>'Logo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867248317306219)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune image d\00E9finie.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867334989306219)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte du logo d''application'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865700465306218)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'fr'
,p_message_text=>'Logo d''application'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866242989306219)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce fichier d\00E9passe la limite autoris\00E9e de %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866724698306219)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Un balisage de logo personnalis\00E9 peut \00EAtre d\00E9fini dans Application Builder.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866639924306219)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'fr'
,p_message_text=>unistr('Glissez-d\00E9placez des fichiers ou cliquez pour en s\00E9lectionner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866502621306219)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866829806306219)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun logo ne sera affich\00E9 pour cette application.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866405832306219)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866381066306219)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867067950306219)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Une image de logo est requise pour ce type de logo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867127117306219)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Logo enregistr\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866917700306219)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Un texte de logo est requis pour ce type de logo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866101424306219)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Seules les images sont autoris\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047530854306367)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Merci pour les informations en retour, un bug a \00E9t\00E9 cr\00E9\00E9 pour ce probl\00E8me. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049073559306368)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>'Merci pour les informations en retour, cette demande sera prise en compte dans une version future.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672395566306073)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Merci pour les informations en retour, un probl\00E8me a \00E9t\00E9 consign\00E9 dans notre syst\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049238641306368)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Merci pour les informations en retour, une t\00E2che a \00E9t\00E9 cr\00E9\00E9e pour r\00E9soudre ce probl\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077004044306389)
,p_name=>'LOG_IN'
,p_message_language=>'fr'
,p_message_text=>'Connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254248084305753)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'fr'
,p_message_text=>'Intervalle de journalisation'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368029731305839)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''\00E9l\00E9ment de liste de valeurs (LOV)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325954680305808)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Priorit\00E9 faible')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869166551305442)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer les groupes de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517886556305949)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer le service')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517660477305949)
,p_name=>'MANAGE USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer les utilisateurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517071765305949)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer l''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461555594305908)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083111948305609)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer ce qui n''est pas affect\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900638181305465)
,p_name=>'MANUAL'
,p_message_language=>'fr'
,p_message_text=>'Manuel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839089604305419)
,p_name=>'MAP_LAYER='
,p_message_language=>'fr'
,p_message_text=>'Couche ='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840453565305420)
,p_name=>'MAP_LAYERS'
,p_message_language=>'fr'
,p_message_text=>'Couches de carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986385407305534)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La carte a \00E9t\00E9 cr\00E9\00E9e.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325120068305807)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9 phare')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399050809305861)
,p_name=>'MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384363691305851)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation des pages ma\00EEtre-d\00E9tail a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837732021305418)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837952996305418)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837812844305418)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450877567305901)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue mat\00E9rialis\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346506771305823)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'fr'
,p_message_text=>'Temps d''affichage maximal (secondes)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437749407305890)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'fr'
,p_message_text=>unistr('Temps maximal d''inactivit\00E9 de session en secondes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437863205305890)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e maximale de session en secondes')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020861703305561)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'fr'
,p_message_text=>unistr('La suppression de jalons avec des fonctionnalit\00E9s associ\00E9es n''est pas autoris\00E9e.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913041725305475)
,p_name=>'MEMORY'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9moire :')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071358283305600)
,p_name=>'MENU'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371751499305841)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''\00E9l\00E9ment de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380562193305848)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de chemin de navigation')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613621919306023)
,p_name=>'MIGRATION FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers de migration'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367622436305838)
,p_name=>'MILESTONE'
,p_message_language=>'fr'
,p_message_text=>'Jalon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347691077305824)
,p_name=>'MILESTONES'
,p_message_language=>'fr'
,p_message_text=>'Jalons'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803968508306171)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'fr'
,p_message_text=>'ms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350305459305826)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Type de colonne MIME'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323678543305806)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'fr'
,p_message_text=>'Impact minimal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888193935305456)
,p_name=>'MIN_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Version minimale'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048131812306368)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'fr'
,p_message_text=>'Signe @ manquant'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271103893305766)
,p_name=>'MODEL_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325354819305807)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'fr'
,p_message_text=>'Souhaitable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323517147305806)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'fr'
,p_message_text=>unistr('Impact mod\00E9r\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010373727305552)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9signe un attribut modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451180803305901)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Modifier la colonne %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101250828598305751)
,p_name=>'MONITOR'
,p_message_language=>'fr'
,p_message_text=>'Surveiller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517774167305949)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Surveiller l''activit\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376936849305845)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'fr'
,p_message_text=>'Plus...'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346021259305822)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'%0 applications les plus actives'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341032976305819)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur la plus r\00E9cente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641649902306044)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('Le fichier le plus r\00E9cent est %0, t\00E9l\00E9charg\00E9 par %1 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109497483305628)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans MRU : ligne = %0, %1, %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108303749305627)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de cl\00E9 primaire identifi\00E9e ne se trouve pas dans la liste SELECT de la requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109549810305628)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La version en cours des donn\00E9es dans la base a chang\00E9 depuis que l''utilisateur a lanc\00E9 le traitement de mise \00E0 jour. Checksum en cours = "%0", checksum de l''\00E9l\00E9ment = "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107873949305626)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de lignes \00E0 traiter')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025753720305565)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'fr'
,p_message_text=>unistr('Assurez-vous que le type du fichier de mise en page d''\00E9tat est XSL-FO, avec l''extension ''.xsl''.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934627042305495)
,p_name=>'MY_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Ma page'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047035669306367)
,p_name=>'NAMES'
,p_message_language=>'fr'
,p_message_text=>'Noms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455057127305904)
,p_name=>'NAVBAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367838238305838)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''\00E9l\00E9ment de barre de navigation')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050665490306369)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aller au d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365739477305837)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380754985305848)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868893470305442)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page de navigation'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860208608305435)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'fr'
,p_message_text=>'Naviguer vers la page d''accueil d''App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086873892306397)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Impl\00E9mentation : liste %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086784270306397)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Impl\00E9mentation : classique')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336006307305815)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9vision n\00E9cessaire')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329137024305810)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations n\00E9cessaires')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347267322305823)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es d''actualit\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080592234306392)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle valeur pour la variable attach\00E9e %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090125410305614)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre nouvelle adresse \00E9lectronique pour votre compte Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324634166305807)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'fr'
,p_message_text=>unistr('Demande d''une nouvelle fonctionnalit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256824203305755)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'fr'
,p_message_text=>'Nouveau ou existant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432936653305886)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom du nouveau sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340314434305818)
,p_name=>'NEW_SERVICE'
,p_message_language=>'fr'
,p_message_text=>'Nouveau service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071201024305600)
,p_name=>'NEW_TABSET'
,p_message_language=>'fr'
,p_message_text=>'Nouveau jeu d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065831218306381)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'fr'
,p_message_text=>unistr('- Aucun parent s\00E9lectionn\00E9 - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377208501305845)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'fr'
,p_message_text=>'Demande de nouvel espace de travail'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385400606305851)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de r\00E9gion correspondante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318783023305802)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune cl\00E9 primaire n''est d\00E9finie pour la table. Une cl\00E9 primaire est requise lors de la cr\00E9ation d''\00E9tats avec des panneaux. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914892571305476)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Archivage de journaux : D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309924595305796)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e non en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365549048305837)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet non en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370053596305840)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'fr'
,p_message_text=>'Aucune indication'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057631554305588)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image non en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434672829305888)
,p_name=>'NON_PACKAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('-Application non \00E9chantillon ou de productivit\00E9-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325897554305808)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Priorit\00E9 normale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047695050306367)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Non disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073021793306386)
,p_name=>'NOTE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Remarque : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228811242305734)
,p_name=>'NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322508275305805)
,p_name=>'NOT_A_BUG'
,p_message_language=>'fr'
,p_message_text=>'Il ne s''agit pas d''un bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079573398306391)
,p_name=>'NOT_CURRENT'
,p_message_language=>'fr'
,p_message_text=>'Non actuel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325521422305807)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'fr'
,p_message_text=>'Non souhaitable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375146043305844)
,p_name=>'NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'N''existe pas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930485954305490)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL N''EXISTE PAS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101322669203305805)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'fr'
,p_message_text=>'Correction impossible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454807823305904)
,p_name=>'NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086297554306396)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage d''ach\00E8vement inf\00E9rieur ou \00E9gal \00E0 80 %')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387928560305853)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non install\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071175302305600)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pas dans le dictionnaire de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326246313305808)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Sans priorit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324092699305806)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'fr'
,p_message_text=>'Non prioritaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370225794305840)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'fr'
,p_message_text=>'Non fourni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645927123306047)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Facultatif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328919052305810)
,p_name=>'NOT_STARTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non commenc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407444231305868)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'fr'
,p_message_text=>'<strong>%0</strong> n''est pas un nom de vue valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887643017305456)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune application n''a \00E9t\00E9 trouv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101391145991305856)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune application n''est s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165715721305670)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun argument autoris\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321682327305804)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune priorit\00E9 affect\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933431054305493)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('aucun mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370430352305840)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aucun processus de file d''attente de travaux de base de donn\00E9es n''est disponible. Contactez<br> l''administrateur pour qu''il augmente la valeur du param\00E8tre d''initialisation JOB_QUEUE_PROCESSES <br>'),
'ou attendez que des travaux se terminent.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244331412305746)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de chemin de navigation trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le de chemin de navigation est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244475580305746)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de bouton trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le de bouton est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243974754305745)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de calendrier trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le de calendrier est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019917675305560)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune date indiqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269728123305765)
,p_name=>'NO_DEBUG'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun d\00E9bogage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881807342305451)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun privil\00E8ge de d\00E9veloppeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943209482305502)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'fr'
,p_message_text=>'- Aucun affichage -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898396031305463)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune fonctionnalit\00E9 cibl\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241998704305744)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune aide n''est disponible pour cet \00E9l\00E9ment de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106930774306412)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ic\00F4ne trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992197391305538)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune image n''a \00E9t\00E9 trouv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229192990305735)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune image n''a \00E9t\00E9 trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073593154305602)
,p_name=>'NO_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('aucun \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435101235305888)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les processus de file d''attente de travaux de base de donn\00E9es ne sont pas activ\00E9s. Demandez \00E0<br>'),
unistr('l''administrateur de d\00E9finir le param\00E8tre d''initialisation JOB_QUEUE_PROCESSES.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244084789305745)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de libell\00E9 trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le de libell\00E9 est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975788568305526)
,p_name=>'NO_LAYOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune mise en page d''\00E9tat s\00E9lectionn\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244268520305746)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de liste trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le de liste est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324836259305807)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8me r\00E9solu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933206245305493)
,p_name=>'NO_LOV'
,p_message_language=>'fr'
,p_message_text=>'aucune liste de valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368746751305839)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun jalon d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595474851306010)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'fr'
,p_message_text=>'Ne pas afficher la liste de menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975646264305526)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('Le d\00E9veloppeur n''est pas autoris\00E9 \00E0 cr\00E9er un composant sur cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244659734305746)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de page trouv\00E9 lors de la tentative de copie du th\00E8me dans l''application %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243756361305745)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de page trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le de page est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167375521305671)
,p_name=>'NO_PARENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune entr\00E9e de chemin de navigation parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615824863306025)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun onglet parent n''a \00E9t\00E9 d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376801155305845)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'fr'
,p_message_text=>'Aucune demande en suspens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244569341305746)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de liste de valeurs (LOV) instantan\00E9e trouv\00E9e dans le th\00E8me. Au moins un mod\00E8le de liste de valeurs (LOV) instantan\00E9e est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326121980305808)
,p_name=>'NO_PRIORITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune priorit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413173047305872)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette position de r\00E9gion ne figure pas dans votre mod\00E8le de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101243826574305745)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le de r\00E9gion trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le de r\00E9gion est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244186851305746)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le d''\00E9tat trouv\00E9 dans le th\00E8me. Au moins un mod\00E8le d''\00E9tat est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933366750305493)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'fr'
,p_message_text=>'aucun raccourci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328886415305810)
,p_name=>'NO_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Aucun statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377460829305846)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun message du syst\00E8me n''est d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671781365306073)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun onglet n''a \00E9t\00E9 d\00E9fini pour cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101616018690306025)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun onglet trouv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613232765306023)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun onglet n''a \00E9t\00E9 d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101615999833306025)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun onglet s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102047427172306367)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune balise trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073417055305602)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101165860883305670)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun acc\00E8s par URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657705083306055)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant de pouvoir utiliser les balises SQL, vous devez, pour des raisons de s\00E9curit\00E9, d\00E9finir une liste des tables autoris\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323384501305806)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Aucune solution de contournement disponible'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069660856305599)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'fr'
,p_message_text=>'(NULL)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454283425305903)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407219118305867)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898214970305463)
,p_name=>'NUM_TOTAL'
,p_message_language=>'fr'
,p_message_text=>'Total de %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305768383305793)
,p_name=>'OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Objets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601139464306014)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets sans valeurs par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601055632306014)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets avec valeurs par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072681833306386)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Objet : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394092768305858)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'fr'
,p_message_text=>'cascade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335365289305815)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer la contrainte de v\00E9rification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889419624305457)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'fr'
,p_message_text=>'%0 erreurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395160985305859)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de contrainte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395226715305859)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne(s)/V\00E9rification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335143880305814)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer le nom de contrainte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335550689305815)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de contrainte est d\00E9j\00E0 utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393795065305858)
,p_name=>'OB_FK_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Cl\00E9 \00E9trang\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334780623305814)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de cl\00E9 \00E9trang\00E8re doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335466118305815)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de cl\00E9 \00E9trang\00E8re d\00E9j\00E0 utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393876562305858)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Table r\00E9f\00E9renc\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393908931305858)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes r\00E9f\00E9renc\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335016790305814)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les colonnes de r\00E9f\00E9rence de cl\00E9 \00E9trang\00E8re doivent \00EAtre s\00E9lectionn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334949715305814)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('La table des r\00E9f\00E9rences de cl\00E9 \00E9trang\00E8re doit \00EAtre s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334842083305814)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les colonnes de cl\00E9 \00E9trang\00E8re doivent \00EAtre s\00E9lectionn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455594324305904)
,p_name=>'OB_POSITION'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395389474305859)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner un type de donn\00E9es -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394166592305858)
,p_name=>'OB_SET_NULL'
,p_message_language=>'fr'
,p_message_text=>'affecter la valeur Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335246638305815)
,p_name=>'OB_UK_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer les colonnes pour la cl\00E9 unique.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804146612306171)
,p_name=>'ODG.API.START'
,p_message_language=>'fr'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804069724306171)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 Exception non trait\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804296399306171)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es int\00E9gr\00E9e non g\00E9r\00E9e : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805007117306172)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de base introuvable ou non cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856632876305433)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de la source de donn\00E9es doit comporter 26 caract\00E8res au maximum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856521160305432)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''import de : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804917239306172)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de la construction de l''instruction SQL INSERT-SELECT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804426255306171)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 en cours d''obtention des donn\00E9es JSON. URL : %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101805197061306172)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'fr'
,p_message_text=>'Script INSERT INTO :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856812412305433)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es int\00E9gr\00E9e non valide : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804891116306172)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur : les donn\00E9es JSON sont NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804523703306172)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'fr'
,p_message_text=>'Objet non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804645226306172)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur : aucune ligne demand\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804379807306171)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Trop de lignes demand\00E9es ; le nombre maximal autoris\00E9 est %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101804786205306172)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur inattendue lors du chargement de %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100856791485305433)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur pour %0 doit \00EAtre Y ou N')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934502811305495)
,p_name=>'ONE'
,p_message_language=>'fr'
,p_message_text=>'Un'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887131877305455)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments install\00E9s uniquement')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124135195305639)
,p_name=>'ON_LOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement de chargement')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101324931666305807)
,p_name=>'OPEN'
,p_message_language=>'fr'
,p_message_text=>'Ouvert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370575696305840)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'fr'
,p_message_text=>'Ouvert au cours des 7 derniers jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369649553305840)
,p_name=>'OPEN_BUGS'
,p_message_language=>'fr'
,p_message_text=>'Bugs ouverts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369380211305840)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s ouvertes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603155258306015)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir, traitement des informations en retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369572353305840)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2ches \00E0 effectuer ouvertes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976738229305527)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir la feuille Web %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310744283305796)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>'Attribut facultatif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090924437306400)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne facultatives')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310658521305796)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image facultative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310821266305796)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs d''image facultatifs'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613790611306023)
,p_name=>'ORACLE FORMS'
,p_message_language=>'fr'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018576360306345)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''impression bas\00E9e sur Oracle REST Data Services a \00E9t\00E9 abandonn\00E9e dans Oracle APEX 19.1. Elle n''est plus prise en charge.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868624716305441)
,p_name=>'OTHER'
,p_message_language=>'fr'
,p_message_text=>'Autre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614363851306024)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'fr'
,p_message_text=>'Autres fichiers de l''espace de travail'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363283434305835)
,p_name=>'OTN'
,p_message_language=>'fr'
,p_message_text=>'Oracle Technology Network'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363381748305835)
,p_name=>'OTN_FORUM'
,p_message_language=>'fr'
,p_message_text=>'Forum de discussion Oracle Technology Network'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493360076305932)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'fr'
,p_message_text=>'ID de remplacement'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069435505306383)
,p_name=>'OVERVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Aper\00E7u')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050919560305583)
,p_name=>'OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897952029305463)
,p_name=>'OWNERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taires')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101274904644305769)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction de requ\00EAte SQL. Corps.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412532795305871)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025382209305564)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de supprimer la LOV. Elle est utilis\00E9e sur les pages %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375294453305844)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment Bind (entrez le nom de l''\00E9l\00E9ment)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024008818306350)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('Une r\00E9g\00E9n\00E9ration peut \00EAtre n\00E9cessaire.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026828040306352)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter un serveur de d\00E9ploiement')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301427525305788)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'fr'
,p_message_text=>unistr('Parcourir les liens base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297458075305785)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''op\00E9ration de cr\00E9ation de lien de base de donn\00E9es a \00E9chou\00E9 pour la raison suivante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297503334305785)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le lien de base de donn\00E9es "%0" a \00E9t\00E9 cr\00E9\00E9 dans le sch\00E9ma "%1".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070425419305599)
,p_name=>'PACKAGE'
,p_message_language=>'fr'
,p_message_text=>'package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245050361305746)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Application \00E9chantillon ou de productivit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907768759305471)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications \00E9chantillon et de productivit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456897777305905)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''installation de l''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288152467305778)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps de package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434579088305888)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'fr'
,p_message_text=>'-Global-'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052497490305585)
,p_name=>'PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372824696305842)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition de calcul de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453175599305902)
,p_name=>'PAGE HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365313863305837)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte, corps et pied de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373170775305842)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut d''\00E9l\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373384268305843)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''affichage d''\00E9l\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373586676305843)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) d''\00E9l\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373234685305842)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Post-calcul d''\00E9l\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373463149305843)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition d''affichage en lecture seule d''\00E9l\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373031847305842)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Source d''\00E9l\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288579335305779)
,p_name=>'PAGE ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366103431305837)
,p_name=>'PAGE PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Processus de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366286290305837)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition de processus de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372912666305842)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition de validation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302463122305789)
,p_name=>'PAGES'
,p_message_language=>'fr'
,p_message_text=>'pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516503172305948)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347001055305823)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383218406305850)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements de page : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099486109306406)
,p_name=>'PAGE_FINDER'
,p_message_language=>'fr'
,p_message_text=>'Utilitaire de recherche de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861817276305436)
,p_name=>'PAGE_GROUP'
,p_message_language=>'fr'
,p_message_text=>'Groupe de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382784747305849)
,p_name=>'PAGE_HELP'
,p_message_language=>'fr'
,p_message_text=>'Indique la page dans l''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547947381305973)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Page %0 verrouill\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548019929305973)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Page %0 d\00E9verrouill\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393225155305857)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La page d''application a \00E9t\00E9 install\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289023614305779)
,p_name=>'PAGE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E9l\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499150187305936)
,p_name=>'PAGE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Page : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101333954457305814)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Page verrouill\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242453343305744)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Page verrouill\00E9e par %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362957664305835)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'le nom de page est requis pour toutes les pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346892237305823)
,p_name=>'PAGE_POSTS'
,p_message_language=>'fr'
,p_message_text=>'Envois de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516697002305948)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'fr'
,p_message_text=>'Processus de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898696632305464)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Traitement de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384079042305850)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>'Protection de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063950817305593)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064133627305593)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'fr'
,p_message_text=>'Cible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064033606305593)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063700302305593)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063877802305593)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063629514305593)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'fr'
,p_message_text=>'Masquer la source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063533294305593)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'fr'
,p_message_text=>'Afficher la source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063368308305593)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063171464305592)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom d''arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063403240305593)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte d''arborescence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063252994305593)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986145424305534)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La page %0 a \00E9t\00E9 cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365230180305837)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101334005679305814)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Page d\00E9verrouill\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346901973305823)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101342687670305820)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de la fonctionnalit\00E9 parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452890706305902)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne d''\00E9tat parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614518599306024)
,p_name=>'PARENT_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612827865306023)
,p_name=>'PARENT_TABS'
,p_message_language=>'fr'
,p_message_text=>'Onglets parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057101192305588)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057288819305588)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets parent - Nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057301837305588)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''onglet parent'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613542740306023)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets parent'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901889775305466)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma d''analyse')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100898702307305464)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page partielle'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882057179305451)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe expir\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869773016305442)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mot de passe de ce compte doit \00EAtre modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881932671305451)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889793593305457)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe (soumission lors de l''utilisation de Entr\00E9e)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406536997305867)
,p_name=>'PAST_DUE'
,p_message_language=>'fr'
,p_message_text=>'Echu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496410973305934)
,p_name=>'PATH'
,p_message_language=>'fr'
,p_message_text=>'Chemin'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101655986257306054)
,p_name=>'PCT_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ferm\00E9 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652203980306051)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Formatage graphique pour les pourcentages, nombres entiers entre 0 et 100'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565083254305986)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565185529305986)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901685690306249)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Calculs d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901733876306249)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Calcul d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567023305305988)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567188257305988)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901882822306249)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901943999306249)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Processus d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567421464305988)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Authentifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567552809305988)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567653489305988)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Autorisations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567789483305988)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Autorisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802248057306170)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Automatisations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802319665306170)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Automatisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038957773306361)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Actions d''automatisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039065886306361)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Action d''automatisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571290385305991)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Branchements'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571342260305991)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567824446305988)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Chemins de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567912178305988)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902011651306249)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902193919306249)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566448341305987)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566519343305987)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567294421305988)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Options de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101567351229305988)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Option de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570042528305990)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Boutons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570140577305990)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566099095305987)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566144685305987)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566664196305987)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de calendrier h\00E9rit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566793055305987)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de calendrier h\00E9rit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882494390306234)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882524140306234)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882647873306234)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882785373306234)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584634827306001)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584790391306002)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572872661305993)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572940721305993)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573086204305993)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573179256305993)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662258742306058)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662352412306058)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869232997306221)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finitions de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869376503306221)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition de chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568837964305989)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finitions de chargement des donn\00E9es h\00E9rit\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568972572305989)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition de chargement des donn\00E9es h\00E9rit\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570400662305990)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570572384305990)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570297814305990)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Actions dynamiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570307350305990)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Action dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126805846305641)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101126985008305641)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de courriel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802507797306170)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Facets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802651535306170)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873840782306228)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Groupes de facets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873902460306228)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Groupe de facets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874074811306228)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Cases \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874103392306228)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Case \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565840011305987)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de champ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565978271305987)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de champ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413320103305872)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413487288305872)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413709539305872)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413864453305872)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413565233305872)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Groupes de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413630698305872)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Groupe de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413983064305872)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414082058305872)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880691027306233)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats enregistr\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881393532306233)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat enregistr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571401985305991)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571536623305991)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572040472305992)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572191299305992)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571870535305992)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Groupes de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571924718305992)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Groupe de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662045173306058)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662178217306058)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571619435305992)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats enregistr\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571733822305992)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat enregistr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460743697305908)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460842629305908)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460529832305908)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Axes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460647258305908)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Axe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460951758305908)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461099126305908)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031351413306355)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031453107306355)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568074507305988)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Listes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568126550305988)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902219592306249)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902349073306249)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566291767305987)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566369278305987)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568225062305989)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Listes de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568302457305989)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902401854306249)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de liste de valeurs (LOV)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902549618306249)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de liste de valeurs (LOV)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808375400306174)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Couches'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808424510306174)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Couche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808567491306175)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808626906306175)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808152316306174)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808230427306174)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569698713305990)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569768960305990)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570891250305991)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Calculs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570917623305991)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569441727305989)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Groupes de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569533588305989)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Groupe de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268043834305764)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268169227305764)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571032519305991)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101571179816305991)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572642349305992)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''authentification de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572773223305992)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre d''authentification de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572278984305992)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572349318305992)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre IN')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572433337305992)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de sortie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101572548723305992)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre OUT')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565485111305986)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565512028305986)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903011966306250)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Modules d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903194606306250)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Module d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569804774305990)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569922653305990)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861056430306215)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861144940306215)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797776969306166)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797852883306167)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565610871305987)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565705375305987)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508817182305943)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508951004305943)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289475467305779)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Bases de donn\00E9es distantes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289520418305779)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669277947306063)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669390937306063)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise en page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566873714305987)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''\00E9tat classiques')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101566905234305988)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''\00E9tat classique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235455972305739)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235507896305739)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235641722305739)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Groupes de filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235783410305739)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Groupe de filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235870875305740)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Cases \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235984893305740)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Case \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902644823306249)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Raccourcis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902755431306249)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Raccourci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569086510305989)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Jeux d''onglets standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569109432305989)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575039336305994)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575156206305994)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575217757305994)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575318783305994)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662448733306058)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662532345306059)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565283559305986)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8mes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101565388891305986)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902846095306249)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Arborescences'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101902992852306250)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569202355305989)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Interfaces utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101569303158305989)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570649660305990)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>'Validations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101570781292305991)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>'Validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568495340305989)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences de service Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568558842305989)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rence de service Web')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568661705305989)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9rations de service Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101568736042305989)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9ration de service Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038009571306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''authentification de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038147430306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre d''authentification de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038298628306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''en-t\00EAte HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038363058306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre d''en-t\00EAte HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037664010306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037706360306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre IN')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037842282306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de sortie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102037900807306360)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre OUT')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402888621305864)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Sources de donn\00E9es REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402907639305864)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de donn\00E9es REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513576259305946)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513683106305946)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508655657305943)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9rations de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508730287305943)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9ration de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513710680305946)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''op\00E9ration de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513851442305946)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre d''op\00E9ration de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513952816305946)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514013421305946)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403097077305864)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403120995305864)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte de source REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524470728305954)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039175471306361)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution de code suppl\00E9mentaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185879248305684)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186198545305685)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments affect\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463166757305910)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'fr'
,p_message_text=>'Animation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187167416305685)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>'Apparence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184327855305683)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834042312305416)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'fr'
,p_message_text=>'Informations d''audit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185926644305684)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>'Autorisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903342563306250)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581932381305999)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9ration automatique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187067650305685)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'fr'
,p_message_text=>'Comportement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557064202305980)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'fr'
,p_message_text=>'Attributs BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883041723306235)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559352821305982)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'fr'
,p_message_text=>'Formatage par sections (BREAK)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592038305306007)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments d''\00E9tat de calendrier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882881388306235)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'fr'
,p_message_text=>'Carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548581186305974)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs en cascade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583530523306001)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053966177306372)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition c\00F4t\00E9 client')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039292429306361)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'fr'
,p_message_text=>'Code'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585224903306002)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'fr'
,p_message_text=>'Couleurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662936546306059)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661385947306058)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtre de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519257165305950)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'fr'
,p_message_text=>'Formatage des colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662841332306059)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAtes de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462490419305909)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'fr'
,p_message_text=>'Mapping de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184491502305683)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'fr'
,p_message_text=>'Commentaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185779018305684)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184636648305683)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'fr'
,p_message_text=>'Configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096153326305618)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'fr'
,p_message_text=>'Confirmation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594631437306009)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184763001305684)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'fr'
,p_message_text=>'Feuille de style CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281381103305773)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585024123306002)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier quotidien et hebdomadaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903464504306250)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Session de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583612377306001)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462332327305909)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Curseur de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186271763305685)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548450454305973)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9pend de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524547738305954)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524602245305954)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593268601306008)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524788767305954)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585355610306002)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'fr'
,p_message_text=>unistr('Glisser-d\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463008655305910)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'fr'
,p_message_text=>unistr('Axes \00E0 double Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414274383305873)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546509441305969)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Modifier une autorisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186300623305685)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414131780305872)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('Autoriser les utilisateurs \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592122032306007)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184551669305683)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184840726305684)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'fr'
,p_message_text=>'Gestion des erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185621301305684)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Options d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552966499305977)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'fr'
,p_message_text=>'Export/Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559431482305982)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Traitement externe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807319748306174)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583437268306000)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'fr'
,p_message_text=>'Cadre temporel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005144038306335)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'fr'
,p_message_text=>'Lucarne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583039529306000)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'fr'
,p_message_text=>'Jauge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184919406305684)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte et pied')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559663053305982)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185054074305684)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186499018305685)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185110087305684)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883252845306235)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne et badge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524854999305954)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184116114305683)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Identification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185274187305684)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'fr'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186549706305685)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187219091305685)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9sentation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582565599306000)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'fr'
,p_message_text=>unistr('L\00E9gende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462531943305909)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539673082305965)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'fr'
,p_message_text=>'Lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646558746306047)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186694341305685)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585176132306002)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier en vue d''agenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014912653306343)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Post-traitement local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280782755305773)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Traitement de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462741267305910)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'fr'
,p_message_text=>'Graduations principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808846294306175)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'fr'
,p_message_text=>'Niveaux de zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808776952306175)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'fr'
,p_message_text=>'Carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809336186306175)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'fr'
,p_message_text=>unistr('Fen\00EAtre d''informations')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101808914311306175)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'fr'
,p_message_text=>'Position initiale et zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809194978306175)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation de cluster de points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809080257306175)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'fr'
,p_message_text=>'Objets de type point'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809280245306175)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'fr'
,p_message_text=>'Affectation de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582622253306000)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'fr'
,p_message_text=>'Marge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462606322305909)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'fr'
,p_message_text=>'Marqueur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608129436306019)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883382460306235)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'fr'
,p_message_text=>'Support'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559519373305982)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'fr'
,p_message_text=>'Messages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462857885305910)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'fr'
,p_message_text=>'Graduations secondaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584816945306002)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier mensuel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987173757305535)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Valeurs multiples'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316461435305801)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es du graphique \00E0 plusieurs s\00E9ries')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903590352306250)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327010168305808)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091093539306400)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670976926306072)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Sortie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462215416305909)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Aper\00E7u')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662711057306059)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663199215306059)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'fr'
,p_message_text=>'Pied de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663029926306059)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524965683305954)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'fr'
,p_message_text=>'Pagination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544992850305968)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414472131305873)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'fr'
,p_message_text=>'Performances'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280824008305773)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('URL apr\00E8s d\00E9connexion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577452014305996)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de cl\00E9 primaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101662602369306059)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'fr'
,p_message_text=>'Impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903219578306250)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186793990305685)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lections rapides')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185384467305684)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'fr'
,p_message_text=>'Lecture seule'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280954793305773)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'fr'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026192233305565)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546048903305969)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289653127305779)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'fr'
,p_message_text=>'Cache distant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505239184305940)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883123510306235)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps secondaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185458741305684)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582717432306000)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur de s\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101185558715305684)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'fr'
,p_message_text=>'Cache de serveur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053808972306372)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition c\00F4t\00E9 serveur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903635655306250)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'fr'
,p_message_text=>'Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281059750305773)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Attributs de cookie de session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281176900305773)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'fr'
,p_message_text=>'Session non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101184258282305683)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525187684305954)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue monoligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525061952305954)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'fr'
,p_message_text=>'Tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186810197305685)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'fr'
,p_message_text=>'Source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281292067305773)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Abonnement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882947355306235)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Sous-titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540593485305965)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Message de succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236071828305740)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'fr'
,p_message_text=>'Suggestions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091185559306400)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'fr'
,p_message_text=>'Onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918802356305479)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'fr'
,p_message_text=>'Seuils'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101462952960305910)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de graduation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797210467306166)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'fr'
,p_message_text=>'Echelle de temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583335509306000)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414385803305873)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'fr'
,p_message_text=>'Barre d''outils'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583291523306000)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'fr'
,p_message_text=>'Info-bulle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576295920305995)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rence de valeurs par d\00E9faut d''interface utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186936670305685)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583129687306000)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584945687306002)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier hebdomadaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101186030194305684)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'fr'
,p_message_text=>'Lorsque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582897779306000)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'fr'
,p_message_text=>'Axe des X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582971605306000)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'fr'
,p_message_text=>'Axe des Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509095500305943)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'fr'
,p_message_text=>'Echelle de zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416163609305874)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez un mod\00E8le d''autorisation pour restreindre les utilisateurs autoris\00E9s \00E0 ajouter des lignes.'),
unistr('Pour autoriser un utilisateur final \00E0 ajouter des lignes, ce mod\00E8le d''autorisation doit renvoyer la valeur TRUE pour cet utilisateur.'),
unistr('Si aucun mod\00E8le d''autorisation n''est indiqu\00E9, n''importe quel utilisateur peut ajouter des lignes dans cette grille interactive.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416043694305874)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419174689305876)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez un autre libell\00E9 pour le bouton Ajouter. Le libell\00E9 par d\00E9faut est <em>Ajouter une ligne</em>.</p>'),
unistr('        <p>Par exemple, vous pouvez saisir <em>Ajouter un employ\00E9</em> pour une grille interactive permettant de g\00E9rer des employ\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419004449305876)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 du bouton Ajouter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417326600305875)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si une nouvelle ligne doit \00EAtre ajout\00E9e lorsque la grille interactive ne contient actuellement aucun enregistrement renvoy\00E9.'),
unistr('        Le message <em>Aucune donn\00E9e d\00E9tect\00E9e</em> n''est pas affich\00E9 car au moins un enregistrement est toujours affich\00E9.</p>'),
unistr('        <p>Remarque : si aucune mise \00E0 jour n''est apport\00E9e \00E0 l''enregistrement ajout\00E9, il n''est pas ins\00E9r\00E9 lors de l''enregistrement de la r\00E9gion.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417225106305875)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne si vide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900801680306248)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce facet. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875882382306229)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce groupe de facets. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432594959305886)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Remarque : cette propri\00E9t\00E9 peut \00EAtre utilis\00E9e pour apporter des modifications de style \00E0 l''\00E9l\00E9ment correspondant lorsque la grille interactive est modifiable.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877544996306231)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Remarque : ces classes CSS peuvent \00EAtre appliqu\00E9es \00E0 la balise d''\00E9l\00E9ment de panneau HTML.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239418445305742)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce filtre. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240143011305743)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce groupe de filtres. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876942637306230)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Ajouter les classes CSS <code>articlenumber</code> et <code>highlight</code> \00E0 la balise HTML du composant</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876804265306230)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes CSS suppl\00E9mentaires \00E0 inclure dans le composant, en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876782143306230)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219246111305727)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le bouton que cette action doit affecter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219171758305727)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054834125306372)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez des colonnes affect\00E9es par cette action.'),
unistr('S\00E9parez les noms de colonne par une virgule.'),
unistr('<p>Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des colonnes disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom de colonne renvoy\00E9 \00E0 partir de la liste.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054727760306372)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219646287305728)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un objet DOM (<code>document</code>, <code>window</code>) ou l''<em>ID</em> d''un objet DOM (<code>myElementID</code>) en tant qu''\00E9l\00E9ment concern\00E9 par cette action.</p>'),
unistr('<p>Remarque : l''option <em>Objet DOM</em> est en phase d''abandon et doit \00EAtre remplac\00E9e par <em>Expression JavaScript</em> ou <em>S\00E9lecteur jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219571975305728)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Objet DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219478020305728)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez au moins un \00E9l\00E9ment de page ou d''application affect\00E9 par cette action.'),
unistr('S\00E9parez les noms d''\00E9l\00E9ment par une virgule.'),
unistr('<p>Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219366357305727)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051295877306370)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Renvoie une r\00E9f\00E9rence \00E0 l''objet DOM <code>window</code> du navigateur.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>Renvoie une r\00E9f\00E9rence \00E0 l''objet DOM <code>document</code> du navigateur.</dt>'),
'<dd>document</dd>',
unistr('<dt>Le s\00E9lecteur jQuery s\00E9lectionne tous les \00E9l\00E9ments DIV ayant la classe ''alert'', puis renvoie un objet jQuery contenant tous leurs parents.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051180701306370)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''expression JavaScript \00E0 \00E9valuer pour renvoyer un seul objet DOM, un tableau d''objets DOM ou un objet jQuery en tant qu''\00E9l\00E9ments concern\00E9s par cette action.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051024748306370)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709665424306101)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Pour s\00E9lectionner un \00E9l\00E9ment de page avec l''ID DOM <code>my_id</code></dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>Pour s\00E9lectionner tous les \00E9l\00E9ments de page avec la classe <code>my_class</code></dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>Pour s\00E9lectionner tous les \00E9l\00E9ments de page qui sont des entr\00E9es</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219819830305728)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la syntaxe de s\00E9lecteur jQuery permettant de renvoyer les \00E9l\00E9ments de page sur lesquels cette action doit influer. La biblioth\00E8que jQuery fournit une syntaxe de s\00E9lecteur tr\00E8s puissante permettant d''acc\00E9der facilement \00E0 des \00E9l\00E9ments d''un')
||'e page.</p>',
unistr('<p>Pour plus d''informations sur la syntaxe de s\00E9lecteur, reportez-vous \00E0 la documentation officielle disponible sur la <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">page d''accueil jQuery</a>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219704679305728)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur jQuery')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219013707305727)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion que cette action doit affecter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218934691305727)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218853608305727)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mode de d\00E9finition des composants de page affect\00E9s lorsque cette action est ex\00E9cut\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708492673306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708569816306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action affecte le bouton que vous s\00E9lectionnez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054178503306372)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054244645306372)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>'L''action affecte les colonnes que vous saisissez.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708813130306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'fr'
,p_message_text=>'Objet DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708989437306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action affecte l''\00E9l\00E9ment de page identifi\00E9 par l''objet de DOM ou par l''ID DOM que vous saisissez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709417477306101)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Source d''\00E9v\00E9nements')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709564111306101)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''action affecte l''\00E9l\00E9ment de page dont provient l''\00E9v\00E9nement, qui peut parfois diff\00E9rer de l''\00E9l\00E9ment d\00E9clencheur.</p>'),
unistr('<p>Dans cette configuration avanc\00E9e, l''\00E9l\00E9ment d\00E9clencheur indiqu\00E9 est g\00E9n\00E9ralement un \00E9l\00E9ment conteneur (par exemple, une r\00E9gion) qui g\00E8re les \00E9v\00E9nements g\00E9n\00E9r\00E9s par tous les sous-\00E9l\00E9ments (par exemple, des \00E9l\00E9ments de page dans cette r\00E9gion).'),
unistr('Ce type de s\00E9lection peut \00EAtre utilis\00E9 pour appliquer une action sur le sous-\00E9l\00E9ment ayant g\00E9n\00E9r\00E9 l''\00E9v\00E9nement, plut\00F4t que sur l''\00E9v\00E9nement conteneur.'),
unistr('Par exemple, si une action dynamique d\00E9finit un \00E9v\00E9nement de <strong>modification</strong> dans une r\00E9gion de votre page, l''action affecte l''\00E9l\00E9ment r\00E9el dans la r\00E9gion modifi\00E9e.</p>'),
unistr('<p>L''utilisation de l''option <em>Source d''\00E9v\00E9nement</em> peut \00EAtre plus efficace pour d\00E9finir des comportements courants qui affectent de nombreux \00E9l\00E9ments de page.'),
unistr('La capacit\00E9 des \00E9l\00E9ments de conteneur \00E0 d\00E9tecter des \00E9v\00E9nements g\00E9n\00E9r\00E9s par des sous-\00E9l\00E9ments est d\00E9termin\00E9e par le type d''\00E9v\00E9nement.'),
unistr('Les types d''\00E9v\00E9nement suivants le prennent en charge : </p>'),
'<ul>',
unistr('  <li><strong>Apr\00E8s r\00E9g\00E9n\00E9ration</strong> (apexafterrefresh)</li>'),
unistr('  <li><strong>Avant r\00E9g\00E9n\00E9ration</strong> (apexbeforerefresh)</li>'),
'  <li><strong>Modification</strong> (change)</li>',
'  <li><strong>Clic</strong> (click)</li>',
'  <li><strong>Double-clic</strong> (dblclick)</li>',
unistr('  <li><strong>El\00E9ment actif s\00E9lectionn\00E9</strong> (focus)</li>'),
'  <li><strong>Activation de la touche</strong> (keydown)</li>',
'  <li><strong>Saisie de texte</strong> (keypress)</li>',
unistr('  <li><strong>D\00E9sactivation de la touche</strong> (keyup)</li>'),
unistr('  <li><strong>El\00E9ment actif d\00E9s\00E9lectionn\00E9</strong> (blur)</li>'),
unistr('  <li><strong>Bouton de la souris enfonc\00E9</strong> (mousedown)</li>'),
unistr('  <li><strong>Bouton de la souris rel\00E2ch\00E9</strong> (mouseup)</li>'),
unistr('  <li><strong>D\00E9placement de la souris</strong> (mousemove)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708232877306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708331607306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action affecte au moins un \00E9l\00E9ment de page que vous saisissez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050816755306369)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050973204306370)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action affecte les \00E9l\00E9ments de page renvoy\00E9s \00E0 l''aide de l''expression JavaScript que vous saisissez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709017862306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur jQuery')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709129070306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action affecte les \00E9l\00E9ments de page renvoy\00E9s \00E0 l''aide de la syntaxe de s\00E9lecteur jQuery que vous saisissez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708611098306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708700142306100)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action affecte la r\00E9gion que vous s\00E9lectionnez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709208993306101)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d\00E9clencheur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709384807306101)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action affecte le composant ou l''\00E9l\00E9ment de page qui a d\00E9clench\00E9 l''action dynamique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218709025305727)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de s\00E9lection')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331314322305812)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune agr\00E9gation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331443662305812)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Renvoie la colonne de valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981692826306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la m\00E9thode d''agr\00E9gation de la colonne de valeurs de graphique associ\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983119339306318)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'fr'
,p_message_text=>'Nombre approximatif de valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983228705306318)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Renvoie le nombre approximatif de valeurs distinctes. Cette agr\00E9gation est beaucoup plus rapide que <em>Nombre de valeurs distinctes</em> en cas de traitement de grands volumes de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982183080306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'fr'
,p_message_text=>'Moyenne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982270357306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'fr'
,p_message_text=>'Renvoie la moyenne de la colonne de valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981788417306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981843821306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Renvoie le nombre d''enregistrements.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982976950306318)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'fr'
,p_message_text=>'Nombre de valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983041619306318)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Renvoie le nombre exact de valeurs distinctes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982786199306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'fr'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982853233306318)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'fr'
,p_message_text=>'Renvoie la valeur maximale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982356560306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9diane')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982483494306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Renvoie le nombre m\00E9dian, en ignorant les valeurs NULL. Cette agr\00E9gation est id\00E9ale pour un mod\00E8le de distribution continue, car elle renvoie le nombre du milieu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982514544306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'fr'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982696303306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Renvoie la valeur minimale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981940855306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'fr'
,p_message_text=>'Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101982091382306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'fr'
,p_message_text=>'Renvoie le total de la colonne de valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981599629306317)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9gation de valeurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198155974305694)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si l''utilisateur final peut soumettre plusieurs fois la m\00EAme page.'),
unistr('Utilisez cette fonctionnalit\00E9 pour \00E9viter la duplication des insertions dans une m\00EAme table,'),
unistr('qui peut survenir lorsque l''utilisateur final clique sur le bouton Pr\00E9c\00E9dent du navigateur et soumet la page une seconde fois, ou lorsqu''il clique sur le bouton Recharger du navigateur.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699725815306093)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Non - Emp\00EAcher le renvoi de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699804115306093)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'Oui - Activer le renvoi de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198033581305693)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Activer les soumissions de page en double'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527959906305956)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les colonnes NULL sont masqu\00E9es sur la vue d''enregistrement unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527826431305956)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Exclure les valeurs NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528156017305956)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si seules les colonnes affich\00E9es apparaissent dans la vue d''enregistrement unique. Si vous indiquez <strong>D\00E9sactiv\00E9</strong>, les colonnes d''\00E9tat non affich\00E9es peuvent \00E9galement \00EAtre affich\00E9es dans la vue d''enregistrement unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528050343305956)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Uniquement les colonnes affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522004073305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent agr\00E9ger cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521946624305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9ger')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522466217305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent utiliser cette colonne dans un graphique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522326779305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522283193305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent utiliser cette colonne dans une colonne de calcul d\00E9finie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522144600305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Calculer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521810471305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent utiliser cette colonne dans une commande BREAK.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521709474305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Commande BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521484625305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent filtrer cette colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521374011305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522639231305953)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent effectuer un regroupement sur cette colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522528682305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Grouper par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521082237305951)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent masquer cette colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520916539305951)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Masquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521673738305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent mettre en \00E9vidence cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521538076305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834820617305416)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir une r\00E9partition avec permutation lignes vers colonnes dans cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834756261305416)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Permutation lignes vers colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535956482305962)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent enregistrer la d\00E9finition d''\00E9tat en cours en tant qu''\00E9tat <em>public</em>.</p>'),
unistr('<p>Les \00E9tats publics sont affich\00E9s dans une liste de s\00E9lection des \00E9tats disponibles dans la barre de recherche et sont visibles pour tous les utilisateurs.'),
unistr('L''option dans le menu Actions est uniquement disponible pour les utilisateurs authentifi\00E9s et est restreinte si vous remplissez \00E9galement l''\00E9l\00E9ment <strong>Enregistrer l''autorisation d''\00E9tat public </strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535875232305962)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer un \00E9tat public')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535745297305962)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent enregistrer la d\00E9finition d''\00E9tat en cours en tant qu''\00E9tat <em>priv\00E9</em>.</p>'),
unistr('<p>Les \00E9tats priv\00E9s sont affich\00E9s dans une liste de s\00E9lection des \00E9tats disponibles dans la barre de recherche et sont visibles uniquement pour les utilisateurs qui ont enregistr\00E9 l''\00E9tat, s''ils sont authentifi\00E9s.'),
unistr('L''option dans le menu Actions est uniquement disponible pour les utilisateurs authentifi\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535666894305962)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer un \00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536136386305962)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent enregistrer des cat\00E9gories d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536069162305962)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer les cat\00E9gories d''\00E9tat')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521236617305952)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent trier cette colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101521167898305951)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Trier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422880559305879)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez un autre libell\00E9 \00E0 utiliser dans les bo\00EEtes de dialogue et dans la vue monoligne.'),
unistr('        Utilisez un autre libell\00E9 lorsque l''en-t\00EAte contient un formatage suppl\00E9mentaire, comme des balises HTML, qui ne s''affiche pas correctement.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422773221305879)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de remplacement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299640916305787)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si cette validation est toujours ex\00E9cut\00E9e.'),
unistr('Si la valeur est d\00E9finie sur <strong>Activ\00E9</strong>, cette validation est toujours \00E9valu\00E9e, quel que soit le param\00E8tre <em>Ex\00E9cuter les validations</em> d\00E9fini par rapport au bouton qui a soumis la page.'),
unistr('Si elle est d\00E9finie sur <strong>D\00E9sactiv\00E9</strong>, cette validation est uniquement \00E9valu\00E9e si le param\00E8tre <em>Ex\00E9cuter les validations</em> du bouton d\00E9clencheur est <strong>Activ\00E9</strong>.</p>'),
unistr('<p>Remarque : pour pouvoir \00EAtre \00E9valu\00E9e, cette validation doit \00E9galement satisfaire les conditions indiqu\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299532429305787)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Toujours ex\00E9cuter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465798851305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si l''animation appara\00EEt lorsque les donn\00E9es sont modifi\00E9es sur le graphique. Une modification de donn\00E9es peut survenir si le graphique est r\00E9g\00E9n\00E9r\00E9 automatiquement, si le comportement de masquage et d''affichage est ex\00E9cut\00E9 lorsque vous cl')
||unistr('iquez sur un \00E9l\00E9ment de l\00E9gende, ou lorsque les donn\00E9es du graphique sont mises \00E0 jour par programme via un code JavaScript personnalis\00E9 ou une action dynamique.</p>'),
unistr('        <p>Les options <strong>Faire glisser vers la gauche</strong> et <strong>Faire glisser vers la droite</strong> ne s''appliquent pas aux graphiques \00E0 cadran</p>.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465866599305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596321588306010)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Appliquez les param\00E8tres d''animation par d\00E9faut d\00E9finis par Oracle JET pour le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466175154305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605869081306018)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune animation n''est appliqu\00E9e au graphique lorsque les donn\00E9es sont modifi\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465924518305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'fr'
,p_message_text=>'Faire glisser vers la gauche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605694228306017)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les \00E9l\00E9ments de donn\00E9es glissent vers la gauche lorsque les donn\00E9es sont modifi\00E9es. Ce param\00E8tre ne s''applique pas aux graphiques de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466088428305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'Faire glisser vers la droite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605755914306017)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les \00E9l\00E9ments de donn\00E9es glissent vers la droite lorsque les donn\00E9es sont modifi\00E9es. Ce param\00E8tre ne s''applique pas aux graphiques de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465602831305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lors de la modification de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465117444305911)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type d''animation utilis\00E9e lors de l''affichage initial du graphique.</p>'),
unistr('        <p>Les options <strong>Fondu alpha</strong> et <strong>Zoom</strong> ne s''appliquent pas aux graphiques \00E0 cadran.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465366907305911)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'fr'
,p_message_text=>'Fondu alpha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596070597306010)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Fondu sur le graphique lors de l''affichage initial. Ce param\00E8tre ne s''applique pas aux graphiques de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465280551305911)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595990511306010)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Appliquez les param\00E8tres d''animation par d\00E9faut d\00E9finis par Oracle JET pour le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465544543305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596275235306010)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune animation n''est appliqu\00E9e au graphique lors de l''affichage initial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465465248305912)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'fr'
,p_message_text=>'Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596146967306010)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Zoom avant sur le graphique lors de l''affichage initial. Ce param\00E8tre ne s''applique pas aux graphiques de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101465096380305911)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Lors de l''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877675394306231)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900721303306248)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878480750306231)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes CSS suppl\00E9mentaires (s\00E9par\00E9es par un espace) que vous voulez ajouter \00E0 l''\00E9tat. Le mod\00E8le d''\00E9tat doit inclure la cha\00EEne de substitution <code>#COMPONENT_CSS_CLASSES#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432373605305886)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
'',
unistr('        <p>Remarque : ces classes CSS seront appliqu\00E9es aux cellules de la grille interactive. Pour appliquer ces classes CSS \00E0 l''\00E9l\00E9ment correspondant, reportez-vous \00E0 la propri\00E9t\00E9 Classes CSS dans le groupe Avanc\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877326121306230)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877417614306231)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez des classes \00E0 ajouter \00E0 cet \00E9l\00E9ment. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.<p/>'),
unistr('        <p>Cette propri\00E9t\00E9 peut \00EAtre utilis\00E9e pour apporter des modifications de style \00E0 l''\00E9l\00E9ment, au-del\00E0 des options de mod\00E8le, ou pour permettre de s\00E9lectionner plus facilement cet \00E9l\00E9ment via JavaScript.</p>'),
unistr('        <p>Remarque : pour appliquer des classes CSS \00E0 la balise d''\00E9l\00E9ment de panneau HTML, reportez-vous \00E0 la propri\00E9t\00E9 Classes CSS dans le groupe Avanc\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877717298306231)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878666674306231)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878587141306231)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes CSS suppl\00E9mentaires (s\00E9par\00E9es par un espace) que vous voulez ajouter \00E0 l''\00E9tat. Le mod\00E8le d''\00E9tat doit inclure la cha\00EEne de substitution <code>#COMPONENT_CSS_CLASSES#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877295151306230)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Ajouter les classes CSS <code>articlenumber</code> et <code>highlight</code> au composant</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877159924306230)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877022111306230)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836327083305417)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la port\00E9e de cet \00E9l\00E9ment d''application. Indiquez <strong>Global</strong> si la session &PRODUCT_NAME. est partag\00E9e par plusieurs applications et que la valeur de l''\00E9l\00E9ment doit \00EAtre la m\00EAme pour toutes les applications.'),
unistr('Sinon, indiquez <strong>Application</strong> (port\00E9e par d\00E9faut).</p>'),
unistr('<p>Les applications peuvent partager la m\00EAme session si leurs authentifications ont les m\00EAmes <em>attributs de cookie de session</em>.'),
unistr('L''attribut de port\00E9e des \00E9l\00E9ments d''application doit \00E9galement \00EAtre le m\00EAme pour ces applications.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731557518306117)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'fr'
,p_message_text=>'Application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731621555306117)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'fr'
,p_message_text=>'Global'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836209595305417)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Port\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482370109305924)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la s\00E9rie en cours est affect\00E9e \00E0 l''axe Y2 affich\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482221247305924)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Affect\00E9 \00E0 l''axe Y2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300221652305787)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne associ\00E9e \00E0 ce composant de traitement de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300107939305787)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne associ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300008350305787)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''\00E9l\00E9ment dans lequel sera affich\00E9 ce message d''erreur de validation.'),
unistr('Si vous s\00E9lectionnez un \00E9l\00E9ment et que le param\00E8tre <em>Emplacement d''affichage du message d''erreur</em> inclut Incorporation avec un champ, le message d''erreur appara\00EEtra sous le libell\00E9 de l''\00E9l\00E9ment indiqu\00E9.'),
'Si <em>Emplacement d''affichage du message d''erreur</em> n''inclut pas Incorporation avec un champ, cet attribut n''a aucun effet sur l''affichage du message d''erreur.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299984071305787)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment associ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903742279306250)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282067368305774)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227680221305734)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le mod\00E8le d''autorisation appliqu\00E9 \00E0 la page. Les mod\00E8les d''autorisation sont d\00E9finis au niveau application et peuvent \00EAtre appliqu\00E9s \00E0 plusieurs \00E9l\00E9ments de l''application.</p>'),
unistr('<p>Le mod\00E8le d''autorisation est \00E9valu\00E9 soit une fois par session d''application (\00E0 la cr\00E9ation de la session), soit une fois par affichage de page. Si le r\00E9sultat de l''\00E9valuation est <strong>TRUE</strong>, la page est affich\00E9e et elle est soumise aux ')
||unistr('autres conditions d\00E9finies. Si le r\00E9sultat de l''\00E9valuation est <strong>FALSE</strong>, la page n''est pas affich\00E9e et un message d''erreur appara\00EEt.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197317726305693)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un mod\00E8le d''autorisation pour contr\00F4ler ce composant. L''autorisation doit aboutir \00E0 la valeur TRUE pour que ce composant soit recompos\00E9 ou ex\00E9cut\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197225429305693)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188282986305686)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le mod\00E8le d''autorisation \00E0 appliquer. Les types d''autorisation suivants sont pris en charge :</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En fonction de la configuration de l''application, des modules d''extension de type d''autorisation suppl\00E9mentaires peuvent \00EAtre disponibles ici.'),
unistr('Ceux-ci sont affich\00E9s au format <em>&lt;Mon module d''extension&gt; [Module d''extension]</em>.'),
unistr('Les modules d''extension suivants sont install\00E9s dans les composants partag\00E9s de cette application :</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188181481305686)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040193769306362)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040480642306362)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040304184306362)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040259658306362)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040523651306362)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040087397306362)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041363015306363)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la source des donn\00E9es \00E9valu\00E9es lors de l''ex\00E9cution de l''automatisation. Les automatisations peuvent \00EAtre bas\00E9es sur des tables, des requ\00EAtes SQL ou des fonctions PL/SQL renvoyant une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041294606306362)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041129654306362)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041002293306362)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la source des donn\00E9es \00E9valu\00E9es lors de l''ex\00E9cution de l''automatisation. Les automatisations peuvent \00EAtre bas\00E9es sur des tables, des requ\00EAtes SQL ou des fonctions PL/SQL renvoyant une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040940178306362)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040874292306362)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040727522306362)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la source des donn\00E9es \00E9valu\00E9es lors de l''ex\00E9cution de l''automatisation. Les automatisations peuvent \00EAtre bas\00E9es sur des tables, des requ\00EAtes SQL ou des fonctions PL/SQL renvoyant une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102040679341306362)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041510790306363)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la source des donn\00E9es \00E9valu\00E9es lors de l''ex\00E9cution de l''automatisation. Les automatisations peuvent \00EAtre bas\00E9es sur des tables, des requ\00EAtes SQL ou des fonctions PL/SQL renvoyant une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041480702306363)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039650451306361)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039511958306361)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039459083306361)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la source des donn\00E9es \00E9valu\00E9es lors de l''ex\00E9cution de l''automatisation. Les automatisations peuvent \00EAtre bas\00E9es sur des tables, des requ\00EAtes SQL ou des fonctions PL/SQL renvoyant une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039342638306361)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039943050306362)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039846008306361)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type d''action.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102039752386306361)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338652330305817)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si l''interface utilisateur appropri\00E9e est d\00E9tect\00E9e automatiquement.'),
unistr('Si la d\00E9tection automatique est d\00E9finie sur <strong>Activ\00E9</strong>, l''utilisateur est automatiquement r\00E9achemin\00E9 vers la page de connexion ou la page d''accueil la plus appropri\00E9e, en fonction de la taille de l''appareil  utilis\00E9.'),
unistr('Les requ\00EAtes de support permettent de d\00E9terminer l''interface utilisateur correspondante \00E0 afficher.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338558361305817)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tection automatique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484348313305925)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur maximale de l''axe. La valeur par d\00E9faut est NULL pour le calcul automatique en fonction des donn\00E9es.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484203718305925)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484121559305925)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur minimale de l''axe. La valeur par d\00E9faut est NULL pour le calcul automatique en fonction des donn\00E9es.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484056956305925)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485182247305926)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la position des libell\00E9s \00E0 afficher sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485242657305926)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485642360305926)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485404436305926)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485342591305926)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485578121305926)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485045271305926)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507521169305942)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9chelle de l''axe. Applicable uniquement \00E0 des axes num\00E9riques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507665947305942)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lin\00E9aire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507743973305942)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'fr'
,p_message_text=>'Journal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507494459305942)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Echelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484933712305926)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''incr\00E9ment entre les marques de graduation principales. La valeur par d\00E9faut est NULL pour le calcul automatique en fonction des donn\00E9es. Cette option est applicable uniquement \00E0 des axes num\00E9riques et temporels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484813513305926)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Etape'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891843845306241)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme badge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891719940306241)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de badge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892020582306241)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891951845306241)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS de badge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892336647306241)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Pour afficher des \00E9valuations de film</dt>'),
unistr('    <dd>La colonne de badge peut correspondre \00E0 la colonne RATING et le libell\00E9 du badge peut \00EAtre "Etoiles"</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892264382306241)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le libell\00E9 du badge servant \00E0 d\00E9crire sa valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892158340306241)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de badge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587371816306004)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sp\00E9cifiez la date de d\00E9but du calendrier. La s\00E9lection de cette option cr\00E9e un calendrier couvrant un intervalle complet (par exemple, un mois).</p>'),
'<ul>',
unistr('  <li>Si Commencer au d\00E9but de l''intervalle est d\00E9fini sur <strong>Activ\00E9</strong>, que la date est le 15 juin et que l''affichage est mensuel, le calendrier couvrira la p\00E9riode du 1er au 30 juin.</li>'),
unistr('  <li>Si Commencer au d\00E9but de l''intervalle est d\00E9fini sur <strong>D\00E9sactiv\00E9</strong>, que la date est le 15 juin et que l''affichage est mensuel, le calendrier couvrira la p\00E9riode du 15 au 30 juin.</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587246656306003)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Commencer au d\00E9but de l''intervalle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558605035305981)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne de jeu de caract\00E8res dans la table qui stocke le contenu BLOB \00E0 afficher. Il est peu probable que l''image apparaisse si vous s\00E9lectionnez une colonne avec le mauvais type de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558557645305981)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de jeu de caract\00E8res')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557635761305981)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne BLOB dans la table qui stocke le contenu BLOB \00E0 afficher. Il est peu probable que l''image apparaisse si vous s\00E9lectionnez une colonne avec le mauvais type de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557515753305980)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558496665305981)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la colonne de nom de fichier de la table qui stocke le contenu BLOB \00E0 afficher. Il est peu probable que l''image apparaisse si vous s\00E9lectionnez une colonne avec le mauvais type de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558334834305981)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de nom de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558820066305981)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la derni\00E8re colonne mise \00E0 jour dans la table qui stocke le contenu BLOB \00E0 afficher. Si vous avez d\00E9j\00E0 une colonne <code>UPDATED</code> avec un d\00E9clencheur associ\00E9 pour tenir \00E0 jour la date, vous pouvez utiliser cette colonne plut\00F4t que ')
||unistr('de d\00E9finir une nouvelle colonne sp\00E9cifique pour la derni\00E8re mise \00E0 jour de l''image. Cependant, si d''autres colonnes que celles du contenu BLOB sont r\00E9guli\00E8rement mises \00E0 jour, cela affecte la mise en cache d''image. Il est peu probable que l''image app')
||unistr('araisse si vous s\00E9lectionnez une colonne avec le mauvais type de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558763075305981)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de derni\00E8re mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558259048305981)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne de type MIME dans la table qui stocke le contenu BLOB \00E0 afficher. Il est peu probable que l''image apparaisse si vous s\00E9lectionnez une colonne avec le mauvais type de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558114411305981)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de colonne MIME'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557805316305981)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la premi\00E8re colonne de cl\00E9 primaire dans la table qui stocke le contenu BLOB \00E0 afficher. Si la cl\00E9 primaire de cette table contient plus de deux colonnes, vous devez s\00E9lectionner la colonne <code>ROWID</code>. Il est peu probable que l''i')
||unistr('mage apparaisse si vous s\00E9lectionnez une colonne avec le mauvais type de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557741260305981)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558094734305981)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la deuxi\00E8me colonne de cl\00E9 primaire uniquement si la cl\00E9 primaire pour votre table poss\00E8de deux colonnes. Si vous s\00E9lectionnez <code>ROWID</code> pour la premi\00E8re colonne de cl\00E9 primaire, vous ne devez pas remplir cette colonne. Il est p')
||unistr('eu probable que l''image apparaisse si vous s\00E9lectionnez une colonne avec le mauvais type de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557918315305981)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557491105305980)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le nom de la table qui stocke le contenu BLOB \00E0 afficher.'),
unistr('Vous pouvez saisir le nom de la table ou le s\00E9lectionner dans la liste des tables disponibles.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557381403305980)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557237590305980)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le sch\00E9ma propri\00E9taire de la table qui stocke le contenu BLOB \00E0 afficher.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101557149387305980)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887486245306238)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant doit \00EAtre affich\00E9 \00E0 l''aide d''une colonne ou \00E0 l''aide d''un format avanc\00E9 bas\00E9 sur des expressions HTML et des cha\00EEnes de substitution prises en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887348297306238)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887698118306238)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme corps.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887510067306238)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888126849306238)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888034150306238)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196925451305693)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le texte ou le code HTML que vous voulez voir appara\00EEtre avant les r\00E9gions affich\00E9es dans la page en cours d''ex\00E9cution.'),
unistr('Le texte que vous saisissez ici appara\00EEt avant la cha\00EEne de substitution <code>#BODY#</code> du mod\00E8le de page.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196877384305693)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de corps')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887946801306238)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&COLUMN_CLASS.</code> et <code>&EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887857189306238)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les expressions HTML \00E0 afficher dans cette colonne. Utilisez la syntaxe <code>&COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887751294306238)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578543099305997)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la demande \00E0 inclure dans le lien de branchement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578425852305997)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Demande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976818795306313)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977196940306313)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977080148306313)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976933438306313)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977267481306313)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976744435306313)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552241316305976)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez l''\00E9l\00E9ment de page ou d''application qui contient un num\00E9ro de page ou une URL de renvoi.'),
unistr('Cet \00E9l\00E9ment peut \00EAtre d\00E9fini par la page appelante ou par un processus au premier chargement de la page.'),
unistr('La sp\00E9cification d''un \00E9l\00E9ment permet de d\00E9finir de fa\00E7on dynamique et facile le branchement pour les pages qui sont appel\00E9es \00E0 partir de nombreuses autres pages.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552136422305976)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978054350306314)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Java qui renvoie l''URL ou le num\00E9ro de page vers lequel effectuer le r\00E9acheminement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977971179306314)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977878726306314)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977777271306314)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction JavaScript qui renvoie l''URL ou le num\00E9ro de page vers lequel effectuer le r\00E9acheminement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977603161306314)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298568263305786)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la page vers laquelle ce branchement est r\00E9achemin\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298439037305786)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298763603305786)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le code PL/SQL ex\00E9cut\00E9 par le branchement. Cette proc\00E9dure PL/SQL permet d''appeler l''URL n\00E9cessaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298667008305786)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977533566306313)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977487850306313)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction PL/SQL qui renvoie l''URL ou le num\00E9ro de page vers lequel effectuer le r\00E9acheminement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101977391688306313)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298136717305786)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez \00E0 quel moment du rendu ou du traitement de la page ce branchement est ex\00E9cut\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720035733306108)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s traitement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009629023306339)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : cr\00E9e des branchements apr\00E8s l''ex\00E9cution des traitements.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719741652306108)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s soumission')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009351389306338)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : cr\00E9e des branchements apr\00E8s la soumission de la page et avant l''ex\00E9cution du calcul, des validations et des traitements.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720135439306109)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009747774306339)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : cr\00E9e des branchements avant le rendu de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719977882306108)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'fr'
,p_message_text=>'Traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009562235306339)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : cr\00E9e des branchements avant l''ex\00E9cution des traitements.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719870912306108)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'fr'
,p_message_text=>'Validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009408897306338)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : cr\00E9e des branchements avant l''ex\00E9cution des validations.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298021771305786)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Point'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978207771306314)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Python qui renvoie l''URL ou le num\00E9ro de page vers lequel effectuer le r\00E9acheminement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978158729306314)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297981394305786)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type de branchement de page \00E0 effectuer.</p>'),
'<dl>',
unistr('<dt>Branchements avec r\00E9acheminement</dt>'),
unistr('<dd>&PRODUCT_NAME. renvoie la nouvelle page ou l''URL au navigateur, qui effectue une nouvelle demande avant d''afficher la page r\00E9sultante.'),
unistr('Cet avantage majeur permet aux utilisateurs finals de r\00E9g\00E9n\00E9rer la page sans perte de contexte, car l''adresse du navigateur contient l''URL de page compl\00E8te.'),
unistr('L''inconv\00E9nient est que le navigateur effectue une demande suppl\00E9mentaire pour afficher la page.</dd>'),
'<dt>Branchements en affichage seul</dt>',
unistr('<dd>&PRODUCT_NAME. affiche imm\00E9diatement la nouvelle page dans le cadre du traitement de la page en cours, sans effectuer de demande suppl\00E9mentaire.'),
unistr('L''avantage est que le navigateur n''effectue aucune demande suppl\00E9mentaire.'),
unistr('L''inconv\00E9nient majeur est que l''adresse du navigateur sera <code>wwv_flow.accept</code>.'),
unistr('Si les utilisateurs finals r\00E9g\00E9n\00E8rent la page, le navigateur demandera le renvoi des donn\00E9es, car son adresse n''est pas une URL de page compl\00E8te.</dd>'),
'</dl>',
unistr('<p>Oracle recommande de s\00E9lectionner l''un des type de branchement avec r\00E9acheminement pour optimiser l''exp\00E9rience utilisateur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719185657306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>'Fonction renvoyant une page (Afficher uniquement)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719249284306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction renvoyant une URL (R\00E9acheminer)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719660287306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'fr'
,p_message_text=>'Traitement de page {non commun}'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719484407306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page identifi\00E9e par un \00E9l\00E9ment (Afficher uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719029631306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'fr'
,p_message_text=>'Page (Afficher uniquement)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719532525306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('URL identifi\00E9e par un \00E9l\00E9ment (R\00E9acheminer)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101719351362306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure PL/SQL [h\00E9rit\00E9]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718993008306108)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page ou URL (R\00E9acheminer)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297863784305785)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836193883305417)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mod\00E8le de chemin de navigation utilis\00E9 avec ce chemin de navigation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836072619305417)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de chemin de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564206769305986)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte qui s''affiche apr\00E8s les colonnes de section lors de l''affichage d''une ligne de section.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564100185305985)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne post\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563858793305985)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez le texte qui s''affiche avant les colonnes de section lors de l''affichage d''une ligne de section.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563719441305985)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne ant\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574598397305994)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucune section'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575759210305995)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucune section'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563005746305985)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nombre de colonnes d''\00E9tat incorpor\00E9es dans le formatage de section. Les colonnes doivent \00EAtre cons\00E9cutives, en partant de la premi\00E8re colonne affich\00E9e dans l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742003415306125)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Premi\00E8re colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742150109306125)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Premi\00E8re et deuxi\00E8me colonnes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742205409306125)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Premi\00E8re, deuxi\00E8me et troisi\00E8me colonnes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562995039305985)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de section (BREAK)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563289101305985)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''impact des sections sur le formatage d''affichage de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742528641306125)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage par sections (BREAK) par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742696466306126)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les sections sont affich\00E9es dans un seul \00E9tat et les en-t\00EAtes ne sont pas r\00E9p\00E9t\00E9s pour chaque section.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742364249306125)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9p\00E9ter les en-t\00EAtes dans les sections')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742406339306125)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9tat est affich\00E9 sous la forme de plusieurs sous-\00E9tats et les en-t\00EAtes sont r\00E9p\00E9t\00E9s pour chaque section.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563136301305985)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563666860305985)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte affich\00E9 sur les sections d''\00E9tat. Utilisez les substitutions <code>#SUM_COLUMN_HEADER#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563595196305985)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Format de section d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564070656305985)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte pour la colonne de section lors de l''affichage d''une section d''\00E9tat. Vous pouvez utiliser les substitutions <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563948759305985)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Format de section de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563426060305985)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte pour les en-t\00EAtes r\00E9p\00E9t\00E9s affich\00E9s pour les sections d''\00E9tat. Vous pouvez utiliser les substitutions <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101563331875305985)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Format de r\00E9p\00E9tition d''en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573790593305993)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014848445306343)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilise le param\00E8tre d\00E9fini dans les attributs de s\00E9curit\00E9 d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198952552305694)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''activation du cache permet au navigateur d''enregistrer le contenu des pages de l''application dans son cache, dans la m\00E9moire et sur le disque.'),
unistr('Si un utilisateur clique sur le bouton Pr\00E9c\00E9dent du navigateur, la page est normalement charg\00E9e \00E0 partir du cache, et pas \00E0 partir du serveur.'),
unistr('Si le cache est d\00E9sactiv\00E9, le navigateur n''enregistre pas le contenu de page et il le demande \00E0 nouveau \00E0 partir du serveur.</p>'),
unistr('<p>Pour des raisons de s\00E9curit\00E9, Oracle recommande de d\00E9sactiver le cache, pour que le navigateur ne stocke pas les donn\00E9es confidentielles et qu''il demande toujours des pages si l''URL change.'),
unistr('Sinon, un utilisateur peut retourner dans l''historique du navigateur, m\00EAme apr\00E8s d\00E9connexion, et visualiser le contenu mis en m\00E9moire cache de la session pr\00E9c\00E9dente.'),
unistr('La d\00E9sactivation du cache du navigateur permet \00E9galement d''\00E9liminer les probl\00E8mes li\00E9s au bouton Pr\00E9c\00E9dent avec les pages utilisant les r\00E9g\00E9n\00E9rations partielles, comme les \00E9tats interactifs.</p>'),
unistr('<p>Si cet attribut est d\00E9fini sur <strong>D\00E9sactiv\00E9</strong>, &PRODUCT_NAME. envoie l''en-t\00EAte HTTP <em>cache-control: no-store</em>, indiquant au navigateur de ne pas mettre en m\00E9moire cache le contenu de page sur le disque ou dans la m\00E9moire.'),
unistr('S''il est d\00E9fini sur <strong>Valeur par d\00E9faut de l''application</strong>, la valeur au moment de l''ex\00E9cution est l''attribut de <em>cache de navigateur</em> de l''application.</p>'),
unistr('<p>Remarque : cette fonctionnalit\00E9 exige un navigateur moderne prenant en charge la variable de r\00E9ponse d''en-t\00EAte HTTP <code>cache-control</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702109885306095)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702089058306095)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198872326305694)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Cache de navigateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083773370306394)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. Vous d\00E9veloppez une application qui aura de nombreuses installations.'),
unistr('                                        Chaque installation peut \00E9galement choisir d''activer ou de d\00E9sactiver certaines fonctions d''application.'),
unistr('                                        Avec les options de construction, vous pouvez d\00E9velopper une application et, une fois celle-ci install\00E9e, des options de construction peuvent \00EAtre configur\00E9es pour inclure et exclure les fonctions d''application')
||unistr('s associ\00E9es.'),
'                                        Vous pouvez aussi utiliser l''API pour afficher cette fonction dans l''application.',
unistr('                                        Cela permet aux utilisateurs finals privil\00E9gi\00E9s d''activer ou de d\00E9sactiver de fa\00E7on s\00E9lective des fonctions d''application.</p>'),
unistr('                                      <p>2. Vous d\00E9veloppez une fonction qui n''est pas encore termin\00E9e, vous ne voulez donc pas qu''elle soit visible pour les utilisateurs finals.'),
unistr('									    L''utilisation des options de construction vous permet de d\00E9sactiver cette fonction dans l''application lorsqu''elle est cr\00E9\00E9e dans les environnements de test et de production.'),
unistr('									    L''avantage de cette approche est que l''application peut quand m\00EAme \00EAtre d\00E9ploy\00E9e sans inclure une fonction non aboutie.</p>'),
unistr('                                      <p>3. Vous enlevez les fonctions que vous jugez inutiles pour l''application, mais vous n''\00EAtes pas certain que cette op\00E9ration soit s\00FBre.'),
unistr('									    Dans ce cas, vous pouvez utiliser les options de construction pour essentiellement "mettre en commentaire" des fonctions sp\00E9cifiques.'),
unistr('									    Lors du d\00E9ploiement, si les fonctions enlev\00E9es sont jug\00E9es n\00E9cessaires, elles peuvent \00EAtre r\00E9install\00E9es.'),
unistr('									    Si ces fonctions ne sont pas jug\00E9es n\00E9cessaires, elles peuvent \00EAtre enlev\00E9es en tout s\00E9curit\00E9 de l''application.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199138559305694)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez une option de construction pour ce composant.</p>'),
unistr('                                     <p>Les options de construction permettent d''activer ou de d\00E9sactiver de mani\00E8re conditionnelle les fonctionnalit\00E9s et les composants d''application lorsque l''application est install\00E9e, ou lors de l''ex\00E9cution via l''')
||'API (APEX_UTIL.SET_BUILD_OPTION_STATUS).<br>',
unistr('                                       Les options de construction peuvent d\00E9finir ce composant afin qu''il soit inclus ou exclu dans l''application d''ex\00E9cution :</p>'),
unistr('									 <p><strong>Inclus :</strong> activ\00E9 et fait partie de l''application.</p>'),
unistr('									 <p><strong>Exclu :</strong> d\00E9sactiv\00E9 et ne fait pas partie de l''application.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199093693305694)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Option de construction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187665713305686)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un statut d''option de construction pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696074379306091)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'fr'
,p_message_text=>'Exclure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696115962306091)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le moteur &PRODUCT_NAME. consid\00E8re que ce composant n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695831023306090)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'fr'
,p_message_text=>'Inclure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695935597306091)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le moteur &PRODUCT_NAME. consid\00E8re ce composant comme un \00E9l\00E9ment de la d\00E9finition d''application au moment de l''ex\00E9cution.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187587331305686)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301221606305788)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''action \00E0 ex\00E9cuter lors d''un clic sur ce bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721879768306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini par une action dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721963271306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne soumet pas la page ou ne r\00E9achemine pas vers une autre page. A la place, le comportement du bouton est d\00E9fini par une action dynamique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722266324306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>'Page suivante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722361797306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la page suivante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722497425306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page pr\00E9c\00E9dente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722542194306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la page pr\00E9c\00E9dente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721440859306109)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une page dans une autre application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721586699306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>R\00E9acheminer vers une page dans une autre application, avec des attributs facultatifs suppl\00E9mentaires permettant de r\00E9initialiser la pagination, de d\00E9finir la valeur de demande, de vider le cache et de d\00E9finir des valeurs d''\00E9l\00E9ment sur la page cibl')
||'e.<p>',
unistr('<p>Remarque : le r\00E9acheminement vers une page dans une autre application repose sur l''activation du lien profond dans l''application cible. Pour activer le lien profond, acc\00E9dez aux attributs <em>S\00E9curit\00E9</em> de l''application et activez <em>Lien prof')
||'ond</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721236905306109)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la page dans cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721341935306109)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une page de l''application en cours, avec des attributs facultatifs suppl\00E9mentaires permettant de r\00E9initialiser la pagination, de d\00E9finir la valeur de demande, de vider le cache et de configurer des valeurs d''\00E9l\00E9ment sur la page cible')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721657007306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721728047306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''URL cible indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722075264306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722169828306110)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la page en effectuant une r\00E9g\00E9n\00E9ration de page compl\00E8te, et non une r\00E9g\00E9n\00E9ration de page partielle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721053397306109)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'fr'
,p_message_text=>'Soumettre une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101721145561306109)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Soumettre la page en cours avec une valeur REQUEST correspondant au nom du bouton.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301138361305788)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204506109305717)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le type d''op\00E9ration SQL ex\00E9cut\00E9 lorsque ce bouton est s\00E9lectionn\00E9.'),
unistr('Cela permet de d\00E9clencher l''action de base de donn\00E9es sp\00E9cifi\00E9e dans le traitement de ligne automatique (DML) int\00E9gr\00E9.'),
unistr('Si vous ne s\00E9lectionnez aucun type, le traitement de base de donn\00E9es est ex\00E9cut\00E9 selon la valeur REQUEST, qui est d\00E9finie en fonction du <strong>nom de bouton</strong> indiqu\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716095851306105)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'fr'
,p_message_text=>'Action SQL DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715818149306105)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'fr'
,p_message_text=>'Action SQL INSERT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715931783306105)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'fr'
,p_message_text=>'Action SQL UPDATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204403563305717)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Action de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899214909306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type d''affichage de bouton pour d\00E9finir l''apparence de ce bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899501293306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899694125306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche uniquement une ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899317170306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899466308306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche uniquement le libell\00E9 du bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899741716306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte avec une ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899863270306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche une ic\00F4ne en regard du libell\00E9 du bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899190338306247)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001072019306332)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez les attributs suppl\00E9mentaires affich\00E9s apr\00E8s la cellule de tableau HTML qui affiche chaque option d''un groupe de boutons d''option ou d''un ensemble de cases \00E0 cocher.'),
'Vous pouvez inclure du HTML, du JavaScript et des raccourcis.</p>',
unistr('<p>Vous pouvez r\00E9f\00E9rencer les cha\00EEnes de substitution suivantes :</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de panneau HTML auquel est associ\00E9 cet \00E9l\00E9ment de page.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de page en cours.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000918930306332)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de conclusion '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000831524306332)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez les attributs suppl\00E9mentaires affich\00E9s avant la cellule de tableau HTML qui affiche chaque option d''un groupe de boutons d''option ou d''un ensemble de cases \00E0 cocher.'),
'Vous pouvez inclure du HTML, du JavaScript et des raccourcis.</p>',
unistr('<p>Vous pouvez r\00E9f\00E9rencer les cha\00EEnes de substitution suivantes :</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de panneau HTML auquel est associ\00E9 cet \00E9l\00E9ment de page.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de page en cours.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000751558306331)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''introduction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204393131305717)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si la page est soumise et que cet attribut est d\00E9fini sur <strong>Activ\00E9</strong>, toutes les validations d\00E9finies pour la page et les validations int\00E9gr\00E9es (telles que le caract\00E8re obligatoire, un num\00E9ro valide ou une date valide) sont ex\00E9cut\00E9es ')
||unistr('c\00F4t\00E9 serveur.</p>'),
unistr('En outre, si le <em>mode de compatibilit\00E9</em> de l''application est d\00E9fini sur <strong>5.1</strong> ou une version sup\00E9rieure, &PRODUCT_NAME. effectuera \00E9galement les validations c\00F4t\00E9 client, comme le caract\00E8re obligatoire de l''\00E9l\00E9ment. Pour plus de ')
||unistr('d\00E9tails, reportez-vous \00E0 la section sur le mode de compatibilit\00E9 dans les notes de version.'),
unistr('La page ne sera soumise qu''une fois toutes les erreurs corrig\00E9es.</p>'),
unistr('<p>Si cet attribut est d\00E9fini sur <strong>D\00E9sactiv\00E9</strong>, aucune des validations d\00E9finies ou int\00E9gr\00E9es n''est ex\00E9cut\00E9e.'),
unistr('Si vous voulez qu''une validation sp\00E9cifique soit ex\00E9cut\00E9e ind\00E9pendamment de ce param\00E8tre, modifiez la validation et d\00E9finissez l''attribut de validation <strong>Toujours ex\00E9cuter</strong> sur <strong>Activ\00E9</strong>.</p>'),
unistr('<p>Cet attribut est particuli\00E8rement utile pour les boutons de suppression ou d''annulation, pour lesquels la majorit\00E9 des validations ne doivent pas \00EAtre ex\00E9cut\00E9es.'),
unistr('Les utilisateurs peuvent g\00E9n\00E9ralement continuer \00E0 effectuer ce type d''action si un \00E9l\00E9ment est NULL ou que son type est incorrect.'),
unistr('Toutefois, si des actions, telles que la suppression, doivent uniquement \00EAtre ex\00E9cut\00E9es par des utilisateurs autoris\00E9s, vous devez d\00E9finir l''attribut de validation <strong>Toujours ex\00E9cuter</strong> correspondant sur <strong>Activ\00E9</strong> ou vous a')
||unistr('ssurer qu''une condition appropri\00E9e est d\00E9finie sur le bouton proprement dit, de sorte qu''il ne soit affich\00E9 que pour les utilisateurs autoris\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204205309305716)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter les validations')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900672097306248)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le bouton <strong>Normal</strong> ou <strong>Actif</strong> doit \00EAtre utilis\00E9 lors de l''affichage de ce bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203911278305716)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le mod\00E8le de bouton <strong>Normal</strong> ou <strong>Actif</strong> doit \00EAtre utilis\00E9 lors de l''affichage de ce bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203832239305716)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Actif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900428838306248)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher sur le bouton. Si le type d''affichage du bouton est d\00E9fini sur Ic\00F4ne, votre saisie devient le texte alternatif de l''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217238017305726)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Si le bouton est de type texte, saisissez le texte \00E0 afficher sur le bouton. Si le bouton est une image, ce texte devient le texte ALT pour l''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217146772305726)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228141591305734)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom utilis\00E9 pour r\00E9f\00E9rencer le bouton s\00E9lectionn\00E9. Une fois cette page soumise, la valeur REQUEST est d\00E9finie sur ce nom de bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217098256305726)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nom utilis\00E9 pour identifier ce bouton dans le traitement de la page suivante.'),
unistr('Lorsque la page est soumise en cliquant sur ce bouton, la valeur REQUEST est d\00E9finie sur le nom saisi.</p>'),
unistr('<p>Le nom du bouton ne doit pas forc\00E9ment \00EAtre unique pour les boutons sur la m\00EAme page ou dans la m\00EAme r\00E9gion.'),
unistr('Vous pouvez indiquer plusieurs boutons avec le m\00EAme nom, ce qui d\00E9finit la m\00EAme valeur REQUEST lors de leur s\00E9lection.'),
unistr('Cela est utile pour d\00E9finir des boutons avec des conditions ou des <strong>libell\00E9s de bouton</strong> diff\00E9rents, qui doivent ex\00E9cuter le traitement de la m\00EAme page, en \00E9valuant simplement la valeur REQUEST commune.</p>'),
unistr('<p>Si vous nommez le bouton <code>FLOW_RESET_BUTTON</code>, il permettra de r\00E9initialiser la page en cours sans effectuer de soumission de page.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216925650305726)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000403703306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque l''utilisateur clique sur ce bouton, la page est soumise et la demande de page prend cette valeur. Si cette valeur est NULL et que l''option <em>Type de source de demande</em> est d\00E9finie sur <em>Valeur statique</em>, le nom du bouton sera util')
||unistr('is\00E9 comme valeur de demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000319151306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Origine de la demande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998327934306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Ceci identifie le type d''expression figurant dans l''attribut de source de demande. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000139110306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'fr'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000214440306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998607188306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998736582306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de colonne saisie dans <em>Colonne de base de donn\00E9es</em>, qui est r\00E9cup\00E9r\00E9e \00E0 partir d''un processus d''extraction de ligne int\00E9gr\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999503263306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999601060306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur g\00E9n\00E9r\00E9e par l''ex\00E9cution de l''<em>expression PL/SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999721529306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999868835306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par le <em>corps de fonction PL/SQL</em> saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998839923306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999009582306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999940769306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000072807306331)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de la <em>pr\00E9f\00E9rence</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999143929306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur unique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999242108306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la premi\00E8re valeur renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999380557306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur s\00E9par\00E9e par deux-points)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101999431937306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur une valeur d\00E9limit\00E9e par le signe deux-points qui concat\00E8ne chaque valeur de ligne, renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998426041306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998573264306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur le texte saisi dans <em>Valeur statique</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101998288625306330)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de source de demande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204108929305716)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur la cible pour appeler une bo\00EEte de dialogue modale. Vous pouvez saisir la cible \00E0 appeler lors de la s\00E9lection de ce bouton. Entrez uniquement une cible pour les boutons qui ne doivent pas appeler de traitement de page lorsqu''ils sont s\00E9l')
||unistr('ectionn\00E9s (par exemple, un bouton Annuler).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204085474305716)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Cible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203770725305716)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un mod\00E8le de bouton pour d\00E9finir l''apparence de ce bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203655775305716)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879959101306232)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101901043875306248)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifiez les modifications non enregistr\00E9es en cas de clic sur le bouton, si la v\00E9rification est activ\00E9e au niveau de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879609399306232)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si l''utilisateur est averti lorsqu''il tente de quitter la page en cliquant sur le bouton alors que la page contient des modifications non enregistr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879778877306232)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne pas v\00E9rifier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882361596306234)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La v\00E9rification des modifications non enregistr\00E9es ne sera pas effectu\00E9e en cas de clic sur le bouton. Ce param\00E8tre doit \00EAtre utilis\00E9 pour les boutons Annuler, Supprimer et Appliquer les modifications.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879532225306232)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertir des modifications non enregistr\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930216133306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930664714306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930578030306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930414388306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930775478306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930369894306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930168795306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932239221306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932551033306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932483008306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932354437306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932660065306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932166460306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205712773305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205643136305717)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207100546305719)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207010393305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931851165306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Java pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931799597306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933440384306273)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Java qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933335653306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931620342306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931565872306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression JavaScript pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931437715306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933242576306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933170748306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction JavaScript qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933092241306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205951968305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste de valeurs s\00E9par\00E9es par un signe deux-points (:) pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205875491305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206331213305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le num\00E9ro de page pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206253842305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206549623305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la liste des num\00E9ros de page s\00E9par\00E9s par des virgules pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206490960305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931311176306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 ou :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931297862306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression PL/SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931139359306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932922847306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932888300306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932716219306272)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206157261305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez une pr\00E9f\00E9rence utilisateur qui est compar\00E9e \00E0 la valeur sp\00E9cifi\00E9e pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206076403305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101932040066306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Python pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931910888306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933640040306273)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Python qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933513161306273)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101931050504306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930942887306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930876742306271)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084217274306395)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs alors que des lignes existent lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Pour r\00E9ussir le renvoi de valeurs alors qu''aucune ligne n''existe lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 40, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205306392305717)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205224788305717)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206728778305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une valeur de texte pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206668453305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207329841305719)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207218225305719)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287789275305778)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de condition \00E0 satisfaire pour que la r\00E9gion soit mise en m\00E9moire cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205133830305717)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une condition. Si cette condition renvoie <strong>TRUE</strong>, la page est affich\00E9e \00E0 partir de la m\00E9moire cache. Si elle renvoie <strong>FALSE</strong>, la page est recompos\00E9e dynamiquement et n''est pas extraite de la m\00E9moire cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770422174306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'fr'
,p_message_text=>'Toujours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911996186306256)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le composant sera toujours affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769096973306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Microsoft Internet Explorer 7.0 ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769123475306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>'Le navigateur client est compatible XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768989026306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Mozilla, Netscape 6.x/7x ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769253694306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est diff\00E9rent (ou version ant\00E9rieure)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767694295306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le texte est compris dans l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769660064306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915553227306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769353182306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours est comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915793020306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769536449306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915605001306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769465041306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915808697306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans l''une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766866872306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours = Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914314721306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est \00E9gale \00E0 la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767030250306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914531567306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours se trouve dans la liste de pages s\00E9par\00E9es par des virgules saisie dans l''attribut <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766940315306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours != Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914475967306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est diff\00E9rente de la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767113975306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours n''est pas contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914675069306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours ne se trouve pas dans la liste de pages s\00E9par\00E9es par des virgules saisie dans l''attribut <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769766996306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769828399306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768571273306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e sont affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915384853306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e est affich\00E9e sur la page \00E0 la suite d''une soumission de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767923260306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767789820306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte est compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767861244306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte n''est pas compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768091330306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764511295306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes renvoy\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912057548306256)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL renvoie au moins une ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929995005306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101930021787306270)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>'L''expression renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764788033306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912286019306256)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Le corps de fonction renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770187983306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770272868306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768238998306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion n''est pas en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915049844306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le cas \00E9ch\00E9ant, la page et la r\00E9gion parent s''affichent normalement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768121987306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion est en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914920469306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour la page ou la r\00E9gion parent, le cas \00E9ch\00E9ant, la condition Lecture seule renvoie la valeur TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766098709306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne contient aucun espace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913517133306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 ne contient pas d''espace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766360188306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est alphanum\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913848100306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est alphanum\00E9rique (elle contient uniquement des lettres ou des chiffres et aucun caract\00E8re sp\00E9cial).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765500789306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913070455306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766259575306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913735860306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765781596306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913216199306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765402567306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912989775306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765801396306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL ou \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913317687306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide ou \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766119492306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913636095306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765625249306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913131071306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765936603306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est ni NULL, ni \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913484310306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est ni vide, ni \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768767962306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'fr'
,p_message_text=>'Etats SQL (OK pour afficher le bouton Suivant)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768819201306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats SQL (OK pour afficher le bouton Pr\00E9c\00E9dent)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770381892306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'fr'
,p_message_text=>'Jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768616406306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e ne sont pas affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915410344306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e n''est pas affich\00E9e sur la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764662841306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ligne n''a \00E9t\00E9 renvoy\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912130022306256)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL ne renvoie aucune ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767488998306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours est en mode d''impression facile'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914745405306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours a \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767520431306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours n''est pas en mode d''impression facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914859652306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours n''a pas \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764871773306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912319177306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est identique au texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765063563306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande est comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912517817306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764949632306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912424348306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La demande de page est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765109880306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912600734306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page n''est pas comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101769967692306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770088506306146)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768336511306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est authentifi\00E9 (utilisateur non public)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915102097306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final est connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101768450489306145)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est public (utilisateur non authentifi\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915218251306259)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''est pas connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766617220306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914138364306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> indiqu\00E9e est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766705016306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914261878306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> indiqu\00E9e est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766442537306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101913969568306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101766513150306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101914068666306258)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765240131306142)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912729384306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101765393476306143)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101912804102306257)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767356289306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours != Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101767249549306144)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours = Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205046836305717)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205536711305717)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur \00E0 comparer \00E0 la condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101205499813305717)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206949511305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101206858579305718)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024838310306350)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez une liste d''\00E9l\00E9ments s\00E9par\00E9s par des virgules de laquelle d\00E9pend le contenu mis en m\00E9moire cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024753052306350)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9pend des \00E9l\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018808409306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez comment le moteur &PRODUCT_NAME. peut mettre en m\00E9moire cache le texte HTML c\00F4t\00E9 serveur. Si la mise en m\00E9moire cache est possible, elle \00E9met le r\00E9sultat en m\00E9moire cache au lieu de le recalculer. Cela permet de r\00E9duire la longue dur\00E9e de ca')
||unistr('lcul sur le serveur. Cette fonctionnalit\00E9 n''est pas li\00E9e aux capacit\00E9s de mise en m\00E9moire cache du navigateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019116935306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019263420306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le contenu est mis en m\00E9moire cache et employ\00E9 par tous les utilisateurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018947445306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019082670306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le contenu n''est pas mis en m\00E9moire cache et il est calcul\00E9 pour chaque demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019526257306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Cache par session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019611887306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le contenu est mis en m\00E9moire cache sp\00E9cifiquement pour chaque session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019375590306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'fr'
,p_message_text=>'Cache par utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102019439151306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le contenu est mis en m\00E9moire cache sp\00E9cifiquement pour chaque utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018738011306346)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise en m\00E9moire cache')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198708714305694)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la dur\00E9e de validit\00E9 d''une page mise en m\00E9moire cache. Les demandes de page suivantes n''utilisent pas la page mise en m\00E9moire cache en cas d''expiration du d\00E9lai.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700195949306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'fr'
,p_message_text=>'10 secondes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700793962306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'fr'
,p_message_text=>'3 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701691922306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'fr'
,p_message_text=>'2 semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700849075306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'fr'
,p_message_text=>'4 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701273009306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'fr'
,p_message_text=>'2 jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700452393306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'fr'
,p_message_text=>'30 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700987205306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'fr'
,p_message_text=>'6 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701734617306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'fr'
,p_message_text=>'4 semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701320565306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'fr'
,p_message_text=>'3 jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701930662306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'fr'
,p_message_text=>'1 an'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701492354306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'fr'
,p_message_text=>'4 jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700588556306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'fr'
,p_message_text=>'1 heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701093409306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'fr'
,p_message_text=>'12 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700226389306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'fr'
,p_message_text=>'1 minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700382175306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'fr'
,p_message_text=>'10 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701528067306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'fr'
,p_message_text=>'1 semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701843816306095)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'fr'
,p_message_text=>'10 semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700699333306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'fr'
,p_message_text=>'2 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101701108465306094)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'fr'
,p_message_text=>'1 jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198600425305694)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9lai d''expiration de cache')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745793266306128)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Afficher les valeurs de colonne</dt>',
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
unistr('<dt>Afficher une image dans un \00E9v\00E9nement de calendrier.</dt>'),
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591905361306007)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un texte personnalis\00E9 \00E0 afficher dans les cellules de calendrier. Vous pouvez saisir des expressions HTML et utiliser la syntaxe <code>#COLUMN_NAME#</code> pour afficher les valeurs de colonne. Ce type d''affichage vous permet de saisir plus')
||'ieurs colonnes dans l''affichage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591812299306007)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Format d''affichage personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586109746306003)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application qui contient la date de d\00E9but du calendrier actuellement affich\00E9 par l''utilisateur final.'),
unistr('L''\00E9l\00E9ment est utilis\00E9 par le moteur &PRODUCT_NAME. lorsque l''utilisateur final le s\00E9lectionne pour acc\00E9der \00E0 la p\00E9riode pr\00E9c\00E9dente ou suivante.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586050589306003)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586774087306003)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez les valeurs affich\00E9es sur le calendrier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745153078306127)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745241467306127)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilise l''attribut <strong>Colonne d''affichage</strong> pour s\00E9lectionner la colonne \00E0 afficher dans la cellule de calendrier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745322208306128)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745484723306128)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Permet de saisir un format de colonne personnalis\00E9 \00E0 l''aide des cha\00EEnes de substitution prises en charge et d''expressions HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745560953306128)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucune valeur d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745688854306128)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune donn\00E9e n''est affich\00E9e dans les cellules de calendrier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586620149306003)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586368987306003)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application qui contient la date de fin du calendrier actuellement affich\00E9 par l''utilisateur final.'),
unistr('L''\00E9l\00E9ment est utilis\00E9 par le moteur &PRODUCT_NAME. lorsque l''utilisateur final le s\00E9lectionne pour acc\00E9der \00E0 la p\00E9riode pr\00E9c\00E9dente ou suivante.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586218671306003)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585551908306002)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mod\00E8le \00E0 utiliser pour l''affichage du calendrier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585447299306002)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586596431306003)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application qui contient le type de calendrier actuellement affich\00E9 pour l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586430445306003)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898996165306246)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nombre de cartes \00E0 afficher par page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898809955306246)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de cartes par page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897753575306246)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine la position du bouton sur la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897863045306246)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'fr'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897986509306246)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'fr'
,p_message_text=>'Secondaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897638041306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896543792306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type d''action \00E0 ajouter au composant de carte.</p>'),
unistr('<p>Vous pouvez ajouter plusieurs actions du m\00EAme type. Toutefois, seules les actions de bouton sont affich\00E9es plusieurs fois.'),
unistr('Pour les autres types d''action, seule la premi\00E8re condition d''affichage pr\00E9sentant la valeur TRUE est prise en compte. Les autres conditions sont ignor\00E9es.</p>'),
unistr('<p>Les conditions d''affichage peuvent d\00E9pendre des valeurs de colonne si la condition d''ex\00E9cution est d\00E9finie de sorte \00E0 v\00E9rifier chaque ligne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896637786306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896756765306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoute un bouton \00E0 la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896807978306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carte compl\00E8te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896910461306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ajoute un lien vers la carte compl\00E8te. G\00E9n\00E9ralement, vous devez d\00E9finir une seule action de ce type.'),
unistr('Si vous en d\00E9finissez plusieurs, ajoutez une condition d''affichage bas\00E9e sur la valeur de colonne et d\00E9finissez la v\00E9rification pour chaque ligne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897440035306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'fr'
,p_message_text=>'Support'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897579538306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ajoute un lien vers le support de la carte. G\00E9n\00E9ralement, vous devez d\00E9finir une seule action de ce type.'),
unistr('Si vous en d\00E9finissez plusieurs, ajoutez une condition d''affichage bas\00E9e sur la valeur de colonne et d\00E9finissez la v\00E9rification pour chaque ligne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897247197306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'fr'
,p_message_text=>'Sous-titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897311224306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ajoute un lien vers le sous-titre de la carte. G\00E9n\00E9ralement, vous devez d\00E9finir une seule action de ce type.'),
unistr('Si vous en d\00E9finissez plusieurs, ajoutez une condition d''affichage bas\00E9e sur la valeur de colonne et d\00E9finissez la v\00E9rification pour chaque ligne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897007866306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101897128595306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ajoute un lien vers le titre de la carte. G\00E9n\00E9ralement, vous devez d\00E9finir une seule action de ce type.'),
unistr('Si vous en d\00E9finissez plusieurs, ajoutez une condition d''affichage bas\00E9e sur la valeur de colonne et d\00E9finissez la v\00E9rification pour chaque ligne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896427609306245)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885400588306236)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes CSS \00E0 appliquer \00E0 chaque carte. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885389866306236)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890642401306240)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher une fl\00E8che pointant vers la droite</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890556223306240)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne que vous voulez ajouter au composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890473713306240)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991586320306324)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher une fl\00E8che pointant vers la droite</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991481113306324)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne que vous voulez ajouter au composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991332557306324)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883890409306235)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette propri\00E9t\00E9 d\00E9termine la disposition des cartes sur la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884192502306235)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'fr'
,p_message_text=>'Flottant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884293686306236)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les cartes sont renvoy\00E9es \00E0 la ligne lorsqu''elles ne tiennent pas sur la surface horizontale de l''\00E9cran.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883976374306235)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'fr'
,p_message_text=>'Grille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884052076306235)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'fr'
,p_message_text=>'Organise les cartes sous forme d''une grille de colonnes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884314067306236)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'fr'
,p_message_text=>'Horizontal (ligne)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884474643306236)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les cartes seront positionn\00E9es les unes au-dessus des autres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883767470306235)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9sentation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898155696306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''action \00E0 ex\00E9cuter lorsqu''un utilisateur clique sur le type d''action indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898494365306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une page dans une autre application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898510027306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>R\00E9acheminer vers une page dans une autre application, avec des attributs facultatifs suppl\00E9mentaires permettant de r\00E9initialiser la pagination, de d\00E9finir la valeur de demande, de vider le cache et de d\00E9finir des valeurs d''\00E9l\00E9ment sur la page cibl')
||'e.<p>',
unistr('<p>Remarque : le r\00E9acheminement vers une page dans une autre application repose sur l''activation du lien profond dans l''application cible. Pour activer le lien profond, acc\00E9dez aux attributs <em>S\00E9curit\00E9</em> de l''application et activez <em>Lien prof')
||'ond</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898253163306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la page dans cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898318822306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une page de l''application en cours, avec des attributs facultatifs suppl\00E9mentaires permettant de r\00E9initialiser la pagination, de d\00E9finir la valeur de demande, de vider le cache et de configurer des valeurs d''\00E9l\00E9ment sur la page cible')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898608325306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898743581306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''URL cible indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101898088414306246)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011262102306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la premi\00E8re colonne de cl\00E9 primaire dans la source de r\00E9gion. Si la cl\00E9 primaire de cette table contient plus de deux colonnes, vous devez s\00E9lectionner la colonne <code>ROWID</code>. Si la r\00E9gion est d\00E9finie de sorte \00E0 afficher la pagina')
||unistr('tion de d\00E9filement, la cl\00E9 primaire est utilis\00E9e pour \00E9viter l''affichage des lignes en double. Si la r\00E9gion affiche une image \00E0 partir d''une colonne BLOB, la cl\00E9 primaire est utilis\00E9e pour obtenir l''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011107247306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011663778306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la premi\00E8re colonne de cl\00E9 primaire dans la source de r\00E9gion. Si la cl\00E9 primaire de cette table contient plus de deux colonnes, vous devez s\00E9lectionner la colonne <code>ROWID</code>. Si la r\00E9gion est d\00E9finie de sorte \00E0 afficher la pagina')
||unistr('tion de d\00E9filement, la cl\00E9 primaire est utilis\00E9e pour \00E9viter l''affichage des lignes en double. Si la r\00E9gion affiche une image \00E0 partir d''une colonne BLOB, la cl\00E9 primaire est utilis\00E9e pour obtenir l''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011589579306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011492878306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la deuxi\00E8me colonne de cl\00E9 primaire uniquement si la cl\00E9 primaire pour la source de r\00E9gion poss\00E8de deux colonnes. Si vous s\00E9lectionnez <code>ROWID</code> pour la premi\00E8re colonne de cl\00E9 primaire, vous ne devez pas remplir cette colonne. ')
||unistr('Si la r\00E9gion est d\00E9finie de sorte \00E0 afficher la pagination de d\00E9filement, la deuxi\00E8me cl\00E9 primaire est utilis\00E9e pour \00E9viter l''affichage des lignes en double. Si la r\00E9gion affiche une image \00E0 partir d''une colonne BLOB, la deuxi\00E8me cl\00E9 primaire est uti')
||unistr('lis\00E9e pour obtenir l''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011329065306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011847833306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la deuxi\00E8me colonne de cl\00E9 primaire uniquement si la cl\00E9 primaire pour la source de r\00E9gion poss\00E8de deux colonnes. Si vous s\00E9lectionnez <code>ROWID</code> pour la premi\00E8re colonne de cl\00E9 primaire, vous ne devez pas remplir cette colonne. ')
||unistr('Si la r\00E9gion est d\00E9finie de sorte \00E0 afficher la pagination de d\00E9filement, la deuxi\00E8me cl\00E9 primaire est utilis\00E9e pour \00E9viter l''affichage des lignes en double. Si la r\00E9gion affiche une image \00E0 partir d''une colonne BLOB, la deuxi\00E8me cl\00E9 primaire est uti')
||unistr('lis\00E9e pour obtenir l''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102011702974306340)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899079428306247)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'La carte utilise une colonne BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551736401305976)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nom de colonne de base de donn\00E9es respectant les minuscules/majuscules de la liste de valeurs, qui est utilis\00E9e pour la requ\00EAte \00E0 l''aide de la valeur de facet ou de filtre parent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551604704305976)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de liste de valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088699947306398)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les colonnes d\00E9clenchant la r\00E9g\00E9n\00E9ration de cette liste de valeurs.'),
unistr('S\00E9parez chaque nom de colonne par une virgule.'),
unistr('Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des colonnes disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom de colonne renvoy\00E9 \00E0 partir de la liste.</p>'),
unistr('<p>Cette liste de valeurs est r\00E9g\00E9n\00E9r\00E9e chaque fois que la valeur de l''une des colonnes sp\00E9cifi\00E9es est modifi\00E9e sur cette page.</p>'),
unistr('<p>Utilisez les colonnes indiqu\00E9es dans cet attribut dans la <em>clause WHERE</em> de cette requ\00EAte SQL de liste de valeurs afin de limiter les valeurs renvoy\00E9es.</p>'),
unistr('<p>Par exemple, si vous utilisez des colonnes pour Marque de voiture et Mod\00E8le, vous pouvez indiquer Marque de voiture comme colonne parent de la liste de valeurs en cascade dans la d\00E9finition de liste de valeurs pour Mod\00E8le, et utiliser Marque de vo')
||'iture dans la clause WHERE pour cette liste de valeurs.',
unistr('Lorsque la marque de voiture est modifi\00E9e, la liste de valeurs Mod\00E8le est r\00E9g\00E9n\00E9r\00E9e et la liste n''affiche que les valeurs pour la marque de voiture actuellement s\00E9lectionn\00E9e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088583372306398)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonnes parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551973777305976)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un facet qui d\00E9clenche la r\00E9g\00E9n\00E9ration de cette liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551830506305976)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Facet parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238306970305741)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un filtre qui d\00E9clenche la r\00E9g\00E9n\00E9ration de cette liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238233538305741)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Filtre parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203443227305697)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les \00E9l\00E9ments de page ou d''application d\00E9clenchant la r\00E9g\00E9n\00E9ration de cette liste de valeurs.'),
unistr('S\00E9parez chaque nom d''\00E9l\00E9ment par une virgule.'),
unistr('Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste.</p>'),
unistr('<p>Cette liste de valeurs est r\00E9g\00E9n\00E9r\00E9e chaque fois que la valeur de l''un des \00E9l\00E9ments sp\00E9cifi\00E9s est modifi\00E9e sur cette page.</p>'),
unistr('<p>Utilisez les \00E9l\00E9ments de page indiqu\00E9s dans cet attribut dans la <em>clause WHERE</em> de cette requ\00EAte SQL de liste de valeurs afin de limiter les valeurs renvoy\00E9es.</p>'),
unistr('<p>Par exemple, si vous utilisez des \00E9l\00E9ments de page pour Marque de voiture et Mod\00E8le, vous pouvez indiquer Marque de voiture comme \00E9l\00E9ment parent de la liste de valeurs en cascade dans la d\00E9finition de liste de valeurs pour Mod\00E8le, et utiliser Marq')
||'ue de voiture dans la clause WHERE pour cette liste de valeurs.',
unistr('Lorsque la marque de voiture est modifi\00E9e, la liste de valeurs Mod\00E8le est r\00E9g\00E9n\00E9r\00E9e et la liste n''affiche que les valeurs pour la marque de voiture actuellement s\00E9lectionn\00E9e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203361933305697)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548717519305974)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez les conditions dans lesquelles cette liste de valeurs est r\00E9g\00E9n\00E9r\00E9e.</p>'),
unistr('<p>Si la valeur est d\00E9finie sur <strong>Activ\00E9</strong>, l''appel de r\00E9g\00E9n\00E9ration permettant d''obtenir les nouvelles valeurs est effectu\00E9 uniquement lorsque tous les <em>\00E9l\00E9ments parent de liste de valeurs (LOV) en cascade</em> sont NOT NULL.'),
unistr('Si un \00E9l\00E9ment est NULL, la requ\00EAte de liste de valeurs ne doit renvoyer aucune ligne.'),
unistr('Dans ce cas, les entr\00E9es de la liste de s\00E9lection sont simplement effac\00E9es dans le navigateur, sans r\00E9g\00E9n\00E9ration.</p>'),
unistr('<p>Si la valeur est d\00E9finie sur <strong>D\00E9sactiv\00E9</strong>, la r\00E9g\00E9n\00E9ration est toujours effectu\00E9e.'),
unistr('Cette option est uniquement utilis\00E9e si vous traitez sp\00E9cifiquement les <em>\00E9l\00E9ments parent de liste de valeurs (LOV) en cascade</em> de type Nullable dans la <em>clause WHERE</em> de cette requ\00EAte SQL de liste de valeurs.'),
unistr('Si les \00E9l\00E9ments de page de type Nullable ne sont pas correctement trait\00E9s, des appels de r\00E9g\00E9n\00E9ration inutiles sont ex\00E9cut\00E9s, sans renvoyer aucune ligne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548619133305974)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Parent requis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834221232305416)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche les informations d''identification utilisateur du dernier d\00E9veloppeur qui a mis \00E0 jour cet attribut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834143206305416)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifi\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834461967305416)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche l''heure de la derni\00E8re mise \00E0 jour de cet attribut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834362153305416)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifi\00E9 le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584274981306001)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la hauteur du graphique en pixels. La hauteur d\00E9finit une hauteur fixe pour la r\00E9gion du graphique. Sinon, pour activer le redimensionnement automatique de la hauteur du graphique, laissez cet \00E9l\00E9ment vide.'),
unistr('La hauteur est alors bas\00E9e sur la hauteur du navigateur.</p>'),
unistr('<p>Par d\00E9faut, un graphique cr\00E9\00E9 sur une page qui utilise l''interface utilisateur jQuery Mobile pour smartphones n''a aucune valeur d\00E9finie pour la hauteur et se redimensionne correctement pour s''adapter \00E0 l''appareil sur lequel il est affich\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584113727306001)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584305047306001)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608042408306019)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la largeur maximale du graphique en pixels. La largeur maximale d\00E9finit une largeur fixe pour la r\00E9gion du graphique.'),
unistr('Sinon, pour activer le redimensionnement automatique de la largeur du graphique, laissez cet \00E9l\00E9ment vide. La largeur est ensuite automatiquement d\00E9finie sur 100 % de la r\00E9gion.</p>'),
unistr('<p>Par d\00E9faut, un graphique cr\00E9\00E9 sur une page qui utilise l''interface utilisateur jQuery Mobile pour smartphones n''a aucune valeur d\00E9finie pour la largeur et se redimensionne correctement pour s''adapter \00E0 l''appareil sur lequel il est affich\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602400391306015)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602568431306015)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581126288305999)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le titre \00E0 afficher dans la partie sup\00E9rieure du graphique. Pour les graphiques de Gantt, la valeur sert uniquement \00E0 d\00E9finir le titre de graphique accessible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581081906305999)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809567730306175)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''emplacement des donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809643026306175)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Base de donn\00E9es locale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809771828306175)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es proviennent de la base de donn\00E9es locale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810271159306176)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Source de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810352298306176)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es proviennent de l''emplacement indiqu\00E9 dans la d\00E9finition de source de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809894017306176)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809964278306176)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es proviennent d''une base de donn\00E9es distante, o\00F9 la connexion est d\00E9finie via le SQL compatible REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810012959306176)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'fr'
,p_message_text=>'Source REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810195685306176)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es proviennent d''un service Web RESTful d\00E9fini via des sources de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101809409564306175)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Emplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574878790305994)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la base pour cette colonne d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732654301306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* S\00E9lecteur de date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732565503306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* S\00E9lecteur de date (classique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732439590306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* Afficher en tant que texte (enregistre l''\00E9tat)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732122058306117)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger un BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909542710306254)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne en tant que lien pour t\00E9l\00E9charger le fichier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732358399306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne masqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909774368306255)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''affiche pas la colonne, mais elle peut \00EAtre r\00E9f\00E9renc\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733191699306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* Champ masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732016801306117)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909401785306254)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la colonne en tant qu''image.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731960929306117)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'fr'
,p_message_text=>'Lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909338499306254)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la colonne en tant que lien.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732270466306117)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 pourcentage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909633460306255)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne en tant que graphique \00E0 pourcentage. La valeur extraite doit \00EAtre comprise entre 0 et 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731712693306117)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'fr'
,p_message_text=>'Texte brut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909154843306254)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la valeur de colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731804097306117)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'fr'
,p_message_text=>'Texte brut (en fonction d''une liste de valeurs)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909229917306254)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la valeur renvoy\00E9e par la liste de valeurs indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733212707306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* Liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733341412306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* Liste de valeurs (LOV) cl\00E9 instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733041222306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'fr'
,p_message_text=>'* Groupe de boutons d''option'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980627592306316)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte enrichi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980792444306316)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne \00E0 l''aide du langage HTML ou Markdown.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733562504306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* S\00E9lecteur de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732990411306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* Liste de s\00E9lection')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733414372306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'fr'
,p_message_text=>unistr('* Case \00E0 cocher simple')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732768348306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'* Champ de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101732889947306118)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'fr'
,p_message_text=>'* Zone de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574784937305994)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574441216305994)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucune pagination (afficher toutes les lignes)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575644585305995)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucune pagination (afficher toutes les lignes)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560880421305983)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type de pagination \00E0 utiliser dans cet \00E9tat.'),
unistr('G\00E9n\00E9ralement, seul un sous-ensemble des r\00E9sultats est actuellement affich\00E9 dans l''\00E9tat.'),
unistr('La pagination fournit \00E0 l''utilisateur des informations sur le nombre de lignes et sur la position en cours dans l''ensemble de r\00E9sultats. Elle d\00E9finit \00E9galement le style des liens ou des boutons qui permettent d''acc\00E9der \00E0 la page suivante ou pr\00E9c\00E9dent')
||'e.</p>',
unistr('<p>La pagination peut figurer en haut ou en bas de l''\00E9tat (ou les deux) et \00EAtre situ\00E9e \00E0 gauche ou \00E0 droite.</p>'),
unistr('<p>Vous pouvez \00E9galement utiliser un style de pagination simplifi\00E9 pour am\00E9liorer les performances, tel que <strong>Plages de lignes X \00E0 Y (avec liens pr\00E9c\00E9dent et suivant)</strong>.'),
unistr('L''utilisation des types de pagination ayant la forme X \00E0 Y sur Z exige que le moteur &PRODUCT_NAME. ex\00E9cute deux requ\00EAtes pour renvoyer les r\00E9sultats'),
unistr('Une requ\00EAte extrait les enregistrements en cours \00E0 afficher et l''autre obtient le nombre total d''enregistrements \00E0 afficher dans le contr\00F4le de pagination.'),
unistr('Pour les \00E9tats bas\00E9s sur des ensembles de donn\00E9es extr\00EAmement grands ou avec des requ\00EAtes tr\00E8s intensives en UC, comme de nombreuses jointures de table non optimales ou des conditions consommatrices en ressources, cette requ\00EAte suppl\00E9mentaire peut aj')
||unistr('outer du temps de traitement, ce qui peut entrainer un d\00E9lai plus long pour l''affichage de l''\00E9tat.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741238284306124)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser des boutons de pagination cr\00E9\00E9s de mani\00E8re externe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741356985306125)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes de X \00E0 Y (avec liens pr\00E9c\00E9dent et suivant)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740646924306124)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes X \00E0 Y (aucune pagination)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740749529306124)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes X \00E0 Y de Z (aucune pagination)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740913204306124)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes 1-15 16-30 (avec pagination d\00E9finie)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741048251306124)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'fr'
,p_message_text=>'Plages de lignes 1-15 16-30 dans la liste SELECT (avec pagination)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740804488306124)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes X \00E0 Y de Z (avec pagination)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741193581306124)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'fr'
,p_message_text=>'Moteur de recherche 1,2,3,4 (en fonction de la pagination)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560786384305983)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530323673305958)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nombre d''ic\00F4nes \00E0 afficher par ligne dans la vue Ic\00F4ne. La valeur 5 affiche 5 ic\00F4nes par ligne de l''\00E9tat.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728731426306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728817000306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728981605306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'fr'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729072650306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'fr'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729156937306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'fr'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729250472306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'fr'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729339412306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'fr'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729464184306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'fr'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729566433306115)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'fr'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530234129305958)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonnes par ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520807856305951)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''alignement de l''affichage de colonne. Cette s\00E9lection d''alignement doit \00EAtre prise en charge par le mod\00E8le d''\00E9tat s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724805068306112)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724741251306112)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724998664306112)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520724514305951)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alignement de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577165302305996)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de valeur de colonne par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744740881306127)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744698476306127)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577062315305996)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432072188305886)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte d''en-t\00EAte du groupe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520078641305951)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte d''en-t\00EAte de colonne de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519990991305951)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949790368305507)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Est triable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858905130306213)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez la colonne contenant la cl\00E9 unique afin d''identifier une ligne. Utilisez cette option pour fournir la valeur de cl\00E9 primaire \00E0 du code JavaScript personnalis\00E9 ou aux gestionnaires d''\00E9v\00E9nement de carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858858594306213)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519466993305950)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de cette colonne d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519369181305950)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574602791305994)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Croissant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576071255305995)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Croissant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555189677305979)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si cette colonne est tri\00E9e par ordre d\00E9croissant. Si vous n''indiquez rien, la colonne est tri\00E9e par ordre croissant (ordre par d\00E9faut).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737989564306122)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555010424305979)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Direction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554932894305979)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la s\00E9quence de tri pour cette colonne.'),
unistr('Chaque colonne doit poss\00E9der une s\00E9quence unique pour trier correctement la sortie d''\00E9tat.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737194853306121)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737242363306121)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737373967306121)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'fr'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737493028306121)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'fr'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737523767306122)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'fr'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737621788306122)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'fr'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737769294306122)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'fr'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737801475306122)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'fr'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554895951305978)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519679765305950)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le type de donn\00E9es de cette colonne d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519533557305950)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553310643305977)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Entrez la largeur de la colonne en pixels.',
unistr('Utilisez cet attribut lors de l''affichage d''\00E9tats dans un navigateur.'),
unistr('La d\00E9finition de la largeur de colonne doit \00EAtre prise en charge par le mod\00E8le d''\00E9tat s\00E9lectionn\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553283097305977)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur de cellule'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583735352306001)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188027376305686)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez ici tout commentaire ou toute remarque du d\00E9veloppeur. Ces commentaires seront uniquement affich\00E9s dans App Builder et ne seront jamais affich\00E9s lors de l''ex\00E9cution de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187916061305686)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Commentaires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885220321306236)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes CSS \00E0 appliquer \00E0 ce composant. Ces classes seront appliqu\00E9es au conteneur des cartes. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885169502306236)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945292096306282)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945637867306282)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945569746306282)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945444833306282)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945793248306282)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945393759306282)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945180583306282)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947236981306290)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947510031306290)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947427671306290)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947388093306290)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947611218306290)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947107134306289)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192095267305689)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application rempli par ce calcul. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191945784305689)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192891705305690)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment dont la valeur est utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192753614305690)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946897421306289)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Java qui g\00E9n\00E8re la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946720490306289)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948409734306290)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Java renvoyant la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948310415306290)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946617368306289)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946545310306289)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression JavaScript qui g\00E9n\00E8re la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946411586306289)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948227035306290)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948112337306290)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction JavaScript renvoyant la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948088860306290)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946307597306289)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946255306306289)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression PL/SQL qui g\00E9n\00E8re la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946143273306282)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947998649306290)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947878845306290)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction PL/SQL renvoyant la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947738421306290)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193464836305690)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez \00E0 quel moment du rendu ou du traitement de la page ce calcul est ex\00E9cut\00E9.'),
unistr('Le point de calcul <strong>Apr\00E8s soumission</strong> est le plus utilis\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705473589306098)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006897403306336)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 apr\00E8s le rendu des r\00E9gions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705690451306098)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s pied')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007014715306337)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 apr\00E8s le rendu du pied de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705273232306098)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006699472306336)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 apr\00E8s le rendu de l''en-t\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705763565306098)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s soumission')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007119854306337)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : est ex\00E9cut\00E9 apr\00E8s la soumission de la page, mais avant le traitement de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705347037306098)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006729706306336)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 avant le rendu des r\00E9gions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705587635306098)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'fr'
,p_message_text=>'Avant pied'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006952196306337)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 avant le rendu du pied de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705101830306098)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006569424306336)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 avant le rendu de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705095243306097)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006433313306336)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Est ex\00E9cut\00E9 lors de la g\00E9n\00E9ration d''une nouvelle session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193307965305690)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Point'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193016843305690)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la pr\00E9f\00E9rence utilisateur poss\00E9dant la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192964621305690)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101947064944306289)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Python qui g\00E9n\00E8re la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946921270306289)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948664220306291)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Python renvoyant la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948599242306290)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911898956306256)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une instruction SQL qui fournit une valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul. Si le r\00E9sultat contient plusieurs lignes, les valeurs de chaque ligne sont regroup\00E9es pour former une valeur unique d\00E9limit\00E9e par des signes deux-points.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911787226306256)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101946029338306282)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945999413306282)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression SQL qui g\00E9n\00E8re la valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945811350306282)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192618331305689)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL fournissant une valeur utilis\00E9e pour remplir l''\00E9l\00E9ment de calcul. Si le r\00E9sultat contient plusieurs lignes, seule la valeur de la premi\00E8re ligne est renvoy\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192548662305689)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192435615305689)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte utilis\00E9 pour remplir l''\00E9l\00E9ment de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192320740305689)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192252291305689)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de calcul dans la liste suivante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928393018306269)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928494806306269)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur g\00E9n\00E9r\00E9e par l''ex\00E9cution de l''<em>expression</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704512367306097)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906983835306253)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par le <em>corps de fonction</em> saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704876397306097)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906657281306252)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704600760306097)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur unique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906733132306252)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la premi\00E8re valeur renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704739919306097)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur s\00E9par\00E9e par deux-points)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906867057306252)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur une valeur d\00E9limit\00E9e par le signe deux-points qui concat\00E8ne chaque valeur de ligne, renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704972964306097)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907067718306253)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de la <em>pr\00E9f\00E9rence</em> saisie.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704415703306097)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906547782306252)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur le texte saisi dans <em>Valeur statique</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101192140115305689)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553109996305977)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pour cette colonne, indiquez si la somme est calcul\00E9e et affich\00E9e \00E0 la fin de l''\00E9tat.'),
unistr('En cas d''utilisation avec des colonnes de section, la somme totale et la somme pour chaque section sont affich\00E9es.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553068166305977)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Calculer la somme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937847100306276)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938290114306276)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938184259306276)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938076318306276)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938301920306276)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937992646306276)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937772220306276)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939807828306277)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940154823306278)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940050312306278)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939909399306277)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940279868306278)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939748364306277)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225593801305732)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225450638305732)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226990079305733)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226817778305733)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939432279306277)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Java pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939313008306277)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941068987306278)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Java qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940961504306278)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939209313306277)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939162379306277)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression JavaScript pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939093603306277)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940866572306278)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940763624306278)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction JavaScript qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940618724306278)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225744142305732)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste de valeurs s\00E9par\00E9es par un signe deux-points (:) pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225603720305732)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226137559305732)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le num\00E9ro de page pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226054952305732)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226380891305733)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la liste des num\00E9ros de page s\00E9par\00E9s par des virgules pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226222561305732)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938969761306277)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 ou :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938803718306277)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression PL/SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938702592306277)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940560062306278)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940466405306278)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101940333687306278)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225953108305732)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une pr\00E9f\00E9rence utilisateur compar\00E9e \00E0 la valeur sp\00E9cifi\00E9e pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225842511305732)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939623653306277)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Python pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101939563492306277)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941206686306278)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Python qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941171613306278)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938605582306276)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938576314306276)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101938436994306276)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084485916306395)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs alors que des lignes existent lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Pour r\00E9ussir le renvoi de valeurs alors qu''aucune ligne n''existe lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 40, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225180172305732)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225083010305732)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226557524305733)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une valeur de texte pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226432475305733)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227100013305733)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227013201305733)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600423856306013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de condition \00E0 satisfaire pour que cette action soit active.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228064165305734)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de condition \00E0 satisfaire pour que cette action dynamique soit active.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101224089463305731)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de condition \00E0 remplir pour que le composant soit recompos\00E9 ou trait\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782422878306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'fr'
,p_message_text=>'Toujours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920047903306262)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le composant sera toujours affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781095878306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Microsoft Internet Explorer 7.0 ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781127171306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>'Le navigateur client est compatible XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780959992306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Mozilla, Netscape 6.x/7x ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781259483306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est diff\00E9rent (ou version ant\00E9rieure)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779628643306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le texte est compris dans l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781635259306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923654698306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781370039306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours est comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923845793306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781516904306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923734687306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781409788306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923910515306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans l''une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778860286306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours = Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922482420306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est \00E9gale \00E0 la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779021917306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922685033306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours se trouve dans la liste de pages s\00E9par\00E9es par des virgules saisie dans l''attribut <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778999817306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours != Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922528358306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est diff\00E9rente de la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779102762306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours n''est pas contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922750235306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours ne se trouve pas dans la liste de pages s\00E9par\00E9es par des virgules saisie dans l''attribut <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781741960306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781863091306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780511721306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e sont affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923478146306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e est affich\00E9e sur la page \00E0 la suite d''une soumission de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779933087306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779768664306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte est compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779819594306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte n''est pas compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780083120306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776578418306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes renvoy\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920135739306262)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL renvoie au moins une ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937504253306276)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937678261306276)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>'L''expression renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776792065306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920327542306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Le corps de fonction renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782188413306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782299697306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780258502306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion n''est pas en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923185208306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le cas \00E9ch\00E9ant, la page et la r\00E9gion parent s''affichent normalement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780124673306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion est en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923038317306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour la page ou la r\00E9gion parent, le cas \00E9ch\00E9ant, la condition Lecture seule renvoie la valeur TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778006846306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne contient aucun espace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921653634306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 ne contient pas d''espace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778349963306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est alphanum\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921987292306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est alphanum\00E9rique (elle contient uniquement des lettres ou des chiffres et aucun caract\00E8re sp\00E9cial).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777552751306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921144632306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778264741306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921804260306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777710566306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921399618306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777428955306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921091050306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777866950306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL ou \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921454067306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide ou \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778160732306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921732914306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777623446306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921241790306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est \00E9gale \00E0 z\00E9ro.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777955819306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est ni NULL, ni \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101921559870306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est ni vide, ni \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780715911306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'fr'
,p_message_text=>'Etats SQL (OK pour afficher le bouton Suivant)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780883143306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats SQL (OK pour afficher le bouton Pr\00E9c\00E9dent)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782383275306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'fr'
,p_message_text=>'Jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924036767306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le composant n''est jamais affich\00E9.</p>'),
unistr('<p>Remarque : le passage \00E0 la condition <strong>Jamais</strong> enl\00E8ve toutes les conditions existantes. Pour la d\00E9sactivation temporaire d''un composant, Oracle recommande l''utilisation de l''attribut <em>Option de construction</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780626134306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e ne sont pas affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923586586306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e n''est pas affich\00E9e sur la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776623602306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ligne n''a \00E9t\00E9 renvoy\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920243919306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL ne renvoie aucune ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779486233306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours est en mode d''impression facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922884533306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours a \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779513501306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours n''est pas en mode d''impression facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922955861306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours n''a pas \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776824694306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920462564306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est identique au texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777096474306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande est comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920638331306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776984117306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920590690306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La demande de page est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777195645306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920757521306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page n''est pas comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101781931080306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782090551306155)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780391626306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est authentifi\00E9 (utilisateur non public)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923292001306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final est connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101780402379306154)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est public (utilisateur non authentifi\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101923315809306265)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''est pas connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778639492306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922238156306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> saisie est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778732663306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922315586306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> saisie est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778438606306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922002560306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101778541674306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101922188224306264)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777205152306151)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920820143306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101777365231306152)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101920937920306263)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779310537306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours != Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101779275312306153)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours = Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223935845305731)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225353947305732)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur \00E0 comparer \00E0 la condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101225214652305732)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226745025305733)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101226652633305733)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096394200305618)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permet de s''assurer que l''action associ\00E9e au bouton doit \00EAtre ex\00E9cut\00E9e avec une invite de confirmation. Affiche une bo\00EEte de dialogue de confirmation apr\00E8s que l''utilisateur a cliqu\00E9 sur le bouton. L''utilisateur doit alors confirmer qu''il souhaite')
||unistr(' effectuer l''action associ\00E9e au bouton.</p>'),
unistr('<p>Cette fonctionnalit\00E9 permet de s''assurer que l''utilisateur n''effectue pas d''action importante par inadvertance, comme la suppression d''un enregistrement.</p>'),
unistr('<p>Remarque : le libell\00E9 du bouton de confirmation dans la bo\00EEte de dialogue est le m\00EAme que celui du bouton principal.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096213988305618)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Requiert une confirmation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096672896305618)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>unistr('<pre>&lt;strong&gt;Voulez-vous&lt;&#x2F;strong&gt; supprimer l''employ\00E9 &amp;P1_ENAME. ?</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096508560305618)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le message \00E0 afficher dans la bo\00EEte de dialogue de confirmation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096455426305618)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Message'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097387775305619)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096825762305619)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le style de la bo\00EEte de dialogue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097188315305619)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'fr'
,p_message_text=>'Danger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096930408305619)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'fr'
,p_message_text=>'Informations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097203744305619)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097097888305619)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101096706622305619)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559229778305982)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la disposition de contenu dans la liste disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738177316306122)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738217297306122)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'fr'
,p_message_text=>'Incorporation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559161106305982)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Disposition du contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284487190305776)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Entrez l''attribut de domaine d''URL pour le cookie de session.',
unistr('Si la comparaison de l''extr\00E9mit\00E9 de l''URL de demande ne correspond pas au domaine indiqu\00E9, le cookie n''est pas envoy\00E9 au navigateur.'),
unistr('La valeur par d\00E9faut est le nom d''h\00F4te de l''URL de demande.</p>'),
unistr('<p>Utilisez cet attribut pour indiquer un domaine moins restrictif lorsque vous souhaitez partager les cookies de session entre les applications qui pr\00E9sentent des domaines communs.'),
unistr('Par exemple, <code>my.yahoo.com</code>, <code>sport.yahoo.com</code> et <code>finance.yahoo.com</code> peuvent acc\00E9der au m\00EAme cookie si le domaine <code>yahoo.com</code> est saisi.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284308525305776)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Domaine de cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284080310305775)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Entrez le nom du cookie de session, qui est requis pour identifier une session &PRODUCT_NAME., et l''ID de session dans l''URL.',
unistr('Si vous n''indiquez pas le nom du cookie de session, &PRODUCT_NAME. utilise une valeur par d\00E9faut.</p>'),
unistr('<p>Si le m\00EAme nom de cookie est saisi dans plusieurs applications, chaque application peut utiliser le m\00EAme cookie de session.'),
unistr('Par cons\00E9quent, un appel d''URL \00E0 partir d''une application &PRODUCT_NAME. vers une autre application &PRODUCT_NAME., avec le m\00EAme nom de cookie, ne requiert pas la r\00E9authentification de l''utilisateur, car la nouvelle application peut utiliser le cooki')
||'e de session existant.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283976135305775)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284256522305775)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Entrez l''attribut de chemin d''URL pour le cookie de session.',
unistr('Si le d\00E9but de l''URL de demande ne correspond pas au chemin indiqu\00E9, le cookie n''est pas envoy\00E9 au navigateur.'),
unistr('La valeur par d\00E9faut est le chemin de l''URL de demande.</p>'),
unistr('<p>Utilisez cet attribut pour indiquer un chemin moins restrictif lorsque vous souhaitez partager les cookies de session entre les applications qui pr\00E9sentent des chemins d''URL conformes initialement.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284157115305775)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Chemin de cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704220148306097)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>R\00E9f\00E9rence de fichier standard</dt>'),
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>R\00E9f\00E9rence de fichier standard qui charge le fichier r\00E9duit main.min.css \00E0 partir de /mycss/minified pour les vues de page normales et le fichier main.css from /mycss/ en mode d\00E9bogage ou lors de l''ex\00E9cution de l''application \00E0 partir d''App Builder')
||'.</dt>',
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
unistr('<dt>Requ\00EAte de support conditionnelle</dt>'),
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>R\00E9f\00E9rence de fichier utilisant une cha\00EEne de requ\00EAte dans l''URL qui r\00E9f\00E9rence la version de l''application, afin d''indiquer au navigateur de toujours charger le nouveau fichier et d''ignorer tous les fichiers pr\00E9c\00E9demment mis en m\00E9moire cache lors ')
||unistr('de la mise \00E0 niveau de l''application (et de l''incr\00E9mentation de la version).</dt>'),
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190822259305688)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les URL de feuille de style CSS charg\00E9es sur cette page. Chaque URL doit \00EAtre \00E9crite sur une nouvelle ligne.'),
unistr('Si vous indiquez une version r\00E9duite du fichier, vous pouvez utiliser la cha\00EEne de substitution <code>#MIN#</code> afin d''inclure <code>.min</code> ou <code>#MIN_DIRECTORY#</code> afin d''inclure <code>minified/</code> dans l''URL de fichier pour une v')
||unistr('ue de page normale, et une cha\00EEne vide si la page est visualis\00E9e en mode d\00E9bogage ou lors de l''ex\00E9cution de l''application \00E0 partir d''App Builder.'),
unistr('Vous avez \00E9galement acc\00E8s \00E0 la cha\00EEne de substitution <code>#APP_VERSION#</code> si vous voulez inclure la version de l''application dans l''URL de fichier.</p>'),
unistr('<p>Les URL de fichier saisies ici remplacent la cha\00EEne de substitution <code>#PAGE_CSS#</code> dans le mod\00E8le de page.</p>'),
unistr('<p>Remarque : vous n''avez pas besoin d''ajouter les balises <code>link</code> de d\00E9but ou de fin, mais simplement l''URL de fichier.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190710556305688)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101737044001306121)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Si la valeur de cet attribut est <code>color:#FF0000;</code>, le texte de la colonne devient rouge et le code HTML suivant est g\00E9n\00E9r\00E9</dt>'),
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554564748305978)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les styles CSS \00E0 appliquer \00E0 la valeur de cette colonne. Vous pouvez saisir le style CSS ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554461061305978)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527521506305956)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un d\00E9limiteur pour indiquer le d\00E9but et la fin d''une valeur de donn\00E9es. Le d\00E9limiteur par d\00E9faut est le guillemet.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527431647305956)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('CSV d\00E9limit\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562486047305984)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent t\00E9l\00E9charger les contenus d''\00E9tat dans un fichier CSV. Pour activer l''option <em>T\00E9l\00E9chargements CSV</em>, vous devez utiliser un mod\00E8le d''\00E9tat avec une cha\00EEne de substitution <code>#CSV_LINK#</code> et d\00E9fin')
||unistr('ir l''option sur <strong>Activ\00E9</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562329148305984)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Export CSV activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527357055305956)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez un s\00E9parateur de colonnes. Si vous ne saisissez pas de valeur, une virgule ou un point-virgule est utilis\00E9, selon les param\00E8tres NLS en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527299310305956)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur CSV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195329736305691)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le focus du curseur est appliqu\00E9 au premier acc\00E8s \00E0 la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697840905306092)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Premier \00E9l\00E9ment sur la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697921771306092)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le focus du curseur est plac\00E9 dans le premier champ de la page avec JavaScript, g\00E9n\00E9r\00E9e par le moteur &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698022935306092)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'fr'
,p_message_text=>'Ne pas diriger vers le curseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698111332306092)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le curseur ne pr\00E9sente aucun focus et aucun JavaScript n''est g\00E9n\00E9r\00E9.<br>'),
unistr('S\00E9lectionnez cette option si le JavaScript g\00E9n\00E9r\00E9 entre en conflit avec le JavaScript personnalis\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189900422305687)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position du curseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288092926305778)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les attributs d''affichage de la r\00E9gion peuvent \00EAtre personnalis\00E9s par l''utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718872200306108)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'fr'
,p_message_text=>'Non personnalisable par les utilisateurs finals'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718739596306108)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Personnalisable et affich\00E9 par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718607350306107)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Personnalisable et non affich\00E9 par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287943321305778)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Personnalisable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287013858305778)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le libell\00E9 du lien affich\00E9 dans cette r\00E9gion, qui fournit l''acc\00E8s \00E0 la page de personnalisation de la r\00E9gion.'),
unistr('Ce libell\00E9 n''appara\00EEt que si les r\00E9gions sont personnalisables.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286942627305777)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592523982306008)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le texte HTML \00E0 inclure pour ce bouton :'),
'<ul>',
unistr('  <li>Pour les boutons de type <strong>Bouton HTML</strong>, ce texte est ajout\00E9 \00E0 la d\00E9finition d''\00E9l\00E9ment HTML.</li>'),
unistr('  <li>Pour les boutons bas\00E9s sur des mod\00E8les, le mod\00E8le doit inclure la cha\00EEne de substitution <code>#BUTTON_ATTRIBUTES#</code>.</li>'),
'</ul>',
unistr('<p>Vous pouvez utiliser cet attribut pour contr\00F4ler les taquets de tabulation.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592779429306008)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La cha\00EEne de substitution <code>#REPORT_ATTRIBUTES#</code> du mod\00E8le d''\00E9tat est remplac\00E9e par cette valeur. La ligne de substitution <code>#REPORT_ATTRIBUTES#</code> est remplac\00E9e uniquement dans l''attribut Avant lignes du mod\00E8le d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432650973305886)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez les attributs suppl\00E9mentaires \00E0 inclure dans la balise HTML d''\00E9l\00E9ment de panneau. Les attributs HTML <code>size</code> et <code>id</code> sont g\00E9n\00E9r\00E9s ; ils ne doivent donc pas \00EAtre fournis. Pour l''attribut HTML <code>class</code>, il est p')
||unistr('r\00E9f\00E9rable d''utiliser l''attribut de <em>classes CSS</em> d\00E9di\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592419914306008)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez les attributs suppl\00E9mentaires \00E0 inclure dans la balise HTML d''\00E9l\00E9ment de panneau. Les attributs HTML <code>size</code> et <code>id</code> sont g\00E9n\00E9r\00E9s ; ils ne doivent donc pas \00EAtre fournis. Pour l''attribut HTML <code>class</code>, il est p')
||unistr('r\00E9f\00E9rable d''utiliser l''attribut de <em>classes CSS</em> d\00E9di\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592698908306008)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur remplac\00E9e dans les attributs de r\00E9gion. Les mod\00E8les de r\00E9gion contenant la cha\00EEne de substitution <code>#REGION_ATTRIBUTES#</code> sont remplac\00E9s par cette valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592837359306008)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La cha\00EEne de substitution <code>#REPORT_ATTRIBUTES#</code> du mod\00E8le d''\00E9tat est remplac\00E9e par cette valeur. La ligne de substitution <code>#REPORT_ATTRIBUTES#</code> est remplac\00E9e uniquement dans l''attribut Avant lignes du mod\00E8le d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592385912306007)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez les attributs suppl\00E9mentaires, s\00E9par\00E9s par un espace, \00E0 inclure dans la balise d''\00E9l\00E9ment.'),
unistr('Pour l''attribut HTML CLASS, Oracle recommande l''utilisation de l''attribut de classes CSS d\00E9di\00E9.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592200606306007)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs personnalis\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503697148305939)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le nom de colonne personnalis\00E9, pouvant \00EAtre utilis\00E9 pour d\00E9finir une info-bulle personnalis\00E9e ou des couleurs en fonction de la base de donn\00E9es, \00E0 utiliser pour les \00E9l\00E9ments de graphique. Pour les bo\00EEtes \00E0 moustaches, la colonne ne doit pas')
||unistr(' correspondre au mapping de colonne de la valeur s\00E9lectionn\00E9e. La s\00E9lection d''une colonne qui correspond au mapping de colonne de la valeur emp\00EAchera l''affichage de la colonne personnalis\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503590368305939)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne personnalis\00E9e ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193875501305690)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Sp\00E9cifiez un nom d''\00E9v\00E9nement JavaScript personnalis\00E9 si les \00E9v\00E9nements d\00E9claratifs indiqu\00E9s sont insuffisants.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193728943305690)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510330096305944)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''op\00E9ration de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510814280305944)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'fr'
,p_message_text=>'Supprimer une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510437669305944)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'fr'
,p_message_text=>'Extraire des lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510585690305944)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'fr'
,p_message_text=>'Extraire une seule ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510668960305944)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E9rer une ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510728058305944)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour une ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510241883305944)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9ration de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748136072306130)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588798426306005)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour l''arri\00E8re-plan des donn\00E9es affich\00E9es dans ce calendrier.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588607363306004)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Arri\00E8re-plan des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023560535305563)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nom de colonne, qui respecte les majuscules et les minuscules, utilis\00E9 comme source pour cette valeur d''\00E9l\00E9ment.</p>'),
unistr('<p>Cette colonne doit exister dans la source de donn\00E9es sp\00E9cifi\00E9e dans la r\00E9gion de panneau.'),
unistr('Une erreur est g\00E9n\00E9r\00E9e lors de l''ex\00E9cution et la page n''est pas charg\00E9e si le nom de colonne n''existe pas dans la table r\00E9f\00E9renc\00E9e.'),
unistr('De m\00EAme, si aucun processus d''extraction de ligne int\00E9gr\00E9 n''est d\00E9fini et qu''il existe un \00E9l\00E9ment avec le type de source <strong>Colonne de base de donn\00E9es</strong>, une erreur est g\00E9n\00E9r\00E9e et la page n''est pas charg\00E9e lors de la tentative d''affichage')
||' de la page.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023469134305563)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023332873305563)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion de panneau associ\00E9e pour cet \00E9l\00E9ment de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023275821305563)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788629033306160)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588996426306005)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour les donn\00E9es de ce calendrier.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588873142306005)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428562744305883)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de donn\00E9es de la colonne de base de donn\00E9es sous-jacente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094961853306403)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'fr'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094761820306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'fr'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094687373306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'fr'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094062156306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'fr'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094537297306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'fr'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094400265306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'fr'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093978343306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'fr'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094830674306403)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'fr'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094278370305617)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'fr'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094172825306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'fr'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094399323306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'fr'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102094234830306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'fr'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093865600306402)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'fr'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428459632305883)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585759926306002)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne de la table ou la requ\00EAte contenant les dates \00E0 placer dans le calendrier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585614062306002)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585988843306002)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si vous voulez afficher les valeurs d''heure ou uniquement les valeurs de date sur le calendrier.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101585870566306002)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553718586305978)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le masque de format \00E0 appliquer au s\00E9lecteur de date pour cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734168064306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'fr'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733995314306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734086616306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'fr'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734786440306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'fr'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734559511306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734614567306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'fr'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734432403306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'fr'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734202990306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734332287306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'fr'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734812136306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735009781306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101734958374306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735113448306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735328998306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735286746306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'fr'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735407472306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'fr'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735695364306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'fr'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735520449306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'fr'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735790983306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'fr'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735921075306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'fr'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101735804069306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'fr'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733608451306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'fr'
,p_message_text=>'Utiliser le format de date d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733772377306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'fr'
,p_message_text=>'Utiliser le masque de format d''application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101733876754306119)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser le masque de format d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736044991306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736236095306121)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736164204306120)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736362373306121)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736725113306121)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736898209306121)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736581522306121)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736672587306121)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736496823306121)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'fr'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553667054305978)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Masque de format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590051656306006)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur la cible pour appeler une bo\00EEte de dialogue modale. Vous pouvez saisir le lien cible que le calendrier appelle lors de la cr\00E9ation d''un \00E9v\00E9nement en cliquant sur une cellule de calendrier hors d''un \00E9v\00E9nement existant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589952826306006)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une cible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218220794305727)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez l''action \00E0 effectuer. Les actions suivantes sont prises en charge :</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En fonction de la configuration de l''application, des modules d''extension d''action dynamique suppl\00E9mentaires peuvent \00E9galement \00EAtre disponibles ici.'),
unistr('Ceux-ci sont affich\00E9s au format <em>&lt;Mon module d''extension&gt; [Module d''extension]</em>.'),
unistr('Les modules d''extension suivants sont install\00E9s dans les composants partag\00E9s de cette application :</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218128049305727)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541672710305966)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9v\00E9nement d''action dynamique appropri\00E9 dans la liste disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541579707305966)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904706644306251)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code PL/SQL de nettoyage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904670563306251)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code PL/SQL d''initialisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573633926305993)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014701208306343)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilise le param\00E8tre d\00E9fini dans les attributs de s\00E9curit\00E9 d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197780269305693)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le mode de gestion des demandes d''URL externes pour cette page.'),
unistr('Les demandes de page \00E0 partir de cette application vers cette page ne sont pas consid\00E9r\00E9es comme des liens profonds et ne sont pas r\00E9gies par la d\00E9finition de cet attribut.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698723156306093)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698849383306093)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Si l''URL ne contient aucun ID de session valide, &PRODUCT_NAME. d\00E9marre une nouvelle session et r\00E9achemine l''utilisateur vers la page d''accueil de l''application plut\00F4t que sur cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698503738306093)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698662074306093)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si cette page est indiqu\00E9e comme page cible dans une URL, le r\00E9acheminement est effectu\00E9 vers cette page.<br>'),
unistr('Si l''utilisateur n''est pas d\00E9j\00E0 authentifi\00E9 et que la page n''est pas publique, l''utilisateur est invit\00E9 \00E0 se connecter.'),
unistr('Apr\00E8s s''\00EAtre connect\00E9 \00E0 l''application, l''utilisateur est r\00E9achemin\00E9 vers cette page.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197637685305693)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Lien profond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338891205305817)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si l''interface utilisateur est l''interface d''application par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338709579305817)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187895383305686)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''option de construction par d\00E9faut appliqu\00E9e \00E0 ce composant lors de l''export. Cette option peut \00EAtre remplac\00E9e par les options d''export.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696237874306091)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'fr'
,p_message_text=>'Exclure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006258677306336)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9 et non inclus dans l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696362379306091)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'fr'
,p_message_text=>'Inclure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006382554306336)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9 et inclus dans l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187794410305686)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Prendre la valeur par d\00E9faut lors de l''export')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429391186305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la m\00E9thode de d\00E9termination de la valeur par d\00E9faut pour cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929395715306269)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929457996306269)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par l''<em>expression</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929521629306270)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929662233306270)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par le <em>corps de fonction</em> saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429600931305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429748927305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e \00E0 partir du statut de session pour l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430261236305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430353209305885)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>D\00E9finissez cette option sur la valeur renvoy\00E9e \00E0 partir de la <em>s\00E9quence</em> entr\00E9e. Il s''agit d''un type par d\00E9faut sp\00E9cial : il est ex\00E9cut\00E9 dans le cadre du processus DML de la grille interactive et <em>non</em> pendant le chargement de la pag')
||unistr('e. Utilisez ce type pour les valeurs de cl\00E9s primaires g\00E9n\00E9r\00E9es automatiquement, lorsque l''option <strong>Renvoyer des cl\00E9s primaires apr\00E8s l''insertion</strong> ne peut pas \00EAtre utilis\00E9e, par exemple, lors de l''utilisation de vues et de d\00E9clencheurs ')
||unistr('INSTEAD OF, ou de liens de base de donn\00E9es. Le nom de s\00E9quence respecte les majuscules et les minuscules. Utilisez des guillemets pour indiquer un nom de s\00E9quence avec minuscules et majuscules ("mySequence").</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429880623305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429953966305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430033814305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL renvoyant une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430160498305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9finissez cette option sur la liste des valeurs s\00E9par\00E9es par le signe deux-points renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.</p>'),
unistr('        <p>Remarque : les listes s\00E9par\00E9es par le signe deux-points sont obligatoires lorsque la colonne est affich\00E9e sous forme de case \00E0 cocher, de groupe de boutons d''option ou de navette.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429406833305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429509437305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur saisie dans la valeur <em>Statique</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429297336305884)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952443968306293)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952851594306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952701953306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952645251306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952992020306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952592946306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952332950306293)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954451001306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954725803306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954643825306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954505958306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954827271306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954339342306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577397868305996)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application qui contient la valeur par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577212009305996)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954037854306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression Java qui g\00E9n\00E8re la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953967933306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955636623306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Java qui renvoie la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955581503306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953860633306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953798824306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression JavaScript qui g\00E9n\00E8re la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953626879306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955420620306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955333502306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction JavaScript qui renvoie la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955260928306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953537373306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953453562306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression PL/SQL qui g\00E9n\00E8re la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953368394306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955158714306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955056985306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction PL/SQL qui renvoie la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954941453306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954237101306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression Python qui g\00E9n\00E8re la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101954185283306295)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955806108306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Python qui renvoie la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955752342306296)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430986775305885)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de la s\00E9quence de base de donn\00E9es qui renvoie la valeur par d\00E9faut pour cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430836832305885)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953232859306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953131243306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression SQL qui g\00E9n\00E8re la valeur pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101953084934306294)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430574100305885)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la requ\00EAte SQL qui renvoie la valeur par d\00E9faut pour cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430459676305885)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430747837305885)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la requ\00EAte SQL qui renvoie la liste par d\00E9faut de valeurs s\00E9par\00E9es par le signe deux-points pour cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101430681236305885)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Signe deux-points dans une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211420376305722)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la valeur par d\00E9faut de cet \00E9l\00E9ment. Cette valeur est utilis\00E9e si la valeur de l''\00E9l\00E9ment n''est pas d\00E9finie \00E0 partir du statut de session et que la valeur de source est Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211332944305722)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211270618305721)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de valeur par d\00E9faut pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928734393306269)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928849607306269)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par l''<em>expression</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928932630306269)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929032022306269)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par le <em>corps de fonction</em> saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022172236305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022253049305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e \00E0 partir du statut de session pour l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022700907305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022885797305563)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>D\00E9finissez cette option sur la valeur renvoy\00E9e \00E0 partir de la <em>s\00E9quence</em> entr\00E9e. Il s''agit d''un type par d\00E9faut sp\00E9cial : il est ex\00E9cut\00E9 dans le cadre du processus DML de la r\00E9gion du panneau et <em>non</em> pendant le chargement de la page')
||unistr('. Utilisez ce type pour les valeurs de cl\00E9s primaires g\00E9n\00E9r\00E9es automatiquement, lorsque l''option <strong>Renvoyer des cl\00E9s primaires apr\00E8s l''insertion</strong> ne peut pas \00EAtre utilis\00E9e, par exemple, lors de l''utilisation de vues et de d\00E9clencheurs I')
||unistr('NSTEAD OF, ou de liens de base de donn\00E9es. Le nom de s\00E9quence respecte les majuscules et les minuscules.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022328649305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022482470305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022559487305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL renvoyant une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022680498305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9finissez cette option sur la liste des valeurs s\00E9par\00E9es par le signe deux-points renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.</p>'),
unistr('        <p>Remarque : les listes s\00E9par\00E9es par le signe deux-points sont obligatoires lorsque la colonne est affich\00E9e sous forme de case \00E0 cocher, de groupe de boutons d''option ou de navette.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713563368306104)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'fr'
,p_message_text=>'Statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022029889305562)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur saisie dans la valeur <em>Statique</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211189718305721)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440997204305893)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si les utilisateurs finals peuvent d\00E9finir un graphique pour cette grille interactive.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440840099305892)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir la vue de graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416562111305874)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez un mod\00E8le d''autorisation pour restreindre les utilisateurs autoris\00E9s \00E0 supprimer des lignes.'),
unistr('		Pour autoriser un utilisateur final \00E0 supprimer des lignes, ce mod\00E8le d''autorisation doit renvoyer la valeur TRUE pour cet utilisateur.'),
unistr('		Si aucun mod\00E8le d''autorisation n''est indiqu\00E9, n''importe quel utilisateur peut supprimer des lignes dans cette grille interactive.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416453127305874)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549955676305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une condition qui v\00E9rifie la valeur d''un autre facet ou filtre pour contr\00F4ler si le facet ou le filtre en cours doit \00EAtre affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550088735305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E9gal \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550127397305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur du <em>facet ou du filtre</em> de d\00E9pendance est \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550420478305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'fr'
,p_message_text=>'dans la liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550549251305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur du <em>facet ou du filtre</em> de d\00E9pendance figure dans la <em>liste</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550281648305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('diff\00E9rent de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550305239305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur du <em>facet ou du filtre</em> de d\00E9pendance n''est pas \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550639234305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'fr'
,p_message_text=>'absent de la liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550778024305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur du <em>facet ou du filtre</em> de d\00E9pendance ne figure pas dans la <em>liste</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551030378305976)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>'n''est pas NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551129063305976)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur du <em>facet ou du filtre</em> de d\00E9pendance n''est pas vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550859482305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'fr'
,p_message_text=>'est NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101550925837305976)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur du <em>facet ou du filtre</em> de d\00E9pendance est vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549891993305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551522771305976)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste de valeurs s\00E9par\00E9es par des virgules pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551419424305976)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551363257305976)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez la valeur de cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101551257775305976)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549761491305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le facet associ\00E9 \00E0 v\00E9rifier pour d\00E9terminer si le facet en cours doit \00EAtre affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101549692174305975)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875208030306229)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la case \00E0 cocher associ\00E9e \00E0 v\00E9rifier pour d\00E9terminer si la case \00E0 cocher en cours doit \00EAtre affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875183040306229)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Case \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237768216305741)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le filtre associ\00E9 \00E0 v\00E9rifier pour d\00E9terminer si le filtre en cours doit \00EAtre affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237697821305741)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237984916305741)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la case \00E0 cocher associ\00E9e \00E0 v\00E9rifier pour d\00E9terminer si la case \00E0 cocher en cours doit \00EAtre affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237873005305741)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Case \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789857574306161)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('$$$ DJP actuellement masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580794888305998)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne d\00E9riv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095215887306403)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la description de cet \00E9tat interactif.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524344302305954)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une description pour le groupe de colonnes. Les utilisateurs finals ne peuvent jamais voir cette description.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191843760305689)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une description.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191710207305689)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730205167306116)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532554498305960)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code HTML \00E0 afficher apr\00E8s les lignes de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532464471305959)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s lignes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730005272306116)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532189928305959)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code HTML \00E0 afficher avant les lignes de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532009282305959)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Avant lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431875961305886)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la vue de d\00E9tail est activ\00E9e. Si vous s\00E9lectionnez <strong>Activ\00E9</strong>, vous ajoutez une ic\00F4ne Voir les d\00E9tails \00E0 la barre de recherche pour les \00E9tats interactifs, ou au bouton Vue de la grille interactive, ce qui permet aux utilisate')
||unistr('urs d''acc\00E9der \00E0 cette vue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531917548305959)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la vue de d\00E9tail est activ\00E9e. Si vous s\00E9lectionnez <strong>Activ\00E9</strong>, vous ajoutez une ic\00F4ne Voir les d\00E9tails \00E0 la barre de recherche pour les \00E9tats interactifs, ou au bouton Vue de la grille interactive, ce qui permet aux utilisate')
||unistr('urs d''acc\00E9der \00E0 cette vue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531824868305959)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092704787306401)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092868795306401)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le corps des lignes d''\00E9tat dans la vue D\00E9tail.</p>'),
unistr('<p>Les cha\00EEnes de substitution suivantes sont disponibles :'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - cha\00EEnes de substitution pour les noms de colonne.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - cha\00EEnes de substitution pour les libell\00E9s de colonne.</li>'),
'<li><code>&APEX$ROW_ID.</code> - identificateur d''enregistrement de la ligne.</li>',
unistr('<li><code>&APEX$ROW_INDEX.</code> - num\00E9ro de s\00E9quence d''affichage d''enregistrement.</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \00E9tat d''enregistrement tel que <code>is-inserted</code> ou <code>is-deleted</code>.</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730129068306116)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532310043305959)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps pour les lignes d''\00E9tat dans la vue D\00E9tail. Utilisez les cha\00EEnes de substitution <code>#COLUMN_NAME#</code> pour les noms et les libell\00E9s de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532250169305959)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Pour chaque ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191630192305689)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La prise en charge des bo\00EEtes de dialogue dans &PRODUCT_NAME. d\00E9pend de l''interface utilisateur de la page.'),
unistr('Un sous-ensemble d''attributs de bo\00EEte de dialogue est pris en charge de fa\00E7on d\00E9clarative : <em>hauteur, largeur et largeur maximale</em>.'),
unistr('Pour d\00E9finir des attributs suppl\00E9mentaires pour la bo\00EEte de dialogue, entrez les paires nom/valeur sous forme de liste, s\00E9par\00E9es par des virgules.</p>'),
unistr('<p>La cha\00EEne de substitution <code>#DIALOG_ATTRIBUTES#</code> dans le code d''initialisation de bo\00EEte de dialogue d\00E9fini au niveau du mod\00E8le de page est remplac\00E9e par les valeurs saisies dans cet \00E9l\00E9ment.</p>'),
unistr('<p>Pour les pages utilisant l''interface utilisateur de bureau, le widget de bo\00EEte de dialogue d''interface utilisateur jQuery est utilis\00E9.'),
unistr('Pour les pages utilisant l''interface utilisateur de smartphone jQuery Mobile, le widget de bo\00EEte de dialogue jQuery Mobile est utilis\00E9.</p>'),
unistr('<p>Par exemple, les attributs suivants peuvent \00EAtre d\00E9finis pour une page de bo\00EEte de dialogue utilisant une interface utilisateur de bureau : <code>resizable:true, draggable:true</code></p>'),
unistr('<p>Pour plus d''informations sur les attributs disponibles, reportez-vous \00E0 la <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">documentation relative au widget de bo\00EEte de dialogue d''interface utilisateur jQuery</a> et \00E0 la ')
||unistr('<a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">documentation relative au widget de bo\00EEte de dialogue jQuery Mobile</a>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191585592305689)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882188375306234)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Choisissez <strong>Activ\00E9</strong> si cette bo\00EEte de dialogue est ouverte par une autre bo\00EEte de dialogue et doit r\00E9utiliser la m\00EAme fen\00EAtre.'),
unistr('Par exemple, si elle fait partie d''un assistant de bo\00EEte de dialogue dot\00E9 de plusieurs pages et que vous souhaitez r\00E9utiliser la fen\00EAtre de bo\00EEte de dialogue \00E0 chaque \00E9tape de l''assistant.<p><p>'),
unistr('S\00E9lectionnez <strong>D\00E9sactiv\00E9</strong> si cette bo\00EEte de dialogue est ouverte par une autre bo\00EEte de dialogue et doit l''\00EAtre dans une nouvelle fen\00EAtre. Par exemple, lorsque cette bo\00EEte de dialogue est modale,'),
unistr('et que vous voulez l''ouvrir dans une fen\00EAtre de bo\00EEte de dialogue modale parent.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882015649306234)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cha\00EEn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593425739306008)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593320927306008)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281934417305774)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez la hauteur de la bo\00EEte de dialogue en pixels, par exemple, <strong><em>500</em></strong>.'),
unistr('La cha\00EEne de substitution <code>#DIALOG_HEIGHT#</code> dans le code d''initialisation de bo\00EEte de dialogue du mod\00E8le de page est remplac\00E9e par la valeur saisie.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281889372305774)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191476641305689)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la largeur maximale de la bo\00EEte de dialogue en pixels.'),
unistr('La cha\00EEne de substitution <code>#DIALOG_MAX_WIDTH#</code> dans le code d''initialisation de bo\00EEte de dialogue du mod\00E8le de page est remplac\00E9e par la valeur saisie dans cet \00E9l\00E9ment.</p>'),
'<p>Pour une page utilisant l''interface utilisateur de smartphone jQuery Mobile, la largeur maximale est <strong><em>500</em></strong>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191333037305688)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573349332305993)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut du th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326939526305808)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le de bo\00EEte de dialogue pour d\00E9finir l''apparence et la mise en page sur cette page.</p>'),
unistr('        <p>Les mod\00E8les de bo\00EEte de dialogue sont d\00E9finis dans le th\00E8me d''application.'),
unistr('        Lorsqu''une page de bo\00EEte de dialogue est cr\00E9\00E9e, le mod\00E8le est automatiquement configur\00E9 sur <em>Valeur par d\00E9faut du th\00E8me</em> qui affichera la page \00E0 l''aide du mod\00E8le de page par d\00E9faut d\00E9fini dans le th\00E8me en cours.'),
unistr('        En effectuant une s\00E9lection, vous remplacez le mod\00E8le de bo\00EEte de dialogue par d\00E9faut.</p>'),
unistr('        <p>Le th\00E8me universel fournit les mod\00E8les de bo\00EEte de dialogue suivants :'),
'          <dl>',
unistr('            <dt>Bo\00EEte de dialogue modale</dt>'),
unistr('              <dd>Utile pour la plupart des cas d''utilisation de bo\00EEte de dialogue.</dd>'),
unistr('            <dt>Bo\00EEte de dialogue modale d''assistant</dt>'),
unistr('              <dd>Fournit une interface utilisateur rationnalis\00E9e et est adapt\00E9e aux alertes, notifications, petits panneaux et assistants de bo\00EEtes de dialogue modales.</dd>'),
'          </dl>',
unistr('          Reportez-vous \00E9galement \00E0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Application \00E9chantillon de th\00E8me universel</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326819337305808)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191265000305688)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la largeur de la bo\00EEte de dialogue, en pixels ou en pourcentage.'),
unistr('La cha\00EEne de substitution <code>#DIALOG_WIDTH#</code> dans le code d''initialisation de bo\00EEte de dialogue du mod\00E8le de page est remplac\00E9e par la valeur saisie dans cet \00E9l\00E9ment.</p>'),
unistr('<p>Pour une page utilisant une interface utilisateur de bureau, la valeur est d\00E9finie en pixels, par exemple <strong><em>500</em></strong>.'),
unistr('Toutefois, pour une page utilisant l''interface utilisateur de smartphone jQuery Mobile, la valeur est d\00E9finie en pourcentage, par exemple <strong><em>80 %</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191172525305688)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509219473305943)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la direction du param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509361851305943)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509569101305943)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e/sortie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509460724305943)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'fr'
,p_message_text=>'Sortie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509184909305943)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Direction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555367679305979)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si cette colonne peut \00EAtre utilis\00E9e par l''utilisateur final pour trier l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555213329305979)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Peut \00EAtre tri\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586932866306003)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne unique \00E0 afficher dans les cellules du calendrier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101586805825306003)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202614776305697)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un \00E9l\00E9ment peut avoir une valeur de statut de session qui ne figure pas dans la d\00E9finition de liste de valeurs donn\00E9e.'),
unistr('Indiquez si cette liste affiche cette valeur de statut de session suppl\00E9mentaire.'),
unistr('Si vous choisissez de ne pas afficher cette valeur de statut de session suppl\00E9mentaire et qu''il n''y a aucune valeur correspondante dans la d\00E9finition de liste de valeurs, la premi\00E8re valeur de la liste est la valeur s\00E9lectionn\00E9e et affich\00E9e.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202555617305697)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher des valeurs suppl\00E9mentaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202847495305697)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la liste de valeurs utilis\00E9e pour cet \00E9l\00E9ment affiche une valeur NULL en haut de la liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202735105305697)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher la valeur NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245432974305747)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la position utilis\00E9e pour afficher ce composant. Les positions sont d\00E9riv\00E9es des points d''affichage de mod\00E8le de page ou de r\00E9gion appropri\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245304754305746)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900567154306248)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez la s\00E9quence d''affichage de cette action.'),
unistr('Ce param\00E8tre permet d''\00E9valuer les conditions d''affichage et de les appliquer dans l''ordre d\00E9fini.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432205311305886)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la s\00E9quence d''affichage de cette colonne. Le param\00E8tre de s\00E9quence d\00E9termine o\00F9 cette colonne est affich\00E9e par rapport aux autres colonnes dans la r\00E9gion.</p>'),
unistr('<p>Remarque : si deux colonnes dans la m\00EAme r\00E9gion ont une valeur de s\00E9quence identique, elles seront peut-\00EAtre affich\00E9es dans un ordre diff\00E9rent lorsque l''application est export\00E9e et import\00E9e dans un autre environnement, comme un environnement de te')
||'st ou de production.',
unistr('Pour assurer la coh\00E9rence, Oracle recommande d''indiquer des num\00E9ros de s\00E9quence uniques pour chaque \00E9l\00E9ment, ou au moins pour ceux de la m\00EAme r\00E9gion.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524252614305954)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la s\00E9quence d''affichage de ce groupe de colonnes. La s\00E9quence d\00E9termine l''ordre d''apparition des groupes de colonnes dans la vue de d\00E9tail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858039518306212)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la s\00E9quence d''affichage de cette couche. Le param\00E8tre de s\00E9quence d\00E9termine l''ordre dans lequel les couches de carte sont superpos\00E9es. Les couches dont le num\00E9ro est plus \00E9lev\00E9 sont affich\00E9es par-dessus celles dont le num\00E9ro est plus faible')
||'.</p>',
unistr('<p>Remarque : si deux couches de carte ont une valeur de s\00E9quence identique, elles seront peut-\00EAtre affich\00E9es dans un ordre diff\00E9rent lorsque l''application est export\00E9e et import\00E9e dans un autre environnement, comme un environnement de test ou de pro')
||'duction.',
unistr('Pour assurer la coh\00E9rence, Oracle recommande d''indiquer des num\00E9ros de s\00E9quence uniques pour chaque couche, ou au moins pour celles de la m\00EAme r\00E9gion de carte.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221042369305729)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la s\00E9quence d''affichage de cet \00E9l\00E9ment. La s\00E9quence et les autres param\00E8tres de mise en page d\00E9terminent o\00F9 cet \00E9l\00E9ment est affich\00E9 par rapport aux autres \00E9l\00E9ments dans la r\00E9gion.</p>'),
unistr('<p>Remarque : si deux \00E9l\00E9ments dans la m\00EAme r\00E9gion ont une valeur de s\00E9quence identique, ils seront peut-\00EAtre affich\00E9s dans un ordre diff\00E9rent lorsque l''application est export\00E9e et import\00E9e dans un autre environnement, comme un environnement de test ')
||unistr('ou de production. Pour assurer la coh\00E9rence, Oracle recommande d''indiquer des num\00E9ros de s\00E9quence uniques pour chaque \00E9l\00E9ment, ou au moins pour ceux de la m\00EAme r\00E9gion.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220994230305729)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042131519306363)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le d''autorisation pour contr\00F4ler les utilisateurs autoris\00E9s \00E0 effectuer un t\00E9l\00E9chargement.'),
unistr('		Pour autoriser un utilisateur final \00E0 effectuer un t\00E9l\00E9chargement, l''\00E9valuation de ce mod\00E8le d''autorisation doit donner la valeur TRUE pour cet utilisateur.</p>'),
unistr('		Remarque : si aucun mod\00E8le d''autorisation n''est indiqu\00E9, le t\00E9l\00E9chargement peut \00EAtre effectu\00E9 par n''importe quel utilisateur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042061684306363)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Autorisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564700604305986)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez un nom pour le fichier de t\00E9l\00E9chargement CSV. Si vous n''en indiquez pas, c''est le nom de r\00E9gion qui est utilis\00E9, suivi de l''extension .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575867747305995)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez un nom pour le fichier de t\00E9l\00E9chargement CSV. Si vous n''en indiquez pas, c''est le nom de r\00E9gion qui est utilis\00E9, suivi de l''extension .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559833699305982)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de fichier du document lorsqu''il est t\00E9l\00E9charg\00E9. N''indiquez pas l''extension du fichier car elle est ajout\00E9e automatiquement. Si vous laissez cet attribut vide, le nom de la r\00E9gion est utilis\00E9 comme nom de fichier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559710150305982)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527102933305956)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>V\00E9rifiez les formats de t\00E9l\00E9chargement dont disposent les utilisateurs pour t\00E9l\00E9charger les colonnes actuellement affich\00E9es.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727568859306114)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'fr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727652343306114)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'fr'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727783349306114)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'fr'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802418993306170)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'fr'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527028057305956)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Formats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562659468305984)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le texte du lien appelant le t\00E9l\00E9chargement CSV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562507293305984)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559015678305982)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 utiliser pour le lien de t\00E9l\00E9chargement sur la page. Les utilisateurs finals emploient ce lien pour t\00E9l\00E9charger le contenu BLOB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101558961922305982)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger le texte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590454282306006)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez un mod\00E8le d''autorisation pour limiter les d\00E9tenteurs des droits de mise \00E0 jour des \00E9v\00E9nements de calendrier existants \00E0 l''aide du glisser-d\00E9placer.'),
unistr('Si cette information est indiqu\00E9e, ce mod\00E8le doit renvoyer la valeur TRUE pour que le glisser-d\00E9placer soit trait\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590375426306006)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749019439306130)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Processus personnalis\00E9</dt>'),
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590299500306006)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez le processus \00E0 ex\00E9cuter lorsqu''une entr\00E9e de calendrier est gliss\00E9e et d\00E9plac\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590193008306006)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431142960305885)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la colonne doit \00EAtre d\00E9finie par d\00E9faut sur la valeur de colonne existante lors de la duplication de l''enregistrement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431033190305885)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur existante des doublons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101229015337305735)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>V\00E9rifiez les op\00E9rations DML prises en charge. Ce processus ex\00E9cute des op\00E9rations DML en fonction de l''attribut d''<strong>action de base de donn\00E9es</strong> du bouton pour soumettre la page. Si cet attribut n''est pas d\00E9fini, l''op\00E9ration sera d\00E9ter')
||unistr('min\00E9e par le bouton Valeur de demande, d\00E9fini en fonction du nom de bouton, comme suit :</p>'),
'<ul>',
unistr('<li><strong>Ajouter une ligne</strong> est d\00E9clench\00E9 par les valeurs de demande suivantes : INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN</li>'),
unistr('<li><strong>Mettre \00E0 jour une ligne</strong> est d\00E9clench\00E9 par les valeurs de demande suivantes : SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%</li>'),
unistr('<li><strong>Supprimer une ligne</strong> est d\00E9clench\00E9 par les valeurs de demande suivantes : DELETE, REMOVE, DELETE ROW, DROP</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415462113305873)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifiez les op\00E9rations de manipulation de donn\00E9es qui sont autoris\00E9es sur cette grille interactive.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415730046305874)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'fr'
,p_message_text=>'Supprimer une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415559521305873)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415611011305874)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour une ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415332893305873)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9rations autoris\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415986870305874)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez une colonne dont la valeur indique si la ligne peut \00EAtre mise \00E0 jour et/ou supprim\00E9e. Les valeurs autoris\00E9es sont les suivantes :'),
'        <dl>',
'          <dt>U</dt>',
unistr('            <dd>La ligne peut \00EAtre mise \00E0 jour</dd>'),
'          <dt>D</dt>',
unistr('            <dd>La ligne peut \00EAtre supprim\00E9e</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>La ligne peut \00EAtre mise \00E0 jour ou supprim\00E9e</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415809236305874)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne d''op\00E9rations de ligne autoris\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207659572305719)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''alignement de l''\00E9l\00E9ment dans la cellule de tableau HTML o\00F9 il figure.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711221340306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>'En bas au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711346904306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'Au centre au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711444683306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'fr'
,p_message_text=>'En haut au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711146561306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'Au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711621974306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En bas \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711739071306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Au centre \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711805161306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711505682306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'fr'
,p_message_text=>'A gauche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712069566306103)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En bas \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712153744306103)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Au centre \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712210113306103)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711961416306102)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'A droite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203581258305698)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alignement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208204337305719)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la hauteur (nombre de lignes approximatif) des zones de texte, des navettes, des listes de s\00E9lection multiples et des types d''\00E9l\00E9ment de module d''extension prenant en charge l''attribut A un attribut de hauteur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208172093305719)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593799609306008)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'fr'
,p_message_text=>'lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208019196305719)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nombre maximal de caract\00E8res pouvant \00EAtre saisis par les utilisateurs dans cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207983445305719)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Longueur maximale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593832717306009)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'fr'
,p_message_text=>unistr('caract\00E8res')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208649100305720)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des attributs suppl\00E9mentaires, en les s\00E9parant par des espaces, pour la cellule de tableau HTML utilis\00E9e pour afficher chaque option d''un groupe de boutons d''options ou d''un ensemble de cases \00E0 cocher.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208547660305720)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs HTML d''option'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209072418305720)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez les attributs suppl\00E9mentaires affich\00E9s apr\00E8s la cellule de tableau HTML qui affiche chaque option d''un groupe de boutons d''option ou d''un ensemble de cases \00E0 cocher.'),
'Vous pouvez inclure du HTML, du JavaScript et des raccourcis.</p>',
unistr('<p>Vous pouvez r\00E9f\00E9rencer les cha\00EEnes de substitution suivantes :</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de panneau HTML auquel est associ\00E9 cet \00E9l\00E9ment de page.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de page en cours.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208954099305720)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de conclusion '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208851917305720)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez les attributs suppl\00E9mentaires affich\00E9s avant la cellule de tableau HTML qui affiche chaque option d''un groupe de boutons d''option ou d''un ensemble de cases \00E0 cocher.'),
'Vous pouvez inclure du HTML, du JavaScript et des raccourcis.</p>',
unistr('<p>Vous pouvez r\00E9f\00E9rencer les cha\00EEnes de substitution suivantes :</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de panneau HTML auquel est associ\00E9 cet \00E9l\00E9ment de page.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Permet d''obtenir le nom de l''\00E9l\00E9ment de page en cours.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208719831305720)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''introduction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208414998305719)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le texte de conseil \00E0 afficher dans cet \00E9l\00E9ment lorsqu''aucune valeur n''a \00E9t\00E9 saisie pour ce dernier. Une fois qu''un texte est saisi dans l''\00E9l\00E9ment, le conseil est enlev\00E9.</p>'),
unistr('<p>Cet attribut de r\00E9serve donne un bref conseil pouvant \00EAtre utilis\00E9 pour d\00E9crire la valeur attendue d''un \00E9l\00E9ment de page.'),
'Ces conseils sont utiles pour fournir un exemple de valeur ou de format attendu, ou des instructions telles que Rechercher dans le titre, la description et les balises.',
unistr('Pour des raisons d''accessibilit\00E9, cet attribut ne doit pas \00EAtre utilis\00E9 comme alternative \00E0 un libell\00E9 bien d\00E9fini et significatif.</p>'),
unistr('<p><strong>Attention :</strong> il s''agit d''une fonctionnalit\00E9 HTML5 qui ne fonctionne que dans les navigateurs modernes. Les anciens navigateurs n''affichent pas le texte saisi dans cet attribut.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101208354480305719)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de r\00E9serve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207886264305719)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la largeur de l''\00E9l\00E9ment de panneau \00E0 utiliser pour afficher cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207710257305719)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593698067306008)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'fr'
,p_message_text=>unistr('caract\00E8res')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728687954306115)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529937790305958)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez une adresse \00E9lectronique valide \00E0 utiliser en tant qu''adresse d''<em>exp\00E9dition</em> lors de l''envoi de courriels \00E0 partir de cet \00E9tat. Ces derniers sont envoy\00E9s pour les t\00E9l\00E9chargements de type Courriel et pour les abonnements.</p>'),
unistr('<p>La valeur peut \00EAtre une cha\00EEne litt\00E9rale incluant une adresse \00E9lectronique valide ou une r\00E9f\00E9rence de substitution statique d\00E9finie dans l''application \00E0 l''aide de la syntaxe de substitution.'),
unistr('L''utilisation d''une substitution d''\00E9l\00E9ment d''application ou de page n''est pas recommand\00E9e, car elle ne fonctionne que lors du t\00E9l\00E9chargement de courriels et entra\00EEne l''\00E9chec de tous les courriels d''abonnement \00E9tant donn\00E9 qu''il n''est pas possible d''ac')
||unistr('c\00E9der \00E0 ces \00E9l\00E9ments en dehors d''une session valide.'),
unistr('Les abonnements sont directement envoy\00E9s \00E0 partir du moteur &PRODUCT_NAME., et non \00E0 partir d''une session utilisateur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529813677305958)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique d''exp\00E9dition')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441504504305893)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent utiliser cette colonne dans les commandes BREAK et les agr\00E9gats.</p>'),
unistr('        <p>Remarque : l''autorisation de ces op\00E9rations peut entra\00EEner des probl\00E8mes de performances, notamment sur les ensembles de donn\00E9es volumineux ou lorsque les index de colonne appropri\00E9s ne sont pas disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441467539305893)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Commande BREAK/Agr\00E9gat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419973915305877)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent t\00E9l\00E9charger l''\00E9tat dans l''un des formats de t\00E9l\00E9chargement sp\00E9cifi\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419836638305877)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424003373305880)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent filtrer cette colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423911003305880)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440784376305892)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent utiliser des requ\00EAtes Flashback pour cette grille interactive.</p>'),
unistr('<p>Les requ\00EAtes Flashback utilisent Oracle Flashback Technology et la r\00E9cup\00E9ration jusqu''\00E0 un point dans le temps de la base de donn\00E9es pour visualiser les donn\00E9es telles qu''elles existaient \00E0 un moment donn\00E9. Les utilisateurs peuvent uniquement inte')
||unistr('rroger ces donn\00E9es, mais ne peuvent effectuer aucun retour en arri\00E8re sur les modifications de ces derni\00E8res. La date limite (dans le pass\00E9) \00E0 laquelle ils peuvent r\00E9aliser une requ\00EAte Flashback est d\00E9termin\00E9e par la date \00E0 laquelle les fichiers de j')
||unistr('ournalisation ont \00E9t\00E9 modifi\00E9s pour la derni\00E8re fois dans la base de donn\00E9es Oracle, \00E9tant donn\00E9 que cette technologie utilise la sauvegarde RMAN.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440690920305892)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441319676305893)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si les utilisateurs finals peuvent masquer cette colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441228826305893)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Masquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420514901305877)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent envoyer un courriel en incluant le t\00E9l\00E9chargement d''\00E9tat sous forme de pi\00E8ce jointe.</p>'),
unistr('<p>Cette option est disponible uniquement pour les utilisateurs authentifi\00E9s, et le SMTP doit \00EAtre configur\00E9 dans l''application de services d''administration &PRODUCT_NAME. par un administrateur d''instance.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420417732305877)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Envoyer en tant que courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669593135306071)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si l''impression d''\00E9tat doit \00EAtre activ\00E9e. La valeur <strong>Activ\00E9</strong> permet aux utilisateurs de t\00E9l\00E9charger en local un \00E9tat sous divers formats : PDF, Microsoft Word, Microsoft Excel et HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669438925306063)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419364260305876)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent enregistrer la d\00E9finition d''\00E9tat en cours en tant qu''\00E9tat <em>public</em>.</p>'),
unistr('		<p>Les \00E9tats publics sont affich\00E9s dans une liste de s\00E9lection des \00E9tats disponibles dans la barre d''outils et sont visibles par tous les utilisateurs.<p>'),
unistr('		<p>Cette option est uniquement disponible pour les utilisateurs authentifi\00E9s et est restreinte si vous remplissez \00E9galement l''\00E9l\00E9ment <strong>Enregistrer l''autorisation d''\00E9tat public </strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419212571305876)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer un \00E9tat public')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429185486305884)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indiquez si les utilisateurs finals peuvent utiliser cette colonne lors du tri.</p>',
unistr('        <p>Remarque : l''autorisation d''une op\00E9ration de tri peut entra\00EEner des probl\00E8mes de performances, notamment sur les ensembles de donn\00E9es volumineux ou lorsque les index de colonne appropri\00E9s ne sont pas disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101429082215305884)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Trier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419795359305877)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des param\00E8tres d''abonnement pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419633819305877)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Abonnement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216444825305725)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si cet \00E9l\00E9ment doit \00EAtre crypt\00E9 lorsqu''il est stock\00E9 dans le statut de session.'),
unistr('Si le contenu d''un \00E9l\00E9ment comprend des donn\00E9es confidentielles, vous devez crypter la valeur lorsqu''elle est stock\00E9e dans les tables de gestion de statut de session &PRODUCT_NAME..'),
unistr('Sinon, tout utilisateur disposant des droits de lecture sur les tables de m\00E9tadonn\00E9es &PRODUCT_NAME. peut \00E9crire une requ\00EAte afin d''extraire ces donn\00E9es confidentielles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216316319305725)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer la valeur crypt\00E9e dans le statut de session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587974047306004)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le dernier jour de la semaine affich\00E9 dans le calendrier hebdomadaire.'),
unistr('Vous pouvez utiliser cet attribut avec la valeur <strong>Premier jour</strong> pour restreindre les jours de la semaine affich\00E9s ou s\00E9lectionner le jour avant la valeur <strong>Premier jour</strong> pour afficher les sept jours.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747233068306129)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'fr'
,p_message_text=>'Dimanche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747355875306129)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'fr'
,p_message_text=>'Lundi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747403204306129)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'fr'
,p_message_text=>'Mardi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747517712306129)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'fr'
,p_message_text=>'Mercredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747681051306129)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'fr'
,p_message_text=>'Jeudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747799063306129)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'fr'
,p_message_text=>'Vendredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747804163306129)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'fr'
,p_message_text=>'Samedi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587809560306004)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Jour de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588534150306004)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez l''heure de fin pour concentrer l''affichage du calendrier hebdomadaire et quotidien.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588491910306004)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Heure de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589818561306005)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur la cible pour appeler une bo\00EEte de dialogue modale. Vous pouvez saisir le lien cible que le calendrier appelle pour visualiser les d\00E9tails d''un \00E9v\00E9nement existant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589720663306005)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cible d''\00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190086605305687)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nom de la fonction PL/SQL appel\00E9e lorsqu''une erreur survient dans l''application.'),
unistr('Vous pouvez utiliser cette fonction pour agir sur diff\00E9rents codes d''erreur, y compris ceux provenant de la base de donn\00E9es Oracle, et journaliser ces erreurs dans une table personnalis\00E9e que vous d\00E9finissez si n\00E9cessaire.'),
unistr('La fonction peut inclure la logique permettant de modifier le message d''erreur et d''afficher l''emplacement, transformant les erreurs de base de donn\00E9es Oracle en messages conviviaux.'),
unistr('Par exemple, vous pouvez capturer une violation de cl\00E9 unique sur <code>DEMO_CUSTOMERS</code> et remplacer le message <code>ORA-00001</code> par ce texte : Le nom du client doit \00EAtre unique.'),
unistr('L''installation de l''application de base de donn\00E9es \00E9chantillon, \00E0 partir des applications packag\00E9es, cr\00E9e le package <code>SAMPLE_PKG</code>, qui inclut la fonction <code>demo_error_handling</code>.'),
unistr('Cette fonction de gestion des erreurs \00E9chantillon inclut des commentaires complets vous permettant de l''utiliser facilement comme base de d\00E9finition de votre propre fonction.</p>'),
unistr('<p>Le nom de fonction saisi peut r\00E9f\00E9rencer une fonction de package ou une fonction autonome dans la base de donn\00E9es. Par exemple :'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>Lors du r\00E9f\00E9rencement d''une fonction autonome ou d''une fonction de package PL/SQL de base de donn\00E9es, vous pouvez utiliser la cha\00EEne de substitution <code>#OWNER#</code> pour r\00E9f\00E9rencer le sch\00E9ma d''analyse de l''application en cours. Par exemple :'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>Si une fonction de gestion des erreurs est sp\00E9cifi\00E9e sur une page, elle est utilis\00E9e \00E0 la place de ce param\00E8tre de niveau application pour cette page.</p>'),
unistr('<p>Les fonctions de gestion des erreurs doivent impl\00E9menter l''interface suivante :'),
'<pre>',
'function &lt;nom de la fonction> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
unistr('<p>Pour obtenir une description du package <code>apex_error</code>, reportez-vous au manuel de r\00E9f\00E9rence des API.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199619723305695)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Fonction de gestion des erreurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906217677306252)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le message d''erreur \00E0 afficher en cas d''\00E9chec de ce calcul.'),
unistr('    Utilisez <code>#SQLERRM#</code> comme cha\00EEne de substitution pour le message d''erreur SQL r\00E9sultant d''un \00E9chec de calcul.</p>'),
unistr('    <p>Les calculs sont con\00E7us pour toujours r\00E9ussir et leurs \00E9checs sont uniquement dus \00E0 des erreurs non anticip\00E9es.'),
unistr('    Il est d\00E9conseill\00E9 d''impl\00E9menter un calcul qui \00E9choue souvent et agit comme pseudo-validation utilisant ce message d''erreur.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227802781305734)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le message d''erreur \00E0 afficher en cas d''\00E9chec de ce calcul.'),
unistr('    Utilisez <code>#SQLERRM#</code> comme cha\00EEne de substitution pour le message d''erreur SQL r\00E9sultant d''un \00E9chec de calcul.</p>'),
unistr('    <p>Les calculs sont con\00E7us pour toujours r\00E9ussir et leurs \00E9checs sont uniquement dus \00E0 des erreurs non anticip\00E9es.'),
unistr('    Il est d\00E9conseill\00E9 d''impl\00E9menter un calcul qui \00E9choue souvent et agit comme pseudo-validation utilisant ce message d''erreur.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541450228305966)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Saisissez le message d''erreur pour ce processus.',
unistr('Ce message appara\00EEt si une exception non g\00E9r\00E9e est g\00E9n\00E9r\00E9e. Apr\00E8s l''interruption du traitement de l''erreur, une annulation (rollback) est ex\00E9cut\00E9e et un message d''erreur appara\00EEt.</p>'),
unistr('<p>Remarque : le message d''erreur SQL (sqlerrm) appara\00EEt par d\00E9faut si l''option <strong>Page d''\00E9v\00E9nement d''erreur</strong> est d\00E9finie en tant qu''emplacement d''affichage de l''erreur. Vous n''avez pas besoin d''ajouter <code>#SQLERRM#</code> au texte d''')
||'erreur</p>',
unistr('<p>Les messages d''erreur peuvent inclure les cha\00EEnes de substitution suivantes : </p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
unistr('  <dd>Texte du message d''erreur sans le num\00E9ro d''erreur.</dd>'),
'  <dt><code>#SQLERRM#</code></dt>',
'  <dd>Message d''erreur complet.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100635194306407)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>'Le champ #LABEL# doit contenir une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188484517305686)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le texte \00E0 afficher en cas d''\00E9chec de la validation.</p>'),
unistr('<p>Vous pouvez utiliser <code>#LABEL#</code> comme valeur de r\00E9serve pour le libell\00E9 de l''\00E9l\00E9ment associ\00E9 de la page ou <code>#COLUMN_HEADER#</code> pour l''en-t\00EAte de la colonne de r\00E9gion modifiable associ\00E9e. Les valeurs de r\00E9serve ne sont pas prises')
||unistr(' en charge si l''emplacement d''affichage d''erreur est d\00E9fini sur Page d''\00E9v\00E9nement d''erreur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188352751305686)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Message d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299826473305787)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''emplacement d''affichage du message d''erreur pour cette validation.'),
unistr('Les messages d''erreur de validation sont affich\00E9s sur une page d''erreur distincte ou int\00E9gr\00E9s \00E0 la page existante.'),
unistr('Les messages d''erreur int\00E9gr\00E9s apparaissent sous le libell\00E9 <em>El\00E9ment associ\00E9</em> et/ou dans la zone de notification, d\00E9finie dans le mod\00E8le de page.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720424667306109)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'fr'
,p_message_text=>'Incorporation dans une notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720390463306109)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'fr'
,p_message_text=>'Incorporation avec un champ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720202858306109)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'fr'
,p_message_text=>'Incorporation avec un champ et dans une notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720555618306109)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page d''\00E9v\00E9nement d''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299761918305787)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Emplacement d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216612109305725)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pour emp\00EAcher les attaques de type Cross-Site Scripting (XSS), d\00E9finissez toujours cet attribut sur <strong>Activ\00E9</strong>.'),
unistr('Si vous devez afficher les balises HTML stock\00E9es dans l''\00E9l\00E9ment de page ou dans les entr\00E9es d''une liste de valeurs, vous pouvez d\00E9finir cet indicateur sur <strong>D\00E9sactiv\00E9</strong>.'),
unistr('Dans ce cas, prenez des pr\00E9cautions suppl\00E9mentaires et assurez-vous que toute entr\00E9e utilisateur dans ces champs est pr\00E9c\00E9d\00E9e d''un caract\00E8re d''\00E9chappement lors de la saisie et avant l''enregistrement.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216503460305725)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Caract\00E8res sp\00E9ciaux d''\00E9chappement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188695169305686)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les mod\00E8les d''autorisation sont \00E9valu\00E9s \00E0 la premi\00E8re utilisation dans une session.'),
unistr('S\00E9lectionnez le point d''\00E9valuation appropri\00E9 pour d\00E9terminer si l''utilisation suivante de l''autorisation donn\00E9e obtient le r\00E9sultat de la m\00E9moire ou r\00E9\00E9value le mod\00E8le d''autorisation.</p>'),
'#LOV_VALUES#',
unistr('<p>La valeur par d\00E9faut <em>Un par session</em> est la plus efficace.'),
unistr('Choisissez une autre valeur si le contr\00F4le d''autorisation d\00E9pend de la modification de l''\00E9tat de session ou d''autres facteurs qui ne sont pas coh\00E9rents sur toute une session.'),
unistr('Les options <em>Une fois par composant</em> et <em>Toujours (aucune mise en m\00E9moire cache)</em> fournissent des param\00E8tres suppl\00E9mentaires pouvant \00EAtre d\00E9finis pour utilisation par le mod\00E8le d''autorisation.'),
unistr('Dans les modules d''extension d''autorisation, vous pouvez utiliser les attributs <em>component.type</em>, <em>component.id</em> et <em>component.name</em> du param\00E8tre <em>t_authorization</em>.'),
unistr('Pour les types de mod\00E8le int\00E9gr\00E9s <em>Requ\00EAte SQL Existe</em> et <em>Corps de fonction</em>, les variables attach\00E9es \00E9quivalentes <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> et <em>:APP_COMPONENT_NAME</em> sont disponibles.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696827466306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'fr'
,p_message_text=>'Une fois par composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696985713306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Effectue une \00E9valuation par chaque composant r\00E9f\00E9ren\00E7ant le mod\00E8le d''autorisation, mais enregistre le r\00E9sultat dans la session. Les autres demandes d''affichage ou de traitement du mod\00E8le utilisent le r\00E9sultat en m\00E9moire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696647865306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'fr'
,p_message_text=>'Une fois par vue de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696713461306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Effectue une \00E9valuation par chaque demande trait\00E9e. Utilisez le r\00E9sultat en m\00E9moire si le mod\00E8le d''autorisation est r\00E9f\00E9renc\00E9 dans plusieurs composants de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696408237306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Une fois par session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101696523934306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''effectue qu''une fois l''\00E9valuation, puis utilise le r\00E9sultat dans la m\00E9moire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697047019306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Toujours (aucune mise en m\00E9moire cache)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697113064306091)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mod\00E8le d''autorisation est toujours \00E9valu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188518392305686)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Point d''\00E9valuation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193605304305690)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez l''\00E9v\00E9nement qui entra\00EEne le d\00E9clenchement de l''action dynamique.'),
unistr('Pour plus d''informations sur des \00E9v\00E9nements sp\00E9cifiques, reportez-vous \00E0 la section appropri\00E9e dans le manuel <em>App Builder User''s Guide</em>.</p>'),
unistr('Les \00E9v\00E9nements sont class\00E9s dans les types suivants :'),
'<dl>',
unistr('  <dt>Ev\00E9nements du navigateur</dt>'),
unistr('    <dd>Ev\00E9nements de navigateur standard.</dd>'),
unistr('  <dt>Ev\00E9nements de structure</dt>'),
unistr('    <dd>Ces \00E9v\00E9nements sont d\00E9clench\00E9s dans la structure Application Express.</dd>'),
unistr('  <dt>Ev\00E9nements de composant</dt>'),
unistr('    <dd>Ces \00E9v\00E9nements ne sont disponibles que lorsqu''un composant est disponible pour l''application qui d\00E9clenche un \00E9v\00E9nement personnalis\00E9. Ces \00E9v\00E9nements sont d\00E9clench\00E9s \00E0 partir de composants natifs ou de composants de module d''extension que vous')
||unistr(' avez install\00E9s dans l''application.</dd>'),
unistr('  <dt>Ev\00E9nement personnalis\00E9</dt>'),
unistr('    <dd>Tout \00E9v\00E9nement personnalis\00E9 d\00E9clench\00E9 \00E0 partir de l''application.</dd>'),
'</dl>',
unistr('<p>Remarque : les \00E9v\00E9nements affich\00E9s varient en fonction du type d''interface utilisateur en cours de la page.'),
unistr('Si vous voulez s\00E9lectionner un \00E9v\00E9nement qui correspond \00E0 un type diff\00E9rent, vous pouvez s\00E9lectionner <strong>Afficher les \00E9l\00E9ments non pris en charge</strong>,'),
unistr('qui affichera tous les \00E9v\00E9nements, y compris ceux qui ne correspondent pas au type en cours.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193538848305690)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217847808305726)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la port\00E9e de l''\00E9v\00E9nement, qui d\00E9termine quand l''\00E9v\00E9nement est \00E9valu\00E9 une seconde fois ou par succession.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707483975306099)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'fr'
,p_message_text=>'Statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707522491306099)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lie le gestionnaire d''\00E9v\00E8nements aux \00E9l\00E9ments d\00E9clencheurs pendant la dur\00E9e de vie de la page en cours, mais n''assure plus la liaison si ces \00E9l\00E9ments sont mis \00E0 jour via la r\00E9g\00E9n\00E9ration de page partielle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707688155306099)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'fr'
,p_message_text=>'Dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707758669306099)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lie le gestionnaire d''\00E9v\00E8nements aux \00E9l\00E9ments d\00E9clencheurs pendant la dur\00E9e de vie de la page en cours, ind\00E9pendamment de la recr\00E9ation des \00E9l\00E9ments d\00E9clencheurs via la r\00E9g\00E9n\00E9ration de page partielle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707817997306099)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'fr'
,p_message_text=>'Une seule fois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707981954306100)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lie le gestionnaire d''\00E9v\00E9nements aux \00E9l\00E9ments d\00E9clencheurs une seule fois. L''action dynamique n''est pas red\00E9clench\00E9e tant que la page n''a pas \00E9t\00E9 r\00E9g\00E9n\00E9r\00E9e enti\00E8rement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217772471305726)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Port\00E9e d''\00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025384316306351)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si vous voulez exclure ce titre de la traduction. Cet attribut n''a aucun effet, sauf lors de la traduction de l''application dans une autre langue.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025217181306350)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Exclure le titre dans la traduction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858564890306213)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le nombre d''ex\00E9cutions de cette condition de couche.'),
unistr('Si vous faites r\00E9f\00E9rence \00E0 <em>Colonnes</em> dans la condition, vous devez indiquer <strong>Pour chaque ligne</strong> afin que la condition soit \00E9valu\00E9e pour chaque ligne de la requ\00EAte de couche.'),
unistr('Sinon, choisissez l''option <strong>Une fois</strong> pour \00E9valuer les validations une seule fois pour la r\00E9gion.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300644224305788)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le nombre d''ex\00E9cutions de cette validation de r\00E9gion modifiable.'),
unistr('Si vous faites r\00E9f\00E9rence \00E0 <em>Colonnes</em> dans la condition, vous devez indiquer <strong>Pour chaque ligne</strong> afin que la condition soit \00E9valu\00E9e pour chaque ligne de la r\00E9gion modifiable.'),
unistr('Sinon, choisissez l''option <strong>Une fois</strong> pour \00E9valuer les validations une seule fois pour la r\00E9gion.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720998994306109)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Une seule fois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720832157306109)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'Pour chaque ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300559298305787)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter la condition')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431359541305885)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le moment d''ex\00E9cution de cette condition en lecture seule.</p>'),
unistr('        <p>Si vous faites r\00E9f\00E9rence \00E0 <em>Colonnes</em> dans votre condition en lecture seule, vous devez indiquer <strong>Pour chaque ligne</strong> afin que la condition soit \00E9valu\00E9e pour chaque ligne de la grille interactive.'),
unistr('		Sinon, choisissez l''option <strong>Une fois</strong> pour \00E9valuer la condition une seule fois pour la r\00E9gion.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431506379305885)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Une seule fois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547354771305973)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Evaluez la condition en lecture seule une seule fois pour la r\00E9gion enti\00E8re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431438515305885)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'Pour chaque ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547234414305973)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Evaluez la condition en lecture seule s\00E9par\00E9ment pour chaque ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431222216305885)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300457187305787)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la port\00E9e d''ex\00E9cution pour cette validation de r\00E9gion modifiable.'),
unistr('S\00E9lectionnez <strong>Pour les lignes cr\00E9\00E9es et modifi\00E9es</strong> pour que la validation soit \00E9valu\00E9e pour les nouvelles lignes et les lignes mises \00E0 jour dans la r\00E9gion modifiable.'),
unistr('Pour que la validation soit \00E9valu\00E9e pour toutes les lignes soumises, s\00E9lectionnez <strong>Toutes les lignes soumises</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720726601306109)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Toutes les lignes soumises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101720618302306109)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour les lignes cr\00E9\00E9es et modifi\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300352777305787)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Etendue d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193204556305690)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la s\00E9quence de ce composant. La s\00E9quence d\00E9finit l''ordre d''ex\00E9cution.</p>'),
unistr('<p>Remarque : si deux composants poss\00E8dent la m\00EAme valeur de s\00E9quence, ils peuvent \00EAtre ex\00E9cut\00E9s dans un ordre diff\00E9rent lorsque l''application est export\00E9e et import\00E9e dans un autre environnement.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193121975305690)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016885780306344)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour un service REST ORDS, filtrez tous les enregistrements dont l''attribut "sal" est inf\00E9rieur \00E0 3 000.</dt>'),
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016718095306344)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une expression de filtre \00E0 transmettre au service REST externe. L''expression sera transmise telle quelle au serveur distant. La syntaxe d\00E9pend du type de source de donn\00E9es REST. Par exemple, Oracle REST Data Services (ORDS) attend une syntax')
||'e JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016627933306344)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Filtre externe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017126957306344)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour un service REST ORDS, triez par l''attribut "job" dans l''ordre croissant, puis par "ename", dans l''ordre d\00E9croissant.</dt>'),
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017018314306344)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une expression ORDER BY \00E0 transmettre au service REST externe. L''expression sera transmise telle quelle au serveur distant. La syntaxe d\00E9pend du type de source de donn\00E9es REST. Par exemple, Oracle REST Data Services (ORDS) attend une syntaxe')
||' JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016963206306344)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'ORDER BY externe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564907291305986)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le post-traitement externe est activ\00E9 pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564885436305986)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564607803305986)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez le texte du lien sur lequel les utilisateurs finals cliquent pour appeler le moteur de traitement externe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564570905305986)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564431221305986)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''URL d''un serveur pour le post-traitement de cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101564351810305986)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874436580306228)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le groupe de facets auquel cette case \00E0 cocher est associ\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874348696306228)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Groupe de facets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802811042306170)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803544496306171)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803607026306171)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) est bas\00E9e sur une requ\00EAte g\00E9n\00E9r\00E9e automatiquement qui s\00E9lectionne les diff\00E9rentes valeurs de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929790878306270)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929884199306270)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste dynamique de valeurs repose sur la requ\00EAte SQL renvoy\00E9e par le corps de fonction que vous avez saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802969076306170)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Composant partag\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803044509306170)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) est bas\00E9e sur une liste de valeurs pr\00E9d\00E9finie, configur\00E9e dans Composants partag\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803188220306170)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803227959306171)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) dynamique est bas\00E9e sur la requ\00EAte SQL saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803300074306171)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101803404978306171)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) statique est bas\00E9e sur la valeur de texte saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802734001306170)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647708360306048)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si le facet est r\00E9ductible. Avec la valeur <strong>Activ\00E9</strong>, un bouton \00E0 bascule appara\00EEt \00E0 gauche du facet, pour masquer/afficher les entr\00E9es de liste correspondantes. Avec la valeur <strong>D\00E9sactiv\00E9</strong>, le facet et ses ent')
||unistr('r\00E9es de liste demeurent toujours visibles.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647630465306048)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ductible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066415328306381)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si le nombre d''entr\00E9es de liste du facet ou du filtre doit \00EAtre calcul\00E9. L''utilisation de cette option a un impact sur les performances.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066316215306381)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Calculer le nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874684019306228)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez comment combiner les filtres de ce groupe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874956858306229)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'fr'
,p_message_text=>'AND (intersection)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875086044306229)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les filtres seront combin\00E9s \00E0 l''aide de l''op\00E9rateur AND. Le r\00E9sultat correspondra \00E0 l''intersection de tous les filtres individuels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874725966306228)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'fr'
,p_message_text=>'OR (union)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874825014306229)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les filtres seront combin\00E9s \00E0 l''aide de l''op\00E9rateur OR. Le r\00E9sultat correspondra \00E0 l''ensemble unifi\00E9 des filtres individuels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874503930306228)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Combiner des filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647100340306048)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si le filtrage c\00F4t\00E9 client des entr\00E9es de liste du facet ou du filtre doit \00EAtre autoris\00E9. Avec la valeur <strong>Activ\00E9</strong>, un champ de recherche appara\00EEt au-dessus des entr\00E9es de liste pour autoriser les utilisateurs finals \00E0 filtr')
||'er la liste.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647070181306047)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Filtrage c\00F4t\00E9 client')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875658238306229)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si le graphique est initialement affich\00E9. Cette propri\00E9t\00E9 s''applique uniquement lorsque la propri\00E9t\00E9 Afficher les graphiques de la r\00E9gion Recherche \00E0 facets correspond \00E0 S\00E9lecteur. Les modifications apport\00E9es \00E0 cette propri\00E9t\00E9 peuvent ne ')
||unistr('pas \00EAtre visibles imm\00E9diatement car l''ensemble de graphiques affich\00E9 par l''utilisateur est conserv\00E9 dans la session de navigateur. Pour voir les effets des modifications apport\00E9es \00E0 cette propri\00E9t\00E9, r\00E9initialisez l''\00E9tat \00E0 l''aide de l''option de contr\00F4')
||unistr('le de cache associ\00E9e R\00E9initialiser les r\00E9gions, par exemple le bouton R\00E9initialiser g\00E9n\00E9r\00E9 par l''assistant.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875595801306229)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher initialement le graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647950765306048)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si le facet doit initialement \00EAtre affich\00E9 \00E0 l''\00E9tat r\00E9duit. Les modifications apport\00E9es \00E0 cette propri\00E9t\00E9 peuvent ne pas \00EAtre visibles imm\00E9diatement car l''\00E9tat de d\00E9veloppement est conserv\00E9 dans la session de navigateur. Pour voir les eff')
||unistr('ets des modifications apport\00E9es \00E0 cette propri\00E9t\00E9, r\00E9initialisez l''\00E9tat \00E0 l''aide de l''option de contr\00F4le de cache associ\00E9e R\00E9initialiser les r\00E9gions, par exemple le bouton R\00E9initialiser g\00E9n\00E9r\00E9 par l''assistant.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647815621306048)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duit initialement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880597169306233)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>D\00E9termine si le facet est affich\00E9 par d\00E9faut. Les modifications apport\00E9es \00E0 cette propri\00E9t\00E9 peuvent ne pas \00EAtre visibles imm\00E9diatement car l''\00E9tat d''affichage est conserv\00E9 dans la session de navigateur. Pour voir les effets des modifications apport')
||unistr('\00E9es \00E0 cette propri\00E9t\00E9, r\00E9initialisez l''\00E9tat \00E0 l''aide de l''option de contr\00F4le de cache R\00E9initialiser les r\00E9gions du concepteur de liens, par exemple le bouton R\00E9initialiser g\00E9n\00E9r\00E9 par l''assistant.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880443283306233)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Affich\00E9 initialement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648140086306048)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez la hauteur maximale du facet, en pixels.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648018669306048)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur maximale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648248360306048)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990444668305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez comment combiner des valeurs individuelles lors du filtrage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990783199305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'fr'
,p_message_text=>'AND (intersection)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990880234305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs seront combin\00E9es \00E0 l''aide de l''op\00E9rateur AND. Le r\00E9sultat correspondra \00E0 l''intersection de toutes les valeurs individuelles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990571277305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'fr'
,p_message_text=>'OR (union)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990668837305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs seront combin\00E9es \00E0 l''aide de l''op\00E9rateur OR. Le r\00E9sultat correspondra \00E0 l''ensemble unifi\00E9 des valeurs individuelles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990332603305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Combinaison de filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990053142305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Caract\00E8res normaux :</dt>'),
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
unistr('<dt>Caract\00E8res de contr\00F4le :</dt>'),
'<dd>Tabulation (<em>ASCII : 9</em>) <pre>\t</pre></dd>',
unistr('<dd>Retour \00E0 la ligne (<em>ASCII : 10</em>) <pre>\005Cn</pre></dd>'),
unistr('<dt>Autres caract\00E8res :</dt>'),
unistr('<dd>Utilisez une valeur d''encodage au format ''\005Cxxxx'' o\00F9 ''xxxx'' est la valeur hexad\00E9cimale d''un caract\00E8re au format d''encodage UCS-2.</dd>'),
unistr('<dd>D\00E9but du titre (<em>ASCII : 1</em>) <pre>\005C0001</pre></dd>'),
'<dd>Symbole "@" (<em>ASCII : 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989903816305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Identifie le caract\00E8re qui s\00E9pare les valeurs les unes des autres. Les caract\00E8res <strong>"</strong> (guillemet) et <strong>\005C</strong> (barre oblique inverse) ne sont pas pris en charge comme s\00E9parateur de valeurs, ni au format <strong>\005Cxxxx</stro')
||'ng>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989801841305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990247682305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indique si les caract\00E8res non imprimables de d\00E9but et de fin doivent \00EAtre tronqu\00E9s dans les valeurs individuelles apr\00E8s fractionnement.</p>'),
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>Si la troncature des caract\00E8res non imprimables est <em>d\00E9sactiv\00E9e</em>, les valeurs individuelles suivantes sont compt\00E9es :</dt>'),
'<dd><pre>',
'"APEX" :            1',
'"APEX " :           1',
'"SQL" :             2',
'"Spatial" :         1',
'"Oracle TEXT" :     1',
'"Data Warehouse" :  1',
'" Data Warehouse" : 1',
'</pre></dd>',
unistr('<dt>Si la troncature des caract\00E8res non imprimables est <em>activ\00E9e</em>, les valeurs individuelles suivantes sont compt\00E9es :</dt>'),
'<dd><pre>',
'"APEX" :            2',
'"SQL" :             2',
'"Spatial" :         1',
'"Oracle TEXT" :     1',
'"Data Warehouse" :  2',
'</pre></dd>',
unistr('<p>La troncature des caract\00E8res non imprimables peut avoir une incidence notable sur les performances de requ\00EAte. Pour les ensembles de donn\00E9es plus grands, envisagez plut\00F4t de nettoyer les donn\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990143567305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Troncature - Caract\00E8re non imprimable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991185735305538)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991263659305538)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'La colonne ne contient pas plusieurs valeurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239604212305742)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239760148305742)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'La colonne ne contient pas plusieurs valeurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989336631305536)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>D\00E9termine si la colonne source contient plusieurs valeurs et la fa\00E7on dont elles sont encod\00E9es.</p><p><em>Les facets ou les filtres \00E0 plusieurs valeurs sont uniquement pris en charge sur les bases de donn\00E9es Oracle 12.2 ou version sup\00E9rieure. Sur ')
||unistr('une base de donn\00E9es 12.1, &PRODUCT_NAME. g\00E9n\00E8re une erreur d''ex\00E9cution si un facet ou un filtre \00E0 plusieurs valeurs est d\00E9fini.</em></p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989645028305536)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'fr'
,p_message_text=>'Tableau JSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989724028305537)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La colonne source contient un tableau JSON de valeurs scalaires. &PRODUCT_NAME. g\00E9n\00E8re des messages d''erreur si la colonne contient une syntaxe JSON non valide.</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989462785305536)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste d\00E9limit\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989540981305536)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La colonne contient des valeurs sous forme de liste d\00E9limit\00E9e.</p><pre>APEX,SQL,PL/SQL</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100989259749305536)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875463639306229)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si un bouton est affich\00E9 en regard du facet pour permettre \00E0 l''utilisateur d''afficher un graphique du nombre d''entr\00E9es de la liste des facets. Cette propri\00E9t\00E9 s''applique uniquement lorsque la propri\00E9t\00E9 Afficher les graphiques de la r\00E9gion')
||unistr(' Recherche \00E0 facets n''est pas d\00E9finie sur Non.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875300480306229)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher le graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646963977306047)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si le nombre d''occurrences des entr\00E9es de liste du facet ou du filtre doit \00EAtre affich\00E9. Avec la valeur <strong>Activ\00E9</strong>, le nombre appara\00EEt entre parenth\00E8ses en regard de l''entr\00E9e de liste. Par exemple, KING (3).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646894815306047)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher le nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647585698306048)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez le nombre maximal d''entr\00E9es de liste \00E0 afficher pour le facet. Si une valeur est indiqu\00E9e et que la liste contient davantage d''entr\00E9es, un lien <strong>Afficher plus</strong> appara\00EEt en bas de la liste. Si aucune valeur n''est indiqu\00E9e, t')
||unistr('outes les entr\00E9es de liste sont affich\00E9es.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647480665306048)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre maximal d''entr\00E9es affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647359016306048)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si les \00E9ventuelles entr\00E9es de liste s\00E9lectionn\00E9es apparaissent en premier dans la liste du facet ou du filtre. Cet attribut ne s''applique pas quand la liste de valeurs associ\00E9e au facet d\00E9finit des groupes.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101647223707306048)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher la s\00E9lection en premier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276875278305770)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les entr\00E9es de liste du facet ou du filtre doivent \00EAtre tri\00E9es. Lorsque vous s\00E9lectionnez <strong>Activ\00E9</strong>, les entr\00E9es de liste sont tri\00E9es par nombre d\00E9croissant. Lorsque vous s\00E9lectionnez <strong>D\00E9sactiv\00E9</strong>, les entr\00E9es ')
||unistr('de liste sont affich\00E9es dans l''ordre d\00E9fini par la liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101276709646305770)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Trier par nombre d\00E9croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880352656306233)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si les utilisateurs finals peuvent afficher ou masquer le facet. Lorsque cette option est activ\00E9e pour au moins un facet, un bouton Plus de facets est ajout\00E9 et permet de choisir les facets \00E0 afficher ou \00E0 masquer. Le calcul du nombre de ')
||unistr('facets non affich\00E9s n''a aucune incidence sur les performances.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880215818306233)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Activation/D\00E9sactivation de l''affichage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066682861306381)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez la fa\00E7on dont les entr\00E9es de liste ne comptant aucune occurrence sont affich\00E9es pour le facet ou le filtre.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066985338306381)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067037583306381)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Affichez toutes les entr\00E9es mais d\00E9sactivez celles qui ne sont pas filtrables.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066760979306381)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'fr'
,p_message_text=>'Masquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066807890306381)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Affichez uniquement les entr\00E9es de liste filtrables.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067171667306382)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'fr'
,p_message_text=>'Afficher le dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067223342306382)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Affichez toutes les entr\00E9es mais d\00E9sactivez celles qui ne sont pas filtrables, et affichez-les en dernier dans la liste du facet ou du filtre. Cette option est ignor\00E9e si la liste de valeurs (LOV) associ\00E9e utilise la fonctionnalit\00E9 de groupe.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066574066306381)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es ne comptant aucune occurrence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200017704305695)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez les attributs suppl\00E9mentaires utilis\00E9s dans la cellule de tableau HTML contenant ce libell\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199998993305695)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs de cellule de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555961569305979)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mod\00E8le de champ \00E0 utiliser pour l''affichage du champ de panneau tabulaire. Si aucun mod\00E8le n''est s\00E9lectionn\00E9, le champ est affich\00E9 \00E0 l''aide du libell\00E9 conforme \00E0 l''accessibilit\00E9 par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576199440305995)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mod\00E8le de champ \00E0 utiliser pour l''affichage du champ de panneau tabulaire. Si aucun mod\00E8le n''est s\00E9lectionn\00E9, le champ est affich\00E9 \00E0 l''aide du libell\00E9 conforme \00E0 l''accessibilit\00E9 par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199818639305695)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le de libell\00E9 pour d\00E9finir l''apparence et la mise en page de ce libell\00E9 d''\00E9l\00E9ment.</p>'),
unistr('        <p>Les mod\00E8les de libell\00E9 sont d\00E9finis dans le th\00E8me d''application.'),
unistr('        Lorsqu''un \00E9l\00E9ment est cr\00E9\00E9, le mod\00E8le est automatiquement configur\00E9 sur le mod\00E8le d''\00E9l\00E9ment par d\00E9faut d\00E9fini dans le th\00E8me en cours.</p>'),
unistr('        <p>De nombreux th\00E8mes comprennent des mod\00E8les de libell\00E9 pour l''affichage des libell\00E9s masqu\00E9s, facultatifs et obligatoires.<br>'),
unistr('        Le th\00E8me universel fournit les mod\00E8les de libell\00E9 suivants :'),
'          <dl>',
unistr('            <dt>Masqu\00E9</dt>'),
unistr('              <dd>A utiliser lorsque le libell\00E9 ne doit pas \00EAtre affich\00E9 \00E0 l''\00E9cran. La technologie d''assistance pourra toujours lire le libell\00E9.'),
unistr('              Le libell\00E9 Masqu\00E9 est ignor\00E9 pour les \00E9l\00E9ments Case \00E0 cocher car un libell\00E9 doit \00EAtre affich\00E9 apr\00E8s la case \00E0 cocher.</dd>'),
'            <dt>Facultatif</dt>',
unistr('              <dd>A utiliser pour les \00E9l\00E9ments de panneau facultatifs. Le libell\00E9 sera affich\00E9 sur le c\00F4t\00E9 de l''\00E9l\00E9ment.</dd>'),
'            <dt>Facultatif - Au-dessus</dt>',
unistr('              <dd>A utiliser pour les \00E9l\00E9ments de panneau facultatifs. Le libell\00E9 sera affich\00E9 au-dessus de l''\00E9l\00E9ment.</dd>'),
'            <dt>Facultatif - Flottant</dt>',
unistr('              <dd>A utiliser pour les \00E9l\00E9ments de panneau facultatifs. Le libell\00E9 sera affich\00E9 \00E0 l''int\00E9rieur de l''\00E9l\00E9ment saisi et sera r\00E9duit automatiquement d\00E8s que le champ de saisie contiendra une valeur.</dd>'),
'            <dt>Obligatoire</dt>',
unistr('              <dd>Ce mod\00E8le de libell\00E9 affiche un ast\00E9risque rouge en regard du libell\00E9 et est utilis\00E9 pour les \00E9l\00E9ments de panneau pour lesquels une entr\00E9e utilisateur est requise. Le libell\00E9 sera affich\00E9 sur le c\00F4t\00E9 de l''\00E9l\00E9ment.</dd>'),
'            <dt>Obligatoire - Au-dessus</dt>',
unistr('              <dd>Ce mod\00E8le de libell\00E9 affiche un ast\00E9risque rouge en regard du libell\00E9 et est utilis\00E9 pour les \00E9l\00E9ments de panneau pour lesquels une entr\00E9e utilisateur est requise. Le libell\00E9 sera affich\00E9 au-dessus de l''\00E9l\00E9ment. Les mod\00E8les d''\00E9l\00E9men')
||unistr('t vous permettent de d\00E9finir les attributs d''interface utilisateur dans le cadre d''un th\00E8me et de partager cette d\00E9finition parmi de nombreux \00E9l\00E9ments de page.</dd>'),
'            <dt>Obligatoire - Flottant</dt>',
unistr('              <dd>Ce mod\00E8le de libell\00E9 affiche un ast\00E9risque rouge en regard du libell\00E9 et est utilis\00E9 pour les \00E9l\00E9ments de panneau dans lesquels une saisie de l''utilisateur est requise. Le libell\00E9 est affich\00E9 \00E0 l''int\00E9rieur de l''\00E9l\00E9ment saisi et sera')
||unistr(' r\00E9duit automatiquement d\00E8s que le champ de saisie contiendra une valeur. Les mod\00E8les d''\00E9l\00E9ment vous permettent de d\00E9finir les attributs de l''interface utilisateur dans le cadre d''un th\00E8me et de partager cette d\00E9finition parmi de nombreux \00E9l\00E9ments de')
||' page.</dd>',
'          </dl>',
unistr('          Reportez-vous \00E9galement \00E0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Application \00E9chantillon de th\00E8me universel</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199753914305695)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013063659306341)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Filtrer le type de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427004823305882)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si une recherche de correspondance exacte doit \00EAtre effectu\00E9e lorsque l''utilisateur final saisit le texte dans un filtre de colonne.'),
unistr('        Si cette option est d\00E9finie sur <strong>D\00E9sactiv\00E9</strong>, le filtre effectue une recherche Contient plut\00F4t qu''une recherche Egal \00E0.</p>'),
unistr('        <p>Par exemple, pour une colonne nomm\00E9e TAGS, cela \00E9quivaut \00E0 TAGS = ''<<value>>''. Si Correspondance exacte est d\00E9finie sur <strong>D\00E9sactiv\00E9</strong>, cela \00E9quivaut \00E0 TAGS LIKE ''%<<value>>%''. ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426951038305882)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Correspondance exacte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425413096305881)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indiquez si un filtre est toujours obligatoire pour cette colonne.</p>',
unistr('        <p>Remarque : un filtre est toujours obligatoire pour cette colonne sp\00E9cifique avant le renvoi de toute donn\00E9e, ind\00E9pendamment de l''option <strong>Filtre obligatoire</strong> dans les attributs de grille interactive.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425310679305881)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425667175305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la m\00E9thode de d\00E9rivation de la liste des valeurs pour le filtre lorsqu''un utilisateur clique sur l''en-t\00EAte de colonne ou dans des bo\00EEtes de dialogue de filtre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425964065305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne distincte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426054927305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Des valeurs de colonne distinctes sont affich\00E9es pour les colonnes VARCHAR2 et NUMBER. Les colonnes DATE et TIMESTAMP utilisent les plages de dates pr\00E9d\00E9finies int\00E9gr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012033153306340)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'fr'
,p_message_text=>'Utiliser la liste de valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012134168306340)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs sont d\00E9riv\00E9es d''une liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425717699305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425852130305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9sactivez toute valeur affich\00E9e dans le filtre.'),
unistr('        Cette option est adapt\00E9e aux colonnes volumineuses, dont la plupart des valeurs d\00E9passe g\00E9n\00E9ralement 50 caract\00E8res, ou lorsqu''une liste ne permet pas vraiment de s\00E9lectionner un enregistrement sp\00E9cifique.'),
unistr('        A la place, l''utilisateur final peut simplement saisir une valeur partielle, puis visualiser les r\00E9sultats.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426797909305882)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426813858305882)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs sont d\00E9riv\00E9es du corps de fonction PL/SQL renvoyant une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426343473305882)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Composant partag\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426469344305882)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs sont d\00E9riv\00E9es d''une liste de valeurs existante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426129115305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426291131305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs sont d\00E9riv\00E9es de la d\00E9finition de requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426560544305882)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101426621003305882)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs sont d\00E9riv\00E9es d''une liste de valeurs statique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425550857305881)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424233275305880)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez les op\00E9rateurs de filtre dont les utilisateurs finals peuvent se servir pour cette colonne.</p>'),
unistr('        <p>En fonction de la taille de l''ensemble de donn\00E9es et des index de colonne, vous pouvez d\00E9sactiver certains op\00E9rateurs de filtre afin d''\00E9viter tout probl\00E8me de performances pour les utilisateurs finals.'),
unistr('        Certains op\00E9rateurs peuvent entra\00EEner des balayages complets de table au lieu d''utiliser des index de colonne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595527659306010)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'fr'
,p_message_text=>'Contient'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595648435306010)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le filtre renvoie des r\00E9sultats de valeurs de colonne contenant la valeur de filtre.'),
'        &PRODUCT_NAME. utilise <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code> dans la clause WHERE.</p>',
unistr('        <p>Remarque : cet op\00E9rateur emp\00EAche l''utilisation de tout index de colonne, ce qui peut entra\00EEner un balayage complet de table.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424435853305880)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'fr'
,p_message_text=>'Sans respect maj/min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547072992305972)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le filtre renvoie des r\00E9sultats de valeurs de colonne sans prendre en compte les diff\00E9rences de casse de la valeur de colonne et de la valeur de filtre.'),
'        &PRODUCT_NAME. utilise <code>UPPER(column) <em>operator</em> UPPER(filtervalue)</code> dans la clause WHERE.</p>',
unistr('        <p>Remarque : en g\00E9n\00E9ral, l''utilisation de l''op\00E9ration UPPER sur les valeurs de colonne et de filtre emp\00EAche d''utiliser des index de colonne, \00E0 l''exception des index de colonne reposant sur la fonction avec UPPER(<em>column</em>).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424326415305880)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Expression r\00E9guli\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547124405305973)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le filtre renvoie des r\00E9sultats en fonction de l''expression r\00E9guli\00E8re saisie.</p>'),
unistr('        <p>Remarque : l''utilisation d''op\00E9rateurs REGEXP est complexe et est g\00E9n\00E9ralement r\00E9serv\00E9e aux utilisateurs avanc\00E9s. De tels op\00E9rateurs peuvent entra\00EEner de tr\00E8s mauvaises performances.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595711902306010)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'fr'
,p_message_text=>'Commence par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595886595306010)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le filtre renvoie des r\00E9sultats de valeurs de colonne commen\00E7ant par la valeur de filtre.'),
'        &PRODUCT_NAME. utilise <code>column LIKE filtervalue<strong>%</strong></code> dans la clause WHERE.</p>',
unistr('        <p>Remarque : cet op\00E9rateur peut utiliser des index de colonne disponibles. {Consultez <strong>Sans respect maj/min</strong> pour plus d''informations sur les exceptions}.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424160428305880)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Performances ayant un impact sur les op\00E9rateurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424620036305880)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la casse avec laquelle le texte dans la valeur de colonne est stock\00E9.</p>'),
unistr('        <p>Si vous pouvez indiquer que la colonne doit toujours appara\00EEtre en majuscules, par exemple pour <em>Nom utilisateur</em>, ou toujours en minuscules, les performances d''extraction des r\00E9sultats de filtre peuvent \00EAtre am\00E9lior\00E9es.'),
unistr('          Si <strong>Majuscules</strong> ou <strong>Minuscules</strong> est s\00E9lectionn\00E9, les recherches sont toujours effectu\00E9es en respectant les majuscules/minuscules.</p>'),
unistr('        <p>Remarque : si Majuscules et minuscules est s\00E9lectionn\00E9, les utilisateurs finals peuvent indiquer <strong>Distinction maj/min</strong> dans les bo\00EEtes de dialogue de recherche et de filtrage.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424901197305881)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'fr'
,p_message_text=>'Minuscules'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425030070305881)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque la valeur de colonne est toujours stock\00E9e en minuscules.'),
unistr('        &PRODUCT_NAME. utilise un <code><em>op\00E9rateur</em> de colonne LOWER(filtervalue)</code> dans la clause WHERE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425151898305881)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'fr'
,p_message_text=>'Majuscules et minuscules'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101425227749305881)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque la valeur de colonne est stock\00E9e en majuscules et en minuscules. Le param\00E8tre de l''op\00E9rateur <strong>Sans respect maj/min</strong> d\00E9termine la clause WHERE utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424762817305880)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'fr'
,p_message_text=>'Majuscules'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424805242305880)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque la valeur de colonne est toujours stock\00E9e en majuscules.'),
unistr('        &PRODUCT_NAME. utilise un <code><em>op\00E9rateur</em> de colonne UPPER(filtervalue)</code> dans la clause WHERE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101424591406305880)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Casse du texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218681147305727)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si l''action est d\00E9clench\00E9e lors de l''initialisation.</p>'),
unistr('        							<p>L''initialisation a une signification l\00E9g\00E8rement diff\00E9rente selon la fa\00E7on dont l''action dynamique est d\00E9finie. Pour les actions'),
unistr('        							dynamiques d\00E9finies de sorte \00E0 \00EAtre d\00E9clench\00E9es sur les colonnes de la grille interactive, cela indique que l''action est d\00E9clench\00E9e'),
unistr('        							 lorsque la ligne de la grille interactive est activ\00E9e pour la modification. Pour toutes les autres actions dynamiques, cela indique'),
unistr('        							que l''action est d\00E9clench\00E9e lors du chargement de la page.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218586514305727)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencher lors de l''initialisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218438285305727)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si cette action est d\00E9clench\00E9e lorsque la condition d''\00E9l\00E9ment d\00E9clencheur est satisfaite en s\00E9lectionnant <strong>True</strong> (action True), ou lorsqu''elle n''est pas satisfaite en s\00E9lectionnant <strong>False</strong> (action False).</p>'),
unistr('<p>Remarque : si aucune condition n''est indiqu\00E9e, seules les actions <strong>True</strong> sont d\00E9clench\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708177315306100)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'fr'
,p_message_text=>'False'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101708040241306100)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'fr'
,p_message_text=>'True'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218328225305727)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencher si le r\00E9sultat d''\00E9v\00E9nement est')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092264125306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si vous voulez que les en-t\00EAtes de colonne de l''\00E9tat soient fixes en haut de la <strong>page</strong> ou de la <strong>r\00E9gion</strong> de sorte que les en-t\00EAtes de colonne restent visibles lorsque l''utilisateur fait d\00E9filer l''\00E9tat verticalem')
||'ent.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093272103306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093349068306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''en-t\00EAte d''\00E9tat n''est pas attach\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092426527306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092651395306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Fixe l''en-t\00EAte d''\00E9tat en haut de la page. Lorsque l''utilisateur fait d\00E9filer la page verticalement, l''en-t\00EAte d''\00E9tat reste fixe en haut de la page. Les en-t\00EAtes fixes au niveau de la <strong>page</strong> sont utiles lorsque l''\00E9tat est le contenu pri')
||unistr('ncipal de la page. Ca param\00E8tre n''est pas pris en charge lorsque la r\00E9gion est dans une bo\00EEte de dialogue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092356001306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092563218306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Fixe l''en-t\00EAte d''\00E9tat en haut de la r\00E9gion en cours. Lorsque l''utilisateur fait d\00E9filer la r\00E9gion verticalement, l''en-t\00EAte d''\00E9tat reste fixe en haut de la r\00E9gion. Les en-t\00EAtes fixes au niveau de la <strong>r\00E9gion</strong> peuvent \00EAtre utiles pour une')
||unistr(' page contenant plusieurs r\00E9gions, par exemple une page de tableau de bord.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092192395306401)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Attach\00E9 \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093686219306402)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la hauteur maximale de l''\00E9tat, en pixels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093540150306402)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Hauteur maximale d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102093778201306402)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601600857306014)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la hauteur fixe de l''\00E9tat, en pixels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601589860306014)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Hauteur d''\00E9tat fixe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601792545306014)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418168108305876)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la grille interactive doit \00EAtre affich\00E9e avec une hauteur de ligne fixe.</p>'),
unistr('        <p>Si cette option est d\00E9finie sur <em>Oui</em>, des points de suspension (...) apparaissent \00E0 la fin des donn\00E9es pour les colonnes qui sont trop \00E9troites afin d''afficher toutes les donn\00E9es.'),
unistr('        Si elle est d\00E9finie sur <em>Non</em>, les donn\00E9es sont renvoy\00E9es sur plusieurs lignes si n\00E9cessaire.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418002498305875)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur de ligne fixe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287578201305778)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le pied de r\00E9gion \00E0 afficher juste apr\00E8s le contenu du corps, c''est-\00E0-dire apr\00E8s <code>#BODY#</code> dans le mod\00E8le de r\00E9gion.'),
unistr('Vous pouvez utiliser des raccourcis, ainsi que la cha\00EEne de substitution <code>#TIMING#</code> pour afficher le temps consomm\00E9 pour recomposer la r\00E9gion.</p>'),
unistr('<p>Pour les r\00E9gions d''\00E9tat, vous pouvez utiliser les cha\00EEnes de substitution de pagination suivantes :</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>Nombre de lignes extraites par le moteur d''\00E9tats (taille de page). Utilisez ces cha\00EEnes de substitution pour pr\00E9senter des messages personnalis\00E9s \00E0 l''utilisateur.</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>Nombre total de lignes correspondant \00E0 une requ\00EAte SQL utilis\00E9e pour un \00E9tat. Par exemple, "Z" dans "lignes X \00E0 Y sur Z"</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"X" dans "lignes X \00E0 Y sur Z"</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"Y" dans "lignes X \00E0 Y sur Z"</dd>'),
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197100085305693)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte ou le code HTML apparaissant avant le pied du mod\00E8le de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197013078305693)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de pied de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101736974927306121)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Si la valeur de cet attribut est <code>fielddatabold</code>, le code HTML suivant est g\00E9n\00E9r\00E9</dt>'),
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554304836305978)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez les classes CSS \00E0 appliquer \00E0 la valeur de cette colonne. Vous pouvez saisir cette classe CSS ou la s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.</p>'),
unistr('<p>Cette classe est comprise par d\00E9faut sur toutes les pages &PRODUCT_NAME. et a pour d\00E9finition ''.fielddatabold{font-size:10pt; font-weight: bold; color:#000000;}''.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554271502305978)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555863133305979)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le masque de format \00E0 appliquer \00E0 cette colonne.'),
unistr('    Vous pouvez saisir le masque de format ou le s\00E9lectionner dans la liste pr\00E9d\00E9finie, selon son exemple de repr\00E9sentation d''affichage.</p>'),
unistr('    <p>Il est important que les masques de format num\00E9rique s''appliquent uniquement aux colonnes contenant des nombres et les masques de format de date aux colonnes contenant des dates.'),
unistr('    Sinon, une erreur d''ex\00E9cution est g\00E9n\00E9r\00E9e lorsque des \00E9tats contiennent une valeur qui ne peut pas \00EAtre convertie \00E0 l''aide du masque de format donn\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575986980305995)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le masque de format \00E0 appliquer \00E0 cette colonne.'),
unistr('    Vous pouvez saisir le masque de format ou le s\00E9lectionner dans la liste pr\00E9d\00E9finie, selon son exemple de repr\00E9sentation d''affichage.</p>'),
unistr('    <p>Il est important que les masques de format num\00E9rique s''appliquent uniquement aux colonnes contenant des nombres et les masques de format de date aux colonnes contenant des dates.'),
unistr('    Sinon, une erreur d''ex\00E9cution est g\00E9n\00E9r\00E9e lorsque des \00E9tats contiennent une valeur qui ne peut pas \00EAtre convertie \00E0 l''aide du masque de format donn\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201801986305696)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un masque de format \00E0 appliquer \00E0 ce composant.'),
unistr('    Vous pouvez saisir le masque de format ou le s\00E9lectionner dans la liste des masques de format pr\00E9d\00E9finis, selon son exemple de repr\00E9sentation d''affichage.</p>'),
unistr('    <p>Il est important que les masques de format num\00E9rique s''appliquent uniquement aux composants contenant des nombres et les masques de format de date aux composants contenant des dates.'),
unistr('    Sinon, une erreur d''ex\00E9cution est g\00E9n\00E9r\00E9e lorsque le composant contient une valeur qui ne peut pas \00EAtre convertie \00E0 l''aide du masque de format donn\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201701628305696)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Masque de format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202096317305696)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez un masque de format de date \00E0 appliquer \00E0 ce composant.'),
unistr('Vous pouvez saisir le masque de format ou le s\00E9lectionner dans la liste des masques de format pr\00E9d\00E9finis, en fonction d''une repr\00E9sentation \00E9chantillon de l''affichage du masque de format.'),
unistr('Vous pouvez \00E9galement utiliser la syntaxe de substitution pour r\00E9f\00E9rencer un masque de format dynamique \00E0 partir d''un \00E9l\00E9ment de page ou d''application.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201969461305696)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Masque de format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202298738305697)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez un masque de format num\00E9rique \00E0 appliquer \00E0 ce composant.'),
unistr('Vous pouvez saisir le masque de format ou le s\00E9lectionner dans la liste des masques de format pr\00E9d\00E9finis, en fonction d''une repr\00E9sentation \00E9chantillon de l''affichage du masque de format.'),
unistr('Vous pouvez \00E9galement utiliser la syntaxe de substitution pour r\00E9f\00E9rencer un masque de format \00E0 partir d''un \00E9l\00E9ment de page ou d''application.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202191049305697)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Masque de format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198559721305694)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si la saisie semi-automatique est d\00E9sactiv\00E9e pour cette page. La valeur <strong>Activ\00E9</strong> n''a aucun effet sur cette page. La valeur <strong>D\00E9sactiv\00E9</strong> g\00E9n\00E8re le HTML suivant dans la balise FORM :'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>Remarque : selon le navigateur utilis\00E9, <code>autocomplete="off"</code> peut \00EAtre respect\00E9 ou ignor\00E9. Tenez compte de cette diff\00E9rence, en particulier lorsque vous d\00E9finissez cette valeur sur <strong>D\00E9sactiv\00E9</strong>, et faites des essais dans v')
||'os navigateurs cible.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101700099308306094)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699969909306094)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198465952305694)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution automatique de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909927688305473)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir les libell\00E9s du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909881631305473)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552844726305977)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nombre maximal de colonnes d''\00E9tat g\00E9n\00E9riques.'),
unistr('Les \00E9tats qui utilisent les noms de colonne g\00E9n\00E9rique n''\00E9tant analys\00E9s qu''\00E0 l''ex\00E9cution, le nombre de colonnes n''est pas connu lors de la modification de l''\00E9tat.</p>'),
unistr('<p>Le nombre maximal de colonnes d''\00E9tat doit concorder avec celui qui est attendu.'),
unistr('Si le nombre r\00E9el est inf\00E9rieur au maximum, l''\00E9tat affiche le nombre r\00E9el de colonnes.'),
unistr('Cependant, s''il est sup\00E9rieur au maximum, un message d''erreur appara\00EEt au moment de l''ex\00E9cution.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552777746305977)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre de colonnes g\00E9n\00E9riques')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339677335305818)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la page globale pour l''interface utilisateur en cours, si elle n''est pas d\00E9j\00E0 d\00E9finie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339519826305818)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Page globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000533704306331)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573865693305993)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574161105305994)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200801114305696)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une colonne de mise en page sp\00E9cifique. Utilisez l''option <strong>Automatique</strong> pour d\00E9terminer automatiquement la prochaine colonne de mise en page disponible dans laquelle le composant sera affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200787734305695)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201666531305696)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des attributs suppl\00E9mentaires d\00E9finis pour la colonne de mise en page. Cette valeur remplace la valeur de r\00E9serve de substitution <code>#ATTRIBUTES#</code> dans le mod\00E8le de colonne de mise en page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201511661305696)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900036241306247)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Auto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884640759306236)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le nombre de colonnes de mise en page occup\00E9es par ce composant. Utilisez l''option Automatique pour \00E9quilibrer les colonnes de mise en page disponibles sur tous les composants dans la m\00EAme ligne.</p>'),
'<dl>',
'  <dt>Automatique</dt>',
unistr('    <dd>Les cartes pr\00E9sentent une largeur initiale et sont automatiquement renvoy\00E9es \00E0 la ligne lorsque l''espace n''est pas suffisant.</dd>'),
'  <dt>2, 3, 4 ou 5 colonnes</dt>',
unistr('    <dd>Les cartes sont dispos\00E9es de fa\00E7on \00E0 occuper le nombre indiqu\00E9 de colonnes par ligne. La mise en page peut r\00E9duire le nombre de colonnes en fonction de la largeur de la lucarne.</dd>'),
unistr('  <dt>Vous pouvez configurer la largeur des cartes en d\00E9finissant une variable CSS.</dt>'),
unistr('    <dd>Par exemple, ajoutez le fragment de code suivant pour d\00E9finir la largeur des cartes sur 320 px : <pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884731378306236)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>'2 colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884813642306236)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'fr'
,p_message_text=>'3 colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884915880306236)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'fr'
,p_message_text=>'4 colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885010296306236)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'fr'
,p_message_text=>'5 colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101884515095306236)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de grille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095174578306403)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes CSS que vous voulez appliquer \00E0 la colonne de mise en page qui contient cette r\00E9gion. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Cette propri\00E9t\00E9 peut \00EAtre utilis\00E9e pour fournir un contr\00F4le pr\00E9cis de la r\00E9activit\00E9 et de la mise en page de la colonne de mise en page de la r\00E9gion alors que la taille de lucarne est modifi\00E9e.'),
unistr('        Pour les applications de th\00E8me universel, vous pouvez utiliser un certain nombre de modificateurs CSS afin de d\00E9velopper vos composants de page. Pour en savoir plus, consultez la section R\00E9f\00E9rence de l''application \00E9chantillon de th\00E8me univers')
||'el.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102095085722306403)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102000669888306331)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573983815305993)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574289074305994)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201237119305696)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nombre de colonnes de mise en page occup\00E9es par ce composant. Utilisez l''option <strong>Automatique</strong> pour \00E9quilibrer les colonnes de mise en page disponibles sur tous les composants dans la m\00EAme ligne de grille.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201154376305696)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'ColSpan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092074257306400)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de mod\00E8le de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091917734306400)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nombre de colonnes de mise en page occup\00E9es par le libell\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091853277306400)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('ColSpan de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201030555305696)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant est affich\00E9 dans la colonne suivante ou dans la m\00EAme colonne que le composant pr\00E9c\00E9dent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200967153305696)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200485395305695)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant est affich\00E9 dans une nouvelle mise en page ou dans la m\00EAme mise en page que le composant pr\00E9c\00E9dent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200350158305695)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marrer une nouvelle mise en page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200675094305695)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant est affich\00E9 sur la ligne suivante apr\00E8s le composant pr\00E9c\00E9dent ou sur la m\00EAme ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200540796305695)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Commencer une nouvelle ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858719262306213)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes CSS que vous voulez appliquer \00E0 la ligne de mise en page qui contient cette r\00E9gion. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Cette propri\00E9t\00E9 peut \00EAtre utilis\00E9e pour fournir un contr\00F4le pr\00E9cis de la r\00E9activit\00E9 et de la mise en page de la ligne de mise en page de la r\00E9gion alors que la taille de lucarne est modifi\00E9e.'),
unistr('        Pour les applications de th\00E8me universel, vous pouvez utiliser un certain nombre de modificateurs CSS afin de d\00E9velopper vos composants de page. Pour en savoir plus, consultez la section R\00E9f\00E9rence de l''application \00E9chantillon de th\00E8me univers')
||'el.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858698673306213)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201421173305696)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nombre de lignes que ce composant occupe dans le tableau HTML. Les composants sont dispos\00E9s dans des tableaux HTML. Cet attribut d\00E9termine la valeur \00E0 utiliser pour l''attribut <em>ROWSPAN</em> dans la cellule de tableau pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101201329098305696)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'RowSpan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477934136305921)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir une courte info-bulle personnalis\00E9e descriptive sur les noms de s\00E9rie dans la l\00E9gende du graphique. Pour les bo\00EEtes \00E0 moustaches, la colonne ne doit pas correspondre au mapping de colonne de la v')
||unistr('aleur s\00E9lectionn\00E9e. La s\00E9lection d''une colonne qui correspond au mapping de colonne de la valeur emp\00EAchera l''affichage de l''info-bulle de l\00E9gende sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477877577305920)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Info-bulle de l\00E9gende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478162049305921)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir une courte info-bulle personnalis\00E9e descriptive sur les libell\00E9s de l''axe des X du graphique. Pour les bo\00EEtes \00E0 moustaches, la colonne ne doit pas correspondre au mapping de colonne de la valeur ')
||unistr('s\00E9lectionn\00E9e. La s\00E9lection d''une colonne qui correspond au mapping de colonne de la valeur emp\00EAchera l''affichage de l''info-bulle de libell\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478048655305921)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Info-bulle de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552694741305977)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si les d\00E9finitions de colonne sont d\00E9riv\00E9es de la requ\00EAte SQL.'),
unistr('Si oui, &PRODUCT_NAME. doit analyser la requ\00EAte.'),
unistr('Si vous ne voulez pas que la requ\00EAte soit analys\00E9e \00E0 ce moment-l\00E0, utilisez les noms de colonne g\00E9n\00E9riques ; vous obtenez alors des d\00E9finitions de colonne de r\00E9serve.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552538028305977)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser des noms de colonne g\00E9n\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287472576305778)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le texte HTML affich\00E9 en haut de la r\00E9gion, juste avant le contenu <code>#BODY#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196732440305693)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte ou le code HTML que vous voulez voir appara\00EEtre imm\00E9diatement derri\00E8re l''en-t\00EAte de page et avant le contenu du corps.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196650344305692)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560029049305982)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez la fa\00E7on dont les en-t\00EAtes sont d\00E9finis pour votre \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738712876306123)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAtes personnalis\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738816112306123)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Permet de saisir vos propres en-t\00EAtes. Les en-t\00EAtes sont initialement d\00E9finis par d\00E9faut, \00E0 partir d''une requ\00EAte de noms de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738912018306123)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739046422306123)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e des en-t\00EAtes \00E0 partir d''une fonction PL/SQL renvoyant une liste de noms s\00E9par\00E9s par le signe deux-points.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739171447306123)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739279342306123)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9tat est affich\00E9 sans en-t\00EAtes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738380788306122)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'fr'
,p_message_text=>'Noms de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738427155306122)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E8re des en-t\00EAtes \00E0 partir d''une requ\00EAte de noms de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738576519306122)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Noms de colonne (InitCap)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738662005306122)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E8re des en-t\00EAtes, dont la premi\00E8re lettre est alors mise en majuscule, \00E0 partir d''une requ\00EAte de noms de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101559941470305982)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520658435305951)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''alignement de l''en-t\00EAte. Cette s\00E9lection d''alignement doit \00EAtre prise en charge par le mod\00E8le d''\00E9tat s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724544931306112)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724495614306112)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724603148306112)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520522832305951)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alignement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739363405306123)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Fournir les en-t\00EAtes d''un \00E9tat \00E0 partir d''une table DEPT</dt>'),
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560295779305983)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une fonction PL/SQL renvoyant une cha\00EEne d''en-t\00EAtes de colonne s\00E9par\00E9s par le signe deux-points.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560151706305982)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431985147305886)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Utilisez cet attribut pour saisir le texte d''aide pour la grille interactive. Le texte d''aide saisi est affich\00E9 avec le contenu d''aide par d\00E9faut sous l''aide du menu Actions.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432883122305886)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez le texte d''aide de cette colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574971622305994)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte d''aide pour cet \00E9l\00E9ment. Le texte d''aide peut fournir de l''aide contextuelle de niveau champ.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199503112305695)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilisez cet attribut pour saisir un texte d''aide pour la page en cours. L''aide de niveau page prend en charge les raccourcis avec la syntaxe suivante :</p>',
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>Le texte d''aide de page n''est pas affich\00E9 par d\00E9faut. Cependant, vous pouvez d\00E9velopper un syst\00E8me d''aide pour le faire.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199465402305694)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453922944305903)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilisez cet attribut pour saisir un texte d''aide pour la page en cours. L''aide de niveau page prend en charge les raccourcis avec la syntaxe suivante :</p>',
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>Le texte d''aide de page n''est pas affich\00E9 par d\00E9faut. Cependant, vous pouvez d\00E9velopper un syst\00E8me d''aide pour le faire.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453872322305903)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236152592305740)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861215852306215)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473830137305918)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le comportement de masquage et d''affichage ex\00E9cut\00E9 lorsque l''utilisateur clique sur un \00E9l\00E9ment de l\00E9gende.'),
unistr('        Par exemple, si l''utilisateur d\00E9s\00E9lectionne un \00E9l\00E9ment de l\00E9gende, la s\00E9rie de donn\00E9es associ\00E9e est masqu\00E9e sur le graphique.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473977567305918)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597572819306011)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>' Le graphique n''active pas le comportement de masquage et d''affichage.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474186547305918)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune remise \00E0 l''\00E9chelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597771426306011)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr(' Les axes du graphique ne sont pas remis \00E0 l''\00E9chelle. Cette option est utile pour conserver l''utilisateur dans le contexte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474039345305918)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Remettre \00E0 l''\00E9chelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597641889306011)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr(' Les axes du graphique sont remis \00E0 l''\00E9chelle lorsque les valeurs minimale et maximale des donn\00E9es visibles augmentent ou diminuent. Cette option est utile pour des s\00E9ries dont les valeurs varient grandement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473737590305917)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Comportement de masquage et d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554755368305978)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez les cha\00EEnes de texte \00E0 mettre en \00E9vidence dans une colonne d''\00E9tat.'),
unistr('Pour mettre en \00E9vidence plusieurs mots, utilisez une liste de mots s\00E9par\00E9s par des virgules.'),
unistr('Vous pouvez \00E9galement faire r\00E9f\00E9rence \00E0 des \00E9l\00E9ments d''application ou de page \00E0 l''aide de la syntaxe <code>&amp;ITEM.</code>.'),
unistr('Par exemple, vous pouvez mettre en \00E9vidence les cha\00EEnes saisies dans un champ de recherche.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554620138305978)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence les mots')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339056533305817)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Sp\00E9cifiez la page d''accueil de l''application pour l''interface utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338906163305817)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL de la page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217477281305726)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>S\00E9lectionnez l''alignement horizontal pour ce bouton dans la position de mod\00E8le indiqu\00E9e.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715673352306105)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'fr'
,p_message_text=>'A gauche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715710875306105)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'A droite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217331158305726)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alignement horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726575105306113)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
unistr('    Les substitutions <code>#COLUMN_CLASS#</code> et <code>#EMPLOYEE_STATUS#</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523273063305953)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les expressions HTML \00E0 afficher dans cette colonne. Utilisez la syntaxe <code>#COLUMN#</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523168094305953)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196358998305692)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le texte qui doit remplacer la cha\00EEne de substitution <code>#HEAD#</code> dans l''en-t\00EAte de mod\00E8le de page.'),
unistr('Les valeurs saisies ici sont ins\00E9r\00E9es apr\00E8s la balise HTML <code>&lt;head&gt;</code>. Utilisez cet attribut de page pour ajouter des balises META propres \00E0 une page.'),
'</p>',
unistr('<p>Remarque : le code JavaScript ou les feuilles de style CSS doivent \00EAtre ajout\00E9s aux attributs JavaScript et CSS d\00E9di\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196256146305692)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890100184306240)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne renvoyant l''objet BLOB pour la source d''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890077090306240)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889982558306240)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme source d''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889850174306240)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238652538305742)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne \00E0 utiliser afin d''identifier ce facet. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238786728305742)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne \00E0 utiliser afin d''identifier ce facet. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238841447305742)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne \00E0 utiliser afin d''identifier ce facet. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017552410306345)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne que vous voulez ajouter au composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et modificateurs disponibles.</p>'),
unistr('        <p>Remarque : cette ic\00F4ne sera affich\00E9e dans l''\00E9l\00E9ment, non pas en tant que partie du libell\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017470146306345)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne que vous voulez ajouter au composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et modificateurs disponibles.</p>'),
unistr('        <p>Remarque : cette ic\00F4ne sera affich\00E9e dans l''\00E9l\00E9ment, non pas en tant que partie du libell\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239097056305742)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne \00E0 utiliser afin d''identifier ce filtre. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239948306305742)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne \00E0 utiliser afin d''identifier ce filtre. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240344050305743)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne \00E0 utiliser afin d''identifier ce filtre. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876672956306230)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher une fl\00E8che pointant vers la droite</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876561607306230)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne que vous voulez ajouter au composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876494322306230)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891659918306241)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce texte sert \00E0 d\00E9crire l''ic\00F4ne et peut \00EAtre utilis\00E9 dans les info-bulles ainsi que dans le texte alternatif des images.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891561969306241)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Description de l''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890329302306240)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''URL pour la source d''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890220415306240)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890836368306240)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine la position de l''ic\00F4ne dans l''en-t\00EAte de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891301485306241)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891462835306241)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aligne l''ic\00F4ne avec la position de fin (g\00E9n\00E9ralement \00E0 droite) de l''en-t\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891127213306241)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891252641306241)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aligne l''ic\00F4ne avec la position de d\00E9but (g\00E9n\00E9ralement \00E0 gauche) de l''en-t\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890903843306240)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'fr'
,p_message_text=>'En haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101891006059306241)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche l''ic\00F4ne en haut de l''en-t\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101890798399306240)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de l''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900182114306247)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889207547306239)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source de l''ic\00F4ne affich\00E9e dans l''en-t\00EAte du composant de carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889711861306240)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne BLOB d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889518112306239)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de classe d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889399102306239)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'fr'
,p_message_text=>'Initiales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889454416306239)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Classe d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889611127306239)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'fr'
,p_message_text=>'URL d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889197404306239)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Source d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420835348305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420760934305877)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('</p>Saisissez le code HTML de colonne personnalis\00E9 pour la vue Ic\00F4ne.</p>'),
unistr('<p>Les cha\00EEnes de substitution suivantes sont disponibles :'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - cha\00EEnes de substitution pour les noms de colonne.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - cha\00EEnes de substitution pour les libell\00E9s de colonne.</li>'),
'<li><code>&APEX$ROW_ID.</code> - identificateur d''enregistrement de la ligne.</li>',
unistr('<li><code>&APEX$ROW_INDEX.</code> - num\00E9ro de s\00E9quence d''affichage d''enregistrement.</li>'),
unistr('<li><code>&APEX$ROW_URL.</code> - r\00E9f\00E9rence la cible de lien indiqu\00E9e.</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \00E9tat d''enregistrement tel que <code>is-inserted</code> ou <code>is-deleted</code>.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420641925305877)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729965512306116)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531783015305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le lien de colonne pour la vue Ic\00F4ne. Utilisez les cha\00EEnes de substitution <code>#COLUMN_NAME#</code> pour les noms de colonne si n\00E9cessaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531647948305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lien personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431732292305886)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la vue Ic\00F4ne est activ\00E9e. Si vous s\00E9lectionnez <strong>Activ\00E9</strong>, vous ajoutez une ic\00F4ne Ic\00F4nes Vue \00E0 la barre de recherche pour les \00E9tats interactifs, ou au bouton Vue de grille interactive, ce qui permet aux utilisateurs d''acc\00E9der')
||unistr(' \00E0 cette vue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530120109305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la vue Ic\00F4ne est activ\00E9e. Si vous s\00E9lectionnez <strong>Activ\00E9</strong>, vous ajoutez une ic\00F4ne Ic\00F4nes Vue \00E0 la barre de recherche pour les \00E9tats interactifs, ou au bouton Vue de grille interactive, ce qui permet aux utilisateurs d''acc\00E9der')
||unistr(' \00E0 cette vue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530068158305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531308758305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez le texte ALT HTML pour l''image.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531256928305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte ALT HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531504313305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez la balise TITLE HTML pour l''image.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531438072305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte TITLE HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422027397305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez les attributs d''image d''ic\00F4ne utilis\00E9s pour la balise HTML IMG.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421989699305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421467717305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne de grille interactive renvoyant l''objet BLOB pour la source de l''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421385213305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421873783305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne de grille interactive renvoyant les classes CSS pour la source de l''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421764245305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421078610305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de colonne qui contient la source de l''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421278258305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421173397305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'fr'
,p_message_text=>'Image dans l''URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420928492305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421683085305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne de grille interactive renvoyant l''URL pour la source de l''image d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101421517268305878)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('URL de l''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531173164305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez les attributs d''image utilis\00E9s pour la balise HTML IMG.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101531064331305959)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729748218306116)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examiner la colonne <code>IMAGE</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530737971305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne d''\00E9tat renvoyant la source d''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530660571305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de source d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729830388306116)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examiner la colonne <code>ENAME</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530929839305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne d''\00E9tat renvoyant le libell\00E9 d''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530830404305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404192026305865)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examiner la colonne <code>ENAME</code></dt>',
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404012605305865)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne d''\00E9tat renvoyant le libell\00E9 d''image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403951516305865)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422441857305879)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les attributs HTML associ\00E9s \00E0 l''affichage de chaque <strong>cible de lien</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422332018305879)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101729601551306116)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examiner la colonne <code>LINK</code> </dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530578378305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne d''\00E9tat renvoyant la cible de lien de l''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101530466717305958)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957611438306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957922871306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957835098306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957775067306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958043546306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957539990306297)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958896999306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez un corps de fonction Java renvoyant une requ\00EAte SQL pour remplir cette liste de valeurs.</p>'),
unistr('<p>La requ\00EAte SQL doit renvoyer uniquement une colonne. Si elle en renvoie plusieurs, seule la premi\00E8re colonne est utilis\00E9e dans la recherche de filtre.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958721191306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Java renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958605389306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher le nom du service, d\00E9finir le num\00E9ro du service</dt>'),
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958597379306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez un corps de fonction JavaScript renvoyant une requ\00EAte SQL pour remplir cette liste de valeurs.</p>'),
unistr('<p>La requ\00EAte SQL doit renvoyer uniquement une colonne. Si elle en renvoie plusieurs, seule la premi\00E8re colonne est utilis\00E9e dans la recherche de filtre.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958434260306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction JavaScript renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958390304306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Pour renvoyer le nom du service :</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958231108306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez un corps de fonction PL/SQL renvoyant une requ\00EAte SQL pour remplir cette liste de valeurs.</p>'),
unistr('<p>La requ\00EAte SQL doit renvoyer uniquement une colonne. Si elle en renvoie plusieurs, seule la premi\00E8re colonne est utilis\00E9e dans la recherche de filtre.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958162616306298)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959083985306299)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez un corps de fonction Python renvoyant une requ\00EAte SQL pour remplir cette liste de valeurs.</p>'),
unistr('<p>La requ\00EAte SQL doit renvoyer uniquement une colonne. Si elle en renvoie plusieurs, seule la premi\00E8re colonne est utilis\00E9e dans la recherche de filtre.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101958970748306299)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Python renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427332148305882)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>'<pre>Cow,Dog,Cat,Lion</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427291890305882)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez une liste de valeurs s\00E9par\00E9es par des virgules pour cette liste statique.</p>'),
unistr('        <p>Remarque : les valeurs statiques seront toujours affich\00E9es dans l''ordre selon lequel elles sont indiqu\00E9es et non par ordre alphab\00E9tique.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427170410305882)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423085207305879)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le groupe pour cette colonne. Les groupes permettent d''associer des colonnes dans la grille et dans la vue monoligne.</p>'),
unistr('        <p>Remarque : les groupes sont ajout\00E9s en d\00E9veloppant le dossier Attributs dans l''arborescence Affichage et en cliquant avec le bouton droit de la souris sur Groupes de colonnes en vue de cr\00E9er un groupe.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422932043305879)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Groupe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427558596305882)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de source sur lequel est bas\00E9e la valeur de cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427631760305882)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427718837305883)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de colonne saisie dans <em>Colonne de base de donn\00E9es</em>, qui est r\00E9cup\00E9r\00E9e \00E0 partir de la requ\00EAte SQL de source de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428066033305883)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428185505305883)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>'La valeur de colonne n''est pas extraite d''une source. Par exemple, les colonnes APEX$ROW_SELECTOR et APEX$ROW_ACTION n''ont pas de source.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427867153305883)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427914888305883)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par l''<em>expression SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101427494861305882)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420163642305877)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>V\00E9rifiez les formats de t\00E9l\00E9chargement dont disposent les utilisateurs pour t\00E9l\00E9charger les colonnes actuellement affich\00E9es.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420232956305877)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'fr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420361257305877)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'fr'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578361976305997)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'fr'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863628162305438)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'fr'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101420036336305877)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Formats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422228879305879)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur la cible de lien pour appeler une bo\00EEte de dialogue modale. Vous pouvez saisir une cible personnalis\00E9e \00E0 appeler lorsqu''un utilisateur clique sur l''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422176698305878)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Cible de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418310213305876)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type de pagination pour cet \00E9tat. Souvent, toutes les lignes d''\00E9tat n''apparaissent pas dans l''\00E9tat.'),
unistr('		Pour afficher des lignes suppl\00E9mentaires, l''utilisateur final peut utiliser la pagination fournie.<p/>'),
unistr('		<p>La pagination renseigne l''utilisateur final sur le nombre de lignes affich\00E9es et sur la position en cours dans l''ensemble de r\00E9sultats.<p/>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418537013305876)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9filement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546964576305972)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Initialement, un nombre suffisant de lignes pour remplir la hauteur de la grille interactive est affich\00E9.'),
unistr('        Alors que l''utilisateur final fait d\00E9filer, d''autres lignes s''affichent, obtenant davantage de donn\00E9es du serveur au besoin.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418417130305876)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546862493305972)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les premi\00E8res lignes sont affich\00E9es, selon le nombre indiqu\00E9 dans <em>Lignes par page</em>.'),
unistr('        En pr\00E9sence de lignes suppl\00E9mentaires, des contr\00F4les sont ajout\00E9s dans le pied de page d''\00E9tat, permettant aux utilisateurs finals d''aller et de venir dans des ensembles de lignes.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418277081305876)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088472304306398)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion de grille interactive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881802848306234)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un alias pour cet \00E9tat enregistr\00E9. Utilisez cet alias pour d\00E9finir un lien d''URL plus significatif vers cet \00E9tat enregistr\00E9 sp\00E9cifique. Ce lien peut \00EAtre utilis\00E9 en tant que lien direct \00E0 partir de n''importe quel emplacement dans l''applicat')
||'ion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880831035306233)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881912032306234)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez la cat\00E9gorie d''\00E9tat enregistr\00E9, qui d\00E9cide de l''emplacement d''affichage de cet \00E9tat dans la liste de s\00E9lection d''\00E9tats. Cet attribut est en lecture seule et ne peut pas \00EAtre mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881043666306233)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'fr'
,p_message_text=>'Remplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881544261306234)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat suivantes enregistr\00E9es par les d\00E9veloppeurs et pouvant \00EAtre s\00E9lectionn\00E9es par les utilisateurs finals.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880900794306233)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'fr'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881408930306233)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat enregistr\00E9 par les d\00E9veloppeurs qui est affich\00E9 par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881283312306233)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Priv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881756185306234)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat enregistr\00E9es par les utilisateurs finals et ne pouvant \00EAtre s\00E9lectionn\00E9es que par l''utilisateur final qui les a enregistr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881106411306233)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'fr'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101881625997306234)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat enregistr\00E9es par les utilisateurs finals et pouvant \00EAtre s\00E9lectionn\00E9es par tous les autres utilisateurs finals.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880707793306233)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Visibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423268086305879)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''emplacement o\00F9 le groupe est utilis\00E9 pour afficher cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423328131305879)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'fr'
,p_message_text=>'Les deux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423454191305879)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le groupe sera affich\00E9 dans l''en-t\00EAte d''\00E9tat et dans la vue monoligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423706693305880)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423852515305880)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le groupe sera affich\00E9 uniquement dans l''en-t\00EAte d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423503265305880)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'fr'
,p_message_text=>'Vue monoligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423685835305880)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le groupe sera affich\00E9 uniquement dans la vue monoligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101423103890305879)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Utiliser le groupe pour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286839568305777)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez les attributs de balise d''image \00E0 inclure dans le code HTML d''image. Cette fonction peut \00EAtre utilis\00E9e pour les attributs tels que la hauteur, la largeur ou le texte ALT d''image (si l''image n''est pas d\00E9corative).</p>'),
unistr('<p>Remarque : si aucun texte ALT n''est d\00E9fini dans les attributs de balise d''image, &PRODUCT_NAME. affiche par d\00E9faut l''image en tant qu''image d\00E9corative, par exemple, avec une balise ALT vide.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286788013305777)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs de balise d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555537446305979)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si cette colonne est incluse lorsque l''\00E9tat est export\00E9 au format CSV ou imprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555470169305979)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Inclure dans l''export/impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067445117306382)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si la liste des valeurs doit inclure une option de valeur NULL en haut de la liste.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067319044306382)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Inclure l''option de valeur NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407983866305868)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la pseudo-colonne ROWID doit \00EAtre s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407827702305868)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Inclure la colonne ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525342274305954)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Une barre de recherche est affich\00E9e au-dessus de l''\00E9tat. Si vous incluez celle-ci, vous pouvez \00E9galement personnaliser toutes les fonctions \00E0 afficher.</p>'),
'La barre de recherche peut contenir les composants suivants :',
'<dl>',
'  <dt>Champ de recherche</dt>',
unistr('    <dd>Affiche un champ textuel dans lequel vous pouvez saisir des crit\00E8res de recherche.</dd>'),
unistr('  <dt>Liste d\00E9roulante de l''outil de recherche</dt>'),
unistr('    <dd>Imbriqu\00E9e dans le <em>champ de recherche</em>, elle contient les colonnes affich\00E9es. Si une colonne est s\00E9lectionn\00E9e, la recherche est uniquement effectu\00E9e par rapport aux valeurs figurant dans cette colonne.</dd>'),
unistr('  <dt>Liste de s\00E9lection des \00E9tats</dt>'),
unistr('    <dd>Affiche la liste de tous les \00E9tats disponibles pour l''utilisateur, y compris les \00E9tats principaux, de remplacement, publics et priv\00E9s. Cette liste est uniquement affich\00E9e si l''utilisateur a acc\00E8s \00E0 un \00E9tat autre que l''\00E9tat principal.</dd>'),
unistr('  <dt>S\00E9lecteur de lignes par page</dt>'),
unistr('    <dd>Fournit une liste permettant de s\00E9lectionner le nombre de lignes \00E0 afficher par page.</dd>'),
'  <dt>Menu Actions</dt>',
unistr('    <dd>Affiche le bouton du menu Actions, qui contient g\00E9n\00E9ralement un ensemble d''options complet. Ces options permettent \00E0 l''utilisateur final de personnaliser l''\00E9tat selon les fonctions que vous rendez disponibles.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525209940305954)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Inclure la barre de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196127349305692)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En g\00E9n\00E9ral, &PRODUCT_NAME. requiert des fichiers CSS et JavaScript sp\00E9cifiques.'),
unistr('Pour certaines applications, notamment les applications mobiles, vous voudrez peut-\00EAtre supprimer l''inclusion de ces fichiers sur la page.</p>'),
unistr('<p>Pour inclure les fichiers JavaScript et &PRODUCT_NAME. standard, s\00E9lectionnez <strong>Activ\00E9</strong>. S\00E9lectionnez <strong>D\00E9sactiv\00E9</strong> pour supprimer l''inclusion de ces fichiers dans l''en-t\00EAte HTML.</p>'),
unistr('<p>La suppression de l''inclusion de ces fichiers peut affecter de fa\00E7on n\00E9gative une application et entra\00EEner son blocage.'),
unistr('Par cons\00E9quent, la d\00E9sactivation de cet attribut n''est recommand\00E9e que pour les d\00E9veloppeurs avanc\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196071975305692)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Inclure les fichiers CSS standard et JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817825065306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Choisissez la colonne contenant la position de carte initiale en tant qu''objet de type point GeoJSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817777310306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817612206306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Choisissez la colonne SDO_GEOMETRY contenant la position de carte initiale en tant qu''objet de type point.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817514010306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de g\00E9om\00E9trie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816855592306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifie le type de colonne \00E0 utiliser pour la position de carte initiale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817163861306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'fr'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817200759306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'fr'
,p_message_text=>'GeoJSON, sous la forme de types de colonne VARCHAR2 ou CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817331264306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'fr'
,p_message_text=>'Longitude/Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817489237306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>'Longitude et latitude, sous la forme de deux colonnes NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816988828306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'fr'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817006064306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Type SDO_GEOMETRY Oracle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816733311306181)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de donn\00E9es de colonne de g\00E9om\00E9trie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815772627306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indique si la carte doit \00EAtre centr\00E9e sur l''emplacement en cours \00E0 partir du navigateur. Si l''option est activ\00E9e et que le navigateur peut acc\00E9der \00E0 l''emplacement en cours, ce dernier est prioritaire sur la position initiale d\00E9termin\00E9e par les opt')
||unistr('ions Valeurs statiques, Requ\00EAte SQL ou En fonction des r\00E9sultat spatiaux, comme configur\00E9 ci-avant.</p><p>Cela ne s''applique qu''au premier chargement de page d''une session APEX. En cas de nouvel acc\00E8s \00E0 la page de carte au cours de la session APEX, l')
||unistr('a carte est centr\00E9e sur la derni\00E8re position.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815658462306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Obtenir la position \00E0 partir du navigateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818238216306182)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez la colonne contenant la latitude de la position de carte initiale. La valeur renvoy\00E9e doit \00EAtre comprise entre -90 et 90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818178475306182)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de latitude initiale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816485073306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la latitude de la position de carte initiale. Utilisez des valeurs comprises entre -90 (sud) et 90 (nord) et "." en tant que marque d\00E9cimale. Par exemple : <strong>45.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816381741306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818067799306182)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez la colonne contenant la longitude de la position de carte initiale. La valeur renvoy\00E9e doit \00EAtre comprise entre -180 et 180.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101817922401306181)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de longitude initiale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816276185306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la longitude de la position de carte initiale. Utilisez des valeurs comprises entre -180 (ouest) et 180 (est) et "." en tant que marque d\00E9cimale. Par exemple : <strong>100.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816171829306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Longitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816090806306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Requ\00EAte renvoyant des colonnes NUMBER afin de d\00E9terminer la position de carte initiale et le niveau de zoom :</p>'),
'<pre>',
'select -133.5 longitude,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>Requ\00EAte renvoyant une colonne SDO_GEOMETRY afin de d\00E9terminer la position de carte initiale et une colonne NUMBER pour le niveau de zoom.</p>'),
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815917385306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la requ\00EAte SQL permettant de d\00E9terminer le niveau de zoom et la position de carte initiale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815807568306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814945786306179)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez comment d\00E9terminer la position de carte initiale et le niveau de zoom d''une nouvelle session APEX ou apr\00E8s une op\00E9ration d''<strong>effacement</strong> ou de <strong>r\00E9initialisation</strong> de r\00E9gion de carte. Au sein d''une m\00EAme session APE')
||unistr('X, la r\00E9gion de carte m\00E9morise la position et le niveau de zoom en cours pour l''ensemble des demandes de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815439661306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En fonction des r\00E9sultats spatiaux')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815545839306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La carte est positionn\00E9e de fa\00E7on \00E0 ce que les r\00E9sultats de requ\00EAte de couche soient visibles. <em>Cette option n''est pas prise en charge si GeoJSON est choisi comme type de colonne de g\00E9om\00E9trie de couche</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815291786306179)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815328394306180)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une requ\00EAte SQL renvoyant des valeurs pour la position de carte initiale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815029426306179)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101815140271306179)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez des valeurs statiques pour la position de carte initiale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814862628306179)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818426626306182)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez la colonne contenant le niveau de zoom initial. La valeur renvoy\00E9e doit \00EAtre comprise entre 1 et 18.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818395914306182)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de niveau de zoom initial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816671298306180)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez le niveau de zoom initial. Utilisez des entiers compris entre 1 et 18.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101816518669306180)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Niveau de zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704375740306097)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>D\00E9finit la classe CSS <code>display_only</code> sur bold</dt>'),
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101191003625305688)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le code CSS utilis\00E9 sur cette page.'),
unistr('S''il est employ\00E9 sur plusieurs pages, saisissez-le dans un fichier externe pour \00E9viter toute duplication et tirer parti de la mise en m\00E9moire cache des fichiers statiques dans le navigateur.</p>'),
unistr('<p>Le code saisi ici remplace la cha\00EEne de substitution <code>#PAGE_CSS#</code> dans le mod\00E8le de page.</p>'),
unistr('<p>Remarque : vous n''avez pas besoin d''ajouter les balises <code>style</code> de d\00E9but ou de fin, mais simplement le code CSS.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190985976305688)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Incorporation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199322633305694)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le message d''erreur \00E0 afficher en cas d''erreur sur cette page. Le message d''erreur remplace <code>#NOTIFICATION_MESSAGE#</code> dans le mod\00E8le de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101199217226305694)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte de notification d''erreur imbriqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017322922306344)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte d''aide incorpor\00E9 pour cet \00E9l\00E9ment. Le texte d''aide est imm\00E9diatement affich\00E9 avec l''\00E9l\00E9ment et peut fournir de l''aide contextuelle de niveau champ.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017267001306344)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''aide incorpor\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282841150305774)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez l''emplacement de r\00E9acheminement de &PRODUCT_NAME. si la session n''est pas valide.'),
unistr('Cela se produit si la <strong>fonction de sentinelle</strong> ou la <strong>fonction de v\00E9rification</strong> renvoie la valeur False sur les demandes de page normales, mais pas sur les demandes AJAX.</p>'),
unistr('<p>Remarque : si vous utilisez le type de mod\00E8le d''authentification <strong>Personnalis\00E9</strong>, l''attribut <strong>Fonction de sentinelle</strong> dans le mod\00E8le d''authentification peut \00E9galement \00EAtre utilis\00E9.'),
unistr('Pour les types de mod\00E8le d''authentification de module d''extension, cela est d\00E9fini par le d\00E9veloppeur du module d''extension dans le callback de <strong>nom de fonction de sentinelle de session</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717393218306106)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de connexion int\00E9gr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717461592306107)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''URL d\00E9finie dans <code>wwv_flow_custom_auth_std.login_page</code>, fournie par &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717130798306106)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'fr'
,p_message_text=>'Page de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717223958306106)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''URL de connexion d\00E9finie dans les attributs d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717520680306107)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'fr'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717699243306107)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''URL saisie, telle que <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282726360305774)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminement de session non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283005018305775)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''URL sur laquelle &PRODUCT_NAME. effectue un r\00E9acheminement lorsque la fonction de sentinelle de session renvoie la valeur FALSE. En principe, il s''agit de l''URL d''une page de connexion ou du portail d''acc\00E8s avec connexion unique. Par exem')
||'ple : f?p=&amp;APP_ID.:101:&amp;SESSION'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282914175305775)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL de session non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524006419305954)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type d''affichage de colonne pertinent pour d\00E9finir le mode d''affichage des valeurs de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724078237306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger un BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908392312306254)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne en tant que lien pour t\00E9l\00E9charger le fichier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724334704306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne masqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908600489306254)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''affiche pas la colonne, mais elle peut \00EAtre r\00E9f\00E9renc\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723973751306111)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908225515306253)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la colonne en tant qu''image.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723802316306111)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'fr'
,p_message_text=>'Lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908130526306253)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la colonne en tant que lien.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724113504306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 pourcentage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908406673306254)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne en tant que graphique \00E0 pourcentage. La valeur extraite doit \00EAtre comprise entre 0 et 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723607649306111)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'fr'
,p_message_text=>'Texte brut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907993038306253)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la valeur de colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723794175306111)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'fr'
,p_message_text=>'Texte brut (en fonction d''une liste de valeurs)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908033559306253)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la valeur renvoy\00E9e par la liste de valeurs indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980422993306316)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte enrichi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980573242306316)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne \00E0 l''aide du langage HTML ou Markdown.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101724219311306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'fr'
,p_message_text=>'Enlever le HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908561960306254)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la valeur de colonne apr\00E8s avoir enlev\00E9 les balises HTML et proc\00E9d\00E9 \00E0 l''\00E9chappement des caract\00E8res sp\00E9ciaux.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523977026305953)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608229476306019)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Pour renvoyer le nom du service :</dt>',
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542375509305967)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez une requ\00EAte SQL qui doit renvoyer une colonne. Si la requ\00EAte renvoie plusieurs colonnes, seule la premi\00E8re est utilis\00E9e dans la liste de valeurs.</p>'),
unistr('<p>En saisissant une requ\00EAte SQL, vous pouvez am\00E9liorer les performances dans certains \00E9tats ou limiter les valeurs affich\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542269762305967)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661751490306058)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une liste de valeurs (LOV) nomm\00E9e d\00E9finie. Le filtre de colonne utilise uniquement la premi\00E8re colonne de la requ\00EAte de liste de valeurs (LOV) dynamique ou la valeur d''affichage de la liste de valeurs (LOV) statique pour filtrer les donn')
||unistr('\00E9es d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661647890306058)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) nomm\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522879421305953)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mode de d\00E9rivation des filtres fournis dans la liste d\00E9roulante de colonnes d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725865709306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) nomm\00E9e pour filtrer la correspondance exacte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725951271306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) de la liste de valeurs nomm\00E9e pour cr\00E9er un filtre de correspondance parfaite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726055117306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) nomm\00E9e pour filtrer le contenu des mots')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726136300306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) de la liste de valeurs nomm\00E9e pour cr\00E9er un filtre de correspondance de contenu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725645442306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) d\00E9finie pour filtrer le contenu des mots')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725793131306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) d''une requ\00EAte SQL de liste de valeurs d\00E9finie pour cr\00E9er un filtre de correspondance de contenu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725299353306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut bas\00E9e sur le type de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725340139306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) des colonnes STRING et NUMBER d\00E9rive de colonnes distinctes. Celle des colonnes DATE d\00E9rive de plages de dates pr\00E9d\00E9finies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725028059306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725117516306112)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun filtre de colonne n''est fourni pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725400448306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) d\00E9finie pour filtrer la correspondance exacte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101725555490306113)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) d''une requ\00EAte SQL de liste de valeurs d\00E9finie pour cr\00E9er un filtre de correspondance parfaite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522784228305953)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523840176305953)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le groupe pour cette colonne. Cette fonction permet d''afficher les colonnes selon des groupes logiques dans la vue monoligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523701674305953)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Groupe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527729320305956)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le type de colonne de lien pour cet \00E9tat.'),
unistr('Si vous s\00E9lectionnez la colonne de lien, elle appara\00EEt toujours en premier dans l''\00E9tat et ne peut pas \00EAtre masqu\00E9e par l''utilisateur.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728049337306114)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lien vers la cible personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728160271306114)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final est dirig\00E9 vers une autre page en fonction de l''URL cible saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728217555306115)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Exclure la colonne de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728380794306115)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de lien n''est pas affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727886729306114)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'Lien vers la vue monoligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727915166306114)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final est dirig\00E9 vers une page qui affiche les valeurs de colonne pour la ligne indiqu\00E9e. Le contenu et l''affichage des colonnes sont r\00E9gis par divers attributs de colonne et d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101527629863305956)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574322178305994)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525561215305955)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type de pagination pour cet \00E9tat. Tr\00E8s souvent, seul un certain nombre de lignes d''un \00E9tat appara\00EEt sur une page.'),
unistr('Pour inclure des lignes suppl\00E9mentaires, l''utilisateur final de l''application doit acc\00E9der \00E0 la page suivante de l''\00E9tat.<p/>'),
unistr('<p>La pagination renseigne l''utilisateur sur le nombre de lignes et sur la position en cours dans l''ensemble de r\00E9sultats.<p/>'),
unistr('<p>Elle peut figurer en haut ou en bas de l''\00E9tat (ou les deux), \00E0 gauche ou \00E0 droite.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726884039306114)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes X \00E0 Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726713276306113)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Plages de lignes X \00E0 Y sur Z')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525427279305955)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540003713305965)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un alias pour cet \00E9tat enregistr\00E9. Utilisez cet alias pour d\00E9finir un lien d''URL plus significatif vers cet \00E9tat enregistr\00E9 sp\00E9cifique. Ce lien peut \00EAtre utilis\00E9 en tant que lien direct \00E0 partir de n''importe quel emplacement dans l''applicat')
||'ion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539936906305965)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540494124305965)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez la cat\00E9gorie d''\00E9tat enregistr\00E9, qui d\00E9cide de l''emplacement d''affichage de cet \00E9tat dans la liste de s\00E9lection d''\00E9tats. Cet attribut est en lecture seule et ne peut pas \00EAtre mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730437273306116)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Val. par d\00E9faut du rempla\00E7ant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908896235306254)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat suivantes enregistr\00E9es par les d\00E9veloppeurs et pouvant \00EAtre s\00E9lectionn\00E9es par les utilisateurs finals.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730327431306116)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Val. par d\00E9faut du principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908765237306254)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat enregistr\00E9 par les d\00E9veloppeurs qui est affich\00E9 par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730600506306116)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Priv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909080459306254)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat enregistr\00E9es par les utilisateurs finals et ne pouvant \00EAtre s\00E9lectionn\00E9es que par l''utilisateur final qui les a enregistr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730557012306116)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'fr'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101908984497306254)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en page d''\00E9tat enregistr\00E9es par les utilisateurs finals et pouvant \00EAtre s\00E9lectionn\00E9es par tous les autres utilisateurs finals.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540372854305965)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Visibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374320533305843)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent modifier cette r\00E9gion de panneau.</p>'),
unistr('        <p>Remarque : lorsque la r\00E9gion de panneau est modifiable, un processus est cr\00E9\00E9 automatiquement pour traiter la ligne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415276305305873)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indiquez si les utilisateurs finals peuvent modifier cette grille interactive.</p>',
unistr('        <p>Remarque : lorsque la grille interactive est modifiable, un processus est cr\00E9\00E9 automatiquement pour traiter les lignes.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415135525305873)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013111800306341)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Est une page globale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428917733305883)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la colonne est l''une des valeurs de cl\00E9 primaire pour les tables sous-jacentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428821595305883)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cl\00E9 primaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428779571305883)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la colonne doit \00EAtre exclue des op\00E9rations DML.</p>'),
unistr('        <p>Si la valeur est d\00E9finie sur <strong>Activ\00E9</strong>, &PRODUCT_NAME. n''utilisera pas la colonne lors de l''ex\00E9cution de Grille interactive - Traitement de ligne automatique (DML).'),
unistr('        Par exemple, vous devez exclure les colonnes dont les d\00E9finitions incluent des concat\00E9nations, des s\00E9lections internes, des appels de fonction, ou une colonne dans une vue modifiable reposant sur une expression.</p>'),
unistr('        <p>Cette option doit \00EAtre d\00E9finie sur <strong>D\00E9sactiv\00E9</strong> pour toutes les colonnes devant \00EAtre incluses dans toute instruction INSERT ou UPDATE.</p>'),
unistr('        <p>Remarque : les colonnes de type <em>Afficher uniquement</em> sont <u>\00E9galement</u> incluses dans le traitement de ligne automatique \00E0 moins que cette option soit d\00E9finie sur <strong>Activ\00E9</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428656431305883)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte uniquement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509760777305943)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le param\00E8tre ne peut \00EAtre d\00E9fini qu''une fois avec une valeur statique ou s''il peut \00EAtre remplac\00E9 au niveau du composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509623426305943)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861438503306215)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si cette colonne est affich\00E9e ou masqu\00E9e. M\00EAme lorsque les colonnes sont masqu\00E9es, vous pouvez y faire r\00E9f\00E9rence \00E0 l''aide d''une syntaxe de substitution, <code>&amp;COLUMN_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101861397661306215)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401800616305863)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la valeur \00E9lev\00E9e sur ce graphique. Lorsqu''aucune colonne n''est s\00E9lectionn\00E9e, la valeur la plus \00E9lev\00E9e de la bo\00EEte \00E0 moustaches reposera sur l''ensemble de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401685922305863)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Elev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401748892305863)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la valeur faible sur ce graphique. Lorsqu''aucune colonne n''est s\00E9lectionn\00E9e, la valeur la plus faible de la bo\00EEte \00E0 moustaches reposera sur l''ensemble de donn\00E9es. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401550761305863)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Faible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476705882305920)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur de fin sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476631301305920)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476396905305919)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur sup\00E9rieure sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476211191305919)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Elev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478312589305921)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir les libell\00E9s de l''axe des X sur le graphique. Pour un graphique boursier, la colonne doit \00EAtre de type Date/Horodatage pour repr\00E9senter les informations relatives \00E0 l''action sur un axe temporel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478222957305921)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307510012305794)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483758616305925)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Saisissez une cha\00EEne de style CSS pour d\00E9finir le style des libell\00E9s sur ce graphique.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483679603305925)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507939806305942)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour les s\00E9ries \00E0 plages, si un tableau comportant deux valeurs est fourni, la premi\00E8re et la seconde valeurs sont appliqu\00E9es respectivement aux points inf\00E9rieur et sup\00E9rieur. La valeur <strong>A l''ext\00E9rieur du secteur</strong> est applicable uniq')
||unistr('uement \00E0 des graphiques \00E0 secteurs.'),
unistr('        Les valeurs <strong>Au-dessus du marqueur</strong>, <strong>En dessous du marqueur</strong>, <strong>Avant le marqueur</strong> et <strong>Apr\00E8s le marqueur</strong> sont uniquement applicables aux s\00E9ries \00E0 courbes, en aires, en nuage de poin')
||unistr('ts et \00E0 bulles. Les valeurs <strong>A l''int\00E9rieur de la bordure de barre</strong> et <strong>A l''ext\00E9rieur de la bordure de barre</strong>'),
unistr('        sont applicables uniquement \00E0 des s\00E9ries \00E0 barres non polaires. Les barres empil\00E9es ne prennent pas en charge l''option <strong>A l''ext\00E9rieur de la bordure de barre</strong>. La valeur <strong>D\00E9part</strong> s''applique uniquement aux graphiqu')
||unistr('es Jauge de compteur de statut verticaux et horizontaux. Actuellement, le graphique n''ajuste pas la mise en page afin d''inclure des libell\00E9s dans la zone de trac\00E9 ou de g\00E9rer des chevauchements entre les libell\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482756464305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la position des libell\00E9s \00E0 afficher sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482910562305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'fr'
,p_message_text=>'Au-dessus du marqueur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483259317305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s le marqueur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483581949305925)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483136894305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'fr'
,p_message_text=>'Avant le marqueur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483088974305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'fr'
,p_message_text=>'En dessous du marqueur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482800138305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'Au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483301640305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('A l''int\00E9rieur de la bordure de barre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507354260305942)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483459474305925)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('A l''ext\00E9rieur de la bordure de barre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507227994305942)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('A l''ext\00E9rieur du secteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943120835305502)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482611121305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482502942305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les libell\00E9s doivent \00EAtre affich\00E9s sur le graphique. Ce param\00E8tre est applicable \00E0 la visibilit\00E9 de la valeur de mesure sur un graphique \00E0 cadran. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482401640305924)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476195279305919)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur inf\00E9rieure sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476034077305919)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Faible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477796882305920)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur maximale sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477600224305920)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579660037305998)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur minimale sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101579532937305998)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476506117305920)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur de d\00E9but sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476444556305919)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478586425305921)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir une courte info-bulle personnalis\00E9e descriptive sur les points de donn\00E9es du graphique. Pour afficher une info-bulle sur les points de donn\00E9es d''un graphique, assurez-vous que l''attribut d''info-b')
||unistr('ulle du graphique <strong>Afficher</strong> est d\00E9fini sur <strong>Activ\00E9</strong>. Pour les bo\00EEtes \00E0 moustaches, la colonne ne doit pas correspondre au mapping de colonne de la valeur s\00E9lectionn\00E9e. La s\00E9lection d''une colonne qui correspond au mappin')
||unistr('g de colonne de la valeur emp\00EAchera l''affichage de l''info-bulle personnalis\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478400001305921)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Info-bulle personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477594368305920)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur cible sur ce graphique. Lorsque cette option est d\00E9finie, l''attribut de valeur d\00E9finit la zone remplie dans le secteur, ce qui repr\00E9sente la valeur du secteur entier. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477416768305920)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur cible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475919032305919)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la valeur sur ce graphique. Pour les bo\00EEtes \00E0 moustaches, vous pouvez utiliser cette colonne pour d\00E9finir les valeurs minimales, m\00E9dianes et maximales ainsi que les quartiles de l''ensemble de don')
||unistr('n\00E9es num\00E9riques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475879769305919)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476974218305920)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur de volume sur ce graphique. Lorsque des valeurs sont indiqu\00E9es, le volume est affich\00E9 sur l''axe Y2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101476805465305920)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Volume'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477166901305920)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur X sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477080119305920)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477334923305920)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la valeur Y sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101477286646305920)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'O'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474730495305918)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la valeur Z sur le graphique. La valeur Z d\00E9finit le rayon des bulles pour un graphique \00E0 bulles, la largeur d''un \00E9l\00E9ment de bo\00EEte \00E0 moustaches, et la largeur des barres pour un graphique \00E0 barre')
||unistr('s ou combin\00E9. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474668282305918)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286238012305777)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez d''afficher les composants de r\00E9gion (sous-r\00E9gions, \00E9l\00E9ments, boutons) au-dessus ou en dessous du contenu de la r\00E9gion principale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718418504306107)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'fr'
,p_message_text=>'Au-dessus du contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718531233306107)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'fr'
,p_message_text=>'Au-dessous du contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286102250305777)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Composants d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220856340305729)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de cet \00E9l\00E9ment. Les noms d''\00E9l\00E9ment doivent \00EAtre des identificateurs Oracle valides et ne pas exc\00E9der 30 octets afin qu''ils puissent \00EAtre utilis\00E9s comme variables attach\00E9es dans les requ\00EAtes SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220766114305728)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432115801305886)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indiquez le mode d''affichage de cette colonne. Les types de colonne suivants sont pris en charge :</p>',
'#NATIVE_PLUGINS#',
unistr('<p>En fonction de la configuration de votre application, il se peut que des modules d''extension suppl\00E9mentaires de type Colonne soient \00E9galement disponibles ici.'),
'Ces derniers apparaissent sous la forme <em>&lt;Mon module d''extension&gt; [Module d''extension]</em>.',
unistr('Les modules d''extension suivants sont install\00E9s dans les composants partag\00E9s de cette application :</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220474694305728)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez comment cet \00E9l\00E9ment est affich\00E9. Les types d''\00E9l\00E9ment suivants sont pris en charge :</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En fonction de la configuration de l''application, des modules d''extension suppl\00E9mentaires de type d''\00E9l\00E9ment peuvent \00EAtre disponibles ici.'),
unistr('Ceux-ci sont affich\00E9s au format <em>&lt;Mon module d''extension&gt; [Module d''extension]</em>.'),
unistr('Les modules d''extension suivants sont install\00E9s dans les composants partag\00E9s de cette application :</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220346648305728)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879800279306232)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900997000306248)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Incluez l''\00E9l\00E9ment dans la v\00E9rification des modifications non enregistr\00E9es si la v\00E9rification est activ\00E9e au niveau de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879353979306232)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si l''\00E9l\00E9ment de page est inclus dans la v\00E9rification des modifications non enregistr\00E9es, qui avertit l''utilisateur lorsqu''il essaie de quitter la page alors qu''elle contient des modifications non enregistr\00E9es. Certains \00E9l\00E9ments n''ont peut-\00EAt')
||unistr('re pas besoin d''\00EAtre v\00E9rifi\00E9s (par exemple, s''ils ne reposent pas sur une colonne de base de donn\00E9es, tels qu''un \00E9l\00E9ment de recherche) et doivent donc pouvoir \00EAtre ignor\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879449299306232)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'fr'
,p_message_text=>'Ignorer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101882294813306234)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les modifications apport\00E9es \00E0 l''\00E9l\00E9ment sont ignor\00E9es par la v\00E9rification des modifications non enregistr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879257070306232)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertir des modifications non enregistr\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024101649306350)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442634769305894)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez une fonction JavaScript qui prend un objet de configuration pour la grille interactive, modifie l''objet et le renvoie. Cela permet d''effectuer une personnalisation avanc\00E9e de l''apparence, des fonctionnalit\00E9s et du comportement de la grille int')
||'eractive, y compris la barre d''outils, les menus et actions.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024255192306350)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578972274305997)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une fonction JavaScript qui prend un objet de configuration pour la colonne, modifie l''objet et le renvoie. Cela permet d''effectuer une personnalisation avanc\00E9e de l''apparence, des fonctionnalit\00E9s et du comportement de la colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024335238306350)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
unistr('    // Configuration d''une fonction callback qui est appel\00E9e lorsque les donn\00E9es sont extraites, permettant de manipuler la s\00E9rie'),
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
unistr('    // D\00E9finition des options d''initialisation de graphique'),
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488362719305928)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>'<p>Saisissez un code JavaScript pour personnaliser le graphique.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024960150306350)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422657647305879)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez une fonction JavaScript qui prend un objet de configuration pour le composant, modifie l''objet et le renvoie. Cela permet d''effectuer une personnalisation avanc\00E9e de l''apparence, des fonctionnalit\00E9s et du comportement du composant.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101422579558305879)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code d''initialisation JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793672633306164)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez la position des axes majeurs et mineurs sur le graphique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794374648306164)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794255856306164)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793536965306163)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position d''axe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797199232306166)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''\00E9chelle de temps \00E0 utiliser pour l''axe sur le graphique. Cela est obligatoire pour afficher correctement le graphique de Gantt. L''\00E9chelle de temps choisie est utilis\00E9e pour le zoom lorsque aucune option d''\00E9chelle de zoom n''est s\00E9lectionn\00E9e')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795258943306165)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'fr'
,p_message_text=>'Jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795126106306165)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'fr'
,p_message_text=>'Heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794814054306164)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'fr'
,p_message_text=>'Minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795693964306165)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'fr'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795833746306165)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'fr'
,p_message_text=>'Trimestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794735685306164)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'fr'
,p_message_text=>'Secondes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795427224306165)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'fr'
,p_message_text=>'Semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796065616306165)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797089076306166)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Echelle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463304528305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de graphique. Le type de graphique d\00E9termine la visualisation utilis\00E9e pour afficher le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463484364305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'fr'
,p_message_text=>'En aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604106217306016)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques en aires permettent de comparer les tendances de valeurs cumul\00E9es dans le temps, comme les r\00E9partitions de tendances des ventes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463580767305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'fr'
,p_message_text=>'Barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604214860306016)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques \00E0 barres permettent de comparer des valeurs dans des cat\00E9gories ou dans le temps.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385077559305851)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte \00E0 moustaches')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385163992305851)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les bo\00EEtes \00E0 moustaches sont utiles pour analyser la distribution de donn\00E9es, afficher les valeurs minimales, m\00E9dianes et maximales ainsi que les quartiles de groupes de donn\00E9es num\00E9riques. Les bo\00EEtes \00E0 moustaches sont \00E9galement appel\00E9es diagrammes e')
||unistr('n bo\00EEte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463669983305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'fr'
,p_message_text=>'Bulle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604395964306016)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques \00E0 bulles d\00E9finissent des \00E9l\00E9ments de donn\00E9es \00E0 l''aide des valeurs X, Y et Z, ce qui permet de visualiser les relations entre 3 dimensions. La troisi\00E8me dimension est repr\00E9sent\00E9e par la taille de la bulle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463769615305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Combin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604413727306016)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques combin\00E9s permettent d''afficher des s\00E9ries de barres, de courbes et d''aires sur le m\00EAme graphique. Le cas d''emploi le plus courant consiste \00E0 combiner courbes et barres, ou courbes et barres empil\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463885775305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'fr'
,p_message_text=>'Jauge de compteur de statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604596842306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'fr'
,p_message_text=>'Les jauges de compteur de statut permettent d''afficher une valeur de mesure par rapport aux valeurs minimale et maximale possibles pour cette mesure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498989486305936)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'fr'
,p_message_text=>'Anneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604643250306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques en anneau sont des graphiques \00E0 secteurs avec un trou au milieu. Ils permettent de visualiser les parties d''un ensemble.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463935787305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'fr'
,p_message_text=>'En entonnoir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604794023306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques en entonnoir permettent de visualiser des donn\00E9es pour les \00E9tapes d''un processus, telles que les \00E9tapes d''un processus de vente. La zone d''un secteur d''entonnoir est proportionnelle \00E0 la valeur de l''\00E9tape correspondante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794086206306164)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'fr'
,p_message_text=>'Graphique de Gantt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794181997306164)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques de Gantt sont utiles pour afficher les plannings de projets, avec des barres qui indiquent les dates de d\00E9but et de fin des t\00E2ches.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464065150305911)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604860655306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques \00E0 courbes permettent de visualiser des tendances dans un ensemble de valeurs dans le temps et de comparer ces valeurs dans des s\00E9ries.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464150413305911)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes avec aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604959010306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques \00E0 courbes avec aires sont identiques aux graphiques \00E0 courbes, mais l''aire en dessous de chaque courbe est remplie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464213140305911)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'fr'
,p_message_text=>'A secteurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605074722306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques \00E0 secteurs permettent de visualiser les parties d''un ensemble.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498682236305935)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'fr'
,p_message_text=>'Polaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605141399306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques polaires ont un axe des Y radial et un axe des X tangentiel. Les graphiques polaires peuvent \00EAtre affich\00E9s sous forme de types de s\00E9rie de graphiques \00E0 barres, \00E0 courbes, en aires, combin\00E9s, en nuage de points ou \00E0 bulles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297609497305785)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'fr'
,p_message_text=>'Pyramide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297767404305785)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques en pyramide sont utiles pour visualiser des relations hi\00E9rarchiques, proportionnelles et reposant sur la structure de base, des \00E9tapes de processus, des couches organisationnelles ou des interconnexions de sujets. La zone d''une portion')
||unistr(' de pyramide est proportionnelle \00E0 sa valeur pour la phase correspondante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498782781305936)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'fr'
,p_message_text=>'Radar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605244814306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques de type Radar sont des graphiques polaires dont la forme de grille est polygonale plut\00F4t que circulaire. Ils sont pris en charge pour les types de s\00E9rie de graphique \00E0 courbes et en aires.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498868492305936)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605388553306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques \00E0 plages affichent les valeurs maximale et minimale (sup\00E9rieure/inf\00E9rieure) pour chaque entr\00E9e, \00E0 l''aide de barres ou d''aires.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464366427305911)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'fr'
,p_message_text=>'En nuage de points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605449014306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques en nuage de points d\00E9finissent des \00E9l\00E9ments de donn\00E9es \00E0 l''aide des valeurs X et Y, ce qui permet de visualiser les relations entre 2 dimensions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464442011305911)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'fr'
,p_message_text=>'Boursier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605559078306017)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les graphiques boursiers permettent d''afficher des informations relatives \00E0 une action sur un axe temporel. La propri\00E9t\00E9 d''<strong>affichage de l''action</strong> en chandelier est sp\00E9cifique des graphiques boursiers, et permet d''afficher des informat')
||unistr('ions sur les valeurs de d\00E9but, de fin, sup\00E9rieures et inf\00E9rieures pour le cours de l''action.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101463250494305910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402072803305864)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les intervalles de vos donn\00E9es de graphique \00E0 plusieurs s\00E9ries doivent \00EAtre d\00E9finis sur la valeur z\00E9ro ou sur NULL.</p>'),
unistr('        <p>Lorsque la valeur est <strong>Activ\00E9</strong>, les intervalles des donn\00E9es sont consid\00E9r\00E9s comme des z\00E9ros. Pour un graphique \00E0 courbes, cela garantit que la ligne est affich\00E9e sous la forme d''une ligne continue. Pour un graphique \00E0 barres')
||unistr(' empil\00E9es dont l''option Libell\00E9 de pile est d\00E9finie sur Activ\00E9, cela garantit que le libell\00E9 de pile est affich\00E9 pour chaque pile.</p>'),
unistr('        <p>Lorsque la valeur est <strong>D\00E9sactiv\00E9</strong>, les intervalles des donn\00E9es sont consid\00E9r\00E9s comme NULL. Pour un graphique \00E0 courbes, la ligne sera affich\00E9e sous la forme d''une ligne discontinue, avec des vides repr\00E9sentant les points de ')
||unistr('donn\00E9es NULL.</p>'),
unistr('        <p>Ce param\00E8tre sera appliqu\00E9 aux types de graphique \00E0 plusieurs s\00E9ries qui prennent en charge l''affichage sous forme de lignes, tels que les graphiques lin\00E9aires, \00E0 courbes avec aires, combin\00E9s, \00E0 aires, polaires, radar et en nuage de points')
||unistr('. La valeur par d\00E9faut est <strong>Activ\00E9</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101401913297305864)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher l''intervalle sous la forme d''un z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466339042305912)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si le curseur de donn\00E9es est activ\00E9 sur le graphique.'),
unistr('        Le curseur de donn\00E9es est une alternative aux info-bulles utile lorsque l''acc\00E8s aux \00E9l\00E9ments de donn\00E9es est difficile, en particulier sur les appareils tactiles.<p/>'),
unistr('        <p/>Si la valeur <strong>Automatique</strong> est d\00E9finie, le curseur de donn\00E9es ne s''affiche que pour les graphiques \00E0 courbes ou en aires sur les appareils tactiles.<p/>'),
unistr('        <p>Remarque : le curseur de donn\00E9es n''est pas affich\00E9 lorsque l''info-bulle est NULL, et n''est pas pris en charge sur les graphiques polaires.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466455227305912)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101605961267306018)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Appliquez l''affichage du curseur de donn\00E9es par d\00E9faut d\00E9fini par Oracle JET pour le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466681594305912)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606128889306018)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le curseur de donn\00E9es n''est pas affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466596710305912)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606025742306018)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le curseur de donn\00E9es est toujours affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466212302305912)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Curseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466811466305913)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le comportement du curseur de donn\00E9es sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466949955305913)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596485221306010)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Appliquez le comportement de curseur de donn\00E9es par d\00E9faut d\00E9fini par Oracle JET pour le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467011326305913)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'fr'
,p_message_text=>'Lisser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606237353306018)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le curseur de donn\00E9es suit sans \00E0-coups le mouvement de la souris/l''effleurement, affichant l''info-bulle \00E0 chaque fois que le curseur de donn\00E9es passe sur une partie d''un \00E9l\00E9ment de donn\00E9es, et pas seulement sur des points de donn\00E9es sp\00E9cifiques. ')
||unistr('Un indicateur identifie l''\00E9l\00E9ment de donn\00E9es actuellement s\00E9lectionn\00E9.</p>'),
unistr('        <p>Remarque : d\00E9finissez <strong>Curseur</strong> sur <strong>Oui</strong> pour que cette visualisation fonctionne correctement.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467168582305913)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'fr'
,p_message_text=>'Ancrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606300719306018)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le curseur de donn\00E9es suit (acc\00E8de \00E0) un \00E9l\00E9ment de donn\00E9es lorsque vous effectuez un mouvement de souris/d''effleurement sur le graphique, affichant l''info-bulle \00E0 chaque fois que le curseur de donn\00E9es passe sur un \00E9l\00E9ment de donn\00E9es. Un indicateu')
||unistr('r identifie l''\00E9l\00E9ment de donn\00E9es actuellement s\00E9lectionn\00E9.</p>'),
unistr('        <p>Remarque : d\00E9finissez <strong>Curseur</strong> sur <strong>Oui</strong> pour que cette visualisation fonctionne correctement.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101466736080305912)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Comportement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316660669305801)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les intervalles de vos donn\00E9es de graphique \00E0 plusieurs s\00E9ries doivent \00EAtre remplis automatiquement. Ce param\00E8tre ne s''applique pas aux graphiques \00E0 s\00E9rie unique ou aux types de graphique suivants : \00E0 bulles, en anneau, en entonnoir, Gant')
||unistr('t, \00E0 secteurs, en pyramide, en nuage de points et boursier. Avec la valeur <strong>Activ\00E9</strong>, la logique de densification des donn\00E9es introduite dans Oracle Application Express 5.1.3 sera appliqu\00E9e aux donn\00E9es de graphique. Avec la valeur <stro')
||unistr('ng>D\00E9sactiv\00E9</strong>, les intervalles de donn\00E9es ne seront pas remplis et risquent d''engendrer un affichage inexact du graphique. La valeur par d\00E9faut est <strong>Activ\00E9</strong>.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316524686305801)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Remplir les intervalles dans les donn\00E9es de graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030557255306354)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Saisissez des classes CSS \00E0 appliquer aux barres de r\00E9f\00E9rence sur le graphique de Gantt. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces. Vous pouvez utiliser des substitutions <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030452236306354)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800721557306169)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de fin de r\00E9f\00E9rence du graphique de Gantt. La date de fin de r\00E9f\00E9rence correspond \00E0 la date de fin initialement planifi\00E9e pour la t\00E2che.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800608871306169)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de fin de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800512709306169)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de d\00E9but de r\00E9f\00E9rence du graphique de Gantt. La date de d\00E9but de r\00E9f\00E9rence correspond \00E0 la date de d\00E9but initialement planifi\00E9e pour la t\00E2che.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800412832306169)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798909118306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de fin du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798898081306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799184686306168)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application \00E0 utiliser pour d\00E9finir la date de fin du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799097546306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de date de fin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798180796306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source \00E0 utiliser pour d\00E9finir la date de fin du graphique de Gantt. Une date de fin est obligatoire pour afficher correctement le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798393756306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798472891306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de colonne saisie dans <em>Colonne de date de fin</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798693544306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798750363306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment de date de fin</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798243133306167)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de source de date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800916029306169)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la progression de la t\00E2che sur le graphique de Gantt. La valeur de la progression doit \00EAtre comprise entre 0 et 1. Si elle n''est pas valide, aucune progression n''est affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800828208306169)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Progression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030396659306354)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Saisissez des classes CSS \00E0 appliquer aux barres de progression sur le graphique de Gantt. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces. Vous pouvez utiliser des substitutions <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030208007306354)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS de progression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799319150306168)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir l''ID de ligne sur le graphique de Gantt. Un ID de ligne est obligatoire pour afficher plusieurs t\00E2ches par ligne. Lorsqu''aucun mapping de colonne d''ID de ligne n''est d\00E9fini, le graphique affiche ')
||unistr('une seule t\00E2che par ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799229420306168)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'ID de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799598856306168)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir le nom de ligne sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799456162306168)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798051152306167)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de d\00E9but du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797960987306167)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807542576306174)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application \00E0 utiliser pour d\00E9finir la date de d\00E9but du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101798559690306167)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794526707306164)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source \00E0 utiliser pour d\00E9finir la date de d\00E9but du graphique de Gantt. Une date de d\00E9but est obligatoire pour afficher correctement le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797379982306166)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797474818306166)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de colonne saisie dans <em>Colonne de date de d\00E9but</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797522341306166)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101797670410306166)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment de date de d\00E9but</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794430271306164)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de source de date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030114221306354)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Saisissez des classes CSS \00E0 appliquer aux barres de t\00E2che sur le graphique de Gantt. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces. Vous pouvez utiliser des substitutions <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030013926306354)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS de t\00E2che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800311620306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de fin de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800201965306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de fin de t\00E2che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799783880306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir l''ID de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799624499306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de t\00E2che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799937169306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir le nom de la t\00E2che sur le graphique de Gantt. Lorsqu''aucun mapping de colonne de nom de ligne n''est d\00E9fini, le nom de la t\00E2che sera utilis\00E9 comme libell\00E9 de ligne sur l''axe des lignes du graphiqu')
||'e. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101799838251306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de t\00E2che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800119935306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de d\00E9but de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101800098855306168)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but de t\00E2che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010767314306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de fin de lucarne du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005775806306336)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010891958306340)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application \00E0 utiliser pour d\00E9finir la date de fin de lucarne du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005543266306335)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de date de fin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010409988306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source \00E0 utiliser pour d\00E9finir la date de fin de la lucarne du graphique de Gantt. Une lucarne est une plage de dates qui, une fois d\00E9finie, peut contr\00F4ler le zoom initial d''un graphique lorsqu''il est affich\00E9. Le graphique appara\00EEt al')
||unistr('ors avec la plage de dates indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005988911306336)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010581326306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de colonne saisie dans <em>Colonne de date de fin</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006180865306336)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010662972306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment de date de fin</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005453460306335)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de source de date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010226278306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de colonne \00E0 utiliser pour d\00E9finir la date de d\00E9but de lucarne du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005620100306335)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010318957306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application \00E0 utiliser pour d\00E9finir la date de d\00E9but de lucarne du graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005327436306335)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009978242306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source \00E0 utiliser pour d\00E9finir la date de d\00E9but de la lucarne du graphique de Gantt. Une lucarne est une plage de dates qui, une fois d\00E9finie, peut contr\00F4ler le zoom initial d''un graphique lorsqu''il est affich\00E9. Le graphique appara\00EEt ')
||unistr('alors avec la plage de dates indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005889450306336)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010066980306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de colonne saisie dans <em>Colonne de date de d\00E9but</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102006036747306336)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102010139752306339)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment de date de d\00E9but</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102005273921306335)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de source de date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909592707305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez en degr\00E9s l''\00E9tendue de l''angle pour le graphique Jauge de compteur de statut avec orientation circulaire. L''\00E9tendue de l''angle est un angle r\00E9el de l''orientation circulaire. Les valeurs positives indiquent un angle dans le sens des aiguille')
||unistr('s d''une montre et les valeurs n\00E9gatives indiquent un angle dans le sens inverse des aiguilles d''une montre. Vous pouvez tracer votre jauge circulaire \00E0 l''angle de votre choix et modifier sa forme en fonction de ce dernier. La forme de la jauge d\00E9pend')
||unistr(' de 2 param\00E8tres : <strong>Angle de d\00E9but</strong> et <strong>Etendue de l''angle</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909380210305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Etendue de l''angle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908942729305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le rapport d''\00E9paisseur relative de l''indicateur vers la zone de trac\00E9. La valeur par d\00E9faut est 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908815962305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille d''indicateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909002415305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le rayon interne d''un graphique Jauge de compteur de statut avec une orientation circulaire, d\00E9fini par la distance entre le centre de la jauge et le bord le plus int\00E9rieur de l''indicateur et de la zone de trac\00E9. Les valeurs valides sont un ')
||unistr('pourcentage ou un rapport allant de 0 \00E0 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909182035305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Rayon int\00E9rieur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908524169305471)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de graphique Jauge de compteur de statut \00E0 afficher.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908254047305471)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'fr'
,p_message_text=>'Circulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908388548305471)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'fr'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908476276305471)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'fr'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908127552305471)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908769259305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la zone de trac\00E9 d''un graphique Jauge de compteur de statut doit \00EAtre affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100908673753305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher la zone de trac\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101022931259305563)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919181658305479)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la couleur \00E0 afficher pour la zone de trac\00E9 d''un graphique Jauge de compteur de statut. Vous pouvez utiliser des substitutions <code>&COLUMN_VALUE.</code>. Cette couleur s''applique uniquement lorsque les couleurs de seuil n''ont pas \00E9t\00E9 d\00E9fi')
||'nies pour le graphique</p>',
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919027162305479)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur de la zone de trac\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909401374305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez en degr\00E9s l''angle de d\00E9but du graphique Jauge de compteur de statut avec orientation circulaire. Les valeurs positives indiquent un angle de d\00E9but dans le sens des aiguilles d''une montre et les valeurs n\00E9gatives, un angle de d\00E9but dans le s')
||unistr('ens inverse des aiguilles d''une montre. Vous pouvez tracer votre jauge circulaire \00E0 l''angle de votre choix et modifier sa forme en fonction de ce dernier. La forme de la jauge d\00E9pend de 2 param\00E8tres : <strong>Angle de d\00E9but</strong> et <strong>Etendu')
||'e de l''angle</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909287473305472)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Angle de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793968742306164)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les lignes de grille horizontales doivent \00EAtre affich\00E9es sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793270005306163)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher la grille horizontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467379231305913)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le comportement \00E0 appliquer lorsque vous passez le pointeur de la souris sur des \00E9l\00E9ments de donn\00E9es dans le graphique.<p/>'),
unistr('        S\00E9lectionnez <strong>Activ\00E9</strong> pour estomper tous les \00E9l\00E9ments de donn\00E9es tant que le pointeur de la souris ne passe pas dessus et mettre en \00E9vidence uniquement l''\00E9l\00E9ment de donn\00E9es sur lequel le pointeur de la souris est positionn\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467222617305913)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Estomper au passage du curseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055019837306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le zoom initial du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055168101306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'fr'
,p_message_text=>'Premier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055228236306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Zoomez initialement sur les premiers points de donn\00E9es qui peuvent tenir dans la zone de trac\00E9 du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055385813306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'fr'
,p_message_text=>'Dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055467390306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Zoomez initialement sur les derniers points de donn\00E9es qui peuvent tenir dans la zone de trac\00E9 du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055546492306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055626676306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Permet de d\00E9sactiver le zoom initial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054933199306373)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Zoom initial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440540922305892)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183279720305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher la police de l''attribut indiqu\00E9.</p>'),
unistr('<p>La couleur est sp\00E9cifi\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et ')
||unistr('zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180243527305680)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181861239305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la famille de polices.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180496494305680)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'fr'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180307762305680)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'fr'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180530877305680)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180645174305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'fr'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180829331305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'fr'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180745730305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180909070305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'fr'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181082049305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9orgie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181119293305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181241823305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'fr'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181388339305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'fr'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181519170305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181442300305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181652157305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'fr'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181763009305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'fr'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179950785305680)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Famille de polices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182397566305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la taille de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182523876305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'fr'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182681691305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'fr'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182728131305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'fr'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182881440305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'fr'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182982954305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'fr'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183070919305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'fr'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183112301305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'fr'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182471317305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'fr'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180142156305680)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101181968561305681)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le style de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182149244305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'fr'
,p_message_text=>'Italique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182082447305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101182217288305682)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'fr'
,p_message_text=>'Oblique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101180012771305680)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100990954266305537)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la mani\00E8re dont les libell\00E9s doivent \00EAtre affich\00E9s sur les secteurs du graphique \00E0 secteur. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034536534306357)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 - Pourcentage (Valeur)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035066682306358)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Les libell\00E9s affichent les informations de libell\00E9, de valeur et de pourcentage au format suivant : libell\00E9 - pourcentage (valeur). Par exemple, <strong>Bugs - 15 % (18)</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034630372306357)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage (valeur)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035138235306358)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Les libell\00E9s s''affichent sous forme de valeurs num\00E9riques, en fonction du mapping de colonne de la valeur s\00E9lectionn\00E9e. Par exemple, <strong>15 % (18)</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034200382306357)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034783964306358)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Les libell\00E9s s''affichent sur les secteurs du graphique, en fonction du mapping de colonne du libell\00E9 s\00E9lectionn\00E9. Par exemple, <strong>Bugs</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378813354305847)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 - Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378954618305847)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Les libell\00E9s affichent les informations de libell\00E9 et de valeur au format suivant : libell\00E9 - valeur. Par exemple, <strong>Bugs - 18</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034336720306357)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034819441306358)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Les libell\00E9s s''affichent sous forme de valeurs comprises entre 0 % et 100 %, en fonction du mapping de colonne de la valeur s\00E9lectionn\00E9e. La valeur est un pourcentage du total des valeurs repr\00E9sent\00E9es sur le graphique. Par exemple, <strong>15 %</s')
||'trong>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034416673306357)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034906198306358)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Les libell\00E9s s''affichent sous forme de valeurs num\00E9riques, en fonction du mapping de colonne de la valeur s\00E9lectionn\00E9e.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034118932306357)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher en tant que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440469751305892)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177249199305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher la police de l''attribut indiqu\00E9.</p>'),
unistr('<p>La couleur est sp\00E9cifi\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et ')
||unistr('zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176880458305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176922914305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la famille de polices.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177448080305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'fr'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177317460305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'fr'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177511244305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177655638305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'fr'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177872902305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'fr'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177744676305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177999565305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'fr'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178004552305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9orgie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178157291305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178223149305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'fr'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178307942305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'fr'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178505583305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178432922305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178601978305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'fr'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178783669305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'fr'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176516544305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Famille de polices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177101910305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la taille de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179204456305680)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'fr'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179342714305680)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'fr'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179467819305680)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'fr'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179553317305680)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'fr'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179692798305680)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'fr'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179762636305680)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'fr'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179878565305680)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'fr'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179146387305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'fr'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176790306305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101177047021305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le style de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178945139305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'fr'
,p_message_text=>'Italique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101178877393305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101179037559305679)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'fr'
,p_message_text=>'Oblique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176607900305678)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026789218305566)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Une liste de couleurs s\00E9par\00E9es par des virgules :</dt>'),
'<dd><pre>',
'<strong>rouge,jaune,bleu</strong>',
'</pre></dd>',
unistr('<dt>Une liste d''\00E9l\00E9ments de page ou d''application s\00E9par\00E9s par des virgules, renvoyant des couleurs, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>. Par exemple, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Une liste de colonnes s\00E9par\00E9es par des virgules, renvoyant des couleurs, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>. Par exemple, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026659743305565)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez les couleurs \00E0 utiliser pour identifier les lignes de r\00E9f\00E9rence \00E0 afficher sur un graphique Jauge de compteur de statut.'),
unistr('En cas de lignes de r\00E9f\00E9rence multiples, utilisez une liste s\00E9par\00E9e par des virgules.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026344098305565)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026549549305565)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Une liste de valeurs num\00E9riques statiques s\00E9par\00E9es par des virgules :</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Une liste d''\00E9l\00E9ments de page ou d''application s\00E9par\00E9s par des virgules, renvoyant des valeurs num\00E9riques, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>. Par exemple, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Une liste de colonnes s\00E9par\00E9es par des virgules, renvoyant des valeurs num\00E9riques, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>. Par exemple, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026421320305565)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez les nombres \00E0 utiliser pour identifier les lignes de r\00E9f\00E9rence \00E0 afficher sur un graphique Jauge de compteur de statut.'),
unistr('En cas de lignes de r\00E9f\00E9rence multiples, utilisez une liste s\00E9par\00E9e par des virgules.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101026266445305565)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793747582306164)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les libell\00E9s de ligne doivent \00EAtre affich\00E9s sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793413047306163)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''axe de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478806216305921)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478742283305921)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la couleur \00E0 afficher pour les \00E9l\00E9ments de donn\00E9es associ\00E9s \00E0 cette s\00E9rie de graphiques. Vous pouvez utiliser des substitutions <code>&COLUMN_VALUE.</code> Pour un graphique Jauge de compteur de statut, cette couleur sera appliqu\00E9e \00E0 l''indi')
||unistr('cateur, sauf lorsque les seuils ont \00E9t\00E9 d\00E9finis et que l''attribut <strong>Affichage du seuil</strong> est d\00E9fini sur la valeur <strong>Sur l''indicateur</strong>.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478629407305921)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404639843305866)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404453872305865)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la couleur \00E0 afficher pour le segment q2 de la s\00E9rie de graphiques Bo\00EEte \00E0 moustaches. Vous pouvez utiliser des substitutions <code>&COLUMN_VALUE.</code>.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404232454305865)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur Q2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404741230305866)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404568896305865)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la couleur \00E0 afficher pour le segment q3 de la s\00E9rie de graphiques Bo\00EEte \00E0 moustaches. Vous pouvez utiliser des substitutions <code>&COLUMN_VALUE.</code>.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101404317230305865)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur Q3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101399527822305862)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de s\00E9rie de graphiques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386483882305852)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'fr'
,p_message_text=>'En aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386548959305852)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'fr'
,p_message_text=>'Barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386319904305852)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte \00E0 moustaches')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386607115305852)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386725320305852)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes avec aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386865108305852)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500827195305937)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mapping de colonne de type de s\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501000845305937)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de s\00E9rie du graphique. Vous pouvez \00E9galement cr\00E9er un graphique associant diff\00E9rents types de s\00E9rie sur le m\00EAme ensemble de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501182194305937)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'fr'
,p_message_text=>'En aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501673448305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage d''aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501249167305937)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'fr'
,p_message_text=>'Barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501510245305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage de barres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501347081305937)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501422599305937)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes avec aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500919011305937)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502266403305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de s\00E9rie de graphiques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502336380305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'fr'
,p_message_text=>'En aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502975875305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage d''aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502437252305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'fr'
,p_message_text=>'Barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502833310305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage de barres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502798263305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'fr'
,p_message_text=>'Bulle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502505191305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790019166306161)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes avec aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502693732305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'fr'
,p_message_text=>'En nuage de points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502181238305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503104093305939)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de s\00E9rie de graphiques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503222899305939)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'fr'
,p_message_text=>'En aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503324594305939)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage d''aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503492271305939)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101503073246305939)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501850131305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de s\00E9rie de graphiques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101502006380305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage d''aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501982633305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'fr'
,p_message_text=>'Plage de barres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101501718442305938)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483987698305925)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si l''axe est affich\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101483820590305925)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''axe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025262532305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les informations de r\00E9f\00E9rence doivent \00EAtre affich\00E9es dans l''info-bulle sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024657481305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher la valeur de r\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025077913305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la date de fin doit \00EAtre affich\00E9e dans l''info-bulle sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024438785305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher la date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025150912305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la progression doit \00EAtre affich\00E9e dans l''info-bulle sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024519069305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher la progression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024777913305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les informations de ligne doivent \00EAtre affich\00E9es dans l''info-bulle sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024185864305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher la ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024910532305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la date de d\00E9but doit \00EAtre affich\00E9e dans l''info-bulle sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024323635305564)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher la date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909729937305473)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la valeur doit \00EAtre affich\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100909639175305472)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024813021305564)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le libell\00E9 doit \00EAtre affich\00E9 dans l''info-bulle sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101024206419305564)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher le libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472123862305916)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si une info-bulle doit \00EAtre affich\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472021261305916)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472757683305917)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si des valeurs doivent \00EAtre affich\00E9es dans l''info-bulle sur votre graphique. Les valeurs sont d\00E9riv\00E9es de votre requ\00EAte de graphique et sont affich\00E9es en regard des donn\00E9es du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472641624305917)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807466185306174)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''ordre de tri des donn\00E9es dans un graphique \00E0 plusieurs s\00E9ries, en fonction de la valeur ou du libell\00E9 du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792032084306162)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 - Croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792451837306163)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez cette option pour trier le graphique par ordre croissant de libell\00E9s de l''axe X. Il s''agit de l''ordre de tri par d\00E9faut. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792152209306162)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 - D\00E9croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792596102306163)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez cette option pour trier le graphique par ordre d\00E9croissant de libell\00E9s de l''axe X. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791891602306162)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur - Croissante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792214203306162)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez cette option pour trier le graphique par ordre croissant de valeurs (1, 2, 3, etc.). N''utilisez ce param\00E8tre que pour les graphiques \00E0 secteurs, les graphiques \00E0 barres/courbes/zones \00E0 une s\00E9rie ou les graphiques \00E0 barres/zones empil\00E9es. L')
||unistr('e tri ne fonctionne pas si vous utilisez un axe de groupe hi\00E9rarchique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791978793306162)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur - D\00E9croissante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792318663306163)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez cette option pour trier le graphique par ordre d\00E9croissant de valeurs (10, 9, 8, etc.). N''utilisez ce param\00E8tre que pour les graphiques \00E0 secteurs, les graphiques \00E0 barres/courbes/zones \00E0 une s\00E9rie ou les graphiques \00E0 barres/zones empil\00E9es')
||unistr('. Le tri ne fonctionne pas si vous utilisez un axe de groupe hi\00E9rarchique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791753135306162)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Ordre de tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637255340306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637118932306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher la police de l''attribut indiqu\00E9.</p>'),
unistr('<p>La couleur est sp\00E9cifi\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et ')
||unistr('zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636767230306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636861429306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la famille de polices.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638555558306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'fr'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638456982306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'fr'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638626508306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638703201306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'fr'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638930589306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'fr'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638886111306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639075399306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'fr'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639194106306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9orgie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639293606306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639398156306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'fr'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639441936306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'fr'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639661067306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639545954306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639728837306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'fr'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639886670306042)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'fr'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636481333306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Famille de polices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637094309306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la taille de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637427873306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'fr'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637518526306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'fr'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637640902306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'fr'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637709216306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'fr'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637864940306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'fr'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637991112306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'fr'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638092661306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'fr'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101637362672306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'fr'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636609225306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636946000306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le style de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638224771306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'fr'
,p_message_text=>'Italique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638180990306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101638302514306041)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'fr'
,p_message_text=>'Oblique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636531931306040)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801143355306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la position des libell\00E9s de t\00E2che sur le graphique de Gantt.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801468775306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801899692306170)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le libell\00E9 de t\00E2che est affich\00E9 \00E0 la fin de la barre de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801515257306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Int\00E9rieur - Centre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801909912306170)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le libell\00E9 de t\00E2che est affich\00E9 \00E0 l''int\00E9rieur et au centre de la barre de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801708562306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Int\00E9rieur - Fin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802157177306170)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le libell\00E9 de t\00E2che est affich\00E9 \00E0 l''int\00E9rieur et \00E0 la fin de la barre de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801688682306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Int\00E9rieur - D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101802009379306170)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le libell\00E9 de t\00E2che est affich\00E9 \00E0 l''int\00E9rieur et au d\00E9but de la barre de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801282241306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801328448306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le libell\00E9 de t\00E2che est affich\00E9 au d\00E9but de la barre de t\00E2che sur le graphique de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101801035323306169)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de libell\00E9 de t\00E2che')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938049494305498)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Une liste de couleurs s\00E9par\00E9es par des virgules :</dt>'),
'<dd><pre>',
'<strong>rouge,jaune,bleu</strong>',
'</pre></dd>',
unistr('<dt>Une liste d''\00E9l\00E9ments de page ou d''application s\00E9par\00E9s par des virgules, renvoyant des couleurs, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>. Par exemple, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Une liste de colonnes s\00E9par\00E9es par des virgules, renvoyant des couleurs, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>. Par exemple, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937970867305498)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez les couleurs \00E0 utiliser pour identifier la limite sup\00E9rieure des seuils \00E0 afficher sur le graphique Jauge de compteur de statut.'),
unistr('En cas de seuils multiples, utilisez une liste s\00E9par\00E9e par des virgules.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919326740305480)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023001429305563)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la mani\00E8re dont les seuils doivent \00EAtre affich\00E9s sur le graphique Jauge de compteur de statut. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937464174305497)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'fr'
,p_message_text=>'Tout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937549215305497)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Tous les seuils, d\00E9finis \00E0 l''aide de l''attribut <strong>Valeurs de seuil</strong>, sont affich\00E9s dans la zone de trac\00E9 du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937706481305497)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'fr'
,p_message_text=>'Seuil en cours uniquement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937814693305498)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le seuil en cours, d\00E9fini \00E0 l''aide de l''attribut <strong>Valeurs de seuil</strong>, est affich\00E9 dans la zone de trac\00E9 du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937653598305497)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'fr'
,p_message_text=>'Sur l''indicateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023121058305563)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le seuil en cours, d\00E9fini \00E0 l''aide de l''attribut <strong>Valeurs de seuil</strong>, est affich\00E9 sur l''indicateur du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937384548305497)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100937264666305497)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Une liste de valeurs num\00E9riques statiques s\00E9par\00E9es par des virgules :</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Une liste d''\00E9l\00E9ments de page ou d''application s\00E9par\00E9s par des virgules, renvoyant des valeurs num\00E9riques, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code>. Par exemple, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Une liste de colonnes s\00E9par\00E9es par des virgules, renvoyant des valeurs num\00E9riques, \00E0 l''aide de la syntaxe :</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code>. Par exemple, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919226097305480)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez les nombres \00E0 utiliser pour identifier la limite sup\00E9rieure des seuils \00E0 afficher sur le graphique Jauge de compteur de statut.'),
unistr('En cas de seuils multiples, utilisez une liste s\00E9par\00E9e par des virgules.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918960873305479)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440373905305892)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176422397305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher la police de l''attribut indiqu\00E9.</p>'),
unistr('<p>La couleur est sp\00E9cifi\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et ')
||unistr('zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173496330305675)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175070018305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la famille de polices.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173629630305675)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'fr'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173573193305675)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'fr'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173707862305675)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173837140305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'fr'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174081357305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'fr'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173968992305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174182641305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'fr'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174246132305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9orgie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174333563305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174453784305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'fr'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174577405305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'fr'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174713561305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174695566305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174821307305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'fr'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101174964437305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'fr'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173153036305675)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Famille de polices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175511406305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la taille de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175729156305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'fr'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175815643305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'fr'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175990422305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'fr'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176056193305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'fr'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176109892305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'fr'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176292878305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'fr'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101176394612305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'fr'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175690649305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'fr'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173377384305675)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175193488305676)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le style de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175377547305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'fr'
,p_message_text=>'Italique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175224019305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101175484819305677)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'fr'
,p_message_text=>'Oblique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101173283433305675)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467524176305913)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type d''axe temporel \00E0 afficher sur le graphique. Ce param\00E8tre affichera automatiquement les donn\00E9es du graphique dans l''ordre chronologique et ne doit pas \00EAtre utilis\00E9 si vous voulez que vos donn\00E9es soient affich\00E9es dans l''ordre chron')
||unistr('ologique invers\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467658769305913)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596535667306010)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Appliquez le param\00E8tre d''axe temporel par d\00E9faut d\00E9fini par Oracle JET pour le graphique, en fonction des donn\00E9es en cours d''affichage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467727561305913)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596664024306011)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''appliquez aucun param\00E8tre de type d''axe temporel au graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467829388305913)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596792188306011)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Appliquez un param\00E8tre de type d''axe temporel au graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467977170305913)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Fr\00E9quence mixte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506872318305941)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs temporelles affich\00E9es sur l''axe du graphique sont en fr\00E9quence mixte. La valeur temporelle des donn\00E9es pouvant varier, l''empilage n''est pas pris en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506945208305941)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'fr'
,p_message_text=>'Ignorer les intervalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507053120305941)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs temporelles sur l''axe du graphique sont affich\00E9es \00E0 intervalles r\00E9guliers, ind\00E9pendamment de tout intervalle de temps pouvant exister dans les donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101467487973305913)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type d''axe temporel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440278346305892)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172604670305675)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher la police de l''attribut indiqu\00E9.</p>'),
unistr('<p>La couleur est sp\00E9cifi\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et ')
||unistr('zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172530208305675)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172250907305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la famille de polices.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170888907305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'fr'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170754973305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'fr'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170937054305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171002684305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'fr'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171246164305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'fr'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171194119305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171334177305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'fr'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171412375305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9orgie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171579434305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171607434305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'fr'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171739796305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'fr'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171952622305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101171884282305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172064705305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'fr'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172111948305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'fr'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169337895305672)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Famille de polices'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172406481305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la taille de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170012118305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'fr'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170180844305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'fr'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170290650305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'fr'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170309206305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'fr'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170414174305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'fr'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170523100305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'fr'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101170611721305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'fr'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169914934305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'fr'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169545271305672)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172311425305674)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le style de police.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169783900305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'fr'
,p_message_text=>'Italique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169613012305672)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169836046305673)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'fr'
,p_message_text=>'Oblique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169469729305672)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793879133306164)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les lignes de grille verticales doivent \00EAtre affich\00E9es sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793333200306163)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher la grille verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507856715305942)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le comportement en mati\00E8re de zoom et de d\00E9filement du graphique. Un comportement <strong>En temps r\00E9el</strong> signifie que le graphique est continuellement mis \00E0 jour lorsqu''il est manipul\00E9,'),
unistr('        tandis que <strong>Diff\00E9r\00E9</strong> signifie que la mise \00E0 jour est effectu\00E9e \00E0 la fin de l''action de zoom/d\00E9filement. Bien que le zoom et le d\00E9filement <strong>en temps r\00E9el</strong> fournissent la meilleure exp\00E9rience utilisateur final poss')
||'ible, il n''existe',
unistr('        aucune garantie quant aux performances d''affichage ou \00E0 l''utilisabilit\00E9 pour des ensembles de donn\00E9es volumineux ou des environnements de client lents. Si les performances posent probl\00E8me, utilisez plut\00F4t le zoom et le d\00E9filement <strong>diff')
||unistr('\00E9r\00E9s</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468142507305913)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le comportement en mati\00E8re de zoom et de d\00E9filement du graphique.'),
unistr('        Le zoom et le d\00E9filement permettent \00E0 l''utilisateur final d''effectuer des op\00E9rations, comme faire glisser un \00E9l\00E9ment vers la zone de trac\00E9, en utilisant la roulette de la souris ou en pin\00E7ant deux doigts sur l''\00E9cran, en vue de redimensionner ')
||unistr('les valeurs affich\00E9es et de parcourir le graphique pour afficher d''autres valeurs de graphique.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468387378305914)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Diff\00E9r\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547562869305973)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La modification de l''affichage des donn\00E9es est appliqu\00E9e \00E0 la fin de l''action de zoom/d\00E9filement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468423089305914)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9filement diff\00E9r\00E9 uniquement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547664818305973)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La modification de l''affichage des donn\00E9es est appliqu\00E9e \00E0 la fin de l''action de d\00E9filement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468571931305914)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En temps r\00E9el')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547754900305973)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le comportement en temps r\00E9el signifie que le graphique est continuellement mis \00E0 jour lorsqu''il est manipul\00E9.'),
unistr('        Pour les ensembles de donn\00E9es volumineux ou les environnements de client lents, il est recommand\00E9 de s\00E9lectionner <strong>Diff\00E9r\00E9</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468680307305914)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9filement en temps r\00E9el uniquement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547871843305973)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le comportement de d\00E9filement en temps r\00E9el uniquement signifie que le graphique est continuellement mis \00E0 jour lorsque l''utilisateur le fait d\00E9filer.'),
unistr('        Pour les ensembles de donn\00E9es volumineux ou les environnements de client lents, envisagez de s\00E9lectionner <strong>D\00E9filement diff\00E9r\00E9 uniquement</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468233199305914)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101547477947305973)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le zoom et le d\00E9filement sont d\00E9sactiv\00E9s pour le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468015506305913)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Zoom et d\00E9filement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012315916306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la direction du zoom du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012498724306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Les deux axes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012594763306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'fr'
,p_message_text=>'Effectue un zoom en direction des axes des X et des Y.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012672935306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'fr'
,p_message_text=>'Axe X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012738989306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'fr'
,p_message_text=>'Effectue un zoom uniquement en direction de l''axe des X.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012894389306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'Axe Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012942944306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'fr'
,p_message_text=>'Effectue un zoom uniquement en direction de l''axe des Y.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102012282232306341)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Direction du zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796513416306166)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des jours est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795328995306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796491061306166)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des heures est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795069451306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796394416306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des minutes est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794969783306164)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796782618306166)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des mois est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795738051306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796830900306166)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des trimestres est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795937427306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Trimestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796225213306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des secondes est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101794697833306164)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Secondes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796628185306166)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des semaines est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101795578542306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796935792306166)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un zoom \00E0 l''\00E9chelle des ann\00E9es est autoris\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101796148119306165)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600146508306013)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une condition c\00F4t\00E9 client pour contr\00F4ler si l''action est d\00E9clench\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195201907305691)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifiez une condition c\00F4t\00E9 client pour contr\00F4ler si les actions True ou False se d\00E9clenchent. Si la condition'),
unistr('                                  a la valeur True, les actions True se d\00E9clenchent ; si la condition a la valeur False, les actions False se d\00E9clenchent.'),
unistr('                                  Si aucune condition n''est indiqu\00E9e, seules les actions True se d\00E9clenchent.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706387279306098)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063092060306378)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706577022306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment > Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063287100306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est sup\00E9rieure \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706661250306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment >= Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063304732306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est sup\00E9rieure ou \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707157327306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment dans la liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063846999306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 figure dans la <em>liste</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707377268306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064096411306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Evalue l''expression JavaScript indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706742948306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment < Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063429323306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est inf\00E9rieure \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706834638306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment <= Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063541783306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est inf\00E9rieure ou \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706459660306098)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063162748306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707234295306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment absent de la liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063967510306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 ne figure pas dans la <em>liste</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101707043142306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063738608306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706979222306099)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102063689410306379)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195170531305691)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064468002306379)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne utilis\00E9e dans cette condition.</p>'),
unistr('<p>Remarque : dans la majorit\00E9 des cas, il doit s''agir de la colonne indiqu\00E9e ci-dessus, dans <em>Colonne(s) sous Quand</em>,'),
unistr('et donc d\00E9finie par d\00E9faut. Cependant, vous pouvez baser la condition sur une autre colonne.'),
unistr('Par exemple, avec une grille interactive bas\00E9e sur la table EMP, si vous voulez d\00E9clencher une action dynamique'),
unistr('d\00E8s que <code>SAL</code> est modifi\00E9 mais uniquement si <code>JOB</code> est \00E9gal \00E0 <em>SALESMAN</em>, remplacez cet attribut par <code>JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059033467306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065718812306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez si un <em>\00E9l\00E9ment</em> ou une <em>colonne</em> est utilis\00E9 dans cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054556974306372)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054418696306372)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054365503306372)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600258624306013)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Saisissez l''\00E9l\00E9ment de page utilis\00E9 dans cette condition. Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600055646306013)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Saisissez l''\00E9l\00E9ment de page utilis\00E9 dans cette condition. Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064532049306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez l''\00E9l\00E9ment de page utilis\00E9 dans cette condition. Vous pouvez saisir son nom ou le choisir dans la liste des \00E9l\00E9ments disponibles.</p>'),
unistr('<p>Remarque : dans la majorit\00E9 des cas, il doit s''agir de l''\00E9l\00E9ment indiqu\00E9 ci-dessus, dans <em>El\00E9ments sous Quand</em>,'),
unistr('et donc d\00E9fini par d\00E9faut. Cependant, vous pouvez baser la condition sur un autre \00E9l\00E9ment de page. Par exemple,'),
unistr('avec un panneau bas\00E9 sur la table EMP, si vous voulez d\00E9clencher une action dynamique d\00E8s que <code>P2_SAL</code> change mais uniquement si'),
unistr('<code>P2_JOB</code> est \00E9gal \00E0 <em>SALESMAN</em>, remplacez cet attribut par <code>P2_JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054619370306372)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064374278306379)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page utilis\00E9 dans cette condition. Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058905379306375)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101600329016306013)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une condition c\00F4t\00E9 client pour contr\00F4ler si l''action est d\00E9clench\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059254308306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifiez une condition c\00F4t\00E9 client pour contr\00F4ler si les actions True ou False se d\00E9clenchent. Si la condition'),
unistr('                                  a la valeur True, les actions True se d\00E9clenchent ; si la condition a la valeur False, les actions False se d\00E9clenchent.'),
unistr('                                  Si aucune condition n''est indiqu\00E9e, seules les actions True se d\00E9clenchent.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059335856306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064605672306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la <em>colonne</em> s\00E9lectionn\00E9 est \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059591133306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne > Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064845741306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la <em>colonne</em> s\00E9lectionn\00E9 est sup\00E9rieure \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059663725306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne >= Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064925155306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la <em>colonne</em> s\00E9lectionn\00E9 est sup\00E9rieure ou \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060121764306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment/Colonne dans la liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065447132306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la <em>colonne</em> s\00E9lectionn\00E9 figure dans la <em>liste</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060348852306377)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065670752306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Evalue l''expression JavaScript indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059720455306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne < Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065004912306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la <em>colonne</em> s\00E9lectionn\00E9 est inf\00E9rieure \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059830447306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne <= Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065173354306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la<em>colonne</em> s\00E9lectionn\00E9 est inf\00E9rieure ou \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059455769306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102064720090306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la <em>colonne</em> s\00E9lectionn\00E9 n''est pas \00E9gale \00E0 la <em>valeur</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060286374306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment/Colonne absent de la liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065503475306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que la valeur de l''<em>\00E9l\00E9ment</em> ou de la <em>colonne</em> s\00E9lectionn\00E9 ne figure pas dans la <em>liste</em> indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060008105306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065354476306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que l''<em>\00E9l\00E9ment</em> ou la <em>colonne</em> s\00E9lectionn\00E9 n''est pas vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059906619306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment / Colonne NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102065254157306380)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifie que l''<em>\00E9l\00E9ment</em> ou la <em>colonne</em> s\00E9lectionn\00E9 est vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102059149380306376)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599997826306013)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez l''expression JavaScript \00E0 \00E9valuer pour cette condition.'),
unistr('Le code permet d''acc\00E9der aux attributs associ\00E9s \00E0 l''action dynamique suivants :</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>R\00E9f\00E9rence \00E0 l''objet DOM de l''\00E9l\00E9ment ayant d\00E9clench\00E9 l''action dynamique.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>Objet d''\00E9v\00E9nement ayant d\00E9clench\00E9 l''\00E9v\00E9nement. Remarque : lors du chargement, cet \00E9l\00E9ment sera \00E9gal \00E0 ''load''.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>Donn\00E9es suppl\00E9mentaires facultatives pouvant \00EAtre transmises depuis le gestionnaire d''\00E9v\00E9nements.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599858443306013)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060996575306377)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez l''expression JavaScript \00E0 \00E9valuer pour cette condition.'),
unistr('Le code permet d''acc\00E9der aux attributs associ\00E9s \00E0 l''action dynamique suivants :</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>R\00E9f\00E9rence \00E0 l''objet DOM de l''\00E9l\00E9ment ayant d\00E9clench\00E9 l''action dynamique.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>Objet d''\00E9v\00E9nement ayant d\00E9clench\00E9 l''\00E9v\00E9nement. Remarque : lors du chargement, cet \00E9l\00E9ment sera \00E9gal \00E0 ''load''.</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>Donn\00E9es suppl\00E9mentaires facultatives pouvant \00EAtre transmises depuis le gestionnaire d''\00E9v\00E9nements.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060830833306377)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058809048306375)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste de valeurs s\00E9par\00E9es par des virgules pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058737976306375)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060704365306377)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la liste des valeurs de la condition \00E0 tester, s\00E9par\00E9es par des virgules.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060647590306377)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099388635306406)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez la valeur de cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099224772306406)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060572379306377)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur de la condition \00E0 tester.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102060400767306377)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195913767305692)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le code JavaScript \00E0 ex\00E9cuter lors du chargement de la page.'),
unistr('Ce code est ex\00E9cut\00E9 apr\00E8s le code JavaScript g\00E9n\00E9r\00E9 par &PRODUCT_NAME..</p>'),
unistr('<p>Le code saisi ici remplace la cha\00EEne de substitution <code>#GENERATED_JAVASCRIPT#</code> dans le mod\00E8le de page.</p>'),
unistr('<p>Remarque : vous n''avez pas besoin d''ajouter les balises <code>script</code> de d\00E9but ou de fin, mais simplement le code JavaScript.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195894837305692)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter lors du chargement de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698245661306092)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>R\00E9f\00E9rence de fichier standard</dt>'),
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>R\00E9f\00E9rence de fichier standard qui charge le fichier r\00E9duit <code>main.min.js</code> \00E0 partir de <code>/myjs/minified/</code> pour les vues de page normales et <code>main.js</code> \00E0 partir de <code>/myjs/</code> en mode d\00E9bogage ou lors de l''ex\00E9c')
||unistr('ution de l''application \00E0 partir d''App Builder.</dt>'),
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>Utilisez cette syntaxe si la biblioth\00E8que est \00E9galement utilis\00E9e \00E0 partir d''un appel require RequireJS. Le nom define doit correspondre \00E0 ce qui est utilis\00E9 dans les chemins requirejs.config et la valeur doit \00EAtre le symbole global affich\00E9 par la')
||unistr(' biblioth\00E8que. S''applique uniquement en cas d''utilisation de RequireJS. Cela \00E9vite \00E0 RequireJS de charger la biblioth\00E8que une seconde fois.</dt>'),
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>Utilisez cette syntaxe si le fichier a une d\00E9pendance sur RequireJS. RequireJS sera automatiquement charg\00E9 avant ce fichier.</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>Utilisez cette syntaxe si le fichier a une d\00E9pendance sur Oracle JET. RequireJS et la configuration RequireJS Oracle JET seront automatiquement charg\00E9s avant ce fichier.</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>R\00E9f\00E9rence de fichier utilisant une cha\00EEne de requ\00EAte dans l''URL qui r\00E9f\00E9rence la version d''application, afin d''indiquer au navigateur de toujours charger le nouveau fichier et d''ignorer les fichiers pr\00E9c\00E9demment mis en m\00E9moire cache lors de la mi')
||unistr('se \00E0 niveau de l''application (et de l''incr\00E9mentation de la version).</dt>'),
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195579194305692)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les URL de fichier JavaScript pour le code charg\00E9 sur cette page. Chaque URL doit \00EAtre \00E9crite sur une nouvelle ligne.'),
unistr('Si vous indiquez une version r\00E9duite du fichier, vous pouvez utiliser la cha\00EEne de substitution <code>#MIN#</code> afin d''inclure <code>.min</code> ou <code>#MIN_DIRECTORY#</code> afin d''inclure <code>minified/</code> dans l''URL de fichier pour une v')
||unistr('ue de page normale, et une cha\00EEne vide si la page est visualis\00E9e en mode d\00E9bogage ou lors de l''ex\00E9cution de l''application \00E0 partir d''App Builder.'),
unistr('Vous avez \00E9galement acc\00E8s \00E0 la cha\00EEne de substitution <code>#APP_VERSION#</code> si vous voulez inclure la version de l''application dans l''URL de fichier.</p>'),
unistr('<p>Les URL de fichier JavaScript saisies ici remplacent la cha\00EEne de substitution <code>#PAGE_JAVASCRIPT#</code> dans le mod\00E8le de page.</p>'),
unistr('<p>Remarque : vous n''avez pas besoin d''ajouter les balises <code>script</code> de d\00E9but ou de fin, mais simplement l''URL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195402863305692)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195723661305692)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le code JavaScript, tel que les fonctions ou les d\00E9clarations de variable globale, r\00E9f\00E9renc\00E9 sur cette page.'),
unistr('Pour r\00E9f\00E9rencer un raccourci, utilisez <code>"SHORTCUTNAME"</code>.'),
unistr('Si le m\00EAme code JavaScript est requis sur plusieurs pages, entrez-le dans un fichier JavaScript externe pour \00E9viter toute duplication et tirer parti de la mise en m\00E9moire cache des fichiers statiques dans le navigateur.</p>'),
unistr('<p>Le code saisi ici remplace la cha\00EEne de substitution <code>#PAGE_JAVASCRIPT#</code> dans le mod\00E8le de page.</p>'),
unistr('<p>Remarque : vous n''avez pas besoin d''ajouter les balises <code>script</code> de d\00E9but ou de fin, mais simplement le code JavaScript.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195679115305692)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9claration de fonction et de variable globale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036390112306359)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le libell\00E9 du facet.'),
unistr('    Le libell\00E9 n''appara\00EEt sur la page que si le facet est affich\00E9. Le libell\00E9 du type <strong>Rechercher</strong> n''est pas visible, mais est accessible \00E0 la technologie d''assistance.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875781468306229)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('~Saisissez le libell\00E9 du groupe de facets.~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101875951203306229)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le libell\00E9 du facet.'),
unistr('    Le libell\00E9 n''appara\00EEt sur la page que si le facet est affich\00E9. Le libell\00E9 du type <strong>Rechercher</strong> n''est pas visible, mais est accessible \00E0 la technologie d''assistance.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238978278305742)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le libell\00E9 du filtre.'),
unistr('    Le libell\00E9 n''appara\00EEt sur la page que si le filtre est affich\00E9. Le libell\00E9 du type <strong>Rechercher</strong> n''est pas visible, mais est accessible \00E0 la technologie d''assistance.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239860839305742)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('~Saisissez le libell\00E9 du groupe de filtres.~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240215067305743)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le libell\00E9 du filtre.'),
unistr('    Le libell\00E9 n''appara\00EEt sur la page que si le filtre est affich\00E9. Le libell\00E9 du type <strong>Rechercher</strong> n''est pas visible, mais est accessible \00E0 la technologie d''assistance.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221414499305729)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le libell\00E9 de champ de l''\00E9l\00E9ment de page.'),
unistr('Ce libell\00E9 n''appara\00EEt sur la page que si l''\00E9l\00E9ment est affich\00E9.'),
unistr('Selon l''affichage et l''alignement choisis, le libell\00E9 appara\00EEt dans sa propre cellule de tableau HTML ou dans la m\00EAme cellule.</p>'),
unistr('<p>Les libell\00E9s d''\00E9l\00E9ment peuvent comporter des raccourcis indiqu\00E9s \00E0 l''aide de la syntaxe <code>"SHORTCUT_NAME"</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221390553305729)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221669498305729)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''alignement de libell\00E9. Les libell\00E9s peuvent \00EAtre affich\00E9s au-dessus, au-dessous ou \00E0 gauche de l''\00E9l\00E9ment.'),
unistr('Lorsqu''un libell\00E9 est affich\00E9 en regard d''un \00E9l\00E9ment de panneau, il occupe sa propre cellule de tableau HTML.'),
unistr('En modifiant cet alignement de libell\00E9, vous pouvez contr\00F4ler la position du libell\00E9 dans cette cellule de tableau.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709788147306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'fr'
,p_message_text=>'Au-dessus '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709827778306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'fr'
,p_message_text=>'En dessous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710065498306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>'En bas au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710147487306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'Au centre au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710297545306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'fr'
,p_message_text=>'En haut au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101709928429306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'Au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710486940306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En bas \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710546440306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Au centre \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710669796306102)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710319282306101)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'fr'
,p_message_text=>'A gauche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710887492306102)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En bas \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710961039306102)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Au centre \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101711075145306102)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101710794395306102)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'A droite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221532922305729)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alignement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038825248306361)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la r\00E9gion doit \00EAtre charg\00E9e ind\00E9pendamment des donn\00E9es pour la r\00E9gion.</p>'),
unistr('        <p>Lorsque le chargement lazy est sp\00E9cifi\00E9, la page est affich\00E9e imm\00E9diatement, et la r\00E9gion reste vide jusqu''\00E0 ce que les donn\00E9es soient charg\00E9es.'),
unistr('        En g\00E9n\00E9ral, la page n''est pas affich\00E9e tant qu''elle n''a pas \00E9t\00E9 charg\00E9e dans son int\00E9gralit\00E9 et qu''elle n''est pas pr\00EAte \00E0 \00EAtre affich\00E9e.'),
unistr('        Par cons\00E9quent, si le chargement de toutes les donn\00E9es prend 5 secondes pour une r\00E9gion, sans chargement lazy, l''utilisateur final doit attendre 5 secondes avant le d\00E9but de l''affichage de la page.</p>'),
unistr('        <p>Remarque : utilisez le chargement lazy uniquement sur des ensembles de donn\00E9es dont le chargement est long, car cela ajoute une surcharge de traitement inutile sur la base de donn\00E9es pour les r\00E9gions qui sont charg\00E9es rapidement.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417797563305875)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la r\00E9gion doit \00EAtre charg\00E9e ind\00E9pendamment des donn\00E9es pour la r\00E9gion.</p>'),
unistr('        <p>Lorsque le chargement lazy est sp\00E9cifi\00E9, la page est affich\00E9e imm\00E9diatement, et la r\00E9gion reste vide jusqu''\00E0 ce que les donn\00E9es soient charg\00E9es.'),
unistr('        En g\00E9n\00E9ral, la page n''est pas affich\00E9e tant qu''elle n''a pas \00E9t\00E9 charg\00E9e dans son int\00E9gralit\00E9 et qu''elle n''est pas pr\00EAte \00E0 \00EAtre affich\00E9e.'),
unistr('        Par cons\00E9quent, si le chargement de toutes les donn\00E9es prend 5 secondes pour une r\00E9gion, sans chargement lazy, l''utilisateur final doit attendre 5 secondes avant le d\00E9but de l''affichage de la page.</p>'),
unistr('        <p>Remarque : utilisez le chargement lazy uniquement sur des ensembles de donn\00E9es dont le chargement est long, car cela ajoute une surcharge de traitement inutile sur la base de donn\00E9es pour les r\00E9gions qui sont charg\00E9es rapidement.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417663390305875)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Chargement lazy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857464472306212)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la visibilit\00E9 de la couche peut \00EAtre activ\00E9e/d\00E9sactiv\00E9e lorsqu''un utilisateur clique sur son nom dans la l\00E9gende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857343763306212)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Activer le masquage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857636513306212)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''ic\00F4ne \00E0 afficher pour la couche dans la l\00E9gende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857566280306212)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473103743305917)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la position d''une l\00E9gende sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473279207305917)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473587779305917)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473473466305917)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473370857305917)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473667446305917)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101473090544305917)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472929956305917)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si une l\00E9gende doit \00EAtre affich\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472814758305917)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857822920306212)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le titre de la l\00E9gende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584092887306001)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le titre \00E0 afficher dans la partie sup\00E9rieure de la l\00E9gende du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583914656306001)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479051111305921)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le style de la courbe \00E0 afficher sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479239016305922)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'fr'
,p_message_text=>'Tirets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479140272305921)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pointill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479308426305922)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'fr'
,p_message_text=>'Solide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101478957756305921)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479890338305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le type de courbe \00E0 afficher sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479986919305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480259285305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Segment\00E9 au centre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480070184305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Echelonn\00E9 au centre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480117838305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Incurv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480531420305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480488998305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Segment\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480354227305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Echelonn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480667978305923)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'Trait'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479750015305922)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479591331305922)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la largeur de la courbe \00E0 afficher sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479432295305922)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101479667609305922)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726644627306113)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Ouvrir le lien dans une nouvelle fen\00EAtre</dt>'),
'<dd><pre>target="_blank"</pre></dd>',
'<dt>Afficher une info-bulle au passage du curseur</dt>',
'<dd><pre>title="Cliquer pour modifier"</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523601248305953)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez des attributs de lien de colonne suppl\00E9mentaires \00E0 inclure dans la balise <code>&lt;a href=...&gt;</code>, tels qu''une cible de lien, des classes ou des styles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523587016305953)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529386556305957)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un mod\00E8le d''autorisation \00E0 associer \00E0 la colonne de lien. L''\00E9valuation de ce mod\00E8le doit donner la valeur TRUE pour que la colonne de lien soit affich\00E9e dans l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529229985305957)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941638606306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942077195306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941948535306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941883172306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942189142306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941740328306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941517507306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943600597306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943990825306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943887660306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943719233306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944031684306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943581865306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537915739305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537836397305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539309601305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539233396305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943240181306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Java pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943119132306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944807685306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Java qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944745473306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943087046306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942914506306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression JavaScript pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942898461306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944681089306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944572422306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction JavaScript qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944458897306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538154388305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste de valeurs s\00E9par\00E9es par un signe deux-points (:) pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538012583305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538572410305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le num\00E9ro de page pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538443664305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538702687305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la liste des num\00E9ros de page s\00E9par\00E9s par des virgules pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538602832305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942770104306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 ou :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942650315306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression PL/SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942595432306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944367135306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944249748306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944147713306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538355690305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une pr\00E9f\00E9rence utilisateur compar\00E9e \00E0 la valeur sp\00E9cifi\00E9e pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538236950305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943473354306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Python pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101943366795306280)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101945010114306282)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Python qui renvoie une valeur bool\00E9enne pour cette condition.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101944901599306281)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942425524306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942328078306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101942259678306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084553874306395)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs alors que des lignes existent lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Pour r\00E9ussir le renvoi de valeurs alors qu''aucune ligne n''existe lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 40, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537565152305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537426146305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538954846305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une valeur de texte pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101538853515305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539526840305965)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539426577305965)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537362762305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de condition \00E0 remplir pour que le lien soit affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788438408306160)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'fr'
,p_message_text=>'Toujours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924138220306265)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le composant sera toujours affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787039096306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Microsoft Internet Explorer 7.0 ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787154393306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>'Le navigateur client est compatible XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786997856306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Mozilla, Netscape 6.x/7x ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787276518306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est diff\00E9rent (ou version ant\00E9rieure)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785688707306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le texte est compris dans l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787677434306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927752721306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787397737306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours est comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927977542306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787513272306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927817347306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787416111306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928083005306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans l''une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784854889306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours = Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926552811306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est \00E9gale \00E0 la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785093935306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926760259306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours se trouve dans la liste de pages s\00E9par\00E9es par des virgules saisie dans l''attribut <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784972061306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours != Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926670944306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est diff\00E9rente de la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785126897306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours n''est pas contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926844607306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours ne se trouve pas dans la liste de pages s\00E9par\00E9es par des virgules saisie dans l''attribut <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787779736306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787876685306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786544519306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e sont affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927508735306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e est affich\00E9e sur la page \00E0 la suite d''une soumission de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785904027306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785795279306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte est compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785849615306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte n''est pas compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786084812306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782557819306155)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes renvoy\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924264181306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL renvoie au moins une ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941385431306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101941414352306279)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>'L''expression renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782769469306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924430118306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Le corps de fonction renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788172718306160)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788211677306160)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786281098306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion n''est pas en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927295731306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le cas \00E9ch\00E9ant, la page et la r\00E9gion parent s''affichent normalement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786164930306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion est en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927113864306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour la page ou la r\00E9gion parent, le cas \00E9ch\00E9ant, la condition Lecture seule renvoie la valeur TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784016011306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne contient aucun espace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925766842306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 ne contient pas d''espace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784365056306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est alphanum\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926066336306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est alphanum\00E9rique (elle contient uniquement des lettres ou des chiffres et aucun caract\00E8re sp\00E9cial).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783550942306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925282116306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784211864306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925966748306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783730603306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925491071306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783413510306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925180233306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783805433306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL ou \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925595120306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide ou \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784180983306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925804770306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783636751306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925396828306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783942756306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est ni NULL, ni \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925684234306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est ni vide, ni \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786703636306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'fr'
,p_message_text=>'Etats SQL (OK pour afficher le bouton Suivant)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786800561306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats SQL (OK pour afficher le bouton Pr\00E9c\00E9dent)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788330099306160)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'fr'
,p_message_text=>'Jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928127825306269)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le composant n''est jamais affich\00E9.</p>'),
unistr('<p>Remarque : le passage \00E0 la condition <strong>Jamais</strong> enl\00E8ve toutes les conditions existantes. Pour la d\00E9sactivation temporaire d''un composant, Oracle recommande l''utilisation de l''attribut <em>Option de construction</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786615042306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e ne sont pas affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927674388306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e n''est pas affich\00E9e sur la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782621890306155)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ligne n''a \00E9t\00E9 renvoy\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924327633306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL ne renvoie aucune ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785412603306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours est en mode d''impression facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926997282306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours a \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785590829306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours n''est pas en mode d''impression facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927095650306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours n''a pas \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782813438306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924598718306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est identique au texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783018888306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande est comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924761145306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101782921347306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924645034306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La demande de page est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783157642306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924873228306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page n''est pas comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101787950952306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788041895306159)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786317470306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est authentifi\00E9 (utilisateur non public)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927361818306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final est connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101786463292306158)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est public (utilisateur non authentifi\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101927451354306268)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''est pas connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784643014306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926330435306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> indiqu\00E9e est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784751289306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926469829306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> indiqu\00E9e est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784416926306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926163280306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101784501573306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101926280633306267)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783281194306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101924975164306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101783330913306156)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101925054373306266)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785379255306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours != Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101785295673306157)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours = Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537200987305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de condition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537763842305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur \00E0 comparer \00E0 la condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537689177305963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539118219305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539035022305964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670849465306072)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les r\00E9gions d''\00E9tat peuvent \00EAtre imprim\00E9es \00E0 l''aide du lien d''impression standard, qui appara\00EEt sous la r\00E9gion d''\00E9tat, ou \00E0 l''aide d''un bouton. Si vous souhaitez utiliser un bouton, enlevez le libell\00E9 de lien et cr\00E9ez un bouton sur votre page en ut')
||unistr('ilisant l''URL indiqu\00E9e dans URL d''impression comme cible de bouton.</p>'),
unistr('<p>L''utilisation des boutons pour l''impression des r\00E9gions d''\00E9tat permet de d\00E9finir le statut de session. Cela est utile si vous pr\00E9voyez d''autoriser plusieurs formats de sortie pour l''impression (Word, Excel, PDF, etc.) et que vous souhaitez affiche')
||unistr('r un bouton, un lien ou une image pour chaque option. Pour ce faire, utilisez le format de sortie d\00E9riv\00E9 de l''option d''\00E9l\00E9ment et incluez le nom et la valeur d''\00E9l\00E9ment dans votre URL d''impression.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101899968734306247)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affichez le lien d''URL pour cet \00E9tat enregistr\00E9. Cet attribut est en lecture seule et ne peut pas \00EAtre mis \00E0 jour.</p>'),
unistr('    <p>Cet attribut vous permet de copier rapidement l''URL affich\00E9e. Cette URL peut \00EAtre utilis\00E9e comme lien direct vers cet \00E9tat enregistr\00E9 particulier, depuis n''importe quel autre emplacement de l''application.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671481943306073)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les r\00E9gions d''\00E9tat peuvent \00EAtre imprim\00E9es \00E0 l''aide du lien d''impression standard, qui appara\00EEt sous la r\00E9gion d''\00E9tat, ou \00E0 l''aide d''un bouton. Si vous souhaitez utiliser un bouton, enlevez le libell\00E9 de lien et cr\00E9ez un bouton sur votre page en ut')
||unistr('ilisant l''URL indiqu\00E9e dans URL d''impression comme cible de bouton.</p>'),
unistr('<p>L''utilisation des boutons pour l''impression des r\00E9gions d''\00E9tat permet de d\00E9finir le statut de session. Cela est utile si vous pr\00E9voyez d''autoriser plusieurs formats de sortie pour l''impression (Word, Excel, PDF, etc.) et que vous souhaitez affiche')
||unistr('r un bouton, un lien ou une image pour chaque option. Pour ce faire, utilisez le format de sortie d\00E9riv\00E9 de l''option d''\00E9l\00E9ment et incluez le nom et la valeur d''\00E9l\00E9ment dans votre URL d''impression.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540242629305965)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affichez le lien d''URL pour cet \00E9tat enregistr\00E9. Cet attribut est en lecture seule et ne peut pas \00EAtre mis \00E0 jour.</p>'),
unistr('<p>Cet attribut vous permet de copier rapidement l''URL affich\00E9e. Cette URL peut \00EAtre utilis\00E9e comme lien direct vers cet \00E9tat enregistr\00E9 particulier, depuis n''importe quel autre emplacement de l''application.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540132871305965)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Exemple de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529168470305957)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte HTML \00E0 utiliser pour le lien. Pour afficher une image, utilisez une balise d''image ou faites votre choix dans la liste des images par d\00E9faut. Si aucune valeur n''est d\00E9finie, le fichier <code>#IMAGE_PREFIX#ws/small_page.gif</code> e')
||unistr('st utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529046266305957)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne de lien')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539882885305965)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cliquez sur la cible pour appeler une bo\00EEte de dialogue modale. Vous pouvez saisir une cible personnalis\00E9e \00E0 appeler lorsque la colonne de lien est s\00E9lectionn\00E9e.</p>'),
unistr('        <p>S\00E9lectionnez le type appropri\00E9 dans Concepteur de liens - Cible en fonction de vos exigences :'),
'        <dl>',
'        <dt>Page dans cette application</dt>',
'        <dd>Saisissez les informations suivantes :',
'        <ul>',
unistr('        <li>Page - saisissez le num\00E9ro de page ou l''alias de page auquel acc\00E9der. Vous pouvez \00E9galement s\00E9lectionner le num\00E9ro de page dans la liste de s\00E9lection.</li>'),
unistr('        <li>D\00E9finir des \00E9l\00E9ments : Nom - saisissez ou s\00E9lectionnez des \00E9l\00E9ments de page (<code>P3_ID</code>), des \00E9l\00E9ments d''application (<code>LAST_PAGE</code>) ou des filtres d''\00E9tat interactif (<code>IR_EMPNO</code>) \00E0 d\00E9finir dans le statut de ses')
||'sion.</li>',
unistr('        <li>D\00E9finir des \00E9l\00E9ments : Valeur - saisissez ou s\00E9lectionnez une colonne d''\00E9tat (<code>#ID#</code>), saisissez un \00E9l\00E9ment d''application ou de page (<code>&P2_EMPNO.</code>) ou saisissez une valeur statique (<code>2</code>).</li>'),
unistr('        <li>Effacer le cache - saisissez une liste de num\00E9ros de page (<code>2,3</code>), d''\00E9l\00E9ments (<code>P3_EMPNO,LAST_PAGE</code>) et de param\00E8tres d''\00E9tat \00E0 effacer, s\00E9par\00E9s par des virgules. Pour r\00E9initialiser la pagination d''un \00E9tat, saisissez ')
||unistr('<code>RP</code>. Pour effacer ou r\00E9initialiser des param\00E8tres d''\00E9tat interactif, saisissez <code>CIR</code> ou <code>RIR</code>.</li>'),
unistr('        <li>R\00E9initialiser la pagination - s\00E9lectionnez Oui pour r\00E9initialiser la pagination et revenir au premier ensemble d''enregistrements, pour les \00E9tats sur la page cible. Cette action a le m\00EAme effet que de transmettre <code>RP</code> dans Effac')
||'er le cache.</li>',
unistr('        <li>Avanc\00E9 : Demande - entrez la demande \00E0 utiliser.</li>'),
'        </ul>',
'        </dd>',
unistr('        <dt>Page dans une application diff\00E9rente</dt>'),
unistr('        <dd>Saisissez les m\00EAmes attributs que ceux r\00E9pertori\00E9s pour Page dans cette application. Toutefois, vous devez \00E9galement saisir l''ID ou l''alias d''application pour Application.</dd>'),
'        <dt>URL</dt>',
'        <dd>Saisissez l''URL.</dd>',
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101539736353305965)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Cible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858257228306212)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''action \00E0 ex\00E9cuter lorsqu''un utilisateur clique sur un objet de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474949759305918)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''action \00E0 ex\00E9cuter lorsqu''un utilisateur clique sur ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434266623305887)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Rediriger vers l''URL renvoy\00E9e par la premi\00E8re colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434384022305888)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Redirige vers l''URL cible renvoy\00E9e par la premi\00E8re colonne de la requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475253103305919)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une page dans une autre application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475364530305919)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>R\00E9acheminer vers une page dans une autre application, avec des attributs facultatifs suppl\00E9mentaires permettant de r\00E9initialiser la pagination, de d\00E9finir la valeur de demande, de vider le cache et de d\00E9finir des valeurs d''\00E9l\00E9ment sur la page cibl')
||'e.<p>',
unistr('<p>Remarque : le r\00E9acheminement vers une page dans une autre application repose sur l''activation du lien profond dans l''application cible. Pour activer le lien profond, acc\00E9dez aux attributs <em>S\00E9curit\00E9</em> de l''application et activez <em>Lien prof')
||'ond</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475026847305918)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la page dans cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475171950305919)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une page de l''application en cours, avec des attributs facultatifs suppl\00E9mentaires permettant de r\00E9initialiser la pagination, de d\00E9finir la valeur de demande, de vider le cache et de configurer des valeurs d''\00E9l\00E9ment sur la page cible')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475429565305919)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475599137305919)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''URL cible indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474815879305918)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523447271305953)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte HTML \00E0 afficher en tant que lien. Pour afficher une image, utilisez une balise d''image ou s\00E9lectionnez-la dans la liste des images par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523387583305953)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835938103305417)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le pour d\00E9finir l''apparence et la mise en page de cette liste.</p>'),
unistr('        <p>Les mod\00E8les de liste sont d\00E9finis dans le th\00E8me d''application.'),
unistr('        Lors de la cr\00E9ation d''une r\00E9gion de liste, le mod\00E8le est automatiquement d\00E9fini sur le mod\00E8le de liste par d\00E9faut configur\00E9 dans le th\00E8me en cours.</p>'),
unistr('        <p>Le th\00E8me universel fournit les mod\00E8les de liste suivants :'),
'          <dl>',
'            <dt>Liste Badge</dt>',
'            <dt>Cartes</dt>',
'            <dt>Liste Liens</dt>',
'            <dt>Liste Support</dt>',
'            <dt>Barre de menus</dt>',
unistr('            <dt>Fen\00EAtre instantan\00E9e de menu</dt>'),
'            <dt>Barre de navigation</dt>',
unistr('            <dt>Menu de navigation lat\00E9ral</dt>'),
'            <dt>Onglets</dt>',
'            <dt>Menu de navigation vers le haut</dt>',
'            <dt>Progression d''assistant</dt>',
'          </dl>',
unistr('          Voir \00E9galement : <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Application \00E9chantillon de th\00E8me universel</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835876407305417)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903980516306250)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904428820306251)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904592210306251)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste dynamique repose sur la requ\00EAte SQL renvoy\00E9e par le corps de fonction PL/SQL que vous avez saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904284543306250)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904354574306251)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste dynamique repose sur la requ\00EAte SQL saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904085382306250)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904103531306250)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>'La liste statique repose sur la valeur de texte saisie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101903842999306250)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589346801306005)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nombre total de jours \00E0 afficher dans la vue d''agenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589258140306005)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589428743306005)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'fr'
,p_message_text=>'jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589164604306005)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez les jours \00E0 afficher pour la vue de liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748643268306130)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748754575306130)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les entr\00E9es de calendrier en fonction du nombre de jours saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748293310306130)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'fr'
,p_message_text=>'Mois en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748341493306130)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les entr\00E9es de calendrier pour le mois en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748486049306130)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9e en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748511804306130)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les entr\00E9es de calendrier pour l''ann\00E9e en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589025782306005)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339250856305818)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Sp\00E9cifiez la page de connexion de l''application pour l''interface utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339192441305817)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283662574305775)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''emplacement de r\00E9acheminement de &PRODUCT_NAME. apr\00E8s la d\00E9connexion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717758433306107)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717879133306107)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la valeur du lien de page d''accueil, indiqu\00E9e dans les attributs d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717992309306107)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'fr'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718037125306107)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''URL saisie, telle que <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283569555305775)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de d\00E9connexion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416752546305874)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez comment prot\00E9ger les donn\00E9es contre les pertes de mise \00E0 jour.'),
unistr('		Les pertes de mise \00E0 jour surviennent lorsque deux personnes ou plus essaient de mettre \00E0 jour les m\00EAmes donn\00E9es. La derni\00E8re mise \00E0 jour \00E9crase les mises \00E0 jour effectu\00E9es par le premier utilisateur ayant enregistr\00E9 des modifications.'),
unistr('		Pour \00E9viter cela, les mises \00E0 jour peuvent comparer les valeurs de colonne existantes dans la base de donn\00E9es avec les valeurs extraites lors de la premi\00E8re interrogation de la ligne.</p>'),
'		<p>Par exemple :',
'          <ol>',
unistr('            <li>L''utilisateur A interroge les enregistrements d''employ\00E9s (EMP).</li>'),
unistr('		    <li>L''utilisateur B interroge les m\00EAmes enregistrements d''employ\00E9s.</li>'),
unistr('		    <li>L''utilisateur B met \00E0 jour les d\00E9tails des employ\00E9s pour EMPNO = 7839 et applique (valide) les modifications apport\00E9es \00E0 la base de donn\00E9es.</li>'),
unistr('		    <li>L''utilisateur A met \00E0 jour les d\00E9tails des employ\00E9s pour EMPNO = 7839 et tente d''appliquer les modifications \00E0 la base de donn\00E9es.</li>'),
'		    </ol>',
unistr('          Si l''utilisateur A parvient \00E0 mettre \00E0 jour le m\00EAme enregistrement, les modifications apport\00E9es par l''utilisateur B sont perdues.</p>'),
unistr('         <p>Lorsque l''utilisateur A tente d''enregistrer l''enregistrement d''employ\00E9, les donn\00E9es figurant dans la base de donn\00E9es sont diff\00E9rentes de celles initialement interrog\00E9es par l''utilisateur A.'),
unistr('		  Dans l''\00E9tape 1 ci-dessus, les valeurs de colonne interrog\00E9es initialement par l''utilisateur A peuvent \00EAtre captur\00E9es.'),
unistr('		  Lors de l''\00E9tape 4 ci-dessus, les valeurs peuvent \00EAtre compar\00E9es aux valeurs en cours dans la base de donn\00E9es.'),
unistr('		  Cette comparaison g\00E9n\00E8re une erreur pour l''utilisateur A, car les valeurs de la base de donn\00E9es ont \00E9t\00E9 mises \00E0 jour par l''utilisateur B lors de l''\00E9tape 3.'),
unistr('          Cela permet d''emp\00EAcher un utilisateur d''\00E9craser les modifications apport\00E9es par un autre utilisateur sur la m\00EAme ligne.</p>'),
unistr('		  <p>Remarque : le type de mise \00E0 jour perdue est utilis\00E9 uniquement si l''option <strong>Emp\00EAcher les pertes de mise \00E0 jour</strong> est activ\00E9e pour le processus correspondant, Grille interactive - Traitement de ligne automatique (DML).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416930443305875)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne de version de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546720621305972)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si la table de base de donn\00E9es contient une colonne qui est incr\00E9ment\00E9e \00E0 chaque fois qu''un enregistrement est mis \00E0 jour, de pr\00E9f\00E9rence par un d\00E9clencheur de base de donn\00E9es, vous pouvez utiliser cette colonne au lieu de calculer des checksums.'),
unistr('        N''utilisez pas cette option si votre grille interactive met \00E0 jour des donn\00E9es dans plusieurs tables.</p>'),
unistr('        <p>Remarque : la colonne de version de ligne doit \00EAtre incluse dans la source SQL pour la r\00E9gion.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416877876305874)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546678619305972)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Une valeur de checksum est calcul\00E9e pour chaque ligne lors de l''interrogation initiale des donn\00E9es.'),
unistr('        Le checksum est calcul\00E9 en concat\00E9nant toutes les colonnes modifiables en une cha\00EEne, puis en g\00E9n\00E9rant une valeur unique.'),
unistr('        Lors de la validation (commit) de l''enregistrement mis \00E0 jour, ce checksum est compar\00E9 \00E0 la valeur de checksum de l''enregistrement de base de donn\00E9es en cours.'),
unistr('        Si les valeurs ne sont pas identiques, une erreur est g\00E9n\00E9r\00E9e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416633309305874)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de mise \00E0 jour perdue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956080608306296)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956325031306297)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956254964306297)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956184070306296)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956413720306297)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101955977712306296)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957228491306297)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un corps de fonction Java qui renvoie une requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit avoir un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui incluent une expression SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957160471306297)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Java renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957068007306297)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher le nom du service, d\00E9finir le num\00E9ro du service</dt>'),
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956926775306297)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un corps de fonction JavaScript qui renvoie une requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit avoir un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui incluent une expression SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956829775306297)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction JavaScript renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552475134305977)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez le nom de cette liste de valeurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552339711305977)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281576808305774)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les \00E9l\00E9ments de colonne, de page ou d''application \00E0 d\00E9finir dans le statut de session lorsque la valeur de l''un des \00E9l\00E9ments parent de liste de valeurs en cascade indiqu\00E9 est modifi\00E9e sur cette page.'),
unistr('S\00E9parez chaque nom d''\00E9l\00E9ment par une virgule.'),
unistr('Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste.</p>'),
unistr('<p>Utilisez les \00E9l\00E9ments de page indiqu\00E9s dans cet attribut dans la <em>clause WHERE</em> de cette requ\00EAte SQL de liste de valeurs afin de limiter les valeurs renvoy\00E9es.</p>'),
unistr('<p>Remarque : les \00E9l\00E9ments de page d\00E9finis dans <em>El\00E9ments parent de liste de valeurs en cascade</em> sont automatiquement transmis, il n''est donc pas n\00E9cessaire de les saisir dans cet attribut.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281401890305773)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments \00E0 soumettre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956766295306297)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher le nom du service, d\00E9finir le num\00E9ro du service</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956690850306297)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un corps de fonction PL/SQL qui renvoie une requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui incluent une expression SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101956557701306297)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957411249306297)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un corps de fonction Python qui renvoie une requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit avoir un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui incluent une expression SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101957370316306297)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Python renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020222503306347)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la d\00E9finition de requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui comprennent une expression SQL.</p>'),
unistr('<p>Remarque : lors de la d\00E9finition d''un type d''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e, pour afficher plusieurs colonnes dans la fen\00EAtre instantan\00E9e, vous devez plut\00F4t d\00E9finir la liste de valeurs dans Composants partag\00E9s,'),
unistr('avec les m\00E9tadonn\00E9es suppl\00E9mentaires requises. Une liste de valeurs incorpor\00E9e ne peut \00EAtre utilis\00E9e que pour afficher des colonnes uniques pour des listes de valeurs instantan\00E9es.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876058686306229)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la d\00E9finition de requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui comprennent une expression SQL.</p>'),
unistr('<p>Remarque : lors de la d\00E9finition d''un type d''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e, pour afficher plusieurs colonnes dans la fen\00EAtre instantan\00E9e, vous devez plut\00F4t d\00E9finir la liste de valeurs dans Composants partag\00E9s,'),
unistr('avec les m\00E9tadonn\00E9es suppl\00E9mentaires requises. Une liste de valeurs incorpor\00E9e ne peut \00EAtre utilis\00E9e que pour afficher des colonnes uniques pour des listes de valeurs instantan\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102036284121306359)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la d\00E9finition de requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui comprennent une expression SQL.</p>'),
unistr('<p>Remarque : lors de la d\00E9finition d''un type d''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e, pour afficher plusieurs colonnes dans la fen\00EAtre instantan\00E9e, vous devez plut\00F4t d\00E9finir la liste de valeurs dans Composants partag\00E9s,'),
unistr('avec les m\00E9tadonn\00E9es suppl\00E9mentaires requises. Une liste de valeurs incorpor\00E9e ne peut \00EAtre utilis\00E9e que pour afficher des colonnes uniques pour des listes de valeurs instantan\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102020180075306347)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la d\00E9finition de requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui comprennent une expression SQL.</p>'),
unistr('<p>Remarque : lors de la d\00E9finition d''un type d''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e, pour afficher plusieurs colonnes dans la fen\00EAtre instantan\00E9e, vous devez plut\00F4t d\00E9finir la liste de valeurs dans Composants partag\00E9s,'),
unistr('avec les m\00E9tadonn\00E9es suppl\00E9mentaires requises. Une liste de valeurs incorpor\00E9e ne peut \00EAtre utilis\00E9e que pour afficher des colonnes uniques pour des listes de valeurs instantan\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239181769305742)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la d\00E9finition de requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui comprennent une expression SQL.</p>'),
unistr('<p>Remarque : lors de la d\00E9finition d''un type d''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e, pour afficher plusieurs colonnes dans la fen\00EAtre instantan\00E9e, vous devez plut\00F4t d\00E9finir la liste de valeurs dans Composants partag\00E9s,'),
unistr('avec les m\00E9tadonn\00E9es suppl\00E9mentaires requises. Une liste de valeurs incorpor\00E9e ne peut \00EAtre utilis\00E9e que pour afficher des colonnes uniques pour des listes de valeurs instantan\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240410035305743)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la d\00E9finition de requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui comprennent une expression SQL.</p>'),
unistr('<p>Remarque : lors de la d\00E9finition d''un type d''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e, pour afficher plusieurs colonnes dans la fen\00EAtre instantan\00E9e, vous devez plut\00F4t d\00E9finir la liste de valeurs dans Composants partag\00E9s,'),
unistr('avec les m\00E9tadonn\00E9es suppl\00E9mentaires requises. Une liste de valeurs incorpor\00E9e ne peut \00EAtre utilis\00E9e que pour afficher des colonnes uniques pour des listes de valeurs instantan\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791511312306162)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher le nom du service, d\00E9finir le num\00E9ro du service</dt>'),
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542563856305967)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la d\00E9finition de requ\00EAte SQL pour remplir cette liste de valeurs. G\00E9n\00E9ralement, les requ\00EAtes de liste de valeurs ont le format suivant : </p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Chaque colonne s\00E9lectionn\00E9e doit poss\00E9der un nom ou un alias unique. Oracle recommande d''utiliser un alias pour toutes les colonnes qui comprennent une expression SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542477316305967)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542935626305967)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez les valeurs pour cette liste statique des valeurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542807962305967)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542785103305967)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929184536306269)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101929249821306269)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste dynamique de valeurs repose sur la requ\00EAte SQL renvoy\00E9e par le corps de fonction que vous avez saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414569388305873)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Composant partag\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414626464305873)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) est bas\00E9e sur une liste de valeurs pr\00E9d\00E9finie, configur\00E9e dans Composants partag\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414746657305873)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414892673305873)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) dynamique est bas\00E9e sur la requ\00EAte SQL saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731386631306117)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731440957306117)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) statique est bas\00E9e sur la valeur de texte saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101542670244305967)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211026018305721)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la m\00E9thode de conservation du statut de session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168594281305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Par demande (m\00E9moire uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168699862305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''enregistrez pas le statut dans la base de donn\00E9es. Le statut n''est disponible que lors du traitement de la demande en cours. Si des demandes AJAX doivent utiliser un \00E9l\00E9ment, veillez \00E0 transmettre le nom de cet \00E9l\00E9ment via El\00E9ments de page \00E0 soumet')
||'tre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713464550306104)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'fr'
,p_message_text=>'Par utilisateur (disque)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007937249306337)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Conserver pour un utilisateur en stockant la valeur dans la base de donn\00E9es, afin d''y avoir acc\00E8s dans toutes les sessions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713365035306104)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'Par session (disque)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007887582306337)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Conserver pour chaque session en stockant la valeur dans la base de donn\00E9es, afin d''y avoir acc\00E8s dans toutes les demandes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210983067305721)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer le statut de session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168821753305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la m\00E9thode de conservation du statut de session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168911323305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Par demande (m\00E9moire uniquement)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169014560305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''enregistrez pas le statut dans la base de donn\00E9es. Le statut n''est disponible que lors du traitement de la demande en cours. Si des demandes AJAX doivent utiliser un \00E9l\00E9ment, veillez \00E0 transmettre le nom de cet \00E9l\00E9ment via El\00E9ments de page \00E0 soumet')
||'tre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169177784305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'Par session (disque)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101169265531305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Conserver pour chaque session en stockant la valeur dans la base de donn\00E9es, afin d''y avoir acc\00E8s dans toutes les demandes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168723173305672)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer le statut de session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485885426305926)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les marques de graduation principales sont affich\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485921897305926)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486114676305926)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486039456305926)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101485785556305926)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830961337306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830838031306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez la couleur de remplissage \00E0 utiliser pour afficher un cluster de points.'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830789686306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de remplissage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830118277306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez les classes CSS d''ic\00F4ne \00E0 utiliser pour afficher un cluster de points.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830081051306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829962491306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''URL vers l''image \00E0 utiliser pour afficher un cluster de points.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829857486306190)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('URL de l''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830307509306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la forme SVG \00E0 utiliser pour afficher un cluster de points. Choisissez parmi les formes pr\00E9d\00E9finies ou entrez le nom d''une <em>forme SVG personnalis\00E9e</em>, indiqu\00E9 dans l''attribut de r\00E9gion de carte <strong>Styles SVG personnalis\00E9s</strong>')
||unistr('. Si le nom indiqu\00E9 ne figure pas dans la liste des styles SVG par d\00E9faut ou personnalis\00E9s, le <strong>marqueur par d\00E9faut</strong> est utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863808010306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'fr'
,p_message_text=>'Appareil photo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871691129306226)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868467915306220)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872954436306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863910124306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'fr'
,p_message_text=>'Cercle - Remplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871805974306226)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830508663306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'fr'
,p_message_text=>'Cercle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871724721306226)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863730165306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871504896306226)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864096295306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Visage aux sourcils fronc\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871912867306226)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864137228306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'fr'
,p_message_text=>'Visage inexpressif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872037074306226)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864208142306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'fr'
,p_message_text=>'Visage souriant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872179046306226)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868943053306221)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'fr'
,p_message_text=>'Drapeau pennon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873499555306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869022058306221)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'fr'
,p_message_text=>'Drapeau queue-de-pie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873553524306228)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864651165306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'fr'
,p_message_text=>'Coeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872663230306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868536908306220)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873051470306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864721882306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'fr'
,p_message_text=>'Pentagone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872799496306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864494332306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'fr'
,p_message_text=>'Epingle ronde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872436209306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864557572306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Epingle carr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872559748306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868738147306220)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'fr'
,p_message_text=>'Brillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873222789306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868698812306220)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'fr'
,p_message_text=>'Barre oblique'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873110833306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864358499306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carr\00E9 - Remplacement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872323639306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830429410306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872242163306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868828349306221)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'fr'
,p_message_text=>'Vue de la rue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101873372865306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830606689306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'fr'
,p_message_text=>'Triangle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101872896805306227)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101830259938306191)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Forme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864920196306218)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le facteur d''\00E9chelle appliqu\00E9 \00E0 la forme SVG utilis\00E9e pour afficher un cluster de points. L''\00E9chelle maximale est <strong>10</strong>. Le composant de carte arrondit la valeur au premier chiffre d\00E9cimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101864866300306217)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Echelle de forme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834189247306194)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Rayon du cluster en pixels. Si la valeur <strong>80</strong> est indiqu\00E9e, les points se trouvant \00E0 80 pixels les uns des autres sont'),
unistr('agr\00E9g\00E9s en un cluster de points.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834092577306194)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Rayon de cr\00E9ation de cluster')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834240434306194)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854997575306210)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez des expressions HTML \00E0 afficher en tant qu''info-bulles lorsque vous passez le pointeur de la souris sur un marqueur de cluster de la carte. Utilisez les valeurs de r\00E9serve <strong>&LAYER.</strong> et <strong>&COUNT.</strong> pour r\00E9f\00E9rencer le')
||' nom de la couche et le nombre d''objets de carte du cluster.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854888507306210)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Info-bulle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820461180306183)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''avis de copyright \00E0 placer dans le pied de page de la carte. Si rien n''est indiqu\00E9, un avis est g\00E9n\00E9r\00E9 pour la carte en arri\00E8re-plan utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820359025306183)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Copyright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822108479306185)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822023739306185)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez les d\00E9finitions des formes SVG personnalis\00E9es, qui peuvent \00EAtre utilis\00E9es comme marqueurs de carte. Les styles d\00E9finis ici peuvent \00EAtre employ\00E9s en tant qu''attribut de <strong>forme SVG</strong> dans une couche de points.</p>'),
unistr('<p>La largeur et la hauteur de la forme SVG doivent \00EAtre \00E9gales \00E0 <strong>20</strong>. Le marqueur est positionn\00E9 sur la carte de sorte que le centre du bas de la forme (coordonn\00E9e SVG <strong>10</strong>, <strong>20</strong>) pointe vers l''objet de ')
||'carte.</p>',
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">La largeur et la hauteur des marqueurs SVG sont \00E9gales \00E0 20. Ces derniers pointent vers l''emplacement de carte situ\00E9 \00E0 la position x=10 et y=20.</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821997938306185)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Styles SVG personnalis\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852698626306208)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne renvoyant une valeur permettant de d\00E9terminer la hauteur du polygone extrud\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852588476306208)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de valeur d''extrusion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854396543306209)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''unit\00E9 permettant de d\00E9terminer la hauteur du polygone extrud\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854600665306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'fr'
,p_message_text=>'Pied'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854569907306209)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Kilom\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854407217306209)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854775697306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'fr'
,p_message_text=>'Mile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854257499306209)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Unit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826874508306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826717288306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indiquez la couleur du remplissage.',
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826698666306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de remplissage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835677543306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si une <em>combinaison de couleurs</em> doit \00EAtre utilis\00E9e pour la couche. Une combinaison de couleurs est une liste de couleurs : en fonction d''une valeur et des valeurs minimale et maximale, le widget de carte choisit dans la liste la coul')
||unistr('eur d''affichage r\00E9elle de l''objet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835518091306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Utiliser une combinaison de couleurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988467101306322)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>La liste de couleurs va du rouge au blanc</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>La liste de couleurs va du bleu au noir</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835809358306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une <em>combinaison de couleurs</em> personnalis\00E9e pour la couche. Une combinaison de couleurs est une liste de couleurs : en fonction d''une valeur et des valeurs minimale et maximale, le widget de carte choisit dans la liste la couleur d''af')
||unistr('fichage r\00E9elle de l''objet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835798596306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de couleurs personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836017576306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne renvoyant une valeur afin de d\00E9terminer la couleur d''affichage \00E0 partir de la combinaison.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835911693306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de valeur de couleur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827051358306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''opacit\00E9 du remplissage. Valeurs comprises entre 0 (totalement transparent) et 1,0 (opaque).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826941646306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Opacit\00E9 du remplissage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836288828306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne renvoyant la valeur afin de d\00E9terminer la couleur d''affichage \00E0 partir de la combinaison. Si aucune colonne n''est s\00E9lectionn\00E9e, la couleur d''affichage sera d\00E9termin\00E9e \00E0 partir de la densit\00E9 de points uniquement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836184711306195)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832011646306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si cette fen\00EAtre d''informations doit \00EAtre affich\00E9e \00E0 l''aide de colonnes ou \00E0 l''aide d''un format avanc\00E9 bas\00E9 sur des expressions HTML et des cha\00EEnes de substitution prises en charge. La fen\00EAtre d''informations sera affich\00E9e en tant que fen\00EAtre')
||unistr(' instantan\00E9e lorsque vous cliquez sur un objet de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831973237306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832447472306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser en tant que corps pour la fen\00EAtre d''informations. Cette derni\00E8re appara\00EEt sous la forme d''une fen\00EAtre instantan\00E9e lorsqu''un utilisateur clique sur un objet de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832347659306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832999558306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez les classes CSS \00E0 utiliser pour l''affichage de la fen\00EAtre instantan\00E9e d''informations. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832894961306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832714409306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&COLUMN_CLASS.</code> et <code>&EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832665034306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez des expressions HTML \00E0 afficher en tant que fen\00EAtre instantan\00E9e d''informations lorsqu''un utilisateur clique sur un objet spatial. Utilisez la syntaxe <code>&COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832532043306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832279431306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser en tant que titre pour la fen\00EAtre d''informations. Cette derni\00E8re appara\00EEt sous la forme d''une fen\00EAtre instantan\00E9e lorsqu''un utilisateur clique sur un objet de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101832183175306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855856052306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 \00E0 afficher dans la l\00E9gende et les info-bulles. Si vous n''indiquez rien, l''attribut <strong>Nom</strong> est utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855628299306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le libell\00E9 \00E0 utiliser pour la couche dans la l\00E9gende et les info-bulles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855514900306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855474421306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855360992306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indiquez la couleur de remplissage du marqueur.',
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855266316306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de remplissage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855136955306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''opacit\00E9 du remplissage. Valeurs comprises entre 0 (totalement transparent) et 1,0 (opaque).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855010873306210)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Opacit\00E9 du remplissage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852968988306208)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852807363306208)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indiquez la couleur du contour.',
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852782303306208)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur du contour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853197848306208)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez la largeur du contour.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853048962306208)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur du contour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833118166306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser pour affecter des lignes de la source de r\00E9gion \00E0 la couche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833050670306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833345201306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la <em>valeur</em> de la <strong>colonne Affectation de ligne</strong>, qui affecte des lignes de la source de r\00E9gion \00E0 la couche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833235773306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur de cette couche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826336638306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826205034306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indiquez la couleur du contour.',
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826112479306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur du contour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833536644306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez le style du contour.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833869767306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'fr'
,p_message_text=>'Tirets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833779303306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pointill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833934028306194)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'fr'
,p_message_text=>'Tirets et points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833632394306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'fr'
,p_message_text=>'Solide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101833499747306193)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style du contour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826500482306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez la largeur du contour.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826455790306188)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur du contour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831128952306191)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si cette info-bulle doit \00EAtre affich\00E9e \00E0 l''aide d''une colonne ou \00E0 l''aide d''un format avanc\00E9 bas\00E9 sur des expressions HTML et des cha\00EEnes de substitution prises en charge. L''info-bulle est affich\00E9e lorsque vous passez le pointeur de la souri')
||'s sur un objet de la carte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831066652306191)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831386503306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme info-bulle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831239281306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831872262306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez les classes CSS \00E0 utiliser pour l''affichage de l''info-bulle. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831760653306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831688724306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&COLUMN_CLASS.</code> et <code>&EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831534200306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez des expressions HTML \00E0 afficher en tant qu''info-bulles lorsque vous passez le pointeur de la souris sur un objet de la carte. Utilisez la syntaxe <code>&COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101831419706306192)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825474371306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne renvoyant des objets GeoJSON \00E0 afficher sur la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825392021306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825685102306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne SDO_GEOMETRY, renvoyant des objets de g\00E9om\00E9trie \00E0 afficher sur la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825549669306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de g\00E9om\00E9trie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824037436306186)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifiez le type de donn\00E9es de la colonne de g\00E9om\00E9trie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824381694306186)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'fr'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824410116306186)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'fr'
,p_message_text=>'GeoJSON, sous la forme de types VARCHAR2 ou CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824506056306186)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'fr'
,p_message_text=>'Longitude/Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824676640306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>'Longitude et latitude, sous la forme de deux colonnes NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824168469306186)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'fr'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824292672306186)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Type SDO_GEOMETRY Oracle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823948921306186)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de donn\00E9es de colonne de g\00E9om\00E9trie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824821083306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifiez le type de donn\00E9es de la colonne de g\00E9om\00E9trie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824984680306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'fr'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825099830306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'fr'
,p_message_text=>'GeoJSON, sous la forme de types VARCHAR2 ou CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825103333306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'fr'
,p_message_text=>'Longitude/Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825252866306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>'Longitude et latitude, sous la forme de deux colonnes NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101824717680306187)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de donn\00E9es de colonne de g\00E9om\00E9trie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823880735306186)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Activez ce commutateur si la table sous-jacente comporte un index spatial et que le widget de carte doit l''utiliser lors de l''extraction de lignes \00E0 partir de la base de donn\00E9es. Dans ce cas, le widget n''extrait de la base de donn\00E9es <em>que</em> ')
||unistr('les lignes de la fen\00EAtre de carte en cours, ce qui permet de meilleures performances si la source de donn\00E9es contient de nombreuses lignes.</p><p>Un index spatial peut \00EAtre cr\00E9\00E9 sur une colonne SDO_GEOMETRY dans SQL Workshop.</p>'),
unistr('<p>Aucun index spatial <em>n''est</em> utilis\00E9 dans les cas suivants :</p>'),
'<ul>',
unistr('<li>Plusieurs couches r\00E9f\00E9rencent la <strong>source de r\00E9gion</strong> en tant que source de donn\00E9es.</li>'),
unistr('<li>La fen\00EAtre de carte est trop grande. Autrement dit, elle englobe plus de la moiti\00E9 du monde.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823757297306186)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Utiliser l''index spatial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101826049980306188)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne NUMBER, contenant la latitude des objets spatiaux \00E0 afficher sur la carte. Les valeurs renvoy\00E9es doivent \00EAtre comprises entre -90 et 90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825944179306188)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841684856306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez l''une des combinaisons de couleurs divergentes pr\00E9d\00E9finies. Celles-ci conviennent \00E0 la visualisation des valeurs divergentes, d''un extr\00EAme \00E0 l''autre. Combinaisons de couleurs de CARTOColors (<a rel="noreferrer" href="https://github.com/Car')
||'toDB/cartocolor" target="_blank">CARTOcolor sur GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841743240306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Vert militaire \00E0 rose')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841867459306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842962108306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'fr'
,p_message_text=>'Couleurs terrestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843099218306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841900627306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'fr'
,p_message_text=>'Couleurs automnales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842030831306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842180284306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'fr'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842292394306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842550012306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu-vert \00E0 rose')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842671211306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842352977306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'fr'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842407620306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842732926306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'fr'
,p_message_text=>'Couleurs tropicales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101842854009306200)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841592774306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843246013306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez l''une des combinaisons de couleurs qualitatives pr\00E9d\00E9finies. Celles-ci conviennent \00E0 la visualisation des valeurs distinctes. Combinaisons de couleurs de CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target=')
||'"_blank">CARTOcolor sur GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843385591306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'fr'
,p_message_text=>'Antique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843413201306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843520512306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'fr'
,p_message_text=>'Gras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843627728306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843760650306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'fr'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843809737306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843928133306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'fr'
,p_message_text=>'Prisme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844037096306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844151944306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Assur\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844203085306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844397624306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'fr'
,p_message_text=>'Vif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844425940306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101843170727306201)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837607634306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez l''une des combinaisons de couleurs s\00E9quentielles pr\00E9d\00E9finies. Celles-ci conviennent \00E0 la visualisation des valeurs s\00E9quentielles, dans l''ordre croissant. Combinaisons de couleurs de CARTOColors (<a rel="noreferrer" href="https://github.com')
||'/CartoDB/cartocolor" target="_blank">CARTOcolor sur GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839187432306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu \00E0 vert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839293747306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839706983306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839824363306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841335364306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Marron \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841406219306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837743812306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'fr'
,p_message_text=>'Bordeaux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837894082306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837956701306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bordeaux \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838045316306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839355168306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Menthe fonc\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839484702306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839587906306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'fr'
,p_message_text=>'Emeraude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839655278306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840987191306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'fr'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841074904306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838972501306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'fr'
,p_message_text=>'Menthe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839052050306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838394690306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Orange \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838400456306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838568748306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'fr'
,p_message_text=>unistr('P\00EAche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838649576306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838722701306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Rose \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838862017306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840305216306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'fr'
,p_message_text=>'Violet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840499816306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840530291306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Violet \00E0 orange')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840618676306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838131755306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Rouge \00E0 orange')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101838271170306197)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840762756306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'fr'
,p_message_text=>'Coucher de soleil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840801235306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841195729306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Coucher de soleil fonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101841211127306199)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101839920747306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'fr'
,p_message_text=>'Bleu-vert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840085035306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840158859306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu-vert \00E0 vert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101840205316306198)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837511211306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856222896306211)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856318682306211)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la liste des couleurs HTML (#rrggbb), s\00E9par\00E9es par des virgules.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836883291306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Choisissez le type de combinaison de couleurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837104185306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'fr'
,p_message_text=>'Divergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837238353306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette combinaison de couleurs convient \00E0 la visualisation des valeurs divergentes, d''un extr\00EAme \00E0 l''autre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837371343306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'fr'
,p_message_text=>'Qualitative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837494684306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette combinaison de couleurs convient \00E0 la visualisation des valeurs distinctes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836981724306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quentielle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101837009582306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette combinaison de couleurs convient \00E0 la visualisation des valeurs s\00E9quentielles, dans l''ordre croissant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836717576306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Combinaison de couleurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988806360306322)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>La liste de couleurs va du rouge au blanc</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>La liste de couleurs va du bleu au noir</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852449924306208)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une <em>combinaison de couleurs</em> personnalis\00E9e pour la couche de carte d''activit\00E9. Une combinaison de couleurs est une liste de couleurs : en fonction d''une valeur et des valeurs minimale et maximale, le widget de carte choisit dans la l')
||unistr('iste la couleur d''affichage r\00E9elle de l''objet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852341480306208)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de couleurs personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849437772306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez l''une des combinaisons de couleurs divergentes pr\00E9d\00E9finies. Celles-ci conviennent \00E0 la visualisation des valeurs divergentes, d''un extr\00EAme \00E0 l''autre. Combinaisons de couleurs de CARTOColors (<a rel="noreferrer" href="https://github.com/Car')
||'toDB/cartocolor" target="_blank">CARTOcolor sur GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849573392306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Vert militaire \00E0 rose')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849624117306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850789593306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'fr'
,p_message_text=>'Couleurs terrestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850862458306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849747820306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'fr'
,p_message_text=>'Couleurs automnales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849879969306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849941702306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'fr'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850029456306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850328247306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu-vert \00E0 rose')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850423427306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850152737306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'fr'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850278527306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850559682306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'fr'
,p_message_text=>'Couleurs tropicales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850690879306206)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849335937306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851086870306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez l''une des combinaisons de couleurs qualitatives pr\00E9d\00E9finies. Celles-ci conviennent \00E0 la visualisation des valeurs distinctes. Combinaisons de couleurs de CARTOColors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target=')
||'"_blank">CARTOcolor sur GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851112265306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'fr'
,p_message_text=>'Antique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851294896306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851353650306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'fr'
,p_message_text=>'Gras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851449983306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851566574306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'fr'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851614329306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851774556306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'fr'
,p_message_text=>'Prisme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851844058306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101851937088306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Assur\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852014616306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852117984306208)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'fr'
,p_message_text=>'Vif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101852207162306208)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101850920436306207)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845409412306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez l''une des combinaisons de couleurs s\00E9quentielles pr\00E9d\00E9finies. Celles-ci conviennent \00E0 la visualisation des valeurs s\00E9quentielles, dans l''ordre croissant. Combinaisons de couleurs de CARTOColors (<a rel="noreferrer" href="https://github.com')
||'/CartoDB/cartocolor" target="_blank">CARTOcolor sur GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846947827306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu \00E0 vert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847001422306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847530469306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847613035306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849117244306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Marron \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849219577306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845509012306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'fr'
,p_message_text=>'Bordeaux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845661983306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845733530306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bordeaux \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845861031306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847102212306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Menthe fonc\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847288708306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847382043306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'fr'
,p_message_text=>'Emeraude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847465664306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848701139306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'fr'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848892852306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846794076306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'fr'
,p_message_text=>'Menthe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846838779306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846160385306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Orange \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846271167306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846340802306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'fr'
,p_message_text=>unistr('P\00EAche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846406668306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846537789306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Rose \00E0 jaune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846655400306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848154081306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'fr'
,p_message_text=>'Violet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848290680306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848390223306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Violet \00E0 orange')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848477354306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845989920306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Rouge \00E0 orange')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101846061081306203)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848585093306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'fr'
,p_message_text=>'Coucher de soleil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848683111306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848949754306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Coucher de soleil fonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101849035925306205)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847719421306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'fr'
,p_message_text=>'Bleu-vert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847889687306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101847988478306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bleu-vert \00E0 vert')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101848001581306204)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'fr'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845321450306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856437561306211)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856545331306211)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la liste des couleurs HTML (#rrggbb), s\00E9par\00E9es par des virgules.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844693276306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Choisissez le type de combinaison de couleurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844980233306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'fr'
,p_message_text=>'Divergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845095778306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette combinaison de couleurs convient \00E0 la visualisation des valeurs divergentes, d''un extr\00EAme \00E0 l''autre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845137238306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'fr'
,p_message_text=>'Qualitative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101845289850306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette combinaison de couleurs convient \00E0 la visualisation des valeurs distinctes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844756699306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quentielle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844893343306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette combinaison de couleurs convient \00E0 la visualisation des valeurs s\00E9quentielles, dans l''ordre croissant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101844505617306202)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Combinaison de couleurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834466477306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Identifiez le type de la couche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835148985306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carte d''activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835236979306195)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Objets de type point, affich\00E9s sous la forme d''une carte d''activit\00E9. Les cartes d''activit\00E9 sont utiles pour visualiser la densit\00E9 des objets de type point.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834779408306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'fr'
,p_message_text=>'Lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834850023306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Objets de type ligne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834526272306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'fr'
,p_message_text=>'Points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834664436306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Objets de type point.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834978909306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'fr'
,p_message_text=>'Polygones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835015271306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'fr'
,p_message_text=>'Objets de type polygone.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835308527306195)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Polygones extrud\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101835484966306195)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Polygones extrud\00E9s en tant qu''objets 3D. La hauteur d\00E9pend de la valeur d''une colonne de r\00E9sultats.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101834308568306194)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de couche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836640985306196)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez le niveau de zoom maximal auquel la couche reste visible.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836599421306195)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836418557306195)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez le niveau de zoom minimal auquel la couche devient visible.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101836325390306195)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825875121306187)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne NUMBER, contenant la longitude des objets spatiaux \00E0 afficher sur la carte. Les valeurs renvoy\00E9es doivent \00EAtre comprises entre -180 et 180.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101825791294306187)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de longitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829751810306190)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indique si les points localis\00E9s au m\00EAme endroit doivent \00EAtre group\00E9s sur la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829679408306190)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Activer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827240775306189)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indique le mode d''affichage des objets de type point.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827584456306189)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827605671306189)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez en tant qu''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827384505306189)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'fr'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827493599306189)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affichez en tant que forme SVG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827110428306188)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829288744306190)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la forme SVG permettant d''afficher des objets de type point. Choisissez parmi les formes pr\00E9d\00E9finies ou entrez le nom d''une <em>forme SVG personnalis\00E9e</em>, indiqu\00E9 dans l''attribut de r\00E9gion de carte <strong>Styles SVG personnalis\00E9s</strong')
||unistr('>. Si aucun nom n''est indiqu\00E9 ou que le nom sp\00E9cifi\00E9 ne figure pas dans la liste des formes SVG par d\00E9faut ou personnalis\00E9es, la forme <strong>par d\00E9faut</strong> est utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862521238306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'fr'
,p_message_text=>'Appareil photo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869595699306221)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867735749306220)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870827515306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862689768306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'fr'
,p_message_text=>'Cercle - Remplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869743475306221)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829483779306190)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'fr'
,p_message_text=>'Cercle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869608636306221)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862456946306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869454178306221)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862776854306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Visage aux sourcils fronc\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869857491306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862839109306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'fr'
,p_message_text=>'Visage inexpressif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101869946600306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101862940441306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'fr'
,p_message_text=>'Visage souriant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870063591306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868298731306220)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'fr'
,p_message_text=>'Drapeau pennon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871335354306226)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868354240306220)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'fr'
,p_message_text=>'Drapeau queue-de-pie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871497078306226)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863349792306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'fr'
,p_message_text=>'Coeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870508666306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867805764306220)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'fr'
,p_message_text=>'Page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870904917306226)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863495348306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'fr'
,p_message_text=>'Pentagone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870644029306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863171098306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'fr'
,p_message_text=>'Epingle ronde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870347668306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863291816306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Epingle carr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870417914306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868085176306220)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'fr'
,p_message_text=>'Brillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871108897306226)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867969846306220)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'fr'
,p_message_text=>'Barre oblique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871075397306226)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863094905306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carr\00E9 - Remplacement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870230133306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829301950306190)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870195765306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101868117852306220)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'fr'
,p_message_text=>'Vue de la rue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101871253691306226)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829583491306190)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'fr'
,p_message_text=>'Triangle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101870718017306225)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'fr'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829132346306190)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Forme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863628546306217)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le facteur d''\00E9chelle appliqu\00E9 \00E0 la forme SVG. L''\00E9chelle maximale est <strong>10</strong>. Si une substitution de colonne est utilis\00E9e et que la valeur est sup\00E9rieure \00E0 <strong>10</strong>, un message est \00E9crit dans la console JavaScript et l')
||unistr('e marqueur est affich\00E9 avec un facteur d''\00E9chelle de <strong>10</strong>. Le composant de carte arrondit la valeur au premier chiffre d\00E9cimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101863580694306216)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Echelle de forme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828604229306190)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne contenant les classes CSS d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828505536306190)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101829081999306190)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS \00E0 utiliser comme source d''ic\00F4ne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828949771306190)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Classes CSS d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828843057306190)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez l''URL pour la source d''image.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828732980306190)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827820147306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source de l''ic\00F4ne utilis\00E9e pour afficher le point sur la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828152792306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de classe d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828217687306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'fr'
,p_message_text=>'Utilisez des classes CSS individuelles pour chaque ligne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827911790306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Classe d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828014012306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'fr'
,p_message_text=>'Utilisez une classe CSS statique pour toutes les lignes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828301329306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'fr'
,p_message_text=>'URL d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101828400485306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('URL de l''image \00E0 utiliser pour afficher le point.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101827767735306189)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Source d''ic\00F4ne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818674876306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Activez ou d\00E9sactivez diverses fonctionnalit\00E9s de widget de carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819755695306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Obtenir l''emplacement \00E0 partir du navigateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819829485306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Obtenez l''emplacement actuel de l''utilisateur \00E0 partir du navigateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819977813306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'fr'
,p_message_text=>'Outil de cercle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820076057306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''outil de cercle permet aux utilisateurs finals de dessiner un cercle sur la carte. Lorsqu''ils ont termin\00E9, un \00E9v\00E9nement se d\00E9clenche afin que le cercle puisse \00EAtre trait\00E9 par des actions dynamiques ou du code JavaScript.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820157830306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'fr'
,p_message_text=>'Outil de distance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820277127306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'fr'
,p_message_text=>'Permet aux utilisateurs finals de mesurer la distance entre des points sur la carte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819581945306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carte \00E0 l''infini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819682039306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9filement de carte \00E0 l''infini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818789116306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'fr'
,p_message_text=>'Zoom avec la roulette de la souris'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818888397306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Effectuez un zoom avant ou arri\00E8re \00E0 l''aide de la roulette de la souris.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819326182306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aper\00E7u de la carte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819407954306183)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez un aper\00E7u de la carte en bas \00E0 droite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818903784306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'fr'
,p_message_text=>'Zoom rectangle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819070367306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'fr'
,p_message_text=>'Effectuez un zoom vers une zone de la carte en dessinant un rectangle sur la carte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819197525306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Indication d''\00E9chelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101819285306306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez une indication d''\00E9chelle sur la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101818561104306182)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Options'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823556299306186)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la hauteur de la r\00E9gion de carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823412382306186)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823610545306186)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821839290306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes CSS \00E0 ajouter \00E0 la l\00E9gende. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821764131306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821653995306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur jQuery pour l''\00E9l\00E9ment dans lequel afficher la l\00E9gende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821585321306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820800944306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la position de la l\00E9gende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821124333306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821228328306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez la l\00E9gende \00E0 la position de fin (g\00E9n\00E9ralement en dessous de la carte).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821327368306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821438390306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez un s\00E9lecteur jQuery pour l''\00E9l\00E9ment dans lequel afficher la l\00E9gende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820998617306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101821035748306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez la l\00E9gende \00E0 la position de d\00E9but (g\00E9n\00E9ralement au-dessus de la carte).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820785243306184)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855709982306210)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Masquer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988615278306322)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'N''affichez pas les messages de couche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822345582306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez l''emplacement o\00F9 les messages de couche de carte "Aucune donn\00E9e d\00E9tect\00E9e" et "D''autres donn\00E9es ont \00E9t\00E9 trouv\00E9es" doivent \00EAtre affich\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822415010306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'fr'
,p_message_text=>'Au-dessus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822528754306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Afficher les messages au-dessus de la carte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822637080306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'fr'
,p_message_text=>'En dessous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822762840306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'fr'
,p_message_text=>'Afficher les messages en dessous de la carte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822848875306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822970416306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez un s\00E9lecteur jQuery pour l''\00E9l\00E9ment dans lequel afficher les messages.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101822258326306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position des messages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823127143306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur jQuery pour l''\00E9l\00E9ment dans lequel afficher les messages.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823042371306185)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de message')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820650876306183)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si une l\00E9gende doit \00EAtre affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101820554424306183)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823325456306186)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si un \00E9l\00E9ment de page est choisi, la r\00E9gion de carte conserve toujours la bo\00EEte englobante de carte en cours, au format GeoJSON, en tant que valeur de l''\00E9l\00E9ment. Cette option est utile pour connecter la carte \00E0 un autre composant APEX (par exemple')
||unistr(', un \00E9tat classique ou interactif) : le contenu de l''\00E9l\00E9ment de bo\00EEte englobante peut \00EAtre utilis\00E9 par l''autre composant pour effectuer une requ\00EAte spatiale et n''afficher que les donn\00E9es visibles sur la carte.</p>'),
unistr('<p>Exemple de contenu de l''\00E9l\00E9ment de bo\00EEte englobante apr\00E8s un mouvement de carte ou une modification de niveau de zoom :</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('Avec une action dynamique <strong>R\00E9g\00E9n\00E9rer</strong>, la carte peut \00EAtre connect\00E9e \00E0 une r\00E9gion d''\00E9tat. Cette derni\00E8re peut appliquer un filtre spatial pour afficher uniquement les r\00E9sultats \00E9galement visibles sur la carte.</p>'),
unistr('<p>Exemple de requ\00EAte d''\00E9tat :</p>'),
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column],',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] )',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101823276579306185)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de bo\00EEte englobante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853340826306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le syst\00E8me d''unit\00E9s \00E0 utiliser pour l''indication d''\00E9chelle et l''outil de distance.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853625402306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Imp\00E9rial')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853794070306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez le syst\00E8me imp\00E9rial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853806616306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river de l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853921532306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9rivez le syst\00E8me d''unit\00E9s de la valeur d''un \00E9l\00E9ment de page ou d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853472733306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'fr'
,p_message_text=>'Mesure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853507527306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez le syst\00E8me m\00E9trique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101853212002306208)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Syst\00E8me d''unit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854149151306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application contenant la valeur \00E0 utiliser comme syst\00E8me d''unit\00E9s de carte : <strong>METRIC</strong> (<strong>M</strong>) ou <strong>IMPERIAL</strong> (<strong>I</strong>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101854061082306209)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de syst\00E8me d''unit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480804756305923)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si un marqueur doit \00EAtre affich\00E9 sur les \00E9l\00E9ments de donn\00E9es du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480914593305923)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481157146305923)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481010284305923)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101480797397305923)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481360557305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la forme du marqueur \00E0 afficher sur les \00E9l\00E9ments de donn\00E9es du graphique. Seule l''option <strong>auto</strong> est prise en charge pour les s\00E9ries de plages. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481474660305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481586667305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'fr'
,p_message_text=>'Cercle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481669924305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'fr'
,p_message_text=>'Losange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481769544305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'fr'
,p_message_text=>'Humain'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481899131305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'fr'
,p_message_text=>'Plus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481964965305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101507181582305941)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En \00E9toile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482050433305924)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'fr'
,p_message_text=>'Triangle bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101482168583305924)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'fr'
,p_message_text=>'Triangle haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101481202988305923)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Forme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597241768306011)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si cette colonne est une colonne de cl\00E9 \00E9trang\00E8re pour la r\00E9gion de grille interactive ma\00EEtre, tel qu''indiqu\00E9 par <strong>R\00E9gion ma\00EEtre</strong> dans la r\00E9gion Param\00E8tres, s\00E9lectionnez la colonne de cl\00E9 primaire correspondante dans la table ma\00EEtre')
||'.</p>',
unistr('        <p>Par exemple, si la r\00E9gion ma\00EEtre est DEPT et que cette grille interactive est EMP, vous devez s\00E9lectionner la colonne DEPTNO dans la grille interactive EMP, puis s\00E9lectionner la colonne DEPTNO dans la liste des colonnes DEPT pour la colonn')
||unistr('e ma\00EEtre.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597189688306011)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101415001835305873)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la r\00E9gion ma\00EEtre \00E0 laquelle appartient cette r\00E9gion d\00E9tail.<br>'),
unistr('        Ce param\00E8tre doit \00EAtre d\00E9fini lorsque cette r\00E9gion est la r\00E9gion d\00E9tail dans une relation ma\00EEtre-d\00E9tail avec une autre r\00E9gion sur cette page.</p>'),
unistr('        <p>Pour que la relation ma\00EEtre-d\00E9tail fonctionne correctement, s\00E9lectionnez les colonnes dans cette r\00E9gion qui sont des cl\00E9s \00E9trang\00E8res \00E0 la r\00E9gion ma\00EEtre et indiquez une valeur appropri\00E9e pour <strong>Colonne ma\00EEtre</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101414978229305873)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion ma\00EEtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526948167305956)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le nombre maximal \00E0 afficher dans le s\00E9lecteur de lignes par page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526872080305956)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nombre maximal de lignes par page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858436421306213)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nombre maximal de lignes qui peuvent \00EAtre trait\00E9es pour la couche. Cette valeur peut servir de mesure contre le t\00E9l\00E9chargement et l''affichage sur la carte d''un trop grand nombre d''objets spatiaux.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526131214305955)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nombre maximal de lignes qui peuvent \00EAtre trait\00E9es par la requ\00EAte. Si le nombre maximal de lignes \00E0 traiter d\00E9passe la limite, un message d''erreur s''affiche \00E0 la place des donn\00E9es.'),
unistr('Un message d''erreur peut \00EAtre d\00E9fini en indiquant un message dans <strong>D''autres donn\00E9es ont \00E9t\00E9 trouv\00E9es</stron>.</p>'),
unistr('<p>Cet attribut sert de protection contre les utilisateurs finals effectuant des actions, telles que des tris ou des agr\00E9gations, sur tous les enregistrements dans des tables et des vues tr\00E8s volumineuses, qui peuvent ne pas \00EAtre performantes.'),
unistr('Au lieu de cela, le nombre d''enregistrements trait\00E9s doit d''abord \00EAtre r\00E9duit en ajoutant des filtres suppl\00E9mentaires.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526033497305955)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre maximal de lignes \00E0 traiter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892571517306242)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant doit \00EAtre affich\00E9 \00E0 l''aide d''une colonne ou \00E0 l''aide d''un format avanc\00E9 bas\00E9 sur des expressions HTML et des cha\00EEnes de substitution prises en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892484692306242)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900345535306248)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Auto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894961593306243)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9termine le rapport hauteur/largeur du support.'),
unistr('<strong>Automatique :</strong> utilise le rapport le plus adapt\00E9 pour conserver la taille initiale du support.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895043791306244)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Carr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895115676306244)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Applique un rapport hauteur/largeur carr\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895251392306244)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'fr'
,p_message_text=>'Ecran large'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895399953306244)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Applique un rapport hauteur/largeur d''\00E9cran large.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894855640306243)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Apparence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893918537306243)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne renvoyant l''objet BLOB pour la source de support.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893867155306243)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896150033306244)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896047700306244)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896312143306244)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce texte sert \00E0 d\00E9crire le support et peut \00EAtre utilis\00E9 dans les info-bulles ainsi que dans le texte alternatif des images.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101896217668306244)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Description de l''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894119650306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine la position du composant de support sur la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894679574306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En tant qu''image d''arri\00E8re-plan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894758161306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche le support en tant qu''arri\00E8re-plan de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894464715306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894500498306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche le support dans le corps de la carte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894273358306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'fr'
,p_message_text=>'Premier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894304272306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche le support avant l''en-t\00EAte de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101894057852306243)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892808339306242)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&COLUMN_CLASS.</code> et <code>&EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892767750306242)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les expressions HTML \00E0 afficher dans cette colonne. Utilisez la syntaxe <code>&COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892660629306242)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895594901306244)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine le dimensionnement du support au sein du composant de support.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895870019306244)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'fr'
,p_message_text=>'Couvrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895997225306244)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajuste les dimensions du support de fa\00E7on \00E0 ce qu''il remplisse la zone d''affichage du support.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895642389306244)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'fr'
,p_message_text=>'Adapter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895700580306244)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajuste les dimensions du support de fa\00E7on \00E0 ce qu''il soit contenu dans la zone d''affichage du support.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101895422327306244)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Dimensionnement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101900231080306247)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucun support'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893030289306242)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de source de support.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893368585306242)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893245042306242)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893113743306242)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'fr'
,p_message_text=>'URL d''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101892939222306242)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190655372305688)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le type de support Internet. Il s''agit d''un identificateur utilis\00E9 pour les formats de fichier sur Internet.'),
unistr('Un type de support se compose d''au moins deux \00E9l\00E9ments, \00E0 savoir un type et un sous-type, et de param\00E8tres facultatifs.'),
unistr('Il est employ\00E9 dans l''en-t\00EAte HTTP Content-Type lors de l''affichage de la page.</p>'),
'<p>Le type de support de niveau page remplace le type de support de niveau application.',
unistr('Si les valeurs de niveau page et application du type de support sont <code>NULL</code>, le type de support <code>text/html</code> est utilis\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190579506305688)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de support'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893567132306242)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez l''URL pour la source de support.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893464037306242)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893723622306243)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme source de support.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101893646346306242)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486722077305927)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''incr\00E9ment entre les marques de graduation secondaires. La valeur par d\00E9faut est NULL pour le calcul automatique en fonction des donn\00E9es. Cette option est applicable uniquement \00E0 des axes num\00E9riques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486693378305927)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Etape'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486533465305927)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les marques de graduation secondaires sont affich\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486445707305927)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486347462305927)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''incr\00E9ment minimal entre les marques de graduation principales. Cette option est g\00E9n\00E9ralement utilis\00E9e pour emp\00EAcher les fractions d''axe pour les mesures discr\00E8tes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486241606305926)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Etape minimale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906323418306252)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nom du processus d''application pour une identification facile par les d\00E9veloppeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287851237305778)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom utilis\00E9 par les d\00E9veloppeurs d''application pour r\00E9f\00E9rencer ce mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227358223305733)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un nom unique identifiant ce mod\00E8le d''autorisation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301079296305788)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nom du branchement pour que les d\00E9veloppeurs puissent l''identifier plus facilement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337998158305817)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le de chemin de navigation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227212802305733)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un nom pour cette option de construction. Les options de construction sont des param\00E8tres pr\00E9d\00E9finis qui d\00E9terminent si les composants d''une application sont activ\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337673265305816)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le de bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338067451305817)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le de calendrier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227981121305734)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez le nom de l''action dynamique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337776486305816)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101524149969305954)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le nom du groupe de colonnes. Il appara\00EEt comme en-t\00EAte de r\00E9gion dans la vue d\00E9taill\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337803416305816)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le de liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857944376306212)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce composant. Utilisez l''attribut <strong>Libell\00E9</strong> si du code HTML ou des substitutions sont n\00E9cessaires pour l''affichage de libell\00E9 dans la r\00E9gion de carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227457044305733)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de la page en cours. Ce nom est utilis\00E9 dans un grand nombre de pages et d''\00E9tats &PRODUCT_NAME., ainsi que le num\00E9ro et le titre de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227725386305734)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez le nom du groupe de pages.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228592639305734)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nom du processus de page pour une identification facile par les d\00E9veloppeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337415281305816)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le de page sp\00E9cifique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337517195305816)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338117088305817)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom descriptif pour ce mod\00E8le d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337355916305816)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un bref nom descriptif pour ce th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338211039305817)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de cette interface utilisateur. Le nom est affich\00E9 dans les assistants, comme l''assistant Cr\00E9ation de th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300755008305788)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de la validation. Ce nom doit \00EAtre descriptif afin que les d\00E9veloppeurs puissent identifier facilement les conditions v\00E9rifi\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187481691305686)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez un nom descriptif pour ce composant.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101187396487305685)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202404818305697)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom d''une liste de valeurs existante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202356894305697)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814371469306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Choisissez la position de la barre de navigation sur la carte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814617588306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814739516306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez la barre de navigation \00E0 la position de fin (g\00E9n\00E9ralement \00E0 droite) de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814419206306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814531294306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez la barre de navigation \00E0 la position de d\00E9but (g\00E9n\00E9ralement \00E0 gauche) de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814207380306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position de la barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813542987306178)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de barre de navigation \00E0 utiliser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814079180306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'fr'
,p_message_text=>'Zoom et boussole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101814195330306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Commandes de zoom et boussole pour contr\00F4ler l''orientation de la carte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813661315306178)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813719789306178)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Aucune barre de navigation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813891037306178)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'fr'
,p_message_text=>'Zoom uniquement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813919937306179)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Commandes de zoom avant et arri\00E8re uniquement.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813406194306178)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Barre de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070555656306384)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Ne pas afficher la liste de menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327428535305809)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la liste de menu de navigation utilis\00E9e pour naviguer sur cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327384833305809)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070067756306384)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la position de la liste de menu de navigation sur cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070255784306384)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('C\00F4t\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070104647306384)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102069987783306384)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position de liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327636226305809)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mod\00E8le de liste de menu de navigation utilis\00E9 avec la liste de menu de navigation sur cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327537695305809)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070456637306384)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>S\00E9lectionnez des options de mod\00E8le pour personnaliser l''interface utilisateur de cette liste de navigation.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102070374475306384)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883672165306235)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher une fl\00E8che pointant vers la droite</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883540043306235)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les classes pour l''ic\00F4ne que vous voulez ajouter au composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.</p>'),
unistr('        <p>Si votre th\00E8me utilise Police APEX, consultez l''<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">application \00E9chantillon de th\00E8me universel</a> pour visualiser les ic\00F4nes et les modificateurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101883439162306235)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne indiquant qu''aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067791455306382)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher dans l''option NULL de liste en haut de cette liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876136314306230)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher dans l''option NULL de liste en haut de cette liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239273752305742)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher dans l''option NULL de liste en haut de cette liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240597340305743)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher dans l''option NULL de liste en haut de cette liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203012082305697)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher dans l''option NULL de liste en haut de cette liste. Cette valeur appara\00EEt \00E9galement lors de l''affichage de l''\00E9l\00E9ment si la valeur est NULL. Si vous n''indiquez pas de texte, la valeur appara\00EEt sous forme de ligne vide dan')
||unistr('s la liste et d''\00E9l\00E9ment vide lors de l''affichage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101202922413305697)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur d''affichage NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203297744305697)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur \00E0 renvoyer si la valeur NULL est s\00E9lectionn\00E9e dans cette liste de valeurs. Si vous n''indiquez aucune valeur, la valeur d''\00E9l\00E9ment reste NULL lorsque l''option NULL est s\00E9lectionn\00E9e dans cette liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101203130776305697)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur de renvoi NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561432137305983)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nombre de lignes d''\00E9tat \00E0 afficher par page d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561328842305983)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561650122305984)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''\00E9l\00E9ment dont la valeur indique le nombre de lignes d''\00E9tat \00E0 afficher par page d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561527057305984)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561212915305983)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le mode de saisie du nombre de lignes pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741517310306125)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En fonction de la valeur d''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741468994306125)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561179037305983)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de nombre de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198322417305694)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez une cible d''URL pour les tentatives de seconde soumission de page de la part de l''utilisateur final. &PRODUCT_NAME. affiche un message d''erreur et un lien vers cette URL pour permettre \00E0 l''utilisateur de continuer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101198219056305694)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lors de soumissions de page en double, passer \00E0 cette URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589628068306005)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la page ou l''URL remplace la page en cours ou est ouverte dans une bo\00EEte de dialogue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748935649306130)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte de dialogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748882869306130)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00EAme fen\00EAtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101589500614306005)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir le lien dans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513477569305946)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9ration')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402347933305864)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Lorsque vous acc\00E9dez \00E0 la table <code>employee</code>, essayez d''utiliser l''index <code>emp_department_ix</code></dt>'),
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
unistr('<dt>Activez l''utilisation de la clause <code>WITH plsql_declarations</code> dans la requ\00EAte SQL</dt>'),
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402284891305864)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le conseil d''optimisation Oracle qui est ajout\00E9 \00E0 l''instruction de niveau sup\00E9rieur lors de l''ex\00E9cution de la requ\00EAte SQL.'),
unistr('        Un conseil est une instruction donn\00E9e \00E0 l''optimiseur. Lorsque vous \00E9crivez une instruction SQL, vous pouvez \00EAtre en possession d''informations sur les donn\00E9es dont l''optimiseur ne dispose pas. Les conseils vous permettent de prendre des d\00E9cisi')
||'ons normalement prises par l''optimiseur,',
unistr('        poussant parfois l''optimiseur \00E0 s\00E9lectionner un plan qu''il consid\00E8re comme plus co\00FBteux.</p>'),
unistr('        <p>Par exemple, vous pouvez savoir qu''un index donn\00E9 peut \00EAtre plus s\00E9lectif pour certaines requ\00EAtes. Sur la base de cette information, vous pourriez choisir un plan d''ex\00E9cution plus efficace que l''optimiseur.'),
unistr('        Dans ce cas, utilisez des conseils pour forcer l''optimiseur \00E0 utiliser le meilleur plan d''ex\00E9cution.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402165281305864)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Conseil d''optimisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074753594306387)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez une colonne index\00E9e par un index Oracle Text.</p>'),
unistr('<p>La recherche de lignes renvoie des r\00E9sultats en fonction de l''op\00E9rateur Oracle Text entr\00E9, \00E0 condition que l''index Oracle Text correspondant ait \00E9t\00E9 cr\00E9\00E9 pour cette colonne.'),
unistr('Cette option doit \00EAtre activ\00E9e si uniquement l''index n\00E9cessaire existe et si les utilisateurs finals ont \00E9t\00E9 form\00E9s \00E0 l''utilisation des op\00E9rateurs de recherche Oracle Text.'),
unistr('Afin de simplifier la syntaxe Oracle Text pour les utilisateurs finals, vous pouvez indiquer une fonction pour le param\00E8tre de composant <em>Nom de fonction PL/SQL Oracle Text</em> des grilles interactives dans Composants partag\00E9s.<br>'),
unistr('Reportez-vous au manuel <a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Guide du d\00E9veloppeur Oracle Text Application</a>.</p>'),
unistr('<p>Remarque : lorsque les utilisateurs finals entrent correctement les op\00E9rateurs Oracle Text, les recherches doivent \00EAtre bien plus performantes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074653206306387)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''index Oracle Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906016825306252)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code de nettoyage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905988863306252)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code d''initialisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464649404305911)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''orientation de ce graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464747536305911)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'fr'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595399003306010)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche les \00E9l\00E9ments de donn\00E9es du graphique horizontalement. Par exemple, les barres d''un graphique \00E0 barres sont affich\00E9es horizontalement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595181467306009)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'fr'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595204156306009)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche les \00E9l\00E9ments de donn\00E9es du graphique verticalement. Par exemple, les barres d''un graphique \00E0 barres sont affich\00E9es verticalement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464594235305911)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474570109305918)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la hauteur de la barre de d\00E9filement d''aper\00E7u \00E0 afficher sur le graphique, en pixels (par exemple, 50 px) ou en pourcentage (par exemple, 15 %).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474428182305918)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474332350305918)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si une barre de d\00E9filement d''aper\00E7u doit \00EAtre affich\00E9e sur le graphique.'),
unistr('        Actuellement, cette option est prise en charge uniquement pour les graphiques \00E0 barres verticales, \00E0 courbes, en aires, \00E0 courbes avec aires, boursiers et combin\00E9s.</p>'),
unistr('        <p>Remarque : l''option <strong>Zoom et d\00E9filement</strong> doit \00EAtre activ\00E9e pour pouvoir afficher la barre de d\00E9filement d''aper\00E7u.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101474247739305918)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327282714305809)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la navigation de niveau interface utilisateur par d\00E9faut est \00E9cras\00E9e. Vous pouvez l''utiliser pour n''avoir aucune navigation pour la page en cours ou choisir une autre navigation pour la page en cours (par exemple, pour offrir une navigati')
||unistr('on diff\00E9rente autour d''une sous-section de votre application).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101327146623305809)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Ecraser le niveau d''interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197912751305693)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de protection d''\00E9tat de session impl\00E9ment\00E9 pour cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699161354306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'fr'
,p_message_text=>'Les arguments doivent avoir un checksum.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699266389306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si les arguments Demande, Effacer le cache ou Paire nom/valeur apparaissent dans l''URL, un checksum doit \00E9galement \00EAtre fourni.<br>'),
unistr('Le type de checksum doit \00EAtre compatible avec l''attribut de <em>protection de statut de session</em> le plus strict de tous les \00E9l\00E9ments transmis en tant qu''arguments.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699548436306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun acc\00E8s par URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699639759306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La page est inaccessible via une URL.<br>',
unistr('Cependant, elle peut \00EAtre la cible d''un branchement de type <em>Branchement sur une page</em>, car il ne r\00E9alise pas de r\00E9acheminement URL.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698947896306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Non restreint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699085949306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page peut \00EAtre demand\00E9e \00E0 l''aide d''une URL, avec ou sans arguments de statut de session et sans checksum requis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699398888306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun argument pris en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101699410287306093)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une URL peut \00EAtre utilis\00E9e pour demander la page, mais elle ne peut pas contenir les arguments Demande, Effacer le cache ou Paire nom/valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197825698305693)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Protection d''acc\00E8s de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188874763305687)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez un alias alphanum\00E9rique pour cette page. Vous pouvez utiliser cet alias \00E0 la place du num\00E9ro de page pour faire r\00E9f\00E9rence \00E0 la page.'),
unistr('Par exemple, si vous travaillez sur la page 1 de l''application 100, vous pouvez cr\00E9er un alias appel\00E9 <code>home</code>.'),
unistr('Vous pourrez ensuite, \00E0 partir des autres pages, acc\00E9der \00E0 cette page au moyen de la syntaxe f?p suivante :'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188716753305686)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alias de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197531116305693)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indiquez si cette page est publique ou exige une authentification.',
unistr('Lorsqu''une page est publique, elle peut \00EAtre affich\00E9e par n''importe quel utilisateur acc\00E9dant \00E0 la page.'),
unistr('La fonction de sentinelle de page de l''application peut acc\00E9der \00E0 cet attribut de page afin d''identifier les pages qui peuvent \00EAtre affich\00E9es sans authentification pr\00E9alable.'),
unistr('L''impl\00E9mentation de la fonction de sentinelle de page du mod\00E8le d''authentification d\00E9termine si cet attribut a quelque effet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698395599306092)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'La page requiert une authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101698457858306092)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>'La page est publique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101197496475305693)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Authentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189008113305687)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sp\00E9cifiez le groupe de pages \00E0 associer \00E0 cette page.'),
unistr('Les groupes de pages n''influent pas sur la fonctionnalit\00E9 ; il aident cependant les d\00E9veloppeurs \00E0 g\00E9rer les pages d''une application.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101188969346305687)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Groupe de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196584455305692)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le texte rempla\00E7ant la cha\00EEne de substitution <code>#ONLOAD#</code> du mod\00E8le de page.'),
unistr('Cette fonctionnalit\00E9 n''est utilisable que si le mod\00E8le de page contient la cha\00EEne de substitution <code>#ONLOAD#</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101196429509305692)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attribut de corps de page HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189243390305687)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le mode de page pour cette page.</p>'),
'#LOV_VALUES#',
unistr('<p>Les options <em>Bo\00EEte de dialogue modale</em> et <em>Bo\00EEte de dialogue non modale</em> seront disponibles uniquement lorsque le th\00E8me d''application en cours contient un <em>mod\00E8le de page de bo\00EEte de dialogue</em> par d\00E9faut.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697446285306092)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte de dialogue modale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697516408306092)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La page est pr\00E9sent\00E9e comme une bo\00EEte de dialogue modale.<br>'),
unistr('Une bo\00EEte de dialogue modale est une fen\00EAtre de recouvrement plac\00E9e dans la lucarne, qui reste active et concentr\00E9e jusqu''\00E0 ce que l''utilisateur final la ferme.'),
unistr('La page sous-jacente appara\00EEt en gris\00E9 et l''utilisateur final ne peut pas interagir avec le reste de la page jusqu''\00E0 la fermeture de la bo\00EEte de dialogue.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697614876306092)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bo\00EEte de dialogue non modale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697796274306092)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La page est pr\00E9sent\00E9e comme une bo\00EEte de dialogue non modale.<br>'),
unistr('Une bo\00EEte de dialogue non modale est une fen\00EAtre de recouvrement plac\00E9e dans la lucarne, o\00F9 l''utilisateur final peut interagir avec la bo\00EEte de dialogue et le contenu de la page qui a lanc\00E9 la bo\00EEte de dialogue.'),
unistr('Une bo\00EEte de dialogue non modale peut \00EAtre utilis\00E9e lorsque l''information demand\00E9e n''est pas essentielle \00E0 la poursuite du travail, qui peut continuer n''importe o\00F9 pendant que la fen\00EAtre est encore ouverte.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697250216306092)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101697326762306092)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page est pr\00E9sent\00E9e comme une page d''application &PRODUCT_NAME. normale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189111483305687)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Mode page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038791538306361)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397745304305860)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le type de processus ex\00E9cut\00E9. Les types de processus suivants sont pris en charge :</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En fonction de la configuration de votre application, il se peut que des modules d''extension suppl\00E9mentaires de type Processus soient disponibles ici.'),
'Ces derniers apparaissent sous la forme <em>&lt;Mes modules d''extension&gt; [Module d''extension]</em>.',
unistr('Les modules d''extension suivants sont install\00E9s dans les composants partag\00E9s de cette application :</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220677228305728)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021875126306348)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL renvoyant une valeur utilis\00E9e comme source pour ce param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021792066306348)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021648576306348)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 comme source pour ce param\00E8tre. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021527183306348)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102022059325306348)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez au moins un \00E9l\00E9ment de page ou d''application utilis\00E9 comme destination pour ce param\00E8tre. S\00E9parez les noms d''\00E9l\00E9ment par une virgule</p>.'),
unistr('<p>Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102021913844306348)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023277824306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source pour le param\00E8tre dans la liste disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023727194306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023809026306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par le <em>corps de fonction PL/SQL</em> saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023311593306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023469588306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023505487306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023656669306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur le texte saisi dans <em>Valeur statique</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102023151976306349)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Source'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545521991305969)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur pour ce param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545495771305969)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573252111305993)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut du th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189418954305687)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le de page pour d\00E9finir l''apparence et la mise en page de cette page.</p>'),
unistr('        <p>Les mod\00E8les de page sont d\00E9finis dans le th\00E8me d''application.'),
unistr('        Lorsqu''une page est cr\00E9\00E9e, le mod\00E8le est automatiquement configur\00E9 sur <em>Valeur par d\00E9faut du th\00E8me</em>, qui affichera la page \00E0 l''aide du mod\00E8le de page par d\00E9faut d\00E9fini dans le th\00E8me en cours.'),
unistr('        En effectuant une s\00E9lection, vous remplacez le mod\00E8le de page par d\00E9faut.</p>'),
unistr('        <p>De nombreux th\00E8mes contiennent des mod\00E8les de page avec des objectifs sp\00E9cifiques, comme pour l''affichage de contenu avec des colonnes lat\00E9rales, une page de connexion, des pages de bo\00EEtes de dialogue, etc.<br>'),
unistr('        Le th\00E8me universel fournit les mod\00E8les de page suivants :'),
'          <dl>',
'            <dt>Standard</dt>',
unistr('              <dd>Mod\00E8le de page par d\00E9faut. Id\00E9al pour les pages d''accueil, les tableaux de bord, les \00E9tats volumineux et d''autres mises en page pour lesquels la surface de travail maximale de l''\00E9cran est voulue.</dd>'),
'            <dt>Colonne de gauche</dt>',
unistr('              <dd>Fournit une position d''affichage \00E0 gauche utile pour rechercher et filtrer les pages.</dd>'),
'            <dt>Colonne de droite</dt>',
unistr('              <dd>Fournit une position d''affichage \00E0 droite r\00E9ductible utile pour l''affichage de contr\00F4les d''action tels que des boutons ou des listes.</dd>'),
'            <dt>Colonnes de droite et de gauche</dt>',
unistr('              <dd>Fournit la colonne de gauche et la colonne de droite r\00E9ductible qui est adapt\00E9e pour les pages tr\00E8s complexes.</dd>'),
'            <dt>Connexion</dt>',
unistr('              <dd>Utilis\00E9 exclusivement pour la page de connexion de l''application.</dd>'),
unistr('            <dt>Banni\00E8re</dt>'),
unistr('              <dd>Fournit une colonne de droite r\00E9ductible et une zone de barre de titre qui contient les informations principales.'),
unistr('              Ce mod\00E8le de page est adapt\00E9 pour l''affichage d''un enregistrement ayant plusieurs \00E9tats ou donn\00E9es associ\00E9s.'),
unistr('              Ce mod\00E8le est fr\00E9quemment utilis\00E9 pour afficher des relations ma\00EEtre-d\00E9tail, o\00F9 un enregistrement ma\00EEtre est d''abord s\00E9lectionn\00E9 dans un \00E9tat. </dd>'),
'            <dt>Minimal (Aucune navigation)</dt>',
unistr('              <dd>Utile pour les pages tr\00E8s simples, les avis d''exclusion de responsabilit\00E9, les applications \00E0 une page, o\00F9 la navigation n''est pas n\00E9cessaire.</dd>'),
'          </dl>',
unistr('          Reportez-vous \00E9galement \00E0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Application \00E9chantillon de th\00E8me universel</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189360422305687)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573446445305993)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut du th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014432894306342)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilise le param\00E8tre d\00E9fini dans les valeurs par d\00E9faut de th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190268667305688)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la transition utilis\00E9e lors de l''acc\00E8s \00E0 une nouvelle page ou lorsque la page est soumise.</p>'),
'<p>Les anciens navigateurs, ne prenant pas en charge les transformations 3D, ne peuvent pas utiliser la plupart des transitions.',
unistr('Par d\00E9faut, les appareils ne prenant pas en charge la 3D (comme Android 2.x) basculent en mode fondu pour tous les types de transition.'),
'Pour plus d''informations, consultez la documentation jQuery Mobile.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702388459306095)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'fr'
,p_message_text=>'Fondu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702458096306095)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Retourn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702597336306096)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'fr'
,p_message_text=>'Flux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702269941306095)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702632034306096)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e brusque')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702708135306096)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'fr'
,p_message_text=>'Balayage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702884403306096)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placement vers le bas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101702941715306096)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'fr'
,p_message_text=>'Balayage en fondu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703067721306096)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placement vers le haut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703157585306096)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'fr'
,p_message_text=>'Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190145089305688)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Transition de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878354171306231)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si l''utilisateur est averti lorsqu''il tente de quitter la page, lorsque cette derni\00E8re contient des modifications non enregistr\00E9es.'),
unistr('        Les \00E9l\00E9ments de page et les boutons permettent \00E9galement un contr\00F4le plus pr\00E9cis du moment auquel cette v\00E9rification est effectu\00E9e et des \00E9l\00E9ments inclus.'),
unistr('        Pour les boutons, vous pouvez indiquer si le fait de cliquer dessus effectuera la v\00E9rification.'),
unistr('        Pour les \00E9l\00E9ments de page, vous pouvez indiquer si les modifications apport\00E9es \00E0 l''\00E9l\00E9ment sont incluses ou ignor\00E9es par la v\00E9rification (reportez-vous \00E0 l''attribut <em>Avertir des modifications non enregistr\00E9es</em> dans les deux cas).</p>'),
unistr('        <p>Remarque : non applicable \00E0 un utilisateur final fermant une page de bo\00EEte de dialogue modale.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878214842306231)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertir des modifications non enregistr\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525736807305955)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''endroit o\00F9 la pagination de l''\00E9tat appara\00EEt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726940296306114)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En bas \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727059941306114)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En bas \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727353345306114)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut et en bas - \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727487826306114)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut et en bas - \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727111357306114)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101727236744306114)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('En haut \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525641337305955)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102038440607306360)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509962469305944)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le param\00E8tre est obligatoire et doit toujours \00EAtre d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101509837157305943)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510149525305944)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez une valeur statique ou par d\00E9faut pour ce param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510065200305944)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245707954305747)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucun parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204768119305717)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion parent dans laquelle la r\00E9gion sera affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204624776305717)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion parent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561014294305983)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si l''option de r\00E9g\00E9n\00E9ration de page partielle doit \00EAtre utilis\00E9e pour mettre \00E0 jour l''affichage de l''\00E9tat.</p>'),
unistr('Si l''utilisateur final effectue une action, telle qu''une demande de pagination ou la s\00E9lection d''une nouvelle colonne de tri, les lignes d''\00E9tat en cours doivent \00EAtre r\00E9g\00E9n\00E9r\00E9es. La d\00E9finition de cet attribut sur <strong>Activ\00E9</strong> r\00E9g\00E9n\00E8re uniqu')
||unistr('ement la r\00E9gion d''\00E9tat. La d\00E9finition de cet attribut sur <strong>D\00E9sactiv\00E9</strong> r\00E9g\00E9n\00E8re la page enti\00E8re.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560935401305983)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9ration de page partielle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101738030600306122)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556553949305980)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour l''arri\00E8re-plan de ce graphique.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556403024305980)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur d''arri\00E8re-plan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556992585305980)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la largeur en pixels pour ce graphique \00E0 barres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556863314305980)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur des barres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101583899095306001)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'fr'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788545039306160)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556769983305980)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour le premier plan de ce graphique.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556631682305980)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de premier plan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468857384305914)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la fraction du graphique \00E0 secteurs entier, en dessous de laquelle les secteurs sont agr\00E9g\00E9s dans un secteur nomm\00E9 "Autres". Les valeurs valides sont comprises entre 0 (valeur par d\00E9faut) et 1.</p>'),
unistr('        <p>Par exemple, une valeur de 0,15 implique que tous les secteurs qui repr\00E9sentent moins de 15 % du graphique sont agr\00E9g\00E9s dans un secteur nomm\00E9 "Autres".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468792777305914)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Autre seuil de graphique \00E0 secteurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499456792305936)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''effet appliqu\00E9 lorsqu''un segment en secteurs est s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499597332305936)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'fr'
,p_message_text=>'Exploser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499715451305936)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499631705305936)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence et exploser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499303195305936)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Effet de s\00E9lection de secteur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577859500305996)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression PL/SQL qui fournit une valeur pour la cl\00E9 primaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577730860305996)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578017672305996)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un nom pour la cl\00E9 primaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577915003305996)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577673696305996)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de source pour la cl\00E9 primaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744959558306127)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745061053306127)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence existante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744859616306127)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencheur existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101577550233305996)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661904306306058)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL \00E0 utiliser \00E0 la place d''une requ\00EAte g\00E9n\00E9r\00E9e automatiquement qui s\00E9lectionne les diff\00E9rentes valeurs de colonne. La requ\00EAte SQL doit renvoyer une colonne. En saisissant une requ\00EAte SQL, vous pouvez am\00E9liorer les performances ')
||unistr('dans certains \00E9tats. Cette liste de valeurs est affich\00E9e lorsqu''un utilisateur clique sur un en-t\00EAte de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661848209306058)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661545274306058)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez comment d\00E9river la liste des valeurs pour le filtre dans la liste d\00E9roulante de colonnes d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749903217306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) nomm\00E9e pour filtrer la correspondance exacte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750043275306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) de la liste de valeurs nomm\00E9e pour cr\00E9er un filtre de correspondance parfaite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750115540306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) nomm\00E9e pour filtrer le contenu des mots')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750285505306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) de la liste de valeurs nomm\00E9e pour cr\00E9er un filtre de correspondance de contenu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749786478306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) d\00E9finie pour filtrer le contenu des mots')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749883226306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) d''une requ\00EAte SQL de liste de valeurs d\00E9finie pour cr\00E9er un filtre de correspondance de contenu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749315275306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut bas\00E9e sur le type de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749456871306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) des colonnes STRING et NUMBER d\00E9rive de colonnes distinctes. Celle des colonnes DATE d\00E9rive de plages de dates pr\00E9d\00E9finies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749171893306130)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749294989306130)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver le filtre sur la liste de valeurs (LOV).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749521910306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la liste de valeurs (LOV) d\00E9finie pour filtrer la correspondance exacte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101749673899306131)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river la liste de valeurs (LOV) d''une requ\00EAte SQL de liste de valeurs d\00E9finie pour cr\00E9er un filtre de correspondance parfaite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101661445244306058)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906463654306252)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code PL/SQL \00E0 ex\00E9cuter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515798018305948)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code PL/SQL \00E0 ex\00E9cuter sur la base de donn\00E9es distante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515600063305948)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code PL/SQL pour g\00E9n\00E9rer la sortie HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282458293305774)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la source PL/SQL utilis\00E9e dans ce mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282342058305774)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515194880305947)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''emplacement d''ex\00E9cution du processus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515284419305947)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Base de donn\00E9es locale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515378506305947)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le code PL/SQL est ex\00E9cut\00E9 dans la base de donn\00E9es locale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515472931305947)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515544399305947)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le code PL/SQL est ex\00E9cut\00E9 dans une base de donn\00E9es distante, o\00F9 la connexion est d\00E9finie via le SQL compatible REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515018151305947)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Emplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396899058305860)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la cat\00E9gorie sous laquelle le module d''extension est affich\00E9 dans l''interface utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722834784306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'fr'
,p_message_text=>'Composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722915999306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'fr'
,p_message_text=>'Effet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723033457306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723150367306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'fr'
,p_message_text=>'Initialiser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723282206306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'fr'
,p_message_text=>'Divers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723320147306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723432456306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'fr'
,p_message_text=>'Notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101723598272306111)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'fr'
,p_message_text=>'Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396767261305860)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cat\00E9gorie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048913289306368)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez un code JavaScript qui peut \00EAtre ex\00E9cut\00E9. Remarque : la nature exacte de l''action produite d\00E9pend du module d''extension en cours.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048856328306368)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code d''initialisation JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101573505470305993)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut du th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014561666306342)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilise le param\00E8tre d\00E9fini dans les valeurs par d\00E9faut de th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190475190305688)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la transition utilis\00E9e lors de l''ouverture d''une fen\00EAtre instantan\00E9e.</p>'),
'<p>Les anciens navigateurs, ne prenant pas en charge les transformations 3D, ne peuvent pas utiliser la plupart des transitions.',
unistr('Par d\00E9faut, les appareils ne prenant pas en charge la 3D (comme Android 2.x) basculent en mode fondu pour tous les types de transition.'),
'Pour plus d''informations, consultez la documentation jQuery Mobile.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703367692306096)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'fr'
,p_message_text=>'Fondu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703492148306096)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Retourn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703517890306096)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'fr'
,p_message_text=>'Flux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703213651306096)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703600265306096)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e brusque')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703785930306096)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'fr'
,p_message_text=>'Balayage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703823422306097)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placement vers le bas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101703991187306097)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'fr'
,p_message_text=>'Balayage en fondu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704070255306097)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placement vers le haut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101704194254306097)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'fr'
,p_message_text=>'Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101190338001305688)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Transition de fen\00EAtre instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283402387305775)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le nom de la proc\00E9dure que doit ex\00E9cuter la proc\00E9dure de connexion &PRODUCT_NAME. (API de connexion) apr\00E8s l''\00E9tape d''authentification (v\00E9rification des informations d''identification).'),
unistr('La proc\00E9dure de connexion ex\00E9cute ce code apr\00E8s les op\00E9rations de proc\00E9dure de connexion normales (d\00E9finition d''un cookie et inscription de la session) et juste avant le r\00E9acheminement vers la page d''application voulue.'),
unistr('La proc\00E9dure peut \00EAtre d\00E9finie dans l''attribut de code PL/SQL ou dans la base de donn\00E9es.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283331369305775)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de proc\00E9dure de postauthentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210878876305721)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez une expression PL/SQL pour affiner la valeur de l''\00E9l\00E9ment.</p>'),
unistr('<p> Par exemple, si l''\00E9l\00E9ment est nomm\00E9 <code>P1_X</code>, vous pouvez utiliser des expressions post-calcul telles que <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X, :P2_Y - 200)</code>, <code>NVL(:P1_X, :P2_Y)</code>, ou un')
||unistr(' appel de fonction tel que <code>my_func(:P1_X);</code> afin d''obtenir la valeur finale de l''\00E9l\00E9ment.'),
unistr('A noter que ces exemples montrent que les expressions peuvent r\00E9f\00E9rencer l''\00E9l\00E9ment en cours ou tout autre \00E9l\00E9ment du statut de session.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210757756305721)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Traitement post-calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283822572305775)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''URL vers laquelle l''application est redirig\00E9e une fois que le nettoyage de la session utilisateur a \00E9t\00E9 effectu\00E9 par &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283790532305775)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('URL apr\00E8s d\00E9connexion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960848611306300)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961133848306300)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961008552306300)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960968631306300)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961249473306300)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960754358306300)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962027589306301)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Java, avec lequel la requ\00EAte SQL renvoy\00E9e transforme les donn\00E9es extraites de la source Web. La requ\00EAte SQL renvoy\00E9e par le corps de fonction Java doit effectuer une s\00E9lection dans la pseudo-table #APEX$SOURCE_DATA# et ')
||unistr('lire les colonnes disponibles dans le profil de donn\00E9es. La factorisation de sous-requ\00EAtes au moyen de la clause SQL WITH n''est pas prise en charge dans le cas pr\00E9sent. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961952400306301)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Java renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961860754306301)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>S\00E9lectionnez les colonnes EMPNO, ENAME et SAL, et filtrez toutes les lignes contenant une valeur SAL inf\00E9rieure \00E0 3 000.</dt>'),
'<dd<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961706816306301)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction JavaScript, avec lequel la requ\00EAte SQL renvoy\00E9e transforme les donn\00E9es extraites de la source Web. La requ\00EAte SQL renvoy\00E9e par le corps de fonction JavaScript doit effectuer une s\00E9lection dans la pseudo-table #APEX$SOUR')
||unistr('CE_DATA# et lire les colonnes disponibles dans le profil de donn\00E9es. La factorisation de sous-requ\00EAtes au moyen de la clause SQL WITH n''est pas prise en charge dans le cas pr\00E9sent. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961639277306301)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction JavaScript renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016368069306344)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Permet d''afficher les nouvelles embauches en premier et les personnes qui n''ont pas encore \00E9t\00E9 embauch\00E9es en dernier. Si la date d''embauche est la m\00EAme, triez-les par num\00E9ro de d\00E9partement.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016245370306344)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez des noms de colonne s\00E9par\00E9s par des virgules, y compris des directives, pour d\00E9finir l''ordre dans lequel les enregistrements sont extraits.</p>'),
'        <p>Directives possibles :',
'          <ul>',
'            <li>ASC : renvoyer les colonnes dans l''ordre croissant</li>',
unistr('            <li>DESC : renvoyer les colonnes dans l''ordre d\00E9croissant</li>'),
'            <li>NULLS FIRST : renvoyer les colonnes sans valeur avant celles contenant des valeurs</li>',
'            <li>NULLS LAST : renvoyer les colonnes contenant des valeurs avant celles sans valeur</li>',
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016126608306344)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Trier par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961541630306301)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>S\00E9lectionnez les colonnes EMPNO, ENAME et SAL, et filtrez toutes les lignes contenant une valeur SAL inf\00E9rieure \00E0 3 000.</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961474122306301)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL, avec lequel la requ\00EAte SQL renvoy\00E9e transforme les donn\00E9es extraites de la source Web. La requ\00EAte SQL renvoy\00E9e par le corps de fonction PL/SQL doit effectuer une s\00E9lection dans la pseudo-table #APEX$SOURCE_DATA#')
||unistr(' et lire les colonnes disponibles dans le profil de donn\00E9es. La factorisation de sous-requ\00EAtes au moyen de la clause SQL WITH n''est pas prise en charge dans le cas pr\00E9sent. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101961354621306301)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962242382306301)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Python, avec lequel la requ\00EAte SQL renvoy\00E9e transforme les donn\00E9es extraites de la source Web. La requ\00EAte SQL renvoy\00E9e par le corps de fonction Python doit effectuer une s\00E9lection dans la pseudo-table #APEX$SOURCE_DATA#')
||unistr(' et lire les colonnes disponibles dans le profil de donn\00E9es. La factorisation de sous-requ\00EAtes au moyen de la clause SQL WITH n''est pas prise en charge dans le cas pr\00E9sent. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962142387306301)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Python renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017898052306345)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>S\00E9lectionnez les colonnes EMPNO, ENAME et SAL, et filtrez toutes les lignes contenant une valeur SAL inf\00E9rieure \00E0 3 000.</dt>'),
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016557414306344)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour transformer les donn\00E9es extraites de la source de donn\00E9es REST. Effectuez une s\00E9lection dans la pseudo-table #APEX$SOURCE_DATA# et indiquez les colonnes disponibles dans le profil de donn\00E9es. La factorisation de sous-re')
||unistr('qu\00EAtes au moyen de la clause SQL WITH n''est pas prise en charge dans le cas pr\00E9sent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016469334306344)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102016040995306343)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Inclut uniquement les employ\00E9s qui ont un responsable ou qui travaillent comme commerciaux.</dt>'),
'<dd><pre>',
'( MGR n''est pas NULL ou JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015933694306343)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une condition SQL WHERE valide, afin de limiter les enregistrements extraits.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015804027306343)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Clause WHERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283260591305775)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nom d''une proc\00E9dure \00E0 ex\00E9cuter apr\00E8s la soumission de la page de connexion et juste avant la v\00E9rification des informations d''identification.'),
unistr('Vous pouvez d\00E9finir cette proc\00E9dure dans l''attribut de code PL/SQL ou dans la base de donn\00E9es.</p>'),
unistr('<p>Les mod\00E8les d''authentification pour lesquels la v\00E9rification des informations d''identification de l''utilisateur est effectu\00E9e en dehors de &PRODUCT_NAME. n''ex\00E9cutent g\00E9n\00E9ralement pas la proc\00E9dure avant l''authentification.'),
unistr('Exemples : <em>Variable d''en-t\00EAte HTTP</em>, <em>Oracle Application Server Single Sign-On</em> et les mod\00E8les d''authentification personnalis\00E9s qui utilisent <code>apex_authentication.post_login</code> au lieu de <code>apex_authentication.login</code>')
||'.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101283122214305775)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de proc\00E9dure de pr\00E9authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587179339306003)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne qui contient la cl\00E9 primaire pour la table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587077865306003)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751708246306132)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664757693306060)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher la bordure de l''attribut indiqu\00E9.</p>'),
unistr('<p>La couleur est sp\00E9cifi\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et ')
||unistr('zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664671055306060)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de bordure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664573884306060)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez la largeur des bordures de table en pixels.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664467981306060)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur de la bordure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788841860306160)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667958138306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher l''arri\00E8re-plan de ce composant.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667868719306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur d''arri\00E8re-plan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753846189306134)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667758759306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher ce composant.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667694793306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667188505306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un style de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753534121306134)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753322494306134)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753416092306134)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667059704306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667595294306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une taille de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667458918306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667393703306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une \00E9paisseur de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753725987306134)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'fr'
,p_message_text=>'Gras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753687141306134)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101667279743306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Epaisseur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101788780168306160)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666936452306062)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher l''arri\00E8re-plan de ce composant.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666838671306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur d''arri\00E8re-plan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753224601306134)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666778192306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher ce composant.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666687678306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666194662306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un style de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752958150306133)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752779251306133)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752843834306133)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666065168306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666516443306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une taille de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666494964306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666346616306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une \00E9paisseur de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753191941306133)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'fr'
,p_message_text=>'Gras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753029565306133)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101666210165306061)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Epaisseur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555716506305979)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la largeur de colonne utilis\00E9e pour dimensionner la colonne lorsque l''\00E9tat est imprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101555651088305979)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur d''impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670527278306072)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez les unit\00E9s utilis\00E9es pour d\00E9finir les valeurs de largeur de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755301539306135)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755464796306135)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'fr'
,p_message_text=>'Point'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670407541306072)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Unit\00E9s de largeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669759020306071)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le nom \00E0 attribuer au document t\00E9l\00E9charg\00E9 en local. Si vous laissez ce champ vide, le nom de r\00E9gion sera utilis\00E9 comme nom de fichier.'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669640731306071)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664334710306060)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez la hauteur de cette page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664237729306060)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671152521306072)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le texte du lien de t\00E9l\00E9chargement en local. Pour remplacer le lien par un autre composant de navigation, comme un bouton, laissez ce champ vide. Vous pouvez configurer l''autre composant pour d\00E9marrer le processus d''impression \00E0 l''aide d')
||'''une URL avec la syntaxe suivante pour la cible : </p>',
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
unistr('</p><strong>Remarque :</strong> remplacez <code>[REGION_ID]</code> dans la cha\00EEne ci-dessus par votre ID de r\00E9gion.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671078635306072)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663762937306059)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''orientation de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751298703306132)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'fr'
,p_message_text=>'Paysage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751112478306132)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'fr'
,p_message_text=>'Portrait'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663691212306059)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670639499306072)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river de l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671283647306072)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9river de l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669940636306071)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le format de sortie d''\00E9tat. Vous pouvez \00E9galement sp\00E9cifier le format de sortie \00E0 l''aide d''un \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755115811306135)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'fr'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754826474306135)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'fr'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754905164306135)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'fr'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755033373306135)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'fr'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755206145306135)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'fr'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669826888306071)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670101818306072)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez l''\00E9l\00E9ment de page ou d''application qui contient la valeur de format. Vous pouvez inclure un \00E9l\00E9ment de page de <em>liste de s\00E9lection</em> pour que les utilisateurs s\00E9lectionnent le format de sortie au moment de l''ex\00E9cution. Les valeurs ')
||'valides sont les suivantes.</p>',
'<dl>',
'<dt>PDF</dt>',
unistr('<dd>Ouvre le document dans un aper\00E7u PDF</dd>'),
'<dt>RTF</dt>',
'<dd>Ouvre le document dans Microsoft Word</dd>',
'<dt>XLS</dt>',
'<dd>Ouvre le document dans Microsoft Excel</dd>',
'<dt>HTM</dt>',
unistr('<dd>T\00E9l\00E9charge le document en tant que fichier HTML</dd>'),
'<dt>XML</dt>',
unistr('<dd>T\00E9l\00E9charge le document en tant que fichier XML</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670022847306072)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de format')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668926821306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''alignement du pied de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754648831306135)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754581367306134)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754794651306135)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668872762306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alignement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754451416306134)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668781280306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher ce composant.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668649325306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668199209306062)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un style de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754179001306134)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101753966143306134)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754012429306134)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668061937306062)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668502935306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une taille de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668412754306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668386069306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une \00E9paisseur de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754339109306134)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'fr'
,p_message_text=>'Gras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101754282259306134)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101668206754306062)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Epaisseur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669143420306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte devant figurer dans la section de pied du document. Pour afficher les valeurs des \00E9l\00E9ments de page ou d''application, utilisez la syntaxe <code>&amp;ITEM_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101669016419306063)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte de pied de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665701343306061)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''alignement de l''en-t\00EAte de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752508960306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752460386306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752680932306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665661696306061)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Alignement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752366668306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML :',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu marine&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665598490306061)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour afficher ce composant.</p>'),
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665436642306061)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Couleur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664933804306060)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un style de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752053671306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'fr'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751853155306132)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'fr'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751938647306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'fr'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664812322306060)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665380743306060)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une taille de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665237218306060)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665140562306060)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une \00E9paisseur de police pour ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752281932306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'fr'
,p_message_text=>'Gras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101752149033306133)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'fr'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665096624306060)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Epaisseur de police'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665943523306061)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte devant figurer dans la section d''en-t\00EAte du document. Pour afficher les valeurs des \00E9l\00E9ments de page ou d''application, utilisez la syntaxe <code>&amp;ITEM_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101665869445306061)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte d''en-t\00EAte de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663500668306059)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la taille de la page d''\00E9tat. Pour saisir vos propres largeur et hauteur, s\00E9lectionnez <strong>Personnalis\00E9</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750958835306132)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'fr'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750833271306132)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'fr'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751083479306132)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750627640306132)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L\00E9gal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750559129306131)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'fr'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750747968306132)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Tablo\00EFd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663475732306059)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663971584306060)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez les unit\00E9s utilis\00E9es pour indiquer la largeur et la hauteur de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751561209306132)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Centim\00E8tres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751305105306132)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'fr'
,p_message_text=>'Pouces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751404819306132)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Millim\00E8tres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101751659621306132)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'fr'
,p_message_text=>'Points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663805343306059)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Unit\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663318715306059)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la disposition de contenu du document imprim\00E9. La disposition du contenu est une extension du protocole MIME qui indique au navigateur le mode d''affichage du document. La s\00E9lection de l''option <strong>Pi\00E8ce jointe</strong> indique au nav')
||unistr('igateur qu''il doit enregistrer le fichier sur le disque plut\00F4t que d''utiliser l''affichage incorpor\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750391752306131)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101750477237306131)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'fr'
,p_message_text=>'Incorporation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101663200452306059)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Visualiser le fichier comme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664147394306060)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez la largeur de cette page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101664062867306060)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Largeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023779315305563)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion de panneau associ\00E9e pour cet \00E9l\00E9ment de page.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101023696212305563)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion de panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541078588305966)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''emplacement d''affichage de ce message d''erreur de processus, lorsque le processus ne parvient pas \00E0 se terminer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730938558306117)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'fr'
,p_message_text=>'Incorporation dans une notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731045639306117)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le message d''erreur de processus est affich\00E9 dans la zone Notification (d\00E9finie dans le mod\00E8le de page)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731189802306117)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page d''\00E9v\00E9nement d''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101731210417306117)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le message d''erreur de processus est affich\00E9 sur la page d''erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540950677305966)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Emplacement d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204998502305717)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez \00E0 quel moment du rendu ou du traitement de la page ce processus est ex\00E9cut\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716570032306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008424970306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 apr\00E8s le rendu des r\00E9gions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716790653306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s pied')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008684134306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 apr\00E8s le rendu de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716395312306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008246905306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 apr\00E8s le rendu de l''en-t\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716935094306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'fr'
,p_message_text=>'Traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008891674306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : est ex\00E9cut\00E9 apr\00E8s les validations et les calculs lors du traitement de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716490026306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008344881306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 avant le rendu des r\00E9gions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716671068306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'fr'
,p_message_text=>'Avant pied'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008564757306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 avant le rendu du pied de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716279777306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Avant en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008162129306337)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage : est ex\00E9cut\00E9 avant le rendu de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101717072789306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'fr'
,p_message_text=>'Fonction callback AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008976093306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Est ex\00E9cut\00E9 lors d''un appel effectu\00E9 par les API JavaScript apex.server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716138479306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008097713306337)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Est ex\00E9cut\00E9 lors de la g\00E9n\00E9ration d''une nouvelle session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101716838245306106)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s soumission')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102008728640306338)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement : est ex\00E9cut\00E9 apr\00E8s la soumission de la page, mais avant l''ex\00E9cution des calculs, des validations et des traitements de la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101204800704305717)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Point'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541297648305966)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion \00E0 associer \00E0 ce processus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541100473305966)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion modifiable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419583628305877)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le d''autorisation pour contr\00F4ler les utilisateurs autoris\00E9s \00E0 enregistrer des d\00E9finitions d''\00E9tat public.'),
unistr('		Pour autoriser un utilisateur final \00E0 enregistrer un \00E9tat public, l''\00E9valuation de ce mod\00E8le d''autorisation doit donner la valeur TRUE pour cet utilisateur.</p>'),
unistr('		Remarque : si aucun mod\00E8le d''autorisation n''est indiqu\00E9, les \00E9tats publics peuvent \00EAtre enregistr\00E9s par n''importe quel utilisateur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101419456466305876)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer l''autorisation d''\00E9tat public')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789705444306161)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('$$$ DJP actuellement masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580438926305998)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de requ\00EAte de colonne d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212007212305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la premi\00E8re <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211931558305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212423187305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la seconde <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212323568305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212814720305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la troisi\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212732142305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213243319305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la quatri\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213165322305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213674966305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la cinqui\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213539657305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214086657305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la sixi\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213970206305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214427365305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la septi\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214393860305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214876233305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la huiti\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214768152305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215212910305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la neuvi\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215177176305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215695262305725)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 pour la dixi\00E8me <strong>s\00E9lection rapide</strong>. Il s''agit du texte que voit l''utilisateur final de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215534337305725)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211815937305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les attributs HTML associ\00E9s \00E0 l''affichage de chaque lien <strong>S\00E9lection rapide</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211730996305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212225803305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la premi\00E8re <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212121675305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212619097305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la seconde <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212510219305722)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213093366305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la troisi\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101212985681305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213476896305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la quatri\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213340025305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213825982305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la cinqui\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101213704686305723)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214264863305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la sixi\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214161769305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214697587305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la septi\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214512047305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215029263305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la huiti\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101214907236305724)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215432798305725)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la neuvi\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215339038305725)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215857910305725)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur associ\00E9e \00E0 la dixi\00E8me <strong>s\00E9lection rapide</strong>. Cette valeur remplace la valeur d''\00E9l\00E9ment existante lorsque l''utilisateur clique sur cette s\00E9lection rapide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215779295305725)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553989076305978)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nombre de colonnes \00E0 afficher pour cette colonne de groupe de boutons d''option.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553832280305978)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285071104305776)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la liste des r\00F4les dynamiques Real Application Security, s\00E9par\00E9s par des signes deux-points, comme :'),
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. active ces r\00F4les lors de la connexion en les transmettant via le param\00E8tre <em>enable_dynamic_roles</em> de <em>sys.dbms_xs_sessions.assign_user</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284912740305776)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4les dynamiques')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284889385305776)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la fa\00E7on dont Oracle Real Application Security (RAS) est utilis\00E9 dans cette application.</p>'),
unistr('<p>Si vous activez le mode RAS, assurez-vous que les utilisateurs disposent de privil\00E8ges permettant d''acc\00E9der aux objets de sch\00E9ma de l''application.'),
unistr('Par exemple, avec des <strong>utilisateurs externes</strong>, vous pouvez accorder des privil\00E8ges de base de donn\00E9es \00E0 un <em>r\00F4le d''application dynamique RAS</em> et le configurer dans ce mod\00E8le d''authentification en tant que <em>r\00F4le dynamique</em>')
||'.',
unistr('Vous pouvez \00E9galement activer des r\00F4les via un appel \00E0 <em>apex_authorization.enable_dynamic_groups</em>, par exemple dans une proc\00E9dure post-authentification.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718133252306107)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009051265306338)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Real Application Security n''est pas utilis\00E9 dans l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718298572306107)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs externes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009179287306338)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('&PRODUCT_NAME. part du principe que tous les utilisateurs sont internes et transmet <em>false</em> via le param\00E8tre <em>is_external</em> \00E0 <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101718336266306107)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs internes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009253322306338)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('&PRODUCT_NAME. transmet <em>true</em> via le param\00E8tre <em>is_external</em> \00E0 <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284745713305776)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Mode RAS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285275246305776)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la liste des mod\00E8les d''espace de noms Real Application Security, s\00E9par\00E9s par des signes deux-points, comme :'),
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. active ces espaces de noms lors de la connexion en les transmettant via le param\00E8tre <em>namespaces</em> de <em>sys.dbms_xs_sessions.assign_user</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285198945305776)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Espaces de noms'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934091300306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934469349306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934302778306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934206924306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934549360306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934106635306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933991800306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936036160306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936391862306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936274378306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936186502306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936405404306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935953160306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222232892305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222159028305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223608947305731)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 dans cette condition. Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223510622305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935672801306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Java pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935557526306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937215978306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Java qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937133615306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935405753306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935316350306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression JavaScript pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935218785306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937021334306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936946069306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction JavaScript qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936823177306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222469787305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste de valeurs s\00E9par\00E9es par un signe deux-points (:) pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222330936305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222831182305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le num\00E9ro de page pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222777280305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223061203305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la liste des num\00E9ros de page s\00E9par\00E9s par des virgules pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222902310305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935190268306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 ou :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935057241306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression PL/SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934912434306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936702401306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936655768306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101936581964306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222697821305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une pr\00E9f\00E9rence utilisateur compar\00E9e \00E0 la valeur sp\00E9cifi\00E9e pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222551759305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935805956306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression Python pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101935704439306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937429217306276)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Python qui renvoie une valeur bool\00E9enne pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101937361629306275)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934821703306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934715539306274)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez une expression SQL pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101934627163306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084392515306395)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir le renvoi de valeurs alors que des lignes existent lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Pour r\00E9ussir le renvoi de valeurs alors qu''aucune ligne n''existe lorsque vous v\00E9rifiez si l''employ\00E9 est dans le service 40, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221850813305729)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221716943305729)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223265701305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une valeur de texte pour cette condition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223164517305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223899945305731)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223738504305731)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432742767305886)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un type de condition \00E0 remplir pour que ce composant apparaisse en lecture seule.'),
unistr('Si vous ne choisissez pas de condition, l''\00E9l\00E9ment sera affich\00E9 normalement.'),
unistr('Un \00E9l\00E9ment en lecture seule est affich\00E9 avec les m\00EAmes param\00E8tres qu''un \00E9l\00E9ment non modifiable.</p>'),
unistr('<p>Remarque : d\00E9finissez le type de condition sur <strong>Jamais</strong> pour toujours afficher l''\00E9l\00E9ment sous la forme d''un champ o\00F9 la saisie est possible.'),
unistr('Ce param\00E8tre passe outre toutes les conditions de lecture seule au niveau de la r\00E9gion ou de la page.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836733361305418)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un type de condition \00E0 remplir pour que ce composant apparaisse en lecture seule.'),
unistr('Si vous ne choisissez pas de condition, l''\00E9l\00E9ment sera affich\00E9 normalement.'),
unistr('Un \00E9l\00E9ment en lecture seule est affich\00E9 avec les m\00EAmes param\00E8tres qu''un \00E9l\00E9ment non modifiable.</p>'),
unistr('<p>Remarque : d\00E9finissez le type de condition sur <strong>Jamais</strong> pour toujours afficher l''\00E9l\00E9ment sous la forme d''un champ o\00F9 la saisie est possible.'),
unistr('Ce param\00E8tre passe outre toutes les conditions de lecture seule au niveau de la r\00E9gion ou de la page.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287618628305778)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un type de condition qui doit \00EAtre rempli pour cette r\00E9gion afin que les \00E9l\00E9ments de page soient affich\00E9s en lecture seule.'),
unistr('Si vous ne choisissez pas de condition, les \00E9l\00E9ments de page seront affich\00E9s normalement.</p>'),
unistr('<p>Remarque : si vous voulez qu''un \00E9l\00E9ment de page de la r\00E9gion (par exemple, un champ de recherche) soit toujours affich\00E9 comme un \00E9l\00E9ment de page o\00F9 la saisie est possible, ind\00E9pendamment de l''\00E9valuation de la condition, vous devez d\00E9finir la condi')
||unistr('tion en lecture seule de l''\00E9l\00E9ment de page sur Jamais pour \00E9craser le param\00E8tre de r\00E9gion.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207562979305719)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un type de condition qui doit \00EAtre rempli pour cette page afin que les \00E9l\00E9ments de page soient affich\00E9s en lecture seule. Si vous ne choisissez pas de condition, les \00E9l\00E9ments de page sont affich\00E9s normalement.'),
unistr('La condition en lecture seule est \00E9valu\00E9e apr\00E8s l''ex\00E9cution des processus dont le point de traitement est <em>Avant en-t\00EAte</em>.</p>'),
unistr('<p>Remarque : si vous voulez que certains \00E9l\00E9ments de page (par exemple, un champ de recherche) ou que tous les \00E9l\00E9ments de page d''une r\00E9gion sp\00E9cifique soient toujours affich\00E9s comme des \00E9l\00E9ments de page o\00F9 la saisie est possible, ind\00E9pendants de l''')
||unistr('\00E9valuation de la condition, d\00E9finissez la condition en lecture seule de ces r\00E9gions/\00E9l\00E9ments de page sur <strong>Jamais</strong> pour \00E9craser le param\00E8tre parent.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776449920306151)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'fr'
,p_message_text=>'Toujours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101915962340306259)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le composant sera toujours affich\00E9 en lecture seule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775053849306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Microsoft Internet Explorer 7.0 ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775135446306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>'Le navigateur client est compatible XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774999472306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est Mozilla, Netscape 6.x/7x ou version sup\00E9rieure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775225945306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le navigateur client est diff\00E9rent (ou version ant\00E9rieure)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773697938306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Le texte est compris dans l''\00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775657412306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919538862306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775320798306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours est comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919711917306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final ex\00E9cute actuellement l''application dans une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775535363306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'Langue en cours != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919619103306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans la langue saisie dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775438232306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'fr'
,p_message_text=>'La langue en cours n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919804400306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''ex\00E9cute actuellement pas l''application dans l''une des langues saisies dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772858621306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours = Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918373109306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est \00E9gale \00E0 la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773097056306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918560658306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours se trouve dans la liste de pages s\00E9par\00E9es par des virgules saisie dans l''attribut <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772940939306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Page en cours != Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918405720306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours est diff\00E9rente de la valeur saisie dans l''attribut <em>Page</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773170337306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours n''est pas contenue dans une liste s\00E9par\00E9e par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918656577306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La page en cours ne se trouve pas dans la liste de pages s\00E9par\00E9es par des virgules saisie dans <em>Pages</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775758242306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775898686306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: DAD_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774503473306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e sont affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919342520306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e est affich\00E9e sur la page \00E0 la suite d''une soumission de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773904054306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773771000306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte est compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773817950306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Le texte n''est pas compris dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774097473306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Texte != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770594283306146)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes renvoy\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916035138306259)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL renvoie au moins une ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933725307306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101933869153306273)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>'L''expression renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770731764306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916294928306259)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Le corps de fonction renvoie la valeur TRUE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776157374306151)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776219053306151)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774227767306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion n''est pas en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919096203306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le cas \00E9ch\00E9ant, la page et la r\00E9gion parent s''affichent normalement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774178649306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La page/r\00E9gion est en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918919131306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour la page ou la r\00E9gion parent, le cas \00E9ch\00E9ant, la condition Lecture seule renvoie la valeur TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772038215306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne contient aucun espace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917500790306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 ne contient pas d''espace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772308320306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est alphanum\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917840271306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est alphanum\00E9rique (elle contient uniquement des lettres ou des chiffres et aucun caract\00E8re sp\00E9cial).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771507320306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917033276306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772258374306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917700792306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771734846306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917266196306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771461599306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916953846306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771811615306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NULL ou \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917375620306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est vide ou \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772150503306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917627088306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771627752306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917148768306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771925362306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est ni NULL, ni \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917402496306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est ni vide, ni \00E9gale \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774761222306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'fr'
,p_message_text=>'Etats SQL (OK pour afficher le bouton Suivant)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774879868306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats SQL (OK pour afficher le bouton Pr\00E9c\00E9dent)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776338456306151)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'fr'
,p_message_text=>'Jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919990041306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le composant s''affiche normalement, ind\00E9pendamment de la condition Lecture seule d\00E9finie pour le(s) composant(s) parent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774664048306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Les erreurs de validation incorpor\00E9e ne sont pas affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919496310306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur de validation incorpor\00E9e n''est pas affich\00E9e sur la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770694196306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ligne n''a \00E9t\00E9 renvoy\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916120530306259)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte SQL ne renvoie aucune ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773465374306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours est en mode d''impression facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918721506306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours a \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773552548306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'fr'
,p_message_text=>'La page en cours n''est pas en mode d''impression facile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918831383306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode d''impression facile de la page en cours n''a pas \00E9t\00E9 activ\00E9 par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770876448306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916363676306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est identique au texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771049316306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande est comprise dans la valeur'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916584731306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page est comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101770960541306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'Demande != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916419522306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La demande de page est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771117961306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'La demande n''est pas comprise dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916688700306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'fr'
,p_message_text=>'La demande de page n''est pas comprise dans le texte saisi dans l''attribut <em>Valeur</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101775941762306150)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101776045522306151)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'fr'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774330366306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est authentifi\00E9 (utilisateur non public)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919164293306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final est connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101774412889306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur est public (utilisateur non authentifi\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101919274731306262)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur final n''est pas connect\00E9 \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772655201306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918156973306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> indiqu\00E9e est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772784815306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence utilisateur != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918210715306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la <em>pr\00E9f\00E9rence</em> indiqu\00E9e est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772485945306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101917942632306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101772515161306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas contenu dans une liste s\00E9par\00E9e par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101918058982306261)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771255136306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment = Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916799309306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est identique au texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101771308706306147)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101916848880306260)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9 est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773306882306149)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours != Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101773282636306148)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Page en cours = Page soumise (envoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101207498875305719)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101222068249305729)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur \00E0 comparer \00E0 la condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221954723305729)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223459605305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur, y compris les cha\00EEnes de substitution <code>&ITEM.</code>, pour cette condition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101223311207305730)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713663060306104)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216067680305725)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez les attributs inclus dans la balise <code>&lt;td&gt;</code> de cellule de tableau HTML d''\00E9l\00E9ment lors de l''affichage en mode lecture seule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101215916574305725)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Attributs HTML en lecture seule'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500660687305937)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''intervalle en secondes entre les mises \00E0 jour de graphique. Les tr\00E8s faibles intervalles de mise \00E0 jour, comme 2 secondes, sont d\00E9conseill\00E9s car ils peuvent entra\00EEner de s\00E9rieux probl\00E8mes de performances de la base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500594074305937)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Intervalle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500745558305937)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'fr'
,p_message_text=>'secondes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228387169305734)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion dans laquelle le bouton sera affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245623483305747)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucun parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836665932305417)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion dans laquelle l''\00E9l\00E9ment sera affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245566430305747)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucun parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221243529305729)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion dans laquelle ce composant est associ\00E9. Si le composant est affich\00E9, il appara\00EEt dans la r\00E9gion sp\00E9cifi\00E9e par rapport aux autres composants de cette r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101221166431305729)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286491597305777)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez <strong>Activ\00E9</strong> pour inclure cette r\00E9gion dans le s\00E9lecteur d''affichage de r\00E9gion.'),
unistr('Cet attribut est uniquement utilis\00E9 si un type de r\00E9gion de <em>s\00E9lecteur d''affichage de r\00E9gion</em> est d\00E9fini et peut \00EAtre visualis\00E9 sur la page.</p>'),
unistr('<p>Lorsqu''un utilisateur clique sur un nom de r\00E9gion inclus dans le s\00E9lecteur d''affichage de r\00E9gion, seule la r\00E9gion s\00E9lectionn\00E9e est affich\00E9e et toutes les autres r\00E9gions r\00E9pertori\00E9es sont masqu\00E9es.'),
unistr('La premi\00E8re entr\00E9e dans le s\00E9lecteur d''affichage de r\00E9gion est <em>Afficher tout</em>, qui permet \00E0 l''utilisateur d''afficher toutes les r\00E9gions disponibles, et pas uniquement la r\00E9gion pr\00E9c\00E9demment s\00E9lectionn\00E9e.</p>'),
unistr('<p>Si une r\00E9gion ne peut pas \00EAtre affich\00E9e, en fonction des conditions de r\00E9gion, elle n''est pas incluse dans les listes des r\00E9gions du s\00E9lecteur d''affichage de r\00E9gion.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286356974305777)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287220529305778)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une fonction PL/SQL qui renvoie une requ\00EAte SQL utilis\00E9e comme base pour cette r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287152439305778)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285423647305776)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le contenu ou la source de r\00E9gion, selon le <em>type de r\00E9gion</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285316589305776)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286695802305777)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez une r\00E9f\00E9rence \00E0 une image qui appara\00EEt dans la partie sup\00E9rieure gauche de la r\00E9gion. Vous ne pouvez pas contr\00F4ler la balise de tableau utilis\00E9e pour afficher cette image.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286568213305777)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Image de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580692702305998)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez la source du texte pour ce composant.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580550545305998)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281717809305774)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez la source SQL pour ce composant.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101281652669305774)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101286051182305777)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le de r\00E9gion pour d\00E9finir l''apparence et la mise en page de cette r\00E9gion.</p>'),
unistr('        <p>Les mod\00E8les de r\00E9gion sont d\00E9finis dans le th\00E8me d''application.'),
unistr('        Lors de la cr\00E9ation d''une r\00E9gion, le mod\00E8le est automatiquement d\00E9fini sur le mod\00E8le de r\00E9gion par d\00E9faut configur\00E9 dans le th\00E8me en cours.</p>'),
unistr('        <p>De nombreux th\00E8mes contiennent des mod\00E8les de r\00E9gion pour l''affichage d''\00E9tats, de panneaux, d''alertes, de boutons, de contenu r\00E9ductible (masquer/afficher), de panneaux de connexion, etc.<br>'),
unistr('        Le th\00E8me universel fournit les mod\00E8les de r\00E9gion suivants :'),
'          <dl>',
'            <dt>Alerte</dt>',
'            <dt>Vide avec des attributs</dt>',
'            <dt>Conteneur de boutons</dt>',
'            <dt>Conteneur de carrousel</dt>',
unistr('            <dt>R\00E9ductible</dt>'),
'            <dt>Bloc de contenu</dt>',
'            <dt>Hero</dt>',
unistr('            <dt>Bo\00EEte de dialogue Incorporation</dt>'),
unistr('            <dt>Fen\00EAtre instantan\00E9e incorpor\00E9e</dt>'),
'            <dt>Etat interactif</dt>',
'            <dt>Connexion</dt>',
'            <dt>Standard</dt>',
'            <dt>Conteneur d''onglets</dt>',
'            <dt>Barre de titre</dt>',
'            <dt>Conteneur d''assistant</dt>',
'          </dl>',
unistr('          Reportez-vous \00E9galement \00E0 : <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285980594305777)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101397665760305860)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le mode d''affichage de cette r\00E9gion. Les types de r\00E9gion suivants sont pris en charge :</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En fonction de la configuration de votre application, il se peut que des modules d''extension suppl\00E9mentaires de type R\00E9gion soient \00E9galement disponibles ici.'),
'Ces derniers apparaissent sous la forme <em>&lt;Mon module d''extension&gt; [Module d''extension]</em>.',
unistr('Les modules d''extension suivants sont install\00E9s dans les composants partag\00E9s de cette application :</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220587439305728)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659688279306056)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type d''\00E9galit\00E9 \00E0 tester pour cette validation. Selon votre choix, des attributs suppl\00E9mentaires sont obligatoires pour d\00E9finir totalement cette validation.</p>'),
unistr('<p>Si la validation r\00E9ussit le test d''\00E9galit\00E9 ou donne la valeur TRUE, le message d''erreur de validation n''appara\00EEt pas.'),
unistr('Les messages d''erreur de validation sont affich\00E9s lorsque la validation \00E9choue au test d''\00E9galit\00E9, l''\00E9valuation donne la valeur FALSE ou une cha\00EEne de texte non vide est renvoy\00E9e.</p>'),
unistr('<p>Un \00E9chec de validation ne met pas fin \00E0 l''\00E9valuation des validations suivantes. Par cons\00E9quent, chaque validation suivante doit d\00E9clencher un message d''erreur de validation suppl\00E9mentaire. Si vous voulez arr\00EAter l''ex\00E9cution des autres validations,')
||unistr(' vous devez ajouter une logique suppl\00E9mentaire \00E0 la premi\00E8re validation en \00E9chec, comme la d\00E9finition d''une valeur sp\00E9cifique pour un \00E9l\00E9ment de page, puis am\00E9liorer la logique conditionnelle des autres validations, selon vos besoins. Les processus e')
||unistr('t branchements suivants ne sont pas ex\00E9cut\00E9s si des validations \00E9chouent \00E0 l''\00E9valuation.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760304904306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes renvoy\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760401012306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la requ\00EAte SQL renvoie plusieurs lignes.<br>'),
unistr('Echec si la requ\00EAte SQL ne renvoie aucune ligne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967767978306306)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967825836306306)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si l''expression renvoie la valeur TRUE.<br>'),
'Echec si l''expression renvoie la valeur FALSE.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760965662306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction (renvoyant une valeur bool\00E9enne)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761028593306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si le corps de fonction renvoie la valeur TRUE.<br>'),
'Echec si le corps de fonction renvoie la valeur FALSE.<br>',
unistr('Remarque : le r\00E9sultat renvoy\00E9 \00E0 partir de la fonction doit \00EAtre de type Boolean.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761150444306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction (renvoyant un texte d''erreur)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761224435306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si le corps de fonction renvoie une cha\00EEne vide.<br>'),
unistr('Echec si le corps de fonction renvoie une cha\00EEne non vide. La cha\00EEne renvoy\00E9e appara\00EEt en tant que message d''erreur pour la validation.<br>'),
unistr('Remarque : le r\00E9sultat renvoy\00E9 \00E0 partir de la fonction doit \00EAtre une cha\00EEne de texte.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761948931306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'fr'
,p_message_text=>'La colonne ne contient aucun espace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762083149306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne ne contient pas d''espaces.<br>'),
'Echec si la valeur de colonne contient des espaces.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763954809306142)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne contient au moins un des caract\00E8res indiqu\00E9s dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764027715306142)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne comprend au moins un caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur de colonne ne comprend aucun caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764191473306142)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne ne contient aucun des caract\00E8res indiqu\00E9s dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764204905306142)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne ne comprend aucun caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur de colonne comprend au moins un caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763766623306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne contient uniquement les caract\00E8res indiqu\00E9s dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763872763306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne contient uniquement les caract\00E8res du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur de colonne contient des caract\00E8res qui ne se trouvent pas dans le texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762983825306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne = Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763062419306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne est identique au texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur de colonne est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763351970306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>'La colonne est contenue dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763497579306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur de colonne n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763155763306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne != Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763240120306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
'Echec si la valeur de colonne est identique au texte saisi dans l''attribut <em>Valeur</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763500105306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>'La colonne n''est pas contenue dans la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101763623492306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur de colonne est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762124681306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne est alphanum\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762222261306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne est alphanum\00E9rique (elle contient uniquement des lettres, des chiffres et aucun caract\00E8re sp\00E9cial).<br>'),
unistr('Echec si la valeur de colonne comporte des caract\00E8res sp\00E9ciaux.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762510766306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'fr'
,p_message_text=>'La colonne est une date valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762668137306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne est une date valide.<br>'),
'Echec si la valeur de colonne n''est pas une date valide.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762372396306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne est num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762473128306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne est num\00E9rique.<br>'),
unistr('Echec si la valeur de colonne contient des caract\00E8res non num\00E9riques, y compris des espaces, autres que les espaces de d\00E9but.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762706764306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'fr'
,p_message_text=>'La colonne est un horodatage valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101762866040306141)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne est un horodatage valide.<br>'),
'Echec si la valeur de colonne n''est pas un horodatage valide.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761361583306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>'La colonne est NOT NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761425331306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne n''est pas vide.<br>'),
'Echec si la valeur de colonne est vide.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761561403306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne est NOT NULL ou \00E9gale \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761698170306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne n''est pas vide et n''est pas \00E9gale \00E0 z\00E9ro.<br>'),
unistr('Echec si la valeur de colonne est vide ou est \00E9gale \00E0 z\00E9ro.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761731530306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne n''est pas \00E9gale \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101761853305306140)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne n''est pas \00E9gale \00E0 z\00E9ro.<br>'),
unistr('Echec si la valeur de colonne est \00E9gale \00E0 z\00E9ro.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760547116306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ligne n''a \00E9t\00E9 renvoy\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760617794306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la requ\00EAte SQL ne renvoie aucune ligne.<br>'),
unistr('Echec si la requ\00EAte SQL renvoie plusieurs lignes.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760755896306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'fr'
,p_message_text=>'Erreur PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760813024306139)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si le code PL/SQL est ex\00E9cut\00E9 sans g\00E9n\00E9rer d''erreur.<br>'),
unistr('Echec si l''expression PL/SQL g\00E9n\00E8re une erreur lors de son ex\00E9cution.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764311168306142)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne correspond \00E0 une expression r\00E9guli\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101764489349306142)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur de colonne correspond \00E0 l''expression r\00E9guli\00E8re saisie dans l''attribut <em>Valeur</em>.'),
unistr('Echec si la valeur de colonne ne correspond pas \00E0 l''expression r\00E9guli\00E8re saisie dans l''attribut <em>Valeur</em>.<br>'),
unistr('Remarque : les expressions r\00E9guli\00E8res permettent de rechercher des mod\00E8les dans les donn\00E9es de cha\00EEne \00E0 l''aide de conventions syntaxiques standardis\00E9es, plut\00F4t qu''une simple comparaison de caract\00E8res.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659502541306056)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660244652306057)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un nom de colonne (respect maj/min) pour cette validation. Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des colonnes disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660110683306057)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969632340306307)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970044308306308)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969974084306308)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969878275306308)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970118245306308)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969716491306308)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969595680306307)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971694361306309)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971962339306309)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971819621306309)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971774122306309)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972080324306309)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971523652306309)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968094697306306)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968318066306306)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968235179306306)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968157755306306)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968411667306306)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967949380306306)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971269132306309)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Java pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971177920306309)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972856866306310)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Java qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972772761306310)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969200933306307)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Java qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969195539306307)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971093480306309)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970960610306309)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression JavaScript pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970823135306308)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972664693306310)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972531423306310)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction JavaScript qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972488486306310)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969047107306307)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer le message d''erreur indiqu\00E9, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968972918306307)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction JavaScript qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968852333306307)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084180938306395)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer l''erreur indiqu\00E9e, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660063206306057)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression PL/SQL qui d\00E9clenche une erreur comme base pour cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659982140306057)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Code PL/SQL g\00E9n\00E9rant une erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970784436306308)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970667271306308)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression PL/SQL pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970573930306308)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972313967306310)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972239551306310)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction PL/SQL qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972133192306309)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968791288306307)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer le message d''erreur indiqu\00E9, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968668486306307)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction PL/SQL qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101968541418306306)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971464959306309)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Python pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101971332129306309)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973069485306310)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Python qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101972990008306310)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969451987306307)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Python qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101969307751306307)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660688597306057)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression r\00E9guli\00E8re utilis\00E9e pour concorder avec la colonne indiqu\00E9e pour cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660555491306057)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Expression r\00E9guli\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970441211306308)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est un responsable ou que le service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970353081306308)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression SQL pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101970288915306308)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102084055394306395)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour <strong>Lignes renvoy\00E9es</strong>, pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Pour <strong>Aucune ligne renvoy\00E9e</strong, pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 40, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659862449306057)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour d\00E9finir cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659758774306057)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660466219306057)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur \00E0 comparer \00E0 la valeur de la colonne indiqu\00E9e pour cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101660339860306057)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674027001306074)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014639080306342)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('H\00E9rite du param\00E8tre d\00E9fini par rapport \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673922286306074)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cet attribut pour contr\00F4ler si &PRODUCT_NAME. doit prendre en charge les URL d''application qui ne contiennent pas d''ID de session.'),
unistr('Lorsque l''option Rejoindre des sessions est activ\00E9e, &PRODUCT_NAME. tente d''utiliser le cookie de session pour rejoindre une session existante, lorsqu''une URL ne contient pas d''ID de session.'),
'</p>',
unistr('<p>Un param\00E8tre de niveau instance plus restrictif remplace la valeur de niveau page.'),
'</p>',
unistr('<p><em><strong>Remarque :</em></strong> l''activation de l''option Rejoindre des sessions expose votre application \00E0 de possibles failles de s\00E9curit\00E9,'),
unistr('car cela peut permettre \00E0 des individus malveillants de prendre le contr\00F4le des sessions d''utilisateur final existantes.'),
'Pour en savoir plus, reportez-vous aux sections <em>Rejoin Sessions</em> du chapitre "Managing Application Security" dans le manuel App Builder User''s Guide.',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755509608306135)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755617206306135)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Si l''URL ne contient aucun ID de session, &PRODUCT_NAME. cr\00E9e une session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755796264306135)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9 pour les sessions publiques')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755853010306135)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si l''URL acc\00E8de \00E0 une page publique et ne contient pas d''ID de session, &PRODUCT_NAME. tente d''utiliser le cookie de session existant \00E9tabli pour cette application.'),
unistr('Pour les applications contenant des pages publiques et authentifi\00E9es, un ID de session est d\00E9fini une fois l''utilisateur final authentifi\00E9.'),
unistr('&PRODUCT_NAME. ne rejoint la session via le cookie que lorsque celle-ci n''est pas encore authentifi\00E9e.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101755953490306136)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9 pour toutes les sessions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756066178306136)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si l''URL ne contient pas d''ID de session, &PRODUCT_NAME. tente d''utiliser le cookie de session existant \00E9tabli pour cette application, si les conditions suivantes sont remplies :</p>'),
'<p><ul>',
unistr('  <li>La protection de statut de session est activ\00E9e pour l''application et l''URL inclut un checksum valide.'),
unistr('    Pour les signets publics, le niveau de protection d''\00E9l\00E9ment le plus restrictif doit \00EAtre <em>Non restreint</em> ou <em>Checksum requis - niveau application</em>.</li>'),
unistr('  <li>Ou l''URL ne contient pas de donn\00E9es trait\00E9es (paires de valeurs de donn\00E9es, effacement du cache ou param\00E8tre de demande).</li>'),
'</ul></p>',
unistr('<p>Ce param\00E8tre exige \00E9galement que l''option <em>Imbriquer dans des cadres</em> soit d\00E9finie sur <em>Autoriser \00E0 partir de la m\00EAme origine</em> ou sur <em>Refuser</em> pour l''application.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673876480306074)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Rejoindre des sessions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601963335306014)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez cette option lorsque la page doit \00EAtre recharg\00E9e apr\00E8s la soumission d''une page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602056019306015)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'fr'
,p_message_text=>'Toujours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602172939306015)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Toujours recharger la page pour afficher les erreurs et le message de succ\00E8s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602293805306015)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Seulement en cas de succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101602384361306015)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichez dynamiquement des erreurs sans recharger la page, mais rechargez-la apr\00E8s le succ\00E8s d''un traitement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101601867876306014)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Recharger apr\00E8s soumission')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983312553306318)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983479090306318)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es ne sont pas mises en m\00E9moire cache et sont demand\00E9es \00E0 chaque fois.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856003538306211)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856157425306211)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es ne sont pas mises en m\00E9moire cache et sont demand\00E9es \00E0 chaque fois.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293457213305782)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293517639305782)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les r\00E9sultats ne sont pas mis en cache. Les donn\00E9es sont extraites de la base de donn\00E9es distante pour chaque demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291689738305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez la mani\00E8re dont le moteur &PRODUCT_NAME. peut mettre en cache des donn\00E9es dans la base de donn\00E9es locale.'),
unistr('        Si la mise en cache est possible, le rendu du composant d\00E9pend des r\00E9sultats mis en cache plut\00F4t que d''une extraction \00E0 partir de la base de donn\00E9es distante.'),
unistr('        Les r\00E9sultats mis en cache am\00E9liorent consid\00E9rablement les performances, surtout en cas de latence entre la base de donn\00E9es locale et la base de donn\00E9es distante.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291766175305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'fr'
,p_message_text=>'Pour tous les utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291848539305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le r\00E9sultat est mis en m\00E9moire cache et employ\00E9 par tous les utilisateurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292103354305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Par session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292271650305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le r\00E9sultat est mis en cache sp\00E9cifiquement pour chaque session utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291995137305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'fr'
,p_message_text=>'Par utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292052322305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le r\00E9sultat est mis en cache sp\00E9cifiquement pour chaque utilisateur, dans toutes les sessions.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291575640305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise en m\00E9moire cache')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292594754305782)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Faire expirer les donn\00E9es 15 minutes apr\00E8s leur mise en cache</dt>'),
'  <dd><pre>15</pre></dd>',
unistr('<dt>Faire expirer les donn\00E9es \00E0 la prochaine heure pile</dt>'),
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
unistr('<dt>Faire expirer les donn\00E9es \00E0 minuit</dt>'),
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292417538305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le moment o\00F9 les donn\00E9es mises en cache doivent \00EAtre invalid\00E9es.'),
unistr('        Indiquez le nombre de minutes ou une cha\00EEne de calendrier DBMS_SCHEDULER.</p>'),
unistr('        <p>Pour la cha\00EEne de calendrier DBMS_SCHEDULER, vous pouvez d\00E9finir que les donn\00E9es mises en cache sont invalid\00E9es \00E0 chaque heure pile, \00E0 minuit ou \00E0 tout autre point de r\00E9currence particulier.'),
unistr('        Pour plus d''informations, reportez-vous \00E0 la documentation sur DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292319116305781)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9lai d''expiration de cache')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529581376305957)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez un alias alphanum\00E9rique pour cette r\00E9gion d''\00E9tat interactif.'),
unistr('L''alias doit \00EAtre unique dans l''application.'),
unistr('Vous pouvez utiliser un alias pour r\00E9f\00E9rencer ce type de r\00E9gion dans votre appel d''API personnalis\00E9.'),
unistr('Par exemple, vous pouvez \00E9crire une fonction pour renvoyer <code>INTERACTIVE_REPORT_ID</code> en interrogeant la colonne <code>ALIAS</code> de la vue <code>APEX_APPLICATION_PAGE_IR</code>.'),
unistr('La valeur <code>INTERACTIVE_REPORT_ID</code> pouvant \00EAtre modifi\00E9e lorsque vous exportez ou importez l''application vers d''autres instances, il est pr\00E9f\00E9rable de faire r\00E9f\00E9rence \00E0 des r\00E9gions d''\00E9tat interactif \00E0 l''aide d''un alias.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529410205305957)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Alias de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101523035704305953)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez les restrictions de date portant sur la liste de valeurs (LOV).'),
unistr('Pour les colonnes de date, la liste de valeurs (LOV) peut afficher une heure pass\00E9e ou future (ou les deux) dans le filtre de la liste d\00E9roulante de colonnes d''\00E9tat.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726234219306113)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'fr'
,p_message_text=>'Tout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726460813306113)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'fr'
,p_message_text=>'Futur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101726325973306113)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pass\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101522971275305953)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Plages de dates'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529713684305958)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez un \00E9l\00E9ment d''application ou de page dont la valeur stocke l''ID d''\00E9tat enregistr\00E9.'),
unistr('L''\00E9tat interactif utilise cette valeur d''\00E9l\00E9ment pour cr\00E9er des liens vers un \00E9tat enregistr\00E9.'),
unistr('Par exemple, vous pouvez d\00E9finir la liste des \00E9tats enregistr\00E9s avec des liens dont le nom d''\00E9l\00E9ment d\00E9fini et l''ID d''\00E9tat enregistr\00E9 comme valeur correspondante afin de cr\00E9er des liens vers des \00E9tats par d\00E9faut enregistr\00E9s, des \00E9tats publics ou des ')
||unistr('\00E9tats priv\00E9s.'),
unistr('Les ID d''\00E9tat enregistr\00E9 peuvent \00EAtre extraits \00E0 partir de la vue <code>APEX_APPLICATION_PAGE_IR_RPT</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101529638939305958)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d''ID d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670774756306072)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise en page d''\00E9tat par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671316402306073)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise en page d''\00E9tat par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670301110306072)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la mise en page \00E0 utiliser lors de l''impression de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101670275976306072)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9sentation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560620368305983)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un mod\00E8le d''\00E9tat pr\00E9d\00E9fini pour contr\00F4ler l''affichage de cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739845974306123)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'fr'
,p_message_text=>'HTML (standard)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739904322306123)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e une table HTML standard.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740031905306124)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'fr'
,p_message_text=>'Etat vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740134842306124)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche chaque colonne sur une ligne distincte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740209046306124)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'fr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740310255306124)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Exporte l''\00E9tat sous la forme d''un fichier CSV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740439995306124)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'fr'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101740577419306124)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Exporte l''\00E9tat sous la forme d''un fichier XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560515984305983)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562867065305984)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le texte affich\00E9 en regard des valeurs de somme d''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562724414305984)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de somme des \00E9tats')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556181096305979)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un mod\00E8le d''\00E9tat pour d\00E9finir l''apparence et la mise en page de cet \00E9tat classique.</p>'),
unistr('        <p>Les mod\00E8les d''\00E9tat sont d\00E9finis dans le th\00E8me d''application.'),
unistr('        Lorsqu''un \00E9tat classique est cr\00E9\00E9, le mod\00E8le est automatiquement configur\00E9 sur le mod\00E8le d''\00E9tat par d\00E9faut d\00E9fini dans le th\00E8me en cours.</p>'),
unistr('        <p>De nombreux th\00E8mes contiennent des mod\00E8les d''\00E9tat classique pour l''affichage de donn\00E9es dans une table, de paires cl\00E9/valeur, de r\00E9sultats de recherche, de cartes, etc.'),
unistr('        Certains mod\00E8les d''\00E9tat, tels que les cartes et les r\00E9sultats de recherche, sont "bas\00E9s sur la ligne" et attendent de votre requ\00EAte SQL qu''elle renvoie un ensemble particulier d''alias de colonne remplac\00E9s dans le mod\00E8le.<br>'),
unistr('        Le th\00E8me universel fournit les mod\00E8les d''\00E9tat suivants :'),
'          <dl>',
'            <dt>Alertes</dt>',
'              <dd>Affiche n''importe quel nombre d''alertes et de notifications horizontales sur votre page.</dd>',
'            <dt>Liste Badge</dt>',
unistr('              <dd>Affiche les paires cl\00E9/valeur dans une interface utilisateur de type tableau de bord.</dd>'),
'            <dt>Cartes</dt>',
unistr('              <dd>Affiche les donn\00E9es d''\00E9tat dans des cartes ou petits blocs, et est utile pour la pr\00E9sentation de diverses informations. Les cartes peuvent \00EAtre fortement personnalis\00E9es via Options de mod\00E8le.</dd>'),
'            <dt>Commentaires</dt>',
'              <dd>Affiche les commentaires et d''autres messages.</dd>',
unistr('            <dt>R\00E9sultats de recherche</dt>'),
unistr('              <dd>Affiche les r\00E9sultats de recherche de style moteur de recherche.</dd>'),
'            <dt>Standard</dt>',
unistr('              <dd>Il s''agit du mod\00E8le d''\00E9tat par d\00E9faut pour l''affichage de donn\00E9es dans une table ; peut \00EAtre fortement personnalis\00E9 via Options de mod\00E8le.</dd>'),
'            <dt>Cadre temporel</dt>',
unistr('              <dd>Affiche un cadre temporel d''actions. Il est adapt\00E9 aux pages d''accueil, aux journaux des modifications et \00E0 d''autres zones o\00F9 un flux d''activit\00E9 des actions r\00E9centes est n\00E9cessaire.</dd>'),
'            <dt>Paires valeur/attribut - Colonne</dt>',
unistr('              <dd>Affiche les paires cl\00E9/valeur pour les requ\00EAtes bas\00E9es sur une colonne. Le mod\00E8le utilise l''en-t\00EAte de colonne comme libell\00E9 pour chaque \00E9l\00E9ment.</dd>'),
'            <dt>Paires valeur/attribut - Ligne</dt>',
unistr('              <dd>Affiche les paires cl\00E9/valeur pour les requ\00EAtes bas\00E9es sur une ligne. Le mod\00E8le utilise la premi\00E8re colonne pour les libell\00E9s et la deuxi\00E8me pour les valeurs.</dd>'),
'          </dl>',
unistr('          Reportez-vous \00E9galement \00E0 <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Application \00E9chantillon de th\00E8me universel</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556061708305979)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417972356305875)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la grille interactive ne doit pas afficher de donn\00E9es, sauf si au moins un filtre est d\00E9fini sur l''une des colonnes d''\00E9tat.'),
unistr('		Cette option est con\00E7ue pour limiter les donn\00E9es charg\00E9es \00E0 partir d''un ensemble de donn\00E9es tr\00E8s volumineux, en limitant le nombre de lignes renvoy\00E9es \00E0 l''aide d''un filtre.</p>'),
unistr('		<p>L''option <strong>Filtre de colonne requis</strong> peut \00EAtre activ\00E9e pour les colonnes individuelles, garantissant qu''un filtre est requis pour cette colonne, tandis qu''un seul filtre est requis dans toutes les colonnes pour cette option.</p>'),
unistr('		<p>Remarque : lorsque cette option est d\00E9finie et qu''aucun filtre n''est actuellement d\00E9fini, un message appara\00EEt pour demander aux utilisateurs d''indiquer un filtre.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417848241305875)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('N\00E9cessite un filtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101574078940305993)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Tous les caract\00E8res peuvent \00EAtre enregistr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216805329305726)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le mode de limitation des caract\00E8res pouvant \00EAtre enregistr\00E9s dans le statut de session.'),
unistr('&PRODUCT_NAME. affiche un message d''erreur si un utilisateur tente d''enregistrer des donn\00E9es qui ne sont pas conformes \00E0 la restriction de caract\00E8res s\00E9lectionn\00E9e.</p>'),
unistr('<p>La restriction des caract\00E8res renforce la s\00E9curit\00E9 de l''application et constitue une contre-mesure possible face aux attaques de type Cross-Site Scripting (XSS).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715122443306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre sur liste de blocage les caract\00E8res &<>"/;,*|=% et --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715211185306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enregistrer les caract\00E8res suivants : &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % et "--" (commentaire PL/SQL).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715357775306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre sur liste de blocage les caract\00E8res &<>"/;,*|=% ou -- et les sauts de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715491431306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enregistrer les sauts de ligne et les caract\00E8res suivants : &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % et "--".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714724384306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre sur liste d''autorisation les caract\00E8res A-Z, 0-9 et l''espace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714896971306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Seuls les caract\00E8res a-z, A-Z, 0-9 et les espaces peuvent \00EAtre enregistr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714936600306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre sur liste de blocage les caract\00E8res de commande HTML (<>")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715084579306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enregistrer les caract\00E8res HTML r\00E9serv\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101715509882306105)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma d''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216731929305726)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Caract\00E8res restreints')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980931148306316)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le format d''entr\00E9e pour le contenu affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981056208306316)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'fr'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981165665306316)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le contenu comporte des balises HTML et sera affich\00E9 sans appliquer d''\00E9chappement de caract\00E8res sp\00E9ciaux. Assurez-vous que les donn\00E9es sont s\00E9curis\00E9es et ne contiennent pas de donn\00E9es saisies par l''utilisateur final afin d''\00E9viter les vuln\00E9rabilit\00E9s d')
||'e type Cross-Side Scripting (XSS).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981266901306316)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'fr'
,p_message_text=>'Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981300691306316)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le contenu comporte des balises Markdown qui seront converties en balises HTML s\00E9curis\00E9es avant l''affichage. La conversion des balises Markdown connues <strong>pr\00E9viendra</strong> les vuln\00E9rabilit\00E9s de type Cross-Side Scripting (XSS).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101980885161306316)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417114297305875)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la colonne qui stocke le num\00E9ro de version de ligne pour la table en cours de mise \00E0 jour. Cette colonne est utilis\00E9e lors de la v\00E9rification de mise \00E0 jour perdue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417002185305875)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne de version de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540764004305965)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la fr\00E9quence \00E0 laquelle ce processus est ex\00E9cut\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730815397306116)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Une fois par visite de page (valeur par d\00E9faut)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101730723169306116)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Une fois par session ou lors de la r\00E9initialisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540604940305965)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter le processus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526549978305955)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez un mod\00E8le d''autorisation pour contr\00F4ler les utilisateurs autoris\00E9s \00E0 enregistrer des d\00E9finitions d''\00E9tat public.'),
unistr('Pour autoriser un utilisateur final \00E0 enregistrer un \00E9tat public, l''\00E9valuation de ce mod\00E8le d''autorisation doit donner la valeur TRUE.'),
unistr('Si aucun mod\00E8le d''autorisation n''est indiqu\00E9, les \00E9tats peuvent \00EAtre enregistr\00E9s par n''importe quel utilisateur.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526408728305955)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer l''autorisation d''\00E9tat public')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298995138305786)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si les valeurs dans le statut de session sont enregistr\00E9es dans la base de donn\00E9es avant l''ex\00E9cution du branchement.'),
unistr('Assurez-vous que vous avez d\00E9fini cet attribut sur <strong>Activ\00E9</strong> si vous naviguez vers une application diff\00E9rente qui doit acc\00E9der aux valeurs de statut de session \00E0 partir de cette application.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298881291305786)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer le statut avant le branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285827638305777)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''\00E9l\00E9ment de page ou d''application \00E0 utiliser en tant que sch\00E9ma d''analyse de remplacement. Cela s''applique aux applications internes uniquement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285719076305777)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de remplacement de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905727064306252)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905653672306252)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904947985306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>S\00E9lectionnez le mode d''application de ce mod\00E8le d''autorisation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905090274306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL Existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905168355306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''autorisation r\00E9ussit lorsque la requ\00EAte renvoie une valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905412291306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction PL/SQL renvoyant une valeur bool\00E9enne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905509618306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrer un corps de fonction PL/SQL renvoyant une valeur bool\00E9enne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905226805306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL N''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905354974306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''autorisation r\00E9ussit lorsque la requ\00EAte ne renvoie aucune valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101904866407306251)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526709838305955)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte du libell\00E9 du bouton de recherche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526659549305955)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 du bouton de recherche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888353716306238)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant doit \00EAtre affich\00E9 \00E0 l''aide d''une colonne ou \00E0 l''aide d''un format avanc\00E9 bas\00E9 sur des expressions HTML et des cha\00EEnes de substitution prises en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888289158306238)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888553181306239)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme corps secondaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888487877306239)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101889079484306239)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888945392306239)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888868734306239)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&COLUMN_CLASS.</code> et <code>&EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888733203306239)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les expressions HTML \00E0 afficher dans cette colonne. Utilisez la syntaxe <code>&COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101888680054306239)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284618035305776)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez <strong>Activ\00E9</strong> pour activer le cookie de gestion de session \00E0 envoyer par le navigateur uniquement lorsque le protocole est HTTPS.'),
unistr('S\00E9lectionnez <strong>D\00E9sactiv\00E9</strong> pour activer le cookie de gestion de session \00E0 envoyer par le navigateur lorsque le protocole est HTTP ou HTTPS.</p>'),
unistr('<p>Si SSL est configur\00E9 sur votre serveur Web, s\00E9lectionnez <strong>Activ\00E9</strong> pour renforcer la s\00E9curit\00E9 de votre application en emp\00EAchant le trafic HTTP non crypt\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101284538139305776)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441129890305893)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la premi\00E8re ligne doit \00EAtre s\00E9lectionn\00E9e automatiquement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441008736305893)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner la premi\00E8re ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581226048305999)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de graphique en s\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475730146305919)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom de la colonne \00E0 utiliser pour d\00E9finir la requ\00EAte dynamique \00E0 plusieurs s\00E9ries.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101475617110305919)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de s\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216253920305725)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un niveau de protection de statut de session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713973491306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'fr'
,p_message_text=>'Checksum requis - niveau application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714096843306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini par sa transmission dans une URL qui inclut un checksum propre \00E0 l''espace de travail et \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714589588306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Restreint - ne peut pas \00EAtre d\00E9fini \00E0 partir du navigateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714679711306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''\00E9l\00E9ment ne peut pas \00EAtre modifi\00E9 \00E0 l''aide de l''URL ou POSTDATA.'),
unistr('S\00E9lectionnez cette option pour limiter ce qui peut d\00E9finir la valeur d''\00E9l\00E9ment sur les processus internes, les calculs, etc.'),
unistr('Cet attribut, applicable uniquement aux \00E9l\00E9ments qui ne sont pas utilis\00E9s comme \00E9l\00E9ments d''entr\00E9e de donn\00E9es, est toujours observ\00E9, m\00EAme si la protection de statut de session est d\00E9sactiv\00E9e.'),
unistr('Utilisez cet attribut pour les \00E9l\00E9ments d''application ou de page dot\00E9s des types <strong>Afficher en tant que</strong> suivants : '),
'<ul>',
'  <li>Afficher uniquement (n''enregistre pas le statut)</li>',
unistr('  <li>Champ de texte (d\00E9sactiv\00E9, n''enregistre pas le statut)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713718028306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Non restreint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713818946306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini par sa transmission dans une URL ou un panneau. Aucun checksum n''est obligatoire dans l''URL.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714197794306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'fr'
,p_message_text=>'Checksum requis - niveau utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714270821306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini par sa transmission dans une URL qui inclut un checksum propre \00E0 l''espace de travail, \00E0 l''application et \00E0 l''utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714366999306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'fr'
,p_message_text=>'Checksum requis - niveau session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101714417484306104)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini par sa transmission dans une URL qui inclut un checksum propre \00E0 la session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101216163314305725)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Protection de statut de session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238137315305741)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le groupe de filtres auquel cette case \00E0 cocher est associ\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238093773305741)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Groupe de filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001468506306332)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101905804804306252)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001543634306332)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536943332305963)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si le menu <em>Actions</em> est inclus dans la barre de recherche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536838792305963)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Inclure le menu Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534117097305961)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des agr\00E9gats pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534018082305961)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9ger')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519810554305951)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si cette colonne appara\00EEt dans l''\00E9tat par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101519790051305950)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534349165305961)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des graphiques pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534262131305961)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533913218305961)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des colonnes de calcul pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533819356305961)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Calculer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533512863305960)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir les commandes BREAK pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533431643305960)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Commande BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238576851305741)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le libell\00E9 du facet doit \00EAtre affich\00E9 en regard des valeurs s\00E9lectionn\00E9es dans la liste des facets en cours. Masquez le libell\00E9 si la valeur s\00E9lectionn\00E9e ne n\00E9cessite pas d''explication, par exemple, un statut d''ordre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101238413798305741)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher le libell\00E9 pour le facet en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536524771305962)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si un s\00E9lecteur de ligne d\00E9roulant s\00E9par\00E9 est inclus dans la barre de recherche.'),
unistr('Vous ne devez pas s\00E9lectionner \00E0 la fois cet attribut et <strong>Lignes par page</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536461255305962)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de lignes par page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535332481305962)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent t\00E9l\00E9charger l''\00E9tat dans l''un des formats de t\00E9l\00E9chargement sp\00E9cifi\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535282661305961)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532736137305960)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des filtres sur cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532625344305960)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536378676305962)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si la liste d\00E9roulante de l''outil de recherche est incluse au d\00E9but du champ de recherche dans la barre de recherche.'),
unistr('La liste d\00E9roulante de l''outil de recherche est une liste de colonnes qui permet aux utilisateurs de limiter leur recherche \00E0 une colonne sp\00E9cifique.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536230604305962)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste d\00E9roulante de l''outil de recherche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534951063305961)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent utiliser des requ\00EAtes Flashback pour cet \00E9tat.</p>'),
unistr('<p>Les requ\00EAtes Flashback utilisent la terminologie Oracle Flashback et la r\00E9cup\00E9ration jusqu''\00E0 un point dans le temps de la base de donn\00E9es pour visualiser les donn\00E9es telles qu''elles existaient \00E0 un moment donn\00E9. Les utilisateurs peuvent uniquement')
||unistr(' interroger ces donn\00E9es, mais ne peuvent effectuer aucun retour en arri\00E8re sur les modifications des donn\00E9es. La date limite (dans le pass\00E9) \00E0 laquelle ils peuvent r\00E9aliser une requ\00EAte Flashback est d\00E9termin\00E9e par la date \00E0 laquelle les fichiers de j')
||unistr('ournalisation ont \00E9t\00E9 modifi\00E9s pour la derni\00E8re fois dans la base de donn\00E9es Oracle, \00E9tant donn\00E9 que cette technologie utilise la sauvegarde RMAN.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534804153305961)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534731995305961)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des r\00E9partitions de regroupement pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534648492305961)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Grouper par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472519006305917)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le nom de groupe doit appara\00EEtre dans l''info-bulle affich\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472402017305917)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher le nom de groupe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535532975305962)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent appeler la bo\00EEte de dialogue modale d''aide int\00E9gr\00E9e pour les \00E9tats interactifs.</p>'),
unistr('<p>La bo\00EEte de dialogue d''aide pr\00E9sente uniquement les options disponibles pour l''utilisateur en cours.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535424491305962)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533786302305960)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des mises en \00E9vidence pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533672326305960)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857223171306212)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la couche est affich\00E9e dans la l\00E9gende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857167053306212)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534564244305961)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des param\00E8tres d''abonnement pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101534438820305961)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Abonnement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525982082305955)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher pour les colonnes NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101525827323305955)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher les valeurs Null en tant que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834645652305416)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des r\00E9partitions avec permutation lignes vers colonnes pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834519243305416)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Permutation lignes vers colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211653921305722)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les s\00E9lections rapides s''affichent pour cet \00E9l\00E9ment de page.'),
unistr('Les s\00E9lections rapides permettent aux utilisateurs de s\00E9lectionner des valeurs pr\00E9d\00E9finies en un seul clic, plut\00F4t que de saisir du texte ou de choisir parmi une liste d''options disponibles.</p>'),
unistr('<p>Sp\00E9cifiez des s\00E9lections rapides dans le cas d''un ensemble relativement r\00E9duit de valeurs d''entr\00E9e <em>communes</em>.'),
unistr('Vous pouvez d\00E9finir jusqu''\00E0 dix s\00E9lections rapides par \00E9l\00E9ment.'),
unistr('Ce type d''aide destin\00E9e aux utilisateurs est particuli\00E8rement utile lors de la d\00E9finition d''un \00E9l\00E9ment ayant une longue liste de s\00E9lection de valeurs disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101211561579305722)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les s\00E9lections rapides')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537135070305963)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la liste de s\00E9lection d''\00E9tats est affich\00E9e dans la barre de recherche</p>'),
unistr('<p>La liste de s\00E9lection d''\00E9tats est affich\00E9e uniquement si un \00E9tat, autre que l''\00E9tat principal, est accessible \00E0 l''utilisateur.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101537044950305963)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de s\00E9lection d''\00E9tats')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535106173305961)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les utilisateurs finals peuvent r\00E9initialiser leurs \00E9tats \00E0 partir du menu Actions.</p>'),
unistr('<p>La r\00E9initialisation de l''\00E9tat r\00E9tablit toutes les personnalisations effectu\00E9es par l''utilisateur ou indiqu\00E9es par l''URL d''appel, et affiche l''\00E9tat principal.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101535027679305961)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533107337305960)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent modifier le nombre de lignes affich\00E9es pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533009697305960)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Lignes par page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536756473305963)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez si le champ de recherche est inclus dans la barre de recherche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101536670616305962)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Champ de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532953919305960)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent se servir de l''option <strong>S\00E9lectionner des colonnes</strong> dans le menu Actions pour modifier les colonnes affich\00E9es dans cet \00E9tat. Les utilisateurs peuvent s\00E9lectionner (ou afficher), d\00E9s\00E9lectionner ')
||unistr('(ou masquer) et r\00E9organiser plusieurs colonnes \00E0 l''aide de cette option.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101532820498305960)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner des colonnes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472310088305917)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le nom de s\00E9rie doit appara\00EEtre dans l''info-bulle affich\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101472263731305916)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher le nom de s\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533365350305960)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les utilisateurs finals peuvent d\00E9finir des colonnes de tri pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101533203573305960)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Trier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237539559305741)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si le libell\00E9 du filtre ou seule la valeur dans le bouton de suggestion doit \00EAtre affich\00E9. Masquez le libell\00E9 si la valeur sugg\00E9r\00E9e ne n\00E9cessite pas d''explication, par exemple, un statut d''ordre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237464764305741)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher le libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418922480305876)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si une barre d''outils est affich\00E9e en haut de l''\00E9tat. La barre d''outils peut inclure des fonctionnalit\00E9s de r\00E9initialisation, de modification, d''actions, d''\00E9tats enregistr\00E9s, de type d''\00E9tat et de recherche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418819460305876)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418762823305876)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si le nombre total de lignes doit \00EAtre affich\00E9 dans le pied de page de l''\00E9tat.<p/>'),
unistr('        <p>Remarque : une requ\00EAte suppl\00E9mentaire est ex\00E9cut\00E9e pour obtenir le nombre total de lignes, ce qui peut entraver les performances, notamment sur des ensembles de donn\00E9es tr\00E8s volumineux.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101418671665305876)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher le nombre total de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554189181305978)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pour le type d''affichage Case \00E0 cocher simple, entrez une valeur ou deux valeurs s\00E9par\00E9es par une virgule.'),
unistr('La premi\00E8re valeur est soumise si la case est coch\00E9e. La deuxi\00E8me valeur, si elle a \00E9t\00E9 d\00E9finie, est soumise si la case n''est pas coch\00E9e.'','),
'        p_examples           => q''~<dl>',
unistr('<dt>Soumettez Oui lorsque la case est coch\00E9e et Non lorsqu''elle ne l''est pas</dt>'),
'<dd><pre>',
'Oui,Non',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101554066145305978)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeurs de case \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520498204305951)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le libell\00E9 de colonne \00E0 utiliser dans la vue monoligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520396696305951)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562091273305984)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour les colonnes d''\00E9tat qui activent le tri des en-t\00EAtes de colonne, s\00E9lectionnez la fa\00E7on dont les enregistrements avec des valeurs NULL doivent \00EAtre tri\00E9s par rapport aux enregistrements sans valeur NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741624768306125)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'fr'
,p_message_text=>'Premier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741788773306125)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les enregistrements avec une valeur NULL sont affich\00E9s avant toutes les colonnes avec des valeurs non NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741818770306125)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'fr'
,p_message_text=>'Dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101741942651306125)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les enregistrements avec des valeurs non NULL sont affich\00E9s avant toutes les colonnes avec une valeur NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561904754305984)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Trier les valeurs NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835308168305417)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la liste de chemins de navigation associ\00E9e \00E0 cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835275712305416)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067830084306382)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez le nom de colonne de base de donn\00E9es respectant les minuscules/majuscules utilis\00E9 comme source pour ce facet.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101876271884306230)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez le nom de colonne de base de donn\00E9es respectant les minuscules/majuscules utilis\00E9 comme source pour ce facet.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239519935305742)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez le nom de colonne de base de donn\00E9es respectant les minuscules/majuscules utilis\00E9 comme source pour ce filtre.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240619189305743)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Entrez le nom de colonne de base de donn\00E9es respectant les minuscules/majuscules utilis\00E9 comme source pour ce filtre.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210447542305721)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nom de colonne de base de donn\00E9es, qui respecte les majuscules et les minuscules, utilis\00E9 comme source pour cette valeur d''\00E9l\00E9ment.</p>'),
unistr('<p>Cette colonne doit exister dans la table sp\00E9cifi\00E9e dans le processus d''extraction de ligne int\00E9gr\00E9 d\00E9fini sur cette page.'),
unistr('Une erreur est g\00E9n\00E9r\00E9e et la page n''est pas charg\00E9e si le nom de colonne de base de donn\00E9es n''existe pas dans la table r\00E9f\00E9renc\00E9e.'),
unistr('De m\00EAme, si aucun processus d''extraction de ligne int\00E9gr\00E9 n''est d\00E9fini et qu''il existe un \00E9l\00E9ment avec le type de source <strong>Colonne de base de donn\00E9es</strong>, une erreur est g\00E9n\00E9r\00E9e et la page n''est pas charg\00E9e lors de la tentative d''affichage')
||' de la page.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210308479305721)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948886398306291)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949284814306291)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949123413306291)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949032121306291)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949396828306291)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948936304306291)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101948772970306291)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646732271306047)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion associ\00E9e \00E0 la recherche \00E0 facets ou \00E0 la r\00E9gion de filtre intelligent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646607888306047)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion filtr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950838638306292)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951158074306293)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951010719306292)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950935023306292)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951205766306293)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950753943306292)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210293639305721)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 comme source pour cette valeur d''\00E9l\00E9ment.'),
unistr('Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210102087305721)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979671243306315)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code Java \00E0 ex\00E9cuter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979580830306315)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950467853306292)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Java g\00E9n\00E9rant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950330504306292)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952099936306293)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Java renvoyant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951979092306293)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979486213306315)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Augmente de 3 % le salaire des employ\00E9s admissibles \00E0 une augmentation de salaire :</dt>'),
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
'    // placeholder for some complicated logic to calculate if employee needs a raise',
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979337992306315)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code JavaScript \00E0 ex\00E9cuter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979277637306315)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950219318306292)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950182777306292)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression JavaScript g\00E9n\00E9rant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950003583306292)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951877019306293)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951770971306293)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction JavaScript renvoyant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951602871306293)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835154428305416)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source de cette liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835058709305416)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292720448305782)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''emplacement des donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292808946305782)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Base de donn\00E9es locale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292966728305782)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es proviennent de la base de donn\00E9es locale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293090236305782)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'fr'
,p_message_text=>'SQL compatible REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293169734305782)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es proviennent d''une base de donn\00E9es distante, o\00F9 la connexion est d\00E9finie via le SQL compatible REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403200759305865)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'fr'
,p_message_text=>'Source REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102009837199306339)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es proviennent d''un service Web RESTful d\00E9fini via des sources de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101292621249305782)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Emplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488451136305928)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste d''\00E9l\00E9ments de la page en cours, s\00E9par\00E9s par des virgules, \00E0 d\00E9finir dans l''\00E9tat de session lors de la lecture des donn\00E9es du graphique avec une demande distincte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101855980455306211)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une liste d''\00E9l\00E9ments de la page en cours, s\00E9par\00E9s par des virgules, \00E0 d\00E9finir dans le statut de session lors de l''extraction des donn\00E9es de carte avec une demande distincte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285628355305776)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les \00E9l\00E9ments de page ou d''application \00E0 d\00E9finir dans le statut de session lorsque la r\00E9gion est r\00E9g\00E9n\00E9r\00E9e par une r\00E9g\00E9n\00E9ration de page partielle.'),
unistr('S\00E9parez chaque nom d''\00E9l\00E9ment par une virgule.'),
unistr('Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste.</p>'),
unistr('<p>Vous pouvez r\00E9g\00E9n\00E9rer la r\00E9gion \00E0 l''aide de la r\00E9g\00E9n\00E9ration de page partielle lors de la pagination, si l''option <em>Activer la r\00E9g\00E9n\00E9ration de page partielle</em> est d\00E9finie sur <strong>Activ\00E9</strong>, ou \00E0 l''aide de l''action R\00E9g\00E9n\00E9rer dans une')
||' action dynamique.</p>',
unistr('Ces \00E9l\00E9ments de page peuvent \00EAtre utilis\00E9s dans la <em>condition WHERE</em> de la requ\00EAte SQL de source de r\00E9gion afin de limiter les r\00E9sultats de la requ\00EAte.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101285586031305776)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments de page \00E0 soumettre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979151148306315)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Augmente de 3 % le salaire des employ\00E9s admissibles \00E0 une augmentation de salaire :</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979094464306315)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code PL/SQL \00E0 ex\00E9cuter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978982520306315)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949924199306292)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949847900306292)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression PL/SQL g\00E9n\00E9rant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949706179306291)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951565122306293)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951418184306293)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL renvoyant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101951322226306293)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015148347306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la m\00E9thode de post-traitement des donn\00E9es de source REST extraites dans la base de donn\00E9es locale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015651169306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015775000306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL dans lequel la requ\00EAte SQL renvoy\00E9e transforme les donn\00E9es extraites.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015438233306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015595350306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour transformer les donn\00E9es extraites.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015241456306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'fr'
,p_message_text=>'Clause WHERE/ORDER BY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015317382306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez les clauses WHERE et/ou ORDER BY pour limiter et trier les donn\00E9es extraites.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102015037413306343)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210693944305721)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la pr\00E9f\00E9rence utilisateur \00E0 utiliser comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210513196305721)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979885213306315)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le code Python \00E0 ex\00E9cuter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101979792352306315)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Code Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950664533306292)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Python g\00E9n\00E9rant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101950515836306292)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952215729306293)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Python renvoyant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101952179656306293)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209816667305720)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la requ\00EAte SQL utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment. Si plusieurs lignes sont renvoy\00E9es, la valeur de la premi\00E8re ligne est utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209725957305720)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101210023344305721)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la requ\00EAte SQL renvoyant au moins une ligne \00E0 utiliser comme source pour cette valeur d''\00E9l\00E9ment. Si le r\00E9sultat contient des lignes multiples, les valeurs de chaque ligne sont regroup\00E9es pour former une valeur unique d\00E9limit\00E9e par des signe')
||'s deux-points.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209973692305721)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959223352306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959509045306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959469864306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959381267306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959679495306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959138276306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960438725306300)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Java qui renvoie une requ\00EAte SQL pour la s\00E9rie du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960307601306300)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Java renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960242975306300)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>S\00E9lectionnez les colonnes EMPNO, ENAME et SAL, et filtrez toutes les lignes contenant une valeur SAL inf\00E9rieure \00E0 3 000.</dt>'),
'<dd<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960181374306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction JavaScript qui renvoie une requ\00EAte SQL pour la s\00E9rie du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960080489306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction JavaScript renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291279722305781)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Permet d''afficher les nouvelles embauches en premier et les personnes qui n''ont pas encore \00E9t\00E9 embauch\00E9es en dernier. Si la date d''embauche est la m\00EAme, triez-les par num\00E9ro de d\00E9partement.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291199087305781)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez des noms de colonne s\00E9par\00E9s par des virgules, y compris des directives, pour d\00E9finir l''ordre dans lequel les enregistrements sont extraits.</p>'),
'        <p>Directives possibles :',
'          <ul>',
'            <li>ASC : renvoyer les colonnes dans l''ordre croissant</li>',
unistr('            <li>DESC : renvoyer les colonnes dans l''ordre d\00E9croissant</li>'),
'            <li>NULLS FIRST : renvoyer les colonnes sans valeur avant celles contenant des valeurs</li>',
'            <li>NULLS LAST : renvoyer les colonnes contenant des valeurs avant celles sans valeur</li>',
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291059684305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Trier par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290463191305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le sch\00E9ma propri\00E9taire de la table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290317432305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403851141305865)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une fonction PL/SQL qui renvoie une requ\00EAte SQL utilis\00E9e comme base pour cette r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403788146305865)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959925450306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>S\00E9lectionnez les colonnes EMPNO, ENAME et SAL, et filtrez toutes les lignes contenant une valeur SAL inf\00E9rieure \00E0 3 000.</dt>'),
'<dd<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959887889306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction PL/SQL qui renvoie une requ\00EAte SQL pour la s\00E9rie du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101959769529306299)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction PL/SQL renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960688899306300)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un corps de fonction Python qui renvoie une requ\00EAte SQL pour la s\00E9rie du graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101960569525306300)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction Python renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290656246305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290595228305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290062748305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la m\00E9thode d''interrogation des donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403320339305865)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction renvoyant une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403459299305865)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es sont extraites en fonction de la requ\00EAte SQL renvoy\00E9e par l''ex\00E9cution d''un corps de fonction.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293295699305782)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293316409305782)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es sont extraites en fonction d''une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290106983305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'fr'
,p_message_text=>'Table/vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290262898305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es sont extraites en fonction d''une table ou d''une vue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289925728305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290980568305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Inclut uniquement les employ\00E9s qui ont un responsable ou qui travaillent comme commerciaux.</dt>'),
'<dd><pre>',
'( MGR n''est pas NULL ou JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290892692305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une condition SQL WHERE valide, afin de limiter les enregistrements extraits.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101290737566305780)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Clause WHERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289870995305780)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le serveur de base de donn\00E9es distant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289736817305780)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Serveur distant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978435101306314)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le code saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978779741306314)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978660132306314)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978511098306314)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978878405306315)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101978337295306314)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101604008059306016)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Pour concat\00E9ner deux colonnes, proc\00E9dez comme suit :</dt>'),
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
unistr('<dt>Ajoutez une s\00E9lection interne :</dt>'),
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428363454305883)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez l''expression SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101428251539305883)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949658664306291)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949561541306291)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression SQL g\00E9n\00E9rant une valeur utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101949471929306291)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858172872306212)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Requ\00EAte renvoyant des valeurs de longitude et de latitude sous la forme de colonnes NUMBER :</p>'),
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>Requ\00EAte renvoyant l''emplacement du client sous la forme d''une colonne SDO_GEOMETRY :</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291421409305781)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>'Entrez la source SQL pour ce composant.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101291382451305781)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209661117305720)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la valeur statique utilis\00E9e comme source pour cette valeur d''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209543414305720)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209456083305720)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type de source sur lequel repose la valeur de cet \00E9l\00E9ment.</p>'),
unistr('<p>Remarque : si <strong>Source utilis\00E9e</strong> est d\00E9fini sur <em>Uniquement lorsque la valeur en cours dans le statut de session est NULL</em>, la source ne sera pas utilis\00E9e si une valeur a \00E9t\00E9 d\00E9finie dans le statut de session pour cet \00E9l\00E9ment.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712568274306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'fr'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907873482306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur NULL car aucune valeur n''a \00E9t\00E9 indiqu\00E9e.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712782059306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907273040306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de colonne saisie dans <em>Colonne de base de donn\00E9es</em>, qui est r\00E9cup\00E9r\00E9e \00E0 partir d''un processus d''extraction de ligne int\00E9gr\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928573766306269)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101928608609306269)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur g\00E9n\00E9r\00E9e par l''ex\00E9cution de l''<em>expression</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713063928306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907653526306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par le <em>corps de fonction</em> saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713119784306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907307046306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101713244319306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907723048306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de la <em>pr\00E9f\00E9rence</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712846031306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur unique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907491680306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la premi\00E8re valeur renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712982295306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur s\00E9par\00E9e par deux-points)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907550741306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur une valeur d\00E9limit\00E9e par le signe deux-points qui concat\00E8ne chaque valeur de ligne, renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712653955306103)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101907136989306253)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur le texte saisi dans <em>Valeur statique</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209374595305720)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209270097305720)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la valeur prioritaire : la valeur du statut de session ou la valeur de source de l''\00E9l\00E9ment.</p>'),
unistr('<p>Vous devez s\00E9lectionner <strong>Toujours, en rempla\00E7ant les valeurs existantes dans le statut de session</strong> pour les \00E9l\00E9ments dont le type de source est <strong>Colonne de base de donn\00E9es</strong>, \00E0 moins que vous ne vouliez pas que l''op\00E9ra')
||unistr('tion d''extraction de ligne associ\00E9e remplisse l''\00E9l\00E9ment, si la page effectue un branchement sur elle-m\00EAme.'),
unistr('Pour les \00E9l\00E9ments dont le type de source est autre, vous devez d\00E9cider, en fonction du mode d''utilisation de la page, si la valeur fournie pr\00E9c\00E9demment doit \00EAtre affich\00E9e ou si un nouveau type de source doit \00EAtre appliqu\00E9 pour chaque vue de page.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712309202306103)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Toujours, en rempla\00E7ant les valeurs existantes dans le statut de session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101712433771306103)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'fr'
,p_message_text=>'Uniquement lorsque la valeur en cours dans le statut de session est NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101209102531305720)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403608940305865)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la source de donn\00E9es REST qui prend en charge l''extraction d''une collection.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101403569889305865)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Source REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488267677305928)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Dans un graphique \00E0 double Y fractionn\00E9, indiquez la fraction de l''espace donn\00E9e au sous-graphique de l''axe des Y. Les valeurs valides sont des nombres compris entre 0 et 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488140722305928)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Emplacement du s\00E9parateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487759213305928)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la zone de trac\00E9 est divis\00E9e en deux sections, de mani\00E8re \00E0 ce que les ensembles de donn\00E9es affect\00E9s aux diff\00E9rents axes Y apparaissent dans des parties distinctes de la zone de trac\00E9. La valeur <strong>Non</strong> de cette option n''est ')
||'pas prise en charge pour les graphiques boursiers.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487891292305928)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488054500305928)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487981392305928)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487606896305927)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464923835305911)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si les \00E9l\00E9ments de donn\00E9es sont empil\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101464852101305911)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Empiler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089022083305613)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le nom de la cat\00E9gorie de pile \00E0 laquelle affecter la s\00E9rie. Par d\00E9faut, toutes les s\00E9ries d''un graphique empil\00E9 sont regroup\00E9es dans la m\00EAme pile. Pour placer la s\00E9rie dans une pile distincte, d\00E9finissez une cat\00E9gorie de pile. Vous pouvez u')
||'tiliser des substitutions <code>&COLUMN_VALUE.</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088953423305613)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cat\00E9gorie de pile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088875960305613)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Indiquez si les valeurs totales des \00E9l\00E9ments de donn\00E9es empil\00E9s doivent \00EAtre affich\00E9es. Applicable uniquement \00E0 des graphiques \00E0 barres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088780860305613)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de pile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189602012305687)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le jeu d''onglets standard utilis\00E9 pour cette page. Un jeu d''onglets standard est associ\00E9 \00E0 un num\00E9ro de page sp\00E9cifique. Vous pouvez utiliser des onglets standard pour amener des utilisateurs \00E0 une page sp\00E9cifique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189502144305687)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587769267306004)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le premier jour de la semaine affich\00E9 dans le calendrier hebdomadaire.'),
unistr('Vous pouvez utiliser cet attribut avec la valeur <strong>Dernier jour</strong> pour restreindre les jours de la semaine affich\00E9s ou simplement pour indiquer le premier jour de la semaine affich\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746550855306128)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'fr'
,p_message_text=>'Dimanche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746688970306129)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'fr'
,p_message_text=>'Lundi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746778467306129)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'fr'
,p_message_text=>'Mardi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746895182306129)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'fr'
,p_message_text=>'Mercredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746917011306129)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'fr'
,p_message_text=>'Jeudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747038585306129)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'fr'
,p_message_text=>'Vendredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747154523306129)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'fr'
,p_message_text=>'Samedi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587660994306004)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Jour de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587520014306004)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine le jour de la semaine par lequel d\00E9bute le calendrier mensuel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745895190306128)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'fr'
,p_message_text=>'Dimanche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101745945184306128)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'fr'
,p_message_text=>'Lundi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746022412306128)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'fr'
,p_message_text=>'Mardi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746140898306128)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'fr'
,p_message_text=>'Mercredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746259450306128)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'fr'
,p_message_text=>'Jeudi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746319748306128)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'fr'
,p_message_text=>'Vendredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101746427795306128)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'fr'
,p_message_text=>'Samedi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101587488423306004)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Jour de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588353721306004)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''heure de d\00E9but pour concentrer l''affichage du calendrier hebdomadaire et quotidien.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588262895306004)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Heure de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101218067168305727)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le conteneur statique d''un s\00E9lecteur jQuery devant \00EAtre utilis\00E9 par cette action dynamique.'),
unistr('Vous pouvez am\00E9liorer les performances des actions dynamiques dont la port\00E9e d''\00E9v\00E9nement est <strong>Dynamique</strong>.'),
unistr('Il s''agit d''un \00E9l\00E9ment sur la page qui n''est pas recr\00E9\00E9, mais qui contient les \00E9l\00E9ments d\00E9clencheurs recr\00E9\00E9s via la r\00E9g\00E9n\00E9ration de page partielle.'),
unistr('Cette r\00E9f\00E9rence d''\00E9l\00E9ment doit \00EAtre d\00E9finie en tant que s\00E9lecteur jQuery.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217996036305726)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Conteneur statique (s\00E9lecteur jQuery)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228251250305734)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''ID statique du bouton. S''il est d\00E9fini, il sera utilis\00E9 en tant qu''ID pour le bouton. L''ID statique est utile lorsque vous d\00E9veloppez un comportement JavaScript personnalis\00E9 pour le bouton. S''il n''est pas d\00E9fini, le bouton g\00E9n\00E8re un ID inter')
||'ne.</p>',
unistr('<p>Remarque : le mod\00E8le doit inclure la cha\00EEne de substitution <code>#BUTTON_ID#</code> afin de permettre au bouton d''utiliser l''ID statique saisi.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101432437017305886)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''ID statique de la colonne. L''ID statique est utile lorsque vous d\00E9veloppez un comportement JavaScript personnalis\00E9 ou un style personnalis\00E9 pour l''\00E9l\00E9ment de colonne. S''il n''est pas d\00E9fini, un ID interne est utilis\00E9 pour l''ID d''\00E9l\00E9ment de')
||' colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109692742306414)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''ID statique de la colonne. S''il est d\00E9fini, il sera utilis\00E9 en tant qu''ID pour la cellule d''en-t\00EAte de table correspondante et en tant que valeur HEADERS pour les cellules de donn\00E9es de table correspondantes. L''ID statique est utile lorsque ')
||unistr('vous d\00E9veloppez un comportement JavaScript personnalis\00E9 ou un style personnalis\00E9 pour la colonne. S''il n''est pas d\00E9fini, la table g\00E9n\00E8re un ID interne pour ces valeurs d''attribut.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488616404305928)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''ID statique de l''axe de graphique. L''ID statique peut \00EAtre utile lors du d\00E9veloppement du comportement JavaScript personnalis\00E9 pour l''axe de graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101488516625305928)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''ID statique de la s\00E9rie de graphiques. L''ID statique peut \00EAtre utile lors du d\00E9veloppement du comportement JavaScript personnalis\00E9 pour la s\00E9rie de graphiques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101287356041305778)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez l''ID statique pour cette r\00E9gion. S''il est d\00E9fini, il est utilis\00E9 en tant qu''ID de la r\00E9gion \00E0 l''aide de la cha\00EEne de substitution <code>#REGION_STATIC_ID#</code>. Cet ID peut \00EAtre utile lorsque vous d\00E9veloppez un comportement JavaScript per')
||unistr('sonnalis\00E9 pour la r\00E9gion. S''il n''est pas d\00E9fini, la r\00E9gion g\00E9n\00E8re un ID interne.</p>'),
unistr('<p>Remarque : le mod\00E8le doit inclure la cha\00EEne de substitution <code>#REGION_STATIC_ID#</code> afin de permettre \00E0 la r\00E9gion d''utiliser l''ID statique saisi.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217675478305726)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''ID statique de ce composant. S''il est d\00E9fini, cet ID est utile lors du d\00E9veloppement du comportement JavaScript personnalis\00E9 pour le composant.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101217528039305726)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'ID statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499939171305936)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de s\00E9rie \00E0 appliquer au graphique boursier affich\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500022471305936)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'fr'
,p_message_text=>'En aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500175244305937)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'fr'
,p_message_text=>'Barre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500207259305937)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'fr'
,p_message_text=>'En chandelier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500380829305937)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101500411351305937)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'fr'
,p_message_text=>'A courbes avec aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499872840305936)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher comme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220097929305728)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si le traitement de toutes les autres actions en suspens est arr\00EAt\00E9 en cas d''erreur lors de l''ex\00E9cution de l''action en cours.</p>'),
unistr('<p>Remarque : l''ordre d''ex\00E9cution des actions sp\00E9cifiques est d\00E9termin\00E9 par la s\00E9quence indiqu\00E9e pour chaque action. Pour vous assurer que les actions sont effectu\00E9es dans le m\00EAme ordre, Oracle recommande que les num\00E9ros de s\00E9quence soient uniques po')
||'ur toutes les actions True et toutes les actions False.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101219902026305728)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Arr\00EAter l''ex\00E9cution en cas d''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297214272305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser le param\00E8tre d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297315990305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne utilisera le param\00E8tre d''\00E9tat <strong>Etirer</strong> d\00E9fini par l''utilisateur final pour indiquer si la colonne doit ou non s''\00E9tirer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296730109305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la colonne doit s''\00E9tirer si l''espace disponible \00E0 l''\00E9cran est suffisant. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297071311305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'fr'
,p_message_text=>'Toujours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101297157585305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne s''\00E9tirera toujours, quel que soit le param\00E8tre d''\00E9tat <strong>Etirer</strong> d\00E9fini par l''utilisateur final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296861263305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'fr'
,p_message_text=>'Jamais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296991156305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne ne s''\00E9tirera pas et utilisera toujours la largeur indiqu\00E9e. Utile pour les colonnes avec un contenu succinct, tel que Oui/Non ou des nombres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296630123305785)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Etirer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561851674305984)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les balises HTML doivent \00EAtre enlev\00E9es des valeurs de colonne d''origine.'),
unistr('Ceci est particuli\00E8rement important pour les colonnes qui utilisent des expressions HTML, qui sont utilis\00E9es dans des liens de colonne ou qui sont export\00E9es sous forme de fichiers CSV.</p>'),
unistr('<p>Si vous s\00E9lectionnez dans la base de donn\00E9es des valeurs contenant d\00E9j\00E0 des balises HTML, ces derni\00E8res risquent d''entrer en conflit avec le HTML g\00E9n\00E9r\00E9 pour vos expressions HTML ou l''URL g\00E9n\00E9r\00E9e pour les liens de colonne.'),
unistr('Lors de l''export de ces valeurs, les balises HTML existantes sont incluses en texte brut dans le fichier CSV g\00E9n\00E9r\00E9.'),
unistr('Lorsque cette option est activ\00E9e, seules la portion de donn\00E9es r\00E9elle de la valeur de colonne est utilis\00E9e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101561780447305984)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Partitionner le code HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417521547305875)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les lignes coch\00E9es doivent \00EAtre incluses dans le traitement de page, g\00E9n\00E9ralement indiqu\00E9 par un bouton personnalis\00E9 tel que <strong>Marquer comme termin\00E9</strong>.'),
unistr('        Ces lignes coch\00E9es peuvent \00EAtre utilis\00E9es dans un processus personnalis\00E9 afin d''effectuer l''action requise.</p>'),
unistr('        <p>Remarque : les lignes s\00E9lectionn\00E9es sont trait\00E9es m\00EAme si aucun \00E9l\00E9ment contenu dans la ligne n''a \00E9t\00E9 mis \00E0 jour. En g\00E9n\00E9ral, seules les lignes ayant \00E9t\00E9 ins\00E9r\00E9es, mises \00E0 jour ou supprim\00E9es sont trait\00E9es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101417490282305875)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('La soumission inclut les lignes s\00E9lectionn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282257643305774)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez l''application au mod\00E8le d''authentification de laquelle vous voulez que ce mod\00E8le s''abonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282117176305774)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Abonn\00E9 \00E0 partir de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886518190306237)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant doit \00EAtre affich\00E9 \00E0 l''aide d''une colonne ou \00E0 l''aide d''un format avanc\00E9 bas\00E9 sur des expressions HTML et des cha\00EEnes de substitution prises en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886490914306237)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886742685306237)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme sous-titre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886699885306237)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887269373306238)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887119247306238)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101887080249306238)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&COLUMN_CLASS.</code> et <code>&EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886985934306237)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les expressions HTML \00E0 afficher dans cette colonne. Utilisez la syntaxe <code>&COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886836926306237)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101541351459305966)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le message de succ\00E8s pour ce processus.'),
unistr('Si le processus est ex\00E9cut\00E9 et qu''il ne g\00E9n\00E8re pas d''erreur, ce message de succ\00E8s appara\00EEt dans la section de notification sur la page r\00E9sultante affich\00E9e.'),
unistr('Si vous vous branchez sur une autre page \00E0 l''aide d''un r\00E9acheminement d''URL, vous devrez peut-\00EAtre s\00E9lectionner l''attribut de <em>conservation du message de succ\00E8s</em>.</p>'),
unistr('<p>Pour les traitements multilignes, la cha\00EEne de substitution suivante permet d''obtenir le nombre d''enregistrements trait\00E9s :</p>'),
'<ul>',
'  <li>Insertion : <code>#MRI_COUNT#</code></li>',
unistr('  <li>Mise \00E0 jour : <code>#MRU_COUNT#</code></li>'),
'  <li>Suppression : <code>#MRD_COUNT#</code></li>',
'</ul>',
unistr('<p>Pour le type de traitement Envoyer un courriel, la cha\00EEne de substitution <code>#TO#</code> permet d''obtenir les adresses \00E9lectroniques.</p>'),
unistr('<p>Les modules d''extension peuvent \00E9galement disposer d''autres cha\00EEnes de substitution. Pour plus de d\00E9tails, reportez-vous \00E0 la documentation du module d''extension.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695717971306090)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte \00E0 afficher dans la zone de notification (d\00E9finie comme \00E9l\00E9ment du mod\00E8le de page) lorsque ce processus est effectu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101540887357305966)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Message de succ\00E8s')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237368911305741)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la requ\00EAte SQL utilis\00E9e en tant que source pour les suggestions.</p>'),
unistr('<p>Remarque : l''ordre dans lequel les valeurs sont renvoy\00E9es est utilis\00E9 pour d\00E9terminer leur ordre d''affichage.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237201028305741)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237133647305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez une liste de valeurs statiques s\00E9par\00E9es par des virgules utilis\00E9es en tant que source pour les suggestions.</p>'),
unistr('<p>Remarque : l''ordre dans lequel les valeurs sont indiqu\00E9es est utilis\00E9 pour d\00E9terminer leur ordre d''affichage.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101237043534305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101239377967305742)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101240087027305743)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236329027305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la mani\00E8re dont les suggestions sont d\00E9termin\00E9es pour ce filtre.</p>'),
unistr('<p>Remarque : les valeurs indiqu\00E9es sont v\00E9rifi\00E9es par rapport aux entr\00E9es visibles de la liste des valeurs et seront utilis\00E9es uniquement en cas de correspondance.'),
unistr('Si une valeur est introuvable, elle sera ignor\00E9e et la suivante sera v\00E9rifi\00E9e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236405189305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'fr'
,p_message_text=>'Dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236579826305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la <strong>premi\00E8re</strong> entr\00E9e visible de la liste des valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236801973305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236941424305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs sont renvoy\00E9es \00E0 partir de la <em>requ\00EAte SQL</em> entr\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236621207305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeurs statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236760996305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs s\00E9par\00E9es par des virgules.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101236280391305740)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505046424305940)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le texte qui appara\00EEt en haut des fichiers de t\00E9l\00E9chargement. Vous pouvez indiquer la classification des donn\00E9es, des messages \00E0 caract\00E8re juridique ou d''avertissement \00E0 propos des donn\00E9es contenues dans le fichier.</p>'),
unistr('        <p> Remarque : le texte saisi appara\00EEtra dans tous les formats de t\00E9l\00E9chargement de rapports. Si le t\00E9l\00E9chargement au format CSV est activ\00E9, le texte saisi invalidera le format du fichier CSV.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504967170305940)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte compl\00E9mentaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520263654305951)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez cet attribut pour utiliser le texte d''en-t\00EAte de colonne comme libell\00E9 dans la vue de d\00E9tail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101520103528305951)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser l''en-t\00EAte de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575534813305995)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la base pour cette colonne de panneau tabulaire.</p>.'),
unistr('<p>La s\00E9lection d\00E9termine si cette colonne peut \00EAtre mise \00E0 jour dans le panneau tabulaire.'),
unistr('Les mises \00E0 jour ne sont possibles que si une mise \00E0 jour multiligne est d\00E9finie ou qu''un processus PL/SQL est impl\00E9ment\00E9 pour traiter les donn\00E9es mises \00E0 jour.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742917974306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911310979306256)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une date ou utilisez le s\00E9lecteur de date pour choisir la date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742824491306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de date (Classique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911411227306256)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une date ou utilisez le s\00E9lecteur de date pour choisir la date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101742734911306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte brut (enregistre l''\00E9tat)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910085435306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la valeur de colonne et l''enregistre dans le statut de session. Cette colonne peut \00EAtre utilis\00E9e dans le traitement de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744462052306127)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger un BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910407028306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne en tant que lien pour t\00E9l\00E9charger le fichier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743916894306127)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne masqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911570189306256)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''affiche pas la colonne, mais elle peut \00EAtre r\00E9f\00E9renc\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743447125306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne masqu\00E9e (enregistre l''\00E9tat)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911684900306256)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('N''affiche pas la colonne, mais elle peut \00EAtre r\00E9f\00E9renc\00E9e. Cette colonne peut \00EAtre utilis\00E9e dans le traitement de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744361913306127)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''image'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910371050306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la colonne en tant qu''image.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744268149306127)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'fr'
,p_message_text=>'Lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910279586306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la colonne en tant que lien.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744596006306127)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 pourcentage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910555747306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la colonne en tant que graphique \00E0 pourcentage. La valeur extraite doit \00EAtre comprise entre 0 et 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744086236306127)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'fr'
,p_message_text=>'Texte brut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909987793306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche la valeur de colonne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101744159068306127)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'fr'
,p_message_text=>'Texte brut (en fonction d''une liste de valeurs)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910160720306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche la valeur renvoy\00E9e par la liste de valeurs indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743563362306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) instantan\00E9e (indique la valeur renvoy\00E9e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911066943306256)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une valeur dans la fen\00EAtre instantan\00E9e. La valeur renvoy\00E9e par la liste de valeurs est affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743650165306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) instantan\00E9e (indique la valeur d''affichage)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910989962306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une valeur dans la fen\00EAtre instantan\00E9e. La valeur d''affichage de la liste de valeurs est affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743343235306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'fr'
,p_message_text=>'Groupe de boutons d''option'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911168164306256)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un seul groupe de boutons d''options dans la liste de valeurs indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743893632306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101909822903306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E8re une case \00E0 cocher au d\00E9but de chaque ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743255937306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'fr'
,p_message_text=>'Liste SELECT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910888620306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une valeur dans la liste de valeurs indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743795946306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Case \00E0 cocher simple')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101911250650306256)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez ou d\00E9s\00E9lectionnez une seule case \00E0 cocher.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743091047306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Champ de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910627292306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une valeur dans un champ de texte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101743103783306126)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'fr'
,p_message_text=>'Zone de texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101910747795306255)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez une valeur dans un champ de texte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101575490795305994)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298367725305786)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez sur la cible pour appeler une bo\00EEte de dialogue modale. Vous pouvez entrer la cible qui est appel\00E9e lorsque ce branchement est appel\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101298277352305786)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Cible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878895689306232)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez des options de mod\00E8le pour personnaliser l''interface utilisateur de ce composant.</p>'),
unistr('<p>Vous pouvez \00E9galement modifier les options de mod\00E8le lorsque vous ex\00E9cutez l''application \00E0 l''aide d''<strong>Options de mod\00E8le en service</strong>.'),
unistr('Options de mod\00E8le en service vous permet de personnaliser votre application en temps r\00E9el, en vous permettant de pr\00E9visualiser et d''appliquer diverses options.'),
unistr('Pour acc\00E9der \00E0 Options de mod\00E8le en service, ex\00E9cutez l''application \00E0 partir d''Application Builder et cliquez sur <em>Edition rapide</em> dans la barre d''outils de d\00E9veloppeur.'),
unistr('Positionnez le curseur de la souris sur un composant de page, tel qu''une r\00E9gion, et cliquez sur l''ic\00F4ne repr\00E9sentant une cl\00E9 ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) affich\00E9 dans l''angle sup\00E9rieur gauche.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878735713306231)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879019534306232)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez des options de mod\00E8le pour personnaliser l''interface utilisateur de ce composant.</p>'),
unistr('<p>Vous pouvez \00E9galement modifier les options de mod\00E8le lorsque vous ex\00E9cutez l''application \00E0 l''aide d''<strong>Options de mod\00E8le en service</strong>.'),
unistr('Options de mod\00E8le en service vous permet de personnaliser votre application en temps r\00E9el, en vous permettant de pr\00E9visualiser et d''appliquer diverses options.'),
unistr('Pour acc\00E9der \00E0 Options de mod\00E8le en service, ex\00E9cutez l''application \00E0 partir d''Application Builder et cliquez sur <em>Edition rapide</em> dans la barre d''outils de d\00E9veloppeur.'),
unistr('Positionnez le curseur de la souris sur un composant de page, tel qu''une r\00E9gion, et cliquez sur l''ic\00F4ne repr\00E9sentant une cl\00E9 ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) affich\00E9 dans l''angle sup\00E9rieur gauche.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878933439306232)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127111509305641)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces r\00E9serv\00E9s dans un mod\00E8le de courriel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127049130305641)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces r\00E9serv\00E9s de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560405162305983)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type de mod\00E8le pour cet \00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739674983306123)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739728737306123)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''\00E9tat pr\00E9d\00E9finis n''\00E9tant pas directement associ\00E9s \00E0 des th\00E8mes. En l''absence de corr\00E9lation entre ces mod\00E8les pr\00E9d\00E9finis et le th\00E8me en cours, la mise en page de l''\00E9tat reste identique m\00EAme si vous modifiez le th\00E8me d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739431642306123)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101739552240306123)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''\00E9tat disponibles dans le th\00E8me correspondant, en fonction du th\00E8me en cours pour l''interface utilisateur de cette page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101560350385305983)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067603229306382)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En fonction du <strong>type de recherche</strong> indiqu\00E9, entrez un nom de colonne de base de donn\00E9es ou la liste des noms de colonne de base de donn\00E9es utilis\00E9s pour la recherche de texte.</p>'),
'<ul>',
unistr('  <li><strong>Recherche de lignes</strong> : entrez la liste des noms de colonne de base de donn\00E9es s\00E9par\00E9s par une virgule et respectant les minuscules/majuscules de type VARCHAR2 utilis\00E9s pour la recherche de texte. Si aucune colonne n''est indiqu\00E9e')
||unistr(', toutes les colonnes VARCHAR2 sont automatiquement utilis\00E9es.</li>'),
unistr('  <li><strong>Oracle Text</strong> : entrez le nom de colonne de base de donn\00E9es respectant les minuscules/majuscules qui contient l''index Oracle Text.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102067583677306382)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339446836305818)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le th\00E8me \00E0 associer \00E0 l''interface utilisateur en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101339395675305818)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487378957305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la position des libell\00E9s de graduation par rapport \00E0 la zone de trac\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487515010305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Int\00E9rieur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487437164305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Ext\00E9rieur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487285755305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486902662305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si les libell\00E9s de graduation sont affich\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101486815241305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487172629305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si le graphique fait automatiquement pivoter les libell\00E9s \00E0 90 degr\00E9s afin d''en faire rentrer un plus grand nombre sur l''axe.'),
unistr('        La rotation est applicable uniquement \00E0 des libell\00E9s de cat\00E9gorie pour un axe horizontal.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101487012577305927)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Rotation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101857721093306212)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Identique \00E0 la version Standard')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988589512306322)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez la m\00EAme carte en arri\00E8re-plan pour le mode clair et le mode fonc\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812304266306177)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez la mosa\00EFque \00E0 utiliser comme carte en arri\00E8re-plan quand le mode fonc\00E9 est activ\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813272719306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'fr'
,p_message_text=>'Carte du monde Oracle BI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813344762306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base discr\00E8te reposant sur des donn\00E9es de carte HERE. Ce style de carte de base offre un contexte d''emplacement aux donn\00E9es et en accentue la visualisation.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par Oracle, Etats-Unis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812852558306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'OpenStreetMap - Clair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812995812306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base offre un contexte d''emplacement d\00E9taill\00E9 aux donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812460450306177)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('OpenStreetMap - Fonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812545028306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Carte de base claire discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812635843306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'fr'
,p_message_text=>'OpenStreetMap - Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812787429306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base fonc\00E9e discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813020048306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'fr'
,p_message_text=>'Carte du monde Oracle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101813129280306178)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es de carte HERE. Ce style de carte de base offre un contexte des lieux aux donn\00E9es et en accentue la visualisation.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par Oracle, Etats-Unis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812298877306177)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mode fonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811118133306176)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez la mosa\00EFque \00E0 utiliser comme carte en arri\00E8re-plan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812080994306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'fr'
,p_message_text=>'Carte du monde Oracle BI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101812118785306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base discr\00E8te reposant sur des donn\00E9es de carte HERE. Ce style de carte de base offre un contexte d''emplacement aux donn\00E9es et en accentue la visualisation.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par Oracle, Etats-Unis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811668660306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'fr'
,p_message_text=>'OpenStreetMap - Clair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811714181306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base offre un contexte d''emplacement d\00E9taill\00E9 aux donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811400544306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'fr'
,p_message_text=>unistr('OpenStreetMap - Fonc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811535889306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base fonc\00E9e discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811280509306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'fr'
,p_message_text=>'OpenStreetMap - Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811303412306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base claire discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811854425306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'fr'
,p_message_text=>'Carte du monde Oracle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811969893306177)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es de carte HERE. Ce style de carte de base offre un contexte des lieux aux donn\00E9es et en accentue la visualisation.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par Oracle, Etats-Unis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101811035553306176)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810521936306176)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la carte en arri\00E8re-plan \00E0 utiliser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810873723306176)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810931393306176)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisissez les mosa\00EFques de cartes \00E0 utiliser pour la carte en arri\00E8re-plan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810660611306176)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810787682306176)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez les param\00E8tres de carte en arri\00E8re-plan par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101810405540306176)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Fond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588121737306004)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le format d''affichage de l''heure.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101747935736306129)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'fr'
,p_message_text=>'12 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101748027649306130)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'fr'
,p_message_text=>'24 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101588090695306004)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Format horaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102076862882306389)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le titre de l''axe. Ce titre d\00E9crit les informations repr\00E9sent\00E9es sur l''axe de votre graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101227577252305733)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le titre \00E0 afficher dans la barre de titre de la fen\00EAtre du navigateur. Le moteur &PRODUCT_NAME. utilise le titre indiqu\00E9 ici pour remplacer la cha\00EEne de substitution <code>#TITLE#</code> figurant dans le mod\00E8le de page. Ce titre est ins\00E9r\00E9')
||' entre les balises HTML <code>&lt;TITLE&gt;</code> et <code>&lt;/TITLE&gt;</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101228457055305734)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un titre de r\00E9gion. Le titre de r\00E9gion ne s''affiche que s''il est d\00E9fini dans le mod\00E8le de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189820052305687)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le titre de la page. Il est affich\00E9 dans la barre de titre de la fen\00EAtre du navigateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101189718447305687)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885662393306237)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si ce composant doit \00EAtre affich\00E9 \00E0 l''aide d''une colonne ou \00E0 l''aide d''un format avanc\00E9 bas\00E9 sur des expressions HTML et des cha\00EEnes de substitution prises en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885587729306236)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Formatage avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885879962306237)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme titre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885737195306237)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886378302306237)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez des classes \00E0 ajouter \00E0 ce composant. Vous pouvez ajouter plusieurs classes en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886215773306237)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886128365306237)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&COLUMN_CLASS.</code> et <code>&EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL d''\00E9tat.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101886087676306237)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez les expressions HTML \00E0 afficher dans cette colonne. Utilisez la syntaxe <code>&COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101885926301306237)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439158872305891)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifiez les contr\00F4les suppl\00E9mentaires devant \00EAtre affich\00E9s dans la barre d''outils.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439614538305892)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'fr'
,p_message_text=>'Menu Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439730030305892)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche le bouton du menu Actions, qui contient g\00E9n\00E9ralement un ensemble d''options complet. Ces options permettent \00E0 l''utilisateur final de personnaliser l''\00E9tat selon les fonctions que vous rendez disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439854444305892)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Bouton R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439951513305892)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche le bouton R\00E9initialiser. Lorsque ce bouton est activ\00E9, toutes les personnalisations telles que les filtres, l''organisation et la largeur des colonnes sont enlev\00E9es, et la d\00E9finition d''\00E9tat est recharg\00E9e \00E0 partir du serveur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440038750305892)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'fr'
,p_message_text=>'Bouton Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101440179342305892)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Affiche le bouton Enregistrer. Lorsque ce bouton est activ\00E9, seules les modifications apport\00E9es \00E0 cette grille interactive sont enregistr\00E9es, sans avoir \00E0 enregistrer la totalit\00E9 de la page.'),
unistr('        <p>Le bouton d''enregistrement est affich\00E9 uniquement lorsque la grille interactive est modifiable et lorsque l''utilisateur final est autoris\00E9 \00E0 ajouter, \00E0 mettre \00E0 jour ou \00E0 supprimer des \00E9l\00E9ments.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439201780305891)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection de colonne de recherche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439380180305891)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche une liste d\00E9roulante des colonnes non num\00E9riques affich\00E9es. Si une colonne est s\00E9lectionn\00E9e, alors la recherche est effectu\00E9e uniquement aupr\00E8s des valeurs de cette colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439478173305891)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'fr'
,p_message_text=>'Champ de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439569629305891)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche un champ de texte dans la barre de recherche utilis\00E9e pour saisir des crit\00E8res de recherche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101439014455305891)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001649776306332)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101906166514306252)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte d''arborescence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001759134306332)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543558557305967)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indique si la colonne reconna\00EEt le fuseau horaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543409031305967)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Reconnaissance du fuseau horaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576832712305996)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le nom de colonne r\00E9f\00E9renc\00E9e par cette colonne d''\00E9tat.'),
unistr('Cet attribut permet de comparer des r\00E9f\00E9rences \00E0 des colonnes dans les applications \00E0 l''aide des valeurs par d\00E9faut d''interface utilisateur.'),
unistr('Cette r\00E9f\00E9rence est g\00E9r\00E9e manuellement apr\00E8s avoir \00E9t\00E9 initialis\00E9e par un assistant, lorsque cela est possible.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576738070305995)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576677980305995)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la table ou la vue r\00E9f\00E9renc\00E9e par cette colonne.'),
unistr('Cet attribut permet de comparer des r\00E9f\00E9rences \00E0 des colonnes dans les applications \00E0 l''aide des valeurs par d\00E9faut d''interface utilisateur.'),
unistr('Cette r\00E9f\00E9rence est g\00E9r\00E9e manuellement apr\00E8s avoir \00E9t\00E9 initialis\00E9e par un assistant, lorsque cela est possible.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576514185305995)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576479115305995)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le sch\00E9ma propri\00E9taire de la table de r\00E9f\00E9rence.'),
unistr('Cet attribut permet de comparer des r\00E9f\00E9rences \00E0 des colonnes dans les applications \00E0 l''aide des valeurs par d\00E9faut d''interface utilisateur.'),
unistr('Cette r\00E9f\00E9rence est g\00E9r\00E9e manuellement apr\00E8s avoir \00E9t\00E9 initialis\00E9e par un assistant, lorsque cela est possible.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576333435305995)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528332811305957)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le type de colonne utilis\00E9 pour identifier la ligne en cours lors de l''utilisation de la colonne de lien.'),
unistr('Par d\00E9faut, <strong>ROWID</strong> est utilis\00E9 pour identifier de fa\00E7on unique les lignes dans un \00E9tat. Toutefois, vous pouvez \00E9galement utiliser une autre colonne en s\00E9lectionnant <strong>Colonne unique</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728585522306115)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne unique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101728421908306115)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'fr'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528261372305957)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifier les lignes de fa\00E7on unique par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528502488305957)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la premi\00E8re colonne utilis\00E9e pour identifier les lignes de fa\00E7on unique dans ce composant.</p>'),
unistr('<p><strong>ROWID</strong> est \00E9galement inclus dans la liste de colonnes disponibles \00E0 des fins de compatibilit\00E9 amont.</p>'),
unistr('<p>Remarque : pour un \00E9tat interactif avec l''attribut <em>Colonne de lien</em> d\00E9fini sur <strong>Lien vers la vue monoligne</strong>, vous ne pouvez s\00E9lectionner qu''une seule colonne. D''autres composants permettent de s\00E9lectionner jusqu''\00E0 trois colo')
||'nnes.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528443236305957)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne unique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528711026305957)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la deuxi\00E8me colonne \00E0 utiliser pour identifier les lignes de fa\00E7on unique dans ce composant. Servez-vous de cet attribut lorsque votre table contient une cl\00E9 primaire en deux parties.</p>'),
unistr('<p><strong>ROWID</strong> est \00E9galement inclus dans la liste des colonnes disponibles \00E0 des fins de compatibilit\00E9 amont.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528616231305957)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne unique 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528921636305957)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la troisi\00E8me colonne \00E0 utiliser pour identifier les lignes de fa\00E7on unique dans ce composant. Servez-vous de cet attribut lorsque votre table contient une cl\00E9 primaire en trois parties.</p>'),
unistr('<p><strong>ROWID</strong> est \00E9galement inclus dans la liste des colonnes disponibles \00E0 des fins de compatibilit\00E9 amont.</p>'),
unistr('<p>Remarque : si la cl\00E9 primaire de votre table comporte plus de trois colonnes, vous devez identifier les lignes de fa\00E7on unique avec <strong>ROWID</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101528833246305957)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne unique 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416328248305874)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez un mod\00E8le d''autorisation pour restreindre les utilisateurs autoris\00E9s \00E0 mettre \00E0 jour des lignes.'),
unistr('Pour autoriser un utilisateur final \00E0 mettre \00E0 jour des lignes, ce mod\00E8le d''autorisation doit renvoyer la valeur TRUE pour cet utilisateur.'),
unistr('Si aucun mod\00E8le d''autorisation n''est indiqu\00E9, n''importe quel utilisateur peut mettre \00E0 jour des lignes dans cette grille interactive.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101416258019305874)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303824754305791)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Affiche l''interface utilisateur pour cette page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303740447305791)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338453057305817)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type d''interface utilisateur pour cette page. S\00E9lectionnez <strong>Bureau</strong> pour les pages con\00E7ues principalement pour une utilisation de bureau. Pour les autres interfaces, comme les smartphones ou tablettes, s\00E9lectionnez l''in')
||'terface utilisateur correspondante.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722696647306110)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'fr'
,p_message_text=>'Bureau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101722717703306111)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'fr'
,p_message_text=>'Smartphone jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101338342777305817)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type d''interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553561841305977)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sp\00E9cifiez si cette colonne appara\00EEt \00E9galement dans l''en-t\00EAte de ligne.'),
unistr('L''inclusion de la valeur de colonne peut am\00E9liorer grandement l''accessibilit\00E9 des champs de panneau affich\00E9s dans un \00E9tat.'),
unistr('Dans ce cas, l''en-t\00EAte de ligne est utilis\00E9 avec l''en-t\00EAte de colonne pour afficher les libell\00E9s des champs de panneau dans l''\00E9tat. Le format employ\00E9 est le suivant : <code>''&lt;En-t\00EAte de colonne&gt; : &lt;En-t\00EAte de ligne&gt;''</code>.</p>'),
unistr('<p>Il peut s''agir par exemple d''un \00E9tat sur la table EMP, dans laquelle vous d\00E9finissez la colonne ENAME en tant qu''en-t\00EAte de ligne. Supposons que vous ayez une ligne dans laquelle ENAME est ''JONES'' ; dans ce cas, le libell\00E9 du champ Salaire de cett')
||'e ligne sera "Salaire : JONES".',
unistr('Cela permet \00E0 un utilisateur de lecteur d''\00E9cran de naviguer par les champs de l''\00E9tat, tout en continuant \00E0 indiquer quels champs de panneau sont li\00E9s \00E0 quelle ligne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101553424642305977)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser comme en-t\00EAte de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581866865305999)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si vous voulez d\00E9finir un lien personnalis\00E9 pour la vue ic\00F4ne. Cette option fournit une plus grande flexibilit\00E9 lors de la d\00E9finition du contenu de la vue ic\00F4ne, y compris la possibilit\00E9 d''utiliser plus d''une colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581784272305999)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300930085305788)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la r\00E9gion associ\00E9e pour cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101300839325305788)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion modifiable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299440823305787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le type d''\00E9galit\00E9 \00E0 tester pour cette validation. Selon votre choix, des attributs suppl\00E9mentaires sont obligatoires pour d\00E9finir totalement cette validation.</p>'),
unistr('<p>Si la validation r\00E9ussit le test d''\00E9galit\00E9 ou donne la valeur TRUE, le message d''erreur de validation n''appara\00EEt pas.'),
unistr('Les messages d''erreur de validation sont affich\00E9s lorsque la validation \00E9choue au test d''\00E9galit\00E9, l''\00E9valuation donne la valeur FALSE ou une cha\00EEne de texte non vide est renvoy\00E9e.</p>'),
unistr('<p>Un \00E9chec de validation ne met pas fin \00E0 l''\00E9valuation des validations suivantes. Par cons\00E9quent, chaque validation suivante doit d\00E9clencher un message d''erreur de validation suppl\00E9mentaire. Si vous voulez arr\00EAter l''ex\00E9cution des autres validations,')
||unistr(' vous devez ajouter une logique suppl\00E9mentaire \00E0 la premi\00E8re validation en \00E9chec, comme la d\00E9finition d''une valeur sp\00E9cifique pour un \00E9l\00E9ment de page, puis am\00E9liorer la logique conditionnelle des autres validations, selon vos besoins. Les processus e')
||unistr('t branchements suivants ne sont pas ex\00E9cut\00E9s si des validations \00E9chouent \00E0 l''\00E9valuation.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756195684306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes renvoy\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756201854306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la requ\00EAte SQL renvoie plusieurs lignes.<br>'),
unistr('Echec si la requ\00EAte SQL ne renvoie aucune ligne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962347552306301)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962485420306301)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si l''expression renvoie la valeur TRUE.<br>'),
'Echec si l''expression renvoie la valeur FALSE.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756775127306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de fonction (renvoyant une valeur bool\00E9enne)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756860501306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si le corps de fonction renvoie la valeur TRUE.<br>'),
'Echec si le corps de fonction renvoie la valeur FALSE.<br>',
unistr('Remarque : le r\00E9sultat renvoy\00E9 \00E0 partir de la fonction doit \00EAtre de type Boolean.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756945223306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction (renvoyant un texte d''erreur)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757045465306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si le corps de fonction renvoie une cha\00EEne vide.<br>'),
unistr('Echec si le corps de fonction renvoie une cha\00EEne non vide. La cha\00EEne renvoy\00E9e appara\00EEt en tant que message d''erreur pour la validation.<br>'),
unistr('Remarque : le r\00E9sultat renvoy\00E9 \00E0 partir de la fonction doit \00EAtre une cha\00EEne de texte.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757726894306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne contient aucun espace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757892300306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment ne contient pas d''espaces.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment contient des espaces.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759741426306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment contient au moins un des caract\00E8res indiqu\00E9s dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759819678306139)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment comprend au moins un caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment ne comprend aucun caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759953273306139)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne contient aucun des caract\00E8res indiqu\00E9s dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760022974306139)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment ne comprend aucun caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment comprend au moins un caract\00E8re du texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759576106306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment contient uniquement les caract\00E8res indiqu\00E9s dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759669275306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment contient uniquement les caract\00E8res du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment contient des caract\00E8res qui ne se trouvent pas dans le texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758757316306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment = Valeur')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758806324306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment est identique au texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759179683306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est contenu dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759268824306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758926385306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment != Valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759095803306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment est diff\00E9rente du texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment est identique au texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759327471306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas contenu dans la valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101759448077306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment n''est pas enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment est enti\00E8rement comprise dans le texte saisi dans l''attribut <em>Valeur</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757962183306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est alphanum\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758067025306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment est alphanum\00E9rique (elle contient uniquement des lettres, des chiffres et aucun caract\00E8re sp\00E9cial).<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment comporte des caract\00E8res sp\00E9ciaux.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758349539306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est une date valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758498246306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment est une date valide.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment n''est pas une date valide.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758152676306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758238478306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment est num\00E9rique.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment contient des caract\00E8res non num\00E9riques, y compris des espaces, autres que les espaces de d\00E9but.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758538553306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est un horodatage valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101758648057306138)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment est un horodatage valide.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment n''est pas un horodatage valide.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757100381306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NOT NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757217466306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment n''est pas vide.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment est vide.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757394579306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment est NOT NULL ou \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757474715306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment n''est pas vide et n''est pas \00E9gale au nombre z\00E9ro.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment est vide ou est \00E9gale au nombre z\00E9ro.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757591025306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''est pas \00E9gal \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101757602297306137)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment n''est pas \00E9gale au nombre z\00E9ro.<br>'),
unistr('Echec si la valeur d''\00E9l\00E9ment est \00E9gale au nombre z\00E9ro.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756339838306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune ligne n''a \00E9t\00E9 renvoy\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756437157306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la requ\00EAte SQL ne renvoie aucune ligne.<br>'),
unistr('Echec si la requ\00EAte SQL renvoie plusieurs lignes.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756550057306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'fr'
,p_message_text=>'Erreur PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101756631382306136)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si le code PL/SQL est ex\00E9cut\00E9 sans g\00E9n\00E9rer d''erreur.<br>'),
unistr('Echec si l''expression PL/SQL g\00E9n\00E8re une erreur lors de son ex\00E9cution.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760141678306139)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment correspond \00E0 une expression r\00E9guli\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101760211184306139)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Succ\00E8s si la valeur d''\00E9l\00E9ment correspond \00E0 l''expression r\00E9guli\00E8re saisie dans l''attribut <em>Valeur</em>.'),
unistr('Echec si la valeur d''\00E9l\00E9ment ne correspond pas \00E0 l''expression r\00E9guli\00E8re saisie dans l''attribut <em>Valeur</em>.<br>'),
unistr('Remarque : les expressions r\00E9guli\00E8res permettent de rechercher des mod\00E8les dans les donn\00E9es de cha\00EEne \00E0 l''aide de conventions syntaxiques standardis\00E9es, plut\00F4t qu''une simple comparaison de caract\00E8res.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299329935305787)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484557914305925)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez si la ligne de base de l''axe commence \00E0 la valeur minimale des donn\00E9es ou \00E0 z\00E9ro. Cette option est applicable uniquement \00E0 des axes de donn\00E9es num\00E9riques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484678749305925)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'fr'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484725266305925)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101484415819305925)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Echelle de ligne de base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516209499305948)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nom de la collection. La source de cette valeur de param\00E8tre d\00E9pendra de la valeur de la colonne CLOB de la premi\00E8re ligne de la collection.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516194670305948)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470837548305915)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez la devise qui sera utilis\00E9e lors du formatage de la valeur sur le graphique.'),
unistr('        La valeur doit se pr\00E9senter sous la forme d''un code de devise alphab\00E9tique ISO 4217. Si le format est d\00E9fini sur Devise et qu''aucune devise n''est d\00E9finie dans la propri\00E9t\00E9 <strong>Devise<strong>, la devise sera automatiquement d\00E9riv\00E9e de la l')
||'angue de l''application au moment de l''affichage du graphique.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470706759305915)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Devise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596964150306011)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le nombre de d\00E9cimales \00E0 appliquer \00E0 la valeur num\00E9rique sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584565971306001)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le nombre de d\00E9cimales \00E0 utiliser dans les libell\00E9s de valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101584444374306001)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9cimales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973219514306310)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973608658306311)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973537041306310)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973421121306310)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973772125306311)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973305753306310)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973120100306310)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471213715305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le comportement d''\00E9chelle de la valeur sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471491696305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471715300305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'fr'
,p_message_text=>'Milliard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471682902305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'fr'
,p_message_text=>'Million'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471337006305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471947000305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'fr'
,p_message_text=>'Quadrillion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471545934305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'fr'
,p_message_text=>'Millier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471828845305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'fr'
,p_message_text=>'Trillion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471181101305916)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Echelle de format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101596844605306011)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le type de formatage \00E0 appliquer \00E0 la valeur sur le graphique.'),
unistr('        Les formats <strong>D\00E9cimal</strong>, <strong>Pourcentage</strong> ou <strong>Devise</strong> s''appliquent uniquement \00E0 des valeurs num\00E9riques.'),
unistr('        Les formats <strong>Date</strong>, <strong>Heure</strong> et <strong>Date/Heure</strong> s''appliquent uniquement \00E0 des valeurs de ce type de donn\00E9es sur le graphique.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469257125305914)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un type de formatage num\00E9rique, de date et/ou d''heure \00E0 appliquer \00E0 la valeur sur le graphique. Pour le formatage de date et/ou d''heure, assurez-vous que l''attribut de graphique <strong>Type d''axe temporel</strong> est d\00E9fini sur l''une d')
||unistr('es valeurs suivantes, en fonction des donn\00E9es de votre graphique : <strong>Activ\00E9</strong>, <strong>Fr\00E9quence mixte</strong> ou <strong>Ignorer les intervalles</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470539263305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'fr'
,p_message_text=>'Devise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607852245306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsqu''un nombre est au format mon\00E9taire, la propri\00E9t\00E9 Devise doit \00EAtre d\00E9finie pour indiquer la devise utilis\00E9e lors du formatage du nombre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469641050305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'fr'
,p_message_text=>'Date - Format complet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606718317306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque le format de date est complet, il contient le jour de la semaine en entier (EEEE), l''ann\00E9e (y), le mois en entier (MMMM) et le jour (d). Par exemple, mercredi 6 janvier 2016.'),
unistr('        Pour certaines langues, le format de mois long n''est pas utilis\00E9. Par exemple, en japonais, la forme num\00E9rique du mois est utilis\00E9e dans des mod\00E8les.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469574818305914)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'fr'
,p_message_text=>'Date - Format long'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606615735306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque le format de date est long, il contient l''ann\00E9e, le mois en entier et le jour. Par exemple, 6 janvier 2016.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469488794305914)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'fr'
,p_message_text=>'Date - Format moyen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606568260306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque le format de date est moyen, il contient l''ann\00E9e, le mois sous forme abr\00E9g\00E9e (MMM) et le jour. Par exemple, 6 jan 2016.'),
unistr('        Pour certaines langues, l''abr\00E9viation n''est pas utilis\00E9e pour les mois. Dans ce cas, le format moyen contient le mois sous forme num\00E9rique (MM/M).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469347535305914)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Date - Format abr\00E9g\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606499223306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque le format de date est court, il contient l''ann\00E9e, le mois sous forme num\00E9rique (MM/M) et le jour. Par exemple, 1/6/16.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607548843306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'fr'
,p_message_text=>'Format de date/d''heure - Complet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607608491306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque le format de date-heure est complet, il contient le jour de la semaine en entier (EEEE), l''ann\00E9e (y), le mois en entier (MMMM), le jour (d), l''heure (h/H), les minutes (mm), les secondes (ss) et le fuseau horaire (zzzz). Par exemple, mercredi')
||' 6 janvier 2016 07 h 30 min 21 s.',
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470390380305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'fr'
,p_message_text=>'Date/Heure - Format long'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607445353306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque le format de date-heure est long, il contient l''ann\00E9e, le mois en entier, le jour, l''heure, les minutes, les secondes et le fuseau horaire (z). Par exemple, 6 janvier 2016 07:30:21.'),
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470262287305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'fr'
,p_message_text=>'Date/Heure - Format moyen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607369934306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque le format de date-heure est moyen, il contient l''ann\00E9e, le mois sous forme abr\00E9g\00E9e (MMM), le jour, l''heure, les minutes, les secondes et le fuseau horaire (z). Par exemple, 6 jan 2016 07:30:21.'),
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470158879305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Date/Heure - Format abr\00E9g\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607270175306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque le format de date-heure est court, il contient l''ann\00E9e, le mois sous forme num\00E9rique (MM/M), le jour, l''heure et les minutes. Par exemple, 01/06/16 07:30.'),
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470405435305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9cimal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607769063306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsqu''un nombre est au format d\00E9cimal, la marque d\00E9cimale est remplac\00E9e par le symbole le plus adapt\00E9 \00E0 l''environnement local. En anglais, cette marque est un point ("."), alors que pour nombre d''autres environnements locaux, il s''agit d''une virgule')
||' (",").'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470676489305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607989976306019)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsqu''un nombre est au format de pourcentage, les valeurs sur le graphique sont multipli\00E9es par 100 pour appara\00EEtre sous forme de pourcentage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470001974305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'fr'
,p_message_text=>'Heure - Format complet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607136811306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Lorsque le format d''heure est complet, il contient l''heure (h/H), les minutes (mm), les secondes (ss) et le fuseau horaire (zzzz). Par exemple, 07 h 30 min 21 s.',
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469905307305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'fr'
,p_message_text=>'Heure - Format long'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101607047582306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Lorsque le format d''heure est long, il contient l''heure, les minutes, les secondes et le fuseau horaire (z). Par exemple, 07:30:21.',
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469838706305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'fr'
,p_message_text=>'Heure - Format moyen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606961041306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Lorsque le format d''heure est moyen, il contient l''heure, les minutes et les secondes. Par exemple, 07:30:21.',
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469798027305915)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Heure - Format abr\00E9g\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101606813860306018)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Lorsque le format d''heure est court, il contient l''heure et les minutes. Par exemple, 07:30.',
unistr('        Le format de l''heure est diff\00E9rent selon que la langue de l''application utilise ou non le format 12 heures.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469108850305914)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975210139306312)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975500097306312)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975454725306312)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975335081306312)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975667314306312)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975177666306312)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513141206305946)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez l''\00E9l\00E9ment de page ou d''application utilis\00E9 comme source pour cette valeur de param\00E8tre.'),
unistr('Vous pouvez entrer le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513070366305946)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974801052306311)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression Java qui g\00E9n\00E8re la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974750620306311)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976426638306313)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Java qui renvoie la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976359365306313)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974654643306311)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974552791306311)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression JavaScript qui g\00E9n\00E8re la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974442903306311)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976283325306313)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976136197306312)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction JavaScript qui renvoie la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976068680306312)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101469018732305914)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez une valeur minimale pour le graphique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101468935747305914)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597034805306011)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez le mod\00E8le num\00E9rique \00E0 appliquer \00E0 la valeur num\00E9rique sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088768287306398)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Mod\00E8le num\00E9rique pour repr\00E9senter les temp\00E9ratures en farenheit, par exemple 15&deg;F :</dt>'),
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
unistr('<dt>Mod\00E8le num\00E9rique pour repr\00E9senter les nombres dans un format sp\00E9cifique, par exemple, 12,30,00 :</dt>'),
'<dd><pre>',
'##,##,##',
'</pre></dd>',
unistr('<dt>Mod\00E8le num\00E9rique pour repr\00E9senter les nombres en millim\00E8tres :</dt>'),
'<dd><pre>',
'# mm',
'</pre></dd>',
unistr('<dt>Mod\00E8le de date pour repr\00E9senter la date au format Mois Ann\00E9e, par exemple, Jul 2016 :</dt>'),
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
unistr('<dt>Mod\00E8le de date pour repr\00E9senter la date au format Mois, par exemple, Juil :</dt>'),
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101471045054305916)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez un mod\00E8le de date ou num\00E9rique localis\00E9 facultatif, dans lequel les caract\00E8res utilis\00E9s sont conformes au r\00E9pertoire Unicode CLDR pour les formats date/heure.'),
unistr('        Lorsqu''il est pr\00E9sent, le format s\00E9lectionn\00E9 sera remplac\00E9.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101470992688305915)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974389916306311)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974287730306311)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression PL/SQL qui g\00E9n\00E8re la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974150620306311)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975991506306312)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975827909306312)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction PL/SQL qui renvoie la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975794905306312)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942444081305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indiquez la position \00E0 laquelle la valeur doit \00EAtre affich\00E9e sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941810036305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942539580305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La valeur sera affich\00E9e \00E0 la position par d\00E9faut sur le graphique, soit en dehors de la zone de trac\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941960576305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'fr'
,p_message_text=>'Au centre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942686211305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La valeur sera affich\00E9e au centre de l''indicateur sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942031978305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('A l''int\00E9rieur de la bordure de l''indicateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942741368305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La valeur sera affich\00E9e \00E0 l''int\00E9rieur de la bordure de l''indicateur sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942181940305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('A l''ext\00E9rieur de la bordure de l''indicateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942891446305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La valeur sera affich\00E9e \00E0 l''ext\00E9rieur de la bordure de l''indicateur sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942272242305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'fr'
,p_message_text=>unistr('A l''ext\00E9rieur de la zone de trac\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942915277305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La valeur sera affich\00E9e \00E0 l''ext\00E9rieur de la zone de trac\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100942339784305501)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Avec libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943051128305502)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Si le libell\00E9 est affich\00E9, la valeur sera affich\00E9e dans la m\00EAme position que le libell\00E9. Si le libell\00E9 n''est pas affich\00E9, la valeur sera affich\00E9e \00E0 l''ext\00E9rieur de la zone de trac\00E9 sur le graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941706112305500)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Position'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513341808305946)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la pr\00E9f\00E9rence utilisateur \00E0 utiliser comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101513293440305946)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101975039839306312)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression Python qui g\00E9n\00E8re la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974920401306312)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976659268306313)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le corps de fonction Python qui renvoie la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101976543797306313)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512905807305946)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la requ\00EAte SQL utilis\00E9e comme source pour cette valeur de param\00E8tre. Si plusieurs lignes sont renvoy\00E9es, la valeur de la premi\00E8re ligne est utilis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512840386305946)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200250813305695)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S''il est d\00E9fini sur <strong>Activ\00E9</strong> et que l''\00E9l\00E9ment de page est visible, &PRODUCT_NAME. effectue automatiquement une validation NON NULL lors de la soumission de la page.</p>'),
unistr('<p>Si vous d\00E9finissez un message <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> dans Composants partag\00E9s > Messages texte, le texte d''erreur pr\00E9d\00E9fini peut \00EAtre remplac\00E9 par un texte d''erreur propre \00E0 l''application.</p>'),
unistr('<p>L''emplacement d''affichage du message est d\00E9fini par le param\00E8tre de niveau application <strong>Emplacement d''affichage d''erreur par d\00E9faut</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101200134037305695)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101974065890306311)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour renvoyer YES lorsque l''employ\00E9 est un responsable et que son service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973927859306311)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression SQL qui g\00E9n\00E8re la valeur utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101973800571306311)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512757941305945)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur statique utilis\00E9e comme source pour cette valeur de param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512667951305945)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101595095179306009)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>'Indiquez le mode d''affichage de la valeur sur le graphique, sous forme de nombre ou de pourcentage de la valeur totale.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594828746306009)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597387465306011)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La valeur sera affich\00E9e sous forme de nombre sur le graphique.</p> <p>Remarque : l''attribut <strong>Format</strong> doit \00EAtre utilis\00E9 uniquement pour appliquer un formatage de devise ou d\00E9cimal personnalis\00E9 au libell\00E9 et \00E0 la valeur affich\00E9s sur l')
||'e graphique.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594994785306009)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101597413785306011)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La valeur sera affich\00E9e sous la forme d''un pourcentage compris entre 0 % et 100 %.</p> <p>Remarque : lorsque <strong>Format</strong> est d\00E9fini sur <strong>Pourcentage</strong>, les valeurs sur le graphique sont multipli\00E9es par 100 pour appara\00EEtre')
||unistr(' sous forme de pourcentage. Si vous souhaitez utiliser l''attribut Format, v\00E9rifiez que le type de libell\00E9 est d\00E9fini sur Nombre.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594712964306009)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type de valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511123531305944)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez la fa\00E7on dont est rempli ce param\00E8tre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101515921515305948)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'fr'
,p_message_text=>'Collection (CLOB)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516089916305948)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez cette option sur la valeur de colonne CLOB de la premi\00E8re ligne de la <em>collection</em> que vous avez saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793012944306163)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de source REST par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101793149762306163)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez la valeur par d\00E9faut d\00E9finie au sein de la source de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511414381305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511571691305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur contenue dans le statut de session pour l''<em>\00E9l\00E9ment</em> s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512496503305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'fr'
,p_message_text=>'NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512577442305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur NULL car aucune valeur n''a \00E9t\00E9 indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511833421305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511991637305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur g\00E9n\00E9r\00E9e par l''ex\00E9cution de l''<em>expression PL/SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512099993305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512173539305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur renvoy\00E9e par le <em>corps de fonction PL/SQL</em> saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512250276305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101512385447305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la valeur de la <em>pr\00E9f\00E9rence</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511621536305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL (renvoi d''une valeur unique)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511720591305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur la premi\00E8re valeur renvoy\00E9e par la <em>requ\00EAte SQL</em> saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511232029305944)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'fr'
,p_message_text=>'Valeur statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511376082305945)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini sur le texte saisi dans <em>Valeur statique</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101511061251305944)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964296260306303)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour \00E9valuer l''expression saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964656796306303)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964591670306303)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964403255306303)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964713021306303)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964331634306303)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'fr'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964166133306303)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966282601306305)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966534165306305)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966465907306305)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966332643306305)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966649760306305)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966138469306304)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962651665306302)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un langage utilis\00E9 pour ex\00E9cuter le corps de fonction saisi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962971155306302)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'fr'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962875091306302)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'fr'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962784484306302)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963015707306302)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'fr'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101962506389306302)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659050321306056)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un \00E9l\00E9ment de page ou d''application utilis\00E9 dans cette validation. Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658926013306056)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965816046306304)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Java pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965716724306304)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967437611306305)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Java qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967377543306305)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963814273306303)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Java qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963737676306303)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Java renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965629212306304)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965503387306304)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression JavaScript pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965402970306304)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967291561306305)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967173951306305)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction JavaScript qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967041484306305)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963696776306302)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer le message d''erreur indiqu\00E9, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963556365306302)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction JavaScript qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963464458306302)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction JavaScript renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083973530306394)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer l''erreur indiqu\00E9e, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658870741306056)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression PL/SQL qui d\00E9clenche une erreur comme base pour cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658767385306056)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Code PL/SQL g\00E9n\00E9rant une erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965311245306304)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30 ou est un responsable, entrez :</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965247326306304)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression PL/SQL pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965147875306304)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966920076306305)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966879209306305)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction PL/SQL qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966719462306305)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963340358306302)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer le message d''erreur indiqu\00E9, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963237621306302)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction PL/SQL qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963147753306302)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction PL/SQL renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101966018611306304)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression Python pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965972739306304)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967652256306306)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Python qui renvoie une valeur BOOLEAN comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101967564880306306)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964078378306303)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un corps de fonction Python qui renvoie le texte de message d''erreur comme base pour cette validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101963928794306303)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Corps de fonction Python renvoyant un texte d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659478303306056)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez l''expression r\00E9guli\00E8re utilis\00E9e pour concorder avec l''\00E9l\00E9ment indiqu\00E9 pour cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659381954306056)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Expression r\00E9guli\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101965077204306304)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est un responsable ou que le service se trouve \00E0 Chicago, entrez :</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964973806306303)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une expression SQL pour d\00E9finir la validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101964896120306303)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083801083306394)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Pour <strong>Lignes renvoy\00E9es</strong>, pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 30, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Pour <strong>Aucune ligne renvoy\00E9e</strong, pour r\00E9ussir la validation et ne pas g\00E9n\00E9rer de message d''erreur, lorsque l''employ\00E9 est dans le service 40, entrez :</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658680127306056)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte SQL pour d\00E9finir cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658541314306056)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659239449306056)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez la valeur \00E0 comparer \00E0 la valeur de la colonne d''\00E9l\00E9ment indiqu\00E9e pour cette validation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101659160759306056)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789954836306161)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Limiter l''utilisation d''une application \00E0 certaines heures de travail</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282674971305774)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le nom de la fonction qui est appel\00E9e apr\00E8s le renvoi de la sentinelle de session.'),
unistr('Vous pouvez d\00E9finir cette fonction dans l''attribut de code PL/SQL ou dans la base de donn\00E9es.'),
unistr('Le r\00E9sultat doit \00EAtre bool\00E9en, "True" signifiant que l''utilisateur est v\00E9rifi\00E9 et "False" que l''utilisateur n''a pas r\00E9ussi la v\00E9rification.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101282531525305774)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifier le nom de fonction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220295641305728)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si toutes les actions en suspens attendent le r\00E9sultat de l''action en cours.'),
unistr('D\00E9finissez cet attribut sur <strong>Activ\00E9</strong> si les actions en suspens d\00E9pendent du r\00E9sultat de cette action'),
unistr('ou sur <strong>D\00E9sactiv\00E9</strong> s''il n''existe aucune d\00E9pendance et qu''elles peuvent \00EAtre ex\00E9cut\00E9es de fa\00E7on asynchrone, sans attendre.</p>'),
unistr('<p>Remarque : l''ordre d''ex\00E9cution des actions sp\00E9cifiques est d\00E9termin\00E9 par la s\00E9quence indiqu\00E9e pour chaque action.'),
unistr('Pour vous assurer que les actions sont ex\00E9cut\00E9es dans le m\00EAme ordre, Oracle recommande que les num\00E9ros de s\00E9quence soient uniques pour toutes les actions True et toutes les actions False.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101220109769305728)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Attendre le r\00E9sultat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308240740305795)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Indique si la source de donn\00E9es REST comporte une table de synchronisation locale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308157796305795)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('La source de donn\00E9es REST comporte une table de synchronisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101510976892305944)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308453995305795)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Activez cette option pour utiliser la table locale, qui est configur\00E9e dans la section <strong>Synchronisation</strong> de la source de donn\00E9es REST, au lieu de contacter le service REST externe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308327582305795)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Utiliser la table de synchronisation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194423048305691)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le bouton qui d\00E9clenchera l''action dynamique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194388853305691)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299127616305786)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour que ce composant de traitement de page soit ex\00E9cut\00E9 uniquement lorsque le bouton sp\00E9cifi\00E9 est s\00E9lectionn\00E9, choisissez un bouton dans la liste. Vous pouvez incorporer cette condition de bouton \00E0 d''autres conditions pour affiner davantage les ex\00E9c')
||'utions du composant de traitement de page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101299059737305786)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Lors de l''activation du bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055833053306373)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez des colonnes permettant de d\00E9clencher l''action dynamique.'),
unistr('S\00E9parez les noms de colonne par une virgule.'),
unistr('Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des colonnes disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom de colonne renvoy\00E9 \00E0 partir de la liste.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055768439306373)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Colonne(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194862997305691)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un objet DOM (<code>document</code>, <code>window</code>) ou l''<em>ID</em> d''un objet DOM (<code>myElementID</code>) en tant qu''\00E9l\00E9ment d\00E9clenchant l''action dynamique.</p>'),
unistr('<p>Remarque : l''option <em>Objet DOM</em> est en phase d''abandon et doit \00EAtre remplac\00E9e par <em>Expression JavaScript</em> ou <em>S\00E9lecteur jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194736252305691)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Objet DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194623665305691)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez les \00E9l\00E9ments de page ou d''application permettant de d\00E9clencher l''action dynamique.'),
unistr('S\00E9parez les noms d''\00E9l\00E9ment par une virgule.'),
unistr('Vous pouvez saisir le nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous le s\00E9lectionnez dans la liste et qu''un texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, suivie du nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194587636305691)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051580330306370)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Renvoie une r\00E9f\00E9rence \00E0 l''objet DOM <code>window</code> du navigateur.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>Renvoie une r\00E9f\00E9rence \00E0 l''objet DOM <code>document</code> du navigateur.</dt>'),
'<dd><code>document</code></dd>',
unistr('<dt>Le s\00E9lecteur jQuery s\00E9lectionne tous les \00E9l\00E9ments DIV ayant la classe ''alert'', puis renvoie un objet jQuery contenant tous leurs parents.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051413137306370)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez l''expression JavaScript \00E0 \00E9valuer pour renvoyer un seul objet DOM, un tableau d''objets DOM ou un objet jQuery en tant qu''\00E9l\00E9ments d\00E9clenchant cette action dynamique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051315504306370)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706282462306098)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Pour s\00E9lectionner un \00E9l\00E9ment de page avec l''ID DOM <code>my_id</code></dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>Pour s\00E9lectionner tous les \00E9l\00E9ments de page avec la classe <code>my_class</code></dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>Pour s\00E9lectionner tous les \00E9l\00E9ments de page qui sont des entr\00E9es</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101195009809305691)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la syntaxe de s\00E9lecteur jQuery permettant de renvoyer au moins un \00E9l\00E9ment de page pour d\00E9clencher l''action dynamique. La biblioth\00E8que jQuery fournit une syntaxe de s\00E9lecteur tr\00E8s puissante permettant d''acc\00E9der facilement \00E0 des \00E9l\00E9ments d')
||'''une page.</p>',
unistr('<p>Pour plus d''informations sur la syntaxe de s\00E9lecteur, reportez-vous \00E0 la documentation officielle disponible sur la <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">page d''accueil jQuery</a>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194964091305691)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur jQuery')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101431626173305886)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le message texte qui s''affiche lorsque la limite <strong>Nombre maximal de lignes \00E0 traiter</strong> est d\00E9pass\00E9e.'),
unistr('Le message par d\00E9faut indique aux utilisateurs finals d''ajouter d''autres filtres pour limiter le nombre d''enregistrements \00E0 traiter.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101576975704305996)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le message texte qui appara\00EEt lorsque le nombre de lignes renvoy\00E9es depuis la requ\00EAte est sup\00E9rieur au nombre maximal entr\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101858327120306212)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le message texte qui s''affiche dans la zone <strong>Messages</strong> lorsque la limite <strong>Nombre maximal de lignes \00E0 traiter</strong> est d\00E9pass\00E9e pour la couche. Utilisez la substitution <strong>#MAX_ROW_COUNT#</strong> pour le nombr')
||unistr('e de lignes r\00E9ellement extraites.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562217928305984)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le message texte qui appara\00EEt lorsque davantage de lignes d''\00E9tat existent.'),
unistr('Utilisez cette approche comme une alternative \00E0 la pagination, sp\00E9cialement si un \00E9tat a g\00E9n\00E9ralement un seul ensemble d''enregistrements.'),
unistr('Si la requ\00EAte d''\00E9tat renvoie des lignes suppl\00E9mentaires, ce message peut \00EAtre utilis\00E9 pour alerter l''utilisateur final de l''anomalie, plut\00F4t que d''afficher simplement des contr\00F4les de pagination l\00E9g\00E8rement diff\00E9rents.'),
unistr('Votre message texte peut int\00E9grer un appel \00E0 l''action afin que les utilisateurs finals re\00E7oivent de l''aide sur la fa\00E7on de r\00E9pondre \00E0 ce r\00E9sultat de requ\00EAte inhabituel et qu''ils puissent inclure des liens de page ou d''URL.</p>'),
unistr('<p>Les cha\00EEnes de substitution de pagination suivantes peuvent \00EAtre utilis\00E9es dans votre message : </p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>Nombre de lignes affich\00E9es (taille de la page)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>"Z" dans les lignes X \00E0 Y sur Z</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"X" dans les lignes X \00E0 Y sur Z</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"Y" dans les lignes X \00E0 Y sur Z</dd>'),
'  <dt><code>#ROW_RANGES"</code></dt>',
'    <dd>Affiche : lignes 1-15 16-30 30-32</dd>',
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
unistr('    <dd>Pareil que pour les plages de lignes, mais dans une liste de s\00E9lection<dd>'),
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
'    <dd>Ensembles de pages : 1 2 3 4 5 6</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101562188408305984)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque d''autres donn\00E9es ont \00E9t\00E9 trouv\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102035949523306358)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte du message \00E0 afficher lorsque la requ\00EAte de graphique ne renvoie aucune ligne. Si la zone de texte est laiss\00E9e vide, Oracle JET utilisera automatiquement le message par d\00E9faut "Aucune donn\00E9e \00E0 afficher".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988794855306322)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez le message texte qui s''affiche dans la zone des <strong>messages</strong>, lorsque la requ\00EAte de couche ne renvoie aucune ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526315028305955)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez le texte du message \00E0 afficher lorsque la requ\00EAte ne renvoie aucune ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101526227708305955)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Si les donn\00E9es sont introuvables')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194265588305691)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez le nom de la r\00E9gion qui d\00E9clenche l''action dynamique.'),
unistr('Par exemple, il peut s''agir d''une r\00E9gion d''\00E9tat interactif utilis\00E9e avec un \00E9v\00E9nement Apr\00E8s r\00E9g\00E9n\00E9ration pour d\00E9finir une action dynamique qui sera d\00E9clench\00E9e \00E0 chaque r\00E9g\00E9n\00E9ration de l''\00E9tat.</p>'),
unistr('<p>Une r\00E9gion qui d\00E9clenche une action dynamique peut \00EAtre utile lorsque vous voulez d\00E9finir un comportement similaire pour plusieurs \00E9l\00E9ments de page d''une r\00E9gion. Toutefois, cela n''est possible que pour certains \00E9v\00E9nements g\00E9n\00E9r\00E9s par des \00E9l\00E9ments ')
||unistr('dans la r\00E9gion.'),
unistr('Pour obtenir la liste des \00E9v\00E9nements qui prennent en charge ce type de d\00E9finition et un exemple de leur utilisation, reportez-vous \00E0 l''aide sur l''\00E9l\00E9ment via <em>El\00E9ments affect\00E9s</em> &gt; <em>Type de s\00E9lection</em> dans Port\00E9e d''\00E9v\00E9nement sur la pa')
||'ge d''action.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194171218305691)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101194084334305690)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le type d''\00E9l\00E9ment de page ou de construction \00E0 utiliser pour d\00E9clencher l''\00E9v\00E9nement. Pour obtenir des exemples d''utilisation d''un type de s\00E9lection sp\00E9cifique, reportez-vous \00E0 l''aide sur l''attribut associ\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705994608306098)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'fr'
,p_message_text=>'Bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007338445306337)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clench\00E9 par un bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102054008521306372)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'fr'
,p_message_text=>'Colonne(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007517048306337)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9clench\00E9 par des colonnes.'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
unistr('        p_help_text     => q''~<p>D\00E9clench\00E9 par l''objet DOM (<code>document</code>, <code>window</code>) ou l''<em>ID</em> d''un objet DOM (<code>myElementID</code>).</p>'),
unistr('        <p>Remarque : l''<em>objet DOM</em> est obsol\00E8te et doit \00EAtre remplac\00E9 par une <em>expression JavaScript</em> ou un <em>s\00E9lecteur jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101705812844306098)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007295888306337)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clench\00E9 par des \00E9l\00E9ments de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050796358306369)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'fr'
,p_message_text=>'Expression JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007777946306337)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clench\00E9 par les \00E9l\00E9ments de page renvoy\00E9s par l''expression JavaScript.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706135961306098)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur jQuery')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007629704306337)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clench\00E9 par des \00E9l\00E9ments de page renvoy\00E9s par le s\00E9lecteur jQuery.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101706094606306098)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102007484395306337)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clench\00E9 par une r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101193913515305690)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de s\00E9lection')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101249763522305750)
,p_name=>'PENDING'
,p_message_language=>'fr'
,p_message_text=>'en attente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340155871305818)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es en suspens')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348897663305824)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'fr'
,p_message_text=>'Demandes en suspens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370975902305841)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage ferm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368808764305839)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage effectu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371077422305841)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage ouvert'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328068085305809)
,p_name=>'PIE_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 secteurs')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350120413305825)
,p_name=>'PKC1'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101350260687305825)
,p_name=>'PKC2'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de cl\00E9 primaire 2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042403357306363)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'fr'
,p_message_text=>'Disponible pour installation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042576531306363)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'fr'
,p_message_text=>unistr('Disponible pour mise \00E0 niveau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042665013306363)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'fr'
,p_message_text=>unistr('Ev\00E9nements d''application \00E9chantillon/de productivit\00E9 : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046021003306366)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>'%0 utilisateurs - %1 vues'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085790462306396)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Echec de la v\00E9rification des pr\00E9requis suivants. L''installation de cette application et de ses objets de prise en charge ne peut pas se poursuivre tant que les probl\00E8mes ne sont pas r\00E9solus.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085922138306396)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'L''objet existe : <br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102085810770306396)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Privil\00E8ges requis : <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071020737306385)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette page pour contr\00F4ler l''acc\00E8s des d\00E9veloppeurs d''application, utilisateurs finals et administrateurs d''espace de travail d''Application Express.</p>'),
'',
unistr('<p>Les <strong>administrateurs d''espace de travail</strong> peuvent installer, enlever ou mettre \00E0 niveau des applications, ainsi que g\00E9rer des comptes utilisateur et des services de d\00E9veloppement.</p>'),
'',
unistr('<p>Les <strong>d\00E9veloppeurs</strong> peuvent installer, enlever ou mettre \00E0 niveau des applications.</p>'),
'',
unistr('<p>Les <strong>utilisateurs finals</strong> ne disposent d''aucun privil\00E8ge de d\00E9veloppement et ne peuvent acc\00E9der qu''aux applications qui n''utilisent pas de mod\00E8le d''authentification externe.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042346944306363)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un espace de travail dans la liste ci-dessous')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101312076756305797)
,p_name=>'PLSQL'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125809253305640)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378717243305846)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) bas\00E9e sur un corps de fonction PL/SQL renvoyant une instruction SQL contient des erreurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071828483305600)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318331764305802)
,p_name=>'PLSQL_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion PL/SQL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613309958306023)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers de module d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101591719450306007)
,p_name=>'PLUGIN'
,p_message_language=>'fr'
,p_message_text=>'Module d''extension'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995987954306328)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'fr'
,p_message_text=>'Composant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995653749306327)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'fr'
,p_message_text=>'Effet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995845600306328)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046793102306367)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'fr'
,p_message_text=>'Initialiser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995477307306327)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'fr'
,p_message_text=>'Divers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101986727340306321)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995715079306327)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995596281306327)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'fr'
,p_message_text=>'Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101545615586305969)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'fr'
,p_message_text=>' [En phase d''abandon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101331814618305812)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'fr'
,p_message_text=>' [Module d''extension]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878114565306231)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'fr'
,p_message_text=>unistr(' [H\00E9rit\00E9]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498255770305935)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de mod\00E8le d''authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877986034305448)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945680367305504)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action dynamique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945090996305503)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643261436306045)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945175766305503)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362409787305835)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107640846306413)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si vous saisissez une URL, utilisez les cha\00EEnes de substitution <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> et <code>&amp;DEBUG.</code> et la syntaxe <code>&amp;COLUMN_NAME.</code> pour d\00E9finir l''ID de ligne ou la cl\00E9 primaire sur la pag')
||unistr('e cible ou pour d\00E9finir des valeurs d''attribut suppl\00E9mentaires.</p>'),
'<p><strong>Exemples</strong></p>',
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
unistr('<p>Pour plus de d\00E9tails sur la syntaxe <code>f?p</code>, reportez-vous au manuel Application Express Builder User''s Guide.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363505359305835)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Le module d''extension a \00E9t\00E9 cr\00E9\00E9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695285930306090)
,p_name=>'PNONUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage d''employ\00E9s hors des Etats-Unis')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073661777305602)
,p_name=>'POPUP_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412139824305871)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste de valeurs (LOV) instantan\00E9e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372586707305842)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Processus de postauthentification'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372399102305842)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Processus de pr\00E9authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255635702305754)
,p_name=>'PRECISION'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9cision')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101592967357306008)
,p_name=>'PREFERENCES'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rences')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064714874305594)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'fr'
,p_message_text=>'appliquer des permissions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065307796305594)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'aucune action requise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065014590305594)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('r\00E9voquer des autorisations')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930867695305490)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de la pr\00E9f\00E9rence dans Expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930954991305491)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de la pr\00E9f\00E9rence dans Expression 1 != Expression 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101032987583305570)
,p_name=>'PRESENTATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9sentation')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092591629305616)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''impression d''\00E9tat n''est pas disponible actuellement. Aucun serveur d''impression n''est configur\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340517960305819)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Avanc\00E9 (Oracle BI Publisher obligatoire)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340643531305819)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'fr'
,p_message_text=>'Standard'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325792363305807)
,p_name=>'PRIORITIZED'
,p_message_language=>'fr'
,p_message_text=>'Prioritaire'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336204617305815)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8mes corrig\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336105640305815)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Probl\00E8mes identifi\00E9s')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070598838305599)
,p_name=>'PROCEDURE'
,p_message_language=>'fr'
,p_message_text=>unistr('proc\00E9dure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101984044516306318)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848119170305426)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter le code')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100848267687305426)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Envoyer un courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934820898305495)
,p_name=>'PROCESSES'
,p_message_language=>'fr'
,p_message_text=>'Processus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868395705305441)
,p_name=>'PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Votre demande est en cours de traitement. Veuillez patienter...'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657800499306055)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'fr'
,p_message_text=>'Baisse de la production'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058135681306375)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'fr'
,p_message_text=>'Product Portal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072981111306386)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Invite : %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887911703305456)
,p_name=>'PROVIDER'
,p_message_language=>'fr'
,p_message_text=>'Fournisseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888055979305456)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Courriel du fournisseur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344911499305822)
,p_name=>'PROVISIONED'
,p_message_language=>'fr'
,p_message_text=>unistr('Provisionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459436141305907)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Espace provisionn\00E9 existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340747724305819)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('A la demande de l''utilisateur avec v\00E9rification d''adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340938135305819)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'fr'
,p_message_text=>'Manuel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340886542305819)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'fr'
,p_message_text=>'A la demande de l''utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079196703305606)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'fr'
,p_message_text=>'Informations d''administrateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080173516305607)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le tablespace sera cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080308227305607)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichier de donn\00E9es pour tablespace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078993329305606)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079308701305606)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080293262305607)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'fr'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078628433305605)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078404823305605)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 le provisionnement d''un nouveau/une nouvelle %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079906609305606)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079763689305606)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9utiliser un sch\00E9ma existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079638712305606)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080003680305606)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078786670305606)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'fr'
,p_message_text=>'ID d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078858976305606)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('Syst\00E8me affect\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079428158305606)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079280775305606)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078556441305605)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'fr'
,p_message_text=>'Informations d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079882751305606)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383945171305850)
,p_name=>'PROXY_SERVER'
,p_message_language=>'fr'
,p_message_text=>'Serveur proxy'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065827201305594)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la r\00E9g\00E9n\00E9ration de l''aide sur l''\00E9l\00E9ment suivant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065940147305594)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'fr'
,p_message_text=>unistr('Si c''est correct, cliquez sur R\00E9g\00E9n\00E9rer tout. Sinon, cliquez sur Annuler.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689680360306086)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'fr'
,p_message_text=>'Administrateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685334974306083)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Lancement de la suppression de l''espace de travail %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685113537306083)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Lancement de la suppression du tablespace %0 de l''espace de travail %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684789675306082)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'fr'
,p_message_text=>'Lancement de la suppression de l''utilisateur %0 de l''espace de travail %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684342420306082)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Lancement de la purge de l''espace de travail %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689555910306086)
,p_name=>'PURGE.BYTES'
,p_message_language=>'fr'
,p_message_text=>'Octets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685668918306083)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de la suppression de l''espace de travail %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685230446306083)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de la suppression du tablespace %0 de l''espace de travail %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685046689306083)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de la suppression de l''utilisateur %0 de l''espace de travail %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684110315306082)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Cher utilisateur d''Oracle APEX,',
'',
unistr('L''espace de travail %0 sur %1 ne pr\00E9sente aucune activit\00E9 r\00E9cente. Sa purge est actuellement programm\00E9e pour le %2 ou apr\00E8s cette date.'),
'',
unistr('Si vous ne souhaitez pas que votre espace de travail soit enlev\00E9, cliquez sur l''URL ci-dessous et indiquez que vous ne voulez pas qu''il soit purg\00E9. Cette op\00E9ration doit \00EAtre effectu\00E9e d''ici les %3 prochains jours. Si vous n''avez plus besoin de cet es')
||unistr('pace de travail, vous n''avez rien \00E0 faire.'),
'',
'Lien de confirmation : %4'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684241482306082)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'fr'
,p_message_text=>'Espace de travail Oracle APEX : espace de travail %0 sur %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685466938306083)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'Fin de la suppression de l''espace de travail %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101996397200306328)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'fr'
,p_message_text=>'Fin de la suppression du tablespace %0 de l''espace de travail %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684975008306082)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'fr'
,p_message_text=>'Fin de la suppression de l''utilisateur %0 de l''espace de travail %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682267581306080)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajout de l''espace de travail %0 \00E0 la liste des \00E9l\00E9ments \00E0 purger, dont le temps d''inactivit\00E9 est d''au moins %1 jour(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682375648306081)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Suppression de l''espace de travail %0 de la liste des \00E9l\00E9ments \00E0 purger, en raison d''une activit\00E9 r\00E9cente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682404271306081)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Courriel envoy\00E9 \00E0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682853821306081)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Espace de travail %0 d\00E9plac\00E9 depuis la liste des \00E9l\00E9ments conserv\00E9s vers la liste des \00E9l\00E9ments \00E0 purger.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688702312306085)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'fr'
,p_message_text=>'Octets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686177623306083)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688627821306085)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688336950306085)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9mas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686057673306083)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686408538306084)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprim\00E9 de la liste des \00E9l\00E9ments \00E0 purger (en raison d''une activit\00E9 r\00E9cente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687117841306084)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Rajout\00E9 \00E0 la liste des \00E9l\00E9ments \00E0 purger (pr\00E9c\00E9demment conserv\00E9 mais aucune activit\00E9 observ\00E9e pendant %0 jour(s))')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686801149306084)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9cemment ajout\00E9 \00E0 la liste des \00E9l\00E9ments \00E0 purger (aucune activit\00E9 observ\00E9e pendant %0 jour(s))')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687756432306085)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Purg\00E9 aujourd''hui')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686655121306084)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Conserv\00E9 (l''administrateur a demand\00E9 de ne pas purger l''espace de travail)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687370684306084)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'fr'
,p_message_text=>'A purger dans %0 jour(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688405184306085)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'fr'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688204601306085)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'fr'
,p_message_text=>'Espaces de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687812156306085)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'fr'
,p_message_text=>'Espaces de travail restants'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682638240306081)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9ponse au courriel %0 enregistr\00E9e - Valeur : %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689393388306086)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684453420306082)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition du statut du sch\00E9ma %0 sur le statut %1 pour l''espace de travail %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684590822306082)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition du statut du tablespace %0 sur le statut %1 pour l''espace de travail %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694816468306090)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif quotidien de purge des espaces de travail Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689421896306086)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689982867306086)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces de travail rajout\00E9s \00E0 la liste des \00E9l\00E9ments \00E0 purger (pr\00E9c\00E9demment conserv\00E9s mais aucune activit\00E9 observ\00E9e pendant %0 jour(s))')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689857670306086)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces de travail r\00E9cemment ajout\00E9s \00E0 la liste des \00E9l\00E9ments \00E0 purger (aucune activit\00E9 observ\00E9e pendant %0 jour(s))')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688877444306085)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif des espaces de travail purg\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689022036306085)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces de travail purg\00E9s aujourd''hui')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690096277306086)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces de travail supprim\00E9s de la liste des \00E9l\00E9ments \00E0 purger (en raison d''une activit\00E9 r\00E9cente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690186042306086)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces de travail conserv\00E9s (l''administrateur a demand\00E9 de ne pas purger l''espace de travail)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689714327306086)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Espaces de travail \00E0 purger dans %0 jour(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689214678306086)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de l''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685927817306083)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Purge de l''espace de travail %0 termin\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987862769306321)
,p_name=>'PURGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Purg\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072543131306386)
,p_name=>'PURGE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Purge : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450053888305900)
,p_name=>'QB_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'&nbsp;Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127255831305641)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez une requ\00EAte valide pour voir les r\00E9sultats.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449849048305900)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ce nom est d\00E9j\00E0 utilis\00E9 par une requ\00EAte existante dans le concepteur de requ\00EAtes ou dans le processeur de commandes SQL.<br> '),
unistr('S\00E9lectionnez un nouveau nom et enregistrez-le.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308594843305795)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a rien \00E0 enregistrer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288716895305779)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte enregistr\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455350639305904)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions de table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455470546305904)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions de vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408136185305868)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le concepteur de requ\00EAtes Visual Query Builder ne peut pas ouvrir la requ\00EAte en cours.<br>'),
unistr('Cliquez sur Cr\00E9er pour remplacer la requ\00EAte en cours par une nouvelle requ\00EAte ou cliquez sur Retour pour conserver la requ\00EAte en cours.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408076886305868)
,p_name=>'QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933190498305493)
,p_name=>'QUERY BUILDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Concepteur de requ\00EAtes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100048885305621)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'fr'
,p_message_text=>unistr('requ\00EAte non valide, absence d''instruction SELECT')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932952298305493)
,p_name=>'QUESTIONS'
,p_message_language=>'fr'
,p_message_text=>'Questions'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652316162306051)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Masque de format num\00E9rique : 999G999G999G999G990')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458300231305906)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'fr'
,p_message_text=>'A propos de Quick SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458414983305906)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quick SQL est une m\00E9thode rapide de g\00E9n\00E9ration du code SQL requis pour cr\00E9er un mod\00E8le de donn\00E9es relationnel \00E0 partir d''un document de texte avec retraits. Cet outil est con\00E7u pour r\00E9duire le temps et les efforts n\00E9cessaires pour cr\00E9er des struct')
||unistr('ures d''index, des d\00E9clencheurs et des tables SQL. Il n''est pas destin\00E9 \00E0 remplacer la mod\00E9lisation de donn\00E9es, mais offre un moyen rapide de d\00E9velopper un script pour des tables et des vues simples. Une fois le code SQL g\00E9n\00E9r\00E9, il peut \00EAtre ajust\00E9 et')
||unistr(' d\00E9velopp\00E9.</p>'),
'',
'<p>Principaux cas d''emploi :',
'<ul>',
unistr('  <li>Cr\00E9er rapidement des mod\00E8les de donn\00E9es robustes</li>'),
unistr('  <li>Enregistrer la syntaxe abr\00E9g\00E9e Quick SQL en tant que mod\00E8le afin d''effectuer une it\00E9ration tout au long des modifications apport\00E9es au mod\00E8le ou de l''utiliser pour cr\00E9er la prochaine conception de mod\00E8le</li>'),
unistr('  <li>G\00E9n\00E9rer facilement des donn\00E9es al\00E9atoires</li>'),
'  <li>Apprendre les instructions SQL CREATE TABLE, SELECT, INSERT, INDEX, TRIGGER, PACKAGE PL/SQL, et visualiser la syntaxe dans les exemples fournis</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351269732305826)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ce param\00E8tre contr\00F4le la syntaxe g\00E9n\00E9r\00E9e pour prendre en charge les colonnes d''audit. En particulier si les colonnes d''audit sont activ\00E9es, des d\00E9clencheurs sont g\00E9n\00E9r\00E9s pour g\00E9rer l''utilisateur qui cr\00E9e une ligne et le dernier utilisateur \00E0 avoir mi')
||unistr('s \00E0 jour une ligne. Lorsqu''il est activ\00E9, la fonction suivante est utilis\00E9e :'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351364608305826)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsqu''il n''est pas activ\00E9, la fonction suivante est utilis\00E9e :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351461515305826)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rez des API PL/SQL sur toutes les tables pour effectuer des t\00E2ches de cr\00E9ation, d''insertion, de mise \00E0 jour, de suppression et d''interrogation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351545934305826)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoute une colonne Cr\00E9\00E9, Cr\00E9\00E9 par, Mis \00E0 jour et Mis \00E0 jour par \00E0 chaque table cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351603305305827)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsqu''il est activ\00E9, cr\00E9e toutes les tables compress\00E9es. Par d\00E9faut, elles ne sont pas compress\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351722939305827)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque les colonnes d''audit sont activ\00E9es, la colonne par d\00E9faut utilis\00E9e pour suivre l''utilisateur qui a cr\00E9\00E9 une ligne est CREATED_BY. Utilisez ce param\00E8tre pour remplacer le nom de colonne d''audit par d\00E9faut. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101351814135305827)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque les colonnes d''audit sont activ\00E9es, la colonne par d\00E9faut utilis\00E9e pour suivre l''utilisateur qui a cr\00E9\00E9 une ligne est CREATED. Utilisez ce param\00E8tre pour remplacer le nom de colonne d''audit par d\00E9faut. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101353874342305828)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Par d\00E9faut, toutes les colonnes DATE sont cr\00E9\00E9es au moyen du type de donn\00E9es Oracle DATE. Utilisez ce param\00E8tre pour remplacer la valeur par d\00E9faut. Les valeurs valides sont :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101356124203305830)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Sp\00E9cifie la version de la base de donn\00E9es avec laquelle la syntaxe doit \00EAtre compatible. Les valeurs valides sont :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360516700305833)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028160367306353)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'fr'
,p_message_text=>unistr('Services et salari\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028790087306353)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Syntaxe SQL abr\00E9g\00E9e qui cr\00E9e une table DEPARTMENTS et EMPLOYEES avec une jointure SQL VIEW. Des donn\00E9es al\00E9atoires sont \00E9galement g\00E9n\00E9r\00E9es \00E0 l''aide de la syntaxe /INSERT. /NN ajoute une contrainte de colonne SQL NOT NULL. Des listes en retrait sont u')
||unistr('tilis\00E9es pour d\00E9finir les tables, les colonnes et les tables enfant. Les colonnes de cl\00E9 primaire et \00E9trang\00E8re sont ajout\00E9es automatiquement. Il n''est pas n\00E9cessaire d''indiquer de colonnes de cl\00E9 primaire ou \00E9trang\00E8re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280673735305773)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101359256782305832)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Incluez des commandes SQL pour supprimer chaque objet de base de donn\00E9es cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028307218306353)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Comp\00E9tences de l''employ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028584005306353)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e une table DEPARTMENTS, EMPLOYEES et SKILLS en utilisant des retraits pour identifier les tables parent et enfant. La syntaxe abr\00E9g\00E9e VC255 est utilis\00E9e pour indiquer un type de donn\00E9es SQL.  La syntaxe /INSERT est utilis\00E9e pour g\00E9n\00E9rer des donn\00E9')
||unistr('es al\00E9atoires.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280457769305773)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'fr'
,p_message_text=>'Exemple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458701694305906)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'fr'
,p_message_text=>'Exemple %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361291005305834)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rez automatiquement une colonne de cl\00E9 primaire ID pour chaque table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458572152305906)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'fr'
,p_message_text=>'Initiation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458657709305906)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez les noms de table parent sans alin\00E9a. Saisissez des colonnes de table avec un alin\00E9a uniforme d''au moins deux espaces. Il est g\00E9n\00E9ralement pr\00E9f\00E9rable de ne pas indiquer de cl\00E9s primaires, qui seront g\00E9n\00E9r\00E9es par le syst\00E8me. Les relations')
||unistr(' parent-enfant sont simplement cr\00E9\00E9es en mettant les tables enfant en retrait sous les tables parent.</p>'),
'',
unistr('<p>Par d\00E9faut, les types de donn\00E9es sont g\00E9n\00E9ralement VARCHAR2. Si vous souhaitez que le type de donn\00E9es d''une colonne soit diff\00E9rent, ajoutez un espace NUM, INT, DATE \00E0 la fin du nom de la colonne. En fonction du texte en anglais contenu dans le nom')
||unistr(' de la colonne et de l''absence de tout type de donn\00E9es sp\00E9cifi\00E9, le syst\00E8me d\00E9duit le nom de certaines colonnes. Par exemple, si le nom de colonne contient le mot DATE, elle prendra le type de donn\00E9es de date. S''il contient le mot NUMBER ou NUM, il s')
||unistr('''agit alors d''un type de donn\00E9es num\00E9rique. Si vous voulez indiquer une longueur VARCHAR2 sp\00E9cifique, saisissez VCn o\00F9 "n" repr\00E9sente la longueur de VARCHAR2. Cliquez sur le bouton Syntaxe pour afficher la syntaxe disponible. Les noms d''objet sont fo')
||unistr('rmat\00E9s automatiquement et les espaces sont remplac\00E9s par des traits de soulignement. Ainsi, vous pouvez utiliser des espaces dans les noms de colonne et de table.</p>'),
'',
unistr('<p>Cliquez sur le bouton Param\00E8tres pour visualiser de nombreuses options de g\00E9n\00E9ration. Vous pouvez ajouter automatiquement des colonnes "Qui", par exemple qui a cr\00E9\00E9 ou mis \00E0 jour en dernier une ligne donn\00E9e, et quand. Vous pouvez ajouter une colon')
||unistr('ne de s\00E9quence de lignes qui s''incr\00E9mente automatiquement de 1 \00E0 chaque mise \00E0 jour de ligne. Une s\00E9quence de lignes peut \00EAtre utile pour simplifier la d\00E9tection des mises \00E0 jour perdues. Vous pouvez \00E9galement g\00E9n\00E9rer une API PL/SQL qui fournit un pa')
||unistr('ckage par table et offre des proc\00E9dures permettant d''interroger, d''ins\00E9rer, de mettre \00E0 jour et de supprimer des lignes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033409588306357)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rer une API de package PL/SQL pour interroger, ins\00E9rer, mettre \00E0 jour et supprimer des donn\00E9es dans une table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033546101306357)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoute un audit Oracle, par d\00E9faut AUDIT ALL ON [TABLE NAME].')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033651806306357)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoute automatiquement des colonnes UPDATED, UPDATED_BY, INSERTED et INSERTED_BY ainsi que la logique de d\00E9clenchement pour d\00E9finir les valeurs de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032873438306356)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoute une contrainte de v\00E9rification BETWEEN sur la colonne, par exemple /between 1 and 100')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032200566306356)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e une contrainte de v\00E9rification avec des valeurs d\00E9limit\00E9es par des virgules ou des espaces. Par ex. /check Yes, No')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362314660305834)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoutez cette valeur comme pr\00E9fixe \00E0 toutes les colonnes d''une table donn\00E9e. Ajoute automatiquement un trait de soulignement s''il n''est pas fourni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101402484487305864)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033229748306356)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'fr'
,p_message_text=>'Mettre les commentaires entre crochets ou utiliser la syntaxe tiret-tiret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033781121306357)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('La table sera cr\00E9\00E9e compress\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032373282306356)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'fr'
,p_message_text=>unistr('Lors de la g\00E9n\00E9ration de donn\00E9es, d\00E9finissez cette colonne sur une valeur constante. Par exemple /constant NYC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865645450306218)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoute une valeur par d\00E9faut si la colonne est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362241168305834)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoute une colonne BLOB et des colonnes _FILENAME, _CHARSET, _MIMETYPE, _LASTUPD qui am\00E9liorent la capacit\00E9 de t\00E9l\00E9chargement de fichiers via un navigateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033060650306356)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences de cl\00E9 \00E9trang\00E8re, par ex. /references table_name. Vous pouvez r\00E9f\00E9rencer des tables qui ne font pas partie de votre mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032976912306356)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Les colonnes masqu\00E9es ne sont pas affich\00E9es avec select * from table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101626263326306032)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e un index non unique sur la colonne associ\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033800151306357)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rer des instructions SQL INSERT <strong>NN</strong> avec des donn\00E9es al\00E9atoires, par exemple : /INSERT 20. (Maximum = 1000)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032692051306356)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'fr'
,p_message_text=>'Force les valeurs de colonne en minuscules'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033379366306356)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'fr'
,p_message_text=>'NNN identifie un nombre compris entre 1 et 32 767.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032792070306356)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'fr'
,p_message_text=>'Ajoute une contrainte NOT NULL sur la colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033156486306356)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifie la colonne en tant que cl\00E9 primaire de la table. Il est recommand\00E9 de ne pas indiquer manuellement de cl\00E9s primaires et de laisser cette application cr\00E9er automatiquement les colonnes de cl\00E9 primaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102034021915306357)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rer une activation REST de la table au moyen d''Oracle REST Data Services (ORDS)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102033995191306357)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rer une instruction SQL SELECT apr\00E8s avoir g\00E9n\00E9r\00E9 des donn\00E9es pour chaque table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101167909218305671)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rer une contrainte unique de niveau table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032187429306356)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e une contrainte unique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032582589306356)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'fr'
,p_message_text=>'Force les valeurs de colonne en majuscules'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032403036306356)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'fr'
,p_message_text=>unistr('Listes de valeurs s\00E9par\00E9es par des virgules \00E0 utiliser lors de la g\00E9n\00E9ration de donn\00E9es. Par exemple, /values 1, 2, 3, 4 ou /values Yes, No.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101461110566305908)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9ation d''objets de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489097675305929)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Une fois que vous avez termin\00E9 de saisir l''abr\00E9g\00E9 Quick SQL et appliqu\00E9 les param\00E8tres appropri\00E9s, vous \00EAtes pr\00EAt \00E0 utiliser le code SQL pour cr\00E9er les objets de base de donn\00E9es et potentiellement renseigner les tables avec des donn\00E9es al\00E9atoires.')
||unistr(' Proc\00E9dez comme suit :<br>'),
'<ol>',
unistr('  <li>Cliquez sur <strong>Enregistrer le mod\00E8le</strong> pour enregistrer la syntaxe abr\00E9g\00E9e Quick SQL en tant que mod\00E8le, en vue d''une r\00E9utilisation ult\00E9rieure.</li>'),
unistr('  <li>Entrez le nom du mod\00E8le.</li>'),
'  <li>Cliquez sur <strong>Enregistrement du script SQL</strong> pour enregistrer la sortie dans un script.</li>',
'  <li>Entrez le nom du script.</li>',
unistr('  <li>Cliquez sur <strong>V\00E9rifier et ex\00E9cuter</strong> pour acc\00E9der \00E0 l''\00E9diteur de scripts.</li>'),
unistr('  <li>Dans l''\00E9diteur de scripts, assurez-vous que le contenu du script est correct.</li>'),
unistr('  <li>Cliquez sur <strong>Ex\00E9cuter</strong> pour cr\00E9er les objets de base de donn\00E9es.</li>'),
unistr('  <li>Sur la page de confirmation du script, cliquez sur <strong>Ex\00E9cuter maintenant</strong>.</li>'),
unistr('  <li>Sur la page de r\00E9sultats, v\00E9rifiez les instructions trait\00E9es, r\00E9ussies et avec erreurs.<br>'),
unistr('  Si des erreurs sont signal\00E9es, parcourez les pages de r\00E9sultats pour consulter les messages d''erreur Oracle sp\00E9cifiques.</li>'),
unistr('  <li>Vous pouvez \00E9ventuellement cliquer sur <strong>Cr\00E9er une application \00E0 partir d''un script</strong> pour acc\00E9der \00E0 l''assistant Cr\00E9ation d''application, et g\00E9n\00E9rer automatiquement des pages \00E0 partir des tables et des vues indiqu\00E9es dans le script.')
||'</li>',
'</ol>',
'</p>',
'',
unistr('<p><em><strong>Remarque :</strong> Oracle recommande de t\00E9l\00E9charger l''abr\00E9g\00E9 SQL sur votre ordinateur si vous souhaitez le mettre \00E0 jour ult\00E9rieurement. Si vous avez indiqu\00E9 des param\00E8tres, acc\00E9dez au bas du panneau Sortie Oracle SQL et copiez la lig')
||unistr('ne qui commence par <code># settings =</code> en haut du panneau Abr\00E9g\00E9 Quick SQL.<br>'),
unistr('Cliquez sur <strong>T\00E9l\00E9charger</strong> pour enregistrer le fichier SQL sur votre ordinateur.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360290520305833)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rez les donn\00E9es utilis\00E9es pour les instructions INSERT dans cette langue. Les langues prises en charge sont : ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360432650305833)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Identifie les identificateurs plus longs \00E0 utiliser pour les noms d''objet de base de donn\00E9es. Lorsqu''ils sont activ\00E9s, les identificateurs plus longs autorisent les noms d''objet \00E0 comporter 128 caract\00E8res. Lorsqu''ils ne sont pas activ\00E9s, la longueur ')
||unistr('maximale d''un nom d''objet est de 30 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360657324305833)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Autorise l''utilisation d''identificateurs plus longs pour les noms d''objet de base de donn\00E9es. Les identificateurs plus longs permettent \00E0 un type de donn\00E9es de colonne VARCHAR2 de comporter 32 767 caract\00E8res. Lorsque ce param\00E8tre n''est pas d\00E9fini, la')
||unistr(' longueur maximale d''un type de donn\00E9es de colonne VARCHAR2 est de 4 000 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360726809305833)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce param\00E8tre contr\00F4le les param\00E8tres ON DELETE des cl\00E9s \00E9trang\00E8res. Les valeurs valides sont : ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360864386305833)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Si ce param\00E8tre est activ\00E9, tous les param\00E8tres d''application d\00E9finis via la console d''interface utilisateur sont ignor\00E9s et seuls les param\00E8tres d\00E9finis dans le script sont utilis\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101360970422305833)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9termine la mani\00E8re dont la cl\00E9 primaire est d\00E9finie. Les cl\00E9s primaires peuvent \00EAtre d\00E9finies au moyen de SYS_GUID, d''une colonne d''identit\00E9 ou d''une s\00E9quence. Les valeurs valides sont :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361127941305833)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoutez comme pr\00E9fixe le nom de la table aux colonnes de table de base de donn\00E9es de cl\00E9 primaire. Par exemple, la cl\00E9 primaire de la table EMPLOYEE devient EMPLOYEE_ID. Si le nom de la cl\00E9 primaire implicitement cr\00E9\00E9e n''est pas d\00E9fini, la colonne se')
||unistr('ra nomm\00E9e ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361083353305833)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9fixe d''objet de base de donn\00E9es. Un trait de soulignement est ajout\00E9 si aucun pr\00E9fixe n''est indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028200467306353)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'fr'
,p_message_text=>'Ventes de produits'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028894317306353)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Syntaxe abr\00E9g\00E9e qui cr\00E9e un sch\00E9ma en \00E9toile avec les tables PRODUCTS, CUSTOMERS, CHANNELS, PROMOTIONS et SALES. La table SALES contient des r\00E9f\00E9rences de cl\00E9 \00E9trang\00E8re aux autres tables. Une instruction SQL VIEW est \00E9galement cr\00E9\00E9e pour joindre les ')
||unistr('5 tables. Des \00E9chantillons de donn\00E9es al\00E9atoires sont \00E9galement g\00E9n\00E9r\00E9s. Les colonnes num\00E9riques sont identifi\00E9es par la syntaxe NUM.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028004553306352)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'fr'
,p_message_text=>'Gestion de projets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028628384306353)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e une table PROJECT_MANAGEMENT et quatre tables de d\00E9tail. Deux vues sont cr\00E9\00E9es au moyen de la syntaxe /VIEW. Des contraintes CHECK de base de donn\00E9es sont \00E9galement ajout\00E9es \00E0 l''aide de la syntaxe /CHECK. Utilise \00E9galement #APEX pour d\00E9finir les')
||unistr(' param\00E8tres qui g\00E8rent la g\00E9n\00E9ration de syntaxe SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361341775305834)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialise tous les param\00E8tres de l''application sur leurs valeurs par d\00E9faut. Lorsque tous les param\00E8tres d''application actuellement actifs pour votre session sont inclus, ils sont ignor\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361443497305834)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour chaque table cr\00E9\00E9e, ajoutez une colonne ROW_KEY qui g\00E9n\00E8re un identificateur alphanum\00E9rique. Les valeurs de la colonne ROW_KEY sont d\00E9finies par la logique de d\00E9clenchement de la table de base de donn\00E9es g\00E9n\00E9r\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361639659305834)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour chaque table g\00E9n\00E9r\00E9e, ajoutez une colonne ROW_VERSION qui est incr\00E9ment\00E9e de 1 par mise \00E0 jour. Lorsque ce param\00E8tre est activ\00E9, la logique de d\00E9clenchement de la table de base de donn\00E9es est g\00E9n\00E9r\00E9e pour incr\00E9menter les versions de ligne \00E0 chaq')
||unistr('ue mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361784064305834)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajoutez un nom de sch\00E9ma comme pr\00E9fixe aux noms d''objet. Par d\00E9faut, aucun pr\00E9fixe de sch\00E9ma n''est ajout\00E9 aux noms d''objet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361570465305834)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour chaque table, ajoutez une colonne TENANT_ID afin de prendre en charge les applications colocatives. La valeur de cette colonne est simplement ajout\00E9e \00E0 la table. Le d\00E9veloppeur est ensuite charg\00E9 de tenir \00E0 jour cette valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362119912305834)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez le choix entre la s\00E9mantique Aucune colonne ou les s\00E9mantiques BYTE ou CHAR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280576734305773)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343782806305821)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez saisir des param\00E8tres incorpor\00E9s pour d\00E9finir explicitement des options de g\00E9n\00E9rations de syntaxe SQL. Sinon, vous pouvez \00E9galement cliquer sur <strong>Param\00E8tres</strong> en haut du panneau de droite pour d\00E9finir de fa\00E7on d\00E9clarative ')
||unistr('les options de g\00E9n\00E9ration.</p>'),
'',
unistr('<p>En saisissant directement des param\00E8tres dans le panneau Abr\00E9g\00E9 Quick SQL, vous vous assurez que les m\00EAmes options de g\00E9n\00E9ration SQL sont utilis\00E9es, m\00EAme si vous t\00E9l\00E9chargez le script, puis le recollez ult\00E9rieurement. Par exemple, entrez le code s')
||unistr('uivant pour ajouter le pr\00E9fixe TEST \00E0 tous les noms de table et g\00E9n\00E9rer pour le sch\00E9ma OBE :<br>'),
'<code># settings = { prefix: "test", schema: "OBE" }</code>.<br>',
unistr('Vous pouvez \00E9galement entrer chaque param\00E8tre sur une ligne distincte pour le m\00EAme r\00E9sultat :<br>'),
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>Remarque :</strong> les param\00E8tres doivent commencer sur une nouvelle ligne et commencer par <code># settings = </code> lorsque vous saisissez plusieurs param\00E8tres, ou par <code># </code> pour saisir un seul param\00E8tre par ligne. Toutes')
||unistr(' les valeurs ne distinguent pas les majuscules des minuscules. Des crochets, des espaces et des virgules peuvent \00EAtre ajout\00E9s \00E0 des fins de clart\00E9, mais sont ignor\00E9s. Pour que tous les param\00E8tres soient g\00E9n\00E9r\00E9s, utilisez <code># verbose: true</code>.')
||'</em> ',
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280280342305773)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'fr'
,p_message_text=>'Syntaxe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050042768306369)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2ches \00E0 effectuer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050104339306369)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9e des tables ASSIGNEES et TODOS. Con\00E7u comme point de d\00E9part pour permettre la cr\00E9ation d''un syst\00E8me personnalis\00E9 de t\00E2ches \00E0 effectuer en quelques minutes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361821238305834)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Lors de l''activation de colonnes d''audit, utilisez ce param\00E8tre pour remplacer le nom de colonne d''audit par d\00E9faut. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101361923392305834)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Lors de l''activation de colonnes d''audit, utilisez ce param\00E8tre pour remplacer le nom de colonne d''audit par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101362093547305834)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Affiche tous les param\00E8tres, et pas seulement ceux qui diff\00E8rent des valeurs par d\00E9faut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101280350755305773)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Assurez-vous que le nom de vue ne contient pas d''espaces, assurez-vous que les noms de table ne contiennent pas d''espaces. D\00E9limitez les noms de table par un espace ou une virgule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101489111221305929)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat Chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128527479305642)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'fr'
,p_message_text=>'Analyse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336400028305815)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'fr'
,p_message_text=>'Moyenne de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011870985305553)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'fr'
,p_message_text=>'Par %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128910068305642)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'fr'
,p_message_text=>'Graphiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011770482305553)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'fr'
,p_message_text=>'Graphique par %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101010448302305552)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue d\00E9tail')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128874590305642)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'fr'
,p_message_text=>'Etats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101336500604305815)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'fr'
,p_message_text=>'Total de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504424383305940)
,p_name=>'QUICK_SQL'
,p_message_language=>'fr'
,p_message_text=>'Quick SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846129350305425)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 2D, avec plage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846261899305425)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'A colonnes 3D, avec plage'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102161734423306458)
,p_name=>'READERS'
,p_message_language=>'fr'
,p_message_text=>'Lecteurs'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102078043692306390)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9affecter l''\00E9l\00E9ment : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869523484305442)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9affecter les pages')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101254923655305753)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'fr'
,p_message_text=>'Corbeille'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458868919305906)
,p_name=>'REDIRECT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459033756305907)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce bouton effectuera un r\00E9acheminement vers une URL et ne soumettra tout probablement pas la page. Si vous voulez que votre bouton soumette la page, n''indiquez pas de r\00E9acheminement vers une page ou une URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125239702305639)
,p_name=>'REDIRECT_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer sur %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590983382306006)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers l''application %0, page %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125172407305639)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer sur la page %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932797865305493)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la page dans cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932810834305493)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101306167665305793)
,p_name=>'REFERENCED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933783953305494)
,p_name=>'REGEN_VER'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer le code de v\00E9rification')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308740324305795)
,p_name=>'REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453212184305902)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Positions de bouton de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372771073305842)
,p_name=>'REGION CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365981350305837)
,p_name=>'REGION CONTENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Contenu de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911669782305474)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Boutons de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100934759181305495)
,p_name=>'REGIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101092730218305616)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'fr'
,p_message_text=>unistr('Remplacement du mod\00E8le de liste de r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317018264305801)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835486929305417)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'fr'
,p_message_text=>'Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581381065305999)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853620727305430)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'fr'
,p_message_text=>'Cartes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301303972305788)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'fr'
,p_message_text=>'Calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877854325305448)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'fr'
,p_message_text=>unistr('Mapping de colonne de t\00E9l\00E9chargement des donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315437344305800)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646065841306047)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherche \00E0 facets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435318816305888)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836590991305417)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''aide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442524232305894)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'fr'
,p_message_text=>'Grille interactive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556233239305979)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'fr'
,p_message_text=>'Etat interactif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295739103305784)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014127298306342)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat d''activation/de d\00E9sactivation de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877769736305448)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue de liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102014236844306342)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'fr'
,p_message_text=>'Etat de reflux'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581513755305999)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'fr'
,p_message_text=>'Arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100834964657305416)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018010355306345)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'fr'
,p_message_text=>'Carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656026903306054)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'fr'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580923631305999)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique (HTML - LEGACY)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101552042188305976)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656188106306054)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'fr'
,p_message_text=>'Contenu statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101580867713305998)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique (SVG - LEGACY)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101556369531305980)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau tabulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101581467473305999)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'fr'
,p_message_text=>'Arborescence classique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100835728619305417)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'fr'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101001742538305545)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320784487305804)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Refus\00E9 ou en double')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341450657305819)
,p_name=>'RELEASE'
,p_message_language=>'fr'
,p_message_text=>'Version'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888299666305456)
,p_name=>'RELEASED'
,p_message_language=>'fr'
,p_message_text=>unistr('Publi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371305598305841)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif des versions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371224639305841)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif des versions pour l''espace de travail : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046627615306366)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations suppl\00E9mentaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087794916306397)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('La bo\00EEte \00E0 outils Web PL/SQL %0 est requise <a href="%1" target="_blank">[Plus d''informations]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087547585306397)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'L''ensemble de patches %0 est disponible <a href="%1" target="_blank">[Plus d''informations]</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087652578306397)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Oracle APEX %0 est disponible <a href="%1" target="_blank">[Plus d''informations]</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102046564073306366)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le syst\00E8me est \00E0 jour')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988029658306321)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Enlev\00E9 en raison d''une activit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100887707888305456)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101879175697306232)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('La d\00E9finition de l''application sera enlev\00E9e, ainsi que tous les objets de prise en charge qui ont \00E9t\00E9 cr\00E9\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101387073222305853)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail a \00E9t\00E9 enlev\00E9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451292018305901)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Renommer la colonne %0 en %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451411560305901)
,p_name=>'RENAME_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Renommer la table %0 en %1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168377279305671)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9organiser les boutons de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183449077305683)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9organiser des entr\00E9es de barre de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168445360305672)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9organiser des r\00E9gions')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168070084305671)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9organiser les \00E9l\00E9ments de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183334827305683)
,p_name=>'REORDER_TABS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9organiser des onglets')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288667381305779)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071725344306385)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Alias d''\00E9tat : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288906947305779)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('colonne d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405504153305866)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380303878305848)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de colonne d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379996837305847)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Le panneau et l''\00E9tat ont \00E9t\00E9 cr\00E9\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344745407305822)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Rapport g\00E9n\00E9r\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412425366305871)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise en page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101241185956305743)
,p_name=>'REPORT_ON'
,p_message_language=>'fr'
,p_message_text=>'Etat sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101405873366305866)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('Attributs de page d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100997378883305542)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte est valide. Les variables attach\00E9es ont \00E9t\00E9 analys\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412370840305871)
,p_name=>'REPORT_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101245932478305747)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'fr'
,p_message_text=>unistr('Etape 1 - T\00E9l\00E9charger en local le fichier XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246039304305747)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'fr'
,p_message_text=>unistr('Etape 2 - Concevoir la mise en page d''\00E9tat et l''enregistrer sous forme de fichier RTF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246299510305747)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'fr'
,p_message_text=>unistr('Etape 2 - T\00E9l\00E9charger vers le serveur le fichier XSL-FO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246139557305747)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'fr'
,p_message_text=>unistr('Etape 3 - T\00E9l\00E9charger vers le serveur le fichier RTF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378418512305846)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes d''\00E9tat extraites')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101446544878305897)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation de l''\00E9tat a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101380432390305848)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385633425305852)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La page Etat sur le service Web a \00E9t\00E9 cr\00E9\00E9e.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302291663305789)
,p_name=>'REQUEST'
,p_message_language=>'fr'
,p_message_text=>'Demande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375925756305844)
,p_name=>'REQUESTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Demand\00E9(e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640158613306042)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 de l''espace de travail "%1" a demand\00E9 une augmentation de la taille de la base de donn\00E9es de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640063379306042)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 a demand\00E9 un nouveau sch\00E9ma pour l''espace de travail "%1" avec %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101639984688306042)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'%0 demande un nouvel espace de travail "%1" d''une taille de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889928738305457)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>'%0 demande un nouvel espace de travail "%1"'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329056646305810)
,p_name=>'RESEARCHING'
,p_message_language=>'fr'
,p_message_text=>'Recherche'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864506555305438)
,p_name=>'RESET_4000'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911484607305474)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser sur la valeur NULL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896383262305462)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'fr'
,p_message_text=>'Groupe de consommateurs Resource Manager'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594112427306009)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s restreint')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164676675305669)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'fr'
,p_message_text=>unistr('Restreint - ne peut pas \00EAtre d\00E9fini \00E0 partir du navigateur')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382220496305849)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9f\00E9rence de service Web a \00E9t\00E9 ajout\00E9e \00E0 l''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994255272305540)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'fr'
,p_message_text=>'Avec alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792889867306163)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Les services RESTful APEX sont en lecture seule.</p>',
'',
unistr('<p>Vous pouvez utiliser les services RESTful bas\00E9s sur APEX avec leur d\00E9finition actuelle. Cependant, Oracle vous encourage \00E0 migrer ces services vers ORDS en cliquant sur <strong>Migrer vers les services RESTful ORDS</strong>.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789440965306161)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Version en cours d''ex\00E9cution d''ORDS introuvable. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993672283305539)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792781921306163)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette action entra\00EEne la d\00E9sinscription et la suppression de toutes les d\00E9finitions de service REST ORDS pour le sch\00E9ma s\00E9lectionn\00E9. Cette action est irr\00E9versible.</p>'),
'',
unistr('<p>Voulez-vous d\00E9sinscrire ce sch\00E9ma ?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101242740743305745)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'fr'
,p_message_text=>unistr('Un pr\00E9fixe de chemin APEX avec cette valeur a d\00E9j\00E0 \00E9t\00E9 d\00E9fini pour un autre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304015879305792)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cet alias de sch\00E9ma est d\00E9j\00E0 utilis\00E9 par un autre sch\00E9ma.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993529061305539)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029226226306353)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Nombre total d''objets compatibles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977371136305527)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'fr'
,p_message_text=>unistr('Le caract\00E8re global (*) peut uniquement appara\00EEtre dans un mod\00E8le de routage comme dernier caract\00E8re et doit \00EAtre pr\00E9c\00E9d\00E9 d''un param\00E8tre nomm\00E9 ou d''une barre oblique (/).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642372744306044)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Gestionnaire cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642521363306044)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Gestionnaire supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612017169306022)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de gestionnaire attendu, mais valeur NULL re\00E7ue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642462399306044)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Gestionnaire mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977233653305527)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Des caract\00E8res non valides ont \00E9t\00E9 trouv\00E9s dans les parties litt\00E9rales du mod\00E8le de routage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014108535305554)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Autorisation obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062151463306378)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">Si vous cliquez sur le bouton Migrer, les m\00E9tadonn\00E9es de tous les services REST bas\00E9s sur APEX seront copi\00E9es vers ORDS. Les d\00E9finitions des services bas\00E9s sur APEX existants resteront intactes, mais ne se')
||unistr('ront plus ex\00E9cut\00E9es tant qu''un service correspondant existera dans ORDS. '),
'',
unistr('Apr\00E8s la migration, nous vous recommandons de valider et de tester les services bas\00E9s sur ORDS migr\00E9s. Une fois la v\00E9rification termin\00E9e, exportez et supprimez les services bas\00E9s sur APEX.</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102062001877306378)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX a d\00E9tect\00E9 que votre espace de travail contient au moins deux modules REST bas\00E9s sur APEX avec des pr\00E9fixes d''URI NULL. ORDS n''autorise pas les modules \00E0 avoir le m\00EAme pr\00E9fixe d''URI de base. </p>'),
'',
unistr('<p>Pour migrer ces services vers ORDS, les r\00E8gles suivantes seront appliqu\00E9es : </p>'),
'',
'<ul>',
unistr('<li>Tous les modules concern\00E9s seront r\00E9duits en un seul module ORDS nomm\00E9 <em><strong>merged.apex.rest.services</strong></em>.</li>'),
unistr('<li>Si <strong><em>l''un</em></strong> des modules bas\00E9s sur APEX en cours de fusion est publi\00E9, le nouveau module fusionn\00E9 <strong><em>sera publi\00E9</em></strong>.</li>'),
unistr('<li>Si <strong><em>aucun</em></strong> des modules bas\00E9s sur APEX en cours de fusion n''est publi\00E9, le nouveau module fusionn\00E9 <strong><em>ne sera pas publi\00E9</em></strong>.</li>'),
unistr('<li><strong><em>Tous les r\00F4les</em></strong> associ\00E9s \00E0 des modules bas\00E9s sur APEX en cours de fusion <strong><em>seront affect\00E9s au nouveau module fusionn\00E9</em></strong>.</li>'),
unistr('<li>La <strong><em>taille de pagination</em></strong> du module fusionn\00E9 sera d\00E9finie sur la <strong><em>taille de pagination la plus grande</em></strong> des modules en cours de fusion.</li>'),
unistr('<li>Si des modules APEX avec des URI de base NULL ont \00E9galement des URI de mod\00E8le en double, les \00E9v\00E9nements suivants se produiront :'),
'',
'<ul>',
unistr('<li>Le mod\00E8le qui a \00E9t\00E9 mis \00E0 jour en dernier conservera l''URI en double</li>'),
unistr('<li>Le pr\00E9fixe dup001_* sera ajout\00E9 \00E0 tous les autres mod\00E8les</li>'),
unistr('<li>Le commentaire du mod\00E8le contiendra le nom du module d''origine \00E0 partir duquel il a \00E9t\00E9 migr\00E9 et l''URI du mod\00E8le d''origine</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061948864306378)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX a d\00E9tect\00E9 que votre espace de travail contient au moins deux modules REST bas\00E9s sur APEX avec des pr\00E9fixes d''URI NULL. ORDS n''autorise pas les modules \00E0 avoir le m\00EAme pr\00E9fixe d''URI de base. </p>'),
'',
unistr('<p>Il n''est actuellement pas possible de migrer vos services REST bas\00E9s sur APEX vers ORDS. La migration sera disponible \00E0 partir des versions d''ORDS 18.2 et ult\00E9rieures.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102028916943306353)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Nombre total de modules'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641713994306044)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Module cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641938785306044)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Module supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611872570306022)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de module attendu, mais valeur NULL re\00E7ue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641872480306044)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Module mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977013443305527)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'fr'
,p_message_text=>unistr('Un param\00E8tre nomm\00E9 dans le mod\00E8le de routage contient des caract\00E8res non valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101859030020306213)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce sch\00E9ma n''est pas inscrit aupr\00E8s d''ORDS RESTful Data Services. Pour inscrire ce sch\00E9ma, cliquez sur <strong>Inscrire le sch\00E9ma aupr\00E8s d''ORDS</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977491626305527)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''URI ne correspondait pas au mod\00E8le de style URI ou ROUTE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977546117305528)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''est pas autoris\00E9 \00E0 comporter plusieurs barres obliques cons\00E9cutives.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976942883305527)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 utiliser une cha\00EEne de requ\00EAte pour un mod\00E8le de routage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100880929764305450)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>APEX est en cours d''ex\00E9cution dans la base de donn\00E9es Conteneur. Vous ne pouvez pas d\00E9finir de services REST bas\00E9s sur ORDS dans la base de donn\00E9es Conteneur.</p><p>Vous pouvez toutefois continuer \00E0 utiliser les services RESTful bas\00E9s sur APEX.</p')
||'>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101792600404306163)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La version d''ORDS actuellement install\00E9e (%0) ne prend pas en charge toutes les fonctionnalit\00E9s requises pour activer les services RESTful bas\00E9s sur ORDS dans Application Express. La version minimale %1 doit \00EAtre install\00E9e.</p>'),
unistr('<p>Vous pouvez continuer d''utiliser les services RESTful bas\00E9s sur APEX.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977109674305527)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'fr'
,p_message_text=>unistr('Le caract\00E8re (?) facultatif peut uniquement appara\00EEtre dans un mod\00E8le de routage comme dernier caract\00E8re et doit \00EAtre pr\00E9c\00E9d\00E9 d''un param\00E8tre nomm\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975985018305526)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Le syst\00E8me n''a pas pu localiser le sch\00E9ma ORDS_METADATA, qui est obligatoire pour activer ORDS REST Workshop. Reportez-vous au guide d''installation d''Oracle REST Data Services pour obtenir des instructions d''installation.</p> <p>Vous pouvez contin')
||unistr('uer \00E0 utiliser les services RESTful bas\00E9s sur APEX.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994160132305540)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'fr'
,p_message_text=>unistr('Partiellement s\00E9curis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975859559305526)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Ce syst\00E8me utilise actuellement la passerelle PL/SQL imbriqu\00E9e Oracle. Vous devez installer la version %0 ou ult\00E9rieure d''Oracle REST Data Services afin d''autoriser l''acc\00E8s \00E0 ORDS REST Workshop.</p> <p>Vous pouvez continuer \00E0 utiliser les services')
||unistr(' RESTful bas\00E9s sur APEX.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029084109306353)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre total de privil\00E8ges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642984811306045)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ge cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643106747306045)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ge supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643004047306045)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ge mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993790202305539)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Publi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994866429305540)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette action entra\00EEnera la suppression et la recr\00E9ation du service <strong>oracle.example.hr</strong> et des objets de base de donn\00E9es associ\00E9s dans le sch\00E9ma actuellement s\00E9lectionn\00E9. Toute modification ou ajout apport\00E9 sera perdu et cette action')
||unistr(' est irr\00E9versible.</p>'),
unistr('<p>Voulez-vous r\00E9initialiser le service \00E9chantillon ?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029182463306353)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre total de r\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642674841306044)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642818890306044)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642799129306044)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014081750305554)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Statut d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101014271974305555)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Alias de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789674409306161)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('Le script t\00E9l\00E9charg\00E9 est trop volumineux. Application Express a une limite de 32 Mo (32 767 octets).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993904353305540)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611902821306022)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de s\00E9quence attendu pour le param\00E8tre, mais valeur NULL re\00E7ue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029426787306354)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'fr'
,p_message_text=>'Echec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029341381306353)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029531895306354)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642027184306044)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642212504306044)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612170143306022)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de mod\00E8le attendu, mais valeur NULL re\00E7ue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912178817305474)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mod\00E8le URI ne peut pas \00EAtre NULL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101642172754306044)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le mis \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994492735305540)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Objets compatibles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994589599305540)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'fr'
,p_message_text=>'Modules'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994631104305540)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994748162305540)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102017998151306345)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Services de donn\00E9es RESTful')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994348377305540)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'fr'
,p_message_text=>'Sans alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993879121305540)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Publication annul\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100994063115305540)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non s\00E9curis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976813105305527)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Des variables URI contiennent une erreur de syntaxe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593040652306008)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le script que vous essayez de charger est un export de service RESTful bas\00E9 sur APEX. Vous ne pouvez pas le charger \00E0 l''aide de la page d''import des services RESTful ORDS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856645878306211)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'fr'
,p_message_text=>unistr('Le script que vous essayez de charger est un export de service RESTful bas\00E9 sur ORDS. Vous ne pouvez pas le charger \00E0 l''aide de la page d''import des services RESTful APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029683444306354)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'fr'
,p_message_text=>'Copier dans le presse-papiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102029733425306354)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier l''URL enti\00E8re vers le presse-papiers')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987902909306321)
,p_name=>'RETAINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Conserv\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102698871305623)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0 la page de connexion %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107938764306413)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur renvoy\00E9e : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329315560305810)
,p_name=>'REVIEWING'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9vision')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101590711099306006)
,p_name=>'ROLE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108823656305627)
,p_name=>'ROLLBACK'
,p_message_language=>'fr'
,p_message_text=>unistr('Instruction d''annulation (rollback) non applicable. Toutes les instructions sont valid\00E9es (commit) automatiquement.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452651878305902)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 lignes renvoy\00E9es en %1 secondes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932558488305492)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'fr'
,p_message_text=>unistr('lignes renvoy\00E9es dans')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543389280305967)
,p_name=>'RUN'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857680867305433)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter et d\00E9velopper')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101308823015305795)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546139231305969)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter l''application : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105505902305625)
,p_name=>'RUN_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter uniquement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548152805305973)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cuter la page : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100911751632305474)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications \00E9chantillon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505968353305941)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'fr'
,p_message_text=>'Pays'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506213381305941)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'fr'
,p_message_text=>'Liste de pays, populations et capitales.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093398316305616)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'fr'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093489303305616)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Tables g\00E9n\00E9riques EMP et DEPT.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506031271305941)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'fr'
,p_message_text=>'Formule 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506468249305941)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'fr'
,p_message_text=>'Champions du monde de formule 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987245317306321)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises \00E0 jour de l''\00E9tat de sant\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987359626306321)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises \00E0 jour de l''\00E9tat de sant\00E9 simplifi\00E9es et rapport\00E9es par les patients \00E0 destination des professionnels de sant\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093558565305616)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es RH')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093605384305616)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Tables RH g\00E9n\00E9riques couramment utilis\00E9es par Oracle Education.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546248604305969)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'fr'
,p_message_text=>'Commandes client'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546312551305969)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Collection de clients, de magasins, de produits et de commandes. Cet ensemble de donn\00E9es contient des donn\00E9es JSON pour la description des produits et la longitude/latitude des magasins.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093113112305616)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es de projet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093255990305616)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Collection de projets, de jalons, de t\00E2ches, etc. Cet ensemble de donn\00E9es inclut des relations ma\00EEtre-d\00E9tail-d\00E9tail et une vue utile pour la g\00E9n\00E9ration de graphiques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093751002305616)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'fr'
,p_message_text=>unistr('Feuille de calcul de t\00E2ches')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101093844432305616)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('Table unique avec des donn\00E9es non normalis\00E9es contenant des t\00E2ches, des dates, des statuts, des \00E9l\00E9ments affect\00E9s, des co\00FBts et des budgets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505806196305941)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'fr'
,p_message_text=>'Tennis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506352433305941)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'fr'
,p_message_text=>'Hommes et femmes vainqueurs et seconds de tournois du Grand Chelem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506133018305941)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'fr'
,p_message_text=>'Coupe du monde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506563171305941)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats de la coupe du monde de football')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389732198305855)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'fr'
,p_message_text=>unistr('Feuille Web \00E9chantillon')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376596596305845)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376646852305845)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'fr'
,p_message_text=>'Exemple de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376756090305845)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Autres \00E9tats enregistr\00E9s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376294999305845)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375594230305844)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Priv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101375611659305844)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Abonnement priv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376132579305845)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'fr'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376412494305845)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101376378059305845)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''\00E9tat')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020541171305561)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020767924305561)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020626302305561)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e de chemin de navigation mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020426850305561)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Chemin de navigation supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020333270305561)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Chemin de navigation mis \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992371875305538)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de grille interactive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992210671305538)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348792453305824)
,p_name=>'SCHEMAS'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9mas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101460200002305908)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('exception d''insertion de sch\00E9ma wwv_flow_companies')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459271688305907)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma "%0" est disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459316219305907)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma "%0" n''est pas disponible actuellement et ne peut pas \00EAtre cr\00E9\00E9, car il entre en conflit avec un utilisateur existant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101256920661305755)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073765657305602)
,p_name=>'SCHEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('mod\00E8les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027800786306352)
,p_name=>'SCREEN_READER'
,p_message_language=>'fr'
,p_message_text=>unistr('Lecteur d''\00E9cran')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379841953305847)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer/D\00E9sactiver le lecteur d''\00E9cran')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410496934305870)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce fichier a \00E9t\00E9 export\00E9 \00E0 partir d''un autre espace de travail (%0), et peut-\00EAtre d''une autre base de donn\00E9es %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052042372306370)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Script %0 verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051909244306370)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Script %0 d\00E9verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061194144306377)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le script n''est pas verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101337150458305816)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('Pour d\00E9crire un objet, saisissez <br><br> '),
'',
unistr('DESCRIBE &lt object name &gt dans le panneau de commande ci-dessus et cliquez sur Ex\00E9cuter.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366683076305838)
,p_name=>'SC_NAME_NN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de requ\00EAte ne peut pas avoir la valeur Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378633379305846)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
unistr('L''objet \00E0 d\00E9crire est introuvable.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369231803305840)
,p_name=>'SC_SC'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte non graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101303628636305791)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Instruction SQL en cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369129468305839)
,p_name=>'SC_VQ'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte graphique')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991687123306324)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres de la barre de recherche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411682947305871)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'fr'
,p_message_text=>'Champ de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257333149305755)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''existe aucune colonne VARCHAR dans cette requ\00EAte. Impossible d''activer la recherche.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101246768045305747)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Il n''existe aucune colonne VARCHAR sur laquelle effectuer la recherche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411545001305871)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'fr'
,p_message_text=>unistr('Rechercher des applications \00E9chantillon et de productivit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101806086132306173)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats de la recherche')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101993565110306326)
,p_name=>'SECTIONS'
,p_message_language=>'fr'
,p_message_text=>'Sections'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052515830305585)
,p_name=>'SECURITY'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343807365305821)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'fr'
,p_message_text=>unistr('Destinataire de la s\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694790648306090)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de groupe de s\00E9curit\00E9 (identit\00E9 de votre espace de travail) n''est pas valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341978136305820)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'fr'
,p_message_text=>unistr('Impact de la s\00E9curit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383863493305850)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370377716305840)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne doit pas \00EAtre un utilisateur public')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344221692305821)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Statut de s\00E9curit\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369823610305840)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Consulter l''\00E9tat joint')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905037315305469)
,p_name=>'SELECT_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Tout s\00E9lectionner')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251014947305751)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859517212305435)
,p_name=>'SELECT_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez une date dans la table. Mois en cours = %0, ann\00E9e en cours = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101878010675306231)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une action dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062125728305592)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062091930305592)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061970766305592)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061821578305592)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062202233305592)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079032081306391)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une ligne : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514407849305947)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un espace de travail ci-dessous pour ouvrir l''environnement de d\00E9veloppement Application Express.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438068412305890)
,p_name=>'SELF_SERVICE'
,p_message_language=>'fr'
,p_message_text=>'Libre-service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437947575305890)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libre-service avec v\00E9rification d''adresse \00E9lectronique')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102051611893306370)
,p_name=>'SEPARATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parateur')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070642495305599)
,p_name=>'SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('s\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101499074039305936)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935923984305496)
,p_name=>'SERIES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340413491305818)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'fr'
,p_message_text=>'Modification de service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883513130305452)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'fr'
,p_message_text=>'Administration du site'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320571794305804)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'fr'
,p_message_text=>'Demande de service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078256736305605)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un code de v\00E9rification sans distinction entre les majuscules et les minuscules et cliquez sur <strong>Soumettre la demande</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077128454305604)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'fr'
,p_message_text=>'Informations d''administrateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078169971305605)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('Taille de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077049742305604)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077477257305605)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077256965305604)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9nom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076817419305604)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Justification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077303137305605)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076798851305604)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077973089305605)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077546633305605)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9phone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077767254305605)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9utiliser un sch\00E9ma existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077674999305605)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078024324305605)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076651982305604)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'fr'
,p_message_text=>'Informations d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101077837719305605)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269565731305765)
,p_name=>'SESSION'
,p_message_language=>'fr'
,p_message_text=>'Session'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101372268916305842)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction de v\00E9rification de session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100913294131305475)
,p_name=>'SESSIONS'
,p_message_language=>'fr'
,p_message_text=>'Sessions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435921995305889)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'fr'
,p_message_text=>'Tampon :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435781482305889)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'fr'
,p_message_text=>'UC :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435419123305888)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'fr'
,p_message_text=>'En cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435868442305889)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'fr'
,p_message_text=>'Disque :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435602288305889)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ecoul\00E9 :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101435519764305888)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996801107305542)
,p_name=>'SET_BINDS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs de toutes les variables attach\00E9es doivent \00EAtre d\00E9finies lors du test d''une requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899021553305464)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir la date d''\00E9ch\00E9ance des %0 fonctionnalit\00E9s incompl\00E8tes affect\00E9es \00E0 %1 pour la version %2 sur la date du jalon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018880709305560)
,p_name=>'SET_MILESTONE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir un jalon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899325821305464)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez les fonctionnalit\00E9s dot\00E9es de jalons manquants sur le jalon (%3) pour les %0 fonctionnalit\00E9s incompl\00E8tes affect\00E9es \00E0 %1 pour la version %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100899270700305464)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Remplacez le jalon des %0 fonctionnalit\00E9s incompl\00E8tes affect\00E9es \00E0 %1 pour la version %2 correspondant \00E0 un jalon \00E9chu par le jalon (%3).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018412999305559)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 fonctionnalit\00E9s ouvertes seront affect\00E9es au jalon s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101018965825305560)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'fr'
,p_message_text=>unistr('La date d''\00E9ch\00E9ance de %0 fonctionnalit\00E9s ouvertes sera d\00E9finie sur la date du jalon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056190101306373)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir des pr\00E9f\00E9rences')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019136216305560)
,p_name=>'SET_RELEASE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir une version')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434789416305888)
,p_name=>'SHARED'
,p_message_language=>'fr'
,p_message_text=>unistr('Partag\00E9(e)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613942702306023)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Composants partag\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371927372305841)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) dynamique partag\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100868464183305441)
,p_name=>'SHARED POOL'
,p_message_language=>'fr'
,p_message_text=>unistr('Pool partag\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101371852628305841)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Condition de liste de valeurs (LOV) statique partag\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943479873305502)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Composant partag\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611283250306022)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Validation partag\00E9e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073887747305602)
,p_name=>'SHORTCUT'
,p_message_language=>'fr'
,p_message_text=>'raccourci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516407278305948)
,p_name=>'SHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'Raccourcis'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101323442268305806)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'fr'
,p_message_text=>'Impact significatif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101326546144305808)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'Progression significative'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072361907305601)
,p_name=>'SIMPLE'
,p_message_language=>'fr'
,p_message_text=>'simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317963401305802)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique simple'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395087926305858)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'fr'
,p_message_text=>'Il y a 16 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454578292305903)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a 1 jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454422113305903)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a 1 heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074486676306387)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'fr'
,p_message_text=>'dans 16 h'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454672745305903)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a 1 semaine'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910036385305473)
,p_name=>'SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030826122306355)
,p_name=>'SL.APP'
,p_message_language=>'fr'
,p_message_text=>'Application'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026953833306352)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'fr'
,p_message_text=>'Modifier la page %0 dans l''application %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027042163306352)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der \00E0 l''application %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856804339306211)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Une correspondance trouv\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101856937019306211)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 correspondances trouv\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101874204062306228)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune correspondance trouv\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030989373306355)
,p_name=>'SL.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101548211943305973)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101593523538306008)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'fr'
,p_message_text=>'Rechercher %0 dans toutes les applications'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027359964306352)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'fr'
,p_message_text=>'Rechercher %0 dans cette application'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101789080598306160)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'fr'
,p_message_text=>'Saisissez au moins deux lettres pour la recherche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027216392306352)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Rechercher %0 dans la page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027470227306352)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'fr'
,p_message_text=>unistr('Rechercher %0 dans le d\00E9veloppement d''\00E9quipe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027521242306352)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'fr'
,p_message_text=>'Rechercher l''utilisateur %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027631149306352)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'fr'
,p_message_text=>'Rechercher %0 dans l''espace de travail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102027165011306352)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Composants partag\00E9s de l''application %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320446871305804)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9faut logiciel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325476434305807)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Plut\00F4t souhaitable')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652849034306052)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'fr'
,p_message_text=>'Identificateur de source'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459517412305907)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'fr'
,p_message_text=>'Utilisation d''espace existant'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309039388305795)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'SQL non disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101516830387305948)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101452544452305902)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'fr'
,p_message_text=>'Commandes SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347885929305824)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'fr'
,p_message_text=>'Historique des commandes SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125788126305640)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386138317305852)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385852771305852)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'fr'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385998565305852)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385700469305852)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101386080900305852)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'fr'
,p_message_text=>'Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671544831306073)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('L''acc\00E8s SQL et PL/SQL n''est pas activ\00E9 pour cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671692335306073)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''acc\00E8s SQL et PL/SQL n''est pas activ\00E9 pour cette instance.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071481572305600)
,p_name=>'SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877493234305448)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte non valide, absence d''instruction SELECT')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172990239305675)
,p_name=>'SQL_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976321219305527)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter \00E0 la fin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065117886305594)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065685270305594)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver la colonne de tri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064892251305594)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur d''affichage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065256490305594)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'fr'
,p_message_text=>'Colonne de tri primaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976208754305527)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'fr'
,p_message_text=>'Remplacer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101064987433305594)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Renvoyer valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065476565305594)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'fr'
,p_message_text=>'Colonne de tri secondaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065565747305594)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348022256305824)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'fr'
,p_message_text=>'Scripts SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347983504305824)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats de script SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657644904306055)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets de base de donn\00E9es suivants doivent \00EAtre d\00E9finis dans la liste des tables autoris\00E9es : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348183925305824)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101128060877305641)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''alias indiqu\00E9 est d\00E9j\00E0 utilis\00E9 par un autre objet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101127957946305641)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'L''alias d''objet fourni n''est pas valide. Les alias ne peuvent contenir que des lettres, des chiffres, des traits de soulignement et des tirets.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101441651108305893)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce sch\00E9ma n''est pas inscrit aupr\00E8s d''ORDS RESTful Data Services. Pour inscrire ce sch\00E9ma, acc\00E9dez \00E0 <strong>Services RESTful > Services RESTful ORDS</strong> et cliquez sur le bouton <strong>Inscrire le sch\00E9ma aupr\00E8s d''ORDS</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456673451305905)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'fr'
,p_message_text=>unistr('APEX est en cours d''ex\00E9cution dans la base de donn\00E9es Conteneur. Vous ne pouvez pas d\00E9finir de services REST bas\00E9s sur ORDS dans la base de donn\00E9es Conteneur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456459167305905)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'fr'
,p_message_text=>unistr('La version d''ORDS actuellement install\00E9e (%0) ne prend pas en charge toutes les fonctionnalit\00E9s requises pour rendre les objets de base de donn\00E9es compatibles REST. La version %1 au minimum doit \00EAtre install\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456224575305905)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Le syst\00E8me n''a pas pu localiser le sch\00E9ma ORDS_METADATA, qui est obligatoire pour activer les services RESTful ORDS. Reportez-vous au guide d''installation d''Oracle REST Data Services pour obtenir des instructions d''installation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456530037305905)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'fr'
,p_message_text=>'Version ORDS <strong>%0</strong>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101456328470305905)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce syst\00E8me utilise actuellement la passerelle PL/SQL imbriqu\00E9e Oracle. Vous devez installer la version %0 ou ult\00E9rieure d''Oracle REST Data Services afin de rendre les objets de base de donn\00E9es compatibles REST.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846316069305425)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 2D, empil\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846468868305425)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 3D, empil\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846581845305425)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 2D, horizontales, empil\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100846631560305425)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('A colonnes 3D, horizontales, empil\00E9es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612718377306023)
,p_name=>'STANDARD _TABS'
,p_message_language=>'fr'
,p_message_text=>'Onglets standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101614445922306024)
,p_name=>'STANDARD_TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101052608076305585)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets standard'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938864356305498)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers d''application statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938785431305498)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers d''espace de travail statiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109451059306414)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez au moins un mot-cl\00E9 comportant au moins deux caract\00E8res. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109566358306414)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun r\00E9sultat ne correspond \00E0 votre requ\00EAte de recherche. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125577318305640)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'fr'
,p_message_text=>'Affectation statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458042759305906)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune application associ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100869665149305442)
,p_name=>'STATIC_HTML'
,p_message_language=>'fr'
,p_message_text=>'HTML statique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853107045305430)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rence statique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316786909305801)
,p_name=>'STATIC_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion statique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381358142305848)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cha\00EEnes de substitution statiques')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072167237306385)
,p_name=>'STATUS_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Statut : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252577118305752)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Statut modifi\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367958886305839)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'fr'
,p_message_text=>'Condition d''onglet standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061215015306377)
,p_name=>'STEAL_LOCK'
,p_message_language=>'fr'
,p_message_text=>'Soustraire le verrou'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912966534305475)
,p_name=>'STORAGE'
,p_message_language=>'fr'
,p_message_text=>'Stockage :'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101071511926305600)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('requ\00EAte structur\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101172781041305675)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat structur\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101458996706305907)
,p_name=>'SUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Soumettre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252468556305752)
,p_name=>'SUBMITTED'
,p_message_language=>'fr'
,p_message_text=>'Soumis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101168213642305671)
,p_name=>'SUBMIT_AS'
,p_message_language=>'fr'
,p_message_text=>'Soumettre en tant que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101378184344305846)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'fr'
,p_message_text=>'Soumettre les informations en retour'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310222270305796)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e en cours subordonn\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101310306296305796)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9e non en cours subordonn\00E9e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087044385306397)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ma\00EEtre non existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087244474306397)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087174356306397)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rentiel de th\00E8mes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054722909305586)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055032884305586)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce mod\00E8le d''autorisation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055255094305586)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le d''autorisation n''est abonn\00E9 \00E0 ce mod\00E8le d''autorisation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055185820305586)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les d''autorisation en cours d''abonnement \00E0 ce mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857146390305433)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857475911305433)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Il s''agit de la copie "ma\00EEtre" de cette d\00E9finition de chargement de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857305810305433)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune d\00E9finition de chargement de donn\00E9es n''est abonn\00E9e \00E0 cette d\00E9finition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857207064305433)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition de chargement de donn\00E9es en cours d''abonnement \00E0 cette d\00E9finition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054158667305586)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054230757305586)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de cette aide sur un \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054411236305586)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun n''\00E9l\00E9ment n''est abonn\00E9 \00E0 ce texte d''aide sur un \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101054398029305586)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments en cours d''abonnement \00E0 ce texte d''aide sur un \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056731650305588)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056817131305588)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de cette liste de valeurs (LOV).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057069075305588)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune liste de valeurs (LOV) n''est abonn\00E9e \00E0 cette liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056900777305588)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs en cours d''abonnement \00E0 cette liste de valeurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944866416305503)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058328599305589)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de cette barre de navigation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058997720305589)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune barre de navigation n''est abonn\00E9e \00E0 cette barre de navigation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101058637725305589)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Barres de navigation en cours d''abonnement \00E0 cette barre de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944426945305503)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944532808305503)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce module d''extension.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944702315305503)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun module d''extension n''est abonn\00E9 \00E0 ce module d''extension.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944626730305503)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Modules d''extension en cours d''abonnement \00E0 ce module d''extension')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055559183305587)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055767560305587)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce raccourci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056024836305587)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun raccourci n''est abonn\00E9 \00E0 ce raccourci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055957449305587)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Raccourcis en cours d''abonnement \00E0 ce raccourci')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050362513305583)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050572841305583)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050619935305583)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le n''est abonn\00E9 \00E0 ce mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101050454581305583)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de liste de valeurs (LOV) instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061475705305591)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les en cours d''abonnement \00E0 ce mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025892333306351)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Abonn\00E9 au th\00E8me d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102068425177306383)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Abonn\00E9 au th\00E8me standard')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026225041306351)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026173760306351)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun th\00E8me n''est abonn\00E9 \00E0 ce th\00E8me. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025974139306351)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me de liste de valeurs instantan\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102026075856306351)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8mes en cours d''abonnement \00E0 ce th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433756835305887)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433887531305887)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Il s''agit de la copie ma\00EEtre de cette source de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434014468305887)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune source de donn\00E9es REST n''est abonn\00E9e \00E0 cette source.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101433929074305887)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Sources de donn\00E9es REST en cours d''abonnement \00E0 cette source.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060416823305590)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 \00E0 partir de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061297144305591)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ceci est la copie ma\00EEtre de ce mod\00E8le de bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061648485305591)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le n''est abonn\00E9 \00E0 ce mod\00E8le de bouton.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061502629305591)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les de bouton en cours d''abonnement \00E0 ce mod\00E8le de bouton')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100888498787305456)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisation des cha\00EEnes de substitution')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289162477305779)
,p_name=>'SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365619256305837)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Message de succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101251575989305751)
,p_name=>'SUCCESSES'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118244464305634)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cluster vid\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114534998305631)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Commande ex\00E9cut\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117365840305634)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Contexte supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117574349305634)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Lien de base de donn\00E9es cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117403572305634)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Lien de base de donn\00E9es supprim\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118497577305634)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction modifi\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113484469305631)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116334329305633)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118003944305634)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''index modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117220899305633)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''index supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113821323305631)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Index cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116677537305633)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Index supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114117597305631)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue mat\00E9rialis\00E9e cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116748275305633)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue mat\00E9rialis\00E9e supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118349966305634)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Package modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113682703305631)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de package cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113717859305631)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Package cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115624487305632)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Package supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118517091305634)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure modifi\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113551689305631)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116478882305633)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114280255305631)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116877174305633)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00F4le supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115010265305632)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ligne(s) supprim\00E9e(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114861986305632)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ligne(s) ins\00E9r\00E9e(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114703841305632)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ligne(s) mise(s) \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118628625305635)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence modifi\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114337508305631)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116037082305633)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840062021305420)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839905659305420)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839851018305420)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874824141305446)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Instruction trait\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114497086305631)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Synonyme cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116997720305633)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Synonyme supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116119846305633)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Table modifi\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113071987305630)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Table cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115596976305632)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Table supprim\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117641210305634)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'fr'
,p_message_text=>unistr('Table renomm\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118147278305634)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Table vid\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117913670305634)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencheur modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113375934305631)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencheur cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117021845305633)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9clencheur supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117805214305634)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Type modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113962560305631)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Type cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117113133305633)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Type supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118788922305635)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateur modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114079089305631)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateur cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115720986305632)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateur supprim\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101117782345305634)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue modifi\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113178774305630)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue cr\00E9\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115819283305632)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue supprim\00E9e.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457636171305906)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Objets de prise en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994329652306326)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('La d\00E9finition d''objet a \00E9t\00E9 modifi\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994402074306326)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'fr'
,p_message_text=>'L''objet n''existe plus.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318280358305802)
,p_name=>'SVG CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101407796615305868)
,p_name=>'SVG PLUGIN'
,p_message_language=>'fr'
,p_message_text=>'Installez le visualiseur SVG pour visualiser le graphique.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838351387305419)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez pas modifier un script SQL vide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838402159305419)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez pas modifier un script de plus de 30 000 octets.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070713934305600)
,p_name=>'SYNONYM'
,p_message_language=>'fr'
,p_message_text=>'synonyme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672066811306073)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'fr'
,p_message_text=>'(synonyme)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450919674305901)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'fr'
,p_message_text=>'Synonyme'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582110691305999)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Message du syst\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252657407305752)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Statut syst\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101252731485305752)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Statut de syst\00E8me modifi\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070870857305600)
,p_name=>'TABLE'
,p_message_language=>'fr'
,p_message_text=>'table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101318807272305802)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'fr'
,p_message_text=>'%0 n''est pas un nom de table ou de vue valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348669105305824)
,p_name=>'TABLESPACES'
,p_message_language=>'fr'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069806944305599)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'fr'
,p_message_text=>'(table)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101365001661305836)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('La longueur du nom de table %0 est sup\00E9rieure au maximum autoris\00E9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377927118305846)
,p_name=>'TABULAR_FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau tabulaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384412198305851)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation du panneau tabulaire a r\00E9ussi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101065764440305594)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : La cible d''onglet parent "%0" semble faire r\00E9f\00E9rence \00E0 une page qui n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101057413864305588)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence d''onglets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056350467305587)
,p_name=>'TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Jeu d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101612652250306023)
,p_name=>'TAB_SETS'
,p_message_language=>'fr'
,p_message_text=>'Jeux d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056503406305587)
,p_name=>'TAB_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''onglet'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073307361306386)
,p_name=>'TAG_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Balise : %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897899403305463)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s cibl\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111472738306415)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de page cible ou URL personnalis\00E9e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321536252305804)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2che termin\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345798315305822)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9veloppement d''\00E9quipe')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101051305898305584)
,p_name=>'TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100510931306407)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305201261305792)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305324929305792)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'fr'
,p_message_text=>'Avant pied'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100231677306407)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier le mod\00E8le : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100408633306407)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouveau mod\00E8le : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833912029305415)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de mod\00E8le de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304923504305792)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de mod\00E8le de page (1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305064306305792)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de mod\00E8le de page (2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101305103124305792)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps de mod\00E8le de page (3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100380215306407)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9visualiser le mod\00E8le : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304108007305792)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304272742305792)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304310640305792)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304470758305792)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304544061305792)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304670124305792)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304780467305792)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101304892813305792)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'fr'
,p_message_text=>unistr('Position de r\00E9gion 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101807881010306174)
,p_name=>'TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8les')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438128817305890)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100867920368305441)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''une application bas\00E9e sur une application mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505168709305940)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Pilot\00E9 par mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436227809305889)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Avanc\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436134177305889)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'fr'
,p_message_text=>'Commun'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101880173075306232)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436003264305889)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9ral')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997245518306329)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune option de mod\00E8le correspondante n''a \00E9t\00E9 d\00E9finie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004968662306335)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('- Aucune option s\00E9lectionn\00E9e -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101981491405306316)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser les valeurs par d\00E9faut du mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087850356306397)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Non-concordance des options de mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108980660306414)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce mod\00E8le est abonn\00E9 au mod\00E8le correspondant dans le th\00E8me ma\00EEtre. Pour modifier ce mod\00E8le, modifiez le mod\00E8le ma\00EEtre, puis r\00E9g\00E9n\00E9rez le th\00E8me. Vous pouvez \00E9galement cr\00E9er une copie d\00E9sabonn\00E9e locale de ce mod\00E8le. Les mod\00E8les d\00E9sabonn\00E9s peuvent \00EAtre ')
||unistr('modifi\00E9s et ne seront pas \00E9cras\00E9s par une r\00E9g\00E9n\00E9ration de th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102108891389306413)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ce mod\00E8le est local pour cette application et ne fait pas l''objet d''un abonnement. '),
unistr('Les mod\00E8les individuels ne peuvent pas faire l''objet d''un abonnement lorsque le th\00E8me associ\00E9 le fait.'),
unistr('Une autre solution pour d\00E9finir des mod\00E8les locaux consiste \00E0 ajouter de nouveaux mod\00E8les au th\00E8me ma\00EEtre, puis \00E0 les envoyer ou les extraire facilement dans cette application.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062521669305592)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9 en tant que mod\00E8le par d\00E9faut d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062766019305592)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9 en tant que mod\00E8le d''erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062992154305592)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce mod\00E8le de page n''est PAS r\00E9f\00E9renc\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101063045126305592)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de page ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062814967305592)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9 dans les pages')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101062688148305592)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9renc\00E9 en tant que mod\00E8le d''impression facile')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101257117254305755)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'fr'
,p_message_text=>'Tablespace temporaire'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101118881669305635)
,p_name=>'TEST'
,p_message_language=>'fr'
,p_message_text=>'Tester'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343656970305821)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'fr'
,p_message_text=>'Test du destinataire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101341818843305819)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'fr'
,p_message_text=>'Test de l''impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344014642305821)
,p_name=>'TESTING_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut des tests'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410385714305870)
,p_name=>'TEST_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Tester la requ\00EAte')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613820229306023)
,p_name=>'TEXT FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers texte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101012098916305553)
,p_name=>'THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100938633954305498)
,p_name=>'THEME FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichiers de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613426435306023)
,p_name=>'THEME IMAGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Images de th\00E8me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074591334306387)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'fr'
,p_message_text=>'Compatible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865819900306218)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8me')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101006438758305549)
,p_name=>'THEMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Th\00E8mes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109058765306414)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas annuler l''abonnement de mod\00E8les individuels faisant partie d''un th\00E8me abonn\00E9 \00E0 un autre th\00E8me au niveau du th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109350836306414)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette application ne peut pas \00EAtre convertie en th\00E8me utilisant la navigation bas\00E9e sur des onglets car elle utilise la navigation bas\00E9e sur des listes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109232604306414)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette application ne peut pas \00EAtre convertie en th\00E8me utilisant la navigation bas\00E9e sur des listes car elle utilise deux niveaux d''onglets. Mettez \00E0 jour l''application et d\00E9finissez les param\00E8tres d''onglet en cours pour utiliser uniquement un niveau ')
||unistr('d''onglets avant de changer de th\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101325629497305807)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Un th\00E8me de bureau ne peut pas basculer sur un th\00E8me mobile.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101232022358305737)
,p_name=>'THEME_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de th\00E8me')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072705805306386)
,p_name=>'TITLE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Titre : %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101320969464305804)
,p_name=>'TO DO'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2che \00E0 effectuer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367709338305838)
,p_name=>'TODO'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2che \00E0 effectuer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101347432751305823)
,p_name=>'TODOS'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2ches \00E0 effectuer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897082456305463)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2ches \00E0 effectuer termin\00E9es (%0/%1) :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652403288306051)
,p_name=>'TODO_DASH_1'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 entr\00E9es, %1 ouverte(s), %2 termin\00E9e(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652546187306051)
,p_name=>'TODO_DASH_2'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 entr\00E9es sont partiellement termin\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652649251306051)
,p_name=>'TODO_DASH_3'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 entr\00E9es sont partiellement termin\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346290578305823)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 principales tables par nombre de lignes, signal\00E9es par sch\00E9ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370879369305841)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre total d''\00E9l\00E9ments ferm\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368322098305839)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'fr'
,p_message_text=>'Nombre total de jalons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101370788953305841)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre total d''\00E9l\00E9ments ouverts')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346362516305823)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'fr'
,p_message_text=>'Temps d''affichage total (secondes)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988244714306322)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'fr'
,p_message_text=>'A purger (dans les 7 prochains jours)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369475889305840)
,p_name=>'TO_DOS'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E2ches \00E0 effectuer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674539406306075)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourcentage de t\00E2ches \00E0 effectuer termin\00E9es (%0/%1) :')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072804853305601)
,p_name=>'TREE'
,p_message_language=>'fr'
,p_message_text=>'arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495639322305933)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Arborescence de d\00E9part bas\00E9e sur un \00E9l\00E9ment existant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495773839305933)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Arborescence de d\00E9part bas\00E9e sur une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495911647305933)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur de l''arborescence de d\00E9part est NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101495834223305933)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Arborescence de d\00E9part bas\00E9e sur une valeur statique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986007939305534)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation de l''arborescence a r\00E9ussi.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101070935630305600)
,p_name=>'TRIGGER'
,p_message_language=>'fr'
,p_message_text=>unistr('d\00E9clencheur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947705591305505)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Les noms de bouton ne doivent pas \00EAtre identiques \00E0 des noms d''onglet existants.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453757505305903)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''application et l''ID de groupe de s\00E9curit\00E9 en cours ne sont pas coh\00E9rents.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947679521305505)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de groupe de s\00E9curit\00E9 20 est r\00E9serv\00E9 \00E0 l''espace de travail ORACLE.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101451696003305901)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'fr'
,p_message_text=>'Vider la table %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101496521175305934)
,p_name=>'TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101498431190305935)
,p_name=>'TYPE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Type : %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101447016550305898)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''\00E9l\00E9ment personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101453611027305903)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'fr'
,p_message_text=>unistr('Visualiser la d\00E9finition de colonne de base de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101340066973305818)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'fr'
,p_message_text=>'Passer au contenu principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860876813305436)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'fr'
,p_message_text=>'Bureau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860933874305436)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9phone portable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861095178305436)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'fr'
,p_message_text=>'Tablette jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861140220305436)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'fr'
,p_message_text=>'Smartphone jQuery Mobile pour PhoneGap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100861255448305436)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'fr'
,p_message_text=>'Tablette jQuery Mobile pour PhoneGap'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101019080097305560)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de d\00E9terminer la date du jalon')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390238295305855)
,p_name=>'UNASSIGNED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non affect\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413245238305872)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisateur non authentifi\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594332168306009)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('Non disponible (r\00E9acheminer vers une URL)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101594287836306009)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Non disponible (statut affich\00E9 avec PL/SQL)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101328736887305810)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Pris en consid\00E9ration')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943797968305502)
,p_name=>'UNEXPIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non p\00E9rim\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455298282305904)
,p_name=>'UNLOCK'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9verrouiller')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543223067305967)
,p_name=>'UNLOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('non verrouill\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907887632305471)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Applications d\00E9verrouill\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100904800029305469)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9verrouiller')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164788636305669)
,p_name=>'UNRESTRICTED'
,p_message_language=>'fr'
,p_message_text=>'Non restreint'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119589926305635)
,p_name=>'UP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072688944305601)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E9tat modifiable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101652796059306052)
,p_name=>'UPDATED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102828307305623)
,p_name=>'UPDATED_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505305053305940)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour vers la version de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505443000305940)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour vers la version')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004837684306335)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'format de date non pris en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675627189306076)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format de date non pris en charge.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102055944797306373)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s la mise \00E0 niveau, assurez-vous que la colonne de libell\00E9 d''attribut de s\00E9rie est mapp\00E9e \00E0 une colonne Date/Horodatage.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072724587305601)
,p_name=>'URL'
,p_message_language=>'fr'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101309231453305795)
,p_name=>'URL LINK'
,p_message_language=>'fr'
,p_message_text=>'Lien URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101332899599305813)
,p_name=>'USERID'
,p_message_language=>'fr'
,p_message_text=>'ID utilisateur'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349174380305825)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 utilisateurs, derni\00E8re cr\00E9ation d''utilisateur %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454032505305903)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune page globale d\00E9finie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343503209305821)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'fr'
,p_message_text=>'Destinataire de l''interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101343064318305820)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'fr'
,p_message_text=>'Impact de l''interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344528840305821)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut de l''interface utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962464317305516)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette page pour contr\00F4ler l''acc\00E8s des d\00E9veloppeurs d''application, utilisateurs finals et administrateurs d''espace de travail d''Application Express.</p>'),
'',
unistr('<p>Les <strong>administrateurs d''espace de travail</strong> peuvent cr\00E9er et modifier des applications et des objets de base de donn\00E9es, ainsi que g\00E9rer des comptes utilisateur, des groupes et des services de d\00E9veloppement.</p>'),
'',
unistr('<p>Les <strong>d\00E9veloppeurs</strong> peuvent cr\00E9er et modifier des applications et des objets de base de donn\00E9es.</p>'),
'',
unistr('<p>Les <strong>utilisateurs finals</strong> ne disposent pas de privil\00E8ges de d\00E9veloppement et ils ne peuvent acc\00E9der qu''aux applications qui n''utilisent pas de mod\00E8le d''authentification externe.</p>'),
'',
'<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">En savoir plus...</a></p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986637343305534)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page permet de contr\00F4ler l''acc\00E8s des utilisateurs finals \00E0 Application Express.</p>'),
'',
unistr('<p>Les <strong>utilisateurs finals</strong> ne sont dot\00E9s d''aucun privil\00E8ge de d\00E9veloppement et ne peuvent acc\00E9der qu''aux applications qui n''utilisent pas de mod\00E8le d''authentification externe.</p>'),
'',
unistr('<p>Les <strong>administrateurs d''espace de travail</strong> et les <strong>d\00E9veloppeurs</strong> sont g\00E9r\00E9s \00E0 l''aide de la console de gestion des identit\00E9s. Lorsqu''un administrateur d''espace de travail ou un d\00E9veloppeur se connecte \00E0 Application Expr')
||unistr('ess, un compte "shadow" est cr\00E9\00E9. Ces utilisateurs "shadow" peuvent \00EAtre enlev\00E9s si n\00E9cessaire.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074179874305602)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser la page de connexion int\00E9gr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101073942247305602)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Utilisez la page %0 comme page de connexion.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436954637305889)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilisez l''attribut <strong>Effacer le cache</strong> pour enlever le statut de session d''une liste de pages s\00E9par\00E9es par des virgules. La syntaxe d''effacement du cache suivante est \00E9galement disponible :'),
'<ul>',
unistr('<li>RIR : R\00E9initialiser l''\00E9tat interactif</li>'),
unistr('<li>CIR : Effacer l''\00E9tat interactif</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101459943882305907)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('utilisation de sch\00E9ma existant')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081651710306393)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081985020306393)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'fr'
,p_message_text=>'Editeur de code'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081843649306393)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'fr'
,p_message_text=>'Agrandir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081702957306393)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083055431306394)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Si vous modifiez le style de th\00E8me, vos modifications non enregistr\00E9es seront r\00E9initialis\00E9es. Cette op\00E9ration ne peut pas \00EAtre annul\00E9e. Voulez-vous continuer ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110348246306415)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier le th\00E8me')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081510762306393)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'fr'
,p_message_text=>'Style'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081319662306393)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080797324306392)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'fr'
,p_message_text=>'Confirmer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110074312306414)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'fr'
,p_message_text=>'Copier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081154381306392)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081221755306392)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'fr'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109927546306414)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr(' Vous avez apport\00E9 des modifications \00E0 un th\00E8me en lecture seule. Si vous l''utilisez comme th\00E8me en cours, vos modifications seront effac\00E9es. Voulez-vous continuer ? ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081412432306393)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de style'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080823721306392)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110138770306414)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102081066450306392)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106638497306412)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'fr'
,p_message_text=>'Collez la ligne de code suivante dans la console JS pour charger la configuration en cours dans Theme Roller :'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106752010306412)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Theme Roller doit \00EAtre ouvert et le style en cours doit \00EAtre valide pour g\00E9n\00E9rer la configuration.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994737370306327)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Rapport de contraste :'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088115327306398)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'fr'
,p_message_text=>'Echec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090525644306399)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour le texte sup\00E9rieur \00E0 18 pt ou en gras sup\00E9rieur \00E0 14 pt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088295432306398)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les validations sont r\00E9alis\00E9es conform\00E9ment aux R\00E8gles pour l''accessibilit\00E9 des contenus Web (WCAG) 2.0 en mati\00E8re de contraste des couleurs pour les polices de taille normale')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102088045263306397)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102087997477306397)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Informations sur le contraste des couleurs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109894709306414)
,p_name=>'UTR.CURRENT'
,p_message_language=>'fr'
,p_message_text=>'En cours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082838368306394)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'fr'
,p_message_text=>unistr('Feuille de style CSS personnalis\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082948440306394)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce code sera inclus \00E0 la fin de la feuille de style')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091772457306400)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce code CSS masque la bo\00EEte de dialogue Theme Roller. Il ne sera pas appliqu\00E9 \00E0 la page.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672531525306073)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672863529306074)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'fr'
,p_message_text=>unistr('Glissez-d\00E9placez des fichiers ou cliquez pour en s\00E9lectionner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673041529306074)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'fr'
,p_message_text=>'Activer la compilation LESS'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080998789306392)
,p_name=>'UTR.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083407685306394)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le style de th\00E8me.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091488595306400)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du chargement des URL de fichier CSS.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083226761306394)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le code LESS pour ce style de th\00E8me n''est pas valide.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083645619306394)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de charger le style de th\00E8me. Assurez-vous que la fen\00EAtre d''App Builder est toujours ouverte et que votre session est valide.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110235543306415)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''utiliser le th\00E8me s\00E9lectionn\00E9 comme th\00E8me en cours de l''application.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083159108306394)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce style de th\00E8me ne prend pas en charge la personnalisation Theme Roller')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083365237306394)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce th\00E8me ne comprend aucun style de th\00E8me. Pour pouvoir utiliser Theme Roller, s\00E9lectionnez un th\00E8me avec des styles de th\00E8me.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102083584044306394)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le style de th\00E8me.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983752096306318)
,p_name=>'UTR.FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090616344306399)
,p_name=>'UTR.HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090719633306400)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'fr'
,p_message_text=>unistr('Theme Roller permet de personnaliser facilement l''interface utilisateur de votre application en vous permettant de s\00E9lectionner des couleurs et de d\00E9finir des styles pour diff\00E9rents composants d''application. Quel que soit le nombre de styles de th\00E8me')
||unistr(' d\00E9finis pour une application, seul le style de th\00E8me en cours est utilis\00E9 pour l''affichage de l''application pour les utilisateurs finals.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102090841983306400)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les attributs peuvent facilement \00EAtre restaur\00E9s \00E0 la suite de modifications, soit en cliquant sur le bouton R\00E9initialiser pour le style de th\00E8me complet, soit en cliquant sur l''ic\00F4ne de r\00E9initialisation pour le groupe. '),
'',
unistr('Pour les attributs qui autorisent la s\00E9lection de couleurs de premier plan et de fond, la case pr\00E9c\00E9dant la s\00E9lection des deux couleurs sp\00E9cifie les informations sur le contraste des couleurs bas\00E9es sur les R\00E8gles pour l''accessibilit\00E9 des contenus We')
||unistr('b (WCAG) 2.0. Un score de contraste plus \00E9lev\00E9 indique que la combinaison de couleurs est plus accessible.')))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101867691412306220)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Editeur incorpor\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392334246305857)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'fr'
,p_message_text=>'Accentuation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102418099306409)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne d''actions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105900519306411)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'fr'
,p_message_text=>'Actif'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106505754306412)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'fr'
,p_message_text=>'Etat actif'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104448787306410)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'fr'
,p_message_text=>'Fond'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101392440116305857)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'fr'
,p_message_text=>'Badge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102340922306408)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102275935306408)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'fr'
,p_message_text=>'Accentuation de corps'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106837230306412)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'fr'
,p_message_text=>'Largeur maximale du contenu du corps'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103076885306409)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'fr'
,p_message_text=>'Rayon de bordure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101114129306408)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'fr'
,p_message_text=>'Boutons'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104696788306410)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'fr'
,p_message_text=>'Couleur 1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105474772306411)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'fr'
,p_message_text=>'Couleur 10'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102073967101306387)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'fr'
,p_message_text=>'Couleur 11'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074047407306387)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'fr'
,p_message_text=>'Couleur 12'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074148666306387)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'fr'
,p_message_text=>'Couleur 13'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074219185306387)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'fr'
,p_message_text=>'Couleur 14'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102074343760306387)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'fr'
,p_message_text=>'Couleur 15'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104741712306410)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'fr'
,p_message_text=>'Couleur 2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105555111306411)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'fr'
,p_message_text=>'Couleur 3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104822087306410)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'fr'
,p_message_text=>'Couleur 4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104961503306411)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'fr'
,p_message_text=>'Couleur 5'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105001355306411)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'fr'
,p_message_text=>'Couleur 6'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105181429306411)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'fr'
,p_message_text=>'Couleur 7'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105225227306411)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'fr'
,p_message_text=>'Couleur 8'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105357961306411)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'fr'
,p_message_text=>'Couleur 9'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101226353306408)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'fr'
,p_message_text=>'Conteneurs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105684755306411)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'fr'
,p_message_text=>'Rayon de bordure de conteneur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103495928306409)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'fr'
,p_message_text=>'Danger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103892292306410)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102724536306409)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'fr'
,p_message_text=>unistr('Contour de s\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104275982306410)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'fr'
,p_message_text=>'Premier plan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111093612306415)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'fr'
,p_message_text=>'Panneaux'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100960532306407)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'fr'
,p_message_text=>'Couleurs globales'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104592461306410)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102142584306408)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Accentuation d''en-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394876872305858)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Hauteur de l''en-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103277706306409)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'fr'
,p_message_text=>'Actif'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106265394306412)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'fr'
,p_message_text=>'Pointage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106390862306412)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'fr'
,p_message_text=>'Etat de pointage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105881489306411)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103983958306410)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'fr'
,p_message_text=>'Info'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102010326306408)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'fr'
,p_message_text=>'Etats interactifs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111191596306415)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102111241597306415)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101378561306408)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9sentation')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102912950306409)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne de gauche'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102641086306409)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'fr'
,p_message_text=>'Couleur de lien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104199705306410)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102097192062306404)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'fr'
,p_message_text=>'Menus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101438901607305891)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat de pointage de l''\00E9l\00E9ment de menu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101490241306408)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Navigation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102105761529306411)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'fr'
,p_message_text=>'Arborescence de navigation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103162284306409)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'fr'
,p_message_text=>'Normal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106025141306411)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'fr'
,p_message_text=>'Inactif'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101763438306408)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'fr'
,p_message_text=>'Palette'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103384392306409)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'fr'
,p_message_text=>'Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268295046305764)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'fr'
,p_message_text=>'Accentuation principale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101045759306408)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gions')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102823899306409)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086083908306396)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'fr'
,p_message_text=>'Etats et grilles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003243737306333)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Arri\00E8re-plan du corps')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003193783306333)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de corps')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003979902306334)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode d''affichage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004191637306334)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'fr'
,p_message_text=>'Compact'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004023196306334)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Standard (par d\00E9faut)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987618324306321)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9sentation')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991230483306324)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'fr'
,p_message_text=>'Contenu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991038165306324)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Bordure \00E0 bordure (par d\00E9faut)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101991182798306324)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'fr'
,p_message_text=>'Flottant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987566336306321)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'fr'
,p_message_text=>'Mode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990824471306324)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonc\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990959916306324)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('Corps fonc\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004372668306334)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonc\00E9 (par d\00E9faut)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101990755233306324)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'fr'
,p_message_text=>'Clair'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004401001306334)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Clair (par d\00E9faut)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101987476060306321)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'fr'
,p_message_text=>'Pilier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002970648306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'fr'
,p_message_text=>'Beige'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002547738306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'fr'
,p_message_text=>'Lilas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001965691306332)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Neutre (par d\00E9faut)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002413896306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'fr'
,p_message_text=>unistr('Oc\00E9an')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002041060306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'fr'
,p_message_text=>'Galet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002287410306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'fr'
,p_message_text=>'Pin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002889381306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'fr'
,p_message_text=>'Prune'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002612420306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'fr'
,p_message_text=>'Rose'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002747469306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'fr'
,p_message_text=>'Terre de Sienne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002122224306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'fr'
,p_message_text=>'Ardoise'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102002370538306333)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'fr'
,p_message_text=>'Bleu-vert'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003084945306333)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'fr'
,p_message_text=>'Apparence'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001816873306332)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'fr'
,p_message_text=>'Options Redwood'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101183647616305683)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'fr'
,p_message_text=>'Echelle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101268315805305764)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'fr'
,p_message_text=>'Accentuation secondaire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106190055306411)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102106457400306412)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat s\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103791955306410)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'fr'
,p_message_text=>'Simple'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101574505306408)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'fr'
,p_message_text=>'Etats'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103618841306410)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102104324578306410)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102102521206306409)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de titre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102103569584306409)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101983857715306318)
,p_name=>'UTR.LOADING'
,p_message_language=>'fr'
,p_message_text=>'Chargement...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100986215865305534)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte de remplacement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635923132306040)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'fr'
,p_message_text=>'Personnalisation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635800376306039)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Vous pouvez modifier le balisage du logo dans Application Builder'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673525992306074)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de charger les donn\00E9es de logo. Assurez-vous que la fen\00EAtre d''App Builder est toujours ouverte et que votre session est valide.')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635718531306039)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675782103306076)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune image charg\00E9e.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635610120306039)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Image et texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673152253306074)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez un fichier de taille inf\00E9rieure \00E0 %0 Ko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635563797306039)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'fr'
,p_message_text=>'Aucun'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673269036306074)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('Seuls les fichiers d''image sont autoris\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672484609306073)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer le logo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673304188306074)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le logo n''a pas pu \00EAtre enregistr\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101673424264306074)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le logo a \00E9t\00E9 enregistr\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635464439306039)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635200307306039)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635198471306039)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Glissez-d\00E9placez des fichiers ou cliquez pour en s\00E9lectionner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101865966051306218)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'fr'
,p_message_text=>'Modifier le logo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672949113306074)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('Seuls les fichiers JSON sont autoris\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098784611306405)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'fr'
,p_message_text=>'Adjacent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098556461306405)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'fr'
,p_message_text=>'RGB de base'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110857497306415)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'fr'
,p_message_text=>'Double'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098692571306405)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'fr'
,p_message_text=>'Monochromatique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099149194306406)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9paration')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098993123306406)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9trade')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098818104306406)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'fr'
,p_message_text=>'Triade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102099083386306406)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Avec compl\00E9ment')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394254755305858)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous n''avez pas enregistr\00E9 les modifications apport\00E9es au logo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101394324517305858)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous n''avez pas enregistr\00E9 les modifications apport\00E9es au th\00E8me.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101900317306408)
,p_name=>'UTR.REDO'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9tablir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082662003306393)
,p_name=>'UTR.RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082773098306394)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Voulez-vous r\00E9initialiser la feuille de style CSS ? Toutes les modifications seront perdues. Cette op\00E9ration ne peut pas \00EAtre annul\00E9e.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110468744306415)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser le style')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082373319306393)
,p_name=>'UTR.SAVE'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082434592306393)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettez \00E0 jour le nom afin de renommer le style de th\00E8me en cours.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082570925306393)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de th\00E8me mis \00E0 jour.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082090998306393)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer sous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082167111306393)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez un nom pour le nouveau style de th\00E8me.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102082262385306393)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de th\00E8me cr\00E9\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102098498867306405)
,p_name=>'UTR.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101866027619306218)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un th\00E8me')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102109779264306414)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir comme actif')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110581946306415)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir en tant que style de th\00E8me en cours')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110638873306415)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le th\00E8me s\00E9lectionn\00E9 est d\00E9sormais le th\00E8me en cours de l''application.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110723614306415)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez apport\00E9 des modifications \00E0 un th\00E8me en lecture seule. Si vous d\00E9finissez ce th\00E8me comme th\00E8me "en cours" de l''application, vos modifications seront effac\00E9es. Voulez-vous continuer ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635008912306039)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'fr'
,p_message_text=>'Logo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101634963933306039)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de th\00E8me')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080664607306392)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'fr'
,p_message_text=>'Theme Roller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091341244306400)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'fr'
,p_message_text=>'Afficher tout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102091255716306400)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher les \00E9l\00E9ments communs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107523571306413)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'fr'
,p_message_text=>'Cercle chromatique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101834608306408)
,p_name=>'UTR.UNDO'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672616870306073)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger vers le serveur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101672729645306074)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'fr'
,p_message_text=>'Charger le fichier de configuration'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082542617305608)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1812 Erreur inattendue lors de la conversion d''alias d''application (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102071584808306385)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Validation : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863747037305438)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'fr'
,p_message_text=>'Voir tous les groupes de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863871472305438)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'fr'
,p_message_text=>'Voir tous les types de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101011308690305552)
,p_name=>'VIEWS2'
,p_message_language=>'fr'
,p_message_text=>'Vues'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611776371306022)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'fr'
,p_message_text=>unistr('Visualiser le d\00E9bogage')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100886711240305455)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'fr'
,p_message_text=>unistr('Voir les d\00E9tails')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455999139305904)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'fr'
,p_message_text=>'Vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881794605305451)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'fr'
,p_message_text=>'Vue pour impression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640211989306043)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'fr'
,p_message_text=>'Visualiser l''historique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102030658266306354)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'fr'
,p_message_text=>'Vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101069941078305599)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'fr'
,p_message_text=>'(vue)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061335877306377)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''historique de verrouillage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992193737306325)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette requ\00EAte SQL permet de g\00E9n\00E9rer les fichiers XML affich\00E9s lorsque l''utilisateur clique sur le bouton <strong>Visualiser les \00E9l\00E9ments XML</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864364776305438)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Pages de vue de ce type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101635308574306039)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'fr'
,p_message_text=>'Visualiser l''historique des modifications de la page "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976548950305527)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Visualiser l''activit\00E9 pour : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384136569305850)
,p_name=>'VPD'
,p_message_language=>'fr'
,p_message_text=>unistr('Base de donn\00E9es priv\00E9e virtuelle (VPD)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396128720305859)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'fr'
,p_message_text=>'Installation de l''application...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077365058306389)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'fr'
,p_message_text=>'Suppression de l''application...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077542583306390)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9verrouillage de l''application...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102077403903306389)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise \00E0 jour de l''application...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396285091305859)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'fr'
,p_message_text=>'Traitement de la demande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396326026305859)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'fr'
,p_message_text=>'Installation des objets de prise en charge :'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505774558305940)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'fr'
,p_message_text=>'Aucune classe correspondante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101505606238305940)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'fr'
,p_message_text=>'Plusieurs correspondances'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851049151305428)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852084513305429)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('A ajouter \00E0 partir du catalogue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851860824305429)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'fr'
,p_message_text=>'Enlever le service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101317713623305802)
,p_name=>'WEBSHEET'
,p_message_language=>'fr'
,p_message_text=>'Feuille Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348351395305824)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ces jointes de feuille Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057791295306375)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'fr'
,p_message_text=>'AnyCo IT Department'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057667190306375)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'fr'
,p_message_text=>unistr('AnyCo IT Department met en \00E9vidence l''utilisation des fonctionnalit\00E9s et fonctions des fiches Web pour le partage du contenu Web et la g\00E9n\00E9ration d''\00E9tats concernant les donn\00E9es critiques. Cette application de feuille Web \00E9chantillon contient plusieur')
||unistr('s grilles de donn\00E9es et indique comment inclure les donn\00E9es dans les \00E9tats et graphiques imbriqu\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003450020306334)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'fr'
,p_message_text=>'Big Cats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003733276306334)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'fr'
,p_message_text=>unistr('Big Cats met en \00E9vidence de nombreuses fonctionnalit\00E9s et fonctions des fiches Web, y compris l''int\00E9gration d''images et de liens de page imbriqu\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917869637305479)
,p_name=>'WEBSHEETS'
,p_message_language=>'fr'
,p_message_text=>'Feuilles Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694260658306089)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'fr'
,p_message_text=>unistr('Une application Web est constitu\00E9e de pages Web associant du texte et des donn\00E9es. Extr\00EAmement dynamiques, ces applications sont d\00E9finies par leurs utilisateurs. Elles comprennent des contr\00F4les de navigation, des fonctions de recherche et offrent la ')
||unistr('possibilit\00E9 d''ajouter des annotations, telles que des fichiers, des remarques et des balises. Elles peuvent \00EAtre s\00E9curis\00E9es \00E0 l''aide de listes de contr\00F4le d''acc\00E8s et de diff\00E9rents mod\00E8les d''authentification int\00E9gr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694334431306089)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'fr'
,p_message_text=>unistr('Les applications Web permettent \00E0 un groupe de contributeurs de cr\00E9er rapidement des pages d''informations, ainsi que des \00E9tats et des graphiques, \00E0 l''aide d''un simple navigateur Web. Les utilisateurs peuvent aussi facilement g\00E9rer le texte et les don')
||unistr('n\00E9es locales (grilles de donn\00E9es), ainsi que visualiser les donn\00E9es \00E0 partir de requ\00EAtes SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694453450306089)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'fr'
,p_message_text=>unistr('Les applications de feuille Web pr\00E9sentent des fonctions semblables \00E0 celles des wikis. Elles sont toutefois optimis\00E9es pour l''affichage et l''int\00E9gration des donn\00E9es. Vous pouvez ainsi d\00E9finir une grille de donn\00E9es pour le stockage d''informations tab')
||unistr('ulaires, d\00E9finir un \00E9tat en fonction de tables existantes ou simplement utiliser une balise SQL pour afficher les donn\00E9es de base de donn\00E9es dans une page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694591382306090)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'fr'
,p_message_text=>unistr('Les grilles de donn\00E9es sont des composants de feuille Web semblables \00E0 des feuilles de calcul, qui permettent de g\00E9rer les informations tabulaires en toute simplicit\00E9. Cependant, la diff\00E9rence majeure est que les donn\00E9es de feuille Web ne sont pas st')
||unistr('ock\00E9es localement dans des fichiers, mais de mani\00E8re centralis\00E9e dans la base de donn\00E9es Oracle. Gr\00E2ce \00E0 ces grilles de donn\00E9es, vous pouvez ajouter des annotations, y compris des fichiers, des remarques, des balises et des liens, \00E0 chaque ligne de d')
||unistr('onn\00E9es. En outre, vous pouvez effectuer des recherches dans toutes les donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694960012306090)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les balises SQL permettent aux utilisateurs d''imbriquer tr\00E8s simplement des \00E9tats dans une page au moyen d''instructions SQL \00E9crites dans les tables de base de donn\00E9es. A l''aide de ces balises SQL, ils peuvent extraire des donn\00E9es directement \00E0 partir')
||unistr(' de leurs tables favorites, en toute simplicit\00E9. Par exemple, pour visualiser l''ensemble des bugs ouverts \00E9chus, utilisez la balise suivante : '),
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('Cette requ\00EAte est ex\00E9cut\00E9e \00E0 chaque nouvelle consultation de la page, afin de renvoyer des donn\00E9es dynamiques plut\00F4t qu''un clich\00E9 \00E0 un moment donn\00E9.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694647770306090)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les applications de feuille Web simplifient le partage de contenu et fournissent des \00E9tats de base informels. La structure et le contenu d''une application Web sont enti\00E8rement contr\00F4l\00E9s par les utilisateurs (contributeurs et administrateurs). A l''inv')
||unistr('erse, les applications de base de donn\00E9es sont g\00E9n\00E9ralement utilis\00E9es pour la maintenance de donn\00E9es et la cr\00E9ation d''\00E9tats plus formels, sophistiqu\00E9s et sp\00E9cialis\00E9s. Par ailleurs, la structure d''une application de base de donn\00E9es est contr\00F4l\00E9e par l')
||unistr('es d\00E9veloppeurs, tandis que le contenu est souvent g\00E9r\00E9 par les utilisateurs finals.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693763349306089)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'fr'
,p_message_text=>'Qu''est-ce qu''une feuille Web ?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693941575306089)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'fr'
,p_message_text=>unistr('Pourquoi cr\00E9er une application Web ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694001346306089)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'fr'
,p_message_text=>unistr('En quoi une application Web diff\00E8re-t-elle d''un WIKI ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101694100808306089)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'fr'
,p_message_text=>'Les applications de feuille Web sont-elles des feuilles de calcul en ligne ?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695000748306090)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'fr'
,p_message_text=>'Qu''est-ce qu''une balise SQL ?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693847255306089)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'fr'
,p_message_text=>unistr('En quoi une application Web diff\00E8re-t-elle d''une application de base de donn\00E9es ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100976656304305527)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Composant non install\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079484747306391)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le d''acc\00E8s de feuille Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102058413792306375)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902440357305467)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'Applications Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101645873259306047)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'L''application %0 n''est pas disponible actuellement.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349456221305825)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pi\00E8ces jointes de feuille Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640390025306043)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re mise \00E0 jour du contenu effectu\00E9e le %0 par %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640455849306043)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Page cr\00E9\00E9e le %0 par %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003804842306334)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes sur le point d''installer une application Web \00E9chantillon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102072356514306385)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Feuille Web : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101632752545306037)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re mise \00E0 jour de la page effectu\00E9e le %0 par %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101348294369305824)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es non BLOB de feuille Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043459869306364)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'fr'
,p_message_text=>'Les objets de feuille Web ne sont pas valides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393075613305857)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Application Web %0 install\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657358204306055)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les objets suivants peuvent \00EAtre interrog\00E9s \00E0 l''aide de la balise SQL ou sont disponibles dans les \00E9tats. Des guillemets permettent d''identifier les noms d''objet qui font la distinction entre les majuscules et les minuscules.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101346757508305823)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'fr'
,p_message_text=>'Vues de page de feuille Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377665380305846)
,p_name=>'WEB_SERVICE'
,p_message_language=>'fr'
,p_message_text=>'Service Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072197668305601)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultat de service Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837526913305418)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'fr'
,p_message_text=>'Oracle REST pour Oracle Cloud Applications (SaaS)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837368454305418)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'fr'
,p_message_text=>'HTTP simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837610209305418)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'fr'
,p_message_text=>'Oracle Cloud Infrastructure (OCI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837440626305418)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'fr'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897626524305463)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cutez cet assistant Inscription pour demander un espace de travail Oracle APEX.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389104750305854)
,p_name=>'WHITE_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte blanc'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930228524305490)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'fr'
,p_message_text=>'Dans le jour qui vient'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101997187462306329)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'fr'
,p_message_text=>'Dans les %0 prochains jours'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349219793305825)
,p_name=>'WITH_ADMIN'
,p_message_language=>'fr'
,p_message_text=>'avec option d''administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101072518643305601)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'fr'
,p_message_text=>'avec raccourcis'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454914039305904)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro de page existe d\00E9j\00E0 dans cette application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101454315897305903)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro de page est r\00E9serv\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105650500305625)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer ce qui est coch\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982660002305531)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'fr'
,p_message_text=>'Mis en commentaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100840175238305420)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877915642306231)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853582771305430)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er des cartes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681077298306080)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un \00E9tat classique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646212896306047)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une recherche \00E0 facets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681541853306080)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un panneau et une vue de liste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681958261306080)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un panneau sur une proc\00E9dure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681884926306080)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un panneau sur une requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681709976306080)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056070610306373)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un panneau sur un service Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860427883305435)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'fr'
,p_message_text=>'Facet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680913702306080)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une grille interactive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101680808907306079)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un \00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851755670305429)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une page de carte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681136363306080)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er ma\00EEtre-d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681349353306080)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un \00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681406537306080)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un \00E9tat avec un panneau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859363096305435)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er des filtres intelligents')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100860544061305435)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681639102306080)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un panneau tabulaire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101681250729306080)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un \00E9tat sur le service Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025609088305565)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cet assistant n\00E9cessite une application reposant sur le th\00E8me universel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839627290305420)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'fr'
,p_message_text=>'Traiter le panneau %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100839507877305420)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'fr'
,p_message_text=>'Initialiser le panneau %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436469615305889)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436381322305889)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'fr'
,p_message_text=>'Table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450119893305900)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 - Enregistrer les donn\00E9es de grille interactive')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442910455305894)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'fr'
,p_message_text=>'Etat classique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442824778305894)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'fr'
,p_message_text=>'Grille interactive'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442768948305894)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'fr'
,p_message_text=>'Etat interactif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443197747305894)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101443039442305894)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'fr'
,p_message_text=>'Etat sur le service Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101046164440305580)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Le champ #LABEL# doit contenir une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366811722305838)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Une erreur de validation est survenue.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366743991305838)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'La valeur #COLUMN_HEADER# doit comporter une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101400205258305862)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation des pages de l''assistant a r\00E9ussi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107078913306412)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'Progression d''assistant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385597283305852)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La page Etat par assistant a \00E9t\00E9 cr\00E9\00E9e.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074289679305602)
,p_name=>'WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>'espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101374166290305843)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436650190305889)
,p_name=>'WORKSPACES'
,p_message_language=>'fr'
,p_message_text=>'Espaces de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345522762305822)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'fr'
,p_message_text=>'Applications d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345831886305822)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif des activit\00E9s d''application d''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988378372306322)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre en cours d''espaces de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344894315305822)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'fr'
,p_message_text=>'ID d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101656936136306055)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'fr'
,p_message_text=>'Images d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101437108476305890)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'fr'
,p_message_text=>'Espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101255569683305754)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'fr'
,p_message_text=>'Espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914523662305476)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Espace de travail : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100883612575305452)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Connexion \00E0 l''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101582264891306000)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Message d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101344670209305821)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de l''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101493510491305932)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'fr'
,p_message_text=>'ID de remplacement d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101377036300305845)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'fr'
,p_message_text=>'Demande d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345406516305822)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'fr'
,p_message_text=>unistr('Sch\00E9mas d''espace de travail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100933621049305494)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous recevrez un courriel pour activer votre espace de travail une fois que la demande aura \00E9t\00E9 approuv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436891477305889)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'fr'
,p_message_text=>'Utilisateurs d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349346944305825)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'fr'
,p_message_text=>'Feuilles Web d''espace de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101345153788305822)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9capitulatif de l''espace de travail %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321143393305804)
,p_name=>'WORK_INITIATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Travail initi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101321281267305804)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'fr'
,p_message_text=>'Travail en cours'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329283267305810)
,p_name=>'WRITING'
,p_message_language=>'fr'
,p_message_text=>'Ecriture'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992522579306325)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'fr'
,p_message_text=>unistr('Capacit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101992449717306325)
,p_name=>'WS.READER'
,p_message_language=>'fr'
,p_message_text=>'Lecteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101384981316305851)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9f\00E9rence de service Web a \00E9t\00E9 ajout\00E9e \00E0 l''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874094938305445)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'fr'
,p_message_text=>unistr('Contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618094695306026)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056297357306374)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Espace insuffisant pour ajouter le fichier. Demandez de l''espace de stockage suppl\00E9mentaire sur la page d''administration, en acc\00E9dant \00E0 G\00E9rer un service et en cliquant sur Demander de l''espace de stockage suppl\00E9mentaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641442723306043)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676381311306076)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter nouvel \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641592635306044)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une remarque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640968130306043)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641334850306043)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter des balises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685547682306083)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873855085305445)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'fr'
,p_message_text=>'Administration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617663493306026)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer l''alias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100866317115305440)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''alias doit \00EAtre alphanum\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877529220305448)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('L''alias est trop long. La limite est de 255 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682574365306081)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Toutes les lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676492844306076)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'fr'
,p_message_text=>'Annotations'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873960659305445)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691039772306087)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type d''affichage s\00E9lectionn\00E9 ne peut pas utiliser la liste de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693479292306089)
,p_name=>'WS_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677865254306077)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Modifier le type de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693667153306089)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 \00E0 modifier la requ\00EAte d''\00E9tat. Si vous avez ajout\00E9 des colonnes \00E0 la requ\00EAte, elles n''appara\00EEtront pas lors de l''ex\00E9cution de l''\00E9tat. Vous devrez utiliser le menu Actions et choisir les colonnes ou cliquer sur <strong>R\00E9initialiser</')
||unistr('strong>. Si vous avez enlev\00E9 des colonnes de la requ\00EAte, cela d\00E9sactivera les filtres, r\00E8gles de mise en \00E9vidence et autres param\00E8tres d''\00E9tat existants de ces colonnes. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871479346305444)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un fichier')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678383679306078)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'fr'
,p_message_text=>'Alignement de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641276919306043)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'fr'
,p_message_text=>'Groupes de colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052862906306371)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne existe d\00E9j\00E0. Saisissez un nom diff\00E9rent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641197200306043)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679335302306078)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'fr'
,p_message_text=>'Confirmer l''action de suppression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690888813306087)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Le libell\00E9 de colonne doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692194378306088)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour modifier la valeur, vous devez s\00E9lectionner la colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692307696306088)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour remplacer la valeur, vous devez s\00E9lectionner la colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691475775306087)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690706432306087)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour modifier la colonne, vous devez la s\00E9lectionner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691532603306087)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour modifier des colonnes, vous devez les s\00E9lectionner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677345722306077)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste d''\00E9l\00E9ments s\00E9par\00E9s par des virgules')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679030327306078)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'fr'
,p_message_text=>unistr('Entrez la liste des \00E9l\00E9ments, en les s\00E9parant par des virgules.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690443477306086)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'fr'
,p_message_text=>'Confirmez la suppression.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102066279018306381)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'fr'
,p_message_text=>'Panneau de configuration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989330125306322)
,p_name=>'WS_COPY'
,p_message_language=>'fr'
,p_message_text=>'Copier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603967958306016)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle page comme copie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627013132306033)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une feuille Web avec les attributs suivants. Confirmez vos s\00E9lections.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603329989306016)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une section de graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101382352758305849)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603423054306016)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une section de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677546677306077)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'fr'
,p_message_text=>'Date du jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603646786306016)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une section de navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603805882306016)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100907515280305471)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une section PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603267759306016)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une section')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603518525306016)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er une section de texte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677636376306077)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur en cours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873657922305445)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'fr'
,p_message_text=>'Tableau de bord'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850951843305428)
,p_name=>'WS_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101363473786305835)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de colonnes disponibles pour le type de colonne a \00E9t\00E9 atteint.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102053028408306371)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Noms de colonne en double d\00E9tect\00E9s. Les noms de colonne doivent \00EAtre uniques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102018466697306345)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de grille de donn\00E9es existe d\00E9j\00E0. Saisissez un nom diff\00E9rent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677781044306077)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Texte par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677415743306077)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079940682306391)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir les colonnes de grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679138490306078)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Supprimer des colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101613052111306023)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer la grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683559796306081)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Supprimer des lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679250080306078)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez les colonnes \00E0 enlever d\00E9finitivement en m\00EAme temps que les donn\00E9es :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896594077305462)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'fr'
,p_message_text=>unistr('La premi\00E8re colonne doit \00EAtre la cl\00E9 primaire de la grille de donn\00E9es \00E0 afficher le lien permettant de modifier ou d''ajouter une ligne. Ajoutez la substitution "APXWS_DATA_GRID_PK" en tant que premi\00E8re colonne de l''instruction SELECT pour inclure la ')
||unistr('cl\00E9 primaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100889896418305457)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte doit r\00E9f\00E9rencer la grille de donn\00E9es une seule fois en vue d''afficher le lien permettant de modifier ou d''ajouter une ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896616997305462)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte contient plusieurs instructions SELECT. Ajoutez la substitution "APXWS_DATA_GRID_PK" en tant que premi\00E8re colonne de l''instruction SELECT \00E0 afficher le lien permettant de modifier ou d''ajouter une ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101695115311306090)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'fr'
,p_message_text=>'Syntaxe de balise SQLVALUE :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101442217213305894)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'fr'
,p_message_text=>'Syntaxe de balise SQL :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676961897306077)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'fr'
,p_message_text=>'Afficher en tant que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676822263306077)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'fr'
,p_message_text=>'Document'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617561695306026)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de choisir la m\00EAme colonne pour la cl\00E9 primaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676154752306076)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier une pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989427805306323)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Modifier des attributs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872723071305445)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'fr'
,p_message_text=>'Modifier un fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872305464305444)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'fr'
,p_message_text=>'Modifier la remarque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101603779594306016)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Modifier une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989508367306323)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier une requ\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610991048306021)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'fr'
,p_message_text=>'Modifier une section'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101674348023306075)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'fr'
,p_message_text=>'Modifier les sections'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872809985305445)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'fr'
,p_message_text=>'Modifier la balise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936652871305497)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'fr'
,p_message_text=>'Modifier les balises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912806268305475)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Envoyer la page par courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679791960306079)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'fr'
,p_message_text=>'Lignes vides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611591400306022)
,p_name=>'WS_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101689142519306086)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Message d''erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692824958306088)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Le message d''erreur doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643316458306045)
,p_name=>'WS_FILE'
,p_message_language=>'fr'
,p_message_text=>'Fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619112989306027)
,p_name=>'WS_FILES'
,p_message_language=>'fr'
,p_message_text=>'Fichiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102101622625306408)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Le fichier doit comporter une valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683134587306081)
,p_name=>'WS_FILL'
,p_message_language=>'fr'
,p_message_text=>'Remplir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683261621306081)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'fr'
,p_message_text=>unistr('Remplir les valeurs des colonnes NULL situ\00E9es en dessous avec la valeur colonne de la cellule situ\00E9e au-dessus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682953344306081)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598090787306012)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gr\00E2ce aux applications de feuille Web, les utilisateurs finals peuvent g\00E9rer les donn\00E9es structur\00E9es et non structur\00E9es, sans l''aide d''un d\00E9veloppeur. Ils peuvent ainsi effectuer les op\00E9rations suivantes :'),
'<ul>',
unistr('<li>Cr\00E9er et partager du contenu sur Internet \00E0 l''aide d''un simple navigateur Web.</li>'),
unistr('<li>Organiser des pages Web selon une hi\00E9rarchie et cr\00E9er des liens entre elles.</li>'),
unistr('<li>Cr\00E9er et g\00E9rer des donn\00E9es tabulaires \00E0 l''aide de la fonctionnalit\00E9 imbriqu\00E9e appel\00E9e Grilles de donn\00E9es.</li>'),
unistr('<li>Cr\00E9er des \00E9tats interactifs via SQL sur des structures de donn\00E9es existantes dans la base de donn\00E9es.</li>'),
unistr('<li>Pr\00E9senter les grilles de donn\00E9es et les donn\00E9es d''\00E9tat dans des pages sous forme de graphiques ou d''\00E9tats.</li>'),
unistr('<li>Annoter les pages avec des fichiers, des balises et des remarques. Les images associ\00E9es peuvent \00EAtre incluses dans la page.</li>'),
unistr('<li>Effectuer une recherche dans une page (\00E0 l''aide de la fonction de recherche int\00E9gr\00E9e).</li>'),
unistr('<li>D\00E9terminer les utilisateurs autoris\00E9s \00E0 se connecter et ceux qui peuvent lire, \00E9crire ou administrer l''application (authentification et autorisation).</li>'),
'</ul>',
'<p>Pour plus d''informations, cliquez sur Aide.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677996391306077)
,p_name=>'WS_GROUP'
,p_message_language=>'fr'
,p_message_text=>'Groupe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683919342306082)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de groupe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691871835306087)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer le nom du groupe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678292541306078)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Alignement d''en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678696880306078)
,p_name=>'WS_HEIGHT'
,p_message_language=>'fr'
,p_message_text=>'Hauteur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692098659306088)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'fr'
,p_message_text=>'Colonne non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690657326306087)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de colonne non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648832482306049)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom ou alias de grille de donn\00E9es non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619397140306027)
,p_name=>'WS_LINKS'
,p_message_language=>'fr'
,p_message_text=>'Liens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684633038306082)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de lien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617888520306026)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un lien vers cette page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683437134306081)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'fr'
,p_message_text=>'Ordre de chargement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691221855306087)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce nom de liste de valeurs existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677254883306077)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finition de liste de valeurs (LOV)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691311787306087)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('La d\00E9finition de la liste de valeurs (LOV) doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678818082306078)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'fr'
,p_message_text=>'Les listes de valeurs permettent de limiter les valeurs de colonne qu''un utilisateur peut saisir.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678997135306078)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvez associer la liste de valeurs d\00E9finie \00E0 une colonne lors de la modification des propri\00E9t\00E9s de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690982618306087)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs doit \00EAtre d\00E9finie pour le type d''affichage s\00E9lectionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691126012306087)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de liste de valeurs (LOV) doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677182263306077)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618921017306027)
,p_name=>'WS_MAP'
,p_message_language=>'fr'
,p_message_text=>'Carte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678583162306078)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'fr'
,p_message_text=>'Largeur maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450573100305900)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('La largeur maximale ne peut pas \00EAtre sup\00E9rieure \00E0 4 000.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676220054306076)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101641050928306043)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer les colonnes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003677620306334)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'fr'
,p_message_text=>'%0 ne respecte pas le format de date %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691939796306088)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez sp\00E9cifier le nom de la nouvelle grille de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617475234306026)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer un nom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679513702306078)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle valeur de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873486090305445)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683720688306082)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouveau nom de grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683834870306082)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'fr'
,p_message_text=>'Nouveau groupe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101677001983306077)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678772915306078)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle liste de valeurs bas\00E9es sur les valeurs en cours')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873229111305445)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873548330305445)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvel \00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873197756305445)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle section'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685768566306083)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693285615306089)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578759368305997)
,p_name=>'WS_NOTE'
,p_message_language=>'fr'
,p_message_text=>'Remarque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619258738306027)
,p_name=>'WS_NOTES'
,p_message_language=>'fr'
,p_message_text=>'Remarques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578800290305997)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'La remarque doit comporter une valeur. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873084928305445)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne n''a \00E9t\00E9 trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872682030305444)
,p_name=>'WS_NO_FILES'
,p_message_language=>'fr'
,p_message_text=>'Aucun fichier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871503981305444)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun fichier s\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872401050305444)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'fr'
,p_message_text=>'Aucune remarque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872966664305445)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'fr'
,p_message_text=>'Aucune balise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676773743306076)
,p_name=>'WS_NUMBER'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693170450306089)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Ancienne valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683364038306081)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'fr'
,p_message_text=>'Trier par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643512925306045)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'fr'
,p_message_text=>'Alias de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912670880305475)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Page cr\00E9\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643641837306045)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873320458305445)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9pertoire de pages')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100873743575305445)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'fr'
,p_message_text=>'Historique de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041719895306363)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste hi\00E9rarchique des pages avec les pages enfant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989075197306322)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690352457306086)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657262531306055)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte des objets d''application internes n''est pas autoris\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678139720306077)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'fr'
,p_message_text=>'Lecture seule'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692973579306088)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'fr'
,p_message_text=>unistr('Les modifications r\00E9centes sont r\00E9pertori\00E9es ci-dessous :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989289348306322)
,p_name=>'WS_REPLACE'
,p_message_language=>'fr'
,p_message_text=>'Remplacer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683094796306081)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'fr'
,p_message_text=>'Remplacer par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693041525306088)
,p_name=>'WS_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101683681898306081)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'fr'
,p_message_text=>'Lignes avec colonnes vides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001244358306332)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ligne %0 cr\00E9\00E9e le %1 par %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001110788306332)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cl\00E9 de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102001319177306332)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re mise \00E0 jour du contenu effectu\00E9e le %0 par %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692238126306088)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour d\00E9finir la valeur de colonne, vous devez s\00E9lectionner une ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619031430306027)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'fr'
,p_message_text=>'Tri des lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101690588324306087)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour supprimer une ligne, vous devez la s\00E9lectionner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627195673306033)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Un \00E9chantillon de page d''accueil sera cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101640854905306043)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer et ajouter un autre \00E9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042717626306364)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'fr'
,p_message_text=>unistr('Rechercher l''\00E9tat %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101643422947306045)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'fr'
,p_message_text=>'Contenu de section'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100912507715305475)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Section cr\00E9\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101627223674306033)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre de section'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679689954306079)
,p_name=>'WS_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101682752371306081)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes s\00E9lectionn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678051780306077)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un groupe de colonnes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101599611582306013)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionnez le nom d''\00E9tat pour visualiser les colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691772073306087)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101691668095306087)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101679452533306078)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir les valeurs de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102049713799306369)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'fr'
,p_message_text=>unistr('<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Politique de confidentialit\00E9 d''Oracle</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042298153306363)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'fr'
,p_message_text=>'En cliquant sur le bouton Suivant ci-dessous, vous comprenez et acceptez que l''utilisation du site Web d''Oracle est soumise aux <a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Conditions d''utilisation d''Oracle.com</a>. Vous t'
||unistr('rouverez davantage d''informations concernant la collecte et l''utilisation par Oracle de vos informations personnelles, y compris concernant leur acc\00E8s, leur conservation, leur rectification, leur suppression, leur s\00E9curit\00E9, les transferts transfronta')
||unistr('liers et d''autres sujets, dans la <a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Charte de confidentialit\00E9 d''Oracle.</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676696316306076)
,p_name=>'WS_STRING'
,p_message_language=>'fr'
,p_message_text=>unistr('Cha\00EEne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692422670306088)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer la cha\00EEne \00E0 rechercher.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101619469491306027)
,p_name=>'WS_TAGS'
,p_message_language=>'fr'
,p_message_text=>'Balises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101989145492306322)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher/Masquer les cases \00E0 cocher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101685895723306083)
,p_name=>'WS_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684092683306082)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes non affect\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676564846306076)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'fr'
,p_message_text=>'Identificateur unique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101684871556306082)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'fr'
,p_message_text=>'Cible d''URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692560239306088)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('La cible d''URL doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693343877306089)
,p_name=>'WS_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102048022678306368)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur trop long'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102003512868306334)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101578644349305997)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'(Valeur obligatoire)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688976006306085)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression de validation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692633544306088)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de validation doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686789589306084)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne sp\00E9cifi\00E9e ne correspond PAS au litt\00E9ral de cha\00EEne de l''expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101692771132306088)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence de validation doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686387284306084)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne sp\00E9cifi\00E9e contient au moins un des caract\00E8res de l''expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688055994306085)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne indiqu\00E9e est alphanum\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687432106306084)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne sp\00E9cifi\00E9e est contenue dans l''expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687564743306084)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne indiqu\00E9e est diff\00E9rente de z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687277495306084)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne sp\00E9cifi\00E9e n''est PAS contenue dans l''expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687920247306085)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne indiqu\00E9e est NON NULL ou \00E9gale \00E0 z\00E9ro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687619414306085)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne indiqu\00E9e ne contient aucun espace')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688165458306085)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne indiqu\00E9e est num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101688502408306085)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne indiqu\00E9e est une date valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101687037687306084)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne sp\00E9cifi\00E9e correspond au litt\00E9ral de cha\00EEne de l''expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686949709306084)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne sp\00E9cifi\00E9e ne contient aucun des caract\00E8res de l''expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686250109306084)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne indiqu\00E9e est NON NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101686541065306084)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne sp\00E9cifi\00E9e ne contient que des caract\00E8res de l''expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101693552165306089)
,p_name=>'WS_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102041670398306363)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Visualiser la grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675816929306076)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'fr'
,p_message_text=>'Visualiser les fichiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101676082347306076)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'fr'
,p_message_text=>'Visualiser les remarques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101675946246306076)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'fr'
,p_message_text=>'Visualiser les balises'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101617786102306026)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cet alias existe d\00E9j\00E0. Entrez-en un autre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101988937786306322)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s de feuille Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101598185949306012)
,p_name=>'WS_WELCOME'
,p_message_language=>'fr'
,p_message_text=>'Bienvenue dans les feuilles Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101678443508306078)
,p_name=>'WS_WIDTH'
,p_message_language=>'fr'
,p_message_text=>'Largeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618228029306027)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'fr'
,p_message_text=>'Sans les fichiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618698566306027)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'fr'
,p_message_text=>'Sans les liens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618805296306027)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'fr'
,p_message_text=>'Sans l''emplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618458264306027)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'fr'
,p_message_text=>'Sans les remarques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618154275306026)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'fr'
,p_message_text=>'Avec les fichiers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618579490306027)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'fr'
,p_message_text=>'Avec les liens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618747845306027)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'fr'
,p_message_text=>'Avec l''emplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101618340514306027)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'fr'
,p_message_text=>'Avec les remarques'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369942060305840)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>La requ\00EAte doit comporter au moins une colonne de date ou d''horodatage ; v\00E9rifiez votre requ\00EAte. (%0) </p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105231719305625)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('La cl\00E9 doit \00EAtre de 8, 16 ou 24 octets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874465693305446)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'L''application %0 n''existe pas dans cet espace de travail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874629290305446)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec du chargement de la table %0. Erreurs consign\00E9es dans la table %1. Cette table doit \00EAtre supprim\00E9e avant la r\00E9ex\00E9cution.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874317628305446)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'fr'
,p_message_text=>unistr('aucun fichier g\00E9n\00E9r\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874254339305446)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('lignes export\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874723945305446)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La table d''erreurs %0 existe d\00E9j\00E0. Cette table doit \00EAtre supprim\00E9e avant la r\00E9ex\00E9cution.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100874559198305446)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Toutes les colonnes incluses sont des types de donn\00E9es non pris en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851656630305429)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma %0 doit disposer des privil\00E8ges READ et WRITE sur le r\00E9pertoire DATA_PUMP_DIR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100855983211305432)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'fr'
,p_message_text=>'Le fichier de banque d''objets choisi est trop volumineux.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843099157305422)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Une erreur interne est survenue lors du traitement de la demande DBMS_CLOUD.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100843173735305422)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''informations d''identification non valide pour une r\00E9f\00E9rence de banque d''objets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851532100305429)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma %0 doit disposer des privil\00E8ges d''acc\00E8s au r\00E9pertoire DATA_PUMP_DIR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854555025305431)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'fr'
,p_message_text=>unistr('Le package DBMS_CLOUD n''est pas disponible sur ce syst\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851430603305429)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma %0 doit disposer du privil\00E8ge EXECUTE sur le package DBMS_CLOUD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086900395305612)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('erreur d''analyse : le corps de fonction ne doit pas \00EAtre Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087083441305612)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'fr'
,p_message_text=>'erreur d''analyse : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079504075305606)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('application=%0 espace de travail en cours=%1 espace de travail demand\00E9=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101079026784305606)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1014 Application introuvable. Espace de travail non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081161978305607)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'fr'
,p_message_text=>'application=%0 page=%1 demande=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075192397305603)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1082 Erreur lors de l''ex\00E9cution du code du mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075921321305603)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1007 Le point de branchement ne peut pas \00EAtre Null : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076081337305604)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1008 Erreur lors de l''ex\00E9cution du branchement sur la page %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836435452305417)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-7746 : Impossible de traiter un branchement \00E0 partir d''une page de bo\00EEte de dialogue vers une page ayant un mode diff\00E9rent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084378867305610)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''extraction du mod\00E8le de bouton dont l''ID est %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074742004305603)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'fr'
,p_message_text=>'<p>Cliquez <a href="%0">ici</a> pour vous connecter</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075496499305603)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1030 Erreur lors de l''ex\00E9cution de l''expression de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075547212305603)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1004 Impossible de calculer la fonction. computation_point=%0 computation_type=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075349065305603)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1003 Erreur lors de l''ex\00E9cution d''une requ\00EAte de calcul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075240291305603)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1001 Erreur inattendue lors de la cr\00E9ation de l''\00E9l\00E9ment : FSP_PROCESS_STATE_%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074984721305603)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1001 Erreur inattendue dans make_deeplinking_item, session=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076578953305604)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de groupe de s\00E9curit\00E9 du propri\00E9taire d''application attendu dans le cookie p_company ou wwv_flow_company.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080886720305607)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-7621 Impossible de d\00E9terminer l''espace de travail pour l''application (%0) \00E0 l''acceptation de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080928749305607)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de groupe de s\00E9curit\00E9 du propri\00E9taire d''application attendu dans le cookie p_company ou wwv_flow_company.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076396063305604)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1011 Type d''\00E9valuation non valide : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084204885305610)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur d''application dans fetch_value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075078252305603)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1902 L''ID d''\00E9l\00E9ment est Null dans la routine find_item_name.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075855531305603)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1021 Impossible d''ex\00E9cuter la validation "corps de fonction renvoyant une valeur bool\00E9enne"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075718678305603)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1024 Impossible d''ex\00E9cuter la validation "corps de fonction renvoyant du texte".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076464103305604)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1812 Erreur inattendue lors de l''affectation de G_FLOW_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081031837305607)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-9988 Les informations fournies pour cette demande sont insuffisantes. Vous n''avez probablement pas attendu le chargement complet de la page pr\00E9c\00E9dente. Cliquez sur les boutons Pr\00E9c\00E9dent et Recharger (ou Actualiser) de votre navigateur, ou retourn')
||unistr('ez \00E0 la page d''accueil de vos applications pour poursuivre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076938103305604)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1555 Non connect\00E9 au serveur de connexion Oracle. Aucun utilisateur public n''est identifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080583847305607)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9connexion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074620379305603)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'fr'
,p_message_text=>unistr('Non connect\00E9. Le cookie requis pour l''authentification est absent ou non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081564224305608)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1777 : La page %0 n''indique aucune page sur laquelle doit s''effectuer le branchement. Signalez cette erreur \00E0 votre administrateur d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080634439305607)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1013 Absence de privil\00E8ge pour l''op\00E9ration tent\00E9e par l''utilisateur %0. Le r\00F4le %1 est requis, contactez votre administrateur d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906449522305470)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('La page peut \00EAtre demand\00E9e avec des arguments si un checksum est transmis \00E0 la proc\00E9dure d''affichage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906631018305470)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('La page ne peut \00EAtre acc\00E9d\00E9e \00E0 partir d''une autre page qu''au moyen d''un branchement de type "Branchement sur une page".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906500032305470)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'fr'
,p_message_text=>unistr('La page ne peut \00EAtre acc\00E9d\00E9e que sans arguments.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906826583305470)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('Des arguments ont \00E9t\00E9 transmis \00E0 une page qui n''accepte pas d''arguments (demande, suppression de cache, valeurs d''\00E9l\00E9ment).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906302966305470)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'fr'
,p_message_text=>'La page n''a pas de protection.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080402031305607)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le r\00F4le requis n''est pas activ\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081602209305608)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('<a href="f?p=%0">Red\00E9marrer l''application</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101074872433305603)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1001 Erreur inattendue dans la routine de sauvegarde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101076255683305604)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1910 Erreur lors de l''\00E9valuation de l''expression SQL dans le texte d''en-t\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107468781305626)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de vous acheminer vers la page d''accueil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101080787816305607)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1512 Impossible de r\00E9soudre l''alias de page (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084524361305610)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de d\00E9finir  timed_statistics : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084400574305610)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Trace impossible : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101078368942305605)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1444 Mod\00E8le d''authentification non pris en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101075611653305603)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1006 Erreur dans la routine de validation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087139469305612)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Obsol\00E8te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115331608305632)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la suppression du r\00F4le de d\00E9veloppeur. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115285314305632)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''extraire les informations utilisateur. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315317173305800)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : L''utilisateur %0 ne dispose pas de privil\00E8ges de d\00E9veloppeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982495711305531)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('COMPATIBLE (vous devriez pouvoir ex\00E9cuter cet import sans probl\00E8mes)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860673686306214)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Avertissement relatif aux informations d''identification "%0" (ID statique) :',
'',
'- Les fichiers d''export Application Express ne contiennent pas d''informations d''identification.',
unistr('- Utilisez la proc\00E9dure APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL pour d\00E9finir les'),
unistr('- informations d''identification apr\00E8s l''import de l''application. Les informations d''identification sont'),
unistr('- r\00E9f\00E9renc\00E9es avec leur ID statique "%0"')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977981528305528)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Votre version en cours :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450414848305900)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de supprimer l''application %0, elle est install\00E9e dans un autre espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982059237305531)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du nom de mod\00E8le d''authentification %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980641266305530)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID de branchement %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981894867305531)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID de bug "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979120875305529)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du nom d''option de construction %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979233093305529)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la d\00E9finition de l''ID d''option de construction "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980501714305530)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du nom de bouton "%0", ID "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335940110305815)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du nom de sous-action de l''action dynamique "%0", ID "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335839145305815)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de la page d''action dynamique "%0", nom "%1", ID "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101020080304305560)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur page=%0 \00E9l\00E9ment="%1" id="%2" : le nom est le m\00EAme que celui d''un \00E9l\00E9ment existant au niveau application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979714381305529)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''\00E9l\00E9ment de calcul d''application %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979667633305529)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID d''\00E9l\00E9ment d''application %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936997894305497)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID d''attribut de module d''extension "%0"	')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101349822637305825)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID de valeur d''attribut de module d''extension "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936871664305497)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID du module d''extension "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100993298568305539)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID d''\00E9v\00E9nement de module d''extension "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979488448305529)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID de processus d''application = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024654305306350)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''option de mod\00E8le d''application id="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102024571887306350)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du groupe d''options de mod\00E8le d''application id="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981672497305531)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Panneau ajout\00E9 \00E0 la page existante %0 .')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956681294305512)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''importer les attributs d''installation d''objets de base de donn\00E9es ayant l''ID "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956789243305512)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du script d''installation ayant l''ID "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981351650305530)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''\00E9tat non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981182968305530)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du mapping de traduction d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100878957897305449)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID de colonne de liste de valeurs "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980166106305529)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID de liste de valeurs (LOV) %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979358906305529)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID d''\00E9l\00E9ment de barre de navigation %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980881293305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de la page de calcul de page %0, \00E9l\00E9ment %1, ID "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980294435305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du nom de page "%0", ID "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101390093671305855)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du groupe de pages')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981533676305531)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'fr'
,p_message_text=>unistr('La page %0 comporte d\00E9j\00E0 des boutons.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980331895305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du texte d''aide %0 de la page :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980722590305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur page %0, \00E9l\00E9ment "%1", ID "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980472459305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la mise \00E0 jour du nom de page "%0", ID "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981299682305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er une page sur la table "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981007313305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de la page de traitement de page %0, nom %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980933599305530)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de la page de validation de page %0, nom %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100980064837305529)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID d''onglet parent %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979513946305529)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la d\00E9finition de l''ID de SQL de traitement "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981404330305530)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La page d''\00E9tat %0 existe, une r\00E9gion d''\00E9tat a \00E9t\00E9 ajout\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981728150305531)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'fr'
,p_message_text=>unistr('La page %0 n''a pas \00E9t\00E9 cr\00E9\00E9e car elle existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100981998312305531)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID de raccourci "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979844205305529)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation de l''ID d''onglet standard %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979962448305529)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du changement de nom de l''onglet, de %1 en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100979069861305529)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du nom de mod\00E8le %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100977835754305528)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re extension de l''API :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982380153305531)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'fr'
,p_message_text=>'Ce fichier d''export n''est pas compatible avec la version d''Application Express dans laquelle vous essayez d''importer le fichier.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978896280305529)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'fr'
,p_message_text=>unistr('La proc\00E9dure %0 a \00E9t\00E9 appel\00E9e sans valeur pour p_id -- un ID d''application doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838123535305419)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''application "%0" ne se trouve pas dans la plage autoris\00E9e (%1 - %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101449925504305900)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''utiliser l''ID d''application "%0", la plage (%1 - %2) est r\00E9serv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982282560305531)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''application %0 est r\00E9serv\00E9 \00E0 Oracle Corporation ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100838238760305419)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''application "%0"est r\00E9serv\00E9 \00E0 un autre espace de travail et ne peut pas \00EAtre utilis\00E9 ici')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978973254305529)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application %0 n''a pas \00E9t\00E9 supprim\00E9e. L''import ne va pas \00EAtre tent\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978011726305528)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Cet import est incompatible avec la version :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408402616305868)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''importer le script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978541898305528)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Combinaison nom utilisateur, mot de passe et espace de travail non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978111088305528)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'fr'
,p_message_text=>'Votre import d''application n''indique pas de version d''export.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860525765306214)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune valeur n''a \00E9t\00E9 fournie pour le serveur distant avec l''ID statique "%0". Utilisez APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER avant d''installer l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408359315305868)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'fr'
,p_message_text=>'nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982503559305531)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'fr'
,p_message_text=>'NON COMPATIBLE (il se peut que votre export contienne des appels non pris en charge par votre version de %0.)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860965143306214)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Avertissement relatif au serveur distant "%0" (ID statique).',
'',
unistr('- Les attributs de ce serveur distant ont \00E9t\00E9 d\00E9finis avec APEX_APPLICATION_INSTALL.'),
unistr('- D''autres applications utilisent \00E9galement cet objet de serveur distant.'),
'',
unistr('Par cons\00E9quent, les attributs de serveur distant d''espace de travail ont \00E9t\00E9 mis \00E0 jour.'),
'- URL de base :      %1',
unistr('- H\00F4te HTTPS :    %2'),
'- Fuseau horaire ORDS : %3'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860865701306214)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Avertissement relatif au serveur distant "%0" (ID statique).',
'',
unistr('- L''attribut PROMPT_ON_INSTALL est d\00E9fini sur YES.'),
unistr('- Aucun attribut n''a \00E9t\00E9 fourni avec APEX_APPLICATION_INSTALL.'),
'',
unistr('Par cons\00E9quent, les param\00E8tres de serveur distant d''espace de travail demeurent inchang\00E9s.'),
'- URL de base :      %1',
unistr('- H\00F4te HTTPS :    %2'),
'- Fuseau horaire ORDS : %3',
'',
'Utilisez APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER pour modifier les attributs.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101860798878306214)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Avertissement relatif au serveur distant "%0" (ID statique).',
'',
unistr('- L''attribut PROMPT_ON_INSTALL est d\00E9fini sur NO.'),
unistr('- Les param\00E8tres issus du fichier d''import de l''application sont diff\00E9rents des attributs existants.'),
unistr('- Ce serveur distant est \00E9galement utilis\00E9 par d''autres applications dans cet espace de travail.'),
'',
unistr('Par cons\00E9quent, les param\00E8tres de serveur distant d''espace de travail demeurent inchang\00E9s.'),
'- URL de base :      %1',
unistr('- H\00F4te HTTPS :    %2'),
'- Fuseau horaire ORDS : %3',
'',
'Utilisez APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER pour modifier les attributs.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408210750305868)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'fr'
,p_message_text=>'remplacer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646401702306047)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas importer les informations en retour dans le m\00EAme syst\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101408576596305868)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'fr'
,p_message_text=>unistr('La taille du script, %0 octets, est sup\00E9rieure au maximum autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100982115301305531)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'fr'
,p_message_text=>unistr('La variable de package g_security_group_id doit \00EAtre d\00E9finie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978756088305528)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('La variable de package g_security_group_id doit \00EAtre d\00E9finie pour l''import d''une application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978322773305528)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''a pas \00E9t\00E9 possible d''\00E9tablir la derni\00E8re version d''API de votre moteur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978233724305528)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''a pas \00E9t\00E9 possible d''\00E9tablir la version de votre moteur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100978482332305528)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous allez devoir effectuer une mise \00E0 niveau pour pouvoir importer cet export d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101646349710306047)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Les informations en retour n''ont pas \00E9t\00E9 export\00E9es pour ce syst\00E8me de d\00E9ploiement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850726434305428)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Les automatisations qui r\00E9f\00E9rencent des sources de donn\00E9es REST ne peuvent pas \00EAtre copi\00E9es \00E0 partir d''une autre application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849153310305427)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Nouvelle action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027205822305566)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le corps de fonction PL/SQL renvoyant une requ\00EAte SQL est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027185957305566)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Une requ\00EAte SQL est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027385849305566)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Le service SQL compatible REST est obligatoire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027056142305566)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Le nom de table est obligatoire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027473737305566)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('La source de donn\00E9es REST est obligatoire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101027585904305566)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'La clause WHERE ou ORDER BY est obligatoire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082663979305608)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>'Application :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098924964305620)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune application n''est s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082938013305609)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'fr'
,p_message_text=>unistr('<span class="tiny">Aucune page n''a \00E9t\00E9 trouv\00E9e.</font>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082757463305609)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083053449305609)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'fr'
,p_message_text=>'%0 <font size=-2>Pages</span>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269264209305765)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'fr'
,p_message_text=>'nombre de pages :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101269340726305765)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'fr'
,p_message_text=>'liste de pages'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082860010305609)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'fr'
,p_message_text=>'%0 %1 PL/SQL contient %2 lignes de code source.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517998359305949)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ex\00E9cution du code n''est pas prise en charge pour le SQL distant.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101517213513305949)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>'Query Builder n''est pas pris en charge pour le SQL distant.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115490588305632)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur d''analyse d''\00E9tat modifiable : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102050397032306369)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de r\00E9acheminer une page de bo\00EEte de dialogue vers une page normale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087367396305612)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('obsol\00E8te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087231496305612)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'fr'
,p_message_text=>'Purge de %0 sessions en double.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055663029305587)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez modifier que votre propre mot de passe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055864796305587)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur inattendue lors du traitement de votre demande de modification de mot de passe : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055362314305587)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe et la confirmation du mot de passe sont obligatoires.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101055470203305587)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'fr'
,p_message_text=>'Mots de passe non identiques, ressayez.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056441356305587)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'fr'
,p_message_text=>'Erreur Oracle : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101056141734305587)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'fr'
,p_message_text=>'ERR-1025 Erreur lors du traitement de l''expression PL/SQL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947001657305505)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro d''attribut de membre indiqu\00E9, %0, n''est pas valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087735418305612)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'fr'
,p_message_text=>'Condition existe/n''existe pas non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087537399305612)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'fr'
,p_message_text=>'Condition de corps de fonction non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087479521305612)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'fr'
,p_message_text=>'Condition d''expression PL/SQL non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087639410305612)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'fr'
,p_message_text=>'Condition d''expression SQL non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101826581305622)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur au cours de l''ex\00E9cution de wwv_flow_copy : %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836865301305418)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de l''application traduite n''est pas valide. Il est utilis\00E9 par une application existante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101720616305622)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de groupe de s\00E9curit\00E9 (identit\00E9 de votre espace de travail) n''est pas d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101389427171305854)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mode de compatibilit\00E9 de l''application "%0" doit correspondre \00E0 21.2 au minimum pour une r\00E9g\00E9n\00E9ration de th\00E8me. Le mode de compatibilit\00E9 peut \00EAtre modifi\00E9 \00E0 partir de la d\00E9finition de l''application, sous Propri\00E9t\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102086142579306396)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le th\00E8me en cours n''est pas compatible avec le th\00E8me ma\00EEtre s\00E9lectionn\00E9, les identificateurs de th\00E8me ne correspondent pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101514836998305947)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de r\00E9g\00E9n\00E9rer le mod\00E8le, mod\00E8le parent introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955098454305511)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible de publier le mod\00E8le d''authentification. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954464247305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible de publier le mod\00E8le de bouton. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108611978305627)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible de publier le mod\00E8le de calendrier. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954205911305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de publier le mod\00E8le de champ. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955111278305511)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible de publier l''aide sur un \00E9l\00E9ment. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954060869305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de publier le mod\00E8le de liste. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954994041305511)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossible de publier la liste de valeurs. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954504691305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible de publier le mod\00E8le de chemin de navigation. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954840959305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de publier la barre de navigation. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953805067305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de publier le mod\00E8le de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954379165305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de publier le mod\00E8le de liste de valeurs (LOV) instantan\00E9e. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953935132305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de publier le mod\00E8le de r\00E9gion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954141830305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de publier le mod\00E8le d''\00E9tat. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954642015305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de publier le mod\00E8le de s\00E9curit\00E9. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100954795665305510)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Impossible de publier le raccourci %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952204676305509)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de mod\00E8le d''authentification. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951113281305508)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de mod\00E8le de bouton. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101108565631305627)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible de s''abonner au mod\00E8le de calendrier. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950479031305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de champ. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952383562305509)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de l''aide sur un \00E9l\00E9ment. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950233898305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de liste. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950862492305508)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de liste de valeurs (LOV). %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100951014586305508)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de mod\00E8le de chemin de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950701567305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de barre de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950001445305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950991403305508)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de mod\00E8le de liste de valeurs (LOV) instantan\00E9e. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950173052305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de r\00E9gion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950318126305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence d''\00E9tat. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950595467305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de mod\00E8le de s\00E9curit\00E9. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100950659184305507)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enlever l''ID de r\00E9f\00E9rence de raccourci. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953658920305510)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le d''authentification. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953137148305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de bouton. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045926035306366)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de calendrier. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952841190305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de champ. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953756435305510)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner \00E0 l''aide sur un \00E9l\00E9ment. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952696874305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de liste. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953551831305510)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner \00E0 la liste de valeurs (LOV). %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953019798305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de chemin de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953440114305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner \00E0 la barre de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952446897305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952902688305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de liste de valeurs (LOV) instantan\00E9e. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952521010305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de r\00E9gion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100952731880305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le d''\00E9tat. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953276646305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner au mod\00E8le de s\00E9curit\00E9. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100953324660305509)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'fr'
,p_message_text=>'Impossible de s''abonner au raccourci. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102025075489306350)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de s''abonner aux options de th\00E8me. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115940437305632)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''ex\00E9cution de wwv_flow_copy_page : %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102094833305622)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur au cours de l''ex\00E9cution de wwv_flow_copy_page_item : %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975017071305526)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'fr'
,p_message_text=>'%0 (%1) introuvable pour copie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302318439305789)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('il existe d\00E9j\00E0 un raccourci portant le nom %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101102436430305623)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de trouver le raccourci (%0) pour copie.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103493288305623)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation des mod\00E8les d''\00E9tat) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104076688305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (calcul des cibles d''onglet) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107380031305626)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les d''authentification) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107269118305626)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les d''autorisation) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104890547305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les de bouton) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104304487305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie du mod\00E8le de champ) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104679306305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les de liste) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105053884305625)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des listes de valeurs) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104744887305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les de chemin de navigation) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104936034305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie de la barre de navigation) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104282197305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie du mod\00E8le de page) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104581146305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les de r\00E9gion) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104458221305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les d''\00E9tat) : %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105169104305625)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie du mod\00E8le de s\00E9curit\00E9) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103340778305623)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation du mod\00E8le de champ) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103617455305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (copie des mod\00E8les de liste) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103735888305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation des mod\00E8les de chemin de navigation) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103193383305623)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation de la page) : %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101104152070305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation des onglets parent) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103283111305623)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation du mod\00E8le de page) : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103874358305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation des mod\00E8les de liste de valeurs instantan\00E9e) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103541329305623)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation des mod\00E8les de r\00E9gion) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103973376305624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation d''application (cr\00E9ation des onglets standard) : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101103029706305623)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de v\00E9rification de %0 : %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302112915305789)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter des lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101302001726305789)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'fr'
,p_message_text=>'Appliquer MRD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101301904798305789)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'fr'
,p_message_text=>'Appliquer MRU'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289299483305779)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366911347305838)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de panneau. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101393452700305857)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page globale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101877826224306231)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de grille interactive. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367162115305838)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de cr\00E9ation de pages. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367061168305838)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de panneau tabulaire. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367236300305838)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'fr'
,p_message_text=>'Extraire une ligne de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410609535305870)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'fr'
,p_message_text=>'Obtenir le cookie de nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101506641255305941)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'fr'
,p_message_text=>'Menu de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101366510401305838)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'fr'
,p_message_text=>'Page de menu %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101367383529305838)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'fr'
,p_message_text=>'Traiter une ligne de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101455602290305904)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'fr'
,p_message_text=>'version %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294822761305783)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser les \00E9l\00E9ments masqu\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288385496305779)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la recherche d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101383192475305850)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('Lignes d''\00E9tat par page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379279077305847)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution du script : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101410589909305870)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir le cookie de nom utilisateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101296035152305784)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette proc\00E9dure doit \00EAtre appel\00E9e \00E0 partir d''une session d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100857767411305433)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('Les informations d''identification ne sont pas autoris\00E9es pour ce point d''extr\00E9mit\00E9 d''URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851279704305429)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'fr'
,p_message_text=>'Les URL de la liste doivent commencer par http:// ou https://'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396595308305860)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification pour %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105398073305625)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de supprimer la feuille de style CSS : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411250551305870)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''action de glisser-d\00E9placer n''est pas prise en charge pour les sources de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086817242305611)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'fr'
,p_message_text=>'Appliquer les modifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968354092305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonction de sentinelle de page renvoie au moteur le r\00E9sultat bool\00E9en de la v\00E9rification de session int\00E9gr\00E9e. Si ce r\00E9sultat est TRUE, le moteur continue \00E0 afficher ou \00E0 accepter la page. Si le r\00E9sultat est FALSE, le moteur effectue un r\00E9achemineme')
||unistr('nt vers la page ou l''URL de session non valide indiqu\00E9e dans ce mod\00E8le d''authentification (voir ci-dessous).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969602284305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'fr'
,p_message_text=>unistr('Si la fonction de sentinelle de page renvoie la valeur TRUE, l''affichage ou le traitement de la page continue. Si elle renvoie la valeur FALSE, le moteur quitte car aucune cible de session non valide n''est indiqu\00E9e dans le mod\00E8le d''authentification. ')
||unistr('Dans ce cas, on suppose que la fonction de sentinelle de page fournie par l''utilisateur a effectu\00E9 un r\00E9acheminement vers une page de connexion en dehors de l''environnement %0, \00E9ventuellement vers un portail d''authentification externe. La fonction do')
||unistr('it \00E9galement avoir d\00E9fini la variable globale g_unrecoverable_error := true pour que le moteur quitte sans afficher de page d''erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969793121305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'fr'
,p_message_text=>unistr('Le moteur va ex\00E9cuter le code suivant, que le mod\00E8le d''authentification d\00E9signe comme le traitement de pr\00E9authentification :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969826372305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution en tant que bloc anonyme ne renvoyant aucune valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969990302305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun code de pr\00E9authentification personnalis\00E9 n''est indiqu\00E9 dans ce mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970152277305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'fr'
,p_message_text=>unistr('Toute combinaison nom utilisateur/mot de passe saisie dans le panneau de connexion sera consid\00E9r\00E9e comme valide. Le nom utilisateur saisi servira de nom d''utilisateur connect\00E9 pour la dur\00E9e de la session. Cette pratique est utile lorsque les applicat')
||unistr('ions sont en cours de d\00E9veloppement et qu''aucun compte utilisateur v\00E9ritable n''est encore d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970254078305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifiez le nom utilisateur et le mot de passe saisis dans le panneau de connexion par rapport aux comptes App Builder (utilisateur de cookie). Ce sont les m\00EAmes comptes que ceux qui sont utilis\00E9s dans votre espace de travail pour la connexion \00E0 %0. ')
||unistr('Cette pratique est utile lorsque les utilisateurs de votre application sont des d\00E9veloppeurs disposant de comptes %0 dans les m\00EAmes base de donn\00E9es et espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902564462305467)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifiez le nom utilisateur et le mot de passe saisis dans le panneau de connexion par rapport aux comptes de base de donn\00E9es Oracle. Cette pratique est utile lorsque les utilisateurs de votre application ont des comptes dans la base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970399076305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rifiez le nom utilisateur et le mot de passe saisis dans le panneau de connexion \00E0 l''aide de l''annuaire LDAP indiqu\00E9 dans ce mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970495896305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'fr'
,p_message_text=>unistr('Les param\00E8tres LDAP ont la valeur suivante :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971134001305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cutez le code personnalis\00E9 suivant pour v\00E9rifier les informations d''identification :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971363984305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'fr'
,p_message_text=>unistr('Recherchez dans la table des sessions int\00E9gr\00E9e la session utilis\00E9e par la page de connexion int\00E9gr\00E9e. Si la session existe et qu''elle n''appartient pas \00E0 un autre utilisateur, marquez-la comme appartenant maintenant \00E0 l''utilisateur authentifi\00E9 (en uti')
||'lisant le nom utilisateur du panneau de connexion).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968451911305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonction de sentinelle de page renvoie au moteur le r\00E9sultat bool\00E9en de la v\00E9rification de session int\00E9gr\00E9e combin\00E9 par AND au r\00E9sultat de la v\00E9rification de session fournie par l''utilisateur. Si le r\00E9sultat est TRUE, le moteur continue \00E0 afficher')
||unistr(' ou \00E0 accepter la page. Si le r\00E9sultat est FALSE, le moteur effectue un r\00E9acheminement vers la cible de session non valide indiqu\00E9e dans ce mod\00E8le d''authentification (voir ci-dessous).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971406491305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'fr'
,p_message_text=>unistr('Affectez au cookie nomm\00E9 %0 une valeur permettant de localiser la ligne dans la table des sessions interne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971597943305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9terminez l''URL sur laquelle effectuer le r\00E9acheminement. Si un "lien profond" a \00E9t\00E9 enregistr\00E9 dans l''\00E9tat de session par le moteur d''affichage, utilisez-le comme URL de destination. Sinon, allez \00E0 l''URL indiqu\00E9e comme attribut de lien d''accueil po')
||'ur l''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971792993305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s la v\00E9rification des informations d''identification, le moteur ex\00E9cute le code suivant, qui est le traitement de postauthentification d\00E9fini pour ce mod\00E8le d''authentification :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971824636305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'fr'
,p_message_text=>unistr('Ex\00E9cution en tant que bloc anonyme ne renvoyant aucune valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971953451305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de code personnalis\00E9 de postauthentification dans ce mod\00E8le.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972082160305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'fr'
,p_message_text=>unistr('Effectuez un r\00E9acheminement vers l''URL d\00E9termin\00E9e ci-dessus. Ceci marque la fin du traitement de connexion \00E0 l''aide de la page de connexion int\00E9gr\00E9e et des API qu''elle appelle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968529626305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez du code personnalis\00E9 pour effectuer les t\00E2ches de sentinelle de page. Pour chaque demande de page, le moteur ex\00E9cute le code suivant :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968685807305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'fr'
,p_message_text=>unistr('Le r\00E9sultat bool\00E9en du bloc ci-dessus est renvoy\00E9 au moteur. Si ce r\00E9sultat est TRUE, le moteur continue \00E0 afficher ou \00E0 accepter la page. Si le r\00E9sultat est FALSE, le moteur effectue un r\00E9acheminement vers la cible de session non valide indiqu\00E9e dan')
||unistr('s ce mod\00E8le d''authentification (voir ci-dessous).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968741651305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'fr'
,p_message_text=>unistr('La m\00E9thode int\00E9gr\00E9e de v\00E9rification de session est disponible pour le d\00E9veloppeur %0 via l''appel API suivant :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968862094305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'fr'
,p_message_text=>unistr('Le r\00E9sultat de cette fonction bool\00E9enne peut \00EAtre combin\00E9 \00E0 d''autres contr\00F4les dans la fonction de sentinelle de page fournie par l''utilisateur qui est indiqu\00E9e dans le mod\00E8le d''authentification. Lorsque cette API est appel\00E9e, elle contr\00F4le le cookie')
||unistr(' nomm\00E9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968913590305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'fr'
,p_message_text=>unistr('Si le cookie existe et que sa valeur d\00E9cod\00E9e localise une ligne dans la table des sessions interne, la session est consid\00E9r\00E9e comme valide et la valeur TRUE est renvoy\00E9e \00E0 la fonction de sentinelle de page l''ayant appel\00E9e..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969144478305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'fr'
,p_message_text=>unistr('Si la fonction de sentinelle de page renvoie la valeur TRUE, l''affichage ou le traitement de la page continue. Si elle renvoie la valeur FALSE, le moteur affiche la page %0, qui est consid\00E9r\00E9e comme la page de connexion de cette application car elle ')
||unistr('est indiqu\00E9e comme page de session non valide dans le mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969541346305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonction de sentinelle de page renvoie un r\00E9sultat bool\00E9en au moteur. Si ce r\00E9sultat est TRUE, l''affichage ou le traitement de la page continue. Si le r\00E9sultat est FALSE, le moteur effectue un r\00E9acheminement vers %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972109971305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'fr'
,p_message_text=>unistr('Dans une approche classique, la page contient un panneau de connexion permettant de r\00E9cup\00E9rer les informations d''identification de l''utilisateur. Ensuite, les traitements postsoumission de la page appellent un module d''authentification pour la v\00E9rifi')
||unistr('cation de ces informations. Apr\00E8s l''authentification, la page effectue les t\00E2ches d''inscription de session et de d\00E9finition de cookie appropri\00E9es. Enfin, elle effectue un r\00E9acheminement vers la page de d\00E9marrage de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972296783305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'fr'
,p_message_text=>unistr('L''API %0 wwv_flow_custom_auth_std peut \00EAtre appel\00E9e par de tels traitements postsoumission pour effectuer les t\00E2ches qui viennent d''\00EAtre d\00E9crites. Deux points d''entr\00E9e sont disponibles :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972365831305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvez appeler la proc\00E9dure login pour que le moteur effectue toutes les t\00E2ches \00E0 votre place. Il utilisera la table des sessions int\00E9gr\00E9e et effectuera pour vous l''inscription de session et la d\00E9finition de cookie. Si vous fournissez du code pe')
||unistr('rsonnalis\00E9 dans ce mod\00E8le d''authentification, il sera ex\00E9cut\00E9 avant l''authentification, au moment de l''authentification et apr\00E8s l''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972423527305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvez appeler la proc\00E9dure post_login si vous effectuez l''authentification vous-m\00EAme mais voulez que %0 prenne en charge toutes les t\00E2ches postauthentification \00E0 votre place. Ces deux points d''entr\00E9e vous permettent d''utiliser n''importe quelle ')
||unistr('\00E9tape int\00E9gr\00E9e de traitement de connexion avec votre propre page de connexion et avec les traitements qu''elle comporte. N''oubliez pas que, si vous utilisez le traitement de postauthentification int\00E9gr\00E9, vous pouvez tirer parti de la sentinelle de pag')
||unistr('e et du traitement de v\00E9rification de session int\00E9gr\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969243195305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'fr'
,p_message_text=>unistr('la page de connexion int\00E9gr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972512892305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'fr'
,p_message_text=>'Traitement de connexion externe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973342295305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'fr'
,p_message_text=>unistr('L''URL de connexion %0 ne semble pas indiquer la page d''application %1 comme cible de session non valide. En outre, le mod\00E8le d''authentification ne comporte pas de valeurs de traitement de connexion. Cette page a en charge la r\00E9alisation des \00E9tapes su')
||'ivantes :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973450750305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'fr'
,p_message_text=>unistr('Notez que, \00E0 moins que les services appel\00E9s \00E0 cette URL n''utilisent l''API wwv_custom_auth_std %0 pour une assistance dans les t\00E2ches d''inscription de session, votre application ne pourra pas utiliser la sentinelle de page ou le traitement de v\00E9rifica')
||unistr('tion de session int\00E9gr\00E9s. Vous devrez effectuer ce travail par vos propres moyens.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973790410305525)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'fr'
,p_message_text=>unistr('L''URL de connexion %0 ne semble pas indiquer une page d''application %1 comme cible de session non valide. Cette page a en charge la r\00E9alisation des \00E9tapes suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973882737305525)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs d\00E9finies pour le traitement de la connexion dans le mod\00E8le d''authentification figurent ci-dessous :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973990037305525)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'fr'
,p_message_text=>unistr('La page de connexion indiqu\00E9e dans ce mod\00E8le est la page [%0] de cette application. Cette page a en charge la r\00E9alisation des \00E9tapes suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974049144305525)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'fr'
,p_message_text=>unistr('Toutefois, il n''y a pas de valeurs de traitement de connexion dans le mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100974196394305525)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page \00E9tant la page de connexion de l''application, il n''est pas possible d''y effectuer certaines actions lors de son premier affichage, car l''authentification de l''utilisateur n''a pas encore eu lieu. En outre, le statut de session et certaines v')
||unistr('ariables d''identification de session ne sont pas disponibles pour les calculs et traitements de la page, comme ils le seraient dans des pages ordinaires trait\00E9es apr\00E8s l''authentification. Pour toutes ces raisons, la d\00E9signation d''une page de connexio')
||unistr('n par un num\00E9ro dans un mod\00E8le d''authentification ne convient que pour les pages comportant peu de fonctionnalit\00E9s ou aucune autre fonctionnalit\00E9 que le traitement du panneau de connexion. Si vous voulez une page de connexion plus active, indiquez un')
||unistr('e URL de connexion dans l''assistant Mod\00E8le d''authentification ou dans la page de modification. Du moment que vous affectez \00E0 l''attribut de page publique la valeur Oui - Cette page est publique dans le panneau des attributs de page d''Application Build')
||unistr('er, la page de connexion peut utiliser toutes les fonctionnalit\00E9s de %0 et non servir seulement de page de connexion dans votre application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972677090305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce mod\00E8le d''authentification n''indique ni page de connexion, ni URL cible de session non valide. De ce fait, ce cas est g\00E9r\00E9 par la fonction de sentinelle de page. Il y aura peut-\00EAtre r\00E9acheminement vers un portail d''acc\00E8s avec connexion unique ou ve')
||unistr('rs un autre serveur de connexion. En outre, le mod\00E8le d''authentification ne comporte pas de valeurs de traitement de connexion. Si ce n''est pas ce qui est pr\00E9vu, modifiez le mod\00E8le d''authentification et indiquez une page ou une URL de session non val')
||unistr('ide, puis r\00E9examinez ce diagramme de flux.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972738491305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce mod\00E8le d''authentification n''indique ni page de connexion, ni URL cible de session non valide. De ce fait, ce cas est g\00E9r\00E9 par la fonction de sentinelle de page. Il y aura peut-\00EAtre r\00E9acheminement vers un portail d''acc\00E8s avec connexion unique ou ve')
||unistr('rs un autre serveur de connexion. En outre, le mod\00E8le d''authentification ne comporte pas de valeurs de traitement de connexion. Si ce n''est pas ce qui est pr\00E9vu, modifiez le mod\00E8le d''authentification et indiquez une page ou une URL de session non val')
||unistr('ide, puis r\00E9examinez ce diagramme de flux.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972818963305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'fr'
,p_message_text=>unistr('L''URL de connexion %0 semble indiquer une page d''application %1 comme cible de session non valide. N\00E9anmoins, le mod\00E8le d''authentification ne comporte pas de valeurs de traitement de connexion. Cette page a en charge l''ex\00E9cution des \00E9tapes suivantes ')
||':'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100972938731305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour que le moteur %0 puisse afficher ou accepter la page de connexion de votre application, vous devez s\00E9lectionner l''attribut de page Oui - Cette page est publique dans la page des attributs de page d''App Builder. Si vous ne le faites pas, le moteu')
||unistr('r tentera d''ex\00E9cuter la fonction de sentinelle de page avant d''afficher la page. Si vous ne vous \00EAtes pas encore connect\00E9, il y aura r\00E9acheminement vers la m\00EAme URL, et donc bouclage. Si vous codez votre propre fonction de sentinelle de page, vous de')
||unistr('vrez peut-\00EAtre pouvoir d\00E9terminer si la page en cours est cette page de connexion et la g\00E9rer diff\00E9remment des autres. Il vous sera peut-\00EAtre possible de l''identifier par un num\00E9ro. Une technique plus g\00E9n\00E9rique consiste \00E0 utiliser la fonction bool\00E9en')
||unistr('ne wwv_flow_custom_auth.current_page_is_public pour reconna\00EEtre l''attribut public de la page de connexion ou de toute autre page du flux.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973025546305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'fr'
,p_message_text=>unistr('L''URL de connexion %0 semble indiquer que la page d''application %1 est la cible de session non valide. Cette page a en charge la r\00E9alisation des \00E9tapes suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973171803305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'fr'
,p_message_text=>unistr('Les valeurs d\00E9finies pour le traitement de la connexion dans le mod\00E8le d''authentification figurent ci-dessous :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973248447305524)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'fr'
,p_message_text=>unistr('Oracle Application Server Single Sign-On effectue un r\00E9acheminement vers cette application apr\00E8s l''authentification de l''utilisateur. Le point d''entr\00E9e est la proc\00E9dure wwv_flow_custom_auth_sso.process_success du sch\00E9ma %0. %0 est inscrit en tant qu''')
||unistr('application partenaire Oracle Application Server Single Sign-On et peut g\00E9rer \00E0 votre place toutes les interfaces avec le serveur de connexion. Toutefois, si vous pr\00E9f\00E9rez inscrire votre propre application dans votre propre sch\00E9ma, c''est possible. Vo')
||unistr('us pouvez \00E9crire votre propre sentinelle de page ou simplement cr\00E9er un mod\00E8le d''authentification bas\00E9 sur le mod\00E8le Portal-SSO (application partenaire = mon application) de la galerie des mod\00E8les d''authentification. Le mod\00E8le r\00E9sultant appellera la ')
||unistr('sentinelle de page SSO int\00E9gr\00E9e sentry wwv_flow_custom_auth_std.portal_sso_sentry_v1. Pour cette fonction, le mod\00E8le d''authentification en cours doit conna\00EEtre le nom de votre application partenaire, sous lequel elle est inscrite aupr\00E8s d''Oracle Appl')
||unistr('ication Server Single Sign-On. Vous pouvez l''indiquer lorsque l''assistant Cr\00E9ation de mod\00E8le d''authentification vous le demande, ou bien vous pouvez l''ajouter ou le modifier en modifiant le mod\00E8le apr\00E8s sa cr\00E9ation. Le nom saisi doit \00EAtre strictement')
||unistr(' identique au nom inscrit, y compris en ce qui concerne la casse. Vous devrez \00E9galement \00E9crire votre propre proc\00E9dure de r\00E9cepteur URLC et y appeler l''API wwv_flow_custom_auth_sso.process_success, en lui transmettant le nom de votre application sous ')
||unistr('lequel elle est inscrite aupr\00E8s d''Oracle Application Server Single Sign-On. Ainsi, la session sera inscrite aupr\00E8s de %0 apr\00E8s l''authentification. Si vous \00E9crivez votre propre sentinelle de page, vous pouvez y appeler l''API wwv_flow_custom_auth_sso.p')
||unistr('ortal_sso_redirect pour effectuer le r\00E9acheminement vers le serveur de connexion lorsque l''authentification est requise. Vous devez transmettre \00E0 cette proc\00E9dure le nom inscrit de votre application partenaire. Pour plus de d\00E9tails, consultez la docum')
||'entation %0 et la documentation %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973685983305525)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'fr'
,p_message_text=>'Traitement de postauthentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100973525727305525)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement de pr\00E9authentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968004283305520)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez du code int\00E9gr\00E9 pour v\00E9rifier le cookie nomm\00E9 [%0]. S''il existe et que sa valeur d\00E9cod\00E9e localise une ligne dans la table des sessions interne, consid\00E9rez que la session est valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968273353305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Calculer la valeur de retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970068641305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rification des informations d''identification (authentification)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971670440305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'fr'
,p_message_text=>unistr('Traitement de postauthentification personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964769238305518)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'fr'
,p_message_text=>unistr('Argument de point d''entr\00E9e interdit pour wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964657431305518)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'fr'
,p_message_text=>'Argument p_session_id Null pour wwv_flow_custom_auth_std.login--p_flow_page:%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964528305305518)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter la fonction de v\00E9rification des informations d''identification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969069701305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'fr'
,p_message_text=>'Cible de session non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970722386305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'fr'
,p_message_text=>'Base de recherche LDAP :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970899650305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le bloc suivant sert \00E0 appeler une fonction avant l''appel de DBMS_LDAP.SIMPLE_BIND_S. Le nom utilisateur du panneau de connexion est transmis \00E0 la fonction qui envoie en retour une valeur utilis\00E9e pour remplacer %LDAP_USER% dans la base de recherche ')
||'LDAP (voir ci-dessus).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970968803305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'fr'
,p_message_text=>'Ce bloc de code doit comporter la signature suivante :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971007565305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette fonctionnalit\00E9 vous permet de transformer le nom utilisateur saisi dans le panneau de connexion afin de lui donner un format correspondant \00E0 l''entr\00E9e de l''annuaire LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970520622305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'fr'
,p_message_text=>unistr('H\00F4te LDAP :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100970633225305522)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'fr'
,p_message_text=>'Port LDAP :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967590344305520)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'fr'
,p_message_text=>'Cette application (%0) utilise la page %1 comme page de connexion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967654540305520)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque la page %0 est demand\00E9e, aucun autre contr\00F4le d''authentification n''est effectu\00E9 et la page est affich\00E9e ou accept\00E9e. Ainsi, la page de connexion peut \00EAtre affich\00E9e avant que l''authentification n''ait lieu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967460181305520)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'fr'
,p_message_text=>'Gestion de page de connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967702541305520)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Fonction de sentinelle de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967833563305520)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez du code int\00E9gr\00E9 pour effectuer les t\00E2ches de sentinelle de page. Pour chaque demande de page, la fonction de sentinelle v\00E9rifie la session et calcule une valeur de retour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100971211681305523)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'fr'
,p_message_text=>'Traitement de postauthentification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100968124151305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez du code suppl\00E9mentaire fourni par l''utilisateur pour d\00E9terminer si la session est valide. Apr\00E8s avoir obtenu le r\00E9sultat TRUE de la v\00E9rification de session int\00E9gr\00E9e ci-dessus, ex\00E9cutez le code suivant et retenez la valeur bool\00E9enne qu''il ren')
||'voie :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967912237305520)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction de v\00E9rification de session')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969375151305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100969465872305521)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'fr'
,p_message_text=>'l''URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116245306305633)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'fr'
,p_message_text=>'erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854617060305431)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le travail de chargement des donn\00E9es a d\00E9marr\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025517719305565)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les fichiers (%0) qui d\00E9passent la taille de %1 Mo ne sont pas pris en charge pour le chargement des donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101411182949305870)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'fr'
,p_message_text=>'Expression SQL non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944904689305503)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Analyser %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945383624305503)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'fr'
,p_message_text=>'Vue par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101105465819305625)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Format de date non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085090904305610)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9boguer :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085194855305610)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9 non prise en charge dans cette version')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082243398305608)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1101 Impossible de traiter un corps de fonction renvoyant une requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085323566305610)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur 4323 - La demande d''aide ne pr\00E9cise pas l''ID num\00E9rique de la page pour laquelle l''aide doit \00EAtre affich\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082036053305608)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1025 Erreur lors du traitement de l''expression PL/SQL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082132230305608)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'fr'
,p_message_text=>'Application=%0 Page=%1 SQLERRM=%2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084877369305610)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''imprimer le raccourci : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082378351305608)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1108 Impossible de traiter la condition en cours de l''\00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084955766305610)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''affichage du graphique : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101235195283305739)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''afficher le composant : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100879266446305449)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''affichage de la r\00E9gion Liste dynamique : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085294710305610)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur 4322 - La syntaxe de la demande d''aide est incorrecte. Elle est Null alors qu''un num\00E9ro de page valide est attendu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111805686305629)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Liaison impossible pour "%0". Utilisez des guillemets pour les \00E9l\00E9ments multioctets ou assurez-vous que la longueur de l''\00E9l\00E9ment est inf\00E9rieure ou \00E9gale \00E0 30 octets. Pour faire r\00E9f\00E9rence \00E0 des \00E9l\00E9ments d''une longueur sup\00E9rieure \00E0 30 octets, utilisez ')
||'la syntaxe v().'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649989338306050)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de colonne BLOB attendu dans le masque de format de la colonne d''\00E9tat : DOWNLOAD:TABLE_NAME:BLOB_COLUMN...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004513421306335)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'La colonne %0 est introuvable dans la table %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101107587293305626)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans DML : p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100941516576305500)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''effectuer l''op\00E9ration d''insertion. %0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101263022729305760)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur num\00E9rique %0 non valide pour la colonne %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948272414305506)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action %0 non valide pour l''objet. (%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649004544306049)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9taire de table non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649175653306049)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'fr'
,p_message_text=>'URL non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648940975306049)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La derni\00E8re colonne de donn\00E9es mise \00E0 jour "%0" (type de donn\00E9es "%1") utilis\00E9e pour suivre les mises \00E0 jour de "%2" doit poss\00E9der des donn\00E9es de type Date ou Horodatage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649276649306049)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur : l''appel doit \00EAtre effectu\00E9 \00E0 partir de la page de panneau qui contient le nom d''\00E9l\00E9ment de type FILE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649547294306049)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun masque de format d\00E9tect\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650098742306050)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de colonne de cl\00E9 primaire 1 attendu dans le masque de format de la colonne d''\00E9tat : DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102004642409306335)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Table ou vue %0 introuvable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649830450306049)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom de table attendu dans le masque de format de la colonne d''\00E9tat : DOWNLOAD:TABLE_NAME...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649741613306049)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>unistr('Le masque de format doit inclure au moins 4 arguments s\00E9par\00E9s par le signe deux-points')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649642303306049)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'fr'
,p_message_text=>'Le masque de format doit commencer par DOWNLOAD ou IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295175569305784)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" n''est pas valide pour la requ\00EAte SQL. Veillez \00E0 utiliser des alias uniques pour vos colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940490421305499)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette op\00E9ration n''est pas autoris\00E9e pour la source de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295053523305783)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL est incorrect. Pour plus de d\00E9tails, consultez l''aide sur l''attribut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850520535305428)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 contient un type de donn\00E9es incorrect dans l''instruction SQL. Le num\00E9ro de colonne %1 est de type %2 alors que %3 est attendu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396006390305859)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" est d\00E9j\00E0 utilis\00E9 dans la requ\00EAte SQL. Veillez \00E0 utiliser des alias uniques pour vos colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395952197305859)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" n''est pas valide pour la requ\00EAte SQL de liste de valeurs (LOV). Veillez \00E0 utiliser des alias valides pour les colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395786956305859)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''analyse a renvoy\00E9 des r\00E9sultats de requ\00EAte dans "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101395858456305859)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL est incorrect. Pour plus de d\00E9tails, consultez l''aide sur l''attribut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100850098448305428)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de source de donn\00E9es REST %0 n''est pas pris en charge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100851979827305429)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'fr'
,p_message_text=>'Nom de fichier en double : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044351176306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment d''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044175188306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'fr'
,p_message_text=>'Constante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043850565306364)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044936664306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot-cl\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044867449306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue mat\00E9rialis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044452176306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'fr'
,p_message_text=>'Package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044271116306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment de page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043719072306364)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Proc\00E9dure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044514031306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044635409306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'fr'
,p_message_text=>'Table'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102045044385306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102043937420306364)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044090774306364)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'fr'
,p_message_text=>'Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102044756358306365)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608902937306020)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de l''analyse de la requ\00EAte SQL de la liste de valeurs (LOV). %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101373755869305843)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Filtre de requ\00EAte non valide soumis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609833497306020)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" est d\00E9j\00E0 utilis\00E9 dans la requ\00EAte SQL de liste de valeurs (LOV). Assurez-vous d''utiliser des alias uniques pour les colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609712969306020)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" n''est pas valide pour la requ\00EAte SQL de liste de valeurs (LOV). Veillez \00E0 utiliser des alias valides pour les colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101608868116306020)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL de liste de valeurs (LOV) est incorrect. Reportez-vous aux exemples pour conna\00EEtre les instructions valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948078931305505)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le serveur a d\00E9tect\00E9 une erreur lors de la suppression du fichier "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948114829305505)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''enlever le fichier %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947839605305505)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur s''est produite lors de l''\00E9criture dans le r\00E9pertoire de fichier physique "%0". (%1: %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083389416305609)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('La limite de taille maximale pour les fichiers d''espace de travail non internes a \00E9t\00E9 d\00E9pass\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947975885305505)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de fichier \00E0 \00E9crire pour l''ID %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101083294522305609)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('La limite de taille maximale pour tous les fichiers d''espace de travail a \00E9t\00E9 d\00E9pass\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101116583264305633)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la suppression du r\00F4le de d\00E9veloppeur. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992547371305539)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur n''a pas \00E9t\00E9 cr\00E9\00E9 pour la raison suivante : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101657111587306055)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''est pas une adresse \00E9lectronique valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110259144305628)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de requ\00EAte pour l''\00E9l\00E9ment %0 de type liste de s\00E9lection avec r\00E9acheminement par JS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110173348305628)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment %0 de type liste de s\00E9lection ne comporte aucune requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110357486305628)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de requ\00EAte pour l''\00E9l\00E9ment %0 de type liste de s\00E9lection avec r\00E9acheminement par URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110469388305628)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas de requ\00EAte pour l''\00E9l\00E9ment %0 de type liste de s\00E9lection avec r\00E9acheminement par URL sur une page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084728795305610)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier l''\00E9l\00E9ment %0 - %1, s\00E9quence : %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081890931305608)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1904 Impossible de calculer le type par d\00E9faut de l''\00E9l\00E9ment = Corps de fonction computation_type = %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081771095305608)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1020 Erreur lors du traitement d''\00E9l\00E9ment PL/SQL (fonction)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101081972777305608)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rification orthographique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101084671315305610)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Impossible de faire correspondre la valeur "%0" au masque de format de date %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849796118305427)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les \00E9l\00E9ments de type de donn\00E9es BLOB ne sont pas pris en charge pour la source de donn\00E9es REST ou SQL compatible REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849922366305428)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''extraire les m\00E9tadonn\00E9es pour l''ID de r\00E9gion %s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101329959107305811)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune r\00E9gion de panneau n''est affect\00E9e au processus d''initialisation ou DML de panneau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335656597305815)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la migration de la page de panneau h\00E9rit\00E9 vers la r\00E9gion de panneau : impossible de d\00E9crire la table r\00E9f\00E9renc\00E9e dans le processus DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101066804108305595)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun checksum trouv\00E9 pour la d\00E9tection des mises \00E0 jour perdues. Op\00E9ration UPDATE ou DELETE possible uniquement pour les lignes existants.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101636291897306040)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter le DML de panneau sur une source REST sur laquelle la synchronisation est activ\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849693818305427)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune cl\00E9 primaire n''a \00E9t\00E9 d\00E9finie pour la r\00E9gion de panneau %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100849823050305428)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de donn\00E9es de l''\00E9l\00E9ment %0 est incorrect.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101017847588305559)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment %0 s\00E9lectionn\00E9 contient un index de domaine. La fonction de g\00E9n\00E9ration de DDL ne peut pas g\00E9n\00E9rer du DDL pour un index de domaine.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956396630305512)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Rem Impossible de g\00E9n\00E9rer le DDL pour %0 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100987037984305535)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun %0 trouv\00E9 pour la g\00E9n\00E9ration de DDL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956577060305512)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur Save_ddl %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100944171125305502)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''enregistrer le DDL en tant que fichier de script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956467314305512)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''analyse du script DDL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110503054305629)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur : le nom de package %0 n''est pas valide ou est d\00E9j\00E0 utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091666647305615)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('-- API de table pour l''application %0, %1 g\00E9n\00E9r\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090304975305614)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cr\00E9er le package PL/SQL %0 avec les proc\00E9dures suivantes :'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091252916305615)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E0 utiliser pour l''insertion de donn\00E9es dans %0, la cl\00E9 primaire doit \00EAtre indiqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091370703305615)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E0 utiliser pour mettre \00E0 jour les donn\00E9es dans %0 identifi\00E9 par la ou les cl\00E9s primaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091494566305615)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'fr'
,p_message_text=>unistr('utilis\00E9 pour supprimer des donn\00E9es dans %0 sur la base de la ou des cl\00E9s primaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091534533305615)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E0 utiliser pour extraire des donn\00E9es de %0 sur la base de la ou des cl\00E9s primaires')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091124515305615)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090968043305614)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger le corps')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090819288305614)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger une sp\00E9cification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090769707305614)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'fr'
,p_message_text=>'Masquer le corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090599491305614)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Masquer la sp\00E9cification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164394024305668)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'fr'
,p_message_text=>'-- corps de package'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164464054305669)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('-- sp\00E9cification de package')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090695076305614)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'fr'
,p_message_text=>'Afficher le corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090410526305614)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher la sp\00E9cification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101091092294305615)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'fr'
,p_message_text=>'Sous-programme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163842580305668)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('-- proc\00E9dure de cr\00E9ation de la table "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164047106305668)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('-- proc\00E9dure de suppression de la table "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164169341305668)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('-- proc\00E9dure d''obtention de la table "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101164227083305668)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('-- fonction MD5 de g\00E9n\00E9ration de la table "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101163944797305668)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'fr'
,p_message_text=>unistr('-- proc\00E9dure de mise \00E0 jour de la table "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110672541305629)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'fr'
,p_message_text=>'erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648328000306048)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''identificateur de source de l''espace de travail doit \00EAtre d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648494897306048)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le syst\00E8me de d\00E9ploiement doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988642507305536)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le composant <strong>%0</strong> ne peut pas \00EAtre affich\00E9 dans la <strong>colonne %1</strong> car un autre composant existe d\00E9j\00E0 dans cette colonne.</p>'),
unistr('<p>Ce probl\00E8me est g\00E9n\00E9ralement r\00E9solu en d\00E9finissant Colonne sur <strong>Automatique</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102092901414306401)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'fr'
,p_message_text=>unistr('<p>Le libell\00E9 d''\00E9l\00E9ment de page <strong>%0</strong> ne peut pas \00EAtre affich\00E9 car le param\00E8tre de grille ColSpan de libell\00E9 pour cet \00E9l\00E9ment de page n''est pas valide. Il est d\00E9fini pour \00EAtre affich\00E9 avec le <strong>ColSpan de libell\00E9 %1</strong>. Il n')
||unistr('''est pas pris en charge car l''\00E9l\00E9ment de page lui-m\00EAme n''a que <strong>%2 colonnes</strong> disponibles.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988413979305536)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le composant <strong>%0</strong> ne peut pas \00EAtre affich\00E9 car ses param\00E8tres de grille ne sont pas valides. Il est d\00E9fini pour \00EAtre affich\00E9 \00E0 la <strong>colonne %1</strong> avec le <strong>ColSpan %2</strong>. Ceci n''est pas pris en charge car la ')
||'grille sur cette page prend en charge <strong>%3 colonnes</strong> au maximum.</p>',
unistr('<p>Ce probl\00E8me est g\00E9n\00E9ralement r\00E9solu en d\00E9finissant Colonne et ColSpan sur <strong>Automatique</strong> pour tous les composants.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988554617305536)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le composant <strong>%0</strong> ne peut pas \00EAtre affich\00E9 car ses param\00E8tres de grille ne sont pas valides. Il est d\00E9fini pour \00EAtre affich\00E9 \00E0 la <strong>colonne %1</strong> avec le <strong>ColSpan %2</strong>. Ceci n''est pas pris en charge car la ')
||'grille sur cette page ne prend en charge que <strong>%3 colonnes</strong>.</p>',
unistr('<p>Ce probl\00E8me est g\00E9n\00E9ralement r\00E9solu en d\00E9finissant Colonne et ColSpan sur <strong>Automatique</strong> pour tous les composants.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870614993305443)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'fr'
,p_message_text=>'2 Day DBA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870599235305443)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'fr'
,p_message_text=>'2 Day + Developer''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100836998494305418)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'fr'
,p_message_text=>'Application Administration Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837094497305418)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rence API')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412874056305871)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'fr'
,p_message_text=>'Contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101406891113305867)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'fr'
,p_message_text=>'A propos de : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412937558305872)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100870493149305443)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'fr'
,p_message_text=>'App Builder User''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518809781305950)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'fr'
,p_message_text=>unistr('la cr\00E9ation d''index initiale peut prendre plusieurs secondes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837198651305418)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'fr'
,p_message_text=>'Application Migration Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101412670293305871)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'fr'
,p_message_text=>'Fichier de mapping de documentation introuvable : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101413098425305872)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'fr'
,p_message_text=>'Score'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100837291986305418)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'fr'
,p_message_text=>'SQL Workshop and Utilities Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119794068305635)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de normalisation de cr\00E9ation : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101295930369305784)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous n''avez pas acc\00E8s au sch\00E9ma que vous voulez importer. Echec de l''import.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119652481305635)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('remove_table_hint a \00E9t\00E9 appel\00E9 sans p_table_id ; une table doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025409062305565)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Un second appel create_company a \00E9t\00E9 d\00E9tect\00E9 au cours de l''installation de l''espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988242337305535)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'fr'
,p_message_text=>'Erreur GET_BLOCK. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988195377305535)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'fr'
,p_message_text=>'Erreur GET_STMT. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988399195305536)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Impossible de trouver le fichier. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854413287305431)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Archive ZIP non valide, aucun fichier manifeste d''installation trouv\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991775399305538)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne disposez d''aucun privil\00E8ge sur le sch\00E9ma %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100988091637305535)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''ex\00E9cution de l''instruction a \00E9chou\00E9. %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101028007894305566)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Appel d''API \00E0 la proc\00E9dure remove_page d\00E9tect\00E9 dans un bloc de grande taille du fichier d''export.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101289361354305779)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun libell\00E9 n''existe pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906186737305470)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Un probl\00E8me a \00E9t\00E9 d\00E9tect\00E9 dans votre environnement : impossible de mettre \00E0 jour les fichiers Application Express. Les fichiers pour la version #LOADED_VERSION# ont \00E9t\00E9 charg\00E9s, mais l''\00E9l\00E9ment %0 est attendu. V\00E9rifiez que vous avez copi\00E9 le r\00E9pertoir')
||unistr('e d''images dans le serveur d''application conform\00E9ment aux instructions du guide d''installation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100906029871305470)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Un probl\00E8me a \00E9t\00E9 d\00E9tect\00E9 dans votre environnement : impossible de charger les fichiers Application Express. V\00E9rifiez que vous avez copi\00E9 le r\00E9pertoire d''images dans le serveur d''application conform\00E9ment aux instructions du guide d''installation. De p')
||unistr('lus, v\00E9rifiez que le chemin du pr\00E9fixe d''image est correct. Le chemin actuel est %0 (il doit contenir des barres obliques de d\00E9but et de fin, tel que dans le chemin par d\00E9faut /i/). Utilisez le script SQL reset_image_prefix.sql pour le modifier (le c')
||unistr('as \00E9ch\00E9ant).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109687921305628)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Tentative non autoris\00E9e d''ex\00E9cution du travail %0 par le sch\00E9ma %1 dans l''application dont l''ID est %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120278735305636)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la collection : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119883218305635)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'fr'
,p_message_text=>'erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101119950682305635)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de recherche de type de donn\00E9es : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120127700305636)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur d''obtention du type de donn\00E9es : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120049847305636)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur1 d''obtention de la longueur maximum de colonne : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307981993305794)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ins\00E9rer une ligne contenant plus de 32 ko de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120304275305636)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur %0 n''a pas de privil\00E8ge sur le sch\00E9ma %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111349121305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de condition de branchement de page : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111248634305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de condition de bouton de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111070197305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de calcul de l''application. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110964743305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de condition WHEN du processus d''application. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111767040305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur au cours de la mise \00E0 jour des mots mal orthographi\00E9s. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110886202305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de condition d''affichage de la barre de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111432218305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de calcul de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111612615305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de processus de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111103873305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de sous-titre de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111595599305629)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le type de validation de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101658279456306055)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 : l''option El\00E9ments parent de liste de valeurs (LOV) en cascade peut \00EAtre utilis\00E9e uniquement si l''option Chargement lazy est d\00E9finie sur Oui.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649480013306049)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur : un seul processus DML peut \00EAtre d\00E9clar\00E9 par page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101649306487306049)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur : aucun processus DML correspondant n''a \00E9t\00E9 d\00E9tect\00E9 pour la page %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101650413442306050)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'fr'
,p_message_text=>'%0 doit avoir une colonne BLOB valide en tant que source.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611103190306021)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous devez indiquer un code PL/SQL \00E9mettant HTML pour l''\00E9l\00E9ment %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121218134305636)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''effectuer une collecte en masse : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120915399305636)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de v\00E9rifier si le code a \00E9t\00E9 analys\00E9 : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121029648305636)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter le fichier de contr\00F4le : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121712564305637)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de v\00E9rifier les statistiques de fichier de contr\00F4le : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121650849305637)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de supprimer les informations analys\00E9es : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121573731305637)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ex\00E9cution de l''instruction a \00E9chou\00E9 : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120431837305636)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de trouver le fichier. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120627722305636)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''obtenir l''instruction : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086766488305611)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('La longueur de ligne %0 d\00E9passe de maximum de %1 (ligne %2).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121477748305637)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : corps de package cr\00E9\00E9 avec des erreurs de compilation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121190586305636)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter le code : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121318891305636)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter l''instruction : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120755853305636)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''enregistrer le param\00E8tre dans la base de donn\00E9es : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120575522305636)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''obtenir le bloc de code : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101120858551305636)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de valider le fichier "%0". %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121837541305637)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''analyser le fichier. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504243040305939)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune fonction d''authentification n''a \00E9t\00E9 d\00E9finie pour le module d''extension %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504384085305939)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune fonction de post-d\00E9connexion n''a \00E9t\00E9 d\00E9finie pour le module d''extension %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101504155830305939)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune fonction de sentinelle de session n''a \00E9t\00E9 d\00E9finie pour le module d''extension %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057419183306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'fr'
,p_message_text=>'Action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056601410306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9fini par une action dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056314595306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers la page dans cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056518799306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9acheminer vers une URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056448809306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Soumettre une page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057029225306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'fr'
,p_message_text=>'Effacer le cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609057558306020)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte de liste de valeurs (LOV) n''est pas valide ; une valeur d''affichage et une valeur renvoy\00E9e sont requises, et les noms de colonne doivent \00EAtre diff\00E9rents. Si la requ\00EAte contient une requ\00EAte imbriqu\00E9e, la premi\00E8re clause FROM de l''instructio')
||unistr('n SQL ne doit pas appartenir \00E0 la requ\00EAte imbriqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610797468306021)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de l''analyse de la requ\00EAte de source de r\00E9gion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991819536305538)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de l''analyse de la requ\00EAte SQL. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102080357088306392)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'fr'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609170192306020)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) statique n''est pas valide ; une valeur d''affichage et une valeur renvoy\00E9e sont requises.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101544799647305968)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'fr'
,p_message_text=>'La table, la vue ou le synonyme n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991307387305538)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609439538306020)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Une requ\00EAte de liste de valeurs (LOV) ou une liste de valeurs (LOV) nomm\00E9e doit \00EAtre indiqu\00E9e pour les \00E9l\00E9ments ayant ce type d''affichage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609303573306020)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisation d''une liste de valeurs (LOV) nomm\00E9e n''est prise en charge que pour les types d''\00E9l\00E9ment exigeant au moins deux colonnes de listes de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992076471305538)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre un entier.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100991981814305538)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056741542306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'fr'
,p_message_text=>'Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917623719305478)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de donn\00E9es de la colonne est incorrect. Cet attribut exige les types de donn\00E9es suivants pour la colonne : %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100905910947305469)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne n''existe pas ou la requ\00EAte de source de r\00E9gion n''est pas valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917798524305478)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('type de donn\00E9es incorrect')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610336970306021)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Une source de r\00E9gion doit \00EAtre indiqu\00E9e pour les r\00E9gions de ce type.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610442766306021)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" est d\00E9j\00E0 utilis\00E9 dans la requ\00EAte de source de r\00E9gion. Assurez-vous d''utiliser des alias uniques pour les colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610512507306021)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" n''est pas valide pour la requ\00EAte de source de r\00E9gion. Assurez-vous d''utiliser des alias uniques pour les colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610653558306021)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de colonnes s\00E9lectionn\00E9es dans la requ\00EAte de source de r\00E9gion est incorrect. Reportez-vous aux exemples pour conna\00EEtre les instructions valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056937465306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'fr'
,p_message_text=>'Demande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102056877301306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la pagination de cette page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057136611306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir ces \00E9l\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101610011358306021)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" est d\00E9j\00E0 utilis\00E9 dans la requ\00EAte SQL. Veillez \00E0 utiliser des alias uniques pour vos colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609961443306021)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de colonne "%0" n''est pas valide pour la requ\00EAte SQL. Veillez \00E0 utiliser des alias uniques pour vos colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100992901018305539)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL est incorrect. Pour plus de d\00E9tails, consultez l''aide sur l''attribut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101609205613306020)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les listes de valeurs (LOV) statiques ne sont prises en charge que pour les types d''\00E9l\00E9ment exigeant au moins deux colonnes de listes de valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057318104306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'fr'
,p_message_text=>'Cible d''URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102057227058306374)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Avec ces valeurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101111991821305630)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1711 Impossible de convertir l''ID de liste de valeurs (LOV) instantan\00E9e de la demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112094097305630)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1721 El\00E9ment introuvable pour la liste de valeurs (LOV) instantan\00E9e de la demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100885842549305454)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le moteur d''impression n''a pas pu \00EAtre atteint : l''URL indiqu\00E9e est incorrecte ou une URL proxy doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790476414306161)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'fr'
,p_message_text=>unistr('Au-dessus de la r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790859615306162)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'fr'
,p_message_text=>unistr('Au-dessous de la r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790983704306162)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Partie inf\00E9rieure de la r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790582366306161)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'fr'
,p_message_text=>'A gauche du titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790147429306161)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Barre de recherche c\00F4t\00E9 droit de l''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790699007306161)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'fr'
,p_message_text=>'A droite du titre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790766982306161)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790202072306161)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'fr'
,p_message_text=>unistr('Partie sup\00E9rieure de la r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101790398944306161)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Parties sup\00E9rieure et inf\00E9rieure de la r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791055550306162)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('Apr\00E8s en-t\00EAte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791173290306162)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'fr'
,p_message_text=>'Avant pied'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013661315306342)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Composant introuvable. Il a peut-\00EAtre \00E9t\00E9 supprim\00E9 par un autre utilisateur. Rechargez la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013556904306342)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Suppression impossible car le composant ''%0'' r\00E9f\00E9rence ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013487408306342)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Suppression impossible car le composant ''%0'' de la page %1 r\00E9f\00E9rence ce composant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013740297306342)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''attribut a d\00E9j\00E0 \00E9t\00E9 modifi\00E9 par un autre utilisateur. Rechargez la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013968725306342)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'L''attribut n''est pas disponible dans ce contexte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102013864694306342)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Le composant a \00E9t\00E9 modifi\00E9 par un autre utilisateur et cet attribut n''existe plus. Rechargez la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508160962305942)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''analyse a renvoy\00E9 des r\00E9sultats de requ\00EAte dans "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100701831306407)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''analyse a renvoy\00E9 les r\00E9sultats de la requ\00EAte dans "%0". Si vous pensez que la syntaxe de la requ\00EAte est correcte, cochez la case Utiliser des noms de colonne g\00E9n\00E9rique ci-dessous pour poursuivre sans analyse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102052181273306370)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Doit \00EAtre unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791261504306162)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun mod\00E8le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508093020305942)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune requ\00EAte n''a \00E9t\00E9 renvoy\00E9e par un bloc PL/SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102100853003306407)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune requ\00EAte n''a \00E9t\00E9 renvoy\00E9e par le bloc PL/SQL. Si vous pensez que la syntaxe du code est correcte, cochez la case Utiliser des noms de colonne g\00E9n\00E9rique ci-dessous pour poursuivre sans analyse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791413896306162)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Page verrouill\00E9e par un autre utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101791313648306162)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('La page est actuellement verrouill\00E9e par %0. Impossible d''enregistrer les modifications.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101398369207305861)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''\00E9tendre le tablespace : les sch\00E9mas de %0 n''existent plus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112173282305630)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans drop_tablespace, p_name est Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112362690305630)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans drop_usern, absence de l_username.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102107797404306413)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'fr'
,p_message_text=>'Le portefeuille de cryptage n''est pas ouvert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100910981065305473)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'fr'
,p_message_text=>unistr('Cha\00EEne de mot de passe interdite transmise \00E0 wwv_flow_provision.create_user.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112999849305630)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans remove_provisioned_company. L''espace de travail est Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112798438305630)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le tablespace. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112659432305630)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er l''utilisateur. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112215348305630)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de supprimer le tablespace. Erreur : %0 \nsql :\n %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112481633305630)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de supprimer l''utilisateur. Erreur : %0 \nsql :\n %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112806516305630)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''accorder des privil\00E8ges initiaux. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100877185495305448)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le tablespace actuellement. R\00E9essayez ult\00E9rieurement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101112570386305630)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur avec : %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955536904305511)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le provisionnement automatique a \00E9chou\00E9 au cours de la phase MAKE_REQUEST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975187293305526)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible de d\00E9terminer l''ID de groupe de s\00E9curit\00E9 pour l''ID d''espace de travail indiqu\00E9 = "%0"'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955831843305511)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail %0 est un nom r\00E9serv\00E9, la demande est rejet\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955699342305511)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur s''est produite lors de l''ajout de l''utilisateur \00E0 l''espace de travail %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101113240912305631)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'fr'
,p_message_text=>'erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101095070762305617)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non impl\00E9ment\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955315856305511)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun espace de travail n''a \00E9t\00E9 trouv\00E9 avec l''ID %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955410843305511)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun sch\00E9ma n''est affect\00E9 \00E0 l''espace de travail dont l''ID est  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975207884305526)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas utiliser cette fonctionnalit\00E9 pour supprimer le dernier sch\00E9ma d''un espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956290304305511)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Demande %0 introuvable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956075265305511)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('La demande %0 n''a pas pu \00EAtre trait\00E9e. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955786703305511)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette demande a \00E9t\00E9 trait\00E9e ou est en cours de traitement. Le statut doit \00EAtre \00E9gal \00E0 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975523462305526)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'fr'
,p_message_text=>'Le nom utilisateur %0 n''existe pas dans l''espace de travail %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975467867305526)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9initialisation du mot de passe pour un sch\00E9ma qui n''est pas associ\00E9 \00E0 votre espace de travail n''est pas autoris\00E9e. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100975359049305526)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de r\00E9initialiser le mot de passe pour le sch\00E9ma %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956158346305511)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('La demande %0 n''a pas pu \00EAtre trait\00E9e car le sch\00E9ma %1 existe dans la table %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955987879305511)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma portant le nom %0 est un sch\00E9ma r\00E9serv\00E9 ; il ne peut pas \00EAtre provisionn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100955247208305511)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''utilisateur %0 ne dispose pas de privil\00E8ges sur le sch\00E9ma %1.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915221047305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'fr'
,p_message_text=>'Analyse de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918071469305479)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'fr'
,p_message_text=>'Analyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100900919419305466)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser les informations d''identification du compte de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100932055501305492)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'fr'
,p_message_text=>'Utilisez les informations d''identification du compte interne %0 et la page de connexion de cette application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101611340330306022)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'fr'
,p_message_text=>'Utiliser Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915327515305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915131154305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Choisir une colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917356146305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''effacer le cache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101994902665306327)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'La valeur #COLUMN_HEADER# doit comporter une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945445326305503)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page d''analyse. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963646219305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le de bouton. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964451740305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963003080305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964825997305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page d''accueil. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964231645305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le panneau d''insertion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963275123305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le de libell\00E9. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964923558305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la liste. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965009100305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er l''\00E9l\00E9ment de liste. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100962964471305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le de liste. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964047523305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le chemin de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963518399305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le de chemin de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965464046305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er les modules.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963965317305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la barre de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915540271305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un nouveau %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918233458305479)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un nouveau')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963199031305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963404615305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le de r\00E9gion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964176728305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page d''\00E9tat. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963361716305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le d''\00E9tat. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965196764305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de succ\00E8s. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963829015305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er les onglets standard. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100964300749305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le panneau de mise \00E0 jour. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917298830305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'fr'
,p_message_text=>'Feuille de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995163378306327)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #COLUMN_HEADER# doit \00EAtre une date valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965286155305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finissez des mod\00E8les par d\00E9faut pour cr\00E9er l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919747835305480)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''afficher la r\00E9gion de page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916707036305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Cette page affiche l''aide sur une page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917005799305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E9rer %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915489674305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau d''insertion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916294557305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'fr'
,p_message_text=>unistr('En ins\00E9rer un autre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917519268305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ins\00E9rer une ligne dans %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916142356305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es ont \00E9t\00E9 ins\00E9r\00E9es avec succ\00E8s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101379355259305847)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# doit \00EAtre une date valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915974945305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315567529305800)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# doit \00EAtre un horodatage valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916934413305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'fr'
,p_message_text=>'%0 Chemin de navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915898214305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'%0 doit comporter une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995051533306327)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #COLUMN_HEADER# doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100963732950305517)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le mod\00E8le de liste de valeurs (LOV) instantan\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100918170331305479)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Etat et modification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917160847305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''afficher l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100917480119305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de r\00E9initialiser la pagination.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916481175305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0 la page d''accueil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916810849305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0 la page pr\00E9c\00E9dente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914912430305476)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Rechercher un \00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102032072964306355)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'fr'
,p_message_text=>'Rechercher toutes les applications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031248793306355)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'fr'
,p_message_text=>'Rechercher une application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031015132306355)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'fr'
,p_message_text=>unistr('Rechercher le d\00E9veloppement d''\00E9quipe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102031706864306355)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'fr'
,p_message_text=>'Rech. des utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915090487305476)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'fr'
,p_message_text=>'Afficher le graphique par'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100919474473305480)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''afficher le chemin de navigation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916572686305478)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916075232305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Page de succ\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101995208037306327)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #COLUMN_HEADER# doit \00EAtre une valeur d''horodatage valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915715240305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100915688986305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Panneau de mise \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965387163305518)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez construire l''application qu''en utilisant un onglet \00E0 un niveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100916330246305477)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Voir l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946494143305504)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'fr'
,p_message_text=>'A propos de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100946507573305504)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'fr'
,p_message_text=>'Branchement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110772604305629)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936761340305497)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Une liste imbriqu\00E9e prend uniquement en charge le type de recherche C\00F4t\00E9 client.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098888392305620)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur inattendue : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101082479663305608)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'fr'
,p_message_text=>'Avertissement : ID de racine d''arborescence "%0" introuvable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294704759305783)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de code PL/SQL g\00E9n\00E9r\00E9e lors du traitement du SQL distant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854754712305431)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de cartes. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101436507902305889)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''acc\00E8s RESTful n''est pas activ\00E9 pour cette instance.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434858606305888)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion introuvable ou REST d\00E9sactiv\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101434907307305888)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune m\00E9thode de sortie n''a \00E9t\00E9 indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085472765305610)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Espace de travail obligatoire.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085565242305611)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Application obligatoire.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085613286305611)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur "%0" ou mot de passe non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314913919305800)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 nouveaux attributs ont \00E9t\00E9 ins\00E9r\00E9s et n\00E9cessitent peut-\00EAtre une traduction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315026837305800)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 attributs ont \00E9t\00E9 purg\00E9s et ne n\00E9cessitent plus de traduction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947397854305505)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de suppression de valeur de d\00E9part : %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947269591305505)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur d''insertion de valeur de d\00E9part : %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315172942305800)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 attributs au total pouvant n\00E9cessiter une traduction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947101387305505)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Impossible de trouver la traduction %0 de l''application %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101314854692305799)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 attributs existants ont \00E9t\00E9 mis \00E0 jour et n\00E9cessitent peut-\00EAtre une traduction')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101121950992305637)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'fr'
,p_message_text=>'erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101385361065305851)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'fr'
,p_message_text=>'Il n''y a pas d''index sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316078080305800)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es de la collection <code>%0</code> ont \00E9t\00E9 compl\00E9t\00E9es par <b id="incompl_success_row_count"></b> nouveaux documents. <b class="u-danger-text" id="incompl_fail_row_count"></b> documents ont \00E9t\00E9 rejet\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315817453305800)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('<b id="success_row_count"></b> nouveaux documents ont \00E9t\00E9 ajout\00E9s \00E0 la fin des donn\00E9es de la collection <code>%0</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853802426305430)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'fr'
,p_message_text=>'Contenu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316224268305801)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854004070305431)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853773627305430)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cl\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100854186450305431)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re modification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853951705305431)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de support'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859114907305434)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le guide de donn\00E9es n''est pas disponible. La collection ne contient aucune donn\00E9e ou l''index de recherche JSON n''a pas encore \00E9t\00E9 cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100853093504305430)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9chargez des fichiers JSON, TXT ou ZIP.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100859292740305434)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les m\00E9tadonn\00E9es de la collection ne sont pas disponibles. V\00E9rifiez le nom de la collection.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316104560305800)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es de la collection <code>%0</code> ont \00E9t\00E9 remplac\00E9es par <b id="incompl_success_row_count"></b> nouveaux documents. <b class="u-danger-text" id="incompl_fail_row_count"></b> documents ont \00E9t\00E9 rejet\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101315956361305800)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es de la collection <code>%0</code> ont \00E9t\00E9 remplac\00E9es par <b id="success_row_count"></b> nouveaux documents.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099757174305621)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : l''intervalle d''axe doit \00EAtre sup\00E9rieur \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099593116305621)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la navigation : le maximum d''axe doit \00EAtre sup\00E9rieur au minimum d''axe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099953341305621)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : le maximum d''axe doit \00EAtre sup\00E9rieur \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099849637305621)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la navigation : le minimum d''axe doit \00EAtre sup\00E9rieur ou \00E9gal \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099691464305621)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : la largeur de la barre doit \00EAtre sup\00E9rieure \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099284227305620)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'fr'
,p_message_text=>'erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101256844305622)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur d''extraction : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101074280305622)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonction renvoyant une requ\00EAte SQL : la requ\00EAte ne peut pas \00EAtre analys\00E9e dans App Builder. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100177784305621)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : l''espace entre les barres doit \00EAtre sup\00E9rieur ou \00E9gal \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099390616305620)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : le nombre maximum de lignes \00E0 afficher doit \00EAtre sup\00E9rieur \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101522777305622)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('D''autres donn\00E9es ont \00E9t\00E9 trouv\00E9es, mais seules 30 valeurs peuvent \00EAtre affich\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101159431305622)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur d''analyse : %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101462183305622)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur de graphique SVG : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101101324351305622)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de calculer la position du contenant du graphique : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100923661305622)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''obtenir la couleur : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100397091305621)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : l''intervalle de l''axe des X doit \00EAtre sup\00E9rieur \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100778583305621)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : le maximum de l''axe des X doit \00EAtre sup\00E9rieur \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100542019305621)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la navigation : le minimum de l''axe des X doit \00EAtre sup\00E9rieur ou \00E9gal \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100409755305621)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : l''intervalle de l''axe des Y doit \00EAtre sup\00E9rieur \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100264747305621)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : le maximum de l''axe des Y doit \00EAtre sup\00E9rieur au minimum d''axe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100815020305621)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la validation : le maximum de l''axe des Y doit \00EAtre sup\00E9rieur \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101100636270305621)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la navigation : le minimum de l''axe des Y doit \00EAtre sup\00E9rieur ou \00E9gal \00E0 z\00E9ro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097455744305619)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur d''ajout de membre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901632766305466)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'fr'
,p_message_text=>unistr('Commande %0 bloqu\00E9e. Impossible de l''ex\00E9cuter \00E0 partir de SQL Workshop.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094389049305617)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur %0 n''a pas de privil\00E8ge sur le sch\00E9ma %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914365893305476)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma %0 ne dispose pas de privil\00E8ge de s\00E9lection sur la table ou la vue %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097626560305619)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la cr\00E9ation du script.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094411230305617)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('table de plan cr\00E9\00E9e pour faciliter l''instruction de plan d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094954080305617)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de cr\00E9ation de fichier de script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094526278305617)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur \00E0 la ligne %0 : %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094740959305617)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''insertion de script dans la table des fichiers.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102042832131306364)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'fr'
,p_message_text=>'ID de ligne non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094844381305617)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''analyse du script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101094653238305617)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma "%0" n''existe pas dans la base de donn\00E9es. Contactez votre administrateur d''espace de travail pour qu''il d\00E9finisse pour vous un sch\00E9ma par d\00E9faut correct.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895112407305461)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans run_sql_arr. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097596061305619)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de mise \00E0 jour de membre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100914269771305476)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de lignes du script d\00E9passe 32 767 octets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881133889305451)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'fr'
,p_message_text=>unistr('Annul\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129977750305643)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'fr'
,p_message_text=>'Annulation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882110429305451)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882547435305452)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'fr'
,p_message_text=>'%0 secondes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881214354305451)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'fr'
,p_message_text=>unistr('En cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100940000913305499)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 l''ex\00E9cution d''un script contenant une ou plusieurs instructions inconnues. Enlevez la ou les instructions suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882279085305451)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('En cours d''ex\00E9cution')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100939970550305499)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901500604305466)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1004 : Les scripts ne peuvent pas \00EAtre imbriqu\00E9s de plus de %0 niveaux.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902880487305467)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1005 : La sortie du script a atteint la taille maximale autoris\00E9e. Modifiez le script pour g\00E9n\00E9rer moins de sortie ou contactez votre administrateur afin qu''il augmente la taille maximale des r\00E9sultats de script.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231076857305736)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('La taille du script d\00E9passe le maximum autoris\00E9 : %0 octets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100902967651305467)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1005 : La sortie du script a atteint la taille maximale autoris\00E9e des r\00E9sultats d''espace de travail. Supprimez les r\00E9sultats existants ou contactez votre administrateur pour qu''il augmente la taille maximale des r\00E9sultats d''espace de travail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101166095168305670)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune instruction \00E0 ex\00E9cuter dans la m\00E9moire tampon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100896886141305462)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('L''instruction SELECT ne peut pas \00EAtre sup\00E9rieure \00E0 32 ko.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882336968305452)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'fr'
,p_message_text=>'%0 ligne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100882402997305452)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'fr'
,p_message_text=>'%0 lignes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100897788493305463)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 lignes s\00E9lectionn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101125055806305639)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 l''ex\00E9cution d''un script ne contenant aucune instruction ex\00E9cutable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100894995998305461)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter le script. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100895082595305461)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans run_statement. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101124912700305639)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez demand\00E9 l''ex\00E9cution d''un script contenant des instructions que SQL Workshop ne prendra pas en compte. Confirmez votre demande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100901414834305466)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'ERR-1001 : Script introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881050305305451)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'fr'
,p_message_text=>'Soumis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129465396305643)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'fr'
,p_message_text=>'Instruction inconnue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101129209901305642)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0% utilis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114933700305632)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la cr\00E9ation du package en raison d''une syntaxe SQL non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101114656021305632)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('La cr\00E9ation de la table a \00E9chou\00E9 en raison d''une syntaxe SQL non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947544350305505)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur de synchronisation : %0.%1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101271026364305766)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('r\00E9f\00E9renc\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101270917400305766)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'fr'
,p_message_text=>unistr('r\00E9f\00E9rences')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100945893343305504)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'fr'
,p_message_text=>unistr('Tentative d''acc\00E8s \00E0 la colonne de panneau tabulaire qui serait mise en correspondance avec le tableau PL/SQL apex_application.g_f%0, mais seulement %1 colonnes enregistrant le statut sont prises en charge. R\00E9duisez le nombre de colonnes enregistrant ')
||'le statut.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101508508501305942)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un nouvel onglet parent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293931163305783)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un nouvel onglet standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294509297305783)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouveau jeu d''onglets (vous permet de cr\00E9er un onglet standard dans un nouveau jeu d''onglets)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122223637305637)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'fr'
,p_message_text=>'Nouveau jeu d''onglets introuvable pour l''ID d''onglet parent %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122161466305637)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'fr'
,p_message_text=>'Ancien jeu d''onglets introuvable pour l''ID d''onglet %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122335413305637)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>'L''ID de page %0 n''est pas un nombre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294099044305783)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('Onglet parent. S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294433075305783)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'fr'
,p_message_text=>unistr('n''est pas associ\00E9 \00E0 un onglet parent. Il est affich\00E9 en tant que pseudo-onglet parent afin que vous puissiez modifier les onglets standard de ce jeu d''onglets;')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294625278305783)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un onglet standard')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294249862305783)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'fr'
,p_message_text=>unistr('Onglet parent s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294137351305783)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Pseudo-onglet parent s\00E9lectionn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122061924305637)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de groupe de s\00E9curit\00E9 doit \00EAtre d\00E9fini.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101122457239305637)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Un nouveau jeu d''onglets doit \00EAtre indiqu\00E9 pour l''onglet dont l''ID est %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293863885305783)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'fr'
,p_message_text=>unistr('Onglet standard. S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293731722305782)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Onglet \00E9galement en cours pour les pages')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101293683588305782)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Onglet en cours de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101294369396305783)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'fr'
,p_message_text=>'Le jeu d''onglets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948761535305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de bouton (%0) pour copie introuvable dans l''application "%1", espace de travail "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949688262305507)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le de bouton. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101115126454305632)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948454165305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de champ (%0) pour copie introuvable dans l''application "%1", espace de travail "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949306487305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le de champ. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949261433305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le de liste. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948613859305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de chemin de navigation (%0) pour copie introuvable dans l''application "%1", espace de travail "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949456987305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le de chemin de navigation. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948967861305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le de page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949538567305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le de liste de valeurs (LOV) instantan\00E9e. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101231910253305737)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le instantan\00E9 (%0) pour copie introuvable dans l''application "%1", espace de travail "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949034268305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le de r\00E9gion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100949137938305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le d''\00E9tat. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948330447305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le (%0) introuvable pour copie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100948820378305506)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de remplacer le mod\00E8le %0. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102061855165306378)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le style de th\00E8me n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079360548306391)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de mettre \00E0 jour le style ; il est en lecture seule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102079277452306391)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce nom est d\00E9j\00E0 utilis\00E9 par un style existant.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100947454716305505)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de mise \00E0 jour de valeur de d\00E9part : %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101396426489305860)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Application Express est en cours de mise \00E0 niveau vers une nouvelle version. Les modifications apport\00E9es aux applications sont d\00E9sactiv\00E9es jusqu''\00E0 la fin de la mise \00E0 niveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059603328305590)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864981043305439)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application %0 ne semble pas \00EAtre connect\00E9e en tant qu''utilisateur de base de donn\00E9es %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100865086238305439)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application %0 et la page %1 ne semblent pas \00EAtre connect\00E9es en tant qu''utilisateur de base de donn\00E9es %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060600602305590)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'fr'
,p_message_text=>'Calendrier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088665624305613)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''\00E9valuation de requ\00EAte de case \00E0 cocher : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060779700305591)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088210594305613)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur : Les listes de valeurs (LOV) Afficher uniquement doivent s\00E9lectionner deux colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059499188305590)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de d\00E9terminer la liste de valeurs (LOV).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061049156305591)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'fr'
,p_message_text=>'Rechercher %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101110024422305628)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la g\00E9n\00E9ration de la liste de valeurs (LOV) instantan\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087928911305612)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la g\00E9n\00E9ration de la requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088034950305612)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''initialisation de la liste de valeurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088586930305613)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''initialiser la requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013883746305554)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte de liste de valeurs (LOV) instantan\00E9e n''est pas valide ; une valeur d''affichage et une valeur de retour sont requises, et les noms de colonne doivent \00EAtre diff\00E9rents')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061199385305591)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'fr'
,p_message_text=>'JavaScript non pris en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061394464305591)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101061794598305591)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''ex\00E9cution de la requ\00EAte de liste de valeurs (LOV).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060549928305590)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060199742305590)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'fr'
,p_message_text=>'Absence de correspondances.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060891010305591)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'fr'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109746221305628)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Une liste de valeurs (LOV) instantan\00E9e doit commencer par "select".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101087898852305612)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de g\00E9n\00E9rer la liste de valeurs (LOV) instantan\00E9e avec filtre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109923103305628)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''initialisation de la liste de valeurs (LOV) instantan\00E9e avec filtre : %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101109828628305628)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''initialisation de la liste de valeurs (LOV) instantan\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088324892305613)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''authentification de la liste de valeurs (LOV) instantan\00E9e a \00E9chou\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088498635305613)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('La v\00E9rification de la liste de valeurs (LOV) instantan\00E9e par checksum a \00E9chou\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060292835305590)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101059857609305590)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101060948484305591)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'fr'
,p_message_text=>'Dialogue de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101671923344306073)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''affichage de l''image. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089144867305613)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'fr'
,p_message_text=>'Gras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089537540305614)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste \00E0 puces')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089969805305614)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'fr'
,p_message_text=>unistr('Indentation \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090037154305614)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Indentation \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089280824305613)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'fr'
,p_message_text=>'Italiques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089721068305614)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'fr'
,p_message_text=>'Centrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089656978305614)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aligner \00E0 gauche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089851407305614)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'fr'
,p_message_text=>unistr('Aligner \00E0 droite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089469304305613)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste num\00E9rot\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101089352299305613)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'fr'
,p_message_text=>'Souligner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101088136187305613)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de lier "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100864890970305439)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application Web %0 ne semble pas \00EAtre connect\00E9e en tant qu''utilisateur de base de donn\00E9es %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101288828129305779)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le service Web n''a pas pu \00EAtre atteint, car l''URL que vous avez indiqu\00E9e n''est pas valide, votre environnement requiert une adresse de serveur proxy valide pour les demandes HTTP, la demande a expir\00E9 ou un portefeuille doit \00EAtre configur\00E9 pour les de')
||'mandes HTTPS. SQLERRM : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100935525989305496)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le document WSDL n''a pas pu \00EAtre extrait, soit parce que l''URL que vous avez indiqu\00E9e n''est pas valide, soit parce que votre environnement requiert une adresse de serveur proxy valide pour les demandes HTTP et que vous n''en avez pas d\00E9finie pour cett')
||unistr('e application, ou parce qu''un portefeuille doit \00EAtre configur\00E9 pour cette instance de &PRODUCT_NAME. pour les demandes HTTPS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936218116305496)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518246592305949)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''ajouter des lignes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100930052427305489)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le bouton. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966599218305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de calendrier. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966255063305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de graphique. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101648614434306049)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de terminer le processus de chargement des donn\00E9es. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966992021305520)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le graphique Excel. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966658620305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le panneau sur \00E9quijointure. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965850603305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le panneau sur sp. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965949262305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le panneau sur table. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966077403305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le panneau d''insertion. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101450310620305900)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le graphique Oracle JET. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100852982012305430)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page ma\00EEtre-d\00E9tail. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101335764116305815)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er l''action dynamique. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966138648305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de requ\00EAte et de mise \00E0 jour. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966410851305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page d''\00E9tat. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967044591305520)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page r\00E9capitulative. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967190142305520)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er la page de graphique SVG. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966835433305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er l''arborescence. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965748233305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er l''\00E9tat modifiable. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966705860305519)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er l''assistant Cr\00E9ation d''assistant. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518188675305949)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de traiter la suppression.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518527988305950)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('#MRD_COUNT# ligne(s) supprim\00E9e(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871910913305444)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'fr'
,p_message_text=>unistr('Obtenir la valeur de la cl\00E9 primaire suivante ou pr\00E9c\00E9dente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871835167305444)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce bouton est requis pour le processus d''obtention de la valeur de la cl\00E9 primaire suivante ou pr\00E9c\00E9dente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100871708706305444)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'fr'
,p_message_text=>unistr('Cet \00E9l\00E9ment est requis pour le processus d''obtention de la valeur de la cl\00E9 primaire suivante ou pr\00E9c\00E9dente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100872582916305444)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter le processus d''obtention de la valeur de la cl\00E9 primaire suivante ou pr\00E9c\00E9dente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100881657592305451)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Etes-vous s\00FBr de vouloir quitter cette page sans l''enregistrer ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230918050305736)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''obtenir la valeur de l''\00E9l\00E9ment de cl\00E9 secondaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101230856722305736)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''obtenir la valeur de l''\00E9l\00E9ment de cl\00E9 primaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100966366847305519)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''\00E9tat non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101244948125305746)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Un \00E9tat interactif existe d\00E9j\00E0. Vous ne pouvez en ajouter qu''un par page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100956880978305512)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de cr\00E9er le processus d''obtention de la valeur de la cl\00E9 primaire suivante ou pr\00E9c\00E9dente. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518039200305949)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'fr'
,p_message_text=>'Il n''y a pas d''aide pour cette page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965682080305519)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'fr'
,p_message_text=>'ParseErr : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100965562191305518)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'fr'
,p_message_text=>'erreur d''analyse 2 %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518604943305950)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''envoi de la demande.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518908139305950)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'fr'
,p_message_text=>'Afficher l''arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518718995305950)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'fr'
,p_message_text=>'Racine d''arborescence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936042054305496)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100936196985305496)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'fr'
,p_message_text=>'Impossible de traiter la ligne de la table %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100967217534305520)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Il existe d\00E9j\00E0 une requ\00EAte SQL modifiable. Vous ne pouvez ajouter qu''une seule requ\00EAte SQL modifiable par page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518309333305949)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mise \00E0 jour appliqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101518428814305950)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'fr'
,p_message_text=>unistr('#MRU_COUNT# ligne(s) mise(s) \00E0 jour, #MRI_COUNT# ligne(s) ins\00E9r\00E9e(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388803348305854)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier un mod\00E8le d''autorisation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388630667305854)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'fr'
,p_message_text=>'Copier une liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388409610305854)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'fr'
,p_message_text=>'Copier une liste de valeurs (LOV)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388748003305854)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'fr'
,p_message_text=>'Utiliser une liste existante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101388518132305854)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'fr'
,p_message_text=>'Utiliser une liste de valeurs (LOV) existante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101090247768305614)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''affichage de l''\00E9tat : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101546420180305969)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 Go au total | %1 Go utilis\00E9 | %2 % utilis\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863579049305438)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la d\00E9finition de la nouvelle cible composite de m\00E9moire PGA. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100863374636305437)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la d\00E9finition de la nouvelle cible de m\00E9moire SGA. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(102110971495306415)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement %0 : %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085902716305611)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'fr'
,p_message_text=>'Moyenne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085848195305611)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'fr'
,p_message_text=>'Axe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086497761305611)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'fr'
,p_message_text=>'Premier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086555318305611)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'fr'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086346538305611)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'fr'
,p_message_text=>'Dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086171000305611)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'fr'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086208964305611)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'fr'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101085721197305611)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101086017931305611)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'fr'
,p_message_text=>'Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021417854305561)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte ne peut pas \00EAtre analys\00E9e, le curseur n''est pas encore ouvert ou une fonction renvoyant une requ\00EAte SQL n''a pas renvoy\00E9 de valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101381941825305849)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre requ\00EAte contient des alias en double. Les requ\00EAtes utilis\00E9es pour les \00E9tats requi\00E8rent des alias uniques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101013587686305554)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('impossible de traiter le corps de fonction renvoyant une requ\00EAte :'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101099492889305620)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'fr'
,p_message_text=>unistr('nombre de colonnes d\00E9fini dans la requ\00EAte non valide, ce type de r\00E9gion requiert %0 colonnes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021518380305562)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fonction renvoyant une requ\00EAte SQL : la requ\00EAte ne peut pas \00EAtre analys\00E9e dans Application Builder. Si vous pensez que la syntaxe de la requ\00EAte est correcte, cochez la case <strong>Colonnes g\00E9n\00E9riques</strong> sous la source de r\00E9gion pour poursuivre')
||' sans qu''il y ait analyse.',
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101021693390305562)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La requ\00EAte ne peut pas \00EAtre analys\00E9e dans Application Builder. Si vous pensez que la syntaxe de la requ\00EAte est correcte, cochez la case Colonnes g\00E9n\00E9riques sous la source de r\00E9gion pour poursuivre sans qu''il y ait analyse.'),
'(%0)</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101097960606305619)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un mot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098574094305620)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'fr'
,p_message_text=>'Ajouter au dictionnaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098471523305620)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'fr'
,p_message_text=>'Appliquer les modifications'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098307856305620)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098274740305620)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'fr'
,p_message_text=>unistr('Termin\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101457195639305905)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'fr'
,p_message_text=>'Soumettre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098153896305620)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 figure d\00E9j\00E0 dans votre dictionnaire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098702354305620)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un nouveau mot.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098691028305620)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un mot')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101316359039305801)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'fr'
,p_message_text=>unistr('V\00E9rificateur orthographique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101098079935305619)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ajout\00E9 \00E0 votre dictionnaire.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100943332784305502)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur de chargement XML.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101368222673305839)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Il existe des balises %0 suppl\00E9mentaires')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101369001911305839)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'fr'
,p_message_text=>'%0 bugs n''ont pas de date de correction'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101543008871305967)
,p_name=>'YEARLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100996762538305542)
,p_name=>'YES_BY_USER'
,p_message_language=>'fr'
,p_message_text=>'Oui, par utilisateur'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101025802185305565)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre adresse \00E9lectronique est inscrite aupr\00E8s d''un utilisateur dans les espaces de travail suivants :')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(101307275952305794)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes maintenant d\00E9connect\00E9.')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4413)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>'Chemin de navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Affiche le chemin de navigation pour la page en cours.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>'Liste'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche les valeurs bas\00E9es sur une liste statique ou dynamique. Elles sont en g\00E9n\00E9ral utilis\00E9es pour acc\00E9der aux pages de l''application.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>unistr('Annuler la bo\00EEte de dialogue')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Annule la page de bo\00EEte de dialogue en cours.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('Fermer la bo\00EEte de dialogue')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ferme la page de bo\00EEte de dialogue en cours.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4413)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('El\00E9ments \00E0 renvoyer')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nom des \00E9l\00E9ments de page que la bo\00EEte de dialogue doit renvoyer. S\00E9parez les noms d''\00E9l\00E9ment par une virgule.</p>'),
unistr('<p>Vous pouvez acc\00E9der aux valeurs d''\00E9l\00E9ment renvoy\00E9es en d\00E9finissant une action dynamique de fa\00E7on \00E0 ce qu''elle soit d\00E9clench\00E9e en cas d''\00E9v\00E9nement <strong>Bo\00EEte de dialogue ferm\00E9e</strong> sur l''\00E9l\00E9ment qui ouvre la bo\00EEte de dialogue, avec l''action ')
||unistr('<strong>D\00E9finir une valeur</strong> et l''action <em>D\00E9finir un type</em> d\00E9finie sur <strong>El\00E9ment renvoy\00E9 de bo\00EEte de dialogue</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche les noms de r\00E9gion dans une liste horizontale, permettant \00E0 l''utilisateur final de s\00E9lectionner une r\00E9gion \00E0 afficher et de masquer les autres r\00E9gions. Seules les r\00E9gions de page dont l''\00E9l\00E9ment <em>S\00E9lecteur d''affichage de r\00E9gion</em> est d\00E9f')
||unistr('ini sur <strong>Oui</strong> sont affich\00E9es dans cette r\00E9gion.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4413)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Inclure le curseur'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Ajoutez de mani\00E8re dynamique un curseur \00E0 la r\00E9gion si les noms de r\00E9gion affich\00E9s d\00E9passent la largeur de la r\00E9gion.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4413)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez comment les r\00E9gions pour lesquelles l''option <em>S\00E9lecteur d''affichage de r\00E9gion</em> est d\00E9finie sur <strong>Oui</strong> seront affich\00E9es sur la page.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Visualiser une seule r\00E9gion')
,p_return_value=>'STANDARD'
,p_help_text=>unistr('Affichez les r\00E9gions en tant qu''onglets. La s\00E9lection d''un onglet permettra de rendre visible la r\00E9gion correspondante et de masquer les autres s\00E9lections.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Fen\00EAtre de d\00E9filement')
,p_return_value=>'JUMP'
,p_help_text=>unistr('Affichez toujours toutes les r\00E9gions sur la page. La s\00E9lection d''un onglet fera d\00E9filer votre fen\00EAtre jusqu''\00E0 la r\00E9gion correspondante.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4413)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Inclure Afficher tout'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('Ajoutez au d\00E9but un onglet Afficher tout qui, lorsqu''il est s\00E9lectionn\00E9, affiche toutes les r\00E9gions sur la page.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4413)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('M\00E9moriser la derni\00E8re s\00E9lection')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Lors du chargement de la page, la derni\00E8re r\00E9gion s\00E9lectionn\00E9e sera affich\00E9e.')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Affiche le contenu distant provenant d''une URL.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4413)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Saisissez l''URL du contenu distant.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4413)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mode d''inclusion'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la m\00E9thode utilis\00E9e pour inclure le contenu distant provenant de l''URL dans la page.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4413)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>'Imbriquer le contenu distant en tant qu''iFrame.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Incorporation (caract\00E8res sp\00E9ciaux d''\00E9chappement)')
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('Lire le contenu distant lors de l''affichage de la page et l''imbriquer, mais \00E9chapper les caract\00E8res sp\00E9ciaux HTML pour \00E9viter le scriptage inter-site.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Incorporation (pas d''\00E9chappement)')
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('Lire le contenu distant lors de l''affichage de la page et l''imbriquer. Cette option ne doit \00EAtre s\00E9lectionn\00E9e que si le contenu distant est compl\00E8tement s\00E9curis\00E9, car aucun \00E9chappement HTML n''a \00E9t\00E9 effectu\00E9. Ceci rend la r\00E9gion plus vuln\00E9rable au scr')
||'iptage inter-site.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4413)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Attributs iFrame'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>unistr('Saisissez des attributs d''\00E9l\00E9ment HTML suppl\00E9mentaires pour la balise iFrame.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4413)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Rejeter le code HTML jusqu''\00E0')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Utilisez cet attribut lorsque vous d\00E9coupez une section de code HTML d''un document plus grand. Saisissez une cha\00EEne identifiant le d\00E9but de la section voulue ou le point jusqu''auquel le code HTML est ignor\00E9.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4413)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Rejeter le code HTML apr\00E8s')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Utilisez cet attribut lorsque vous d\00E9coupez une section de code HTML d''un document HTML plus grand. Saisissez une cha\00EEne identifiant la fin de la section cibl\00E9e ou le point \00E0 partir duquel le code HTML restant est ignor\00E9. La cha\00EEne identifiant la fin')
||unistr(' de la section cibl\00E9e n''est pas incluse dans le texte renvoy\00E9.')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>'Texte d''aide'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche une r\00E9gion d''aide sp\00E9ciale utilis\00E9e sur la page d''aide d\00E9di\00E9e.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>unistr('Recherche \00E0 facets')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>R\00E9gion reposant sur la source d''une recherche \00E0 facets associ\00E9e, qui fournit aux utilisateurs finals de nombreux facets utilis\00E9s pour affiner les r\00E9sultats de recherche au moment de l''ex\00E9cution. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Modifications de facet en batch'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si les facets s\00E9lectionn\00E9s doivent \00EAtre appliqu\00E9s en batch ou individuellement dans l''\00E9tat Recherche \00E0 facets. Si l''option est d\00E9finie sur Oui, le filtrage de l''\00E9tat est ex\00E9cut\00E9 lorsque l''utilisateur clique sur un bouton Appliquer. Si elle e')
||unistr('st d\00E9finie sur Non, il est ex\00E9cut\00E9 d\00E8s qu''une valeur de facet change.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Afficher les facets en cours'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si la zone des facets en cours doit \00EAtre affich\00E9e. Cette zone r\00E9pertorie les facets actuellement s\00E9lectionn\00E9s et facilite leur suppression individuelle ou globale.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4413)
,p_display_sequence=>10
,p_display_value=>'Oui'
,p_return_value=>'Y'
,p_help_text=>unistr('La liste des facets en cours est affich\00E9e dans la partie sup\00E9rieure de la r\00E9gion Recherche \00E0 facets.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4413)
,p_display_sequence=>20
,p_display_value=>'Non'
,p_return_value=>'N'
,p_help_text=>unistr('La liste des facets en cours n''est pas affich\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4413)
,p_display_sequence=>30
,p_display_value=>unistr('S\00E9lecteur')
,p_return_value=>'E'
,p_help_text=>unistr('La zone des facets en cours est affich\00E9e dans l''\00E9l\00E9ment indiqu\00E9 par ce s\00E9lecteur. Vous pouvez ainsi placer la zone des facets en cours presque partout sur la page.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('S\00E9lecteur de facets en cours')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('Ceci est le s\00E9lecteur d''un \00E9l\00E9ment de la page o\00F9 la r\00E9gion de la recherche \00E0 facets affichera les facets en cours.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Afficher le nombre total de lignes'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Indiquez l''emplacement d''affichage du nombre total de lignes.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4413)
,p_display_sequence=>10
,p_display_value=>'Non'
,p_return_value=>'N'
,p_help_text=>unistr('Le nombre total de lignes n''est pas affich\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4413)
,p_display_sequence=>20
,p_display_value=>'Oui'
,p_return_value=>'Y'
,p_help_text=>unistr('Le nombre total de lignes est affich\00E9 dans la partie sup\00E9rieure de la zone des facets en cours ou, si l''option Afficher les facets en cours est d\00E9finie sur Non, dans la partie sup\00E9rieure de la r\00E9gion Recherche \00E0 facets.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4413)
,p_display_sequence=>30
,p_display_value=>unistr('S\00E9lecteur')
,p_return_value=>'E'
,p_help_text=>unistr('Le nombre total de lignes (sans aucun libell\00E9) est affich\00E9 dans l''\00E9l\00E9ment indiqu\00E9 par ce s\00E9lecteur. Vous pouvez ainsi placer le nombre total de lignes presque partout sur la page.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Libell\00E9 du nombre total de lignes')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Libell\00E9 utilis\00E9 pour le nombre total de lignes. Si aucun libell\00E9 n''est fourni, APEX utilisera le message texte APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('S\00E9lecteur du nombre total de lignes')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Ceci est le s\00E9lecteur d''un \00E9l\00E9ment de la page sur laquelle la r\00E9gion de la recherche \00E0 facets affichera le nombre total de lignes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>'Seuil de nombres compacts'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez une valeur de seuil au-dessus de laquelle le nombre de facets est affich\00E9 dans un format num\00E9rique compact. Avec ce format, la valeur <strong>1,234</strong> est repr\00E9sent\00E9e par <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Afficher les graphiques'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Indiquez l''emplacement d''affichage des graphiques de valeurs de facet.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Bo\00EEte de dialogue')
,p_return_value=>'Y'
,p_help_text=>unistr('Les graphiques de valeurs de facet sont affich\00E9s dans une bo\00EEte de dialogue non modale.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4413)
,p_display_sequence=>20
,p_display_value=>'Non'
,p_return_value=>'N'
,p_help_text=>'Aucun bouton permettant aux utilisateurs d''afficher les graphiques de valeurs de facet n''est disponible.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4413)
,p_display_sequence=>30
,p_display_value=>unistr('S\00E9lecteur')
,p_return_value=>'E'
,p_help_text=>unistr('Les graphiques de valeurs de facet sont ajout\00E9s \00E0 l''\00E9l\00E9ment indiqu\00E9 par ce s\00E9lecteur. Vous pouvez ainsi placer les graphiques presque partout sur la page, en cr\00E9ant un tableau de bord des graphiques de valeurs de facet.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('S\00E9lecteur de graphique')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('Ceci est le s\00E9lecteur d''un \00E9l\00E9ment de la page sur laquelle la r\00E9gion de la recherche \00E0 facets affichera les graphiques des facets.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Afficher le graphique des N valeurs les plus \00E9lev\00E9es')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('Indiquez le nombre de valeurs \00E0 afficher dans le graphique pour chaque facet. Une valeur de <strong>10</strong> signifie que les graphiques de facet afficheront les <em>10 premiers</em> \00E9l\00E9ments tels qu''ils sont class\00E9s sous le facet. Lorsque la prop')
||unistr('ri\00E9t\00E9 du facet Trier par nombre d\00E9croissant est activ\00E9e, il s''agira des <em>10 principaux</em> \00E9l\00E9ments en fonction du nombre d''occurrences. Les modifications apport\00E9es \00E0 cette propri\00E9t\00E9 peuvent ne pas \00EAtre visibles imm\00E9diatement dans les sessions de')
||unistr(' navigateur actuellement actives. Cette valeur ainsi que le choix d''un graphique \00E0 secteurs ou \00E0 barres de l''utilisateur sont enregistr\00E9s dans la session de navigateur. Pour voir les effets des modifications apport\00E9es \00E0 cette propri\00E9t\00E9, r\00E9initialisez')
||unistr(' l''\00E9tat \00E0 l''aide de l''option de contr\00F4le de cache ou de l''option de r\00E9initialisation des r\00E9gions, par exemple le bouton R\00E9initialiser g\00E9n\00E9r\00E9 par l''assistant.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_name=>'facetsafterremovechart'
,p_display_name=>unistr('Apr\00E8s la suppression d''un graphique')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>'Avant l''ajout d''un graphique'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4413)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4413)
,p_name=>'facetschange'
,p_display_name=>'Modification de facets'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>'Connexion SAML'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>'Banque d''informations d''identification pour la signature des demandes'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la banque d''informations d''identification contenant le certificat public et la cl\00E9 priv\00E9e utilis\00E9s pour signer les messages adress\00E9s au fournisseur d''identit\00E9s.'),
unistr('Vous devez inscrire le certificat aupr\00E8s du fournisseur d''identit\00E9s.'),
unistr('&PRODUCT_NAME. utilise la cl\00E9 priv\00E9e pour signer les demandes.'),
unistr('Cet attribut est facultatif. Il est n\00E9anmoins recommand\00E9 de signer les demandes pour des raisons de s\00E9curit\00E9.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Utiliser les attributs SAML de'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>unistr('Indiquez si une configuration SAML de niveau instance ou propre \00E0 l''application doit \00EAtre utilis\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_display_sequence=>10
,p_display_value=>'Instance'
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilisez la configuration SAML partag\00E9e pour l''int\00E9gralit\00E9 de l''instance &PRODUCT_NAME..'),
unistr('L''administrateur d''instance doit avoir configur\00E9 des attributs SAML de niveau instance.'),
unistr('Dans le cas contraire, des erreurs d''ex\00E9cution surviendront.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_display_sequence=>20
,p_display_value=>'Application'
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>unistr('Utilisez une configuration SAML propre \00E0 l''application.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('URL SSO (acc\00E8s avec connexion unique) de fournisseur d''identit\00E9s')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('S\00E9lectionnez l''URL POST SSO (acc\00E8s avec connexion unique) du fournisseur d''identit\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('URL de d\00E9connexion unique de fournisseur d''identit\00E9s')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''URL POST de d\00E9connexion unique du fournisseur d''identit\00E9s.'),
unistr('Si rien n''est indiqu\00E9, l''URL SSO (acc\00E8s avec connexion unique) est utilis\00E9e.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('Emetteur de fournisseur d''identit\00E9s')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la valeur Emetteur du fournisseur d''identit\00E9s.'),
unistr('&PRODUCT_NAME. v\00E9rifiera cette valeur dans les messages du fournisseur d''identit\00E9s.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Attribut du nom utilisateur'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Attribut SAML contenant le nom utilisateur.',
unistr('Prend par d\00E9faut la valeur du noeud "Assertion/Subject/NameID".')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>unistr('Certificat de signature du fournisseur d''identit\00E9s')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le certificat utilis\00E9 par le fournisseur d''identit\00E9s pour signer les messages.'),
unistr('&PRODUCT_NAME. utilise ce certificat pour v\00E9rifier les messages de r\00E9ponse du fournisseur d''identit\00E9s.'),
unistr('Cet attribut est facultatif. Il est n\00E9anmoins recommand\00E9 de v\00E9rifier les r\00E9ponses pour des raisons de s\00E9curit\00E9.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4413)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Mettre le nom utilisateur en majuscules'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si les valeurs d''attribut du nom utilisateur doivent \00EAtre converties en majuscules.')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>unistr('Champ d''entr\00E9e')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4413)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Op\00E9rateur de comparaison')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Est \00E9gal \00E0')
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Est inf\00E9rieur \00E0')
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_display_sequence=>40
,p_display_value=>unistr('Est inf\00E9rieur ou \00E9gal \00E0')
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_display_sequence=>50
,p_display_value=>unistr('Est sup\00E9rieur \00E0')
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_display_sequence=>60
,p_display_value=>unistr('Est sup\00E9rieur ou \00E9gal \00E0')
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_display_sequence=>70
,p_display_value=>'Commence par'
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_display_sequence=>80
,p_display_value=>'Contient'
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4413)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Distinction maj/min'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4413)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Casse des valeurs'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Si toutes les valeurs de donn\00E9es sont en minuscules ou en majuscules, vous pouvez effectuer la d\00E9claration ici. Le filtre indiqu\00E9 par l''utilisateur final convertira automatiquement les valeurs vers la casse d\00E9clar\00E9e. De cette fa\00E7on, l''utilisateur fin')
||unistr('al peut r\00E9aliser une recherche sans distinction entre les majuscules et les minuscules, alors que la base de donn\00E9es ex\00E9cute une recherche classique avec respect des majuscules/minuscules.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4413)
,p_display_sequence=>10
,p_display_value=>'Majuscules et minuscules'
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4413)
,p_display_sequence=>20
,p_display_value=>'Minuscule'
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4413)
,p_display_sequence=>30
,p_display_value=>'Majuscule'
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4413)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Libell\00E9 en cours')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'Filtrage pour %0'
,p_help_text=>unistr('Indiquez le texte \00E0 afficher pour ce facet dans la zone des facets en cours. La valeur en cours peut \00EAtre r\00E9f\00E9renc\00E9e avec la valeur de r\00E9serve <strong>%0</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4413)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Texte de pr\00E9fixe')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez le texte \00E0 afficher avant le champ de saisie.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4413)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Texte de suffixe'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez le texte \00E0 afficher apr\00E8s le champ de saisie.')
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>'Cartes'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Etat bas\00E9 sur une requ\00EAte SQL qui affiche les donn\00E9es de chaque ligne dans les cartes. Les cartes vous permettent de visualiser facilement les donn\00E9es dans des blocs de contenu. Vous pouvez personnaliser l''en-t\00EAte, le support, le corps ou les actions')
||unistr(' de fa\00E7on d\00E9clarative.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4413)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4413)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4413)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>'Changement de page'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4413)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type de pagination'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Aucune pagination'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Taille de page et d\00E9calage d''extraction')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pagination flexible avec laquelle l''API REST permet de demander un ensemble sp\00E9cifique de lignes \00E0 l''aide des param\00E8tres de <em>taille de page</em> et de <em>d\00E9calage</em> ("commencer \00E0 la ligne"). En g\00E9n\00E9ral, l''URL ressemble \00E0 l''exemple suivant, ')
||unistr('dans lequel <strong>20</strong> lignes sont ignor\00E9es et les <strong>100</strong> lignes suivantes sont extraites :</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Taille de page et num\00E9ro de page')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pagination avec laquelle l''API REST permet de demander un ensemble de lignes, \00E0 l''aide des param\00E8tres de <em>taille de page</em> et de <em>num\00E9ro de page</em>. En g\00E9n\00E9ral, les URL ressemblent \00E0 l''exemple suivant, dans lequel le num\00E9ro de page <str')
||unistr('ong>2</strong> est demand\00E9 avec une taille de page de <strong>100</strong>, menant ainsi au renvoi des lignes 101 \00E0 200.'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Num\00E9ro de page')
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pagination avec laquelle l''API REST permet de demander un ensemble de lignes, \00E0 l''aide du param\00E8tre de <em>page</em>. La taille de page est fixe et d\00E9termin\00E9e par l''API REST. En g\00E9n\00E9ral, les URL ressemblent \00E0 l''exemple suivant, dans lequel le num\00E9')
||unistr('ro de page <strong>2</strong> est demand\00E9. Si l''API REST utilise une taille de page fixe de <strong>20</strong>, les lignes 21 \00E0 40 sont renvoy\00E9es.'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Param\00E8tre d''URL de taille de page')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le param\00E8tre d''URL pour sp\00E9cifier la <em>taille de page</em> \00E0 demander \00E0 l''API REST. Valeurs types : <strong>limit</strong>, <strong>page_size</strong> ou </strong>per_page</strong>.</p>'),
unistr('<p><em>N''ajoutez pas ce param\00E8tre aux <strong>param\00E8tres</strong></em> de source de donn\00E9es REST. &PRODUCT_NAME. l''ajoutera automatiquement lors de l''ex\00E9cution de la demande HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Taille de page maximale'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>'lignes'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la quantit\00E9 maximale de lignes par page que l''API REST est autoris\00E9e \00E0 extraire. &PRODUCT_NAME. n''essaiera pas de demander plus de lignes par page.</p>'),
unistr('<p>Si la r\00E9ponse contient moins de lignes que la quantit\00E9 demand\00E9e, assurez-vous que l''API REST <em>renvoie r\00E9ellement</em> cette quantit\00E9 de lignes, car &PRODUCT_NAME. consid\00E8re que la page demand\00E9e est la derni\00E8re page.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Param\00E8tre d''URL de num\00E9ro de page')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le param\00E8tre d''URL pour sp\00E9cifier le <em>num\00E9ro de page</em> \00E0 demander \00E0 l''API REST. Valeurs types : <strong>page</strong>.</p>'),
unistr('<p><em>N''ajoutez pas ce param\00E8tre aux <strong>param\00E8tres</strong></em> de source de donn\00E9es REST. &PRODUCT_NAME. l''ajoutera automatiquement lors de l''ex\00E9cution de la demande HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Index de la premi\00E8re page')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Indiquez si l''API REST commence \00E0 compter les pages \00E0 partir de l''index <strong>0</strong> ou <strong>1</strong>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4413)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>unistr('L''API REST fait r\00E9f\00E9rence \00E0 la premi\00E8re page en tant que page <strong>1</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4413)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>unistr('L''API REST fait r\00E9f\00E9rence \00E0 la premi\00E8re page en tant que page <strong>0</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Taille de page fixe'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>'lignes'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la <em>taille de page</em> (nombre de lignes par page), qui est d\00E9termin\00E9e par l''API REST.</p>'),
unistr('<p>En g\00E9n\00E9ral, cette information est disponible dans la documentation de l''API REST. Veillez \00E0 indiquer une valeur correcte : si la valeur est incorrecte, des lignes seront manquantes ou dupliqu\00E9es lors de l''extraction des donn\00E9es par &PRODUCT_NAME. ')
||unistr('\00E0 partir de l''API REST.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Param\00E8tre d''URL de d\00E9calage de ligne')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>'lignes'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le param\00E8tre d''URL pour sp\00E9cifier le <em>d\00E9calage</em>, qui identifie les lignes \00E0 ignorer avant le renvoi de la premi\00E8re ligne.</p>'),
unistr('<p><em>N''ajoutez pas ce param\00E8tre aux <strong>param\00E8tres</strong></em> de source de donn\00E9es REST. &PRODUCT_NAME. l''ajoutera automatiquement lors de l''ex\00E9cution de la demande HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Type de d\00E9calage de ligne')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>D\00E9terminez si le param\00E8tre de <strong>d\00E9calage</strong> indique la <em>quantit\00E9 de lignes \00E0 ignorer</em> ou la <em>premi\00E8re ligne \00E0 extraire</em>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Lignes \00E0 ignorer ')
,p_return_value=>'OFFSET'
,p_help_text=>unistr('La valeur de d\00E9calage indique les lignes \00E0 ignorer. Par exemple, si une valeur de 100 est indiqu\00E9e, l''API REST renvoie les lignes \00E0 partir de l''index 101.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Premi\00E8re ligne \00E0 extraire')
,p_return_value=>'START'
,p_help_text=>unistr('La valeur de d\00E9calage indique la ligne par laquelle commencer l''extraction. Par exemple, si une valeur de 100 est indiqu\00E9e, l''API REST ignore 99 lignes et commence l''extraction \00E0 partir de l''index 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('S\00E9lecteur Contient plus de lignes')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si une API REST renvoie la r\00E9ponse JSON suivante :</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('Le <strong>s\00E9lecteur Contient plus de lignes</strong> est <strong>metadata.pagination.moreRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si l''API REST de r\00E9ponse renvoie des informations indiquant s''il existe des pages suppl\00E9mentaires, fournissez le <em>s\00E9lecteur</em> pour extraire cet attribut.</p>'),
unistr('<p>Vous n''avez pas besoin d''indiquer un <strong>s\00E9lecteur Contient plus de lignes</strong>, mais cela permet \00E0 &PRODUCT_NAME. d''enregistrer des demandes HTTP suppl\00E9mentaires (qui ne renverraient pas de donn\00E9es) lorsque toutes les donn\00E9es ont d\00E9j\00E0 \00E9t\00E9')
||' extraites.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Valeur WHEN Contient plus de lignes'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>D\00E9terminez comment interpr\00E9ter la valeur de l''attribut de r\00E9ponse r\00E9f\00E9renc\00E9 par le <strong>s\00E9lecteur Contient plus de lignes</strong>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Est \00E9gal \00E0')
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('Consid\00E9rez que plus de lignes sont disponibles lorsque l''attribut de r\00E9ponse r\00E9f\00E9renc\00E9 par le <strong>s\00E9lecteur Contient plus de lignes</strong> est \00E9gal \00E0 une valeur.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4413)
,p_display_sequence=>20
,p_display_value=>'N''est pas NULL'
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('Consid\00E9rez que plus de lignes sont disponibles lorsque l''attribut de r\00E9ponse r\00E9f\00E9renc\00E9 par le <strong>s\00E9lecteur Contient plus de lignes</strong> existe et n''est pas vide.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Valeur d''attribut Contient plus de lignes'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p>&PRODUCT_NAME. consid\00E8re que plus de lignes sont disponibles si l''attribut de r\00E9ponse r\00E9f\00E9renc\00E9 par le <strong>s\00E9lecteur Contient plus de lignes</strong> contient cette valeur.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4413)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('S\00E9lecteur du nombre total de lignes')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si l''API REST renvoie la r\00E9ponse JSON suivante :</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('Le <strong>s\00E9lecteur Contient plus de lignes</strong> est <strong>metadata.pagination.totalRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si l''API REST renvoie la <em>quantit\00E9 totale de lignes</em> (sur toutes les pages) dans la r\00E9ponse, fournissez le <em>s\00E9lecteur</em> pour extraire cet attribut.</p>'),
unistr('<p>Vous n''avez pas besoin d''indiquer un <strong>s\00E9lecteur Contient plus de lignes</strong>. Il permet d''afficher la quantit\00E9 totale de lignes contenues dans les composants &PRODUCT_NAME., <em>tant que les donn\00E9es ne sont pas davantage filtr\00E9es</em>.<')
||'/p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>unistr('Adresse g\00E9ocod\00E9e')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ce type d''\00E9l\00E9ment fournit la fonctionnalit\00E9 de g\00E9ocodage (conversion d''une adresse postale en coordonn\00E9es).<p>'),
unistr('<p>Le g\00E9ocodage est r\00E9alis\00E9 par le <em>navigateur</em> via une demande REST effectu\00E9e aupr\00E8s du service de g\00E9ocodage <strong>Oracle eLocation</strong> (elocation.oracle.com). Par cons\00E9quent, le navigateur doit \00EAtre connect\00E9 \00E0 Internet pour que le g\00E9o')
||'codage fonctionne.</p>',
unistr('<p>Les donn\00E9es d''entr\00E9e de g\00E9ocodage proviennent d''autres \00E9l\00E9ments de page, qui sont mis en correspondance avec des parties d''adresse comme la rue, le num\00E9ro de b\00E2timent, le code postal ou la ville. L''application de g\00E9ocodage affiche une fen\00EAtre inst')
||unistr('antan\00E9e avec la liste des correspondances possibles. Une fois que vous avez choisi une correspondance, la valeur du statut de session de l''\00E9l\00E9ment correspond aux coordonn\00E9es de l''adresse au format GeoJSON. Si l''option <strong>Nettoyer l''adresse</stro')
||unistr('ng> est activ\00E9e, les \00E9l\00E9ments de page de partie d''adresse sont remplac\00E9s par les valeurs propres re\00E7ues du service de g\00E9ocodage.</p>'),
unistr('<p>Pour les cas d''utilisation plus simples, le mode <strong>Adresse non structur\00E9e</strong> permet de mettre en correspondance uniquement une zone ou un champ de texte dans lequel les utilisateurs finals saisissent des parties d''adresse, s\00E9par\00E9es par')
||' une virgule. Dans ce cas, le mode <strong>Nettoyer l''adresse</strong> n''est pas disponible.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Mode de correspondance de l''application de g\00E9ocodage')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Le <strong>mode de mise en correspondance</strong> d\00E9termine le degr\00E9 de correspondance entre les attributs d''une adresse saisie et les donn\00E9es utilis\00E9es pour le g\00E9ocodage.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4413)
,p_display_sequence=>10
,p_display_value=>'Exact'
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>Toutes les parties d''adresse fournies doivent correspondre. Toutefois, si le num\00E9ro de b\00E2timent, le nom ou le type de rue ne correspondent pas <em>tous</em>, la premi\00E8re correspondance de la liste suivante est renvoy\00E9e : code postal, ville ou quar')
||unistr('tier et \00E9tat. Par exemple, si le nom de rue est incorrect mais que le code postal indiqu\00E9 est valide, un lieu situ\00E9 dans la zone du code postal est renvoy\00E9.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4413)
,p_display_sequence=>20
,p_display_value=>'Type de rue assoupli'
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>Le <em>type de rue</em> indiqu\00E9 peut \00EAtre diff\00E9rent des donn\00E9es utilis\00E9es pour le g\00E9ocodage. Par exemple, <strong>Main Street</strong> ou <strong>Main Blvd</strong> correspond \00E0 <strong>Main St</strong> s''il n''existe aucune autre rue nomm\00E9e <stron')
||unistr('g>Main Blvd</strong> ou <strong>Main Street</strong> dans la zone concern\00E9e.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Num\00E9ro de b\00E2timent assoupli')
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>Le num\00E9ro de b\00E2timent et le type de rue peuvent \00EAtre diff\00E9rents des donn\00E9es utilis\00E9es pour le g\00E9ocodage. Par exemple, <strong>123 Main St</strong> correspond \00E0 <strong>123 Main Lane</strong> et \00E0 <strong>124 Main St</strong> tant qu''il n''y a pas d')
||unistr('''ambigu\00EFt\00E9 ou d''autres correspondances.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4413)
,p_display_sequence=>40
,p_display_value=>'Nom de rue assoupli'
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>Le <em>nom de base</em> de la rue, du num\00E9ro de b\00E2timent et du type de rue peut \00EAtre diff\00E9rent des donn\00E9es utilis\00E9es pour le g\00E9ocodage. Par exemple, <strong>Pleasant Vale</strong> correspond \00E0 <strong>Pleasant Valley</strong> tant qu''il n''y a pas ')
||unistr('d''ambigu\00EFt\00E9 ou d''autres correspondances dans les donn\00E9es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4413)
,p_display_sequence=>50
,p_display_value=>'Code postal assoupli'
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>Le code postal (si indiqu\00E9), le nom de rue, le type de rue et le num\00E9ro de b\00E2timent peuvent \00EAtre diff\00E9rents des donn\00E9es utilis\00E9es pour le g\00E9ocodage.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4413)
,p_display_sequence=>60
,p_display_value=>unistr('Tous les \00E9l\00E9ments assouplis')
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>L''adresse peut se trouver en dehors de la ville indiqu\00E9e tant qu''elle se trouve dans le m\00EAme pays. Inclut \00E9galement les caract\00E9ristiques de <strong>Code postal assoupli</strong>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Afficher les coordonn\00E9es dans une fen\00EAtre instantan\00E9e')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>D\00E9terminez si les coordonn\00E9es d''adresse (longitude, latitude) doivent \00EAtre affrich\00E9es dans la bo\00EEte de dialogue instantan\00E9e des r\00E9sultats de g\00E9ocodage.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Aper\00E7u de la carte')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Indiquez si la pr\00E9visualisation de l''adresse g\00E9ocod\00E9e sur une carte est autoris\00E9e.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Fen\00EAtre instantan\00E9e de r\00E9sultats')
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affichez la carte dans la fen\00EAtre instantan\00E9e de r\00E9sultats de g\00E9ocodage pour que les utilisateurs puissent v\00E9rifier la position avant de s\00E9lectionner un r\00E9sultat.</p>'),
unistr('<p>Pris en charge uniquement lorsque l''option Afficher en tant que - Vue de grille est activ\00E9e.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4413)
,p_display_sequence=>20
,p_display_value=>unistr('El\00E9ment')
,p_return_value=>'ITEM'
,p_help_text=>unistr('Affichez une carte pr\00E9sentant la localisation de l''adresse au niveau de la position de l''\00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Fond'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Choisissez la carte en arri\00E8re-plan sur laquelle afficher les r\00E9sultats de g\00E9ocodage.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4413)
,p_display_sequence=>5
,p_display_value=>unistr('Valeur par d\00E9faut')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez l''arri\00E8re-plan de carte par d\00E9faut.</p>'),
unistr('<p>Utilise "OpenStreetMap - Clair" ou "OpenStreetMap - Fonc\00E9" pour les th\00E8mes sombres.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4413)
,p_display_sequence=>10
,p_display_value=>'OpenStreetMap - Clair'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base offre un contexte d''emplacement d\00E9taill\00E9 aux donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4413)
,p_display_sequence=>20
,p_display_value=>unistr('OpenStreetMap - Fonc\00E9')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base fonc\00E9e discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4413)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap - Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base claire discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4413)
,p_display_sequence=>40
,p_display_value=>'Carte du monde Oracle'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es de carte HERE. Ce style de carte de base offre un contexte des lieux aux donn\00E9es et en accentue la visualisation.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par Oracle, Etats-Unis.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Hauteur'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixels'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la hauteur (en pixels) de la carte affich\00E9e.</p>'),
unistr('<p>La hauteur par d\00E9faut de la carte est calcul\00E9e en fonction de sa largeur avec un rapport hauteur/largeur de 3:2.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Afficher en tant que'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>S\00E9lectionnez la fa\00E7on dont les r\00E9sultats de g\00E9ocodage sont affich\00E9s.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4413)
,p_display_sequence=>10
,p_display_value=>'Vue de liste'
,p_return_value=>'LIST'
,p_help_text=>unistr('<p>Les r\00E9sultats seront affich\00E9s dans une vue de liste.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4413)
,p_display_sequence=>20
,p_display_value=>'Grille'
,p_return_value=>'GRID'
,p_help_text=>unistr('<p>Les r\00E9sultats seront affich\00E9s dans une vue de grille.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>unistr('Adresse structur\00E9e')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indique si les parties d''une adresse sont fournies au service de g\00E9ocodage de mani\00E8re <em>structur\00E9e</em> ou <em>d\00E9structur\00E9e</em>.</p>'),
unistr('<p>Avec la mani\00E8re structur\00E9e, les \00E9l\00E9ments de page explicites sont mis en correspondance avec des parties d''adresse telles que la rue, le code postal, la ville ou la r\00E9gion. Les r\00E9sultats du g\00E9ocodage sont ainsi plus pr\00E9cis, et cela permet \00E9galement')
||unistr(' de r\00E9injecter'),
unistr('les adresses corrig\00E9es dans les \00E9l\00E9ments de page.</p>'),
unistr('<p>Avec la mani\00E8re d\00E9structur\00E9e, seul un \00E9l\00E9ment est utilis\00E9 pour l''adresse compl\00E8te ; les parties sont s\00E9par\00E9es par une virgule. Ce mode ne permet pas de r\00E9injecter les adresses corrig\00E9es dans l''\00E9l\00E9ment de page.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Type de pays'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Choisissez d''utiliser un pays statique pour le g\00E9ocodage ou de d\00E9duire le pays \00E0 partir d''un \00E9l\00E9ment.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4413)
,p_display_sequence=>10
,p_display_value=>'Statique'
,p_return_value=>'STATIC'
,p_help_text=>unistr('<p>Utilisez un pays statique s\00E9lectionn\00E9 dans une liste.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4413)
,p_display_sequence=>20
,p_display_value=>unistr('El\00E9ment')
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>Obtenez le pays \00E0 partir d''un \00E9l\00E9ment de page ou d''application. L''\00E9l\00E9ment doit contenir le code ISO \00E0 deux chiffres d''un pays. </p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Pays'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><strong>US :</strong> Etats-Unis</li>',
'<li><strong>UK :</strong> Royaume-Uni</li>',
'<li><strong>DE :</strong> Allemagne</li>',
'<li><strong>AT :</strong> Autriche</li>',
'</ul>'))
,p_help_text=>unistr('<p>Choisissez un \00E9l\00E9ment d''application ou de page \00E0 partir duquel obtenir le pays pour le g\00E9ocodage. L''\00E9l\00E9ment doit contenir le code ISO \00E0 deux chiffres d''un pays.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Pays'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Choisissez le pays \00E0 utiliser pour le g\00E9ocodage.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>10
,p_display_value=>'Etats-Unis'
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>20
,p_display_value=>'Royaume-Uni'
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>30
,p_display_value=>'Allemagne'
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>40
,p_display_value=>'France'
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>50
,p_display_value=>'Italie '
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>60
,p_display_value=>'Canada'
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>70
,p_display_value=>'Pays-Bas'
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>80
,p_display_value=>'Belgique'
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>90
,p_display_value=>'Autriche'
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>100
,p_display_value=>'Suisse'
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>110
,p_display_value=>'Espagne'
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>120
,p_display_value=>'Portugal'
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>130
,p_display_value=>unistr('F\00E9d\00E9ration de Russie')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>140
,p_display_value=>'Estonie'
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>150
,p_display_value=>'Inde'
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>160
,p_display_value=>'Mexique'
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>170
,p_display_value=>'Australie'
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>180
,p_display_value=>unistr('Br\00E9sil')
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>190
,p_display_value=>'Chili'
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>200
,p_display_value=>unistr('R\00E9publique tch\00E8que')
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>210
,p_display_value=>unistr('Norv\00E8ge')
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>220
,p_display_value=>'Finlande'
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>230
,p_display_value=>'Danemark'
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>240
,p_display_value=>'Hong Kong'
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>250
,p_display_value=>'Irlande'
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>260
,p_display_value=>'Lettonie'
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>270
,p_display_value=>'Roumanie'
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>280
,p_display_value=>'Colombie'
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>290
,p_display_value=>'Pologne'
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>300
,p_display_value=>'Emirats arabes unis'
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>310
,p_display_value=>'Hongrie'
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>320
,p_display_value=>'Arabie saoudite'
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4413)
,p_display_sequence=>330
,p_display_value=>'Afrique du Sud'
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>unistr('El\00E9ment d''adresse')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>Choisissez l''\00E9l\00E9ment contenant des parties d''adresse non structur\00E9es, s\00E9par\00E9es par une virgule.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>unistr('El\00E9ment de rue')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Choisissez l''\00E9l\00E9ment contenant la partie <em>Rue</em> de l''adresse.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>unistr('El\00E9ment de num\00E9ro de b\00E2timent')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Choisissez l''\00E9l\00E9ment contenant la partie <em>Num\00E9ro de b\00E2timent</em> de l''adresse.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('El\00E9ment de sous-zone de ville')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Choisissez l''\00E9l\00E9ment contenant la partie <em>Sous-zone (dans une ville)</em> de l''adresse.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>unistr('El\00E9ment de ville')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Choisissez l''\00E9l\00E9ment contenant la partie <em>Ville</em> de l''adresse.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('El\00E9ment de code postal')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Choisissez l''\00E9l\00E9ment contenant la partie <em>Code postal</em> de l''adresse.</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>unistr('El\00E9ment de r\00E9gion')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Choisissez l''\00E9l\00E9ment contenant la partie <em>R\00E9gion (Etat)</em> de l''adresse.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Nettoyer l''adresse'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Activez ce commutateur pour r\00E9injecter les donn\00E9es d''adresse \00E0 partir du service de g\00E9ocodage dans les \00E9l\00E9ments mis en correspondance.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>unistr('El\00E9ment de vecteur de mise en correspondance')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Choisissez un \00E9l\00E9ment de page dans lequel l''application de g\00E9ocodage renverra le <em>vecteur de mise en correspondance</em>. Le vecteur de mise en correspondance est une cha\00EEne \00E0 17 chiffres qui contient des informations d\00E9taill\00E9es sur la fa\00E7on do')
||unistr('nt chaque attribut d''adresse a \00E9t\00E9 mis en correspondance par rapport aux donn\00E9es utilis\00E9es pour le g\00E9ocodage.</p>'),
'<p><strong>Le vecteur de mise correspondance peut avoir les valeurs suivantes :</strong></p>',
'<ul>',
unistr('<li><p>0 : l''attribut d''entr\00E9e n''est pas NULL et est mis en correspondance avec une valeur non NULL.</p></li>'),
unistr('<li><p>1 : l''attribut d''entr\00E9e est NULL et est mis en correspondance avec une valeur NULL.</p></li>'),
unistr('<li><p>2 : l''attribut d''entr\00E9e n''est pas NULL et est remplac\00E9 par une autre valeur non NULL.</p></li>'),
unistr('<li><p>3 : l''attribut d''entr\00E9e n''est pas NULL et est remplac\00E9 par une valeur NULL.</p></li>'),
unistr('<li><p>4 : l''attribut d''entr\00E9e est NULL et est remplac\00E9 par une valeur non NULL.</p></li>'),
'</ul>',
'<br>',
'<p><strong>Nombres du vecteur de mise correspondance et attribut d''adresse correspondant :</strong></p>',
'<ul>',
unistr('<li><p>3 : point d''adresse (adresse exacte mise en correspondance dans les donn\00E9es utilis\00E9es pour le g\00E9ocodage)</p></li>'),
unistr('<li><p>4 : nom de point d''int\00E9r\00EAt</p></li>'),
unistr('<li><p>5 : num\00E9ro de b\00E2timent</p></li>'),
unistr('<li><p>6 : pr\00E9fixe de rue</p></li>'),
'<li><p>7 : nom de rue</p></li>',
'<li><p>8 : suffixe de rue</p></li>',
'<li><p>9 : type de rue</p></li>',
unistr('<li><p>10 : compl\00E9ment d''adresse</p></li>'),
'<li><p>11 : ville</p></li>',
unistr('<li><p>14 : r\00E9gion</p></li>'),
'<li><p>15 : pays</p></li>',
'<li><p>16 : code postal</p></li>',
unistr('<li><p>17 : compl\00E9ment de code postal</p></li>'),
unistr('<li><p><em>Les autres nombres ne sont pas encore utilis\00E9s.</em></p></li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('D\00E9clencher le g\00E9ocodage')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>D\00E9terminez \00E0 quel moment d\00E9clencher le g\00E9ocodage. Inclut le navigateur qui envoie la demande REST au service de g\00E9ocodage et qui affiche la fen\00EAtre instantan\00E9e avec les correspondances possibles.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4413)
,p_display_sequence=>10
,p_display_value=>'Automatique'
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le g\00E9ocodage est d\00E9clench\00E9 automatiquement avant la soumission de la page.</p>'),
unistr('<p>Si la valeur d''un \00E9l\00E9ment d\00E9pendant a \00E9t\00E9 modifi\00E9e, par exemple la valeur de <em>P1_STREET</em>, et que le g\00E9ocodage n''a pas \00E9t\00E9 ex\00E9cut\00E9 jusqu''\00E0 pr\00E9sent, ou qu''aucune adresse valide n''a \00E9t\00E9 s\00E9lectionn\00E9e, nous nous assurons que le g\00E9ocodage est d\00E9c')
||unistr('lench\00E9 automatiquement. Dans ce cas, nous interrompons le flux de soumission de la page en cours et affichons d''abord une fen\00EAtre instantan\00E9e avec les correspondances possibles. Si l''utilisateur a choisi un r\00E9sultat correspondant, la page peut \00EAtre s')
||unistr('oumise \00E0 nouveau sans autre interruption.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4413)
,p_display_sequence=>20
,p_display_value=>'Action dynamique'
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>Le g\00E9ocodage doit \00EAtre d\00E9clench\00E9 en ajoutant l''action dynamique <em>D\00E9clencher le g\00E9ocodage</em> \00E0 la page.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4413)
,p_display_sequence=>30
,p_display_value=>unistr('S\00E9lecteur jQuery')
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>Le g\00E9ocodage est d\00E9clench\00E9 en fonction d''un \00E9v\00E9nement sur l''\00E9l\00E9ment DOM cibl\00E9 par le s\00E9lecteur. Si un champ d''entr\00E9e est r\00E9f\00E9renc\00E9, le g\00E9ocodage est d\00E9clench\00E9 lors de la <em>modification</em> de l''\00E9l\00E9ment. Si un bouton est r\00E9f\00E9renc\00E9, le g\00E9ocodage ')
||unistr('est d\00E9clench\00E9 lorsque l''utilisateur <em>clique</em> sur le bouton.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('S\00E9lecteur')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ex\00E9cuter le processus lorsque les \00E9l\00E9ments <em>P1_STREET</em> et <em>P1_ZIP_CODE</em> sont modifi\00E9s, s\00E9lecteur jQuery :</p>'),
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>Fournissez le s\00E9lecteur jQuery r\00E9f\00E9ren\00E7ant l''\00E9l\00E9ment qui d\00E9clenche le g\00E9ocodage. Les boutons d\00E9clenchent le g\00E9ocodage lors du <em>clic</em>, alors que d''autres \00E9l\00E9ments le d\00E9clencheront lors de leur <em>modification</em>.</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_name=>'apexgeocoderresponse'
,p_display_name=>unistr('R\00E9ponse de g\00E9ocodage')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4413)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4413)
,p_name=>'apexgeocoderselection'
,p_display_name=>unistr('S\00E9lection de r\00E9sultat')
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>'Filtres intelligents'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>R\00E9gion reposant sur la source de filtres intelligents associ\00E9s, qui fournit aux utilisateurs finals de nombreux filtres utilis\00E9s pour affiner les r\00E9sultats de recherche au moment de l''ex\00E9cution. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4413)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre maximal de boutons de suggestion'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez le nombre maximal de boutons de suggestion \00E0 afficher. Si aucun nombre n''est indiqu\00E9, une valeur par d\00E9faut de 5 sera utilis\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4413)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Plus de filtres de bouton de suggestion'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si les filtres non affich\00E9s en tant que boutons de suggestion peuvent \00EAtre s\00E9lectionn\00E9s via le bouton de menu d\00E9roulant Plus de filtres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4413)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Seuil de nombres compacts'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez une valeur de seuil au-dessus de laquelle les nombres sont affich\00E9s dans un format num\00E9rique compact. Avec ce format, la valeur <strong>1,234</strong> est repr\00E9sent\00E9e par <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4413)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Afficher le nombre total de lignes'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Indiquez l''emplacement d''affichage du nombre total de lignes.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4413)
,p_display_sequence=>10
,p_display_value=>'Non'
,p_return_value=>'N'
,p_help_text=>unistr('Le nombre total de lignes n''est pas affich\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4413)
,p_display_sequence=>20
,p_display_value=>'Oui'
,p_return_value=>'Y'
,p_help_text=>unistr('Le nombre total de lignes est affich\00E9 sous les boutons de suggestion.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4413)
,p_display_sequence=>30
,p_display_value=>unistr('S\00E9lecteur')
,p_return_value=>'E'
,p_help_text=>unistr('Le nombre total de lignes (sans aucun libell\00E9) est affich\00E9 dans l''\00E9l\00E9ment indiqu\00E9 par ce s\00E9lecteur. Vous pouvez ainsi placer le nombre total de lignes presque partout sur la page.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4413)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Libell\00E9 du nombre total de lignes')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Libell\00E9 utilis\00E9 pour le nombre total de lignes. Si aucun libell\00E9 n''est fourni, APEX utilisera le message texte APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4413)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('S\00E9lecteur du nombre total de lignes')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Ceci est le s\00E9lecteur d''un \00E9l\00E9ment de la page sur laquelle la r\00E9gion des filtres intelligents affichera le nombre total de lignes.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4413)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4413)
,p_name=>'facetschange'
,p_display_name=>'Modification des filtres'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4413)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4413)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4413)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4413)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Renvoie une repr\00E9sentation JSON ORDS h\00E9rit\00E9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Activez cette option si le service REST ORDS renvoie des donn\00E9es dans la <em>repr\00E9sentation JSON ORDS h\00E9rit\00E9</em>.')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>'Rechercher'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un champ de texte, permettant \00E0 l''utilisateur final de rechercher les entr\00E9es de liste des facets dans la r\00E9gion Recherche \00E0 facets. Une r\00E9gion Recherche \00E0 facets ne prend en charge qu''un facet de recherche, qui sera toujours en haut de la li')
||unistr('ste des facets, quelle que soit la s\00E9quence.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4413)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type de recherche'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4413)
,p_display_sequence=>10
,p_display_value=>'Recherche de lignes'
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4413)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4413)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Champ d''entr\00E9e')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Partie sup\00E9rieure de la r\00E9gion Recherche \00E0 facets')
,p_return_value=>'FACET'
,p_help_text=>unistr('Un champ de recherche sera affich\00E9 dans la partie sup\00E9rieure de la r\00E9gion Recherche \00E0 facets, au-dessus des facets.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4413)
,p_display_sequence=>20
,p_display_value=>unistr('El\00E9ment de page externe')
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('L''attribut El\00E9ment de page externe associ\00E9 permet de s\00E9lectionner un \00E9l\00E9ment de page \00E0 utiliser comme champ de recherche de la r\00E9gion Recherche \00E0 facets.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4413)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ment de page externe')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4413)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Champ de recherche r\00E9duit')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si le champ de recherche des filtres intelligents est initialement r\00E9duit.')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>'Carte'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4413)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4413)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4413)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4413)
,p_name=>'spatialmapchanged'
,p_display_name=>unistr('Carte modifi\00E9e')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4413)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4413)
,p_name=>'spatialmapclick'
,p_display_name=>unistr('Carte s\00E9lectionn\00E9e')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4413)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4413)
,p_name=>'spatialmapinitialized'
,p_display_name=>unistr('Carte initialis\00E9e')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4413)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4413)
,p_name=>'spatialmapobjectclick'
,p_display_name=>unistr('Objet de carte s\00E9lectionn\00E9')
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>'Panneau'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('R\00E9gion de panneau qui prend en charge diff\00E9rentes sources de donn\00E9es. Cette r\00E9gion de panneau contient des informations sur la source de donn\00E9es (qui peut \00EAtre locale, distante ou fournie par un service REST) et des \00E9l\00E9ments de page lui sont affect\00E9s')
||unistr('. Chaque \00E9l\00E9ment est affect\00E9 \00E0 une r\00E9gion de panneau et \00E0 une r\00E9gion d''affichage.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4413)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4413)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>'Panneau - Traitement de ligne automatique (DML)'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus pour ins\00E9rer, mettre \00E0 jour ou supprimer des lignes d''une r\00E9gion de panneau.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type de cible'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la technique de traitement de ligne utilis\00E9e pour enregistrer les modifications de donn\00E9es apport\00E9es \00E0 la r\00E9gion de panneau.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Source de r\00E9gion')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les insertions, mises \00E0 jour et suppressions utilisent la requ\00EAte SQL source de r\00E9gion.</p>'),
unistr('<p>Remarque : assurez-vous que le param\00E8tre <strong>Requ\00EAte uniquement</strong> est d\00E9fini sur <code>Oui</code> pour les colonnes ne pouvant pas \00EAtre ins\00E9r\00E9es ou mises \00E0 jour, afin de les exclure du traitement.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4413)
,p_display_sequence=>20
,p_display_value=>'Table/vue'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les insertions, mises \00E0 jour et suppressions utilisent une table ou vue diff\00E9rente de celle d\00E9finie dans la requ\00EAte SQL source de r\00E9gion.'),
unistr('Par exemple, la requ\00EAte SQL extrait des donn\00E9es \00E0 partir d''une vue non modifiable ou d''une jointure de tables, et le traitement DML doit \00EAtre ex\00E9cut\00E9 par rapport \00E0 une vue modifiable ou \00E0 une table de base unique.</p>'),
unistr('<p>Remarque : assurez-vous que le param\00E8tre <strong>Requ\00EAte uniquement</strong> est d\00E9fini sur <code>Oui</code> pour les colonnes ne pouvant pas \00EAtre ins\00E9r\00E9es ou mises \00E0 jour, afin de les exclure du traitement.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4413)
,p_display_sequence=>30
,p_display_value=>'Code PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le traitement est fond\00E9 sur un code PL/SQL personnalis\00E9. Cette option permet d''ex\00E9cuter tout code PL/SQL pour impl\00E9menter la manipulation de donn\00E9es dans la base de donn\00E9es sous-jacente.</p>'),
unistr('<p>Choisissez cette option lors de l''utilisation de packages de base de donn\00E9es, comme les API de table ou les appels aux services Web RESTful, afin d''impl\00E9menter une logique applicative.</p>'),
unistr('<p>Remarque : le code PL/SQL est appel\00E9 pour chaque ligne ins\00E9r\00E9e, mise \00E0 jour ou supprim\00E9e.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4413)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Code PL/SQL pour ins\00E9rer/mettre \00E0 jour/supprimer')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le code PL/SQL pour traiter chaque ligne de donn\00E9es manipul\00E9e dans la r\00E9gion de panneau.</p>'),
unistr('<p>Utilisez le nom de colonne en tant que variable attach\00E9e pour acc\00E9der \00E0 la valeur d''une colonne. La variable syst\00E8me <code>APEX$ROW_STATUS</code> renvoie le statut d''une ligne et peut \00EAtre utilis\00E9e pour v\00E9rifier si la ligne a \00E9t\00E9 cr\00E9\00E9e, mise \00E0 jou')
||unistr('r ou supprim\00E9e (reportez-vous \00E0 l''exemple ci-dessous pour d\00E9couvrir comment le v\00E9rifier).</p>'),
unistr('<p><em>Remarque :</em> si les colonnes de cl\00E9 primaire sont remplies par un d\00E9clencheur ou dans le code PL/SQL, les nouvelles valeurs doivent \00EAtre affect\00E9es aux variables attach\00E9es des colonnes de cl\00E9 primaire, car &PRODUCT_NAME. utilise ces valeurs ')
||unistr('pour extraire la ligne apr\00E8s une insertion ou une mise \00E0 jour.</p>'),
unistr('<p>Oracle recommande d''appeler des proc\00E9dures ou des fonctions dans un package PL/SQL, afin de faciliter la r\00E9utilisation et la mise \00E0 jour.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Emp\00EAcher les pertes de mise \00E0 jour')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si le traitement doit v\00E9rifier que les mises \00E0 jour ne sont pas perdues lorsque plusieurs utilisateurs mettent \00E0 jour le m\00EAme enregistrement de base de donn\00E9es.</p> '),
unistr('<p>Les pertes de mise \00E0 jour surviennent lorsque deux personnes ou plus essaient de mettre \00E0 jour les m\00EAmes donn\00E9es. La derni\00E8re mise \00E0 jour \00E9crase les mises \00E0 jour effectu\00E9es par le premier utilisateur ayant enregistr\00E9 des modifications. Pour \00E9viter')
||unistr(' cela, les mises \00E0 jour peuvent comparer les valeurs de colonne existantes dans la base de donn\00E9es avec les valeurs extraites lors de la premi\00E8re interrogation de la ligne.</p>'),
'<p>Par exemple :',
'  <ol>',
unistr('    <li>L''utilisateur A interroge les enregistrements d''employ\00E9s (EMP).</li>'),
unistr('    <li>L''utilisateur B interroge les m\00EAmes enregistrements d''employ\00E9s.</li>'),
unistr('    <li>L''utilisateur B met \00E0 jour les d\00E9tails des employ\00E9s pour EMPNO = 7839 et applique (valide) les modifications apport\00E9es \00E0 la base de donn\00E9es.</li>'),
unistr('    <li>L''utilisateur A met \00E0 jour les d\00E9tails des employ\00E9s pour EMPNO = 7839 et tente d''appliquer les modifications \00E0 la base de donn\00E9es.</li>'),
'  </ol>',
unistr('Si l''utilisateur A parvient \00E0 mettre \00E0 jour la m\00EAme ligne, les modifications apport\00E9es par l''utilisateur B sont perdues.'),
unistr('Lorsque l''utilisateur A tente d''enregistrer la ligne des employ\00E9s, les donn\00E9es figurant dans la base de donn\00E9es sont diff\00E9rentes de celles initialement interrog\00E9es par l''utilisateur A. Dans l''\00E9tape 1 ci-dessus, les valeurs de colonne interrog\00E9es init')
||unistr('ialement par l''utilisateur A peuvent \00EAtre captur\00E9es. Lors de l''\00E9tape 4 ci-dessus, les valeurs peuvent \00EAtre compar\00E9es aux valeurs en cours dans la base de donn\00E9es. Cette comparaison g\00E9n\00E8re une erreur pour l''utilisateur A, car les valeurs de la base de')
||unistr(' donn\00E9es ont \00E9t\00E9 mises \00E0 jour par l''utilisateur B lors de l''\00E9tape 3. Cela permet d''emp\00EAcher un utilisateur d''\00E9craser les modifications apport\00E9es par un autre utilisateur sur la m\00EAme ligne.</p>'),
unistr('<p>Remarque : la m\00E9thode de d\00E9tection des pertes de mise \00E0 jour est indiqu\00E9e dans la r\00E9gion des attributs de la grille interactive, en fonction du param\00E8tre d\00E9fini pour le <strong>type de mise \00E0 jour perdue</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verrouiller la ligne'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Choisissez de verrouiller ou non chaque ligne \00E0 mettre \00E0 jour ou \00E0 supprimer dans la table sous-jacente avant le traitement de la ligne.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4413)
,p_display_sequence=>10
,p_display_value=>'Oui'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les lignes \00E0 mettre \00E0 jour ou \00E0 supprimer sont verrouill\00E9es \00E0 l''aide de SELECT ... FOR UPDATE afin d''\00E9viter que d''autres transactions soient effectu\00E9es sur la ligne avant la validation (commit) de la transaction.</p>'),
unistr('<p>Remarque : si une erreur est g\00E9n\00E9r\00E9e, par exemple pour les vues modifiables ne prenant pas en charge le verrouillage, vous pouvez utiliser le code PL/SQL pour verrouiller la table directrice.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4413)
,p_display_sequence=>20
,p_display_value=>'Non'
,p_return_value=>'N'
,p_help_text=>unistr('Les lignes ne sont pas verrouill\00E9es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4413)
,p_display_sequence=>30
,p_display_value=>'Code PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('Le code PL/SQL personnalis\00E9 est utilis\00E9 pour verrouiller les lignes jusqu''\00E0 la validation (commit) de la transaction.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Code PL/SQL pour verrouiller une ligne'
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Entrez le code PL/SQL pour verrouiller les lignes de la table de base de donn\00E9es \00E0 mettre \00E0 jour et \00E0 supprimer.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4413)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Renvoyer des cl\00E9s primaires apr\00E8s l''insertion')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les colonnes de cl\00E9 primaire doivent \00EAtre renvoy\00E9es aux \00E9l\00E9ments de r\00E9gion correspondants une fois que la ligne est ins\00E9r\00E9e dans la base de donn\00E9es.'),
unistr('En g\00E9n\00E9ral, cette option doit \00EAtre utilis\00E9e lorsque les colonnes de cl\00E9 primaire sont remplies \00E0 partir d''un d\00E9clencheur de base de donn\00E9es ou d''une colonne d''identit\00E9 Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Remarque : si une erreur est g\00E9n\00E9r\00E9e indiquant que la clause RETURNING INTO n''est pas autoris\00E9e, vous devez d\00E9finir cette option sur Non et pr\00E9-remplir les colonnes de cl\00E9 primaire.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>'Panneau - Initialisation'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus pour initialiser des \00E9l\00E9ments d''une r\00E9gion de panneau. L''initialisation peut consister \00E0 extraire des donn\00E9es \00E0 partir de la source de r\00E9gion, en utilisant les valeurs de cl\00E9 primaire, ou \00E0 simplement initialiser les \00E9l\00E9ments de la r\00E9gion d')
||'e panneau.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4413)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('El\00E9ments de cl\00E9 primaire suivants')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4413)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('El\00E9ments de cl\00E9 primaire pr\00E9c\00E9dents')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4413)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Ligne en cours/Nombre total d''\00E9l\00E9ments')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>unistr('Chargement des donn\00E9es')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus permettant de charger des donn\00E9es dans la table ou la collection cible, en fonction de la d\00E9finition de chargement des donn\00E9es indiqu\00E9e.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('D\00E9finition de chargement des donn\00E9es')
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la <strong>d\00E9finition de chargement des donn\00E9es</strong> \00E0 partir de Composants partag\00E9s. Parmi d''autres attributs, la d\00E9finition de chargement des donn\00E9es permet de d\00E9finir la collection ou la table cible, la m\00E9thode de chargement et le')
||unistr(' <em>profil de donn\00E9es</em>. Toutes les informations relatives au nom de colonne, au mapping de colonne et au type de donn\00E9es sont stock\00E9es dans le profil de donn\00E9es.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Type de donn\00E9es source')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez la source des donn\00E9es \00E0 charger.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4413)
,p_display_sequence=>10
,p_display_value=>unistr('El\00E9ment Exploration de fichiers')
,p_return_value=>'FILE'
,p_help_text=>unistr('Choisissez le nom d''un \00E9l\00E9ment d''exploration de fichiers sur la page en cours. APEX charge les donn\00E9es \00E0 partir du fichier choisi.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Nom d''\00E9l\00E9ment Zone de texte')
,p_return_value=>'TEXT'
,p_help_text=>unistr('Choisissez le nom d''un \00E9l\00E9ment de zone de texte contenant des donn\00E9es \00E0 charger.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Requ\00EAte SQL')
,p_return_value=>'SQL_QUERY'
,p_help_text=>unistr('Indiquez une requ\00EAte SQL renvoyant un objet CLOB ou BLOB contenant les donn\00E9es \00E0 charger.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ment Exploration de fichiers')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('Choisissez l''\00E9l\00E9ment d''exploration de fichiers \00E0 partir duquel charger des donn\00E9es. L''\00E9l\00E9ment doit utiliser <strong>APEX_APPLICATION_TEMP_FILES</strong> comme <strong>type de stockage</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('El\00E9ment Zone de texte')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('Choisissez le nom d''un \00E9l\00E9ment de zone de texte contenant des donn\00E9es \00E0 charger.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Requ\00EAte SQL')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>unistr('Indiquez une requ\00EAte SQL renvoyant une ligne et une colonne, et qui contient un objet BLOB ou CLOB \00E0 partir duquel charger des donn\00E9es.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('El\00E9ment de page contenant un nom de feuille XLSX')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un \00E9l\00E9ment de liste de valeurs (LOV) instantan\00E9e ou de liste de s\00E9lection pour afficher les feuilles de calcul disponibles dans le fichier XLSX t\00E9l\00E9charg\00E9 utiliserait la <em>requ\00EAte SQL de liste de valeurs</em> suivante (<strong>PX_FILE</strong> e')
||unistr('st l''\00E9l\00E9ment d''exploration de fichiers utilis\00E9 pour t\00E9l\00E9charger le fichier XLSX).</p><p>L''attribut <strong>SHEET_FILE_NAME</strong> doit \00EAtre utilis\00E9 en tant que colonne renvoy\00E9e LOV.</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>Indiquez un \00E9l\00E9ment de page contenant un nom de feuille de calcul pour le chargement des fichiers XLSX. Les donn\00E9es sont charg\00E9es \00E0 partir de la feuille de calcul sp\00E9cifi\00E9e. Si rien n''est indiqu\00E9, APEX charge les donn\00E9es de la premi\00E8re feuille de ')
||unistr('calcul du fichier XLSX.</p><p>G\00E9n\00E9ralement, les \00E9l\00E9ments de <em>liste de s\00E9lection</em> sont utilis\00E9s pour cela : dans la <em>requ\00EAte de liste de valeurs (LOV)</em>, utilisez <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong> afin d''extraire les n')
||'oms internes et d''affichage de la feuille de calcul.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('El\00E9ment de nombre de lignes trait\00E9es')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Choisissez un \00E9l\00E9ment de page dans lequel stocker le nombre de lignes t\00E9l\00E9charg\00E9es (et trait\00E9es). La valeur est disponible \00E0 la fin du processus de chargement des donn\00E9es et peut \00EAtre affich\00E9e dans des messages.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4413)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('El\00E9ment de nombre de lignes d''erreur')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Choisissez un \00E9l\00E9ment de page dans lequel stocker le nombre de lignes d''erreur. La valeur est disponible \00E0 la fin du processus de chargement des donn\00E9es et peut \00EAtre affich\00E9e dans des messages.')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>'Plage'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Affiche un \00E9l\00E9ment avec un s\00E9lecteur de liste de valeurs int\00E9gr\00E9. Le facet prend en charge la s\00E9lection unique ou multiple, et l''entr\00E9e manuelle. Pour la prise en charge de la s\00E9lection unique, affiche plusieurs valeurs sous forme de groupe de bou')
||unistr('tons d''option, permettant \00E0 l''utilisateur final de s\00E9lectionner une seule valeur. Pour la prise en charge de la s\00E9lection multiple, affiche plusieurs valeurs sous forme de cases \00E0 cocher, permettant \00E0 l''utilisateur final de s\00E9lectionner des valeurs m')
||unistr('ultiples. Pour la prise en charge de l''entr\00E9e manuelle, des champs de texte sont affich\00E9s sous le facet, permettant \00E0 l''utilisateur final d''entrer manuellement la plage de valeurs \00E0 utiliser pour le filtrage de la r\00E9gion filtr\00E9e.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4413)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('S\00E9lectionner plusieurs fichiers')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si le facet prend en charge la s\00E9lection de plusieurs entr\00E9es de liste. Avec la valeur <strong>Activ\00E9</strong>, le facet sera affich\00E9 sous forme de cases \00E0 cocher pour prendre en charge la s\00E9lection multiple. Avec la valeur <strong>D\00E9sactiv\00E9')
||unistr('</strong>, le facet sera affich\00E9 sous forme de groupe de boutons d''option pour prendre en charge la s\00E9lection unique.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4413)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Entr\00E9e manuelle')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si le facet de plage prend en charge l''entr\00E9e manuelle. Avec la valeur <strong>Activ\00E9</strong>, des champs de texte seront affich\00E9s sous le facet, permettant \00E0 l''utilisateur final d''entrer manuellement la plage de valeurs \00E0 utiliser pour le ')
||unistr('filtrage de la r\00E9gion filtr\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4413)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Texte de plage'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Entrez le texte \00E0 afficher entre les champs de texte Entr\00E9e manuelle.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4413)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Libell\00E9 en cours')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('0% \00E0 %1')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4413)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Libell\00E9 en cours - Ouverture maximale')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Au-dessus de %0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4413)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Libell\00E9 en cours - Ouverture minimale')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'En dessous de %0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4413)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4413)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Liste de valeurs bas\00E9e sur une requ\00EAte SQL</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Liste de valeurs avec les m\00EAmes valeurs d''affichage et renvoy\00E9es</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Remarque : lorsque vous s\00E9lectionnez la m\00EAme colonne pour les valeurs d''affichage et renvoy\00E9es, utilisez un alias de colonne.</p>'),
'</dd>',
unistr('<dt>Liste de valeurs avec variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>'Afficher la carte'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche une carte reposant sur des coordonn\00E9es au format de point GeoJSON.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Fond'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la carte en arri\00E8re-plan \00E0 utiliser.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Valeur par d\00E9faut')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez l''arri\00E8re-plan de carte par d\00E9faut.</p>'),
unistr('<p>Utilise "OpenStreetMap - Clair" ou "OpenStreetMap - Fonc\00E9" pour les th\00E8mes sombres.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4413)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap - Clair'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base offre un contexte d''emplacement d\00E9taill\00E9 aux donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4413)
,p_display_sequence=>30
,p_display_value=>unistr('OpenStreetMap - Fonc\00E9')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base fonc\00E9e discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4413)
,p_display_sequence=>40
,p_display_value=>'OpenStreetMap - Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base claire discr\00E8te reposant sur des donn\00E9es OpenStreetMap. Ce style de carte de base accentue la visualisation des donn\00E9es.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par des contributeurs KlokanTech.com et OpenMapTiles, et d\00E9riv\00E9s des styles Mapbox ouverts. Conc\00E9d\00E9s sous licence BSD/CC-BY. La cartographie de Stamen Design est conc\00E9d\00E9e sous licence CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Afficher sur GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4413)
,p_display_sequence=>50
,p_display_value=>'Carte du monde Oracle'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Carte de base \00E0 usage g\00E9n\00E9ral reposant sur des donn\00E9es de carte HERE. Ce style de carte de base offre un contexte des lieux aux donn\00E9es et en accentue la visualisation.</p>'),
unistr('<p>Sch\00E9ma et d\00E9finitions de style fournis par Oracle, Etats-Unis.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Niveau de zoom'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indiquez le niveau de zoom auquel la couche devient visible.</p>',
'<p>',
'Valeur minimale : 1<br>',
'Valeur maximale : 18',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Afficher le marqueur'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('<p>Indiquez si un marqueur doit \00EAtre affich\00E9.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Couleur de marqueur'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indiquez la couleur de remplissage du marqueur.</p>',
unistr('<p>La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML. La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et z')
||unistr('z repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement. Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, et chacun repr\00E9sente une valeur d''octet de 8')
||' bits pour le rouge, le vert et le bleu, respectivement.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Info-bulle'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le texte d''info-bulle d''un marqueur affich\00E9.</p>'),
unistr('<p>L''attribut d''info-bulle prend en charge les directives de mod\00E8le HTML et APEX.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Afficher les contr\00F4les de carte')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les contr\00F4les de carte doivent \00EAtre affich\00E9s.</p>'),
unistr('<p>Permet d''ajouter les contr\00F4les de zoom et de rotation \00E0 la carte.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Carte interactive'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la carte doit \00EAtre interactive.</p>'),
unistr('<p>Si l''option est d\00E9finie sur Non, la carte cr\00E9\00E9e est statique et n''est pas interactive.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4413)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Hauteur'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixels'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la hauteur (en pixels) de la carte affich\00E9e.</p>'),
unistr('<p>La hauteur par d\00E9faut de la carte est calcul\00E9e en fonction de sa largeur avec un rapport hauteur/largeur de 3:2.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>unistr('Requ\00EAte SQL Existe')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Requ\00EAte entra\00EEnant le succ\00E8s du mod\00E8le d''autorisation lorsqu''elle renvoie au moins une ligne ou l''\00E9chec du mod\00E8le si aucune ligne n''est renvoy\00E9e.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4413)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Requ\00EAte SQL')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>unistr('Requ\00EAte entra\00EEnant le succ\00E8s du mod\00E8le d''autorisation lorsqu''elle renvoie au moins une ligne ou l''\00E9chec du mod\00E8le si aucune ligne n''est renvoy\00E9e.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>unistr('Requ\00EAte SQL N''existe pas.')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Requ\00EAte entra\00EEnant le succ\00E8s du mod\00E8le d''autorisation lorsqu''elle ne renvoie aucune ligne ou l''\00E9chec du mod\00E8le si au moins une ligne est renvoy\00E9e.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4413)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Requ\00EAte SQL')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('Requ\00EAte entra\00EEnant l''\00E9chec du mod\00E8le d''autorisation lorsqu''elle renvoie au moins une ligne ou le succ\00E8s du mod\00E8le si aucune ligne n''est renvoy\00E9e.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>unistr('L''\00E9l\00E9ment est NULL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('La valeur de l''\00E9l\00E9ment est NULL.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4413)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('El\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('L''autorisation r\00E9ussit si la valeur de cet \00E9l\00E9ment est NULL ; autrement, elle \00E9choue.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>unistr('L''\00E9l\00E9ment est NOT NULL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('La valeur de l''\00E9l\00E9ment est NOT NULL.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4413)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('El\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorisation r\00E9ussit si la valeur de cet \00E9l\00E9ment est NOT NULL ; autrement, elle \00E9choue')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('Fonction PL/SQL renvoyant une valeur bool\00E9enne')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Corps de fonction PL/SQL renvoyant la valeur True ou False. La valeur False entra\00EEne l''\00E9chec du mod\00E8le d''autorisation. La valeur True permet le succ\00E8s du mod\00E8le.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4413)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Corps de fonction PL/SQL'
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Corps de fonction PL/SQL renvoyant la valeur True ou False. La valeur False entra\00EEne l''\00E9chec du mod\00E8le d''autorisation. La valeur True permet le succ\00E8s du mod\00E8le.'),
'<p/>',
'Exemple :',
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>unistr('La pr\00E9f\00E9rence correspond \00E0 la valeur')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('La valeur de la pr\00E9f\00E9rence correspond \00E0 la valeur.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4413)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nom de pr\00E9f\00E9rence')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorisation r\00E9ussit si la valeur de cette pr\00E9f\00E9rence est \00E9gale \00E0 la valeur situ\00E9e dans le champ ci-dessous; elle \00E9choue si ces valeurs sont diff\00E9rentes')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4413)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'voir ci-dessus'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>unistr('La pr\00E9f\00E9rence ne correspond PAS \00E0 la valeur')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('La valeur de la pr\00E9f\00E9rence ne correspond pas \00E0 la valeur.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4413)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nom de pr\00E9f\00E9rence')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorisation r\00E9ussit si la valeur de cette pr\00E9f\00E9rence est diff\00E9rente de la valeur situ\00E9e dans le champ ci-dessous ; elle \00E9choue si ces valeurs sont \00E9gales')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4413)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'voir ci-dessus'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>unistr('L''\00E9l\00E9ment correspond \00E0 la valeur')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('La valeur de l''\00E9l\00E9ment correspond \00E0 la valeur.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4413)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('El\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorisation r\00E9ussit si la valeur de cet \00E9l\00E9ment est \00E9gale \00E0 la valeur situ\00E9e dans le champ ci-dessous ; elle \00E9choue si ces valeurs sont diff\00E9rentes')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4413)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'voir ci-dessus'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>unistr('L''\00E9l\00E9ment ne correspond PAS \00E0 la valeur')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La valeur de l''\00E9l\00E9ment ne correspond pas \00E0 la valeur.</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4413)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('El\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('L''autorisation r\00E9ussit si la valeur de cet \00E9l\00E9ment est diff\00E9rente de la valeur situ\00E9e dans le champ ci-dessous ; elle \00E9choue si ces valeurs sont \00E9gales')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4413)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'voir ci-dessus'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('D\00E9clencher le g\00E9ocodage')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>D\00E9clenchez manuellement la recherche de g\00E9ocodage d''un \00E9l\00E9ment d''<em>adresse g\00E9ocod\00E9e</em>.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>'Connexion sociale'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Prend en charge l''authentification via Google, Facebook, et des fournisseurs d''identit\00E9s g\00E9n\00E9riques OpenID Connect et OAuth2.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Banque d''informations d''identification'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la banque d''informations d''identification qui contient la cl\00E9 secr\00E8te et l''ID de client du fournisseur d''authentification.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Fournisseur d''authentification'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_display_sequence=>10
,p_display_value=>'Fournisseur OpenID Connect'
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('Utilisez un fournisseur d''authentification reposant sur OpenID Connect. Vous devez saisir l''URL de rep\00E9rage OpenID du fournisseur ci-dessous.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Fournisseur OAuth2 g\00E9n\00E9rique')
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('Utilisez un fournisseur d''authentification OAuth2. Vous devez saisir les URL pour les points d''extr\00E9mit\00E9 d''authentification, de token et d''informations utilisateur ci-dessous.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('Utilisez des param\00E8tres pr\00E9d\00E9finis pour la connexion \00E0 Google.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('Utilisez des param\00E8tres pr\00E9d\00E9finis pour la connexion \00E0 Facebook.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('URL de rep\00E9rage')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>unistr('Saisissez l''URL de rep\00E9rage du fournisseur OpenID Connect.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'URL endpoint d''autorisation'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Saisissez l''URL endpoint d''autorisation du fournisseur OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'URL endpoint de jeton'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Saisissez l''URL endpoint de token du fournisseur OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'URL endpoint d''informations utilisateur'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Saisissez l''URL endpoint d''informations utilisateur du fournisseur OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Port\00E9e')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'email,profile'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Entrez la liste des droits \00E0 demander pour l''utilisateur connect\00E9, s\00E9par\00E9s par des virgules.'),
unistr('Les valeurs acceptables d\00E9pendent du fournisseur d''authentification.'),
unistr('Pour OpenID Connect et Google, Application Express ajoute automatiquement la port\00E9e "openid".'),
'Le fournisseur d''authentification renvoie des attributs utilisateur en fonction de ces droits.',
unistr('Vous pouvez mettre en correspondance les attributs avec les \00E9l\00E9ments d''application, ou utiliser une proc\00E9dure post-authentification pour traiter ces attributs, \00E0 l''aide des fonctions APEX_JSON.GET_%.'),
'</p><p>',
unistr('Les port\00E9es et les attributs (aussi appel\00E9s demandes) OpenID Connect sont r\00E9pertori\00E9s \00E0 l''adresse suivante : https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Param\00E8tres d''URI d''authentification')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('Saisissez des param\00E8tres facultatifs pour l''URI d''authentification. Consultez la documentation du fournisseur d''authentification pour conna\00EEtre les param\00E8tres pris en charge.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Nom utilisateur'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez l''attribut contenant le nom utilisateur ou du texte libre avec des substitutions d''attribut d\00E9limit\00E9es par des symboles "#".'),
unistr('Vous pouvez faire r\00E9f\00E9rence au nom du mod\00E8le d''authentification avec #APEX_AUTH_NAME#.'),
unistr('Par exemple, "#email# (#APEX_AUTH_NAME#)" g\00E9n\00E9rera un nom utilisateur compos\00E9 de l''adresse \00E9lectronique, suivie de " (", puis du nom du mod\00E8le d''authentification, et enfin de ")". Exemple : "jane.doe@example.com (Google)".'),
'</p><p>',
unistr('Consultez la documentation du fournisseur d''authentification pour conna\00EEtre les attributs pris en charge.'),
unistr('Vous devez d\00E9finir la port\00E9e requise, sans quoi le fournisseur d''authentification n''enverra pas l''ensemble des attributs.'),
unistr('Les port\00E9es et les attributs (aussi appel\00E9s demandes) OpenID Connect sont r\00E9pertori\00E9s \00E0 l''adresse suivante : https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Attributs utilisateur suppl\00E9mentaires')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'link,picture,email'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Entrez la liste des attributs de donn\00E9es utilisateur suppl\00E9mentaires, s\00E9par\00E9s par des virgules.'),
'</p><p>',
unistr('Consultez la documentation du fournisseur d''authentification pour conna\00EEtre les attributs pris en charge.'),
unistr('Vous devez d\00E9finir la port\00E9e requise, sans quoi le fournisseur d''authentification n''enverra pas l''ensemble des attributs.'),
unistr('Les port\00E9es et les attributs (aussi appel\00E9s demandes) OpenID Connect sont r\00E9pertori\00E9s \00E0 l''adresse suivante : https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>'Mettre le nom utilisateur en majuscules'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si les valeurs d''attribut du nom utilisateur doivent \00EAtre converties en majuscules.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('M\00E9thode d''authentification de token')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Entrez la m\00E9thode de transmission au serveur de l''ID client et de la cl\00E9 secr\00E8te client des informations d''identification.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4413)
,p_display_sequence=>10
,p_display_value=>'Authentification de base'
,p_return_value=>'BASIC'
,p_help_text=>unistr('Envoyez l''ID client et la cl\00E9 secr\00E8te client dans un en-t\00EAte Authentification de base.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4413)
,p_display_sequence=>22
,p_display_value=>'ID client et authentification de base dans le corps'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>unistr('Envoyez l''ID client et la cl\00E9 secr\00E8te client dans un en-t\00EAte Authentification de base, et envoyez \00E9galement l''ID client dans le corps de la demande.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4413)
,p_display_sequence=>30
,p_display_value=>unistr('ID client et cl\00E9 secr\00E8te client')
,p_return_value=>'BODY'
,p_help_text=>unistr('Envoyez l''ID client et la cl\00E9 secr\00E8te client dans le corps de la demande.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4413)
,p_display_sequence=>40
,p_display_value=>'ID de client dans le corps'
,p_return_value=>'CLID'
,p_help_text=>'Envoyez uniquement l''ID de client dans le corps de la demande.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>unistr('V\00E9rifier les attributs')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si l''option est activ\00E9e, &PRODUCT_NAME. recherche un attribut "#name#_verified" (par exemple : "email_verified" pour l''attribut "email").'),
unistr('OpenID \00E9tablit que le fournisseur d''identit\00E9s envoie <code>"#name#_verified":false</code> pour les attributs "email" et "phone_number" non v\00E9rifi\00E9s.'),
unistr('&PRODUCT_NAME. ignore les attributs non v\00E9rifi\00E9s.'),
unistr('Par cons\00E9quent, l''authentification \00E9choue si "#name#" est l''attribut du nom utilisateur.'),
'</p><p>',
unistr('Si le fournisseur d''identit\00E9s laissait des individus malveillants saisir des donn\00E9es non v\00E9rifi\00E9es utilis\00E9es par l''application pour l''authentification,'),
unistr('ces individus pourraient emprunter l''identit\00E9 d''autres utilisateurs de l''application.'),
unistr('La v\00E9rification V\00E9rifier les attributs permet d''\00E9viter ce probl\00E8me.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4413)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>unistr('Mettre en correspondance des attributs utilisateur suppl\00E9mentaires avec')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez la liste des noms d''\00E9l\00E9ment d''application (s\00E9par\00E9s par des virgules) avec lesquels les <em>attributs utilisateur suppl\00E9mentaires</em> sont mis en correspondance. Par exemple, si vous d\00E9finissez'),
'<ul>',
unistr('<li>Attributs utilisateur suppl\00E9mentaires : email,profile,picture</li>'),
unistr('<li>Mettre en correspondance les attributs utilisateur suppl\00E9mentaires avec : G_EMAIL,G_PROFILE,G_PICTURE</li>'),
'</ul>, ',
unistr('APEX enregistre automatiquement les valeurs d''attribut dans le statut de session pour les \00E9l\00E9ments correspondants.')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>'Vue de liste'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche les donn\00E9es dans une liste facile \00E0 parcourir. Vous pouvez \00E9galement incorporer de nombreuses fonctionnalit\00E9s afin d''optimiser la vue de liste.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Fonctionnalit\00E9s')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez les fonctionnalit\00E9s activ\00E9es pour cette vue de liste.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_display_sequence=>5
,p_display_value=>unistr('Formatage avanc\00E9')
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_display_sequence=>10
,p_display_value=>'Afficher l''image'
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Afficher le s\00E9parateur de liste')
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_display_sequence=>50
,p_display_value=>unistr('Contient un bouton fractionn\00E9')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_display_sequence=>55
,p_display_value=>'Activer la recherche'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_display_sequence=>65
,p_display_value=>unistr('Est une vue de liste imbriqu\00E9e')
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_display_sequence=>70
,p_display_value=>unistr('Liste incrust\00E9e')
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Colonne de texte'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('S\00E9lectionnez la colonne de base de donn\00E9es incluant le contenu principal de l''entr\00E9e de vue de liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Attributs de liste'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Le client cr\00E9e des diviseurs \00E0 partir du texte de l''\00E9l\00E9ment de liste</dt>'),
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
unistr('<dt>Modifier l''ic\00F4ne</dt>'),
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>Modifier l''ic\00F4ne du bouton fractionn\00E9</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Saisissez des attributs suppl\00E9mentaires \00E0 d\00E9finir sur l''\00E9l\00E9ment de liste. Reportez-vous aux exemples pour identifier certains attributs qui ont une incidence sur la vue de liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Attributs d''entr\00E9e de liste')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>D\00E9finir une ic\00F4ne de lien d''entr\00E9e de liste \00E0 supprimer.</dt>'),
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Saisissez des attributs suppl\00E9mentaires \00E0 d\00E9finir sur l''\00E9l\00E9ment de liste. Reportez-vous aux exemples pour identifier certains attributs qui ont une incidence sur la vue de liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Formatage de texte'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher le nom et, au-dessous, la date d''embauche de l''employ\00E9</dt>'),
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Hire date: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le balisage HTML utilis\00E9 pour afficher le contenu principal d''une entr\00E9e de vue de liste.</p>'),
unistr('<p>Pour r\00E9f\00E9rencer les valeurs de colonne de l''instruction SQL de vue de liste, utilisez une syntaxe de substitution.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Colonne d''informations suppl\00E9mentaires')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('S\00E9lectionnez la colonne de base de donn\00E9es contenant les informations suppl\00E9mentaires sur l''entr\00E9e de vue de liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Formatage des informations suppl\00E9mentaires')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Afficher le salaire en gras</dt>',
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le balisage HTML utilis\00E9 pour afficher les informations suppl\00E9mentaires sur une entr\00E9e de vue de liste.</p>'),
unistr('<p>Pour r\00E9f\00E9rencer les valeurs de colonne de l''instruction SQL de vue de liste, utilisez une syntaxe de substitution.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Colonne de d\00E9compte')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la colonne de base de donn\00E9es contenant la valeur \00E0 afficher dans la bulle de d\00E9compte.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Type d''image'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez le type d''image affich\00E9e et l''emplacement \00E0 partir duquel elle est lue. L''image affich\00E9e peut correspondre \00E0 une ic\00F4ne (16 x 16) ou \00E0 une miniature (80 x 80). La source de l''image peut \00EAtre une colonne BLOB de base de donn\00E9es ou une URL ')
||'pointant vers un fichier statique.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Ic\00F4ne stock\00E9e dans la colonne BLOB')
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Ic\00F4ne lue \00E0 partir de l''URL')
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4413)
,p_display_sequence=>40
,p_display_value=>unistr('Image stock\00E9e dans la colonne BLOB')
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4413)
,p_display_sequence=>50
,p_display_value=>unistr('Image lue \00E0 partir de l''URL')
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Colonne BLOB d''image'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('S\00E9lectionnez la colonne de base de donn\00E9es de type BLOB contenant l''image.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Colonne 1 de cl\00E9 primaire d''image')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('S\00E9lectionnez la colonne de cl\00E9 primaire ou une colonne de base de donn\00E9es unique utilis\00E9e pour rechercher l''image.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Colonne 2 de cl\00E9 primaire d''image')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('S\00E9lectionnez une seconde colonne de cl\00E9 primaire ou une colonne de base de donn\00E9es unique utilis\00E9e pour rechercher l''image.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Colonne d''URL d''image'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>unistr('S\00E9lectionnez la colonne de base de donn\00E9es contenant l''URL pointant vers l''ic\00F4ne/l''image.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Colonne de s\00E9parateur de liste')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('S\00E9lectionnez la colonne de base de donn\00E9es contenant le s\00E9parateur. Chaque fois que la valeur du s\00E9parateur est modifi\00E9e, un nouveau s\00E9parateur est affich\00E9 parmi les entr\00E9es de vue de liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Formatage de s\00E9parateur de liste')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher le nom du service et le nombre d''employ\00E9s sous forme de badge</dt>'),
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le balisage HTML utilis\00E9 pour afficher le s\00E9parateur d''une vue de liste.</p>'),
unistr('<p>Pour r\00E9f\00E9rencer les valeurs de colonne de l''instruction SQL de vue de liste, utilisez une syntaxe de substitution.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Cible de lien'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Saisissez la page cible \00E0 appeler lorsque l''utilisateur clique sur une entr\00E9e de liste.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('Cible de bouton fractionn\00E9')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Saisissez la page cible \00E0 appeler lorsque l''utilisateur clique sur une entr\00E9e de liste.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'Type de recherche'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la m\00E9thode de recherche.</p>'),
unistr('<p>Les recherches c\00F4t\00E9 client sont ex\00E9cut\00E9es imm\00E9diatement, d\00E8s que l''utilisateur commence \00E0 saisir du texte. Pour toutes les recherches bas\00E9es sur le serveur, l''utilisateur doit appuyer sur Entr\00E9e pour afficher les r\00E9sultats de la recherche. Seules ')
||unistr('les recherches bas\00E9es sur le serveur prennent en compte les attributs de globalisation de comparaison des valeurs alphanum\00E9riques d\00E9finis pour l''application.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4413)
,p_display_sequence=>20
,p_display_value=>unistr('C\00F4t\00E9 client')
,p_return_value=>'CLIENT'
,p_help_text=>unistr('Pour effectuer une recherche avec un navigateur, toutes les entr\00E9es de vue de liste doivent \00EAtre charg\00E9es dans ce dernier (l''attribut Nombre de lignes extraites n''est pas pris en compte dans ce cas). Utilisez cette option de recherche pour un petit n')
||unistr('ombre d''entr\00E9es de liste uniquement, afin d''\00E9viter des chargements de page inutilement longs.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4413)
,p_display_sequence=>30
,p_display_value=>'Serveur : Exact et Distinction maj/min'
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>unistr('La recherche utilise LIKE [valeur de recherche]% pour interroger le r\00E9sultat.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4413)
,p_display_sequence=>40
,p_display_value=>'Serveur : Exact et Ignorer la casse'
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>unistr('La recherche utilise LIKE UPPER( [valeur de recherche] )% pour interroger le r\00E9sultat. Les index existants sur la colonne ne seront pas utilis\00E9s, \00E0 moins qu''il s''agisse d''un index bas\00E9 sur une fonction utilisant une expression UPPER.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4413)
,p_display_sequence=>50
,p_display_value=>'Serveur : Semblable et Distinction maj/min'
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('La recherche utilise LIKE %[valeur de recherche]% pour interroger le r\00E9sultat. Ceci emp\00EAchera l''utilisation d''un index existant sur cette colonne.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4413)
,p_display_sequence=>60
,p_display_value=>'Serveur : Semblable et Ignorer la casse'
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('La recherche utilise LIKE %UPPER( [valeur de recherche] )% pour interroger le r\00E9sultat. Ceci emp\00EAchera l''utilisation d''un index existant sur cette colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>'Rechercher une colonne'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('S\00E9lectionnez une autre colonne de base de donn\00E9es utilis\00E9e pour la recherche. Si aucun \00E9l\00E9ment n''est indiqu\00E9, la colonne de texte est utilis\00E9e.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>unistr('Valeur de r\00E9serve de zone de recherche')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('Entrez le texte affich\00E9 dans la zone de recherche. Si aucune valeur n''est indiqu\00E9e, la valeur du message syst\00E8me <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong> est utilis\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>unistr('Colonne de liste imbriqu\00E9e')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('S\00E9lectionnez la colonne de base de donn\00E9es contenant le niveau de hi\00E9rarchie d''une requ\00EAte imbriqu\00E9e. Si vous utilisez une requ\00EAte CONNECT BY, utilisez la pseudo-colonne <code>LEVEL</code>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4413)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher tous les employ\00E9s class\00E9s par nom</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>Afficher tous les employ\00E9s du service en cours class\00E9s par nom</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Lorsque vous utilisez des variables attach\00E9es pour r\00E9f\00E9rencer des \00E9l\00E9ments de page, d\00E9signez-les en tant qu''<strong>\00E9l\00E9ments de page \00E0 soumettre</strong>.</p>'),
'</dd>',
unistr('<dt>Utiliser ROWID comme colonne de cl\00E9 primaire</dt>'),
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
'<p>Lorsque vous utilisez ROWID, vous devez indiquer un alias de colonne.</p>',
'</dd>',
unistr('<dt>Requ\00EAte imbriqu\00E9e renvoyant tous les employ\00E9s</dt>'),
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('Fermer la r\00E9gion')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ferme une r\00E9gion, telle qu''une fen\00EAtre instantan\00E9e incorpor\00E9e, une bo\00EEte de dialogue incorpor\00E9e ou un \00E9l\00E9ment r\00E9ductible, qui prend en charge l''ouverture et qui est ouverte.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('Ouvrir la r\00E9gion')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ouvre une r\00E9gion, telle qu''une fen\00EAtre instantan\00E9e incorpor\00E9e, une bo\00EEte de dialogue incorpor\00E9e ou un \00E9l\00E9ment r\00E9ductible, qui prend en charge l''ouverture .')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>unistr('Est dans un r\00F4le ou un groupe')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4413)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nom(s)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez des noms de groupe, s\00E9par\00E9s par des virgules.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4413)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4413)
,p_display_sequence=>10
,p_display_value=>unistr('R\00F4le d''application')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4413)
,p_display_sequence=>20
,p_display_value=>'Groupe d''espace de travail'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4413)
,p_display_sequence=>30
,p_display_value=>'Personnalisation'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4413)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>unistr('N''est pas dans un r\00F4le ou un groupe')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4413)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nom(s)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez des noms de groupe, s\00E9par\00E9s par des virgules.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4413)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4413)
,p_display_sequence=>10
,p_display_value=>unistr('R\00F4le d''application')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4413)
,p_display_sequence=>20
,p_display_value=>'Groupe d''espace de travail'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4413)
,p_display_sequence=>30
,p_display_value=>'Personnalisation'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>unistr('S\00E9lecteur de date')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche un champ de texte avec une ic\00F4ne de calendrier. Les utilisateurs finals peuvent entrer la date directement dans l''\00E9l\00E9ment de texte ou cliquer sur l''ic\00F4ne de calendrier pour s\00E9lectionner une date, et \00E9ventuellement une heure, dans le calend')
||unistr('rier instantan\00E9.</p>'),
unistr('<p>L''heure est affich\00E9e dans le calendrier instantan\00E9 uniquement si le <em>masque de format</em> de cet \00E9l\00E9ment inclut des composants d''heure.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Apparence'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Contr\00F4le l''apparence du calendrier utilis\00E9 pour s\00E9lectionner des dates.</p>'),
unistr('<p>Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4413)
,p_display_sequence=>10
,p_display_value=>'Afficher la semaine'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Indique si la semaine de l''ann\00E9e est affich\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4413)
,p_display_sequence=>20
,p_display_value=>unistr('S\00E9lecteur de mois')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Indique si le mois doit \00EAtre affich\00E9 sous forme de bouton afin de permettre la s\00E9lection, plut\00F4t que sous forme de texte.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4413)
,p_display_sequence=>30
,p_display_value=>unistr('S\00E9lecteur d''ann\00E9e')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Indique si l''ann\00E9e doit \00EAtre affich\00E9e sous forme de bouton afin de permettre la s\00E9lection, plut\00F4t que sous forme de texte.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Jours en dehors du mois'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indique le comportement des jours en dehors du mois en cours d''affichage.</p>',
unistr('<p>Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Masqu\00E9')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Les jours en dehors du mois en cours d''affichage sont masqu\00E9s.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4413)
,p_display_sequence=>20
,p_display_value=>unistr('S\00E9lectionnable')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Les jours en dehors du mois en cours d''affichage sont visibles et s\00E9lectionnables.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4413)
,p_display_sequence=>30
,p_display_value=>'Visible'
,p_return_value=>'VISIBLE'
,p_help_text=>'Les jours en dehors du mois en cours d''affichage sont visibles.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Incr\00E9ment temporel')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>'minutes'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incr\00E9ment de temps en minutes utilis\00E9 par la commande de s\00E9lection de l''heure. Remarque : cela permet uniquement de contr\00F4ler la commande destin\00E9e \00E0 s\00E9lectionner l''heure, toutes les heures non comprises dans ces incr\00E9ments peuvent quand m\00EAme \00EAtre ')
||unistr('entr\00E9es et enregistr\00E9es manuellement.</p>'),
unistr('<p>Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation et lorsque l''option Afficher l''heure est activ\00E9e.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Afficher quand'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Permet de d\00E9finir le moment o\00F9 la fen\00EAtre instantan\00E9e de calendrier est affich\00E9e. Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4413)
,p_display_sequence=>10
,p_display_value=>'Surbrillance'
,p_return_value=>'FOCUS'
,p_help_text=>unistr('Lorsque l''\00E9l\00E9ment est s\00E9lectionn\00E9 ou lors d''un clic sur l''ic\00F4ne de calendrier.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4413)
,p_display_sequence=>20
,p_display_value=>unistr('S\00E9lection d''une ic\00F4ne')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('Uniquement lors d''un clic sur l''ic\00F4ne de calendrier.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Afficher l''heure'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Indique s''il faut inclure des informations temporelles.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Afficher en tant que'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionner le mode d''affichage pour le s\00E9lecteur de date.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Fen\00EAtre instantan\00E9e')
,p_return_value=>'POPUP'
,p_help_text=>unistr('Le calendrier appara\00EEt dans une fen\00EAtre instantan\00E9e lorsque l''\00E9l\00E9ment est s\00E9lectionn\00E9 ou lors d''un clic sur l''ic\00F4ne de calendrier.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4413)
,p_display_sequence=>20
,p_display_value=>'Incorporation'
,p_return_value=>'INLINE'
,p_help_text=>unistr('L''affichage du calendrier est toujours incorpor\00E9 \00E0 la page. Aucun champ de texte n''appara\00EEt et la s\00E9lection de date en cours est mise en \00E9vidence dans le calendrier.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4413)
,p_display_sequence=>30
,p_display_value=>'HTML natif'
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affichez l''\00E9l\00E9ment \00E0 l''aide des types de date d''entr\00E9e HTML natifs, s''ils sont pris en charge par le navigateur. Lorsque l''option Afficher l''heure est d\00E9sactiv\00E9e, un type "date" est affich\00E9, mais lorsqu''elle est activ\00E9e, un type "datetime-local" e')
||unistr('st affich\00E9. Remarque : l''affichage exact de ces types de date d\00E9pend du navigateur. Le format HTML natif peut \00EAtre l''option pr\00E9f\00E9r\00E9e lorsque l''application est utilis\00E9e sur un appareil mobile.</p>'),
unistr('<p>Lors de l''utilisation du format HTML natif, \00E9tant donn\00E9 que les types de date natifs requi\00E8rent un format de date tr\00E8s sp\00E9cifique, le masque de format de l''\00E9l\00E9ment sera d\00E9fini automatiquement par APEX et vous ne pourrez pas le modifier. Toutefois,')
||unistr(' ce n''est pas ce format que l''utilisateur final verra. Ce dernier verra la date au format correspondant \00E0 son environnement local en cours.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Date minimale'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si cet \00E9l\00E9ment a une date minimale.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4413)
,p_display_sequence=>10
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
,p_help_text=>unistr('Aucune date minimale d\00E9finie.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4413)
,p_display_sequence=>20
,p_display_value=>unistr('El\00E9ment')
,p_return_value=>'ITEM'
,p_help_text=>unistr('La date minimale est d\00E9riv\00E9e de mani\00E8re dynamique de la valeur d''un autre \00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4413)
,p_display_sequence=>30
,p_display_value=>'Statique'
,p_return_value=>'STATIC'
,p_help_text=>unistr('La date minimale est une valeur statique, d\00E9finie comme une valeur absolue ou une valeur relative par rapport \00E0 la date du jour.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Valeur statique minimale'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la date minimale pouvant \00EAtre saisie ou s\00E9lectionn\00E9e.</p>'),
unistr('<p>La valeur de date peut \00EAtre une valeur absolue au format <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, une valeur relative par rapport \00E0 la date du jour, comme <code>+7d</code>, ou une valeur dynamique utilisant la syntaxe')
||unistr(' de substitution, \00E0 condition que la substitution renvoie la valeur relative ou le format de date correct.</p>'),
'<p>Les valeurs relatives de date sont les suivantes :</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - ann\00E9es \00E0 compter d''aujourd''hui</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - mois \00E0 compter d''aujourd''hui</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - semaines \00E0 compter d''aujourd''hui</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - jours \00E0 compter d''aujourd''hui</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('El\00E9ment minimal')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>El\00E9ment qui d\00E9termine la valeur minimale autoris\00E9e. Il doit s''agir d''un \00E9l\00E9ment de page qui est soit sur la page en cours, soit sur la page globale.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Date maximale'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si cet \00E9l\00E9ment a une date maximale.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4413)
,p_display_sequence=>10
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
,p_help_text=>unistr('Aucune date maximale d\00E9finie.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4413)
,p_display_sequence=>20
,p_display_value=>unistr('El\00E9ment')
,p_return_value=>'ITEM'
,p_help_text=>unistr('La date maximale est d\00E9riv\00E9e de mani\00E8re dynamique de la valeur d''un autre \00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4413)
,p_display_sequence=>30
,p_display_value=>'Statique'
,p_return_value=>'STATIC'
,p_help_text=>unistr('La date maximale est une valeur statique, d\00E9finie comme une valeur absolue ou une valeur relative par rapport \00E0 la date du jour.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Valeur statique maximale'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la date maximale pouvant \00EAtre saisie ou s\00E9lectionn\00E9e.</p>'),
unistr('<p>La valeur de date peut \00EAtre une valeur absolue au format <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, une valeur relative par rapport \00E0 la date du jour, comme <code>+7d</code>, ou une valeur dynamique utilisant la syntaxe')
||unistr(' de substitution, \00E0 condition que la substitution renvoie la valeur relative ou le format de date correct.</p>'),
'<p>Les valeurs relatives de date sont les suivantes :</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - ann\00E9es \00E0 compter d''aujourd''hui</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - mois \00E0 compter d''aujourd''hui</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - semaines \00E0 compter d''aujourd''hui</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - jours \00E0 compter d''aujourd''hui</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('El\00E9ment maximal')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>El\00E9ment qui d\00E9termine la valeur maximale autoris\00E9e. Il doit s''agir d''un \00E9l\00E9ment de page qui est soit sur la page en cours, soit sur la page globale.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Plusieurs mois'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>'Indique si le calendrier affichera plusieurs mois.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Nombre de mois'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Nombre de mois \00E0 afficher simultan\00E9ment.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Utiliser les valeurs par d\00E9faut')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indique s''il faut utiliser les valeurs par d\00E9faut d\00E9finies pour ce composant, dans Composants partag\00E9s > Param\00E8tres de composant, ou des param\00E8tres personnalis\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Apparence'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Contr\00F4le l''apparence du calendrier utilis\00E9 pour s\00E9lectionner des dates.</p>'),
unistr('<p>Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4413)
,p_display_sequence=>10
,p_display_value=>'Afficher la semaine'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Indique si la semaine de l''ann\00E9e est affich\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4413)
,p_display_sequence=>20
,p_display_value=>unistr('S\00E9lecteur de mois')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Indique si le mois doit \00EAtre affich\00E9 sous forme de bouton afin de permettre la s\00E9lection, plut\00F4t que sous forme de texte.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4413)
,p_display_sequence=>30
,p_display_value=>unistr('S\00E9lecteur d''ann\00E9e')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Indique si l''ann\00E9e doit \00EAtre affich\00E9e sous forme de bouton afin de permettre la s\00E9lection, plut\00F4t que sous forme de texte.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Jours en dehors du mois'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indique le comportement des jours en dehors du mois en cours d''affichage.</p>',
unistr('<p>Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Masqu\00E9')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Les jours en dehors du mois en cours d''affichage sont masqu\00E9s.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4413)
,p_display_sequence=>20
,p_display_value=>unistr('S\00E9lectionnable')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Les jours en dehors du mois en cours d''affichage sont visibles et s\00E9lectionnables.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4413)
,p_display_sequence=>30
,p_display_value=>'Visible'
,p_return_value=>'VISIBLE'
,p_help_text=>'Les jours en dehors du mois en cours d''affichage sont visibles.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Incr\00E9ment temporel')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>'minutes'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incr\00E9ment de temps en minutes utilis\00E9 par la commande de s\00E9lection de l''heure. Remarque : cela permet uniquement de contr\00F4ler la commande destin\00E9e \00E0 s\00E9lectionner l''heure, toutes les heures non comprises dans ces incr\00E9ments peuvent quand m\00EAme \00EAtre ')
||unistr('entr\00E9es et enregistr\00E9es manuellement.</p>'),
unistr('<p>Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation et lorsque l''option Afficher l''heure est activ\00E9e.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4413)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Afficher quand'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Permet de d\00E9finir le moment o\00F9 la fen\00EAtre instantan\00E9e de calendrier est affich\00E9e. Remarque : utilis\00E9 uniquement lorsque l''option Afficher en tant que est d\00E9finie sur Fen\00EAtre instantan\00E9e ou Incorporation.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4413)
,p_display_sequence=>10
,p_display_value=>'Surbrillance'
,p_return_value=>'FOCUS'
,p_help_text=>unistr('Lorsque l''\00E9l\00E9ment est s\00E9lectionn\00E9 ou lors d''un clic sur l''ic\00F4ne de calendrier.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4413)
,p_display_sequence=>20
,p_display_value=>unistr('S\00E9lection d''une ic\00F4ne')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('Uniquement lors d''un clic sur l''ic\00F4ne de calendrier.')
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>unistr('Case \00E0 cocher')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche une case \00E0 cocher unique que l''utilisateur peut s\00E9lectionner ou d\00E9s\00E9lectionner. La valeur d\00E9finie (s\00E9lectionn\00E9 ou d\00E9s\00E9lectionn\00E9) est stock\00E9e dans le statut de session lors de la soumission.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4413)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Valeur v\00E9rifi\00E9e')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Saisissez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur final s\00E9lectionne la case \00E0 cocher. La valeur peut contenir jusqu''\00E0 255 caract\00E8res.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4413)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Valeur non v\00E9rifi\00E9e')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Saisissez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur d\00E9s\00E9lectionne la case \00E0 cocher. Cet attribut peut \00E9galement \00EAtre laiss\00E9 vide pour stocker la valeur <code>NULL</code> lorsque la case est coch\00E9e. La valeur peut contenir jusqu''\00E0 255 ')
||unistr('caract\00E8res.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4413)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Utiliser les valeurs par d\00E9faut')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indique s''il faut utiliser les valeurs par d\00E9faut d\00E9finies pour ce composant, dans Composants partag\00E9s > Param\00E8tres de composant, ou des param\00E8tres personnalis\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4413)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Valeur v\00E9rifi\00E9e')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'O'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Entrez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur a coch\00E9 la case. La valeur peut contenir jusqu''\00E0 255 caract\00E8res.</p>'),
'<p>',
unistr('Sur une page de recherche \00E0 facets, si le facet filtre une colonne de requ\00EAte <em>bas\00E9e sur une liste de valeurs (LOV)</em>, cette valeur doit correspondre <em>\00E0 la fois</em> \00E0 la valeur d''affichage et \00E0 la valeur renvoy\00E9e de la LOV. Si ces valeurs n')
||unistr('e sont pas identiques, vous ne pouvez pas utiliser ce type de facet pour cette colonne. Utilisez plut\00F4t le facet <strong>Groupe de cases \00E0 cocher</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4413)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Valeur non v\00E9rifi\00E9e')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur d\00E9s\00E9lectionne la case \00E0 cocher. Cet attribut peut \00E9galement \00EAtre laiss\00E9 vide pour stocker la valeur <code>NULL</code> lorsque l''option est d\00E9s\00E9lectionn\00E9e. La valeur peut contenir ')
||unistr('jusqu''\00E0 255 caract\00E8res.</p>'),
unistr('<p><em>Remarque : cette valeur est utilis\00E9e si l''\00E9l\00E9ment de page contient une valeur qui ne correspond ni \00E0 la <strong>valeur v\00E9rifi\00E9e</strong> ni \00E0 la <strong>valeur non v\00E9rifi\00E9e</strong>.</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>'Grille interactive'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>R\00E9gion multiligne compl\00E8te en ligne reposant sur une requ\00EAte SQL qui fournit aux utilisateurs finals de nombreuses fonctionnalit\00E9s de personnalisation au moment de l''ex\00E9cution. '),
unistr('Vous pouvez d\00E9finir un acc\00E8s en modification ou en lecture seule pour la r\00E9gion.</p>'),
unistr('<p>Vous pouvez d\00E9finir une seule grille interactive et demander aux utilisateurs finals de manipuler les donn\00E9es affich\00E9es pour r\00E9pondre \00E0 leurs propres exigences, plut\00F4t que de d\00E9velopper plusieurs r\00E9gions similaires avec des crit\00E8res diff\00E9rents pur')
||unistr(' r\00E9pondre \00E0 ces m\00EAmes exigences.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'apexbeginrecordedit'
,p_display_name=>'Initialisation de ligne'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'gridpagechange'
,p_display_name=>'Changement de page'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'interactivegridmodechange'
,p_display_name=>'Changement de mode'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'interactivegridreportchange'
,p_display_name=>unistr('Changement d''\00E9tat')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'interactivegridsave'
,p_display_name=>'Enregistrer'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('Modification de s\00E9lection')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4413)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4413)
,p_name=>'interactivegridviewchange'
,p_display_name=>'Changement de vue'
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>unistr('S\00E9lecteur de ligne')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche une case \00E0 cocher sur chaque ligne d''une grille interactive, permettant de s\00E9lectionner des lignes sp\00E9cifiques pour les manipuler.</p>'),
unistr('<p>Par d\00E9faut, la colonne APEX$ROW_SELECTOR est d\00E9finie sur un type de s\00E9lecteur de ligne. Cette colonne est ajout\00E9e automatiquement lorsque la grille interactive devient modifiable.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4413)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Activer la s\00E9lection multiple')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Autorisez la s\00E9lection de plusieurs lignes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4413)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Afficher Tout s\00E9lectionner')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Autorisez l''utilisateur \00E0 s\00E9lectionner toutes les lignes \00E0 l''aide du raccourci Ctrl+A ou, si l''option <em>Masquer les contr\00F4les</em> a la valeur <em>Non</em>, \00E0 l''aide d''une case \00E0 cocher dans l''en-t\00EAte de colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4413)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Masquer le contr\00F4le')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Masquez la case \00E0 cocher ou le contr\00F4le de bouton d''option affich\00E9 sur chaque ligne.')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>'Menu Actions'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche l''ic\00F4ne des actions (hamburger) sur chaque ligne d''une grille interactive. '),
unistr('Le menu Actions inclut des options telles que Vue monoligne, Ajouter une ligne, Supprimer une ligne, R\00E9g\00E9n\00E9rer la ligne, etc. en fonction des attributs de grille et des autorisations de l''utilisateur final. Ces options de menu permettent aux utilisat')
||unistr('eurs finals d''effectuer des actions sp\00E9cifiques sur la ligne en cours dans la grille.</p>'),
unistr('<p>Le menu Actions peut \00EAtre utilis\00E9 dans les grilles interactives modifiables et non modifiables, mais les options de menu diff\00E8rent. Pour les grilles interactives non modifiables, le menu contient un sous-ensemble d''options, par exemple Vue monolig')
||unistr('ne et R\00E9g\00E9n\00E9rer la ligne. Il n''inclut pas les actions propres aux grilles modifiables comme Ajouter une ligne, Supprimer une ligne, etc.</p>'),
unistr('<p>Lorsqu''une grille interactive devient modifiable, la colonne APEX$ROW_ACTION est ajout\00E9e automatiquement et d\00E9finie sur un type de menu Actions. Pour les grilles interactives non modifiables, cette colonne doit \00EAtre ajout\00E9e manuellement.</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>'Graphique'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche les donn\00E9es \00E0 l''aide de plusieurs types de graphique int\00E9gr\00E9s.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4413)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4413)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>'Masquer'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Masque les \00E9l\00E9ments affect\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4413)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Masquer tous les \00E9l\00E9ments de page sur la m\00EAme ligne')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si tous les \00E9l\00E9ments et libell\00E9s de page sur la m\00EAme ligne que les \00E9l\00E9ments affect\00E9s sont masqu\00E9s.</p>'),
unistr('<p>Remarque : cet attribut ne fonctionne pas pour les \00E9l\00E9ments sur les pages qui n''utilisent pas de grille de table pour afficher les \00E9l\00E9ments de panneau. Cela inclut toute page utilisant un mod\00E8le de page mobile.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>'Activer'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Active les \00E9l\00E9ments affect\00E9s.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>unistr('D\00E9sactiver')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('D\00E9sactive les \00E9l\00E9ments affect\00E9s. Cette op\00E9ration rend les \00E9l\00E9ments non modifiables, de sorte qu''ils ne conservent pas les valeurs d''\00E9l\00E9ment lorsque la page est soumise.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>unistr('D\00E9finir une valeur')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('D\00E9finit la valeur des \00E9l\00E9ments affect\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('D\00E9finir un type')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la m\00E9thode \00E0 utiliser pour d\00E9river les valeurs \00E0 d\00E9finir.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_display_sequence=>10
,p_display_value=>'Affectation statique'
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('D\00E9finir une valeur statique unique.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_display_sequence=>15
,p_display_value=>'Expression JavaScript'
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>unistr('D\00E9finir plusieurs valeurs, d\00E9riv\00E9es ou calcul\00E9es \00E0 partir de JavaScript.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_display_sequence=>20
,p_display_value=>'Instruction SQL'
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>unistr('D\00E9finir plusieurs valeurs, en fonction du r\00E9sultat d''une requ\00EAte SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_display_sequence=>40
,p_display_value=>'Expression PL/SQL'
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>unistr('D\00E9finir une valeur unique en fonction du r\00E9sultat d''une expression PL/SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_display_sequence=>50
,p_display_value=>'Corps de fonction PL/SQL'
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>unistr('D\00E9finir une valeur unique en fonction du r\00E9sultat d''un corps de fonction PL/SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_display_sequence=>60
,p_display_value=>unistr('El\00E9ment renvoy\00E9 de bo\00EEte de dialogue')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('D\00E9finissez une valeur unique en fonction de l''\00E9l\00E9ment renvoy\00E9 d''une bo\00EEte de dialogue. Remarque : ce type fonctionne uniquement si l''action dynamique est d\00E9clench\00E9e pour l''\00E9v\00E9nement <strong>Bo\00EEte de dialogue ferm\00E9e</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>'Saisissez une valeur statique.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Instruction SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>Dans cet exemple, saisissez <code>P1_DEPTNO</code> dans <strong>El\00E9ments de page \00E0 soumettre</strong>. Vous devez \00E9galement s\00E9lectionner deux <em>\00E9l\00E9ments affect\00E9s</em>, pour les colonnes <code>loc</code> et <code>dname</code>, respectivement (par')
||' exemple, P1_LOC et P1_DNAME).</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez une instruction SQL renvoyant entre 1 et 100 colonnes. Les colonnes que vous s\00E9lectionnez avec l''instruction SQL doivent correspondre en fonction de la position dans les \00E9l\00E9ments de page s\00E9lectionn\00E9s dans <strong>El\00E9ments affect\00E9s</stron')
||'g>.',
unistr('<p>Vous pouvez r\00E9f\00E9rencer des \00E9l\00E9ments de page ou d''application \00E0 l''aide de la syntaxe Bind, si vous les incluez dans <strong>El\00E9ments de page \00E0 soumettre</strong></p>.'),
unistr('<p><em>Remarque : si l''instruction SQL ne renvoie qu''une ligne, elle sera utilis\00E9e pour d\00E9finir les valeurs ; si elle en renvoie plusieurs, la valeur d\00E9finie sera une cha\00EEne de toutes les lignes, s\00E9par\00E9es par des virgules.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Expression PL/SQL'
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
unistr('<p>Dans cet exemple, saisissez <code>P1_SAL</code> dans <strong>El\00E9ments de page \00E0 soumettre</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez l''expression PL/SQL utilis\00E9e pour d\00E9finir la valeur.</p>'),
unistr('<p>Vous pouvez r\00E9f\00E9rencer des \00E9l\00E9ments de page ou d''application, \00E0 condition de les inclure dans <strong>El\00E9ments de page \00E0 soumettre</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Expression JavaScript'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ce code permet d''acc\00E9der aux attributs associ\00E9s \00E0 l''action dynamique suivants :</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>R\00E9f\00E9rence \00E0 l''objet DOM de l''\00E9l\00E9ment ayant d\00E9clench\00E9 l''action dynamique.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>Objet jQuery contenant tous les \00E9l\00E9ments affect\00E9s.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>Objet d''action contenant les d\00E9tails, tels que le nom de l''action et les valeurs d''attributs suppl\00E9mentaires.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>Objet de l''\00E9v\00E9nement ayant d\00E9clench\00E9 l''\00E9v\00E9nement. Remarque : lors du chargement, cet \00E9l\00E9ment sera \00E9gal \00E0 la valeur "chargement".</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>Donn\00E9es suppl\00E9mentaires facultatives pouvant \00EAtre transmises depuis le gestionnaire d''\00E9v\00E9nements.</dd>'),
'</dl>'))
,p_help_text=>unistr('Entrez une expression JavaScript utilis\00E9e pour d\00E9finir la valeur. Cette expression peut g\00E9n\00E9rer une seule valeur ou un tableau de valeurs (o\00F9 l''\00E9l\00E9ment en cours de d\00E9finition prend en charge plusieurs valeurs, comme une navette).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Corps de fonction PL/SQL'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
unistr('<p>Dans cet exemple, saisissez <code>P1_SAL</code> et <code>P1_JOB</code> dans <strong>El\00E9ments de page \00E0 soumettre</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le corps de fonction PL/SQL utilis\00E9 pour d\00E9finir la valeur.</p>'),
unistr('<p>Vous pouvez r\00E9f\00E9rencer des \00E9l\00E9ments de page ou d''application, \00E0 condition de les inclure dans <strong>El\00E9ments de page \00E0 soumettre</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('El\00E9ments \00E0 soumettre')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Entrez les \00E9l\00E9ments de page ou d''application \00E0 soumettre lors de l''ex\00E9cution de cette action. S\00E9parez les noms d''\00E9l\00E9ment par une virgule. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles. Si vous s\00E9lectionnez un nom')
||unistr(' dans la liste et que du texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, puis le nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste est ajout\00E9.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Caract\00E8res sp\00E9ciaux d''\00E9chappement')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Indiquez si les caract\00E8res sp\00E9ciaux HTML sont pr\00E9c\00E9d\00E9s d''un caract\00E8re d''\00E9chappement. Pour emp\00EAcher les attaques de type Cross-Site Scripting (XSS), Oracle recommande vivement de d\00E9finir cet attribut sur <strong>Oui</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Supprimer l''\00E9v\00E9nement de modification')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si l''\00E9v\00E9nement de modification est supprim\00E9 pour les \00E9l\00E9ments sp\00E9cifi\00E9s dans <strong>El\00E9ments de page \00E0 renvoyer</strong>. Cela emp\00EAche l''activation d''actions dynamiques ult\00E9rieures bas\00E9es sur la <em>modification</em> pour ces \00E9l\00E9ments.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4413)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>unistr('El\00E9ment renvoy\00E9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('Saisissez le nom d''un \00E9l\00E9ment de page renvoy\00E9 par la bo\00EEte de dialogue utilis\00E9e pour d\00E9finir la valeur.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('Ex\00E9cuter le code JavaScript')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Permet de d\00E9finir ou d''appeler un code JavaScript de page personnalis\00E9 \00E0 utiliser dans la structure d''action dynamique. Si vous d\00E9finissez un code JavaScript propre \00E0 une seule page, vous pouvez utiliser l''attribut de niveau de page <em>D\00E9claration d')
||unistr('e fonction et de variable globale</em> pour le d\00E9finir. Les fonctions et variables d\00E9finies ici peuvent \00EAtre r\00E9f\00E9renc\00E9es ult\00E9rieurement \00E0 partir de cette action.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4413)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Code'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ce code permet d''acc\00E9der aux attributs associ\00E9s \00E0 l''action dynamique suivants :</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>R\00E9f\00E9rence \00E0 l''objet DOM de l''\00E9l\00E9ment ayant d\00E9clench\00E9 l''action dynamique.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>Objet jQuery contenant tous les \00E9l\00E9ments affect\00E9s.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>Objet d''action contenant les d\00E9tails, tels que le nom de l''action et les valeurs d''attributs suppl\00E9mentaires.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>Objet de l''\00E9v\00E9nement ayant d\00E9clench\00E9 l''\00E9v\00E9nement. Remarque : lors du chargement, cet \00E9l\00E9ment sera \00E9gal \00E0 la valeur "chargement".</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>Donn\00E9es suppl\00E9mentaires facultatives pouvant \00EAtre transmises depuis le gestionnaire d''\00E9v\00E9nements.</dd>'),
'</dl>'))
,p_help_text=>unistr('Entrez un code JavaScript personnalis\00E9 propre \00E0 la page ou \00E0 l''action dynamique.')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>'Grille interactive - Traitement de ligne automatique (DML)'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus permettant d''ins\00E9rer, de mettre \00E0 jour ou de supprimer des lignes de grille interactive.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type de cible'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la technique de traitement de ligne utilis\00E9e pour enregistrer les modifications de donn\00E9es apport\00E9es \00E0 la grille interactive.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Source de r\00E9gion')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les insertions, mises \00E0 jour et suppressions utilisent la requ\00EAte SQL source de r\00E9gion.</p>'),
unistr('<p>Remarque : assurez-vous que le param\00E8tre <strong>Requ\00EAte uniquement</strong> est d\00E9fini sur <code>Oui</code> pour les colonnes ne pouvant pas \00EAtre ins\00E9r\00E9es ou mises \00E0 jour, afin de les exclure du traitement.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4413)
,p_display_sequence=>20
,p_display_value=>'Table/vue'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les insertions, mises \00E0 jour et suppressions utilisent une table ou vue diff\00E9rente de celle d\00E9finie dans la requ\00EAte SQL source de r\00E9gion.'),
unistr('Par exemple, la requ\00EAte SQL extrait des donn\00E9es \00E0 partir d''une vue non modifiable ou d''une jointure de tables, et le traitement DML doit \00EAtre ex\00E9cut\00E9 par rapport \00E0 une vue modifiable ou \00E0 une table de base unique.</p>'),
unistr('<p>Remarque : assurez-vous que le param\00E8tre <strong>Requ\00EAte uniquement</strong> est d\00E9fini sur <code>Oui</code> pour les colonnes ne pouvant pas \00EAtre ins\00E9r\00E9es ou mises \00E0 jour, afin de les exclure du traitement.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4413)
,p_display_sequence=>30
,p_display_value=>'Code PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le traitement est fond\00E9 sur un code PL/SQL personnalis\00E9. Cette option permet d''ex\00E9cuter tout code PL/SQL pour impl\00E9menter la manipulation de donn\00E9es dans la base de donn\00E9es sous-jacente.</p>'),
unistr('<p>Choisissez cette option lors de l''utilisation de packages de base de donn\00E9es, comme les API de table ou les appels aux services Web RESTful, afin d''impl\00E9menter une logique applicative.</p>'),
unistr('<p>Remarque : le code PL/SQL est appel\00E9 pour chaque ligne ins\00E9r\00E9e, mise \00E0 jour ou supprim\00E9e.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4413)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Code PL/SQL pour ins\00E9rer/mettre \00E0 jour/supprimer')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le code PL/SQL pour traiter chaque ligne de donn\00E9es manipul\00E9es dans la grille interactive.</p>'),
unistr('<p>Utilisez le nom de colonne en tant que variable attach\00E9e pour acc\00E9der \00E0 la valeur d''une colonne. La variable syst\00E8me <code>APEX$ROW_STATUS</code> renvoie le statut d''une ligne et peut \00EAtre utilis\00E9e pour v\00E9rifier si la ligne a \00E9t\00E9 cr\00E9\00E9e, mise \00E0 jou')
||unistr('r ou supprim\00E9e (reportez-vous \00E0 l''exemple ci-dessous pour d\00E9couvrir comment le v\00E9rifier).</p>'),
unistr('<p><em>Remarque :</em> si les colonnes de cl\00E9 primaire sont remplies par un d\00E9clencheur ou dans le code PL/SQL, les nouvelles valeurs doivent \00EAtre affect\00E9es aux variables attach\00E9es des colonnes de cl\00E9 primaire, car &PRODUCT_NAME. utilise ces valeurs ')
||unistr('pour extraire la ligne apr\00E8s une insertion ou une mise \00E0 jour.</p>'),
unistr('<p>Oracle recommande d''appeler des proc\00E9dures ou des fonctions dans un package PL/SQL, afin de faciliter la r\00E9utilisation et la mise \00E0 jour.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Emp\00EAcher les pertes de mise \00E0 jour')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si le traitement doit v\00E9rifier que les mises \00E0 jour ne sont pas perdues lorsque plusieurs utilisateurs mettent \00E0 jour le m\00EAme enregistrement de base de donn\00E9es.</p> '),
unistr('<p>Les pertes de mise \00E0 jour surviennent lorsque deux personnes ou plus essaient de mettre \00E0 jour les m\00EAmes donn\00E9es. La derni\00E8re mise \00E0 jour \00E9crase les mises \00E0 jour effectu\00E9es par le premier utilisateur ayant enregistr\00E9 des modifications. Pour \00E9viter')
||unistr(' cela, les mises \00E0 jour peuvent comparer les valeurs de colonne existantes dans la base de donn\00E9es avec les valeurs extraites lors de la premi\00E8re interrogation de la ligne.</p>'),
'<p>Par exemple :',
'  <ol>',
unistr('    <li>L''utilisateur A interroge les enregistrements d''employ\00E9s (EMP).</li>'),
unistr('    <li>L''utilisateur B interroge les m\00EAmes enregistrements d''employ\00E9s.</li>'),
unistr('    <li>L''utilisateur B met \00E0 jour les d\00E9tails des employ\00E9s pour EMPNO = 7839 et applique (valide) les modifications apport\00E9es \00E0 la base de donn\00E9es.</li>'),
unistr('    <li>L''utilisateur A met \00E0 jour les d\00E9tails des employ\00E9s pour EMPNO = 7839 et tente d''appliquer les modifications \00E0 la base de donn\00E9es.</li>'),
'  </ol>',
unistr('Si l''utilisateur A parvient \00E0 mettre \00E0 jour la m\00EAme ligne, les modifications apport\00E9es par l''utilisateur B sont perdues.'),
unistr('Lorsque l''utilisateur A tente d''enregistrer la ligne des employ\00E9s, les donn\00E9es figurant dans la base de donn\00E9es sont diff\00E9rentes de celles initialement interrog\00E9es par l''utilisateur A. Dans l''\00E9tape 1 ci-dessus, les valeurs de colonne interrog\00E9es init')
||unistr('ialement par l''utilisateur A peuvent \00EAtre captur\00E9es. Lors de l''\00E9tape 4 ci-dessus, les valeurs peuvent \00EAtre compar\00E9es aux valeurs en cours dans la base de donn\00E9es. Cette comparaison g\00E9n\00E8re une erreur pour l''utilisateur A, car les valeurs de la base de')
||unistr(' donn\00E9es ont \00E9t\00E9 mises \00E0 jour par l''utilisateur B lors de l''\00E9tape 3. Cela permet d''emp\00EAcher un utilisateur d''\00E9craser les modifications apport\00E9es par un autre utilisateur sur la m\00EAme ligne.</p>'),
unistr('<p>Remarque : la m\00E9thode de d\00E9tection des pertes de mise \00E0 jour est indiqu\00E9e dans la r\00E9gion des attributs de la grille interactive, en fonction du param\00E8tre d\00E9fini pour le <strong>type de mise \00E0 jour perdue</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verrouiller la ligne'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Choisissez de verrouiller ou non chaque ligne \00E0 mettre \00E0 jour ou \00E0 supprimer dans la table sous-jacente avant le traitement de la ligne.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4413)
,p_display_sequence=>10
,p_display_value=>'Oui'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les lignes \00E0 mettre \00E0 jour ou \00E0 supprimer sont verrouill\00E9es \00E0 l''aide de SELECT ... FOR UPDATE afin d''\00E9viter que d''autres transactions soient effectu\00E9es sur la ligne avant la validation (commit) de la transaction.</p>'),
unistr('<p>Remarque : si une erreur est g\00E9n\00E9r\00E9e, par exemple pour les vues modifiables ne prenant pas en charge le verrouillage, vous pouvez utiliser le code PL/SQL pour verrouiller la table directrice.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4413)
,p_display_sequence=>20
,p_display_value=>'Non'
,p_return_value=>'N'
,p_help_text=>unistr('Les lignes ne sont pas verrouill\00E9es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4413)
,p_display_sequence=>30
,p_display_value=>'Code PL/SQL'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('Le code PL/SQL personnalis\00E9 est utilis\00E9 pour verrouiller les lignes jusqu''\00E0 la validation (commit) de la transaction.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Code PL/SQL pour verrouiller une ligne'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Entrez le code PL/SQL pour verrouiller les lignes de la table de base de donn\00E9es \00E0 mettre \00E0 jour et \00E0 supprimer.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4413)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Renvoyer des cl\00E9s primaires apr\00E8s l''insertion')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les colonnes de cl\00E9 primaire doivent \00EAtre renvoy\00E9es \00E0 la ligne de grille interactive correspondante une fois que la ligne est ins\00E9r\00E9e dans la base de donn\00E9es.'),
unistr('En g\00E9n\00E9ral, cette option doit \00EAtre utilis\00E9e lorsque les colonnes de cl\00E9 primaire sont remplies \00E0 partir d''un d\00E9clencheur de base de donn\00E9es ou d''une colonne d''identit\00E9 Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Remarque : si une erreur est g\00E9n\00E9r\00E9e indiquant que la clause RETURNING INTO n''est pas autoris\00E9e, vous devez d\00E9finir cette option sur Non et pr\00E9-remplir les colonnes de cl\00E9 primaire.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>'Ajouter une classe'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ajoute une classe CSS ou plusieurs aux \00E9l\00E9ments affect\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4413)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Classe'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ajouter les classes CSS <code>articlenumber</code> et <code>highlight</code> \00E0 la balise HTML des \00E9l\00E9ments affect\00E9s :'),
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('Indiquez au moins une classe \00E0 appliquer aux \00E9l\00E9ments affect\00E9s. Si vous en indiquez plusieurs, s\00E9parez les noms de classe par un espace.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>'Enlever la classe'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Enl\00E8ve une classe CSS ou plusieurs des \00E9l\00E9ments affect\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4413)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Classe'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>Indiquez au moins un nom de classe \00E0 enlever des \00E9l\00E9ments affect\00E9s. Si vous en indiquez plusieurs, s\00E9parez les noms de classe par un espace. Pour enlever tous les noms de classe des \00E9l\00E9ments affect\00E9s, laissez ce champ vide.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>unistr('D\00E9finir le style')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('D\00E9finit une propri\00E9t\00E9 (CSS) de style pour les \00E9l\00E9ments affect\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4413)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nom de style'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez le nom de la propri\00E9t\00E9 CSS de style \00E0 d\00E9finir pour les \00E9l\00E9ments affect\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4413)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Entrez la valeur de propri\00E9t\00E9 de style \00E0 d\00E9finir pour les \00E9l\00E9ments affect\00E9s. Pour enlever la propri\00E9t\00E9 de style des \00E9l\00E9ments affect\00E9s, laissez ce champ vide.')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>'Personnalisation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Mod\00E8le d''authentification permettant de d\00E9finir vos propres fonctions PL/SQL afin de d\00E9terminer l''authentification utilisateur.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nom de fonction de sentinelle'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez du code PL/SQL renvoyant une valeur bool\00E9enne, dans la zone de texte Code PL/SQL -</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
unistr('<p>Indiquez une fonction de base de donn\00E9es PL/SQL - </p>'),
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nom d''une fonction ex\00E9cut\00E9e par le moteur &PRODUCT_NAME. au d\00E9but de toute demande adress\00E9e au moteur, par exemple avant que chaque page soit affich\00E9e ou trait\00E9e, ou qu''une demande AJAX soit \00E9mise. '),
unistr('Il peut \00EAtre d\00E9fini dans le code PL/SQL de l''authentification, dans un package ou en tant que fonction stock\00E9e.</p>'),
unistr('<p>Lorsque cette fonction renvoie la valeur False (indiquant peut-\00EAtre que l''utilisateur n''est pas connect\00E9), la session est alors marqu\00E9e comme non valide et l''\00E9l\00E9ment <em>Proc\00E9dure de session non valide</em> est appel\00E9.'),
unistr('Ensuite, &PRODUCT_NAME. redirige l''utilisateur vers l''URL d\00E9finie dans Session non valide > Atteindre.'),
'Si ce champ ne contient aucune valeur,',
unistr('une sentinelle interne par d\00E9faut est appel\00E9e pour tenter d''\00E9tablir une session valide en comparant l''ID de session de l''URL et les informations de session du cookie de mod\00E8le d''authentification (avec une solution de secours vers le cookie &PRODUCT_N')
||unistr('AME. en cas d''\00E9chec).</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Nom de proc\00E9dure de session non valide')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nom d''une proc\00E9dure PL/SQL \00E0 appeler en cas de d\00E9tection d''une session non valide.</p>'),
'',
unistr('<p>Il peut r\00E9f\00E9rencer une fonction du bloc de code PL/SQL anonyme, une fonction de package ou une fonction autonome dans la base de donn\00E9es. Par exemple : <code>invalid_session_basic_auth</code></p>'),
'',
unistr('<p>S''il fait r\00E9f\00E9rence \00E0 une fonction autonome ou une fonction de package PL/SQL de base de donn\00E9es, vous pouvez utiliser la cha\00EEne de substitution <code>#OWNER#</code> pour r\00E9f\00E9rencer le sch\00E9ma d''analyse de l''application en cours. Par exemple : <cod')
||'e>#OWNER#.invalid_session_basic_auth</code></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nom de fonction d''authentification'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Saisissez le code suivant dans la zone de texte Code PL/SQL</p>',
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
'<p>et <code>my_authentication</code> en tant que fonction d''authentification.'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez le nom de la fonction qui v\00E9rifiera le nom et le mot de passe de l''utilisateur une fois qu''ils auront \00E9t\00E9 saisis sur une page de connexion.'),
unistr('Si vous n''entrez pas de donn\00E9es, vous autorisez l''emploi de n''importe quel nom utilisateur/mot de passe.'),
unistr('La fonction proprement dite peut \00EAtre d\00E9finie dans la zone de texte de code PL/SQL de l''authentification, dans un package ou en tant que fonction stock\00E9e.</p>'),
'',
unistr('<p>Cette fonction doit renvoyer une valeur bool\00E9enne \00E0 la proc\00E9dure de connexion qui l''appelle. Elle comporte 2 param\00E8tres de sortie, ''p_username'' et ''p_password'', permettant d''acc\00E9der aux valeurs que l''utilisateur final a saisies sur la page de conn')
||'exion.<p/>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Nom de proc\00E9dure de post-d\00E9connexion')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Saisissez le code suivant dans la zone de texte Code PL/SQL</p>',
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
'<p>and <code>my_post_logout</code> as ''Post Logout Procedure''.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nom de la proc\00E9dure qui est appel\00E9e lorsque l''utilisateur final clique sur l''URL de d\00E9connexion. Il peut \00EAtre utilis\00E9 pour la connexion.'),
unistr('La proc\00E9dure proprement dite peut \00EAtre d\00E9finie dans la zone de texte de code PL/SQL de l''authentification, dans un package ou en tant que fonction stock\00E9e.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Activer les attributs d''authentification h\00E9rit\00E9s')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Des attributs d''authentification suppl\00E9mentaires sont affich\00E9s lorsque cette liste de s\00E9lection est d\00E9finie sur Oui.'),
unistr('Ils concernent principalement les authentifications personnalis\00E9es issues de &PRODUCT_NAME. 4.0 et des versions ant\00E9rieures.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Nom d''application partenaire SSO'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si vous effectuez l''authentification aupr\00E8s d''Oracle Application Server Single Sign-On et que votre application est une application partenaire inscrite aupr\00E8s de SSO, saisissez exactement le m\00EAme nom que celui que vous avez indiqu\00E9 lors de l''inscript')
||unistr('ion de l''application partenaire aupr\00E8s de SSO.'),
'',
'Si vous pensez utiliser Application Express en tant qu''application partenaire inscrite, laissez ce champ vide.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('H\00F4te LDAP')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Nom d''h\00F4te du serveur d''annuaire LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Port LDAP'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Num\00E9ro de port de l''h\00F4te d''annuaire LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Utiliser le protocole SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si le protocole SSL doit \00EAtre utilis\00E9 pour lier l''annuaire LDAP. Si l''option SSL avec authentification est s\00E9lectionn\00E9e, un portefeuille doit \00EAtre configur\00E9 pour l''instance Application Express.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4413)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4413)
,p_display_sequence=>20
,p_display_value=>'SSL avec authentification'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4413)
,p_display_sequence=>30
,p_display_value=>'Non SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Cha\00EEne DN LDAP')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>DN exact</dt>',
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
'  <dt>DN non exact (base de recherche)</dt>',
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>unistr('Saisissez le mod\00E8le servant \00E0 construire la cha\00EEne de nom distinctif (DN) qualifi\00E9 complet pour DBMS_LDAP.SIMPLE_BIND_S si vous utilisez un DN exact ou indiquez la base de recherche si vous utilisez un DN non exact. Utilisez <strong>%LDAP_USER%</stro')
||unistr('ng> comme valeur de r\00E9serve pour le nom utilisateur.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Utiliser le nom distinctif (DN) exact'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Indiquez si la cha\00EEne du nom distinctif (DN) LDAP est exacte ou non. Si elle n''est pas exacte, le nom distinctif (DN) LDAP repr\00E9sente la base de la recherche et vous devez fournir un filtre de recherche.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Filtre de recherche'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('Entrez le filtre de recherche lorsque vous n''avez pas recours \00E0 un nom distinctif exact. Utilisez <code>%LDAP_USER%</code> comme valeur de r\00E9serve pour le nom utilisateur.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Fonction de modification de nom utilisateur LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le code suivant appelle une fonction qui remplace tous les points (".") par des traits de soulignement ("_") dans la cha\00EEne de nom distinctif :</p>'),
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('Vous pouvez indiquer du code suppl\00E9mentaire \00E0 ex\00E9cuter pour transformer le nom utilisateur et lui donner un format parfaitement adapt\00E9 \00E0 une entr\00E9e d''annuaire LDAP ou \00E0 un nom utilisateur LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4413)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Echappement du nom utilisateur'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Avant de remplacer <code><strong>%LDAP_USER%</strong></code> dans le nom distinctif LDAP et la cha\00EEne de recherche,'),
unistr('&PRODUCT_NAME. peut automatiquement ins\00E9rer un caract\00E8re d''\00E9chappement devant les caract\00E8res sp\00E9ciaux figurant dans le nom utilisateur.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4413)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Echappement des caract\00E8res sp\00E9ciaux conform\00E9ment aux normes RFC 4514 (pour les noms distinctifs) et RFC 4515 (pour les cha\00EEnes de recherche).'),
unistr('Echappement des caract\00E8res Unicode \00E9galement.'),
unistr('Il s''agit du param\00E8tre le plus s\00E9curis\00E9, mais il peut entra\00EEner des probl\00E8mes sur certains serveurs LDAP.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Caract\00E8res sp\00E9ciaux uniquement')
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Echappement des caract\00E8res sp\00E9ciaux conform\00E9ment aux normes RFC 4514 (pour les noms distinctifs) et RFC 4515 (pour les cha\00EEnes de recherche).'),
unistr('Aucun \00E9chappement des caract\00E8res Unicode.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Pas d''\00E9chappement')
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aucun \00E9chappement d''aucun caract\00E8re. Ce param\00E8tre est potentiellement dangereux,'),
unistr('sauf si une <strong>fonction de modification de nom utilisateur</strong> est employ\00E9e et proc\00E8de d\00E9j\00E0'),
unistr('\00E0 l''\00E9chappement du nom utilisateur (par exemple, <code>apex_escape.ldap_dn</code> ou <code>apex_escape.ldap_search_filter</code>).')))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('Ex\00E9cuter le code')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Processus permettant d''ex\00E9cuter le code PL/SQL.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('Fermer la bo\00EEte de dialogue')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Processus permettant de fermer la page de bo\00EEte de dialogue modale ou non modale en cours.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4413)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('El\00E9ments \00E0 renvoyer ')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nom des \00E9l\00E9ments de page que la bo\00EEte de dialogue doit renvoyer. S\00E9parez les noms d''\00E9l\00E9ment par une virgule.</p>'),
unistr('<p>Vous pouvez acc\00E9der aux valeurs d''\00E9l\00E9ment renvoy\00E9es en d\00E9finissant une action dynamique de fa\00E7on \00E0 ce qu''elle soit d\00E9clench\00E9e en cas d''\00E9v\00E9nement <strong>Bo\00EEte de dialogue ferm\00E9e</strong> sur l''\00E9l\00E9ment qui ouvre la bo\00EEte de dialogue, avec l''action ')
||unistr('<strong>D\00E9finir une valeur</strong> et l''action <em>D\00E9finir un type</em> d\00E9finie sur <strong>El\00E9ment renvoy\00E9 de bo\00EEte de dialogue</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('Effacer l''\00E9tat de session')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Processus permettant d''effacer l''\00E9tat de session stock\00E9 dans &PRODUCT_NAME..')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4413)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez le type d''\00E9tat de session \00E0 effacer.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_display_sequence=>1
,p_display_value=>unistr('Effacer tous les \00E9l\00E9ments sur la page en cours')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_display_sequence=>3
,p_display_value=>unistr('Effacer tous les \00E9l\00E9ments sur les pages')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_display_sequence=>5
,p_display_value=>unistr('Effacer les \00E9l\00E9ments  ')
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_display_sequence=>7
,p_display_value=>'Effacer la session en cours'
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_display_sequence=>9
,p_display_value=>'Effacer l''application en cours'
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_display_sequence=>10
,p_display_value=>'Effacer les applications'
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4413)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Applications'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>unistr('Saisissez la liste des ID d''application, s\00E9par\00E9s par des virgules (par exemple : <code>100,101,105</code>).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4413)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ments')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('S\00E9lectionnez les \00E9l\00E9ments de page \00E0 effacer de l''\00E9tat de session, comme <code>P1_EMPNO,P1_ENAME</code>. S\00E9parez les noms d''\00E9l\00E9ment par une virgule. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4413)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Pages'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>unistr('Saisissez la liste des num\00E9ros de page, s\00E9par\00E9s par des virgules (par exemple : <code>1,2,5</code>).')
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('R\00E9initialiser la pagination')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus permettant de r\00E9initialiser la pagination des \00E9tats sur la page en cours.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4413)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Cible'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si la pagination doit \00EAtre r\00E9initialis\00E9e sur toutes les pages, certaines pages ou la page en cours.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4413)
,p_display_sequence=>10
,p_display_value=>'Cette page'
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4413)
,p_display_sequence=>20
,p_display_value=>'Pages'
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4413)
,p_display_sequence=>30
,p_display_value=>'Toutes les pages'
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4413)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Pages'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>unistr('Saisissez la liste des num\00E9ros de page, s\00E9par\00E9s par des virgules.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>'Panneau tabulaire - Ajouter des lignes'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processus permettant d''ajouter une ligne dans une r\00E9gion de panneau tabulaire.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4413)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre de lignes'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>'Entrez le nombre de lignes.'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('Panneau tabulaire - Mise \00E0 jour multiligne')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processus permettant de mettre \00E0 jour plusieurs lignes d''une r\00E9gion de panneau tabulaire. Ce processus ins\00E8re \00E9galement les enregistrements ajout\00E9s dans la r\00E9gion.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4413)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4413)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4413)
,p_help_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4413)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Colonne de cl\00E9 primaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4413)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne contenant la valeur de cl\00E9 primaire. Pour les tables contenant des cl\00E9s primaires compos\00E9es de plus deux \00E9l\00E9ments, choisissez <strong>ROWID</strong>.</p>'),
unistr('<p>La cl\00E9 primaire permet d''identifier les lignes \00E0 mettre \00E0 jour et ne doit pas \00EAtre modifiable dans le panneau tabulaire. Pour les nouvelles lignes, la valeur de cl\00E9 primaire doit \00EAtre vide.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4413)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Colonne de cl\00E9 secondaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4413)
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la seconde valeur de cl\00E9 primaire. Cet attribut doit \00EAtre rempli uniquement si la cl\00E9 primaire est compos\00E9e de deux colonnes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4413)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Clause WHERE d''ex\00E9cution')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez les services \00E0 l''aide de :'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Saisissez la clause SQL WHERE \00E0 ajouter \00E0 la fin de toutes les instructions INSERT et UPDATE g\00E9n\00E9r\00E9es. Utilisez cet attribut pour limiter les enregistrements employ\00E9s dans des appels SQL g\00E9n\00E9r\00E9s automatiquement.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>'Extraction de ligne automatique'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processus permettant d''extraire les enregistrements d''une vue ou d''une table de base de donn\00E9es unique. Ce processus est \00E9galement utilis\00E9 pour remplir les \00E9l\00E9ments de panneau avec une source de type <strong>Colonne de base de donn\00E9es</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4413)
,p_help_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ment de cl\00E9 primaire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir la valeur de colonne de cl\00E9 primaire. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>unistr('Colonne de cl\00E9 primaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4413)
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la valeur de cl\00E9 primaire. Pour les tables contenant des cl\00E9s primaires compos\00E9es de plus de deux \00E9l\00E9ments, choisissez <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('El\00E9ment de cl\00E9 secondaire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir la seconde valeur de colonne de cl\00E9 primaire. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>unistr('Colonne de cl\00E9 secondaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4413)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la seconde valeur de cl\00E9 primaire. Cet attribut doit \00EAtre rempli uniquement si la cl\00E9 primaire est compos\00E9e de deux colonnes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Colonne de version de ligne'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4413)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne identifiant la version de la ligne (cette colonne n''a pas besoin d''\00EAtre pr\00E9sente sur la page). Laissez cet attribut vide pour utiliser le checksum int\00E9gr\00E9.</p>'),
unistr('<p>Le verrouillage adapt\00E9 utilise la d\00E9tection des mises \00E0 jour perdues pour garantir l''int\00E9grit\00E9 des donn\00E9es dans les applications dans lesquelles les donn\00E9es sont accessibles simultan\00E9ment. &PRODUCT_NAME. peut utiliser un checksum int\00E9gr\00E9 pour ex\00E9c')
||unistr('uter la d\00E9tection des mises \00E0 jour perdues et d\00E9terminer la version de la ligne. Le checksum est une fonction de hachage de toutes les valeurs de colonne pour la ligne de table sp\00E9cifique. Il est extrait lorsque l''enregistrement est interrog\00E9 \00E0 parti')
||unistr('r de la base de donn\00E9es, puis compar\00E9 au hachage de l''enregistrement en cours dans la base de donn\00E9es dans le cadre du <em>traitement de ligne automatique</em>. Si les deux valeurs sont identiques, la mise \00E0 jour continue, sinon une erreur est g\00E9n\00E9r\00E9')
||'e par le traitement de ligne automatique.</p>',
unistr('<p>Cet attribut vous permet d''indiquer une colonne unique contenant la version de la ligne, ce qui offre une alternative \00E0 l''utilisation du traitement de checksum int\00E9gr\00E9. Cette colonne doit \00EAtre mise \00E0 jour lorsqu''un enregistrement dans la base de d')
||unistr('onn\00E9es est mis \00E0 jour. Oracle recommande d''impl\00E9menter un d\00E9clencheur de base de donn\00E9es ''Avant la mise \00E0 jour'' sur la table pour incr\00E9menter ou mettre \00E0 jour la colonne de version de ligne. Les colonnes NUMBER sont cens\00E9es contenir un num\00E9ro de s\00E9qu')
||unistr('ence de la ligne. Toutefois, les colonnes DATE et TIMESTAMP peuvent \00E9galement \00EAtre utilis\00E9es. Avec l''utilisation d''une colonne unique, le moteur &PRODUCT_NAME. n''a pas besoin d''effectuer le hachage de la ligne compl\00E8te, il peut simplement comparer un')
||unistr('e valeur de colonne unique \00E0 la place.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Clause WHERE d''ex\00E9cution')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez les services \00E0 l''aide de :'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Saisissez la clause SQL WHERE \00E0 ajouter \00E0 la fin de l''instruction SELECT g\00E9n\00E9r\00E9e. Utilisez cet attribut pour limiter les enregistrements employ\00E9s dans des appels SQL g\00E9n\00E9r\00E9s automatiquement.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4413)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Mode d''extraction'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Cette option est disponible \00E0 des fins de compatibilit\00E9 amont uniquement.'),
unistr('Ce param\00E8tre doit \00EAtre laiss\00E9 vide pour les nouvelles applications.'),
unistr('L''option D\00E9finir la m\00E9moire cache sur affichage est en phase d''abandon et n''est pas utilis\00E9e dans les processus g\00E9n\00E9r\00E9s dans la cette version de &PRODUCT_NAME..'),
'</p>',
'<p>',
unistr('Lorsqu''un processus d''extraction de ligne automatis\00E9e s\00E9lectionne une ligne, les \00E9l\00E9ments de page correspondants prennent les valeurs des colonnes extraites. Le param\00E8tre Mode d''extraction DML d\00E9termine \00E0 quel moment cela se fait. Avec le mode par d\00E9')
||unistr('faut, l''\00E9tat de session en m\00E9moire est mis \00E0 jour d\00E8s que la ligne est extraite. Avec le mode D\00E9finir la m\00E9moire cache sur affichage, l''\00E9tat de session n''est mis \00E0 jour que lorsque l''\00E9l\00E9ment est affich\00E9 (s''il l''est). Si vous devez faire r\00E9f\00E9rence \00E0 l')
||unistr('a valeur extraite pour l''\00E9l\00E9ment \00E0 l''aide de la syntaxe de variable attach\00E9e ou <code>v(''ITEM_NAME'')</code> entre le moment o\00F9 la ligne est extraite et le moment o\00F9 l''\00E9l\00E9ment est affich\00E9, vous devez utiliser le mode d''extraction par d\00E9faut. Lorsque v')
||unistr('ous cr\00E9ez un processus d''extraction de ligne automatis\00E9e, il est automatiquement d\00E9fini sur le mode d''extraction par d\00E9faut. A moins que la logique de votre page ne n\00E9cessite le comportement "sur affichage", nous vous conseillons de mettre \00E0 jour le ')
||unistr('processus afin qu''il utilise le mode par d\00E9faut ; vous pourrez ainsi faire r\00E9f\00E9rence aux valeurs de colonne extraites au cours de l''affichage de page.'),
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4413)
,p_display_sequence=>20
,p_display_value=>unistr('D\00E9finir la m\00E9moire cache sur affichage [En phase d''abandon]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>'Service Web'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus permettant d''utiliser le service Web sp\00E9cifi\00E9.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4413)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Op\00E9ration de service Web')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('S\00E9lectionnez une op\00E9ration de service Web.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4413)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Stocker le r\00E9sultat dans')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4413)
,p_display_sequence=>10
,p_display_value=>unistr('El\00E9ments')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4413)
,p_display_sequence=>20
,p_display_value=>'Collection'
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4413)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nom de collection'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>'Pagination de panneau'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Processus permettant d''extraire l''enregistrement pr\00E9c\00E9dent ou suivant d''une vue ou d''une table de base de donn\00E9es. Ce processus peut \00EAtre utilis\00E9 pour fournir la pagination sur les pages de panneau, de sorte que l''utilisateur final puisse extraire')
||unistr(' l''enregistrement pr\00E9c\00E9dent ou suivant sans avoir \00E0 naviguer \00E0 nouveau jusqu''\00E0 un \00E9tat.</p>'),
unistr('<p><em>Remarque : si le panneau permet la mise \00E0 jour des donn\00E9es, vous devez g\00E9n\00E9ralement vous assurer que le traitement de panneau appropri\00E9 est effectu\00E9 avant d''ex\00E9cuter ce processus de pagination. Dans le cas contraire, toute mise \00E0 jour apport\00E9e')
||unistr(' par l''utilisateur final sera perdue lorsqu''il acc\00E8dera \00E0 un autre enregistrement.</em></p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4413)
,p_help_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('El\00E9ment de cl\00E9 primaire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la valeur de colonne de cl\00E9 primaire. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('Colonne de cl\00E9 primaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4413)
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la valeur de cl\00E9 primaire. Pour les tables contenant des cl\00E9s primaires compos\00E9es de plus de deux \00E9l\00E9ments, choisissez <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('El\00E9ment de cl\00E9 secondaire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la seconde valeur de colonne de cl\00E9 primaire. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('Colonne de cl\00E9 secondaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4413)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la seconde valeur de cl\00E9 primaire. Cet attribut doit \00EAtre rempli uniquement si la cl\00E9 primaire est compos\00E9e de deux colonnes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Colonne d''ordre de navigation'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4413)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne contenant la valeur d''ordre de navigation.</p>'),
unistr('<p>Cette colonne permet de d\00E9terminer les lignes pr\00E9c\00E9dentes et suivantes. Par cons\00E9quent, une colonne comme <code>DISPLAY_SEQ</code> est id\00E9ale \00E0 utiliser. Si vous souhaitez ordonner les enregistrements en fonction de la s\00E9quence selon laquelle ils ')
||unistr('ont \00E9t\00E9 cr\00E9\00E9s, utilisez une colonne comme <code>CREATED</code> ou <code>ID</code>, si elle est remplie \00E0 partir d''une s\00E9quence ou bas\00E9e sur une colonne d''identit\00E9 Oracle Database 12<em>c</em>. Vous avez toutefois la possibilit\00E9 d''ordonner les enregis')
||'trements selon deux autres colonnes, par exemple <code>JOB</code> et <code>DEPTNO</code></p>',
unistr('<p><em>Remarque : les colonnes d''ordre de navigation doivent correspondre aux colonnes par d\00E9faut utilis\00E9es pour classer l''\00E9tat auquel les utilisateurs finals ont acc\00E9d\00E9 pour obtenir ce panneau. Vous devez \00E9galement vous assurer que les utilisateurs ')
||unistr('finals comprennent la m\00E9thode utilis\00E9e pour d\00E9terminer les lignes pr\00E9c\00E9dentes et suivantes, par exemple \00E0 l''aide de libell\00E9s de bouton ou de texte d''aide.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Colonne d''ordre de navigation secondaire'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4413)
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la seconde valeur d''ordre de navigation. Cet attribut doit \00EAtre rempli uniquement si la cl\00E9 de navigation est compos\00E9e de deux colonnes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('El\00E9ment de cl\00E9 primaire suivant')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la valeur de colonne de cl\00E9 primaire pour l''enregistrement <em>suivant</em>. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('El\00E9ment de cl\00E9 primaire pr\00E9c\00E9dent')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la valeur de colonne de cl\00E9 primaire pour l''enregistrement <em>pr\00E9c\00E9dent</em>. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('El\00E9ment de cl\00E9 secondaire suivant')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la seconde valeur de colonne de cl\00E9 primaire pour l''enregistrement <em>suivant</em>. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('El\00E9ment de cl\00E9 secondaire pr\00E9c\00E9dent')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la seconde valeur de colonne de cl\00E9 primaire pour l''enregistrement <em>pr\00E9c\00E9dent</em>. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('El\00E9ment de nombre de lignes en cours')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez l''\00E9l\00E9ment de page ou d''application devant contenir la valeur du nombre total d''enregistrements. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.</p>'),
unistr('<p>Si l''ensemble de r\00E9sultats contient plus de 10 000 lignes, la d\00E9finition de cet \00E9l\00E9ment peut entra\00EEner une baisse des performances.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4413)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Clause WHERE d''ex\00E9cution')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>unistr('Entrez une instruction SQL pour limiter les enregistrements renvoy\00E9s par la requ\00EAte.')
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>unistr('Service Web h\00E9rit\00E9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processus permettant d''utiliser le service Web sp\00E9cifi\00E9. Oracle recommande de mettre \00E0 jour ce processus vers <strong>Service Web</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4413)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('R\00E9f\00E9rence de service Web')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez le num\00E9ro de r\00E9f\00E9rence du service Web.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4413)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Stocker le r\00E9sultat dans')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4413)
,p_display_sequence=>10
,p_display_value=>unistr('El\00E9ments')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4413)
,p_display_sequence=>20
,p_display_value=>'Collection'
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4413)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nom de collection'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>'Zone de texte'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Affiche une zone de texte multiligne.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4413)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redimensionnable'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la fonction de redimensionnement de la zone de texte \00E0 l''aide de la souris est activ\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4413)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Hauteur automatique'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la hauteur de la zone de texte varie en fonction de la longueur du texte affich\00E9. Utilisez cette option pour redimensionner la zone de texte selon la quantit\00E9 de donn\00E9es.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4413)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Compteur de caract\00E8res')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si un compteur est affich\00E9 sous la zone de texte. Le compteur affiche le nombre de caract\00E8res saisis dans le champ et le nombre total de caract\00E8res autoris\00E9s (par exemple : <code>123 sur 4 000</code>). L''attribut Longueur maximale doit \00EAtre ')
||unistr('indiqu\00E9 lorsqu''il est activ\00E9.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4413)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Supprimer les espaces'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la m\00E9thode \00E0 utiliser pour tronquer la valeur de l''\00E9l\00E9ment apr\00E8s la soumission de la page. Ce param\00E8tre supprime les espaces, les tabulations et les sauts de ligne dans le texte saisi.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4413)
,p_display_sequence=>10
,p_display_value=>unistr('D\00E9but')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4413)
,p_display_sequence=>20
,p_display_value=>'Fin'
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4413)
,p_display_sequence=>30
,p_display_value=>unistr('D\00E9but et fin')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4413)
,p_display_sequence=>40
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>'Etat classique'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Etat simplifi\00E9 bas\00E9 sur une requ\00EAte SQL. Les \00E9tats classiques sont semblables aux \00E9tats interactifs, mais ils n''incluent pas les nombreuses options de personnalisation mises \00E0 la disposition des utilisateurs finals dans les \00E9tats interactifs.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4413)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>'Panneau tabulaire'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Affiche plusieurs lignes de donn\00E9es dans une mise en page de grille, dans laquelle les utilisateurs finals peuvent mettre \00E0 jour les valeurs directement au sein d''un \00E9l\00E9ment de grille.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4413)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4413)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>'Etat interactif'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Etat en ligne complet bas\00E9 sur une requ\00EAte SQL qui fournit aux utilisateurs finals de nombreuses fonctionnalit\00E9s permettant de personnaliser la mise en page de l''\00E9tat au moment de l''ex\00E9cution. Vous pouvez contr\00F4ler les fonctions mises \00E0 la disposi')
||unistr('tion des utilisateurs finals en activant ou d\00E9sactivant les diff\00E9rentes options de personnalisation d''\00E9tat.</p>'),
unistr('<p>Vous pouvez d\00E9finir un seul \00E9tat interactif dans lequel les utilisateurs finals peuvent manipuler les donn\00E9es affich\00E9es pour r\00E9pondre \00E0 leurs propres exigences en mati\00E8re de g\00E9n\00E9ration d''\00E9tats, plut\00F4t que de d\00E9velopper plusieurs \00E9tats similaires a')
||unistr('vec des crit\00E8res diff\00E9rents.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4413)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Structure du menu Actions'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si la structure du menu Actions sera coh\00E9rente avec le composant de grille interactive ou si la structure h\00E9rit\00E9e sera utilis\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4413)
,p_display_sequence=>10
,p_display_value=>unistr('H\00E9rit\00E9')
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4413)
,p_display_sequence=>20
,p_display_value=>'Grille interactive'
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4413)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>'Contenu statique'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Affiche le contenu de texte ou un conteneur de r\00E9gion pour les \00E9l\00E9ments de page. Pour g\00E9n\00E9rer le balisage HTML sans \00E9chappement du contenu, d\00E9finissez la propri\00E9t\00E9 <em>Sortie au format</em> sur <strong>HTML</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4413)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>unistr('D\00E9velopper les raccourcis')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>unistr('Indiquez si &PRODUCT_NAME. d\00E9veloppe les raccourcis dans le corps HTML.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4413)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Sortie au format'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez la m\00E9thode utilis\00E9e pour g\00E9n\00E9rer le contenu du texte.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Texte (caract\00E8res sp\00E9ciaux d''\00E9chappement)')
,p_return_value=>'TEXT'
,p_help_text=>unistr('&PRODUCT_NAME. proc\00E8de \00E0 l''\00E9chappement de caract\00E8res sp\00E9ciaux HTML, tels que <code>"<", ">", "&"</code>, lors de l''\00E9mission de la source de r\00E9gion.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4413)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME. inclut du balisage HTML lors de l''\00E9mission de la source de r\00E9gion. Ceci peut rendre la r\00E9gion vuln\00E9rable au scriptage inter-site.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4413)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Afficher les sauts de ligne'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('Indiquez si les sauts de ligne dans la r\00E9gion source entra\00EEnent des sauts de ligne dans la r\00E9gion de sortie.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4413)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4413)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>'Contenu dynamique PL/SQL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Affiche la sortie HTML du code PL/SQL.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4413)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4413)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>'Graphique SVG'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Affiche les donn\00E9es dans un graphique SVG. Ce type de r\00E9gion est en phase d''abandon. Utilisez le type de r\00E9gion <em>Graphique</em> pour les nouvelles r\00E9gions de graphique. Oracle recommande d''utiliser <em>Mettre \00E0 niveau l''application</em> pour mettr')
||unistr('e \00E0 jour ces r\00E9gions vers la r\00E9gion de graphique \00E9quivalente.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4413)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4413)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>'Graphique simple'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Affiche les donn\00E9es dans un graphique HTML. Ce type de r\00E9gion est en phase d''abandon. Utilisez le type de r\00E9gion <em>Graphique</em> pour les nouvelles r\00E9gions de graphique. Oracle recommande d''utiliser <em>Mettre \00E0 niveau l''application</em> pour mett')
||unistr('re \00E0 jour ces r\00E9gions vers la r\00E9gion de graphique \00E9quivalente.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>'Arborescence'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche les donn\00E9es dans une structure hi\00E9rarchique, en fonction des relations parent-enfant entre les enregistrements.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>'Activer le lien de noeud avec'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>S\00E9lectionnez l''action requise pour activer les liens de noeud sur l''arborescence. Une arborescence peut servir principalement \00E0 des fins de s\00E9lection/d''affichage ou de navigation. Si elle est utilis\00E9e \00E0 la fois pour la s\00E9lection et la navigation, ')
||unistr('il est recommand\00E9 de d\00E9finir cette option sur Double-clic afin qu''un clic simple ne s\00E9lectionne que le noeud.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4413)
,p_display_sequence=>10
,p_display_value=>'Un seul clic'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4413)
,p_display_sequence=>20
,p_display_value=>'Double-clic'
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('El\00E9ment de page de noeud s\00E9lectionn\00E9')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application devant contenir la valeur du noeud s\00E9lectionn\00E9. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.</p>'),
unistr('<p>Cet \00E9l\00E9ment permet d''enregistrer l''\00E9tat de l''arborescence, en d\00E9tenant la valeur du dernier noeud s\00E9lectionn\00E9. Cette valeur peut \00EAtre enregistr\00E9e dans l''\00E9l\00E9ment s\00E9lectionn\00E9 via l''attribut de lien de noeud ou via un processus de page. Une fois la p')
||unistr('age recharg\00E9e, elle s''ouvre sur la valeur du noeud s\00E9lectionn\00E9.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>'Info-bulle'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si les info-bulles sont affich\00E9es et s\00E9lectionnez leur source. Si une info-bulle est d\00E9finie, elle appara\00EEt lorsque l''utilisateur final s\00E9lectionne ou positionne la souris sur un libell\00E9 de noeud de l''arborescence.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4413)
,p_display_sequence=>10
,p_display_value=>'Aucun'
,p_return_value=>'N'
,p_help_text=>unistr('Aucune info-bulle ne sera affich\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Mod\00E8le h\00E9rit\00E9')
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>unistr('Utilisez une valeur d''info-bulle statique avec les substitutions de colonne de source de donn\00E9es suivantes : #VALUE#, #TITLE#, #LINK# et #TOOLTIP#')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4413)
,p_display_sequence=>30
,p_display_value=>'Expression HTML'
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('Indiquez une expression HTML \00E0 utiliser en tant qu''info-bulle. Des substitutions sont effectu\00E9es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4413)
,p_display_sequence=>40
,p_display_value=>unistr('Colonne de base de donn\00E9es')
,p_return_value=>'DB'
,p_help_text=>'Utilisez la valeur de la <strong>colonne Info-bulle</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>'Valeur d''info-bulle'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>unistr('Entrez le texte qui appara\00EEt lorsqu''un utilisateur final positionne la souris sur un \00E9l\00E9ment de l''arborescence.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>'ID d''arborescence statique'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identificateur unique facultatif de l''arborescence.</p>',
unistr('<p>Il est conseill\00E9 d''attribuer un ID statique \00E0 la r\00E9gion et d''utiliser l''API apex.region("<i>static-id</i>").widget() pour acc\00E9der \00E0 l''\00E9l\00E9ment d''arborescence.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>unistr('Classe CSS de type d''ic\00F4ne')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Classe CSS servant \00E0 indiquer le type des ic\00F4nes utilis\00E9es pour tous les noeuds. Dans les r\00E8gles CSS, cette classe permet de sp\00E9cifier les propri\00E9t\00E9s de toutes les ic\00F4nes de ce type. Le type d''ic\00F4ne, ainsi que la valeur de la colonne d''ic\00F4ne de la')
||unistr(' source de r\00E9gion, d\00E9terminent les classes CSS d''ic\00F4ne utilis\00E9es pour chaque noeud.</p>'),
'<p>Valeurs types :</p>',
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong> : permet d''utiliser un petit nombre d''ic\00F4nes APEX int\00E9gr\00E9es telles que <code>icon-circle</code> ou <code>icon-tree-folder</code>.</li>'),
unistr('<li><strong><code>fa</code></strong> : permet d''utiliser des ic\00F4nes Font APEX ou Font Awesome. Avec le th\00E8me universel, vous disposez de l''une de ces biblioth\00E8ques d''ic\00F4nes.</li>'),
'</ul>',
unistr('<p>En l''absence de valeur, aucun type d''ic\00F4ne n''est d\00E9fini. La classe CSS de type d''ic\00F4ne peut \00EAtre incluse dans la colonne d''ic\00F4ne, si n\00E9cessaire. Par exemple, la valeur de la colonne d''ic\00F4ne peut \00EAtre "fa fa-user".'),
unistr('Pour une arborescence sans ic\00F4ne, laissez vides le type d''ic\00F4ne et les attributs d''ic\00F4ne par d\00E9faut. Dans la source de requ\00EAte SQL, la colonne d''ic\00F4ne doit \00E9galement \00EAtre NULL.'),
unistr('Les th\00E8mes personnalis\00E9s ou tiers peuvent disposer de leur propre police ou biblioth\00E8que d''ic\00F4nes de sprite CSS, et utiliser une autre classe de pr\00E9fixe/type d''ic\00F4ne (que vous pouvez indiquer ici).</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>unistr('Classe CSS d''ic\00F4nes facultative')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>Si le type d''ic\00F4ne est <code>fa</code> pour Police APEX, vous pouvez utiliser les valeurs suivantes : <code>fa-user-circle-o</code>, <code>fa-file-o</code> ou <code>fa-arrow-circle-right</code>. Reportez-vous \00E0 l''application de th\00E8me universel pou')
||unistr('r obtenir la liste compl\00E8te des ic\00F4nes.</p>')
,p_help_text=>unistr('Ic\00F4ne par d\00E9faut \00E0 utiliser lorsque la colonne de l''ic\00F4ne de requ\00EAte SQL est NULL. La valeur est un nom de classe CSS indiquant l''ic\00F4ne \00E0 afficher. Les valeurs possibles d\00E9pendent du type d''ic\00F4ne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>unistr('Colonne de libell\00E9s de noeud')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur de libell\00E9 de noeud. La valeur ne peut pas contenir de balisage.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>unistr('Colonne de niveaux de hi\00E9rarchie')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur pour le niveau de hi\00E9rarchie du noeud. Obligatoire lorsque l''attribut <strong>Hi\00E9rarchie</strong> est d\00E9fini sur <strong>Non calcul\00E9</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>unistr('Colonne de classe CSS d''ic\00F4nes')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur de la classe CSS d''ic\00F4ne \00E0 appliquer au noeud.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>'Colonne d''ID de noeud'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient l''ID d''un noeud. Obligatoire lorsque la hi\00E9rarchie est calcul\00E9e par Application Express. Une colonne de cl\00E9 primaire est g\00E9n\00E9ralement choisie ici.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>unistr('Colonne de cl\00E9 parent')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur pour la cl\00E9 parent d''un noeud. Obligatoire si Application Express calcule la hi\00E9rarchie.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>'Colonne de statuts de noeud'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur pour le statut de noeud. Obligatoire lorsque l''attribut <strong>Hi\00E9rarchie</strong> est d\00E9fini sur <strong>Non calcul\00E9</strong>. La colonne doit contenir <strong>0</strong> pour les ')
||'noeuds feuille et <strong>1</strong> pour les noeuds avec enfants.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>unistr('Arborescence de d\00E9part avec')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Cet attribut d\00E9termine la mani\00E8re dont la racine de l''arborescence est calcul\00E9e. Les noeuds, pour lesquels la colonne <strong>Cl\00E9 parent</strong> contient la valeur d\00E9finie ici, sont consid\00E9r\00E9s comme des noeuds racine. Plusieurs racines sont possible')
||'s.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4413)
,p_display_sequence=>10
,p_display_value=>unistr('A partir d''un \00E9l\00E9ment existant')
,p_return_value=>'ITEM'
,p_help_text=>unistr('Utilisez une valeur d''\00E9l\00E9ment pour commencer l''arborescence.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4413)
,p_display_sequence=>20
,p_display_value=>unistr('A partir d''une requ\00EAte SQL')
,p_return_value=>'SQL'
,p_help_text=>unistr('Utilisez la valeur renvoy\00E9e par une requ\00EAte SQL pour commencer l''arborescence.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4413)
,p_display_sequence=>30
,p_display_value=>'A partir d''une valeur statique'
,p_return_value=>'STATIC'
,p_help_text=>'Utilisez une valeur statique pour commencer l''arborescence.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4413)
,p_display_sequence=>40
,p_display_value=>'La valeur est NULL'
,p_return_value=>'NULL'
,p_help_text=>'Utilisez une valeur SQL NULL pour commencer l''arborescence.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>unistr('El\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('Choisissez l''\00E9l\00E9ment contenant la valeur avec laquelle commencer l''arborescence.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>unistr('Requ\00EAte SQL')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('Sp\00E9cifiez la requ\00EAte SQL permettant de d\00E9terminer la valeur avec laquelle commencer l''arborescence. La requ\00EAte SQL est toujours ex\00E9cut\00E9e dans la <em>base de donn\00E9es locale</em> et doit renvoyer exactement une colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>'Valeur statique'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>'Valeur statique avec laquelle commencer l''arborescence.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>'Colonne de valeur de noeud'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur du noeud "valeur". Cette valeur n''est pas affich\00E9e, mais est ajout\00E9e \00E0 la propri\00E9t\00E9 d''ID de noeud d''adaptateur de l''arborescence accessible \00E0 l''aide de JavaScript.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>'Lien'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Sp\00E9cifiez le lien \00E0 ex\00E9cuter lorsque vous cliquez sur un noeud.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>'Colonne d''info-bulle'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur pour l''info-bulle du noeud.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>unistr('Hi\00E9rarchie')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si Application Express doit calculer la hi\00E9rarchie d''arborescences \00E0 partir des donn\00E9es ou si les donn\00E9es contiennent d\00E9j\00E0 toutes les informations de hi\00E9rarchie.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Calcul\00E9 avec SQL')
,p_return_value=>'SQL'
,p_help_text=>unistr('La hi\00E9rarchie est calcul\00E9e \00E0 l''aide de la clause SQL START WITH CONNECT BY. Vous devez indiquer une <strong>colonne de cl\00E9 parent</strong>. Utilisez cette option uniquement si votre requ\00EAte SQL ne contient <em>pas</em> d\00E9j\00E0 de clause START WITH CONNE')
||'CT BY.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Non calcul\00E9')
,p_return_value=>'LEVEL'
,p_help_text=>unistr('Toutes les informations de hi\00E9rarchie sont d\00E9j\00E0 contenues dans les donn\00E9es. Le mapping des colonnes <strong>Niveau de noeud</strong> et <strong>Statut de noeud</strong> est obligatoire pour cette option. <strong>Niveau de noeud</strong> doit contenir')
||unistr(' le niveau de hi\00E9rarchie sous forme de valeur num\00E9rique, <strong>Statut de noeud</strong> doit contenir <strong>0</strong> pour un noeud feuille et <strong>1</strong> pour un noeud non feuille.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>'Colonne de lien'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es qui contient la valeur du lien \00E0 ex\00E9cuter lorsque vous cliquez sur un noeud.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>unistr('Classer les fr\00E8res par')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('S\00E9lectionnez la colonne de source de donn\00E9es \00E0 utiliser pour organiser les enfants au sein d''un noeud parent.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez une fonction JavaScript qui prend un objet d''options de l''arborescence, modifie cet objet, puis le renvoie. Cela permet une personnalisation avanc\00E9e de l''arborescence lors de l''initialisation du widget treeView. Pour conna\00EEtre les option')
||unistr('s disponibles, reportez-vous \00E0 la documentation des API JavaScript du widget treeView.<p>'),
unistr('<p>Options suppl\00E9mentaires d\00E9finies par la r\00E9gion d''arborescence :</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong> : permet de d\00E9finir un \00E9l\00E9ment nodeAdapter personnalis\00E9. Il s''agit d''une fonction qui utilise les m\00EAmes arguments que makeDefaultNodeAdapter et doit renvoyer une interface treeNodeAdapter.</li>'),
unistr('<li><strong>initialSelectedNodeId</strong> : valeur d''un noeud \00E0 s\00E9lectionner. Cette option est d\00E9finie en fonction de l''attribut El\00E9ment de page de noeud s\00E9lectionn\00E9.</li>'),
unistr('<li><strong>nodeHasTooltip</strong> : cette option est d\00E9finie en fonction de l''attribut Info-bulle. Elle a la valeur True si le noeud poss\00E8de une info-bulle. Sinon, la valeur est False.</li>'),
unistr('<li><strong>regionStaticId</strong> : ID d''\00E9l\00E9ment utilis\00E9 pour cette r\00E9gion.</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Lorsque l''attribut de hi\00E9rarchie est d\00E9fini sur Calcul\00E9 avec SQL</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
unistr('<p>Indiquez EMPNO pour la colonne des ID de noeud, MGR pour les attributs de la colonne de cl\00E9 parent</p>'),
'</dd>',
unistr('<dt>Lorsque l''attribut de hi\00E9rarchie est d\00E9fini sur Non calcul\00E9</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
unistr('<p>Indiquez STATUS pour la colonne de statut de noeud, LEVEL pour les attributs de la colonne des niveaux de hi\00E9rarchie.</p>'),
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4413)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4413)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('Modification de s\00E9lection')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>'Calendrier'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche les entr\00E9es bas\00E9es sur la date dans diff\00E9rentes vues de calendrier.</p>'),
unistr('<p>Lorsque vous cr\00E9ez des r\00E9gions, utilisez <em>Calendrier</em> plut\00F4t que ce type de r\00E9gion. Les r\00E9gions de calendrier classique sont g\00E9n\00E9ralement celles cr\00E9\00E9es dans &PRODUCT_NAME. 4.2 ou une version ant\00E9rieure.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4413)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4413)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>'Arborescence classique'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche les donn\00E9es dans une structure hi\00E9rarchique, en fonction des relations parent-enfant entre les enregistrements.</p>'),
unistr('<p>Lorsque vous cr\00E9ez des r\00E9gions, utilisez <em>Arborescence</em> plut\00F4t que ce type de r\00E9gion. </p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4413)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'ID de composant d''arborescence'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>unistr('D\00E9velopper l''arborescence')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('D\00E9veloppe le noeud en cours dans une r\00E9gion d''arborescence.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>unistr('R\00E9duire l''arborescence')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('R\00E9duit le noeud en cours dans une r\00E9gion d''arborescence.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>'Mot de passe'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un \00E9l\00E9ment de panneau de mot de passe HTML. Lorsque l''utilisateur final saisit le texte, un point noir appara\00EEt \00E0 la place de chaque caract\00E8re.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4413)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Soumettre lorsque la touche Entr\00E9e est activ\00E9e')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la page est soumise automatiquement lorsque l''utilisateur appuie sur la touche <em>Entr\00E9e</em> dans ce champ.')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>unistr('Arr\00EAter et d\00E9marrer une mise en page de grille')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El\00E9ment h\00E9rit\00E9 permettant d''arr\00EAter le tableau HTML pr\00E9c\00E9dent et d''en d\00E9marrer un nouveau. Avant que la <em>mise en page de grille</em> soit introduite dans &PRODUCT_NAME. version xx, ce type d''\00E9l\00E9ment \00E9tait souvent utilis\00E9 pour personnaliser l''af')
||unistr('fichage des \00E9l\00E9ments de page.</p>'),
unistr('<p>Oracle recommande de supprimer ces types d''\00E9l\00E9ment h\00E9rit\00E9 et de d\00E9finir la propri\00E9t\00E9 <em>D\00E9marrer une nouvelle grille</em> sur <strong>Oui</strong> pour le prochain \00E9l\00E9ment de page affich\00E9 dans cette r\00E9gion. Sur le plan fonctionnel, cela revient \00E0')
||unistr(' utiliser un \00E9l\00E9ment Arr\00EAter et d\00E9marrer une mise en page de grille.</p>')))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>unistr('R\00E9g\00E9n\00E9rer')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('D\00E9clenche la r\00E9g\00E9n\00E9ration des \00E9l\00E9ments affect\00E9s. Les \00E9l\00E9ments ne prennent pas tous en charge une action de r\00E9g\00E9n\00E9ration. Utilisez cette action pour r\00E9g\00E9n\00E9rer le contenu des \00E9tats interactifs, des \00E9tats classiques et de tous les types d''\00E9l\00E9ment prenan')
||'t en charge les listes de valeurs (LOV) en cascade.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>'Afficher'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Affiche les \00E9l\00E9ments affect\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4413)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Afficher tous les \00E9l\00E9ments sur la m\00EAme ligne')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si tous les \00E9l\00E9ments et libell\00E9s de page sur la m\00EAme ligne que les \00E9l\00E9ments affect\00E9s sont affich\00E9s.</p>'),
unistr('<p>Remarque : cet attribut ne fonctionne pas pour les \00E9l\00E9ments sur les pages qui n''utilisent pas de grille de table pour afficher les \00E9l\00E9ments de panneau. Cela inclut toute page utilisant un mod\00E8le de page mobile.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>unistr('Variable d''en-t\00EAte HTTP')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Authentification externe avec le nom utilisateur stock\00E9 dans une variable d''en-t\00EAte HTTP d\00E9finie par le serveur Web.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4413)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nom de variable d''en-t\00EAte HTTP')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indique le nom de la variable d''en-t\00EAte HTTP contenant le nom utilisateur. Si aucune valeur n''est indiqu\00E9e, la valeur REMOTE_USER sera utilis\00E9e.</p>'),
'',
unistr('<p>La variable d''en-t\00EAte HTTP est une variable d\00E9finie par le serveur Web.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4413)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action si le champ Nom utilisateur est vide'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Indique l''action \00E0 effectuer si le nom utilisateur stock\00E9 dans la variable d''en-t\00EAte HTTP est vide. Les options disponibles sont les suivantes :'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>R\00E9acheminer vers l''URL int\00E9gr\00E9e</strong> permet d''initier une connexion via le serveur Web. L''URL int\00E9gr\00E9e doit \00EAtre configur\00E9e de fa\00E7on \00E0 \00EAtre prot\00E9g\00E9e par le serveur Web afin de pouvoir forcer une connexion lorsqu''elle est appel\00E9e. Ap')
||unistr('r\00E8s la connexion, le serveur Web doit stocker le nom utilisateur valid\00E9 dans la variable d''en-t\00EAte HTTP pour qu''il soit disponible pour le mod\00E8le d''authentification. L''URL int\00E9gr\00E9e est'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('Le pr\00E9fixe <code>/apex/</code> d\00E9pend de la configuration du serveur.'),
'</li>',
unistr('  <li><strong>R\00E9acheminer vers l''URL</strong> permet d''initier une connexion sur un serveur externe qui d\00E9finit ensuite le nom utilisateur valid\00E9 dans la variable d''en-t\00EAte HTTP. Le serveur externe doit effectuer un r\00E9acheminement vers l''application ')
||unistr('en utilisant l''URL g\00E9n\00E9r\00E9e par la valeur de r\00E9serve <code>#CALLBACK#</code> pour terminer l''authentification dans l''application.</li>'),
unistr('  <li><strong>Afficher l''erreur</strong> permet d''afficher le message d''erreur indiqu\00E9 et aucune connexion ne sera \00E9tablie dans l''application.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4413)
,p_display_sequence=>10
,p_display_value=>unistr('R\00E9acheminer vers l''URL int\00E9gr\00E9e')
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4413)
,p_display_sequence=>20
,p_display_value=>unistr('R\00E9acheminer vers une URL')
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4413)
,p_display_sequence=>30
,p_display_value=>'Afficher erreur'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4413)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('Indique l''URL d''un serveur de connexion externe qui d\00E9finit le nom utilisateur valid\00E9 dans la variable d''en-t\00EAte HTTP. Le serveur externe doit effectuer le r\00E9acheminement vers l''application \00E0 l''aide de l''URL g\00E9n\00E9r\00E9e par la valeur de r\00E9serve <code>#CA')
||'LLBACK#</code> pour terminer l''authentification dans l''application.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4413)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Message d''erreur'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>unistr('Indique le message d''erreur \00E0 afficher si la variable d''en-t\00EAte HTTP ne contient aucune valeur ou si elle n''existe pas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4413)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('V\00E9rifier le nom utilisateur')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Indique la fr\00E9quence de v\00E9rification du nom utilisateur stock\00E9 dans la variable d''en-t\00EAte HTTP. Les options suivantes sont disponibles :'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>A chaque demande</strong> : la variable CGI est toujours d\00E9finie d\00E8s que la connexion est \00E9tablie par le serveur Web. Si le nom utilisateur n''est pas le m\00EAme que celui qui est stock\00E9 dans la session &PRODUCT_NAME. en cours, la session n')
||unistr('e sera pas valid\00E9e et une nouvelle connexion sera initi\00E9e. Il s''agit de l''option la plus s\00E9curis\00E9e car elle d\00E9tecte les d\00E9connexions ou les modifications de nom utilisateur.'),
'  </li>',
unistr('  <li><strong>Apr\00E8s la connexion</strong> : v\00E9rifie et stocke le nom utilisateur dans la session &PRODUCT_NAME. uniquement apr\00E8s que le serveur Web a \00E9tabli la connexion et lorsqu''il appelle le callback pour terminer l''authentification dans l''applica')
||unistr('tion. Pour le callback, reportez-vous \00E0 la configuration de l''\00E9l\00E9ment Action si le nom utilisateur est vide.'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4413)
,p_display_sequence=>10
,p_display_value=>'A chaque demande'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Apr\00E8s la connexion')
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4413)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('URL de d\00E9connexion du serveur SSO')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour d\00E9finir un acc\00E8s SSO bas\00E9 sur Oracle Access Manager, saisissez par exemple :</p>'),
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si le mod\00E8le d''authentification est bas\00E9 sur Oracle Access Manager ou des serveurs similaires,'),
unistr('utilisez cet attribut pour indiquer une URL permettant de se d\00E9connecter du serveur SSO central.</p>'),
'',
unistr('<p>Le param\00E8tre de substitution <code>%POST_LOGOUT_URL%</code> sera remplac\00E9 par une URL encod\00E9e pointant vers la page de connexion de l''application.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>'Expression HTML'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un \00E9l\00E9ment dans lequel la saisie n''est pas autoris\00E9e \00E0 partir d''une expression HTML.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4413)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Expression HTML'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Modifier les couleurs de fond et du texte</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Utiliser l''en-t\00EAte 2</dt>'),
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utiliser une classe dynamique \00E0 partir de la requ\00EAte SQL</dt>'),
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    Les substitutions <code>&amp;COLUMN_CLASS!ATTR.</code> et <code>&amp;EMPLOYEE_STATUS.</code> de cet exemple repr\00E9sentent des colonnes s\00E9lectionn\00E9es dans la requ\00EAte SQL.</dd>'),
'  <dt>Afficher une image et une info-bulle au passage du curseur</dt>',
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Entrez les expressions HTML \00E0 afficher dans cette colonne. Utilisez la syntaxe <code>&amp;COLUMN.</code> pour afficher les valeurs de colonne en HTML.')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>'Lien'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un \00E9l\00E9ment dans lequel la saisie n''est pas autoris\00E9e en tant que lien.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>'Effacer'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Efface les \00E9l\00E9ments affect\00E9s.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>'Alerte'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un message d''alerte, avec un bouton <em>OK</em> unique. La s\00E9lection de ce bouton permet d''afficher des informations n\00E9cessitant une r\00E9ponse, tout en continuant l''ex\00E9cution de l''\00E9v\00E9nement.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4413)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Message'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;Impossible&lt;&#x2F;strong&gt; de supprimer l''employ\00E9 &amp;P1_ENAME..</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le message \00E0 afficher dans la bo\00EEte de dialogue d''alerte.</p>'),
unistr('<p>Les substitutions d''\00E9l\00E9ment sont r\00E9alis\00E9es c\00F4t\00E9 client lors de l''affichage de la bo\00EEte de dialogue.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4413)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Titre'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>Indiquez \00E9ventuellement le titre de la bo\00EEte de dialogue.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4413)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Valeur par d\00E9faut')
,p_help_text=>unistr('Indiquez le style de la bo\00EEte de dialogue.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4413)
,p_display_sequence=>10
,p_display_value=>'Informations'
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4413)
,p_display_sequence=>20
,p_display_value=>'Danger'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4413)
,p_display_sequence=>30
,p_display_value=>'Avertissement'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4413)
,p_display_sequence=>40
,p_display_value=>unistr('Succ\00E8s')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4413)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Ic\00F4ne')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez une ic\00F4ne facultative de bo\00EEte de dialogue.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4413)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Entrez des classes CSS facultatives \00E0 appliquer au conteneur de bo\00EEte de dialogue.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4413)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Libell\00E9 OK')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Entrez le libell\00E9 du bouton OK. Si aucun n''est indiqu\00E9, la valeur du message texte <code>APEX.DIALOG.OK</code> est utilis\00E9e.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>'Confirmer'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche une bo\00EEte de dialogue de confirmation, avec les boutons Annuler et Confirmer. Si l''utilisateur s\00E9lectionne <em>Annuler</em>, les actions suivantes ne sont pas ex\00E9cut\00E9es et l''\00E9v\00E9nement en cours est annul\00E9.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4413)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Message'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;Voulez-vous&lt;&#x2F;strong&gt; supprimer l''employ\00E9 &amp;P1_ENAME. ?</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le message \00E0 afficher dans la bo\00EEte de dialogue de confirmation.</p>'),
unistr('<p>Les substitutions d''\00E9l\00E9ment sont r\00E9alis\00E9es c\00F4t\00E9 client lors de l''affichage de la bo\00EEte de dialogue.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4413)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Titre'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>Indiquez \00E9ventuellement le titre de la bo\00EEte de dialogue.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4413)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Valeur par d\00E9faut')
,p_help_text=>unistr('Indiquez le style de la bo\00EEte de dialogue.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4413)
,p_display_sequence=>10
,p_display_value=>'Informations'
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4413)
,p_display_sequence=>20
,p_display_value=>'Avertissement'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4413)
,p_display_sequence=>30
,p_display_value=>'Danger'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4413)
,p_display_sequence=>40
,p_display_value=>unistr('Succ\00E8s')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4413)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Ic\00F4ne')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez une ic\00F4ne facultative de bo\00EEte de dialogue.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4413)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Entrez des classes CSS facultatives \00E0 appliquer au conteneur de bo\00EEte de dialogue.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4413)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Libell\00E9 Confirmer')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Entrez le libell\00E9 du bouton Confirmer. Si aucun n''est indiqu\00E9, la valeur du message texte <code>APEX.DIALOG.OK</code> est utilis\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4413)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Libell\00E9 Annuler')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Entrez le libell\00E9 du bouton Annuler. Si aucun n''est indiqu\00E9, la valeur du message texte <code>APEX.DIALOG.CANCEL</code> est utilis\00E9e.')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>unistr('Analyser les donn\00E9es t\00E9l\00E9charg\00E9es')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processus permettant d''analyser les donn\00E9es de feuille de calcul pr\00E9par\00E9es en vue du chargement dans une table existante. Ce type de processus est g\00E9n\00E9r\00E9 par l''assistant Cr\00E9er une page pour le <em>chargement des donn\00E9es</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('D\00E9finition de chargement des donn\00E9es')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Dans Composants partag\00E9s, s\00E9lectionnez la d\00E9finition de chargement des donn\00E9es d\00E9terminant la table \00E0 charger.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Importer \00E0 partir de l''\00E9l\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir l''option <em>Importer \00E0 partir de</em> s\00E9lectionn\00E9e par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ment de s\00E9parateur')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le texte de l''option <em>S\00E9parateur</em> saisi par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('El\00E9ment de d\00E9limitation')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le texte de l''option <em>Eventuellement d\00E9limit\00E9 par</em> saisi par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('El\00E9ment de premi\00E8re ligne')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir la valeur de la case \00E0 cocher <em>La premi\00E8re ligne contient des noms de colonne</em> saisie par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('El\00E9ment de symbole mon\00E9taire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le texte de l''option <em>Symbole mon\00E9taire</em> saisi par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('El\00E9ment de s\00E9parateur de groupes')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le texte de l''option <em>S\00E9parateur de groupes</em> saisi par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('El\00E9ment de marque d\00E9cimale')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le texte de l''option <em>Marque d\00E9cimale</em> saisi par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('El\00E9ment de nom de fichier')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir la valeur du champ <em>Nom de fichier</em> saisie par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('El\00E9ment de copier/coller')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le texte de l''option <em>Copier/coller les donn\00E9es d\00E9limit\00E9es</em> saisi par l''utilisateur final. Vous pouvez entrer un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('El\00E9ment de jeu de caract\00E8res')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le <em>jeu de caract\00E8res de fichier</em> s\00E9lectionn\00E9 par l''utilisateur final. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4413)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('El\00E9ment de format de date')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page devant contenir le texte de <em>format de date</em> saisi par l''utilisateur final. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>unistr('Mapping de colonne de t\00E9l\00E9chargement des donn\00E9es')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Met en correspondance les colonnes de feuille de calcul t\00E9l\00E9charg\00E9es avec les colonnes de table. Ce type de r\00E9gion est g\00E9n\00E9r\00E9 par l''assistant de Cr\00E9er une page pour le <em>chargement des donn\00E9es</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4413)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('D\00E9finition de chargement des donn\00E9es')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la d\00E9finition de chargement des donn\00E9es d\00E9finie dans le processus <em>Chargement des donn\00E9es</em>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>unistr('Pr\00E9parer les donn\00E9es t\00E9l\00E9charg\00E9es')
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processus permettant de pr\00E9parer les donn\00E9es de feuille de calcul en vue du t\00E9l\00E9chargement dans une table existante. Ce type de processus est g\00E9n\00E9r\00E9 par l''assistant Cr\00E9er une page pour le <em>chargement des donn\00E9es</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4413)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('D\00E9finition de chargement des donn\00E9es')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Dans Composants partag\00E9s, s\00E9lectionnez la d\00E9finition de chargement des donn\00E9es d\00E9terminant la table \00E0 charger.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4413)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('El\00E9ment de nombre d''insertions')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements \00E0 ins\00E9rer. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4413)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ment de nombre de mises \00E0 jour')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements \00E0 mettre \00E0 jour. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4413)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('El\00E9ment de nombre d''erreurs')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements avec des erreurs. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4413)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('El\00E9ment de nombre de r\00E9visions')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements v\00E9rifi\00E9s. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>unistr('Charger les donn\00E9es t\00E9l\00E9charg\00E9es')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processus permettant de charger les donn\00E9es de feuille de calcul analys\00E9es dans une table ou une vue existante. Ce type de processus est g\00E9n\00E9r\00E9 par l''assistant Cr\00E9er une page pour le <em>chargement des donn\00E9es</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4413)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('D\00E9finition de chargement des donn\00E9es')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Dans Composants partag\00E9s, s\00E9lectionnez la d\00E9finition de chargement des donn\00E9es d\00E9terminant la table \00E0 charger.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4413)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('El\00E9ment de nombre d''insertions')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements ins\00E9r\00E9s.'),
unistr('Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4413)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ment de nombre de mises \00E0 jour')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements mis \00E0 jour.'),
unistr('Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4413)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('El\00E9ment de nombre d''erreurs')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements avec des erreurs.'),
unistr('Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4413)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('El\00E9ment de nombre de r\00E9visions')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir le nombre d''enregistrements v\00E9rifi\00E9s.'),
unistr('Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>'Comptes Application Express'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Saisissez le nom utilisateur et le mot de passe de votre compte &PRODUCT_NAME.. Chaque espace de travail a son propre r\00E9f\00E9rentiel de comptes utilisateur. L''application \00E0 laquelle vous vous connectez appartient \00E0 l''espace de travail &amp;F4155_WORK')
||'SPACE_NAME.. N''oubliez pas que, pour les mots de passe, il y a distinction entre les majuscules et les minuscules.</p>'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>'Informations d''identification porte ouverte'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Permet \00E0 quiconque d''acc\00E9der \00E0 votre application. Saisissez tout identificateur permettant de vous identifier en tant qu''utilisateur de l''application au cours de la session. La valeur saisie sera affect\00E9e \00E0 la variable APP_USER.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>unistr('Comptes de base de donn\00E9es')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Pour ce mod\00E8le d''authentification, un utilisateur de base de donn\00E9es (sch\00E9ma) doit exister dans la base de donn\00E9es locale. Lors de l''utilisation de cette m\00E9thode, le nom utilisateur et le mot de passe du compte de base de donn\00E9es servent \00E0 authentifi')
||'er l''utilisateur.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>'Annuaire LDAP'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Authentification de l''utilisateur/du mot de passe \00E0 l''aide d''une demande d''authentification aupr\00E8s d''un serveur LDAP.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('H\00F4te')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Nom d''h\00F4te du serveur d''annuaire LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Num\00E9ro de port de l''h\00F4te d''annuaire LDAP. Valeur par d\00E9faut : 389.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Utiliser le protocole SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si le protocole SSL doit \00EAtre utilis\00E9 pour lier l''annuaire LDAP. Si l''option SSL avec authentification est s\00E9lectionn\00E9e, un portefeuille doit \00EAtre configur\00E9 pour l''instance &PRODUCT_NAME..')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4413)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4413)
,p_display_sequence=>20
,p_display_value=>'SSL avec authentification'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4413)
,p_display_sequence=>30
,p_display_value=>'Non SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Cha\00EEne de nom distinctif (DN)')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le mod\00E8le servant \00E0 construire la cha\00EEne de nom distinctif (DN) qualifi\00E9 complet pour DBMS_LDAP.SIMPLE_BIND_S si vous utilisez un DN exact ou indiquez la base de recherche si vous utilisez un DN non exact. Utilisez <strong>%LDAP_USER%</stro')
||unistr('ng> comme valeur de r\00E9serve pour le nom utilisateur. Par exemple :'),
'<p>',
'<strong>DN exact</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>DN non exact (base de recherche)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Utiliser le nom distinctif (DN) exact'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la cha\00EEne du nom distinctif (DN) LDAP est exacte ou non. Si elle n''est pas exacte, le nom distinctif (DN) LDAP repr\00E9sente la base de la recherche et vous devez fournir un filtre de recherche.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Filtre de recherche'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le filtre de recherche lorsque vous n''avez pas recours \00E0 un nom distinctif (DN) exact. Utilisez <strong>%LDAP_USER%</strong> comme valeur de r\00E9serve pour le nom utilisateur. Par exemple :'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Fonction de modification de nom utilisateur LDAP'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Vous pouvez indiquer du code suppl\00E9mentaire \00E0 ex\00E9cuter pour transformer le nom utilisateur et lui donner un format parfaitement adapt\00E9 \00E0 l''entr\00E9e d''annuaire LDAP ou au nom utilisateur LDAP.'),
unistr('La variable attach\00E9e :USERNAME contient le nom que l''utilisateur final a indiqu\00E9.'),
unistr('Par exemple, le code ci-dessous appelle une fonction rempla\00E7ant tous les caract\00E8res "." par des caract\00E8res "_" dans la cha\00EEne de nom distinctif :</p>'),
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME. ins\00E9rera des caract\00E8res d''\00E9chappement dans le nom utilisateur renvoy\00E9 en fonction de l''attribut d''authentification <strong>Echappement du nom utilisateur</strong>.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4413)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Echappement du nom utilisateur'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Avant de remplacer <strong>%LDAP_USER%</strong> dans le nom distinctif LDAP et la cha\00EEne de recherche,'),
unistr('&PRODUCT_NAME. peut automatiquement ins\00E9rer un caract\00E8re d''\00E9chappement devant les caract\00E8res sp\00E9ciaux figurant dans le nom utilisateur.'),
'<p/>',
unistr('Les r\00E8gles d''\00E9chappement possibles sont les suivantes :'),
'<ul>',
'<li><strong>Standard</strong> :',
unistr('Echappement des caract\00E8res sp\00E9ciaux conform\00E9ment aux normes RFC 4514 (pour les noms distinctifs) et RFC 4515 (pour les cha\00EEnes de recherche).'),
unistr('Echappement des caract\00E8res Unicode \00E9galement.'),
unistr('Il s''agit du param\00E8tre le plus s\00E9curis\00E9, mais il peut entra\00EEner des probl\00E8mes sur les serveurs LDAP.</li>'),
unistr('<li><strong>Caract\00E8res sp\00E9ciaux uniquement</strong> :'),
unistr('Echappement des caract\00E8res sp\00E9ciaux conform\00E9ment aux normes RFC 4514 (pour les noms distinctifs) et RFC 4515 (pour les cha\00EEnes de recherche).'),
unistr('Aucun \00E9chappement des caract\00E8res Unicode.</li>'),
unistr('<li><strong>Pas d''\00E9chappement</strong> :'),
unistr('Aucun \00E9chappement d''aucun caract\00E8re.'),
unistr('Ce param\00E8tre est potentiellement dangereux,'),
unistr('sauf si une <strong>fonction de modification de nom utilisateur</strong> est utilis\00E9e et proc\00E8de d\00E9j\00E0'),
unistr('\00E0 l''\00E9chappement du nom utilisateur (par exemple, apex_escape.ldap_dn ou apex_escape.ldap_search_filter).</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4413)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Caract\00E8res sp\00E9ciaux uniquement')
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Pas d''\00E9chappement')
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('D\00E9l\00E8gue l''authentification au serveur Oracle AS Single Sign-On (SSO). Pour utiliser ce mod\00E8le d''authentification, votre site doit \00EAtre inscrit en tant qu''application partenaire aupr\00E8s du serveur SSO.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4413)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nom d''application partenaire'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si vous effectuez l''authentification aupr\00E8s d''Oracle Application Server Single Sign-On et que votre application est une application partenaire inscrite aupr\00E8s de SSO, saisissez exactement le m\00EAme nom que celui que vous avez indiqu\00E9 lors de l''inscript')
||unistr('ion de l''application partenaire aupr\00E8s de SSO.'),
'</p>',
'<p>',
'Si vous pensez utiliser &PRODUCT_NAME. en tant qu''application partenaire inscrite, laissez ce champ vide.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4413)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('URL de d\00E9connexion du serveur SSO')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez le chemin de d\00E9connexion du serveur SSO, par exemple :'),
'<em>https://login.example.com/sso/logout</em>.',
unistr('Lorsque vous vous d\00E9connectez de l''application, &PRODUCT_NAME. utilise cette valeur, concat\00E8ne ''?p_done_url='' et l''URL de connexion de l''application, utilise l''URL obtenue pour se d\00E9connecter du serveur SSO et redirige l''utilisateur vers l''applicatio')
||'n.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4413)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>'Aucune authentification'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Adopte l''utilisateur de base de donn\00E9es en cours. Cette m\00E9thode peut \00EAtre utilis\00E9e conjointement \00E0 une configuration DAD mod_plsql utilisant l''authentification de base pour d\00E9finir l''utilisateur de la session de base de donn\00E9es.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4413)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nom utilisateur'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('Entrez le nom utilisateur pour la session &PRODUCT_NAME.. S''il n''est pas indiqu\00E9, &PRODUCT_NAME. se sert de l''utilisateur de session de base de donn\00E9es (en g\00E9n\00E9ral, APEX_PUBLIC_USER).')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>'Calendrier'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche les entr\00E9es bas\00E9es sur la date dans diff\00E9rentes vues de calendrier. Si une date de fin est indiqu\00E9e, le calendrier peut afficher les \00E9v\00E9nements bas\00E9s sur la dur\00E9e. Les calendriers peuvent \00E9galement mettre \00E0 jour les enregistrements directemen')
||unistr('t si la fonction Glisser-d\00E9placer est activ\00E9e.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Cl\00E9 d''API Google Agenda [en phase d''abandon]')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Entrez la cl\00E9 d''API Google Agenda pour que les calendriers de cette application s''int\00E8grent aux donn\00E9es Google Agenda.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>unistr('Colonne de date de d\00E9but')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la date de d\00E9but des \00E9v\00E9nements affich\00E9s sur le calendrier.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Colonne de date de fin'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la date de fin des \00E9v\00E9nements affich\00E9s sur le calendrier. Si cet attribut est indiqu\00E9, le calendrier affiche les \00E9v\00E9nements bas\00E9s sur la dur\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>'Colonne d''affichage'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant le texte affich\00E9 pour les \00E9v\00E9nements sur le calendrier.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>unistr('Colonne de cl\00E9 primaire')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne contenant la valeur de cl\00E9 primaire pour les \00E9v\00E9nements de calendrier. Si la table contient une cl\00E9 primaire multipart, choisissez <strong>ROWID</strong>.</p>'),
unistr('<p>La valeur de cette colonne est renvoy\00E9e dans la variable de substitution <code>APEX$PK_VALUE</code>. Utilisez cette variable dans l''attribut <em>Code de glisser-d\00E9placer</em> pour identifier l''enregistrement \00E0 mettre \00E0 jour, apr\00E8s l''op\00E9ration de g')
||unistr('lisser-d\00E9placer sur le calendrier.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>'Lien de visualisation/modification'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Saisissez la page cible \00E0 appeler lorsque l''utilisateur clique sur une entr\00E9e existante.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Cr\00E9er un lien')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la page cible \00E0 appeler lorsque l''utilisateur clique sur une cellule vide ou \00E0 l''ext\00E9rieur d''une entr\00E9e de calendrier existante.</p>'),
unistr('<p>Vous devez utiliser les variables de substitution sp\00E9ciales du calendrier <pre>&APEX$NEW_START_DATE.</pre> et <pre>&APEX$NEW_END_DATE.</pre> pour transmettre les dates s\00E9lectionn\00E9es du calendrier \00E0 la page cible.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>unistr('Glisser-d\00E9placer')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les op\00E9rations de glisser-d\00E9placer sont autoris\00E9es sur le calendrier.</p>'),
unistr('<p><em>Remarque : si les op\00E9rations de glisser-d\00E9placer sont activ\00E9es, les utilisateurs finals dot\00E9s de droits permettant de visualiser le calendrier disposent \00E9galement de droits permettant de mettre \00E0 jour des entr\00E9es de calendrier.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>unistr('Code PL/SQL de glisser-d\00E9placer')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exemple avec date de d\00E9but uniquement (pour les \00E9v\00E9nements non bas\00E9s sur la dur\00E9e)</dt>'),
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
unistr('<dt>Exemple avec des dates de d\00E9but et de fin (pour les \00E9v\00E9nements bas\00E9s sur la dur\00E9e)</dt>'),
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le code PL/SQL permettant de mettre \00E0 jour les vues modifiables ou les tables sous-jacentes lorsqu''une entr\00E9e de calendrier est mise \00E0 jour \00E0 l''aide d''une op\00E9ration de glisser-d\00E9placer.</p>'),
unistr('<p>Si le calendrier affiche les \00E9v\00E9nements bas\00E9s sur la dur\00E9e (en s\00E9lectionnant une colonne pour Date de fin), le code PL/SQL doit \00E9galement mettre \00E0 jour cette valeur. Si l''\00E9v\00E9nement complet est d\00E9plac\00E9, la colonne Date de fin conserve la dur\00E9e en c')
||unistr('ours. Si la fin de l''\00E9v\00E9nement est d\00E9plac\00E9e, la dur\00E9e de l''\00E9v\00E9nement est mise \00E0 jour. Dans ce cas, la date de d\00E9but reste inchang\00E9e, mais la date de fin est mise \00E0 jour de mani\00E8re \00E0 refl\00E9ter la dur\00E9e modifi\00E9e.</p>'),
'<p>Les variables de substitution du calendrier sont les suivantes :</p>',
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>Renvoie la date de d\00E9but modifi\00E9e. Le format de date est <code>''YYYYMMDDHH24MISS''</code>, m\00EAme si l''option <em>Afficher l''heure</em> pour le calendrier est d\00E9finie sur <strong>Non</strong>.</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>Renvoie la date de fin modifi\00E9e pour les \00E9v\00E9nements bas\00E9s sur la dur\00E9e. Le format de date est <code>''YYYYMMDDHH24MISS''</code>, m\00EAme si l''option <em>Afficher l''heure</em> pour le calendrier est d\00E9finie sur <strong>Non</strong>.</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
unistr('    <dd>Renvoie la valeur de la colonne indiqu\00E9e dans la colonne Cl\00E9 primaire.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>unistr('Vues de calendrier suppl\00E9mentaires')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez les vues de calendrier suppl\00E9mentaires \00E0 afficher. La vue Mensuel est toujours affich\00E9e.</p>'),
unistr('<p>Remarque : les vues Hebdomadaire et Quotidien ne sont pas disponibles si le param\00E8tre Afficher l''heure est d\00E9fini sur <strong>Non</strong>.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4413)
,p_display_sequence=>40
,p_display_value=>'Liste'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4413)
,p_display_sequence=>50
,p_display_value=>'Navigation'
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Exporter'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choisissez les liens d''export fournis au bas du calendrier.</p>',
unistr('<p><em>Remarque : ces liens permettent d''exporter toutes les entr\00E9es de calendrier actuellement affich\00E9es, et non une entr\00E9e de calendrier unique.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4413)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4413)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4413)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>'Navigation et vues de calendrier'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>S\00E9lectionnez les vues de calendrier \00E0 afficher. Au moins l''une des vues <strong>Jour</strong>, <strong>Semaine</strong> ou <strong>Mois</strong> doit \00EAtre s\00E9lectionn\00E9e. Sinon, le calendrier affichera automatiquement la vue <strong>Mois</strong>.</')
||'p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4413)
,p_display_sequence=>10
,p_display_value=>'Mois'
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4413)
,p_display_sequence=>20
,p_display_value=>'semaine'
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4413)
,p_display_sequence=>30
,p_display_value=>'jour'
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4413)
,p_display_sequence=>35
,p_display_value=>'Liste'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4413)
,p_display_sequence=>40
,p_display_value=>'Navigation'
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'ID Google Agenda'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>'<p>ID Google Agenda : abc123@group.calendar.google.com</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez l''ID Google Agenda pour le flux de donn\00E9es de calendrier \00E0 afficher dans ce calendrier.</p>'),
unistr('<p>Etant donn\00E9 les restrictions de s\00E9curit\00E9 des calendriers Google, ceux-ci doivent \00EAtre publics ou disponibles pour tous les utilisateurs finals du calendrier.</p>'),
unistr('<p><em>Remarque : la cl\00E9 d''API Google Agenda doit \00EAtre entr\00E9e pour que les calendriers Google fonctionnent correctement. Acc\00E9dez \00E0 Composants partag\00E9s > Param\00E8tres de composant > Calendrier afin de d\00E9finir la cl\00E9 pour l''application.</em</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>'Afficher l''heure'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la partie heure de la date doit \00EAtre affich\00E9e. </p>'),
unistr('<p>Les vues Hebdomadaire et Quotidien ne sont affich\00E9es que lorsque le param\00E8tre Afficher l''heure est d\00E9fini sur <strong>Oui</strong>. Si les colonnes de date de d\00E9but ou de date de fin n''incluent pas les composants d''heure, elles sont affich\00E9es avec')
||' 12:00 AM.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>'Classe de feuille de style CSS'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9finition du style du calendrier en fonction du statut de projet</p>'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la colonne contenant la classe CSS pour d\00E9finir le style des \00E9v\00E9nements affich\00E9s sur ce calendrier. <br>'),
unistr('Plusieurs classes par d\00E9faut sont disponibles :'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('Reportez-vous \00E0 la documentation pour savoir comment ajouter des classes CSS suppl\00E9mentaires.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Service Web REST (JSON)'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez l''URL d''un flux de service Web RESTful \00E0 afficher dans le calendrier. Le calendrier peut afficher les donn\00E9es JSON extraites de sources externes, par exemple Oracle REST Data Services. Ces services Web doivent \00EAtre publics ou disponibles')
||' pour tous les utilisateurs finals du calendrier.</p>',
unistr('<p>Le flux JSON doit \00EAtre format\00E9 de fa\00E7on \00E0 inclure les \00E9l\00E9ments suivants :</p>'),
'<ol>',
unistr('<li>Le tableau de liste d''\00E9v\00E9nements contenant - <code>items</code></li>'),
unistr('<li>Chaque objet d''\00E9v\00E9nement contenant - <code>{ id, title, start, allday, end, description }</code><br>Les attributs de titre et de d\00E9but sont obligatoires.</li>'),
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('Informations suppl\00E9mentaires')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le code HTML suppl\00E9mentaire \00E0 afficher dans la vue de liste et l''info-bulle. Utilisez la syntaxe &COLUMN. pour afficher les valeurs de colonne en HTML. </p>'),
unistr('<p>Remarque : pour que ces informations suppl\00E9mentaires soient affich\00E9es dans les vues Mois, Semaine et Jour, d\00E9finissez Afficher l''info-bulle sur <strong>Oui</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>'Afficher le week-end'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si samedi et dimanche sont affich\00E9s pour ce calendrier.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>'Format horaire'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>S\00E9lectionnez le format d''heure utilis\00E9 pour afficher la partie heure d''un \00E9v\00E9nement pour ce calendrier.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Valeur par d\00E9faut')
,p_return_value=>'00'
,p_help_text=>unistr('Utilise le format d''horodatage de l''application, saisi sous Globalisation. Si cet attribut n''est pas rempli, il utilisera le param\00E8tre NLS de base de donn\00E9es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4413)
,p_display_sequence=>20
,p_display_value=>'12 heures'
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche l''heure au format 12 heures avec les lettres a.m. (du latin <em>ante meridiem</em>, qui signifie "avant midi") et p.m. (<em>post meridiem</em>, "apr\00E8s midi"), comme 8:00 a.m. et 4:00 p.m.</p>'),
unistr('<p>Le format d''affichage r\00E9el pour a.m./p.m., comme les majuscules et les points, est d\00E9riv\00E9 du format d''horodatage.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4413)
,p_display_sequence=>30
,p_display_value=>'24 heures'
,p_return_value=>'24'
,p_help_text=>'Affiche l''heure au format 24 heures (par exemple, 08:00 et 16:00).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>'Afficher l''info-bulle'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si une info-bulle appara\00EEt lorsque les utilisateurs positionnent le curseur de la souris sur un \00E9v\00E9nement de ce calendrier.</p>'),
unistr('<p><em>La bo\00EEte de dialogue d\00E9roulante affichera le nom de l''\00E9v\00E9nement, des informations suppl\00E9mentaires et des d\00E9tails sur la date.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>unistr('Premi\00E8re heure')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Saisissez un entier compris entre 0 et 23 pour indiquer la premi\00E8re heure affich\00E9e sur les calendriers Semaine et Jour.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>unistr('Nombre maximal d''\00E9v\00E9nements/jour')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nombre maximal d''\00E9v\00E9nements affich\00E9s pour chaque jour dans la vue Mensuel. </p>'),
unistr('<p>Si un jour sp\00E9cifique, ce nombre est d\00E9pass\00E9, ce jour inclura <strong>Plus...</strong>. Si vous cliquez sur cet \00E9l\00E9ment, une fen\00EAtre instantan\00E9e appara\00EEtra avec tous les \00E9v\00E9nements de ce jour sp\00E9cifique.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('Ev\00E9nements sur plusieurs lignes')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez <strong>Oui</strong> afin que les \00E9v\00E9nements soient affich\00E9s sur plusieurs lignes, en fonction de la longueur du texte de la colonne d''affichage. </p>'),
unistr('<p>S\00E9lectionnez <strong>Non</strong> afin que chaque \00E9v\00E9nement soit affich\00E9 sur une seule ligne et que le texte ne tenant pas dans l''affichage soit tronqu\00E9. Le texte complet sera affich\00E9 dans l''info-bulle.</p>'),
unistr('<p>Remarque : le param\00E8tre des \00E9v\00E9nements sur plusieurs lignes est utilis\00E9 uniquement dans la vue Mensuel. Pour les vues Hebdomadaire et Quotidien, la dur\00E9e de l''\00E9v\00E9nement d\00E9termine la hauteur de l''\00E9v\00E9nement affich\00E9.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>'Version'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3 est en phase d''abandon et sera prochainement remplac\00E9 par FullCalendar 5. Nous vous recommandons d''effectuer la transition maintenant pour \00E9viter que votre application ne cesse de fonctionner dans les versions futures. L''API de Full')
||unistr('Calendar a \00E9t\00E9 modifi\00E9e. Si vous avez utilis\00E9 un code JavaScript d''initialisation personnalis\00E9, vous devrez donc sans doute l''ajuster.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4413)
,p_display_sequence=>10
,p_display_value=>'FullCalendar 3 [en phase d''abandon]'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
unistr('    pOptions.titleFormat      = "[Conference Schedule]";                                // titre personnalis\00E9'),
'    pOptions.slotMinTime      = "07:00:00";                                             // masquer les tranches horaires avant minTime',
unistr('    pOptions.slotMaxTime      = "18:00:00";                                             // masquer les tranches horaires apr\00E8s maxTime'),
unistr('    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // en-t\00EAtes de colonne de vue de semaine'),
unistr('    pOptions.slotDuration     = "00:15:00";                                             // dur\00E9e des tranches horaires personnalis\00E9e'),
unistr('    pOptions.weekNumbers      = true;                                                   // afficher les num\00E9ros de semaine'),
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('Entrez une fonction JavaScript pour remplacer les attributs d''initialisation FullCalendar standard. La fonction doit renvoyer un objet contenant les attributs d''initialisation de calendrier en tant que param\00E8tres.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9finition du style du calendrier en fonction du statut de projet</p>,'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne contenant la classe CSS pour d\00E9finir le style des \00E9v\00E9nements affich\00E9s sur ce calendrier. '),
unistr('Plusieurs classes par d\00E9faut sont disponibles :</p>'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>Reportez-vous \00E0 la documentation pour savoir comment ajouter des classes CSS suppl\00E9mentaires.</p>')))
);
end;
/
begin
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_name=>'apexcalendardateselect'
,p_display_name=>unistr('Date s\00E9lectionn\00E9e')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_name=>'apexcalendareventselect'
,p_display_name=>unistr('Ev\00E9nement s\00E9lectionn\00E9')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4413)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4413)
,p_name=>'apexcalendarviewchange'
,p_display_name=>unistr('Vue modifi\00E9e')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>'Panneau tabulaire - Suppression multiligne'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processus permettant de supprimer plusieurs lignes dans une r\00E9gion de panneau tabulaire.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4413)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4413)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4413)
,p_help_text=>unistr('Entrez le nom de table ou de vue modifiable, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4413)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Colonne de cl\00E9 primaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4413)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne contenant la valeur de cl\00E9 primaire. Pour les tables contenant des cl\00E9s primaires compos\00E9es de plus deux \00E9l\00E9ments, choisissez <strong>ROWID</strong>.</p>'),
unistr('<p>La cl\00E9 primaire permet d''identifier les lignes \00E0 supprimer et ne doit pas \00EAtre modifiable dans le panneau tabulaire. Pour les nouvelles lignes, la valeur de cl\00E9 primaire doit \00EAtre vide.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4413)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Colonne de cl\00E9 secondaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4413)
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la seconde valeur de cl\00E9 primaire. Cet attribut doit \00EAtre rempli uniquement si la cl\00E9 primaire est compos\00E9e de deux colonnes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4413)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Clause WHERE d''ex\00E9cution')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez les services \00E0 l''aide de :'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Saisissez la clause SQL WHERE \00E0 ajouter \00E0 la fin de l''instruction DELETE g\00E9n\00E9r\00E9e. Utilisez cet attribut pour limiter les enregistrements employ\00E9s dans des appels SQL g\00E9n\00E9r\00E9s automatiquement.')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>unistr('Pr\00E9f\00E9rences utilisateur')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus permettant de d\00E9finir les pr\00E9f\00E9rences de l''utilisateur final.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4413)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez un type de processus pour r\00E9initialiser ou d\00E9finir les pr\00E9f\00E9rences utilisateur.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4413)
,p_display_sequence=>10
,p_display_value=>unistr('R\00E9initialiser les pr\00E9f\00E9rences (enl\00E8ve toutes les pr\00E9f\00E9rences de l''utilisateur en cours)')
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4413)
,p_display_sequence=>20
,p_display_value=>unistr('D\00E9finir sur la valeur de l''\00E9l\00E9ment')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4413)
,p_display_sequence=>30
,p_display_value=>unistr('D\00E9finir sur la valeur de l''\00E9l\00E9ment si celui-ci est NOT NULL')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4413)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Nom de pr\00E9f\00E9rence')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>unistr('Entrez un nom de pr\00E9f\00E9rence.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4413)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('S\00E9lectionnez l''\00E9l\00E9ment de page ou d''application contenant la valeur de pr\00E9f\00E9rence. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>'Traitement de ligne automatique (DML)'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processus permettant d''ins\00E9rer, de mettre \00E0 jour ou de supprimer des enregistrements dans une table de base de donn\00E9es ou une vue modifiable unique. Ce processus est utilis\00E9 pour traiter les \00E9l\00E9ments de panneau avec une source de type <strong>Colonne')
||unistr(' de base de donn\00E9es</strong>. Les attributs saisis pour ce processus doivent \00EAtre mis en corr\00E9lation avec les attributs saisis pour le processus <em>Extraction de ligne automatique</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4413)
,p_help_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('El\00E9ment de cl\00E9 primaire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la valeur de colonne de cl\00E9 primaire. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('Colonne de cl\00E9 primaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4413)
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la valeur de cl\00E9 primaire. Pour les tables contenant des cl\00E9s primaires compos\00E9es de plus de deux \00E9l\00E9ments, choisissez <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('El\00E9ment de cl\00E9 secondaire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la valeur de colonne de cl\00E9 secondaire. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('Colonne de cl\00E9 secondaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4413)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la seconde valeur de cl\00E9 primaire. Cet attribut doit \00EAtre rempli uniquement si la cl\00E9 primaire est compos\00E9e de deux colonnes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Colonne de version de ligne'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la colonne identifiant la version de la ligne (cette colonne n''a pas besoin d''\00EAtre pr\00E9sente sur la page). Laissez cet attribut vide pour utiliser le checksum int\00E9gr\00E9.</p>'),
unistr('<p>Le verrouillage adapt\00E9 utilise la d\00E9tection des mises \00E0 jour perdues pour garantir l''int\00E9grit\00E9 des donn\00E9es dans les applications dans lesquelles les donn\00E9es sont accessibles simultan\00E9ment. &PRODUCT_NAME. peut utiliser un checksum int\00E9gr\00E9 pour ex\00E9c')
||unistr('uter la d\00E9tection des mises \00E0 jour perdues et d\00E9terminer la version de la ligne. Le checksum est une fonction de hachage de toutes les valeurs de colonne pour la ligne de table sp\00E9cifique. Il est extrait lorsque l''enregistrement est interrog\00E9 \00E0 parti')
||unistr('r de la base de donn\00E9es lors de l''<em>extraction de ligne automatique</em>, puis il est compar\00E9 au hachage de l''enregistrement en cours dans la base de donn\00E9es dans le cadre de ce processus. Si les deux valeurs sont identiques, la mise \00E0 jour continu')
||unistr('e, sinon une erreur est g\00E9n\00E9r\00E9e par ce processus.</p>'),
unistr('<p>Cet attribut vous permet d''indiquer une colonne unique contenant la version de la ligne, ce qui offre une alternative \00E0 l''utilisation du traitement de checksum int\00E9gr\00E9. Cette colonne doit \00EAtre mise \00E0 jour lorsqu''un enregistrement dans la base de d')
||unistr('onn\00E9es est mis \00E0 jour. Oracle recommande d''impl\00E9menter un d\00E9clencheur de base de donn\00E9es <em>Avant la mise \00E0 jour</en> sur la table pour incr\00E9menter ou mettre \00E0 jour la colonne de version de ligne. Les colonnes NUMBER sont cens\00E9es contenir un num\00E9ro ')
||unistr('de s\00E9quence de la ligne. Toutefois, les colonnes DATE et TIMESTAMP peuvent \00E9galement \00EAtre utilis\00E9es. Avec l''utilisation d''une colonne unique, le moteur &PRODUCT_NAME. n''a pas besoin d''effectuer le hachage de la ligne compl\00E8te, il peut simplement comp')
||unistr('arer une valeur de colonne unique \00E0 la place.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Clause WHERE d''ex\00E9cution')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limitez les services :</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Saisissez la clause SQL WHERE \00E0 ajouter \00E0 la fin de toutes les instructions INSERT, UPDATE et DELETE g\00E9n\00E9r\00E9es. Utilisez cet attribut pour limiter les enregistrements employ\00E9s dans des appels SQL g\00E9n\00E9r\00E9s automatiquement.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Renvoyer la cl\00E9 dans l''\00E9l\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez l''\00E9l\00E9ment de page ou d''application devant contenir la valeur de colonne de cl\00E9 primaire renvoy\00E9e \00E0 partir d''une instruction SQL INSERT. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.</p>'),
unistr('<p>Sp\00E9cifiez cette colonne pour r\00E9cup\00E9rer les champs de cl\00E9 primaire remplis par les s\00E9quences ou les d\00E9clencheurs de base de donn\00E9es. Cette valeur est d\00E9finie dans l''\00E9tat de session par le processus. </p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Renvoyer la seconde cl\00E9 dans l''\00E9l\00E9ment')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application devant contenir la seconde valeur de colonne de cl\00E9 primaire renvoy\00E9e \00E0 partir d''une instruction SQL INSERT. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Op\00E9rations prises en charge')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('V\00E9rifiez quelles op\00E9rations DML (langage de manipulation de donn\00E9es) sont prises en charge. Ce processus de manipulation de donn\00E9es ex\00E9cute une op\00E9ration DML lorsque la valeur de la demande est l''une des valeurs r\00E9pertori\00E9es. En cas d''utilisation d''u')
||unistr('n bouton pour soumettre cette page, la valeur de la demande est d\00E9finie par le bouton.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Ins\00E9rer')
,p_return_value=>'I'
,p_help_text=>unistr('D\00E9clench\00E9 par des valeurs de demande : INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Mettre \00E0 jour')
,p_return_value=>'U'
,p_help_text=>unistr('D\00E9clench\00E9 par des valeurs de demande : SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4413)
,p_display_sequence=>30
,p_display_value=>'Supprimer'
,p_return_value=>'D'
,p_help_text=>unistr('D\00E9clench\00E9 par des valeurs de demande : DELETE, REMOVE, DELETE ROW, DROP')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4413)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>'Verrouiller la ligne'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('<p>Choisissez de verrouiller ou non chaque ligne \00E0 mettre \00E0 jour ou \00E0 supprimer dans la table sous-jacente avant le traitement de la ligne.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>unistr('D\00E9finir le domaine d''attention')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('D\00E9finit le domaine d''attention sur les \00E9l\00E9ments affect\00E9s. Par d\00E9faut, il s''agit du premier \00E9l\00E9ment affect\00E9, s''il en existe plusieurs. Cette action peut s''av\00E9rer tr\00E8s utile lorsqu''elle est employ\00E9e avec les actions <em>Afficher</em> et <em>Activer</em')
||unistr('> pour diriger l''utilisateur directement vers l''\00E9l\00E9ment appropri\00E9.  Par d\00E9faut, il s''agit du premier \00E9l\00E9ment affect\00E9.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>'Soumettre une page'
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Soumet la page.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4413)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nom de demande/bouton'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Entrez la valeur de demande utilis\00E9e pour soumettre la page. Si un bouton d\00E9clenche l''action dynamique, d\00E9finissez cette valeur sur le nom du bouton. Cela garantit que l''attribut <em>Ex\00E9cuter les validations</em> du bouton est respect\00E9 au cours du tr')
||'aitement de la page.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4413)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Afficher le traitement'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la page en cours est gris\00E9e et si une animation de type traitement est affich\00E9e au cours de la soumission de la page. Cela permet d''emp\00EAcher les actions utilisateur lorsque de longues op\00E9rations sont en cours d''ex\00E9cution, telles qu''une no')
||unistr('uvelle tentative de clic, de la part de l''utilisateur final, sur le bouton de recherche d''un \00E9tat dont la r\00E9g\00E9n\00E9ration est lente.')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>'Champ nombre'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Affiche un champ num\00E9rique. Ce type d''\00E9l\00E9ment valide automatiquement le fait que la valeur est un nombre.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4413)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valeur minimum'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez la valeur minimale autoris\00E9e. Il peut s''agir d''une valeur statique ou dynamique utilisant la syntaxe de substitution.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4413)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur maximum'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez la valeur maximale autoris\00E9e. Il peut s''agir d''une valeur statique ou dynamique utilisant la syntaxe de substitution.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4413)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Alignement des nombres'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez l''alignement du nombre affich\00E9. Ce param\00E8tre n''est pas applicable si l''\00E9l\00E9ment est affich\00E9 en <em>lecture seule</em> ou lorsque les <strong>attributs d''\00E9l\00E9ment de panneau HTML</strong> sont indiqu\00E9s.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4413)
,p_display_sequence=>10
,p_display_value=>'A gauche'
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4413)
,p_display_sequence=>20
,p_display_value=>'Au centre'
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4413)
,p_display_sequence=>30
,p_display_value=>'A droite'
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>'Curseur'
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un type d''\00E9l\00E9ment de curseur, permettant aux utilisateurs de mettre \00E0 jour la valeur d''\00E9l\00E9ment en d\00E9pla\00E7ant le curseur vers la droite ou la gauche.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4413)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valeur minimum'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez la valeur minimale autoris\00E9e. Il peut s''agir d''une valeur statique ou dynamique utilisant la syntaxe de substitution.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4413)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valeur maximum'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez la valeur maximale autoris\00E9e. Il peut s''agir d''une valeur statique ou dynamique utilisant la syntaxe de substitution.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4413)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Incr\00E9ment d''\00E9tape')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez une valeur pour forcer le curseur \00E0 suivre une incr\00E9mentation donn\00E9e. Il peut s''agir d''une valeur statique ou dynamique utilisant la syntaxe de substitution.')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4413)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Mettre en \00E9vidence la s\00E9lection')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si le curseur met en \00E9vidence le suivi jusqu''\00E0 la position en cours de la barre du curseur.')
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>'Envoyer un courriel'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processus permettant d''envoyer un courriel, et \00E9ventuellement une pi\00E8ce jointe, \00E0 partir de l''application.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'De'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez l''adresse \00E9lectronique \00E0 afficher comme l''exp\00E9diteur du courriel. Il doit s''agir d''une adresse valide. Dans le cas contraire, le message ne sera pas envoy\00E9. Pour inclure une valeur dynamique, utilisez la syntaxe de substitution.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'A'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez les destinataires de courriel en indiquant leurs adresses \00E9lectroniques. Si vous voulez saisir plusieurs adresses \00E9lectroniques, s\00E9parez-les par des virgules. Pour inclure une valeur dynamique, utilisez la syntaxe de substitution.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez les destinataires de courriel en copie conforme en indiquant leurs adresses \00E9lectroniques. Si vous voulez saisir plusieurs adresses \00E9lectroniques, s\00E9parez-les par des virgules. Pour inclure une valeur dynamique, utilisez la syntaxe de substitu')
||'tion.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Cci'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Entrez les destinataires de courriel en copie conforme invisible en indiquant leurs adresses \00E9lectroniques. Si vous voulez saisir plusieurs adresses \00E9lectroniques, s\00E9parez-les par des virgules. Pour inclure une valeur dynamique, utilisez la syntaxe d')
||'e substitution.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('R\00E9pondre \00E0')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Indiquez l''adresse \00E9lectronique \00E0 laquelle les r\00E9ponses doivent \00EAtre envoy\00E9es. Si aucune valeur n''est sp\00E9cifi\00E9e, l''adresse \00E9lectronique indiqu\00E9e dans <strong>De</strong> est utilis\00E9e. Pour inclure une valeur dynamique, utilisez la syntaxe de substitu')
||'tion.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Objet'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4413)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Entrez l''objet du courriel. Pour inclure une valeur dynamique, utilisez la syntaxe de substitution (par exemple, <code>&amp;P6_PRODUCT_NAME.</code>).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>'Texte brut du corps'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le texte du courriel. La version en texte brut est utilis\00E9e lorsque le client de messagerie du destinataire ne prend pas en charge l''affichage de texte enrichi. Pour inclure du contenu dynamique dans votre texte, utilisez la syntaxe de subs')
||'titution (par exemple, <code>&amp;P6_PRODUCT_NAME.</code>).</p>',
unistr('<p><em>Remarque : la sp\00E9cification SMTP/MIME exige que les lignes ne d\00E9passent pas 1 000 caract\00E8res. Afin de respecter cette restriction, vous devez utiliser des retours chariot ou des retours \00E0 la ligne pour diviser votre texte en plusieurs blocs de')
||unistr(' moins de 1 000 caract\00E8res. Si vous ne respectez pas cette limitation, les courriels envoy\00E9s seront erron\00E9s (messages incomplets ou comprenant des points d''exclamation superflus, par exemple).</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>'HTML du corps'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4413)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez du texte qui entra\00EEne la g\00E9n\00E9ration d''un message HTML multipart incluant \00E0 la fois du texte brut et du contenu HTML. Les \00E9l\00E9ments affich\00E9s d\00E9pendent des param\00E8tres et des fonctions du client de messagerie du destinataire. Bien que la plupar')
||unistr('t des clients de messagerie modernes soient capables de lire les courriels au format HTML, certains utilisateurs d\00E9sactivent cette fonction pour des raisons de s\00E9curit\00E9. Pour inclure du contenu dynamique dans le texte, utilisez la syntaxe de substitu')
||'tion (par exemple, <code>&amp;P6_PRODUCT_NAME.</code>).</p>',
unistr('<p>Lorsque vous r\00E9f\00E9rencez des images \00E0 l''aide de la balise &lt;img /&gt;, celles-ci ne s''afficheront que si elles sont accessibles au client de messagerie du destinataire. Par exemple, supposons que vous r\00E9f\00E9renciez une image de votre r\00E9seau, nomm\00E9e')
||' hello.gif, comme suit :</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>Dans ce cas, l''image n''est pas jointe au courriel ; elle est r\00E9f\00E9renc\00E9e par celui-ci. Pour que le destinataire puisse la visualiser, il doit pouvoir y acc\00E9der \00E0 l''aide d''un navigateur Web. Si l''image se trouve dans un pare-feu et que le destinatai')
||unistr('re est en dehors de celui-ci, l''image n''appara\00EEtra pas. C''est la raison pour laquelle il est recommand\00E9 de ne pas utiliser d''image. Si vous devez en ins\00E9rer une, incluez l''attribut ALT afin de fournir une description de l''image dans le cas o\00F9 celle-c')
||'i serait inaccessible.</p>',
unistr('<p><em>Remarque : la sp\00E9cification SMTP/MIME exige que les lignes ne d\00E9passent pas 1 000 caract\00E8res. Afin de respecter cette restriction, vous devez utiliser des retours chariot ou des retours \00E0 la ligne pour diviser votre texte en plusieurs blocs de')
||unistr(' moins de 1 000 caract\00E8res. Si vous ne respectez pas cette limitation, les courriels envoy\00E9s seront erron\00E9s (messages incomplets ou comprenant des points d''exclamation superflus, par exemple).</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('Pi\00E8ce jointe SQL')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''instruction SQL doit \00EAtre au format suivant :</p>'),
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>Les colonnes mime_type et content_id sont facultatives. Si la colonne content_id est pr\00E9sente, le fichier sera attach\00E9 sous forme de pi\00E8ce jointe incorpor\00E9e et la valeur de content_id sera utilis\00E9e pour le CID de la pi\00E8ce jointe.</p>'),
unistr('<p>Si la colonne content_id contient la valeur "my_inline_content", l''image peut \00EAtre imbriqu\00E9e dans le courriel \00E0 l''aide du code HTML suivant :</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
unistr('&nbsp;&nbsp;&lt;h1&gt;Contenu imbriqu\00E9&lt;/h1&gt;'),
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez l''instruction SQL qui renvoie au moins un objet BLOB attach\00E9 en tant que fichier au courriel.</p>'),
unistr('<p>Si la colonne content_id contient une valeur NULL, les fichiers associ\00E9s sont des pi\00E8ces jointes standard. Les fichiers tels que des documents ou des archives au format ZIP sont g\00E9n\00E9ralement joints de cette fa\00E7on.</p>'),
unistr('<p>Si la valeur de la colonne content_id est une valeur non NULL, le fichier associ\00E9 est marqu\00E9 comme pi\00E8ce jointe incorpor\00E9e. La valeur de la colonne content_id est utilis\00E9e en tant que CID (ID de contenu) de la pi\00E8ce jointe. La valeur CID peut \00EAtre')
||unistr(' utilis\00E9e dans le code HTML du courriel afin d''imbriquer directement des images dans le contenu du courriel. Il se peut que certains clients de messagerie n''affichent pas automatiquement les pi\00E8ces jointes incorpor\00E9es. De plus, les normes de messager')
||unistr('ie imposent diverses exigences concernant le format des identificateurs de contenu. Oracle Application Express n''exige pas la conformit\00E9 \00E0 ces normes.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('Envoyer imm\00E9diatement')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si ce courriel est envoy\00E9 imm\00E9diatement. Tous les courriels figurant actuellement dans la table de file d''attente des courriels &PRODUCT_NAME. seront \00E9galement envoy\00E9s. Par d\00E9faut, &PRODUCT_NAME. stocke les courriels non envoy\00E9s dans une tab')
||unistr('le et les distribue de mani\00E8re p\00E9riodique afin d''am\00E9liorer les performances syst\00E8me.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>unistr('Mod\00E8le de courriel')
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Choisissez un mod\00E8le de courriel \00E0 utiliser.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>unistr('Valeurs de r\00E9serve')
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Noms d''espace r\00E9serv\00E9 de mod\00E8le avec les valeurs, \00E0 remplacer.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4413)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>'Remplacement de langue'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si un code de langue est indiqu\00E9, le processus recherche le mod\00E8le d''une traduction de l''application pour cette langue. Si aucune traduction n''existe, le processus utilise la langue principale de l''application. La syntaxe de substitution est prise')
||' en charge.</p>',
unistr('<p>La hi\00E9rarchie de code de langue est prise en charge. Si la valeur "fr-ca" (Fran\00E7ais - Canada) est indiqu\00E9 mais que seule la traduction "fr" (Fran\00E7ais) existe, cette traduction est utilis\00E9e.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>'Exploration de fichiers...'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un champ de texte avec un bouton <em>Parcourir...</em>. Ce bouton permet \00E0 l''utilisateur de rechercher et t\00E9l\00E9charger un fichier \00E0 partir d''un syst\00E8me de fichiers local.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Type de stockage'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la table de base de donn\00E9es dans laquelle le fichier t\00E9l\00E9charg\00E9 est stock\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Colonne BLOB indiqu\00E9e dans l''attribut Source d''\00E9l\00E9ment')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('Stocke le fichier t\00E9l\00E9charg\00E9 dans la table utilis\00E9e par le processus de <strong>traitement de ligne automatique (DML)</strong> et la colonne indiqu\00E9e dans l''attribut de source d''\00E9l\00E9ment. La colonne doit avoir BLOB comme type de donn\00E9es. Si le fichier')
||unistr(' est t\00E9l\00E9charg\00E9, le nom de table du processus d''<strong>extraction de ligne automatis\00E9e</strong> est utilis\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_display_sequence=>20
,p_display_value=>'Table APEX_APPLICATION_TEMP_FILES'
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Stocke les fichiers t\00E9l\00E9charg\00E9s dans un emplacement temporaire auquel vous pouvez acc\00E9der avec la vue APEX_APPLICATION_TEMP_FILES. &PRODUCT_NAME. supprimera automatiquement les fichiers \00E0 la fin de la session ou \00E0 la fin de la demande de t\00E9l\00E9charg')
||'ement, en fonction de votre choix pour <strong>Purge du fichier</strong>.</p>',
unistr('<p>Pour acc\00E9der aux fichiers si l''option <strong>Autoriser plusieurs fichiers</strong> est d\00E9finie sur <strong>Non</strong> :</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
unistr('<p>Pour acc\00E9der aux fichiers si l''option <strong>Autoriser plusieurs fichiers</strong> est d\00E9finie sur <strong>Oui</strong> :</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_display_sequence=>30
,p_display_value=>'Table WWV_FLOW_FILES'
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Stocke le fichier t\00E9l\00E9charg\00E9 dans la table &PRODUCT_NAME. <code>WWV_FLOW_FILES</code>.</p>'),
unistr('<p>Pour acc\00E9der au fichier, utilisez la syntaxe suivante :</p>'),
'<pre>',
'select *',
'  from wwv_flow_files',
unistr(' where name = :<<em>nom d''\00E9l\00E9ment de page</em>>;'),
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'Type de colonne MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Entrez le nom de l''\00E9l\00E9ment de page ou d''application, en majuscules, utilis\00E9 pour stocker le type MIME du fichier t\00E9l\00E9charg\00E9. Le type MIME est utilis\00E9 par le navigateur Web pour identifier l''application dans laquelle afficher le contenu de l''objet BLO')
||unistr('B lors du t\00E9l\00E9chargement du fichier.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>'Colonne de nom de fichier'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application utilis\00E9 pour stocker le nom du fichier t\00E9l\00E9charg\00E9.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>unistr('Colonne de jeu de caract\00E8res')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Entrez le nom de l''\00E9l\00E9ment de page ou d''application, en majuscules, utilis\00E9 pour stocker le jeu de caract\00E8res du fichier t\00E9l\00E9charg\00E9. Le jeu de caract\00E8res de l''objet BLOB n''est pas automatiquement d\00E9fini lors du t\00E9l\00E9chargement. Les utilisateurs finals')
||unistr(' doivent d\00E9finir le jeu de caract\00E8res du document qu''ils t\00E9l\00E9chargent.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>unistr('BLOB - Derni\00E8re colonne mise \00E0 jour')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Entrez le nom de l''\00E9l\00E9ment de page ou d''application, en majuscules, utilis\00E9 pour stocker l''horodatage en cours lorsqu''un fichier est t\00E9l\00E9charg\00E9. Cette valeur de date est utilis\00E9e pour la mise en m\00E9moire cache dans le navigateur Web.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>unistr('Afficher le lien de t\00E9l\00E9chargement')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Indiquez si le lien de t\00E9l\00E9chargement appara\00EEt lorsqu''un objet BLOB non vide est associ\00E9 \00E0 cet \00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>unistr('T\00E9l\00E9charger le texte de lien')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Entrez le texte \00E0 afficher dans le lien de t\00E9l\00E9chargement. Si cet \00E9l\00E9ment n''est pas sp\00E9cifi\00E9, le texte stock\00E9 dans le message texte pour <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code>, dans Composants partag\00E9s, sera affich\00E9.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>'Disposition du contenu'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la m\00E9thode utilis\00E9e par le navigateur Web pour g\00E9rer le contenu lors du t\00E9l\00E9chargement.</p>'),
unistr('<p><em>Remarque : l''affichage incorpor\00E9 n''est pas disponible pour tous les contenus. La prise en charge de l''affichage incorpor\00E9 d\00E9pend des types MIME pris en charge par le navigateur.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4413)
,p_display_sequence=>10
,p_display_value=>'Incorporation'
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Pi\00E8ce jointe')
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Purge du fichier'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('D\00E9finissez le moment o\00F9 &PRODUCT_NAME. doit enlever le fichier temporaire.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4413)
,p_display_sequence=>10
,p_display_value=>'Fin de session'
,p_return_value=>'SESSION'
,p_help_text=>unistr('Supprimez le fichier \00E0 la fin de la session &PRODUCT_NAME. en cours.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4413)
,p_display_sequence=>20
,p_display_value=>'Fin de demande'
,p_return_value=>'REQUEST'
,p_help_text=>unistr('Supprimez le fichier \00E0 la fin de la demande HTTP en cours.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Autoriser plusieurs fichiers'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si plusieurs fichiers peuvent \00EAtre t\00E9l\00E9charg\00E9s en m\00EAme temps.</p>'),
'',
unistr('<p>Remarque : plusieurs noms de fichier seront stock\00E9s en tant que liste s\00E9par\00E9e par le signe deux-points dans l''\00E9l\00E9ment de page.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'Types de fichier'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dt>Indique que seuls les fichiers image doivent \00EAtre accept\00E9s</dt>'),
'<dd><pre>image/*</pre></dd>',
unistr('<dt>Indique que seuls les fichiers vid\00E9o et image doivent \00EAtre accept\00E9s</dt>'),
'<dd><pre>image/*,video/*</pre></dd>',
unistr('<dt>Indique que seuls les fichiers image PNG doivent \00EAtre accept\00E9s</dt>'),
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('Indiquez une liste de types de fichier s\00E9par\00E9s par une virgule, qui pourra \00EAtre utilis\00E9e par le navigateur afin de restreindre les fichiers pouvant \00EAtre t\00E9l\00E9charg\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>'Afficher en tant que'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez un style d''affichage pour l''\00E9l\00E9ment d''exploration de fichiers.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Exploration de fichiers incorpor\00E9e')
,p_return_value=>'INLINE'
,p_help_text=>unistr('Affichez le champ de saisie d''exploration de fichiers sous une forme semblable \00E0 celles des autres champs de texte et \00E9l\00E9ments de la page.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Zone de d\00E9placement incorpor\00E9e')
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('Affichez le champ de saisie d''exploration de fichiers sous la forme d''une zone de d\00E9placement incorpor\00E9e avec un titre et une description.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Zone de d\00E9placement en bloc')
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('Affichez le champ de saisie d''exploration de fichiers sous la forme d''une zone de d\00E9placement de type assistant avec un titre, une description et un bouton permettant de s\00E9lectionner des fichiers.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4413)
,p_display_sequence=>40
,p_display_value=>'Exploration de fichiers native'
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Utilisez le formatage natif du navigateur pour afficher l''\00E9l\00E9ment d''exploration de fichiers.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>unistr('Titre de la zone de d\00E9placement')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le titre de la zone de d\00E9placement.'),
unistr('Si ce champ est laiss\00E9 vide, le message texte <code>APEX.ITEM.FILE.DROP_FILE</code> ou <code>APEX.ITEM.FILE.DROP_FILES</code> est utilis\00E9 par d\00E9faut.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>unistr('Description de la zone de d\00E9placement')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la description de la zone de d\00E9placement.</p>'),
unistr('<p>Si ce champ est laiss\00E9 vide, les messages texte suivants sont utilis\00E9s par d\00E9faut, en fonction de la propri\00E9t\00E9 Afficher en tant que.</p>'),
unistr('<p><strong>Zone de d\00E9placement en bloc</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
unistr('<p><strong>Zone de d\00E9placement incorpor\00E9e</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4413)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Taille maximale de fichier'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'ko'
,p_is_translatable=>false
,p_help_text=>unistr('Entrez la taille de fichier maximale (ko) accept\00E9e pour les fichiers t\00E9l\00E9charg\00E9s via cet \00E9l\00E9ment.')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>'Gestionnaire de liste'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche un \00E9l\00E9ment de texte avec une ic\00F4ne de liste de valeurs (LOV) instantan\00E9e, les boutons <em>Ajouter</em> et <em>Enlever</em>, et la liste des valeurs s\00E9lectionn\00E9es.</p>'),
unistr('<p>Vous pouvez saisir la valeur ou la s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles. Vous pouvez ensuite utiliser les boutons pour g\00E9rer les valeurs s\00E9lectionn\00E9es. Ces derni\00E8res sont stock\00E9es dans une cha\00EEne unique dont les \00E9l\00E9ments sont d\00E9limi')
||unistr('t\00E9s par deux-points.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4413)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Extraire'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez le mode d''affichage des donn\00E9es lorsque la liste de valeurs (LOV) instantan\00E9e est ouverte.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4413)
,p_display_sequence=>10
,p_display_value=>'Aucune extraction'
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4413)
,p_display_sequence=>20
,p_display_value=>'Extraire le premier rowset'
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4413)
,p_display_sequence=>30
,p_display_value=>'Extraire le premier rowset et filtrer la valeur en cours'
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4413)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Respecter maj/min'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la valeur est conserv\00E9e telle qu''elle a \00E9t\00E9 saisie ou si elle est convertie en majuscules.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4413)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4413)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Liste de valeurs bas\00E9e sur une requ\00EAte SQL</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Liste de valeurs avec les m\00EAmes valeurs d''affichage et renvoy\00E9es</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Remarque : lorsque vous s\00E9lectionnez la m\00EAme colonne pour les valeurs d''affichage et renvoy\00E9es, utilisez un alias de colonne.</p>'),
'</dd>',
unistr('<dt>Liste de valeurs avec variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4413)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('Traitement de ligne automatique h\00E9rit\00E9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processus permettant d''ins\00E9rer, de mettre \00E0 jour ou de supprimer des enregistrements dans une table de base de donn\00E9es ou une vue modifiable unique. Ce processus est utilis\00E9 pour traiter les \00E9l\00E9ments de panneau avec une source de type <strong>Colonne')
||unistr(' de base de donn\00E9es</strong>. Oracle recommande de mettre \00E0 jour ce type de processus vers <strong>Traitement de ligne automatique (DML)</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4413)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez les op\00E9rations DML (langage de manipulation des donn\00E9es) prises en charge.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Ins\00E9rer')
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Mettre \00E0 jour')
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4413)
,p_display_sequence=>30
,p_display_value=>'Supprimer'
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4413)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Propri\00E9taire de table')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('S\00E9lectionnez le nom (sch\00E9ma) de propri\00E9taire de table.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4413)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nom de table'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4413)
,p_help_text=>unistr('Entrez le nom de table ou de vue, avec respect des majuscules/minuscules. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4413)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('El\00E9ment de cl\00E9 primaire')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Entrez l''\00E9l\00E9ment de page ou d''application contenant la valeur de colonne de cl\00E9 primaire. Vous pouvez saisir un nom ou le s\00E9lectionner dans la liste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4413)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('Colonne de cl\00E9 primaire')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4413)
,p_help_text=>unistr('S\00E9lectionnez la colonne contenant la valeur de cl\00E9 primaire. Si la table contient une cl\00E9 primaire multipart, choisissez <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4413)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Clause WHERE d''ex\00E9cution')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limitez le service :</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Saisissez la clause SQL WHERE \00E0 ajouter \00E0 la fin de toutes les instructions SELECT, UPDATE et DELETE g\00E9n\00E9r\00E9es. Utilisez cet attribut pour limiter les enregistrements employ\00E9s dans des appels SQL g\00E9n\00E9r\00E9s automatiquement.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>unistr('Ev\00E9nement d''annulation')
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Annule l''\00E9v\00E9nement en cours.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>unistr('S\00E9lecteur de date (jQuery)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche un champ de texte avec une ic\00F4ne de calendrier. Les utilisateurs finals peuvent entrer la date directement dans l''\00E9l\00E9ment de texte ou cliquer sur l''ic\00F4ne de calendrier pour s\00E9lectionner une date, et \00E9ventuellement une heure, dans le calend')
||unistr('rier instantan\00E9.</p>'),
unistr('<p>L''heure est affich\00E9e dans le calendrier instantan\00E9 uniquement si le <em>masque de format</em> de cet \00E9l\00E9ment inclut des composants d''heure.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Date mise en \00E9vidence')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la valeur de date par d\00E9faut \00E0 mettre en \00E9vidence lorsque le calendrier instantan\00E9 est appel\00E9. Si cette valeur n''est pas sp\00E9cifi\00E9e, le calendrier met en \00E9vidence la date et l''heure en cours.</p>'),
unistr('<p>La valeur de date peut \00EAtre une valeur absolue au format <code>''YYYYMMDDHH24MI''</code>, une valeur relative par rapport \00E0 la date du jour, comme <code>+7d</code>, ou une valeur dynamique utilisant la syntaxe de substitution, \00E0 condition que la sub')
||'stitution renvoie la valeur relative ou le format de date correct.</p>',
'<p>Les valeurs relatives de date sont les suivantes :</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - ann\00E9es \00E0 compter d''aujourd''hui</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - mois \00E0 compter d''aujourd''hui</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - semaines \00E0 compter d''aujourd''hui</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - jours \00E0 compter d''aujourd''hui</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Date minimale'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la date minimale pouvant \00EAtre saisie ou s\00E9lectionn\00E9e.</p>'),
unistr('<p>La valeur de date peut \00EAtre une valeur absolue au format <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, une valeur relative par rapport \00E0 la date du jour, comme <code>+7d</code>, ou une valeur dynamique utilisant la syntaxe')
||unistr(' de substitution, \00E0 condition que la substitution renvoie la valeur relative ou le format de date correct.</p>'),
'<p>Les valeurs relatives de date sont les suivantes :</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - ann\00E9es \00E0 compter d''aujourd''hui</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - mois \00E0 compter d''aujourd''hui</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - semaines \00E0 compter d''aujourd''hui</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - jours \00E0 compter d''aujourd''hui</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Date maximale'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la date maximale pouvant \00EAtre saisie ou s\00E9lectionn\00E9e.</p>'),
unistr('<p>La valeur de date peut \00EAtre une valeur absolue au format <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, une valeur relative par rapport \00E0 la date du jour, comme <code>+7d</code>, ou une valeur dynamique utilisant la syntaxe')
||unistr(' de substitution, \00E0 condition que la substitution renvoie la valeur relative ou le format de date correct.</p>'),
'<p>Les valeurs relatives de date sont les suivantes :</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - ann\00E9es \00E0 compter d''aujourd''hui</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - mois \00E0 compter d''aujourd''hui</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - semaines \00E0 compter d''aujourd''hui</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - jours \00E0 compter d''aujourd''hui</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Afficher'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez les situations dans lesquelles le calendrier instantan\00E9 du s\00E9lecteur de date doit \00EAtre affich\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Lors de la mise en \00E9vidence')
,p_return_value=>'focus'
,p_help_text=>unistr('Le calendrier instantan\00E9 appara\00EEt d\00E8s que l''\00E9l\00E9ment est s\00E9lectionn\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Lors de la s\00E9lection d''une ic\00F4ne')
,p_return_value=>'button'
,p_help_text=>unistr('Le calendrier instantan\00E9 appara\00EEt d\00E8s que vous cliquez sur l''ic\00F4ne.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4413)
,p_display_sequence=>30
,p_display_value=>'Les deux'
,p_return_value=>'both'
,p_help_text=>unistr('Le calendrier instantan\00E9 appara\00EEt d\00E8s que l''\00E9l\00E9ment est s\00E9lectionn\00E9, puis d\00E8s que vous cliquez sur l''ic\00F4ne.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4413)
,p_display_sequence=>40
,p_display_value=>'Incorporation'
,p_return_value=>'inline'
,p_help_text=>unistr('L''affichage du calendrier est toujours incorpor\00E9 \00E0 la page. Aucun champ de texte n''appara\00EEt et la s\00E9lection de date en cours est mise en \00E9vidence dans le calendrier.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Afficher les autres mois'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si les dates au d\00E9but du mois pr\00E9c\00E9dent et les dates \00E0 la fin du mois suivant sont affich\00E9es. Les dates de d\00E9but et de fin apparaissent sur la totalit\00E9 des premi\00E8re et derni\00E8re lignes du calendrier. Par exemple, si le premier jour de la sema')
||unistr('ine est un dimanche et que le premier jour du mois en cours tombe un mercredi, dimanche, lundi et mardi sont affich\00E9es comme les trois derniers jours du mois pr\00E9c\00E9dent.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Nombre de mois'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
unistr('    <dd>Affiche trois mois \00E0 l''horizontale.</dd>'),
'  <dt>[2,3]</dt>',
'    <dd>Affiche six mois, sur deux lignes et trois colonnes.</dd>',
'  <dt>[4,3]</dt>',
'    <dd>Afficher douze mois, sur quatre lignes et trois colonnes.</dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nombre de mois \00E0 afficher dans le calendrier instantan\00E9.</p>'),
unistr('<p>Vous pouvez saisir une valeur enti\00E8re ou un tableau \00E0 deux dimensions au format <code>[<em>row,column</em>]</code> pour d\00E9finir le nombre de lignes et de colonnes \00E0 afficher.</p>'),
unistr('<p><em>Remarque : les mois apr\00E8s la <strong>date mise en \00E9vidence</strong> sont affich\00E9s.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Liste de navigation pour'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si des listes de s\00E9lection sont fournies dans le calendrier instantan\00E9 pour les mois et/ou les ann\00E9es.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4413)
,p_display_sequence=>5
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4413)
,p_display_sequence=>10
,p_display_value=>'Mois'
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Ann\00E9e')
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Mois et ann\00E9e')
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4413)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Plage d''ann\00E9es')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
unistr('    <dd>Utilise les ann\00E9es absolues pour que les ann\00E9es permises soient comprises entre 2000 et 2010, inclus.</dd>'),
'  <dt>-05:+05</dt>',
unistr('    <dd>Utilise les dates relatives pour limiter les ann\00E9es permises \00E0 +/- cinq ans par rapport \00E0 l''ann\00E9e en cours.</dd>'),
'  <dt>+01:+03</dt>',
unistr('    <dd>Utilise les dates relatives pour limiter les ann\00E9es permises \00E0 l''ann\00E9e suivante pendant encore deux ans.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez la plage des ann\00E9es autoris\00E9es \00E0 afficher dans la liste de s\00E9lection <strong>Ann\00E9e</strong> du calendrier instantan\00E9.</p>'),
unistr('<p>La valeur d''ann\00E9e peut \00EAtre une valeur absolue au format <code>''YYYY:YYYY''</code> ou 	des valeurs relatives au format <code>''-nn:+nn''</code>, o\00F9 <code>nn</code> repr\00E9sente des valeurs enti\00E8res.')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>'Champ de texte'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Affiche un champ de texte.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4413)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('Soumettre lorsque la touche Entr\00E9e est activ\00E9e')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la page est soumise automatiquement lorsque l''utilisateur appuie sur la touche <em>Entr\00E9e</em> dans ce champ.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4413)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('D\00E9sactiv\00E9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si cet \00E9l\00E9ment est d\00E9sactiv\00E9, ce qui emp\00EAche les utilisateurs finals de modifier la valeur.</p>'),
unistr('<p>Un \00E9l\00E9ment de texte d\00E9sactiv\00E9 est toujours affich\00E9 avec le m\00EAme formatage HTML, contrairement \00E0 un \00E9l\00E9ment de type <em>Afficher uniquement</em>, qui enl\00E8ve le formatage HTML. Les \00E9l\00E9ments de texte d\00E9sactiv\00E9s font partie de la source de page, ce qu')
||unistr('i permet l''\00E9valuation de leur \00E9tat de session. R\00E9ciproquement, les \00E9l\00E9ments de type Afficher uniquement ne sont pas stock\00E9s dans l''\00E9tat de session.</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4413)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Envoyer lors de la soumission de la page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Indiquez si la valeur d''\00E9l\00E9ment en cours doit \00EAtre envoy\00E9e lorsque la page est soumise.')
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4413)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>'Sous-type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez le sous-type de texte HTML5. Cette fonctionnalit\00E9 permet aux appareils \00E9quip\00E9s de claviers \00E0 l''\00E9cran d''afficher une mise en page optimis\00E9e du clavier propre au sous-type pour une saisie facilit\00E9e des donn\00E9es. La s\00E9lection du sous-type pe')
||unistr('rmet \00E9galement d''afficher un lien appropri\00E9 correspondant \00E0 la valeur de l''\00E9l\00E9ment de page lorsque le rendu s''effectue en lecture seule. Lorsque vous utilisez un clavier physique, cet attribut ne modifie pas l''\00E9l\00E9ment de texte ni la saisie des donn\00E9e')
||'s.  ',
'</p>',
unistr('<p><strong><em>Remarque :</strong> cette fonctionnalit\00E9 HTML5 ne fonctionne que dans les navigateurs modernes. Les anciens navigateurs, incompatibles avec HTML5, ignorent cet attribut et affichent l''\00E9l\00E9ment de page comme un champ de texte normal.</em')
||'></p>'))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4413)
,p_display_sequence=>5
,p_display_value=>'Texte'
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4413)
,p_display_sequence=>10
,p_display_value=>'Courriel'
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Num\00E9ro de t\00E9l\00E9phone')
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4413)
,p_display_sequence=>25
,p_display_value=>'Rechercher'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4413)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4413)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>'Supprimer les espaces'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la m\00E9thode \00E0 utiliser pour tronquer la valeur de l''\00E9l\00E9ment apr\00E8s la soumission de la page. Ce param\00E8tre supprime les espaces, les tabulations et les sauts de ligne dans le texte saisi.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4413)
,p_display_sequence=>10
,p_display_value=>unistr('D\00E9but')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4413)
,p_display_sequence=>20
,p_display_value=>'Fin'
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4413)
,p_display_sequence=>30
,p_display_value=>unistr('D\00E9but et fin')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4413)
,p_display_sequence=>40
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4413)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>'Casse du texte'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Aucune modification'
,p_help_text=>unistr('S\00E9lectionnez le mode de transformation de la casse du texte de la valeur de l''\00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4413)
,p_display_sequence=>10
,p_display_value=>'Minuscules'
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4413)
,p_display_sequence=>20
,p_display_value=>'Majuscules'
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>unistr('Masqu\00E9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('El\00E9ments qui sont inclus dans la source de page, mais qui ne sont pas affich\00E9s. Les valeurs des \00E9l\00E9ments masqu\00E9s sont enregistr\00E9es dans l''\00E9tat de session. Ces \00E9l\00E9ments sont g\00E9n\00E9ralement utilis\00E9s pour stocker les valeurs requises par le traitement de ')
||unistr('la page ou d''autres \00E9l\00E9ments de page, mais ils ne doivent pas \00EAtre visibles par l''utilisateur final.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4413)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Valeur prot\00E9g\00E9e')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si l''\00E9l\00E9ment est prot\00E9g\00E9, ce qui emp\00EAche la valeur d''\00EAtre manipul\00E9e lorsque la page est envoy\00E9e.')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>'Afficher l''image'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche une image stock\00E9e dans les colonnes BLOB d''une base de donn\00E9es ou bas\00E9e sur une URL d''image.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Bas\00E9 sur')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez l''emplacement \00E0 partir duquel extraire l''image.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_display_sequence=>10
,p_display_value=>unistr('URL d''image stock\00E9e dans Valeur d''\00E9l\00E9ment de page')
,p_return_value=>'URL'
,p_help_text=>unistr('L''URL de l''image est lue \00E0 partir de la valeur stock\00E9e dans l''\00E9tat de session pour l''\00E9l\00E9ment de page indiqu\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Colonne BLOB indiqu\00E9e dans l''attribut Source d''\00E9l\00E9ment')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('Lit l''image \00E0 partir de la colonne BLOB indiqu\00E9e dans l''attribut <strong>Source d''\00E9l\00E9ment</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Colonne BLOB renvoy\00E9e par l''instruction SQL')
,p_return_value=>'SQL'
,p_help_text=>unistr('Affiche l''image en fonction de la colonne BLOB renvoy\00E9e par l''instruction SQL indiqu\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4413)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Autre texte'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>unistr('Entrez le texte lu par les lecteurs d''\00E9cran lorsqu''un utilisateur final acc\00E8de \00E0 cet \00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4413)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Autre colonne de texte'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Entrez le nom de page ou d''application, en majuscules, contenant le texte alternatif de cette image. Ce texte est lu par les lecteurs d''\00E9cran lorsqu''un utilisateur final acc\00E8de \00E0 cet \00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4413)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Colonne de nom de fichier'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Entrez le nom de l''\00E9l\00E9ment de page ou d''application, en majuscules, qui contient la valeur de colonne de nom de fichier associ\00E9e \00E0 la colonne BLOB.')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4413)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('BLOB - Derni\00E8re colonne mise \00E0 jour')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nom de l''\00E9l\00E9ment de page ou d''application, en majuscules, qui contient la valeur de colonne de date correspondant \00E0 la derni\00E8re mise \00E0 jour de l''objet BLOB associ\00E9.</p>'),
unistr('<p>Cette valeur est utilis\00E9e pour la mise en m\00E9moire cache dans le navigateur Web. Elle indique si l''image a \00E9t\00E9 modifi\00E9e depuis la derni\00E8re demande du navigateur Web. Si l''image n''est pas mise \00E0 jour, elle est extraite du cache du navigateur Web, le')
||unistr(' cas \00E9ch\00E9ant.</p>')))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4413)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Instruction SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>'Entrez l''instruction SQL qui renvoie la colonne BLOB contenant l''image.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4413)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>'Type de colonne MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Entrez le nom de l''\00E9l\00E9ment de page ou d''application, en majuscules, utilis\00E9 pour stocker le type MIME du fichier t\00E9l\00E9charg\00E9. Le type MIME est utilis\00E9 par le navigateur Web pour identifier l''application dans laquelle afficher le contenu de l''objet BLO')
||unistr('B lors du t\00E9l\00E9chargement du fichier.')
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('Champ de texte avec \00E9criture automatique')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un champ de texte contenant la liste des valeurs possibles, en fonction du texte d\00E9j\00E0 saisi par l''utilisateur final, incorpor\00E9 \00E0 l''\00E9l\00E9ment de texte. La liste est affin\00E9e au fur et \00E0 mesure que l''utilisateur final saisit du texte.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4413)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Rechercher'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez la m\00E9thode utilis\00E9e pour rechercher la valeur saisie. Lorsque vous utilisez l''option <em>Chargement lazy</em>, ce param\00E8tre peut avoir une incidence sur les performances de requ\00EAte.</p>'),
unistr('<p><em>Remarque : si vous s\00E9lectionnez <strong>Contient et Distinction maj/min</strong> ou <strong>Contient et Ignorer la casse</strong>, les index de colonne ne peuvent pas \00EAtre utilis\00E9s.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4413)
,p_display_sequence=>10
,p_display_value=>'Contient et Distinction maj/min'
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4413)
,p_display_sequence=>20
,p_display_value=>'Exact et Distinction maj/min'
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4413)
,p_display_sequence=>30
,p_display_value=>'Contient et Ignorer la casse'
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4413)
,p_display_sequence=>40
,p_display_value=>'Exact et Ignorer la casse'
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4413)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Chargement lazy'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les valeurs correspondantes sont extraites de la base de donn\00E9e \00E0 l''aide l''option <em>Chargement lazy</em>. Le chargement lazy extrait les enregistrements correspondants \00E0 partir de la base de donn\00E9es \00E0 chaque fois qu''un caract\00E8re est ')
||unistr('saisi par l''utilisateur. Sinon, toutes les valeurs de liste sont affich\00E9es lors du chargement de la page.</p>'),
unistr('<p>Oracle recommande d''utiliser l''option <em>Chargement lazy</em> pour les longues listes de s\00E9lection, car le chargement d''un grand nombre d''enregistrements peut avoir une incidence sur la dur\00E9e de chargement initial de la page.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4413)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Valeurs maximales de la liste'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le nombre maximal d''\00E9l\00E9ments \00E0 afficher dans la zone de s\00E9lection.</p> '),
unistr('<p>Cette valeur permet d''\00E9viter les probl\00E8mes de performances li\00E9s au renvoi d''un trop grand nombre de lignes. Elle \00E9vite \00E9galement le renvoi d''un ensemble d''\00E9l\00E9ments trop volumineux si uniquement quelques lettres ont \00E9t\00E9 saisies.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4413)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Recherche minimale'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>unistr('caract\00E8res')
,p_is_translatable=>false
,p_help_text=>unistr('<p>Indiquez le nombre minimal de caract\00E8res devant \00EAtre saisis avant l''ex\00E9cution d''une recherche.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4413)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>'Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Indiquez si les r\00E9sultats de recherche sont mis en cache lors de l''extraction des enregistrements concordants via le chargement lazy.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4413)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher et stocker la m\00EAme valeur dans un \00E9l\00E9ment de page</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
unistr('<dt>Afficher les employ\00E9s d''un service donn\00E9 \00E0 l''aide d''une variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4413)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4413)
,p_name=>'ojupdate'
,p_display_name=>unistr('Mettre \00E0 jour')
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>'Editeur de texte enrichi'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche une zone de texte avec toutes les options de formatage de texte. Les utilisateurs finals peuvent optimiser le contenu affich\00E9 de la m\00EAme fa\00E7on que dans un programme de traitement de texte, tel que Microsoft Word. Les utilisateurs finals peuve')
||unistr('nt \00E9galement <em>couper et coller</em> des documents au format de fichier RTF (Rich Text Format) dans cet \00E9l\00E9ment.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('R\00E9actif [en phase d''abandon]')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si l''\00E9diteur de texte enrichi doit automatiquement s''ajuster \00E0 la taille de la r\00E9gion de conteneur. Pour cela, l''application doit utiliser le th\00E8me universel ou un autre th\00E8me r\00E9actif.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Barre d''outils'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez le nombre d''options de formatage de texte disponibles dans l''\00E9diteur.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4413)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Interm\00E9diaire')
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4413)
,p_display_sequence=>30
,p_display_value=>'Complet'
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Barre d''outils d\00E9velopp\00E9e')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('Indiquez si l''\00E9diteur est initialement d\00E9velopp\00E9 dans la zone de texte.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Apparence'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez l''apparence utilis\00E9e pour d\00E9finir le style de l''\00E9diteur.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4413)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4413)
,p_display_sequence=>2
,p_display_value=>'Couleur moono'
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4413)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Position de la barre d''outils'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Sp\00E9cifiez l''emplacement auquel est affich\00E9 l''\00E9diteur dans la zone de texte.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4413)
,p_display_sequence=>10
,p_display_value=>'Haut'
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4413)
,p_display_sequence=>20
,p_display_value=>'Bas'
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>'Version'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'CK Editor 5'
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4 est en phase d''abandon et sera prochainement remplac\00E9 par CKEditor 5. Nous vous recommandons d''effectuer la transition maintenant pour \00E9viter que votre application ne cesse de fonctionner dans les versions futures. L''API de CKEditor a \00E9')
||unistr('t\00E9 modifi\00E9e. Si vous avez utilis\00E9 un code JavaScript d''initialisation personnalis\00E9, vous devrez donc sans doute l''ajuster.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4413)
,p_display_sequence=>10
,p_display_value=>'CK Editor 4 [en phase d''abandon]'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Hauteur minimale'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>unistr('D\00E9finissez la hauteur minimale en pixels de la zone modifiable.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Hauteur maximale'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>unistr('D\00E9finissez la hauteur maximale en pixels de la zone modifiable. Si vous laissez cet attribut vide, l''\00E9diteur s''agrandira sans limite \00E0 mesure que vous saisissez du texte.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>'Format'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez le format de sortie du contenu saisi dans l''\00E9diteur de texte enrichi.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4413)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('Utilisez le format HTML pour la source et la sortie de cet \00E9diteur de texte enrichi.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4413)
,p_display_sequence=>20
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>unistr('Utilisez le format Markdown pour la source et la sortie de cet \00E9diteur de texte enrichi.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4413)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4413)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
unistr('    // d\00E9sactiver la fonctionnalit\00E9 de formatage automatique'),
'    options.editorOptions.removePlugins.push(''Autoformat'');',
unistr('    // appliquer une barre d''outils personnalis\00E9e'),
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('Entrez une fonction JavaScript pour remplacer la configuration de l''\00E9diteur standard. Les options sp\00E9cifiques CKEditor5 doivent \00EAtre appliqu\00E9es \00E0 <code>options.editorOptions</code>. Reportez-vous \00E0 la documentation sur l''API CKEditor5 pour plus d''inf')
||'ormations.'
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>unistr('S\00E9lecteur de couleur')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Permet aux utilisateurs de choisir ou de saisir une couleur. Les couleurs peuvent \00EAtre s\00E9lectionn\00E9es \00E0 partir d''un spectre de couleurs.')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la quantit\00E9 d''informations affich\00E9es dans le s\00E9lecteur de couleur.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4413)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('Affiche uniquement les commandes du spectre de couleurs et les valeurs de couleur pr\00E9d\00E9finies, le cas \00E9ch\00E9ant.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4413)
,p_display_sequence=>20
,p_display_value=>'Complet'
,p_return_value=>'FULL'
,p_help_text=>unistr('Affiche des champs suppl\00E9mentaires pour visualiser ou saisir des couleurs, par exemple des valeurs hexad\00E9cimales, HSL ou RGB avec une valeur alpha facultative en fonction de l''option Renvoyer une valeur en tant que. Affiche \00E9galement les couleurs ini')
||'tiales et en cours.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Afficher en tant que'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez le mode d''affichage du s\00E9lecteur de couleur.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Fen\00EAtre instantan\00E9e')
,p_return_value=>'POPUP'
,p_help_text=>unistr('Une couleur peut \00EAtre saisie dans le champ de texte ou choisie dans le s\00E9lecteur de couleur instantan\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4413)
,p_display_sequence=>20
,p_display_value=>'Incorporation'
,p_return_value=>'INLINE'
,p_help_text=>unistr('Un s\00E9lecteur de couleur est incorpor\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Fen\00EAtre instantan\00E9e de couleur uniquement')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('Un bouton ouvre le s\00E9lecteur de couleur instantan\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4413)
,p_display_sequence=>40
,p_display_value=>unistr('S\00E9lecteur de couleur natif')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Une saisie de couleur dans un navigateur natif. L''interface utilisateur d\00E9pend du navigateur.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Utiliser les valeurs par d\00E9faut')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indique s''il faut utiliser les valeurs par d\00E9faut d\00E9finies pour ce composant, dans Composants partag\00E9s > Param\00E8tres de composant, ou des param\00E8tres personnalis\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la quantit\00E9 d''informations affich\00E9es dans le s\00E9lecteur de couleur.</p>'),
unistr('<p>Non applicable lorsque l''option Afficher en tant que est d\00E9finie sur S\00E9lecteur de couleur natif.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4413)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('Affiche uniquement les commandes du spectre de couleurs et les valeurs de couleur pr\00E9d\00E9finies, le cas \00E9ch\00E9ant.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4413)
,p_display_sequence=>20
,p_display_value=>'Complet'
,p_return_value=>'FULL'
,p_help_text=>unistr('Affiche des champs suppl\00E9mentaires pour visualiser ou saisir des couleurs, par exemple des valeurs hexad\00E9cimales, HSL ou RGB avec une valeur alpha facultative en fonction de l''option Renvoyer une valeur en tant que. Affiche \00E9galement les couleurs ini')
||'tiales et en cours.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Afficher en tant que'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez le mode d''affichage du s\00E9lecteur de couleur.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Fen\00EAtre instantan\00E9e')
,p_return_value=>'POPUP'
,p_help_text=>unistr('Une couleur peut \00EAtre saisie dans le champ de texte ou choisie dans le s\00E9lecteur de couleur instantan\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4413)
,p_display_sequence=>20
,p_display_value=>'Incorporation'
,p_return_value=>'INLINE'
,p_help_text=>unistr('Un s\00E9lecteur de couleur est incorpor\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Fen\00EAtre instantan\00E9e de couleur uniquement')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('Un bouton ouvre le s\00E9lecteur de couleur instantan\00E9.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4413)
,p_display_sequence=>40
,p_display_value=>unistr('S\00E9lecteur de couleur natif')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Une saisie de couleur dans un navigateur natif. L''interface utilisateur d\00E9pend du navigateur.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Couleur pr\00E9d\00E9finie')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez si le s\00E9lecteur de couleur doit afficher un ensemble de couleurs pr\00E9d\00E9finies. Si c''est le cas, indiquez si ces couleurs proviennent du th\00E8me ou si elles sont personnalis\00E9es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4413)
,p_display_sequence=>10
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Couleurs du style de th\00E8me')
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Couleurs personnalis\00E9es')
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Couleurs'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Liste des couleurs pr\00E9d\00E9finies \00E0 afficher dans la bo\00EEte de dialogue du s\00E9lecteur de couleur.'),
unistr('S\00E9parez les couleurs par un point-virgule.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Contraster avec'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permet de comparer la couleur de cet \00E9l\00E9ment avec la couleur d''un autre \00E9l\00E9ment ou d''une valeur statique, et d''afficher le rapport de contraste entre les deux dans l''interface utilisateur du s\00E9lecteur de couleur.  '),
unistr('Cela permet \00E0 l''utilisateur de choisir des couleurs suffisamment contrast\00E9es pour \00EAtre visibles par tous.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4413)
,p_display_sequence=>10
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4413)
,p_display_sequence=>20
,p_display_value=>unistr('El\00E9ment de page')
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4413)
,p_display_sequence=>30
,p_display_value=>'Couleur statique'
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('El\00E9ment de contraste')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('El\00E9ment \00E0 utiliser pour la comparaison du contraste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Couleur de contraste'
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('Couleur \00E0 utiliser pour la comparaison du contraste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4413)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Renvoyer une valeur en tant que'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez le format de la valeur de couleur renvoy\00E9e par cet \00E9l\00E9ment. La couleur sera pr\00E9sent\00E9e, renvoy\00E9e et envoy\00E9e au serveur dans ce format m\00EAme si elle est saisie dans un autre format valide.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Hexad\00E9cimal')
,p_return_value=>'HEX'
,p_help_text=>unistr('Valeur de couleur hexad\00E9cimale. Aucune valeur alpha n''est autoris\00E9e. Par exemple, #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4413)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>'Rouge, vert, bleu dans une notation de fonction rgb. Par exemple, rgb(34,68,238)'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4413)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Rouge, vert, bleu, avec valeur alpha facultative (transparence) dans une notation de fonction rgb/rgba.',
unistr('Si la couleur ne comporte aucune valeur alpha (valeur alpha \00E9gale \00E0 1), un format rgb est utilis\00E9.'),
unistr('Si la couleur comporte une valeur alpha, un format rgba est utilis\00E9.'),
'Par exemple, rgba(34,68,238,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4413)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>unistr('Teinte, saturation, luminosit\00E9 dans une notation de fonction hsl. Par exemple, hsl(34,68,238)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4413)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Teinte, saturation, luminosit\00E9, avec valeur alpha facultative (transparence) dans une notation de fonction hsl/hsla. '),
unistr('Si la couleur ne comporte aucune valeur alpha (valeur alpha \00E9gale \00E0 1), un format hsl est utilis\00E9.'),
unistr('Si la couleur comporte une valeur alpha, un format hsla est utilis\00E9.'),
'Par exemple, hsla(230,86,53,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4413)
,p_display_sequence=>60
,p_display_value=>'Toute valeur CSS'
,p_return_value=>'CSS'
,p_help_text=>'Tout format de couleur CSS valide, y compris des noms de couleur ou une variable CSS.'
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>unistr('Liste de valeurs (LOV) instantan\00E9e')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche un \00E9l\00E9ment de texte avec une ic\00F4ne de liste de valeurs (LOV) instantan\00E9e. Lorsque l''utilisateur final clique sur cette ic\00F4ne, une fen\00EAtre instantan\00E9e contenant un champ de recherche et la liste des valeurs prises en charge appara\00EEt.</p>'),
unistr('<p>L''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e convient plut\00F4t aux longues listes, car les utilisateurs finals peuvent entrer des crit\00E8res de recherche afin de limiter les valeurs disponibles affich\00E9es. L''\00E9l\00E9ment <em>Liste SELECT</em> convient g\00E9n\00E9r')
||'alement mieux aux listes relativement courtes.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Afficher en tant que'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('D\00E9finissez la fa\00E7on dont la liste de valeurs (LOV) instantan\00E9e est affich\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Bo\00EEte de dialogue modale')
,p_return_value=>'DIALOG'
,p_help_text=>unistr('La liste de valeurs sera affich\00E9e dans une bo\00EEte de dialogue modale.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4413)
,p_display_sequence=>20
,p_display_value=>unistr('Fen\00EAtre instantan\00E9e incorpor\00E9e')
,p_return_value=>'POPUP'
,p_help_text=>unistr('La liste de valeurs sera affich\00E9e dans une fen\00EAtre instantan\00E9e incorpor\00E9e sous le champ.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Extraction initiale'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez la fa\00E7on dont les donn\00E9es sont initialement extraites pour la liste de valeurs. Cela s''applique uniquement \00E0 la premi\00E8re ouverture de la fen\00EAtre instantan\00E9e apr\00E8s le chargement de la page ou \00E0 la premi\00E8re r\00E9g\00E9n\00E9ration de l''\00E9l\00E9ment, comme une')
||unistr(' cons\00E9quence d''un effet en cascade. Reportez-vous \00E9galement \00E0 l''attribut Nombre minimal de caract\00E8res.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4413)
,p_display_sequence=>10
,p_display_value=>'A la demande de l''utilisateur'
,p_return_value=>'NO_FETCH'
,p_help_text=>'Aucune liste de valeurs n''est extraite initialement tant que l''utilisateur n''effectue pas de recherches avec ou sans terme de recherche.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4413)
,p_display_sequence=>20
,p_display_value=>'Automatique'
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>'Extrayez initialement la liste de valeurs sans terme de recherche.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4413)
,p_display_sequence=>30
,p_display_value=>'Automatique avec la valeur en cours'
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>unistr('Extrayez initialement la liste de valeurs avec la valeur en cours d\00E9finie en tant que terme de recherche.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valeurs multiples'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si cet \00E9l\00E9ment peut contenir plusieurs valeurs ou une seule. Les valeurs multiples sont renvoy\00E9es sous la forme d''une liste d''\00E9l\00E9ments s\00E9par\00E9s par une virgule.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Entr\00E9e manuelle')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('D\00E9terminez si l''entr\00E9e manuelle est autoris\00E9e. Si vous choisissez Oui, l''utilisateur peut s\00E9lectionner des valeurs existantes dans la liste de valeurs instantan\00E9e ou entrer une valeur manuellement. Le fonctionnement est identique \00E0 celui d''une liste ')
||unistr('d\00E9roulante. Si vous choisissez Non, l''utilisateur peut uniquement s\00E9lectionner des valeurs dans la liste de valeurs instantan\00E9e. Le fonctionnement est identique \00E0 celui d''une liste de s\00E9lection. Lorsque l''entr\00E9e manuelle est autoris\00E9e, c''est la valeu')
||unistr('r renvoy\00E9e de la liste de valeurs correspondante qui doit \00EAtre entr\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Recherche semi-automatique'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Si l''option est d\00E9finie sur Oui, la liste de valeurs est filtr\00E9e \00E0 mesure que vous saisissez du texte dans le champ de recherche. Si elle est d\00E9finie sur Non, la liste de valeurs est filtr\00E9e uniquement lorsque l''utilisateur appuie sur Entr\00E9e ou qu''il')
||unistr(' clique sur l''ic\00F4ne de recherche.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Nombre minimal de caract\00E8res')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez le nombre minimal de caract\00E8res requis pour le terme de recherche afin que la liste de valeurs soit extraite. Cette option peut \00EAtre utile pour r\00E9duire la quantit\00E9 de recherches effectu\00E9es lorsque la requ\00EAte de liste de valeurs (LOV) est co\00FB')
||unistr('teuse. Le nombre de caract\00E8res de toutes les valeurs d''affichage de la liste doit \00EAtre sup\00E9rieur \00E0 ce nombre minimal. Dans le cas contraire, elles ne peuvent pas \00EAtre trouv\00E9es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4413)
,p_display_sequence=>10
,p_display_value=>'Aucun minimum (0)'
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4413)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4413)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4413)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4413)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4413)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Titre'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Titre de la bo\00EEte de dialogue instantan\00E9e. Si ce champ est vide, le titre par d\00E9faut est utilis\00E9.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Largeur de la fen\00EAtre instantan\00E9e')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('Largeur de la fen\00EAtre instantan\00E9e. Si ce champ est vide, une valeur par d\00E9faut est utilis\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Hauteur de la fen\00EAtre instantan\00E9e')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('Hauteur de la fen\00EAtre instantan\00E9e. Si ce champ est vide, une valeur par d\00E9faut est utilis\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Sorties suppl\00E9mentaires')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Renvoyez des colonnes de liste de valeurs (LOV) suppl\00E9mentaires vers d''autres \00E9l\00E9ments de page, et des colonnes de grille interactive. D\00E9finissez un mapping de nom de colonne de liste de valeurs avec un nom d''\00E9l\00E9ment de page ou un ID statique de c')
||'olonne de grille interactive.</p>',
unistr('<p>Remarque : uniquement applicable lorsque la d\00E9finition de liste de valeurs inclut des colonnes suppl\00E9mentaires.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>unistr('S\00E9parateur')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez une fonction JavaScript qui prend un objet d''options de l''\00E9l\00E9ment Liste de valeurs (LOV) instantan\00E9e, modifie cet objet, puis le renvoie. Cela permet une personnalisation avanc\00E9e de la bo\00EEte de dialogue de l''\00E9l\00E9ment Liste de valeurs (LOV')
||unistr(') instantan\00E9e et de son contenu lors de l''initialisation.</p>'),
'',
'<p>Ces options sont transmises au widget <code>popup</code> ou au widget <code>dialog</code> de l''interface utilisateur jQuery :<br>',
'draggable, resizable, width, height, minWidth, minHeight, maxWidth et maxHeight<br>',
unistr('Pour plus de d\00E9tails, consultez la documentation relative au widget de bo\00EEte de dialogue d''interface utilisateur jQuery.</p>'),
'',
unistr('<p>Lorsque les r\00E9sultats sont affich\00E9s dans une liste simple, l''option <code>defaultIconListOptions</code> est un objet transmis au widget <code>tableModelView</code>. Pour conna\00EEtre les options disponibles, consultez la documentation relative au wid')
||'get APEX tableModelView.</p>',
'',
unistr('<p>Lorsque les r\00E9sultats sont affich\00E9s dans une grille, l''option <code>defaultGridOptions</code> est un objet transmis au widget <code>grid</code>.'),
unistr('Pour conna\00EEtre les options disponibles, consultez la documentation relative au widget APEX grid.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4413)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4413)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Liste de valeurs bas\00E9e sur une requ\00EAte SQL</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Liste de valeurs avec les m\00EAmes valeurs d''affichage et renvoy\00E9es</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Remarque : lorsque vous s\00E9lectionnez la m\00EAme colonne pour les valeurs d''affichage et renvoy\00E9es, utilisez un alias de colonne.</p>'),
'</dd>',
unistr('<dt>Liste de valeurs avec variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4413)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('Ex\00E9cuter le code c\00F4t\00E9 serveur')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ex\00E9cute le code sur le serveur.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4413)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Code PL/SQL'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Augmente de 3 % le salaire des employ\00E9s admissibles \00E0 une augmentation de salaire :</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>Dans cet exemple, vous devez saisir <code>P2_DEPTNO</code> dans <strong>El\00E9ments \00E0 soumettre</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez un bloc anonyme PL/SQL en ex\00E9cution seule, qui est ex\00E9cut\00E9 sur le serveur.</p>'),
unistr('<p>Vous pouvez r\00E9f\00E9rencer d''autres \00E9l\00E9ments de page ou d''application depuis votre application \00E0 l''aide de la syntaxe Bind (par exemple <code>:P1_MY_ITEM</code>). Tout \00E9l\00E9ment r\00E9f\00E9renc\00E9 doit \00E9galement \00EAtre inclus dans l''attribut <strong>El\00E9ments de pa')
||unistr('ge \00E0 soumettre</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4413)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>'Code JavaScript'
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Augmente de 3 % le salaire des employ\00E9s admissibles \00E0 une augmentation de salaire :</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
'  // placeholder for some complicated logic to calculate if employee needs a raise',
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>Dans cet exemple, vous devez saisir <code>P2_DEPTNO</code> dans <strong>El\00E9ments \00E0 soumettre</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez un bloc JavaScript en ex\00E9cution seule, qui est ex\00E9cut\00E9 sur le serveur.</p>'),
unistr('<p>Vous pouvez r\00E9f\00E9rencer d''autres \00E9l\00E9ments de page ou d''application \00E0 partir de votre application \00E0 l''aide de la syntaxe Bind (par exemple <code>apex.env.P1_MY_ITEM</code>). Tout \00E9l\00E9ment r\00E9f\00E9renc\00E9 doit \00E9galement \00EAtre inclus dans <strong>El\00E9ments de ')
||unistr('page \00E0 soumettre</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4413)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('El\00E9ments \00E0 soumettre')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez les \00E9l\00E9ments de page, en majuscules, soumis au serveur et qui, par cons\00E9quent, peuvent \00EAtre utilis\00E9s dans le <strong>code PL/SQL</strong>.</p>'),
unistr('<p>Vous pouvez saisir le nom de l''\00E9l\00E9ment ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous s\00E9lectionnez un nom dans la liste et que du texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, puis le nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste est ajout\00E9.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4413)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('El\00E9ments \00E0 renvoyer')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
unistr('<p>Dans cet exemple, saisissez <code>P1_MY_ITEM</code> dans cet attribut pour que la nouvelle valeur soit affich\00E9e dans cet \00E9l\00E9ment sur la page.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez les \00E9l\00E9ments de page, en majuscules, d\00E9finis lorsque l''appel au serveur est renvoy\00E9, en fonction de leur valeur en cours dans l''\00E9tat de session. Si le <strong>code PL/SQL</strong> d\00E9finit au moins une valeur d''\00E9l\00E9ment de page dans l''\00E9tat de')
||unistr(' session, vous devez d\00E9finir ces \00E9l\00E9ments dans cet attribut.</p>'),
unistr('<p>Vous pouvez saisir le nom de l''\00E9l\00E9ment ou le s\00E9lectionner dans la liste des \00E9l\00E9ments disponibles.'),
unistr('Si vous s\00E9lectionnez un nom dans la liste et que du texte a d\00E9j\00E0 \00E9t\00E9 saisi, une virgule est plac\00E9e \00E0 la fin du texte existant, puis le nom d''\00E9l\00E9ment renvoy\00E9 \00E0 partir de la liste est ajout\00E9.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4413)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Supprimer l''\00E9v\00E9nement de modification')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Indiquez si l''\00E9v\00E9nement de modification est supprim\00E9 pour les \00E9l\00E9ments sp\00E9cifi\00E9s dans <strong>El\00E9ments de page \00E0 renvoyer</strong>. Cela emp\00EAche l''activation d''actions dynamiques ult\00E9rieures bas\00E9es sur la <em>modification</em> pour ces \00E9l\00E9ments.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4413)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Langue'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>'Afficher uniquement'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Affiche un \00E9l\00E9ment de texte dans lequel la saisie n''est pas autoris\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4413)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>'Envoyer lors de la soumission de la page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Indiquez si la valeur d''\00E9l\00E9ment en cours doit \00EAtre envoy\00E9e lorsque la page est soumise.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4413)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Bas\00E9 sur')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez la m\00E9thode utilis\00E9e pour d\00E9terminer la valeur affich\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4413)
,p_display_sequence=>10
,p_display_value=>unistr('Valeur d''\00E9l\00E9ment')
,p_return_value=>'VALUE'
,p_help_text=>unistr('La valeur en cours de l''\00E9l\00E9ment appara\00EEt.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4413)
,p_display_sequence=>20
,p_display_value=>'Valeur d''affichage de la liste de valeurs'
,p_return_value=>'LOV'
,p_help_text=>unistr('La valeur en cours de l''\00E9l\00E9ment de page est mise en correspondance avec une valeur d''affichage diff\00E9rente \00E0 l''aide d''une liste de valeurs (LOV).')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4413)
,p_display_sequence=>30
,p_display_value=>'Sortie du code PL/SQL'
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>unistr('Le code PL/SQL indiqu\00E9 \00E9met la sortie affich\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4413)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Code PL/SQL'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez le code PL/SQL en utilisant <code>sys.htp.p</code> ou <code>sys.htp.prn</code> pour \00E9mettre le code HTML.</p>'),
unistr('<p>Oracle recommande d''utiliser <code>sys.htf.escape_sc</code> pour ajouter des caract\00E8res d''\00E9chappement aux donn\00E9es extraites \00E0 partir de la base de donn\00E9es afin de garantir que les balises HTML sont pr\00E9c\00E9d\00E9es d''un caract\00E8re d''\00E9chappement.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4413)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Afficher les sauts de ligne'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si les sauts de ligne sont conserv\00E9s dans la sortie.</p>'),
unistr('<p>Comme l''affichage est au format HTML, lorsque cet \00E9l\00E9ment est d\00E9fini sur <strong>Oui</strong>, les sauts de ligne dans la valeur d''affichage sont convertis en sauts de ligne HTML pour qu''ils soient affich\00E9s correctement.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4413)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>'Format'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4413)
,p_display_sequence=>10
,p_display_value=>'Texte brut'
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4413)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4413)
,p_display_sequence=>30
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4413)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4413)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('<strong>Exemple 1 : liste de valeurs bas\00E9e sur une requ\00EAte SQL.</strong>'),
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
'<strong>Exemple 2 : exemples de listes statiques</strong>',
'<ul>',
'<li>STATIC:Yes;Y,No;N (afficher Yes/No, au lieu de Y et N)</li>',
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>Exemple 3 : liste de valeurs avec une restriction suppl\00E9mentaire \00E0 l''aide de la variable attach\00E9e</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>unistr('Evaluation sous forme d''\00E9toiles')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>El\00E9ment d''\00E9valuation moderne sous forme d''\00E9toiles</strong></p>'),
unistr('<p>Cet \00E9l\00E9ment affiche une valeur num\00E9rique sous forme d''\00E9toiles ou d''autres ic\00F4nes. L''utilisateur final peut modifier la valeur en s\00E9lectionnant le nombre d''\00E9toiles souhait\00E9. Il peut r\00E9gler la valeur en cliquant sur le nombre d''\00E9toiles avec la souri')
||'s ou en utilisant le clavier.</p>',
unistr('<p>L''ic\00F4ne \00E0 afficher, les couleurs d''arri\00E8re-plan et de premier plan peuvent \00EAtre d\00E9finies dans les param\00E8tres du composant ou des \00E9l\00E9ments individuels. Pour utiliser des \00E9l\00E9ments et des couleurs individuels, d\00E9finissez l''attribut d''<strong>utilisat')
||unistr('ion des valeurs de composant par d\00E9faut</strong> sur <strong>Non</strong>.</p>'),
unistr('<p>Pour les ic\00F4nes, vous pouvez utiliser n''importe quelle ic\00F4ne de la police d''ic\00F4ne disponible dans votre application. Pour les applications de th\00E8me universel, utilisez une ic\00F4ne de la biblioth\00E8que <em>Police APEX</em>.</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Ic\00F4ne par d\00E9faut')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('Choisissez l''ic\00F4ne par d\00E9faut \00E0 utiliser.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Couleur active'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Choisissez la couleur par d\00E9faut des \00E9toiles actives.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Couleur inactive'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Choisissez la couleur par d\00E9faut des \00E9toiles inactives.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Info-bulle'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>unistr('Evaluation : #VALUE# \00E9toiles.')
,p_help_text=>unistr('Indiquez le mod\00E8le pour l''info-bulle. La substitution #VALUE# est remplac\00E9e par la valeur d''\00E9valuation en cours.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nombre d''\00E9toiles')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Nombre total d''\00E9toiles \00E0 afficher.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4413)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Utiliser les valeurs par d\00E9faut')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indique s''il faut utiliser les valeurs par d\00E9faut d\00E9finies pour ce composant, dans Composants partag\00E9s > Param\00E8tres de composant, ou des param\00E8tres personnalis\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Ic\00F4ne')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('Indiquez l''ic\00F4ne \00E0 utiliser.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Couleur active'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Choisissez la couleur par d\00E9faut des \00E9toiles actives.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Couleur inactive'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Choisissez la couleur par d\00E9faut des \00E9toiles inactives.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Info-bulle'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>unistr('Evaluation : #VALUE# \00E9toiles.')
,p_help_text=>unistr('Indiquez le mod\00E8le pour l''info-bulle. La substitution #VALUE# est remplac\00E9e par la valeur d''\00E9valuation en cours.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Afficher le bouton Effacer'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Indiquez si un bouton Effacer doit \00EAtre affich\00E9.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Afficher la valeur'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Indiquez si une valeur doit \00EAtre affich\00E9e en regard des \00E9toiles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4413)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Affichage en lecture seule'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indiquez ce qui doit \00EAtre affich\00E9 lorsque l''\00E9l\00E9ment est en lecture seule.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4413)
,p_display_sequence=>20
,p_display_value=>'Etoiles'
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4413)
,p_display_sequence=>30
,p_display_value=>'Valeur'
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4413)
,p_display_sequence=>40
,p_display_value=>'Etoiles et valeur'
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4413)
,p_display_sequence=>50
,p_display_value=>'Etoile unique et valeur'
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>unistr('Groupe de cases \00E0 cocher')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Affiche plusieurs valeurs sous forme de cases \00E0 cocher, permettant \00E0 l''utilisateur final de s\00E9lectionner des valeurs multiples. Une liste de valeurs est requise pour les \00E9l\00E9ments affich\00E9s sous forme de cases \00E0 cocher. Les valeurs correspondant aux ca')
||unistr('ses \00E0 cocher sont stock\00E9es dans une cha\00EEne unique dont les \00E9l\00E9ments sont d\00E9limit\00E9s par deux-points.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4413)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre de colonnes'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Entrez le nombre de colonnes de mise en page utilis\00E9es pour afficher les cases \00E0 cocher. Par exemple, une valeur de 2 affiche deux colonnes de cases \00E0 cocher. Par d\00E9faut, toutes les valeurs apparaissent dans une seule colonne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4413)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Orientation de l''affichage'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez le mode d''affichage des cases \00E0 cocher.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4413)
,p_display_sequence=>10
,p_display_value=>'Vertical'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4413)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4413)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4413)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Liste de valeurs bas\00E9e sur une requ\00EAte SQL</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Liste de valeurs avec les m\00EAmes valeurs d''affichage et renvoy\00E9es</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Remarque : lorsque vous s\00E9lectionnez la m\00EAme colonne pour les valeurs d''affichage et renvoy\00E9es, utilisez un alias de colonne.</p>'),
'</dd>',
unistr('<dt>Liste de valeurs avec variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>'Liste SELECT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Affiche un \00E9l\00E9ment avec un s\00E9lecteur de liste de valeurs int\00E9gr\00E9e. Lorsque l''utilisateur final clique sur cet \00E9l\00E9ment, la liste des valeurs prises en charge appara\00EEt directement incorpor\00E9e \00E0 l''\00E9l\00E9ment en cours.</p>'),
unistr('<p>L''\00E9l\00E9ment Liste SELECT convient mieux aux listes relativement courtes et s\00E9par\00E9es. Les utilisateurs finals peuvent s\00E9lectionner rapidement une valeur dans la liste sans devoir modifier le domaine d''attention dans une bo\00EEte de dialogue instantan\00E9e.')
||unistr(' L''\00E9l\00E9ment <em>Liste de valeurs (LOV) instantan\00E9e</em> convient plut\00F4t aux longues listes.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Action de page lors de la s\00E9lection')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez l''action \00E0 ex\00E9cuter lorsqu''une valeur de liste est s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_display_sequence=>1
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
,p_help_text=>unistr('Aucune action imm\00E9diate n''est appliqu\00E9e lorsque la valeur est modifi\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_display_sequence=>5
,p_display_value=>'Soumettre une page'
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('La page est soumise avec la valeur REQUEST d\00E9finie sur le nom d''\00E9l\00E9ment de page.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_display_sequence=>7
,p_display_value=>unistr('R\00E9acheminer et d\00E9finir la valeur')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('Le navigateur Web est redirig\00E9 vers la page en cours et l''\00E9tat de session de l''\00E9l\00E9ment en cours est d\00E9fini sur la valeur s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_display_sequence=>9
,p_display_value=>unistr('R\00E9acheminer vers une page')
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('Le navigateur Web est redirig\00E9 vers la page contenue dans la valeur s\00E9lectionn\00E9e. Les valeurs renvoy\00E9es de la liste doivent inclure des num\00E9ros ou des alias de page valides.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_display_sequence=>10
,p_display_value=>unistr('R\00E9acheminer vers une URL')
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('Le navigateur Web est redirig\00E9 vers l''URL contenue dans la valeur s\00E9lectionn\00E9e. Les valeurs renvoy\00E9es de la liste doivent inclure des URL valides.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4413)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Autoriser la s\00E9lection multiple')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('Indiquez si une valeur unique ou plusieurs valeurs peuvent \00EAtre s\00E9lectionn\00E9es dans la liste des valeurs. Les valeurs multiples sont renvoy\00E9es sous la forme d''une liste d''\00E9l\00E9ments s\00E9par\00E9s par une virgule.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4413)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Ex\00E9cuter les validations')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Indiquez si les validations sont effectu\00E9es lors de la soumission de la page, en fonction du param\00E8tre d''action de page de <strong>Soumettre une page</strong>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4413)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4413)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Liste de valeurs bas\00E9e sur une requ\00EAte SQL</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Liste de valeurs avec les m\00EAmes valeurs d''affichage et renvoy\00E9es</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Remarque : lorsque vous s\00E9lectionnez la m\00EAme colonne pour les valeurs d''affichage et renvoy\00E9es, utilisez un alias de colonne.</p>'),
'</dd>',
unistr('<dt>Liste de valeurs avec variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>unistr('Etat d''activation/de d\00E9sactivation de colonne')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un \00E9tat permettant aux utilisateurs finals de s\00E9lectionner les colonnes \00E0 afficher lors de l''ex\00E9cution. Les utilisateurs finals peuvent ensuite modifier les colonnes en fonction de la largeur et de l''orientation de l''\00E9cran qu''ils utilisent po')
||unistr('ur afficher l''\00E9tat.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la base pour cette colonne d''\00E9tat.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_display_sequence=>10
,p_display_value=>'Texte brut'
,p_return_value=>'PLAIN'
,p_help_text=>'Affiche la valeur de colonne.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_display_sequence=>20
,p_display_value=>'Lien'
,p_return_value=>'LINK'
,p_help_text=>'Affiche la colonne en tant que lien.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Graphique \00E0 pourcentage')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('Affiche la colonne en tant que graphique \00E0 pourcentage. La valeur extraite doit \00EAtre comprise entre 0 et 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Cible'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Saisissez la page cible \00E0 appeler lorsque l''utilisateur clique sur une entr\00E9e existante.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Texte de lien'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Saisissez le texte HTML \00E0 afficher en tant que lien. Pour afficher une image, utilisez une balise d''image ou s\00E9lectionnez-la dans la liste des images par d\00E9faut.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Attributs de lien'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Indiquez des attributs de lien de colonne suppl\00E9mentaires \00E0 inclure dans la balise <code>&lt;a href=...&gt;</code>, tels qu''une cible de lien, des classes ou des styles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Couleur d''arri\00E8re-plan')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML : ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu fonc\00E9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour l''arri\00E8re-plan de ce graphique.'),
unistr('La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML.</p>'),
unistr('<p>La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Couleur de premier plan'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML : ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu fonc\00E9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour le premier plan de ce graphique.'),
unistr('La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML.</p>'),
unistr('<p>La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Largeur des barres'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Saisissez la largeur en pixels pour ce graphique \00E0 barres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Utiliser comme en-t\00EAte de ligne')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Utilis\00E9 \00E0 des fins d''accessibilit\00E9 pour identifier la colonne qui repr\00E9sente le mieux le contenu de la ligne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>unistr('Priorit\00E9')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''\00E9tat fonctionne en masquant et affichant les colonnes selon deux entr\00E9es : la largeur d''\00E9cran disponible ou la s\00E9lection/d\00E9s\00E9lection par l''utilisateur des colonnes \00E0 afficher dans le menu S\00E9lecteur de colonne. Choisissez une valeur prioritaire p')
||unistr('our chaque colonne \00E0 afficher de fa\00E7on r\00E9active. Toutes les colonnes dot\00E9es d''une priorit\00E9 seront disponibles dans le menu S\00E9lecteur de colonne.<p>'),
'',
unistr('<p>Pour rendre une colonne persistante afin qu''elle ne soit jamais masqu\00E9e, s\00E9lectionnez <strong>Toujours affich\00E9</strong>. Cette action enl\00E8ve \00E9galement la colonne du menu S\00E9lecteur de colonne.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_display_sequence=>5
,p_display_value=>unistr('Toujours affich\00E9')
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_display_sequence=>10
,p_display_value=>'1 - Masquer le dernier'
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4413)
,p_display_sequence=>60
,p_display_value=>'6 - Masquer le premier'
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Options de mise en page'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('V\00E9rifiez les options de mise en page d''\00E9tat suppl\00E9mentaires.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4413)
,p_display_sequence=>10
,p_display_value=>'Stripes'
,p_return_value=>'STRIPE'
,p_help_text=>'Ajoutez des stripes alternatifs sur chaque ligne.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4413)
,p_display_sequence=>20
,p_display_value=>'Trait'
,p_return_value=>'STROKE'
,p_help_text=>'Ajoutez des traits horizontaux entre chaque ligne.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Saisissez des classes CSS suppl\00E9mentaires \00E0 inclure dans le composant, en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Attributs personnalis\00E9s')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Saisissez les attributs suppl\00E9mentaires \00E0 inclure dans la balise HTML de table. L''attribut HTML de classe est g\00E9n\00E9r\00E9 et ne doit donc pas \00EAtre indiqu\00E9. Utilisez l''attribut <em>Classes CSS</em> d\00E9di\00E9 \00E0 la place.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Texte du bouton Colonne'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('Ce libell\00E9 doit \00EAtre utilis\00E9 pour le bouton qui permet d''ouvrir la fen\00EAtre instantan\00E9e de s\00E9lection de colonnes. Si aucun texte n''est indiqu\00E9, un libell\00E9 par d\00E9faut est utilis\00E9.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4413)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher tous les employ\00E9s class\00E9s par nom</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>Afficher tous les employ\00E9s du service en cours class\00E9s par nom</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Lorsque vous utilisez des variables attach\00E9es pour r\00E9f\00E9rencer des \00E9l\00E9ments de page, d\00E9signez-les en tant qu''<strong>\00E9l\00E9ments de page \00E0 soumettre<strong>.</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>'Navette'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S''affiche sous la forme d''une liste de s\00E9lection multiple incluant deux zones de liste. La liste de gauche affiche la liste des valeurs source qui n''ont pas \00E9t\00E9 s\00E9lectionn\00E9es, tandis que celle de droite affiche les valeurs actuellement s\00E9lectionn\00E9')
||unistr('es. Les utilisateurs finals peuvent choisir des valeurs dans une des listes, puis utiliser les navettes pour d\00E9placer toutes les valeurs ou seulement les valeurs s\00E9lectionn\00E9es.</p>'),
unistr('<p>Les valeurs en cours sont stock\00E9es dans une cha\00EEne unique dont les \00E9l\00E9ments sont d\00E9limit\00E9s par deux-points.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4413)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Afficher les contr\00F4les')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez ce que les contr\00F4les de mouvement des donn\00E9es affichent au centre de la navette.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4413)
,p_display_sequence=>10
,p_display_value=>'Tout'
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4413)
,p_display_sequence=>20
,p_display_value=>unistr('En cours de d\00E9placement uniquement')
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4413)
,p_display_sequence=>30
,p_display_value=>'En cours de commande uniquement'
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4413)
,p_display_sequence=>40
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4413)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4413)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Liste de valeurs bas\00E9e sur une requ\00EAte SQL</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Liste de valeurs avec les m\00EAmes valeurs d''affichage et renvoy\00E9es</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Remarque : lorsque vous s\00E9lectionnez la m\00EAme colonne pour les valeurs d''affichage et renvoy\00E9es, utilisez un alias de colonne.</p>'),
'</dd>',
unistr('<dt>Liste de valeurs avec variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4413)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4413)
,p_name=>'shuttlechangeorder'
,p_display_name=>'Changer l''ordre'
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>'Groupe de boutons d''option'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche plusieurs valeurs sous forme de groupes de boutons d''options, permettant \00E0 l''utilisateur final de s\00E9lectionner une seule valeur.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4413)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre de colonnes'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Entrez le nombre de colonnes de groupe de boutons d''option \00E0 afficher. Par exemple, une valeur de <code>2</code> affiche deux colonnes ; ainsi, si vous avez cinq valeurs, elles sont affich\00E9es sur trois lignes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4413)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Action de page lors de la s\00E9lection')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez l''action \00E0 ex\00E9cuter lorsqu''une valeur de groupe de boutons d''option est s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4413)
,p_display_sequence=>10
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
,p_help_text=>unistr('Aucune action imm\00E9diate n''est appliqu\00E9e lorsque la valeur est modifi\00E9e.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4413)
,p_display_sequence=>20
,p_display_value=>'Soumettre une page'
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('La page est soumise avec la valeur REQUEST d\00E9finie sur le nom d''\00E9l\00E9ment de page.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4413)
,p_display_sequence=>30
,p_display_value=>unistr('R\00E9acheminer et d\00E9finir la valeur')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('Le navigateur Web redirige l''utilisateur vers la page en cours et l''\00E9tat de session de l''\00E9l\00E9ment en cours est d\00E9fini sur la valeur s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4413)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Ex\00E9cuter les validations')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Indiquez si les validations sont effectu\00E9es lors de la soumission de la page, selon le param\00E8tre d''action de page <strong>Soumettre une page</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4413)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>'Orientation de l''affichage'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez l''orientation de l''affichage des valeurs de groupe de boutons d''option.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4413)
,p_display_sequence=>10
,p_display_value=>'Vertical'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4413)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4413)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Masquer les boutons d''option'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4413)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4413)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Liste de valeurs bas\00E9e sur une requ\00EAte SQL</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Liste de valeurs avec les m\00EAmes valeurs d''affichage et renvoy\00E9es</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Remarque : lorsque vous s\00E9lectionnez la m\00EAme colonne pour les valeurs d''affichage et renvoy\00E9es, utilisez un alias de colonne.</p>'),
'</dd>',
unistr('<dt>Liste de valeurs avec variable attach\00E9e</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Remarque : d\00E9finissez l''attribut <em>El\00E9ments parent de liste de valeurs (LOV) en cascade</em> sur <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> est un \00E9l\00E9ment modifiable sur la m\00EAme page.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>'Etat de reflux'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche un \00E9tat r\00E9actif qui transforme les colonnes en lignes pour adapter les \00E9tats \00E0 un navigateur (\00E9cran) de plus petite taille.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('S\00E9lectionnez la base pour cette colonne d''\00E9tat.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_display_sequence=>10
,p_display_value=>'Texte brut'
,p_return_value=>'PLAIN'
,p_help_text=>'Affiche la valeur de colonne.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_display_sequence=>20
,p_display_value=>'Lien'
,p_return_value=>'LINK'
,p_help_text=>'Affiche la colonne en tant que lien.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_display_sequence=>30
,p_display_value=>unistr('Graphique \00E0 pourcentage')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('Affiche la colonne en tant que graphique \00E0 pourcentage. La valeur extraite doit \00EAtre comprise entre 0 et 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Cible'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Saisissez la page cible \00E0 appeler lorsque l''utilisateur clique sur une entr\00E9e existante.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Texte de lien'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Saisissez le texte HTML \00E0 afficher en tant que lien. Pour afficher une image, utilisez une balise d''image ou s\00E9lectionnez-la dans la liste des images par d\00E9faut.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Attributs de lien'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Indiquez des attributs de lien de colonne suppl\00E9mentaires \00E0 inclure dans la balise <code>&lt;a href=...&gt;</code>, tels qu''une cible de lien, des classes ou des styles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Couleur d''arri\00E8re-plan')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML : ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu fonc\00E9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour l''arri\00E8re-plan de ce graphique.'),
unistr('La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML.</p>'),
unistr('<p>La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Couleur de premier plan'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Exemples des principaux codes couleur HTML : ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Noir&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rouge&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Jaune&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Vert clair&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Vert&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Turquoise&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Bleu&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Bleu fonc\00E9&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanc&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour le premier plan de ce graphique.'),
unistr('La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML.</p>'),
unistr('<p>La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Largeur des barres'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Saisissez la largeur en pixels pour ce graphique \00E0 barres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Utiliser comme en-t\00EAte de ligne')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Utilis\00E9 \00E0 des fins d''accessibilit\00E9 pour identifier la colonne qui repr\00E9sente le mieux le contenu de la ligne.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Options de mise en page'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('V\00E9rifiez les options de mise en page d''\00E9tat suppl\00E9mentaires.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4413)
,p_display_sequence=>10
,p_display_value=>'Stripes'
,p_return_value=>'STRIPE'
,p_help_text=>'Ajoutez des stripes alternatifs sur chaque ligne.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4413)
,p_display_sequence=>20
,p_display_value=>'Trait'
,p_return_value=>'STROKE'
,p_help_text=>'Ajoutez des traits horizontaux entre chaque ligne.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Saisissez des classes CSS suppl\00E9mentaires \00E0 inclure dans le composant, en les s\00E9parant par des espaces.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Attributs personnalis\00E9s')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Saisissez les attributs suppl\00E9mentaires \00E0 inclure dans la balise HTML de table. L''attribut HTML de classe est g\00E9n\00E9r\00E9 et ne doit donc pas \00EAtre indiqu\00E9. Utilisez l''attribut <em>Classes CSS</em> d\00E9di\00E9 \00E0 la place.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4413)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4413)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Afficher tous les employ\00E9s class\00E9s par nom</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>Afficher tous les employ\00E9s du service en cours class\00E9s par nom</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Lorsque vous utilisez des variables attach\00E9es pour r\00E9f\00E9rencer des \00E9l\00E9ments de page, d\00E9signez-les en tant qu''<strong>\00E9l\00E9ments de page \00E0 soumettre<strong>.</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>unistr('Graphique \00E0 pourcentage')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche la valeur en tant que graphique \00E0 pourcentage. La valeur extraite doit \00EAtre comprise entre 0 et 100.')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4413)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Afficher la valeur'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indiquez si la valeur de pourcentage est visible.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4413)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Couleur d''arri\00E8re-plan')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour l''arri\00E8re-plan de ce graphique.'),
unistr('La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML.</p>'),
unistr('<p>La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4413)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Couleur de premier plan'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour le premier plan de ce graphique.'),
unistr('La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML.</p>'),
unistr('<p>La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous souhaitez utiliser.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4413)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Couleur du texte'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la couleur utilis\00E9e pour le texte de ce graphique.'),
unistr('La couleur est indiqu\00E9e \00E0 l''aide d''une notation hexad\00E9cimale, de codes de couleur RGB ou de noms de couleur HTML.</p>'),
unistr('<p>La notation hexad\00E9cimale est d\00E9finie comme #xxyyzz (signe # suivi de nombres hexad\00E9cimaux \00E0 trois paires de chiffres), o\00F9 xx, yy et zz repr\00E9sentent les valeurs hexad\00E9cimales \00E0 deux caract\00E8res pour le rouge, le vert et le bleu, respectivement.'),
unistr('Les codes RGB sont d\00E9finis comme RGB(xxx,xxx,xxx), o\00F9 xxx est un nombre compris entre 0 et 255, chacun repr\00E9sentant la valeur unique d''octet de 8 bits pour le rouge, le vert et le bleu, respectivement.</p>'),
unistr('<p>Recherchez sur Internet les codes de couleur HTML pour trouver le code hexad\00E9cimal ou le code RGB correspondant \00E0 la couleur que vous voulez utiliser.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4413)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Largeur des barres'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>unistr('Saisissez la largeur en pixels pour ce graphique \00E0 barres.')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>'Editeur Markdown'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Affiche une zone de texte prenant en charge les entr\00E9es Markdown, avec des options de formatage de texte, la prise en charge de l''inclusion d''images et une option d''aper\00E7u du texte format\00E9. L''\00E9diteur Markdown vous permet d''\00E9crire en utilisant du text')
||unistr('e brut facile \00E0 lire et \00E0 \00E9crire, puis de le convertir en code HTML valide structurellement \00E0 l''aide des diverses options fournies et de la syntaxe prise en charge.')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4413)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Barre d''outils'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Fournit plusieurs options de configuration de la barre d''outils pour l''\00E9diteur Markdown')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4413)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('Affichez les contr\00F4les de formatage de base dans la barre d''outils.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4413)
,p_display_sequence=>20
,p_display_value=>'Complet'
,p_return_value=>'FULL'
,p_help_text=>unistr('Affichez l''ensemble des contr\00F4les de formatage dans la barre d''outils.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4413)
,p_display_sequence=>40
,p_display_value=>'Aucun'
,p_return_value=>'NONE'
,p_help_text=>'Masquez la barre d''outils.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4413)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Mise en \00E9vidence de syntaxe')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indique s''il faut appliquer la mise en \00E9vidence de syntaxe pour des \00E9l\00E9ments Markdown sp\00E9cifiques, par exemple du texte en gras, en italique, des blocs de code, etc.</p>'),
unistr('<p>La mise en \00E9vidence ne peut \00EAtre appliqu\00E9e que pour le contenu comportant moins de 4 000 caract\00E8res.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4413)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4413)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>Entrez une fonction JavaScript qui prend un objet de configuration pour l''\00E9diteur Markdown, modifie l''objet et le renvoie. Cela permet d''effectuer une personnalisation avanc\00E9e de l''apparence, des fonctionnalit\00E9s et du comportement de l''\00E9diteur Mar')
||'kdown, y compris la barre d''outils, les menus et les actions.</p>'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4413)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4413)
,p_name=>'markdownified'
,p_display_name=>'converti en Markdown'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>'Changer'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'S''affiche sous la forme d''un bouton bascule.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Valeur Activ\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Saisissez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur final s\00E9lectionne l''option <strong>Activ\00E9</strong>. La valeur peut contenir jusqu''\00E0 255 caract\00E8res.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Libell\00E9 Activ\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le texte affich\00E9 pour l''option <strong>Activ\00E9</strong>. Si aucun texte n''est saisi, le libell\00E9 par d\00E9faut du syst\00E8me est utilis\00E9.'),
unistr('<p>Remarque : si le param\00E8tre de composant Style d''affichage a pour valeur <strong>Changer</strong>, cet attribut est utilis\00E9 uniquement comme valeur d''affichage pour les colonnes de grille interactive. Il n''est pas affich\00E9 pour les \00E9l\00E9ments de page ')
||'normale.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Valeur D\00E9sactiv\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur s\00E9lectionne l''option <strong>D\00E9sactiv\00E9</strong>. La valeur peut contenir jusqu''\00E0 255 caract\00E8res.</p>'),
unistr('<p><em>Remarque : cette valeur est utilis\00E9e si l''\00E9l\00E9ment de page contient une valeur qui ne correspond ni \00E0 la valeur <strong>Activ\00E9</strong> ni \00E0 la valeur <strong>D\00E9sactiv\00E9</strong>.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Libell\00E9 D\00E9sactiv\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le texte affich\00E9 pour l''option <strong>D\00E9sactiv\00E9</strong>. Si aucun texte n''est saisi, le libell\00E9 par d\00E9faut du syst\00E8me est utilis\00E9.'),
unistr('<p>Remarque : si le param\00E8tre de composant Style d''affichage a pour valeur <strong>Changer</strong>, cet attribut est utilis\00E9 uniquement comme valeur d''affichage pour les colonnes de grille interactive. Il n''est pas affich\00E9 pour les \00E9l\00E9ments de page ')
||'normale.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>'Style d''affichage'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4413)
,p_display_sequence=>5
,p_display_value=>'Changer'
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4413)
,p_display_sequence=>10
,p_display_value=>'Bouton pillule'
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4413)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4413)
,p_display_sequence=>20
,p_display_value=>'Liste SELECT'
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Utiliser les valeurs par d\00E9faut')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Indique s''il faut utiliser les valeurs par d\00E9faut d\00E9finies pour ce composant, dans Composants partag\00E9s > Param\00E8tres de composant, ou des param\00E8tres personnalis\00E9s.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Valeur Activ\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Saisissez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur s\00E9lectionne l''option <strong>Activ\00E9</strong>. La valeur peut contenir jusqu''\00E0 255 caract\00E8res.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Libell\00E9 Activ\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le texte affich\00E9 pour l''option <strong>Activ\00E9</strong>.'),
unistr('<p>Remarque : si le param\00E8tre de composant Style d''affichage a pour valeur <strong>Changer</strong>, cet attribut n''a aucun effet.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Valeur D\00E9sactiv\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez la valeur stock\00E9e dans l''\00E9l\00E9ment de page si l''utilisateur s\00E9lectionne l''option <strong>D\00E9sactiv\00E9</strong>. Cet attribut peut \00E9galement \00EAtre laiss\00E9 vide pour stocker la valeur <code>NULL</code> lorsque l''option D\00E9sactiv\00E9 est s\00E9lectionn\00E9e.')
||unistr(' La valeur peut contenir jusqu''\00E0 255 caract\00E8res.</p>'),
unistr('<p><em>Remarque : cette valeur est utilis\00E9e si l''\00E9l\00E9ment de page contient une valeur qui ne correspond ni \00E0 la valeur <strong>Activ\00E9</strong> ni \00E0 la valeur <strong>D\00E9sactiv\00E9</strong>.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4413)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4413)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Libell\00E9 D\00E9sactiv\00E9')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le texte affich\00E9 pour l''option <strong>D\00E9sactiv\00E9</strong>.'),
unistr('<p>Remarque : si le param\00E8tre de composant Style d''affichage a pour valeur <strong>Changer</strong>, cet attribut n''a aucun effet.</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4413)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Bureau'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4413
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4413)
,p_name=>'Messages'
,p_step_title=>'Messages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4413)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
