prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4472
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4472 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4472
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101975364403550')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'fr'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4472)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113350'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4472)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4472)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4472)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4472)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4472)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4472)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4472)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4472)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4472)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4472)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4472)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4472)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4472)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.fr'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4472
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4472)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4472)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4472)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4472)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4472)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4472)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4472)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.fr'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4472
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4472)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4472)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4472)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4472)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4472)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4472)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4472)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.fr'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4472
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4472)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4472)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4472)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.fr'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4472
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4472)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4472)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4472)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4472)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4472)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4472)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4472)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4472)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4472)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4472)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4472)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4472)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4472)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4472)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4472)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.fr'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4472
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4472)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4472)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4472)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4472)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4472)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4472)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4472)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4472)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4472)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4472)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4472)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4472)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4472)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4472)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4472)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.fr'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4472
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4472)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4472)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4472)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4472)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4472)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4472)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4472)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4472)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4472)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4472)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4472)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4472)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4472)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4472)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4472)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.fr'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4472
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4472)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4472)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4472)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4472)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4472)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4472)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4472)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4472)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4472)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4472)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4472)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4472)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4472)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4472)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4472)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4472
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4472)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4472
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4472)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4472
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4472)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4472
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4472)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4472
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4472)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4472
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4472
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4472)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4472)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4472)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4472)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4472)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4472)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4472)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4472)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4472)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4472)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4472)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4472)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4472)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4472)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4472)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4472)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4472)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4472)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4472)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4472)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4472)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4472)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4472)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4472)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4472)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4472)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4472)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4472
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4472)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4472)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4472)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4472)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4472)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4472
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4472)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4472
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4472)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4472
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4472)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4472
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4472)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4472
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4472)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4472
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4472)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4472)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4472)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4472)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4472)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4472)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4472)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4472)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4472)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4472
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4472)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4472)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4472)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4472)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4472)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4472)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4472)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4472
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4472)
,p_page_name=>'winlov'
,p_page_title=>unistr('Bo\00EEte de dialogue de recherche')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Rechercher'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Fermer'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Suivant &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; Pr\00E9c\00E9dent')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Ligne(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4472
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4472)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4472
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4472)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4472)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4472)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4472)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4472)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4472)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4472)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4472)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4472)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4472)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4472)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4472)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4472)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4472)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4472)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4472)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4472)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4472)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4472)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4472)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4472)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4472)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4472)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4472)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4472)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4472)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4472)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4472)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4472)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4472)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4472)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4472)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4472)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4472)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4472)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4472)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4472)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4472)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4472)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4472)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4472)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4472)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4472)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4472)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4472)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4472)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4472)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4472)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4472)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4472)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4472)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4472)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4472)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4472)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4472)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4472)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4472)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4472)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4472)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4472)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4472)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4472)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4472)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4472)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4472)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4472)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4472)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4472)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4472)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4472)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4472)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4472)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4472)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4472)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4472)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4472)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4472)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4472)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4472)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4472)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4472)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4472)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4472)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4472)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4472)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4472)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4472)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4472)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4472)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4472)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4472)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4472)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4472)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4472)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4472)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4472)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4472)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4472)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4472)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4472)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4472)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4472)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4472)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4472)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4472)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4472)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4472)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4472)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4472)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4472)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4472)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4472)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4472)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4472)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4472)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4472)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4472)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4472)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4472)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4472)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4472)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4472)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4472)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4472)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4472)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4472)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4472)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4472)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4472)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4472)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4472)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4472)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4472)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4472)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4472)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4472)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4472)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4472)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4472)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4472)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4472)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4472)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4472)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4472)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4472)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4472)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4472)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4472)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4472)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4472)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4472)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4472)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4472)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4472)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4472)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4472)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4472)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4472)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4472)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4472)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4472)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4472)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4472)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4472)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4472)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4472)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4472)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4472)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4472)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4472)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4472)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4472)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4472)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4472)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4472)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4472)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4472)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4472)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4472)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4472)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4472)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4472)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4472)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4472)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4472)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4472)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813664936399679)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'fr'
,p_message_text=>'Colonne %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800790831399670)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Administrateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800614759399670)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857955065399711)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s refus\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817661146399682)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre compte %0 a \00E9t\00E9 cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803213018399671)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'fr'
,p_message_text=>unistr('Compte verrouill\00E9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793130137399664)
,p_name=>'AM_PM'
,p_message_language=>'fr'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927517742399761)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer/d\00E9sactiver %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935685343399767)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'fr'
,p_message_text=>'(Actif)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905120650399745)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''appel d''AJAX a renvoy\00E9 une erreur de serveur %0 pour %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835991793399695)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''alias d''application "%0" ne peut pas \00EAtre converti en ID d''application unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836016826399696)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'L''application portant l''alias "%0" n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825609577399688)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1816 Erreur inattendue lors de la conversion de l''alias d''application p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918597573399755)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le checksum d''application permet de d\00E9terminer facilement si la m\00EAme application est d\00E9ploy\00E9e dans diff\00E9rents espaces de travail. Vous pouvez comparer ce checksum afin de d\00E9terminer s''il existe une correspondance. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811412856399678)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de la fonction d''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796805250399667)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de la fonction d''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960302350399786)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de locataire %0 renvoy\00E9 par Oracle Cloud Identity Management n''est pas autoris\00E9 pour le domaine %1.<br/><a href="&LOGOUT_URL.">Reconnectez-vous</a>, puis indiquez un nom de locataire autoris\00E9 ou modifiez l''URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794558965399665)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'fr'
,p_message_text=>unistr('Le compte "%0" ne dispose pas des privil\00E8ges de d\00E9veloppement n\00E9cessaires (DB_DEVELOPER ou DB_ADMINISTRATOR)<br/>pour l''espace de travail "%1". <a href="&LOGOUT_URL.">Reconnectez-vous</a> une fois les privil\00E8ges obtenus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793608987399665)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de locataire renvoy\00E9 par Oracle Cloud Identity Management n''est pas autoris\00E9 pour l''espace de travail en cours.<br/><a href="&LOGOUT_URL.">Reconnectez-vous</a> et indiquez un nom de locataire autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794602286399665)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour des raisons de s\00E9curit\00E9, l''ex\00E9cution des applications de cet espace de travail via le domaine de l''URL n''est pas autoris\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811120043399677)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Demandez \00E0 votre administrateur de base de donn\00E9es d''ex\00E9cuter $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811086472399677)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'fr'
,p_message_text=>'Le package SYS.DBMS_LDAP n''existe pas ou n''est pas valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810946748399677)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du traitement de la fonction de mise \00E0 jour de l''utilisateur LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811228418399677)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de l''authentification LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812069611399678)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur dans l''argument p_flow_page de la proc\00E9dure login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811689481399678)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'fr'
,p_message_text=>'p_session non valide dans wwv_flow_custom_auth_std.login--p_flow_page : %0 p_session_id : %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859538691399713)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'fr'
,p_message_text=>'Argument incorrect pour wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811746883399678)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom utilisateur Null transmis \00E0 la proc\00E9dure de connexion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800571998399670)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'fr'
,p_message_text=>'Veuillez patienter pendant <span id="apex_login_throttle_sec">%0</span> secondes avant de vous reconnecter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801838907399670)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La tentative de connexion a \00E9t\00E9 bloqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857304988399711)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Authentification "%0" introuvable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802154348399671)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de groupe de s\00E9curit\00E9 est Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811551050399678)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur d''ex\00E9cution du processus de postauthentification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811347638399677)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du traitement du processus de pr\00E9authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812516559399678)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ouvrez l''URL dans le navigateur que vous avez utilis\00E9 pour lancer la demande de r\00E9initialisation de mot de passe. Si vous cliquez sur l''URL de r\00E9initialisation du mot de passe et \00EAtes redirig\00E9 vers'),
unistr('la page de connexion, relancez la r\00E9initialisation du mot de passe et laissez le'),
'navigateur ouvert.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957865964399784)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('URL de r\00E9initialisation du mot de passe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794864277399665)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le groupe de consommateurs Resource Manager %0 n''a pas \00E9t\00E9 accord\00E9 \00E0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794995967399665)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilisez DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP pour octroyer le privil\00E8ge manquant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822925369399686)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de la fonction de sentinelle de session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823018436399686)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du traitement de la fonction de v\00E9rification de session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823243441399686)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Demandez \00E0 votre administrateur %0 de configurer le moteur pour Oracle Application Server Single Sign-On.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832738947399693)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 non valide dans le token %1 renvoy\00E9 par SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811963561399678)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifiez le mod\00E8le d''authentification et ajoutez le nom d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832481685399693)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'fr'
,p_message_text=>unistr('Appelant de la proc\00E9dure %0 non valide :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832669084399693)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'fr'
,p_message_text=>'Session d''application non valide dans le token URLC : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832236368399693)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans portal_sso_redirect : informations d''inscription d''application absentes : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823130186399686)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'fr'
,p_message_text=>'Le package WWSEC_SSO_ENABLER_PRIVATE n''existe pas ou n''est pas valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111811852189399678)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de trouver le nom d''application partenaire inscrit dans le mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832391104399693)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'fr'
,p_message_text=>unistr('Inscrivez cette application comme indiqu\00E9 dans le guide d''installation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823362975399686)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de l''authentification SSO.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932773489399765)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'fr'
,p_message_text=>unistr('URL non autoris\00E9e : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822732969399686)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de l''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794797972399665)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'fr'
,p_message_text=>'L''espace de travail "%0" est inactif. Contactez l''administrateur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795122240399666)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'fr'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801582347399670)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s refus\00E9 par le contr\00F4le de s\00E9curit\00E9 de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801657236399670)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s refus\00E9 par le contr\00F4le de s\00E9curit\00E9 de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801747887399670)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de l''autorisation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865147759399717)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'fr'
,p_message_text=>unistr('Construit avec %0 \00E0 l''aide de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865203014399717)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'fr'
,p_message_text=>'amour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923087327399758)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Description d''\00E9v\00E9nement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922834965399758)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'fr'
,p_message_text=>'Date de fin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923138345399758)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('ID d''\00E9v\00E9nement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922742961399758)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922920743399758)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre de l''\00E9v\00E9nement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813501144399679)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur de contenu de checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813489236399679)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur de format de checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877417058399725)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Copi\00E9 dans le presse-papiers.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877146682399725)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce navigateur ne prend pas en charge la copie \00E0 partir d''un bouton ou d''un menu. Essayez la combinaison Ctrl+C ou Commande+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865669749399717)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Fermer la notification'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921684406399757)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'fr'
,p_message_text=>'Contraste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916190704399753)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'fr'
,p_message_text=>'En cours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916055632399753)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'fr'
,p_message_text=>'Initial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920256284399756)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit \00EAtre une couleur valide. Par exemple : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915939231399753)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Choisir une couleur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916241366399753)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Changer de format de couleur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955412863399782)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955524727399782)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir la liste pour : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935744967399768)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'fr'
,p_message_text=>unistr('(Termin\00E9)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828074513399690)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'fr'
,p_message_text=>'Contactez l''administrateur de l''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842450217399700)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Contactez l''administrateur de l''application.',
unistr('Les d\00E9tails relatifs \00E0 cet incident sont disponibles via l''ID de d\00E9bogage "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920599049399756)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'fr'
,p_message_text=>'Corrigez les erreurs avant l''enregistrement.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866578753399718)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 correspondances trouv\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866413689399718)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune correspondance trouv\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936267108399768)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'fr'
,p_message_text=>'Progression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920910184399757)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Le fichier indiqu\00E9 dans l''\00E9l\00E9ment %0 n''existe pas dans APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909453282399748)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('La version en cours des donn\00E9es dans la base a chang\00E9 depuis que l''utilisateur a lanc\00E9 le traitement de mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878533721399726)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'fr'
,p_message_text=>'Ne pas charger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925597378399760)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'fr'
,p_message_text=>'Erreur avant traitement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925383790399760)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E9rer une ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939467684399770)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence : action')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925410846399760)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre \00E0 jour une ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866958348399718)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Calendrier instantan\00E9 : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789507240399662)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789692559399662)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925758470399760)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'#LABEL# doit comporter une valeur.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925668605399760)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit \00EAtre une date valide, par exemple : %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793284812399664)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit \00EAtre compris entre %0 et %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793308580399664)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit correspondre ou \00EAtre post\00E9rieur \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793408294399664)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit correspondre ou \00EAtre ant\00E9rieur \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870449696399720)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# est sup\00E9rieure \00E0 la date maximale indiqu\00E9e %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870836978399721)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>'La valeur #LABEL# ne concorde pas avec le format %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870309224399720)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# est inf\00E9rieure \00E0 la date minimale indiqu\00E9e %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870545193399720)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# n''est pas comprise dans la plage valide de %0 \00E0 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870728182399721)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# ne figure pas dans la plage d''ann\00E9es valide comprise entre %0 et %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920871064399757)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948051839399776)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950046961399778)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920637963399756)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'fr'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920753335399757)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826927332399689)
,p_name=>'APEX.ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794307820399665)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''erreur suivante est survenue lors de l''ex\00E9cution du callback de gestion des erreurs : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803028093399671)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''affichage de la page d''erreur : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795093179399666)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'fr'
,p_message_text=>'Erreur interne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934819010399767)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Contactez l''administrateur.',
unistr('Les d\00E9tails relatifs \00E0 cet incident sont disponibles via l''ID de d\00E9bogage "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929188824399763)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'fr'
,p_message_text=>unistr('La base de donn\00E9es est ouverte pour acc\00E8s en lecture seule')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959739518399785)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'fr'
,p_message_text=>unistr('ORA-28353 : \00E9chec de l''ouverture du portefeuille. Les donn\00E9es d''application sont actuellement inaccessibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929236398399763)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sol\00E9, cette page n''est pas disponible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796792887399667)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'fr'
,p_message_text=>unistr('Informations techniques (visibles uniquement par les d\00E9veloppeurs)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892866748399737)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'fr'
,p_message_text=>'Message d''erreur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906741370399747)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format attendu : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873425428399723)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''utilisateur figure d\00E9j\00E0 dans la liste de contr\00F4le d''acc\00E8s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873328416399723)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Confirmez l''ajout des %0 utilisateurs suivants \00E0 la liste de contr\00F4le d''acc\00E8s <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873817571399723)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur en double'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873578893399723)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'fr'
,p_message_text=>unistr('Arobase manquante (@) dans l''adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873679960399723)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'fr'
,p_message_text=>unistr('Point manquant (.) dans l''adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873723957399723)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>'Le nom utilisateur est trop long'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874052490399723)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Seuls les utilisateurs d\00E9finis dans la liste de contr\00F4le d''acc\00E8s de l''application peuvent acc\00E9der \00E0 l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874166515399723)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de param\00E8tre de contr\00F4le d''acc\00E8s inattendue : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873992621399723)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'fr'
,p_message_text=>unistr('Tous les utilisateurs authentifi\00E9s peuvent acc\00E9der \00E0 cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916735928399754)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916612100399754)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916914203399754)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 : est d\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916842601399754)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 : est activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916505837399754)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('non identifi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909687778399749)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866144432399717)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'fr'
,p_message_text=>unistr('Filtre appliqu\00E9 : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907263274399747)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'fr'
,p_message_text=>'Appliquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792193117399664)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 barres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919995756399756)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'fr'
,p_message_text=>'Autres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792288653399664)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 secteurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918639202399755)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791999644399663)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907782536399747)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'fr'
,p_message_text=>'Effacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907875171399747)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'fr'
,p_message_text=>'Effacer tout'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907973332399747)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Effacer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925110175399760)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne %1, r\00E9f\00E9renc\00E9e par le facet %0, n''est pas disponible ou n''est pas autoris\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782334427399656)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisir les filtres \00E0 afficher')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864321483399716)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 r\00E9sultats')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864427515399716)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867041661399718)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'fr'
,p_message_text=>'Filtres en cours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783871598399657)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste des filtres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923658839399759)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Limite de valeur distincte (%0) d\00E9pass\00E9e pour le facet %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909201167399748)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Le facet %0 n''est pas pris en charge pour les colonnes de type DATE ou TIMESTAMP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907331666399747)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907437612399747)
,p_name=>'APEX.FS.GO'
,p_message_language=>'fr'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908870330399748)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('est \00E9gal \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792930246399664)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'fr'
,p_message_text=>'contient %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792619545399664)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'fr'
,p_message_text=>unistr('sup\00E9rieur \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792796420399664)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'fr'
,p_message_text=>unistr('sup\00E9rieur ou \00E9gal \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792456627399664)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'fr'
,p_message_text=>unistr('inf\00E9rieur \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792502998399664)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'fr'
,p_message_text=>unistr('inf\00E9rieur ou \00E9gal \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792868862399664)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'fr'
,p_message_text=>'commence par %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795358882399666)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de donn\00E9es %0 (%1) n''est pas pris en charge pour le facet de champ de saisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785523722399659)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'fr'
,p_message_text=>unistr('Les facets \00E0 plusieurs valeurs requi\00E8rent des bases de donn\00E9es version 12.2 ou sup\00E9rieure.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909085296399748)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne de recherche n''a \00E9t\00E9 fournie pour le facet %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782479675399657)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'fr'
,p_message_text=>'Plus de filtres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864580606399716)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but de la plage')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908520475399748)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908619542399748)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'fr'
,p_message_text=>'Au-dessus de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908752170399748)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'fr'
,p_message_text=>'En dessous de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864627469399716)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'fr'
,p_message_text=>'Fin de la plage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927445224399761)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment de liste de valeurs (LOV) #%2 ("%1") du facet de plage %0 n''est pas valide (s\00E9parateur "|" manquant).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908961009399748)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''entr\00E9e manuelle n''est actuellement pas prise en charge pour le facet de plage %0, car la colonne est de type DATE ou TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908275049399748)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792056634399663)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'fr'
,p_message_text=>'Enlever le graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861105016399714)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907638879399747)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907546040399747)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'fr'
,p_message_text=>'Rechercher...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908474061399748)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791863899399663)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'fr'
,p_message_text=>'Afficher le graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908049709399747)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'fr'
,p_message_text=>'Afficher moins'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908140452399748)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'fr'
,p_message_text=>'Afficher plus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111908338857399748)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 \00E9toiles et plus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866083978399717)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'fr'
,p_message_text=>'Suggestions de filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909173691399748)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Le facet de champ de texte %0 n''est actuellement pris en charge que pour les colonnes de type NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782234295399656)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Nombre total de lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925216432399760)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de donn\00E9es %0 (%1) n''est pas pris en charge pour la recherche \00E0 facets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917109642399754)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E9der \00E0 l''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874707903399724)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9ger.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882382195399729)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire la commande BREAK')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874836704399724)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>'Commande BREAK.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882278451399729)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper la commande BREAK')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960916420399786)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>'Colonne %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882056603399729)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 lignes supprim\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952404763399780)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Dupliquer l''identit\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871705970399721)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Premier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875010762399724)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de groupe.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874940633399724)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871862627399721)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Dernier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891865819399736)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'fr'
,p_message_text=>'Charger plus de lignes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871557560399721)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875141487399724)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'fr'
,p_message_text=>'Lignes de page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871910605399721)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'fr'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872066561399722)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'fr'
,p_message_text=>'%0 - %1 sur %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928032899399762)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection de page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871670449399721)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952201489399780)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajout\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952373230399780)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifi\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960745359399786)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>'Ligne %0, colonne %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960803078399786)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>'Ligne %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952176559399780)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprim\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875364246399724)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte de ligne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870906488399721)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 cellules s\00E9lectionn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872170899399722)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 lignes s\00E9lectionn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912490012399751)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner tout')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882163735399729)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'fr'
,p_message_text=>'Page %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875273805399724)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une ligne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875461253399724)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'fr'
,p_message_text=>unistr('Tri\00E9 par ordre croissant %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875540490399724)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'fr'
,p_message_text=>unistr('Tri\00E9 par ordre d\00E9croissant %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871089770399721)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'fr'
,p_message_text=>'Trier par ordre croissant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871385284399721)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'fr'
,p_message_text=>'Trier par ordre croissant %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871192214399721)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'fr'
,p_message_text=>unistr('Trier par ordre d\00E9croissant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871496744399721)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'fr'
,p_message_text=>unistr('Trier par ordre d\00E9croissant %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111871238299399721)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'fr'
,p_message_text=>'Ne pas trier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881977012399729)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'fr'
,p_message_text=>'Total %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808317266399675)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la demande HTTP \00E0 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949680183399778)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 colonnes et %1 lignes de la liste de s\00E9lection de grille. Utiliser les touches fl\00E9ch\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881860233399729)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 lignes de la liste de s\00E9lection. Utiliser les touches fl\00E9ch\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960570506399786)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Grille interactive %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868633049399719)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869621742399720)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869547047399720)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954092508399781)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9ger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939534248399770)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9gation')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941246142399771)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'fr'
,p_message_text=>'Tout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897631526399740)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Toutes les colonnes de texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898872747399741)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'fr'
,p_message_text=>'Remplacement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899982562399742)
,p_name=>'APEX.IG.AND'
,p_message_language=>'fr'
,p_message_text=>'et'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919301688399756)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'fr'
,p_message_text=>'Nombre approximatif de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955015401399782)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'fr'
,p_message_text=>'Nombre approximatif global de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938157140399769)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'fr'
,p_message_text=>'Graphique en aires'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940021715399771)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'fr'
,p_message_text=>'Croissant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898971080399741)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'fr'
,p_message_text=>'Autorisation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954141044399781)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'fr'
,p_message_text=>'Automatique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919716377399756)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'fr'
,p_message_text=>'Moyenne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954711653399781)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'fr'
,p_message_text=>'Moyenne globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937652738399769)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre d''axe de libell\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937869654399769)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9cimales')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937728423399769)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre d''axe de valeur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943831235399773)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur d''arri\00E8re-plan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938224668399769)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 barres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894238448399738)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'fr'
,p_message_text=>'entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945078016399774)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'fr'
,p_message_text=>'Les deux'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938358228399769)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 bulles')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869836364399720)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899843151399742)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'fr'
,p_message_text=>'Respect des majuscules/minuscules'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955647318399782)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'fr'
,p_message_text=>'(Respect des majuscules/minuscules)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926585487399761)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifications enregistr\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870241381399720)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Modifier la vue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900924937399742)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897466751399740)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre requ\00EAte d\00E9passe la valeur maximale de %0 points de donn\00E9es par graphique. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements dans votre requ\00EAte de base.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868522940399719)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875808223399724)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'fr'
,p_message_text=>'Effacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937182925399768)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944039488399773)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'fr'
,p_message_text=>'Couleurs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920122567399756)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Aper\00E7u')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899266021399741)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868723225399719)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945843898399775)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Objectif de la colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899355339399741)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'fr'
,p_message_text=>'Complexe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868919944399719)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'fr'
,p_message_text=>'Calculer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894812969399738)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'fr'
,p_message_text=>'contient'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901155632399743)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'fr'
,p_message_text=>'Commande BREAK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875640677399724)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'fr'
,p_message_text=>'Copier dans le presse-papiers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875787005399724)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'fr'
,p_message_text=>'Copier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919187649399755)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919225756399755)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954968812399782)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'fr'
,p_message_text=>'Nombre global de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954810588399781)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'fr'
,p_message_text=>'Nombre global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952534338399780)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897881150399740)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945611739399775)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945253882399774)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'fr'
,p_message_text=>'Date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926328124399761)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur de date non valide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895534737399739)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'fr'
,p_message_text=>'jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898589994399741)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898355755399741)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869762703399720)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946833130399776)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Voulez-vous supprimer cet \00E9tat ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902990661399744)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'fr'
,p_message_text=>'Supprimer une ligne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901709694399743)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Supprimer des lignes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940132457399771)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9croissant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900605022399742)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9tail')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868297975399719)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue d\00E9tail')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928875095399762)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'fr'
,p_message_text=>'Direction'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900319131399742)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894930485399738)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'fr'
,p_message_text=>'ne contient pas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895179151399738)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'fr'
,p_message_text=>'ne commence pas par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938471441399769)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'fr'
,p_message_text=>'Graphique en anneau'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901344256399743)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800038601399669)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es uniquement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947866974399776)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Choisir un format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812639627399678)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le format de t\00E9l\00E9chargement %0 n''est pas activ\00E9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940823834399771)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Dupliquer l''agr\00E9gation')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940931550399771)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'fr'
,p_message_text=>'Dupliquer la commande BREAK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902805572399744)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ligne en double'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901646101399743)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Lignes en double'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869367615399720)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939918629399770)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'fr'
,p_message_text=>'Modifier un graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951438222399779)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'fr'
,p_message_text=>'Modifier le groupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947409114399776)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'fr'
,p_message_text=>'Copie conforme invisible (Cci)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947670301399776)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'fr'
,p_message_text=>'Message'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947301572399776)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'fr'
,p_message_text=>'Copie (Cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947047454399776)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'fr'
,p_message_text=>unistr('Courriel envoy\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947510726399776)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'fr'
,p_message_text=>'Objet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947244928399776)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'fr'
,p_message_text=>'Destinataire (A)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900087685399742)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893233286399737)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'fr'
,p_message_text=>unistr('est \00E9gal \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946439721399775)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'fr'
,p_message_text=>'Exemple'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900136795399742)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946390625399775)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912378675399751)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'fr'
,p_message_text=>unistr('Fichier pr\00E9par\00E9. D\00E9marrage du t\00E9l\00E9chargement.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111875968969399724)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'fr'
,p_message_text=>'Remplir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877002148399725)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Remplir la s\00E9lection avec')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876966776399725)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Remplir la s\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868876951399719)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899459370399741)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Filtres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954480337399781)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'fr'
,p_message_text=>'Filtrer...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940311975399771)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'fr'
,p_message_text=>'Premier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869046347399719)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'fr'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897920936399740)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944936793399774)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'fr'
,p_message_text=>'Masque de format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946780875399776)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'fr'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946663676399775)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'fr'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859478856399712)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'fr'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798740032399668)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'fr'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902575805399744)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'fr'
,p_message_text=>'Figer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900219442399742)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctions et op\00E9rateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938534091399769)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'fr'
,p_message_text=>'Graphique en entonnoir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919084346399755)
,p_name=>'APEX.IG.GO'
,p_message_language=>'fr'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893851998399737)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'fr'
,p_message_text=>unistr('est sup\00E9rieur \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893946937399737)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'fr'
,p_message_text=>unistr('est sup\00E9rieur ou \00E9gal \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900507057399742)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'fr'
,p_message_text=>'Grille'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868033833399719)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Grille'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941129946399771)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'fr'
,p_message_text=>'Groupe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900789776399742)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'fr'
,p_message_text=>'Regrouper par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868348098399719)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue Grouper par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945500328399775)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de condition'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944456791399774)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('En-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944657458399774)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'fr'
,p_message_text=>unistr('Alignement d''en-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954350012399781)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949873104399778)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez ins\00E9rer, mettre \00E0 jour et supprimer des donn\00E9es directement dans cette grille interactive.</p>'),
'',
unistr('<p>Ins\00E9rez une nouvelle ligne en cliquant sur le bouton Ajouter une ligne.</p>'),
'',
unistr('<p>Modifiez des donn\00E9es existantes en double-cliquant sur une cellule sp\00E9cifique. Pour effectuer des modifications plus importantes, cliquez sur Modifier pour entrer en mode \00E9dition. Dans ce mode, vous pouvez effectuer un seul clic ou utiliser le cla')
||unistr('vier pour modifier des cellules sp\00E9cifiques.</p>'),
'',
unistr('<p>Utilisez le menu Modifier pour dupliquer et supprimer des lignes. Pour activer le menu Modifier, utilisez les cases \00E0 cocher pour s\00E9lectionner des lignes.</p>'),
'',
unistr('<p>Dupliquez une ligne s\00E9lectionn\00E9e en cliquant sur le menu Modifier et en s\00E9lectionnant Lignes en double. Supprimez une ligne s\00E9lectionn\00E9e en cliquant sur le menu Modifier et en s\00E9lectionnant Supprimer une ligne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951966332399779)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s de modification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952020466399779)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Une grille interactive pr\00E9sente un ensemble de donn\00E9es dans un \00E9tat pouvant faire l''objet d''une recherche et d''une personnalisation. Vous pouvez effectuer de nombreuses op\00E9rations pour limiter les enregistrements renvoy\00E9s et modifier la fa\00E7on dont')
||unistr(' les donn\00E9es sont affich\00E9es.</p>'),
'',
unistr('<p>Utilisez le champ de recherche pour filtrer les enregistrements renvoy\00E9s. Cliquez sur Actions pour acc\00E9der aux nombreuses options de modification de la mise en page de l''\00E9tat, ou utilisez les menus d''en-t\00EAte de colonne sur les colonnes affich\00E9es.<')
||'/p>',
'',
unistr('<p>Utilisez les param\00E8tres d''\00E9tat pour enregistrer les personnalisations d''un \00E9tat. Vous pouvez \00E9galement t\00E9l\00E9charger les donn\00E9es de l''\00E9tat vers un fichier externe, ou les envoyer par courriel \00E0 vous-m\00EAme ou \00E0 d''autres utilisateurs.</p>'),
'',
unistr('<p>Pour en savoir plus, reportez-vous \00E0 "Using Interactive Grids" dans le manuel <em>Oracle Application Express End User''s Guide</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951727112399779)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Aper\00E7u')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949736915399778)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez personnaliser la grille interactive de sorte qu''elle affiche les donn\00E9es de diverses fa\00E7ons \00E0 l''aide de capacit\00E9s int\00E9gr\00E9es.</p>'),
'',
unistr('<p>Utilisez les menus d''en-t\00EAte de colonne ou le menu Actions pour d\00E9terminer les colonnes \00E0 afficher, dans quel ordre, et pour figer les colonnes. Vous pouvez \00E9galement d\00E9finir divers filtres de donn\00E9es et trier les donn\00E9es renvoy\00E9es.</p>'),
'',
unistr('<p>Utilisez le bouton Vue (adjacent au champ de recherche) pour acc\00E9der \00E0 d''autres vues de donn\00E9es qui peuvent avoir \00E9t\00E9 d\00E9finies par le d\00E9veloppeur d''application. Vous pouvez \00E9galement cr\00E9er un graphique ou visualiser un graphique existant.</p>  '),
'',
unistr('<p><em>Remarque : cliquez sur <strong>Aide</strong> dans les bo\00EEtes de dialogue de la grille interactive pour obtenir des informations plus d\00E9taill\00E9es sur la fonction s\00E9lectionn\00E9e.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951822841399779)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctionnalit\00E9s de g\00E9n\00E9ration d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901549057399743)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide de la grille interactive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948639961399777)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour agr\00E9ger des colonnes. Les valeurs agr\00E9g\00E9es s''affichent en bas des donn\00E9es ou, si des commandes BREAK sont d\00E9finies, en bas de chaque commande.</p>'),
'',
unistr('<p><strong>Liste Agr\00E9gation</strong><br>'),
unistr('La liste Agr\00E9gation affiche les agr\00E9gations d\00E9finies. D\00E9sactivez une agr\00E9gation existante en la d\00E9s\00E9lectionnant.<br>'),
unistr('Cliquez sur Ajouter ( &plus; ) pour cr\00E9er une agr\00E9gation ou sur Supprimer ( &minus; ) pour enlever une agr\00E9gation existante.</p>'),
'',
unistr('<p><strong>Param\00E8tres d''agr\00E9gation</strong><br>'),
unistr('Utilisez le panneau \00E0 droite pour d\00E9finir l''agr\00E9gation.<br>'),
unistr('S\00E9lectionnez le nom de colonne et le type d''agr\00E9gation.<br>'),
unistr('Saisissez \00E9ventuellement une info-bulle pour l''agr\00E9gation.<br>'),
unistr('Si vous avez d\00E9fini une commande BREAK, la s\00E9lection de l''option <strong>Afficher la valeur globale</strong> affiche la moyenne globale, le total ou une valeur similaire en bas des donn\00E9es.</p>'),
'',
unistr('<p><em>Remarque : acc\00E9dez \00E0 la bo\00EEte de dialogue Agr\00E9gation dans le menu Actions ou en cliquant sur l''en-t\00EAte de colonne et la somme ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950837151399779)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aide sur l''agr\00E9gation')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949352800399777)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir un graphique qui s''affiche sous forme d''une vue de donn\00E9es distincte.<br>'),
unistr('S\00E9lectionnez un type et des attributs de graphique.</p>'),
'<p><strong>Attributs de graphique</strong></br>',
'Les attributs de graphique disponibles varient selon le type de graphique.</p>',
'<p>',
'<ul>',
unistr('  <li>S\00E9lectionnez la colonne contenant la valeur pour l''attribut :'),
'    <ul>',
unistr('      <li>Libell\00E9 : texte pour chaque point de donn\00E9es.</li>'),
unistr('      <li>Valeur : donn\00E9es \00E0 tracer.</li>'),
unistr('      <li>S\00E9rie : pour d\00E9finir votre requ\00EAte dynamique \00E0 plusieurs s\00E9ries.</li>'),
unistr('      <li>Ouverture : prix d''ouverture boursi\00E8re quotidien (graphique boursier uniquement).</li>'),
unistr('      <li>Cl\00F4ture : prix de cl\00F4ture boursi\00E8re quotidien (graphique boursier uniquement).</li>'),
unistr('      <li>Elev\00E9 : valeur \00E9lev\00E9e (graphiques \00E0 plages et boursiers uniquement).</li>'),
unistr('      <li>Faible : valeur basse (graphiques \00E0 plages et boursiers uniquement).</li>'),
'      <li>Volume : volume boursier quotidien (graphique boursier uniquement).</li>',
'      <li>Cible : valeur cible (graphique en entonnoir uniquement).</li>',
unistr('      <li>X : valeur de l''axe des X (graphiques \00E0 bulles et en nuage de points uniquement).</li>'),
unistr('      <li>Y : valeur de l''axe des Y (graphiques \00E0 bulles et en nuage de points uniquement).</li>'),
unistr('      <li>Z : largeur des barres ou rayon des bulles (graphiques \00E0 barres, \00E0 bulles et \00E0 plages uniquement).</li>'),
'    </ul>',
'  </li>',
'  <li>Orientation : verticale ou horizontale.</li>',
unistr('  <li>Agr\00E9gation : s\00E9lectionnez le mode d''agr\00E9gation des valeurs de graphique associ\00E9es.</li>'),
unistr('  <li>Pile : indiquez si les \00E9l\00E9ments de donn\00E9es sont empil\00E9s.</li>'),
unistr('  <li>Trier par : d\00E9terminez si le graphique est tri\00E9 par libell\00E9 ou valeur.'),
'    <ul>',
unistr('      <li>Direction : triez les valeurs par ordre croissant ou d\00E9croissant.</li>'),
unistr('      <li>Valeurs NULL : indiquez la fa\00E7on dont vous voulez que les enregistrements avec des valeurs NULL soient tri\00E9s par rapport aux enregistrements avec des valeurs non NULL.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>D\00E9cimales</li>'),
unistr('  <li>Titre de l''axe de libell\00E9</li>'),
'  <li>Titre de l''axe de valeur</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951253604399779)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur le graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948371338399777)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour choisir les colonnes \00E0 afficher et leur ordre d''affichage.</p>'),
'',
unistr('<p>Masquez une colonne en la d\00E9s\00E9lectionnant.<br>'),
unistr('R\00E9organisez les colonnes en cliquant sur D\00E9placer vers le haut ( &uarr; ) ou D\00E9placer vers le bas ( &darr; ).<br>'),
unistr('Utilisez le s\00E9lecteur d\00E9roulant pour r\00E9pertorier toutes les colonnes, les colonnes affich\00E9es ou les colonnes non affich\00E9es.</p>'),
'',
unistr('<p>Utilisez \00E9ventuellement le panneau pour indiquer la largeur minimale d''une colonne en pixels.</p>'),
'',
unistr('<p><em>Remarque : vous pouvez \00E9galement r\00E9organiser les colonnes affich\00E9es en cliquant sur la poign\00E9e de glissement (au d\00E9but de l''en-t\00EAte de colonne) et en d\00E9pla\00E7ant la colonne \00E0 gauche ou \00E0 droite. Vous pouvez \00E9galement modifier la largeur des colo')
||unistr('nnes affich\00E9es en s\00E9lectionnant le s\00E9parateur de colonnes, entre les en-t\00EAtes, et en le d\00E9pla\00E7ant vers la gauche ou la droite.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951199892399779)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur les colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948780558399777)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir des colonnes suppl\00E9mentaires en fonction des calculs math\00E9matiques et fonctionnels r\00E9alis\00E9s par rapport aux colonnes existantes.</p>'),
'',
'<p><strong>Liste Calcul</strong><br>',
unistr('La liste Calcul affiche les calculs d\00E9finis. D\00E9sactivez un calcul existant en le d\00E9s\00E9lectionnant.<br>'),
'Cliquez sur Ajouter ( &plus; ) pour ajouter un nouveau calcul ou sur Supprimer ( &minus; ) pour enlever un calcul existant.</p>',
'',
unistr('<p><strong>Param\00E8tres de calcul</strong><br>'),
unistr('Utilisez le panneau pour d\00E9finir le calcul.<br>'),
unistr('Entrez les d\00E9tails de colonne, tels qu''un en-t\00EAte ou un libell\00E9, et s\00E9lectionnez des param\00E8tres d''alignement.<br> '),
unistr('Utilisez la zone de texte Expression pour entrer les colonnes et les fonctions associ\00E9es pour le calcul.<br>'),
unistr('S\00E9lectionnez le type de donn\00E9es ad\00E9quat et \00E9ventuellement un masque de format pour la nouvelle colonne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950754414399778)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur le calcul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949038887399777)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir une commande BREAK sur des colonnes.</p>'),
'',
'<p><strong>Liste Commande BREAK</strong><br>',
unistr('La liste Commande BREAK affiche les commandes BREAK d\00E9finies. D\00E9sactivez une colonne de commande BREAK existante en la d\00E9s\00E9lectionnant.<br>'),
'Cliquez sur Ajouter ( &plus; ) pour inclure une nouvelle colonne dans la commande BREAK ou sur Supprimer ( &minus; ) pour enlever une colonne existante de la commande BREAK.<br>',
unistr('Pour r\00E9organiser les colonnes, cliquez sur D\00E9placer vers le haut ( &uarr; ) ou D\00E9placer vers le bas ( &darr; ) pour d\00E9placer la colonne s\00E9lectionn\00E9e vers le haut et vers le bas par rapport aux autres colonnes.</p>'),
'',
unistr('<p><strong>Param\00E8tres de commande BREAK</strong><br>'),
unistr('Utilisez le panneau pour d\00E9finir la colonne de commande BREAK.<br>'),
unistr('S\00E9lectionnez une colonne de commande BREAK, le sens de tri et le mode d''organisation des colonnes NULL (colonnes sans valeur).</p>'),
'',
unistr('<p><em>Remarque : lorsque vous affichez la grille interactive, vous pouvez d\00E9finir une commande BREAK en cliquant sur un en-t\00EAte de colonne et en s\00E9lectionnant l''ic\00F4ne de commande BREAK.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950449856399778)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur les commandes BREAK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949218004399777)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour t\00E9l\00E9charger toutes les lignes en cours vers un fichier externe. Le fichier comportera uniquement les colonnes actuellement affich\00E9es, utilisant tous les filtres et les tris appliqu\00E9s aux donn\00E9es.</p>'),
'',
unistr('<p>S\00E9lectionnez le format de fichier et cliquez sur T\00E9l\00E9charger.<br>'),
unistr('Remarque : le format CSV n''inclura pas le formatage de texte tel que les agr\00E9gats et les commandes BREAK.</p>'),
'',
unistr('<p>Pour envoyer le fichier par courriel, s\00E9lectionnez Envoyer en tant que courriel et entrez les d\00E9tails de courriel (Destinataire, Objet et Message).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950285233399778)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aide sur le t\00E9l\00E9chargement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948426400399777)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour configurer des filtres de donn\00E9es qui limitent le nombre de lignes renvoy\00E9es.</p>'),
'',
'<p><strong>Liste Filtre</strong><br>',
unistr('La liste Filtre affiche les filtres d\00E9finis. Pour d\00E9sactiver un filtre existant, d\00E9s\00E9lectionnez-le.<br>'),
unistr('Cliquez sur Ajouter (&plus;) pour cr\00E9er un filtre ou sur Supprimer (&minus;) pour enlever un filtre existant.</p>'),
'',
unistr('<p><strong>Param\00E8tres de filtre</strong><br>'),
unistr('Utilisez le panneau pour d\00E9finir les propri\00E9t\00E9s de filtre.<br>'),
unistr('S\00E9lectionnez le type de filtre ad\00E9quat :<br>'),
'&nbsp;&nbsp;&nbsp;Ligne : filtrer sur un terme dans toute colonne filtrable.<br>',
unistr('&nbsp;&nbsp;&nbsp;Colonne : filtrer sur une colonne sp\00E9cifique avec un op\00E9rateur et une valeur indiqu\00E9s.</p>'),
'',
unistr('<p><em>Remarque : lorsque vous affichez une grille interactive, vous pouvez d\00E9finir des filtres de ligne en les saisissant directement dans le champ de recherche. Cliquez sur S\00E9lectionner les colonnes \00E0 rechercher pour limiter la recherche \00E0 une cert')
||unistr('aine colonne. Vous pouvez \00E9galement ouvrir un menu En-t\00EAte de colonne et s\00E9lectionner une valeur pour cr\00E9er un filtre de colonne.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951036858399779)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur le filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948866529399777)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour visualiser les donn\00E9es telles qu''elles existaient \00E0 un moment donn\00E9.</p>'),
unistr('<p>Entrez le nombre de minutes pass\00E9es pour ex\00E9cuter la requ\00EAte Flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950682599399778)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951348548399779)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur le regroupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948912227399777)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour mettre en \00E9vidence des lignes ou des colonnes de donn\00E9es en fonction de la condition entr\00E9e.</p>'),
'',
unistr('<p><strong>Liste Mise en \00E9vidence</strong><br>'),
unistr('La liste Mise en \00E9vidence affiche les mises en \00E9vidence d\00E9finies. Pour d\00E9sactiver une mise en \00E9vidence existante, d\00E9s\00E9lectionnez-la.<br>'),
unistr('Cliquez sur Ajouter (&plus;) pour cr\00E9er une mise en \00E9vidence ou sur Supprimer (&minus;) pour enlever une mise en \00E9vidence existante.</p>'),
'',
unistr('<p><strong>Param\00E8tres de mise en \00E9vidence</strong><br>'),
unistr('Utilisez le panneau pour d\00E9finir les propri\00E9t\00E9s de mise en \00E9vidence.<br>'),
unistr('Entrez le nom, s\00E9lectionnez Ligne ou Colonne, puis s\00E9lectionnez les codes couleur HTML pour le texte et l''arri\00E8re-plan.<br>'),
unistr('S\00E9lectionnez le <strong>type de condition</strong> ad\00E9quat pour mettre en \00E9vidence des donn\00E9es sp\00E9cifiques :<br>'),
unistr('&nbsp;&nbsp;&nbsp;Ligne : mise en \00E9vidence du terme dans toute colonne.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Colonne : mise en \00E9vidence dans une colonne sp\00E9cifique selon l''op\00E9rateur et la valeur sp\00E9cifi\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950589635399778)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aide sur la mise en \00E9vidence')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949138555399777)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour enregistrer les modifications que vous avez apport\00E9es \00E0 la configuration et \00E0 la mise en page de la grille en cours.<br>'),
unistr('Les d\00E9veloppeurs d''application peuvent d\00E9finir plusieurs mises en page d''\00E9tat de remplacement. Lorsque cela est autoris\00E9, vous et d''autres utilisateurs finals pouvez enregistrer un \00E9tat comme Public, le mettant ainsi \00E0 la disposition de tous les autr')
||unistr('es utilisateurs de la grille. Vous pouvez \00E9galement enregistrer un \00E9tat comme Priv\00E9 ; vous seul pouvez alors le consulter.</p>'),
unistr('<p>Effectuez une s\00E9lection parmi les types disponibles et entrez le nom de l''\00E9tat enregistr\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950310002399778)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aide sur l''\00E9tat'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948592665399777)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir l''ordre d''affichage.</p>'),
'',
'<p><strong>Liste Trier</strong><br>',
unistr('La bo\00EEte de dialogue Trier affiche la liste des r\00E8gles de tri configur\00E9es.<br>'),
unistr('Cliquez sur Ajouter ( &plus; ) pour cr\00E9er une colonne de tri ou sur Supprimer ( &minus; ) pour enlever une colonne de tri.<br>'),
unistr('Cliquez sur D\00E9placer vers le haut ( &uarr; ) et D\00E9placer vers le bas ( &darr; ) pour d\00E9placer la colonne de tri s\00E9lectionn\00E9e vers le haut et vers le bas par rapport aux autres colonnes de tri.</p>'),
'',
unistr('<p><strong>Param\00E8tres de tri</strong><br>'),
unistr('S\00E9lectionnez une colonne de tri, le sens du tri et le mode d''organisation des colonnes NULL (colonnes sans valeur).</p>'),
'',
unistr('<p><em>Remarque : les donn\00E9es peuvent \00EAtre tri\00E9es par des colonnes qui ne sont pas affich\00E9es. Cependant, les colonnes ne sont peut-\00EAtre pas toutes triables.</em><br>'),
unistr('<em>Les colonnes affich\00E9es peuvent \00EAtre tri\00E9es en appuyant sur les fl\00E8ches vers le haut (par ordre croissant) ou vers le bas (par ordre d\00E9croissant) \00E0 la fin des en-t\00EAtes de colonne. Pour ajouter une autre colonne \00E0 un tri existant, maintenez la touc')
||unistr('he Maj enfonc\00E9e et cliquez sur la fl\00E8che vers le haut ou vers le bas.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950990088399779)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur le tri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111950193242399778)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Aide sur l''abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902429114399743)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'fr'
,p_message_text=>'Masquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869251210399720)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937238804399769)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Elev\00E9')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938024467399769)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'fr'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895482629399738)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'fr'
,p_message_text=>'heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900480260399742)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868199180399719)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue ic\00F4ne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893614077399737)
,p_name=>'APEX.IG.IN'
,p_message_language=>'fr'
,p_message_text=>'est dans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902017757399743)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre inactif')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902113960399743)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres inactifs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909793932399749)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Une erreur interne est survenue lors du traitement de la demande de grille interactive.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805582710399673)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Le type de filtre de colonne "%0" n''est pas pris en charge pour la colonne "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949926141399778)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format de date non valide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924167057399759)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('La grille interactive ne prend pas en charge la d\00E9finition d''un filtre sur la colonne %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924041395399759)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''est pas un type de filtre valide pour d\00E9finir un filtre Grille interactive.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810636202399677)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'fr'
,p_message_text=>unistr('Format num\00E9rique non valide')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952661325399780)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tre non valide')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952749915399780)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres non valides')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943785873399773)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Trier par a \00E9t\00E9 d\00E9fini sur %0, mais aucune colonne n''a \00E9t\00E9 s\00E9lectionn\00E9e pour %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941077671399771)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur non valide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936136857399768)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Non affich\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894450153399738)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'fr'
,p_message_text=>'au cours des'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894618645399738)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'fr'
,p_message_text=>'dans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893593825399737)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'n''est pas vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893498987399737)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'fr'
,p_message_text=>'est vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944553545399774)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936514983399768)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940499962399771)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'fr'
,p_message_text=>'Dernier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883719500399730)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'fr'
,p_message_text=>'Dernier jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883926772399730)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re heure')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884429649399730)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883416702399730)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'fr'
,p_message_text=>'Dernier mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883502530399730)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re semaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883601997399730)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'fr'
,p_message_text=>'Les %0 derniers jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883857731399730)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les %0 derni\00E8res heures')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884572927399730)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 derni\00E8res minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884306495399730)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'fr'
,p_message_text=>'%0 derniers mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884275571399730)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 derni\00E8res semaines')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883260527399730)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 derni\00E8res ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883374874399730)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re ann\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944729350399774)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'fr'
,p_message_text=>'Alignement des cellules'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944881696399774)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'fr'
,p_message_text=>'Utiliser le groupe pour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894039814399737)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'fr'
,p_message_text=>unistr('est inf\00E9rieur \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894126442399738)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'fr'
,p_message_text=>unistr('est inf\00E9rieur ou \00E9gal \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938610089399770)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 courbes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938763509399770)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'fr'
,p_message_text=>'A courbes avec aires'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945125059399774)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'fr'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937307282399769)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Faible'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947788798399776)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parez les adresses par des virgules')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895268946399738)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>unistr('recherche une expression r\00E9guli\00E8re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919683833399756)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'fr'
,p_message_text=>'Valeur maximale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955215879399782)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'fr'
,p_message_text=>'Maximum global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919805085399756)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9diane')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955369943399782)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9diane globale')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919587082399756)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'fr'
,p_message_text=>'Valeur minimale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895368465399738)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'fr'
,p_message_text=>'minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920355797399756)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'fr'
,p_message_text=>'Minutes auparavant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955105833399782)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'fr'
,p_message_text=>'Minimum global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895717928399739)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'fr'
,p_message_text=>'mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902331843399743)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es contiennent plus de %0 lignes, ce qui d\00E9passe le nombre maximal autoris\00E9. Appliquez des filtres suppl\00E9mentaires pour visualiser les r\00E9sultats.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929099319399763)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID statique de r\00E9gion doit \00EAtre indiqu\00E9, car la page contient plusieurs grilles interactives.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898470904399741)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898632777399741)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat nomm\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882641238399729)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'fr'
,p_message_text=>'Jour suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882434519399729)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'fr'
,p_message_text=>'Heure suivante'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884608712399731)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'fr'
,p_message_text=>'Prochaine minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882986862399729)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'fr'
,p_message_text=>'Mois suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882828168399729)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'fr'
,p_message_text=>'Semaine suivante'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882735785399729)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 prochains jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111882557276399729)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'fr'
,p_message_text=>'%0 prochaines heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884735534399731)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'fr'
,p_message_text=>'%0 prochaines minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884085604399730)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'fr'
,p_message_text=>'%0 prochains mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884157654399730)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'fr'
,p_message_text=>'%0 prochaines semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883102491399730)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 prochaines ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111883072832399729)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9e suivante')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894303221399738)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'fr'
,p_message_text=>'non compris entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893357834399737)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'fr'
,p_message_text=>unistr('est diff\00E9rent de')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959597577399785)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion portant l''ID %0 n''est pas une r\00E9gion de grille interactive ou n''existe pas dans l''application %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893783386399737)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'fr'
,p_message_text=>'n''est pas dans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894583901399738)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'fr'
,p_message_text=>'pas au cours des'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111894760754399738)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'fr'
,p_message_text=>'pas dans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902208213399743)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940274276399771)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'fr'
,p_message_text=>'Valeurs NULL'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945310969399775)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9rique')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940509142399771)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940687043399771)
,p_name=>'APEX.IG.ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892579575399736)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a 1 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948241813399777)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ouvrir le s\00E9lecteur de couleur : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937037973399768)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Ouvrir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899564675399741)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9rateur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936490882399768)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'fr'
,p_message_text=>'Orientation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938840828399770)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 secteurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111900864323399742)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'fr'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111868414824399719)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue de pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111948139043399777)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9parer les valeurs par "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111938940308399770)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'fr'
,p_message_text=>'Graphique polaire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944293986399774)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'fr'
,p_message_text=>'Au centre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944320406399774)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'fr'
,p_message_text=>'Fin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111944152816399774)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9marrer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898763587399741)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'fr'
,p_message_text=>'Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899070922399741)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Val. par d\00E9faut du principal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915554155399753)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797701936399667)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclure des balises d''accessibilit\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796426571399667)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'fr'
,p_message_text=>'Paysage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796586772399667)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'fr'
,p_message_text=>'Portrait'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796344973399666)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Orientation de page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796296700399666)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'fr'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796182692399666)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'fr'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797808991399668)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Personnalis\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795947559399666)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'fr'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795876928399666)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'fr'
,p_message_text=>'Lettre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796083935399666)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'fr'
,p_message_text=>unistr('Tablo\00EFd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795787270399666)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Taille de page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785961313399659)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'fr'
,p_message_text=>'Enlever le texte enrichi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939061997399770)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'fr'
,p_message_text=>'Graphique en radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939130372399770)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 plages')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949486402399778)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903027580399744)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer la ligne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901855590399743)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer les lignes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907027285399747)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion de grille interactive n''existe pas dans l''application %0, la page %1 et la r\00E9gion %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869918378399720)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'fr'
,p_message_text=>'Enlever %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898150211399740)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958746758399784)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat supprim\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958498359399784)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat de remplacement enregistr\00E9 pour tous les utilisateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958312325399784)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat par d\00E9faut enregistr\00E9 pour tous les utilisateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958691771399784)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat priv\00E9 enregistr\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958557184399784)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat public enregistr\00E9 pour tous les utilisateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111907105463399747)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La grille interactive enregistr\00E9e avec le nom %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892475356399736)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es d''\00E9tat datant d''il y a %0 minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892397054399736)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es d''\00E9tat datant d''il y a 1 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832051735399693)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9tat de grille interactive n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951644316399779)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Etat - Modifier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906973546399747)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La grille interactive enregistr\00E9e avec l''ID %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111951592265399779)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'fr'
,p_message_text=>'Etat - Enregistrer sous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870044591399720)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''\00E9tat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959627410399785)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La grille interactive enregistr\00E9e avec l''ID statique %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954560238399781)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue d''\00E9tat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869186223399720)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903120972399744)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9tablir les modifications')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901953703399743)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9tablir les lignes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899198740399741)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898029895399740)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Lignes par page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959201716399785)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions de ligne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960473694399786)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'fr'
,p_message_text=>'Actions pour la ligne %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111869492118399720)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912166499399750)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'fr'
,p_message_text=>unistr('enregistr\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867618687399718)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Etats enregistr\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867724458399718)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842223035399700)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Un \00E9tat enregistr\00E9 nomm\00E9 %0 existe d\00E9j\00E0. Entrez un nouveau nom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867826471399719)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Priv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867952835399719)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'fr'
,p_message_text=>'Public'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954220003399781)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer sous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901252192399743)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer les param\00E8tres d''\00E9tat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939256828399770)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'fr'
,p_message_text=>'Graphique en nuage de points'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867580555399718)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946582417399775)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Rechercher : Toutes les colonnes de texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867477002399718)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Rechercher : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945791546399775)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Rechercher : Texte int\00E9gral')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892251843399736)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'fr'
,p_message_text=>'Rechercher ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935836010399768)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner -')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876041271399725)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928718904399762)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner 1 ligne dans la r\00E9gion ma\00EEtre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867352326399718)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner les colonnes \00E0 rechercher')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958982229399785)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Actions de s\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876279891399725)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection de cellule')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876154150399725)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lection de ligne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947145340399776)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Envoyer en tant que courriel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939615213399770)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9rie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865377907399717)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917916347399755)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Afficher la valeur globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902737618399744)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue monoligne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901052183399742)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'fr'
,p_message_text=>'Trier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939709822399770)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'fr'
,p_message_text=>'Trier par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959370015399785)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez d\00E9finir qu''un seul tri par colonne.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959145089399785)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'fr'
,p_message_text=>'Modifier le menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111940750115399771)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'fr'
,p_message_text=>'Pile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895084818399738)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'fr'
,p_message_text=>'commence par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939392267399770)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'fr'
,p_message_text=>'Graphique boursier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860322465399713)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Etirer les largeurs de colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111901453711399743)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111919441415399756)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'fr'
,p_message_text=>'Somme'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960650909399786)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'fr'
,p_message_text=>'Grille interactive. Etat : %0, vue : %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111954640087399781)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'fr'
,p_message_text=>'Somme globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937537474399769)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Cible'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943998380399773)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'fr'
,p_message_text=>'Couleur du texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870111939399720)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer/d\00E9sactiver')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917870217399754)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'fr'
,p_message_text=>'Info-bulle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111898288873399740)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111902621856399744)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'fr'
,p_message_text=>unistr('Lib\00E9rer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899704689399742)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Unit\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946979688399776)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Certaines modifications n''ont pas \00E9t\00E9 enregistr\00E9es. Voulez-vous continuer ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111899619366399741)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936633831399768)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941514654399772)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Une valeur est requise.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926421657399761)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'fr'
,p_message_text=>'Valeur (impossible de modifier le fuseau horaire)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945488341399775)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'fr'
,p_message_text=>'Texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937968177399769)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'fr'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897786139399740)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'fr'
,p_message_text=>'Visualiser'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935948064399768)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Affich\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111937415151399769)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Volume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895606341399739)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'fr'
,p_message_text=>'semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936048587399768)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'fr'
,p_message_text=>'Largeur de colonne minimale (pixels)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886803952399732)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'fr'
,p_message_text=>'%0 compris entre %1 et %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886554497399732)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 contient %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886633042399732)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 ne contient pas %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864741410399716)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 ne commence pas par %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885373269399731)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 est \00E9gal \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885523941399731)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 est sup\00E9rieur \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885649163399731)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 sup\00E9rieur ou \00E9gal \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886347125399732)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 dans %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887525232399733)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours des %1 derniers jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887333422399732)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res heures')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887126739399732)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887920144399733)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours des %1 derniers mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887795529399733)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res semaines')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888152965399733)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887441037399733)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours du dernier jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887287462399732)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours de la derni\00E8re heure')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887025972399732)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours de la derni\00E8re minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887805261399733)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours du dernier mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111887682391399733)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours de la derni\00E8re semaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888040080399733)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 au cours de la derni\00E8re ann\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889918098399734)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours des %1 prochains jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889760904399734)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'fr'
,p_message_text=>'%0 dans les %1 prochaines heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889557737399734)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'fr'
,p_message_text=>'%0 dans les %1 prochaines minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890364264399735)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours des %1 prochains mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890176097399735)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours des %1 prochaines semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890543397399735)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 dans les %1 prochaines ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889824922399734)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours du prochain jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889655563399734)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'fr'
,p_message_text=>'%0 dans l''heure suivante'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889424529399734)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'fr'
,p_message_text=>'%0 dans la prochaine minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890294755399735)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours du prochain mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890044474399734)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'fr'
,p_message_text=>'%0 au cours de la prochaine semaine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890498848399735)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 dans l''ann\00E9e prochaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886085800399732)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'%0 n''est pas vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885945781399731)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'fr'
,p_message_text=>'%0 est vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885734009399731)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 inf\00E9rieur \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885888257399731)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 inf\00E9rieur ou \00E9gal \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886195776399732)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 comme %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886737926399732)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 recherche une expression r\00E9guli\00E8re %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892603490399736)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886912768399732)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'fr'
,p_message_text=>'%0 n''est pas compris entre %1 et %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885407647399731)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 est diff\00E9rent de %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886415862399732)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 n''est pas dans %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888722093399734)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 pas au cours des %1 derniers jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888542138399733)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res heures')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888336432399733)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889192467399734)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'fr'
,p_message_text=>'%0 pas au cours des %1 derniers mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888948025399734)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res semaines')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889389182399734)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888682272399733)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'fr'
,p_message_text=>'%0 pas au cours du dernier jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888477900399733)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours de la derni\00E8re heure')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888293336399733)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours de la derni\00E8re minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889057391399734)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'fr'
,p_message_text=>'%0 pas au cours du dernier mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111888882389399734)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours de la derni\00E8re semaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111889221102399734)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas au cours de la derni\00E8re ann\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891146298399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 pas au cours des %1 prochains jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890931411399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'fr'
,p_message_text=>'%0 pas dans les %1 prochaines heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890762832399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'fr'
,p_message_text=>'%0 pas dans les %1 prochaines minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891590446399736)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'fr'
,p_message_text=>'%0 pas dans les %1 prochains mois '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891356258399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'fr'
,p_message_text=>'%0 pas au cours des %1 prochaines semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891715776399736)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas dans les %1 prochaines ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891019359399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'fr'
,p_message_text=>'%0 pas le jour suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890822291399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'fr'
,p_message_text=>'%0 pas dans la prochaine heure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111890653663399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'fr'
,p_message_text=>'%0 pas dans la prochaine minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891422287399736)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'fr'
,p_message_text=>'%0 pas dans le prochain mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891229033399735)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'fr'
,p_message_text=>'%0 pas au cours de la semaine prochaine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891631394399736)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 pas l''ann\00E9e prochaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111886274089399732)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 n''est pas comme %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893156493399737)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'fr'
,p_message_text=>'%0 commence par %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936781706399768)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895813988399739)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936855576399768)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'O'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936921091399768)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111945954404399775)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'fr'
,p_message_text=>'Lundi 12 janvier 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946018614399775)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'fr'
,p_message_text=>'Janvier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946126346399775)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'fr'
,p_message_text=>'Il y a 16 heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111946298182399775)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'fr'
,p_message_text=>'dans 16 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801286870399670)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'fr'
,p_message_text=>'Type de fichier non valide. Types de fichier pris en charge : %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928145556399762)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'fr'
,p_message_text=>'Parcourir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927881304399762)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un fichier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927919037399762)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner des fichiers')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801053104399670)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Glisser-d\00E9placer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801410055399670)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('Glisser et d\00E9placer des fichiers')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802659305399671)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un fichier ou en d\00E9placer un ici.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802786110399671)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner des fichiers ou en d\00E9placer ici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802854596399671)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un fichier ou en d\00E9placer un ici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802961302399671)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner des fichiers ou en d\00E9placer ici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801345441399670)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'fr'
,p_message_text=>'%0 fichiers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801166739399670)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'fr'
,p_message_text=>'Le fichier est trop volumineux. La taille de fichier maximale est de %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788944609399661)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Adresse requise.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787827865399660)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'fr'
,p_message_text=>'Ville'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788269851399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'fr'
,p_message_text=>'Code pays'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787971293399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Num\00E9ro de b\00E2timent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788853504399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'fr'
,p_message_text=>'Latitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788711010399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'fr'
,p_message_text=>'Longitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788695980399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'fr'
,p_message_text=>'Affich. sur carte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788315963399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'fr'
,p_message_text=>'Score'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788028869399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'fr'
,p_message_text=>'Code postal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788196687399661)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'fr'
,p_message_text=>'Etat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787749733399660)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'fr'
,p_message_text=>'Rue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787676834399660)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats de g\00E9ocodage')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800267472399669)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9ocod\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800326371399669)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Non g\00E9ocod\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788534422399661)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Carte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111788427026399661)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune adresse trouv\00E9e.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789056721399661)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'%0 est requis.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958859347399785)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Texte d''aide : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852228379399707)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852304533399707)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9s\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798232903399668)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# n''est pas comprise dans la plage valide de %0 \00E0 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798388910399668)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'fr'
,p_message_text=>'#LABEL# n''est pas un multiple de %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797923853399668)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'fr'
,p_message_text=>'#LABEL# doit correspondre aux valeurs %0 et %1.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798180506399668)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876452412399725)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876514990399725)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798048302399668)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781401574399656)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter une entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910655532399749)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910757483399749)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781587391399656)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'fr'
,p_message_text=>unistr('Entr\00E9es s\00E9lectionn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914443727399752)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'fr'
,p_message_text=>unistr('Avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914764702399752)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914569937399752)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'fr'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914855372399752)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Options de mod\00E8le en service')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915464262399753)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Les options de mod\00E8le ne sont pas disponibles car ce composant n''est pas affich\00E9 sur la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914336666399752)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune option de mod\00E8le n''a \00E9t\00E9 trouv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914601069399752)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789959740399662)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'fr'
,p_message_text=>'Effacer le cercle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791733779399663)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'fr'
,p_message_text=>unistr('Les styles personnalis\00E9s ne sont pas une expression JSON valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790246028399662)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'fr'
,p_message_text=>'Outil Distance'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790074890399662)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'fr'
,p_message_text=>'Dessiner un cercle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782659894399657)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('La recherche \00E0 facets n\00E9cessite une source de donn\00E9es au niveau de la r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785274880399659)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'fr'
,p_message_text=>'Position actuelle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786302262399659)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('Les coordonn\00E9es de la position initiale ne sont pas valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783776082399657)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('La position initiale doit \00EAtre une g\00E9om\00E9trie de type point.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786171393399659)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'fr'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784732925399658)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'fr'
,p_message_text=>'Couche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918089001399755)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'fr'
,p_message_text=>'Couche : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789336876399662)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'fr'
,p_message_text=>'Carte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782534254399657)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'fr'
,p_message_text=>'Messages'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786275127399659)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'fr'
,p_message_text=>'miles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917011542399754)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es contiennent plus de %0 lignes, ce qui est sup\00E9rieur au nombre maximal autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784585474399658)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Conditions</a> &nbsp;&nbsp; Donn\00E9es de carte &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783456835399657)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de donn\00E9es SDO_GEOMETRY n''est pas disponible dans cette base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784604389399658)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'fr'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; Contributeurs OpenStreetMap </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784827994399658)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'fr'
,p_message_text=>'Points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918172564399755)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'fr'
,p_message_text=>'%0 points'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790131589399662)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'fr'
,p_message_text=>'Zoom rectangle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789896298399662)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785186609399658)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser l''azimut sur le nord')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865464378399717)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'fr'
,p_message_text=>'Basculer en mode 2D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865545600399717)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'fr'
,p_message_text=>'Basculer en mode 3D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789751960399662)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer/d\00E9sactiver le copyright')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790388367399662)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'fr'
,p_message_text=>'Distance totale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784972344399658)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'fr'
,p_message_text=>'Zoom avant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785096194399658)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'fr'
,p_message_text=>unistr('Zoom arri\00E8re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912558055399751)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'fr'
,p_message_text=>'Gras'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913476123399751)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913082971399751)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'fr'
,p_message_text=>unistr('Code incorpor\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926629367399761)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E9rer une image')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926719841399761)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'fr'
,p_message_text=>unistr('Ins\00E9rer un lien')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912624663399751)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'fr'
,p_message_text=>'Italique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927324717399761)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'fr'
,p_message_text=>'Lien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913316956399751)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913234368399751)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste tri\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912756905399751)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Aper\00E7u')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912828676399751)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a rien \00E0 pr\00E9visualiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912946142399751)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'fr'
,p_message_text=>unistr('Barr\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913135443399751)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste non tri\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892059031399736)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'fr'
,p_message_text=>'en cours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111949567727399778)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Plus...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111891946760399736)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Chargement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923717987399759)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'fr'
,p_message_text=>'Message de notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897040609399740)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit \00EAtre un nombre inf\00E9rieur ou \00E9gal \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897149171399740)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit \00EAtre une valeur num\00E9rique valide.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897262383399740)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur #LABEL# ne correspond pas au format num\00E9rique %0 (exemple : %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896929712399740)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit \00EAtre un nombre sup\00E9rieur ou \00E9gal \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896834924399739)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fr'
,p_message_text=>unistr('#LABEL# doit \00EAtre un nombre compris entre %0 et %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892192624399736)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'fr'
,p_message_text=>unistr('s''ouvre dans une nouvelle fen\00EAtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845339272399702)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page a d\00E9j\00E0 \00E9t\00E9 soumise ; elle ne peut pas l''\00EAtre de nouveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827921725399690)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'L''application "%0", page "%1", est introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861707187399714)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'#LABEL# doit comporter une valeur.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805091071399673)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911012681399750)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910944491399750)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'fr'
,p_message_text=>'Rechercher %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911242255399750)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911150519399750)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797154588399667)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'fr'
,p_message_text=>unistr('Saisissez un terme de recherche comportant au moins %0 caract\00E8res.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866676623399718)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Liste de valeurs (LOV) instantan\00E9e : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797229440399667)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'fr'
,p_message_text=>'Saisissez un terme de recherche.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797093142399667)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun r\00E9sultat trouv\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796936626399667)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Enlever %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884811528399731)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Terme de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910824002399749)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921580563399757)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'fr'
,p_message_text=>'Traitement en cours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795549455399666)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Ajouter \00E0 \00E9cran d''accueil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791585557399663)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Votre appareil ou votre navigateur ne semble pas prendre en charge l''installation des applications Web progressives pour le moment.</p>',
unistr('    <p class="a-pwaDialog-intro">Si cette application est d\00E9j\00E0 install\00E9e sur votre appareil, ouvrez-la \00E0 partir de votre \00E9cran d''accueil.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791168857399663)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application. Ajoutez-le \00E0 votre \00E9cran d''accueil pour l''utiliser en plein \00E9cran.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Appuyer sur l''ic\00F4ne <strong>Menu</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Appuyer sur <strong>Installer</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Appuyer sur <strong>Ajouter</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791284910399663)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application et est optimal dans Chrome ou Edge.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Appuyer sur l''ic\00F4ne <strong>Menu</strong> en regard de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Appuyer sur <strong>Installer</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790853780399663)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application et est optimal dans Safari.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Appuyer sur l''ic\00F4ne <strong>Partager</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Appuyer sur <strong>Ouvrir dans Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790578223399662)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application. Ajoutez-le \00E0 votre \00E9cran d''accueil pour profiter d''une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Appuyer sur l''ic\00F4ne <strong>Partager</strong> en regard de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Appuyer sur <strong>Ajouter \00E0 \00E9cran d''accueil</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Appuyer sur <strong style="color:#007AE1;">Ajouter</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790419703399662)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application. Ajoutez-le \00E0 votre \00E9cran d''accueil pour profiter d''une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Appuyer sur l''ic\00F4ne <strong>Partager</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Faire d\00E9filer l''\00E9cran vers le bas et appuyer sur <strong>Ajouter \00E0 \00E9cran d''accueil</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Appuyer sur <strong style="color:#007AE1;">Ajouter</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785435889399659)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application. Ajoutez-le \00E0 votre \00E9cran d''accueil pour profiter d''une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Appuyer sur l''ic\00F4ne <strong>Plus</strong> en regard de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Appuyer sur <strong>Ajouter \00E0 \00E9cran d''accueil</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Appuyer sur <strong style="color:#007AE1;">Ajouter</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790792792399662)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application. Ajoutez-le \00E0 votre \00E9cran d''accueil pour profiter d''une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Appuyer sur l''ic\00F4ne <strong>Partager</strong> en regard de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Appuyer sur <strong>Ouvrir dans Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790663815399662)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application. Ajoutez-le \00E0 votre \00E9cran d''accueil pour profiter d''une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Appuyer sur l''ic\00F4ne <strong>Partager</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Appuyer sur <strong>Ouvrir dans Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791496341399663)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application et est optimal dans Chrome.</p>',
'    <p class="a-pwaDialog-intro">Firefox ne prend actuellement pas en charge l''installation d''applications Web.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111790962093399663)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application et est optimal dans Chrome ou Edge.</p>',
'    <p class="a-pwaDialog-intro">Firefox ne prend actuellement pas en charge l''installation d''applications Web sur macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791070094399663)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application et est optimal dans Chrome ou Edge.</p>',
'    <p class="a-pwaDialog-intro">Safari ne prend actuellement pas en charge l''installation d''applications Web sur macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791355894399663)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Ce site Web est disponible sous forme d''application et est optimal dans Chrome ou Edge.</p>',
'    <p class="a-pwaDialog-intro">Firefox ne prend actuellement pas en charge l''installation d''applications Web sous Windows.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793835633399665)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Connexion impossible</h1>',
unistr('    <p>Une connexion Internet est n\00E9cessaire pour utiliser cette application.</p>'),
unistr('    <button type="button">R\00E9essayer</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793712597399665)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Connexion impossible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933581138399766)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877951184399726)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Toute la journ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956831631399783)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'fr'
,p_message_text=>'Envoyer une invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956662933399783)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'fr'
,p_message_text=>'Options'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879759445399727)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue quotidienne pour toute la journ\00E9e ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879521662399727)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue quotidienne pour les donn\00E9es avec l''heure ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924419697399759)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'fr'
,p_message_text=>'Jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918884552399755)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809437468399676)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'fr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809269881399676)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'fr'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809153143399676)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'fr'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809316750399676)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'fr'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808829500399676)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'fr'
,p_message_text=>'Date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809040011399676)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Nom d''\00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956770404399783)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'fr'
,p_message_text=>'Invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924559368399759)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924269503399759)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'fr'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927042906399761)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941352729399772)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun \00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957043600399783)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifiez un \00E9v\00E9nement existant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956936758399783)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'fr'
,p_message_text=>'Envoi d''une invitation par courriel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927169180399761)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935170204399767)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'fr'
,p_message_text=>'Envoyer un courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934920396399767)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'fr'
,p_message_text=>'Envoyer un courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957722375399784)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Tous les champs sont obligatoires.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957611247399784)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'fr'
,p_message_text=>'Envoyer une invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956552595399783)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'fr'
,p_message_text=>'Objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935036059399767)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'fr'
,p_message_text=>'A'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808908894399676)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932831150399765)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'fr'
,p_message_text=>'Panneau sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879336836399727)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'fr'
,p_message_text=>'Heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927282982399761)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'fr'
,p_message_text=>'Aujourd''hui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925026032399760)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'fr'
,p_message_text=>'Visualiser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924392856399759)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'fr'
,p_message_text=>'Semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879604375399727)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue hebdomadaire pour toute la journ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879438199399727)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue hebdomadaire pour les donn\00E9es avec l''heure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924972278399760)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924681175399759)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924781177399759)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'fr'
,p_message_text=>unistr('Charger plus d''\00E9l\00E9ments...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856863603399711)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'fr'
,p_message_text=>'Retour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803151494399671)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'fr'
,p_message_text=>unistr('Charger plus d''\00E9l\00E9ments...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805241529399673)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111924844671399759)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'fr'
,p_message_text=>unistr('Charger plus d''\00E9l\00E9ments...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926978108399761)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('ID de r\00E9gion %0 introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805105056399673)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829245528399691)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de r\00E9initialiser la pagination de r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797402275399667)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la d\00E9finition de pagination de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918273085399755)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926843218399761)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le type de r\00E9gion %0 n''est pas pris en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797355836399667)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''affichage de la r\00E9gion "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861898199399714)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'#COLUMN_HEADER# doit comporter une valeur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956143954399782)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('%0, \00E9diteur de texte enrichi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863946555399716)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le balisage HTML de texte enrichi d\00E9passe la longueur maximale de l''\00E9l\00E9ment (r\00E9elle : %0, autoris\00E9e : %1 caract\00E8res)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923814969399759)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915619755399753)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'fr'
,p_message_text=>'Dupliquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913923089399752)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes affich\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913890905399752)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'fr'
,p_message_text=>'Exclure les valeurs NULL'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923975448399759)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877589729399726)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer vers le bas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877669993399726)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer vers le haut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913694666399751)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914239332399752)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Autres colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913704904399752)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914004788399752)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'fr'
,p_message_text=>'Ligne %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914123032399752)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'fr'
,p_message_text=>'Ligne %0 sur %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915791141399753)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9g\00E9n\00E9rer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915888870399753)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9tablir les modifications')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111913588486399751)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('Menu Param\00E8tres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874557826399723)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Par exemple, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782070085399656)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'fr'
,p_message_text=>'Se reconnecter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781970443399656)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'fr'
,p_message_text=>'Votre session a pris fin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782150810399656)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'fr'
,p_message_text=>'Prolonger'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781779122399656)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre session prendra fin \00E0 %0. Voulez-vous la prolonger ?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781875361399656)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre session prendra fin \00E0 %0 et ne peut pas \00EAtre prolong\00E9e. Enregistrez votre travail pour \00E9viter de perdre des donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934788096399767)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du traitement du code de nettoyage de session de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827800377399690)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du traitement du code de configuration de session de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111801991411399671)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'fr'
,p_message_text=>'Votre session a pris fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933655858399766)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'fr'
,p_message_text=>unistr('Fermez cette bo\00EEte de dialogue et appuyez sur le bouton Recharger de votre navigateur pour obtenir une nouvelle session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952926737399780)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'fr'
,p_message_text=>unistr('Cliquez <a href="%0">ici</a> pour cr\00E9er une session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839543895399698)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'fr'
,p_message_text=>'Session non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879048355399727)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun r\00F4le dynamique n''a pu \00EAtre activ\00E9 dans la session Real Application Security pour l''utilisateur "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825727757399688)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-99900 Impossible de cr\00E9er l''ID de session unique : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842068590399700)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Violation de protection de l''\00E9tat de session. Cause possible : modification manuelle de l''\00E9l\00E9ment de page prot\00E9g\00E9 %0. Si vous n''\00EAtes pas s\00FBr de la cause de l''erreur, contactez l''administrateur de l''application pour obtenir de l''aide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961107047399786)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Violation de protection de page. Cause possible : soumission d''une page dont le chargement n''est pas encore termin\00E9 ou modification manuelle d''\00E9l\00E9ments de page prot\00E9g\00E9s. Pour obtenir de l''aide, contactez l''administrateur de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960130882399786)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 contient l''un des caract\00E8res non valides suivants : &<>"/;,*|=% ou --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960231960399786)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 contient l''un des caract\00E8res non valides suivants : &<>"/;,*|=% ou --, ou un saut de ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959962970399785)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 contient des caract\00E8res sp\00E9ciaux. Seuls les caract\00E8res a-Z, 0-9 et les espaces sont autoris\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111960081736399785)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 contient <, > ou ", qui ne sont pas des caract\00E8res valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804129265399672)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun checksum n''a \00E9t\00E9 fourni au traitement de l''affichage d''une page exigeant un checksum lorsqu''une ou plusieurs demandes, suppressions de cache ou valeurs d''argument sont transmises en tant que param\00E8tres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836954748399696)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Violation de protection du statut de session. Cause possible : modification manuelle d''une URL contenant un checksum ou utilisation d''un lien dont le checksum est incorrect ou absent. Si vous n''\00EAtes pas s\00FBr de la cause de l''erreur, contactez votre ad')
||'ministrateur pour obtenir de l''aide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111914923603399752)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver le mode de contraste \00E9lev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915047769399752)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer le mode de contraste \00E9lev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833630433399694)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833826364399694)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833975419399694)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834031453399694)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Tout d\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834158951399694)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834247235399694)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'fr'
,p_message_text=>'Tout enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834321702399694)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833545909399694)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833775623399694)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942611497399772)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'fr'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943304236399773)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'dans %0 jours(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942553665399772)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'fr'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943495512399773)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'dans %0 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942382185399772)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'fr'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943507111399773)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'dans %0 min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942928915399773)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'fr'
,p_message_text=>'%0 mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943101567399773)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'dans %0 mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942412889399772)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'fr'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943230855399773)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'dans %0 s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942724907399773)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'fr'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943664298399773)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'dans %0 semaine(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942841369399773)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'fr'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111943002565399773)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'dans %0 an(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782925494399657)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'fr'
,p_message_text=>'[Ligne]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783373817399657)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'fr'
,p_message_text=>'[Plusieurs lignes]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783184571399657)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'fr'
,p_message_text=>'[Plusieurs points]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783560122399657)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'fr'
,p_message_text=>'[Plusieurs polygones]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783616820399657)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'fr'
,p_message_text=>unistr('[Objet de g\00E9om\00E9trie]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782868040399657)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'fr'
,p_message_text=>'[Point (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783067063399657)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'fr'
,p_message_text=>'[Polygone]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860211406399713)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860107092399713)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Restaurer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906663275399746)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'fr'
,p_message_text=>unistr('Effacer l''\00E9valuation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896569935399739)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur %0 ne figure pas dans la plage d''\00E9valuation valide comprise entre 1 et %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896618661399739)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 n''est pas une valeur num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892796845399737)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'fr'
,p_message_text=>unistr('Message de succ\00E8s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955853969399782)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955782047399782)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941498774399772)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'fr'
,p_message_text=>'Barre d''outils'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956214570399783)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper/R\00E9duire la navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956396960399783)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper/R\00E9duire la colonne lat\00E9rale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865948233399717)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Navigation principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872971885399722)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'fr'
,p_message_text=>'1 jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872724896399722)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'fr'
,p_message_text=>'1 heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873032642399722)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872821496399722)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'fr'
,p_message_text=>'%0 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872604515399722)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'fr'
,p_message_text=>'%0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873216684399722)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'fr'
,p_message_text=>'%0 semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111873192338399722)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'fr'
,p_message_text=>'1 semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959436625399785)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9but de la page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821424245399685)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795286297399666)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du traitement de la demande.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874612581399723)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Valeur requise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957519402399784)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'fr'
,p_message_text=>unistr('Attendez la fin du chargement de la page et r\00E9essayez.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917712218399754)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page comporte des modifications non enregistr\00E9es.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798690247399668)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'fr'
,p_message_text=>'Le classeur ne comporte pas de feuille de calcul active.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798537404399668)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le classeur n''est pas initialis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798417002399668)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur interne est survenue lors de la cr\00E9ation du fichier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800925042399670)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'fr'
,p_message_text=>'Feuille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932646879399765)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'fr'
,p_message_text=>'Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850159626399706)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'fr'
,p_message_text=>'Menu Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845825363399703)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845730461399703)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une colonne de regroupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879903177399727)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une colonne pour la permutation lignes vers colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880045547399727)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne /colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820254438399684)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9ger')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856371880399710)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Agr\00E9gation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837487754399697)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'fr'
,p_message_text=>'Moyenne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841739232399700)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837566260399697)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'fr'
,p_message_text=>'Valeur maximale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837784085399697)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9diane')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837617577399697)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'fr'
,p_message_text=>'Valeur minimale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837326926399696)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'fr'
,p_message_text=>'Total de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838493228399697)
,p_name=>'APEXIR_ALL'
,p_message_language=>'fr'
,p_message_text=>'Tout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819518583399684)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Toutes les colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802053512399671)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Toutes les lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929604445399763)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'fr'
,p_message_text=>'Remplacement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931220317399764)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Autre valeur par d\00E9faut : %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832173745399693)
,p_name=>'APEXIR_AND'
,p_message_language=>'fr'
,p_message_text=>'et'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821608843399685)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'fr'
,p_message_text=>'Appliquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815355460399680)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'fr'
,p_message_text=>'Croissant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834907448399695)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'fr'
,p_message_text=>'A partir du %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931851029399765)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'fr'
,p_message_text=>'Moyenne de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923241967399758)
,p_name=>'APEXIR_BAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 barres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821018892399685)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'fr'
,p_message_text=>'entre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814135265399680)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Couleur d''arri\00E8re-plan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816038179399681)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'fr'
,p_message_text=>'bleu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847761912399704)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816665420399681)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822524226399686)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cat\00E9gorie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814078095399680)
,p_name=>'APEXIR_CELL'
,p_message_language=>'fr'
,p_message_text=>'Cellule'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838306160399697)
,p_name=>'APEXIR_CHART'
,p_message_language=>'fr'
,p_message_text=>'Graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848600755399705)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'fr'
,p_message_text=>'Initialisation en cours...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111884957407399731)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le libell\00E9 de graphique doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897388099399740)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre requ\00EAte d\00E9passe la valeur maximale de %0 points de donn\00E9es par graphique. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements dans votre requ\00EAte de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896294048399739)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de lignes pour la requ\00EAte Graphique limite le nombre de lignes dans la requ\00EAte de base, et non le nombre de lignes affich\00E9es. Votre requ\00EAte de base d\00E9passe le nombre de lignes maximal de %0. Appliquez un filtre pour r\00E9duire le nombr')
||unistr('e d''enregistrements dans votre requ\00EAte de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819647989399684)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111892942200399737)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner tout')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835326549399695)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'fr'
,p_message_text=>unistr('Choisir le format de l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842773168399700)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'fr'
,p_message_text=>'effacer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816597181399681)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853938029399708)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926263092399760)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844736988399702)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('Menu d''en-t\00EAte de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848419332399704)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'fr'
,p_message_text=>'Informations de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928509761399762)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846132639399703)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'fr'
,p_message_text=>'Colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830207768399691)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'fr'
,p_message_text=>'contient'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831170809399692)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'fr'
,p_message_text=>'ne contient pas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815056548399680)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'fr'
,p_message_text=>'est dans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831395618399692)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'fr'
,p_message_text=>'n''est pas dans les dern.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839887180399698)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'fr'
,p_message_text=>'ne figure pas sur la ligne suivante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831250172399692)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'fr'
,p_message_text=>'est dans les derniers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839722941399698)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'fr'
,p_message_text=>'figure sur la ligne suivante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814940695399680)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'n''est pas NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814889356399680)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'fr'
,p_message_text=>'est NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814668409399680)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'fr'
,p_message_text=>'est comme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815174786399680)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'fr'
,p_message_text=>'n''est pas dans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814770974399680)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'fr'
,p_message_text=>'n''est pas comme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830530926399692)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'fr'
,p_message_text=>unistr('recherche une expression r\00E9guli\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835292881399695)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111895962467399739)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854299130399709)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er un calcul en utilisant les alias de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854361931399709)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'fr'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854434046399709)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'fr'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854534846399709)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'fr'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800416068399669)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'fr'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839177247399698)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'fr'
,p_message_text=>'Calculer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846781545399703)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'fr'
,p_message_text=>'Commande BREAK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849748021399705)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'fr'
,p_message_text=>'Commandes BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934194816399766)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de commande BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797585307399667)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932316782399765)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'fr'
,p_message_text=>'Nombre de valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932250189399765)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'fr'
,p_message_text=>'Nombre de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904395890399745)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'fr'
,p_message_text=>'Quotidien'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959030999399785)
,p_name=>'APEXIR_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848546383399705)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'fr'
,p_message_text=>unistr('Donn\00E9es d''\00E9tat datant d''il y a %0 minutes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922081164399757)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aide sur les grilles de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820363627399684)
,p_name=>'APEXIR_DATE'
,p_message_language=>'fr'
,p_message_text=>'Date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852482836399707)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929465862399763)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type d''\00E9tat par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816706989399681)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820659148399684)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Voulez-vous supprimer ces param\00E8tres d''\00E9tat ?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915368658399753)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer l''\00E9tat par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846497961399703)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer l''\00E9tat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815490409399681)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822616447399686)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844607633399702)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'fr'
,p_message_text=>'Vue monoligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852995703399708)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'fr'
,p_message_text=>'Direction %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853896273399708)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816227007399681)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'fr'
,p_message_text=>unistr('Affich\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819479174399683)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852826068399708)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher dans l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847605972399704)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'fr'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839274427399698)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852764346399708)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'fr'
,p_message_text=>'Ne pas afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918786972399755)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'fr'
,p_message_text=>unistr('Une mise en \00E9vidence avec la m\00EAme condition existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934381010399766)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonne de pivot en double. La liste de colonnes de pivot doit \00EAtre unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934523432399767)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848740051399705)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier les param\00E8tres du graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855363231399709)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'fr'
,p_message_text=>'Modifier un graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855799910399710)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Modifier le filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910178338399749)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'fr'
,p_message_text=>'Modifier le groupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855670340399710)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier la mise en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880298805399727)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'fr'
,p_message_text=>'Modifier le pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929789316399763)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808492003399675)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930040924399763)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'fr'
,p_message_text=>'Cci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930268742399763)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'fr'
,p_message_text=>'Corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929951329399763)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'fr'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930736324399764)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'fr'
,p_message_text=>unistr('Fr\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812116553399678)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'fr'
,p_message_text=>unistr('La messagerie \00E9lectronique n''a pas \00E9t\00E9 configur\00E9e pour cette application. Contactez l''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903633910399744)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''adresse \00E9lectronique doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930390272399763)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Consulter la pi\00E8ce jointe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930197857399763)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'fr'
,p_message_text=>'Objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904676214399745)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''objet du courriel doit \00EAtre indiqu\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929857027399763)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'fr'
,p_message_text=>'A'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813806558399679)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855506527399710)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer/d\00E9sactiver')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855024644399709)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854698790399709)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'fr'
,p_message_text=>'Exemples'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855498105399709)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'fr'
,p_message_text=>'Exemples :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819373714399683)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'fr'
,p_message_text=>'Exclure les valeurs NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856072531399710)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper/R\00E9duire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853603029399708)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838764743399697)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849600356399705)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'fr'
,p_message_text=>'Filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859962605399713)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'fr'
,p_message_text=>'Expression de filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956469202399783)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>'L''expression de filtre est trop longue.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859855478399713)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Type de filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856289439399710)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner les colonnes \00E0 rechercher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839076215399698)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'fr'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853464363399708)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Une requ\00EAte Flashback permet de visualiser les donn\00E9es telles qu''elles existaient \00E0 un moment donn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904068961399745)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Dur\00E9e de l''op\00E9ration Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905486866399746)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835103576399695)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>'Masque de format %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846378355399703)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>'Fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854177631399709)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'fr'
,p_message_text=>'Fonctions %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929399228399763)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'fr'
,p_message_text=>unistr('Fonctions/Op\00E9rateurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846011700399703)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'fr'
,p_message_text=>'Fonction %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838503193399697)
,p_name=>'APEXIR_GO'
,p_message_language=>'fr'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814317383399680)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'fr'
,p_message_text=>'vert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111797642129399667)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'fr'
,p_message_text=>'Regrouper par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930459047399764)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Grouper par colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885063674399731)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de regroupement doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896184772399739)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de lignes pour la requ\00EAte Grouper par limite le nombre de lignes dans la requ\00EAte de base, et non le nombre le lignes affich\00E9es. Votre requ\00EAte de base d\00E9passe le nombre de lignes maximal de %0. Appliquez un filtre pour r\00E9duire le nom')
||unistr('bre d''enregistrements dans votre requ\00EAte de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876731495399725)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'fr'
,p_message_text=>'Grouper par tri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934224668399766)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'fr'
,p_message_text=>'Grouper par ordre de tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819710294399684)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne horizontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851366331399707)
,p_name=>'APEXIR_HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843154546399701)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les \00E9tats interactifs permettent aux utilisateurs finals de personnaliser les \00E9tats. Les utilisateurs peuvent modifier la mise en page des donn\00E9es d''\00E9tat en choisissant des colonnes, en appliquant des filtres, en mettant des valeurs en \00E9vidence et en')
||unistr(' les triant. Ils peuvent \00E9galement d\00E9finir des sections, des agr\00E9gations, des graphiques, ainsi que des regroupements et ajouter des calculs personnalis\00E9s. Ils peuvent aussi d\00E9finir un abonnement pour l''envoi par courriel d''une version HTML de l''\00E9tat')
||unistr(' \00E0 un intervalle d\00E9fini. Il est possible de cr\00E9er plusieurs versions d''un \00E9tat et de les enregistrer sous forme d''\00E9tats nomm\00E9s, pour une utilisation publique ou priv\00E9e. '),
'<p/>',
unistr('Les sections qui suivent r\00E9capitulent les m\00E9thodes de personnalisation d''un \00E9tat interactif. Pour en savoir plus, reportez-vous \00E0 "Using Interactive Reports" dans le manuel <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850252442399706)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('Le menu Actions se trouve \00E0 droite du bouton Ex\00E9cuter dans la barre de recherche. Utilisez ce menu pour personnaliser un \00E9tat interactif.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843943807399701)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les agr\00E9gats sont des calculs math\00E9matiques r\00E9alis\00E9s sur une colonne. Ils sont affich\00E9s apr\00E8s chaque commande BREAK et \00E0 la fin de l''\00E9tat dans la colonne o\00F9 ils sont d\00E9finis. Les options disponibles sont les suivantes :'),
'<p>',
'</p><ul>',
unistr('<ul><li><strong>Agr\00E9gation</strong> permet de s\00E9lectionner un agr\00E9gat'),
unistr('pr\00E9d\00E9fini \00E0 modifier.</li>'),
unistr('<li><strong>Fonction</strong> est la fonction \00E0 ex\00E9cuter (exemple : SUM, MIN).</li>'),
unistr('<li><strong>Colonne</strong> permet de s\00E9lectionner la colonne \00E0 laquelle appliquer la fonction math\00E9matique. Seules les colonnes num\00E9riques'),
unistr('seront affich\00E9es.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844091695399701)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez d\00E9finir un graphique par \00E9tat interactif. Une fois'),
unistr('que vous l''avez d\00E9fini, vous pouvez basculer de la vue du graphique \00E0 celle de l''\00E9tat \00E0 l''aide des ic\00F4nes de vue de la barre de recherche.'),
'Les options disponibles sont les suivantes :  ',
'<p>',
'</p><ul>',
unistr('<li><strong>Type de graphique</strong> indique le type de graphique \00E0 inclure.'),
unistr('S\00E9lectionnez A barres horizontales, A barres verticales, A secteurs ou A courbes.</li>'),
unistr('<li><strong>Libell\00E9</strong> permet de s\00E9lectionner la colonne \00E0 utiliser comme libell\00E9.</li>'),
unistr('<li><strong>Titre de l''axe pour le libell\00E9</strong> indique le titre qui appara\00EEtra sur l''axe associ\00E9 \00E0 la colonne d\00E9finie'),
unistr('comme libell\00E9. Cette option n''est pas disponible pour les graphiques \00E0 secteurs.</li>'),
unistr('<li><strong>Valeur</strong> permet de s\00E9lectionner la colonne \00E0 utiliser comme valeur. Si votre fonction'),
unistr('est de type COUNT, il est inutile de s\00E9lectionner une valeur.</li>'),
unistr('<li><strong>Titre de l''axe pour la valeur</strong> indique le titre qui appara\00EEtra sur l''axe associ\00E9 \00E0 la colonne d\00E9finie'),
unistr('comme valeur. Cette option n''est pas disponible pour les graphiques \00E0 secteurs.</li>'),
unistr('<li><strong>Fonction</strong> est une fonction facultative \00E0 ex\00E9cuter sur la colonne s\00E9lectionn\00E9e comme valeur.</li>'),
unistr('<li><strong>Trier</strong> permet de trier l''ensemble de r\00E9sultats.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843388117399701)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si vous cliquez sur un en-t\00EAte de colonne, cela affiche un menu d''en-t\00EAte de colonne. Les options disponibles sont les suivantes :'),
'<p></p>',
'<ul>',
unistr('<li><strong>Ic\00F4ne de tri par ordre croissant :</strong> permet de trier les \00E9tats par ordre croissant.</li>'),
unistr('<li><strong>Ic\00F4ne de tri par ordre d\00E9croissant :</strong> permet de trier les \00E9tats par ordre d\00E9croissant.</li>'),
unistr('<li><strong>Masquer la colonne :</strong> permet de masquer une colonne. Les colonnes ne peuvent pas toutes \00EAtre masqu\00E9es. Si une colonne ne peut pas l''\00EAtre, cette ic\00F4ne n''est pas disponible.</li>'),
unistr('<li><strong>Colonne de section (BREAK) :</strong> permet de cr\00E9er un groupe de section sur la colonne, ce qui extrait la colonne de l''\00E9tat comme enregistrement ma\00EEtre.</li>'),
'<li><strong>Informations de colonne :</strong> permet d''afficher l''aide de la colonne, si elle existe.</li>',
unistr('<li><strong>Zone de texte :</strong> permet de saisir des crit\00E8res de recherche,'),
unistr('sans distinction entre les majuscules et les minuscules (caract\00E8res g\00E9n\00E9riques inutiles). Si vous saisissez une valeur, cela r\00E9duira'),
unistr('la liste de valeurs au bas du menu. Vous pourrez ensuite s\00E9lectionner une valeur du'),
unistr('bas du menu et cette valeur sera cr\00E9\00E9e en tant que filtre gr\00E2ce \00E0 l''op\00E9rateur ''='''),
unistr('(par exemple, <code>colonne = ''ABC''</code>). Vous pouvez \00E9galement cliquer sur l''ic\00F4ne repr\00E9sentant une torche pour que la valeur saisie soit cr\00E9\00E9e en tant que filtre avec le modificateur ''LIKE'''),
'(par exemple, <code>colonne LIKE ''%ABC%''</code>).</li>',
unistr('<li>La <b>liste de valeurs uniques</b> contient les 500 premi\00E8res valeurs uniques'),
unistr('correspondant \00E0 vos filtres. Si la colonne est une date, une liste de'),
unistr('plages de dates s''affiche \00E0 la place. Si vous s\00E9lectionnez une valeur, un filtre sera cr\00E9\00E9 avec'),
unistr('l''op\00E9rateur ''='' (par exemple, <code>colonne = ''ABC''</code>).</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843880586399701)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permet d''ajouter des colonnes calcul\00E9es \00E0 votre \00E9tat. Il peut s''agir de calculs math\00E9matiques (comme <code>NBR_HOURS/24</code>) ou de fonctions Oracle'),
unistr('standard appliqu\00E9es \00E0 des colonnes existantes (certaines sont affich\00E9es comme exemple tandis que d''autres, telles que <code>TO_DATE</code>, peuvent \00E9galement \00EAtre utilis\00E9es).'),
'Les options disponibles sont les suivantes :',
'<p></p>',
'<ul>',
unistr('<li><strong>Calcul</strong> permet de s\00E9lectionner un calcul pr\00E9d\00E9fini \00E0 modifier.</li>'),
unistr('<li><strong>En-t\00EAte de colonne</strong> d\00E9signe l''en-t\00EAte de la nouvelle colonne.</li>'),
unistr('<li><strong>Masque de format</strong> d\00E9signe un masque de format Oracle \00E0 appliquer \00E0 la colonne (par exemple, S9999).</li>'),
unistr('<li><strong>Calcul</strong> d\00E9signe le calcul \00E0 ex\00E9cuter. Dans le calcul, les colonnes sont r\00E9f\00E9renc\00E9es \00E0 l''aide des alias affich\00E9s.</li>'),
'</ul>',
unistr('<p>Sous le calcul, les colonnes de votre requ\00EAte sont affich\00E9es avec'),
unistr('leur alias associ\00E9. Si vous cliquez sur un nom de colonne ou un alias,'),
'celui-ci sera inscrit dans le calcul. En regard des colonnes, un clavier fournit simplement',
unistr('des raccourcis pour les touches fr\00E9quemment utilis\00E9es. A droite se trouvent les fonctions.</p>'),
unistr('<p>Voici un exemple de calcul permettant d''afficher la r\00E9mun\00E9ration totale :</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(o\00F9 A est ORGANIZATION, B est SALARY et C, COMMISSION)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850390369399706)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilis\00E9 pour cr\00E9er un groupe de section sur une ou plusieurs colonnes, ce qui extrait les colonnes de l''\00E9tat interactif et les affiche comme enregistrements ma\00EEtre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844514709399702)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Pour afficher les d\00E9tails d''une seule ligne \00E0 la fois, cliquez sur l''ic\00F4ne de vue monoligne sur la ligne que vous souhaitez visualiser. Si l''option est disponible, la vue monoligne sera toujours la premi\00E8re colonne. En fonction de la personnalisation')
||unistr(' de l''\00E9tat interactif, la vue monoligne peut \00EAtre la vue standard ou une page personnalis\00E9e pouvant \00EAtre mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844499071399702)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permet le t\00E9l\00E9chargement de l''ensemble de r\00E9sultats en cours. Les formats de t\00E9l\00E9chargement'),
unistr('seront diff\00E9rents en fonction de votre installation et de la d\00E9finition d''\00E9tat,'),
'et pourront inclure CSV, HTML, courriel, XLS, PDF ou RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843512778399701)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Active l''\00E9tat en ajoutant ou modifiant la clause <code>WHERE</code> de la requ\00EAte. Vous pouvez filtrer par colonne ou par ligne.  '),
unistr('<p>Si vous filtrez par colonne, vous devez s\00E9lectionner une colonne (pas n\00E9cessairement'),
unistr('une de celles affich\00E9es), choisir un op\00E9rateur Oracle standard (=, !=, n''est pas dans, entre), puis saisir une expression \00E0 comparer. Les expressions font la distinction entre les majuscules et les minuscules. Vous pouvez utiliser le caract\00E8re g\00E9n\00E9ri')
||'que % (par exemple, <code>STATE_NAME',
'like A%)</code>.</p>',
unistr('<p>Si vous filtrez par ligne, vous pouvez cr\00E9er des clauses <code>WHERE</code> complexes \00E0 l''aide'),
unistr('d''alias de colonne et de toute fonction ou tout op\00E9rateur Oracle (par exemple, <code>G = ''VA'' ou G = ''CT''</code>, o\00F9'),
'<code>G</code> est l''alias de <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844128024399701)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Une requ\00EAte Flashback vous permet de visualiser les donn\00E9es telles qu''elles existaient'),
unistr('\00E0 un moment donn\00E9. Par d\00E9faut, l''op\00E9ration Flashback permet de remonter \00E0 3 heures (ou 180 minutes)'),
unistr('mais la dur\00E9e r\00E9elle sera diff\00E9rente en fonction de la base de donn\00E9es.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905373579399746)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''\00E9l\00E9ment Format permet de personnaliser l''affichage d''un \00E9tat.'),
'Il comprend les sous-menus suivants :</p>',
'<ul><li>Trier</li>',
'<li>Commande BREAK</li>',
unistr('<li>Mise en \00E9vidence</li>'),
'<li>Calculer</li>',
unistr('<li>Agr\00E9gat</li>'),
'<li>Graphique</li>',
'<li>Grouper par</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903580092399744)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez d\00E9finir une vue Grouper par pour chaque \00E9tat'),
unistr('enregistr\00E9. Une fois d\00E9fini, vous pouvez basculer entre la vue Grouper par et la vue'),
unistr('d''\00E9tat \00E0 l''aide des ic\00F4nes de vue situ\00E9es en dessous de la barre de recherche. Pour cr\00E9er une vue Grouper par,'),
unistr('vous s\00E9lectionnez :'),
'<p></p><ul>',
'<li>les colonnes sur la base desquelles former le groupe</li>',
unistr('<li>les colonnes \00E0 agr\00E9ger, ainsi que la fonction \00E0 ex\00E9cuter (moyenne, somme, nombre, etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843771959399701)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permet de d\00E9finir un filtre. Les lignes correspondant aux crit\00E8res du filtre sont mises en \00E9vidence \00E0 l''aide des caract\00E9ristiques associ\00E9es au filtre. Les options disponibles sont les suivantes :</p>'),
'<ul>',
unistr('<li><strong>Nom</strong> est utilis\00E9 uniquement pour l''affichage.</li>'),
unistr('<li><strong>S\00E9quence</strong> identifie la s\00E9quence utilis\00E9e pour l''\00E9valuation des r\00E8gles.</li>'),
unistr('<li><strong>Activ\00E9</strong> indique si la r\00E8gle est activ\00E9e ou non.</li>'),
unistr('<li><strong>Mettre le type en \00E9vidence</strong> indique si la ligne ou la cellule doit \00EAtre'),
unistr('mise en \00E9vidence. Si vous s\00E9lectionnez la cellule, la colonne r\00E9f\00E9renc\00E9e sous'),
unistr('Conditions de mise en \00E9vidence sera mise en \00E9vidence.</li>'),
unistr('<li><strong>Couleur d''arri\00E8re-plan</strong> indique la nouvelle couleur d''arri\00E8re-plan pour les zones mises en \00E9vidence.</li>'),
unistr('<li><strong>Couleur du texte</strong> indique la nouvelle couleur de texte pour les zones mises en \00E9vidence.</li>'),
unistr('<li><strong>Conditions de mise en \00E9vidence</strong> d\00E9finit vos conditions de filtrage.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781395646399656)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez d\00E9finir une vue de permutation lignes vers colonnes pour chaque \00E9tat enregistr\00E9. Cela permet ensuite de basculer entre la vue de permutation lignes vers colonnes et la vue d''\00E9tat \00E0 l''aide des ic\00F4nes d''affichage de la barre de recherche. P')
||unistr('our cr\00E9er une vue de permutation lignes vers colonnes, vous devez s\00E9lectionner : '),
'<p></p>',
'<ul>',
'<li>les colonnes sur lesquelles effectuer la permutation lignes vers colonnes ;</li>',
unistr('<li>les colonnes \00E0 afficher en tant que lignes ; </li>'),
unistr('<li>les colonnes \00E0 agr\00E9ger, ainsi que la fonction \00E0 ex\00E9cuter (moyenne, somme, d\00E9compte, etc.).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854835470399709)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si vous personnalisez un \00E9tat interactif, les param\00E8tres d''\00E9tat seront affich\00E9s'),
unistr('en dessous de la barre de recherche et au-dessus de l''\00E9tat. Cette zone peut \00EAtre r\00E9duite et d\00E9velopp\00E9e \00E0 l''aide de l''ic\00F4ne de gauche.'),
'<p>',
unistr('Pour chaque param\00E8tre d''\00E9tat, vous pouvez effectuer les op\00E9rations suivantes :'),
'</p><ul>',
unistr('<li>Modifier un param\00E8tre en cliquant sur le nom.</li>'),
unistr('<li>D\00E9sactiver/Activer un param\00E8tre en cochant ou en d\00E9s\00E9lectionnant la case Activer/D\00E9sactiver. Ceci permet d''activer et de d\00E9sactiver temporairement le param\00E8tre.</li>'),
unistr('<li>Enlever un param\00E8tre en cliquant sur l''ic\00F4ne Enlever.</li>'),
'</ul>',
unistr('<p>Si vous avez cr\00E9\00E9 un graphique, un regroupement ou un pivot, vous pouvez basculer entre eux'),
unistr('et l''\00E9tat de base via les liens de vue d''\00E9tat, Vue de graphique, Vue Grouper par et Vue de pivot'),
'sur la droite. Si vous visualisez le graphique, le regroupement ou le pivot, vous',
unistr('pouvez \00E9galement utiliser le lien Modifier pour modifier les param\00E8tres.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844325743399702)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialise l''\00E9tat pour retrouver les param\00E8tres par d\00E9faut, ce qui enl\00E8ve toute personnalisation effectu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905667131399746)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finit le nombre d''enregistrements \00E0 afficher par page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844263017399701)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Enregistre l''\00E9tat personnalis\00E9 en vue d''une utilisation ult\00E9rieure. Vous devez indiquer un nom, pouvez entrer une description et rendre l''\00E9tat accessible au public (\00E0 savoir, \00E0 tous les utilisateurs pouvant acc\00E9der \00E0 l''\00E9tat par d\00E9faut principal). ')
||unistr('Vous pouvez enregistrer quatre types d''\00E9tat interactif :</p>'),
'<ul>',
unistr('<li><strong>Val. par d\00E9faut du principal</strong> (d\00E9veloppeur uniquement) : l''\00E9tat par d\00E9faut principal est celui qui est affich\00E9 initialement. Les \00E9tats de ce type ne peuvent \00EAtre ni renomm\00E9s, ni supprim\00E9s.</li>'),
unistr('<li><strong>Etat de remplacement</strong> (d\00E9veloppeur uniquement) : permet aux d\00E9veloppeurs de cr\00E9er diff\00E9rentes mises en page d''\00E9tat. Seuls les d\00E9veloppeurs sont autoris\00E9s \00E0 enregistrer, renommer et supprimer ce type d''\00E9tat.</li>'),
unistr('<li><strong>Etat public</strong> (utilisateur final) : ce type d''\00E9tat peut \00EAtre enregistr\00E9, renomm\00E9 et supprim\00E9 par l''utilisateur final l''ayant cr\00E9\00E9. Les autres utilisateurs peuvent visualiser et enregistrer la mise en page, comme pour les autres \00E9ta')
||'ts.</li>',
unistr('<li><strong>Etat priv\00E9</strong> (utilisateur final) : seul l''utilisateur final ayant cr\00E9\00E9 l''\00E9tat est autoris\00E9 \00E0 le visualiser, l''enregistrer, le renommer et le supprimer.</li>'),
'</ul>',
unistr('<p>Lorsque vous enregistrez des \00E9tats personnalis\00E9s, un s\00E9lecteur d''\00E9tats appara\00EEt dans la barre de recherche \00E0 gauche du s\00E9lecteur de lignes (\00E0 condition que cette fonctionnalit\00E9 soit activ\00E9e).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843296306399701)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Une r\00E9gion de recherche se trouve dans la partie sup\00E9rieure de chaque page d''\00E9tat. Cette r\00E9gion (ou barre de recherche) fournit les fonctionnalit\00E9s suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906273950399746)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('<li>Le <strong>menu Actions</strong> permet de personnaliser un \00E9tat. Reportez-vous aux sections qui suivent.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905765366399746)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'fr'
,p_message_text=>unistr('<li>L''<strong>ic\00F4ne S\00E9lectionner des colonnes</strong> permet d''indiquer les colonnes sur lesquelles doit porter la recherche (ou toutes les colonnes).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906095347399746)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'fr'
,p_message_text=>unistr('<li>L''option <strong>Etats</strong> permet d''afficher les autres \00E9tats par d\00E9faut, et les \00E9tats enregistr\00E9s priv\00E9s ou publics.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905982854399746)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('<li>Le champ <strong>Lignes</strong> permet de d\00E9finir le nombre d''enregistrements \00E0 afficher par page.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905805650399746)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>La <strong>zone de texte</strong> permet d''entrer des crit\00E8res de recherche sans distinction entre les majuscules et les minuscules (les caract\00E8res g\00E9n\00E9riques sont implicites).</li>'),
unistr('<li>Le <strong>bouton OK</strong> permet de lancer la recherche. Si vous appuyez sur la touche Entr\00E9e, la recherche sera \00E9galement ex\00E9cut\00E9e lorsque le curseur se trouve dans la zone de recherche de texte.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906156466399746)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('<li>L''option <strong>Ic\00F4nes Vue</strong> permet de basculer entre les vues d''ic\00F4ne, d''\00E9tat, de d\00E9tail, de graphique, de regroupement et de pivot de l''\00E9tat si elles sont d\00E9finies.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922131255399758)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('<li>L''\00E9l\00E9ment <strong>G\00E9rer</strong> permet de g\00E9rer les propri\00E9t\00E9s, les colonnes et les lignes, et de visualiser l''historique de l''\00E9tat ou de la grille de donn\00E9es.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843497647399701)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilis\00E9 pour modifier les colonnes affich\00E9es. Les colonnes situ\00E9es sur la droite sont affich\00E9es, tandis que celles situ\00E9es sur la gauche sont masqu\00E9es. Vous pouvez re-trier les colonnes affich\00E9es \00E0 l''aide de la fl\00E8che situ\00E9e \00E0 droite. Les colonnes ca')
||unistr('lcul\00E9es sont pr\00E9c\00E9d\00E9es par <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843664184399701)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilis\00E9 pour modifier les colonnes \00E0 utiliser pour trier et d\00E9terminer si'),
unistr('le tri doit \00EAtre croissant ou d\00E9croissant. Vous pouvez \00E9galement indiquer comment g\00E9rer'),
unistr('les valeurs <code>NULL</code>. Le param\00E8tre par d\00E9faut affiche toujours les valeurs <code>NULL</code> en premier ou en dernier. Le tri r\00E9sultant est affich\00E9 \00E0 droite'),
unistr('des en-t\00EAtes de colonnes dans l''\00E9tat.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903342903399744)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Lorsque vous ajoutez un abonnement, vous fournissez une adresse \00E9lectronique (ou plusieurs adresses \00E9lectroniques s\00E9par\00E9es par des virgules), un objet de courriel, une fr\00E9quence, et des dates de d\00E9but et de fin. Les courriels obtenus seront une versi')
||unistr('on HTML de l''\00E9tat interactif contenant les donn\00E9es en cours utilisant les param\00E8tres d''\00E9tat pr\00E9sents lors de l''ajout de l''abonnement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921951982399757)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les grilles de donn\00E9es sont essentiellement des \00E9tats modifiables dont la plupart des \00E9l\00E9ments peuvent \00EAtre personnalis\00E9s. Les utilisateurs peuvent ainsi modifier la mise en page des donn\00E9es de l''\00E9tat en choisissant des colonnes, en appliquant des fi')
||unistr('ltres, en mettant les valeurs en \00E9vidence et en les triant. Ils peuvent \00E9galement d\00E9finir des sections, des agr\00E9gations, des graphiques ainsi que des regroupements et ajouter des calculs personnalis\00E9s. Il est possible de cr\00E9er diff\00E9rentes versions d''')
||unistr('un \00E9tat et les enregistrer en tant qu''\00E9tats nomm\00E9s, pour une utilisation priv\00E9e. '),
'<p/>',
unistr('Vous pouvez personnaliser une grille de donn\00E9es via la barre de recherche, le menu Actions et le menu d''en-t\00EAte de colonne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933734139399766)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'fr'
,p_message_text=>unistr('Le menu Actions se trouve \00E0 droite du bouton Ex\00E9cuter dans la barre de recherche. Utilisez ce menu pour personnaliser un \00E9tat de grille de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922408870399758)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'fr'
,p_message_text=>'Page Ajouter/Modifier une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922599973399758)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour ajouter une ligne \00E0 la grille de donn\00E9es, cliquez sur Ajouter une ligne. Pour modifier les d\00E9tails d''une ligne, cliquez sur l''ic\00F4ne Modifier une ligne (dans la premi\00E8re colonne) de la ligne \00E0 modifier. La page Ajouter/Modifier une ligne est a')
||unistr('ffich\00E9e avec les colonnes de la grille de donn\00E9es. </p>'),
'',
unistr('<p>Lors de la modification d''une ligne, vous pouvez effectuer les op\00E9rations suivantes :</p>'),
'',
'<p><ul>',
'<li><strong>Supprimer</strong> la ligne.</li>',
unistr('<li><strong>Appliquer les modifications</strong> pour enregistrer les modifications apport\00E9es \00E0 la ligne.</li>'),
unistr('<li>Dans l''\00E9l\00E9ment <strong>Actions</strong>, ajouter une ligne, des fichiers, des remarques, des liens ou des balises et v\00E9rifier l''historique.</li>'),
unistr('<li>Acc\00E9der aux lignes <strong>pr\00E9c\00E9dente et suivante</strong>.</li>'),
unistr('<li>Dans l''\00E9l\00E9ment <strong>G\00E9rer</strong>, d\00E9finir les propri\00E9t\00E9s des colonnes, les groupes de colonnes, les validations et les listes de valeurs.</li>'),
'</ul></p>',
'',
unistr('<p>La r\00E9gion Annotations situ\00E9e au bas de la page affiche les fichiers, remarques, liens ou balises associ\00E9s \00E0 la ligne en cours.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933885540399766)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'fr'
,p_message_text=>unistr('Utilis\00E9 pour cr\00E9er un groupe de section pour une ou plusieurs colonnes, ce qui extrait les colonnes de la grille de donn\00E9es et les affiche comme enregistrements ma\00EEtre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922386340399758)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permet le t\00E9l\00E9chargement de l''ensemble de r\00E9sultats en cours. Les formats de t\00E9l\00E9chargement'),
'sont les suivants : CSV, HTML ou courriel.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933954673399766)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si vous personnalisez un \00E9tat de grille de donn\00E9es, les param\00E8tres d''\00E9tat seront affich\00E9s'),
unistr('au-dessous de la barre de recherche et au-dessus de l''\00E9tat. Cette zone peut \00EAtre r\00E9duite et d\00E9velopp\00E9e \00E0 l''aide de l''ic\00F4ne de gauche.'),
'<p>',
unistr('Pour chaque param\00E8tre d''\00E9tat, vous pouvez effectuer les op\00E9rations suivantes :'),
'</p><ul>',
unistr('<li>Modifier un param\00E8tre en cliquant sur son nom.</li>'),
unistr('<li>D\00E9sactiver/activer un param\00E8tre en cochant ou en d\00E9s\00E9lectionnant la case Activer/D\00E9sactiver. Ceci permet d''activer et de d\00E9sactiver temporairement le param\00E8tre.</li>'),
unistr('<li>Enlever un param\00E8tre en cliquant sur l''ic\00F4ne Enlever.</li></ul>'),
'</ul>',
unistr('<p>Si vous avez cr\00E9\00E9 un graphique ou un regroupement, vous pouvez basculer entre eux'),
unistr('et l''\00E9tat de base via les liens de vue d''\00E9tat, de graphique et de regroupement'),
'sur la droite. Si vous visualisez le graphique ou le regroupement, vous',
unistr('pouvez \00E9galement utiliser le lien Modifier pour modifier leurs param\00E8tres.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922278108399758)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Enregistre la mise en page personnalis\00E9e de l''\00E9tat de grille de donn\00E9es en vue d''une utilisation ult\00E9rieure. Vous devez indiquer un nom et pouvez entrer une description. Vous pouvez enregistrer trois types de mise en page d''\00E9tat de grille de donn\00E9')
||'es :</p>',
'<ul>',
unistr('<li><strong>Val. par d\00E9faut du principal</strong> (administrateur uniquement) : la mise en page par d\00E9faut principale est celle qui est affich\00E9e initialement. Les \00E9tats de ce type ne peuvent \00EAtre ni renomm\00E9s, ni supprim\00E9s.</li>'),
unistr('<li><strong>Etat de remplacement</strong> (administrateur uniquement) : permet aux administrateurs de cr\00E9er diff\00E9rentes mises en page d''\00E9tat. Seuls les administrateurs sont autoris\00E9s \00E0 enregistrer, renommer et supprimer ce type d''\00E9tat.</li>'),
unistr('<li><strong>Etat priv\00E9</strong> (tous les utilisateurs) : seul l''utilisateur ayant cr\00E9\00E9 la mise en page d''\00E9tat est autoris\00E9 \00E0 visualiser, enregistrer, renommer et supprimer l''\00E9tat.</li>'),
'</ul>',
unistr('<p>Lorsque vous enregistrez des \00E9tats personnalis\00E9s, un s\00E9lecteur d''\00E9tats appara\00EEt dans la barre de recherche \00E0 gauche du s\00E9lecteur de lignes (\00E0 condition que cette fonctionnalit\00E9 soit activ\00E9e).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848341649399704)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Masquer la colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838953074399698)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre en \00E9vidence')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849877829399705)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Mises en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854968765399709)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'fr'
,p_message_text=>unistr('Conditions de mises en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903905481399745)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Style de mise en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813905466399679)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Mettre le type en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923498226399758)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'fr'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953035082399780)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('1 param\00E8tre inactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953156934399780)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 param\00E8tres inactifs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844978357399702)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'fr'
,p_message_text=>unistr('Aide de l''\00E9tat interactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855996853399710)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'fr'
,p_message_text=>'Non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849396595399705)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Expression de calcul non valide. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808785270399675)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('La date de fin doit \00EAtre post\00E9rieure \00E0 la date de d\00E9but.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863669442399715)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Expression de filtre non valide. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931413070399764)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Requ\00EAte de filtrage non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953215398399780)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('1 param\00E8tre non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953367482399780)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 param\00E8tres non valides')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904142914399745)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'fr'
,p_message_text=>'(en minutes)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921113802399757)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'fr'
,p_message_text=>'%0 est dans les derniers %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921362960399757)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'fr'
,p_message_text=>'%0 est dans les %1 suivants'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921285877399757)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'fr'
,p_message_text=>'%0 n''est pas dans les derniers %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921431667399757)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'fr'
,p_message_text=>'%0 n''est pas dans les %1 suivants'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854053999399708)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'fr'
,p_message_text=>'Clavier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820121424399684)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847962708399704)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Titre de l''axe pour le libell\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840483541399699)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'fr'
,p_message_text=>'La veille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840644269399699)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'fr'
,p_message_text=>unistr('Derni\00E8re heure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840107029399698)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'fr'
,p_message_text=>'Le mois dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840211835399699)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'fr'
,p_message_text=>unistr('La semaine derni\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840333292399699)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'fr'
,p_message_text=>'Les %0 derniers jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840538972399699)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'fr'
,p_message_text=>unistr('Les %0 derni\00E8res heures')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839923408399698)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 derni\00E8res ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840028568399698)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ann\00E9e derni\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820009964399684)
,p_name=>'APEXIR_LINE'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 courbes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816827313399682)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'fr'
,p_message_text=>'A courbes avec aires'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931388730399764)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'fr'
,p_message_text=>'Mise en correspondance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848838004399705)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'fr'
,p_message_text=>unistr('Selon les estimations, la requ\00EAte d\00E9passe les ressources maximales autoris\00E9es. Modifiez les param\00E8tres de votre \00E9tat et r\00E9essayez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831087063399692)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de lignes pour cet \00E9tat est de %0 lignes. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements dans votre requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931982238399765)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'fr'
,p_message_text=>'Maximum de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932174465399765)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'fr'
,p_message_text=>unistr('M\00E9diane de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835090908399695)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932090831399765)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'fr'
,p_message_text=>'Minimum de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931015993399764)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'fr'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904568149399745)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'fr'
,p_message_text=>'Mensuel'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847118662399704)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847078515399703)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('Tout d\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958291601399784)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID statique de r\00E9gion doit \00EAtre indiqu\00E9, car la page contient plusieurs \00E9tats interactifs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815560405399681)
,p_name=>'APEXIR_NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842909820399701)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle agr\00E9gation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953999046399781)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Nouvelle cat\00E9gorie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111843030877399701)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'fr'
,p_message_text=>'Nouveau calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837898577399697)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840904135399699)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'fr'
,p_message_text=>'Jour suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840727247399699)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'fr'
,p_message_text=>'Heure suivante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841292939399699)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'fr'
,p_message_text=>'Mois suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841185794399699)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'fr'
,p_message_text=>'La semaine prochaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841040300399699)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 prochains jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111840897735399699)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'fr'
,p_message_text=>'%0 prochaines heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841425974399699)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 prochaines ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841307636399699)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9e suivante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815838117399681)
,p_name=>'APEXIR_NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856139144399710)
,p_name=>'APEXIR_NONE'
,p_message_language=>'fr'
,p_message_text=>'- Aucun -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903721312399744)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852693884399707)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'fr'
,p_message_text=>'Valeurs NULL toujours en premier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852520943399707)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'fr'
,p_message_text=>'Valeurs NULL toujours en dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853060012399708)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'fr'
,p_message_text=>'Tri des valeurs NULL %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849485680399705)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'fr'
,p_message_text=>unistr('L''heure de l''op\00E9ration Flashback doit \00EAtre une valeur num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849040228399705)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853503432399708)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Op\00E9rateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814477415399680)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'fr'
,p_message_text=>'orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923375410399758)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'fr'
,p_message_text=>'Orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816371397399681)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'fr'
,p_message_text=>'Autre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799123338399668)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'fr'
,p_message_text=>'Orientation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799839849399669)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'fr'
,p_message_text=>'Paysage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799919081399669)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'fr'
,p_message_text=>'Portrait'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799060027399668)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'fr'
,p_message_text=>'Taille de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799639940399669)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'fr'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799541256399669)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'fr'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799700133399669)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799365153399669)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'fr'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799272056399669)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'fr'
,p_message_text=>'Lettre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111799467864399669)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'fr'
,p_message_text=>unistr('Tablo\00EFd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932445835399765)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage du nombre total de %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931630942399764)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage de la somme totale de %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930642125399764)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage du nombre total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930504245399764)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage de la somme totale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819948247399684)
,p_name=>'APEXIR_PIE'
,p_message_language=>'fr'
,p_message_text=>unistr('Graphique \00E0 secteurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879871460399727)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'fr'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881349143399728)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''agr\00E9gation doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881550384399728)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas effectuer l''agr\00E9gation sur une colonne s\00E9lectionn\00E9e en tant que colonne de ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880762759399728)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880560784399728)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'fr'
,p_message_text=>'Colonne de pivot %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881122857399728)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de pivot doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781244495399656)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre maximal de lignes pour la requ\00EAte Permutation ligne vers colonnes limite le nombre de lignes dans la requ\00EAte de base, et non le nombre de lignes affich\00E9es. La requ\00EAte de base d\00E9passe le nombre de lignes maximal de %0. Appliquez un filtre po')
||unistr('ur r\00E9duire le nombre d''enregistrements dans la requ\00EAte de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881058422399728)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'fr'
,p_message_text=>'Tri de pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850486949399706)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de pivot contient trop de valeurs distinctes : le code SQL de pivot ne peut pas \00EAtre g\00E9n\00E9r\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903811397399744)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9visualiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837914622399697)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111929592028399763)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'fr'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904886205399745)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798978353399668)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Inclure des balises d''accessibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785880775399659)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'fr'
,p_message_text=>'Enlever le texte enrichi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862653680399715)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Priv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820551435399684)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'fr'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816199531399681)
,p_name=>'APEXIR_RED'
,p_message_language=>'fr'
,p_message_text=>'rouge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958140933399784)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID statique de r\00E9gion %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847203499399704)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'fr'
,p_message_text=>'Enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847323772399704)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'fr'
,p_message_text=>'Tout enlever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953415677399780)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'fr'
,p_message_text=>'Enlever le graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846806390399703)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'fr'
,p_message_text=>'Enlever la commande BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846529725399703)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Enlever le filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846692565399703)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'fr'
,p_message_text=>unistr('Enlever l''op\00E9ration Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953524386399781)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'fr'
,p_message_text=>'Enlever le regroupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846919330399703)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enlever la mise en \00E9vidence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953660042399781)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'fr'
,p_message_text=>'Enlever le pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934616735399767)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Enlever le rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915293074399753)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Renommer l''\00E9tat par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856442357399710)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Renommer un \00E9tat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838256217399697)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932517702399765)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'fr'
,p_message_text=>'Etats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812756018399679)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9tat interactif enregistr\00E9 portant l''alias %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862970363399715)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9tat n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812867205399679)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID d''\00E9tat interactif enregistr\00E9, %0, n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111854737875399709)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'fr'
,p_message_text=>unistr('Param\00E8tres d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835554533399695)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'fr'
,p_message_text=>unistr('Vue d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839400464399698)
,p_name=>'APEXIR_RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820798142399684)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Restaurer les param\00E8tres par d\00E9faut de l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815974149399681)
,p_name=>'APEXIR_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928654228399762)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous ne pouvez pas utiliser ROWID en tant que colonne de cl\00E9 primaire pour une source de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845959472399703)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Lignes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905566379399746)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'fr'
,p_message_text=>'Lignes par page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880891129399728)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880693667399728)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'fr'
,p_message_text=>'Colonne de ligne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881262015399728)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de ligne doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881478023399728)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne de ligne doit \00EAtre diff\00E9rente de la colonne de pivot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860058382399713)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtre de ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835653074399695)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'fr'
,p_message_text=>'Ligne %0 sur %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839643220399698)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'fr'
,p_message_text=>'Le texte de ligne contient'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815281529399680)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850035579399706)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat enregistr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849997540399706)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'fr'
,p_message_text=>unistr('Etat enregistr\00E9 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852129991399707)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'fr'
,p_message_text=>unistr('Les param\00E8tres en cours de l''\00E9tat seront utilis\00E9s comme param\00E8tres par d\00E9faut pour tous les utilisateurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111915198212399753)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer l''\00E9tat par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111839391328399698)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer un \00E9tat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953813160399781)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Enregistrer un \00E9tat *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906539554399746)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111844848941399702)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'fr'
,p_message_text=>'Barre de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111953733344399781)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Rechercher : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912086147399750)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Rechercher un \00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896090724399739)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Colonnes s\00E9lectionn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816946380399682)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une colonne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838660056399697)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner des colonnes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820414100399684)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une fonction -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845651473399702)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner une colonne de regroupement -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880351741399727)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner la colonne de pivot -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931511294399764)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880433106399728)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('- S\00E9lectionner la colonne de ligne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789182105399661)
,p_name=>'APEXIR_SEND'
,p_message_language=>'fr'
,p_message_text=>'Envoyer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795412319399666)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'fr'
,p_message_text=>'Envoyer en tant que courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815645341399681)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838823305399698)
,p_name=>'APEXIR_SORT'
,p_message_language=>'fr'
,p_message_text=>'Trier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848174911399704)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'fr'
,p_message_text=>'Trier par ordre croissant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848243459399704)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'fr'
,p_message_text=>unistr('Trier par ordre d\00E9croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934025751399766)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'fr'
,p_message_text=>'Ordre de tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842678143399700)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'fr'
,p_message_text=>'espace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853733438399708)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'fr'
,p_message_text=>'Statut %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904202033399745)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930948744399764)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'fr'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785321349399659)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'fr'
,p_message_text=>unistr('Ignorer si aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111930818160399764)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'fr'
,p_message_text=>'A partir de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931795157399765)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'fr'
,p_message_text=>'Total de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921774143399757)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion = %0, \00E9tat = %1, vue = %2, d\00E9but des lignes affich\00E9es = %3, fin des lignes affich\00E9es = %4, nombre total de lignes = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842383509399700)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion = %0, \00E9tat = %1, vue = %2, d\00E9but des lignes affich\00E9es = %3, fin des lignes affich\00E9es = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814561942399680)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'fr'
,p_message_text=>'Couleur du texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831662245399692)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'fr'
,p_message_text=>'jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831589540399692)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'fr'
,p_message_text=>'heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831461680399692)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'fr'
,p_message_text=>'minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831857295399693)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'fr'
,p_message_text=>'mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831790464399692)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'fr'
,p_message_text=>'semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111831941619399693)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111934429338399767)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer/d\00E9sactiver')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847456249399704)
,p_name=>'APEXIR_TOP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927608490399761)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne sans groupe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848948879399705)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom de mise en \00E9vidence doit \00EAtre unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819244432399683)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('type de donn\00E9es non pris en charge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847585922399704)
,p_name=>'APEXIR_UP'
,p_message_language=>'fr'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849100520399705)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'fr'
,p_message_text=>'Entrez une couleur valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849210643399705)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'fr'
,p_message_text=>'Entrez un masque de format valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111816421444399681)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'fr'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111848082387399704)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre de l''axe pour la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855808765399710)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Valeur requise'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819814498399684)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111923558404399759)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'fr'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855122633399709)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'fr'
,p_message_text=>'Visualiser le graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910393867399749)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Voir le d\00E9tail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111955995453399782)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La vue %0 n''est pas d\00E9finie pour l''\00E9tat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910497992399749)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'fr'
,p_message_text=>'Visualiser le groupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910294372399749)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4nes Vue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880187511399727)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'fr'
,p_message_text=>'Afficher le pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111855202369399709)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Voir l''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904400362399745)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'fr'
,p_message_text=>'Hebdomadaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838179556399697)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933119853399766)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'fr'
,p_message_text=>'%0 jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933088286399766)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'fr'
,p_message_text=>'%0 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111932990587399765)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'fr'
,p_message_text=>'%0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933346703399766)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'fr'
,p_message_text=>'%0 mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933205230399766)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'fr'
,p_message_text=>'%0 semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111933400642399766)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'fr'
,p_message_text=>'%0 ans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111931198946399764)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('Ann\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111814294418399680)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'fr'
,p_message_text=>'jaune'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111815759551399681)
,p_name=>'APEXIR_YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111847898091399704)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 contient < ou >, qui ne sont pas des caract\00E8res valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111870670003399721)
,p_name=>'APEX_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9gion')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111798850357399668)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'fr'
,p_message_text=>unistr('La condition pr\00E9alable de l''API n''a pas \00E9t\00E9 respect\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818301975399683)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''obtenir la valeur du param\00E8tre d''application %0 car l''option de construction associ\00E9e est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818245447399683)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de d\00E9finir la valeur du param\00E8tre d''application %0 car l''option de construction associ\00E9e est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925908795399760)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur du param\00E8tre d''application %0 n''est pas valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111925808334399760)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le param\00E8tre d''application demand\00E9 %0 n''est pas d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926015483399760)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Le param\00E8tre d''application %0 ne peut pas \00EAtre d\00E9fini sur une valeur NULL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806968055399674)
,p_name=>'BACK'
,p_message_language=>'fr'
,p_message_text=>'Retour'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793937719399665)
,p_name=>'BUILDER'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9n\00E9rateur')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858017631399711)
,p_name=>'BUTTON LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9 de bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793063520399664)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'fr'
,p_message_text=>'Classes CSS de bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822239383399686)
,p_name=>'BUTTON_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de bouton g\00E9n\00E9r\00E9 sera l''ID statique du bouton, s''il est d\00E9fini ; dans le cas contraire il s''agira d''un ID g\00E9n\00E9r\00E9 en interne au format ''B'' || [ID de bouton interne]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785798647399659)
,p_name=>'CANDLESTICK'
,p_message_language=>'fr'
,p_message_text=>'Chandelier'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867294396399718)
,p_name=>'CENTER'
,p_message_language=>'fr'
,p_message_text=>'Au centre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817238489399682)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'fr'
,p_message_text=>'%0 - Demande'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808652734399675)
,p_name=>'CHECK$'
,p_message_language=>'fr'
,p_message_text=>unistr('s\00E9lecteur de ligne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111927735248399762)
,p_name=>'CHECKED'
,p_message_language=>'fr'
,p_message_text=>unistr('s\00E9lectionn\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903242151399744)
,p_name=>'COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Colonne'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863782593399716)
,p_name=>'COMMENTS'
,p_message_language=>'fr'
,p_message_text=>'Commentaires'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845299906399702)
,p_name=>'CONTINUE'
,p_message_language=>'fr'
,p_message_text=>'Continuer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807218580399674)
,p_name=>'COPYRIGHT'
,p_message_language=>'fr'
,p_message_text=>unistr('Copyright &copy; %0, Tous droits r\00E9serv\00E9s.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850923912399706)
,p_name=>'COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857694470399711)
,p_name=>'CREATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909983244399749)
,p_name=>'CREATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910054888399749)
,p_name=>'CREATED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834822234399695)
,p_name=>'CREATED_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Date/heure de cr\00E9ation')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845436684399702)
,p_name=>'CUSTOM'
,p_message_language=>'fr'
,p_message_text=>unistr('Personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856660235399710)
,p_name=>'CUSTOMIZE'
,p_message_language=>'fr'
,p_message_text=>'Personnaliser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858206565399712)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rences de page r\00E9initialis\00E9es pour l''utilisateur %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858380600399712)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Les pr\00E9f\00E9rences ont \00E9t\00E9 modifi\00E9es pour l''utilisateur %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858181386399712)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9f\00E9rences de page r\00E9initialis\00E9es pour l''utilisateur %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821958026399685)
,p_name=>'DAILY'
,p_message_language=>'fr'
,p_message_text=>'Quotidien'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111793587660399664)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le fichier charg\00E9 n''est pas valide ou son extension est incorrecte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817433489399682)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lecteur JSON ou XML non valide utilis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786710880399660)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le profil de donn\00E9es et le fichier t\00E9l\00E9charg\00E9 ne contiennent pas de colonne de table cible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872473785399722)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e dans le fichier t\00E9l\00E9charg\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872577452399722)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e dans la feuille de calcul "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111792376648399664)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le fichier indiqu\00E9 n''est pas un fichier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111782789973399657)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : %0 lignes trait\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783935250399658)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : %0 lignes trait\00E9es avec 1 erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784297253399658)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : %0 lignes trait\00E9es avec %1 erreurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784013819399658)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : 1 ligne trait\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787080981399660)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : 1 ligne trait\00E9e avec erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784182137399658)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : 1 ligne trait\00E9e sans erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877738183399726)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'fr'
,p_message_text=>'Colonne cible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877850897399726)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'fr'
,p_message_text=>'Colonne source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878695493399726)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format date/nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942090236399772)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'fr'
,p_message_text=>'Echec de l''extraction de la valeur de recherche.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111910546730399749)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'fr'
,p_message_text=>unistr('Mapping de table/donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878719706399726)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'fr'
,p_message_text=>'Ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874294298399723)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la r\00E8gle de transformation')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850539878399706)
,p_name=>'DATE'
,p_message_language=>'fr'
,p_message_text=>'Date'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824619418399687)
,p_name=>'DAY'
,p_message_language=>'fr'
,p_message_text=>'jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824742395399687)
,p_name=>'DAYS'
,p_message_language=>'fr'
,p_message_text=>'jours'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863421445399715)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'fr'
,p_message_text=>unistr('Le d\00E9bogage n''est pas activ\00E9 pour cette application.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111912217463399750)
,p_name=>'DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825454057399688)
,p_name=>'DELETE'
,p_message_language=>'fr'
,p_message_text=>'supprimer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111785668196399659)
,p_name=>'DIAL_PCT'
,p_message_language=>'fr'
,p_message_text=>'Cadran (pourcentage)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800128234399669)
,p_name=>'DOWNLOAD'
,p_message_language=>'fr'
,p_message_text=>unistr('T\00E9l\00E9charger en local')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911344615399750)
,p_name=>'DUP_USER'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur en double dans la liste.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807726861399675)
,p_name=>'EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817190766399682)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('L''adresse \00E9lectronique "%0" est introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802214812399671)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce courriel a \00E9t\00E9 envoy\00E9 par %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911539990399750)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('L''adresse \00E9lectronique est trop longue. La limite est de 240 caract\00E8res.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845182259399702)
,p_name=>'ERROR'
,p_message_language=>'fr'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874342928399723)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de d\00E9finir la valeur de source de l''\00E9l\00E9ment de page pour la r\00E9gion de r\00E9g\00E9n\00E9ration de page partielle.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836695709399696)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Cr\00E9\00E9 par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802523985399671)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mot de passe arriv\00E9 \00E0 expiration')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111796607225399667)
,p_name=>'FILE_EMPTY'
,p_message_language=>'fr'
,p_message_text=>'Le fichier est vide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876818709399725)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'fr'
,p_message_text=>unistr('La taille du fichier t\00E9l\00E9charg\00E9 d\00E9passe %0 Mo. T\00E9l\00E9chargez un fichier plus petit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804695046399672)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''authentification de l''utilisateur a \00E9chou\00E9 et des fichiers n''ont pas \00E9t\00E9 t\00E9l\00E9charg\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804718087399673)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''instance n''autorise pas les utilisateurs non authentifi\00E9s \00E0 t\00E9l\00E9charger des fichiers.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857733317399711)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'fr'
,p_message_text=>'1 erreur s''est produite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856990125399711)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'fr'
,p_message_text=>'%0 erreurs se sont produites'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807130150399674)
,p_name=>'FORM_OF'
,p_message_language=>'fr'
,p_message_text=>'%0 sur %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841845331399700)
,p_name=>'GO'
,p_message_language=>'fr'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941678180399772)
,p_name=>'HELP'
,p_message_language=>'fr'
,p_message_text=>'Aide'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794099106399665)
,p_name=>'HOME'
,p_message_language=>'fr'
,p_message_text=>'Accueil'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824440788399687)
,p_name=>'HOUR'
,p_message_language=>'fr'
,p_message_text=>'heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824527648399687)
,p_name=>'HOURS'
,p_message_language=>'fr'
,p_message_text=>'heures'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808560820399675)
,p_name=>'ICON'
,p_message_language=>'fr'
,p_message_text=>unistr('Ic\00F4ne %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858588610399712)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'fr'
,p_message_text=>'Informations d''identification non valides'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111958002107399784)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur non valide pour le param\00E8tre : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853270658399708)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'fr'
,p_message_text=>unistr('Comme param\00E8tre d''\00E9tat par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853387648399708)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'fr'
,p_message_text=>unistr('Comme \00E9tat nomm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835777688399695)
,p_name=>'IR_ERROR'
,p_message_language=>'fr'
,p_message_text=>'%0 erreur. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835411875399695)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'fr'
,p_message_text=>'Impossible de calculer la navigation du panneau. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813065137399679)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Etat interactif introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812449189399678)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9gion d''\00E9tat interactif n''existe pas dans l''application %0, la page %1 et la r\00E9gion %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111853115771399708)
,p_name=>'IR_STAR'
,p_message_language=>'fr'
,p_message_text=>unistr('S''affiche uniquement pour les d\00E9veloppeurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841583508399699)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte d''\00E9tat requiert une cl\00E9 unique pour identifier chaque ligne. La cl\00E9 fournie est inutilisable pour cette requ\00EAte. D\00E9finissez une colonne de cl\00E9 unique. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841622021399700)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'fr'
,p_message_text=>unistr('La requ\00EAte d''\00E9tat requiert une cl\00E9 unique pour identifier chaque ligne. La cl\00E9 fournie est inutilisable pour cette requ\00EAte. Modifiez les attributs d''\00E9tat pour d\00E9finir une colonne de cl\00E9 unique. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878982507399727)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner un fichier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878856807399726)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'fr'
,p_message_text=>unistr('Glisser et d\00E9placer le fichier ici ou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807491125399675)
,p_name=>'ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836800370399696)
,p_name=>'ITEM_VALUE'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur d''\00E9l\00E9ment')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851226662399706)
,p_name=>'LABEL'
,p_message_language=>'fr'
,p_message_text=>unistr('Libell\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863391279399715)
,p_name=>'LANGUAGE'
,p_message_language=>'fr'
,p_message_text=>'Langue'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825125897399688)
,p_name=>'LAST'
,p_message_language=>'fr'
,p_message_text=>'dernier'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804594375399672)
,p_name=>'LENGTH'
,p_message_language=>'fr'
,p_message_text=>'Longueur'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857846444399711)
,p_name=>'LOGIN'
,p_message_language=>'fr'
,p_message_text=>'Connexion'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896479959399739)
,p_name=>'MANAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('G\00E9rer')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961062580399786)
,p_name=>'MAXIMIZE'
,p_message_language=>'fr'
,p_message_text=>'Agrandir'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824264089399687)
,p_name=>'MINUTE'
,p_message_language=>'fr'
,p_message_text=>'minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824307770399687)
,p_name=>'MINUTES'
,p_message_language=>'fr'
,p_message_text=>'minutes'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911712237399750)
,p_name=>'MISSING_AT'
,p_message_language=>'fr'
,p_message_text=>unistr('"@" manquant dans l''adresse \00E9lectronique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911976652399750)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'fr'
,p_message_text=>unistr('Avertissement : aucun mod\00E8le de page de bo\00EEte de dialogue n''a \00E9t\00E9 d\00E9fini pour la page de bo\00EEte de dialogue %0 dans l''application %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911663450399750)
,p_name=>'MISSING_DOT'
,p_message_language=>'fr'
,p_message_text=>unistr('"." manquant dans le domaine d''adresse \00E9lectronique.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860824376399713)
,p_name=>'MODULE'
,p_message_language=>'fr'
,p_message_text=>'Module'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817928312399682)
,p_name=>'MONTH'
,p_message_language=>'fr'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821734529399685)
,p_name=>'MONTHLY'
,p_message_language=>'fr'
,p_message_text=>'Mensuel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818003303399682)
,p_name=>'MONTHS'
,p_message_language=>'fr'
,p_message_text=>'mois'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850872218399706)
,p_name=>'MOVE'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918369666399755)
,p_name=>'MOVE_FROM'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer \00E0 partir de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918470903399755)
,p_name=>'MOVE_TO'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9placer vers')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111838055510399697)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur dans l''op\00E9ration de suppression multiligne : lignes = %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837073265399696)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'fr'
,p_message_text=>unistr('Ne doit pas \00EAtre un utilisateur public')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794266812399665)
,p_name=>'NAME'
,p_message_language=>'fr'
,p_message_text=>'Nom'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851069461399706)
,p_name=>'NEW'
,p_message_language=>'fr'
,p_message_text=>'Nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817769004399682)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvez vous connecter \00E0 %0 en acc\00E9dant \00E0 :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817880565399682)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>'Notification du nouveau compte %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941837787399772)
,p_name=>'NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860720466399713)
,p_name=>'NO'
,p_message_language=>'fr'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111956014324399782)
,p_name=>'NOBODY'
,p_message_language=>'fr'
,p_message_text=>'personne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825587565399688)
,p_name=>'NOT'
,p_message_language=>'fr'
,p_message_text=>'N''est pas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866374134399717)
,p_name=>'NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'Non NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837147419399696)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'fr'
,p_message_text=>'N''est pas %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856703191399710)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865873796399717)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucun \00E9tat modifiable n''a \00E9t\00E9 trouv\00E9. Les op\00E9rations de mise \00E0 jour et de suppression multilignes ne peuvent \00EAtre effectu\00E9es que sur des panneaux tabulaires de type ''Etat modifiable''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866797195399718)
,p_name=>'OK'
,p_message_language=>'fr'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862459953399715)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'fr'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111959850109399785)
,p_name=>'ORA_06550'
,p_message_language=>'fr'
,p_message_text=>'ORA-06550 : ligne %0, colonne %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909353055399748)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre navigateur Web est obsol\00E8te. Pour obtenir une liste des navigateurs Web pris en charge, reportez-vous au manuel Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810791086399677)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ensemble de lignes demand\00E9 n''est pas valide : les donn\00E9es source de l''\00E9tat ont \00E9t\00E9 modifi\00E9es.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830871795399692)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Un num\00E9ro de page valide doit \00EAtre indiqu\00E9, par exemple p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834425586399694)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'fr'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834540923399694)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'fr'
,p_message_text=>'Ensemble suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834606536399694)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111834720962399695)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'fr'
,p_message_text=>unistr('Ensemble pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941748367399772)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner la pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872362364399722)
,p_name=>'PASSWORD'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817086897399682)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('Votre mot de passe pour %0 a \00E9t\00E9 modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806810208399674)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mot de passe n''est pas conforme aux r\00E8gles de complexit\00E9 de mot de passe de ce site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805997535399673)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nouveau mot de passe doit comporter au moins %0 caract\00E8res diff\00E9rents de l''ancien mot de passe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806526445399674)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe ne doit pas contenir de nom utilisateur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806749263399674)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe contient un mot simple interdit.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806659811399674)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe ne doit pas contenir de nom d''espace de travail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805848551399673)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mot de passe doit contenir au moins %0 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806030895399673)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe doit contenir au moins une lettre (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806450591399674)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe doit contenir au moins une lettre minuscule.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806152465399674)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe doit contenir au moins un chiffre (0123456789).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806206081399674)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe doit contenir au moins un signe de ponctuation (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111806329921399674)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'fr'
,p_message_text=>'Le mot de passe doit contenir au moins une lettre majuscule.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817574022399682)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Notification de r\00E9initialisation du mot de passe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804848135399673)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mot de passe ne peut pas \00EAtre utilis\00E9 car il l''a d\00E9j\00E0 \00E9t\00E9 au cours des %0 derniers jours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885163818399731)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111885248536399731)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'fr'
,p_message_text=>unistr('El\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862276293399714)
,p_name=>'PERCENT'
,p_message_language=>'fr'
,p_message_text=>'Pourcentage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832501066399693)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'fr'
,p_message_text=>'Contactez l''administrateur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111941963335399772)
,p_name=>'PREVIOUS'
,p_message_language=>'fr'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877300415399725)
,p_name=>'PRINT'
,p_message_language=>'fr'
,p_message_text=>'Imprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861088250399714)
,p_name=>'PRIVILEGES'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ges')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830917526399692)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9f\00E9rences de r\00E9gion')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851170752399706)
,p_name=>'REPORT'
,p_message_language=>'fr'
,p_message_text=>'Etat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860972297399714)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'fr'
,p_message_text=>unistr('P\00E9riode de g\00E9n\00E9ration d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942138216399772)
,p_name=>'REPORT_LABEL'
,p_message_language=>'fr'
,p_message_text=>'Etat : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861643865399714)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre total d''\00E9tats')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810825132399677)
,p_name=>'RESET'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836770229399696)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser la pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865732003399717)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9initialiser le mot de passe')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842555186399700)
,p_name=>'RESTORE'
,p_message_language=>'fr'
,p_message_text=>'Restaurer'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111874451201399723)
,p_name=>'RESULTS'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9sultats')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866895713399718)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Retour \00E0 l''application')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111867129586399718)
,p_name=>'RIGHT'
,p_message_language=>'fr'
,p_message_text=>'A droite'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896718587399739)
,p_name=>'ROW'
,p_message_language=>'fr'
,p_message_text=>'Ligne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850765905399706)
,p_name=>'ROW_COUNT'
,p_message_language=>'fr'
,p_message_text=>'Nombre de lignes'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111866218800399717)
,p_name=>'SAVE'
,p_message_language=>'fr'
,p_message_text=>'Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862825353399715)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Val. par d\00E9faut du rempla\00E7ant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863225379399715)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'fr'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862779962399715)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Val. par d\00E9faut du principal')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863593144399715)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'fr'
,p_message_text=>unistr('Plus de %0 lignes sont disponibles. Augmentez le s\00E9lecteur de lignes pour afficher plus de lignes.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928928285399762)
,p_name=>'SEARCH'
,p_message_language=>'fr'
,p_message_text=>'Rechercher'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824116642399687)
,p_name=>'SECONDS'
,p_message_language=>'fr'
,p_message_text=>'secondes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862376170399715)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'fr'
,p_message_text=>unistr('Consulter la pi\00E8ce jointe')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920004488399756)
,p_name=>'SELECT_ROW'
,p_message_language=>'fr'
,p_message_text=>unistr('S\00E9lectionner une ligne')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862080717399714)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9sactiver le mode lecteur d''\00E9cran')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862173481399714)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'fr'
,p_message_text=>unistr('Activer le mode lecteur d''\00E9cran')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858421337399712)
,p_name=>'SHOW'
,p_message_language=>'fr'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921815498399757)
,p_name=>'SHOW_ALL'
,p_message_language=>'fr'
,p_message_text=>'Afficher tout'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111947935246399776)
,p_name=>'SIGN_IN'
,p_message_language=>'fr'
,p_message_text=>'Connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111897599925399740)
,p_name=>'SIGN_OUT'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9connexion')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851754356399707)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'fr'
,p_message_text=>'Depuis %0 jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858921829399712)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'Dans %0 jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851674515399707)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858868752399712)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 heures \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851505925399707)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858767762399712)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 minutes \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851908100399707)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859154435399712)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>'Dans %0 mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859399446399712)
,p_name=>'SINCE_NOW'
,p_message_language=>'fr'
,p_message_text=>'Maintenant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851440380399707)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 secondes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111858628846399712)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 secondes \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111851892454399707)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859007913399712)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 semaines \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111852056180399707)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'fr'
,p_message_text=>'Il y a %0 ans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859270792399712)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 ann\00E9es \00E0 partir de maintenant')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845576903399702)
,p_name=>'STANDARD'
,p_message_language=>'fr'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861933769399714)
,p_name=>'START_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Date de d\00E9but')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802486028399671)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce courriel provient d''un abonnement \00E0 l''\00E9tat interactif cr\00E9\00E9 par %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957167228399783)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'fr'
,p_message_text=>'Abonnements'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905223559399745)
,p_name=>'TAB'
,p_message_language=>'fr'
,p_message_text=>'Onglet'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824028740399687)
,p_name=>'TITLE'
,p_message_language=>'fr'
,p_message_text=>'Titre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807088191399674)
,p_name=>'TODAY'
,p_message_language=>'fr'
,p_message_text=>'Aujourd''hui'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861580790399714)
,p_name=>'TOTAL'
,p_message_language=>'fr'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808017507399675)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Un maximum de %0 colonnes peut \00EAtre s\00E9lectionn\00E9.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786568515399659)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire tout')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786837162399660)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'fr'
,p_message_text=>unistr('R\00E9duire tous les \00E9l\00E9ments en dessous')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786429987399659)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper tout')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786699835399660)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9velopper tous les \00E9l\00E9ments en dessous')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786928561399660)
,p_name=>'TREE.REPARENT'
,p_message_language=>'fr'
,p_message_text=>'Affecter un nouveau parent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879161024399727)
,p_name=>'TREES'
,p_message_language=>'fr'
,p_message_text=>'Arborescences'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111922640722399758)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Requis'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111846205830399703)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Non autoris\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111893076258399737)
,p_name=>'UNAVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Non disponible'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859730600399713)
,p_name=>'UNKNOWN'
,p_message_language=>'fr'
,p_message_text=>'Inconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803363001399672)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Une erreur d''authentification non identifi\00E9e s''est produite.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805344192399673)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'fr'
,p_message_text=>unistr('Si vous ne souhaitez plus recevoir de courriels, cliquez sur <a href="%0">Annuler l''abonnement</a> pour g\00E9rer votre abonnement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111802361686399671)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Si vous ne souhaitez plus recevoir de courriels, acc\00E9dez \00E0 l''URL suivante pour g\00E9rer votre abonnement :')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111837243737399696)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('type de donn\00E9es non pris en charge')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825331447399688)
,p_name=>'UPDATE'
,p_message_language=>'fr'
,p_message_text=>unistr('mettre \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823992744399687)
,p_name=>'UPDATED'
,p_message_language=>'fr'
,p_message_text=>unistr('Mis \00E0 jour')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830629316399692)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''URL demand\00E9e est interdite. Contactez l''administrateur.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111850668106399706)
,p_name=>'USER'
,p_message_language=>'fr'
,p_message_text=>'Utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111872290737399722)
,p_name=>'USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911847708399750)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom utilisateur est trop long. La limite est de %0 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857439056399711)
,p_name=>'USERS'
,p_message_language=>'fr'
,p_message_text=>'utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111911458904399750)
,p_name=>'USER_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nom utilisateur existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111926192645399760)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'fr'
,p_message_text=>'Image de profil de l''utilisateur %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813756747399679)
,p_name=>'VALID'
,p_message_language=>'fr'
,p_message_text=>'Valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807380901399674)
,p_name=>'VALIDATIONS'
,p_message_language=>'fr'
,p_message_text=>'Validations'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863096283399715)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre indiqu\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906458771399746)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer la valeur pour %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832977507399693)
,p_name=>'VERTICAL'
,p_message_language=>'fr'
,p_message_text=>'vertical'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825258903399688)
,p_name=>'VIEW'
,p_message_language=>'fr'
,p_message_text=>'visualiser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857539151399711)
,p_name=>'VIEWS'
,p_message_language=>'fr'
,p_message_text=>'vues'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863851424399716)
,p_name=>'VIEW_ALL'
,p_message_language=>'fr'
,p_message_text=>'Visualiser tout'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111845043548399702)
,p_name=>'WARNING'
,p_message_language=>'fr'
,p_message_text=>'Avertissement'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824828907399687)
,p_name=>'WEEK'
,p_message_language=>'fr'
,p_message_text=>'semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821883651399685)
,p_name=>'WEEKLY'
,p_message_language=>'fr'
,p_message_text=>'Hebdomadaire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111824943709399687)
,p_name=>'WEEKS'
,p_message_language=>'fr'
,p_message_text=>'semaines'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111863196146399715)
,p_name=>'WELCOME_USER'
,p_message_language=>'fr'
,p_message_text=>'Bienvenue, %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861319178399714)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'fr'
,p_message_text=>unistr('Une valeur non valide a \00E9t\00E9 trouv\00E9e. V\00E9rifiez les donn\00E9es saisies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861407911399714)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Une valeur non valide a \00E9t\00E9 trouv\00E9e. V\00E9rifiez les donn\00E9es saisies.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804467803399672)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur de date non valide. V\00E9rifiez le format de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111861277891399714)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'fr'
,p_message_text=>unistr('Une valeur num\00E9rique non valide a \00E9t\00E9 trouv\00E9e. V\00E9rifiez le format num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813367400399679)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur d''horodatage non valide. V\00E9rifiez le format d''horodatage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111835881878399695)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Liaison impossible pour "%0". Utilisez des guillemets pour les \00E9l\00E9ments multioctets ou assurez-vous que la longueur de l''\00E9l\00E9ment est inf\00E9rieure ou \00E9gale \00E0 30 octets. Pour faire r\00E9f\00E9rence \00E0 des \00E9l\00E9ments d''une longueur sup\00E9rieure \00E0 30 octets, utilisez ')
||'la syntaxe v().'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826355364399688)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s refus\00E9 par le contr\00F4le de s\00E9curit\00E9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828837052399690)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>'Application non disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827244294399689)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1014 : Application introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827326047399689)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'fr'
,p_message_text=>'application=%0  espace de travail=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827732818399690)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''acc\00E8s \00E0 cette application est limit\00E9. Ressayez plus tard.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827699305399689)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'fr'
,p_message_text=>unistr('L''acc\00E8s \00E0 cette application est r\00E9serv\00E9 aux d\00E9veloppeurs d''application ; ressayez plus tard.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826839952399689)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'fr'
,p_message_text=>'ERR-7744 Impossible de traiter un branchement sur une fonction renvoyant une URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826741289399689)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-7744 Impossible de traiter un branchement sur une fonction renvoyant une page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827021189399689)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1430 Appel au processus d''affichage \00E0 partir de la page non pris en charge : G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828133152399690)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1018 Erreur lors du nettoyage du cache d''\00E9tape.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826503050399689)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'fr'
,p_message_text=>'ERR-1005 Type de calcul inconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827402451399689)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1201 ID de session non d\00E9fini pour authentification personnalis\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827552536399689)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'fr'
,p_message_text=>'page=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111827108787399689)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-7620 Impossible de d\00E9terminer l''espace de travail de l''application (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809599270399676)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'fr'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826240771399688)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1802 ID \00E9l\00E9ment "%0" introuvable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825929332399688)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1002 ID d''\00E9l\00E9ment introuvable pour l''\00E9l\00E9ment "%0" dans l''application "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826037431399688)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur inattendue, nom d''\00E9l\00E9ment introuvable au niveau application ou page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826438566399689)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous \00EAtes d\00E9j\00E0 dans la premi\00E8re page de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111841943838399700)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de l''\00E9l\00E9ment (%0) n''est pas d\00E9fini sur la page en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804021309399672)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment ne peut pas \00EAtre d\00E9fini par la transmission d''arguments \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804364937399672)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'fr'
,p_message_text=>unistr('(Aucun checksum n''a \00E9t\00E9 fourni)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803829442399672)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini lorsqu''il est accompagn\00E9 d''un checksum de type "signet de niveau utilisateur".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803700812399672)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini lorsqu''il est accompagn\00E9 d''un checksum de type "signet de niveau application".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803913219399672)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini lorsqu''il est accompagn\00E9 d''un checksum de type "session".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803661478399672)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'fr'
,p_message_text=>unistr('L''\00E9l\00E9ment n''a pas de protection.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828215398399690)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'fr'
,p_message_text=>'Aucune aide n''est disponible pour la page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111817332033399682)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail %0 n''est pas autoris\00E9 \00E0 effectuer une analyse en tant que sch\00E9ma %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826682862399689)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1010 Branchement sur un traitement d''acceptation de page : limite de r\00E9cursivit\00E9 d\00E9pass\00E9e. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804283092399672)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette page ne peut pas \00EAtre appel\00E9e via une URL ou au moyen de GET ou POST vers la proc\00E9dure d''affichage. Elle doit \00EAtre appel\00E9e \00E0 l''aide d''un branchement de type "Branchement sur une page".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111880929785399728)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la tentative d''enregistrement d''une valeur non num\00E9rique dans l''\00E9l\00E9ment %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819060164399683)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Le sch\00E9ma d''analyse "%0" de l''application n''existe pas dans la base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111819118324399683)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'fr'
,p_message_text=>unistr('Les comptes de l''espace de travail INTERNAL ne peuvent \00EAtre utilis\00E9s que pour acc\00E9der \00E0 &PRODUCT_NAME. <a href="%0">Services d''administration</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825837276399688)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-1029 Impossible de stocker les infos de session. session=%0 \00E9l\00E9ment=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828981661399690)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''arr\00EAter la trace : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111826112906399688)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur inattendue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836178280399696)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur dans update_substitution_cache : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829005243399690)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('L''application et la page doivent \00EAtre indiqu\00E9es pour l''affichage de l''aide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111849538313399705)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Automatisation introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830175291399691)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 sessions ont \00E9t\00E9 purg\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789452825399662)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''ex\00E9cuter le code %0. Il n''est pas pris en charge par la base de donn\00E9es ou n''est pas activ\00E9 par le param\00E8tre d''instance MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111789202626399661)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>unistr('Multilingual Engine n''est pas disponible pour cette version de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810075429399676)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'Le tableau de collection d''applications ne doit pas avoir la valeur Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809886614399676)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Le num\00E9ro d''attribut de membre indiqu\00E9, %0, n''est pas valide. Le num\00E9ro d''attribut doit \00EAtre compris entre 1 et %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810387002399677)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'fr'
,p_message_text=>'La collection d''applications existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810114387399677)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'fr'
,p_message_text=>'Le nom de collection ne doit pas avoir la valeur Null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810298247399677)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'fr'
,p_message_text=>unistr('La longueur du nom de collection ne doit pas d\00E9passer 255 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809621464399676)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>'La collection d''applications %0 n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810417253399677)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'fr'
,p_message_text=>'Le curseur n''est pas encore ouvert.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809719393399676)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La s\00E9quence de membre %0 n''existe pas dans la collection d''applications %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111809952799399676)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La s\00E9quence de membre %0 n''existe pas dans la collection d''applications "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881793919399728)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonction de cryptographie %0 n''est pas prise en charge sur ce syst\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935235217399767)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Accessibilit\00E9 test\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829645226399691)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'fr'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829768089399691)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'fr'
,p_message_text=>'Options de personnalisation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829871243399691)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829907937399691)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affich\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830035119399691)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Masqu\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829450648399691)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'fr'
,p_message_text=>unistr('Cochez les r\00E9gions que vous voulez inclure dans la page. Les r\00E9gions coch\00E9es peuvent ne pas s''afficher si vous n''\00EAtes pas dans le bon contexte applicatif ou si vous ne disposez pas des privil\00E8ges appropri\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829577468399691)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'fr'
,p_message_text=>'Vous ne pouvez pas personnaliser cette page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935581450399767)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous pouvez personnaliser l''apparence de cette application en modifiant le style de th\00E8me. S\00E9lectionnez un style de th\00E8me dans la liste ci-dessous et cliquez sur Appliquer les modifications.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111936336037399768)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'fr'
,p_message_text=>unistr('Affichage de la r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935405612399767)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'fr'
,p_message_text=>unistr('Utiliser le style par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111935388510399767)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'fr'
,p_message_text=>'Apparence '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878364538399726)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''index de colonne r\00E9f\00E9renc\00E9 dans l''\00E9l\00E9ment %0 agr\00E9g\00E9 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781674635399656)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>'La sortie CLOB n''est pas prise en charge pour le format %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878049747399726)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'fr'
,p_message_text=>unistr('La section de colonne doit appara\00EEtre au d\00E9but du tableau de colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878144933399726)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''index de groupe de colonnes r\00E9f\00E9renc\00E9 dans %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111795657754399666)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'fr'
,p_message_text=>'export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111800824991399670)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'fr'
,p_message_text=>unistr('Le format d''export doit \00EAtre XML, avec ORDS comme serveur d''impression.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878405669399726)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''index de colonne r\00E9f\00E9renc\00E9 dans l''\00E9l\00E9ment %0 de mise en \00E9vidence n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794135248399665)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'fr'
,p_message_text=>'Format d''export non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111878222473399726)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('L''index de groupe parent r\00E9f\00E9renc\00E9 dans %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111903437956399744)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne %1 de la table %0 est une colonne d''identit\00E9 cr\00E9\00E9e avec "GENERATED ALWAYS". V\00E9rifiez qu''aucune colonne source n''est mise en correspondance avec la colonne %1 dans la bo\00EEte de dialogue Configurer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820826529399685)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'fr'
,p_message_text=>unistr('L''intervalle de validation (commit) indiqu\00E9 est trop petit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111820961276399685)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne n''a \00E9t\00E9 fournie pour le chargement des donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822135544399685)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne trouv\00E9e pour le s\00E9lecteur de ligne "%0". Essayez d''effectuer une d\00E9tection automatique ou de v\00E9rifier la structure JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830497644399691)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'fr'
,p_message_text=>'Feuilles de calcul introuvables dans le fichier XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830306231399691)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'fr'
,p_message_text=>unistr('La feuille de calcul indiqu\00E9e n''existe pas dans le fichier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111810502920399677)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'fr'
,p_message_text=>unistr('La version en cours des donn\00E9es dans la base a chang\00E9 depuis que l''utilisateur a lanc\00E9 le traitement de mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812950825399679)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la mise \00E0 jour des colonnes d''\00E9tat : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917613844399754)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'fr'
,p_message_text=>'Impossible de convertir %0 en SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857187128399711)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de convertir la colonne %0 dont le type de donn\00E9es est %1 en VARCHAR2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864145929399716)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne "%0" indiqu\00E9e pour l''attribut "%1" est introuvable dans la source de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805467591399673)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Le type de filtre %0 n''est pas pris en charge pour les colonnes multivaleurs.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111921066600399757)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'fr'
,p_message_text=>'Filtre "Entre" non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787537224399660)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de liste de valeurs indiqu\00E9 non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787410808399660)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Type de requ\00EAte non valide. Le type de requ\00EAte doit \00EAtre une table, une requ\00EAte SQL ou une fonction PL/SQL renvoyant une requ\00EAte SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857284235399711)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Echec de l''analyse de la requ\00EAte SQL.'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864256421399716)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('La position de colonne %0 indiqu\00E9e pour l''attribut "%1" est introuvable dans l''instruction SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111786030965399659)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'fr'
,p_message_text=>unistr('Trop d''\00E9l\00E9ments utilis\00E9s dans le filtre \00E0 plusieurs valeurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864030126399716)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne indiqu\00E9e pour l''attribut "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787322558399660)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le corps de fonction PL/SQL n''a renvoy\00E9 aucune valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111877270692399725)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'fr'
,p_message_text=>unistr('La source de donn\00E9es REST ne dispose pas d''op\00E9ration pour g\00E9rer l''action DML demand\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111783260769399657)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'fr'
,p_message_text=>unistr('La conversion de GeoJSON en SDO_GEOMETRY (colonne %0) n''est pas disponible dans cette base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784331358399658)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'fr'
,p_message_text=>unistr('La conversion SDO_GEOMETRY (colonne %0) n''est pas prise en charge pour les sources de donn\00E9es XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111791605476399663)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'fr'
,p_message_text=>unistr('Le caract\00E8re %0 n''est pas pris en charge en tant que s\00E9parateur multivaleur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111918980368399755)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette fonction ne peut pas \00EAtre utilis\00E9e dans un contexte de requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111784435865399658)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('Non-concordance du type de donn\00E9es de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787260802399660)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Limites de variable attach\00E9e ORDS OUT internes d\00E9pass\00E9es. R\00E9duisez le nombre de lignes DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111865035213399716)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible d''analyser la r\00E9ponse JSON du serveur distant : '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111787112145399660)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'fr'
,p_message_text=>'Type de contexte incorrect ou inconnu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111881603163399728)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'fr'
,p_message_text=>'Ce type de fichier n''est pas pris en charge par l''analyseur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836297452399696)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s non autoris\00E9 (wwv_flow_api.set_credentials non d\00E9fini).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813256830399679)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'fr'
,p_message_text=>unistr('L''espace de travail n''a pas \00E9t\00E9 cr\00E9\00E9 car il existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111813141960399679)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le groupe d''utilisateurs n''a pas \00E9t\00E9 cr\00E9\00E9 car il existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823417739399686)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur en double pour %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823529386399686)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors du chargement des utilisateurs. Echec pour l''utilisateur %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833401984399694)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 utilisateurs auraient \00E9t\00E9 charg\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833220370399693)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'fr'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833305078399694)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'fr'
,p_message_text=>unistr('Privil\00E8ges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833095400399693)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'fr'
,p_message_text=>'Nom utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909538269399748)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''affichage de l''\00E9l\00E9ment de page "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829104786399691)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''afficher l''\00E9l\00E9ment de page car le panneau HTML n''\00E9tait pas encore ouvert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111794485192399665)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du calcul de la valeur par d\00E9faut de l''\00E9l\00E9ment de page #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828404660399690)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du post-calcul de l''\00E9l\00E9ment de page #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828380597399690)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors du calcul de la valeur source de l''\00E9l\00E9ment de page #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808145537399675)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'fr'
,p_message_text=>unistr('Acc\00E8s non autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828645326399690)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'fr'
,p_message_text=>'JavaScript non pris en charge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828710201399690)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'fr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111829353375399691)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''initialiser la requ\00EAte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836529474399696)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('La mise \00E0 jour de %0 n''est pas admise.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111830738336399692)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ID d''\00E9l\00E9ment non valide : %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111857007741399711)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('Il n''y a pas d''aide pour cet \00E9l\00E9ment.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821566540399685)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'fr'
,p_message_text=>unistr('Echec de la g\00E9n\00E9ration de la requ\00EAte de graphique. V\00E9rifiez les param\00E8tres Source et Mapping de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916327542399753)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'fr'
,p_message_text=>unistr('La pi\00E8ce jointe de %0 Mo d\00E9passe la taille maximale autoris\00E9e (%1 Mo).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822455554399686)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur non valide pour le param\00E8tre p_mail_id : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111939823394399770)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez d\00E9pass\00E9 le nombre maximal de messages \00E9lectroniques par espace de travail. Contactez l''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803459821399672)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'fr'
,p_message_text=>unistr('Cette proc\00E9dure doit \00EAtre appel\00E9e \00E0 partir d''une session d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822333686399686)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'fr'
,p_message_text=>unistr('Valeur NULL fournie pour le param\00E8tre %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876310402399725)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('Mod\00E8le de courriel "%0" introuvable dans l''application %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111952886265399780)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le param\00E8tre d''instance SMTP_HOST_ADDRESS doit \00EAtre d\00E9fini de fa\00E7on \00E0 envoyer des courriels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822041163399685)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>'Vous devez indiquer un destinataire de courriel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111942293466399772)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible d''\00E9tablir une connexion SMTP avec le serveur de messagerie configur\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111916467745399753)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'fr'
,p_message_text=>'Appel AJAX non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807821435399675)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune fonction AJAX n''a \00E9t\00E9 d\00E9finie pour le module d''extension %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906871926399747)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune fonction d''ex\00E9cution n''a \00E9t\00E9 d\00E9finie pour le module d''extension %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807914922399675)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune fonction d''affichage n''a \00E9t\00E9 d\00E9finie pour le module d''extension %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917312104399754)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le module d''extension Source de donn\00E9es REST "%0" ne contient pas de fonction de type Fonctionnalit\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917202404399754)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le module d''extension Source de donn\00E9es REST "%0" ne contient pas de fonction DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917403823399754)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le module d''extension Source de donn\00E9es REST "%0" ne contient pas de fonction d''ex\00E9cution.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111917529601399754)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'fr'
,p_message_text=>unistr('Le module d''extension Source de donn\00E9es REST "%0" ne contient pas de fonction d''extraction.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805668223399673)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur de code PL/SQL g\00E9n\00E9r\00E9e lors du traitement du module d''extension.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812274810399678)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur doit \00EAtre indiqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842824485399700)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de convertir le type de donn\00E9es %0 en VARCHAR2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928490700399762)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne "%0" indiqu\00E9e pour l''attribut "%1" est introuvable dans l''instruction SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904771084399745)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'fr'
,p_message_text=>unistr('Une requ\00EAte de liste de valeurs (LOV) ou une liste de valeurs (LOV) nomm\00E9e doit \00EAtre indiqu\00E9e pour %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111906368855399746)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'fr'
,p_message_text=>unistr('Le nombre de colonnes s\00E9lectionn\00E9es est incorrect dans la requ\00EAte SQL de liste de valeurs (LOV) pour %0. Reportez-vous aux exemples pour conna\00EEtre les instructions valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928262284399762)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'fr'
,p_message_text=>unistr('Aucune colonne indiqu\00E9e pour l''attribut "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957909491399784)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('La valeur saisie %0 pour l''attribut "%1" n''est pas num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111909820097399749)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('%0 contient un type de donn\00E9es incorrect dans l''instruction SQL. Le num\00E9ro de colonne %1 est de type %2 alors que %3 est attendu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111928396021399762)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne "%0" indiqu\00E9e pour l''attribut "%1" poss\00E8de le type de donn\00E9es %2 alors qu''elle doit poss\00E9der le type %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111804991437399673)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'fr'
,p_message_text=>'La mise en page du rapport est introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864907055399716)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'fr'
,p_message_text=>unistr('La fonctionnalit\00E9 Calculer la somme ne peut pas \00EAtre utilis\00E9e pour des \00E9tats reposant sur une source de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111828598923399690)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('ERR-2904 Impossible de d\00E9finir la valeur de raccourci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111832829159399693)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur : type de raccourci inconnu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111822881765399686)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'fr'
,p_message_text=>'Impossible d''extraire authentication_scheme dans l''application %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111896329518399739)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'fr'
,p_message_text=>unistr('L''ID de location existe d\00E9j\00E0 pour la session en cours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111833135086399693)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'fr'
,p_message_text=>unistr('Adresse \00E9lectronique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957308029399783)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'fr'
,p_message_text=>'Echec de l''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111859680394399713)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'fr'
,p_message_text=>unistr('Au moins un cookie d\00E9fini dans apex_util.g_request_cookies contient une valeur non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111842102504399700)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9ponse du registre UDDI n''\00E9tait pas valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111805786900399673)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'fr'
,p_message_text=>unistr('L''URL indiqu\00E9e n''a pas renvoy\00E9 de document WSDL valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111808296961399675)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le document WSDL contient plusieurs liaisons SOAP. &PRODUCT_NAME. ne prend en charge que les documents WSDL n''ayant qu''une seule liaison SOAP. Cliquez sur Cr\00E9er manuellement une r\00E9f\00E9rence de service Web pour continuer la cr\00E9ation d''une r\00E9f\00E9rence pour')
||' ce service.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111876612504399725)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'fr'
,p_message_text=>unistr('La r\00E9ponse du service n''\00E9tait pas au format XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957296752399783)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le token d''acc\00E8s OAuth n''est pas disponible ou a expir\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111920466140399756)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'fr'
,p_message_text=>unistr('Vous avez d\00E9pass\00E9 le nombre maximal de demandes de service Web par espace de travail. Contactez l''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111957425629399783)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'fr'
,p_message_text=>unistr('Le serveur a r\00E9pondu avec un type de token OAuth non pris en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807659425399675)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'fr'
,p_message_text=>unistr('Le document WSDL ne contient pas de liaison pour SOAP ; elle est requise pour l''ajout de la r\00E9f\00E9rence.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111803556967399672)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'fr'
,p_message_text=>'Ce WSDL exige des informations d''authentification. Indiquez le nom utilisateur et le mot de passe ci-dessous.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111812379451399678)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'fr'
,p_message_text=>unistr('Le moteur d''affichage n''a pas r\00E9ussi \00E0 interpr\00E9ter le document WSDL. Cliquez sur Cr\00E9er manuellement une r\00E9f\00E9rence de service Web pour continuer la cr\00E9ation d''une r\00E9f\00E9rence pour ce service.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111879285011399727)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'fr'
,p_message_text=>unistr('Impossible de traiter la mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111905006154399745)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'fr'
,p_message_text=>unistr('La colonne d''affichage et renvoy\00E9e de la liste de valeurs (LOV) sont identiques.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111904953814399745)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'fr'
,p_message_text=>unistr('La liste de valeurs (LOV) ne comporte aucune colonne renvoy\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836446621399696)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'fr'
,p_message_text=>'Erreur lors de l''extraction de la valeur de colonne : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860472655399713)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'fr'
,p_message_text=>unistr('Les donn\00E9es de panneau tabulaire en cours sont trop anciennes ; les donn\00E9es source ont \00E9t\00E9 modifi\00E9es.<br/> Cliquez <strong><a href="%0">ici</a></strong> pour annuler vos modifications et recharger les donn\00E9es \00E0 partir de la base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818547420399683)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de la d\00E9termination de la cha\00EEne de pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818453541399683)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('impossible de d\00E9terminer les en-t\00EAtes de requ\00EAte :'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818606294399683)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'fr'
,p_message_text=>unistr('erreur lors des remplacements de pied d''\00E9tat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818768747399683)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00E9chec de l''analyse de la requ\00EAte SQL :'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823725188399687)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'fr'
,p_message_text=>unistr('Nombre minimum de lignes demand\00E9 : %0, lignes trouv\00E9es mais non affich\00E9es : %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821275684399685)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'fr'
,p_message_text=>unistr('la colonne de requ\00EAte #%0 (%1) n''est pas valide ; les colonnes utilisant le HTML doivent avoir des alias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111836316456399696)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'fr'
,p_message_text=>unistr('Erreur lors de l''obtention des en-t\00EAtes de requ\00EAte : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818876815399683)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('erreur d''\00E9tat :'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111856553455399710)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Trier sur cette colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821338180399685)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'fr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La requ\00EAte ne peut pas \00EAtre analys\00E9e, v\00E9rifiez-en la syntaxe.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860588594399713)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'fr'
,p_message_text=>unistr('Ce panneau contient des modifications non enregistr\00E9es. Cliquez sur OK pour continuer sans enregistrer vos modifications. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111864803092399716)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'fr'
,p_message_text=>unistr('Le mod\00E8le de pagination d''\00E9tat (%0) n''est pas pris en charge avec la source de donn\00E9es choisie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111821105688399685)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'fr'
,p_message_text=>unistr('la colonne de requ\00EAte #%0 (%1) n''est pas valide, utilisez l''alias de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823873988399687)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'fr'
,p_message_text=>'ligne(s) %0 - %1 de plus de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111862512052399715)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'fr'
,p_message_text=>'%0 - %1 de plus que %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111823686692399687)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'fr'
,p_message_text=>'ligne(s) %0 - %1 sur %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111807593558399675)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'fr'
,p_message_text=>'%0 - %1 sur %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818992820399683)
,p_name=>'Y'
,p_message_language=>'fr'
,p_message_text=>'O'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111825026130399688)
,p_name=>'YEAR'
,p_message_language=>'fr'
,p_message_text=>unistr('ann\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111818101141399683)
,p_name=>'YEARS'
,p_message_language=>'fr'
,p_message_text=>unistr('ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111860653075399713)
,p_name=>'YES'
,p_message_language=>'fr'
,p_message_text=>'Oui'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4472)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4472)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Bureau'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4472
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4472)
,p_name=>'Messages'
,p_alias=>'MESSAGES'
,p_step_title=>'Messages'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
