prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4902
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4902 - Oracle APEX Websheets
--
-- Application Export:
--   Application:     4902
--   Name:            Oracle APEX Websheets
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    109
--       Items:                  517
--       Computations:            59
--       Validations:            101
--       Processes:              131
--       Regions:                496
--       Buttons:                224
--       Dynamic Actions:         47
--     Shared Components:
--       Logic:
--         Items:                 29
--         Processes:             13
--         Computations:           5
--         Build Options:          1
--       Navigation:
--         Lists:                 23
--         Breadcrumbs:            1
--           Entries:             78
--         NavBar Entries:         5
--       Security:
--         Authentication:         1
--         Authorization:         11
--       User Interface:
--         Templates:
--           Page:                11
--           Region:              22
--           Label:                5
--           List:                14
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:              20
--           Report:               4
--         LOVs:                 118
--         Shortcuts:              8
--         Plug-ins:               6
--       Globalization:
--         Messages:              30
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Websheets')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110312785518375765')
,p_page_view_logging=>'YES'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110922'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'fr'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'DS'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(709672827800503408.4902)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'T'
,p_logo_text=>'Application Express'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'S'
,p_deep_linking=>'Y'
,p_vpd=>'wwv_flow_ws_auth.init_schema;'
,p_security_scheme=>wwv_flow_api.id(612254693942923247)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_friendly_url=>'N'
,p_substitution_string_01=>'MSG_LANGUAGE'
,p_substitution_value_01=>'Langue'
,p_substitution_string_02=>'MSG_USER'
,p_substitution_value_02=>'Utilisateur'
,p_substitution_string_03=>'DELETE_MSG'
,p_substitution_value_03=>'Voulez-vous effectuer cette action de suppression ?'
,p_substitution_string_04=>'PRODUCT_NAME'
,p_substitution_value_04=>'Oracle APEX'
,p_substitution_string_05=>'VIEW'
,p_substitution_value_05=>'Visualiser'
,p_substitution_string_06=>'MSG_JSCRIPT'
,p_substitution_value_06=>unistr('JavaScript doit \00EAtre activ\00E9 lorsque vous ex\00E9cutez ce produit.')
,p_substitution_string_07=>'CLOSE_MESSAGE'
,p_substitution_value_07=>'Fermer le message'
,p_substitution_string_08=>'GO_TO_TOP'
,p_substitution_value_08=>unistr('Aller au d\00E9but')
,p_substitution_string_09=>'COLLAPSE'
,p_substitution_value_09=>unistr('R\00E9duire')
,p_substitution_string_10=>'EDIT'
,p_substitution_value_10=>'Modifier'
,p_substitution_string_11=>'EXPANDED'
,p_substitution_value_11=>unistr('D\00E9velopp\00E9')
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112912'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_sections
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15661014418081294.4902)
,p_name=>'Edit Sections'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 as level_value',
'	, c001 label_value',
'	, ''f?p=''||:APP_ID||'':''||:APP_PAGE_ID||'':''||:APP_SESSION target',
'	, null is_current_list_entry',
'	, null image',
'	, null image_attribute',
'	, null image_alt_attribute',
'	, lower(c002)||''Icon'' attribute1',
'	, wwv_flow_item.text_from_lov(c002,''SECTION TYPES'') attribute2',
'	, lower(decode(c005,null,c004,c005)) attribute3',
'	, htmldb_util.get_since(decode(d001,null,d002,d001)) attribute4',
'	, case when c002 = ''TEXT'' and :APP_PAGE_ID = 930 and n003 = :P930_SECTION_ID then ''active''',
'	       when c002 = ''NAV_PAGE'' and :APP_PAGE_ID = 931 and n003 = :P931_SECTION_ID then ''active''',
'	       when c002 = ''NAV_SECTION'' and :APP_PAGE_ID = 932 and n003 = :P932_SECTION_ID then ''active''',
'	       when c002 = ''CHART'' and :APP_PAGE_ID = 760 and n003 = :P760_SECTION_ID then ''active''',
'	       when c002 = ''DATA'' and :APP_PAGE_ID = 934 and n003 = :P934_SECTION_ID then ''active''',
'	       when c002 = ''PLSQL'' and :APP_PAGE_ID = 23 and n003 = :P23_SECTION_ID then ''active''',
'	       when :APP_PAGE_ID = 991 and n003 = :SECTION_ID then ''active''',
'               when :APP_PAGE_ID = 990 and n003 = :SECTION_ID then ''active''	  ',
'	  end attribute5        ',
'    , c006 attribute6 -- next page id',
'    , c007 attribute7 -- next section page item name to hold section id',
'    , n003 attribute8 -- next section id',
'    , n002 display_sequence',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_PAGE_SECTIONS''',
'order by n002'))
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/sections_settings_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(17135113310000767.4902)
,p_name=>'Sections Settings Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18786329979544670.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Afficher l''historique de section'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18785810240539012.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('D\00E9placer la section vers une autre page')
,p_list_item_link_target=>'f?p=&APP_ID.:990:&SESSION.::&DEBUG.::P990_SECTION_ID,P990_PAGE_ID:&SECTION_ID.,&P900_ID.:'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18786123053542660.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('D\00E9placer la section vers une nouvelle page')
,p_list_item_link_target=>'f?p=&APP_ID.:991:&SESSION.::&DEBUG.:991:P991_SECTION_ID,P991_PAGE_ID:&SECTION_ID.,&P900_ID.:'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(17154020760040710.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Modifier plusieurs sections'
,p_list_item_link_target=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_pages
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18529824151546479.4902)
,p_name=>'Edit Pages'
,p_list_type=>'FUNCTION_RETURNING_SQL_QUERY'
,p_list_language=>'PLSQL'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q               varchar2(32767) := null;',
'    l_parent_page_id number := null;',
'begin      ',
'    for c1 in (select parent_page_id',
'               from wwv_flow_ws_webpages',
'               where ws_app_id = :ws_app_id',
'               and security_group_id = :flow_security_group_id',
'               and id =:P53_ID)',
'    loop',
'        l_parent_page_id := c1.parent_page_id;',
'    end loop;    ',
'    ',
'    q := ''select level ''||',
'         ''	, name label ''||',
'         ''  , ''''javascript:applyAndGoToNextPage(''''''''''''||id||'''''''''''')'''' target ''||         ',
'         ''	, null is_current_list_entry ''||',
'         ''	, null image ''||',
'         ''	, null image_attribute ''||',
'         ''	, null image_alt_attribute ''||',
'         ''	, lower(decode(updated_by,null,created_by,updated_by)) attribute1 ''||',
'         ''	, htmldb_util.get_since(decode(updated_on,null,created_on,updated_on)) attribute2 ''||',
'         ''	, case when id = :P53_ID then ''''active'''' end attribute3 ''||',
'         ''from wwv_flow_ws_webpages ''||',
'         ''where security_group_id = :FLOW_SECURITY_GROUP_ID ''||',
'         ''and ws_app_id = :WS_APP_ID '';',
'         --''and level    <= 2 '';',
'    ',
'    if l_parent_page_id is null then',
'        q:=q||''start with parent_page_id is null '';',
'    else',
'        q:=q||''start with id = ''||l_parent_page_id;        ',
'    end if; ',
'',
'    q:=q||''connect by prior id = parent_page_id '';',
'    q:=q||''order siblings by name'';        ',
'    ',
'    return q;',
'end;'))
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/pages_settings_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18583325957802446.4902)
,p_name=>'Pages Settings Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18583829450802448.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Nouvelle page'
,p_list_item_link_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200:P200_PARENT_PAGE,WS_APP_ID:&P900_ID.,&WS_APP_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18584127738802448.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nouvelle page comme copie'
,p_list_item_link_target=>'f?p=&APP_ID.:908:&SESSION.::&DEBUG.:908:WS_APP_ID,P908_COPY_PAGE_FROM,P900_ID:&WS_APP_ID.,&P900_ID.,&P900_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23689225706066046.4902)
,p_name=>'Monitor Activity Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23689400293066047.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Vues de page'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23689719692066048.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Pages principales'
,p_list_item_link_target=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'24'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23690031914066048.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Principales grilles de donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.::::	'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'141'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23690308632066049.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Principaux \00E9tats')
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'142'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23690603303066049.4902)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Principaux utilisateurs'
,p_list_item_link_target=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'146'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_annotations_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23775330395531080.4902)
,p_name=>'Admin Annotations Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23775513281531081.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Principaux fichiers'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'143'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23775818182531082.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Principales remarques'
,p_list_item_link_target=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'144'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23776108748531082.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Principales balises'
,p_list_item_link_target=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'145'
);
end;
/
prompt --application/shared_components/navigation/lists/create_page_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(29874807106517169.4902)
,p_name=>'create page progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(173227427841861244.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Type de composant'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(29885520930644174.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('M\00E9thode de cr\00E9ation')
,p_list_item_link_target=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'205'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(29885725086645395.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Propri\00E9t\00E9s')
,p_list_item_link_target=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:201:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'201,206'
);
end;
/
prompt --application/shared_components/navigation/lists/create_section_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(174369523339947712.4902)
,p_name=>'create section progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(174370314120954487.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Choisir le type de section'
,p_list_item_link_target=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'920'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178563610566182386.4902)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Type de navigation'
,p_list_item_link_target=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'921,926,927'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'926'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178522522266580262.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Source de donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'922,925'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'922'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(174370522431956915.4902)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('D\00E9finir une section')
,p_list_item_link_target=>'f?p=&APP_ID.:910:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'910,921,927,925'
);
end;
/
prompt --application/shared_components/navigation/lists/annotation_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(178837028298310188.4902)
,p_name=>'annotation tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187173101861909018.4902)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Tout'
,p_list_item_link_target=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'906'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178837317622310200.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Fichiers'
,p_list_item_link_target=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:APEX$_WS_FILES:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'903'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178838019750310282.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Remarques'
,p_list_item_link_target=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'905'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(473073917597603316.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Liens'
,p_list_item_link_target=>'f?p=&APP_ID.:915:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'915'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178837724276310282.4902)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Balises'
,p_list_item_link_target=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'904'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(458964205010652503.4902)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>unistr('Nuage de mots-cl\00E9s')
,p_list_item_link_target=>'f?p=&APP_ID.:928:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'928'
);
end;
/
prompt --application/shared_components/navigation/lists/create_report_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(181250307256073810.4902)
,p_name=>'create report progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181310223288910949.4902)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Type de composant'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181259832284137754.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Attributs d''\00E9tat')
,p_list_item_link_target=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1310'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181272207059234540.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmer'
,p_list_item_link_target=>'f?p=&APP_ID.:1320:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1320'
);
end;
/
prompt --application/shared_components/navigation/lists/p_902_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(187087619151586620.4902)
,p_name=>'p 902 tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187087931306586621.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tout'
,p_list_item_link_target=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:ALL:'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'EXISTS'
,p_list_item_current_for_pages=>'select 1 from dual where nvl(:P902_SHOW,''ALL'') = ''ALL'''
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187088302932586621.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Grilles de donn\00E9es')
,p_list_item_link_target=>'f?p=4900:902:&SESSION.::::P902_SHOW:DATAGRID'
,p_list_item_current_type=>'EXISTS'
,p_list_item_current_for_pages=>'select 1 from dual where :P902_SHOW = ''DATAGRID'''
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187088713953586622.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Etats'
,p_list_item_link_target=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:REPORT:'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'EXISTS'
,p_list_item_current_for_pages=>'select 1 from dual where :P902_SHOW = ''REPORT'''
);
end;
/
prompt --application/shared_components/navigation/lists/admin_toolbar_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(202684424744514793.4902)
,p_name=>'Admin Toolbar Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202686125516514795.4902)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Administration'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:APP_USER,''nobody'') not in (''APEX_PUBLIC_USER'',''HTMLDB_PUBLIC_USER'',''ANONYMOUS'',''nobody'',''PUBLIC_USER'') then',
'  if wwv_flow_ws_security.current_user_is_admin or wwv_flow_ws_api.show_reset_password(p_ws_app_id => :ws_app_id) then',
'      return true;',
'  else',
'      return false;',
'  end if;',
'else',
'  return false;',
'end if;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202688803947514796.4902)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Tableau de bord'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4902)
,p_list_text_01=>'ws-admin-dashboard'
,p_list_text_05=>'Alt+B'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202692116934514798.4902)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>unistr('Surveiller l''activit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4902)
,p_list_text_01=>'ws-admin-monitor'
,p_list_text_05=>'Alt+M'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202692413363514798.4902)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>unistr('Propri\00E9t\00E9s de feuille Web')
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:1250:P1250_ID:&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4902)
,p_list_text_01=>'ws-admin-properties'
,p_list_text_05=>'Alt+P'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202692709697514798.4902)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>unistr('Contr\00F4le d''acc\00E8s')
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4902)
,p_list_text_01=>'ws-admin-acl'
,p_list_text_05=>'Alt+X'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(212953623410993837.4902)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'--'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4902)
,p_list_text_01=>'wsMenuSep'
,p_security_scheme=>wwv_flow_api.id(506060600392166972)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202693609322514799.4902)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Modifier mon mot de passe'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:5:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4902)
,p_security_scheme=>wwv_flow_api.id(506060600392166972)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_chart_section_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(261469429368022853.4902)
,p_name=>'create chart section progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261470512876027512.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Type de section'
,p_list_item_link_target=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'920'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261470821880030114.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Type de graphique'
,p_list_item_link_target=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'710'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261471504481044080.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Source de graphique'
,p_list_item_link_target=>'f?p=&APP_ID.:740:&SESSION.::&DEBUG.::::'
,p_list_item_disp_condition2=>'DATA_GRID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'740:745'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261471828030050875.4902)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('D\00E9finition de graphique')
,p_list_item_link_target=>'f?p=&APP_ID.:742:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'742'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261472414655056417.4902)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Cr\00E9er')
,p_list_item_link_target=>'f?p=&APP_ID.:750:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'750'
);
end;
/
prompt --application/shared_components/navigation/lists/help_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(456471813385447055.4902)
,p_name=>'Help Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(472810017189623092.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'A propos de'
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'16'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(456472503328447058.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Aper\00E7u')
,p_list_item_link_target=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'15'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(619280916964076011.4902)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>unistr('Contr\00F4le d''acc\00E8s')
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'6'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(456472932226447059.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Syntaxe de balisage'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'17'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6247915223597961.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Grille de donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491253712635289676.4902)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Contenu de l''application'
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'25,27,28,29,30,12'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(487175029602607075.4902)
,p_list_item_display_sequence=>999
,p_list_item_link_text=>'Foire aux questions'
,p_list_item_link_target=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'19'
);
end;
/
prompt --application/shared_components/navigation/lists/administration_menu_options
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(457230629124432618.4902)
,p_name=>'administration menu options'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457230905908432621.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tableau de bord'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'ws/ws-dashboard.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457231305495432622.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Surveiller l''activit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'ws/ws-chart.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457232713110446916.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Propri\00E9t\00E9s de feuille Web')
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:1250:P1250_ID:&WS_APP_ID.:'
,p_list_item_icon=>'ws/ws-properties.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457321625061188359.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Contr\00F4le d''acc\00E8s')
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'ws/ws-access-control.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_menu_options
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(457456818808085338.4902)
,p_name=>'Page Menu Options'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457458705480119260.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page d''accueil'
,p_list_item_link_target=>'ws?p=&WS_APP_ID.:home:&SESSION.'
,p_list_item_icon=>'apex/builder/menu-home-128.gif'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457457112971085339.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('R\00E9pertoire de pages')
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex/builder/menu-page-dir-128.gif'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457468208784233794.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Voir l''historique'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex/builder/menu-change-log-128.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457482932080297318.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Cr\00E9er une page')
,p_list_item_link_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200:::'
,p_list_item_icon=>'apex/builder/menu-add-page-128.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(459634320543429042.4902)
,p_name=>'Monitor Activity'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(459634600866429048.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Vues de page'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471679808716623953.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Pages principales'
,p_list_item_link_target=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471680625685628854.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Principales grilles de donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.::::	'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'141'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471681413003634676.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Principaux \00E9tats')
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'142'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471917315656277818.4902)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Principaux utilisateurs'
,p_list_item_link_target=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'142'
);
end;
/
prompt --application/shared_components/navigation/lists/annotations
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(461178801985335895.4902)
,p_name=>'Annotations'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461179122466335896.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Principaux fichiers'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461179526172335897.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Principales remarques'
,p_list_item_link_target=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461179925451335897.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Principales balises'
,p_list_item_link_target=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
end;
/
prompt --application/shared_components/navigation/lists/page_directory
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(461346705230446581.4902)
,p_name=>'Page Directory'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461347024629446628.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('R\00E9pertoire de pages')
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.:'
,p_list_item_current_for_pages=>'1000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461347428128446630.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('R\00E9pertoire de feuilles Web')
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/history_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(471880222274882374.4902)
,p_name=>'History Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471880504499882381.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Etat'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.:'
,p_list_item_current_for_pages=>'950'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471880901168882390.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Calendrier'
,p_list_item_link_target=>'f?p=&APP_ID.:951:&SESSION.:'
,p_list_item_current_for_pages=>'951'
);
end;
/
prompt --application/shared_components/navigation/lists/help_application_content_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(491255024672312078.4902)
,p_name=>'Help application content tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491256117021312081.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Pages'
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'25'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492152905074851834.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Sections'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'28'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491256416740312081.4902)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Fichiers/Images'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'27'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491257030941312082.4902)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Grilles de donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT 1',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'29'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491257320723312082.4902)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Etats'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT 1',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''REPORT'''))
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'30'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491257610094312082.4902)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Code SQL sugg\00E9r\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_ws_applications',
' where id = :WS_APP_ID',
'   and security_group_id = :flow_security_group_id',
'   and allow_sql_yn = ''Y''',
'   and exists (select 1 from wwv_flow_ws_app_sug_objects',
'                where ws_app_id = :WS_APP_ID',
'                and security_group_id = :flow_security_group_id)'))
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'12'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_report_view_mode
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(491741626522063565.4902)
,p_name=>'edit report view mode'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491742324922072587.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Attributs d''\00E9tat')
,p_list_item_link_target=>'javascript:doSubmit(''SAVE_REPORT_ATTR'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3010:3020'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491761112810144768.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Requ\00EAte d''\00E9tat')
,p_list_item_link_target=>'javascript:doSubmit(''SAVE_QUERY'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3030:3060'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_0_toolbar_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(929134615131186819.4902)
,p_name=>'APEX 5.0 - Toolbar Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Visualiser'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929138403023186825.4902)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Page d''accueil'
,p_list_item_link_target=>'ws?p=&WS_APP_ID.:home:&APP_SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_text_01=>'ws-view-home'
,p_list_text_05=>'Alt+H'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929138706106186825.4902)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>unistr('Mode Pr\00E9sentation')
,p_list_item_link_target=>'f?p=&APP_ID.:901:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'900'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_text_01=>'ws-view-presentation-mode'
,p_list_text_05=>'Alt+Q'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139001784186826.4902)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>unistr('R\00E9pertoire de pages')
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929140888830186828.4902)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Etats'
,p_list_item_link_target=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:REPORT:'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_text_01=>'ws-view-reports'
,p_list_text_05=>'Alt+R'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929141179837186828.4902)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Historique de pages'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929141414305186828.4902)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>unistr('R\00E9pertoire de feuilles Web')
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_text_01=>'ws-view-ws-directory'
,p_list_text_05=>'Alt+Shift+D'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(930987028365270703.4902)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Annotations'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4902)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139607423186826.4902)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Fichiers'
,p_list_item_link_target=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139919238186826.4902)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'Balises'
,p_list_item_link_target=>'f?p=&APP_ID.:928:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929140243536186826.4902)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Remarques'
,p_list_item_link_target=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929140500508186828.4902)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Liens'
,p_list_item_link_target=>'f?p=&APP_ID.:915:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(931217661486553673.4902)
,p_list_item_display_sequence=>203
,p_list_item_link_text=>'--'
,p_list_item_link_target=>'separator'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'7,8,32'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139371751186826.4902)
,p_list_item_display_sequence=>205
,p_list_item_link_text=>'Visualiser tout'
,p_list_item_link_target=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4902)
,p_list_text_01=>'ws-view-all-annotations'
,p_list_text_05=>'Alt+A'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929135108865186823.4902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Cr\00E9er')
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136360244186823.4902)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Nouvelle page'
,p_list_item_link_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200:P200_PARENT_PAGE,WS_APP_ID:&P900_ID.,&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4902)
,p_list_text_01=>'ws-create-page'
,p_list_text_05=>'Alt+N'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136628803186823.4902)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Nouvelle page comme copie'
,p_list_item_link_target=>'f?p=&APP_ID.:908:&SESSION.::&DEBUG.:908:WS_APP_ID,P908_COPY_PAGE_FROM,P900_ID:&WS_APP_ID.,&P900_ID.,&P900_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136959895186825.4902)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Nouvelle section'
,p_list_item_link_target=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4902)
,p_list_text_01=>'ws-create-section'
,p_list_text_05=>'Alt+Shift+N'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929137293514186825.4902)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>unistr('Nouvelle grille de donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:205,1310,1320:WS_APP_ID:&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4902)
,p_list_text_01=>'ws-create-datagrid'
,p_list_text_05=>'Alt+Shift+D'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929137547826186825.4902)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Nouvel \00E9tat')
,p_list_item_link_target=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:1310,1320:WS_APP_ID:&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4902)
,p_list_text_01=>'ws-create-report'
,p_list_text_05=>'Alt+Shift+R'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929137898140186825.4902)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'--'
,p_list_item_link_target=>'separator'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'7,8,32'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4902)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929135423776186823.4902)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Cr\00E9er')
,p_list_text_02=>'true'
,p_security_scheme=>'!'||wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929135709186186823.4902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Modifier'
,p_list_text_03=>'Ctrl+N'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929141723344186828.4902)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Modifier une page'
,p_list_item_link_target=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:53:P53_ID,WS_APP_ID:&P900_ID.,&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135709186186823.4902)
,p_list_text_01=>'ws-edit-page'
,p_list_text_05=>'Alt+E'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929142003161186828.4902)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Supprimer une page'
,p_list_item_link_target=>'f?p=&APP_ID.:960:&SESSION.::&DEBUG.:53:P53_ID:&P900_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_ws_api.is_app_home_page(p_ws_app_id => :ws_app_id, p_webpage_id => :p900_id)'
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(929135709186186823.4902)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929142397543186828.4902)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Modifier les sections'
,p_list_item_link_target=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.:940:::'
,p_parent_list_item_id=>wwv_flow_api.id(929135709186186823.4902)
,p_list_text_01=>'ws-edit-sections'
,p_list_text_05=>'Alt+Shift+E'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136059659186823.4902)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Modifier'
,p_list_text_02=>'true'
,p_security_scheme=>'!'||wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1081398599474545.4902)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2015719452410064.4902)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14849102226940934.4902)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(92009116035572450.4902)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99821629609888928.4902)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176118490436506807.4902)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592209067420709428.4902)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765073485610712056.4902)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831723025707993879.4902)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917633175675939889.4902)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178942513630772437.4902)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 effectuer cette op\00E9ration')
,p_reference_id=>786516029127697713.4902
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178942909534772438.4902)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 utiliser SQL Workshop')
,p_reference_id=>786516265251697717.4902
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178943426646772439.4902)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>unistr('Le d\00E9veloppement d''\00E9quipe n''est pas activ\00E9 pour cet espace de travail')
,p_reference_id=>786516861027697723.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_websheets_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178943900647772439.4902)
,p_name=>'APEX 5.0 Websheets Enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, wwv_flow_fnd_user u',
'where nvl(w.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'''))
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 effectuer cette op\00E9ration')
,p_reference_id=>786517166823697723.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/current_user_is_at_least_contributor
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(456220226828170850.4902)
,p_name=>'Current user is at least contributor'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.current_user_is_not_reader;'
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 acc\00E9der \00E0 cette fonction.')
,p_reference_id=>786952716254317846.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/current_user_is_admin
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(456220816180174638.4902)
,p_name=>'Current user is admin'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.current_user_is_admin;'
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 acc\00E9der \00E0 cette fonction.')
,p_reference_id=>786954200597322276.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/user_is_apex_developer
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(487678607690660963.4902)
,p_name=>'User is APEX Developer'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in (select 1 ',
'             from wwv_flow_developer_workspaces ',
'             where workspace_id = :flow_security_group_id',
'             and developer_name= :app_user)',
'  loop',
'    -- if websheet logged in user is developer then, return true',
'    return true;',
'  end loop;  ',
'  return false;',
'end;'))
,p_error_message=>unistr('Vous devez \00EAtre d\00E9veloppeur Application Express pour acc\00E9der \00E0 cette fonction.')
,p_reference_id=>786953667141317846.4902
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(492214905335570870.4902)
,p_name=>'SQL_ENABLED'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and wwv_flow_ws_security.sql_enabled_inst;'
,p_error_message=>unistr('L''acc\00E8s SQL n''est pas activ\00E9.')
,p_reference_id=>786953304778317846.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/current_user_is_at_least_contributor_and_sql_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(495860932509802714.4902)
,p_name=>'Current user is at least contributor and SQL enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.current_user_is_not_reader and wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and wwv_flow_ws_security.sql_enabled_inst;'
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 acc\00E9der \00E0 cette fonction.')
,p_reference_id=>786953038199317846.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/show_reset_password
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(506060600392166972.4902)
,p_name=>'show reset password'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_api.show_reset_password(p_ws_app_id => :ws_app_id);'
,p_error_message=>unistr('La r\00E9initialisation du mot de passe n''est pas activ\00E9e.')
,p_reference_id=>786953911558317846.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/f4900_websheet_create_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(612254693942923247.4902)
,p_name=>'f4900 Websheet Create Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce( wwv_flow_platform.get_preference(''WEBSHEET_CREATE_ENABLED''), ''N'' ) = ''Y'' OR :APP_PAGE_ID = 9 then',
'    return TRUE;',
'else',
'    htmldb_util.redirect_url(''f?p=4900:9:'' || :APP_SESSION );',
'    return FALSE;',
'end if;'))
,p_error_message=>unistr('Pour acc\00E9der \00E0 cette page, l''application Web doit \00EAtre activ\00E9e.')
,p_reference_id=>.4902
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(2221120362249577.4902)
,p_icon_sequence=>10
,p_icon_subtext=>'Bienvenue &APP_USER.'
,p_icon_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_icon_image_alt=>'Bienvenue &APP_USER.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(617028331038386115.4902)
,p_icon_sequence=>20
,p_icon_subtext=>'( <span style="text-decoration:underline;">Connexion</span> )'
,p_icon_target=>'f?p=&APP_ID.:79:&SESSION.:LOGIN:&DEBUG.::WS_APP_ID:&WS_APP_ID.:'
,p_icon_image_alt=>'Connexion'
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'USER_IS_PUBLIC_USER'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(620001721380496329.4902)
,p_icon_sequence=>30
,p_icon_subtext=>'Langue'
,p_icon_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(2290404332055831.4902)
,p_icon_sequence=>40
,p_icon_subtext=>unistr('( <span style="text-decoration:underline;">D\00E9connexion</span> )')
,p_icon_target=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.::::'
,p_icon_image_alt=>unistr('D\00E9connexion')
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'USER_IS_NOT_PUBLIC_USER'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(203498613231050603.4902)
,p_icon_sequence=>50
,p_icon_subtext=>'Informations en retour'
,p_icon_target=>'javascript:popupURL(''f?p=4900:102:&SESSION.:::102:P102_APPLICATION_ID,P102_PAGE_ID:&APP_ID.,&APP_PAGE_ID.'');'
,p_nav_entry_is_feedback_yn=>'Y'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/set_websheet_application_date_format_for_session
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(467798605271386699.4902)
,p_process_sequence=>5
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Websheet Application Date Format for Session'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_worksheet_standard.set_ws_app_date_format( ',
'    p_ws_app_id => :WS_APP_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la d\00E9finition du format de date de l''application Web')
,p_process_when=>'WS_APP_ID'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/shared_components/logic/application_processes/maintain_g_running_worksheets_app
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(185099800820727550.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'maintain g_running_worksheets_app'
,p_process_sql_clob=>'wwv_flow_log.g_websheet_id := :WS_APP_ID;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('impossible de d\00E9finir l''\00E9l\00E9ment global')
);
end;
/
prompt --application/shared_components/logic/application_processes/check_user_is_at_least_reader
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(456113631939841224.4902)
,p_process_sequence=>15
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check user is at least reader'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_ws_security.get_current_user_role,''0'') = ''0'' then',
'  sys.htp.init;',
'  wwv_flow.g_unrecoverable_error := true;',
'                 sys.owa_util.redirect_url(''f?p=&APP_ID.:99:&SESSION.'');',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la d\00E9termination de l''autorisation.')
,p_process_when=>':APP_PAGE_ID not in (''79'',''99'',''101'') and nvl(wwv_flow_security.g_user,''nobody'') != ''nobody'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/shared_components/logic/application_processes/user_is_at_least_a_contributor
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(456277312414876323.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'User is at least a contributor'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_ws_security.get_current_user_role,''0'') not in (''C'',''A'') then',
'  sys.htp.init;',
'  wwv_flow.g_unrecoverable_error := true;',
'  sys.owa_util.redirect_url(''f?p=&APP_ID.:99:&SESSION.'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 acc\00E9der \00E0 cette fonction.')
,p_process_when=>'20,53,90,131,200,201,205,206,710,760,908,910,920,921,922,926,927,930,931,932,934,1310,1320,4020,4030,4040,940,960,3010,3030'
,p_process_when_type=>'CURRENT_PAGE_IN_CONDITION'
);
end;
/
prompt --application/shared_components/logic/application_processes/check_user_is_admin
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(456253831789380446.4902)
,p_process_sequence=>25
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check user is admin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_ws_security.current_user_is_admin then',
'',
'  sys.htp.init;',
'  wwv_flow.g_unrecoverable_error := true;',
'                 sys.owa_util.redirect_url(''f?p=4900:99:''||:APP_SESSION);',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 acc\00E9der \00E0 cette fonction.')
,p_process_when=>'1,3,11,13,18,24,140,141,142,143,144,145,146,1250'
,p_process_when_type=>'CURRENT_PAGE_IN_CONDITION'
);
end;
/
prompt --application/shared_components/logic/application_processes/websheet
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(1367007177305239.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'websheet'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_widget_action     varchar2(32767) := wwv_flow.g_widget_action;',
'  l_validation_error  varchar2(32767) := null;',
'  l_opt               varchar2(4000) := null;',
'begin',
'  if l_widget_action = ''websheet_properties_save'' then',
'    wwv_flow_ws_api.save_websheet_properties (',
'        p_ws_app_id        => :WS_APP_ID,',
'        p_worksheet_id     => :P2_ID,        ',
'        p_name             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NAME''),',
'        p_alias            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ALIAS''),',
'        p_description      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DESCRIPTION''),        ',
'        p_row_pk1          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROW_PK1''),',
'        p_row_pk2          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROW_PK2''),',
'        p_row_pk3          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROW_PK3''),',
'        p_publish          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_PUBLISH''),',
'        p_validation_error => l_validation_error',
'        );',
'  elsif l_widget_action = ''column_properties_save'' then',
'     wwv_flow_ws_api.save_column_properties (',
'        p_worksheet_id      => :P2_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,',
'        p_app_user          => :APP_USER,',
'        p_db_column_name    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'        p_display_order     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'        p_group_id          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),       ',
'        p_display_as        => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),        ',
'        p_label             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_LABEL''),',
'        p_format_mask       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_FORMAT_MASK''),        ',
'        p_value_required    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),        ',
'        p_heading_alignment => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HEADING_ALIGNMENT''),',
'        p_column_alignment  => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_ALIGNMENT''),        ',
'        p_lov_id            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'        p_lov_name          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'        p_lov_entries       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),        ',
'        p_default_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'        p_default_text      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),        ',
'        p_width             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_WIDTH''),',
'        p_max_width         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_MAX_LENGTH''),',
'        p_height            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_HEIGHT''),',
'        p_help_text         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HELP_TEXT''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''column_add'' then',
'     wwv_flow_ws_api.add_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_report_id        => :RPT_ID,',
'         p_app_user         => :APP_USER,',
'         p_column_name      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_NAME''),',
'         p_column_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_TYPE''),',
'         p_display_as       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'         p_value_required   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),',
'         p_default_type     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'         p_default_text     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),',
'         p_validation_error => l_validation_error',
'         ); ',
'  elsif l_widget_action = ''column_remove'' then',
'',
'',
'',
'     wwv_flow_ws_api.remove_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),      ',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''lov_save'' then',
'     wwv_flow_ws_api.save_lov (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),  ',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''column_groups_save'' then',
'     wwv_flow_ws_api.save_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'         p_group_name       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NAME''),',
'         p_description      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DESCRIPTION''),         ',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_SHUTTLE_RIGHT''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''column_groups_delete'' then',
'     wwv_flow_ws_api.delete_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID'')',
'         );',
'  elsif l_widget_action = ''copy'' then',
'    wwv_flow_ws_api.copy_websheet (',
'         p_ws_app_id        => :WS_APP_ID,',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_new_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NEW_WORKSHEET_NAME''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''delete_websheet'' then    ',
'    wwv_flow_ws_api.delete_websheet (',
'        p_worksheet_id     => :P2_ID,',
'        p_websheet_id      => :P2_WEBSHEET_ID,               ',
'        p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),',
'        p_validation_error => l_validation_error);       ',
'  elsif l_widget_action = ''delete_rows'' then',
'    wwv_flow_ws_api.delete_rows (',
'        p_websheet_id      => :P2_WEBSHEET_ID,',
'        p_rows             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROWS''),',
'        p_selected_rows    => wwv_flow.g_x01,',
'        p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),',
'        p_validation_error => l_validation_error);',
'  elsif l_widget_action = ''set_column_value'' then',
'    wwv_flow_ws_api.set_column_value (',
'        p_websheet_id      => :P2_WEBSHEET_ID, ',
'        p_db_column_name   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'        p_new_value        => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NEW_COLUMN_VALUE''),',
'        p_rows             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROWS''),',
'        p_selected_rows    => wwv_flow.g_x01,',
'        p_validation_error => l_validation_error);',
'  elsif l_widget_action = ''replace_column_value'' then',
'    wwv_flow_ws_api.replace_column_value (',
'        p_websheet_id      => :P2_WEBSHEET_ID,',
'        p_rows              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROWS''),',
'        p_db_column_names   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMS''),',
'        p_find_what         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REPLACE''),',
'        p_replace_with      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REPLACE_WITH''),',
'        p_selected_rows     => wwv_flow.g_x01,',
'        p_validation_error  => l_validation_error);',
'  elsif l_widget_action = ''fill_column_value'' then',
'    wwv_flow_ws_api.fill_column_value (',
'        p_websheet_id      => :P2_WEBSHEET_ID,',
'        p_db_column_name     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),    ',
'        p_validation_error   => l_validation_error);',
'  elsif l_widget_action = ''lov_delete'' then',
'    wwv_flow_ws_api.delete_lov (',
'        p_worksheet_id     => :P2_ID,',
'        p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),  ',
'        p_validation_error => l_validation_error',
'        );     ',
'  elsif l_widget_action = ''toggle_checkboxes'' then',
'        if nvl(v(''P2_SHOW_CHECKBOX''),''N'') = ''Y'' then',
'            wwv_flow.update_cache_with_write(p_name => ''P2_SHOW_CHECKBOX'', p_value => ''N'');            ',
'        elsif nvl(v(''P2_SHOW_CHECKBOX''),''N'') = ''N'' then',
'            wwv_flow.update_cache_with_write(p_name => ''P2_SHOW_CHECKBOX'', p_value => ''Y'');',
'        end if;',
'  elsif l_widget_action = ''export'' then',
'    if wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_EXPORT_FORMAT'') = ''DATABASE'' then',
'        sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':2:''||:APP_SESSION||'':HTMLD'');',
'    end if;',
'  elsif l_widget_action = ''set_geocode'' then',
'    wwv_flow_ws_geocode.save_geocodes(',
'        p_worksheet_id => :P2_ID,',
'        p_columns      => wwv_flow.g_x01 );',
'  elsif l_widget_action = ''refresh_geocode'' then',
'    wwv_flow_ws_geocode.reset_geocodes(',
'        p_worksheet_id => :P2_ID);',
'  elsif l_widget_action = ''VALIDATION_SAVE'' then',
'     wwv_flow_ws_api.save_column_validation (',
'         p_ws_app_id        => :WS_APP_ID,',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID''),',
'         p_validation_level => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_LEVEL''),',
'         p_name             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_NAME''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_SEQUENCE''),',
'         p_type             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_TYPE''),',
'         p_expr1            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_expr2            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION''),',
'         p_error_message    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ERROR_MESSAGE''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''VALIDATION_DELETE'' then',
'     wwv_flow_ws_api.delete_column_validation (',
'         p_worksheet_id     => :P2_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID'')         ',
'         );       ',
'  end if;  ',
'',
'  if l_validation_error is null then',
'      sys.htp.prn(''true'');      ',
'  else',
'      sys.htp.prn(l_validation_error);      ',
'  end if;',
'exception when others then',
'  sys.htp.prn(''error ''||wwv_flow_escape.html(sqlerrm));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'websheet process error'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_process_comment=>'WebSheet dialog saving.'
);
end;
/
prompt --application/shared_components/logic/application_processes/item_row
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(2693010773842087.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ITEM_ROW'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_goto_ws_row       varchar2(32767);',
'    l_validation_error	varchar2(32767) := null;',
'    l_validation_count  number          := 0;',
'    l_validation_title  varchar2(4000)  := null;',
'    l_action            varchar2(4000)  := wwv_flow.g_x01;',
'begin',
'    -- Don''t process the row, if we''re removing a column.',
'    if l_action != ''column_remove'' then ',
'        wwv_flow_ws_api.process_row (',
'            p_ws_app_id     => :WS_APP_ID,',
'            p_worksheet_id  => :P2_ID,',
'            p_websheet_id   => :P2_WEBSHEET_ID,',
'            p_row_id        => :CURRENT_WORKSHEET_ROW,',
'            f01             => wwv_flow.g_f01,',
'            f02             => wwv_flow.g_f02,       ',
'            p_validation_error => l_validation_error,',
'            p_validation_count => l_validation_count,',
'            p_ajax_mode => true );',
'    end if;',
'    ',
'    if l_validation_count = 0 then',
'        htmldb_util.set_session_state(''CURRENT_WORKSHEET_ROW'', v(''GOTO_WORKSHEET_ROW''));',
'        htmldb_util.set_session_state(''P20_ROW_ID'', v(''GOTO_WORKSHEET_ROW''));',
'        --htmldb_util.set_session_state(''P20_IR_ID'', :P2_ID);',
'        --htmldb_util.set_session_state(''P20_DATA_GRID_ID'', :P2_WEBSHEET_ID);',
'        --:CURRENT_WORKSHEET_ROW := :GOTO_WORKSHEET_ROW;',
'        --:P20_ROW_ID := :GOTO_WORKSHEET_ROW;',
'        --:P20_IR_ID := :P2_ID;',
'        --:P20_DATA_GRID_ID := :P2_WEBSHEET_ID; ',
'        -- Redraw the form, with the new row''s details.',
'        sys.htp.prn(''<div id="apexir_WORKSHEET_REGION" class="apex_worksheet">'');',
'        sys.htp.prn(''<div id="apexir_DETAIL" class="detail">'');        ',
'        wwv_flow_ws_form.show (',
'            p_ws_app_id            => :WS_APP_ID,',
'        	p_worksheet_id         => :P2_ID,',
'        	p_data_grid_id         => :P2_WEBSHEET_ID,',
'        	p_session              => :APP_SESSION,',
'        	p_app_user             => :APP_USER,',
'        	p_row_id               => v(''CURRENT_WORKSHEET_ROW''),         ',
'        	p_base_report_id       => :RPT_ID,',
'            p_partial_page_refresh => true,',
'            p_last_page_id         => :P20_LAST_PAGE_ID,',
'            p_last_section_id      => :P20_LAST_SECTION_ID);',
'        sys.htp.prn(''</div></div>'');',
'    else',
'        if l_validation_count = 1 then',
'            l_validation_title := wwv_flow_lang.system_message(''FLOW.SINGLE_VALIDATION_ERROR'');',
'        else',
'            l_validation_title := wwv_flow_lang.system_message(''FLOW.VALIDATION_ERROR'', l_validation_count);',
'        end if;',
'        l_validation_error := l_validation_title || ''<ul class="htmldbUlErr">'' || l_validation_error || ''</ul>'';',
'        sys.htp.prn(''error|'' || l_validation_error);',
'    end if;',
'      ',
'exception',
'    when others then',
'        sys.htp.prn(''error|'' || wwv_flow_escape.html(sqlerrm));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_process_comment=>'This application process is used to re-load single row detail view data with validation message from page 20.'
);
end;
/
prompt --application/shared_components/logic/application_processes/websheet_detail
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(2776923488356345.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'websheet_detail'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_widget_action           varchar2(32767) := upper(wwv_flow.g_widget_action);',
'  l_widget_action_mod       varchar2(32767) := wwv_flow.g_widget_action_mod;',
'  l_validation_error        varchar2(32767) := null;',
'begin  ',
'  if l_widget_action = ''NOTE_SAVE'' then      ',
'      wwv_flow_ws_api.add_note (',
'        p_ws_app_id         => :WS_APP_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,',
'        p_row_id            => :CURRENT_WORKSHEET_ROW,',
'        p_note_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NOTE_ID''),',
'        p_component_level   => ''ROW'',',
'        p_content           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NOTES''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''NOTE_DELETE'' then',
'      wwv_flow_ws_api.delete_note ( ',
'        p_note_id   => l_widget_action_mod);',
'  elsif l_widget_action = ''COLUMN_PROPERTIES_SAVE'' then      ',
'      wwv_flow_ws_api.save_column_properties (',
'        p_worksheet_id      => :P2_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,',
'        p_app_user          => :APP_USER,',
'        p_db_column_name    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'        p_display_order     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'        p_group_id          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),       ',
'        p_display_as        => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),',
'        p_label             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_LABEL''),',
'        p_format_mask       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_FORMAT_MASK''),        ',
'        p_value_required    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),        ',
'        p_heading_alignment => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HEADING_ALIGNMENT''),',
'        p_column_alignment  => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_ALIGNMENT''),        ',
'        p_lov_id            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'        p_lov_name          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'        p_lov_entries       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),        ',
'        p_default_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'        p_default_text      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),        ',
'        p_width             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_WIDTH''),',
'        p_max_width         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_MAX_LENGTH''),',
'        p_height            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_HEIGHT''),',
'        p_help_text         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HELP_TEXT''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''LINK_SAVE'' then',
'      wwv_flow_ws_api.add_link (',
'        p_ws_app_id         => :WS_APP_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,          ',
'        p_row_id            => :CURRENT_WORKSHEET_ROW,',
'        p_component_level   => ''ROW'',',
'        p_link_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LINK_ID''),',
'        p_link_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LINK_NAME''), ',
'        p_url               => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_URL''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''LINK_DELETE'' then',
'        wwv_flow_ws_api.delete_link ( ',
'            p_link_id   => l_widget_action_mod);',
'',
'  elsif l_widget_action = ''TAG_SAVE'' then',
'    wwv_flow_ws_api.add_tags (    ',
'        p_ws_app_id       => :WS_APP_ID,            ',
'        p_websheet_id     => :P2_WEBSHEET_ID,',
'        p_row_id          => :CURRENT_WORKSHEET_ROW,',
'        p_component_level => ''ROW'',',
'        p_tag             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_TAGS'')); ',
'  elsif l_widget_action = ''TAG_DELETE'' then',
'        wwv_flow_ws_api.delete_tag (',
'            p_websheet_id  => :P2_WEBSHEET_ID,',
'            p_row_id       => :CURRENT_WORKSHEET_ROW,',
'            p_tag_id       => l_widget_action_mod);',
'  elsif l_widget_action = ''ATTACHMENT_DELETE'' then',
'        wwv_flow_ws_attachment.delete_doc ( ',
'            p_doc_id   => l_widget_action_mod);',
'  elsif l_widget_action = ''LOV_DELETE'' then',
'    wwv_flow_ws_api.delete_lov (',
'        p_worksheet_id     => :P2_ID,',
'        p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),  ',
'        p_validation_error => l_validation_error',
'        );',
'  elsif l_widget_action = ''LOV_SAVE'' then',
'     wwv_flow_ws_api.save_lov (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),  ',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''VALIDATION_SAVE'' then',
'     wwv_flow_ws_api.save_column_validation (',
'         p_ws_app_id        => :WS_APP_ID,',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID''),',
'         p_validation_level => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_LEVEL''),',
'         p_name             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_NAME''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_SEQUENCE''),',
'         p_type             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_TYPE''),',
'         p_expr1            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_expr2            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION''),',
'         p_error_message    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ERROR_MESSAGE''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''VALIDATION_DELETE'' then',
'     wwv_flow_ws_api.delete_column_validation (',
'         p_worksheet_id     => :P2_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID'')         ',
'         );',
'  elsif l_widget_action = ''COLUMN_GROUPS_SAVE'' then',
'     wwv_flow_ws_api.save_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'         p_group_name       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NAME''),',
'         p_description      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DESCRIPTION''),         ',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_SHUTTLE_RIGHT''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''COLUMN_GROUPS_DELETE'' then',
'     wwv_flow_ws_api.delete_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID'')',
'         );',
'  -- cbcho',
'  elsif l_widget_action = ''COLUMN_ADD'' then',
'     wwv_flow_ws_api.add_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_report_id        => :RPT_ID,',
'         p_app_user         => :APP_USER,',
'         p_column_name      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_NAME''),',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),',
'         p_column_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_TYPE''),',
'         p_display_as       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'         p_value_required   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),',
'         p_default_type     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'         p_default_text     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),',
'         p_validation_error => l_validation_error',
'         ); ',
'  elsif l_widget_action = ''COLUMN_REMOVE'' then',
'     wwv_flow_ws_api.remove_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),      ',
'         p_validation_error => l_validation_error',
'         );',
'  end if;',
'',
'  if l_validation_error is null then',
'      sys.htp.prn(''true'');      ',
'  else',
'      sys.htp.prn(l_validation_error);      ',
'  end if;',
'exception when others then',
'  sys.htp.prn(''error ''||wwv_flow_escape.html(sqlerrm));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/dialog
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(3291701954237236.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'DIALOG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_dialog.ondemand_dialog (',
'    p_websheet_id    => :P2_WEBSHEET_IT,',
'    p_worksheet_id   => :P2_ID,',
'    p_base_report_id => :RPT_ID,',
'    p_row_id         => :CURRENT_WORKSHEET_ROW );'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/cell
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(37132405811210809.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CELL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_ACTION			varchar2(32767);',
'    l_ROW				varchar2(32767);',
'    l_COLUMN			varchar2(32767);',
'    l_VALUE				varchar2(32767);',
'    l_CHANGE			varchar2(32767);',
'    l_validation_error	varchar2(32767) := null;',
'begin',
'    l_ROW       := wwv_flow_ws_api.get_item_value(p_item_name => ''ROW'');',
'    l_COLUMN    := wwv_flow_ws_api.get_item_value(p_item_name => ''COLUMN'');',
'    l_VALUE     := wwv_flow_ws_api.get_item_value(p_item_name => ''VALUE'');',
'    l_CHANGE    := wwv_flow_ws_api.get_item_value(p_item_name => ''CHANGE'');',
'    l_ACTION    := wwv_flow_ws_api.get_item_value(p_item_name => ''ACTION'');    ',
'    if l_ACTION = ''SAVE'' then                       ',
'    	wwv_flow_ws_api.update_cell( ',
'            p_worksheet_id     => :P2_ID,',
'    	   p_websheet_id      => :P2_WEBSHEET_ID, ',
'    	   p_row_id           => l_ROW , ',
'    	   p_column_name      => l_COLUMN, ',
'    	   p_new_value        => l_VALUE,',
'    	   p_change_count     => l_CHANGE,',
'    	   p_validation_error => l_validation_error);',
'     else ',
'    	null;',
'     end if;',
'    if l_validation_error is null then    ',
'        sys.htp.prn(''true'');',
'    else',
'        sys.htp.prn(l_validation_error);',
'    end if;',
'exception when others then',
'    sys.htp.prn(wwv_flow_escape.html(substr(sqlerrm,instr(sqlerrm,''ORA-'',-1))));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/get_item_help
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(452245511492078992.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_ITEM_HELP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_form.show_column_popup (',
'    p_db_column_name => wwv_flow_ws_api.get_item_value(p_item_name => ''COLUMN_NAME''),',
'    p_workspace_id   => to_number(:WORKSPACE_ID),',
'    p_worksheet_id   => to_number(:P2_ID));'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/get_dtfmt
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(460600501716774062.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_dtFmt'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_COLUMN			varchar2(32767);',
'    l_DATE                      varchar2(32767);',
'    l_app_date_format   varchar2(4000);',
'    l_format_mask       varchar2(4000);',
'    l_json_return           varchar2(32767);',
'begin',
'    l_COLUMN    := wwv_flow_ws_api.get_item_value(p_item_name => ''COLUMN'');',
'    l_DATE      := wwv_flow_ws_api.get_item_value(p_item_name => ''DATE'');',
'',
'    l_json_return := wwv_flow_ws_api.inline_date_picker_options(',
'        p_worksheet_id => :P2_ID,',
'        p_date         => l_DATE,',
'        p_column       => l_COLUMN );',
'',
'',
'    sys.htp.prn(l_json_return);',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/get_lov_json
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(615062144451949851.4902)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_LOV_JSON'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_worksheet_id varchar2(32767) := wwv_flow.g_x01;  ',
'    l_single_id    varchar2(32767) := wwv_flow_worksheet_ajax.clean_column_name(wwv_flow.g_x02);',
'begin',
'    wwv_flow_ws_api.get_lov_json(',
'        p_worksheet_id   => l_worksheet_id,',
'        p_db_column_name => l_single_id );',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_action
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24477906500589587.4902)
,p_name=>'AJAX_WS_ACTION'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'FILTER,SEARCH,SORT'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_column
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24506014409837883.4902)
,p_name=>'AJAX_WS_COLUMN'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_filter
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24505231939833457.4902)
,p_name=>'AJAX_WS_FILTER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_filter_type
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24503818779829694.4902)
,p_name=>'AJAX_WS_FILTER_TYPE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_num
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(25407924412215582.4902)
,p_name=>'AJAX_WS_NUM'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/app_name
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(187889401560281661.4902)
,p_name=>'APP_NAME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/builder_session_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(406291700131840546.4902)
,p_name=>'BUILDER_SESSION_ID'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/current_worksheet_row
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(179652013865859868.4902)
,p_name=>'CURRENT_WORKSHEET_ROW'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4900_last_view
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(161139305537061829.4902)
,p_name=>'F4900_LAST_VIEW'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4900_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(617034601471718123.4902)
,p_name=>'F4900_LOGIN_URL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4900_logo
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(471216109613872357.4902)
,p_name=>'F4900_LOGO'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(154784210014091542.4902)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/goto_worksheet_row
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(461331700195331599.4902)
,p_name=>'GOTO_WORKSHEET_ROW'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/home_page_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(458560827333195349.4902)
,p_name=>'HOME_PAGE_ID'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ir_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185115316114835976.4902)
,p_name=>'IR_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This application item is used to run Websheet reports and Data Grid on page 3010.'
);
end;
/
prompt --application/shared_components/logic/application_items/item_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(7934826114498652.4902)
,p_name=>'ITEM_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/owner_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(176645422859500226.4902)
,p_name=>'OWNER_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/rpt_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(179806310494315818.4902)
,p_name=>'RPT_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/run_link
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185298032482647725.4902)
,p_name=>'RUN_LINK'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/section_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(20015114768535427.4902)
,p_name=>'SECTION_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/shownav
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(172130707665449025.4902)
,p_name=>'SHOWNAV'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/temporary_action
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(7965920927622901.4902)
,p_name=>'TEMPORARY_ACTION'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This is used to run a action using Ajax it should not be used on anything else and not be expected to save it''s value between requests.'
);
end;
/
prompt --application/shared_components/logic/application_items/temporary_filter
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(23088531657485941.4902)
,p_name=>'TEMPORARY_FILTER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/temporary_item
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(7939330981651397.4902)
,p_name=>'TEMPORARY_ITEM'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This is used to run a action using AJAX it should not be used on anything else and not be expected to save it''s value between requests.'
);
end;
/
prompt --application/shared_components/logic/application_items/worksheet_filter_type
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(23801903782632819.4902)
,p_name=>'WORKSHEET_FILTER_TYPE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/worksheet_name
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(78919021160643130.4902)
,p_name=>'WORKSHEET_NAME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ws_app_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185116129620839895.4902)
,p_name=>'WS_APP_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Websheet application ID'
);
end;
/
prompt --application/shared_components/logic/application_items/ws_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185115622347837829.4902)
,p_name=>'WS_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This application item is used to run Websheet reports and Data Grid on page 3010.'
);
end;
/
prompt --application/shared_components/logic/application_items/ws_setup_valid
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(451945309573247981.4902)
,p_name=>'WS_SETUP_VALID'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_computations/f4900_logo
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(471216708359881476.4902)
,p_computation_sequence=>100
,p_computation_item=>'F4900_LOGO'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_ws_api.get_logo(p_ws_app_id=>:WS_APP_ID,p_security_group_id=>:flow_security_group_id);'
);
end;
/
prompt --application/shared_components/logic/application_computations/home_page_id
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(458561209110199522.4902)
,p_computation_sequence=>10
,p_computation_item=>'HOME_PAGE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select HOME_PAGE_ID',
'  from WWV_FLOW_WS_APPLICATIONS',
' where id = :WS_APP_ID',
'and security_group_id = :WORKSPACE_ID'))
);
end;
/
prompt --application/shared_components/logic/application_computations/f4900_login_url
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(617038105476908535.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LOGIN_URL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_ws_webpage.get_login_url(:WS_APP_ID);'
);
end;
/
prompt --application/shared_components/logic/application_computations/shownav
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(172131313205450686.4902)
,p_computation_sequence=>10
,p_computation_item=>'SHOWNAV'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'Y'
);
end;
/
prompt --application/shared_components/logic/application_computations/builder_session_id
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(406460806842851924.4902)
,p_computation_sequence=>10
,p_computation_item=>'BUILDER_SESSION_ID'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_security.get_builder_session_id;'
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/accessibility_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(680996401756072029.4902)
,p_lov_name=>'ACCESSIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(680996401756072029.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(680996730973072031.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lecteur d''\00E9cran')
,p_lov_return_value=>'SCREEN_READER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(680996901097072032.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Contraste \00E9lev\00E9')
,p_lov_return_value=>'HIGH_CONTRAST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/acl_priv
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4183515898494342.4902)
,p_lov_name=>'ACL_PRIV'
,p_lov_query=>'.'||wwv_flow_api.id(4183515898494342.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4183804118494346.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualiser et modifier'
,p_lov_return_value=>'EDIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4184010247494348.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Visualiser seulement'
,p_lov_return_value=>'VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/alignment_l_c_r
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187517603302080409.4902)
,p_lov_name=>'ALIGNMENT_L_C_R'
,p_lov_query=>'.'||wwv_flow_api.id(187517603302080409.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187517811651080411.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00E0 gauche')
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187518005825080412.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'au centre'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187518229295080412.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('\00E0 droite')
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_or_selected_or_null_row_domain
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6200201590860952.4902)
,p_lov_name=>'ALL OR SELECTED OR NULL (ROW DOMAIN)'
,p_lov_query=>'.'||wwv_flow_api.id(6200201590860952.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6200409579860953.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Toutes les lignes'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6200608372860954.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Lignes s\00E9lectionn\00E9es')
,p_lov_return_value=>'SELECTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20082523608431635.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Lignes NULL'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/annotation_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(251379008493597083.4902)
,p_lov_name=>'ANNOTATION TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(251379008493597083.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251379209365597089.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Fichiers'
,p_lov_return_value=>'ATTACHMENT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:4020:&SESSION.:::4020:P4020_ANNOTATION_TYPE:ATTACHMENT"><img src="#IMAGE_PREFIX#menu/wiz_multiple_140x90.gif" height="90" widt'
||'h="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251379423628597095.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Remarques'
,p_lov_return_value=>'NOTE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:4020:&SESSION.:::4020:P4020_ANNOTATION_TYPE:NOTE"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" '
||'width="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251379620302597095.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Balise'
,p_lov_return_value=>'TAG'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:4020:&SESSION.:::4020:P4020_ANNOTATION_TYPE"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" width'
||'="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631189019655476474.4902)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Liens'
,p_lov_return_value=>'LINK'
,p_lov_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_lov_disp_cond=>'906'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_name_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(172965416124494830.4902)
,p_lov_name=>'APPLICATION NAME RETURNING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       not exists (',
'       select null from wwv_flow_language_map',
'       where translation_flow_id = f.id and ',
'         security_group_id = :flow_security_group_id) and',
'       (',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :app_user and ',
'             flow_id is null and ',
'             security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :app_user and ',
'             flow_id = f.id and ',
'             security_group_id = :flow_security_group_id ))'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/attachment_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177785329944899135.4902)
,p_lov_name=>'ATTACHMENT OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(177785329944899135.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177785525202899136.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Afficher dans l''\00E9tat avec l''ic\00F4ne et le nom')
,p_lov_return_value=>'BOTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177785716327899136.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Afficher dans l''\00E9tat avec le nom uniquement')
,p_lov_return_value=>'NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177785901379899136.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Afficher avec l''ic\00F4ne uniquement')
,p_lov_return_value=>'ICON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_content_disposition
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(382939512009208407.4902)
,p_lov_name=>'BLOB_CONTENT_DISPOSITION'
,p_lov_query=>'.'||wwv_flow_api.id(382939512009208407.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382939815594208407.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Incorporation'
,p_lov_return_value=>'inline'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382940022425208407.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Pi\00E8ce jointe')
,p_lov_return_value=>'attachment'
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_format_mask
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(382915819151201016.4902)
,p_lov_name=>'BLOB_FORMAT_MASK'
,p_lov_query=>'.'||wwv_flow_api.id(382915819151201016.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382916131553201016.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'DOWNLOAD'
,p_lov_return_value=>'DOWNLOAD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382916305818201016.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'IMAGE'
,p_lov_return_value=>'IMAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_on
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22967915270872919.4902)
,p_lov_name=>'BREAK ON'
,p_lov_query=>'.'||wwv_flow_api.id(22967915270872919.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24136313336017502.4902)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Pas de saut'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22968117650872920.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Colonne 1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22968313303872920.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Colonnes 1 et 2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22968508747872920.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Colonnes 1, 2 et 3'
,p_lov_return_value=>'3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_functions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261396928274568408.4902)
,p_lov_name=>'CHART FUNCTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(261396928274568408.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397126573568409.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Total'
,p_lov_return_value=>'SUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397325621568409.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Moyenne'
,p_lov_return_value=>'AVG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397511265568409.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Minimum'
,p_lov_return_value=>'MIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397717213568409.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Maximum'
,p_lov_return_value=>'MAX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397932564568409.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Nombre'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_sort
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261446703779618102.4902)
,p_lov_name=>'CHART SORT'
,p_lov_query=>'.'||wwv_flow_api.id(261446703779618102.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261446917693618102.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Valeur par d\00E9faut')
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447112282618103.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Valeur - Croissante'
,p_lov_return_value=>'VALUE_ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447310262618103.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Valeur - D\00E9croissante')
,p_lov_return_value=>'VALUE_DESC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447525538618103.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Libell\00E9 - Croissant')
,p_lov_return_value=>'LABEL_ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447704881618103.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Libell\00E9 - D\00E9croissant')
,p_lov_return_value=>'LABEL_DESC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_3d
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(430988702419464894.4902)
,p_lov_name=>'CHART_3D'
,p_lov_query=>'.'||wwv_flow_api.id(430988702419464894.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(430988921586464895.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activer 3D'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_orientation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(107038275478210797.4902)
,p_lov_name=>'CHART_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_api.id(107038275478210797.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(107038518670210798.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'vertical'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(107038941666210804.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'horizontal'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(259453605523899856.4902)
,p_lov_name=>'CHART_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(259453605523899856.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259453813697899860.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'A barres'
,p_lov_return_value=>'bar'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:bar"><img src="#IMAGE_PREFIX#ws/ws-column-chart.png" alt="#DISPLAY_VALUE#" width="128" height='
||'"128" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259454024992899863.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'A courbes avec aires'
,p_lov_return_value=>'lineWithArea'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:lineWithArea"><img src="#IMAGE_PREFIX#ws/ws-line-area-chart.png" alt="#DISPLAY_VALUE#" width="'
||'128" height="128" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259454217060899863.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'A secteurs'
,p_lov_return_value=>'pie'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:pie"><img src="#IMAGE_PREFIX#ws/ws-pie-chart.png" alt="#DISPLAY_VALUE#" width="128" height="12'
||'8" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259454601928899863.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'A courbes'
,p_lov_return_value=>'line'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:line"><img src="#IMAGE_PREFIX#ws/ws-line-chart.png" alt="#DISPLAY_VALUE#" width="128" height="'
||'128" /></a></td><td>&nbsp;</td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(169740222151305876.4902)
,p_lov_name=>'COLUMN GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME display_value, ID return_value ',
'from WWV_FLOW_WORKSHEET_COL_GROUPS',
'where worksheet_id = :p2_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_label_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157556708734983770.4902)
,p_lov_name=>'COLUMN LABEL RETURNING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COLUMN_LABEL display_value, ID return_value ',
'from WWV_FLOW_WORKSHEET_COLUMNS',
'where worksheet_id = :p2_id',
'order by DISPLAY_ORDER, upper(column_label)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_filter_operators
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178773405987392681.4902)
,p_lov_name=>'COLUMN_FILTER_OPERATORS'
,p_lov_query=>'.'||wwv_flow_api.id(178773405987392681.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178773624786392683.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178773816619392689.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774029915392689.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774203147392689.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'>='
,p_lov_return_value=>'>='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774404844392689.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774611401392689.4902)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'<='
,p_lov_return_value=>'<='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774803359392690.4902)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'est NULL'
,p_lov_return_value=>'is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775031923392690.4902)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'n''est pas NULL'
,p_lov_return_value=>'is not null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775213763392690.4902)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'est comme'
,p_lov_return_value=>'like'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775414742392690.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'n''est pas comme'
,p_lov_return_value=>'not like'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775626341392690.4902)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'dans'
,p_lov_return_value=>'in'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775816853392690.4902)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'n''est pas dans'
,p_lov_return_value=>'not in'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178776030779392690.4902)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'contient'
,p_lov_return_value=>'contains'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178776226760392690.4902)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'ne contient pas'
,p_lov_return_value=>'does not contain'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178776415143392690.4902)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'regexp_like'
,p_lov_return_value=>'regexp_like'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178778229882399595.4902)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'entre'
,p_lov_return_value=>'between'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178779911313403739.4902)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'est dans les derniers'
,p_lov_return_value=>'is in the last'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178780215815404960.4902)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'n''est pas dans les dern.'
,p_lov_return_value=>'is not in the last'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178780518932405861.4902)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>'figure sur la ligne suivante'
,p_lov_return_value=>'is in the next'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178780722741406996.4902)
,p_lov_disp_sequence=>38
,p_lov_disp_value=>'ne figure pas sur la ligne suivante'
,p_lov_return_value=>'is not in the next'
);
end;
/
prompt --application/shared_components/user_interface/lovs/comparison_expressions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157548605355963845.4902)
,p_lov_name=>'COMPARISON EXPRESSIONS'
,p_lov_query=>'.'||wwv_flow_api.id(157548605355963845.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157548815917963845.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549008133963845.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177923106066093754.4902)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'>='
,p_lov_return_value=>'>='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549227534963845.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177923812646095626.4902)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'<='
,p_lov_return_value=>'<='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549604153963845.4902)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'est comme'
,p_lov_return_value=>'LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179793328389112795.4902)
,p_lov_disp_sequence=>51
,p_lov_disp_value=>'Pas comme'
,p_lov_return_value=>'not like '
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549823989963846.4902)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6035512141000243.4902)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'est NULL'
,p_lov_return_value=>'is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6035915258001184.4902)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'n''est pas NULL'
,p_lov_return_value=>'is not null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24709324557666429.4902)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'dans'
,p_lov_return_value=>'in'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24709626635667023.4902)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'n''est pas dans'
,p_lov_return_value=>'not in'
);
end;
/
prompt --application/shared_components/user_interface/lovs/component_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(455012825948829772.4902)
,p_lov_name=>'COMPONENT_LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(455012825948829772.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(455013000682829776.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'WEBPAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(455013212503829779.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Ligne'
,p_lov_return_value=>'ROW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/control_break_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22978927746952171.4902)
,p_lov_name=>'CONTROL BREAK GROUPS'
,p_lov_query=>'.'||wwv_flow_api.id(22978927746952171.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22979110471952172.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tous les groupes de commande BREAK'
,p_lov_return_value=>'ALL_GROUPS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22979300855952172.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Un groupe de commande BREAK'
,p_lov_return_value=>'ONE_GROUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_data_or_report
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(173236520362944199.4902)
,p_lov_name=>'CREATE DATA OR REPORT'
,p_lov_query=>'.'||wwv_flow_api.id(173236520362944199.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173236715134944199.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Grille de donn\00E9es')
,p_lov_return_value=>'DATA'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:205:&SESSION.:::205"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" width="140" alt="#DISPLAY_VAL'
||'UE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(181301630402676517.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Etat'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:1310:&SESSION.:::1310,1320"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" width="140" alt="#DISP'
||'LAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_security.current_user_is_not_reader',
'and wwv_flow_ws_security.sql_enabled(:WS_APP_ID)',
'and wwv_flow_ws_security.sql_enabled_inst()'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_text_section_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(18725515716010637.4902)
,p_lov_name=>'CREATE TEXT SECTION METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(18725515716010637.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(18725807766010639.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cr\00E9er une section de texte unique')
,p_lov_return_value=>'NORMAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(18726004246010640.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Cr\00E9er plusieurs sections de texte \00E0 partir de la feuille de calcul')
,p_lov_return_value=>'SPREADSHEET'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_worksheet_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2960208403984068.4902)
,p_lov_name=>'CREATE WORKSHEET OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(2960208403984068.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2960523083984070.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Enti\00E8rement nouveau')
,p_lov_return_value=>'SCRATCH'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:201:&SESSION.:::201,WS_WIZ_COLUMNS"><img src="#IMAGE_PREFIX#ws/ws-from-scratch.png" height="128" width="128" alt="#DISPLAY_VAL'
||'UE#" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2960708902984070.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Copier/coller'
,p_lov_return_value=>'CUTANDPASTE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:206:&SESSION.:::206,CLOB_CONTENT,RP"><img src="#IMAGE_PREFIX#ws/ws-copy-paste.png" height="128" width="128" alt="#DISPLAY_VALU'
||'E#" /></a></td><td>&nbsp;</td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_ws_auth_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174618728240220381.4902)
,p_lov_name=>'CREATE_WS_AUTH_OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, v from (',
'select ',
'  :product_name||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/admin_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d ,''HTML DB'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.NO_AUTH'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/opendoor_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DATABASE'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.DBACCOUNT'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/dbauth_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DBACCOUNT'' v from dual)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_grid
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(179694201378826303.4902)
,p_lov_name=>'DATA GRID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_section_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(746262913082105905.4902)
,p_lov_name=>'DATA SECTION STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(746262913082105905.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(746263201593105907.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Style 1'
,p_lov_return_value=>'1'
,p_lov_template=>'<img src="#IMAGE_PREFIX#ws/report_style_1.gif" height="48" width="128" alt="#DISPLAY_VALUE#" class="radioGroupImage"/>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(746263432526105909.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Style 2'
,p_lov_return_value=>'2'
,p_lov_template=>'<img src="#IMAGE_PREFIX#ws/report_style_2.gif" height="48" width="128" alt="#DISPLAY_VALUE#" class="radioGroupImage"/>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(746263605381105909.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Style 3'
,p_lov_return_value=>'3'
,p_lov_template=>'<img src="#IMAGE_PREFIX#ws/report_style_3.gif" height="48" width="128" alt="#DISPLAY_VALUE#" class="radioGroupImage"/>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_grid_returning_worksheet_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(745648018052041064.4902)
,p_lov_name=>'DATA_GRID_RETURNING_WORKSHEET_ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.websheet_name d, w.id r',
'from wwv_flow_ws_websheet_attr a, wwv_flow_worksheets w',
'where a.worksheet_id = w.id',
'and a.ws_app_id = :ws_app_id',
'and a.security_group_id = :flow_security_group_id',
'and a.websheet_type = ''DATA'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_with_user_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(497241820310060978.4902)
,p_lov_name=>'DATA_WITH_USER_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ws.websheet_name d, ws.websheet_name r',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'wwv_flow_ws_applications a,',
'wwv_flow_ws_websheet_attr ws',
'where a.id = ws.ws_app_id',
'and ws.worksheet_id = i.id',
'and r.worksheet_id = i.id',
'and r.websheet_id is not null',
'and r.security_group_id = :flow_security_group_id',
'and a.id = :ws_app_id',
'and r.application_user = :app_user',
'and r.session_id is null',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/date_format_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460140315153255042.4902)
,p_lov_name=>'DATE_FORMAT_LOV'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_rows
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161072331491917913.4902)
,p_lov_name=>'DISPLAY ROWS'
,p_lov_query=>'.'||wwv_flow_api.id(161072331491917913.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161075705996920049.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161076108073920614.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161072510215917914.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161072713820917914.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161072930490917914.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073118910917914.4902)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073314283917914.4902)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073520539917914.4902)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073726945917914.4902)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073905737917914.4902)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161074106700917914.4902)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161074329336917914.4902)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161074529716917914.4902)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177272802329654940.4902)
,p_lov_disp_sequence=>9999
,p_lov_disp_value=>'Tout'
,p_lov_return_value=>'100000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/expression_types_column_value
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(175787711198660520.4902)
,p_lov_name=>'EXPRESSION TYPES (COLUMN/VALUE)'
,p_lov_query=>'.'||wwv_flow_api.id(175787711198660520.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175788023327660521.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Valeur'
,p_lov_return_value=>'VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175788232491660521.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Colonne'
,p_lov_return_value=>'COLUMN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/feedback_component
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(945870019196474793.4902)
,p_lov_name=>'FEEDBACK_COMPONENT'
,p_lov_query=>'.'||wwv_flow_api.id(945870019196474793.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870326932474795.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Grille de donn\00E9es')
,p_lov_return_value=>'Datagrid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870517003474796.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'Page'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870730487474797.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Contr\00F4le d''acc\00E8s')
,p_lov_return_value=>'Access Control'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870930916474797.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Etat'
,p_lov_return_value=>'Report'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945871101913474797.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Syntaxe de balisage'
,p_lov_return_value=>'Markup Syntax'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945871316354474797.4902)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Autre'
,p_lov_return_value=>'Other'
);
end;
/
prompt --application/shared_components/user_interface/lovs/first_row_contains_column_headings
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(799517811838484369.4902)
,p_lov_name=>'FIRST_ROW_CONTAINS_COLUMN_HEADINGS'
,p_lov_query=>'.'||wwv_flow_api.id(799517811838484369.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(799518019833484371.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('La premi\00E8re ligne contient des en-t\00EAtes de colonne')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187514328189059218.4902)
,p_lov_name=>'FORMAT MASK DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hr_column_names
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162817307492916433.4902)
,p_lov_name=>'HR COLUMN NAMES'
,p_lov_query=>'.'||wwv_flow_api.id(162817307492916433.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162817620426916433.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Pr\00E9nom')
,p_lov_return_value=>'FIRST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162817815634916433.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nom de famille'
,p_lov_return_value=>'LAST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162818030292916433.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Nom complet'
,p_lov_return_value=>'FULL_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162818210247916433.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Adresse \00E9lectronique')
,p_lov_return_value=>'EMAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hr_column_names_for_seeding
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(166804518636616614.4902)
,p_lov_name=>'HR COLUMN NAMES (FOR SEEDING)'
,p_lov_query=>'.'||wwv_flow_api.id(166804518636616614.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166804814185616615.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Pr\00E9nom')
,p_lov_return_value=>'FIRST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166805014333616615.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nom de famille'
,p_lov_return_value=>'LAST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166805200851616615.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Adresse \00E9lectronique')
,p_lov_return_value=>'EMAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166805429286616615.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Transf\00E9rer le nom')
,p_lov_return_value=>'FORWARD_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166807720152626504.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Inverser le nom'
,p_lov_return_value=>'REVERSE_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166808026385628340.4902)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'GUID'
,p_lov_return_value=>'USERID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166808400544630345.4902)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Titre facultatif'
,p_lov_return_value=>'TITLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166808808855632713.4902)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Centre de co\00FBts')
,p_lov_return_value=>'COST_CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166809111972633632.4902)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Organisation'
,p_lov_return_value=>'ORGANIZATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166809515781634745.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('T\00E9l\00E9phone professionnel')
,p_lov_return_value=>'WORK_PHONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166809820629636090.4902)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('B\00E2timent du bureau')
,p_lov_return_value=>'WORK_BUILDING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166810125131637429.4902)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Etage du bureau'
,p_lov_return_value=>'WORK_FLOOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166810430672639004.4902)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Num\00E9ro du bureau')
,p_lov_return_value=>'WORK_OFFICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166810803099640515.4902)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Adresse professionnelle'
,p_lov_return_value=>'WORK_ADDR1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166811408293641989.4902)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Ville du bureau'
,p_lov_return_value=>'WORK_CITY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166812011410642946.4902)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Etat du bureau'
,p_lov_return_value=>'WORK_STATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166812416605644416.4902)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Code postal de l''organisation'
,p_lov_return_value=>'WORK_ZIP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166812722492646170.4902)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Pays de l''organisation'
,p_lov_return_value=>'WORK_COUNTRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166813328033647779.4902)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>unistr('Sup\00E9rieurs directs')
,p_lov_return_value=>'DIRECTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166813732188648908.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Nombre total d''\00E9tats')
,p_lov_return_value=>'TOTAL_REPORTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166814003230649994.4902)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Responsable ?'
,p_lov_return_value=>'IS_MANAGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(502587106305037128.4902)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_reference_id=>107899321117195063.4902
,p_lov_query=>'.'||wwv_flow_api.id(502587106305037128.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699077671048180068.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Az\00E9ri (az)')
,p_lov_return_value=>'az'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699078037978180068.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699078405074180068.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (ar)'
,p_lov_return_value=>'ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699078828289180068.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Alg\00E9rie) (ar-dz)')
,p_lov_return_value=>'ar-dz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699079234537180069.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Bahre\00EFn) (ar-bh)')
,p_lov_return_value=>'ar-bh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699079606258180069.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Egypte) (ar-eg)'
,p_lov_return_value=>'ar-eg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699080050912180069.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Iraq) (ar-iq)'
,p_lov_return_value=>'ar-iq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699080454215180069.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Jordanie) (ar-jo)'
,p_lov_return_value=>'ar-jo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699080864791180070.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Kowe\00EFt) (ar-kw)')
,p_lov_return_value=>'ar-kw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699081255911180070.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Liban) (ar-lb)'
,p_lov_return_value=>'ar-lb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699081603517180070.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Libye) (ar-ly)'
,p_lov_return_value=>'ar-ly'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699082008415180070.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Maroc) (ar-ma)'
,p_lov_return_value=>'ar-ma'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699082459066180070.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Oman) (ar-om)'
,p_lov_return_value=>'ar-om'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699082811282180071.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Qatar) (ar-qa)'
,p_lov_return_value=>'ar-qa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699083231940180071.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Arabie saoudite) (ar-sa)'
,p_lov_return_value=>'ar-sa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699083518057180071.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Syrie) (ar-sy)'
,p_lov_return_value=>'ar-sy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699083935661180071.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Tunisie) (ar-tn)'
,p_lov_return_value=>'ar-tn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699084301028180072.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (E.A.U.) (ar-ae)'
,p_lov_return_value=>'ar-ae'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699084726592180072.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Y\00E9men) (ar-ye)')
,p_lov_return_value=>'ar-ye'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699085149541180072.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Assamais (as)'
,p_lov_return_value=>'as'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699085551541180073.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Basque (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699085941439180073.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('B\00E9larussien (be)')
,p_lov_return_value=>'be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699086317208180073.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bengali (bn)'
,p_lov_return_value=>'bn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699086722772180073.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgare (bg)'
,p_lov_return_value=>'bg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699087134419180073.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalan (ca)'
,p_lov_return_value=>'ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699087520210180074.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699087954139180074.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Chine) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699088321602180074.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Hong Kong SAR) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699088718989180074.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Macao SAR) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699089197590180075.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Singapour) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699089584303180075.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Taiwan) (zh-tw)'
,p_lov_return_value=>'zh-tw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699089965064180075.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croate (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699090330404180075.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tch\00E8que (cs)')
,p_lov_return_value=>'cs'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699090719346180076.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danois (da)'
,p_lov_return_value=>'da'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699091122669180076.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00E9erlandais (Belgique) (nl-be)')
,p_lov_return_value=>'nl-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699091589403180076.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00E9erlandais (Pays-Bas) (nl)')
,p_lov_return_value=>'nl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699091971660180076.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (en)'
,p_lov_return_value=>'en'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699092358936180076.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Australie) (en-au)'
,p_lov_return_value=>'en-au'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699092773809180077.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Belize) (en-bz)'
,p_lov_return_value=>'en-bz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699093124993180077.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Canada) (en-ca)'
,p_lov_return_value=>'en-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699093521574180077.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Irlande) (en-ie)'
,p_lov_return_value=>'en-ie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699093981695180077.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Anglais (Jama\00EFque) (en-jm)')
,p_lov_return_value=>'en-jm'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699094398450180078.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Anglais (Nouvelle-Z\00E9lande) (en-nz)')
,p_lov_return_value=>'en-nz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699094718902180078.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Philippines) (en-ph)'
,p_lov_return_value=>'en-ph'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699095171931180078.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Afrique du Sud) (en-za)'
,p_lov_return_value=>'en-za'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699095556248180078.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Anglais (Trinit\00E9) (en-tt)')
,p_lov_return_value=>'en-tt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699095900882180078.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Royaume-Uni) (en-gb)'
,p_lov_return_value=>'en-gb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699096397022180079.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Etats-Unis) (en-us)'
,p_lov_return_value=>'en-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699096756533180079.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Zimbabwe) (en-zw)'
,p_lov_return_value=>'en-zw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699097111707180079.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonien (et)'
,p_lov_return_value=>'et'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699097569130180079.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('FYRO Mac\00E9donien (mk)')
,p_lov_return_value=>'mk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699097901194180080.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Faeroese (fo)'
,p_lov_return_value=>'fo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699098392128180080.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699098761314180080.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Suisse) (fr-ch)')
,p_lov_return_value=>'fr-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699099157140180080.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnois (fi)'
,p_lov_return_value=>'fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699099528056180081.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Belgique) (fr-be)')
,p_lov_return_value=>'fr-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699099985670180081.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Canada) (fr-ca)')
,p_lov_return_value=>'fr-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699100362011180081.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (France) (fr)')
,p_lov_return_value=>'fr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699100749619180081.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Luxembourg) (fr-lu)')
,p_lov_return_value=>'fr-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699101188548180082.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Monaco) (fr-mc)')
,p_lov_return_value=>'fr-mc'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699101509999180082.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ga\00E9lique (gd)')
,p_lov_return_value=>'gd'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699101965546180082.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Galicien (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699102367955180082.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Autriche) (de-at)'
,p_lov_return_value=>'de-at'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699102767340180083.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Allemagne) (de)'
,p_lov_return_value=>'de'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699103114120180083.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Liechtenstein) (de-li)'
,p_lov_return_value=>'de-li'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699103543063180083.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Luxembourg) (de-lu)'
,p_lov_return_value=>'de-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699103949411180083.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Suisse) (de-ch)'
,p_lov_return_value=>'de-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699104368944180083.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Grec (el)'
,p_lov_return_value=>'el'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699104710217180084.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gujarati (gu)'
,p_lov_return_value=>'gu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699105112508180084.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('H\00E9breu (he)')
,p_lov_return_value=>'he'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699105550789180084.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699105901185180085.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hongrois (hu)'
,p_lov_return_value=>'hu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699106301886180085.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Islandais (is)'
,p_lov_return_value=>'is'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699106757512180085.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Indon\00E9sien (id)')
,p_lov_return_value=>'id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699107115109180085.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italien (Italie) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699107521210180086.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italien (Suisse) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699107936215180086.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japonais (ja)'
,p_lov_return_value=>'ja'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699108362538180086.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kannada (kn)'
,p_lov_return_value=>'kn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699108709201180086.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakh (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699109156123180086.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699109579709180087.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cor\00E9en (ko)')
,p_lov_return_value=>'ko'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699109999363180087.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kirghiz (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699110323574180087.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Letton (lv)'
,p_lov_return_value=>'lv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699110750109180087.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lituanien (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699111197428180088.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malais (Malaisie) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699111558985180088.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699111988302180088.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maltais (mt)'
,p_lov_return_value=>'mt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699112318794180088.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699112751141180088.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00E9palais (Inde) (ne)')
,p_lov_return_value=>'ne'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699113167827180089.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E9gien (Bokmal) (nb-no)')
,p_lov_return_value=>'nb-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699113521452180089.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E9gien (Bokmal) (no)')
,p_lov_return_value=>'no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699113935508180089.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E9gien (Nynorsk) (nn-no)')
,p_lov_return_value=>'nn-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699114353177180089.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699114731122180089.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polonais (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699115176842180090.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Portugais (Br\00E9sil) (pt-br)')
,p_lov_return_value=>'pt-br'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699115528210180090.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugais (Portugal) (pt)'
,p_lov_return_value=>'pt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699115900344180090.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pendjabi (pa)'
,p_lov_return_value=>'pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699116347937180090.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Roumain (ro)'
,p_lov_return_value=>'ro'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699116720955180091.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russe (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699117177554180091.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russe (Moldova) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699117577240180091.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbe (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699117988910180091.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovaque (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699118314040180091.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Slov\00E8ne (sl)')
,p_lov_return_value=>'sl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699118753922180092.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Argentine) (es-ar)'
,p_lov_return_value=>'es-ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699119188393180092.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Bolivie) (es-bo)'
,p_lov_return_value=>'es-bo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699119581631180092.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Chili) (es-cl)'
,p_lov_return_value=>'es-cl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699119997191180092.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Colombie) (es-co)'
,p_lov_return_value=>'es-co'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699120318838180092.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Costa Rica) (es-cr)'
,p_lov_return_value=>'es-cr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699120709109180093.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espagnol (R\00E9publique dominicaine) (es-do)')
,p_lov_return_value=>'es-do'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699121134727180093.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Equateur) (es-ec)'
,p_lov_return_value=>'es-ec'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699121568485180093.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (El Salvador) (es-sv)'
,p_lov_return_value=>'es-sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699121921139180093.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Guatemala) (es-gt)'
,p_lov_return_value=>'es-gt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699122338312180094.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Honduras) (es-hn)'
,p_lov_return_value=>'es-hn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699122706175180094.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Mexique) (es-mx)'
,p_lov_return_value=>'es-mx'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699123193173180094.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Nicaragua) (es-ni)'
,p_lov_return_value=>'es-ni'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699123576249180094.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espagnol (Panam\00E1) (es-pa)')
,p_lov_return_value=>'es-pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699123952759180094.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Paraguay) (es-py)'
,p_lov_return_value=>'es-py'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699124377656180095.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espagnol (P\00E9rou) (es-pe)')
,p_lov_return_value=>'es-pe'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699124748226180095.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Porto Rico) (es-pr)'
,p_lov_return_value=>'es-pr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699125127369180095.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Traditionnel) (es)'
,p_lov_return_value=>'es'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699125511532180095.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Etats-Unis) (es-us)'
,p_lov_return_value=>'es-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699125971306180096.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Uruguay) (es-uy)'
,p_lov_return_value=>'es-uy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699126309761180096.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Venezuela) (es-ve)'
,p_lov_return_value=>'es-ve'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699126741047180096.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Su\00E9dois (sv)')
,p_lov_return_value=>'sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699127176377180096.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Su\00E9dois (Finlande) (sv-fi)')
,p_lov_return_value=>'sv-fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699127597883180096.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamoul (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699127927061180097.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('T\00E9lougou (te)')
,p_lov_return_value=>'te'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699128382178180097.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tha\00EF (th)')
,p_lov_return_value=>'th'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699128731024180097.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turc (tr)'
,p_lov_return_value=>'tr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699129157411180097.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukrainien (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699129585255180098.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ourdou (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699129971575180098.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ouzbek (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699130356540180098.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamien (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699130787098180098.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irlandais (ga)'
,p_lov_return_value=>'ga'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699131129792180100.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gallois (cy)'
,p_lov_return_value=>'cy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699131522308180101.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swahili (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699131990424180101.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Albanais'
,p_lov_return_value=>'sq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699132366271180101.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arm\00E9nien')
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_territories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(634728210841234369.4902)
,p_lov_name=>'I18N_TERRITORIES'
,p_reference_id=>634612723768159258.4902
,p_lov_query=>'.'||wwv_flow_api.id(634728210841234369.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62768512046442477.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Azerba\00EFdjan')
,p_lov_return_value=>'AZERBAIJAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62768930505442477.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alg\00E9rie')
,p_lov_return_value=>'ALGERIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62769309199442477.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Am\00E9rique')
,p_lov_return_value=>'AMERICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62769770701442478.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentine'
,p_lov_return_value=>'ARGENTINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62770125083442478.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Australie'
,p_lov_return_value=>'AUSTRALIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62770576591442478.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Autriche'
,p_lov_return_value=>'AUSTRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62770950179442478.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bahre\00EFn')
,p_lov_return_value=>'BAHRAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62771329653442479.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bangladesh'
,p_lov_return_value=>'BANGLADESH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62771751169442479.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belgique'
,p_lov_return_value=>'BELGIUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62772126105442479.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Br\00E9sil')
,p_lov_return_value=>'BRAZIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62772555136442479.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarie'
,p_lov_return_value=>'BULGARIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62772924789442480.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Canada'
,p_lov_return_value=>'CANADA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62773397498442480.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalogne'
,p_lov_return_value=>'CATALONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62773715833442480.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chili'
,p_lov_return_value=>'CHILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62774123927442480.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chine'
,p_lov_return_value=>'CHINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62774562332442481.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Colombie'
,p_lov_return_value=>'COLOMBIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62774972634442481.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'COSTA RICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62775351297442481.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatie'
,p_lov_return_value=>'CROATIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62775747407442481.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('R\00E9publique tch\00E8que')
,p_lov_return_value=>'CZECH REPUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62776195701442481.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danemark'
,p_lov_return_value=>'DENMARK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62776502463442482.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Equateur'
,p_lov_return_value=>'ECUADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62776904673442482.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Egypte'
,p_lov_return_value=>'EGYPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62777371218442482.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'EL SALVADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62777721576442482.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonie'
,p_lov_return_value=>'ESTONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62778182718442483.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finlande'
,p_lov_return_value=>'FINLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62778552942442483.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'France'
,p_lov_return_value=>'FRANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62778904538442483.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Mac\00E9doine')
,p_lov_return_value=>'FYR MACEDONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62779355380442483.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemagne'
,p_lov_return_value=>'GERMANY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62779707068442484.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gr\00E8ce')
,p_lov_return_value=>'GREECE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62780191281442484.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GUATEMALA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62780570482442484.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hong Kong'
,p_lov_return_value=>'HONG KONG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62780972409442484.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hongrie'
,p_lov_return_value=>'HUNGARY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62781310225442485.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Islande'
,p_lov_return_value=>'ICELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62781759163442485.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Inde'
,p_lov_return_value=>'INDIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62782151355442485.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Indon\00E9sie')
,p_lov_return_value=>'INDONESIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62782519713442486.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irak'
,p_lov_return_value=>'IRAQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62782982144442486.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irlande'
,p_lov_return_value=>'IRELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62783350927442486.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Isra\00EBl')
,p_lov_return_value=>'ISRAEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62783797822442486.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italie'
,p_lov_return_value=>'ITALY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62784141001442486.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japon'
,p_lov_return_value=>'JAPAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62784519265442487.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jordanie'
,p_lov_return_value=>'JORDAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62784913226442487.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakhstan'
,p_lov_return_value=>'KAZAKHSTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62785308333442487.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cor\00E9e')
,p_lov_return_value=>'KOREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62785717099442487.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Kowe\00EFt')
,p_lov_return_value=>'KUWAIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62786101932442488.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lettonie'
,p_lov_return_value=>'LATVIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62786558628442488.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Liban'
,p_lov_return_value=>'LEBANON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62786952129442488.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Libye'
,p_lov_return_value=>'LIBYA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62787323890442488.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lituanie'
,p_lov_return_value=>'LITHUANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62787782538442489.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Luxembourg'
,p_lov_return_value=>'LUXEMBOURG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62788182614442489.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malaisie'
,p_lov_return_value=>'MALAYSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62788528479442489.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mexique'
,p_lov_return_value=>'MEXICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62788997279442490.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maroc'
,p_lov_return_value=>'MOROCCO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62789325661442490.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Nouvelle-Z\00E9lande')
,p_lov_return_value=>'NEW ZEALAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62789782549442490.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NICARAGUA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62790133238442490.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E8ge')
,p_lov_return_value=>'NORWAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62790562008442491.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oman'
,p_lov_return_value=>'OMAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62790923765442491.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Panam\00E1')
,p_lov_return_value=>'PANAMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62791326115442491.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E9rou')
,p_lov_return_value=>'PERU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62791722352442491.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Philippines'
,p_lov_return_value=>'PHILIPPINES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62792127389442492.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pologne'
,p_lov_return_value=>'POLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62792532827442492.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PORTUGAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62792943133442492.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Porto Rico'
,p_lov_return_value=>'PUERTO RICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62793345569442492.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Qatar'
,p_lov_return_value=>'QATAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62793726564442493.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Roumanie'
,p_lov_return_value=>'ROMANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62794173620442493.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russie'
,p_lov_return_value=>'RUSSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62794528506442493.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabie saoudite'
,p_lov_return_value=>'SAUDI ARABIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62794957133442493.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Serbie et Mont\00E9n\00E9gro')
,p_lov_return_value=>'SERBIA AND MONTENEGRO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62795307781442494.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Singapour'
,p_lov_return_value=>'SINGAPORE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62795777034442494.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovaquie'
,p_lov_return_value=>'SLOVAKIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62796162893442494.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Slov\00E9nie')
,p_lov_return_value=>'SLOVENIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62796548292442494.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrique du Sud'
,p_lov_return_value=>'SOUTH AFRICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62796908133442495.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagne'
,p_lov_return_value=>'SPAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62797382995442495.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Su\00E8de')
,p_lov_return_value=>'SWEDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62797757964442495.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suisse'
,p_lov_return_value=>'SWITZERLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62798128335442495.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Syrie'
,p_lov_return_value=>'SYRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62798526167442495.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ta\00EFwan')
,p_lov_return_value=>'TAIWAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62798964210442496.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tha\00EFlande')
,p_lov_return_value=>'THAILAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62799338177442496.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pays-Bas'
,p_lov_return_value=>'THE NETHERLANDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62799783102442496.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tunisie'
,p_lov_return_value=>'TUNISIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62800138392442496.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turquie'
,p_lov_return_value=>'TURKEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62800521279442497.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukraine'
,p_lov_return_value=>'UKRAINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62800975328442497.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Emirats arabes unis'
,p_lov_return_value=>'UNITED ARAB EMIRATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62801343830442497.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Royaume-Uni'
,p_lov_return_value=>'UNITED KINGDOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62801707976442497.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ouzb\00E9kistan')
,p_lov_return_value=>'UZBEKISTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62802182931442498.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Venezuela'
,p_lov_return_value=>'VENEZUELA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62802531981442498.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Vi\00EAt Nam')
,p_lov_return_value=>'VIETNAM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62802931670442498.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Y\00E9men')
,p_lov_return_value=>'YEMEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_clear_settings
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184141723318598286.4902)
,p_lov_name=>'IR_CLEAR_SETTINGS'
,p_lov_query=>'.'||wwv_flow_api.id(184141723318598286.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184141903129598286.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Effacer les param\00E8tres d''\00E9tat')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_column_filter_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187536631811296748.4902)
,p_lov_name=>'IR_COLUMN_FILTER_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(187536631811296748.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187536803714296749.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Aucun'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187537027390296749.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Valeur par d\00E9faut bas\00E9e sur le type de colonne')
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187537221036296749.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Utiliser la liste de valeurs (LOV) d\00E9finie pour filtrer sur la correspondance exacte')
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187537420494296749.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Utiliser la liste de valeurs (LOV) d\00E9finie pour filtrer sur le contenu du mot')
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_column_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187521603695108878.4902)
,p_lov_name=>'IR_COLUMN_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(187521603695108878.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261252015294852290.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Masquer'
,p_lov_return_value=>'HIDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187521815724108878.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Trier'
,p_lov_return_value=>'SORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522018417108878.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Filtre'
,p_lov_return_value=>'FILTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522228192108878.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Mise en \00E9vidence')
,p_lov_return_value=>'HIGHLIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522424754108878.4902)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Commande BREAK'
,p_lov_return_value=>'BREAK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522603425108878.4902)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Agr\00E9gat')
,p_lov_return_value=>'AGGREGATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522808972108878.4902)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Calculer'
,p_lov_return_value=>'COMPUTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187523010729108878.4902)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Graphique'
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187523228523108878.4902)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Grouper par'
,p_lov_return_value=>'GROUP_BY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3701401105670.4902)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Pivot'
,p_lov_return_value=>'PIVOT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_detail_page_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184015632435758855.4902)
,p_lov_name=>'IR_DETAIL_PAGE_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(184015632435758855.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184015811357758856.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Autoriser l''exclusion des valeurs NULL'
,p_lov_return_value=>'EXCLUDE_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184016009426758856.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Autoriser les colonnes affich\00E9es')
,p_lov_return_value=>'HIDE_EXTR_COL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_display_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(183810312847513834.4902)
,p_lov_name=>'IR_DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(183810312847513834.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183810509783513835.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Colonne d''\00E9tat standard')
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183810717133513835.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Afficher en tant que texte (\00E9chappement des caract\00E8res sp\00E9ciaux)')
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450527627281054238.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Enlever le texte HTML et les caract\00E8res sp\00E9ciaux d''\00E9chappement')
,p_lov_return_value=>'STRIP_HTML_ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183810915056513835.4902)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Masqu\00E9')
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_link_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184013026632738314.4902)
,p_lov_name=>'IR_LINK_COLUMN'
,p_lov_query=>'.'||wwv_flow_api.id(184013026632738314.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184013223015738314.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lien vers la vue monoligne'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184013402164738315.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Lien vers la cible personnalis\00E9e')
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184013623895738315.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Exclure la colonne de lien'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_link_operator
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184114411019556922.4902)
,p_lov_name=>'IR_LINK_OPERATOR'
,p_lov_query=>'.'||wwv_flow_api.id(184114411019556922.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184114626877556922.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Est \00E9gal \00E0')
,p_lov_return_value=>'EQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184114812403556922.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Est diff\00E9rent de')
,p_lov_return_value=>'NEQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115009808556923.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Est inf\00E9rieur \00E0')
,p_lov_return_value=>'LT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115216118556923.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Est inf\00E9rieur ou \00E9gal \00E0')
,p_lov_return_value=>'LTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115410372556923.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Est sup\00E9rieur \00E0')
,p_lov_return_value=>'GT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115603175556923.4902)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Est sup\00E9rieur ou \00E9gal \00E0')
,p_lov_return_value=>'GTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115811804556923.4902)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Op\00E9rateur SQL LIKE')
,p_lov_return_value=>'LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116014545556923.4902)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'NULL'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116211240556923.4902)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Non NULL'
,p_lov_return_value=>'NN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116429729556923.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Contient'
,p_lov_return_value=>'C '
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116600682556923.4902)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Ne contient pas'
,p_lov_return_value=>'NC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116820056556923.4902)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'La ligne contient'
,p_lov_return_value=>'IR_ROWFILTER '
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(497258407132255912.4902)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_api.id(497258407132255912.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497258621830255914.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Quotidien'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497258807889255918.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Hebdomadaire'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497259008562255918.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Mensuel'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_pagination_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(183988226651539622.4902)
,p_lov_name=>'IR_PAGINATION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(183988226651539622.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183988425548539651.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Plages de lignes X \00E0 Y sur Z')
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183988600836539651.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Plages de lignes X \00E0 Y')
,p_lov_return_value=>'ROWS_X_TO_Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_reports_in_current_app
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184030311010131156.4902)
,p_lov_name=>'IR_REPORTS_IN_CURRENT_APP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_reset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184090310224424164.4902)
,p_lov_name=>'IR_RESET'
,p_lov_query=>'.'||wwv_flow_api.id(184090310224424164.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184090518146424166.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('R\00E9initialiser l''\00E9tat')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_rowid_or_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184017715035772751.4902)
,p_lov_name=>'IR_ROWID_OR_COLS'
,p_lov_query=>'.'||wwv_flow_api.id(184017715035772751.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184017914148772751.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ROWID'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184018110509772751.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Colonne unique'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_same_label_for_detail_view
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187510818230037360.4902)
,p_lov_name=>'IR_SAME_LABEL_FOR_DETAIL_VIEW'
,p_lov_query=>'.'||wwv_flow_api.id(187510818230037360.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187511006081037360.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Utiliser le m\00EAme texte pour la vue monoligne')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/languages_installed
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(631691002719703351.4902)
,p_lov_name=>'LANGUAGES_INSTALLED'
,p_reference_id=>631619712812572565.4902
,p_lov_query=>'.'||wwv_flow_api.id(631691002719703351.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797110708703121637.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand'
,p_lov_return_value=>'de'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''de'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797110905024121637.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais'
,p_lov_return_value=>'en'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''zh-cn'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111115323121638.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol'
,p_lov_return_value=>'es'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''es'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111316804121638.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais')
,p_lov_return_value=>'fr'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''fr'')'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111505126121638.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italien'
,p_lov_return_value=>'it'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''it'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111712120121638.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japonais'
,p_lov_return_value=>'ja'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''ja'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111918483121638.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cor\00E9en')
,p_lov_return_value=>'ko'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''ko'')'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797112116588121638.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Portugais (Br\00E9sil)')
,p_lov_return_value=>'pt-br'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''pt-br'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797112313424121638.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Chine)'
,p_lov_return_value=>'zh-cn'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''zh-cn'')'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797112528313121640.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Chinois (Ta\00EFwan)')
,p_lov_return_value=>'zh-tw'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''zh-tw'')         '))
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_derived_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(502656918406037207.4902)
,p_lov_name=>'LANGUAGE_DERIVED_FROM'
,p_lov_query=>'.'||wwv_flow_api.id(502656918406037207.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(502657718966037208.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Langue principale de l''application'
,p_lov_return_value=>'FLOW_PRIMARY_LANGUAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(502657317052037208.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Navigateur (utiliser la pr\00E9f\00E9rence de langue du navigateur)')
,p_lov_return_value=>'BROWSER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_application_pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461381027000774471.4902)
,p_lov_name=>'LIST APPLICATION PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(name,1,30) name , id',
'from wwv_flow_ws_webpages p',
'where  p.ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id',
'order by name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/logo_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461438607298231622.4902)
,p_lov_name=>'LOGO ATTRIBUTES'
,p_reference_id=>461376702019738964.4902
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88891506202224413.4902)
,p_lov_name=>'LOV_FROM'
,p_lov_query=>'.'||wwv_flow_api.id(88891506202224413.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88892002310224415.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Liste de valeurs (LOV) partag\00E9e')
,p_lov_return_value=>'SHARED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88891803220224415.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Valeurs de colonne distinctes'
,p_lov_return_value=>'DISTINCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88938810600443285.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Cr\00E9er un autre')
,p_lov_return_value=>'CREATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_section_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178562403162170735.4902)
,p_lov_name=>'NAV_SECTION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(178562403162170735.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178562620987170738.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation de page'
,p_lov_return_value=>'NAV_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178562830738170741.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Navigation de section'
,p_lov_return_value=>'NAV_SECTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/order_by_direction
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(606013026952235682.4902)
,p_lov_name=>'ORDER_BY_DIRECTION'
,p_lov_query=>'.'||wwv_flow_api.id(606013026952235682.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(606013300020235684.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Croissant'
,p_lov_return_value=>'ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(606013531554235685.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('D\00E9croissant')
,p_lov_return_value=>'DESC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p740_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(429632313107701908.4902)
,p_lov_name=>'P740_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p742_data_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261395425456539191.4902)
,p_lov_name=>'P742_DATA_GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p742_data_grid_num_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261459220009944453.4902)
,p_lov_name=>'P742_DATA_GRID_NUM_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and c.column_type = ''NUMBER''',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and column_type = ''NUMBER''',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p750_chart_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428899916079615170.4902)
,p_lov_name=>'P750_CHART_SOURCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name||',
'       case when websheet_type=''DATA'' then '' (''||wwv_flow_lang.system_message(''DATA_GRID'')||'')''',
'            when websheet_type=''REPORT'' then '' (''||wwv_flow_lang.system_message(''REPORT'')||'')''',
'       end d,',
'       id r',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_chart_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(444797819996488091.4902)
,p_lov_name=>'P760_CHART_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(444797819996488091.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798026947488095.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'A barres'
,p_lov_return_value=>'bar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798216267488096.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'A courbes avec aires'
,p_lov_return_value=>'lineWithArea'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798632016488096.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'A secteurs'
,p_lov_return_value=>'pie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798420560488096.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'A courbes'
,p_lov_return_value=>'line'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_data_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(293396605682831178.4902)
,p_lov_name=>'P760_DATA_GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_data_grid_num_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(424623105999868608.4902)
,p_lov_name=>'P760_DATA_GRID_NUM_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'and c.column_type = ''NUMBER''',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id',
'and column_type = ''NUMBER'')',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(429677014294033232.4902)
,p_lov_name=>'P760_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_datagrid_show_opt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244084119358061944.4902)
,p_lov_name=>'P922_DATAGRID_SHOW_OPT'
,p_lov_query=>'.'||wwv_flow_api.id(244084119358061944.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244084422806061944.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ajouter une ligne'
,p_lov_return_value=>'ADD_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244084730829061948.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Modifier une ligne'
,p_lov_return_value=>'EDIT_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244085024367061948.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Champ de recherche'
,p_lov_return_value=>'SEARCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_data_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178772114682347881.4902)
,p_lov_name=>'P922_DATA_GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P922_DATA_GRID_ID',
'and d.security_group_id = :flow_security_group_id',
'order by display_order'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_report_show_opt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244090113649098118.4902)
,p_lov_name=>'P922_REPORT_SHOW_OPT'
,p_lov_query=>'.'||wwv_flow_api.id(244090113649098118.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244091002759098119.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Champ de recherche'
,p_lov_return_value=>'SEARCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(430293730079245893.4902)
,p_lov_name=>'P922_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION''',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION'') x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p925_data_section_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244105603016227532.4902)
,p_lov_name=>'P925_DATA_SECTION_STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(244105603016227532.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244105926056227533.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Style 1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244106215253227534.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Style 2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244106500467227534.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Style 3'
,p_lov_return_value=>'3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p934_data_section_show_opt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(239269013341119720.4902)
,p_lov_name=>'P934_DATA_SECTION_SHOW_OPT'
,p_lov_query=>'.'||wwv_flow_api.id(239269013341119720.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239269323845119720.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ajouter une ligne'
,p_lov_return_value=>'ADD_ROW'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P934_WEBSHEET_TYPE'
,p_lov_disp_cond2=>'DATA_GRID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239269606033119720.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Modifier une ligne'
,p_lov_return_value=>'EDIT_ROW'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P934_WEBSHEET_TYPE'
,p_lov_disp_cond2=>'DATA_GRID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239269902232119720.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Champ de recherche'
,p_lov_return_value=>'SEARCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p934_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(431037130827466603.4902)
,p_lov_name=>'P934_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_email_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(473383419441178851.4902)
,p_lov_name=>'PAGE EMAIL OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(473383419441178851.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(473383631984178859.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Envoyer le lien vers cette page par courriel'
,p_lov_return_value=>'LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(473383814758178865.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Envoyer le contenu de cette page par courriel'
,p_lov_return_value=>'PAGE'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_navigation_order
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(381950720171699749.4902)
,p_lov_name=>'PAGE NAVIGATION ORDER'
,p_lov_query=>'.'||wwv_flow_api.id(381950720171699749.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(381951031098699751.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nom de page'
,p_lov_return_value=>'PAGE_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(381951211109699752.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Date de cr\00E9ation')
,p_lov_return_value=>'CREATED_ON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(381951400366699752.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Date de mise \00E0 jour')
,p_lov_return_value=>'UPDATED_ON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_position
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174603521097074779.4902)
,p_lov_name=>'PAGE POSITION'
,p_lov_query=>'.'||wwv_flow_api.id(174603521097074779.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174603926494074780.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'A gauche'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174604103608074780.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Au centre'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174604316948074780.4902)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'A droite'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(454994331134405615.4902)
,p_lov_name=>'PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_parent_page_for_page_53
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177413911605744887.4902)
,p_lov_name=>'PICK PARENT PAGE (FOR PAGE 53)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID',
'minus',
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id ',
'   and ws_app_id = :WS_APP_ID ',
'connect by prior id = parent_page_id',
'start with id = :P53_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/popup_data_grid_view_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6245305086538240.4902)
,p_lov_name=>'POPUP_DATA_GRID_VIEW_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(6245305086538240.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6245604034538241.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Grilles de donn\00E9es')
,p_lov_return_value=>'DATA_GRIDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6245803688538242.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Colonnes de grille de donn\00E9es s\00E9lectionn\00E9e')
,p_lov_return_value=>'COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6246002516538242.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Requ\00EAte sur la grille de donn\00E9es s\00E9lectionn\00E9e')
,p_lov_return_value=>'QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remember_username
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(263997216503587205.4902)
,p_lov_name=>'REMEMBER_USERNAME'
,p_lov_query=>'.'||wwv_flow_api.id(263997216503587205.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(263997505048587206.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('M\00E9moriser le nom utilisateur')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428697210472793191.4902)
,p_lov_name=>'REPORT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_label_returning_column_alias
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157608702042123701.4902)
,p_lov_name=>'REPORT LABEL RETURNING COLUMN ALIAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_label, db_column_name',
'from wwv_flow_worksheet_columns',
'where worksheet_id = :P2_ID',
'and security_group_id = :WORKSPACE_ID',
'order by display_order'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(181139517862367299.4902)
,p_lov_name=>'REPORT_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(181139517862367299.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(181139731760367303.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tableau'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(181139914754367305.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Requ\00EAte SQL')
,p_lov_return_value=>'QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_security_restrict_by
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4200913969354730.4902)
,p_lov_name=>'ROW_SECURITY_RESTRICT_BY'
,p_lov_query=>'.'||wwv_flow_api.id(4200913969354730.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4201216137354731.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Expression de colonne'
,p_lov_return_value=>'COLUMN_EXPR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4201401816354731.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nom utilisateur dans les colonnes'
,p_lov_return_value=>'USERNAME_IN_COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4201616338354731.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Nom utilisateur dans la hi\00E9rarchie')
,p_lov_return_value=>'USERNAME_IN_HIERARCHY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/searchable_components
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(468375932547106712.4902)
,p_lov_name=>'SEARCHABLE COMPONENTS'
,p_lov_query=>'.'||wwv_flow_api.id(468375932547106712.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468388406715184404.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nom de page'
,p_lov_return_value=>'Page name'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471083025269088996.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Alias de page'
,p_lov_return_value=>'Page alias'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471083730810090673.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Description de page'
,p_lov_return_value=>'Page description'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376931120106721.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Titre de section'
,p_lov_return_value=>'Section title'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376724828106721.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Contenu de section'
,p_lov_return_value=>'Section content'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376107670106719.4902)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Nom, alias et description du fichier'
,p_lov_return_value=>'File'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468377117690106722.4902)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Balises'
,p_lov_return_value=>'Tags'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376332154106721.4902)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Remarques'
,p_lov_return_value=>'Notes'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468763112243277596.4902)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('Donn\00E9es de grille de donn\00E9es')
,p_lov_return_value=>'Data grid'
);
end;
/
prompt --application/shared_components/user_interface/lovs/section_type_selector
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174363201295924966.4902)
,p_lov_name=>'SECTION TYPE SELECTOR'
,p_lov_query=>'.'||wwv_flow_api.id(174363201295924966.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174363729720924971.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Texte'
,p_lov_return_value=>'TEXT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:910:&SESSION.:::910,P910_CONTENT,P910_SPREADSHEET:P920_SECTION_TYPE:TEXT"><img src="#IMAGE_PREFIX#ws/ws-text.png" height="128"'
||' width="128" alt="#DISPLAY_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174366523901938416.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Navigation'
,p_lov_return_value=>'NAV'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:926:&SESSION.:::926:P920_SECTION_TYPE:NAV"><img src="#IMAGE_PREFIX#ws/ws-navigation.png" height="128" width="128" alt="#DISPLA'
||'Y_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174363503996924969.4902)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Donn\00E9es')
,p_lov_return_value=>'DATA'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:922:&SESSION.:::922,925:P920_SECTION_TYPE:DATA"><img src="#IMAGE_PREFIX#ws/ws-from-scratch.png" height="128" width="128" alt="'
||'#DISPLAY_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(257305806305291010.4902)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Graphique'
,p_lov_return_value=>'CHART'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:710:&SESSION.:::710,740,742,750:P920_SECTION_TYPE:CHART"><img src="#IMAGE_PREFIX#ws/ws-chart.png" height="128" width="128" alt'
||'="#DISPLAY_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/section_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(492203630195322675.4902)
,p_lov_name=>'SECTION TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(492203630195322675.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492203816689322675.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Texte'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204004458322675.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Graphique'
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204222124322676.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Navigation de section'
,p_lov_return_value=>'NAV_SECTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204407452322676.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Navigation de page'
,p_lov_return_value=>'NAV_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204623758322676.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Donn\00E9es')
,p_lov_return_value=>'DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15734501398512875.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PL/SQL'
,p_lov_return_value=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/section_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428681322228645128.4902)
,p_lov_name=>'SECTION_SOURCE'
,p_lov_query=>'.'||wwv_flow_api.id(428681322228645128.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(428681516422645131.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Grille de donn\00E9es')
,p_lov_return_value=>'DATA_GRID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(428681722703645131.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Etat '
,p_lov_return_value=>'REPORT'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>'return wwv_flow_ws_security.current_user_is_not_reader and wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and wwv_flow_ws_security.sql_enabled_inst;'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sharing_standard_codes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161342315175360665.4902)
,p_lov_name=>'SHARING - STANDARD CODES'
,p_lov_query=>'.'||wwv_flow_api.id(161342315175360665.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161342511198360666.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Partag\00E9 avec tous les utilisateurs')
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22963820418845971.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Partag\00E9 avec la liste de contr\00F4le d''acc\00E8s (ACL)')
,p_lov_return_value=>'ACL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161342929843360666.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Priv\00E9')
,p_lov_return_value=>'AVAILABLE_FOR_OWNER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_websheets_or_my_websheets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(83901725439965785.4902)
,p_lov_name=>'SHOW ALL WEBSHEETS OR MY WEBSHEETS'
,p_lov_query=>'.'||wwv_flow_api.id(83901725439965785.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83901929137965786.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Toutes les feuilles Web'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83902128718965786.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Mes feuilles Web'
,p_lov_return_value=>'MINE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/suggested_sql_table_type_p90
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17231024016826986.4902)
,p_lov_name=>'SUGGESTED SQL TABLE TYPE (P90)'
,p_lov_query=>'.'||wwv_flow_api.id(17231024016826986.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17231212381826990.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Objets sugg\00E9r\00E9s')
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17231413694826994.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tous les objets accessibles'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/text_websheets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174421329189713558.4902)
,p_lov_name=>'TEXT WEBSHEETS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/timeframe
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(185584826211920495.4902)
,p_lov_name=>'TIMEFRAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/url_or_report
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184024419940878266.4902)
,p_lov_name=>'URL_OR_REPORT'
,p_lov_query=>'.'||wwv_flow_api.id(184024419940878266.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184024616003878266.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Etat dans cette application'
,p_lov_return_value=>'REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184024823203878266.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/use_primary_default
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428734704772905075.4902)
,p_lov_name=>'USE_PRIMARY_DEFAULT'
,p_lov_query=>'.'||wwv_flow_api.id(428734704772905075.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(428734912977905076.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Utiliser les param\00E8tres d''\00E9tat par d\00E9faut du principal')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/validate_plsql
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12497031296679964.4902)
,p_lov_name=>'VALIDATE_PLSQL'
,p_lov_query=>'.'||wwv_flow_api.id(12497031296679964.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12497306721679972.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ne pas valider le code PL/SQL (analyser le code PL/SQL \00E0 l''ex\00E9cution uniquement).')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_icons_or_details
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(83845910791829052.4902)
,p_lov_name=>'VIEW AS ICONS OR DETAILS'
,p_lov_query=>'.'||wwv_flow_api.id(83845910791829052.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83846129033829055.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ic\00F4nes')
,p_lov_return_value=>'ICONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83846305343829058.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('D\00E9tails')
,p_lov_return_value=>'DETAILS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_application_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(471867429070174759.4902)
,p_lov_name=>'WEBSHEET APPLICATION STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(471867429070174759.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471867623399174772.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471868003921176945.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Non disponible'
,p_lov_return_value=>'UNAVAILABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_authentication
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(444727703759035884.4902)
,p_lov_name=>'WEBSHEET AUTHENTICATION'
,p_lov_query=>'.'||wwv_flow_api.id(444727703759035884.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728117740035894.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Compte Application Express'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728300760035894.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Acc\00E8s avec connexion unique SSO')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728526805035894.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'LDAP'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1959643209188118620.4902)
,p_lov_disp_sequence=>4.5
,p_lov_disp_value=>'Oracle Cloud Identity Management'
,p_lov_return_value=>'5'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728724858035894.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Personnalis\00E9')
,p_lov_return_value=>'4'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_home_page_selector_p_1250
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177463924416148776.4902)
,p_lov_name=>'WEBSHEET HOME PAGE SELECTOR (P 1250)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :P1250_ID and',
'      security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_page_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(478186020350840371.4902)
,p_lov_name=>'WEBSHEET PAGE STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(478186020350840371.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(478186224261840375.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Style par d\00E9faut')
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(478186402878840381.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Autre style 1'
,p_lov_return_value=>'1'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(478187212720840384.4902)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Style personnalis\00E9')
,p_lov_return_value=>'99'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177459420645100351.4902)
,p_lov_name=>'WEBSHEET PAGE TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(177459420645100351.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177459613519100354.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177459807231100356.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Grille de donn\00E9es')
,p_lov_return_value=>'DATA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheets_pick_parent_show_all_pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(477788102822094591.4902)
,p_lov_name=>'WEBSHEETS - PICK PARENT -- SHOW ALL PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID ',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_priv
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4272307523349785.4902)
,p_lov_name=>'WEBSHEET_PRIV'
,p_lov_query=>'.'||wwv_flow_api.id(4272307523349785.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4272616503349799.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Visualiser et modifier'
,p_lov_return_value=>'EDIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4272800274349801.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Visualiser seulement'
,p_lov_return_value=>'VIEW_ONLY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_share_with
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4270305567216064.4902)
,p_lov_name=>'WEBSHEET_SHARE_WITH'
,p_lov_query=>'.'||wwv_flow_api.id(4270305567216064.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4271211380216070.4902)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Priv\00E9, non partag\00E9')
,p_lov_return_value=>'PRIVATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_column_lov_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7088909602608513.4902)
,p_lov_name=>'WORKSHEET COLUMN LOV FROM'
,p_lov_query=>'.'||wwv_flow_api.id(7088909602608513.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7089115009608515.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Valeurs de colonne distinctes'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7089311442608516.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Domaine de valeurs statique'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_lovs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(20284128708076403.4902)
,p_lov_name=>'WORKSHEET LOVS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME display_value, ID return_value ',
'from WWV_FLOW_WORKSHEET_LOVS',
'where worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID',
'order by upper(name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_reports_with_worksheet
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1097408377479572.4902)
,p_lov_name=>'WORKSHEET REPORTS WITH WORKSHEET'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(name, ''- Worksheet -'') name, id ',
'  from wwv_flow_worksheet_rpts',
' where worksheet_id = :P2_ID',
'   and application_user = :APP_USER',
'   and name is not null',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4196722056290886.4902)
,p_lov_name=>'WORKSHEET_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_label, db_column_name',
'from wwv_flow_worksheet_columns',
'where worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID',
'order by display_order'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_column_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159512305334979648.4902)
,p_lov_name=>'WORKSHEET_COLUMN_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(159512305334979648.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159512611310979649.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cha\00EEne')
,p_lov_return_value=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159512810815979649.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nombre'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159513008482979649.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Date'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159513210897979649.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Document'
,p_lov_return_value=>'DOCUMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11517807514880595.4902)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Calcul\00E9')
,p_lov_return_value=>'COMPUTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_column_types2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(38353412581019585.4902)
,p_lov_name=>'WORKSHEET_COLUMN_TYPES2'
,p_lov_query=>'.'||wwv_flow_api.id(38353412581019585.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38353715513019587.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cha\00EEne')
,p_lov_return_value=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38353907530019587.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nombre'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38354113803019587.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Date'
,p_lov_return_value=>'DATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_acl_privs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(451333930142995878.4902)
,p_lov_name=>'WS_ACL_PRIVS'
,p_lov_query=>'.'||wwv_flow_api.id(451333930142995878.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(451334128711995879.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lecteur'
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(451334314312995960.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Contributeur'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(451334509043995960.4902)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Administrateur'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_acl_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(450940100671567605.4902)
,p_lov_name=>'WS_APP_ACL_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(450940100671567605.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450940311282567606.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Valeur par d\00E9faut')
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450940510709567608.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Personnalis\00E9')
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_logo_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461278502171499627.4902)
,p_lov_name=>'WS_LOGO_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(461278502171499627.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461278702764499627.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Aucun'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461278910485499644.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Texte'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461279109274499644.4902)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Image t\00E9l\00E9charg\00E9e')
,p_lov_return_value=>'IMAGE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461279326169499644.4902)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Chemin du fichier'
,p_lov_return_value=>'FILEPATH'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174627223457398766.4902)
,p_lov_name=>'WS_PAGE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(174627223457398766.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174627515804398767.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Grille de donn\00E9es')
,p_lov_return_value=>'DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174627719694398770.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Texte'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returning_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159003224636178271.4902)
,p_lov_name=>'YES NO RETURNING Y N'
,p_lov_query=>'.'||wwv_flow_api.id(159003224636178271.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159003530237178272.4902)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oui'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159003719271178272.4902)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Non'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4091010662546975.4902)
,p_lov_name=>'YES NO RETURNS Y N'
,p_lov_query=>'.'||wwv_flow_api.id(4091010662546975.4902)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4091213313546978.4902)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oui'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4091420742546980.4902)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Non'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/worksheet_standard
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(78897017520604216.4902)
,p_name=>'worksheet standard'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2670021526029217.4902)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4902)
,p_short_name=>'Visualiser l''historique des modifications'
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4230728579343205.4902)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4902)
,p_short_name=>'Modifier le type de colonne'
,p_link=>'f?p=&FLOW_ID.:89:&SESSION.'
,p_page_id=>89
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4233729491405795.4902)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4902)
,p_short_name=>'Modifier le type de colonne'
,p_link=>'f?p=&FLOW_ID.:91:&SESSION.'
,p_page_id=>91
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(5510514461754522.4902)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4902)
,p_short_name=>'Tableau de bord'
,p_link=>'f?p=&FLOW_ID.:400:&SESSION.'
,p_page_id=>400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(78897520983605269.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('R\00E9pertoire de pages')
,p_link=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_page_id=>1000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(78901107456613285.4902)
,p_parent_id=>wwv_flow_api.id(78897520983605269.4902)
,p_short_name=>unistr('Cr\00E9er une page')
,p_link=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:::'
,p_page_id=>200
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(78917815626639965.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>'&WORKSHEET_NAME.'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::P2_ID:&P2_ID.'
,p_page_id=>2
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(81681714437489706.4902)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4902)
,p_short_name=>'Ajouter/Modifier une ligne'
,p_link=>'f?p=&FLOW_ID.:20:&SESSION.'
,p_page_id=>20
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(81687303832540185.4902)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4902)
,p_short_name=>unistr('Ajouter une pi\00E8ce jointe')
,p_link=>'f?p=&FLOW_ID.:50:&SESSION.'
,p_page_id=>50
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(85198520867592463.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_link=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:::'
,p_page_id=>205
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(85200708143598339.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_link=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:::'
,p_page_id=>201
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(87067930193889011.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_link=>'f?p=&APP_ID.:206:&SESSION.::&DEBUG.:::'
,p_page_id=>206
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171300231813414293.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>'&P3000_REPORT_NAME!RAW.'
,p_link=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
,p_page_id=>3000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171582602179856081.4902)
,p_parent_id=>wwv_flow_api.id(171300231813414293.4902)
,p_short_name=>unistr('Modifier un \00E9tat')
,p_link=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::'
,p_page_id=>3010
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(172959905219473555.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Rechercher'
,p_link=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:::'
,p_page_id=>8000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(173221216721622592.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>unistr('Cr\00E9er')
,p_link=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_page_id=>131
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174460015452180827.4902)
,p_parent_id=>wwv_flow_api.id(.4902)
,p_short_name=>'Page d''accueil'
,p_link=>'ws?p=&WS_APP_ID.:home:&SESSION.'
,p_page_id=>900
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174536419956209170.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Nouvelle section'
,p_link=>'f?p=&APP_ID.:910:&SESSION.::&DEBUG.:::'
,p_page_id=>910
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174537325551221738.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Nouvelle section'
,p_link=>'f?p=&FLOW_ID.:920:&SESSION.'
,p_page_id=>920
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174562103281566299.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Modifier une section'
,p_link=>'f?p=&FLOW_ID.:930:&SESSION.'
,p_page_id=>930
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174587421741748355.4902)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4902)
,p_short_name=>'Tableau de bord'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(176493330002233411.4902)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4902)
,p_short_name=>unistr('Propri\00E9t\00E9s de feuille Web')
,p_link=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:::'
,p_page_id=>1250
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177132319189562341.4902)
,p_parent_id=>wwv_flow_api.id(174587421741748355.4902)
,p_short_name=>unistr('G\00E9rer les mod\00E8les d''authentification')
,p_link=>'f?p=&FLOW_ID.:51:&SESSION.'
,p_page_id=>51
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177425500872951637.4902)
,p_parent_id=>wwv_flow_api.id(.4902)
,p_short_name=>'Modifier une page'
,p_link=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:::'
,p_page_id=>53
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177505624887294566.4902)
,p_parent_id=>wwv_flow_api.id(174587421741748355.4902)
,p_short_name=>unistr('Cr\00E9er une section')
,p_link=>'f?p=&FLOW_ID.:921:&SESSION.'
,p_page_id=>921
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177969610547759155.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Supprimer une page'
,p_link=>'f?p=&FLOW_ID.:960:&SESSION.'
,p_page_id=>960
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178435411977260701.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Modifier une section'
,p_link=>'f?p=&FLOW_ID.:931:&SESSION.'
,p_page_id=>931
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178515920668406977.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('Cr\00E9er une section de donn\00E9es')
,p_link=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:::'
,p_page_id=>922
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178567213402219839.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('Cr\00E9er une section')
,p_link=>'f?p=&FLOW_ID.:926:&SESSION.'
,p_page_id=>926
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178572623297245626.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('Cr\00E9er une section')
,p_link=>'f?p=&FLOW_ID.:927:&SESSION.'
,p_page_id=>927
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178735000980446641.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Modifier une section'
,p_link=>'f?p=&FLOW_ID.:932:&SESSION.'
,p_page_id=>932
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178832411836267350.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('Donn\00E9es')
,p_link=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:::'
,p_page_id=>902
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178833326920275511.4902)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4902)
,p_short_name=>'Fichiers'
,p_link=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:::'
,p_page_id=>903
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178833723901276942.4902)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4902)
,p_short_name=>'Balises'
,p_link=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.:::'
,p_page_id=>904
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178834117647279840.4902)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4902)
,p_short_name=>'Remarques'
,p_link=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:::'
,p_page_id=>905
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178856318730488076.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Copier une page'
,p_link=>'f?p=&FLOW_ID.:908:&SESSION.'
,p_page_id=>908
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(179692514107778690.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('Cr\00E9er une section de donn\00E9es')
,p_link=>'f?p=&APP_ID.:925:&SESSION.::&DEBUG.:::'
,p_page_id=>925
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(180470222886094847.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Modifier une section'
,p_link=>'f?p=&FLOW_ID.:934:&SESSION.'
,p_page_id=>934
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(181263431536172556.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>unistr('Cr\00E9er un \00E9tat')
,p_link=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:::'
,p_page_id=>1310
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(181299229440629329.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>unistr('Cr\00E9er un \00E9tat')
,p_link=>'f?p=&APP_ID.:1320:&SESSION.::&DEBUG.:::'
,p_page_id=>1320
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(184267525052006599.4902)
,p_parent_id=>wwv_flow_api.id(171582602179856081.4902)
,p_short_name=>unistr('Modifier une colonne d''\00E9tat')
,p_link=>'f?p=&APP_ID.:3020:&SESSION.::&DEBUG.:::'
,p_page_id=>3020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(185430107950682414.4902)
,p_parent_id=>wwv_flow_api.id(171300231813414293.4902)
,p_short_name=>unistr('Modifier un \00E9tat')
,p_link=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::'
,p_page_id=>3030
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(187171813556872743.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Annotations'
,p_link=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:::'
,p_page_id=>906
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(187174620703946459.4902)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4902)
,p_short_name=>unistr('Surveiller l''activit\00E9')
,p_link=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:::'
,p_page_id=>140
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(188056521384504797.4902)
,p_parent_id=>wwv_flow_api.id(171300231813414293.4902)
,p_short_name=>unistr('Modifier un \00E9tat')
,p_link=>'f?p=&APP_ID.:3060:&SESSION.::&DEBUG.:::'
,p_page_id=>3060
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(301532509548629032.4902)
,p_parent_id=>wwv_flow_api.id(176493330002233411.4902)
,p_short_name=>'Supprimer une application'
,p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::'
,p_page_id=>4
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(431020021350285368.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('Cr\00E9er une section de graphique')
,p_link=>'f?p=&FLOW_ID.:710:&SESSION.'
,p_page_id=>710
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(451312903217376859.4902)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4902)
,p_short_name=>unistr('Contr\00F4le d''acc\00E8s')
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(451316327052485988.4902)
,p_parent_id=>wwv_flow_api.id(451312903217376859.4902)
,p_short_name=>unistr('D\00E9tails de l''entr\00E9e')
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(454926007401991139.4902)
,p_parent_id=>wwv_flow_api.id(178833326920275511.4902)
,p_short_name=>unistr('D\00E9tails')
,p_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
,p_page_id=>912
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(455078007098014547.4902)
,p_parent_id=>wwv_flow_api.id(178833723901276942.4902)
,p_short_name=>unistr('D\00E9tails')
,p_link=>'f?p=&APP_ID.:913:&SESSION.::&DEBUG.:::'
,p_page_id=>913
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(455084307504044741.4902)
,p_parent_id=>wwv_flow_api.id(178834117647279840.4902)
,p_short_name=>unistr('D\00E9tails')
,p_link=>'f?p=&APP_ID.:914:&SESSION.::&DEBUG.:::'
,p_page_id=>914
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(455867027556226619.4902)
,p_parent_id=>wwv_flow_api.id(456715709817052851.4902)
,p_short_name=>unistr('Aper\00E7u des feuilles Web')
,p_link=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:::'
,p_page_id=>15
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(456716629226062947.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Administration'
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(456723414173263488.4902)
,p_parent_id=>wwv_flow_api.id(456715709817052851.4902)
,p_short_name=>'Syntaxe de balisage'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457141423716390388.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Ajouter un fichier'
,p_link=>'f?p=&APP_ID.:4020:&SESSION.::&DEBUG.:::'
,p_page_id=>4020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457151729837534039.4902)
,p_parent_id=>wwv_flow_api.id(.4902)
,p_short_name=>'Ajouter une remarque'
,p_link=>'f?p=&APP_ID.:4030:&SESSION.::&DEBUG.:::'
,p_page_id=>4030
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457152105511545952.4902)
,p_parent_id=>wwv_flow_api.id(.4902)
,p_short_name=>'Ajouter une balise'
,p_link=>'f?p=&APP_ID.:4040:&SESSION.::&DEBUG.:::'
,p_page_id=>4040
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457468026650230855.4902)
,p_parent_id=>wwv_flow_api.id(.4902)
,p_short_name=>'Historique de section de page'
,p_link=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.:::'
,p_page_id=>950
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459182006892056281.4902)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4902)
,p_short_name=>unistr('Nuage de mots-cl\00E9s')
,p_link=>'f?p=&FLOW_ID.:928:&SESSION.'
,p_page_id=>928
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459633626075416367.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>'Vues de page'
,p_link=>'f?p=&FLOW_ID.:18:&SESSION.'
,p_page_id=>18
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459662412537763358.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>'Pages principales'
,p_link=>'f?p=&FLOW_ID.:24:&SESSION.'
,p_page_id=>24
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(461238603047810834.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>unistr('Principales grilles de donn\00E9es')
,p_link=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:::'
,p_page_id=>141
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(461331422787325871.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>unistr('Principaux \00E9tats')
,p_link=>'f?p=&FLOW_ID.:142:&SESSION.'
,p_page_id=>142
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(461348622392450101.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('R\00E9pertoire de feuilles Web')
,p_link=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.:::'
,p_page_id=>1001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471882914071890170.4902)
,p_parent_id=>wwv_flow_api.id(.4902)
,p_short_name=>unistr('Calendrier de cr\00E9ation de page')
,p_link=>'f?p=&FLOW_ID.:951:&SESSION.'
,p_page_id=>951
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471901627876065162.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>'Principaux fichiers'
,p_link=>'f?p=&FLOW_ID.:143:&SESSION.'
,p_page_id=>143
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471903119311084491.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>'Principales remarques'
,p_link=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.:::'
,p_page_id=>144
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471904206990093888.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>'Principales balises'
,p_link=>'f?p=&FLOW_ID.:145:&SESSION.'
,p_page_id=>145
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471917025140272524.4902)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4902)
,p_short_name=>'Principaux utilisateurs'
,p_link=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.:::'
,p_page_id=>146
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472197018359897527.4902)
,p_parent_id=>wwv_flow_api.id(174562103281566299.4902)
,p_short_name=>unistr('D\00E9placer la section vers une page existante')
,p_link=>'f?p=&APP_ID.:990:&SESSION.::&DEBUG.:::'
,p_page_id=>990
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472200003119943726.4902)
,p_parent_id=>wwv_flow_api.id(174562103281566299.4902)
,p_short_name=>unistr('D\00E9placer la section vers une nouvelle page')
,p_link=>'f?p=&FLOW_ID.:991:&SESSION.'
,p_page_id=>991
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472804624985588482.4902)
,p_parent_id=>wwv_flow_api.id(456715709817052851.4902)
,p_short_name=>'A propos de cette application'
,p_link=>'f?p=&FLOW_ID.:16:&SESSION.'
,p_page_id=>16
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(473082318328043502.4902)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4902)
,p_short_name=>'Liens'
,p_link=>'f?p=&FLOW_ID.:915:&SESSION.'
,p_page_id=>915
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(497240808682988557.4902)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4902)
,p_short_name=>unistr('Mes \00E9tats enregistr\00E9s')
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(619997132010437333.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>unistr('S\00E9lectionner une langue')
,p_link=>'f?p=&FLOW_ID.:37:&SESSION.'
,p_page_id=>37
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(626920713710448375.4902)
,p_parent_id=>wwv_flow_api.id(473082318328043502.4902)
,p_short_name=>unistr('D\00E9tails de lien')
,p_link=>'f?p=&FLOW_ID.:916:&SESSION.'
,p_page_id=>916
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(733378208922655612.4902)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4902)
,p_short_name=>'Modifier le mot de passe'
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>5
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_three_columns
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3700422714748.4902)
,p_theme_id=>3
,p_name=>'[EBA] WS Three Columns.fr'
,p_internal_name=>'[EBA]_WS_THREE_COLUMNS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'		',
'	<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'			<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="ebaMainCol">',
'#BODY#',
'		</div>',
'		<div class="ebaSideCol">',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097489730349429.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097527296349429.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097600963349429.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097722755349429.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097810938349428.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097924373349428.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140098011356349428.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140098179919349428.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140098224504349428.4902)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/iframe_load_required_for_data_grid_file_upload
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3152608674388513.4902)
,p_theme_id=>3
,p_name=>'iframe load - Required for Data Grid File Upload.fr'
,p_internal_name=>'IFRAME_LOAD_REQUIRED_FOR_DATA_GRID_FILE_UPLOAD'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com" xmlns:apex="http://apex.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# style="margin:5px;"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#BODY#',
'</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbSuccessMessage">#SUCCESS_MESSAGE#</div>',
''))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbNotification">#MESSAGE#</div>',
''))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058492776349479.4902)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058518143349479.4902)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058684597349479.4902)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058776517349479.4902)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058837902349479.4902)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058938460349478.4902)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_two_columns
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(9297021464956579.4902)
,p_theme_id=>3
,p_name=>'[EBA] WS Two Columns.fr'
,p_internal_name=>'[EBA]_WS_TWO_COLUMNS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="ebaMainCol">',
'#BODY#',
'		</div>',
'		<div class="ebaSideCol">',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061732411349475.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061811144349475.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061965981349475.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062088282349475.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062175058349475.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062264599349475.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062395038349475.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062491818349474.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062514072349474.4902)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_one_column
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(10606007362285088.4902)
,p_theme_id=>3
,p_name=>'[EBA] WS One Column.fr'
,p_internal_name=>'[EBA]_WS_ONE_COLUMN'
,p_is_popup=>false
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/widget.stickyWidget.js',
'#IMAGE_PREFIX#libraries/apex/widget.stickyTableHeader.js'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// $(''.a-IRR-reportView'').setTableHeadersAsFixed();',
'//$(".js-stickyTableHeader").stickyWidget({',
'//   toggleWidth: true',
'//});'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="wsPaddedContentContainer">',
'#BODY#',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067387257349464.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067421727349464.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067591886349464.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067696428349464.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067759500349464.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067810848349463.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067963315349463.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140068013224349463.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140068132565349463.4902)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_help_pop_up
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(11249921373943607.4902)
,p_theme_id=>3
,p_name=>'[EBA] Help Pop Up.fr'
,p_internal_name=>'[EBA]_HELP_POP_UP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="wsPopup ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE." class="wsPopup"> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body #ONLOAD# class="wsPopup">',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="wsPopUpHeader">',
'#REGION_POSITION_02#',
'</div>',
'<div class="wsPopUpContent">',
'  <div class="wsSideCol">',
'#REGION_POSITION_03#',
'  </div>',
'  <div class="wsMainCol">',
'#BODY#',
'  </div>',
'<div class="clear"></div>',
'</div>',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069408377349461.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069537000349461.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069623747349461.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069739050349461.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069814885349461.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069965422349461.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140070082284349460.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140070101506349460.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140070203419349460.4902)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_two_panel_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15627530893704526.4902)
,p_theme_id=>3
,p_name=>'[EBA] WS Two Panel Page.fr'
,p_internal_name=>'[EBA]_WS_TWO_PANEL_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_03#',
'	<div class="ebaTwoColPane">',
'		<div class="ebaSideCol contentSection" id="wsSideCol">',
'					<h2 class="leftButtons">',
'			#REGION_POSITION_05#',
'					</h2>',
'			#REGION_POSITION_06#',
'		</div>',
'		<div class="ebaMainCol contentSection">',
'			#REGION_POSITION_04#',
'			<div class="ebaMainColContentContainer">',
'				<div class="ebaContent ebaOneCol">',
'					#BODY#',
'				</div> <!-- End .ebaContent .ebaOneCol -->',
'			</div> <!-- End .wsMainColContentContainer -->',
'		</div> <!-- End .ebaMainCol contentSection -->',
'	</div> <!-- End .ebaTwoColPane -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072642082349458.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072720824349458.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072848929349457.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072973381349457.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073054438349457.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073197487349457.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073250010349457.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073374370349457.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073485997349457.4902)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_login_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(53193408981633671.4902)
,p_theme_id=>3
,p_name=>'[EBA] Login Page.fr'
,p_internal_name=>'[EBA]_LOGIN_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame ebaWizardFrame ebaLoginWizard">',
'<div class="ebaFrameHeader">',
'		<h1 class="oracleLogo">',
'			#LOGO#',
'		</h1>',
'		<div class="ebaProgressBar">',
'#REGION_POSITION_02#',
'		</div>',
'</div> <!-- End .ebaFrameHeader -->',
'<div class="ebaContentContainer">',
'	<div class="ebaContent">',
'<div class="websheetsIcon">',
'#REGION_POSITION_03#',
'</div>',
'<div class="loginFormFields">',
'#BODY#',
'</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'	<div class="ebaFrameFooter">',
'#REGION_POSITION_04#',
'<span>',
'#REGION_POSITION_05#',
'</span>',
'	</div>',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>6
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075690213349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075738281349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075886172349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075921828349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076012829349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076100068349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076221955349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076340391349454.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076408102349453.4902)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_presentation_view
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(75962824844186301.4902)
,p_theme_id=>3
,p_name=>'[EBA] Presentation View.fr'
,p_internal_name=>'[EBA]_PRESENTATION_VIEW'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_presentation.css" type="text/css" />',
'	<script src="#IMAGE_PREFIX#ws/js/ws_presentation.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div id="wspToolbar">',
'	#REGION_POSITION_01#',
'</div>',
'<div class="wspSectionContainer" aria-live="polite">',
'#BODY#',
'</div>',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077826786349452.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077944690349452.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078059697349452.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078199669349452.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078280955349451.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078344799349451.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078411771349451.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078570489349451.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078698538349451.4902)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_pop_up
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(134255203486851095.4902)
,p_theme_id=>3
,p_name=>'[EBA] Pop Up.fr'
,p_internal_name=>'[EBA]_POP_UP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="wsPopup ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE." class="wsPopup"> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body #ONLOAD# class="wsPopup">',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="wsPopUpHeader">',
'#REGION_POSITION_02#',
'</div>',
'<div class="wsPopUpContent simplePopUp paddedPopUp">',
'  <div class="wsMainCol">',
'#BODY#',
'  </div>',
'<div class="clear"></div>',
'</div>',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079702460349450.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079819848349450.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079971938349450.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080026400349450.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080183799349449.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080201984349449.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080389350349449.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080442532349449.4902)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_0_websheets_printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(636311004626147097.4902)
,p_theme_id=>3
,p_name=>'APEX 4.0 - WEBSHEETS (printer friendly).fr'
,p_internal_name=>'APEX_4.0_WEBSHEETS_PRINTER_FRIENDLY'
,p_is_popup=>false
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div.wsSection h2 span,',
'div.wsFooter ul.wsViewModes,',
'span.wsBreadcrumbBarLinks,',
'div.wsSection h2 a.wsSectionControl,',
'.ebaHeader ul,',
'.ebaFrameHeader,',
'.wsSideSection {',
'    display: none !important;',
'}',
'body .ebaHeader h1 a {',
'    color: #000;',
'    text-shadow: none;',
'}',
'body .ebaHeader {',
'    background: none #F8FBFF;',
'}',
'body div.wsBreadcrumb>ul>li>a {',
'    border: none;',
'}'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="wsPaddedContentContainer">',
'#BODY#',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="htmldbSuccessMessage" id="MESSAGE"><img src="#IMAGE_PREFIX#delete.gif" onclick="$x_Remove(''MESSAGE'')"  style="float:right;" class="pb" alt="" />#SUCCESS_MESSAGE#</div>'
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbNotification" id="MESSAGE"><img src="#IMAGE_PREFIX#delete.gif" onclick="$x_Remove(''MESSAGE'')"  style="float:right;" class="pb" alt="" />#MESSAGE#</div>',
''))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083405483349446.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083557895349446.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083692637349445.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083726401349445.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083898536349445.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083959853349445.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140084028487349445.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140084167036349445.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140084221141349445.4902)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_websheets_sign_in_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(1418140425267007336.4902)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Websheets Sign In Page.fr'
,p_internal_name=>'APEX_5.0_WEBSHEETS_SIGN_IN_PAGE'
,p_is_popup=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(function() {',
'  $(''a[href*="#"]:not([href="#"])'').click(function() {',
'    if (location.pathname.replace(/^\//,'''') == this.pathname.replace(/^\//,'''') && location.hostname == this.hostname) {',
'      var target = $(this.hash);',
'      target = target.length ? target : $(''[name="'' + this.hash.slice(1) +''"]'');',
'      if (target.length) {',
'        $(''html,body'').animate({',
'          scrollTop: target.offset().top',
'        }, 500);',
'        return false;',
'      }',
'    }',
'  });',
'});'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--login #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide" id="top">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Login-container">',
'  #BODY#',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086138940349443.4902)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4902)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086287346349443.4902)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4902)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086320010349442.4902)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4902)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086441817349442.4902)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4902)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_image_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3791820543327.4902)
,p_template_name=>'HTML image (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_IMAGE_LEGACY_APEX_5_MIGRATION'
,p_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_hot_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_add_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(9301120013126533.4902)
,p_template_name=>'[EBA] Title - Add Button'
,p_internal_name=>'[EBA]_TITLE_ADD_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="addIcon" #BUTTON_ATTRIBUTES# id="#BUTTON_ID" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_view_all_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(9301209409132905.4902)
,p_template_name=>'[EBA] Title - View All Button'
,p_internal_name=>'[EBA]_TITLE_VIEW_ALL_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="viewAllIcon" #BUTTON_ATTRIBUTES# id="#BUTTON_ID" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_hot_button_next
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(10604003722246228.4902)
,p_template_name=>'[EBA] Hot Button (Next)'
,p_internal_name=>'[EBA]_HOT_BUTTON_NEXT'
,p_template=>'<a href="#LINK#" class="ebaHotButton ebaNextButton" role="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15106902867837483.4902)
,p_template_name=>'[EBA] Button'
,p_internal_name=>'[EBA]_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaButton" id="#BUTTON_ID#" role="button" #BUTTON_ATTRIBUTES#>#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_hot_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15108012910840408.4902)
,p_template_name=>'[EBA] Hot Button'
,p_internal_name=>'[EBA]_HOT_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaHotButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_button_delete
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15160928947568323.4902)
,p_template_name=>'[EBA] Button (Delete)'
,p_internal_name=>'[EBA]_BUTTON_DELETE'
,p_template=>'<a href="#LINK#" class="ebaButton ebaDeleteButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_options_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15650119453846225.4902)
,p_template_name=>'[EBA] Title - Options Button'
,p_internal_name=>'[EBA]_TITLE_OPTIONS_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" class="addIcon" #BUTTON_ATTRIBUTES# id="#BUTTON_ID" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_back_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15650219931855856.4902)
,p_template_name=>'[EBA] Title - Back Button '
,p_internal_name=>'[EBA]_TITLE_BACK_BUTTON_'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" class="backIcon"/></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_expand_collapse_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(16714408571357214.4902)
,p_template_name=>'[EBA] Title - Expand/Collapse Button '
,p_internal_name=>'[EBA]_TITLE_EXPAND/COLLAPSE_BUTTON_'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#IMAGE_PREFIX#f_spacer.gif" class="hideIcon" alt="#LABEL!ATTR#" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20457218105321816.4902)
,p_template_name=>'[EBA] Small Button'
,p_internal_name=>'[EBA]_SMALL_BUTTON'
,p_template=>'<a href="#LINK#" class="wsSmallButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_hot_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20480423759330923.4902)
,p_template_name=>'[EBA] Small Hot Button'
,p_internal_name=>'[EBA]_SMALL_HOT_BUTTON'
,p_template=>'<a href="#LINK#" class="wsSmallButton wsHotButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>4
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_button_previous
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20890400835826116.4902)
,p_template_name=>'[EBA] Small Button (Previous)'
,p_internal_name=>'[EBA]_SMALL_BUTTON_PREVIOUS'
,p_template=>'<a href="#LINK#" class="wsSmallButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="smallPrevIcon" /> #LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_hot_button_next
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20890726723852448.4902)
,p_template_name=>'[EBA] Small Hot Button (Next) '
,p_internal_name=>'[EBA]_SMALL_HOT_BUTTON_NEXT_'
,p_template=>'<a href="#LINK#" class="wsSmallButton wsHotButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML# <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="smallNextIcon" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_button_next
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20905523503069232.4902)
,p_template_name=>'[EBA] Small Button (Next) '
,p_internal_name=>'[EBA]_SMALL_BUTTON_NEXT_'
,p_template=>'<a href="#LINK#" class="wsSmallButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML# <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="smallNextIcon" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_button_previous
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(61282809984809202.4902)
,p_template_name=>'[EBA] Button (Previous)'
,p_internal_name=>'[EBA]_BUTTON_PREVIOUS'
,p_template=>'<a href="#LINK#" class="ebaButton ebaPrevButton" role="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(629231036412957099.4902)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(798473351219404350.4902)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4902
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(936712837989177653.4902)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4902
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(936746267011392790.4902)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4902
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/div_with_id
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3700433754276.4902)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'Div with ID'
,p_internal_name=>'DIV_WITH_ID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>7
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660576405344345.4902)
,p_plug_template_id=>wwv_flow_api.id(3700433754276.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660636395344345.4902)
,p_plug_template_id=>wwv_flow_api.id(3700433754276.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_ws_side_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(9299916504097072.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSideSection">',
'	<h3>#TITLE#',
'		<span>',
'		#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#',
'		</span>',
'	</h3>',
'	#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] WS Side Region'
,p_internal_name=>'[EBA]_WS_SIDE_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660777960344345.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660876152344345.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660929497344345.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661032838344345.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661131645344345.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661271245344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661307299344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661425547344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661541149344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661644344344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661736711344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661837734344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661901606344344.4902)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4902)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(10604720260269861.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsButtonBar">',
'#BODY##CLOSE##EDIT##DELETE##PREVIOUS##CREATE##CHANGE##CREATE2##EXPAND##HELP##COPY##NEXT#</div>'))
,p_page_plug_template_name=>'[EBA] Button Region'
,p_internal_name=>'[EBA]_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662067814344344.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662179042344344.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662203670344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662330662344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662421926344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662533883344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662678374344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662773089344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662868714344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662920203344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663094640344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663168558344343.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663280101344342.4902)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4902)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_collapsable_text_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(11269620137104105.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSection" id="#REGION_STATIC_ID#"> <!-- Begin .wsSection -->',
'	<h2><a href="javascript:void(0)" class="wsSectionControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&COLLAPSE." /></a>',
'		#TITLE#',
'		<span>',
'			<a href="#" class="wsSectionLink wsTopLink" title="&GO_TO_TOP."><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&GO_TO_TOP." class="topIcon" /></a>',
'		</span>',
'	</h2>',
'	<div class="wsSectionContent">',
'		<div class="wsTextSection #REGION_ATTRIBUTES#">',
'			#BODY#',
'		</div>',
'	</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Collapsable Text Region'
,p_internal_name=>'[EBA]_COLLAPSABLE_TEXT_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663350302344342.4902)
,p_plug_template_id=>wwv_flow_api.id(11269620137104105.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663464125344342.4902)
,p_plug_template_id=>wwv_flow_api.id(11269620137104105.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_two_col_pane_heading_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15634208564734334.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2 #REGION_ATTRIBUTES#>',
'	<span class="leftButtons">',
'		#PREVIOUS#',
'	</span>',
'	#TITLE#',
'	<span>',
'		#EDIT##CLOSE##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'	</span>',
'</h2>',
'#BODY#'))
,p_page_plug_template_name=>'[EBA] Two Col Pane Heading Region'
,p_internal_name=>'[EBA]_TWO_COL_PANE_HEADING_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663524386344342.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663645596344342.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663719191344342.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663897217344342.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663926000344342.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664061522344342.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664135877344341.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664249439344341.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664317041344341.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664423144344341.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664596270344341.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664667096344341.4902)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_two_col_pane_heading_left_col_with_control_menu
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(17121518626936007.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="leftButtons" #REGION_ATTRIBUTES#>#PREVIOUS##EXPAND##EDIT##CLOSE##DELETE##CREATE##CREATE2##HELP##COPY##NEXT# </span>',
'#TITLE#<span class="rightButtons" #REGION_ATTRIBUTES#>#CHANGE#</span>'))
,p_page_plug_template_name=>'[EBA] Two Col Pane Heading (Left Col with Control Menu)'
,p_internal_name=>'[EBA]_TWO_COL_PANE_HEADING_LEFT_COL_WITH_CONTROL_MENU'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664796937344341.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664883032344341.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664908404344341.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665020135344341.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665174796344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665214830344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665333045344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665489411344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665508792344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665638491344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665769247344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665841617344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665930824344340.4902)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4902)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_form_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20185117556737935.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsFormRegion">',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Form Region'
,p_internal_name=>'[EBA]_FORM_REGION'
,p_theme_id=>3
,p_theme_class_id=>8
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666013798344340.4902)
,p_plug_template_id=>wwv_flow_api.id(20185117556737935.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666146968344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20185117556737935.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_action_bar_top
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20454830409304572.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsActionBar">',
'#PREVIOUS#',
'#BODY#',
'<span class="wsActionBarRight">',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</span>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Action Bar Top'
,p_internal_name=>'[EBA]_ACTION_BAR_TOP'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666211998344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666384600344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666409296344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666584763344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666615182344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666759434344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666820101344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666930577344339.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667024732344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667180277344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667270512344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667378561344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_action_bar_bottom
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20910304550120452.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsActionBar wsActionBarBottom">',
'<div class="wsActionBarInside">',
'#PREVIOUS#',
'#BODY#',
'<span class="wsActionBarRight">',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</span>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Action Bar Bottom'
,p_internal_name=>'[EBA]_ACTION_BAR_BOTTOM'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667486569344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667532706344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667607480344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667769925344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667827978344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667981395344338.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668079020344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668110637344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668240256344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668341428344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668424534344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668593167344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_interactive_report_with_no_action_bar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20956911766368602.4902)
,p_layout=>'TABLE'
,p_template=>'<div class="wsInteractiveReportOnly" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[EBA] Interactive Report with No Action Bar'
,p_internal_name=>'[EBA]_INTERACTIVE_REPORT_WITH_NO_ACTION_BAR'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668696993344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20956911766368602.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668794309344337.4902)
,p_plug_template_id=>wwv_flow_api.id(20956911766368602.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_action_bar_only
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(25109627701530900.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsActionBar wsActionBarOnly" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'#PREVIOUS#',
'#BODY#',
'<span class="wsActionBarRight">',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</span>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Action Bar Only'
,p_internal_name=>'[EBA]_ACTION_BAR_ONLY'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668860748344337.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668961693344337.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669026948344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669187621344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669228015344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669320922344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669466993344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669541021344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669680053344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669794439344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669891725344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669919080344336.4902)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_collapsable_form_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(27071223638280295.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSection"> <!-- Begin .wsSection -->',
'	<h2><a href="javascript:void(0)" class="wsSectionControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&COLLAPSE." /></a>',
'		#TITLE#',
'		<span>',
'			<a href="#" class="wsSectionLink wsTopLink" title="&GO_TO_TOP."><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&GO_TO_TOP." class="topIcon" /></a>',
'		</span>',
'	</h2>',
'	<div class="wsSectionContent">',
'		<div class="wsFormRegion">',
'			#BODY#',
'		</div>',
'	</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Collapsable Form Region '
,p_internal_name=>'[EBA]_COLLAPSABLE_FORM_REGION_'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670021608344335.4902)
,p_plug_template_id=>wwv_flow_api.id(27071223638280295.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670194534344335.4902)
,p_plug_template_id=>wwv_flow_api.id(27071223638280295.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_collapsable_form_region_collapsed
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(47316730240795884.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSection"> <!-- Begin .wsSection -->',
'	<h2><a href="javascript:void(0)" class="wsSectionControl wsSectionCollapsed"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&COLLAPSE." /></a>',
'		#TITLE#',
'		<span>',
'			<a href="#" class="wsSectionLink wsTopLink" title="&GO_TO_TOP."><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&GO_TO_TOP." class="topIcon" /></a>',
'		</span>',
'	</h2>',
'	<div class="wsSectionContent" style="display: none">',
'		<div class="wsFormRegion">',
'			#BODY#',
'		</div>',
'	</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Collapsable Form Region (Collapsed) '
,p_internal_name=>'[EBA]_COLLAPSABLE_FORM_REGION_COLLAPSED_'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670297051344335.4902)
,p_plug_template_id=>wwv_flow_api.id(47316730240795884.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670358018344335.4902)
,p_plug_template_id=>wwv_flow_api.id(47316730240795884.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_small_form_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(82536903857665765.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsFormRegion wsSmallFormRegion">',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Small Form Region'
,p_internal_name=>'[EBA]_SMALL_FORM_REGION'
,p_theme_id=>3
,p_theme_class_id=>8
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670483707344335.4902)
,p_plug_template_id=>wwv_flow_api.id(82536903857665765.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670542632344335.4902)
,p_plug_template_id=>wwv_flow_api.id(82536903857665765.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_small_form_component_left
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(108051114664442909.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSmallFormComponent wsSmallFormComponentLeft" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'#PREVIOUS#',
'#BODY#',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Small Form Component Left'
,p_internal_name=>'[EBA]_SMALL_FORM_COMPONENT_LEFT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670697553344335.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670799977344335.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670885644344335.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670978891344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671065910344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671183490344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671217047344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671393937344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671453455344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671537352344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671690409344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671712619344334.4902)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/dhtml_hidden_with_id_required_for_data_grid_file_upload
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(173336062654423126.4902)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_ID#" style="display:none;">#BODY#</div>'
,p_page_plug_template_name=>'(DHTML) Hidden with ID (Required for Data Grid File Upload)'
,p_internal_name=>'DHTML_HIDDEN_WITH_ID_REQUIRED_FOR_DATA_GRID_FILE_UPLOAD'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671830212344334.4902)
,p_plug_template_id=>wwv_flow_api.id(173336062654423126.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671926891344333.4902)
,p_plug_template_id=>wwv_flow_api.id(173336062654423126.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_toolbar_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202707431395573866.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsMenu" id="#REGION_STATIC_ID#">',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Toolbar Container'
,p_internal_name=>'[EBA]_TOOLBAR_CONTAINER'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672009613344333.4902)
,p_plug_template_id=>wwv_flow_api.id(202707431395573866.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672185006344333.4902)
,p_plug_template_id=>wwv_flow_api.id(202707431395573866.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/div_with_id_required_for_edit_report_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(400020739576925060.4902)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'Div  with ID ( Required for Edit Report Attributes)'
,p_internal_name=>'DIV_WITH_ID_REQUIRED_FOR_EDIT_REPORT_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>7
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672263295344333.4902)
,p_plug_template_id=>wwv_flow_api.id(400020739576925060.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672305141344333.4902)
,p_plug_template_id=>wwv_flow_api.id(400020739576925060.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(931543191007401308.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4902
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672438243344333.4902)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672591963344333.4902)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672657652344333.4902)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672736479344333.4902)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672851686344332.4902)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672912580344332.4902)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_no_template
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1071999318750156264.4902)
,p_layout=>'TABLE'
,p_template=>'#BODY#'
,p_page_plug_template_name=>'[EBA] No Template'
,p_internal_name=>'[EBA]_NO_TEMPLATE'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673041572344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1071999318750156264.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673138725344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1071999318750156264.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4902
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673254334344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673332934344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673403677344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673575133344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1418149362592020763.4902)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-body">',
'  #BODY#',
'</div>',
'<div class="a-Login-buttons">',
'  #NEXT#',
'</div>',
'<div class="a-Login-links">',
'  #EDIT##CREATE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Workspace Login Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>781637364422290692.4902
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673684257344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4902)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673767486344332.4902)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4902)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673824307344331.4902)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4902)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673998844344331.4902)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4902)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140674022473344331.4902)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4902)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_toolbar_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(9301809587170761.4902)
,p_list_template_current=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a></li>'
,p_list_template_noncurrent=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a></li>'
,p_list_template_name=>'[EBA] Toolbar Menu '
,p_internal_name=>'[EBA]_TOOLBAR_MENU_'
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>' '
,p_list_template_after_rows=>' '
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_noncurrent=>'<li class="#A01#"><a href="#LINK#" class="wsMenuItem #A04#">#TEXT#<span>#A02#</span></a></li>'
,p_item_templ_curr_w_child=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a>#SUB_LISTS#</li>'
,p_item_templ_noncurr_w_child=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a>#SUB_LISTS#</li>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_pop_up_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(11252405836967523.4902)
,p_list_template_current=>'--><li class="active"><a href="#LINK#">#TEXT#</a></li><!--'
,p_list_template_noncurrent=>'--><li><a href="#LINK#">#TEXT#</a></li><!--'
,p_list_template_name=>'[EBA] Pop Up Tabs'
,p_internal_name=>'[EBA]_POP_UP_TABS'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsTabs">',
'  <ul><!-- '))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--><li class="searchBox">',
'    <div class="wsSearch" style="display: none;">',
'      <input type="text" id="wsSearchBar"/>',
'      <span></span>',
'    </div>',
'  </li>',
'</ul>',
'</div>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_pop_up_side_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(11270206893119252.4902)
,p_list_template_current=>'<li><a href="#LINK#" class="active">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'[EBA] Pop Up Side Navigation'
,p_internal_name=>'[EBA]_POP_UP_SIDE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_left_pane_sections_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15654631677982271.4902)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="javascript:applyAndGoToNextSection(''&APP_PAGE_ID.'',''#A06#'',''#A07#'',''#A08#'');" class="#A05#" title="#A02#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#A02#" /></span>',
'		<h3>#TEXT_ESC_SC#',
'			<em>#A03# &mdash; #A04#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#A02#" /></span>',
'		<h3>#TEXT_ESC_SC#',
'			<em>#A03# &mdash; #A04#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_name=>'[EBA] Left Pane Sections List'
,p_internal_name=>'[EBA]_LEFT_PANE_SECTIONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<ul class="sectionList">'
,p_list_template_after_rows=>' </ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_heading_control_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(17118702088912337.4902)
,p_list_template_current=>'<a href="#LINK#" class="ebaTitleButton"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#TEXT#" title="#TEXT#"/></a>'
,p_list_template_noncurrent=>'<a href="#LINK#" class="ebaTitleButton"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#"  alt="#TEXT#" title="#TEXT#"/></a>'
,p_list_template_name=>'[EBA] Heading Control Menu'
,p_internal_name=>'[EBA]_HEADING_CONTROL_MENU'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<span class="controlMenus">'
,p_list_template_after_rows=>' </span>'
,p_before_sub_list=>'<div class="panelMenuContainer"><div class="panelMenu"><ul>'
,p_after_sub_list=>'</ul></div></div>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<a href="#LINK#" class="ebaTitleButton controlMenu"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#TEXT#" title="#TEXT#"/></a>'
,p_item_templ_noncurr_w_child=>'<a href="#LINK#" class="ebaTitleButton controlMenu"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#TEXT#" title="#TEXT#"/></a>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_horizontal_progress_bar_train
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(17197023652325418.4902)
,p_list_template_current=>'<li class="currentStep"><span></span></li>'
,p_list_template_noncurrent=>'<li><span></span></li>'
,p_list_template_name=>'[EBA] Horizontal Progress Bar Train'
,p_internal_name=>'[EBA]_HORIZONTAL_PROGRESS_BAR_TRAIN'
,p_theme_id=>3
,p_theme_class_id=>17
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="ebaProgressWizard">',
''))
,p_list_template_after_rows=>' </ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_left_pane_pages_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(18574125863745642.4902)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#" class="#A04#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" /></span>',
'		<h3>#TEXT#',
'			<em>#A02# &mdash; #A03#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" /></span>',
'		<h3>#TEXT#',
'			<em>#A02# &mdash; #A03#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_name=>'[EBA] Left Pane Pages List '
,p_internal_name=>'[EBA]_LEFT_PANE_PAGES_LIST_'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<ul class="sectionList">'
,p_list_template_after_rows=>' </ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_unformatted_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(20455926267312733.4902)
,p_list_template_current=>'<li><a href="#LINK#" class="active">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'[EBA] Unformatted List'
,p_internal_name=>'[EBA]_UNFORMATTED_LIST'
,p_theme_id=>3
,p_theme_class_id=>3
,p_list_template_before_rows=>' <ul>'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(138239722779443444.4902)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist_from_4999
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(156210646767386810.4902)
,p_list_template_current=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#ws/dropdown_32x24.gif" width="32" height="24" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#L'
||'IST_ITEM_ID#'',false)" alt=""/><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_noncurrent=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_name=>'DHTML List (Image) with Sublist from 4999'
,p_internal_name=>'DHTML_LIST_IMAGE_WITH_SUBLIST_FROM_4999'
,p_theme_id=>3
,p_theme_class_id=>4
,p_list_template_before_rows=>'<div class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">',
'<li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>'))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" />#TEXT#</li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></li>'
,p_item_templ_noncurr_w_child=>'<div class="dhtmlMenuItem"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="dhtmlMenu" onclick="ws_Pd(this,''#LIST_ITEM_ID#'',false)" alt=""/><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /><span>#TEXT#</span><img class="htmldbMIMG" alt="" s'
||'rc="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#" style="background-image:url(#IMAGE_PREFIX#menu_open_right2.gif);background-repeat:no-repeat;background-position:95% cente'
||'r;"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></li>'
,p_list_template_comment=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</span><img class="htmldbMIMG" alt="" s'
||'rc="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_left_pane_pages_list_new
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(158861503239501998.4902)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_list_template_name=>'[EBA] Left Pane Pages List [NEW]'
,p_internal_name=>'[EBA]_LEFT_PANE_PAGES_LIST_[NEW]'
,p_theme_id=>3
,p_theme_class_id=>19
,p_list_template_before_rows=>' <ul class="pageList" id="pageList">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_websheets_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(929122129315135247.4902)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Websheets Menu'
,p_internal_name=>'APEX_5.0_WEBSHEETS_MENU'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>' '
,p_list_template_after_rows=>' '
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>926415475390827132.4902
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(936708315591140469.4902)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4902
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1338174060370978758.4902)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4902
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_report_sortable
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(46784125242633572.4902)
,p_row_template_name=>'[EBA] Report (Sortable)'
,p_internal_name=>'[EBA]_REPORT_SORTABLE'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>'<table class="wsStandardReport wsTable" summary="" cellspacing="0" cellpadding="0" id="r#REGION_ID#"><tbody>'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>',
'<script>',
'var g_#REGION_ID#;',
'function f_#REGION_ID#(){',
'		g_#REGION_ID# =  new apex.tabular.sort(''r#REGION_ID#'');',
'		}',
'addLoadEvent(f_#REGION_ID#)',
'</script>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#EEE'
,p_row_style_checked=>'#EEE'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(129228711620465473.4902)
,p_row_template_name=>'[EBA] Report'
,p_internal_name=>'[EBA]_REPORT'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>'<table class="wsStandardReport wsTable" summary="" cellspacing="0" cellpadding="0" id="r#REGION_ID#"><tbody>'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#EEE'
,p_row_style_checked=>'#EEE'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_portlet_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(171646109232237656.4902)
,p_row_template_name=>'[EBA] Portlet Column'
,p_internal_name=>'[EBA]_PORTLET_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4902
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_portlet_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(171646521495237685.4902)
,p_row_template_name=>'[EBA] Portlet Row'
,p_internal_name=>'[EBA]_PORTLET_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'<th><label>#1#</label></th>',
'<td>#2#</td>',
'</tr>'))
,p_row_template_before_rows=>'<table class="wsTable wsPortlet" #REPORT_ATTRIBUTES# id="#REGION_ID#">'
,p_row_template_after_rows=>'</table>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(5556614497310460.4902)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4902
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/eba_optional_w_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(11461002620401386.4902)
,p_template_name=>'[EBA] Optional w/ Help'
,p_internal_name=>'[EBA]_OPTIONAL_W/_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="wsOptional">'
,p_template_body2=>'</label>'
,p_after_element=>'#HELP_TEMPLATE#'
,p_help_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button">',
'    <span class="a-Icon icon-help"></span>',
'    <span class="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span>',
'</button>'))
,p_on_error_after_label=>'<span class="wsLabelError">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/eba_required_w_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(11461206197401386.4902)
,p_template_name=>'[EBA] Required w/ Help'
,p_internal_name=>'[EBA]_REQUIRED_W/_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="wsRequired">'
,p_template_body2=>' <img src="#IMAGE_PREFIX#f_spacer.gif" alt="#VALUE_REQUIRED#" class="wsAsterisk" /></label>'
,p_after_element=>'#HELP_TEMPLATE#'
,p_help_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button">',
'    <span class="a-Icon icon-help"></span>',
'    <span class="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span>',
'</button>'))
,p_on_error_after_label=>'<span class="wsLabelError">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(264000229814622656.4902)
,p_template_name=>'Login Hidden Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_HIDDEN_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Icon a-Login-iconLabel a-Login-hiddenLabel u-VisuallyHidden">'
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--hiddenLabel #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'#HELP_TEMPLATE#</div></div>'
,p_after_element=>'#ERROR_TEMPLATE#'
,p_help_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button">',
'    <span class="a-Icon icon-help"></span>',
'    <span class="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span>',
'</button>'))
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1418153120551046350.4902)
,p_template_name=>'APEX 5.0 - Workspace Login Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Icon a-Login-iconLabel">'
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'</div></div>'
,p_after_element=>'<span class="a-Login-iconValidation a-Icon icon-check"></span>#ERROR_TEMPLATE#'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span class="u-VisuallyHidden">#CURRENT_ITE'
||'M_HELP_LABEL#</span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>781637020106265852.4902
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/eba_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(20175617163709368.4902)
,p_name=>'[EBA] Breadcrumbs'
,p_internal_name=>'[EBA]_BREADCRUMBS'
,p_before_first=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsBreadcrumb wsBreadcrumbSubPage" id="wsBreadcrumb">',
'<ul class="ws-Breadcrumb">',
''))
,p_current_page_option=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">#NAME# <span class="a-Icon icon-right-chevron"></span></a>',
'</li>',
''))
,p_non_current_page_option=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">#NAME# <span class="a-Icon icon-right-chevron"></span></a>',
'</li>',
''))
,p_after_last=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'</div>'))
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(165003451930708292.4902)
,p_popup_icon=>'#IMAGE_PREFIX#htmldb/icons/view_small.gif'
,p_popup_icon_attr=>'width="18" height="18" alt="#LIST_OF_VALUES#" title="#LIST_OF_VALUES#"'
,p_page_name=>'winlov'
,p_page_title=>'Rechercher'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=edge" /><![endif]-->',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'<!--[if IE 7]>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'<![endif]-->',
'<!--[if IE 8]>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'<![endif]-->',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'class="wsPopUpLOV"'
,p_before_field_text=>'<div class="wsActionBar wsActionBarOnly">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="searchField"'
,p_find_button_text=>'Rechercher'
,p_find_button_attr=>'class="smallButton"'
,p_close_button_text=>'Fermer'
,p_close_button_attr=>'class="smallButton hotButton"'
,p_next_button_text=>'Suivant >'
,p_next_button_attr=>'class="smallButton"'
,p_prev_button_text=>unistr('< Pr\00E9c\00E9dent')
,p_prev_button_attr=>'class="smallButton"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'500'
,p_result_row_x_of_y=>'<div class="lovPagination">Ligne(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="lovLinks">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/eba_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(20940421004163137.4902)
,p_cal_template_name=>'[EBA] Calendar'
,p_internal_name=>'[EBA]_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="CalendarHolder"> ',
' <tr>',
'   <td class="MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="WeekCalendarHolder">',
'<tr>',
'<td class="MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="Today">'
,p_daily_time_open_format=>'<th scope="row" class="Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(931574038306409142.4902)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(931574723130409146.4902)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(936751341799414713.4902)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931573772023409139.4902)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931573860104409140.4902)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574184140409145.4902)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574386836409146.4902)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574519466409146.4902)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574894275409146.4902)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(931574723130409146)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931575094854409146.4902)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(931574723130409146)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931575149476409146.4902)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931575333122409146.4902)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4902)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(936709001085140492.4902)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4902)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(936709194813140492.4902)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4902)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1338174721014978766.4902)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832103532526804.4902)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832278061526804.4902)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832317693526804.4902)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1332151043262185426.4902)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(239986615251259134.4902)
,p_build_option_name=>'Do Not Include in APEX 4.2 EA1'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275247454322028)
,p_name=>'ADD'
,p_message_language=>'fr'
,p_message_text=>'Ajouter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273333359322027)
,p_name=>'ADD_COLUMN'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274555012322027)
,p_name=>'ADD_FILE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un fichier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274714259322027)
,p_name=>'ADD_LINK'
,p_message_language=>'fr'
,p_message_text=>'Ajouter un lien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274637679322027)
,p_name=>'ADD_NOTE'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une remarque'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275403904322028)
,p_name=>'ADD_ROW'
,p_message_language=>'fr'
,p_message_text=>'Ajouter une ligne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274875401322028)
,p_name=>'ADD_TAGS'
,p_message_language=>'fr'
,p_message_text=>'Ajouter des balises'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273094206322026)
,p_name=>'APPLY'
,p_message_language=>'fr'
,p_message_text=>'Appliquer'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110272836902322026)
,p_name=>'CANCEL'
,p_message_language=>'fr'
,p_message_text=>'Annuler'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275117389322028)
,p_name=>'COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273656672322027)
,p_name=>'COLUMN_GROUPS'
,p_message_language=>'fr'
,p_message_text=>'Groupes de colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273483538322027)
,p_name=>'COLUMN_PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s de colonne')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273146233322026)
,p_name=>'COPY'
,p_message_language=>'fr'
,p_message_text=>'Copier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274358096322027)
,p_name=>'COPY_DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Copier la grille de donn\00E9es')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273242122322026)
,p_name=>'DATA_GRID_PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s de grille de donn\00E9es')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110272984638322026)
,p_name=>'DELETE'
,p_message_language=>'fr'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273839277322027)
,p_name=>'DELETE_COLUMNS'
,p_message_language=>'fr'
,p_message_text=>'Supprimer des colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274433801322027)
,p_name=>'DELETE_DATA_GRID'
,p_message_language=>'fr'
,p_message_text=>unistr('Supprimer la grille de donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274295442322027)
,p_name=>'DELETE_ROWS'
,p_message_language=>'fr'
,p_message_text=>'Supprimer des lignes'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275606453322028)
,p_name=>'EDIT_ATTRIBUTES'
,p_message_language=>'fr'
,p_message_text=>'Modifier des attributs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275702911322028)
,p_name=>'EDIT_QUERY'
,p_message_language=>'fr'
,p_message_text=>unistr('Modifier une requ\00EAte')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274199511322027)
,p_name=>'FILL'
,p_message_language=>'fr'
,p_message_text=>'Remplissage'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275556665322028)
,p_name=>'HISTORY'
,p_message_language=>'fr'
,p_message_text=>'Historique'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273531011322027)
,p_name=>'LIST_OF_VALUES'
,p_message_language=>'fr'
,p_message_text=>'Liste de valeurs (LOV)'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274922960322028)
,p_name=>'PROPERTIES'
,p_message_language=>'fr'
,p_message_text=>unistr('Propri\00E9t\00E9s')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110274090945322027)
,p_name=>'REPLACE'
,p_message_language=>'fr'
,p_message_text=>'Remplacer'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275354452322028)
,p_name=>'ROWS'
,p_message_language=>'fr'
,p_message_text=>'Lignes'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273942154322027)
,p_name=>'SET_COLUMN_VALUES'
,p_message_language=>'fr'
,p_message_text=>unistr('D\00E9finir les valeurs de colonne')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110275010917322028)
,p_name=>'TOGGLE_CHECKBOXES'
,p_message_language=>'fr'
,p_message_text=>unistr('Afficher/Masquer les cases \00E0 cocher')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110273729853322027)
,p_name=>'VALIDATION'
,p_message_language=>'fr'
,p_message_text=>'Validation'
,p_is_js_message=>true
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(7176806101815144.4902)
,p_shortcut_name=>'OK_TO_GET_NEXT_PREV_PK_VALUE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('Etes-vous s\00FBr de vouloir quitter cette page sans l''enregistrer ?')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(155157613934985128.4902)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Voulez-vous effectuer cette action de suppression ?'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/pick_ws_rpt_col_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(184021228934805221.4902)
,p_shortcut_name=>'PICK_WS_RPT_COL_NAME'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3050:&SESSION.::::P3050_CALLING_ITEM,P3050_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3010_LB_WS_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0" w'
||'idth="18" height="18" alt="torche" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/pick_ws_rpt_col_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(185539627466561397.4902)
,p_shortcut_name=>'PICK_WS_RPT_COL_VALUE'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.::::P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3010_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0'
||'" width="18" height="18" alt="torche" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/pick_curr_ws_rpt_col
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(185548307614697562.4902)
,p_shortcut_name=>'PICK_CURR_WS_RPT_COL'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.::::P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3010_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0'
||'" width="18" height="18" alt="torche" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/p3020_pick_curr_ws_rpt_col
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(187888728094279874.4902)
,p_shortcut_name=>'P3020_PICK_CURR_WS_RPT_COL'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.::::P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3020_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0'
||'" width="18" height="18" alt="torche" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/p3020_pick_ws_rpt_col_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(187889809179283856.4902)
,p_shortcut_name=>'P3020_PICK_WS_RPT_COL_NAME'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3050:&SESSION.::::P3050_CALLING_ITEM,P3050_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3020_LB_WS_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0" w'
||'idth="18" height="18" alt="torche" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/p3020_pick_ws_rpt_col_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(187890114027285273.4902)
,p_shortcut_name=>'P3020_PICK_WS_RPT_COL_VALUE'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.:::3040:P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3020_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" borde'
||'r="0" width="18" height="18" alt="torche" /></a>'
);
end;
/
prompt --application/shared_components/security/authentications/internal_websheet_authentication
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(709672827800503408.4902)
,p_name=>'Internal Websheet Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.AUTHENTICATION.WEBSHEET'
,p_invalid_session_type=>'URL'
,p_invalid_session_url=>'f?p=4900:101:&APP_SESSION.'
,p_cookie_name=>'-NO_COOKIE-'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(65218046382244660.4902)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Zone de recherche'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442.4902
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513167447444230024.4902)
,p_plugin_id=>wwv_flow_api.id(65218046382244660.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513167803753230024.4902)
,p_plugin_id=>wwv_flow_api.id(65218046382244660.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_clob_textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(377419101248577827.4902)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_display_name=>'Zone de texte CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CLOB_TEXTAREA'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_textarea'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_textarea'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:ELEMENT:WIDTH:HEIGHT'
,p_substitute_attributes=>false
,p_reference_id=>200125518386793215.4902
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513356480445479112.4902)
,p_plugin_id=>wwv_flow_api.id(377419101248577827.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL or PL/SQL to get CLOB value'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_display_length=>80
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This item supports sql statements, like',
'<pre>',
'select big_data',
'from my_table',
'where id=:P4711_ID',
'</pre>',
'and function results, like',
'<pre>',
'return wwv_flow_xxx.get_big_data(p_id => :P4711_ID);',
'</pre>',
'to get a clob value for rendering.',
'',
'To write the data back, the CLOB Textarea makes an AJAX call before the actual page submit, which stores the clob value in wwv_flow_collections.clob001, with a collection name that equals the item name.',
'Developers can then define a page process that stores the clob value where it belongs, either directly',
'<pre>',
'update my_table',
'   set big_data = (select clob001',
'                     from wwv_flow_collections',
'                    where collection_name=''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
'or via the built-in function wwv_flow_f4000_plugins.get_clob_textarea_value:',
'',
'<pre>',
'update my_table',
'   set agreement_text = wwv_flow_f4000_plugins.get_clob_textarea_value(''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513356893048479113.4902)
,p_plugin_id=>wwv_flow_api.id(377419101248577827.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Textarea Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513357286353479114.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(1513356893048479113.4902)
,p_display_sequence=>10
,p_display_value=>'HTML Textarea'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513357742751479114.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(1513356893048479113.4902)
,p_display_sequence=>20
,p_display_value=>'Rich Text Editor'
,p_return_value=>'CKEDITOR-Full'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_data_grid
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(596503234954274806.4902)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.DATA_GRID'
,p_display_name=>unistr('Grille de donn\00E9es')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.DATA_GRID'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_data_grid'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_data_grid'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Affiche un widget Application Express de type Data Grid'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(615743690109519472.4902)
,p_plugin_id=>wwv_flow_api.id(596503234954274806.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Worksheet ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(615744471837526561.4902)
,p_plugin_id=>wwv_flow_api.id(596503234954274806.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Show Checkbox Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(632128835511089827.4902)
,p_plugin_id=>wwv_flow_api.id(596503234954274806.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Checks SQL Enabled'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_authentication_websheet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(709653022821492509.4902)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.AUTHENTICATION.WEBSHEET'
,p_display_name=>'Authentification de feuille Web interne'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.AUTHENTICATION.WEBSHEET'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_f4900.callback'
,p_session_sentry_function=>'wwv_flow_authentication_f4900.session_sentry'
,p_invalid_session_function=>'wwv_flow_authentication_f4900.invalid_session'
,p_post_logout_function=>'wwv_flow_authentication_f4900.post_logout'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1129000224849873155.4902)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>unistr('Autorisation du d\00E9veloppeur')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494.4902
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(651583615809363815.4902)
,p_plugin_id=>wwv_flow_api.id(1129000224849873155.4902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651584047608363815.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651584589168363816.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651585023708363816.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651585536003363816.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651586043667363816.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651586548273363817.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651587007958363817.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651587521302363817.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651588015914363817.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651588581137363818.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651589076996363818.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651589515126363818.4902)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4902)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2564397076686507738.4902)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Ajouter la case Cocher tout'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512.4902
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''action dynamique "Ajouter la case Cocher tout" transforme un en-t\00EAte de colonne contenant la cha\00EEne #CHECK_ALL_CHECKBOX# en une case de type Cocher tout accessible, qui s\00E9lectionnera ou d\00E9s\00E9lectionnera toutes les cases dans la colonne correspond')
||'ante.<p>',
'<p>',
unistr('Pour utiliser ce module d''extension, assurez-vous que les attributs suivants sont d\00E9finis :'),
'<ol>',
unistr('<li>Dans la colonne d''\00E9tat, d\00E9finissez la valeur ''#CHECK_ALL_CHECKBOX#'' comme valeur d''en-t\00EAte.</li>'),
unistr('<li>Pour l''attribut Action dynamique lorsque, s\00E9lectionnez la r\00E9gion d''\00E9tat contenant la colonne.</li>'),
unistr('<li>D\00E9finissez l''action dynamique sur un d\00E9clenchement ''Apr\00E8s r\00E9g\00E9n\00E9ration'' et l''action sur ''D\00E9clencher lors du chargement de la page''. (Les valeurs par d\00E9faut de ces deux actions seront d\00E9finies de fa\00E7on appropri\00E9e si l''action dynamique est cr\00E9\00E9e en')
||unistr(' s\00E9lectionnant la r\00E9gion dans la section ''Affichage'' du concepteur de page et en cr\00E9ant l''action dynamique \00E0 partir de l\00E0.</li>'),
unistr('<li>Cela ne permet pas de g\00E9rer l''accessibilit\00E9 des cases affich\00E9es sur chaque ligne, ce qui doit \00EAtre effectu\00E9 s\00E9par\00E9ment dans la source de r\00E9gion. (Pour obtenir un exemple, reportez-vous \00E0 la r\00E9gion R\00E9gions 4000:656).</li>'),
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968616267302342.4902)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Bureau'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1000:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>.4902
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'0'
,p_step_title=>'0'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11470321135602393.4902)
,p_plug_name=>'Application Header [EBA]'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.page_header (',
'   p_app_id => :app_id,',
'   p_session => :app_session,',
'   p_app_user => :app_user,',
'   p_ws_app_id => :ws_app_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,90,102,605,3040,3050,92,101,888,999,6,12,15,16,17,19,22,25,27,28,29,30,901,50,33'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>'900,908,200,53,930,760,934,932,931,23,920,940,991,20,902,2,1000,9,950,906,903,904,905,915,928,1001,3,1,140,1250,11,951,910,990,31,960,205,201,206,4020,1310,1320,131,912,4040,4030,3000,21,926,921,927,922,923,925,710,740,745,742,750,37,13,18,24,141,800'
||'0,142,146,143,144,145,42,3010,3020,3030,3060,914,91,89'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22912720326182943.4902)
,p_plug_name=>'Search'
,p_region_css_classes=>'wsSearch'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4902)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,33,90,92,101,102,888,901,999,6,12,15,16,17,19,22,25,27,28,29,30,3040,3050,8000'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23000306359277138.4902)
,p_plug_name=>'widget for ws'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="rollover" style="position:absolute;display:none;">',
'  <table cellpadding="1" cellspacing="0" border="0" width="100%">',
'    <tr>',
'      <td><input type="text" onkeyup="html_Find(''rollover_content'',this.value);" style="width:150px;" id="search" /><img onclick="ws_SearchApply()" src="#IMAGE_PREFIX#ws/find_20x.gif" /></td>',
'    </tr>',
'    <tr>',
'      <td>',
'        <span id="sortup"><img src="#IMAGE_PREFIX#ws/dup.gif" alt="Trier par ordre croissant" title="Trier par ordre croissant" onclick="gReport.column.order(''ASC'')" /></span>',
unistr('        <span id="sortdown"><img src="#IMAGE_PREFIX#ws/ddown.gif" alt="Trier par ordre d\00E9croissant" title="Trier par ordre d\00E9croissant" onclick="gReport.column.order(''DESC'')" /></span>'),
'        <span id="removefilter"><img src="#IMAGE_PREFIX#ws/no_filter.gif" alt="Enlever un filtre" title="Enlever un filtre" onclick="gReport.column.filter_delete()" /></span>',
'        <span id="hide"><img src="#IMAGE_PREFIX#ws/trash.gif" alt="Masquer une colonne" title="Masquer une colonne" onclick="gReport.column.hide()" /></span>',
'        <span id="break"><img src="#IMAGE_PREFIX#ws/break_col.gif" alt="Colonne de section (BREAK)" title="Colonne de section (BREAK)" onclick="gReport.column.break_on()" /></span>',
'      </td>',
'    </tr>',
'  </table>',
'  <div id="rollover_content"></div>',
'</div>',
''))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_IN_CONDITION'
,p_plug_display_when_condition=>'2,16'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(111070233758155201.4902)
,p_plug_name=>'Les feuilles Web sont en phase d''abandon.'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(931543191007401308.4902)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les feuilles Web ne seront bient\00F4t plus disponibles. Pour migrer les donn\00E9es contenues dans cette feuille Web, contactez l''administrateur.</p>'),
'<p>',
'<strong>Besoin d''aide pour la migration ?</strong>',
unistr('Reportez-vous \00E0 la <a href="https://einstein.oracle.com/q/are-you-still-using-websheets-on-apex-oraclecorp-com-2453" target="_blank">publication d''Einstein</a> sur le s\00E9minaire en ligne relatif \00E0 la migration des feuilles Web.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'101'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.a-Alert--horizontal .a-Alert-title { font-weight: 700; }',
'.a-Alert--horizontal .a-Alert-body { font-weight: 400; font-size: 14px; line-height: 1.5; color: rgba(0, 0, 0, .65); }',
'</style>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202667427121487089.4902)
,p_plug_name=>'Toolbar Menu Container'
,p_region_name=>'wsMenu'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(202707431395573866.4902)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_02'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,33,90,92,101,102,888,901,999,6,12,15,16,17,19,22,25,27,28,29,30,3040,3050'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'900,902,1,1000,906,903,904,928,905,915,2,3000,950,951,140,1250,11,3,18,24,141,8000,142,146,143,144,145,42'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202668901410498676.4902)
,p_plug_name=>'Data Grid Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4902)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_data_grid_menu (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_app_session => :APP_SESSION);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202703416002531181.4902)
,p_plug_name=>'Admin Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4902)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(202684424744514793.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(929122129315135247.4902)
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'</ul></div>'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(246646208489080880.4902)
,p_plug_name=>'Report Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4902)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_report_menu (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_app_session => :APP_SESSION);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and',
'   wwv_flow_ws_security.sql_enabled_inst then',
'  return true;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(929118964340126057.4902)
,p_plug_name=>'APEX 5.0 - Toolbar Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4902)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(929134615131186819.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(929122129315135247.4902)
,p_translate_title=>'N'
,p_plug_header=>'<div id="websheets_menubar" class=""><ul style="display: none">'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(353259602905391710.4902)
,p_plug_name=>'print app custom css'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.print_custom_css (',
'    p_ws_app_id  => :WS_APP_ID',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,90,102,605,3040,3050,92,101,888,999,6,12,15,16,17,19,22,25,27,28,29,30,901,50,33'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(978301830711571982.4902)
,p_plug_name=>'high contrast mode CSS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_util.is_high_contrast_session then',
'  sys.htp.p(''<link rel="stylesheet" href="''||wwv_flow.g_image_prefix||''ws/css/ws_hc.css" type="text/css" />'');',
'end if;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(978405910887585124.4902)
,p_plug_name=>'high contrast mode .js'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_util.is_high_contrast_session then',
'  sys.htp.p(''<script type="text/javascript">'');',
'  sys.htp.p(''initHighContrastMode()'');',
'  sys.htp.p(''</script>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29174927846182851.4902)
,p_name=>'P0_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22912720326182943.4902)
,p_prompt=>'Rechercher une feuille Web'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.SEARCHBOX'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'f?p=&APP_ID.:8000:&SESSION.:::RIR:P8000_SEARCH:'
,p_attribute_02=>'Rechercher une feuille Web'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Tableau de bord'
,p_step_title=>'Tableau de bord'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174589600742777269.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Cette page affiche les informations sur cette application.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181148802605561554.4902)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108117930940447534.4902)
,p_plug_name=>'Tranche de temps'
,p_parent_plug_id=>wwv_flow_api.id(181148802605561554.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(108051114664442909.4902)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185579501876856681.4902)
,p_name=>unistr('D\00E9tails d''application')
,p_template=>wwv_flow_api.id(27071223638280295.4902)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:33%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'(',
'select name co',
'from wwv_flow_ws_applications',
'where id = :ws_app_id and',
'      security_group_id = :flow_security_group_id',
') application_name,',
'(',
'select apex_util.get_since(created_on) co',
'from wwv_flow_ws_applications',
'where id = :ws_app_id and',
'      security_group_id = :flow_security_group_id',
') application_created,',
'(',
'select created_by co',
'from wwv_flow_ws_applications',
'where id = :ws_app_id and',
'      security_group_id = :flow_security_group_id',
') created_by,',
'(',
'select count(*) websheet_pages',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :ws_app_id',
'and a.id = p.ws_app_id',
') websheet_pages,',
'(',
'select count(*) websheet_datagrids',
'from wwv_flow_worksheets w, ',
'                  wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id and',
'             w.security_group_id = :flow_security_group_id and             ',
'             a.ws_app_id = :ws_app_id and',
'             nvl(a.websheet_type,''DATA'') = ''DATA''',
') websheet_datagrids,',
'(',
'select count(*) websheet_reports',
'from wwv_flow_worksheets w, ',
'                  wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id and',
'             w.security_group_id = :flow_security_group_id and             ',
'             a.ws_app_id = :ws_app_id and',
'             nvl(a.websheet_type,''DATA'') = ''REPORT'' ',
') websheet_reports',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646109232237656.4902)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185791324487395890.4902)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185791420618395890.4902)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_CREATED'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Cr\00E9\00E9')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185793209343448296.4902)
,p_query_column_id=>3
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Cr\00E9ation par')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185579730924856683.4902)
,p_query_column_id=>4
,p_column_alias=>'WEBSHEET_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>'Pages de feuille Web'
,p_column_format=>'999G999G999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185582712789897769.4902)
,p_query_column_id=>5
,p_column_alias=>'WEBSHEET_DATAGRIDS'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Grilles de donn\00E9es de feuille Web')
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185583313959907472.4902)
,p_query_column_id=>6
,p_column_alias=>'WEBSHEET_REPORTS'
,p_column_display_sequence=>6
,p_column_heading=>'Etats de feuille Web'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185592226389958372.4902)
,p_name=>'Principaux utilisateurs'
,p_template=>wwv_flow_api.id(27071223638280295.4902)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:33%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select userid user_name, count(*) page_events',
'from wwv_flow_activity_log',
'where websheet_id = :ws_app_id and',
'      security_group_id = :flow_security_group_id and',
'      time_stamp >= (sysdate - nvl(:P1_TIMEFRAME,7))',
'group by userid',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646521495237685.4902)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('L''\00E9tat ne contient aucune donn\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185597127736006112.4902)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom utilisateur'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185597203639006112.4902)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Ev\00E9nements de page')
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185694921184931340.4902)
,p_name=>'Pages principales'
,p_template=>wwv_flow_api.id(27071223638280295.4902)
,p_display_sequence=>50
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:66%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'          (select max(name)',
'          from wwv_flow_ws_webpages p',
'          where p.ws_app_id = :ws_app_id',
'            and p.id = v.webpage_id',
'            and p.security_group_id = :flow_security_group_id) page_name,',
'       page_events',
'from (',
'select webpage_id, count(*) page_events',
'from wwv_flow_activity_log',
'where websheet_id = :ws_app_id and',
'      security_group_id = :flow_security_group_id and',
'      time_stamp >= (sysdate - nvl(:P1_TIMEFRAME,7)) and',
'      webpage_id is not null and',
'      webpage_id in (select id from wwv_flow_ws_webpages where ws_app_id = :ws_app_id)',
'group by  webpage_id',
'order by count(*) desc',
') v',
'where rownum < 8',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646521495237685.4902)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('L''\00E9tat ne contient aucune donn\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(459664827478856710.4902)
,p_query_column_id=>1
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nom de page'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185695219132931341.4902)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>1
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185788025254301476.4902)
,p_name=>unistr('Derni\00E8res modifications')
,p_template=>wwv_flow_api.id(27071223638280295.4902)
,p_display_sequence=>30
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:66%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(updated_by,created_by)||'' ''||wwv_flow_lang.system_message(''DATA_GRID'')||'': ''||websheet_name n,',
'       nvl(updated_on,created_on) the_date',
'from wwv_flow_ws_websheet_attr a',
'where a.ws_app_id = :ws_app_id and',
'      a.security_group_id = :workspace_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA''',
'union all',
'select nvl(updated_by,created_by)||'' ''||wwv_flow_lang.system_message(''F4000.PAGE'')||'': ''||name n,',
'       nvl(updated_on,created_on) the_date',
'from wwv_flow_ws_webpages p',
'where p.ws_app_id = :ws_app_id and',
'      p.security_group_id = :workspace_id',
'union all',
'select nvl(updated_by,created_by)||'' ''||wwv_flow_lang.system_message(''REPORT'')||'': ''||websheet_name n, nvl(updated_on,created_on) the_date',
'from  wwv_flow_ws_websheet_attr a',
'where  a.ws_app_id = :ws_app_id and',
'       a.security_group_id = :workspace_id and',
'       nvl(a.websheet_type,''DATA'') = ''REPORT'' ',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646521495237685.4902)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('L''\00E9tat ne contient aucune donn\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185789009633344267.4902)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185789100826344267.4902)
,p_query_column_id=>2
,p_column_alias=>'THE_DATE'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431071714612124037.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185591206649952695.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(108117930940447534.4902)
,p_button_name=>'P1_SET'
,p_button_static_id=>'P1_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_button_condition_type=>'NEVER'
,p_request_source=>'refresh'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(467407418236734151.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(181148802605561554.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:1,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185586311236935113.4902)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185585314221926524.4902)
,p_name=>'P1_TIMEFRAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108117930940447534.4902)
,p_item_default=>'7'
,p_prompt=>'Tranche de temps'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la p\00E9riode pour cet \00E9tat.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(185297526463636542.4902)
,p_computation_sequence=>10
,p_computation_item=>'RUN_LINK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''f?p=''||:app_id||'':900:''||:app_session||''::::WS_APP_ID,P900_ID:''||',
'          :WS_APP_ID||'',''||home_page_id',
'  from WWV_FLOW_WS_APPLICATIONS',
' where SECURITY_GROUP_ID = :flow_security_group_id ',
'   and id = :WS_APP_ID '))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174635511046499211.4902)
,p_computation_sequence=>20
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_api.create_page(
 p_id=>2.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Grille de donn\00E9es')
,p_step_title=>unistr('Grille de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18847410435428482.4902)
,p_plug_name=>'Boutons droits de la barre d''outil'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20889528970815297.4902)
,p_plug_name=>'Hidden Region'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32890424941372009.4902)
,p_plug_name=>'Layout 1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'<table border="0" cellpadding="0" cellspacing="0" width="100%" ><tr><td valign="top">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32890625221372009.4902)
,p_plug_name=>'Layout 2'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td><td width="100%" valign="top" style="padding:0 0 0 15px;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32890824632372010.4902)
,p_plug_name=>'Layout 3'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td></tr></table>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78917510079639965.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155020820894822892.4902)
,p_plug_name=>'name'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(394039573177873943.4902)
,p_plug_name=>unistr('Grille de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DATA_GRID'
,p_attribute_01=>'P2_ID'
,p_attribute_02=>'P2_SHOW_CHECKBOX'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460549006734687548.4902)
,p_plug_name=>'Ajax Notification Holder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="ajaxMESSAGE" style="display:none;"><div id="theMESSAGE"></div>',
'<a href="javascript:void()" onclick="$x_Remove(''ajaxMESSAGE'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt=""/></a>',
'</div>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154946714578185788.4902)
,p_branch_action=>'f?p=&FLOW_ID.:2:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2631325119551194.4902)
,p_name=>'P2_SHOW_CHECKBOX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159405412148423457.4902)
,p_name=>'P2_SHOW_TOOLBAR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185166302121096890.4902)
,p_name=>'P2_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4902)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185166510779099358.4902)
,p_name=>'P2_WEBSHEET_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4902)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(161140617657065325.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'2'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5115909074633266.4902)
,p_computation_sequence=>20
,p_computation_item=>'RPT_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'null'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_worksheet_rpts',
'where worksheet_id = :P2_ID',
'and id = :RPT_ID'))
,p_compute_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(471737810971362548.4902)
,p_computation_sequence=>30
,p_computation_item=>'WORKSHEET_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_websheet_name(p_worksheet_id => :p2_id);'
,p_computation_error_message=>unistr('Impossible d''obtenir le nom de la grille de donn\00E9es.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5886702465031774.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Collection'
,p_process_sql_clob=>'wwv_flow_ws_api.save_checked(p_worksheet_id => :P2_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_api.create_page(
 p_id=>3.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Administration'
,p_step_title=>'Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456716416117062946.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457231706098432622.4902)
,p_plug_name=>'administration menu options'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(457230629124432618.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(138239722779443444.4902)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(457236625109516658.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3'
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_api.create_page(
 p_id=>4.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Supprimer une application'
,p_step_title=>'Supprimer une application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220816180174638)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(301529030296629019.4902)
,p_plug_name=>'Confirmer la suppression'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(487678607690660963)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Si vous supprimez une application, cette application et tous ses composants correspondants seront supprim\00E9s.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(301532105496629025.4902)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(301601412384641231.4902)
,p_plug_name=>'Toolbar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-bottom: 10px"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_footer=>'<div class="clear"></div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(318042708957711067.4902)
,p_plug_name=>'Impossible de supprimer l''application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_required_role=>'!'||wwv_flow_api.id(487678607690660963)
,p_plug_header=>unistr('<div class="wsErrorMessageSQL">Vous devez \00EAtre d\00E9veloppeur &PRODUCT_NAME. pour acc\00E9der \00E0 cette fonction.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(301529230900629020.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(301601412384641231.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(319787302199021438.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(301601412384641231.4902)
,p_button_name=>'BUILDER_LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Connexion au d\00E9veloppement')
,p_button_position=>'CREATE'
,p_security_scheme=>'!'||wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(301529418920629020.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(301601412384641231.4902)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer de mani\00E8re permanente maintenant')
,p_button_position=>'DELETE'
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(302848719197785179.4902)
,p_branch_action=>'f?p=4000:1500:&BUILDER_SESSION_ID.::NO:RP:P1500_SHOW:WEBSHEET'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_applications',
'where security_group_id = :flow_security_group_id'))
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301529629185629020.4902)
,p_name=>'P4_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4902)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Application s\00E9lectionn\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301530122954629023.4902)
,p_name=>'P4_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4902)
,p_prompt=>'Nom'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flow_ws_applications ',
' where id = :P4_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nom de l''application s\00E9lectionn\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301530606969629023.4902)
,p_name=>'P4_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4902)
,p_prompt=>'Pages'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :P4_ID',
'and a.id = p.ws_app_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Nombre de pages dans l''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301531114457629024.4902)
,p_name=>'P4_DATAGRIDS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4902)
,p_prompt=>unistr('Grilles de donn\00E9es')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
' from wwv_flow_worksheets w, ',
'       wwv_flow_ws_websheet_attr a',
' where w.id = a.worksheet_id and',
'       w.security_group_id = :flow_security_group_id and            ',
'       a.websheet_type = ''DATA'' and',
'       a.ws_app_id = :P4_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nombre de grilles de donn\00E9es dans l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301531601072629024.4902)
,p_name=>'P4_REPORTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4902)
,p_prompt=>'Etats'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
' from wwv_flow_worksheets w, ',
'       wwv_flow_ws_websheet_attr a',
' where w.id = a.worksheet_id and',
'       w.security_group_id = :flow_security_group_id and            ',
'       a.websheet_type = ''REPORT'' and',
'       a.ws_app_id = :P4_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nombre d''\00E9tats dans l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(317199623052582715.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete websheet application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_ws_app (',
'    p_ws_app_id   => :P4_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer l''application.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(301529418920629020.4902)
,p_process_success_message=>unistr('Application supprim\00E9e.')
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_api.create_page(
 p_id=>5.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier le mot de passe'
,p_step_title=>'Modifier le mot de passe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(506060600392166972)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(733375232512655603.4902)
,p_plug_name=>'Modifier le mot de passe'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_ws_applications ',
'where id = :WS_APP_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(733377515496655611.4902)
,p_plug_name=>'Toobar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(733377932388655611.4902)
,p_plug_name=>'Change Password'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(733377104075655609.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(733377515496655611.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(733377316895655611.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(733377515496655611.4902)
,p_button_name=>'RESET_PASSWORD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Modifier le mot de passe'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(733378822544655614.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(733375407229655605.4902)
,p_name=>'P5_CURRENT_PASSWORD'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4902)
,p_prompt=>'Saisir le mot de passe en cours'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez votre mot de passe en cours.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(733376401898655607.4902)
,p_name=>'P5_USERNAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom utilisateur'
,p_source=>'APP_USER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nom de l''utilisateur dont le mot de passe doit \00EAtre modifi\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(739791012792509692.4902)
,p_name=>'P5_NEW_PASSWORD'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4902)
,p_prompt=>'Saisir le nouveau mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Entrer le nouveau mot de passe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(739973506690517391.4902)
,p_name=>'P5_CONFIRM_PASSWORD'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4902)
,p_prompt=>'Confirmer le nouveau mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('R\00E9-entrer le nouveau mot de passe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740169510284527901.4902)
,p_validation_name=>'APP_USER not null'
,p_validation_sequence=>10
,p_validation=>'APP_USER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom utilisateur n''a pas \00E9t\00E9 d\00E9fini correctement. Fermez compl\00E8tement votre navigateur Web et r\00E9essayez de modifier votre mot de passe.')
,p_associated_item=>wwv_flow_api.id(733376401898655607.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740337923575541125.4902)
,p_validation_name=>'new passwd = confirm passwd'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P5_NEW_PASSWORD != :P5_CONFIRM_PASSWORD then',
'  :P5_NEW_PASSWORD := null;',
'  :P5_CONFIRM_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'La confirmation du mot de passe et le nouveau mot de passe ne sont pas identiques.'
,p_validation_condition=>':P5_NEW_PASSWORD is not null and :P5_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740556219204549371.4902)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_api.is_login_password_valid(',
'  p_username => :APP_USER,',
'  p_password => :P5_CURRENT_PASSWORD);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Mot de passe non valide'
,p_validation_condition=>'P5_CURRENT_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740770724529560332.4902)
,p_validation_name=>'strong password'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username              => :APP_USER,',
'      p_password              => :P5_NEW_PASSWORD,',
'      p_old_password          => :P5_CURRENT_PASSWORD,',
'      p_workspace_name        => wwv_flow_security.find_company_name(:flow_security_group_id));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>':P5_NEW_PASSWORD is not null and :P5_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(733378319666655613.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.g_fnd_user_password_action := true;',
'update wwv_flow_fnd_user ',
'  set web_password = :P5_NEW_PASSWORD',
'where security_group_id = :flow_security_group_id ',
'  and user_id = (select user_id ',
'                  from wwv_flow_fnd_user ',
'                 where security_group_id = :flow_security_group_id ',
'                   and user_name = :app_user);',
'wwv_flow_api.g_fnd_user_password_action := false;',
'',
':P5_NEW_PASSWORD := null;',
':P5_CONFIRM_PASSWORD := null;',
':P5_CURRENT_PASSWORD := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la modification du mot de passe.'
,p_process_when=>':P5_NEW_PASSWORD = :P5_CONFIRM_PASSWORD'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Mot de passe modifi\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741456721937597439.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'5'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_api.create_page(
 p_id=>6.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Contr\00F4le d''acc\00E8s')
,p_step_title=>unistr('Contr\00F4le d''acc\00E8s')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen">',
'	/* Hide left col */',
'	div.wsSideCol {',
'		 display: none !important;',
'	}',
'	div.wsMainCol {',
'		 padding: 5px;',
'	}',
'</style>'))
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619279823495072045.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619385132669714338.4902)
,p_plug_name=>unistr('Contr\00F4le d''acc\00E8s')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628484022950304722.4902)
,p_plug_name=>'intro text'
,p_parent_plug_id=>wwv_flow_api.id(619385132669714338.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<p>''||wwv_flow_lang.system_message(''ACL_TABLE.INTRO_TEXT'')||''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628484309576310290.4902)
,p_plug_name=>'acl table'
,p_parent_plug_id=>wwv_flow_api.id(619385132669714338.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(wwv_flow_ws_api.get_acl_table);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(619280212586072050.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Window'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_api.create_page(
 p_id=>9.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Feuilles Web non prises en charge'
,p_alias=>'WEBSHEET-NOT-SUPPORTED'
,p_step_title=>'Feuilles Web non prises en charge'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(607707103506483809.4902)
,p_plug_name=>'Feuilles Web non prises en charge'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(931543191007401308.4902)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Les feuilles Web ne sont plus prises en charge dans cette version de &PRODUCT_NAME.. Contactez l''administrateur.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_api.create_page(
 p_id=>11.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Contr\00F4le d''acc\00E8s')
,p_step_title=>unistr('Contr\00F4le d''acc\00E8s')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451311515410376846.4902)
,p_plug_name=>'Access Control List Entries'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select n001 id,',
'       c001 username,',
'       c002 priv,',
'       wwv_flow_lang.system_message(''EDIT_LINK_TEXT'', c001) link_text',
'from wwv_flow_collections',
'where collection_name = ''APEX$_ACL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(451311719920376851.4902)
,p_name=>'Change History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune entr\00E9e dans la liste de contr\00F4le d''acc\00E8s (ACL).')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451333131265977320.4902)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>' '
,p_column_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:13:P13_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="#LINK_TEXT#">'
,p_column_link_attr=>'Edit'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451314505039414398.4902)
,p_db_column_name=>'USERNAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Nom utilisateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451314610985414398.4902)
,p_db_column_name=>'PRIV'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>unistr('Privil\00E8ge')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(451333930142995878)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247045499759377619.4902)
,p_db_column_name=>'LINK_TEXT'
,p_display_order=>14
,p_column_identifier=>'E'
,p_column_label=>'Texte de lien'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451312628829376856.4902)
,p_plug_name=>'Manage Access Control List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458561726210213950.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Si l''application utilise l''autorisation personnalis\00E9e, cette liste de contr\00F4le d''acc\00E8s g\00E8re les privil\00E8ges des utilisateurs de cette application.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458945107668445108.4902)
,p_plug_name=>unistr('Mod\00E8le d''authentification')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_auth_type varchar2(255);',
'begin',
'  l_auth_type := wwv_flow_item.text_from_lov(wwv_flow_ws_security.ws_auth_type(:WS_APP_ID),''WEBSHEET AUTHENTICATION'');',
'',
'  sys.htp.prn(''<p>''||',
'      wwv_flow_lang.system_message(''F4900_P11_AUTH_TYPE_MESSAGE'',l_auth_type)||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466701412926181295.4902)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(466702532319186899.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(466701412926181295.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:11,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451340528822175261.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(451311515410376846.4902)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>unistr('Cr\00E9er une entr\00E9e >')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:13::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451313319291376861.4902)
,p_branch_action=>'f?p=&FLOW_ID.:11:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451313108133376860.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create ACL collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_acl_collection (',
'    p_ws_app_id => :WS_APP_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection ACL.')
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_api.create_page(
 p_id=>12.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Code SQL sugg\00E9r\00E9')
,p_step_title=>unistr('Code SQL sugg\00E9r\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488396212380125306.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Le code SQL peut \00EAtre utilis\00E9 dans les \00E9tats et les balises SQL. Voici une liste d''outils sugg\00E9r\00E9s qui peuvent \00EAtre utiles pour votre application. S\00E9lectionnez un objet et l''instruction SQL SELECT appropri\00E9e appara\00EEtra, pr\00EAte \00E0 l''emploi.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488403717840125334.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488408215444168022.4902)
,p_plug_name=>unistr('Objets sugg\00E9r\00E9s')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>15
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name,',
'       object_comment',
'  from wwv_flow_ws_app_sug_objects',
' where ws_app_id = :WS_APP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(488408303926168022.4902)
,p_name=>'Available Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(488408529626168027.4902)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom d''objet'
,p_column_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12:P12_TABLE_NAME:#OBJECT_NAME#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492616214470258718.4902)
,p_db_column_name=>'OBJECT_COMMENT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Commentaire'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488409211280188810.4902)
,p_plug_name=>'&P12_TABLE_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4902)
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare q varchar2(32767);',
'begin',
'q := ''select'';',
'for c1 in (',
'select column_name',
'  from sys.dba_tab_columns',
' where table_name = :P12_TABLE_NAME and',
'       owner = wwv_flow_security.g_apex$_schema',
' order by column_id) loop',
'q := q||''<br />'';',
'q := q||''&nbsp;&nbsp;&nbsp;&nbsp;''||wwv_flow_escape.html(c1.column_name)||'','';',
'end loop;',
'q := rtrim(q,'','')||''<br />from ''||wwv_flow_escape.html(:P12_TABLE_NAME);',
'sys.htp.p(q);',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P12_TABLE_NAME'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488415531993365037.4902)
,p_plug_name=>'Exemples'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>35
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[[SQL: select ename "Employee Name", sal "Salary" from emp order by sal desc | limit=10]]',
'[[SQLVALUE: select count(*)  from emp ]]',
'</pre>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491315127198795285.4902)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488411205618253386.4902)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(488408215444168022.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488409426171193110.4902)
,p_name=>'P12_TABLE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(488396212380125306.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_api.create_page(
 p_id=>13.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er/modifier une entr\00E9e de liste de contr\00F4le d''acc\00E8s (ACL)')
,p_step_title=>unistr('Cr\00E9er/modifier une entr\00E9e de liste de contr\00F4le d''acc\00E8s (ACL)')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22693023416256513.4902)
,p_plug_name=>'Top Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22695808618308969.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451316114910485987.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451316527354493693.4902)
,p_plug_name=>unistr('Entr\00E9e')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455753022786260831.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si l''application utilise l''autorisation personnalis\00E9e, la liste de contr\00F4le d''acc\00E8s g\00E8re les privil\00E8ges des utilisateurs de cette application.</p>'),
'',
'<ul>',
'<li><b>Lecteur</b> : peut visualiser le contenu mais pas le modifier</li>',
'<li><b>Contributeur</b> : peut visualiser et modifier le contenu</li>',
unistr('<li><b>Administrateur</b> : peut visualiser et modifier le contenu, et peut \00E9galement modifier les propri\00E9t\00E9s d''application et g\00E9rer la liste de contr\00F4le d''acc\00E8s (ACL)</li>'),
'</ul>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451317504937543969.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451317707492554199.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er')
,p_button_position=>'CREATE'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488046828362984858.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4902)
,p_button_name=>'CREATE_AND_CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>unistr('Cr\00E9er et cr\00E9er un autre')
,p_button_position=>'CREATE'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451326723076908671.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE2'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451334810665009173.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(488047325507002977.4902)
,p_branch_action=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:13::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(488046828362984858.4902)
,p_branch_sequence=>2
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451317931226554200.4902)
,p_branch_action=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451316709130497825.4902)
,p_name=>'P13_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22695808618308969.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451316912509517726.4902)
,p_name=>'P13_USERNAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(451316527354493693.4902)
,p_prompt=>'Nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indiquez le nom utilisateur dont vous souhaitez contr\00F4ler l''acc\00E8s.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451317328917531994.4902)
,p_name=>'P13_PRIV'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(451316527354493693.4902)
,p_item_default=>'R'
,p_prompt=>unistr('Privil\00E8ge')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_ACL_PRIVS'
,p_lov=>'.'||wwv_flow_api.id(451333930142995878.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifiez le niveau de privil\00E8ge de l''utilisateur. Si l''application emploie l''autorisation personnalis\00E9e, la liste de contr\00F4le d''acc\00E8s g\00E8re les privil\00E8ges des utilisateurs de cette application.</p>'),
'',
'<ul>',
'<li><strong>Lecteur</strong> : peut visualiser le contenu mais pas le modifier</li>',
'<li><strong>Contributeur</strong> : peut visualiser et modifier le contenu</li>',
unistr('<li><strong>Administrateur</strong> : peut visualiser et modifier le contenu et peut \00E9galement modifier les propri\00E9t\00E9s d''application et g\00E9rer la liste de contr\00F4le d''acc\00E8s (ACL)</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(22573104501037740.4902)
,p_computation_sequence=>10
,p_computation_item=>'P13_USERNAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:P13_USERNAME)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(456322608585423890.4902)
,p_validation_name=>'Cannot Delete or lesser privilege yourself'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001',
'             from wwv_flow_collections',
'            where collection_name = ''APEX$_ACL''',
'              and n001 = :P13_ID ) loop',
'  if :REQUEST = ''DELETE'' and c1.c001 = upper(:APP_USER) then',
'    return false;',
'  elsif :REQUEST = ''APPLY_CHANGES'' and c1.c001 = upper(:APP_USER) and :P13_PRIV != ''A'' then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Vous ne pouvez pas vous enlever vous-m\00EAme en tant qu''administrateur.')
,p_validation_condition=>':REQUEST in (''DELETE'',''APPLY_CHANGES'') and wwv_flow_ws_security.ws_acl_type(:WS_APP_ID) = ''CUSTOM'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(451316912509517726.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(799469025785845096.4902)
,p_validation_name=>'P13_USERNAME already exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''APEX$_ACL''',
'   and c001 = upper(:P13_USERNAME)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('L''utilisateur existe d\00E9j\00E0 dans la liste de contr\00F4le d''acc\00E8s.')
,p_validation_condition=>'CREATE,CREATE_AND_CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(451316912509517726.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(819882220390557560.4902)
,p_validation_name=>'P13_USERNAME not null'
,p_validation_sequence=>30
,p_validation=>'P13_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom utilisateur doit \00EAtre indiqu\00E9.')
,p_validation_condition=>'CREATE,CREATE_AND_CREATE_ANOTHER,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(451316912509517726.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451339402456139272.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add/update ACL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_acl_entry(',
'    p_ws_app_id  => :WS_APP_ID,',
'    p_acl_id          => :P13_ID,',
'    p_username   => :P13_USERNAME,',
'    p_priv             => :P13_PRIV );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la cr\00E9ation de l''entr\00E9e de liste de contr\00F4le d''acc\00E8s (ACL).')
,p_process_when=>'CREATE,APPLY_CHANGES,CREATE_AND_CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Entr\00E9e de liste de contr\00F4le d''acc\00E8s (ACL) cr\00E9\00E9e ou modifi\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(833790620596523418.4902)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create ACL collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_acl_collection (',
'    p_ws_app_id => :WS_APP_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection ACL.')
,p_process_when_button_id=>wwv_flow_api.id(488046828362984858.4902)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451340317956162700.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete acl entry'
,p_process_sql_clob=>'wwv_flow_ws_api.delete_acl_entry(:P13_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la suppression de l''entr\00E9e de liste de contr\00F4le d''acc\00E8s (ACL).')
,p_process_when_button_id=>wwv_flow_api.id(451334810665009173.4902)
,p_process_success_message=>unistr('Entr\00E9e de liste de contr\00F4le d''acc\00E8s (ACL) supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451338731714109921.4902)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 username, c002 priv',
'             from wwv_flow_collections',
'            where collection_name = ''APEX$_ACL''',
'              and n001 = :P13_ID ) loop',
'    :P13_USERNAME := c1.username;',
'    :P13_PRIV := c1.priv;',
'    exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P13_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_api.create_page(
 p_id=>14.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Visualiser l''historique des modifications'
,p_step_title=>'Visualiser l''historique des modifications'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2669725667029212.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29080824628705464.4902)
,p_plug_name=>'Visualiser l''historique des modifications'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 row_key,',
'       c002 column_name,',
'       c003 old_value,',
'       c004 new_value,',
'       c005 application_user_id,',
'       d001 date_of_change,',
'       c006 history_rowid',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_HISTORY'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(29080913600705464.4902)
,p_name=>'Change History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_base_pk1=>'ROW_KEY'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_rows_per_page=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#ws/small_page.gif" alt="&VIEW." />'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1524146599951611412.4902)
,p_db_column_name=>'ROW_KEY'
,p_display_order=>10
,p_column_identifier=>'G'
,p_column_label=>unistr('Cl\00E9 de ligne')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081219740705468.4902)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Nom de colonne'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081302162705468.4902)
,p_db_column_name=>'OLD_VALUE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Ancienne valeur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081429809705469.4902)
,p_db_column_name=>'NEW_VALUE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Nouvelle valeur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081503189705469.4902)
,p_db_column_name=>'APPLICATION_USER_ID'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'ID utilisateur d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29085729935792011.4902)
,p_db_column_name=>'DATE_OF_CHANGE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>unistr('Modifi\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(246124596661890750.4902)
,p_db_column_name=>'HISTORY_ROWID'
,p_display_order=>70
,p_column_identifier=>'I'
,p_column_label=>'ID de ligne d''historique'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(906866216721570277.4902)
,p_plug_name=>'Boutons droits de la barre d''outil'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(907020707979586718.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(29080824628705464.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2647813413278526.4902)
,p_branch_action=>'f?p=&FLOW_ID.:14:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29080030787678754.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create history collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_history_collection (',
'    p_worksheet_id => :p2_id,',
'    p_websheet_id  => :p2_websheet_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection d''historiques.')
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_api.create_page(
 p_id=>15.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Aper\00E7u')
,p_step_title=>unistr('Aper\00E7u')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455867416484229688.4902)
,p_plug_name=>'Applications Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Gr\00E2ce aux applications de feuille Web, les utilisateurs finals peuvent g\00E9rer les donn\00E9es structur\00E9es et non structur\00E9es, sans l''aide d''un d\00E9veloppeur. Ils peuvent ainsi effectuer les op\00E9rations suivantes :</p> '),
'',
'<ul>',
unistr('<li>Cr\00E9er et partager du contenu sur Internet \00E0 l''aide d''un simple navigateur Web.</li>'),
unistr('<li>Organiser des pages Web selon une hi\00E9rarchie et cr\00E9er des liens entre elles (\00E0 l''aide de la syntaxe [[ pagename ]]).</li>'),
unistr('<li>Cr\00E9er et g\00E9rer des donn\00E9es tabulaires \00E0 l''aide de la fonctionnalit\00E9 imbriqu\00E9e appel\00E9e Grilles de donn\00E9es.</li>'),
unistr('<li>Cr\00E9er des \00E9tats interactifs via SQL sur des structures de donn\00E9es existantes dans la base de donn\00E9es.</li>'),
unistr('<li>Pr\00E9senter les grilles de donn\00E9es et les donn\00E9es d''\00E9tat dans des pages sous forme de graphiques ou d''\00E9tats.</li>'),
unistr('<li>Annoter les pages avec des fichiers, des balises et des remarques. Les images associ\00E9es peuvent \00EAtre incluses dans la page (\00E0 l''aide de la syntaxe [[image: filename]]).</li>'),
unistr('<li>Effectuer une recherche dans une page (\00E0 l''aide de la fonction de recherche int\00E9gr\00E9e).</li>'),
unistr('<li>D\00E9terminer les utilisateurs autoris\00E9s \00E0 se connecter et ceux qui peuvent lire, \00E9crire ou administrer l''application (authentification et autorisation).</li>'),
'</ul> '))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455869309520274904.4902)
,p_plug_name=>'Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le contenu des pages est organis\00E9 en sections. Les types de section pris en charge par les fiches Web sont les suivants :</p>'),
'<ul>',
unistr('<li>Texte : affiche le texte saisi. Celui-ci peut comprendre des images et des \00E9tats inclus, ainsi que des liens vers des \00E9tats, des grilles de donn\00E9es, d''autres pages, des fichiers, des URL externes, etc. Les sections de texte sont g\00E9r\00E9es \00E0 l''aide d')
||unistr('''un \00E9diteur WYSIWIG. </li>'),
unistr('<li>Navigation : ajoute la navigation g\00E9n\00E9r\00E9e de fa\00E7on dynamique vers des pages ou des sections de page subordonn\00E9es.</li>'),
unistr('<li>Donn\00E9es : cr\00E9e un \00E9tat ins\00E9r\00E9 bas\00E9 sur une grille de donn\00E9es ou un \00E9tat.</li>'),
unistr('<li>Graphique : cr\00E9e un graphique ins\00E9r\00E9 bas\00E9 sur une grille de donn\00E9es ou un \00E9tat.</li>'),
'</ul>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455869514368276321.4902)
,p_plug_name=>'Annotations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dans les pages ou les lignes d''une grille de donn\00E9es, vous pouvez inclure les annotations suivantes :</p>'),
'<ul>',
unistr('<li>Fichiers : fichiers de t\00E9l\00E9chargement \00E0 t\00E9l\00E9charger en local ou \00E0 afficher sous forme d''images incluses dans le texte de section</li>'),
'<li>Remarques : remarques propres au contenu',
unistr('<li>Balises : balises ajout\00E9es pour am\00E9liorer la fonction de recherche int\00E9gr\00E9e'),
'</ul>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455869719909277967.4902)
,p_plug_name=>unistr('Contr\00F4le d''acc\00E8s')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les administrateurs contr\00F4lent les utilisateurs autoris\00E9s \00E0 se connecter \00E0 une application Web en sp\00E9cifiant l''une des m\00E9thodes d''authentification suivantes :</p>'),
'<ul>',
unistr('<li>Acc\00E8s public (aucune authentification)</li>'),
'<li>Comptes Oracle Application Express</li>',
'<li>Oracle Single Sign-On</li>',
unistr('<li>V\00E9rification des informations d''identification LDAP</li>'),
unistr('<li>Personnalis\00E9'),
'</ul>',
'',
unistr('<p>Une fois connect\00E9 \00E0 l''application, l''utilisateur a acc\00E8s aux diff\00E9rents \00E9l\00E9ments en fonction du r\00F4le qui lui a \00E9t\00E9 attribu\00E9. Les r\00F4les pris en charge sont les suivants :</p>'),
'<ul>',
'<li>Administrateur</li>',
'<li>Contributeur</li>',
'<li>Lecteur</li>',
'</ul>',
'',
'',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455870812899294887.4902)
,p_plug_name=>unistr('Grilles de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les grilles de donn\00E9es sont des ensembles de donn\00E9es tabulaires d\00E9finis par un contributeur. Il s''agit en somme d''une feuille de calcul Web. Vous pouvez d\00E9finir la structure d''une grille de donn\00E9es (noms des colonnes, types de donn\00E9es et validatio')
||unistr('ns de base) ou cr\00E9er une grille de donn\00E9es en copiant et collant les donn\00E9es d''une feuille de calcul. Une fois cr\00E9\00E9e, la structure peut \00EAtre modifi\00E9e \00E0 tout moment.</p>'),
'',
unistr('<p>En plus des colonnes d\00E9finies par l''utilisateur, un ensemble de colonnes standard est toujours inclus dans chaque grille de donn\00E9es. Il s''agit notamment des colonnes Propri\00E9taire, Cr\00E9\00E9 par, Cr\00E9\00E9 le, Mis \00E0 jour par, Mis \00E0 jour le, Tri des lignes et')
||' Annotation (fichiers, remarques, liens et balises).</p>',
'',
unistr('<p>Les grilles de donn\00E9es sont des \00E9tats modifiables dont la plupart des \00E9l\00E9ments peuvent \00EAtre personnalis\00E9s. Les utilisateurs peuvent ainsi modifier la mise en page des donn\00E9es de l''\00E9tat en choisissant les colonnes pertinentes, en appliquant des fil')
||unistr('tres et en s\00E9lectionnant des r\00E8gles de mise en \00E9vidence et de tri. Ils peuvent \00E9galement d\00E9finir des sections, des agr\00E9gations, des regroupements, des calculs et des graphiques. De plus, ils peuvent cr\00E9er plusieurs variantes pour une grille de donn\00E9e')
||unistr('s et les enregistrer en tant qu''\00E9tats nomm\00E9s, \00E0 des fins de visualisation publique ou priv\00E9e</p>'),
'',
unistr('<p>En plus d''\00EAtre disponibles dans le menu Visualiser, les donn\00E9es d''une grille peuvent \00EAtre incluses dans n''importe quelle page sous forme de graphique ou d''\00E9tat.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455871123288297886.4902)
,p_plug_name=>'Etats'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les \00E9tats repr\00E9sentent les requ\00EAtes d''objets de base de donn\00E9es auxquels vous avez acc\00E8s. Pour d\00E9finir un \00E9tat, vous pouvez soit tout simplement s\00E9lectionner une table ou une vue dans un sch\00E9ma disponible, soit cr\00E9er un objet plus complexe \00E0 l''aid')
||'e d''une instruction SQL standard.</p>',
'',
unistr('<p>Tout comme les grilles de donn\00E9es, les \00E9tats peuvent \00EAtre personnalis\00E9s. Les utilisateurs peuvent ainsi modifier la mise en page des donn\00E9es de l''\00E9tat en choisissant les colonnes pertinentes, en appliquant des filtres et en s\00E9lectionnant des r\00E8gle')
||unistr('s de mise en \00E9vidence et de tri. Ils peuvent \00E9galement d\00E9finir des sections, des agr\00E9gations, des regroupements, des calculs et des graphiques diff\00E9rents. Un abonnement peut en outre \00EAtre configur\00E9 pour envoyer l''\00E9tat par courriel \00E0 un intervalle don')
||unistr('n\00E9. Les utilisateurs peuvent cr\00E9er diff\00E9rentes versions d''un \00E9tat et les enregistrer en tant qu''\00E9tats nomm\00E9s, pour une utilisation publique ou priv\00E9e.</p>'),
'',
unistr('<p>En plus d''\00EAtre disponibles sous l''onglet Donn\00E9es, les donn\00E9es d''un \00E9tat peuvent \00EAtre incluses dans n''importe quelle page sous forme de graphique ou d''\00E9tat.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466849110862832553.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468686130956258389.4902)
,p_plug_name=>'anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_list_template_id=>wwv_flow_api.id(171596314926127907.4902)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_api.create_page(
 p_id=>16.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'A propos de cette application'
,p_step_title=>'A propos de cette application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen">',
'	/* Hide left col */',
'	div.wsSideCol {',
'		 display: none !important;',
'	}',
'	div.wsMainCol {',
'		 padding: 5px;',
'	}',
'</style>'))
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472804823833588483.4902)
,p_plug_name=>'A propos de cette application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472809806454619957.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472810527578626072.4902)
,p_name=>'P16_APPLICATION_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Nom d''application'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le nom de cette application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472817823619814197.4902)
,p_name=>'P16_CREATED_BY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>unistr('Cr\00E9ation par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie le cr\00E9ateur de l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472818029160815789.4902)
,p_name=>'P16_CREATED_ON'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>unistr('Cr\00E9\00E9')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la date de cr\00E9ation de l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472818901717826724.4902)
,p_name=>'P16_RUN_LINK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>unistr('Ex\00E9cuter le lien')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie l''URL utilis\00E9e pour ex\00E9cuter cette application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472819621719851449.4902)
,p_name=>'P16_WEB_PAGES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Pages'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le nombre de pages de cette application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472823322804880132.4902)
,p_name=>'P16_DATA_GRIDS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>unistr('Grilles de donn\00E9es')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie le nombre de grilles de donn\00E9es de cette application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472824025144899716.4902)
,p_name=>'P16_REPORTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Etats'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_help_text=>unistr('Identifie le nombre d''\00E9tats de cette application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472827429534042915.4902)
,p_name=>'P16_FILES'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Fichiers'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le nombre de fichiers de cette application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472829909495065498.4902)
,p_name=>'P16_FILE_STORAGE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Stockage de fichier'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie la taille totale de tous les fichiers de cette application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472835720408106552.4902)
,p_name=>'P16_PAGE_SECTIONS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Sections de page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie le nombre d''\00E9tats de cette application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472849515269209062.4902)
,p_name=>'P16_NOTES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Remarques'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le nombre de remarques de cette application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472849720118210471.4902)
,p_name=>'P16_TAGS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Balises'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le nombre de balises de cette application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472850124966211939.4902)
,p_name=>'P16_DATAGRID_ROWS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>unistr('Lignes de grille de donn\00E9es')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie le nombre de lignes de toutes les grilles de donn\00E9es contenues dans cette application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484478622627455477.4902)
,p_name=>'P16_DESCRIPTION'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4902)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P16_DESCRIPTION'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Description de l''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472810926324635162.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set item values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select name, created_by, created_on, id, description',
'    from WWV_FLOW_WS_APPLICATIONS ',
'    where id = :WS_APP_ID and security_group_id = :flow_security_group_id) loop',
'  :P16_APPLICATION_NAME := c1.name;',
'  :P16_CREATED_BY := c1.created_by;',
'  :P16_CREATED_ON := htmldb_util.get_since(c1.created_on);',
'  :P16_RUN_LINK := wwv_flow_utilities.host_url(''SCRIPT'')||''ws?p=''||c1.id||'':home'';',
'  :P16_DESCRIPTION := c1.description;',
'   for c2 in (select count(*) c from WWV_FLOW_WS_WEBPAGES where ws_app_id = c1.id) loop',
'      :P16_WEB_PAGES := to_char(c2.c,''999G999G999G990'');',
'   end loop;',
'   for c2 in (',
'     select count(*) c',
'     from wwv_flow_worksheets w, ',
'             wwv_flow_ws_websheet_attr a',
'     where w.id = a.worksheet_id and',
'         w.security_group_id = :flow_security_group_id and                  ',
'         a.ws_app_id = :ws_app_id and',
'         nvl(a.websheet_type,''DATA'') = ''DATA'') loop',
'    :P16_DATA_GRIDS := to_char(c2.c,''999G999G999G990'');',
'    end loop;',
'    for c2 in (',
'       select count(*) c',
'       from wwv_flow_worksheets w, ',
'              wwv_flow_ws_websheet_attr a',
'       where w.id = a.worksheet_id and',
'                w.security_group_id = :flow_security_group_id and                  ',
'               a.ws_app_id = :ws_app_id and',
'               nvl(a.websheet_type,''DATA'') = ''REPORT'') loop',
'         :P16_REPORTS := c2.c;',
'     end loop;',
'     :P16_files := trim(to_char(wwv_flow_ws_api.get_file_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_FILE_STORAGE :=trim(htmldb_util.filesize_mask(wwv_flow_ws_api.get_file_size(p_ws_app_id=>:WS_APP_ID)));',
'     :P16_PAGE_SECTIONS := trim(to_char(wwv_flow_ws_api.get_section_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_TAGS := trim(to_char(wwv_flow_ws_api.get_tag_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_NOTES := trim(to_char(wwv_flow_ws_api.get_note_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_DATAGRID_ROWS := trim(to_char(wwv_flow_ws_api.get_datagrid_row_count(',
'         p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_api.create_page(
 p_id=>17.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Syntaxe de balisage'
,p_step_title=>'Syntaxe de balisage'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456375908174931142.4902)
,p_plug_name=>'URL externes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez inclure des liens vers des URL externes dans les sections de page \00E0 l''aide de la syntaxe ci-dessous. L''identificateur <code>''url:''</code> est facultatif. Pour que le lien s''ouvre dans une nouvelle fen\00EAtre de navigateur, ins\00E9rez le pr\00E9f')
||'ixe popup.</p>',
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ url: &lt;url> | &lt;link name> ]]',
'[[ popupurl: &lt;url> | &lt;link name> ]]',
'[[ &lt;url> | &lt;link name> ]]',
'</pre>',
'',
'<p><b>Exemples de syntaxe :</b></p>',
'<pre>',
'[[url: http://www.oracle.com/store | oraclestore]] ',
'[[popupurl: http://www.oracle.com/store | oraclestore]]',
'[[http://www.example.com | example]] ',
'[[http://www.example.com ]] ',
'</pre>',
'',
'<p><b>Exemple en contexte :</b></p>',
'<pre>',
'Vous pouvez acheter le logiciel Oracle sur le site Web [[http://www.oracle.com/store | Oracle Store]].',
'</pre>',
'',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456378202762952007.4902)
,p_plug_name=>'Images'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Une fois que vous avez t\00E9l\00E9charg\00E9 une image, vous pouvez l''afficher dans n''importe quelle section de page d''une application en imbriquant un lien de t\00E9l\00E9chargement \00E0 l''aide de la syntaxe ci-dessous. Vous pouvez r\00E9f\00E9rencer une image t\00E9l\00E9charg\00E9e en ')
||unistr('utilisant le nom ou l''alias de l''image. Les images d\00E9finies pour la page en cours sont utilis\00E9es avant les images associ\00E9es \00E0 d''autres pages. Si les noms d''image sont ambigus, l''image cr\00E9\00E9e le plus r\00E9cemment sera affich\00E9e. Les propri\00E9t\00E9s d''image peuv')
||unistr('ent \00EAtre d\00E9finies pour le fichier ou d\00E9finies comme \00E9tant incorpor\00E9es. Si vous d\00E9finissez des attributs incorpor\00E9s, ces derniers sont prioritaires sur ceux d\00E9finis pour le fichier.</p>'),
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ image: &lt; file name > | &lt; properties > ]]',
'[[ image: &lt; file alias > | &lt; properties > ]]',
'</pre>',
'',
'<p><b>Exemples de syntaxe :</b></p>',
'<pre>',
'[[image: myimage ]]',
'[[image: theimagename.jpg ]]',
'[[image: myimage | width="600" alt="my image" ]]',
'</pre>',
'',
'<p><b>Exemple en contexte :</b></p>',
'<pre>',
'Le diagramme [[image: diagram1]] illustre le workflow.',
'</pre>',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456378508650953757.4902)
,p_plug_name=>'Lien vers une page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dans des sections de page, vous pouvez fournir des liens vers d''autres pages d''une feuille Web \00E0 l''aide de la syntaxe ci-dessous. L''identificateur <code>''page:''</code> est facultatif. Si la page existe, un lien sera affich\00E9, et si elle n''existe pa')
||unistr('s, un lien permettant de cr\00E9er la page appara\00EEtra.</p>'),
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ page: &lt;page alias> | &lt;link name> ]]',
'[[ &lt;page alias> | &lt;link name> ]]',
'</pre>',
'',
'<p><b>Exemples de syntaxe :</b></p>',
'<pre>',
'[[page: home]] ',
'[[mypage | My Page]] ',
'</pre>',
'',
'<p><b>Exemple en contexte :</b></p>',
'<pre>',
unistr('Un des poissons les plus color\00E9s est le [[ clownfish | Clown fish]].'),
'</pre>',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456378714883955473.4902)
,p_plug_name=>unistr('Liaison de grille de donn\00E9es')
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour inclure des liens vers les grilles de donn\00E9es dans les sections de page, utilisez la syntaxe ci-dessous. Ces liens peuvent \00EAtre utilis\00E9s pour visualiser la grille de donn\00E9es ou cr\00E9er des donn\00E9es. Vous pouvez \00E9crire datagrid (grille de donn\00E9es')
||') en un ou deux mots.</p>',
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ data grid: &lt;datagrid alias> | &lt;link name> ]] ',
'[[ datagrid: &lt;datagrid alias> | &lt;link name> ]]',
'[[ datagrid: &lt;datagrid alia> . &lt;saved report name (may not be private)> | &lt;link name> ]]',
'</pre>',
'',
'<p><b>Exemples de syntaxe :</b></p>',
'<pre>',
'[[ data grid: todo list | To Do List ]] ',
'[[ datagrid: todo list | To Do List ]] ',
'[[ data grid: todo list . open todo items | To Do List ]] ',
'</pre>',
'',
'<p><b>Exemple en contexte :</b></p>',
'<pre>',
unistr('V\00E9rifiez la [[ data grid: todo list | To Do List ]] et veillez \00E0 ce que'),
unistr('vos t\00E2ches puissent \00EAtre effectu\00E9es d''ici vendredi.'),
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456463415491324659.4902)
,p_plug_name=>'Liaison de section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez cr\00E9er un lien vers une section de page \00E0 l''aide de la syntaxe ci-dessous. Si la section existe, un lien sera affich\00E9, et si elle n''existe pas, un lien permettant de la cr\00E9er appara\00EEtra. Si la section n''est pas pr\00E9c\00E9d\00E9e d''une page, elle')
||unistr(' est cens\00E9e se trouver sur la page en cours.</p>'),
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ section: &lt;page alias> . &lt;page section> | &lt;link name> ]]',
'[[ section: &lt;page section> | &lt;link name> ]]',
'</pre>',
'',
unistr('<p><b>Exemple de syntaxe cr\00E9ant un lien dans la page en cours :</b></p>'),
'<pre>',
'[[section: clownfish | Clown Fish]] ',
'</pre>',
'',
unistr('<p><b>Exemple de syntaxe cr\00E9ant un lien vers une page diff\00E9rente :</b></p>'),
'<pre>',
'[[section: fish.clownfish | Clown Fish]] ',
'</pre>',
'',
'<p><b>Exemples en contexte :</b></p>',
'<pre>',
unistr('Un des poissons les plus color\00E9s est le poisson clown [[ section: clownfish | Clown fish]].'),
unistr('Visitez notre page sur les poissons pour voir le poisson clown [[ section: fish . clownfish | Clown fish]], \00E9galement appel\00E9 N\00E9mo.'),
'</pre>',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456475006515549140.4902)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_list_template_id=>wwv_flow_api.id(171596314926127907.4902)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456475623830554083.4902)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506319619645513438.4902)
,p_plug_name=>'SQL Introduction'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La syntaxe <code>SQL</code> ou <code>SQLVALUE</code> vous permet d''inclure la valeur unique et les r\00E9sultats tabulaires des requ\00EAtes de grilles de donn\00E9es ou de tables et des vues dans les sections d''une page. La balise <code>SQLVALUE</code> affic')
||unistr('he la premi\00E8re colonne de la premi\00E8re ligne renvoy\00E9e par la requ\00EAte SQL. Cela permet d''imbriquer des donn\00E9es dans une phrase (par exemple : Il existe actuellement 5 types de chat.). Pour les r\00E9sultats tabulaires, utilisez la balise <code>SQL</code>. ')
||unistr('Les r\00E9sultats de la balise <code>SQL</code> apparaissent dans un \00E9tat pouvant faire l''objet d''une recherche, mais l''option de recherche peut \00EAtre d\00E9sactiv\00E9e par d\00E9faut via la syntaxe <code>NOSEARCH</code>.</p>'),
'',
unistr('<p>Lorsque vous utilisez les grilles de donn\00E9es, des options suppl\00E9mentaires sont disponibles sous Syntaxe et d''autres r\00E8gles existent \00E9galement. Les r\00E8gles de base lors de l''\00E9criture d''une grille de donn\00E9es sont les suivantes :</p>'),
'<p>',
'<ul>',
unistr('<li>Le nom ou l''alias de grille de donn\00E9es doit \00EAtre d\00E9limit\00E9 par des accolades. Par exemple :'),
'<pre>{Cat Facts}</pre></li>',
unistr('<li>Les noms de colonne de grille de donn\00E9es doivent \00EAtre d\00E9limit\00E9s par des guillemets. Par exemple :'),
'<pre>"Type of Cat"</pre></li>',
'</ul>',
unistr('Les r\00E8gles avanc\00E9es sont d\00E9crites en d\00E9tail dans la derni\00E8re section.'),
'</p>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506320009733520103.4902)
,p_plug_name=>'SQL Syntax'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><b>Syntaxe des requ\00EAtes de table et des vue :</b></p>'),
'<pre>',
'[[sql: &lt;select statement> ]]',
'[[sql: &lt;select statement | limit="&lt;maximum rows>" nosearch style="&lt;style number>" ]]',
'[[sqlvalue: &lt;select statement> ]]',
'</pre>',
'',
unistr('<p><b>Syntaxe des requ\00EAtes de grille de donn\00E9es :</b></p>'),
'<pre>',
'[[sql: &lt;select statement> ]]',
'[[sql: &lt;select statement | limit="&lt;maximum rows>" nosearch style="&lt;style number>" edit_row add_row show_sql ]]',
'[[sqlvalue: &lt;select statement> ]]',
'[[sqlvalue: &lt;select statement> | show_sql ]]',
'</pre>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506320222200523729.4902)
,p_plug_name=>'SQL Examples'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Exemples de syntaxe de balise SQL en contexte :</b></p>',
'<pre>',
unistr('Voici un \00E9tat de 10 employ\00E9s au maximum qui travaillent dans le service 10 : '),
'[[sql: select ename "Employee Name", sal "Salary" from emp order by sal desc | limit="10" style="2"]].',
'[[sql: select "Type of Cat",',
'              "Estimated Population",',
'              "Largest Threats",',
'              "Top Speed",',
'              "Scientific Name",',
'              "IUCN Status",',
'              "Weight",',
'              "Study Date"',
'       from {Cat Facts} | add_row edit_row ]]',
'</pre>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506321126618543925.4902)
,p_plug_name=>'SQLVALUE Tag Example'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Exemples de syntaxe de balise SQLVALUE en contexte :</b></p>',
'<pre>',
unistr('Nous avons [[sqlvalue: select count(*) from emp]] employ\00E9s dans notre base de donn\00E9es, '),
'[[sqlvalue: select count(*) from emp where deptno=10 ]] travaillent dans le service 10.',
'Nous suivons actuellement [[sqlvalue: select count(*) from {Cat Facts} ]] types de chat.',
'</pre>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456684602920305675.4902)
,p_plug_name=>unistr('Liaison d''\00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez inclure des liens vers des \00E9tats dans les sections de page \00E0 l''aide de la syntaxe suivante.</p>'),
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ report: &lt;report alias> | &lt;link name> ]]',
'[[ report: &lt;report alias> . &lt;saved report name (may not be private)> | &lt;link name> ]] ',
'</pre>',
'',
'<p><b>Exemples de syntaxe :</b></p>',
'<pre>',
'[[ report: fish | marine fish ]]',
'[[ report: fish . my favorite | marine fish ]] ',
'',
'</pre>',
'',
'<p><b>Exemple en contexte :</b></p>',
'<pre>',
unistr('Visualiser l''\00E9tat [[ report: fish | perfect temperature ]] pour le poisson marin s\00E9lectionn\00E9.'),
'</pre>'))
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456722229827231075.4902)
,p_plug_name=>'Fichiers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez imbriquer un lien de t\00E9l\00E9chargement vers les fichiers t\00E9l\00E9charg\00E9s dans une section de page \00E0 l''aide de la syntaxe suivante.<p/>'),
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ file: &lt; file name > | &lt; link name > ]]',
'[[ file: &lt; file alias > | &lt; link name > ]]',
'</pre>',
'',
'<p><b>Exemples de syntaxe :</b></p>',
'<pre>',
'[[file: myfile ]]',
'[[file: myfile.xls ]]',
'[[file: myfile | My File ]]',
'</pre>',
'',
'<p><b>Exemple en contexte :</b></p>',
'<pre>',
unistr('Le fichier [[file: parts01.xls | spreadsheet ]] indique les num\00E9ros de r\00E9f\00E9rence.'),
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466849412509851927.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752825018135722319.4902)
,p_plug_name=>unistr('Requ\00EAtes Data Grid avanc\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>105
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les r\00E8gles de requ\00EAte de grille de donn\00E9es avanc\00E9es sont les suivantes :</p>'),
'<p>',
'<ul>',
unistr('<li>La requ\00EAte ne doit r\00E9f\00E9rencer la grille de donn\00E9es qu''une seule fois pour pouvoir inclure un lien de modification ou d''ajout de ligne (cela signifie que vous ne pouvez pas joindre la grille de donn\00E9es \00E0 elle-m\00EAme dans la requ\00EAte).</li>'),
unistr('<li>La premi\00E8re colonne doit \00EAtre la cl\00E9 primaire (c''est-\00E0-dire, la colonne identifiant de fa\00E7on unique la ligne de donn\00E9es) de la grille de donn\00E9es pour inclure un lien de modification de ligne. Si l''option "edit_row" est incluse et que la requ\00EAte n')
||unistr('e comporte qu''une seule instruction SELECT, la colonne de cl\00E9 primaire est incluse automatiquement. Si la requ\00EAte contient plusieurs instructions SELECT, vous pouvez utiliser la substitution <code>"APXWS_DATA_GRID_PK"</code> (toujours entre guillemet')
||unistr('s) comme premi\00E8re colonne de l''instruction SELECT pour inclure la cl\00E9 primaire en vue d''afficher un lien de modification de ligne.</li>'),
unistr('<li>Les noms de colonne d''\00E9tat correspondront aux noms de colonne de la grille de donn\00E9es mais ils peuvent \00EAtre modifi\00E9s \00E0 l''aide de la syntaxe SQL standard d''alias de colonne. L''exemple suivant affiche les donn\00E9es de la colonne Nombre minimal, mais ')
||unistr('l''en-t\00EAte affiche Min :'),
'<pre>select "Minimum Number" "Min" from ...</pre></li>',
unistr('<li>Si un nom de colonne d\00E9passe 30 caract\00E8res, vous ne pouvez inclure que les 30 premiers caract\00E8res du nom. Par exemple, utilisez : '),
'<pre>"% of Estimated Lions per Regio"</pre> ',
'Au lieu de :',
'<pre>"% of Estimated Lions per Region"</pre>',
unistr('<li>Pour afficher la requ\00EAte ex\00E9cut\00E9e, incluez l''option "show_sql". La requ\00EAte appara\00EEt au-dessus de l''\00E9tat inclus. Bien qu''il s''agisse d''une approche efficace en cas de d\00E9bogage, Oracle recommande de ne pas utiliser "show_sql" pour une application d')
||'e production.</li>',
'</ul>',
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_api.create_page(
 p_id=>18.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Vues de page'
,p_step_title=>'Vues de page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23684126174999945.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23684522796999946.4902)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23684126174999945.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>200
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23691322028074401.4902)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23684126174999945.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459633427711416362.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459640000854444211.4902)
,p_plug_name=>'Page Views'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    time_stamp,',
'    (select name from wwv_flow_steps p where p.id = l.step_id and p.flow_id = 4900) component_name,',
'    webpage_id,',
'    decode(webpage_id,null,null,(',
'       select max(name)',
'       from wwv_flow_ws_webpages p',
'       where p.ws_app_id = :ws_app_id',
'       and p.security_group_id = :flow_security_group_id',
'       and p.id = l.webpage_id)) page_name,',
'    elap,',
'    num_rows,',
'    lower(userid) userid,',
'    session_id,',
'    substr(user_agent,1,100) user_agent,',
'    sqlerrm,',
'   websheet_id,',
'   worksheet_id,',
'   ir_search,',
'   CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P18_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    webpage_id in (select id from wwv_flow_ws_webpages where ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(459640129876444211.4902)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640328679444227.4902)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640430971444230.4902)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Temps d''affichage'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640528870444230.4902)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Lignes'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640631431444230.4902)
,p_db_column_name=>'USERID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Utilisateur'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459641100631444231.4902)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459641220629444231.4902)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Agent utilisateur'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459641414761444232.4902)
,p_db_column_name=>'SQLERRM'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Message d''erreur'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642022665444233.4902)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Feuille Web'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642106997444233.4902)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Feuille de calcul'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642211221444233.4902)
,p_db_column_name=>'IR_SEARCH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Rechercher un texte'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642314321444233.4902)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Longueur du contenu'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459654731381564614.4902)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'ID de page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459654904510641947.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Nom de page'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459656813953701510.4902)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Nom de composant'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459653504454537879.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(459640000854444211.4902)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:18,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459652428040497404.4902)
,p_name=>'P18_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23684522796999946.4902)
,p_item_default=>'1'
,p_prompt=>'Tranche de temps'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Affichez les donn\00E9es d''\00E9tat dans la tranche de temps de g\00E9n\00E9ration d''\00E9tat s\00E9lectionn\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_api.create_page(
 p_id=>19.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Foire aux questions'
,p_step_title=>'Foire aux questions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen">',
'	/* Hide left col */',
'	div.wsSideCol {',
'		 display: none !important;',
'	}',
'	div.wsMainCol {',
'		 padding: 5px;',
'	}',
'</style>'))
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487174720945604524.4902)
,p_plug_name=>'Foire aux questions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><ol>'');',
'for i in 1..6 loop',
'    sys.htp.p(''<li>'');',
'    sys.htp.p(''<b>''||wwv_flow_lang.system_message(''WEBSHEETS_FAQ_Q''||i)||''</b>'');',
'    sys.htp.p(''<p>''||wwv_flow_lang.system_message(''WEBSHEETS_FAQ_A''||i)||''</p>'');',
'    sys.htp.p(''</li>'');',
'end loop;',
'sys.htp.p(''</ol></p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487175204107609089.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_api.create_page(
 p_id=>20.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Ajouter/Modifier une ligne'
,p_step_title=>'Ajouter/Modifier une ligne'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.ie7 table.wsTable,',
'.ie9 table.wsTable { width: 100%;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_comment=>'onload="wsPageInit(); $x_Hide(''R177113009695013686'');"'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3156111248550044.4902)
,p_plug_name=>'HIDDEN FORM ELEMENTS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(173336062654423126.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18840420076327189.4902)
,p_plug_name=>'Toolbar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60003614641461883.4902)
,p_plug_name=>'edit row'
,p_region_name=>'row'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_validation_passed varchar2(1) := null;  ',
'begin',
'  if :P20_VALIDATION_CNT > 0 then',
'    l_validation_passed := ''N'';',
'  else',
'    l_validation_passed := ''Y'';',
'  end if;',
'',
'  wwv_flow_ws_form.show (',
'    p_ws_app_id            => :WS_APP_ID,',
'    p_worksheet_id         => :P2_ID,',
'    p_data_grid_id         => :P2_WEBSHEET_ID,',
'    p_session              => :APP_SESSION,',
'    p_app_user             => :APP_USER,',
'    p_row_id               => :CURRENT_WORKSHEET_ROW,         ',
'    p_base_report_id       => :RPT_ID,',
'    p_partial_page_refresh => false,    ',
'    p_validation_passed    => l_validation_passed,',
'    p_last_page_id         => :P20_LAST_PAGE_ID,',
'    p_last_section_id      => :P20_LAST_SECTION_ID',
'    );',
'',
'  sys.htp.prn(''<span id="apexir_LOADER" style="display:none;" role="alert">'');',
'  sys.htp.prn(''<img alt="''||wwv_flow_lang.system_message(''WAITING.GENERIC'')||''" src="''||wwv_flow.g_image_prefix||''ws/ajax-loader.gif" />'');',
'  sys.htp.prn(''</span>'');    ',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81681415007489705.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466744416033456525.4902)
,p_plug_name=>'Ajax Notification Holder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'<div class="htmldbNotification" id="ajaxMESSAGE" style="display:none;"><img src="#IMAGE_PREFIX#delete.gif" onclick="apex.jQuery(''#ajaxMESSAGE'').hide();"  style="float:right;" class="pb" alt="" /><div id="theMESSAGE"></div></div>'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617574631447733199.4902)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_form.show_actions (',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_ir_id           => :P2_ID,',
'    p_data_grid_id    => :P2_WEBSHEET_ID,',
'    p_row_id          => :CURRENT_WORKSHEET_ROW',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'CURRENT_WORKSHEET_ROW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18840704623332140.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18840420076327189.4902)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157417700068555483.4902)
,p_branch_action=>'&P20_RETURN_URL.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'',''APPLY_CHANGES'',''DELETE'') and :P20_RETURN_URL is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3142429378139099.4902)
,p_branch_action=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'ATTACHMENT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157307002240912816.4902)
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3040322372230697.4902)
,p_name=>'P20_DESC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3142702413159613.4902)
,p_name=>'P20_X'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10603912332220266.4902)
,p_name=>'P20_LAST_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253264503612911225.4902)
,p_name=>'P20_LAST_PAGE_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(254176711273952957.4902)
,p_name=>'P20_RETURN_URL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(636400801424215275.4902)
,p_name=>'P20_VALIDATION_CNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2495429001405484202.4902)
,p_name=>'P20_IR_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2495429311101487046.4902)
,p_name=>'P20_DATA_GRID_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2495988315189126716.4902)
,p_name=>'P20_ROW_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2495429625300491103.4902)
,p_computation_sequence=>10
,p_computation_item=>'P2_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P20_IR_ID'
,p_compute_when=>'P20_IR_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2495430601190493614.4902)
,p_computation_sequence=>20
,p_computation_item=>'P2_WEBSHEET_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P20_DATA_GRID_ID'
,p_compute_when=>'P20_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(254184217200086883.4902)
,p_computation_sequence=>40
,p_computation_item=>'P20_RETURN_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_url             varchar2(4000);',
'    l_page_alias      varchar2(255);',
'    l_data_grid_alias varchar2(255);',
'begin               ',
'    if :P20_LAST_PAGE_ID is not null then',
'        l_page_alias := wwv_flow_ws_api.get_page_alias(p_ws_app_id => :WS_APP_ID,p_page_id=> :P20_LAST_PAGE_ID);',
'        l_url := wwv_flow_ws_webpage.get_url (',
'                    p_ws_app_id   => :WS_APP_ID,',
'                    p_session     => :APP_SESSION,',
'                    p_alias       => l_page_alias,',
'                    p_url_postfix => ''#SECTION_''||:P20_LAST_SECTION_ID);',
'    else',
'        l_data_grid_alias := wwv_flow_ws_api.get_data_grid_alias(p_ws_app_id => :WS_APP_ID,p_data_grid_id=> :P20_DATA_GRID_ID);',
'        l_url := wwv_flow_ws_webpage.get_url (',
'                    p_ws_app_id   => :WS_APP_ID,',
'                    p_session     => :APP_SESSION,',
'                    p_alias       => ''DG_''||l_data_grid_alias);',
'    end if;',
'    return l_url;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(471737310147352854.4902)
,p_computation_sequence=>20
,p_computation_item=>'WORKSHEET_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_websheet_name(p_worksheet_id => :p2_id);'
,p_computation_error_message=>unistr('Impossible d''obtenir le nom de la grille de donn\00E9es.')
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(162010510295416465.4902)
,p_computation_sequence=>30
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'20'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458952427548535993.4902)
,p_validation_name=>'process row'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_validation_error varchar2(32767);',
'  l_validation_count number;',
'begin',
'',
'wwv_flow_ws_api.process_row (',
'    p_ws_app_id     => :WS_APP_ID,',
'    p_worksheet_id  => :P2_ID,',
'    p_websheet_id   => :P2_WEBSHEET_ID,',
'    p_row_id        => :CURRENT_WORKSHEET_ROW,',
'    f01             => wwv_flow.g_f01,',
'    f02             => wwv_flow.g_f02,   ',
'    p_validation_error => l_validation_error,',
'    p_validation_count => l_validation_count,',
'    p_ajax_mode     => false );',
'',
'  :P20_VALIDATION_CNT :=  l_validation_count;',
'',
'  return '''';',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Une erreur de validation est survenue.'
,p_validation_condition=>'CREATE_AND_CREATE_ANOTHER,CREATE,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(157440521988694296.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Row'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_row(',
'    p_websheet_id   => :P2_WEBSHEET_ID,',
'    p_row_id        => :CURRENT_WORKSHEET_ROW);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de traiter la demande.'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_api.create_page(
 p_id=>22.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Syntaxe SQL de grille de donn\00E9es')
,p_step_title=>unistr('Syntaxe SQL de grille de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6247329636592604.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6498131507796437.4902)
,p_plug_name=>'Data Grids'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p22_data_grid_list (',
'    p_app_id       => :app_id,',
'    p_app_session  => :app_session,',
'    p_ws_app_id    => :ws_app_id,',
'    p_data_grid_id => :P22_DATA_GRID_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6674628032470220.4902)
,p_plug_name=>'Colonnes dans &P22_DATA_GRID_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p22_data_grid_columns (',
'    p_data_grid_id   => :P22_DATA_GRID_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6707429061744964.4902)
,p_plug_name=>unistr('Requ\00EAtes bas\00E9es sur &P22_DATA_GRID_NAME.')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p22_data_grid_query (',
'    p_data_grid_id   => :P22_DATA_GRID_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>S\00E9lectionnez une grille de donn\00E9es sur la gauche pour g\00E9n\00E9rer des requ\00EAtes SQL et SQLVALUE que vous pouvez utiliser dans l''application.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11359532303186287.4902)
,p_plug_name=>unistr('Aucune grille de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(1071999318750156264.4902)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<div class="wsPageMessage">Cette application n''a aucune grille de donn\00E9es.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133788708672776881.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(248081616517731203.4902)
,p_plug_name=>'Lien de signet vers &P22_DATA_GRID_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>75
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''ws?p=''||:WS_APP_ID||'':DG_''||:P22_DATA_GRID_ALIAS);',
'sys.htp.p(''<br />'');',
'sys.htp.p(''ws?p=''||:WS_APP_ID||'':DG_''||:P22_DATA_GRID_ALIAS||''::ROW_ID:[DATA_GRID_ROW_ID]'');',
'sys.htp.p(''<br /><br />'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Pour ajouter un signet directement \00E0 une grille de donn\00E9es ou une ligne, utilisez la syntaxe suivante :</p>')
,p_plug_footer=>unistr('<p>Remarque : DATA_GRID_ROW_ID est la valeur de la colonne d''ID de la table APEX$_WS_ROWS. Pour obtenir un lien vers une ligne de grille de donn\00E9es sp\00E9cifique, ex\00E9cutez une grille de donn\00E9es, puis cliquez sur l''ic\00F4ne de modification de la ligne et ob')
||unistr('tenez l''URL \00E0 partir du navigateur.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(268418006320837162.4902)
,p_plug_name=>'Lien vers &P22_DATA_GRID_NAME. (syntaxe de balisage)'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>85
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez fournir des liens vers les grilles de donn\00E9es dans les sections de page \00E0 l''aide de la syntaxe ci-dessous. Ces liens peuvent \00EAtre utilis\00E9s pour visualiser la grille de donn\00E9es ou cr\00E9er des donn\00E9es. Vous pouvez \00E9crire datagrid (grille d')
||unistr('e donn\00E9es) en un ou deux mots.</p>'),
'',
'<p><b>Syntaxe :</b></p>',
'<pre>',
'[[ data grid: &lt;datagrid alias | &lt;link name> ]] ',
'[[ datagrid: &lt;datagrid alias | &lt;link name> ]] ',
'[[ datagrid: &lt;datagrid alias . &lt;saved report name (may not be private)> | &lt;link name> ]] ',
'</pre>',
'',
'<p><b>Exemples de syntaxe :</b></p>',
'<pre>',
'[[ data grid: todo list | To Do List ]] ',
'[[ data grid: todo list . open todo items | To Do List ]] ',
'[[ datagrid: todo list | To Do List ]] ',
'</pre>',
'',
'<p><b>Exemple en contexte :</b></p>',
'<pre>',
unistr('V\00E9rifiez la [[ data grid: todo list | To Do List ]] et veillez \00E0 ce que'),
unistr('vos t\00E2ches puissent \00EAtre effectu\00E9es d''ici vendredi.'),
'</pre>',
''))
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6706611868673736.4902)
,p_name=>'P22_DATA_GRID_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(133788708672776881.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(248170113574405575.4902)
,p_name=>'P22_DATA_GRID_ALIAS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(133788708672776881.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(605139824509083611.4902)
,p_name=>'P22_DATA_GRID_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(133788708672776881.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(8467419570074984.4902)
,p_computation_sequence=>10
,p_computation_item=>'P22_DATA_GRID_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_ws_websheet_attr',
'where security_group_id = :flow_security_group_id',
'and ws_app_id = :ws_app_id',
'and rownum = 1',
'order by websheet_name',
''))
,p_compute_when=>'P22_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(248170305595409210.4902)
,p_computation_sequence=>10
,p_computation_item=>'P22_DATA_GRID_ALIAS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_alias',
'from wwv_flow_ws_websheet_attr',
'where security_group_id = :flow_security_group_id',
'and ws_app_id = :ws_app_id',
'and id = :P22_DATA_GRID_ID'))
,p_compute_when=>'P22_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(605211826718093751.4902)
,p_computation_sequence=>10
,p_computation_item=>'P22_DATA_GRID_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where security_group_id = :flow_security_group_id',
'and ws_app_id = :ws_app_id',
'and id = :P22_DATA_GRID_ID',
''))
,p_compute_when=>'P22_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_api.create_page(
 p_id=>24.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Pages principales'
,p_step_title=>'Pages principales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459659409774763317.4902)
,p_plug_name=>'Page Views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    webpage_id,',
'    decode(webpage_id,null,null,(',
'       select max(name)',
'       from wwv_flow_ws_webpages p',
'       where p.ws_app_id = :ws_app_id',
'       and p.id = l.webpage_id)) page_name,',
'    count(*) page_views,',
'    avg(elap) elap,',
'    avg(num_rows) num_rows,',
'    count(distinct userid) userid,',
'    avg(content_length) CONTENT_LENGTH,',
'  sum(CONTENT_LENGTH) content_served,',
'   sum(elap) page_generation_time,',
'   max(time_stamp) last_view',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P24_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    webpage_id is not null  and',
'    webpage_id in (select id from wwv_flow_ws_webpages where ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id)',
'group by     webpage_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(459659605981763318.4902)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459659820880763321.4902)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Temps d''affichage moyen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459659905607763326.4902)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre moyen de lignes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459660912570763334.4902)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Contenu de texte moyen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459661125550763335.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Nom de page'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459663826561790231.4902)
,p_db_column_name=>'USERID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Utilisateurs distincts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459664004874793441.4902)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471969020072698244.4902)
,p_db_column_name=>'CONTENT_SERVED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>unistr('Contenu trait\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471969215286698247.4902)
,p_db_column_name=>'PAGE_GENERATION_TIME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>unistr('Heure de g\00E9n\00E9ration de la page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479550923423223017.4902)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Page Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479557502570311662.4902)
,p_db_column_name=>'LAST_VIEW'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>unistr('Derni\00E8re vue')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459661531662763337.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23692317442092071.4902)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(459661531662763337.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23692521944093325.4902)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(459661531662763337.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459662911407766995.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459661713093763338.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(459659409774763317.4902)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:24,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459661926271763339.4902)
,p_name=>'P24_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23692521944093325.4902)
,p_item_default=>'1'
,p_prompt=>'Tranche de temps'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Affichez les donn\00E9es d''\00E9tat dans la tranche de temps de g\00E9n\00E9ration d''\00E9tat s\00E9lectionn\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00025
begin
wwv_flow_api.create_page(
 p_id=>25.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Liens de page et de section'
,p_step_title=>'Liens de page et de section'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488510805876131179.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491313913908782031.4902)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491318015433867606.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Copiez le lien de la section ou de la page et collez-le dans un texte de section pour cr\00E9er un lien sur une page.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491577932536354374.4902)
,p_plug_name=>'Liens vers une page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.name page_name, ',
'       decode(a.home_page_id, p.id, ''[[ page: ''||p.name||'' ]]'', ',
'          ''[[ page: ''||p.page_alias||'' | ''||p.name||'' ]]'') page_link',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'  and p.ws_app_id = :ws_app_id',
'  and p.ws_app_id = a.id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491578027851354374.4902)
,p_name=>'Page and Section Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491578208150354381.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491578311606354385.4902)
,p_db_column_name=>'PAGE_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Lien de page'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488510218502131175.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491577932536354374.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(491599426242893169.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_section_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id         => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection.')
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_api.create_page(
 p_id=>26.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('T\00E9l\00E9charger une feuille de calcul (adresse AJAX)')
,p_step_title=>unistr('T\00E9l\00E9charger une feuille de calcul (adresse AJAX)')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(157592926751064610)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(157427219470636840.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SPREADSHEET_SAVE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code clob := empty_clob;',
'begin',
'   sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'   for i in 1..wwv_flow.g_f02.count loop',
'        sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f02(i)),wwv_flow.g_f02(i));',
'    end loop;',
'apex_collection.create_or_truncate_collection(p_collection_name=>''SPREADSHEET_CONTENT'');',
'apex_collection.add_member(p_collection_name=>''SPREADSHEET_CONTENT'',p_c001=>wwv_flow.g_f01(1),p_clob001=>l_code);',
'sys.htp.prn(''success'');',
'htmldb_application.g_unrecoverable_error := TRUE;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_api.create_page(
 p_id=>27.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Fichiers'
,p_step_title=>'Fichiers'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488523103160992637.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491316430100805612.4902)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491454229828060959.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Cr\00E9ez des liens pour t\00E9l\00E9charger des fichiers \00E0 l''aide de la syntaxe [[FILE: ]] ou affichez des images incorpor\00E9es \00E0 l''aide de la syntaxe [[IMAGE: ]].</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491582707308395779.4902)
,p_plug_name=>'Fichiers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select name from wwv_flow_ws_webpages ',
'         where id = n003 and ws_app_id = n002 ',
'           and security_group_id=:flow_security_group_id) page_name,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws ',
'         where w.id=ws.worksheet_id and ws.id = n004 ',
'           and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr ',
'         where id = n004 and ws_app_id = n002 ',
'           and security_group_id=:flow_security_group_id) data_grid_name,',
'       c001 component_level,',
'       c002 file_name,',
'       c003 image_alias,',
'       c008 description,',
'       c009 created_by,',
'       to_number(c011) doc_size,',
'       ''[[ file: ''||c003||'' | ''||c002||'' ]]'' file_link,',
'       ''[[ image: ''||c003||'' | title="''||c002||''" ]]'' image_link,',
'       d001 created_on',
'  from wwv_flow_collections',
' where collection_name = ''APEX$_WS_FILES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491582908789395824.4902)
,p_name=>'Attachments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'ICON_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584227347395830.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584331848395830.4902)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Grille de donn\00E9es')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584421517395830.4902)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Niveau'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584708827395830.4902)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491585006345395831.4902)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'ID de feuille de calcul'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491585118316395831.4902)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Nom de fichier'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491583420164395827.4902)
,p_db_column_name=>'IMAGE_ALIAS'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491591904650603108.4902)
,p_db_column_name=>'FILE_LINK'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Lien de fichier'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491592915647625219.4902)
,p_db_column_name=>'IMAGE_LINK'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Lien d''image'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(495846530207735868.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(495848524451743667.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(495860525237800639.4902)
,p_db_column_name=>'DOC_SIZE'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'Taille'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488522502529992636.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491582707308395779.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(491585815273398010.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create file collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_attachment_collection (',
'    p_ws_app_id    => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection.')
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_api.create_page(
 p_id=>28.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Liens de section'
,p_step_title=>'Liens de section'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492133721971626990.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492133918103626991.4902)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492134119027626992.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Copiez le lien de la section ou de la page et collez-le dans un texte de section pour cr\00E9er un lien sur une page.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492134510311626995.4902)
,p_plug_name=>'Liens de section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.name page_name, ',
'       s.c001 section_name,',
'       s.c002 section_type,',
'       decode(s.n001, NULL, NULL, ''[[ section: ''||p.page_alias||''.''||s.c001||',
'              '' |  ''||s.c001||'' ]]'') section_link,',
'       s.n003 section_seq',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a,',
'     wwv_flow_collections s',
'where p.security_group_id = :flow_security_group_id ',
'  and p.ws_app_id = :ws_app_id',
'  and p.ws_app_id = a.id',
'  and p.id = s.n002 (+)',
'  and s.collection_name (+) = ''APEX$_WS_SECTIONS''',
'  and s.c002 != ''PLSQL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492134718217626996.4902)
,p_name=>'Page and Section Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492134831239626996.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135023564626998.4902)
,p_db_column_name=>'SECTION_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Section'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135204191626998.4902)
,p_db_column_name=>'SECTION_SEQ'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>unistr('S\00E9quence sur la page')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135323582626998.4902)
,p_db_column_name=>'SECTION_TYPE'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Type de section'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(492203630195322675)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135114156626998.4902)
,p_db_column_name=>'SECTION_LINK'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Lien'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492134320826626994.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(492134510311626995.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492135623803626999.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_section_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id         => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection.')
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_api.create_page(
 p_id=>29.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Liens de grille de donn\00E9es')
,p_step_title=>unistr('Liens de grille de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488528711832072509.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>300
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Copiez le lien de la grille de donn\00E9es et collez-le dans un texte de section pour cr\00E9er un lien sur une page.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488529907857072513.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491316014516801049.4902)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491746024610087200.4902)
,p_plug_name=>unistr('Liens de grille de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.name name, ',
'       ''[[ data grid: ''||lower(a.websheet_alias)||'' | ''|| w.name ||'' ]]'' data_grid_link',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491746111378087200.4902)
,p_name=>'Data Grid Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491746317155087207.4902)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491746428175087207.4902)
,p_db_column_name=>'DATA_GRID_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Lien de grille de donn\00E9es')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488529313077072512.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491746024610087200.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_api.create_page(
 p_id=>30.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Liens d''\00E9tat')
,p_step_title=>unistr('Liens d''\00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4902)
,p_required_role=>wwv_flow_api.id(492214905335570870)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488531706310080311.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Copiez le lien de l''\00E9tat et collez-le dans un texte de section pour cr\00E9er un lien sur une page.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488532919512080318.4902)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491315807244799034.4902)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491748021852099994.4902)
,p_plug_name=>unistr('Liens d''\00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.name name, ',
'       ''[[ report: ''||lower(a.websheet_alias)||'' | ''|| w.name ||'' ]]'' report_link',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      a.websheet_type = ''REPORT'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491748229774099997.4902)
,p_name=>'Data Grid Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491748324162100000.4902)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491751223153119333.4902)
,p_db_column_name=>'REPORT_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Lien d''\00E9tat')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(491750704452113945.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491748021852099994.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_api.create_page(
 p_id=>31.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Copier une page'
,p_step_title=>'Copier une page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20320615327276649.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_COPY_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(929190133057280555.4902)
,p_plug_name=>unistr('Succ\00E8s')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(931543191007401308.4902)
,p_plug_display_sequence=>10
,p_plug_query_num_rows=>15
,p_plug_header=>unistr('<p>La page a \00E9t\00E9 copi\00E9e.<p>')
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(929190488644282428.4902)
,p_plug_name=>'barre de boutons'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(929190621583287226.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(929190488644282428.4902)
,p_button_name=>'VIEW_CURRENT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la page en cours'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:P900_ID:&P900_ID.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(929190863882290386.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(929190488644282428.4902)
,p_button_name=>'VIEW_NEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Visualiser la nouvelle page'
,p_button_position=>'CREATE2'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:P900_ID:&P908_NEW_PAGE_ID.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_api.create_page(
 p_id=>33.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Masque de format BLOB'
,p_step_title=>'Masque de format BLOB'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
'  function apex_p33_download_format_set(){',
'    var l_Array = [$v(''P33_TYPE''),$v(''P33_BLOB_TABLE''),$v(''P33_BLOB_COLUMN''),$v(''P33_PK1''),$v(''P33_PK2''),$v(''P33_MIMETYPE''),$v(''P33_FILENAME''),$v(''P33_UPDATED''),$v(''P33_CHARSET''),$v(''P33_CONTENT_DISPOSITION''),$v(''P33_LINK_TEXT'')];',
'    var lItem = ''P3020_FORMAT_MASK'';',
'    var l_Value = $u_ArrayToString(l_Array,'':'');',
'    opener.$s(lItem,l_Value);',
'    window.close();',
'    opener.$x(lItem).focus();',
'  }',
'',
'//-->',
'</script>  '))
,p_step_template=>wwv_flow_api.id(134255203486851095.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(382871122829192382.4902)
,p_plug_name=>'Masque de format BLOB'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid=>true
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(383167816689247554.4902)
,p_plug_name=>'Top Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(383212323961249647.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(383167816689247554.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Appliquer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex_p33_download_format_set();'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(382974024476212019.4902)
,p_name=>'P33_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>'Masque de format'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BLOB_FORMAT_MASK'
,p_lov=>'.'||wwv_flow_api.id(382915819151201016.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(383000402790215206.4902)
,p_name=>'P33_BLOB_TABLE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>'Table BLOB'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(383045518374219662.4902)
,p_name=>'P33_BLOB_COLUMN'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>'Colonne BLOB'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(402663623371449753.4902)
,p_name=>'P33_PK1'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>unistr('Colonne de cl\00E9 primaire 1')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(402992609350483622.4902)
,p_name=>'P33_PK2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>unistr('Colonne de cl\00E9 primaire 2')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403109000131490412.4902)
,p_name=>'P33_MIMETYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>'Type de colonne MIME'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403280800609499987.4902)
,p_name=>'P33_FILENAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>'Colonne de nom de fichier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403382322426506264.4902)
,p_name=>'P33_UPDATED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>unistr('BLOB - Derni\00E8re colonne mise \00E0 jour')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403460500740509547.4902)
,p_name=>'P33_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>unistr('Colonne de jeu de caract\00E8res')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403561421518515499.4902)
,p_name=>'P33_CONTENT_DISPOSITION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>'Disposition du contenu'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BLOB_CONTENT_DISPOSITION'
,p_lov=>'.'||wwv_flow_api.id(382939512009208407.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403683725112525989.4902)
,p_name=>'P33_LINK_TEXT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4902)
,p_prompt=>unistr('T\00E9l\00E9charger le texte de lien')
,p_source=>'wwv_flow_lang.system_message(''DOWNLOAD'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(992326827720799292.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch blob format mask info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.p33_fetch_blob_format (',
'    p_format_mask         => :P3020_FORMAT_MASK,    ',
'    --',
'    p_type                => :P33_TYPE,',
'    p_blob_table          => :P33_BLOB_TABLE,',
'    p_blob_column         => :P33_BLOB_COLUMN,',
'    p_pk1_column          => :P33_PK1,',
'    p_pk2_column          => :P33_PK2,',
'    p_mimetype_column     => :P33_MIMETYPE,',
'    p_filename_column     => :P33_FILENAME,',
'    p_last_upd_column     => :P33_UPDATED,',
'    p_charset_column      => :P33_CHARSET,',
'    p_content_disposition => :P33_CONTENT_DISPOSITION,',
'    p_download_text       => :P33_LINK_TEXT',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_api.create_page(
 p_id=>37.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('S\00E9lectionner une langue')
,p_step_title=>unistr('S\00E9lectionner une langue')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22687832673202415.4902)
,p_plug_name=>'Top Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619996914922437329.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(633817727195790601.4902)
,p_plug_name=>unistr('S\00E9lectionner une langue et un territoire')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(620002529476508161.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22687832673202415.4902)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(633832411704842867.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22687832673202415.4902)
,p_button_name=>'SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(636473024858464198.4902)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(633832411704842867.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(633818130920810528.4902)
,p_name=>'P37_LANGUAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(633817727195790601.4902)
,p_item_default=>'wwv_flow_lang.get_g_session_lang'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Langue'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGES_INSTALLED'
,p_lov=>'.'||wwv_flow_api.id(631691002719703351.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la langue \00E0 utiliser lorsque vous ex\00E9cutez cette application. Si les cookies sont activ\00E9s dans votre navigateur Web, cette pr\00E9f\00E9rence de langue est \00E9crite dans un cookie qui contr\00F4le cette pr\00E9f\00E9rence dans toutes les applications de feuil')
||unistr('le Web de cette instance. La liste de langues d\00E9pend des versions traduites de &PRODUCT_NAME. install\00E9es.'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(633818321354817301.4902)
,p_name=>'P37_TERRITORY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(633817727195790601.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.get_g_session_territory'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Territoire'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_TERRITORIES'
,p_lov=>'.'||wwv_flow_api.id(634728210841234369.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la pr\00E9f\00E9rence de territoire utilis\00E9e lorsque vous ex\00E9cutez cette application. Cette pr\00E9f\00E9rence contr\00F4le l''affichage par d\00E9faut des dates, nombres et calendriers. Si les cookies sont activ\00E9s dans votre navigateur Web, cette pr\00E9f\00E9rence de ')
||unistr('territoire est \00E9crite dans un cookie qui contr\00F4le cette pr\00E9f\00E9rence dans toutes les applications de feuille Web de cette instance.  '),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(636322931994230689.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set language and territory'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.set_session_lang( p_lang => :P37_LANGUAGE );',
'wwv_flow.g_browser_language := :P37_LANGUAGE;',
'wwv_flow_lang.set_session_territory( p_territory => :P37_TERRITORY );',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors du traitement de la mise \00E0 jour.')
,p_process_when_button_id=>wwv_flow_api.id(633832411704842867.4902)
,p_process_success_message=>unistr('Action trait\00E9e.')
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_api.create_page(
 p_id=>42.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Mes \00E9tats enregistr\00E9s')
,p_step_title=>unistr('Mes \00E9tats enregistr\00E9s')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(496647113913986363.4902)
,p_plug_name=>unistr('Mes \00E9tats enregistr\00E9s')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'case when r.is_default!=''Y'' or r.application_user!=''APXWS_DEFAULT'' then',
'    wwv_flow_item.checkbox(',
'        1,',
'        r.id,null,null,'':'',',
'       ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'        wwv_flow_lang.system_message(''REPORT_LABEL'',',
'                            case',
'                              when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'                                wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'                              else',
'                                wwv_flow_escape.html(r.name)',
'                            end) )',
'end id,',
'a.id napp_id,',
'case when ws.websheet_type = ''DATA'' then',
'       ''<a href="f?p=''||:app_id||'':2:''||:app_session||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||:ws_app_id||'',''||i.id||'',''||ws.id||''">''||wwv_flow_escape.html(ws.websheet_name)||''</a>''',
'     when ws.websheet_type = ''REPORT'' then',
'       ''<a href="f?p=''||:app_id||'':3000:''||:app_session||''::::WS_APP_ID,IR_ID,WS_ID:''||:ws_app_id||'',''||i.id||'',''||ws.id||''">''||wwv_flow_escape.html(ws.websheet_name)||''</a>''',
'end websheet_name,',
'case when ws.websheet_type = ''DATA'' then',
'       sm.data_grid',
'     when ws.websheet_type = ''REPORT'' then',
'       sm.report',
'end websheet_type,',
'case when r.is_default = ''Y''then ',
'     decode(r.application_user,',
'            ''APXWS_DEFAULT'',sm.primary_def, ',
'            ''APXWS_ALTERNATIVE'',sm.alt_def)',
'     when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'         sm.spublic',
'     when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'         sm.private',
'end report_type, ',
'case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'else',
'    r.name',
'end name,',
'decode(r.application_user,',
'       ''APXWS_DEFAULT'',null,',
'       ''APXWS_ALTERNATIVE'',null,',
'       lower(r.application_user)) owner,',
'substr(r.description,1,50) description,        ',
'r.report_alias report_alias,',
'r.created_on',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'wwv_flow_ws_applications a,',
'wwv_flow_ws_websheet_attr ws,',
'(select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,               ',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic,',
'      wwv_flow_lang.system_message(''DATA_GRID'') data_grid,',
'      wwv_flow_lang.system_message(''REPORT'') report',
' from dual) sm',
'where a.id = ws.ws_app_id',
'and ws.worksheet_id = i.id',
'and r.worksheet_id = i.id',
'and r.websheet_id is not null',
'and r.security_group_id = :flow_security_group_id',
'and a.id = :ws_app_id',
'and r.application_user = :app_user',
'and r.session_id is null'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(496647211081986363.4902)
,p_name=>'Saved Reports'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647413912986368.4902)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647505239986368.4902)
,p_db_column_name=>'NAPP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647610315986368.4902)
,p_db_column_name=>'WEBSHEET_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Donn\00E9es')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(497241820310060978)
,p_rpt_show_filter_lov=>'2'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647729642986369.4902)
,p_db_column_name=>'WEBSHEET_TYPE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647830164986369.4902)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Type d''\00E9tat')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647931210986369.4902)
,p_db_column_name=>'NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Nom'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496648005718986369.4902)
,p_db_column_name=>'OWNER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Propri\00E9taire')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496648117100986369.4902)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496648221465986369.4902)
,p_db_column_name=>'REPORT_ALIAS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Alias d''\00E9tat')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(737065808338186629.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(497240631383988555.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(497261218307315877.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilisez cette page pour g\00E9rer les \00E9tats enregistr\00E9s. Vous pouvez cr\00E9er des \00E9tats enregistr\00E9s \00E0 l''aide du menu Actions lorsque vous visualisez les \00E9tats et les grilles de donn\00E9es. Les param\00E8tres d''un \00E9tat enregistr\00E9 sont r\00E9f\00E9renc\00E9s lors de la cr\00E9a')
||unistr('tion d''une section en fonction d''un \00E9tat ou d''une grille de donn\00E9es. Ils permettent de personnaliser les donn\00E9es pr\00E9sent\00E9es dans cette section.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(497767325222992406.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(496647113913986363.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:42,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(497233530597931570.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(496647113913986363.4902)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>unistr('Supprimer les \00E9l\00E9ments coch\00E9s')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(497233703023933067.4902)
,p_branch_action=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(497241020778994879.4902)
,p_validation_name=>'must select report to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Pour supprimer l''\00E9tat, vous devez le s\00E9lectionner.')
,p_when_button_pressed=>wwv_flow_api.id(497233530597931570.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045581531252367912.4902)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(496647113913986363.4902)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045581649091367913.4902)
,p_event_id=>wwv_flow_api.id(2045581531252367912.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(497237425533939526.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for c1 in (select id report_id, worksheet_id, application_user, is_default, report_type',
'               from wwv_flow_worksheet_rpts',
'               where id = wwv_flow.g_f01(i)',
'               and security_group_id=:flow_security_group_id',
'               and application_user = :app_user)',
'    loop                ',
'        wwv_flow_worksheet_api.delete_saved_report (            ',
'            p_worksheet_id      => c1.worksheet_id,               ',
'            p_report_id         => c1.report_id,',
'            p_is_default        => c1.is_default);        ',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enlever l''\00E9tat.')
,p_process_when_button_id=>wwv_flow_api.id(497233530597931570.4902)
,p_process_success_message=>unistr('Etats enlev\00E9s.')
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_api.create_page(
 p_id=>50.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Ajouter une pi\00E8ce jointe')
,p_step_title=>unistr('Ajouter une pi\00E8ce jointe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(3152608674388513.4902)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This page needed for Ajax in Data Grid Single Row View (page 20).',
'onload="window.parent.closeupload();"'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3144901000282263.4902)
,p_plug_name=>'Upload'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_error_msg varchar2(4000);',
'begin',
'    wwv_flow_ws_attachment.add_doc (',
'        p_ws_app_id       => :WS_APP_ID,',
'        p_websheet_id     => :P2_WEBSHEET_ID,',
'        p_row_id          => :CURRENT_WORKSHEET_ROW,',
'        p_component_level => ''ROW'',',
'        p_file_name       => :P20_X,',
'        p_desc            => :P20_DESC',
'    );',
'    sys.htp.p(''<script type="text/javascript" charset="utf-8">'');',
'    sys.htp.p(''  window.parent.apex.websheet.closeUpload();'');',
'    sys.htp.p(''</script>'');',
'exception when others then',
'    if sqlcode = -1691 then',
'        l_error_msg := wwv_flow_lang.system_message(''WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'');',
'    else',
'        l_error_msg := sqlerrm;',
'    end if;',
'    sys.htp.p(''<script type="text/javascript" charset="utf-8">'');',
'    sys.htp.p(''  window.parent.apex.websheet.spinner$.remove();'');',
'    sys.htp.p(''  $("#apexir_DIALOG_MESSAGE", window.parent.document).html("''||wwv_flow_escape.html(l_error_msg)||''");'');',
'    sys.htp.p(''</script>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177392830105668569.4902)
,p_branch_name=>'Go To Page 20'
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_api.create_page(
 p_id=>51.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('G\00E9rer les mod\00E8les d''authentification')
,p_step_title=>unistr('G\00E9rer les mod\00E8les d''authentification')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177132113855562337.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00053
begin
wwv_flow_api.create_page(
 p_id=>53.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier une page'
,p_step_title=>'Modifier une page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<style>',
'/* There is no collapse left col functionality on this page, so adding additional padding to Left Col heading */',
'div.ebaTwoColPane > div h2.leftButtons {padding-left: 10px !important;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18534419096630219.4902)
,p_plug_name=>'List of Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18529824151546479.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(158861503239501998.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18534800527634294.4902)
,p_plug_name=>unistr('D\00E9tails de &P53_NAME.')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18557529579690008.4902)
,p_plug_name=>'Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18585811889807838.4902)
,p_plug_name=>'Page Settings List'
,p_region_name=>'page_control'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18583325957802446.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162991400186731236.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177409809869723629.4902)
,p_plug_name=>'Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177422928892872875.4902)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2061383146528710242.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(18557529579690008.4902)
,p_button_name=>'CREATE_PAGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4902)
,p_button_image_alt=>unistr('Cr\00E9er une page')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-plus'
,p_button_cattributes=>'data-menu="page_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177410225400723635.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(177422928892872875.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18562324993707537.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(18557529579690008.4902)
,p_button_name=>'Hide/Show'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177410026421723634.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(177422928892872875.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
,p_button_condition=>'P53_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177410112058723634.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(177422928892872875.4902)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_condition=>'(:P53_ID is not null) and (not wwv_flow_ws_api.is_app_home_page(p_ws_app_id => :ws_app_id, p_webpage_id => :p53_id))'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(163262329454777553.4902)
,p_branch_action=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:53:P53_ID:&P53_NEXT_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GET_NEXT_PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177410910657723644.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(467021002093988715.4902)
,p_branch_action=>'f?p=&APP_ID.:960:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177410112058723634.4902)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(163040114731735379.4902)
,p_name=>'P53_NEXT_PAGE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(162991400186731236.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411102679723645.4902)
,p_name=>'P53_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(162991400186731236.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411303356723657.4902)
,p_name=>'P53_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifiez le nom de la page. Il appara\00EEt dans le titre de la fen\00EAtre ainsi que dans le chemin de navigation.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411518259723658.4902)
,p_name=>'P53_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Propri\00E9taire')
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie le propri\00E9taire de la page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411701386723658.4902)
,p_name=>'P53_STATUS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Statut'
,p_source=>'STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le statut de la page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411912672723659.4902)
,p_name=>'P53_DESCRIPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description de page'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Texte d\00E9crivant la page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177412115882723659.4902)
,p_name=>'P53_PARENT_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page parent'
,p_source=>'PARENT_PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK PARENT PAGE (FOR PAGE 53)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID',
'minus',
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id ',
'   and ws_app_id = :WS_APP_ID ',
'connect by prior id = parent_page_id',
'start with id = :P53_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Aucun parent -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie la page parent. La page parent d\00E9finie est utilis\00E9e pour g\00E9n\00E9rer le chemin de navigation et la navigation de page en page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(457384308073732200.4902)
,p_name=>'P53_PAGE_ALIAS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alias'
,p_source=>'PAGE_ALIAS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indiquez un alias alphanum\00E9rique pour cette page. Un alias de page permet de cr\00E9er des liens dans les sections d''une page vers d''autres pages. Chaque alias de page doit \00EAtre unique dans une application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457472018265246008.4902)
,p_validation_name=>'P53_PAGE_ALIAS must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P53_PAGE_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists(',
'     p_ws_app_id=>:WS_APP_ID,',
'     p_alias=>:P53_PAGE_ALIAS,',
'     p_alias_type=>''PAGE'',',
'     p_page_id=>:P53_ID) then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('L''alias de page existe d\00E9j\00E0. Saisissez-en un autre.')
,p_validation_condition=>'SAVE,GET_NEXT_PAGE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(457384308073732200.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(467021405256017928.4902)
,p_validation_name=>'cannot delete home page'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_home_page_id  number;',
'begin',
'   for c1 in (',
'      select home_page_id',
'        from wwv_flow_ws_applications',
'       where id = :WS_APP_ID',
'         and security_group_id = :flow_security_group_id )',
'   loop',
'      l_home_page_id := c1.home_page_id;',
'   end loop;',
'',
'   if :P53_ID = l_home_page_id then',
'      return false;',
'   else',
'      return true;',
'   end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Impossible de supprimer la page d''accueil. Modifiez les propri\00E9t\00E9s de l''application et s\00E9lectionnez une nouvelle page d''accueil.')
,p_when_button_pressed=>wwv_flow_api.id(177410112058723634.4902)
,p_associated_item=>wwv_flow_api.id(177411303356723657.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(467022317985040552.4902)
,p_validation_name=>'cannot delete only page'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_page_count  number;',
'begin',
'   for c1 in (',
'      select count(*) cnt',
'        from wwv_flow_ws_webpages',
'       where ws_app_id = :WS_APP_ID',
'         and security_group_id = :flow_security_group_id )',
'   loop',
'      l_page_count := c1.cnt;',
'   end loop;',
'',
'   if l_page_count = 1 then',
'      return false;',
'   else',
'      return true;',
'   end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Chaque application doit comporter au moins une page. Vous ne pouvez pas supprimer la seule page existante.'
,p_when_button_pressed=>wwv_flow_api.id(177410112058723634.4902)
,p_associated_item=>wwv_flow_api.id(177411303356723657.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6140313816861525.4902)
,p_validation_name=>'P53_PAGE_ALIAS is valid'
,p_validation_sequence=>40
,p_validation=>'P53_PAGE_ALIAS'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('L''alias doit \00EAtre alphanum\00E9rique.')
,p_validation_condition=>':P53_PAGE_ALIAS is not null and :REQUEST in (''SAVE'',''GET_NEXT_PAGE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(457384308073732200.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177412315870723660.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WS_WEBPAGES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_WEBPAGES'
,p_attribute_03=>'P53_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and ws_app_id = :WS_APP_ID'))
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177412503075723662.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WS_WEBPAGES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_WEBPAGES'
,p_attribute_03=>'P53_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and ws_app_id = :WS_APP_ID'))
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_process_error_message=>'Impossible de traiter la ligne de la table WWV_FLOW_WS_WEBPAGES.'
,p_process_when=>'SAVE,GET_NEXT_PAGE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_api.create_page(
 p_id=>79.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Administration'
,p_step_title=>'Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4881207741750467)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4098511924636618.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(198343320048239476.4902)
,p_plug_name=>'perform logout'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_ws_app_id number := v(''WS_APP_ID'');',
'begin',
'    for c1 in (select auth_id authentication ',
'              from wwv_flow_ws_applications',
'              where id = l_ws_app_id',
'              and security_group_id = :flow_security_group_id)',
'    loop',
'        if c1.authentication is null then',
'            null;',
'        else',
'            for c2 in (select page_sentry_function,logout_url from wwv_flow_ws_custom_auth_setups where id = c1.authentication) loop',
'                if c2.page_sentry_function = ''-DATABASE-'' then',
'                    null;',
'                else',
'                    sys.htp.init;',
'                    sys.owa_util.redirect_url(replace(replace(replace(c2.logout_url,''&''||''WS_APP_ID.'',l_ws_app_id),''&''||''APP_SESSION.'',''&''||''SESSION.''),''&''||''SESSION.'',v(''APP_SESSION'')));',
'                    wwv_flow.stop_apex_engine;',
'                end if;',
'            end loop;                    ',
'        end if;',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(811176724741077278.4902)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'redirect if login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_found boolean := false;',
'  l_territory      varchar2(255);',
'begin',
'for c1 in (select auth_id, language, territory, home_page_id',
'             from wwv_flow_ws_applications',
'            where id = :WS_APP_ID) loop',
'  for c2 in (select auth_function, invalid_session_url',
'               from wwv_flow_ws_custom_auth_setups',
'              where id = c1.auth_id ) loop',
'               if c1.territory is null then',
'                   for c3 in (select nls_territory from wwv_flow_languages where lang_id = c1.language) loop',
'                       l_territory := c3.nls_territory;',
'                       exit;',
'                   end loop;',
'               else',
'                   l_territory := c1.territory;',
'               end if;',
'    if c2.invalid_session_url = ''-PORTAL_SSO-'' then',
'            wwv_flow.g_user := ''nobody'';',
'            wwv_flow_security.g_user := wwv_flow.g_user;',
'            wwv_flow_custom_auth.remember_deep_link(',
'                p_url=>''f?p=''||:app_id||'':900:::::WS_APP_ID,P900_ID:''||:WS_APP_ID||'',''||c1.home_page_id);',
'            begin',
'            wwv_flow_security.g_context := ''WWV_FLOW_CUSTOM_AUTH_SSO'';',
'            wwv_flow_dynamic_exec.run_block (',
'                p_sql=>''begin wwv_flow_custom_auth_sso.portal_sso_redirect; end;'',',
'                p_user=>wwv_flow.g_flow_schema_owner);',
'            wwv_flow_security.g_context := ''NULL'';',
'            exception when others then',
'               wwv_flow_security.g_context := ''NULL'';',
'               l_found := false;',
'               for c1 in (select /* APEXad5ea5 */  1 from sys.dba_objects',
'                   where object_name=''WWSEC_SSO_ENABLER_PRIVATE'' and',
'                   object_type = ''PACKAGE''',
'                   and status = ''VALID'') loop',
'                   l_found := true;',
'               end loop;',
'               if not l_found then',
'                    wwv_flow_error.raise_internal_error (',
'                        p_error_message =>',
'                            wwv_flow_lang.system_message(',
'                                p_name=>''WWV_FLOW_SECURITY.SSO_PKG_MISSING1'')||',
'                                ''<br>&nbsp;''||',
'                            wwv_flow_lang.system_message(',
'                                p_name=>''WWV_FLOW_SECURITY.SSO_PKG_MISSING2'',',
'                                p0=>''&PRODUCT_NAME.'') );',
'               else',
'                   wwv_flow_error.raise_internal_error (',
'                       p_error_code => ''WWV_FLOW_SECURITY.SSO_PKG_ERR'' );',
'               end if;',
'               return;',
'            end;',
'    elsif c2.invalid_session_url = ''-SAML-'' then',
'      wwv_flow_authentication_f4900.trigger_login;',
'    else',
'      sys.htp.init;',
'      sys.owa_util.redirect_url(wwv_flow_ws_webpage.get_login_url(:WS_APP_ID));',
'      wwv_flow.stop_apex_engine;',
'    end if;',
'  end loop;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'LOGIN'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_api.create_page(
 p_id=>89.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier le type de colonne'
,p_step_title=>'Modifier le type de colonne'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4230411616343203.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4231008955350266.4902)
,p_plug_name=>'Confirmer la modification du type de colonne'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Vous avez demand\00E9 \00E0 modifier le type de colonne de la grille de donn\00E9es. Cette modification d\00E9sactivera les filtres, les r\00E8gles de mise en \00E9vidence et d''autres param\00E8tres d''\00E9tat existants r\00E9f\00E9ren\00E7ant ces colonnes. Confirmez votre demande.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(128720011527408660.4902)
,p_plug_name=>'Boutons droits de la barre d''outil'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4231507009359228.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(128720011527408660.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4231818090362334.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(128720011527408660.4902)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Confirmer'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4236313729446260.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(128720011527408660.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4232110828362335.4902)
,p_branch_action=>'f?p=&FLOW_ID.:2:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4231818090362334.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4236626497446261.4902)
,p_branch_action=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4236313729446260.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4239107514595863.4902)
,p_name=>'P89_COLUMN_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4902)
,p_prompt=>'Nom de colonne'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_label',
'from wwv_flow_worksheet_columns',
'where db_column_name = :p91_db_column_name',
'and worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nom de colonne s\00E9lectionn\00E9 pour modifier le type de colonne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4239902235613223.4902)
,p_name=>'P89_OLD_COLUMN_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4902)
,p_prompt=>'Ancien type de colonne'
,p_source=>'wwv_flow_item.text_from_lov (:p91_column_type,''WORKSHEET_COLUMN_TYPES2'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Ancien type de colonne.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4240110892615736.4902)
,p_name=>'P89_NEW_COLUMN_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4902)
,p_prompt=>'Nouveau type de colonne'
,p_source=>'wwv_flow_item.text_from_lov (:p91_new_column_type,''WORKSHEET_COLUMN_TYPES2'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nouveau type de colonne.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4242814626061519.4902)
,p_name=>'P89_FORMAT_MASK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4902)
,p_prompt=>unistr('Masque de format \00E0 utiliser lors de la modification du type de colonne')
,p_source=>'P91_FORMAT_MASK'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Masque de format \00E0 utiliser lors de la modification du type de colonne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4243626448093240.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change column type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.change_column_type (',
'    p_worksheet_id         => :p2_id,',
'    p_websheet_id          => :p2_websheet_id,',
'    p_old_db_column_name   => :p91_db_column_name,    ',
'    p_new_column_type      => :P91_NEW_COLUMN_TYPE,',
'    p_format_mask_to_use   => :P91_FORMAT_MASK);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de modifier le type de colonne.'
,p_process_when_button_id=>wwv_flow_api.id(4231818090362334.4902)
,p_process_success_message=>unistr('Type de colonne modifi\00E9.')
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_api.create_page(
 p_id=>90.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Objets disponibles'
,p_step_title=>'Objets disponibles'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript">',
'   function passBack(passVal1)',
'   {',
'   opener.document.getElementById("P1310_TABLE_NAME").value = passVal1;',
'   opener.document.getElementById("P1310_TABLE_NAME").focus();',
'   close();',
'   }',
'</script>',
''))
,p_step_template=>wwv_flow_api.id(134255203486851095.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(134428823965885392.4902)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492080122343937551.4902)
,p_plug_name=>'Objects'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, ',
'       null t,',
'       object_name v,',
'       object_comment c',
'  from wwv_flow_ws_app_sug_objects',
' where ws_app_id = :WS_APP_ID',
'   and security_group_id = :workspace_id',
'   and nvl(:P90_TABLE_TYPE,''S'') = ''S''',
'union all',
'select table_name d,',
'       wwv_flow_lang.system_message(''TABLE'') t, ',
'       table_name v,',
'       null c',
'  from sys.dba_tables',
' where owner = :P90_SCHEMA',
'   and table_name not like ''BIN$%''',
'   and table_name not like ''APEX$_%''',
'   and :P90_TABLE_TYPE = ''A''',
'union all',
'select view_name d,',
'       wwv_flow_lang.system_message(''VIEW'') t, ',
'       view_name v,',
'       null c',
'  from sys.dba_views',
' where owner = :P90_SCHEMA',
'   and :P90_TABLE_TYPE = ''A''',
'union all',
'select synonym_name d,',
'       wwv_flow_lang.system_message(''SYNONYM'') t, ',
'       synonym_name v,',
'       null c',
'  from sys.dba_synonyms',
' where owner = :P90_SCHEMA',
'   and :P90_TABLE_TYPE = ''A''',
' order by 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492080213042937551.4902)
,p_name=>'Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492080416858937588.4902)
,p_db_column_name=>'D'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Nom d''objet'
,p_column_link=>'javascript:passBack(''#V#'');'
,p_column_linktext=>'#D#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492103930374310439.4902)
,p_db_column_name=>'T'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Type d''objet'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P90_TABLE_TYPE'
,p_display_condition2=>'A'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492623505769353937.4902)
,p_db_column_name=>'C'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Commentaire'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P90_TABLE_TYPE'
,p_display_condition2=>'S'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492080514008937588.4902)
,p_db_column_name=>'V'
,p_display_order=>5
,p_column_identifier=>'B'
,p_column_label=>'V'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492053301677732661.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(134428823965885392.4902)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Fermer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492102203653198613.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(492080122343937551.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:90,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492067824637769509.4902)
,p_name=>'P90_TABLE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(134428823965885392.4902)
,p_prompt=>'Afficher'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SUGGESTED SQL TABLE TYPE (P90)'
,p_lov=>'.'||wwv_flow_api.id(17231024016826986.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492697000185414926.4902)
,p_name=>'P90_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(492080122343937551.4902)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_ws_setup.get_apex$_schema (p_workspace_id=>:flow_security_group_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(495865912227957737.4902)
,p_computation_sequence=>10
,p_computation_item=>'P90_TABLE_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select count(*) cnt ',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID )',
'loop',
'   if c1.cnt = 0 then',
'      return ''A'';',
'   else',
'      return ''S'';',
'   end if;',
'end loop;'))
,p_compute_when=>'P90_TABLE_TYPE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(495717104974056773.4902)
,p_name=>'when no sug obj'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NOT_EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(495717422657056775.4902)
,p_event_id=>wwv_flow_api.id(495717104974056773.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P90_TABLE_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432751509152951102.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(p_schema => :P90_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P90_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_api.create_page(
 p_id=>91.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier le type de colonne'
,p_step_title=>'Modifier le type de colonne'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4233421912405794.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4233920131410265.4902)
,p_plug_name=>'Modifier le type de colonne'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(127798813633286291.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(128015931556310368.4902)
,p_plug_name=>'Boutons droits de la barre d''outil'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4234716106418588.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(128015931556310368.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CHANGE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4234126710412218.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(128015931556310368.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4235020699418588.4902)
,p_branch_action=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4234716106418588.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235200653423582.4902)
,p_name=>'P91_COLUMN_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4902)
,p_prompt=>'Nom de colonne'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_label',
'from wwv_flow_worksheet_columns',
'where db_column_name = :P91_DB_COLUMN_NAME',
'and worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nom de colonne s\00E9lectionn\00E9 pour modifier le type de colonne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235408965425946.4902)
,p_name=>'P91_COLUMN_TYPE_DISPLAY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4902)
,p_prompt=>'Type de colonne'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov (column_type,''WORKSHEET_COLUMN_TYPES2'')',
'from wwv_flow_worksheet_columns',
'where db_column_name = :P91_DB_COLUMN_NAME',
'and worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_lov_display_extra=>'NO'
,p_help_text=>'Type de colonne en cours.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235631474432520.4902)
,p_name=>'P91_NEW_COLUMN_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4902)
,p_prompt=>'Nouveau type de colonne'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WORKSHEET_COLUMN_TYPES2'
,p_lov=>'.'||wwv_flow_api.id(38353412581019585.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un type de colonne -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le nouveau type de colonne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235917061437778.4902)
,p_name=>'P91_DB_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(127798813633286291.4902)
,p_prompt=>'Db Column Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4238507121567312.4902)
,p_name=>'P91_COLUMN_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(127798813633286291.4902)
,p_prompt=>'Column Type'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_type',
'from wwv_flow_worksheet_columns',
'where db_column_name = :P91_DB_COLUMN_NAME',
'and worksheet_id = :p2_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4241105389916880.4902)
,p_name=>'P91_FORMAT_MASK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4902)
,p_prompt=>unistr('Masque de format \00E0 utiliser lors de la modification du type de colonne')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT MASK DYNAMIC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from wwv_flow_format_masks'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Entrez le masque de format \00E0 utiliser au cours de la modification du type de colonne. Lorsque vous changez le type de colonne en date ou en nombre, vous devez entrer le masque de format. Si vous ne le faites pas, cette modification risque d''\00E9chouer.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4237821488533664.4902)
,p_validation_name=>'P91_NEW_COLUMN_TYPE not null'
,p_validation_sequence=>10
,p_validation=>'P91_NEW_COLUMN_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nouveau type de colonne doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(4234716106418588.4902)
,p_associated_item=>wwv_flow_api.id(4235631474432520.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4238113438550220.4902)
,p_validation_name=>'old type not equal new type'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P91_COLUMN_TYPE = :P91_NEW_COLUMN_TYPE then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nouveau type de colonne doit \00EAtre diff\00E9rent de l''ancien.')
,p_validation_condition=>'P91_NEW_COLUMN_TYPE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(4234716106418588.4902)
,p_associated_item=>wwv_flow_api.id(4235631474432520.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186914619522722819.4902)
,p_validation_name=>'P91_NEW_COLUMN_TYPE max reached'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.max_col_limit_reached (',
'    p_worksheet_id   => :p2_id,',
'    p_column_type    => :P91_NEW_COLUMN_TYPE) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nombre maximal de colonnes disponibles pour le type de colonne a \00E9t\00E9 atteint. S\00E9lectionnez un autre type de colonne.')
,p_validation_condition=>'replace(:P91_NEW_COLUMN_TYPE,''%''||''null%'') is not null and :P91_COLUMN_TYPE != :P91_NEW_COLUMN_TYPE'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(4234716106418588.4902)
,p_associated_item=>wwv_flow_api.id(4235631474432520.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_api.create_page(
 p_id=>92.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('R\00E9initialiser le mot de passe')
,p_step_title=>unistr('R\00E9initialiser le mot de passe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-AppCards--slim .a-AppCards-icon {',
'    margin: 16px auto;',
'}',
'',
'h1.a-Login-title {',
'    font-size: 20px;',
'    margin: 24px 0;',
'}'))
,p_step_template=>wwv_flow_api.id(1418140425267007336.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(506060600392166972)
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8557512241276654.4902)
,p_plug_name=>'Reset password Container'
,p_region_css_classes=>'a-Login-region a-Form--stretchInputs a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_ws_applications ',
'where id = :WS_APP_ID'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1284871394951082007.4902)
,p_plug_name=>'Reset assword Header'
,p_parent_plug_id=>wwv_flow_api.id(8557512241276654.4902)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select',
'               wwv_flow_4000_ui.get_app_initials( name, id ) as app_initials,',
'               ''u-ColorBG--'' || to_char( ora_hash( name, 29 ) + 1 ) as app_color,',
'               name ws_name',
'           from  wwv_flow_ws_applications a',
'           where a.security_group_id = :flow_security_group_id',
'           and a.id = :ws_app_id)',
'loop',
'    sys.htp.p(''<div class="a-Login-header a-AppCards--slim">'');',
'    sys.htp.p(''  <span class="a-AppCards-icon a-AppCards-icon--initials ''||',
'              wwv_flow_escape.html(c1.app_color)||',
'              ''" role="presentation" aria-hidden="true">''||',
'              wwv_flow_escape.html(c1.app_initials)||',
'              ''</span>'');',
'    sys.htp.p(''  <h1 class="a-Login-title">''||wwv_flow_escape.html(c1.ws_name)||''</h1>'');',
'    sys.htp.p(''</div>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1418413115140401416.4902)
,p_plug_name=>'Reset password items'
,p_parent_plug_id=>wwv_flow_api.id(8557512241276654.4902)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1418149362592020763.4902)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(692442804709370101.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1418413115140401416.4902)
,p_button_name=>'RESET_PASSWORD'
,p_button_action=>'SUBMIT'
,p_button_template_id=>wwv_flow_api.id(798473351219404350.4902)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('R\00E9initialiser le mot de passe')
,p_button_position=>'NEXT'
,p_button_css_classes=>' a-Button--large'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(692442518084364512.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1418413115140401416.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(798473351219404350.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(692443304148379348.4902)
,p_branch_action=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(692442804709370101.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(692437908116266949.4902)
,p_name=>'P92_EMAIL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1418413115140401416.4902)
,p_prompt=>unistr('Votre adresse \00E9lectronique dans notre base de donn\00E9es')
,p_placeholder=>unistr('adresse \00E9lectronique')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(1418153120551046350.4902)
,p_item_css_classes=>'icon-login-email'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(692438611018277308.4902)
,p_name=>'P92_WORKSPACE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1418413115140401416.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Saisissez votre espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693704031500021583.4902)
,p_name=>'P92_USERNAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1418413115140401416.4902)
,p_prompt=>'Nom utilisateur'
,p_placeholder=>'nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(1418153120551046350.4902)
,p_item_css_classes=>'icon-login-username'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7293128029885669.4902)
,p_validation_name=>'is valid email and username'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_fnd_user u, wwv_flow_ws_applications w',
'where upper(u.email_address) = upper(:P92_EMAIL) and',
'      upper(u.user_name) = upper(:P92_USERNAME) and',
'      u.security_group_id != 10 and',
'      u.security_group_id = w.security_group_id and',
'      w.id = :WS_APP_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Le nom utilisateur ou l''adresse \00E9lectronique indiqu\00E9 est incorrect.')
,p_when_button_pressed=>wwv_flow_api.id(692442804709370101.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(692443023410375451.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_developer_api.f4900_reset_password (',
'  p_ws_app_id => :WS_APP_ID,',
'  p_user_name => :P92_USERNAME,',
'  p_email_address=> :P92_EMAIL,',
'  p_workspace_name=> null );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de r\00E9initialiser le mot de passe.')
,p_process_when_button_id=>wwv_flow_api.id(692442804709370101.4902)
,p_process_success_message=>unistr('La demande de r\00E9initialisation du mot de passe a \00E9t\00E9 envoy\00E9e pour traitement.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(693689731931002813.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Determine Workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select security_group_id from wwv_flow_ws_applications where id = :WS_APP_ID) loop',
'    :P92_WORKSPACE := c1.security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_api.create_page(
 p_id=>99.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Non autoris\00E9')
,p_step_title=>unistr('Non autoris\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456110204457776640.4902)
,p_plug_name=>'Not Authorized'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Vous n''\00EAtes pas autoris\00E9 \00E0 acc\00E9der \00E0 cette application ou fonction.</p>')
,p_translate_title=>'N'
,p_region_image=>'#IMAGE_PREFIX#menu/alarm_bell_wbg_64x64.png'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_api.create_page(
 p_id=>101.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Connexion'
,p_alias=>'LOGIN'
,p_step_title=>'Ouverture de session de feuilles Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-AppCards--slim .a-AppCards-icon { margin: 16px auto; }',
'h1.a-Login-title { font-size: 20px; margin: 24px 0; }',
'.a-Login-wsMsg { font-size: 14px; margin: 16px 8px; color: #707070; }',
'.a-Form-fieldContainer--hiddenLabel .apex-item-option {height: 16px;}'))
,p_step_template=>wwv_flow_api.id(1418140425267007336.4902)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1410890655888668019.4902)
,p_plug_name=>unistr('Ouvrir une session de conteneur de r\00E9gion')
,p_region_css_classes=>'a-Login-region a-Form--stretchInputs a-Form--labelsAbove'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154773620917091162.4902)
,p_plug_name=>'Sign In items'
,p_parent_plug_id=>wwv_flow_api.id(1410890655888668019.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_plug_template=>wwv_flow_api.id(1418149362592020763.4902)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459631111530350735.4902)
,p_plug_name=>'Language Selector'
,p_parent_plug_id=>wwv_flow_api.id(1410890655888668019.4902)
,p_region_css_classes=>'a-Login-links a-Login-links--languages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4902)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p( wwv_flow_lang.get_language_selector_list );'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4000_ui.is_translation_installed( p_flow_id => 4000 )'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1410890754992668020.4902)
,p_plug_name=>'Sign In Region Header'
,p_parent_plug_id=>wwv_flow_api.id(1410890655888668019.4902)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select',
'               wwv_flow_4000_ui.get_app_initials( name, id ) as app_initials,',
'               ''u-ColorBG--'' || to_char( ora_hash( name, 29 ) + 1 ) as app_color,',
'               name ws_name',
'           from  wwv_flow_ws_applications a',
'           where a.security_group_id = :flow_security_group_id',
'           and a.id = :ws_app_id)',
'loop',
'    sys.htp.p(''<div class="a-Login-header a-AppCards--slim">'');',
'    sys.htp.p(''  <span class="a-AppCards-icon a-AppCards-icon--initials ''||',
'              wwv_flow_escape.html(c1.app_color)||',
'              ''" role="presentation" aria-hidden="true">''||',
'              wwv_flow_escape.html(c1.app_initials)||',
'              ''</span>'');',
'    sys.htp.p(''  <h1 class="a-Login-title">''||wwv_flow_escape.html(c1.ws_name)||''</h1>'');',
'    for l_msg in (select login_page_message ',
'                  from WWV_FLOW_WS_APPLICATIONS ',
'                  where id = :WS_APP_ID',
'                  and login_page_message is not null )',
'    loop',
'        sys.htp.p(''<p class="a-Login-wsMsg">''||wwv_flow_escape.html(l_msg.login_page_message)||''</p>'');',
'    end loop;',
'    sys.htp.p(''</div>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61034832101787205.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(154773620917091162.4902)
,p_button_name=>'RESET_PASSWORD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>unistr('R\00E9initialiser le mot de passe')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_button_condition=>'return wwv_flow_ws_api.show_reset_password (p_ws_app_id=>:WS_APP_ID);'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5698501044727837.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(154773620917091162.4902)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(798473351219404350.4902)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ouvrir une session'
,p_button_position=>'NEXT'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154773716538091162.4902)
,p_name=>'P101_USERNAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4902)
,p_prompt=>'Nom utilisateur'
,p_placeholder=>'nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(1418153120551046350.4902)
,p_item_css_classes=>'icon-login-username'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154773815685091162.4902)
,p_name=>'P101_PASSWORD'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4902)
,p_prompt=>'Mot de passe'
,p_placeholder=>'mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_field_template=>wwv_flow_api.id(1418153120551046350.4902)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(216990508511910211.4902)
,p_name=>'P101_REMEMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4902)
,p_prompt=>unistr('M\00E9moriser le nom utilisateur')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REMEMBER_USERNAME'
,p_lov=>'.'||wwv_flow_api.id(263997216503587205.4902)||'.'
,p_field_template=>wwv_flow_api.id(264000229814622656.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si vous cochez cette case, la feuille Web enregistre votre nom utilisateur dans un cookie de navigateur persistant nomm\00E9 "LOGIN_USERNAME_COOKIE".'),
unistr('La prochaine fois que vous acc\00E9derez \00E0 la page de connexion,'),
'le champ de nom utilisateur sera automatiquement rempli avec cette valeur.',
'</p>',
'<p>',
unistr('Si vous d\00E9s\00E9lectionnez cette case \00E0 cocher et si votre nom utilisateur est d\00E9j\00E0 enregistr\00E9 dans le cookie,'),
'la feuille Web le remplacera par une valeur vide.',
unistr('Vous pouvez \00E9galement utiliser les outils de d\00E9veloppement de votre navigateur pour enlever compl\00E8tement le cookie.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(388700621118310671.4902)
,p_name=>'P101_BUILDER_SESSION_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_security.get_builder_session_id'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'wwv_flow_security.get_builder_session_id'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10356803620488362.4902)
,p_validation_name=>'P101_USERNAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P101_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La valeur doit \00EAtre indiqu\00E9e.')
,p_associated_item=>wwv_flow_api.id(154773716538091162.4902)
,p_error_display_location=>'INLINE_WITH_FIELD'
,p_validation_comment=>'generated 09-OCT-2008 14:47'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10357031948488372.4902)
,p_validation_name=>'P101_PASSWORD Not Null'
,p_validation_sequence=>20
,p_validation=>'P101_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La valeur doit \00EAtre indiqu\00E9e.')
,p_associated_item=>wwv_flow_api.id(154773815685091162.4902)
,p_error_display_location=>'INLINE_WITH_FIELD'
,p_validation_comment=>'generated 09-OCT-2008 14:47'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774114072091162.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.send_login_username_cookie (',
'    p_username => :P101_USERNAME,',
'    p_consent  => :P101_REMEMBER = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774006644091162.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_custom_auth_std.ws_login(',
'    P_UNAME            => :P101_USERNAME,',
'    P_PASSWORD         => :P101_PASSWORD,',
'    P_SESSION_ID       => v(''APP_SESSION''),',
'    P_WEBSHEET_APP_ID  => :WS_APP_ID,',
'    p_websheet_page_id => :P900_ID );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774302570091162.4902)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'101'
,p_process_when=>'P101_REGION'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774210215091162.4902)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P101_USERNAME := apex_authentication.get_login_username_cookie;',
':P101_REMEMBER := case when :P101_USERNAME is not null then ''Y'' end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P101_USERNAME is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00102
begin
wwv_flow_api.create_page(
 p_id=>102.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Informations en retour'
,p_alias=>'FEEDBACK'
,p_step_title=>'Informations en retour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(134255203486851095.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_comment=>'This page was generated by the feedback wizard'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203493217304049113.4902)
,p_plug_name=>'Informations en retour'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752334827869677901.4902)
,p_plug_name=>unistr('R\00E9gion de boutons')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203497828051049124.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(752334827869677901.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203497606057049122.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(752334827869677901.4902)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Soumettre les informations en retour'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203493400295049114.4902)
,p_name=>'P102_APPLICATION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie l''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203494014853049116.4902)
,p_name=>'P102_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Indique la page dans l''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203494614905049117.4902)
,p_name=>'P102_A'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203494830875049118.4902)
,p_name=>'P102_FEEDBACK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_prompt=>'Informations en retour'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez vos informations en retour et cliquez sur le bouton Soumettre les informations en retour.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203495425757049118.4902)
,p_name=>'P102_X'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203495625923049119.4902)
,p_name=>'P102_FEEDBACK_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_prompt=>'Type d''informations en retour'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select the_name, id from WWV_FLOW_FEEDBACK_TYPES order by id'
,p_cSize=>20
,p_cMaxlength=>100
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifiez le type d''informations en retour que vous fournissez.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203496204433049120.4902)
,p_name=>'P102_Y'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'workspace 10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203496432737049121.4902)
,p_name=>'P102_ATTRIBUTE1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_prompt=>'Composant :'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FEEDBACK_COMPONENT'
,p_lov=>'.'||wwv_flow_api.id(945870019196474793.4902)||'.'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Fournissez ces informations \00E0 consigner dans le journal sous forme d''informations en retour.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203497005770049121.4902)
,p_name=>'P102_ATTRIBUTE2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4902)
,p_prompt=>'Attribut 2'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Fournissez ces informations \00E0 consigner dans le journal sous forme d''informations en retour.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(203498000886049124.4902)
,p_validation_name=>'Feedback not null'
,p_validation_sequence=>10
,p_validation=>'P102_FEEDBACK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La valeur doit \00EAtre indiqu\00E9e')
,p_when_button_pressed=>wwv_flow_api.id(203497606057049122.4902)
,p_associated_item=>wwv_flow_api.id(203494830875049118.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203498223414049125.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Submit Feedback'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.submit_feedback (',
'    p_comment         => :P102_FEEDBACK,',
'    p_type            => :P102_FEEDBACK_TYPE,',
'    p_application_id     => :P102_APPLICATION_ID,',
'    p_page_id         => :P102_PAGE_ID,',
'    p_label_01        => ''Component'',',
'    p_label_02        => ''Contact me via email'',',
'    p_attribute_01   => :P102_ATTRIBUTE1,',
'    p_attribute_02   => :P102_ATTRIBUTE2);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(203497606057049122.4902)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203498403008049126.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Window'
);
end;
/
prompt --application/pages/page_00131
begin
wwv_flow_api.create_page(
 p_id=>131.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une page')
,p_step_title=>unistr('Cr\00E9er une page')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20820515633073398.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173220910407622558.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173221309115622593.4902)
,p_plug_name=>unistr('Cr\00E9er')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173227111911856634.4902)
,p_plug_name=>'create page progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173233928842908830.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20820515633073398.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173234125942908830.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20820515633073398.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(173234507156912066.4902)
,p_branch_action=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:205::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P131_PAGE_TYPE'
,p_branch_condition_text=>'DATA'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(181302519582692237.4902)
,p_branch_action=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:1310,1320::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(173234125942908830.4902)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P131_PAGE_TYPE'
,p_branch_condition_text=>'REPORT'
,p_save_state_before_branch_yn=>'Y'
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173236415514942802.4902)
,p_name=>'P131_PAGE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(173221309115622593.4902)
,p_item_default=>'TEXT'
,p_prompt=>unistr('Quel type de composant de donn\00E9es voulez-vous cr\00E9er ?')
,p_source=>'DATA'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE DATA OR REPORT'
,p_lov=>'.'||wwv_flow_api.id(173236520362944199.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez le type de composant de donn\00E9es \00E0 cr\00E9er.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00140
begin
wwv_flow_api.create_page(
 p_id=>140.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Surveiller l''activit\00E9')
,p_step_title=>unistr('Surveiller l''activit\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187174414157946457.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459635018791429050.4902)
,p_plug_name=>unistr('Activit\00E9')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:49%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(459634320543429042.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460619812376871783.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilisez ces pages pour analyser l''utilisation, les performances et la popularit\00E9 des pages et du contenu.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461180329066335897.4902)
,p_plug_name=>'Annotations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:49%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(461178801985335895.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
);
end;
/
prompt --application/pages/page_00141
begin
wwv_flow_api.create_page(
 p_id=>141.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Principales grilles de donn\00E9es')
,p_step_title=>unistr('Principales grilles de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23764728224473605.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23764905998473606.4902)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23764728224473605.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23765115127473607.4902)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23764728224473605.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461236028506810793.4902)
,p_plug_name=>'Page Views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   (select max(WEBSHEET_NAME)',
'       from WWV_FLOW_WS_WEBSHEET_ATTR p',
'       where p.ws_app_id = :ws_app_id',
'       and p.id = l.DATAGRID_ID) data_grid_name,',
'    count(*) page_views,',
'    avg(elap) elap,',
'    avg(num_rows) num_rows,',
'    count(distinct userid) userid,',
'    avg(content_length) CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P141_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    DATAGRID_ID is not null and',
'    datagrid_id in (select id from WWV_FLOW_WS_WEBSHEET_ATTR where ws_app_id = :ws_app_id and WEBSHEET_TYPE = ''DATA'')',
'group by     l.DATAGRID_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(461236228917810797.4902)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236316065810801.4902)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Temps d''affichage moyen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236430570810802.4902)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre moyen de lignes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236514063810802.4902)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Longueur moyenne de contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236710411810802.4902)
,p_db_column_name=>'USERID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Utilisateurs distincts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236829739810802.4902)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461242409753848980.4902)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>unistr('Nom de grille de donn\00E9es')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461330100756322323.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461237306673810811.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(461236028506810793.4902)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:141,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461237501740810812.4902)
,p_name=>'P141_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23765115127473607.4902)
,p_item_default=>'1'
,p_prompt=>'Tranche de temps'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Affichez les donn\00E9es d''\00E9tat dans la tranche de temps de g\00E9n\00E9ration d''\00E9tat s\00E9lectionn\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00142
begin
wwv_flow_api.create_page(
 p_id=>142.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Principaux \00E9tats')
,p_step_title=>unistr('Principaux \00E9tats')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23768425584482295.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23768620004482297.4902)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23768425584482295.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23768808968482297.4902)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23768425584482295.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461244005589858615.4902)
,p_plug_name=>'Page Views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   (select max(WEBSHEET_NAME)',
'       from WWV_FLOW_WS_WEBSHEET_ATTR p',
'       where p.ws_app_id = :ws_app_id',
'       and p.id = l.DATAGRID_ID) data_grid_name,',
'    count(*) page_views,',
'    avg(elap) elap,',
'    avg(num_rows) num_rows,',
'    count(distinct userid) userid,',
'    avg(content_length) CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P142_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    DATAGRID_ID is not null and',
'    datagrid_id in (select id from WWV_FLOW_WS_WEBSHEET_ATTR where ws_app_id = :ws_app_id and WEBSHEET_TYPE = ''REPORT'')',
'group by     l.DATAGRID_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(461244219249858616.4902)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244423593858617.4902)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Temps d''affichage moyen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244509013858617.4902)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre moyen de lignes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244618067858617.4902)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Longueur moyenne de contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244716297858617.4902)
,p_db_column_name=>'USERID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Utilisateurs distincts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244806456858617.4902)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244320248858616.4902)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>unistr('Nom de grille de donn\00E9es')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461331213223325868.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461245330336858618.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(461244005589858615.4902)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461245523336858619.4902)
,p_name=>'P142_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23768808968482297.4902)
,p_item_default=>'1'
,p_prompt=>'Tranche de temps'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Affichez les donn\00E9es d''\00E9tat dans la tranche de temps de g\00E9n\00E9ration d''\00E9tat s\00E9lectionn\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00143
begin
wwv_flow_api.create_page(
 p_id=>143.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Principaux fichiers'
,p_step_title=>'Principaux fichiers'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471901413752065160.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471907103870125733.4902)
,p_plug_name=>'Top Files by User'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       c009 created_by,',
'       count(*) c,',
'       sum(decode(greatest(d002,sysdate-1),sysdate-1,0,1)) last_day,',
'       sum(decode(greatest(d002,sysdate-7),sysdate-7,0,1)) created_last_7_days,',
'       sum(decode(greatest(d002,add_months(sysdate,-1)),add_months(sysdate,-1),0,1)) last_month,',
'       apex_util.get_since(max(d002)) most_recent',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_FILES''',
'group by c009'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(471907203619125733.4902)
,p_name=>'Top Files by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471907430015125742.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom utilisateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471907510799125744.4902)
,p_db_column_name=>'C'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre de fichiers'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471909222611156826.4902)
,p_db_column_name=>'CREATED_LAST_7_DAYS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('La semaine derni\00E8re')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471909706596171166.4902)
,p_db_column_name=>'LAST_MONTH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Le mois dernier'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471910003957179869.4902)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('La derni\00E8re journ\00E9e')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914803012236331.4902)
,p_db_column_name=>'MOST_RECENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Plus r\00E9cent')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473412104980505809.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23795705639561731.4902)
,p_plug_name=>'Admin Annotation Tab'
,p_parent_plug_id=>wwv_flow_api.id(473412104980505809.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23775330395531080.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473412314903505852.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(471907103870125733.4902)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:143,RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471901910350068155.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>'wwv_flow_ws_api.create_attachment_collection (p_ws_app_id    => :ws_app_id);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00144
begin
wwv_flow_api.create_page(
 p_id=>144.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Principales remarques'
,p_step_title=>'Principales remarques'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471902911012084490.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471912413500212406.4902)
,p_plug_name=>'Top Notes by Username'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   c003 created_by,',
'   count(*) new_notes,',
'   sum(decode(greatest(d001,sysdate-1),sysdate-1,0,1)) last_day,',
'   sum(decode(greatest(d001,sysdate-7),sysdate-7,0,1)) created_last_7_days,',
'   sum(decode(greatest(d001,add_months(sysdate,-1)),add_months(sysdate,-1),0,1)) last_month,',
'   apex_util.get_since(max(d001)) most_recent',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_NOTES''',
'group by c003'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(471912507778212406.4902)
,p_name=>'Top Notes by Username'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471912706310212408.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom utilisateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471912829080212409.4902)
,p_db_column_name=>'NEW_NOTES'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre de remarques'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471913913139220374.4902)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('La derni\00E8re journ\00E9e')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914029231220374.4902)
,p_db_column_name=>'CREATED_LAST_7_DAYS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('La semaine derni\00E8re')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914113108220376.4902)
,p_db_column_name=>'LAST_MONTH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Le mois dernier'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914307729228250.4902)
,p_db_column_name=>'MOST_RECENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Plus r\00E9cent')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473415025889521297.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>3
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23814902438579759.4902)
,p_plug_name=>'Admin Annotation Tab'
,p_parent_plug_id=>wwv_flow_api.id(473415025889521297.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23775330395531080.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473416325674530692.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(471912413500212406.4902)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.:144,RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471912009760200442.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_note_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00145
begin
wwv_flow_api.create_page(
 p_id=>145.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Principales balises'
,p_step_title=>'Principales balises'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23816101530588971.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23816319486588973.4902)
,p_plug_name=>'Admin Annotation Tab'
,p_parent_plug_id=>wwv_flow_api.id(23816101530588971.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23775330395531080.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471904015280093887.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471905601524103473.4902)
,p_plug_name=>'Tag Cloud'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_webpage.show_tag_clouds (',
'    p_ws_app_id             => :ws_app_id,    ',
'    p_session_id            => :app_session);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_00146
begin
wwv_flow_api.create_page(
 p_id=>146.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Principaux utilisateurs'
,p_step_title=>'Principaux utilisateurs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23771705892505054.4902)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23771903817505055.4902)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23771705892505054.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23772114743505056.4902)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23771705892505054.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471916808921272522.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471919230020311098.4902)
,p_plug_name=>'Top Users'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    userid,',
'    count(*) page_views,',
'    count(distinct webpage_id) distinct_pages,',
'   sum(CONTENT_LENGTH) content_served,',
'   sum(num_rows) rows_served,',
'   sum(elap) page_generation_time',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - :P146_TIME) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id',
'group by userid'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(471919303440311098.4902)
,p_name=>'Top Users'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919508010311100.4902)
,p_db_column_name=>'USERID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Utilisateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919604537311100.4902)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919731265311100.4902)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Pages distinctes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919900949311100.4902)
,p_db_column_name=>'CONTENT_SERVED'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Contenu trait\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471920018399311101.4902)
,p_db_column_name=>'ROWS_SERVED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Lignes trait\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471920105353311101.4902)
,p_db_column_name=>'PAGE_GENERATION_TIME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Heure de g\00E9n\00E9ration de la page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D99'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472158913824081267.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(471919230020311098.4902)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.:146,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472159121381081270.4902)
,p_name=>'P146_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23772114743505056.4902)
,p_item_default=>'1'
,p_prompt=>'Tranche de temps'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Affichez les donn\00E9es d''\00E9tat dans la tranche de temps de g\00E9n\00E9ration d''\00E9tat s\00E9lectionn\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00200
begin
wwv_flow_api.create_page(
 p_id=>200.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une page')
,p_step_title=>unistr('Cr\00E9er une page')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1198430386542478.4902)
,p_plug_name=>unistr('Cr\00E9er une page')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11464130252463090.4902)
,p_plug_name=>'Boutons de barre d''outils'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436570726052138706.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154880404371674336.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(11464130252463090.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154880603784674338.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11464130252463090.4902)
,p_button_name=>'create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er une page')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(155398607371684404.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173712624517222880.4902)
,p_name=>'P200_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1198430386542478.4902)
,p_prompt=>'Nom'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez un nom de page. Il appara\00EEt dans le titre de la fen\00EAtre ainsi que dans le chemin de navigation.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174369210872944115.4902)
,p_name=>'P200_PARENT_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1198430386542478.4902)
,p_prompt=>'Page parent'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEXT WEBSHEETS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une page parent -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si cette page fait partie d''une hi\00E9rarchie, s\00E9lectionnez la page parent.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458468714942046990.4902)
,p_name=>'P200_PAGE_ALIAS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(1198430386542478.4902)
,p_prompt=>'Alias de page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifiez l''alias de page. Vous pouvez l''utiliser pour cr\00E9er des liens vers cette page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458480527802429176.4902)
,p_validation_name=>'P200_PAGE_ALIAS must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P200_PAGE_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P200_PAGE_ALIAS,',
'    p_alias_type   => ''PAGE'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('L''alias de page existe d\00E9j\00E0. Saisissez-en un autre.')
,p_when_button_pressed=>wwv_flow_api.id(154880603784674338.4902)
,p_associated_item=>wwv_flow_api.id(458468714942046990.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513405225400857985.4902)
,p_validation_name=>'P200_PAGE_ALIAS is valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P200_PAGE_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P200_PAGE_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_when_button_pressed=>wwv_flow_api.id(154880603784674338.4902)
,p_associated_item=>wwv_flow_api.id(458468714942046990.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(173742624666383777.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ceate page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_webpage_id number := null;',
'begin',
'    l_webpage_id := wwv_flow_id.next_val;',
'    ',
'    wwv_flow_ws_api.create_webpage (',
'        p_webpage_id      => l_webpage_id,',
'        p_ws_app_id       => :WS_APP_ID,',
'        p_name            => :P200_NAME,',
'        p_page_alias      => :P200_PAGE_ALIAS,',
'        p_description     => null,',
'        p_parent_page_id  => replace(:P200_PARENT_PAGE,''%''||''null%'')',
'        );',
'        ',
'    :P900_ID := l_webpage_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la page.')
,p_process_success_message=>unistr('Page cr\00E9\00E9e.')
);
end;
/
prompt --application/pages/page_00201
begin
wwv_flow_api.create_page(
 p_id=>201.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_step_title=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function addTableRow2(pThis,pThat,pNum){',
'    //console.log(pThat);',
'    var tt = html_GetElement(pThat);',
'        tt = tt.getElementsByTagName("tbody")[0];',
'    var l_newRows = new Array();',
'    for(i=0;i<pNum;i++){',
'      var ogTR = tt.rows[tt.rows.length -1];',
'      var trClone = ogTR.cloneNode(true);',
'      if(document.all){',
'        myNewRow = tt.insertRow(tt.rows.length);',
'        oReplace = myNewRow.replaceNode(trClone);',
'      }else{',
'        tt.appendChild(trClone);',
'      }',
'      l_newRows[l_newRows.length] = trClone;',
'      ',
'      var tSelects = trClone.getElementsByTagName(''select'');',
'      for(var iSelects=0;iSelects<tSelects.length;iSelects++){',
'          tSelects[iSelects].selectedIndex = 0;',
'          tSelects[iSelects].disabled="";',
'       }',
'      var tInputs = trClone.getElementsByTagName(''input'');',
'      for(var iInputs=0;iInputs<tInputs.length;iInputs++){',
'        if(tInputs[iInputs].type=="text"){',
'        tInputs[iInputs].value="";',
'        tInputs[iInputs].disabled="";',
'        }',
'      }',
'    }',
'    return l_newRows;',
'}',
'',
'/*Add table row for add column*/',
'function ob_TableAddColumn(pThis,pThat,pNum){     ',
'  var newRows = addTableRow2(pThis,pThat,pNum);',
'  for (var i = 0;i<newRows.length;i++){',
'    var l_Inputs = newRows[i].getElementsByTagName(''input'');',
'    html_HiddenElement(l_Inputs[1]);',
'    html_HiddenElement(l_Inputs[2]);',
'  }',
'}',
'',
'var gLastRowMovedColor = ''#FFF'';'))
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20777514043457891.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21434717060303392.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29893532414751568.4902)
,p_plug_name=>'create page progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85200421058598337.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161567019228946315.4902)
,p_plug_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'wwv_flow_ws_ui.p201_define_data_grid_columns;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161624313556285232.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(161567019228946315.4902)
,p_button_name=>'ADD_COLUMN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Ajouter une colonne'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'javascript:ob_TableAddColumn(this,''htmldbNewTable'',1);'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154889406934794672.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20777514043457891.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154889228692794671.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20777514043457891.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_button_position=>'CREATE'
,p_button_condition=>'P201_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3021502937237873.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20777514043457891.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(459284513339156315.4902)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:201:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,&P201_WORKSHEET_ID.,&P201_WEBSHEET_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154889228692794671.4902)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2691129726790817.4902)
,p_name=>'P201_PAGE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'2'
,p_prompt=>'Page ID'
,p_source=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154889802826794677.4902)
,p_name=>'P201_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154890025030794679.4902)
,p_name=>'P201_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4902)
,p_source=>'APP_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154890421381794680.4902)
,p_name=>'P201_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(161567019228946315.4902)
,p_prompt=>'Nom'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez un nom de grille de donn\00E9es.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161620030694252400.4902)
,p_name=>'P201_COL_ORDER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161745022194836488.4902)
,p_name=>'P201_NEW_WORKSHEET_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458477720127322928.4902)
,p_name=>'P201_ALIAS'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(161567019228946315.4902)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Entrez un alias de grille de donn\00E9es. Il vous permet de cr\00E9er des liens vers cette grille de donn\00E9es dans les sections d''une page. Les alias de grille de donn\00E9es doivent \00EAtre uniques dans une application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459283706282144844.4902)
,p_name=>'P201_WORKSHEET_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459283912425144845.4902)
,p_name=>'P201_WEBSHEET_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154890305337794680.4902)
,p_validation_name=>'P201_FLOW_ID not null'
,p_validation_sequence=>10
,p_validation=>'P201_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'L''ID de flux doit comporter une valeur.'
,p_associated_item=>wwv_flow_api.id(154890025030794679.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154890725984794680.4902)
,p_validation_name=>'P201_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P201_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom doit \00EAtre indiqu\00E9.')
,p_associated_item=>wwv_flow_api.id(154890421381794680.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8647014897469438.4902)
,p_validation_name=>'column must be defined'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  if wwv_flow.g_f01(i) is null then',
'    if i = 1 then',
'      return false;',
'    end if;',
'  end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Vous devez d\00E9finir les colonnes de feuille Web.')
,p_when_button_pressed=>wwv_flow_api.id(154889228692794671.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458488820108521527.4902)
,p_validation_name=>'P201_ALIAS must be unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P201_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P201_ALIAS,',
'    p_alias_type   => ''DATA_GRID'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Cet alias existe d\00E9j\00E0. Entrez-en un autre.')
,p_associated_item=>wwv_flow_api.id(458477720127322928.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(660056428068767360.4902)
,p_validation_name=>'P201_NAME must be unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P201_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P201_NAME,',
'    p_type         => ''DATA'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nom de grille de donn\00E9es existe d\00E9j\00E0. Saisissez un nom diff\00E9rent.')
,p_associated_item=>wwv_flow_api.id(154890421381794680.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(865527713121965593.4902)
,p_validation_name=>'duplicate column name found'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.duplicate_found_in_array (    ',
'    p_array => wwv_flow.g_f01) then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Noms de colonne en double d\00E9tect\00E9s. Les noms de colonne doivent \00EAtre uniques.')
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(506158920514422820.4902)
,p_validation_name=>'P201_ALIAS is valid'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P201_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P201_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_associated_item=>wwv_flow_api.id(458477720127322928.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169327811698892928.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  r varchar2(255) := null;',
'  c pls_integer;',
'begin',
'for i in 1..12 loop',
'select  count(*) into c',
'from  wwv_flow_ws_websheet_attr w',
'where security_group_id = :flow_security_group_id and',
'websheet_name = upper(:app_user)||'' 0''||i;',
'if c = 0 then',
'   r := upper(:app_user)||'' 0''||i;',
'   exit;',
'end if;',
'end loop;',
':P201_NAME := r;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P201_NAME'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(161740023102827299.4902)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Data Grid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_data_grid_from_scratch (',
'    p_ws_app_id     => :WS_APP_ID,',
'    p_name          => :P201_NAME,',
'    p_alias         => :P201_ALIAS,',
'    p_column_order  => :P201_COL_ORDER,',
'    p_worksheet_id  => :P201_WORKSHEET_ID,',
'    p_websheet_id   => :P201_WEBSHEET_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la grille de donn\00E9es.')
,p_process_when_button_id=>wwv_flow_api.id(154889228692794671.4902)
,p_process_success_message=>unistr('Grille de donn\00E9es cr\00E9\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23550931764462326.4902)
,p_process_sequence=>50
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save user input in collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(p_collection_name => ''WS_WIZ_COLUMNS'');',
'    ',
'wwv_flow_collection.add_members (',
'   p_collection_name => ''WS_WIZ_COLUMNS'',',
'   p_c001            => wwv_flow.g_f01,',
'   p_c002            => wwv_flow.g_f02);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer l''entr\00E9e utilisateur.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(154889228692794671.4902)
);
end;
/
prompt --application/pages/page_00205
begin
wwv_flow_api.create_page(
 p_id=>205.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_step_title=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2981808413059759.4902)
,p_plug_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Les grilles de donn\00E9es g\00E8rent les donn\00E9es utilis\00E9es par votre application. Choisissez comment vous souhaitez cr\00E9er la grille de donn\00E9es.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20775629580434005.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29886309287650228.4902)
,p_plug_name=>'create page progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85198200626592456.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157356222063249657.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20775629580434005.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157356622290249657.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20775629580434005.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157356416282249657.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20775629580434005.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157369302417300714.4902)
,p_branch_action=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:201,WS_WIZ_COLUMNS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P205_CREATE'
,p_branch_condition_text=>'SCRATCH'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157374926444317137.4902)
,p_branch_action=>'f?p=&APP_ID.:206:&SESSION.::&DEBUG.:206,CLOB_CONTENT::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P205_CREATE'
,p_branch_condition_text=>'CUTANDPASTE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2962827104989463.4902)
,p_name=>'P205_CREATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2981808413059759.4902)
,p_item_default=>'SCRATCH'
,p_source=>'SCRATCH'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE WORKSHEET OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(2960208403984068.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00206
begin
wwv_flow_api.create_page(
 p_id=>206.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_step_title=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(157592926751064610)
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20782013444514508.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21432216236293657.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29895108135791796.4902)
,p_plug_name=>'create websheet progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87067600442889007.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157402130664498141.4902)
,p_plug_name=>unistr('T\00E9l\00E9charger une feuille de calcul')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Collez la feuille de calcul ou les autres donn\00E9es d\00E9limit\00E9es par des tabulations ci-dessous.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157412930927517115.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20782013444514508.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157412021923514509.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20782013444514508.4902)
,p_button_name=>'UPLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('T\00E9l\00E9charger')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3019823238234313.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20782013444514508.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188356618124649439.4902)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,&P206_WORKSHEET_ID.,&P206_WEBSHEET_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157415007986529400.4902)
,p_name=>'P206_WORKSHEET_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4902)
,p_prompt=>'Nom'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_cattributes_element=>'width="100%"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le nom de la grille de donn\00E9es. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161542600584694900.4902)
,p_name=>'P206_COLUMN_HEADINGS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4902)
,p_item_default=>'Y'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FIRST_ROW_CONTAINS_COLUMN_HEADINGS'
,p_lov=>'.'||wwv_flow_api.id(799517811838484369.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162619632484627537.4902)
,p_name=>'P206_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(21432216236293657.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(399301229989054252.4902)
,p_name=>'P206_SPREADSHEET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4902)
,p_prompt=>unistr('Coller les donn\00E9es de feuille de calcul')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'spellcheck="false"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Copiez et collez les donn\00E9es que vous voulez charger \00E0 partir d''un tableur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458479616018350127.4902)
,p_name=>'P206_WORKSHEET_ALIAS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4902)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Entrez un alias de grille de donn\00E9es. Il vous permet de cr\00E9er des liens vers cette grille de donn\00E9es dans les sections d''une page. Les alias de grille de donn\00E9es doivent \00EAtre uniques dans une application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459294712047212712.4902)
,p_name=>'P206_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(21432216236293657.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459294929831212712.4902)
,p_name=>'P206_WEBSHEET_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(21432216236293657.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458491521409540890.4902)
,p_validation_name=>'P206_WORKSHEET_ALIAS must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P206_WORKSHEET_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P206_WORKSHEET_ALIAS,',
'    p_alias_type   => ''DATA_GRID'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Cet alias existe d\00E9j\00E0. Entrez-en un autre.')
,p_associated_item=>wwv_flow_api.id(458479616018350127.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(459413421772442554.4902)
,p_validation_name=>'P206_SPREADSHEET not null'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clob clob;',
'begin',
'  l_clob := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P206_SPREADSHEET'');',
'',
'  if (nvl(sys.dbms_lob.getlength(l_clob),0) = 0) then',
'      return false;',
'  end if;',
'',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Les donn\00E9es doivent \00EAtre indiqu\00E9es.')
,p_associated_item=>wwv_flow_api.id(399301229989054252.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(660376512709829107.4902)
,p_validation_name=>'P206_WORKSHEET_NAME must be unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P206_WORKSHEET_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P206_WORKSHEET_NAME,',
'    p_type         => ''DATA'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nom de grille de donn\00E9es existe d\00E9j\00E0. Saisissez un nom diff\00E9rent.')
,p_associated_item=>wwv_flow_api.id(157415007986529400.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(506662505047599536.4902)
,p_validation_name=>'P206_WORKSHEET_ALIAS is valid'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P206_WORKSHEET_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P206_WORKSHEET_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_associated_item=>wwv_flow_api.id(458479616018350127.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159446328406626838.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data grid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_data_grid_from_cp_paste (',
'    p_app_id            => :APP_ID,',
'    p_ws_app_id         => :WS_APP_ID,',
'    p_name              => :P206_WORKSHEET_NAME,',
'    p_alias             => :P206_WORKSHEET_ALIAS,',
'    p_headings_included => :P206_COLUMN_HEADINGS,',
'    p_collection_name   => ''P206_SPREADSHEET'',',
'    p_worksheet_id      => :P206_WORKSHEET_ID,',
'    p_websheet_id       => :P206_WEBSHEET_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la grille de donn\00E9es.')
,p_process_when_button_id=>wwv_flow_api.id(157412021923514509.4902)
,p_process_success_message=>unistr('Grille de donn\00E9es cr\00E9\00E9e.')
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_api.create_page(
 p_id=>400.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Tableau de bord'
,p_step_title=>'Tableau de bord'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5510207856754518.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00710
begin
wwv_flow_api.create_page(
 p_id=>710.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section de graphique')
,p_step_title=>unistr('Cr\00E9er une section de graphique')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21404623275153782.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(259451015474899829.4902)
,p_plug_name=>unistr('Cr\00E9er une section de graphique')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261473724838144583.4902)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436560332736922985.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259451227871899835.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(21404623275153782.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259451615967899838.4902)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(21404623275153782.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259451427400899837.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(21404623275153782.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(259453009785899851.4902)
,p_branch_action=>'f?p=&APP_ID.:740:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(259451615967899838.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(259453212836899853.4902)
,p_branch_action=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259451800210899839.4902)
,p_name=>'P710_CHART_TYPE'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(259451015474899829.4902)
,p_item_default=>'COLUMN'
,p_prompt=>unistr('S\00E9lectionner le type de graphique')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_TYPE'
,p_lov=>'.'||wwv_flow_api.id(259453605523899856.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez le type de graphique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
end;
/
prompt --application/pages/page_00740
begin
wwv_flow_api.create_page(
 p_id=>740.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section de graphique')
,p_step_title=>unistr('Cr\00E9er une section de graphique')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21406523537172813.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21407114664179699.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261363204569258801.4902)
,p_plug_name=>unistr('Cr\00E9er une section de graphique')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261474625315154102.4902)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436560900576942084.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261363407957258804.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21406523537172813.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261363832524258807.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21406523537172813.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261363630146258806.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21406523537172813.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261364204030258811.4902)
,p_branch_action=>'f?p=&APP_ID.:742:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(261363832524258807.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261364014478258808.4902)
,p_name=>'P740_DATA_GRID_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4902)
,p_item_default=>'DATA_GRID'
,p_prompt=>unistr('Grille de donn\00E9es')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une grille de donn\00E9es -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la grille de donn\00E9es \00E0 utiliser pour remplir le graphique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261376900027371013.4902)
,p_name=>'P740_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4902)
,p_prompt=>unistr('S\00E9quence d''affichage')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261377609293392684.4902)
,p_name=>'P740_TITLE'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4902)
,p_prompt=>'Titre de section'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262124824705602180.4902)
,p_name=>'P740_CHART_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4902)
,p_prompt=>'Type de graphique'
,p_source=>'return wwv_flow_item.text_from_lov(:p710_chart_type,''CHART_TYPE'');'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Type de graphique s\00E9lectionn\00E9. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428683227947684649.4902)
,p_name=>'P740_CHART_SOURCE'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4902)
,p_item_default=>'DATA_GRID'
,p_prompt=>'Source de graphique'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez le type de source du graphique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428698306448801460.4902)
,p_name=>'P740_REPORT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4902)
,p_prompt=>'Etat'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un \00E9tat -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez l''\00E9tat \00E0 utiliser pour remplir le graphique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428737702957923433.4902)
,p_name=>'P740_WEBSHEET_ID'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(21407114664179699.4902)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428752405961066251.4902)
,p_name=>'P740_WORKSHEET_ID'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(21407114664179699.4902)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(769439022514908016.4902)
,p_name=>'P740_SAVED_REPORT_ID'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4902)
,p_prompt=>unistr('Param\00E8tres d''\00E9tat \00E0 utiliser')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id r',
'from wwv_flow_worksheet_rpts',
'where worksheet_id = :P740_WORKSHEET_ID',
'and application_user = ''APXWS_DEFAULT''',
'and is_default = ''Y''                    ',
'and (security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and session_id is null'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P740_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un \00E9tat -')
,p_lov_cascade_parent_items=>'P740_WORKSHEET_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez les param\00E8tres d''\00E9tat \00E0 utiliser pour la grille de donn\00E9es ou l''\00E9tat s\00E9lectionn\00E9. Vous pouvez ainsi filtrer les lignes et les colonnes \00E0 afficher. Si aucun des \00E9tats enregistr\00E9s ne pr\00E9sente les param\00E8tres dont vous avez besoin, cr\00E9ez-le ')
||'maintenant avant d''ajouter la section.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(770955330628071177.4902)
,p_name=>'P740_REPORT_COLUMNS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(21407114664179699.4902)
,p_prompt=>'Report Columns'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(428745016378946272.4902)
,p_computation_sequence=>10
,p_computation_item=>'P740_WEBSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P740_CHART_SOURCE = ''DATA_GRID'' then',
'  return :P740_DATA_GRID_ID;',
'elsif :P740_CHART_SOURCE = ''REPORT'' then',
'  return :P740_REPORT_ID;',
'end if;',
'  '))
,p_compute_when=>'replace(:P740_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P740_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(428753515573087899.4902)
,p_computation_sequence=>20
,p_computation_item=>'P740_WORKSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P740_CHART_SOURCE = ''DATA_GRID'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P740_DATA_GRID_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'elsif :P740_CHART_SOURCE = ''REPORT'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P740_REPORT_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'end if;'))
,p_compute_when=>'replace(:P740_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P740_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(770974802016072332.4902)
,p_computation_sequence=>20
,p_computation_item=>'P740_REPORT_COLUMNS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select report_columns',
'           from wwv_flow_worksheet_rpts',
'           where worksheet_id = :p740_worksheet_id',
'           and security_group_id = :flow_security_group_id',
'           and id = :p740_saved_report_id',
'           and session_id is null)',
'loop',
'  return c1.report_columns;',
'end loop;'))
,p_compute_when=>'P740_SAVED_REPORT_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(428748111839992173.4902)
,p_validation_name=>'P740_DATA_GRID_ID not null'
,p_validation_sequence=>10
,p_validation=>'P740_DATA_GRID_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P740_CHART_SOURCE'
,p_validation_condition2=>'DATA_GRID'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(261363832524258807.4902)
,p_associated_item=>wwv_flow_api.id(261364014478258808.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(428748522574995338.4902)
,p_validation_name=>'P740_REPORT_ID not null'
,p_validation_sequence=>20
,p_validation=>'P740_REPORT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P740_CHART_SOURCE'
,p_validation_condition2=>'REPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(261363832524258807.4902)
,p_associated_item=>wwv_flow_api.id(428698306448801460.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(261382623585453517.4902)
,p_name=>'get data grid title'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_DATA_GRID_ID'
,p_condition_element=>'P740_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_cond=>'P740_DATA_GRID_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(261382912222453521.4902)
,p_event_id=>wwv_flow_api.id(261382623585453517.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P740_DATA_GRID_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P740_DATA_GRID_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(428701929781817609.4902)
,p_name=>'show hide data grid'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_CHART_SOURCE'
,p_condition_element=>'P740_CHART_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DATA_GRID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428702204856817609.4902)
,p_event_id=>wwv_flow_api.id(428701929781817609.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428702431656817610.4902)
,p_event_id=>wwv_flow_api.id(428701929781817609.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(428711509527849597.4902)
,p_name=>'show hide report'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_CHART_SOURCE'
,p_condition_element=>'P740_CHART_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428711801380849598.4902)
,p_event_id=>wwv_flow_api.id(428711509527849597.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428712030847849598.4902)
,p_event_id=>wwv_flow_api.id(428711509527849597.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(428715908189877604.4902)
,p_name=>'get report title'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_REPORT_ID'
,p_condition_element=>'P740_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428716206531877605.4902)
,p_event_id=>wwv_flow_api.id(428715908189877604.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P740_REPORT_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P740_REPORT_ID'
,p_attribute_08=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(769744919097935359.4902)
,p_name=>'reset data grid, report id, saved report id to null if source changes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_CHART_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(769745208133935360.4902)
,p_event_id=>wwv_flow_api.id(769744919097935359.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_REPORT_ID,P740_DATA_GRID_ID,P740_SAVED_REPORT_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(769836400313948837.4902)
,p_name=>'set data grid worksheet and websheet id'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_DATA_GRID_ID'
,p_condition_element=>'P740_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(769836711787948837.4902)
,p_event_id=>wwv_flow_api.id(769836400313948837.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WORKSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_DATA_GRID_ID'))
,p_attribute_07=>'P740_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(770006016720963068.4902)
,p_event_id=>wwv_flow_api.id(769836400313948837.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WEBSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_DATA_GRID_ID'))
,p_attribute_07=>'P740_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(770182331742976872.4902)
,p_name=>'set report worksheet and websheet id'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_REPORT_ID'
,p_condition_element=>'P740_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(770182616938976872.4902)
,p_event_id=>wwv_flow_api.id(770182331742976872.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WORKSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_REPORT_ID'))
,p_attribute_07=>'P740_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(770266430488985958.4902)
,p_event_id=>wwv_flow_api.id(770182331742976872.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WEBSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_REPORT_ID'))
,p_attribute_07=>'P740_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00742
begin
wwv_flow_api.create_page(
 p_id=>742.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section de graphique')
,p_step_title=>unistr('Cr\00E9er une section de graphique')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21413916573218059.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261388504493521133.4902)
,p_plug_name=>unistr('Cr\00E9er une section de graphique')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261474829471155310.4902)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436561331051950914.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261388704242521195.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21413916573218059.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261389116845521196.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21413916573218059.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261388900323521196.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21413916573218059.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:740:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261390303188521203.4902)
,p_branch_action=>'f?p=&APP_ID.:750:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(261389116845521196.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261393406410533693.4902)
,p_name=>'P742_CHART_LABEL'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_prompt=>unistr('Libell\00E9 du graphique')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P742_DATA_GRID_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une colonne -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme libell\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261396115891545900.4902)
,p_name=>'P742_LABEL_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_prompt=>unistr('Titre de l''axe pour le libell\00E9')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le titre \00E0 afficher sur l''axe associ\00E9 \00E0 la colonne utilis\00E9e comme libell\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261396329051549767.4902)
,p_name=>'P742_CHART_VALUE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_prompt=>'Valeur de graphique'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P742_DATA_GRID_NUM_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and c.column_type = ''NUMBER''',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and column_type = ''NUMBER''',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une colonne -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme valeur. Si la fonction est de type COUNT, vous n''avez pas besoin de s\00E9lectionner une valeur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261396504940552265.4902)
,p_name=>'P742_VALUE_TITLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_prompt=>'Titre de l''axe pour la valeur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le titre \00E0 afficher sur l''axe associ\00E9 \00E0 la colonne utilis\00E9e comme valeur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261398411089572910.4902)
,p_name=>'P742_CHART_FUNCTION'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_prompt=>'Fonction'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART FUNCTIONS'
,p_lov=>'.'||wwv_flow_api.id(261396928274568408.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une fonction -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la fonction \00E0 ex\00E9cuter sur la colonne utilis\00E9e comme valeur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261398613860573732.4902)
,p_name=>'P742_X'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261448315339630888.4902)
,p_name=>'P742_CHART_SORT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_item_default=>'DEFAULT'
,p_prompt=>'Trier'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SORT'
,p_lov=>'.'||wwv_flow_api.id(261446703779618102.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le sens de tri du graphique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621666736107538434.4902)
,p_name=>'P742_CHART_ORIENTATION'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4902)
,p_item_default=>'DEFAULT'
,p_prompt=>'Orientation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(107038275478210797.4902)||'.'
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le sens de tri du graphique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(622866606496034906.4902)
,p_validation_name=>'P742_CHART_VALUE not null'
,p_validation_sequence=>10
,p_validation=>'P742_CHART_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P742_CHART_FUNCTION'
,p_validation_condition2=>'COUNT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(261396329051549767.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00750
begin
wwv_flow_api.create_page(
 p_id=>750.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section de graphique')
,p_step_title=>unistr('Cr\00E9er une section de graphique')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21418604499242965.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>61
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261476811573205292.4902)
,p_plug_name=>unistr('Confirmer la cr\00E9ation de la section de graphique')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une section de graphique avec les attributs suivants. Confirmez vos s\00E9lections.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261479831296212615.4902)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436561528065959454.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>51
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261477013637205299.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21418604499242965.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261477420203205302.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21418604499242965.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261477215920205300.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21418604499242965.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:742:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261479201138205320.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(261477420203205302.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261477801442205304.4902)
,p_name=>'P750_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Titre de section'
,p_source=>'P740_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261478225076205307.4902)
,p_name=>'P750_CHART_LABEL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Libell\00E9 du graphique')
,p_source=>'P742_CHART_LABEL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P742_DATA_GRID_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261478403806205307.4902)
,p_name=>'P750_CHART_SOURCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Source de graphique'
,p_source=>'P740_WEBSHEET_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P750_CHART_SOURCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name||',
'       case when websheet_type=''DATA'' then '' (''||wwv_flow_lang.system_message(''DATA_GRID'')||'')''',
'            when websheet_type=''REPORT'' then '' (''||wwv_flow_lang.system_message(''REPORT'')||'')''',
'       end d,',
'       id r',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261481523247229241.4902)
,p_name=>'P750_CHART_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_prompt=>'Type de graphique'
,p_source=>'return wwv_flow_item.text_from_lov(:P710_CHART_TYPE,''CHART_TYPE'')'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262132610281881794.4902)
,p_name=>'P750_LABEL_TITLE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_prompt=>unistr('Titre de l''axe pour le libell\00E9')
,p_source=>'P742_LABEL_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262133012144891796.4902)
,p_name=>'P750_CHART_VALUE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_prompt=>'Valeur de graphique'
,p_source=>'P742_CHART_VALUE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P742_DATA_GRID_NUM_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and c.column_type = ''NUMBER''',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and column_type = ''NUMBER''',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262137723357904563.4902)
,p_name=>'P750_VALUE_TITLE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_prompt=>'Titre de l''axe pour la valeur'
,p_source=>'P742_VALUE_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262138724180914209.4902)
,p_name=>'P750_SORT'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_prompt=>'Trier'
,p_source=>'P742_CHART_SORT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CHART SORT'
,p_lov=>'.'||wwv_flow_api.id(261446703779618102.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262139209766919560.4902)
,p_name=>'P750_CHART_FUNCTION'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_prompt=>'Fonction'
,p_source=>'P742_CHART_FUNCTION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CHART FUNCTIONS'
,p_lov=>'.'||wwv_flow_api.id(261396928274568408.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429658830581943501.4902)
,p_name=>'P750_SAVED_REPORT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Param\00E8tres d''\00E9tat \00E0 utiliser')
,p_source=>'P740_SAVED_REPORT_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P740_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431069802828044934.4902)
,p_name=>'P750_DISPLAY_SEQ'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('S\00E9quence d''affichage')
,p_source=>'P740_DISPLAY_SEQ'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621666683956538433.4902)
,p_name=>'P750_CHART_ORIENTATION'
,p_item_sequence=>165
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4902)
,p_prompt=>'Orientation'
,p_source=>'P742_CHART_ORIENTATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(107038275478210797.4902)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(261479020815205310.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create chart section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (    ',
'    p_ws_app_id             => :ws_app_id,',
'    p_webpage_id            => :P900_ID,',
'    p_section_type          => ''CHART'',',
'    p_display_seq           => :P740_DISPLAY_SEQ,',
'    p_title                 => :P740_TITLE,    ',
'    --',
'    p_data_grid_id          => :P740_WEBSHEET_ID,',
'    p_report_id             => :P740_SAVED_REPORT_ID,',
'    --    ',
'    p_chart_type             => :P710_CHART_TYPE,',
'    p_chart_label            => replace(:P742_CHART_LABEL,''%''||''null%''),',
'    p_label_axis_title       => :P742_LABEL_TITLE,',
'    p_chart_value            => replace(:P742_CHART_VALUE,''%''||''null%''),',
'    p_value_axis_title       => :P742_VALUE_TITLE,',
'    p_chart_aggregate        => replace(:P742_CHART_FUNCTION,''%''||''null%''),',
'    p_chart_sorting          => replace(:P742_CHART_SORT,''%''||''null%''),',
'    p_chart_orientation      => :P742_CHART_ORIENTATION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la section de donn\00E9es.')
,p_process_when_button_id=>wwv_flow_api.id(261477420203205302.4902)
,p_process_success_message=>unistr('Section de graphique cr\00E9\00E9e.')
);
end;
/
prompt --application/pages/page_00760
begin
wwv_flow_api.create_page(
 p_id=>760.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier la section de graphique'
,p_step_title=>'Modifier la section de graphique'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16850611110835501.4902)
,p_plug_name=>'Modifier une section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16851016651837010.4902)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16851420114838049.4902)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16852127040840026.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18673205084790014.4902)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(293373002605789454.4902)
,p_plug_name=>'Attributs de section de graphique'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(293377205444789470.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936769878944729563.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16851016651837010.4902)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4902)
,p_button_image_alt=>unistr('Menu Param\00E8tres')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936770026675730926.4902)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16851016651837010.4902)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293377611010789479.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(293377205444789470.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293377811025789479.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(293377205444789470.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293377430562789471.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(293377205444789470.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16851219419837010.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16851016651837010.4902)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16858602499861356.4902)
,p_branch_action=>'f?p=&APP_ID.:&P760_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P760_NEXT_SECTION_PAGE_ID.:&P760_NEXT_SECTION_ITEM_NAME.:&P760_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(293383022622789505.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16853000696840028.4902)
,p_name=>'P760_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16853219047840028.4902)
,p_name=>'P760_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16853413690840028.4902)
,p_name=>'P760_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20226306961820031.4902)
,p_name=>'P760_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121268678889561216.4902)
,p_name=>'P760_CHART_ORIENTATION'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Orientation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(107038275478210797.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez l''orientation du graphique. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373231959789455.4902)
,p_name=>'P760_SECTION_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373420373789458.4902)
,p_name=>'P760_TITLE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Titre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373619157789459.4902)
,p_name=>'P760_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>unistr('S\00E9quence')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373829530789459.4902)
,p_name=>'P760_WEBSHEET_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_prompt=>'Data Grid:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293374010377789460.4902)
,p_name=>'P760_WEBSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_prompt=>'Websheet ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293388714347819418.4902)
,p_name=>'P760_CHART_TYPE'
,p_is_required=>true
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Type de graphique'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P760_CHART_TYPE'
,p_lov=>'.'||wwv_flow_api.id(444797819996488091.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le type de graphique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293402730193842903.4902)
,p_name=>'P760_CHART_LABEL'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>unistr('Libell\00E9 du graphique')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P760_DATA_GRID_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme libell\00E9. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293402915087847946.4902)
,p_name=>'P760_CHART_VALUE'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Valeur de graphique'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P760_DATA_GRID_NUM_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'and c.column_type = ''NUMBER''',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id',
'and column_type = ''NUMBER'')',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une colonne -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la colonne \00E0 utiliser comme valeur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293403432056852908.4902)
,p_name=>'P760_LABEL_AXIS_TITLE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>unistr('Titre de l''axe pour le libell\00E9')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le titre \00E0 afficher sur l''axe associ\00E9 \00E0 la colonne utilis\00E9e comme libell\00E9. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293403607945855380.4902)
,p_name=>'P760_VALUE_AXIS_TITLE'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Titre de l''axe pour la valeur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le titre \00E0 afficher sur l''axe associ\00E9 \00E0 la colonne utilis\00E9e comme valeur. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293403826299860683.4902)
,p_name=>'P760_FUNCTION'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Fonction'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART FUNCTIONS'
,p_lov=>'.'||wwv_flow_api.id(261396928274568408.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une fonction -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la fonction \00E0 ex\00E9cuter sur la colonne utilis\00E9e comme valeur. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293404005998864316.4902)
,p_name=>'P760_SORT'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Trier'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SORT'
,p_lov=>'.'||wwv_flow_api.id(261446703779618102.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le sens de tri du graphique. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429669330028028427.4902)
,p_name=>'P760_SAVED_REPORT_ID'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>unistr('Param\00E8tres d''\00E9tat \00E0 utiliser')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P760_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie les param\00E8tres d''\00E9tat utilis\00E9s pour la grille de donn\00E9es ou l''\00E9tat s\00E9lectionn\00E9. Pour utiliser des param\00E8tres d''\00E9tat diff\00E9rents, vous devez supprimer et recr\00E9er la section.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430264430653526530.4902)
,p_name=>'P760_REPORT_COLUMNS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_prompt=>'Report Columns'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430733221841580527.4902)
,p_name=>'P760_WORKSHEET_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430965306584191770.4902)
,p_name=>'P760_WEBSHEET_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_prompt=>'Type de source'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifie le type de source de graphique. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430967428532207560.4902)
,p_name=>'P760_DATA_GRID_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de grille de donn\00E9es')
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P760_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':2:''||:APP_SESSION||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||:WS_APP_ID||'',''||:P760_WORKSHEET_ID||'',''||:P760_WEBSHEET_ID||''" class="goToLink">''|'
||'|wwv_flow_lang.system_message(''WS_VIEW_DATA_GRID'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P760_WEBSHEET_TYPE'
,p_display_when2=>'DATA_GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifie la grille de donn\00E9es utilis\00E9e pour remplir le graphique. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430969527194235556.4902)
,p_name=>'P760_REPORT_NAME'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P760_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':3000:''||:APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||:WS_APP_ID||'',''||:P760_WORKSHEET_ID||'',''||:P760_WEBSHEET_ID||''" class="goToLink">''||wwv_f'
||'low_lang.system_message(''APEXIR_VIEW_REPORT'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P760_WEBSHEET_TYPE'
,p_display_when2=>'REPORT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie l''\00E9tat utilis\00E9 pour remplir le graphique. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(813762811200738734.4902)
,p_name=>'P760_CHANGE_COUNT'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20021111567553355.4902)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P760_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(9495409627921389.4902)
,p_validation_name=>'P760_CHART_LABEL not null'
,p_validation_sequence=>10
,p_validation=>'P760_CHART_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(293402730193842903.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(813847224753771090.4902)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id             => :WS_APP_ID,',
'    p_page_id               => :P900_ID,',
'    p_section_id            => :P760_SECTION_ID,',
'    p_change_count          => :P760_CHANGE_COUNT,',
'    --',
'    p_display_seq           => :P760_DISPLAY_SEQ,',
'    p_title                 => :P760_TITLE,   ',
'    --',
'    p_data_grid_id          => :P760_WEBSHEET_ID,',
'    p_report_id             => :P760_SAVED_REPORT_ID,',
'    --    ',
'    p_chart_type            => :P760_CHART_TYPE,',
'    p_chart_label           => :P760_CHART_LABEL,',
'    p_label_axis_title      => :P760_LABEL_AXIS_TITLE,',
'    p_chart_value           => replace(:P760_CHART_VALUE,''%''||''null%''),',
'    p_value_axis_title      => :P760_VALUE_AXIS_TITLE,',
'    p_chart_aggregate       => replace(:P760_FUNCTION,''%''||''null%''),',
'    p_chart_sorting         => :P760_SORT,',
'    p_chart_orientation     => :P760_CHART_ORIENTATION',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(121268775059561217.4902)
,p_name=>'Visibility of Pie Options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P760_CHART_TYPE'
,p_condition_element=>'P760_CHART_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'pie'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(121268856702561218.4902)
,p_event_id=>wwv_flow_api.id(121268775059561217.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P760_LABEL_AXIS_TITLE,P760_VALUE_AXIS_TITLE,P760_CHART_ORIENTATION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(121268934556561219.4902)
,p_event_id=>wwv_flow_api.id(121268775059561217.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P760_LABEL_AXIS_TITLE,P760_VALUE_AXIS_TITLE,P760_CHART_ORIENTATION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293382827985789499.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save chart section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (   ',
'    p_ws_app_id             => :ws_app_id,     ',
'    p_webpage_id            => :P900_ID,',
'    p_section_id            => :P760_SECTION_ID,',
'    p_section_type          => ''CHART'',',
'    p_display_seq           => :P760_DISPLAY_SEQ,',
'    p_title                 => :P760_TITLE,   ',
'    --',
'    p_data_grid_id          => :P760_WEBSHEET_ID,',
'    p_report_id             => :P760_SAVED_REPORT_ID,',
'    --    ',
'    p_chart_type            => :P760_CHART_TYPE,',
'    p_chart_label           => :P760_CHART_LABEL,',
'    p_label_axis_title      => :P760_LABEL_AXIS_TITLE,',
'    p_chart_value           => replace(:P760_CHART_VALUE,''%''||''null%''),',
'    p_value_axis_title      => :P760_VALUE_AXIS_TITLE,',
'    p_chart_aggregate       => replace(:P760_FUNCTION,''%''||''null%''),',
'    p_chart_sorting         => :P760_SORT,',
'    p_chart_orientation     => :P760_CHART_ORIENTATION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer la section des donn\00E9es.')
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Section de donn\00E9es enregistr\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293382410880789495.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P760_SECTION_ID,',
'    p_section_type     => ''CHART'',',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la section.'
,p_process_when_button_id=>wwv_flow_api.id(293377430562789471.4902)
,p_process_success_message=>unistr('Section supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293382606613789497.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch chart section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_chart_section (',
'  p_section_id           => :P760_SECTION_ID,',
'  p_section_type         => ''CHART'',',
'  -- out  ',
'  p_display_seq          => :P760_DISPLAY_SEQ,     ',
'  p_title                => :P760_TITLE,',
'  p_worksheet_id         => :P760_WORKSHEET_ID,',
'  p_websheet_type        => :P760_WEBSHEET_TYPE,',
'  p_websheet_id          => :P760_WEBSHEET_ID,',
'  p_websheet_name        => :P760_WEBSHEET_NAME,  ',
'  p_report_id            => :P760_SAVED_REPORT_ID,',
'  p_report_columns       => :P760_REPORT_COLUMNS,',
'  --',
'  p_chart_type           => :P760_CHART_TYPE,',
'  p_chart_label          => :P760_CHART_LABEL,',
'  p_label_axis_title     => :P760_LABEL_AXIS_TITLE,',
'  p_chart_value          => :P760_CHART_VALUE,',
'  p_value_axis_title     => :P760_VALUE_AXIS_TITLE,',
'  p_chart_aggregate      => :P760_FUNCTION,',
'  p_chart_sorting        => :P760_SORT,',
'  p_chart_orientation    => :P760_CHART_ORIENTATION,',
'  p_change_count         => :P760_CHANGE_COUNT',
'  );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''extraire la section de donn\00E9es.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471215106441767363.4902)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00888
begin
wwv_flow_api.create_page(
 p_id=>888.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Vous \00EAtes maintenant d\00E9connect\00E9')
,p_step_title=>unistr('Vous \00EAtes maintenant d\00E9connect\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(53193408981633671.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(823024031730159043.4902)
,p_plug_name=>unistr('Vous \00EAtes maintenant d\00E9connect\00E9')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('Vous avez \00E9t\00E9 d\00E9connect\00E9.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_api.create_page(
 p_id=>900.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Page'
,p_step_title=>'&P900_PAGE_NAME.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.ebaLeftColumn {',
'  padding: 10px 0 10px 10px;',
'  display: table-cell;',
'  width: 220px;',
'}',
'body .tree-default li a,',
'body .tree-default li a:hover, body .tree-default li a.hover, body .tree-default li span {',
'padding: 4px 8px !important;',
'}'))
,p_step_template=>wwv_flow_api.id(3700422714748.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3700425732560.4902)
,p_plug_name=>'Colonne de gauche'
,p_region_css_classes=>'ebaLeftColumn'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(3700433754276.4902)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'null;',
'--wwv_flow_ws_webpage.show_navigation_only (',
'--    p_ws_app_id         => :WS_APP_ID,',
'--    p_webpage_id        => :p900_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14135027279837704.4902)
,p_plug_name=>'Control Panel'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.control_panel (',
'    p_app_id      => :app_id,',
'    p_session     => :app_session,',
'    p_ws_app_id   => :ws_app_id,',
'    p_ws_page_id  => :P900_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_required_role=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173530904554100763.4902)
,p_plug_name=>'Fichiers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_attachments (',
'    p_ws_app_id   => :ws_app_id,',
'    p_webpage_id  => :p900_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.page_annotation_exists (',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id      => :p900_id,',
'    p_annotation_type => ''ATTACHMENT'');'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173993913692886038.4902)
,p_plug_name=>'Web Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_include_nav_section varchar2(1);',
'begin',
'  /*if wwv_flow_ws_webpage.nav_section_exists (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P900_ID) then',
'    l_include_nav_section := ''Y'';',
'  else',
'    l_include_nav_section := ''N'';',
'  end if;*/',
'',
'  wwv_flow_ws_webpage.show (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :p900_id,    ',
'    p_request     => :REQUEST);',
'    --p_include_nav_section => l_include_nav_section',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185291823656333041.4902)
,p_plug_name=>'Hierarchical Page List with Child Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id       => :WS_APP_ID,   ',
'    p_app_session     => :app_session,',
'    p_page_id         => :P900_ID,',
'    p_image_prefix    => ''#IMAGE_PREFIX#'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251648912659488984.4902)
,p_plug_name=>'Remarques'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="apex-ws-annotations"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_notes (',
'    p_session        => :app_session,',
'    p_ws_app_id    => :ws_app_id,',
'    p_webpage_id  => :p900_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.page_annotation_exists (',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id      => :p900_id,',
'    p_annotation_type => ''NOTE'');'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251655526830616039.4902)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253850701461144946.4902)
,p_plug_name=>'Balises'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_tags (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P900_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.page_annotation_exists (',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id      => :p900_id,',
'    p_annotation_type => ''TAG'');'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(290400321962259604.4902)
,p_plug_name=>'Footer Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_07'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p900_footer (',
'    p_app_id          => :app_id,',
'    p_ws_app_id       => :ws_app_id,',
'    p_page_id         => :p900_id,',
'    p_app_session     => :app_session',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsFooter">'
,p_plug_footer=>'</div>'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9303319377230427.4902)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(173530904554100763.4902)
,p_button_name=>'ADD_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4902)
,p_button_image_alt=>'Ajouter un fichier'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4020:&SESSION.::&DEBUG.:4020::'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="addIcon"'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9305107481293173.4902)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(251648912659488984.4902)
,p_button_name=>'ADD_NOTE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4902)
,p_button_image_alt=>'Ajouter une remarque'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4030:&SESSION.::&DEBUG.:4030::'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="addIcon"'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9304109989274947.4902)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(253850701461144946.4902)
,p_button_name=>'ADD_TAG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4902)
,p_button_image_alt=>'Ajouter une balise'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4040:&SESSION.::&DEBUG.:4040::'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="addIcon"'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9303010111208753.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(173530904554100763.4902)
,p_button_name=>'VIEW_FILES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4902)
,p_button_image_alt=>'Visualiser les fichiers'
,p_button_position=>'EXPAND'
,p_button_redirect_url=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:RIR:IRC_PAGE_NAME:&P900_PAGE_NAME.'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="viewAllIcon"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9305415446295478.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(251648912659488984.4902)
,p_button_name=>'VIEW_NOTES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4902)
,p_button_image_alt=>'Visualiser les remarques'
,p_button_position=>'EXPAND'
,p_button_redirect_url=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:RIR:IRC_PAGE_NAME:&P900_PAGE_NAME.'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="viewAllIcon"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9304316569276885.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(253850701461144946.4902)
,p_button_name=>'VIEW_TAGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4902)
,p_button_image_alt=>'Visualiser les balises'
,p_button_position=>'EXPAND'
,p_button_redirect_url=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.:RIR:IRC_PAGE_NAME:&P900_PAGE_NAME.'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="viewAllIcon"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178548705774056302.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173532304470119605.4902)
,p_name=>'P900_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(251655526830616039.4902)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471970208476732743.4902)
,p_name=>'P900_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(251655526830616039.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(795545130800771079.4902)
,p_name=>'P900_SELECTED_NODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(251655526830616039.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(257126318389641735.4902)
,p_computation_sequence=>10
,p_computation_item=>'WS_APP_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ws_app_id from wwv_flow_ws_webpages where id = :P900_ID;',
''))
,p_compute_when=>'WS_APP_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187891606886292635.4902)
,p_computation_sequence=>30
,p_computation_item=>'APP_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) n',
'from wwv_flow_ws_applications ',
'where id = :WS_APP_ID and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174066317868558402.4902)
,p_computation_sequence=>40
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'900'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(471970417133735260.4902)
,p_computation_sequence=>50
,p_computation_item=>'P900_PAGE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n',
'from WWV_FLOW_WS_WEBPAGES ',
'where ws_app_id = :WS_APP_ID and security_group_id = :flow_security_group_id and id = :P900_ID'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253745513836041604.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete attachment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_doc_id number := null;',
'begin',
'  l_doc_id := replace(:REQUEST,''DELETE_ATTACHMENT_'');',
'  wwv_flow_ws_attachment.delete_doc (',
'    p_doc_id   => l_doc_id',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de supprimer la pi\00E8ce jointe.')
,p_process_when=>':REQUEST like ''DELETE_ATTACHMENT_%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253745924356054016.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_note_id number := null;',
'begin',
'  l_note_id := replace(:REQUEST,''DELETE_NOTE_'');',
'  wwv_flow_ws_api.delete_note (',
'    p_note_id   => l_note_id',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la remarque.'
,p_process_when=>':REQUEST like ''DELETE_NOTE_%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253750008361219755.4902)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete tag'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_tag_id number := null;',
'begin',
'  l_tag_id := replace(:REQUEST,''DELETE_TAG_'');',
'  wwv_flow_ws_api.delete_tag (',
'    p_tag_id   => l_tag_id',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la balise.'
,p_process_when=>':REQUEST like ''DELETE_TAG_%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1003383025772157176.4902)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SET ACCESSIBILITY MODE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :REQUEST = ''SET_ACCESSIBILITY_OFF'' then',
'  htmldb_util.set_session_screen_reader_off;',
'  htmldb_util.set_session_high_contrast_off;',
'elsif :REQUEST = ''SET_SESSION_SCREEN_READER_ON'' then',
'  htmldb_util.set_session_screen_reader_on;',
'  htmldb_util.set_session_high_contrast_off;',
'elsif :REQUEST = ''SET_SESSION_HIGH_CONTRAST_ON'' then',
'  htmldb_util.set_session_high_contrast_on;',
'  htmldb_util.set_session_screen_reader_off;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'''SET_ACCESSIBILITY_OFF'',''SET_SESSION_SCREEN_READER_ON'',''SET_SESSION_HIGH_CONTRAST_ON'''
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00901
begin
wwv_flow_api.create_page(
 p_id=>901.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Vue de pr\00E9sentation')
,p_step_title=>'&P900_PAGE_NAME.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(75962824844186301.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(75856500380178545.4902)
,p_plug_name=>'Web Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_webpage.show (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :p900_id,    ',
'    p_request     => :REQUEST,    ',
'    p_presentation_mode => ''Y'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(75856709579178547.4902)
,p_plug_name=>'Breadcrumbs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_slide_breadcrumbs (',
'    p_ws_app_id       => :WS_APP_ID,   ',
'    p_app_session     => :app_session,',
'    p_page_id         => :P900_ID,',
'    p_image_prefix    => ''#IMAGE_PREFIX#'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(800674711428354357.4902)
,p_plug_name=>'Presentation Controls'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="wspSlideOptions">'');',
'sys.htp.p(''  <a href="javascript:void(0);" id="prevSectionButton"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="''||wwv_flow_lang.system_message(''LAYOUT.PREVIOUS_BUTTON'')||''" /></a>'');',
'sys.htp.p(''    <input type="text" id="slideJump" title="''||wwv_flow_lang.system_message(''SECTIONS'')||''"/>'');',
'sys.htp.p(''    <span class="totalSlides"><em>/</em><span id="totalSlides"></span></span>'');',
'sys.htp.p(''  <a href="javascript:void(0);" id="nextSectionButton"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="''||wwv_flow_lang.system_message(''LAYOUT.NEXT_BUTTON'')||''" /></a>'');',
'sys.htp.p(''  <a href="#" id="togglePosition" style="display: none">Toggle</a>'');',
'sys.htp.p(''  <a href="f?p=&APP_ID.:900:&APP_SESSION." class="closeButton"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="''||wwv_flow_lang.system_message(''LAYOUT.CLOSE_BUTTON'')||''" /></a>'');',
'sys.htp.p(''</div>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75857709288178548.4902)
,p_name=>'P901_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00902
begin
wwv_flow_api.create_page(
 p_id=>902.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Donn\00E9es')
,p_step_title=>unistr('Donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20482400388361999.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1000
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178727025146420288.4902)
,p_plug_name=>'Data'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select type, name, alias, the_link, status, websheet_id, worksheet_id, ',
'       created_on, created_by, updated_on, updated_by, img, embed_tag',
'  from',
'(select ',
'   wwv_flow_lang.system_message(''DATA_GRID'') type,',
'   a.websheet_name name, ',
'   a.websheet_alias alias,',
'   ''ws?p=''||:WS_APP_ID||'':DG_''||a.websheet_alias||'':''||:APP_SESSION the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.updated_on,',
'   lower(a.updated_by) updated_by,',
'   a.created_on,',
'   lower(a.created_by) created_by,',
'   ''#IMAGE_PREFIX#ws/img/icons/icon-ws-data-grid.png'' img,',
'   ''[[ datagrid: ''||lower(a.websheet_alias)||'' ]]'' embed_tag, ''1'' show',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''DATAGRID'')',
'union all',
'select ',
'   wwv_flow_lang.system_message(''REPORT'') type,',
'   a.websheet_name name, ',
'   a.websheet_alias alias,',
'   ''f?p=''||:APP_ID||'':3000:''||',
'      :APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||a.ws_app_id||'',''||w.id||',
'      '',''||a.id the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.updated_on,',
'   lower(a.updated_by) updated_by,',
'   a.created_on,',
'   lower(a.created_by) created_by,',
'   ''#IMAGE_PREFIX#ws/img/icons/icon-ws-report.png'' img,',
'   ''[[ report: ''||lower(a.websheet_alias)||'' ]]'' embed_tag, ',
'   case when (wwv_flow_ws_security.sql_enabled_inst_yn = ''Y'' ',
'    and wwv_flow_ws_security.sql_enabled_yn(775) = ''Y'') ',
'    then ''1'' else ''0'' end show',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''REPORT'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''REPORT''))'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P902_SHOW'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<div class="clear"></div>'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   wwv_flow_lang.system_message(''DATA_GRID'') type,',
'   w.name name, ',
'   a.websheet_alias alias,',
'   ''f?p=''||:APP_ID||'':2:''||',
'      :APP_SESSION||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||',
'      a.ws_app_id||'',''||w.id||',
'      '',''||a.id the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.created_on,',
'   a.created_by,',
'   ''#IMAGE_PREFIX#menu/interactive_page_64.gif'' img,',
'   ''[[ datagrid: ''||lower(a.websheet_alias)||'' ]]'' embed_tag',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''DATAGRID'')',
'union all',
'select ',
'   wwv_flow_lang.system_message(''REPORT'') type,',
'   w.name name, ',
'   a.websheet_alias alias,',
'   ''f?p=''||:APP_ID||'':3000:''||',
'      :APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||a.ws_app_id||'',''||w.id||',
'      '',''||a.id the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.created_on,',
'   a.created_by,',
'   ''#IMAGE_PREFIX#menu/report_64.gif'' img,',
'   ''[[ report: ''||lower(a.websheet_alias)||'' ]]'' embed_tag',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''REPORT'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''REPORT'')'))
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(178727117027420288.4902)
,p_name=>'Data'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 d\00E9finie.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'THE_LINK'
,p_icon_view_img_src_column=>'IMG'
,p_icon_view_label_column=>'NAME'
,p_icon_view_columns_per_row=>7
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178727330296420308.4902)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom'
,p_column_link=>'#THE_LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178727400573420314.4902)
,p_db_column_name=>'THE_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Lien'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178727513130420314.4902)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178742525016546760.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178742614480546761.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185808623998060900.4902)
,p_db_column_name=>'IMG'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(186433400249098947.4902)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Feuille Web'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(186433532151098949.4902)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(458514110355764730.4902)
,p_db_column_name=>'TYPE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_display_condition=>'P902_SHOW'
,p_display_condition2=>'REPORT:DATAGRID'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(458520110027916055.4902)
,p_db_column_name=>'ALIAS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468143130998993657.4902)
,p_db_column_name=>'EMBED_TAG'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Imbriquer la balise'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(204656304904400586.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(204656415860400592.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178832210805267347.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187089104016586622.4902)
,p_plug_name=>unistr('Liste de vue des donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(187087619151586620.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458503124760683707.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cette page vous permet de choisir la grille de donn\00E9es ou l''\00E9tat \00E0 ex\00E9cuter. Cliquez sur l''onglet <b>Grilles de donn\00E9es</b> pour n''afficher que la grille de donn\00E9es ou sur l''onglet <b>Etats</b> pour n''afficher que les \00E9tats.</p>'),
'',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458937708651341308.4902)
,p_plug_name=>unistr('Grilles de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les grilles de donn\00E9es vous permettent de g\00E9rer les donn\00E9es tabulaires. Vous pouvez ajouter des lignes et des colonnes selon vos besoins. Les donn\00E9es de ces grilles peuvent \00EAtre affich\00E9es dans les sections des pages sous forme d''\00E9tats ou de graphi')
||'ques.</p>',
'',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P902_SHOW = ''DATAGRID'' or nvl(:P902_SHOW,''ALL'') = ''ALL'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458937914192342938.4902)
,p_plug_name=>'Etats'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Les \00E9tats sont bas\00E9s sur des requ\00EAtes SQL et sont accessibles en lecture seule. Vous pouvez contr\00F4ler l''affichage, le filtrage et le tri des colonnes, et cr\00E9er des graphiques illustrant ces donn\00E9es. Les donn\00E9es des \00E9tats peuvent \00EAtre affich\00E9es dan')
||unistr('s les sections des pages sous forme d''\00E9tats ou de graphiques.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P902_SHOW = ''REPORT'' or nvl(:P902_SHOW,''ALL'') = ''ALL'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468144604594005049.4902)
,p_plug_name=>'Imbriquer les balises'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>La balise imbriqu\00E9e affiche la syntaxe utilis\00E9e pour inclure un lien vers l''\00E9tat ou la grille de donn\00E9es \00E0 partir d''une section de page.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459950222043604207.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:902,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(292572704374860078.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4902)
,p_button_name=>'VIEW_SAVED_RPTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('Visualiser les \00E9tats enregistr\00E9s')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:RP::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461369508843608456.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4902)
,p_button_name=>'CREATE_DATA_GRID'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4902)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er une grille de donn\00E9es')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:205,1310,1320::'
,p_button_condition=>'P902_SHOW'
,p_button_condition2=>'DATAGRID'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461370003086616244.4902)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4902)
,p_button_name=>'CREATE_DATA_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4902)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un \00E9tat')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:205,1310,1320::'
,p_button_condition=>'P902_SHOW'
,p_button_condition2=>'REPORT'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178840308390342342.4902)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4902)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4902)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:1310,1320::'
,p_button_condition=>'nvl(:P902_SHOW,''x'') not in (''DATAGRID'',''REPORT'')'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186437031117136227.4902)
,p_branch_action=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186434908130120083.4902)
,p_name=>'P902_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20482400388361999.4902)
,p_item_default=>'ALL'
,p_prompt=>'Show:'
,p_source=>'ALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le type d''\00E9tat \00E0 afficher.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(178840523974346853.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'902'
);
end;
/
prompt --application/pages/page_00903
begin
wwv_flow_api.create_page(
 p_id=>903.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Fichiers'
,p_step_title=>'Fichiers'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178833106434275510.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178838607304313668.4902)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178842714109381854.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez ajouter des fichiers aux grilles de donn\00E9es et aux pages. Utilisez cette page pour visualiser tous les fichiers de cette application.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253998509295980827.4902)
,p_plug_name=>'Attachments'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, n001,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''FILE_LABEL'',c007)) delete_ck,',
'       n001 id,',
'       n002 ws_app_id,',
'       (select name from wwv_flow_ws_applications where id = n002 and security_group_id=:flow_security_group_id) app_name,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id = n003 and ws_app_id = n002 and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id = n004 and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id = n004 and ws_app_id = n002 and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       ''<a class="attachment_link" href="''||wwv_flow_ws_attachment.get_ws_file_src(n001)||''" title="''||wwv_flow_escape.html_attribute(c008)||''">''||c002||''</a>'' file_name,',
'       c003 image_alias,',
'       c004 image_attributes,      ',
'       null content,',
'       d001 content_last_update,',
'       c012 mime_type,',
'       c006 content_charset,',
'       c007 content_filename,',
'       c008 description,',
'       d002 created_on,',
'       lower(c009) created_by,',
'       d003 updated_on,',
'       lower(c010) updated_by,',
'       to_number(nvl(c011,''0'')) content_size,',
'       c007 icon_name,',
'       ''f?p=4900:912:''||:app_session||''::::WS_APP_ID,P912_ID:''||:WS_APP_ID||'',''||n001 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-file.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_FILES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(253998604086980827.4902)
,p_name=>'Attachments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:912:WS_APP_ID,P912_ID:&WS_APP_ID.,#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'ICON_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(215460110811270128.4902)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'AM'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999020619980835.4902)
,p_db_column_name=>'APP_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999204012980836.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::p900_id,ws_app_id:#WEBPAGE_ID#,#WS_APP_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999430469980836.4902)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>unistr('Grille de donn\00E9es')
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_WEBSHEET_ID,P2_ID:&WS_APP_ID.,#WEBSHEET_ID#,#WORKSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999619710980838.4902)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Niveau'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000024473980838.4902)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>6
,p_column_identifier=>'M'
,p_column_label=>'Type MIME'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000105627980838.4902)
,p_db_column_name=>'CONTENT_CHARSET'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>unistr('Jeu de caract\00E8res de contenu')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000309479980839.4902)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000432139980839.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>9
,p_column_identifier=>'Q'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000523034980839.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'R'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254115025775224528.4902)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>11
,p_column_identifier=>'U'
,p_column_label=>unistr('Grille de donn\00E9es s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123507785370672.4902)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>12
,p_column_identifier=>'V'
,p_column_label=>'Nom de fichier'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123625843370672.4902)
,p_db_column_name=>'ICON_NAME'
,p_display_order=>13
,p_column_identifier=>'W'
,p_column_label=>unistr('Nom d''ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123702955370672.4902)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>14
,p_column_identifier=>'X'
,p_column_label=>unistr('Image de l''ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123821404370673.4902)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>15
,p_column_identifier=>'Y'
,p_column_label=>unistr('Lien de l''ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836316153477235.4902)
,p_db_column_name=>'CONTENT'
,p_display_order=>16
,p_column_identifier=>'Z'
,p_column_label=>'Contenu'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836425540477236.4902)
,p_db_column_name=>'CONTENT_LAST_UPDATE'
,p_display_order=>17
,p_column_identifier=>'AA'
,p_column_label=>unistr('Derni\00E8re mise \00E0 jour du contenu')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836525864477236.4902)
,p_db_column_name=>'CONTENT_FILENAME'
,p_display_order=>18
,p_column_identifier=>'AB'
,p_column_label=>'Nom de fichier de contenu'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836605211477236.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>19
,p_column_identifier=>'AC'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836720825477237.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>20
,p_column_identifier=>'AD'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(455844323794484348.4902)
,p_db_column_name=>'IMAGE_ALIAS'
,p_display_order=>21
,p_column_identifier=>'AE'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(455844408787484351.4902)
,p_db_column_name=>'IMAGE_ATTRIBUTES'
,p_display_order=>22
,p_column_identifier=>'AF'
,p_column_label=>'Attributs'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266321739448004.4902)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'AG'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266413762448008.4902)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>24
,p_column_identifier=>'AH'
,p_column_label=>unistr('Application s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266526969448008.4902)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>25
,p_column_identifier=>'AI'
,p_column_label=>unistr('Page s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266631391448008.4902)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>26
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Grille de donn\00E9es s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266714150448009.4902)
,p_db_column_name=>'ROW_ID'
,p_display_order=>27
,p_column_identifier=>'AK'
,p_column_label=>'ID de ligne'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(506407832739687549.4902)
,p_db_column_name=>'CONTENT_SIZE'
,p_display_order=>28
,p_column_identifier=>'AL'
,p_column_label=>'Taille de fichier'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455860417850078707.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(253998509295980827.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:903,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(215736217437300382.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(253998509295980827.4902)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>unistr('Supprimer les \00E9l\00E9ments coch\00E9s')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455075728117987482.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'903'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(216398515770829833.4902)
,p_validation_name=>'must select files to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Les fichiers \00E0 supprimer doivent \00EAtre indiqu\00E9s.')
,p_when_button_pressed=>wwv_flow_api.id(215736217437300382.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045581730769367914.4902)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(253998509295980827.4902)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045581854494367915.4902)
,p_event_id=>wwv_flow_api.id(2045581730769367914.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216337302480816498.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_attachment.delete_doc (',
'    p_doc_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer les fichiers.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(215736217437300382.4902)
,p_process_success_message=>unistr('Fichier(s) supprim\00E9(s).')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253865428595436595.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create attachment collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_attachment_collection (',
'    p_ws_app_id    => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection.')
);
end;
/
prompt --application/pages/page_00904
begin
wwv_flow_api.create_page(
 p_id=>904.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Balises'
,p_step_title=>'Balises'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178833511282276941.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178841427914357467.4902)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254015026794200479.4902)
,p_plug_name=>'Tags'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,n001,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''TAG_LABEL'',wwv_flow_escape.html(c002) ))||wwv_flow_item.hidden(2,n004)||wwv_flow_item.hidden(3,n005) delete_ck,',
'       n001 id,',
'       n002 ws_app_id,',
'       (select name from wwv_flow_ws_applications where id=to_number(n002) and security_group_id=:flow_security_group_id) app_name,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       c002 tag,',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,           ''f?p=4900:913:''||:app_session||''::::WS_APP_ID,P913_ID:''||:ws_app_id||'',''||n001 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-tag.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_TAGS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(254015101399200479.4902)
,p_name=>'Tags'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:913:&SESSION.::&DEBUG.:913:WS_APP_ID,P913_ID:&WS_APP_ID.,#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'TAG'
,p_icon_view_title_text=>'#PAGE_NAME#'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(217062512550046490.4902)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'W'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254015505263200486.4902)
,p_db_column_name=>'APP_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254015705868200486.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254015915131200486.4902)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>unistr('Grille de donn\00E9es')
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,#WORKSHEET_ID#,#WEBSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016105535200487.4902)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Niveau'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016224943200487.4902)
,p_db_column_name=>'TAG'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Balise'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016320667200487.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016412897200487.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016519720200487.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016631211200488.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255837324689545892.4902)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>11
,p_column_identifier=>'O'
,p_column_label=>'ID de feuille de calcul'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255837408454545892.4902)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>12
,p_column_identifier=>'P'
,p_column_label=>unistr('Lien de l''ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255837509997545892.4902)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>13
,p_column_identifier=>'Q'
,p_column_label=>unistr('Image de l''ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468318722581959111.4902)
,p_db_column_name=>'ID'
,p_display_order=>14
,p_column_identifier=>'R'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468318825419959112.4902)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>15
,p_column_identifier=>'S'
,p_column_label=>unistr('Application s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468318925521959112.4902)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>16
,p_column_identifier=>'T'
,p_column_label=>unistr('Page s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468319025753959113.4902)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>17
,p_column_identifier=>'U'
,p_column_label=>unistr('Feuille Web s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468319124883959113.4902)
,p_db_column_name=>'ROW_ID'
,p_display_order=>18
,p_column_identifier=>'V'
,p_column_label=>unistr('Ligne s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459069409427022751.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez utiliser des balises pour faciliter la recherche et l''organisation du contenu. Vous pouvez baliser les pages et les lignes de grille de donn\00E9es.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(457294104555926987.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(254015026794200479.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217107102639053085.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(254015026794200479.4902)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>unistr('Supprimer les \00E9l\00E9ments coch\00E9s')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455076111625992229.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'904'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(217122108179054722.4902)
,p_validation_name=>'must select tags to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Les balises \00E0 supprimer doivent \00EAtre indiqu\00E9es.')
,p_when_button_pressed=>wwv_flow_api.id(217107102639053085.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045581906703367916.4902)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(254015026794200479.4902)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045582057080367917.4902)
,p_event_id=>wwv_flow_api.id(2045581906703367916.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217137013720056285.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.delete_tag (',
'    p_tag_id         => wwv_flow.g_f01(i),',
'    p_websheet_id    => wwv_flow.g_f02(i),',
'    p_row_id         => wwv_flow.g_f03(i)',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer les balises.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(217107102639053085.4902)
,p_process_success_message=>unistr('Balise(s) supprim\00E9e(s).')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(254013515649190350.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create tag collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_tag_collection (',
'    p_ws_app_id    => :WS_APP_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection.')
);
end;
/
prompt --application/pages/page_00905
begin
wwv_flow_api.create_page(
 p_id=>905.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Remarques'
,p_step_title=>'Remarques'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178833921325279839.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178841631031358270.4902)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178845117141401629.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez ajouter des remarques aux lignes des grilles de donn\00E9es et aux pages. Les remarques vous permettent de saisir un commentaire sur le contenu.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(255846828818688350.4902)
,p_plug_name=>'Notes'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,n001,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'    wwv_flow_lang.system_message(''NOTE_LABEL'',wwv_flow_escape.html(c002))',
') delete_ck,',
'       n001 id,',
'       n002 ws_app_id,',
'       (select name from wwv_flow_ws_applications where id = n002 and security_group_id=:flow_security_group_id) app_name,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id = n003 and ws_app_id = n002 and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id = n004 and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id = n002 and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       substr(c002,1,255) content,',
'       substr(c002,1,25) short_content_str,',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,    ',
'       ''f?p=4900:914:''||:app_session||'':::914:WS_APP_ID,P914_ID:''||:WS_APP_ID||'',''||n001 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-note.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_NOTES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(255846907421688350.4902)
,p_name=>'Notes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:914:&SESSION.::&DEBUG.:914:WS_APP_ID,P914_ID:&WS_APP_ID.,#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'SHORT_CONTENT_STR'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(216493801619854176.4902)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'X'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847327303688360.4902)
,p_db_column_name=>'APP_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847528785688360.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847705165688361.4902)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>unistr('Grille de donn\00E9es s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847815498688361.4902)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>unistr('Grille de donn\00E9es')
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,#WORKSHEET_ID#,#WEBSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848000730688361.4902)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Niveau'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848106005688361.4902)
,p_db_column_name=>'CONTENT'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>'Remarque'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848230986688361.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848319906688362.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848431948688362.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848520550688362.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'O'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848601377688362.4902)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>12
,p_column_identifier=>'P'
,p_column_label=>'Lien'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848724775688362.4902)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>13
,p_column_identifier=>'Q'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255849126439697754.4902)
,p_db_column_name=>'SHORT_CONTENT_STR'
,p_display_order=>14
,p_column_identifier=>'R'
,p_column_label=>unistr('Courte cha\00EEne de contenu')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468284710769652942.4902)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'S'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468284830411652942.4902)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>16
,p_column_identifier=>'T'
,p_column_label=>unistr('Application s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468284923837652942.4902)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>17
,p_column_identifier=>'U'
,p_column_label=>unistr('Page s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468285003913652943.4902)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>18
,p_column_identifier=>'V'
,p_column_label=>unistr('Grille de donn\00E9es s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468285114403652943.4902)
,p_db_column_name=>'ROW_ID'
,p_display_order=>19
,p_column_identifier=>'W'
,p_column_label=>unistr('Ligne s\00E9lectionn\00E9e')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(457292318276921480.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(255846828818688350.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(216585325298870404.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(255846828818688350.4902)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>unistr('Supprimer les \00E9l\00E9ments coch\00E9s')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455076625477996183.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'905'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(216615403612873638.4902)
,p_validation_name=>'must select notes to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Les remarques \00E0 supprimer doivent \00EAtre indiqu\00E9es.')
,p_when_button_pressed=>wwv_flow_api.id(216585325298870404.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045582148887367918.4902)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(255846828818688350.4902)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045582210366367919.4902)
,p_event_id=>wwv_flow_api.id(2045582148887367918.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216600231186872101.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked notes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.delete_note (',
'    p_note_id        => wwv_flow.g_f01(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer les remarques.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(216585325298870404.4902)
,p_process_success_message=>unistr('Remarque(s) supprim\00E9e(s).')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(255845516826676042.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create note collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_note_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la collection.')
);
end;
/
prompt --application/pages/page_00906
begin
wwv_flow_api.create_page(
 p_id=>906.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Annotations'
,p_step_title=>'Annotations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187171600866872737.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187172721816905251.4902)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(255851308915773521.4902)
,p_plug_name=>'Annotations'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select n001 id,',
'       wwv_flow_item.text_from_lov(''ATTACHMENT'',''ANNOTATION TYPE'') annotation_type,       ',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       c002 annotation_name,',
'       ''f?p=4900:912:''||:app_session||'':::912:WS_APP_ID,P912_ID:''||',
'          :WS_APP_ID||'',''||n001 edit_url,       ',
'       d002 created_on,',
'       lower(c009) created_by,',
'       d003 updated_on,',
'       lower(c010) updated_by,',
'       c007 icon_name,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-file.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_FILES''',
'union all',
'select n001 id,',
'       wwv_flow_item.text_from_lov(''TAG'',''ANNOTATION TYPE'') annotation_type,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       substr(c002,1,255) annotation_name,',
'       ''f?p=4900:913:''||:app_session||'':::913:WS_APP_ID,P913_ID:''||',
'          :ws_app_id||'',''||n001 edit_url,',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,',
'       c002 icon_name,    ',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-tag.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_TAGS''',
'union all',
'select n001 id,',
'       wwv_flow_item.text_from_lov(''NOTE'',''ANNOTATION TYPE'') annotation_type,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       substr(c002,1,255) annotation_name,',
'       ''f?p=4900:914:''||:app_session||'':::914:WS_APP_ID,P914_ID:''||',
'          :ws_app_id||'',''||n001 edit_url,        ',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,',
'       substr(c002,1,25) icon_name,    ',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-note.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_NOTES''',
'union all',
'select n003 id,',
'       wwv_flow_item.text_from_lov(''LINK'',''ANNOTATION TYPE'') annotation_type,',
'       null webpage_id,',
'       null page_name,',
'       n001 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n001) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n001 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       to_number(c003) row_id,',
'       ''ROW'' component_level,',
'       substr(c001,1,255) annotation_name,',
'       ''f?p=4900:916:''||:app_session||'':::916:WS_APP_ID,P916_ID:''||',
'          :ws_app_id||'',''||n003 edit_url,        ',
'       d001 created_on,',
'       lower(c005) created_by,',
'       d002 updated_on,',
'       lower(c006) updated_by,',
'       substr(c001,1,25) icon_name,    ',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-link.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_LINKS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(255851412641773521.4902)
,p_name=>'Annotations'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'#EDIT_URL#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'EDIT_URL'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'ICON_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852005950773543.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852225637773544.4902)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'ID de feuille de calcul'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852309332773544.4902)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Grille de donn\00E9es')
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,#WORKSHEET_ID#,#WEBSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852511097773544.4902)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Niveau'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(455012825948829772)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852728494773546.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852805571773546.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852910617773546.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255853021972773546.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255853110913773547.4902)
,p_db_column_name=>'ICON_NAME'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Nom d''ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255853322750773547.4902)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Image de l''ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255854313681798109.4902)
,p_db_column_name=>'ANNOTATION_TYPE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Type d''annotation'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(457286624070866412.4902)
,p_db_column_name=>'ANNOTATION_NAME'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Annotation'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(457286720645866413.4902)
,p_db_column_name=>'EDIT_URL'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758308584087246.4902)
,p_db_column_name=>'ID'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758413655087251.4902)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Page Web'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758505213087251.4902)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Feuille Web'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758628616087252.4902)
,p_db_column_name=>'ROW_ID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Ligne'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458959507555586977.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez annoter les pages et les donn\00E9es dans les grilles de donn\00E9es avec des fichiers, des remarques et des balises.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458962423532620027.4902)
,p_plug_name=>'Fichiers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez attacher des fichiers et des images aux pages et aux lignes de grille de donn\00E9es.  </p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458962906956643565.4902)
,p_plug_name=>'Balises'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez ajouter des balises aux pages et aux lignes de grille de donn\00E9es.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458963413883645600.4902)
,p_plug_name=>'Remarques'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez ajouter des remarques aux pages et aux lignes de grille de donn\00E9es. Les remarques ne sont pas accessibles \00E0 tous.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(636365309755668891.4902)
,p_plug_name=>'Liens'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous ne pouvez ajouter des liens qu''aux lignes de grille de donn\00E9es.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455858606984066110.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(255851308915773521.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:906,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455075113226983193.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'906'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(454878913193530039.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create annotations collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_attachment_collection (',
'    p_ws_app_id    => :ws_app_id',
'    );',
'wwv_flow_ws_api.create_tag_collection (',
'    p_ws_app_id    => :WS_APP_ID',
'    );',
'wwv_flow_ws_api.create_note_collection (',
'    p_ws_app_id => :ws_app_id',
'    );',
'wwv_flow_ws_api.create_link_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00908
begin
wwv_flow_api.create_page(
 p_id=>908.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Copier une page'
,p_step_title=>'Copier une page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10604302945264867.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188038326108736234.4902)
,p_plug_name=>'Copier une page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436571609692152874.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_COPY_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486257504103048552.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10604302945264867.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486257708807048555.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(10604302945264867.4902)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Copier une page'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(486258017609052488.4902)
,p_branch_action=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(486257708807048555.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20335603319481351.4902)
,p_name=>'P908_NEW_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(188038326108736234.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471671317758579229.4902)
,p_name=>'P908_COPY_PAGE_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(188038326108736234.4902)
,p_prompt=>unistr('Copier la page \00E0 partir de')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la page \00E0 copier.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471671528839582487.4902)
,p_name=>'P908_COPY_TO_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(188038326108736234.4902)
,p_prompt=>'Nouveau nom de page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_from_page_name varchar2(4000) := null;',
'begin',
'  for c1 in (select name',
'             from wwv_flow_ws_webpages',
'             where ws_app_id = :WS_APP_ID',
'             and security_group_id = :flow_security_group_id',
'             and id = :P908_COPY_PAGE_FROM)',
'  loop',
'      l_from_page_name := c1.name;',
'  end loop;',
'  return wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',l_from_page_name);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le nom de la nouvelle page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(486259417871071420.4902)
,p_validation_name=>'P908_COPY_TO_PAGE_NAME'
,p_validation_sequence=>10
,p_validation=>'P908_COPY_TO_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Valeur obligatoire'
,p_when_button_pressed=>wwv_flow_api.id(486257708807048555.4902)
,p_associated_item=>wwv_flow_api.id(471671528839582487.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486257219210043510.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.copy_page (',
'    p_ws_app_id        => :ws_app_id,',
'    p_webpage_id       => :p900_id,',
'    p_new_name         => :P908_COPY_TO_PAGE_NAME,',
'    --',
'    p_new_page_id      => :P908_NEW_PAGE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>unistr('Page copi\00E9e.')
);
end;
/
prompt --application/pages/page_00910
begin
wwv_flow_api.create_page(
 p_id=>910.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Nouvelle section'
,p_step_title=>'Nouvelle section'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174268512533615218.4902)
,p_plug_name=>'Text Section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174271304004645983.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(217644509082961167.4902)
,p_plug_name=>unistr('Syntaxe SQL de grille de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.data_grid_sql_help (',
'    p_app_id       => :app_id,',
'    p_app_session  => :app_session,',
'    p_ws_app_id    => :ws_app_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>unistr('Pour visualiser la syntaxe SQL de grille de donn\00E9es, cliquez sur un nom de grille de donn\00E9es :')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436563711798030455.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_TEXT_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174271912792658011.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(174271304004645983.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174272226645661950.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(174271304004645983.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174374610834991383.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(174271304004645983.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(174272529571661951.4902)
,p_branch_action=>'f?p=&FLOW_ID.:900:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(174272226645661950.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18723303895978880.4902)
,p_name=>'P910_METHOD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4902)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('M\00E9thode')
,p_source=>'NORMAL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE TEXT SECTION METHOD'
,p_lov=>'.'||wwv_flow_api.id(18725515716010637.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18730825582055709.4902)
,p_name=>'P910_COLUMN_HEADINGS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4902)
,p_item_default=>'Y'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FIRST_ROW_CONTAINS_COLUMN_HEADINGS'
,p_lov=>'.'||wwv_flow_api.id(799517811838484369.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174269508244628245.4902)
,p_name=>'P910_SECTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4902)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174270318633631244.4902)
,p_name=>'P910_TITLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4902)
,p_prompt=>'Titre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174425118771833503.4902)
,p_name=>'P910_DISPLAY_SEQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4902)
,p_prompt=>unistr('S\00E9quence')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(379982713574846288.4902)
,p_name=>'P910_CONTENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4902)
,p_prompt=>'Contenu'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Entrez le contenu de la section de page. Pour modifier le formatage, cliquez sur l''ic\00F4ne D\00E9velopper la barre d''outils dans le coin sup\00E9rieur droit. Pour plus d''informations sur la syntaxe de balisage, reportez-vous \00E0 l''aide en ligne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_section_clob ( ',
'    p_item_name        => ''P910_CONTENT'',',
'    p_section_id       => :P910_SECTION_ID);'))
,p_attribute_02=>'CKEDITOR-Full'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(380327123317877450.4902)
,p_name=>'P910_SPREADSHEET'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4902)
,p_prompt=>unistr('Coller les donn\00E9es de feuille de calcul')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P910_METHOD'
,p_display_when2=>'SPREADSHEET'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Collez la feuille de calcul \00E0 deux colonnes ou les autres donn\00E9es d\00E9limit\00E9es par des tabulations. La premi\00E8re colonne doit contenir le titre de la section et la seconde, son contenu.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174458707081161234.4902)
,p_computation_sequence=>10
,p_computation_item=>'P910_DISPLAY_SEQ'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174540423282260522.4902)
,p_validation_name=>'P910_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P910_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La s\00E9quence d''affichage doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'NORMAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4902)
,p_associated_item=>wwv_flow_api.id(174425118771833503.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174540832286263166.4902)
,p_validation_name=>'P910_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P910_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le titre doit \00EAtre indiqu\00E9.')
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'NORMAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4902)
,p_associated_item=>wwv_flow_api.id(174270318633631244.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(487999914043996835.4902)
,p_validation_name=>'P910_CONTENT contains valid sql'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_content clob;',
'begin',
'  l_content := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P910_CONTENT'');  ',
'  ',
'  return wwv_flow_ws_security.str_contains_valid_sql (',
'    p_ws_app_id    => :WS_APP_ID,',
'    p_page_id      => :P900_ID,',
'    p_section_id   => :P910_SECTION_ID,',
'    p_string       => l_content);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'NORMAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(397544527893902326.4902)
,p_validation_name=>'P910_SPREADSHEET not null'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_spreadsheet clob;',
'begin',
'  l_spreadsheet := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P910_SPREADSHEET'');',
'  ',
'  if (nvl(sys.dbms_lob.getlength(l_spreadsheet),0) = 0) then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Pour cr\00E9er des sections, vous devez coller des donn\00E9es de feuille de calcul.')
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'SPREADSHEET'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(18756032619185846.4902)
,p_name=>'show hide upload spreadsheet item'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P910_METHOD'
,p_condition_element=>'P910_METHOD'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NORMAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18756323145185847.4902)
,p_event_id=>wwv_flow_api.id(18756032619185846.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_COLUMN_HEADINGS,P910_SPREADSHEET'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18756511288185847.4902)
,p_event_id=>wwv_flow_api.id(18756032619185846.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_COLUMN_HEADINGS,P910_SPREADSHEET'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(18757120629191891.4902)
,p_name=>'show hide seq, title, content'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P910_METHOD'
,p_condition_element=>'P910_METHOD'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPREADSHEET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18757410206191891.4902)
,p_event_id=>wwv_flow_api.id(18757120629191891.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_DISPLAY_SEQ,P910_TITLE,P910_CONTENT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18757607040191891.4902)
,p_event_id=>wwv_flow_api.id(18757120629191891.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_DISPLAY_SEQ,P910_TITLE,P910_CONTENT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(174539227999252468.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create new section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_section_id       => :P910_SECTION_ID,   ',
'    p_ws_app_id        => :WS_APP_ID, ',
'    p_webpage_id       => :P900_ID,',
'    p_section_type     => ''TEXT'',',
'    p_display_seq      => :P910_DISPLAY_SEQ,',
'    p_title            => :P910_TITLE,',
'    --',
'    p_clob_item_name   => ''P910_CONTENT'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la section.')
,p_process_when_button_id=>wwv_flow_api.id(174272226645661950.4902)
,p_process_when=>'P910_METHOD'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NORMAL'
,p_process_success_message=>unistr('Section cr\00E9\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18729515201048337.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create multiple section from spreadsheet'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_import.import_text_sections (    ',
'    p_ws_app_id           => :WS_APP_ID,        ',
'    p_webpage_id          => :P900_ID,',
'    p_collection_name     => ''P910_SPREADSHEET'',',
'    p_headings_included   => :P910_COLUMN_HEADINGS',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er les sections de texte.')
,p_process_when_button_id=>wwv_flow_api.id(174272226645661950.4902)
,p_process_when=>'P910_METHOD'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SPREADSHEET'
,p_process_success_message=>unistr('Sections de texte cr\00E9\00E9es.')
);
end;
/
prompt --application/pages/page_00912
begin
wwv_flow_api.create_page(
 p_id=>912.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('D\00E9tails de fichier')
,p_step_title=>unistr('D\00E9tails de fichier')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20825624122113669.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454921121386829978.4902)
,p_plug_name=>unistr('D\00E9tails de fichier')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454925804722991135.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454996211966466267.4902)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456339419601597354.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Vous pouvez modifier le nom et l''alias de votre fichier. Vous pouvez r\00E9f\00E9rencer ce fichier dans n''importe quelle page \00E0 l''aide de l''image ou de la syntaxe du fichier (reportez-vous \00E0 Aide > Syntaxe de balisage).</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(456220226828170850)
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(454996400668472429.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4902)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la page'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P912_PAGE_ID.'
,p_button_condition=>'P912_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(454997519977496975.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4902)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la ligne'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P912_WORKSHEET_ID.,&P912_DATA_GRID_ID.,&P912_ROW_ID.'
,p_button_condition=>'P912_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455024118479988502.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(456296125835249091.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE2'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(456293003971214419.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(456293413667217260.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454927807155067573.4902)
,p_name=>'P912_FILENAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom de fichier'
,p_source=>'''<a href="''||wwv_flow_ws_attachment.get_ws_file_src(to_number(:P912_ID))||''">''||wwv_flow_escape.html(:P912_FILENAME)||''</a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_help_text=>'Identifie le nom du fichier.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454928020661071393.4902)
,p_name=>'P912_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Texte d\00E9crivant le fichier. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454928813866078946.4902)
,p_name=>'P912_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>unistr('Grille de donn\00E9es')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P912_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la grille de donn\00E9es \00E0 laquelle le fichier est attach\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454929223216081604.4902)
,p_name=>'P912_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P912_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la page \00E0 laquelle le fichier est attach\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454929614343088547.4902)
,p_name=>'P912_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>unistr('Cr\00E9\00E9')
,p_format_mask=>'SINCE'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Affiche la date de t\00E9l\00E9chargement du fichier. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454929929927093047.4902)
,p_name=>'P912_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>unistr('Cr\00E9ation par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie l''utilisateur ayant t\00E9l\00E9charg\00E9 le fichier. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454930108241096224.4902)
,p_name=>'P912_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>unistr('Mis \00E0 jour')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la date de la derni\00E8re mise \00E0 jour de la d\00E9finition du fichier.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454930705732114408.4902)
,p_name=>'P912_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>unistr('Mis \00E0 jour par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie l''utilisateur \00E0 l''origine de la derni\00E8re mise \00E0 jour du fichier. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454995621615440707.4902)
,p_name=>'P912_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(20825624122113669.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454996028803461699.4902)
,p_name=>'P912_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20825624122113669.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454999414399542710.4902)
,p_name=>'P912_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20825624122113669.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455012320969818934.4902)
,p_name=>'P912_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>'Niveau d''annotation'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le niveau d''annotation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455846709212527413.4902)
,p_name=>'P912_IMAGE_ALIAS'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Un alias de fichier permet d''imbriquer des liens de t\00E9l\00E9chargement ou d''image dans les sections d''une page. Chaque alias de fichier doit \00EAtre unique dans une application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455846927220532619.4902)
,p_name=>'P912_IMAGE_ATTRIBUTES'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4902)
,p_prompt=>'Attributs d''image'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez les attributs de fichier suppl\00E9mentaires \00E0 inclure dans le lien d''image, tels que la hauteur, la largeur, le texte Alt ou le titre. '),
'',
'<p>width="36"</p>',
'<p>title="my image"</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6730817016243915.4902)
,p_validation_name=>'P912_IMAGE_ALIAS is valid'
,p_validation_sequence=>10
,p_validation=>'P912_IMAGE_ALIAS'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('L''alias doit \00EAtre alphanum\00E9rique.')
,p_validation_condition=>'P912_IMAGE_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(456296125835249091.4902)
,p_associated_item=>wwv_flow_api.id(455846709212527413.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2077294070799630404.4902)
,p_validation_name=>'P912_IMAGE_ALIAS must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_id           => :P912_ID,',
'    p_alias        => :P912_IMAGE_ALIAS,',
'    p_alias_type   => ''FILE'') then',
'    return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Cet alias existe d\00E9j\00E0. Entrez-en un autre.')
,p_validation_condition=>'P912_IMAGE_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(455846709212527413.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(456295425358239503.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete attachment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_attachment.delete_doc (',
'    p_doc_id    => :P912_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer le fichier.'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Fichier supprim\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(456306916194350402.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change img attr'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_attachment.change_image_attr (',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_file_id          => :P912_ID,',
'    p_page_id          => :P912_PAGE_ID, ',
'    p_image_alias      => :P912_IMAGE_ALIAS,',
'    p_image_attributes => :P912_IMAGE_ATTRIBUTES,',
'    p_description      => :P912_DESCRIPTION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer les mises \00E0 jour du fichier.')
,p_process_when_button_id=>wwv_flow_api.id(456296125835249091.4902)
,p_process_success_message=>unistr('Mises \00E0 jour de fichier enregistr\00E9es.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(454995411919437874.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get attachment info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_attachment_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P912_ID,',
'    p_component_level => :P912_COMPONENT_LEVEL,',
'    p_webpage_id      => :P912_PAGE_ID,',
'    p_worksheet_id    => :P912_WORKSHEET_ID,',
'    p_websheet_id     => :P912_DATA_GRID_ID,',
'    p_row_id          => :P912_ROW_ID,    ',
'    p_name            => :P912_FILENAME,',
'    p_image_alias     => :P912_IMAGE_ALIAS,',
'    p_image_attributes => :P912_IMAGE_ATTRIBUTES,',
'    p_description     => :P912_DESCRIPTION,',
'    p_created_on      => :P912_CREATED,',
'    p_created_by      => :P912_CREATED_BY,',
'    p_updated_on      => :P912_UPDATED,',
'    p_updated_by      => :P912_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''obtenir les informations de pi\00E8ce jointe.')
);
end;
/
prompt --application/pages/page_00913
begin
wwv_flow_api.create_page(
 p_id=>913.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('D\00E9tails de balise')
,p_step_title=>unistr('D\00E9tails de balise')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132335222168705130.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455028903657058336.4902)
,p_plug_name=>unistr('D\00E9tails de balise')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455031730948058349.4902)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455077823315014545.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455031921901058350.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4902)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la page'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P913_PAGE_ID.'
,p_button_condition=>'P913_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455032120704058351.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4902)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la ligne'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P913_WORKSHEET_ID.,&P913_DATA_GRID_ID.,&P913_ROW_ID.'
,p_button_condition=>'P913_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455032319023058352.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626877529699552002.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(626877321041549461.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029112237058339.4902)
,p_name=>'P913_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(132335222168705130.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029331137058341.4902)
,p_name=>'P913_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(132335222168705130.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029520826058341.4902)
,p_name=>'P913_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(132335222168705130.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029706994058342.4902)
,p_name=>'P913_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>'Niveau d''annotation'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le niveau d''annotation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030314177058344.4902)
,p_name=>'P913_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>unistr('Grille de donn\00E9es')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P913_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la grille de donn\00E9es \00E0 laquelle la balise est ajout\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030505077058345.4902)
,p_name=>'P913_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P913_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la page \00E0 laquelle la balise est ajout\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030709396058345.4902)
,p_name=>'P913_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>unistr('Cr\00E9\00E9')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Date de cr\00E9ation de la balise. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030925696058346.4902)
,p_name=>'P913_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>unistr('Cr\00E9ation par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Utilisateur ayant cr\00E9\00E9 la balise. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455031115888058346.4902)
,p_name=>'P913_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>unistr('Mis \00E0 jour')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Date de la derni\00E8re mise \00E0 jour de la d\00E9finition de la balise.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455031329370058347.4902)
,p_name=>'P913_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>unistr('Mis \00E0 jour par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Utilisateur \00E0 l''origine de la derni\00E8re mise \00E0 jour de la balise. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455072104690914526.4902)
,p_name=>'P913_TAG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4902)
,p_prompt=>'Balise'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la balise d\00E9finie.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626877030260542686.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete tag'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_tag (',
'    p_tag_id         => :P913_ID,',
'    p_websheet_id    => :P913_DATA_GRID_ID,',
'    p_row_id         => :P913_ROW_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la balise.'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Balise supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(455032518299058353.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get tag info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_tag_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P913_ID,',
'    p_component_level => :P913_COMPONENT_LEVEL,',
'    p_webpage_id      => :P913_PAGE_ID,',
'    p_worksheet_id    => :P913_WORKSHEET_ID,',
'    p_websheet_id     => :P913_DATA_GRID_ID,',
'    p_row_id          => :P913_ROW_ID,    ',
'    p_tag             => :P913_TAG,   ',
'    p_created_on      => :P913_CREATED,',
'    p_created_by      => :P913_CREATED_BY,',
'    p_updated_on      => :P913_UPDATED,',
'    p_updated_by      => :P913_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''obtenir les informations de balise.'
);
end;
/
prompt --application/pages/page_00914
begin
wwv_flow_api.create_page(
 p_id=>914.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('D\00E9tail de remarque')
,p_step_title=>unistr('D\00E9tail de remarque')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(126670928141987745.4902)
,p_plug_name=>'Toolbar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(139891328812587007.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455080213732034100.4902)
,p_plug_name=>'Note Details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455084129596044740.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455082826806034113.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4902)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la page'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P914_PAGE_ID.'
,p_button_condition=>'P914_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455083012275034115.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4902)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la ligne'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P914_WORKSHEET_ID.,&P914_DATA_GRID_ID.,&P914_ROW_ID.'
,p_button_condition=>'P914_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(458497018601587323.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CHANGE'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455083231583034115.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(458497605573593064.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(458497817136593066.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455080402345034106.4902)
,p_name=>'P914_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(139891328812587007.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455080624318034107.4902)
,p_name=>'P914_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(139891328812587007.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455080810711034107.4902)
,p_name=>'P914_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(139891328812587007.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081000524034108.4902)
,p_name=>'P914_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>'Niveau d''annotation'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le niveau d''annotation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081210912034108.4902)
,p_name=>'P914_NOTE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>'Remarque'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez le contenu de la remarque.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081401089034109.4902)
,p_name=>'P914_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>unistr('Grille de donn\00E9es')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P914_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la grille de donn\00E9es \00E0 laquelle la remarque est ajout\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081632086034109.4902)
,p_name=>'P914_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P914_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la page \00E0 laquelle la remarque est ajout\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081814247034110.4902)
,p_name=>'P914_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>unistr('Cr\00E9\00E9')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Date de cr\00E9ation de la remarque. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455082027328034110.4902)
,p_name=>'P914_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>unistr('Cr\00E9ation par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Utilisateur ayant cr\00E9\00E9 la remarque. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455082224099034111.4902)
,p_name=>'P914_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>unistr('Mis \00E0 jour')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Date de la derni\00E8re mise \00E0 jour de la d\00E9finition de la remarque.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455082418097034111.4902)
,p_name=>'P914_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4902)
,p_prompt=>unistr('Mis \00E0 jour par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Utilisateur \00E0 l''origine de la derni\00E8re mise \00E0 jour de la remarque. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(458498722935626413.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_note (',
'    p_note_id        => :P914_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Echec de la suppression de la remarque.'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Remarque supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(458499128738647021.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_note (',
'    p_ws_app_id        => :ws_app_id,        ',
'    p_webpage_id       => :p900_id,',
'    p_note_id          => :P914_ID,',
'    p_component_level  => :P914_COMPONENT_LEVEL,',
'    p_content          => :P914_NOTE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Echec de la mise \00E0 jour de la remarque.')
,p_process_when_button_id=>wwv_flow_api.id(458497018601587323.4902)
,p_process_success_message=>unistr('Remarque mise \00E0 jour.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(455083627741034117.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get note info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_note_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P914_ID,',
'    p_component_level => :P914_COMPONENT_LEVEL,',
'    p_webpage_id      => :P914_PAGE_ID,',
'    p_worksheet_id    => :P914_WORKSHEET_ID,',
'    p_websheet_id     => :P914_DATA_GRID_ID,',
'    p_row_id          => :P914_ROW_ID,    ',
'    p_note            => :P914_NOTE,   ',
'    p_created_on      => :P914_CREATED,',
'    p_created_by      => :P914_CREATED_BY,',
'    p_updated_on      => :P914_UPDATED,',
'    p_updated_by      => :P914_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''obtenir les informations de remarque.'
);
end;
/
prompt --application/pages/page_00915
begin
wwv_flow_api.create_page(
 p_id=>915.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Liens'
,p_step_title=>'Liens'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473082104205043499.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473082812327046503.4902)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473373204887098955.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Des liens peuvent \00EAtre ajout\00E9s aux lignes de grille de donn\00E9es. Utilisez cet \00E9tat pour visualiser tous les liens de toutes les grilles de donn\00E9es.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(479800700877656094.4902)
,p_plug_name=>'Links'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select   wwv_flow_item.checkbox(1,n003,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''LINK_LABEL'',wwv_flow_escape.html(c001) )) delete_ck,',
'         n003 id,',
'         n001 data_grid_id,',
'         n002 ws_app_id,',
'         d001 created_on,',
'         d002 updated_on,',
'         c001 link_name,',
'         c002 url,',
'         c003 row_id,',
'         c004 tags,',
'         c005 created_by,',
'         c006 updated_by,',
'       ''f?p=4900:916:''||:app_session||'':::916:WS_APP_ID,P916_ID:''||:WS_APP_ID||'',''||n003 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-link.png'' icon_img,',
'              ''f?p=4900:20:''||:app_session||''::::''||',
'           ''WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:''||',
'           :WS_APP_ID||'',''||(select worksheet_id from wwv_flow_ws_websheet_attr where id   = n001)||'',''||n001||'',''||c003 view_row',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_LINKS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(479800812105656094.4902)
,p_name=>'Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:916:&SESSION.::&DEBUG.:916:P916_ID:#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'LINK_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(216816623052907614.4902)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'O'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801000325656111.4902)
,p_db_column_name=>'DATA_GRID_ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('Grille de donn\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801128596656111.4902)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801231613656111.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801330084656111.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801428974656112.4902)
,p_db_column_name=>'LINK_NAME'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Nom de lien'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801530840656112.4902)
,p_db_column_name=>'URL'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Cible d''URL'
,p_column_link=>'#URL#'
,p_column_linktext=>'#URL#'
,p_column_link_attr=>'target="_blank"'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801606667656112.4902)
,p_db_column_name=>'ROW_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Ligne'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801730173656112.4902)
,p_db_column_name=>'TAGS'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Balises'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801813339656112.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801900811656112.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479802025414656113.4902)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480517403932027960.4902)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Lien'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480549407245218078.4902)
,p_db_column_name=>'VIEW_ROW'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Visualiser la ligne'
,p_column_link=>'#VIEW_ROW#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(626918628236396345.4902)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481106817753672204.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(479800700877656094.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:915:&SESSION.::&DEBUG.:915,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(216880524915917657.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(479800700877656094.4902)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>unistr('Supprimer les \00E9l\00E9ments coch\00E9s')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(479782522981566331.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'915'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(216895501151920223.4902)
,p_validation_name=>'must select links to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Les liens \00E0 supprimer doivent \00EAtre indiqu\00E9s.')
,p_when_button_pressed=>wwv_flow_api.id(216880524915917657.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045582355681367920.4902)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(479800700877656094.4902)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045582445103367921.4902)
,p_event_id=>wwv_flow_api.id(2045582355681367920.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216910409116922484.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked links'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.delete_link (',
'    p_link_id        => wwv_flow.g_f01(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer les liens.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(216880524915917657.4902)
,p_process_success_message=>unistr('Lien(s) supprim\00E9(s).')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(479782313285563541.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_link_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00916
begin
wwv_flow_api.create_page(
 p_id=>916.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('D\00E9tails de lien')
,p_step_title=>unistr('D\00E9tails de lien')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133321202391746654.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(626909330617315176.4902)
,p_plug_name=>unistr('D\00E9tails de lien')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(626914105678315194.4902)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(626920511707448372.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914701991315196.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4902)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la page'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P916_PAGE_ID.'
,p_button_condition=>'P916_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914932512315196.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4902)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Visualiser la ligne'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P916_WORKSHEET_ID.,&P916_DATA_GRID_ID.,&P916_ROW_ID.'
,p_button_condition=>'P916_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914515453315195.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CHANGE'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626915131935315197.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914311761315194.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(626916104629315205.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626909516329315180.4902)
,p_name=>'P916_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(133321202391746654.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626909728940315182.4902)
,p_name=>'P916_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(133321202391746654.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626909911465315183.4902)
,p_name=>'P916_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(133321202391746654.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626910101419315183.4902)
,p_name=>'P916_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>'Niveau d''annotation'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le niveau d''annotation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626910600476315185.4902)
,p_name=>'P916_LINK_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>'Nom de lien'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>7
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez le nom du lien.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626911106974315188.4902)
,p_name=>'P916_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>unistr('Grille de donn\00E9es')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P916_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la grille de donn\00E9es \00E0 laquelle le lien est ajout\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626911610186315190.4902)
,p_name=>'P916_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P916_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie la page \00E0 laquelle le lien est ajout\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626912109851315191.4902)
,p_name=>'P916_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>unistr('Cr\00E9\00E9')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Date de cr\00E9ation du lien. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626912625729315192.4902)
,p_name=>'P916_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>unistr('Cr\00E9ation par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Utilisateur ayant cr\00E9\00E9 le lien. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626913118602315192.4902)
,p_name=>'P916_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>unistr('Mis \00E0 jour')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Date de la derni\00E8re mise \00E0 jour de la d\00E9finition du lien.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626913628428315193.4902)
,p_name=>'P916_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>unistr('Mis \00E0 jour par')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Utilisateur \00E0 l''origine de la derni\00E8re mise \00E0 jour du lien. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626916815507373749.4902)
,p_name=>'P916_URL'
,p_is_required=>true
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4902)
,p_prompt=>'Cible d''URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez l''URL du lien.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626915516363315203.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete link'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_link (',
'    p_link_id        => :P916_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Echec de la suppression du lien.'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Lien supprim\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626915707310315203.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update link'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_validation_error varchar2(4000) := null;',
'begin',
'  wwv_flow_ws_api.add_link (    ',
'    p_ws_app_id        => :ws_app_id,            ',
'    p_link_id          => :P916_ID,',
'    p_link_name        => :P916_LINK_NAME,',
'    p_url              => :P916_URL,',
'    p_validation_error => l_validation_error);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Echec de la mise \00E0 jour du lien.')
,p_process_when_button_id=>wwv_flow_api.id(626914515453315195.4902)
,p_process_success_message=>unistr('Lien mis \00E0 jour.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626915926570315204.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get link info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_link_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P916_ID,',
'    p_component_level => :P916_COMPONENT_LEVEL,',
'    p_webpage_id      => :P916_PAGE_ID,',
'    p_worksheet_id    => :P916_WORKSHEET_ID,',
'    p_websheet_id     => :P916_DATA_GRID_ID,',
'    p_row_id          => :P916_ROW_ID,    ',
'    p_link_name       => :P916_LINK_NAME,',
'    p_url             => :P916_URL,',
'    p_created_on      => :P916_CREATED,',
'    p_created_by      => :P916_CREATED_BY,',
'    p_updated_on      => :P916_UPDATED,',
'    p_updated_by      => :P916_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''obtenir les informations de remarque.'
);
end;
/
prompt --application/pages/page_00920
begin
wwv_flow_api.create_page(
 p_id=>920.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section')
,p_step_title=>unistr('Cr\00E9er une section')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17202921536372154.4902)
,p_plug_name=>'Boutons droits de la barre d''outil'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174354720645915002.4902)
,p_plug_name=>unistr('Cr\00E9er une section')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<div class="formNoHighlight">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436556632146705231.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id       => :WS_APP_ID,    ',
'    p_app_session     => :APP_SESSION,',
'    p_page_id         => :P900_ID,',
'    p_image_prefix    => ''#IMAGE_PREFIX#'',',
'    p_current_entry   => wwv_flow_lang.system_message(''WS_CREATE_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455838102606248329.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Une section de page est un composant d''une page. Vous pouvez cr\00E9er plusieurs sections sur une page. Cette page vous permet de choisir le type de section \00E0 ajouter \00E0 la page en cours.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174354910736915005.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(17202921536372154.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174355130239915005.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(17202921536372154.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(174356013015915007.4902)
,p_branch_action=>'f?p=&APP_ID.:910:&SESSION.::&DEBUG.:910,P910_CONTENT,P910_SPREADSHEET::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'TEXT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177507111836337182.4902)
,p_branch_action=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.:926,921::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(174355130239915005.4902)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'NAV'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178763608028090504.4902)
,p_branch_name=>'Go To Page 922'
,p_branch_action=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:922,925::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(174355130239915005.4902)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'DATA'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261473424707135006.4902)
,p_branch_name=>'Go To Page 710'
,p_branch_action=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.:710,740,742,750::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'CHART'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174355315313915005.4902)
,p_name=>'P920_SECTION_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(174354720645915002.4902)
,p_item_default=>'TEXT'
,p_prompt=>unistr('Quel type de section de page voulez-vous cr\00E9er ?')
,p_source=>'TEXT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SECTION TYPE SELECTOR'
,p_lov=>'.'||wwv_flow_api.id(174363201295924966.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00921
begin
wwv_flow_api.create_page(
 p_id=>921.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21386114982952726.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177506032470294572.4902)
,p_plug_name=>'Section de navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177507500885343531.4902)
,p_plug_name=>'create websheet progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(174369523339947712.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436568617432088844.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_NAV_SECTION''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177604932373442179.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21386114982952726.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177605313591442181.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21386114982952726.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177605109363442180.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21386114982952726.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177605817613447363.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177606906100462949.4902)
,p_branch_action=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177605109363442180.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177606323285458505.4902)
,p_name=>'P921_STARTING_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_prompt=>unistr('Page de d\00E9marrage')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :WS_APP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une page de d\00E9marrage -')
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la page de d\00E9marrage \00E0 partir de laquelle afficher la navigation hi\00E9rarchique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177606506978458508.4902)
,p_name=>'P921_MAXIMUM_LEVELS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_item_default=>'12'
,p_prompt=>'Niveaux maximaux'
,p_source=>'12'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:1;1,2;2,3;3,4;4,5;5,6;6,7;7,8;8,9;9,10;10,11;11,12;12'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le nombre maximal de niveaux (ou la profondeur d''arborescence) \00E0 afficher. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177606712975458508.4902)
,p_name=>'P921_INCLUDE_SECTION_LINKS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_item_default=>'Y'
,p_prompt=>'Include Section Links'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178094008603712314.4902)
,p_name=>'P921_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_prompt=>'Titre'
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178094215529714335.4902)
,p_name=>'P921_DISPLAY_SEQ'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_prompt=>unistr('S\00E9quence')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178573103303255986.4902)
,p_name=>'P921_NAV_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_prompt=>'Type de navigation'
,p_source=>'P926_NAV_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le type de navigation \00E0 cr\00E9er.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381985629999712041.4902)
,p_name=>'P921_ORDER_BY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_prompt=>unistr('Classer les fr\00E8res par')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE NAVIGATION ORDER'
,p_lov=>'.'||wwv_flow_api.id(381950720171699749.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('S\00E9lectionnez l''ordre des fr\00E8res par colonne. S''il n''est pas d\00E9fini, les fr\00E8res sont class\00E9s par nom de page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(607148518453469821.4902)
,p_name=>'P921_ORDER_BY_DIRECTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_prompt=>'Sens du tri'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ORDER_BY_DIRECTION'
,p_lov=>'.'||wwv_flow_api.id(606013026952235682.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(607211403347474951.4902)
,p_name=>'P921_X'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4902)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178095228473727498.4902)
,p_validation_name=>'P921_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P921_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La s\00E9quence d''affichage doit \00EAtre indiqu\00E9e.')
,p_when_button_pressed=>wwv_flow_api.id(177605313591442181.4902)
,p_associated_item=>wwv_flow_api.id(178094215529714335.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178095404709730099.4902)
,p_validation_name=>'P921_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P921_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le titre doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(177605313591442181.4902)
,p_associated_item=>wwv_flow_api.id(178094008603712314.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(607317121832489778.4902)
,p_name=>'show or hide order by direction'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P921_ORDER_BY'
,p_condition_element=>'P921_ORDER_BY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607317409299489779.4902)
,p_event_id=>wwv_flow_api.id(607317121832489778.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P921_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607317604656489780.4902)
,p_event_id=>wwv_flow_api.id(607317121832489778.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P921_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178092407601664683.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (    ',
'    p_ws_app_id        => :WS_APP_ID,   ',
'    p_webpage_id       => :P900_ID,',
'    p_section_type     => :P926_NAV_TYPE,',
'    p_title            => :P921_TITLE,',
'    p_display_seq      => :P921_DISPLAY_SEQ, ',
'    p_nav_start_webpage_id  => :P921_STARTING_PAGE,',
'    p_nav_max_level         => nvl(:P921_MAXIMUM_LEVELS,''12''),',
'    p_nav_order_by          => :P921_ORDER_BY,',
'    p_nav_order_by_dir      => :P921_ORDER_BY_DIRECTION,',
'    p_nav_include_link      => :P921_INCLUDE_SECTION_LINKS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la section de navigation.')
,p_process_when_button_id=>wwv_flow_api.id(177605313591442181.4902)
,p_process_success_message=>unistr('Section de navigation cr\00E9\00E9e.')
);
end;
/
prompt --application/pages/page_00922
begin
wwv_flow_api.create_page(
 p_id=>922.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section de donn\00E9es')
,p_step_title=>unistr('Cr\00E9er une section de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21394627412003604.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21395215076009516.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178517415930445925.4902)
,p_plug_name=>unistr('Cr\00E9er une section de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436561728327978462.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_DATA_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455837601735210222.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez afficher les donn\00E9es \00E0 partir de la grille de donn\00E9es ou d''un \00E9tat sous la forme d''une section de votre page. En affichant les donn\00E9es, vous visualisez les donn\00E9es textuelles qui peuvent \00EAtre un sous-ensemble des donn\00E9es contenues dans')
||unistr(' la grille de donn\00E9es ou l''\00E9tat.</p>'),
unistr('<p>Une section de donn\00E9es s''apparente \00E0 une publication de donn\00E9es sur une page.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178517615368455281.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21394627412003604.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178519308451528993.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21394627412003604.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178517832684460267.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21394627412003604.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178519529054528994.4902)
,p_branch_action=>'f?p=&APP_ID.:925:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178519308451528993.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178519128752525369.4902)
,p_name=>'P922_DATA_GRID_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_prompt=>unistr('Grille de donn\00E9es')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une grille de donn\00E9es -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la grille de donn\00E9es \00E0 utiliser pour afficher la section de donn\00E9es. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180221817184364203.4902)
,p_name=>'P922_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_prompt=>unistr('S\00E9quence d''affichage')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180222224110366187.4902)
,p_name=>'P922_TITLE'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_prompt=>'Titre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244080827354978984.4902)
,p_name=>'P922_REPORT_SHOW_OPT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_item_default=>'SEARCH'
,p_prompt=>'Inclure'
,p_source=>'SEARCH'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P922_REPORT_SHOW_OPT'
,p_lov=>'.'||wwv_flow_api.id(244090113649098118.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez personnaliser les fonctions que vous voulez afficher dans la section de donn\00E9es.'),
'<ul>',
unistr('<li>Ajouter une ligne : si le type de source est Grille de donn\00E9es, vous pouvez afficher le bouton Ajouter une ligne pour permettre aux utilisateurs privil\00E9gi\00E9s d''ajouter un enregistrement dans la grille de donn\00E9es.</li>'),
unistr('<li>Modifier une ligne : si le type de source est Grille de donn\00E9es, vous pouvez afficher le lien Modifier une ligne pour permettre aux utilisateurs privil\00E9gi\00E9s de modifier un enregistrement dans la grille de donn\00E9es.</li>'),
unistr('<li>Champ de recherche - Affiche dans la barre de recherche un champ de texte dans lequel vous pouvez saisir vos crit\00E8res de recherche.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244081321747981663.4902)
,p_name=>'P922_MAX_ROW_CNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_prompt=>'Nombre maximum de lignes'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>7
,p_cMaxlength=>10
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9finit le nombre maximal de lignes \00E0 interroger. Cet attribut a une incidence sur les performances. R\00E9duire le nombre de lignes peut am\00E9liorer les performances. A l''inverse, interroger plusieurs milliers de lignes peut les alt\00E9rer.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244089415406090919.4902)
,p_name=>'P922_DATAGRID_SHOW_OPT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_item_default=>'SEARCH'
,p_prompt=>'Inclure'
,p_source=>'SEARCH'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P922_DATAGRID_SHOW_OPT'
,p_lov=>'.'||wwv_flow_api.id(244084119358061944.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez personnaliser les fonctions que vous voulez afficher dans la section de donn\00E9es.'),
'<ul>',
unistr('<li>Ajouter une ligne : si le type de source est Grille de donn\00E9es, vous pouvez afficher le bouton Ajouter une ligne pour permettre aux utilisateurs privil\00E9gi\00E9s d''ajouter un enregistrement dans la grille de donn\00E9es.</li>'),
unistr('<li>Modifier une ligne : si le type de source est Grille de donn\00E9es, vous pouvez afficher le lien Modifier une ligne pour permettre aux utilisateurs privil\00E9gi\00E9s de modifier un enregistrement dans la grille de donn\00E9es.</li>'),
unistr('<li>Champ de recherche - Affiche dans la barre de recherche un champ de texte dans lequel vous pouvez saisir vos crit\00E8res de recherche.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244100400932128024.4902)
,p_name=>'P922_SHOW_OPT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(21395215076009516.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430267602106707516.4902)
,p_name=>'P922_DATA_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_item_default=>'DATA_GRID'
,p_prompt=>unistr('Source de section de donn\00E9es')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez le type de source de la section de donn\00E9es.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430268828210724512.4902)
,p_name=>'P922_REPORT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_prompt=>'Etat'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un \00E9tat -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
,p_help_text=>unistr('S\00E9lectionnez l''\00E9tat \00E0 utiliser pour afficher la section de donn\00E9es. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430269312757729488.4902)
,p_name=>'P922_WEBSHEET_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(21395215076009516.4902)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430269625917733292.4902)
,p_name=>'P922_WORKSHEET_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(21395215076009516.4902)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(506337317277616860.4902)
,p_name=>'P922_STYLE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_item_default=>'1'
,p_prompt=>'Style'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA SECTION STYLE'
,p_lov=>'.'||wwv_flow_api.id(746262913082105905.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez des styles d''interface utilisateur diff\00E9rents.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(744638613924916860.4902)
,p_name=>'P922_SAVED_REPORT_ID'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4902)
,p_prompt=>unistr('Param\00E8tres d''\00E9tat \00E0 utiliser')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id r',
'from wwv_flow_worksheet_rpts',
'where worksheet_id = :P922_WORKSHEET_ID',
'and application_user = ''APXWS_DEFAULT''',
'and is_default = ''Y''                    ',
'and (security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and session_id is null',
'and nvl(report_type,''REPORT'')!=''NOTIFICATION'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P922_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION''',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION'') x',
'order by x.seq, x.r'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un \00E9tat -')
,p_lov_cascade_parent_items=>'P922_WORKSHEET_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez les param\00E8tres d''\00E9tat \00E0 utiliser pour la grille de donn\00E9es ou l''\00E9tat s\00E9lectionn\00E9. Vous pouvez ainsi filtrer les lignes et les colonnes \00E0 afficher, et d\00E9finir les colonnes devant appara\00EEtre. Si aucun des \00E9tats enregistr\00E9s ne pr\00E9sente les ')
||unistr('param\00E8tres dont vous avez besoin, cr\00E9ez-le maintenant avant d''ajouter la section.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(430283328041112368.4902)
,p_computation_sequence=>10
,p_computation_item=>'P922_WEBSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P922_DATA_SOURCE = ''DATA_GRID'' then',
'  return :P922_DATA_GRID_ID;',
'elsif :P922_DATA_SOURCE = ''REPORT'' then',
'  return :P922_REPORT_ID;',
'end if;'))
,p_compute_when=>'replace(:P922_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P922_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(430283627479121662.4902)
,p_computation_sequence=>20
,p_computation_item=>'P922_WORKSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P922_DATA_SOURCE = ''DATA_GRID'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P922_DATA_GRID_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'elsif :P922_DATA_SOURCE = ''REPORT'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P922_REPORT_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'end if;'))
,p_compute_when=>'replace(:P922_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P922_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(244100616879135860.4902)
,p_computation_sequence=>30
,p_computation_item=>'P922_SHOW_OPT'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P922_DATA_SOURCE = ''DATA_GRID'' then',
'  return :P922_DATAGRID_SHOW_OPT;',
'elsif :P922_DATA_SOURCE = ''REPORT'' then',
'  return :P922_REPORT_SHOW_OPT;',
'end if;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178526011577605519.4902)
,p_validation_name=>'P922_DATA_GRID_ID not null'
,p_validation_sequence=>10
,p_validation=>'P922_DATA_GRID_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P922_DATA_SOURCE'
,p_validation_condition2=>'DATA_GRID'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(178519308451528993.4902)
,p_associated_item=>wwv_flow_api.id(178519128752525369.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(430284814497155703.4902)
,p_validation_name=>'P922_REPORT_ID not null'
,p_validation_sequence=>20
,p_validation=>'P922_REPORT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P922_DATA_SOURCE'
,p_validation_condition2=>'REPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(178519308451528993.4902)
,p_associated_item=>wwv_flow_api.id(430268828210724512.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(261386108094505816.4902)
,p_name=>'get data grid title'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_GRID_ID'
,p_condition_element=>'P922_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(261386430504505817.4902)
,p_event_id=>wwv_flow_api.id(261386108094505816.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P922_DATA_GRID_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P922_DATA_GRID_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430274030989800961.4902)
,p_name=>'get report title'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_REPORT_ID'
,p_condition_element=>'P922_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430274324034800964.4902)
,p_event_id=>wwv_flow_api.id(430274030989800961.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P922_REPORT_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P922_REPORT_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430274815668815504.4902)
,p_name=>'show hide data grid'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_SOURCE'
,p_condition_element=>'P922_DATA_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DATA_GRID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430275125531815505.4902)
,p_event_id=>wwv_flow_api.id(430274815668815504.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244096214315106571.4902)
,p_event_id=>wwv_flow_api.id(430274815668815504.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATAGRID_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430275311073815506.4902)
,p_event_id=>wwv_flow_api.id(430274815668815504.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244096410002108585.4902)
,p_event_id=>wwv_flow_api.id(430274815668815504.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATAGRID_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430275708526822857.4902)
,p_name=>'show hide report'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_SOURCE'
,p_condition_element=>'P922_DATA_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430276009572822857.4902)
,p_event_id=>wwv_flow_api.id(430275708526822857.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244097500513112975.4902)
,p_event_id=>wwv_flow_api.id(430275708526822857.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430276227680822858.4902)
,p_event_id=>wwv_flow_api.id(430275708526822857.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244098628105115423.4902)
,p_event_id=>wwv_flow_api.id(430275708526822857.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(747829913447257392.4902)
,p_name=>'reset data grid, report id, saved report id to null if source changes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(747830202548257393.4902)
,p_event_id=>wwv_flow_api.id(747829913447257392.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATA_GRID_ID,P922_REPORT_ID,P922_SAVED_REPORT_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(745902210134067132.4902)
,p_name=>'set data grid worksheet and websheet id'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_GRID_ID'
,p_condition_element=>'P922_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(745902519517067133.4902)
,p_event_id=>wwv_flow_api.id(745902210134067132.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WORKSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select w.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_DATA_GRID_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(748723328778318541.4902)
,p_event_id=>wwv_flow_api.id(745902210134067132.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WEBSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select a.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_DATA_GRID_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(747479308205227472.4902)
,p_name=>'set report worksheet and websheet id'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_REPORT_ID'
,p_condition_element=>'P922_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(747479601494227473.4902)
,p_event_id=>wwv_flow_api.id(747479308205227472.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WORKSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select w.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_REPORT_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(748927908954331757.4902)
,p_event_id=>wwv_flow_api.id(747479308205227472.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WEBSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select a.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_REPORT_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00925
begin
wwv_flow_api.create_page(
 p_id=>925.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section de donn\00E9es')
,p_step_title=>unistr('Cr\00E9er une section de donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21401305913120374.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>51
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179690718468764994.4902)
,p_plug_name=>unistr('Confirmer la cr\00E9ation de la section de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Vous avez demand\00E9 la cr\00E9ation d''une section de page avec les attributs suivants. Confirmez vos s\00E9lections.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436562600323998761.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_DATA_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179685611450754334.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21401305913120374.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179686030494754336.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21401305913120374.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179685830220754336.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21401305913120374.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(179688414608754348.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(179686030494754336.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187342720245457992.4902)
,p_name=>'P925_TITLE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Titre de section'
,p_source=>'P922_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244103023515193541.4902)
,p_name=>'P925_MAX_ROW_COUNT'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre maximum de lignes'
,p_source=>'P922_MAX_ROW_CNT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244104301733203623.4902)
,p_name=>'P925_SHOW_OPT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Inclure'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_option  varchar2(4000);',
'begin',
'  if instr(:P922_SHOW_OPT,''ADD_ROW'',1) > 0 then',
'    l_option := wwv_flow_lang.system_message(''WS_ADD_ROW'');',
'  end if;',
'  if instr(:P922_SHOW_OPT,''EDIT_ROW'',1) > 0 then',
'    if l_option is not null then',
'        l_option := l_option||'', '';',
'    end if;',
'    l_option := l_option||wwv_flow_lang.system_message(''APEX_WS_EDIT_ROW'');',
'  end if;',
'  if instr(:P922_SHOW_OPT,''SEARCH'',1) > 0 then',
'    if l_option is not null then',
'        l_option := l_option||'', '';',
'    end if;',
'    l_option := l_option||wwv_flow_lang.system_message(''SEARCH_FIELD'');',
'  end if;',
'  return l_option;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244105113366213468.4902)
,p_name=>'P925_STYLE'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Style'
,p_source=>'P922_STYLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P925_DATA_SECTION_STYLE'
,p_lov=>'.'||wwv_flow_api.id(244105603016227532.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431015615315149759.4902)
,p_name=>'P925_DATA_SOURCE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Source de donn\00E9es')
,p_source=>'P922_WEBSHEET_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P750_CHART_SOURCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name||',
'       case when websheet_type=''DATA'' then '' (''||wwv_flow_lang.system_message(''DATA_GRID'')||'')''',
'            when websheet_type=''REPORT'' then '' (''||wwv_flow_lang.system_message(''REPORT'')||'')''',
'       end d,',
'       id r',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431016706058203930.4902)
,p_name=>'P925_SAVED_REPORT_ID'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Param\00E8tres d''\00E9tat \00E0 utiliser')
,p_source=>'P922_SAVED_REPORT_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P922_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION''',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION'') x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431018209568233295.4902)
,p_name=>'P925_DISPLAY_SEQ'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4902)
,p_prompt=>unistr('S\00E9quence d''affichage')
,p_source=>'P922_DISPLAY_SEQ'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(179696201555864179.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (     ',
'    p_ws_app_id             => :ws_app_id,   ',
'    p_webpage_id            => :P900_ID,',
'    p_section_type          => ''DATA'',',
'    p_display_seq           => :P922_DISPLAY_SEQ,',
'    p_title                 => :P922_TITLE,   ',
'    --',
'    p_data_grid_id          => :P922_WEBSHEET_ID,',
'    p_report_id             => :P922_SAVED_REPORT_ID,',
'    p_data_section_style    => :P922_STYLE,',
'    p_max_row_count         => :P922_MAX_ROW_CNT,',
'    p_show_option           => :P922_SHOW_OPT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la section de donn\00E9es.')
,p_process_when_button_id=>wwv_flow_api.id(179686030494754336.4902)
,p_process_success_message=>unistr('Section de donn\00E9es cr\00E9\00E9e.')
);
end;
/
prompt --application/pages/page_00926
begin
wwv_flow_api.create_page(
 p_id=>926.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section')
,p_step_title=>unistr('Cr\00E9er une section')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21382806755931399.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178560813494164239.4902)
,p_plug_name=>'Section de navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178561614851164242.4902)
,p_plug_name=>'create section progress bar'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(174369523339947712.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436567608166067266.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_NAV_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178561008148164240.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21382806755931399.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178561228601164240.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(21382806755931399.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178573823173271094.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21382806755931399.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178562216428164244.4902)
,p_branch_action=>'f?p=&APP_ID.:927:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P926_NAV_TYPE'
,p_branch_condition_text=>'NAV_SECTION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178562026311164244.4902)
,p_branch_action=>'f?p=&APP_ID.:921:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178561228601164240.4902)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P926_NAV_TYPE'
,p_branch_condition_text=>'NAV_PAGE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178561412725164241.4902)
,p_name=>'P926_NAV_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178560813494164239.4902)
,p_item_default=>'NAV_PAGE'
,p_prompt=>'Type de navigation'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez le type de section de navigation \00E0 cr\00E9er.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00927
begin
wwv_flow_api.create_page(
 p_id=>927.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er une section')
,p_step_title=>unistr('Cr\00E9er une section')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21390504640978088.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178569110362240726.4902)
,p_plug_name=>'Section de navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178570913178240731.4902)
,p_plug_name=>'create websheet progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(174369523339947712.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436568901418103134.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_NAV_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178569317746240726.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21390504640978088.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178569702314240727.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21390504640978088.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178569513761240727.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21390504640978088.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178571905755240735.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178571727907240734.4902)
,p_branch_action=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178569513761240727.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178569929692240727.4902)
,p_name=>'P927_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178569110362240726.4902)
,p_prompt=>'Titre'
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178570125928240728.4902)
,p_name=>'P927_DISPLAY_SEQ'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178569110362240726.4902)
,p_prompt=>unistr('S\00E9quence')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178573503434265425.4902)
,p_name=>'P927_NAV_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(178569110362240726.4902)
,p_prompt=>'Type de navigation'
,p_source=>'P926_NAV_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le type de navigation \00E0 cr\00E9er. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178571301607240733.4902)
,p_validation_name=>'P927_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P927_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La s\00E9quence d''affichage doit \00EAtre indiqu\00E9e.')
,p_when_button_pressed=>wwv_flow_api.id(178569702314240727.4902)
,p_associated_item=>wwv_flow_api.id(178570125928240728.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178571117220240732.4902)
,p_validation_name=>'P927_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P927_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le titre doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(178569702314240727.4902)
,p_associated_item=>wwv_flow_api.id(178569929692240727.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178571520097240733.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (    ',
'    p_ws_app_id        => :ws_app_id,   ',
'    p_webpage_id       => :P900_ID,',
'    p_section_type     => :P926_NAV_TYPE,',
'    p_title            => :P927_TITLE,',
'    p_display_seq      => :P927_DISPLAY_SEQ);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er la section de navigation.')
,p_process_when_button_id=>wwv_flow_api.id(178569702314240727.4902)
,p_process_success_message=>unistr('Section de navigation cr\00E9\00E9e.')
);
end;
/
prompt --application/pages/page_00928
begin
wwv_flow_api.create_page(
 p_id=>928.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Nuage de mots-cl\00E9s')
,p_step_title=>unistr('Nuage de mots-cl\00E9s')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459067726134008686.4902)
,p_plug_name=>'Tag Cloud'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_plug_display_sequence=>30
,p_plug_new_grid=>true
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_webpage.show_tag_clouds (',
'    p_ws_app_id             => :ws_app_id,    ',
'    p_session_id            => :app_session);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459068100292010685.4902)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459178609343041600.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Un nuage de mots-cl\00E9s affiche les balises en mode Nuage avec les balises les plus r\00E9f\00E9renc\00E9es dans une police plus grande.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459181827135056279.4902)
,p_plug_name=>'Breadcrumb'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00930
begin
wwv_flow_api.create_page(
 p_id=>930.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier une section de texte'
,p_step_title=>'Modifier une section de texte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'apex.jQuery(document).ready(function(){',
' apex.jQuery("#P930_CONTENT").rte();',
'});',
'',
'function p930editSection(pSubmit){',
'  if ( apex.jQuery(''textarea[id=P930_CONTENT]'').is('':hidden'') ) { ',
'  	var content = apex.jQuery(''iframe.rte-iframe'').contents().find("body").html();',
'  	apex.jQuery(''textarea[id=P930_CONTENT]'').val(content);',
'  	apex.jQuery(''textarea[id=P930_CONTENT]'').css(''visibility'',''hidden'').css(''width'',''1px'').css(''height'',''1px'');',
'  	apex.jQuery(''textarea[id=P930_CONTENT]'').show();',
'  }',
'  doSubmit(pSubmit);',
'}',
'</script>'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15648226117829185.4902)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15648605124832619.4902)
,p_plug_name=>'Modifier une section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'&P930_TITLE. Details'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15661211477081423.4902)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15732828494501720.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18669929540787618.4902)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174552913634401874.4902)
,p_plug_name=>'Attributs de section de texte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174554312455401879.4902)
,p_plug_name=>'Boutons de barre d''outils'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(248172125472455867.4902)
,p_plug_name=>unistr('Syntaxe SQL de grille de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.data_grid_sql_help (',
'    p_app_id       => :app_id,',
'    p_app_session  => :app_session,',
'    p_ws_app_id    => :ws_app_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>unistr('Pour visualiser la syntaxe SQL de grille de donn\00E9es, cliquez sur un nom de grille de donn\00E9es :')
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936719456397213387.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(15648226117829185.4902)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4902)
,p_button_image_alt=>unistr('Menu Param\00E8tres')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(858631107838067914.4902)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(15648226117829185.4902)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174554723530401880.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(174554312455401879.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177611930061649618.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(174554312455401879.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174554515748401879.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(174554312455401879.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15650427680867507.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(15648226117829185.4902)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16271123804804753.4902)
,p_branch_action=>'f?p=&APP_ID.:&P930_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:P930_CONTENT,&P930_NEXT_SECTION_PAGE_ID.:&P930_NEXT_SECTION_ITEM_NAME.:&P930_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P930_NEXT_SECTION_PAGE_ID is not null and :P930_NEXT_SECTION_ITEM_NAME is not null and :P930_NEXT_SECTION_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(174556007850401885.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16205311085507758.4902)
,p_name=>'P930_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16205517665509666.4902)
,p_name=>'P930_NEXT_SECTION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16328930402958073.4902)
,p_name=>'P930_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20127109376394929.4902)
,p_name=>'P930_PAGE_NAME'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22693907402270854.4902)
,p_name=>'P930_X'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4902)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174553132113401875.4902)
,p_name=>'P930_TITLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4902)
,p_prompt=>'Titre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifie le titre de la section.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174553520816401877.4902)
,p_name=>'P930_DISPLAY_SEQ'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4902)
,p_prompt=>unistr('S\00E9quence')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie la s\00E9quence d''affichage de la section dans la page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174553712988401877.4902)
,p_name=>'P930_SECTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4902)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(378535409662712632.4902)
,p_name=>'P930_CONTENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4902)
,p_prompt=>'Contenu'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le contenu de la section de page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_section_clob ( ',
'    p_item_name        => ''P930_CONTENT'',',
'    p_section_id       => :P930_SECTION_ID);'))
,p_attribute_02=>'CKEDITOR-Full'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(790634718795645245.4902)
,p_name=>'P930_CHANGE_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20015500008540614.4902)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P930_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174555426069401882.4902)
,p_validation_name=>'P930_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P930_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La s\00E9quence d''affichage doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(174553520816401877.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174555618686401882.4902)
,p_validation_name=>'P930_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P930_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le titre doit \00EAtre indiqu\00E9.')
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(174553132113401875.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488007911029128399.4902)
,p_validation_name=>'P930_CONTENT contains valid sql'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_content clob;',
'begin  ',
'  l_content := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P930_CONTENT'');  ',
'  ',
'  return wwv_flow_ws_security.str_contains_valid_sql (',
'    p_ws_app_id    => :WS_APP_ID,',
'    p_page_id      => :P900_ID,',
'    p_section_id   => :P930_SECTION_ID,',
'    p_string       => l_content);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(808665215002613839.4902)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id      => :WS_APP_ID,',
'    p_page_id        => :P900_ID,',
'    p_section_id     => :P930_SECTION_ID,',
'    p_change_count   => :P930_CHANGE_COUNT,',
'    --',
'    p_section_type   => ''TEXT'',',
'    p_display_seq    => :P930_DISPLAY_SEQ,',
'    p_title          => :P930_TITLE,   ',
'    p_clob_item_name => ''P930_CONTENT''',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(174555702178401882.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_section_id       => :P930_SECTION_ID,',
'    p_section_type     => ''TEXT'',',
'    p_webpage_id       => :P900_ID,',
'    p_display_seq      => :P930_DISPLAY_SEQ,',
'    p_title            => :P930_TITLE,',
'    p_clob_item_name   => ''P930_CONTENT'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''enregistrer la section.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Section enregistr\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177616917172740533.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P930_SECTION_ID,',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la section.'
,p_process_when_button_id=>wwv_flow_api.id(177611930061649618.4902)
,p_process_success_message=>unistr('Section supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(174557016253476142.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_section_info (',
'    p_section_id       => :P930_SECTION_ID,    ',
'    -- out',
'    p_display_seq      => :P930_DISPLAY_SEQ,    ',
'    p_title            => :P930_TITLE,',
'    p_change_count     => :P930_CHANGE_COUNT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''extraire les donn\00E9es.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471208613320740995.4902)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00931
begin
wwv_flow_api.create_page(
 p_id=>931.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier une section'
,p_step_title=>'Modifier une section'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16731128856471529.4902)
,p_plug_name=>'Boutons de barre d''outils'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16731805916483837.4902)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16732211457485413.4902)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16732730157490822.4902)
,p_plug_name=>'Modifier une section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16733121284497803.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17135819160000800.4902)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178368408637765960.4902)
,p_plug_name=>'Attributs de navigation de page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936765510087700308.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16731805916483837.4902)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4902)
,p_button_image_alt=>unistr('Menu Param\00E8tres')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936765768571701620.4902)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16731805916483837.4902)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178368614342765962.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16731128856471529.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178369011126765966.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16731128856471529.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178368802810765966.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16731128856471529.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16732027467483838.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16731805916483837.4902)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16759320638525941.4902)
,p_branch_action=>'f?p=&APP_ID.:&P931_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P931_NEXT_SECTION_PAGE_ID.:&P931_NEXT_SECTION_ITEM_NAME.:&P931_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178371409970765994.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16759919730535123.4902)
,p_name=>'P931_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16760125618536865.4902)
,p_name=>'P931_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16761131851538693.4902)
,p_name=>'P931_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20206108430801477.4902)
,p_name=>'P931_PAGE_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369204192765967.4902)
,p_name=>'P931_TITLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_prompt=>'Titre'
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369430310765971.4902)
,p_name=>'P931_DISPLAY_SEQ'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_prompt=>unistr('S\00E9quence')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifie l''ordre d''affichage de la section dans la page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369610358765972.4902)
,p_name=>'P931_STARTING_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_prompt=>unistr('Page de d\00E9marrage')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :WS_APP_ID',
'and security_group_id = :WORKSPACE_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une page de d\00E9marrage -')
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la page de d\00E9marrage sur laquelle afficher la navigation dans la hi\00E9rarchie.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369805638765973.4902)
,p_name=>'P931_MAXIMUM_LEVELS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_item_default=>'3'
,p_prompt=>'Niveaux maximaux'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:1;1,2;2,3;3,4;4,5;5,6;6,7;7,8;8,9;9,10;10,11;11,12;12'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez le nombre maximal de niveaux ou la profondeur d''arborescence \00E0 afficher.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178370015853765973.4902)
,p_name=>'P931_INCLUDE_SECTION_LINKS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4902)
,p_item_default=>'Y'
,p_prompt=>'Include Section Links'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('En plus des liens vers la page, incluez \00E9galement les liens vers les sections de la page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178379310204930611.4902)
,p_name=>'P931_SECTION_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4902)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178739115966515701.4902)
,p_name=>'P931_NAV_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_item_default=>'NAV_PAGE'
,p_prompt=>'Type de navigation'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifie le type de section de navigation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(382185121781766501.4902)
,p_name=>'P931_ORDER_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_prompt=>unistr('Classer les fr\00E8res par')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE NAVIGATION ORDER'
,p_lov=>'.'||wwv_flow_api.id(381950720171699749.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('S\00E9lectionnez l''ordre des fr\00E8res par colonne. S''il n''est pas d\00E9fini, les fr\00E8res sont class\00E9s par nom de page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(606070214401251046.4902)
,p_name=>'P931_ORDER_BY_DIRECTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_prompt=>'Sens du tri'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ORDER_BY_DIRECTION'
,p_lov=>'.'||wwv_flow_api.id(606013026952235682.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(606114931716256027.4902)
,p_name=>'P931_X'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4902)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(811975427842194759.4902)
,p_name=>'P931_CHANGE_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20015324811538337.4902)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P931_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178370604774765981.4902)
,p_validation_name=>'P931_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P931_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La s\00E9quence d''affichage doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178369430310765971.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178370417599765978.4902)
,p_validation_name=>'P931_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P931_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le titre doit \00EAtre indiqu\00E9.')
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178369204192765967.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(812301814645238215.4902)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id    => :WS_APP_ID,',
'    p_page_id      => :P900_ID,',
'    p_section_id   => :P931_SECTION_ID,',
'    p_change_count => :P931_CHANGE_COUNT,',
'    --',
'    p_title            => :P931_TITLE,',
'    p_display_seq      => :P931_DISPLAY_SEQ, ',
'    p_nav_start_webpage_id  => replace(:P931_STARTING_PAGE,''undefined'',null),',
'    p_nav_max_level         => :P931_MAXIMUM_LEVELS,',
'    p_nav_order_by          => :P931_ORDER_BY,',
'    p_nav_order_by_dir      => :P931_ORDER_BY_DIRECTION,',
'    p_nav_include_link      => :P931_INCLUDE_SECTION_LINKS',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(607393113998496884.4902)
,p_name=>'show or hide order by direction'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P931_ORDER_BY'
,p_condition_element=>'P931_ORDER_BY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607393426539496885.4902)
,p_event_id=>wwv_flow_api.id(607393113998496884.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P931_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607393632327496885.4902)
,p_event_id=>wwv_flow_api.id(607393113998496884.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P931_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178370809965765982.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_section_id       => :P931_SECTION_ID,      ',
'    p_webpage_id       => :P900_ID,',
'    --p_section_type     => :P920_SECTION_TYPE,',
'    p_title            => :P931_TITLE,',
'    p_display_seq      => :P931_DISPLAY_SEQ, ',
'    p_nav_start_webpage_id  => replace(:P931_STARTING_PAGE,''undefined'',null),',
'    p_nav_max_level         => :P931_MAXIMUM_LEVELS,',
'    p_nav_order_by          => :P931_ORDER_BY,',
'    p_nav_order_by_dir      => :P931_ORDER_BY_DIRECTION,',
'    p_nav_include_link      => :P931_INCLUDE_SECTION_LINKS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''enregistrer la section de navigation.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Section de navigation enregistr\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178428631010163685.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P931_SECTION_ID,',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la section.'
,p_process_when_button_id=>wwv_flow_api.id(178368802810765966.4902)
,p_process_success_message=>unistr('Section supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178428304344155910.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_nav_section (',
'    p_section_id           => :P931_SECTION_ID,',
'    p_section_type         => ''NAV_PAGE'',',
'    -- out                 ',
'    p_display_seq          => :P931_DISPLAY_SEQ,        ',
'    p_title                => :P931_TITLE,    ',
'    p_nav_start_webpage_id => :P931_STARTING_PAGE,',
'    p_nav_max_level        => :P931_MAXIMUM_LEVELS,',
'    p_nav_order_by         => :P931_ORDER_BY,',
'    p_nav_order_by_dir     => :P931_ORDER_BY_DIRECTION,',
'    p_nav_include_link     => :P931_INCLUDE_SECTION_LINKS,',
'    p_change_count         => :P931_CHANGE_COUNT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''extraire la section de navigation.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471211203885757178.4902)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00932
begin
wwv_flow_api.create_page(
 p_id=>932.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier une section'
,p_step_title=>'Modifier une section'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16821113132731976.4902)
,p_plug_name=>'Boutons de barre d''outils'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16821602873738438.4902)
,p_plug_name=>'Modifier une section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16821808414740080.4902)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16822018804743033.4902)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16822228500745826.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18667921575785243.4902)
,p_plug_name=>'Sections Controls Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(17118702088912337.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178731016198436890.4902)
,p_plug_name=>'Attributs de navigation de section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178731226665436892.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16821113132731976.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178731613312436894.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16821113132731976.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178731417793436894.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16821113132731976.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16823808892749633.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16821808414740080.4902)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16837912664798080.4902)
,p_branch_action=>'f?p=&APP_ID.:&P932_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P932_NEXT_SECTION_PAGE_ID.:&P932_NEXT_SECTION_ITEM_NAME.:&P932_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178733618463436914.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16823109180745829.4902)
,p_name=>'P932_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16823302223745830.4902)
,p_name=>'P932_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16823506641745830.4902)
,p_name=>'P932_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20215308215810865.4902)
,p_name=>'P932_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178731814095436895.4902)
,p_name=>'P932_TITLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4902)
,p_prompt=>'Titre'
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178732029900436897.4902)
,p_name=>'P932_DISPLAY_SEQ'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4902)
,p_prompt=>unistr('S\00E9quence')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178732212508436897.4902)
,p_name=>'P932_NAV_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4902)
,p_prompt=>'Type de navigation'
,p_source=>'NAV_SECTION'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifie le type de section de navigation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178735221282451014.4902)
,p_name=>'P932_SECTION_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4902)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(812229531483233669.4902)
,p_name=>'P932_CHANGE_COUNT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20018930829549545.4902)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P932_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178733002360436908.4902)
,p_validation_name=>'P932_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P932_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La s\00E9quence d''affichage doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178732029900436897.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178732811663436903.4902)
,p_validation_name=>'P932_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P932_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le titre doit \00EAtre indiqu\00E9.')
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178731814095436895.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(812385231960243289.4902)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_section_id            => :P932_SECTION_ID,',
'    p_ws_app_id             => :WS_APP_ID,',
'    p_page_id               => :P900_ID,    ',
'    p_change_count          => :P932_CHANGE_COUNT,    ',
'    p_display_seq           => :P932_DISPLAY_SEQ,',
'    p_title                 => :P932_TITLE  ',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178733224857436909.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_ws_app_id        => :ws_app_id,',
'    p_section_id       => :P932_SECTION_ID,',
'    p_webpage_id       => :P900_ID,',
'    p_display_seq      => :P932_DISPLAY_SEQ,',
'    p_title            => :P932_TITLE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''enregistrer la section.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Section enregistr\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178736815095477670.4902)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P932_SECTION_ID,',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la section.'
,p_process_when_button_id=>wwv_flow_api.id(178731417793436894.4902)
,p_process_success_message=>unistr('Section supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471212514275760167.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178735427862452947.4902)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare        ',
'    l_nav_start_webpage_id  number := null;',
'    l_nav_max_level         number := null;',
'    l_nav_order_by          varchar2(255) := null;',
'    l_nav_order_by_dir      varchar2(255) := null;',
'    l_nav_include_link      varchar2(1) := null;',
'begin',
'    wwv_flow_ws_api.fetch_nav_section (',
'        p_section_id           => :P932_SECTION_ID,',
'        p_section_type         => ''NAV_SECTION'',',
'        -- out                 ',
'        p_display_seq          => :P932_DISPLAY_SEQ,        ',
'        p_title                => :P932_TITLE,        ',
'        p_nav_start_webpage_id => l_nav_start_webpage_id,',
'        p_nav_max_level        => l_nav_max_level,',
'        p_nav_order_by         => l_nav_order_by,',
'        p_nav_order_by_dir     => l_nav_order_by_dir,',
'        p_nav_include_link     => l_nav_include_link,',
'        p_change_count         => :P932_CHANGE_COUNT',
'        );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00934
begin
wwv_flow_api.create_page(
 p_id=>934.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Modifier la section des donn\00E9es')
,p_step_title=>unistr('Modifier la section des donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16874326226906060.4902)
,p_plug_name=>'Modifier une section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16874531766907700.4902)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16874903500908924.4902)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16875108349910367.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18675312702792138.4902)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180790812190845034.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431020504392383148.4902)
,p_plug_name=>unistr('Attributs de section de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936771449913741390.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16874531766907700.4902)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4902)
,p_button_image_alt=>unistr('Menu Param\00E8tres')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936771635134742936.4902)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16874531766907700.4902)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4902)
,p_button_image_alt=>unistr('Cr\00E9er une section')
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180465828305085279.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(180790812190845034.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180466228327085287.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(180790812190845034.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180466021313085287.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(180790812190845034.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16874731003907700.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16874531766907700.4902)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16879425580934285.4902)
,p_branch_action=>'f?p=&APP_ID.:&P934_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P934_NEXT_SECTION_PAGE_ID.:&P934_NEXT_SECTION_ITEM_NAME.:&P934_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(180469013145085360.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16876022889910369.4902)
,p_name=>'P934_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16876206592910369.4902)
,p_name=>'P934_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16876406880910369.4902)
,p_name=>'P934_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20235124061834380.4902)
,p_name=>'P934_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180466427184085287.4902)
,p_name=>'P934_SECTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180466615812085313.4902)
,p_name=>'P934_TITLE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_prompt=>'Titre'
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le titre de la section.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180466803263085314.4902)
,p_name=>'P934_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_prompt=>unistr('S\00E9quence')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez la s\00E9quence d''affichage de section.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180603407157329829.4902)
,p_name=>'P934_WEBSHEET_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_prompt=>'Websheet Name:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180803211675882755.4902)
,p_name=>'P934_WEBSHEET_ID'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_prompt=>'Websheet ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(239265214706074225.4902)
,p_name=>'P934_MAX_ROW_CNT'
,p_item_sequence=>415
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_prompt=>'Nombre maximum de lignes'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>7
,p_cMaxlength=>10
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9finit le nombre maximal de lignes \00E0 interroger. Cet attribut a une incidence sur les performances. R\00E9duire le nombre de lignes peut am\00E9liorer les performances. A l''inverse, interroger plusieurs milliers de lignes peut les alt\00E9rer.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(239270404317124679.4902)
,p_name=>'P934_SHOW_OPT'
,p_item_sequence=>417
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_prompt=>'Inclure'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P934_DATA_SECTION_SHOW_OPT'
,p_lov=>'.'||wwv_flow_api.id(239269013341119720.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez personnaliser les fonctions que vous voulez afficher dans la section de donn\00E9es.'),
'<ul>',
unistr('<li>Ajouter une ligne : si le type de source est Grille de donn\00E9es, vous pouvez afficher le bouton Ajouter une ligne pour permettre aux utilisateurs privil\00E9gi\00E9s d''ajouter un enregistrement dans la grille de donn\00E9es.</li>'),
unistr('<li>Modifier une ligne : si le type de source est Grille de donn\00E9es, vous pouvez afficher le lien Modifier une ligne pour permettre aux utilisateurs privil\00E9gi\00E9s de modifier un enregistrement dans la grille de donn\00E9es.</li>'),
unistr('<li>Champ de recherche - Affiche dans la barre de recherche un champ de texte dans lequel vous pouvez saisir vos crit\00E8res de recherche.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431025005693402485.4902)
,p_name=>'P934_WORKSHEET_ID'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431027200976410589.4902)
,p_name=>'P934_WEBSHEET_TYPE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_prompt=>'Type de source'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le type de source de la section de donn\00E9es.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431027810457422741.4902)
,p_name=>'P934_DATA_GRID_NAME'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de grille de donn\00E9es')
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P934_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':2:''||:APP_SESSION||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||:WS_APP_ID||'',''||:P934_WORKSHEET_ID||'',''||:P934_WEBSHEET_ID||''" class="goToLink">''|'
||'|wwv_flow_lang.system_message(''WS_VIEW_DATA_GRID'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P934_WEBSHEET_TYPE'
,p_display_when2=>'DATA_GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifie la grille de donn\00E9es utilis\00E9e pour afficher la section de donn\00E9es. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431028416475433950.4902)
,p_name=>'P934_REPORT_NAME'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P934_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':3000:''||:APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||:WS_APP_ID||'',''||:P934_WORKSHEET_ID||'',''||:P934_WEBSHEET_ID||''" class="goToLink">''||wwv_f'
||'low_lang.system_message(''APEXIR_VIEW_REPORT'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P934_WEBSHEET_TYPE'
,p_display_when2=>'REPORT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifie l''\00E9tat \00E0 utiliser pour afficher la section de donn\00E9es. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431028803447439614.4902)
,p_name=>'P934_SAVED_REPORT_ID'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_prompt=>unistr('Param\00E8tres d''\00E9tat \00E0 utiliser')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P934_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie les param\00E8tres d''\00E9tat utilis\00E9s pour la grille de donn\00E9es ou l''\00E9tat s\00E9lectionn\00E9. Pour utiliser des param\00E8tres d''\00E9tat diff\00E9rents, vous devez supprimer et recr\00E9er la section.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619991221839354556.4902)
,p_name=>'P934_STYLE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4902)
,p_item_default=>'1'
,p_prompt=>'Style'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA SECTION STYLE'
,p_lov=>'.'||wwv_flow_api.id(746262913082105905.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez des styles d''interface utilisateur diff\00E9rents. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(814201812810805440.4902)
,p_name=>'P934_CHANGE_COUNT'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20022318840555508.4902)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P934_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(814243608224823057.4902)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id             => :WS_APP_ID,',
'    p_page_id               => :P900_ID,',
'    p_section_id            => :P934_SECTION_ID,',
'    p_change_count          => :P934_CHANGE_COUNT,',
'    p_section_type          => ''DATA'',',
'    p_display_seq           => :P934_DISPLAY_SEQ,',
'    p_title                 => :P934_TITLE,   ',
'    --',
'    p_data_grid_id          => :P934_WEBSHEET_ID,',
'    p_report_id             => :P934_SAVED_REPORT_ID,',
'    p_data_section_style    => :P934_STYLE',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(180468800256085348.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save data section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (     ',
'    p_ws_app_id             => :ws_app_id,   ',
'    p_webpage_id            => :P900_ID,',
'    p_section_id            => :P934_SECTION_ID,',
'    p_section_type          => ''DATA'',',
'    p_display_seq           => :P934_DISPLAY_SEQ,',
'    p_title                 => :P934_TITLE,   ',
'    --',
'    p_data_grid_id          => :P934_WEBSHEET_ID,',
'    p_report_id             => :P934_SAVED_REPORT_ID,',
'    p_data_section_style    => :P934_STYLE,',
'    p_max_row_count         => :P934_MAX_ROW_CNT,',
'    p_show_option           => :P934_SHOW_OPT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer la section des donn\00E9es.')
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Section de donn\00E9es enregistr\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(180468432009085336.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P934_SECTION_ID,',
'    p_section_type     => ''DATA'',',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la section.'
,p_process_when_button_id=>wwv_flow_api.id(180466021313085287.4902)
,p_process_success_message=>unistr('Section supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(180468626102085347.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_data_section (',
'  p_section_id           => :P934_SECTION_ID,',
'  p_section_type         => ''DATA'',',
'  -- out',
'  p_display_seq          => :P934_DISPLAY_SEQ,     ',
'  p_title                => :P934_TITLE,',
'  p_worksheet_id         => :P934_WORKSHEET_ID,',
'  p_websheet_type        => :P934_WEBSHEET_TYPE,',
'  p_websheet_id          => :P934_WEBSHEET_ID,',
'  p_websheet_name        => :P934_WEBSHEET_NAME,',
'  p_report_id            => :P934_SAVED_REPORT_ID,',
'  p_data_section_style   => :P934_STYLE,',
'  p_change_count         => :P934_CHANGE_COUNT,',
'  p_max_row_count        => :P934_MAX_ROW_CNT,',
'  p_show_option          => :P934_SHOW_OPT',
'  );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''extraire la section de donn\00E9es.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471213828127764148.4902)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00940
begin
wwv_flow_api.create_page(
 p_id=>940.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Modifier les sections'
,p_step_title=>'Modifier les sections'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18810709996021492.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_EDIT_SECTIONS''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(495911823374140640.4902)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(495963309025325720.4902)
,p_name=>'Edit Sections'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(1,s.n001)||wwv_flow_item.text(2,s.n003, 16, 255, ''class="orderby" style="display:none;"'')||wwv_flow_item.text(3,s.c001,60,4000) section_name,',
'       s.c002 section_type',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a,',
'     wwv_flow_collections s',
'where p.security_group_id = :flow_security_group_id ',
'  and p.ws_app_id = :ws_app_id',
'  and p.id = :p900_id',
'  and p.ws_app_id = a.id  ',
'  and p.id = s.n002 (+)',
'  and s.collection_name (+) = ''APEX$_WS_SECTIONS''',
'order by n003'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46784125242633572.4902)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(495963605456325727.4902)
,p_query_column_id=>1
,p_column_alias=>'SECTION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Titre de section'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_column_width=>60
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(495963731919325805.4902)
,p_query_column_id=>2
,p_column_alias=>'SECTION_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(492203630195322675)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(495972224131670688.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(495911823374140640.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(495972401406673565.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(495911823374140640.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(495973102922683439.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(495972401406673565.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(495974021454726671.4902)
,p_name=>'P940_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(495911823374140640.4902)
,p_prompt=>'Page :'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(495974419161735489.4902)
,p_computation_sequence=>10
,p_computation_item=>'P940_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and id = :p900_id',
'order by 1'))
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496323222231058051.4902)
,p_validation_name=>'sequence cannot be null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f03.count',
'loop',
'    if wwv_flow.g_f01(i) is null then',
'        return false;',
'    end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La s\00E9quence doit \00EAtre indiqu\00E9e.')
,p_when_button_pressed=>wwv_flow_api.id(495972401406673565.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496327106085062791.4902)
,p_validation_name=>'section title cannot be null'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f03.count',
'loop',
'    if wwv_flow.g_f02(i) is null then',
'        return false;',
'    end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le titre de section doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(495972401406673565.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496328429419079069.4902)
,p_validation_name=>'Sequence must be numeric'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f03.count',
'loop',
'    if wwv_flow.g_f01(i) is not null then',
'        if not wwv_flow_utilities.is_numeric(p_str=>wwv_flow.g_f01(i)) then',
'          return false;',
'        end if;',
'    end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La s\00E9quence doit \00EAtre num\00E9rique.')
,p_when_button_pressed=>wwv_flow_api.id(495972401406673565.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(495977229429804648.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save sections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.save_section_seq_title (',
'    p_section_id    => wwv_flow.g_f01(i), ',
'    p_ws_app_id     => :ws_app_id,',
'    p_webpage_id    => :p900_id,    ',
'    p_display_seq   => i*10,',
'    p_title         => wwv_flow.g_f03(i)    ',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de mettre \00E0 jour les sections.')
,p_process_when_button_id=>wwv_flow_api.id(495972401406673565.4902)
,p_process_success_message=>unistr('Sections mises \00E0 jour.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(495964502492352222.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection for sections report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_section_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id         => :ws_app_id,',
'    p_page_id           => :p900_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed to populate collection data to report all sections.'
);
end;
/
prompt --application/pages/page_00950
begin
wwv_flow_api.create_page(
 p_id=>950.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Historique'
,p_step_title=>'Historique'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20894908640941912.4902)
,p_plug_name=>'Barre d''action'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20895900114948899.4902)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(20894908640941912.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471881322072882391.4902)
,p_plug_name=>'History Tab'
,p_parent_plug_id=>wwv_flow_api.id(20894908640941912.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(471880222274882374.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22641410173571436.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456375318299928143.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cet \00E9tat indique les modifications apport\00E9es aux sections de page.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457467831509230851.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460146921197349250.4902)
,p_plug_name=>'Change History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'-- section content chages',
'       (select max(p.name) from WWV_FLOW_WS_WEBPAGES p where p.id = n003) page_name,',
'       n003 page_id,',
'       d001 change_date,',
'       c001 section_title,        ',
'       c004 old_content, ',
'       c005 new_content, ',
'       lower(c006) application_user_id',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_SEC_HISTORY'' and',
'     (nvl(:P950_PAGE,0) = 0 or n003 = :P950_PAGE) and',
'     (c004 is not null or c005 is not null)',
'union all',
'-- section title changes',
'select ',
'       (select max(p.name) from WWV_FLOW_WS_WEBPAGES p where p.id = n003) page_name,',
'       n003 page_id,',
'       d001 change_date,',
'       c001 section_title, ',
'       c002 old_content, ',
'       c003 new_content,        ',
'       lower(c006) application_user_id',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_SEC_HISTORY'' and',
'     (nvl(:P950_PAGE,0) = 0 or n003 = :P950_PAGE) and',
'     c002 is not null',
'union all',
'-- new pages',
'select ',
'       name page_name,',
'       id page_id,',
'       CREATED_ON change_date,',
'       null section_title, ',
'       null old_content, ',
'       :P950_PAGE_CREATED_TEXT new_content,       ',
'       lower(created_by) application_user_id',
'from WWV_FLOW_WS_WEBPAGES',
'where ',
'     (nvl(:P950_PAGE,0) = 0 or id = :P950_PAGE) and',
'     security_group_id = :flow_security_group_id and',
'     WS_APP_ID = :WS_APP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(460147017782349250.4902)
,p_name=>'Change History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460147624830349263.4902)
,p_db_column_name=>'CHANGE_DATE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Modifi\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460147911265349264.4902)
,p_db_column_name=>'OLD_CONTENT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Ancien contenu'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460148024030349264.4902)
,p_db_column_name=>'NEW_CONTENT'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Nouveau contenu'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460148126679349264.4902)
,p_db_column_name=>'APPLICATION_USER_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Utilisateur'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460154224569437501.4902)
,p_db_column_name=>'SECTION_TITLE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Section'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22562305671219986.4902)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:P900_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22564822687253328.4902)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460245323566439989.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20895900114948899.4902)
,p_button_name=>'P950_SET'
,p_button_static_id=>'P950_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460243531961423515.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(460146921197349250.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.:950,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(460245527855439992.4902)
,p_branch_action=>'f?p=&FLOW_ID.:950:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22646627881604899.4902)
,p_name=>'P950_PAGE_CREATED_TEXT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(22641410173571436.4902)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_lang.system_message(''WS_PAGE_CREATED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460244810406436230.4902)
,p_name=>'P950_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20895900114948899.4902)
,p_prompt=>'Page'
,p_source=>'P900_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST APPLICATION PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(name,1,30) name , id',
'from wwv_flow_ws_webpages p',
'where  p.ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Visualiser toutes les pages -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460143514077302021.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Section History collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_sec_history_collection (',
'    p_ws_app_id => :WS_APP_ID,',
'    p_max_row_count => 500,',
'    p_webpage_id => nvl(:P950_PAGE, :P900_ID)',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00951
begin
wwv_flow_api.create_page(
 p_id=>951.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Calendrier de cr\00E9ation de page')
,p_step_title=>unistr('Calendrier de cr\00E9ation de page')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20860907265317014.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20911307798130897.4902)
,p_plug_name=>'Barre de navigation du calendrier'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-bottom: 10px;min-height:40px;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471882717562890165.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_calendar(
 p_id=>wwv_flow_api.id(471883431194903918.4902)
,p_plug_name=>unistr('Calendrier de cr\00E9ation de page')
,p_region_attributes=>'style="width:100%;clear:both;"'
,p_plug_source_type=>'NATIVE_CALENDAR'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       sys.htf.escape_sc(p.name) name, ',
'       ''ws?p=''||p.ws_app_id||'':''||p.PAGE_ALIAS||'':''||:APP_SESSION run_link,     ',
'       p.created_on,',
'       p.created_by',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :ws_app_id',
'and a.id = p.ws_app_id'))
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'ABOVE'
,p_cal_id=>wwv_flow_api.id(471883623668903925.4902)
,p_begin_at_start_of_interval=>'Y'
,p_date_item=>'P951_CALENDAR_DATE'
,p_display_as=>'M'
,p_display_item=>'P951_CALENDAR_DISPLAY'
,p_display_type=>'COL'
,p_date_column=>'CREATED_ON'
,p_display_column=>'NAME'
,p_start_of_week=>19721105
,p_item_link=>'#RUN_LINK#'
,p_start_time=>0
,p_end_time=>23
,p_time_format=>'24HOUR'
,p_week_start_day=>19721105
,p_week_end_day=>19721111
,p_date_type_column=>'P951_CALENDAR_TYPE'
,p_custom_cal_days=>3
,p_item_link_open_in=>'W'
,p_include_time_with_date=>'N'
,p_agenda_cal_days_type=>'MONTH'
,p_agenda_cal_days=>30
,p_template_id=>wwv_flow_api.id(20940421004163137.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471888129940913000.4902)
,p_plug_name=>'History Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(471880222274882374.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471892218436004296.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(471888129940913000.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:951:&SESSION.::&DEBUG.:951::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471885701426903947.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20911307798130897.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890400835826116.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471886127121903947.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20911307798130897.4902)
,p_button_name=>'TODAY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Aujourd''hui'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471886503849903950.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20911307798130897.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20905523503069232.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(471886900141903951.4902)
,p_branch_action=>'f?p=&FLOW_ID.:951:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471883907793903929.4902)
,p_name=>'P951_CALENDAR_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20860907265317014.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return to_char(localtimestamp,''YYYYMMDD'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'P951_CALENDAR_DATE'
,p_source=>'P951_CALENDAR_DATE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated by Calendar wizard on 22-FEB-10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471884125264903938.4902)
,p_name=>'P951_CALENDAR_END_DATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20860907265317014.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return to_char(localtimestamp+7,''YYYYMMDD'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'P951_CALENDAR_END_DATE'
,p_source=>'P951_CALENDAR_END_DATE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated by Calendar wizard on 22-FEB-10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471884327165903939.4902)
,p_name=>'P951_CALENDAR_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20860907265317014.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'P951_CALENDAR_DISPLAY'
,p_source=>'P951_CALENDAR_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated by Calendar wizard on 22-FEB-10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471886732408903950.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' apex_util.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du changement de la date de calendrier.'
,p_process_when_button_id=>wwv_flow_api.id(471886503849903950.4902)
,p_process_comment=>'Generated 22-FEB-10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471885925459903947.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' apex_util.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du changement de la date de calendrier.'
,p_process_when_button_id=>wwv_flow_api.id(471885701426903947.4902)
,p_process_comment=>'Generated 22-FEB-10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471886330644903949.4902)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' apex_util.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du changement de la date de calendrier.'
,p_process_when_button_id=>wwv_flow_api.id(471886127121903947.4902)
,p_process_comment=>'Generated 22-FEB-10'
);
end;
/
prompt --application/pages/page_00960
begin
wwv_flow_api.create_page(
 p_id=>960.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Supprimer une page'
,p_step_title=>'Supprimer une page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177964015580736665.4902)
,p_plug_name=>'Supprimer une page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Si vous supprimez une page, cette page, tous ses enfants et le contenu de page associ\00E9 seront supprim\00E9s.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177971004253771606.4902)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(437163100711661598.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :app_session, ',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',    ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_EDIT_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(636290328503002581.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Supprimez cette page et tout contenu associ\00E9.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177971415335774767.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(177971004253771606.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177972408886782347.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(177971004253771606.4902)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Supprimer une page'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177971609672774769.4902)
,p_branch_action=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177980232004158002.4902)
,p_name=>'P960_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(177964015580736665.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom de page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_ws_webpages',
'where id = :p53_id',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177980515990172377.4902)
,p_name=>'P960_CHILD_PAGES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(177964015580736665.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pages enfant'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_child_page  varchar2(32767) := null;',
'  l_cnt         pls_integer := 0;',
'begin',
'  for c1 in (select name',
'             from wwv_flow_ws_webpages',
'             where parent_page_id = :p53_id',
'             and security_group_id = :flow_security_group_id)',
'  loop',
'    l_cnt := l_cnt + 1;',
'    if l_cnt > 1 then',
'        l_child_page := l_child_page||'', '';',
'    end if;',
'    l_child_page := l_child_page||c1.name;',
'  end loop;',
'  return l_child_page;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_webpages',
'where parent_page_id = :p53_id',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177973310749792376.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page 900'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'900'
,p_process_when_button_id=>wwv_flow_api.id(177972408886782347.4902)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177973023431786563.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P53_ID);',
'',
'-- set the page id to home page id which never gets deleted',
'-- otherwise, page specific menu will error out',
':P900_ID := wwv_flow_ws_api.get_home_page_id (p_ws_app_id => :WS_APP_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la page.'
,p_process_when_button_id=>wwv_flow_api.id(177972408886782347.4902)
,p_process_success_message=>unistr('Page supprim\00E9e.')
);
end;
/
prompt --application/pages/page_00977
begin
wwv_flow_api.create_page(
 p_id=>977.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Envoyer la page par courriel'
,p_step_title=>'Envoyer la page par courriel'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22859824023975817.4902)
,p_plug_name=>'Boutons de barre d''outils'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22860628872977239.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_EMAIL_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473381600132154324.4902)
,p_plug_name=>'Courriel'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473384100872182900.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22859824023975817.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.::WS_APP_ID:&WS_APP_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473387723213227278.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22859824023975817.4902)
,p_button_name=>'SEND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Envoyer'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(473384500656192340.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473381910521157342.4902)
,p_name=>'P977_TO'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4902)
,p_prompt=>'A'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Entrez l''adresse \00E9lectronique \00E0 envoyer.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473382416755159202.4902)
,p_name=>'P977_SUBJECT'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4902)
,p_prompt=>'Objet'
,p_source=>'select name from wwv_flow_ws_webpages where id = :P900_ID and security_group_id = :flow_security_group_id and ws_app_id = :ws_app_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Entrez l''objet du courriel.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473382626105161894.4902)
,p_name=>'P977_BODY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4902)
,p_prompt=>'Corps'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Entrez le contenu de courriel \00E0 inclure avec le lien de page de feuille Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473383214939177539.4902)
,p_name=>'P977_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4902)
,p_item_default=>'LINK'
,p_prompt=>'Format'
,p_source=>'LINK'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGE EMAIL OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(473383419441178851.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Le courriel enverra un lien de page de feuille Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(473384813470196064.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'email report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.send_page_email (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P900_ID,',
'    p_to          => :P977_TO,',
'    p_subject     => :P977_SUBJECT,',
'    p_body        => :P977_BODY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>unistr('Action trait\00E9e')
);
end;
/
prompt --application/pages/page_00990
begin
wwv_flow_api.create_page(
 p_id=>990.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('D\00E9placer la section vers une autre page')
,p_step_title=>unistr('D\00E9placer la section vers une autre page')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20058000092871776.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20076302338184738.4902)
,p_plug_name=>unistr('D\00E9placer la section vers une autre page')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20076832466193411.4902)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20077203161194445.4902)
,p_plug_name=>'Sections Controls Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(17118702088912337.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20077412512197151.4902)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20077720477199411.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472197228960897529.4902)
,p_plug_name=>'Move Section to Another Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472616914577492023.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20058000092871776.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472617129806492026.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20058000092871776.4902)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('D\00E9placer la section')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20077006258193411.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(20076832466193411.4902)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20079116106207624.4902)
,p_branch_action=>'f?p=&APP_ID.:&P990_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P990_NEXT_SECTION_PAGE_ID.:&P990_NEXT_SECTION_ITEM_NAME.:&P990_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(472662514305747409.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20078323818199413.4902)
,p_name=>'P990_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20078518731199413.4902)
,p_name=>'P990_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20078701839199413.4902)
,p_name=>'P990_NEXT_SECTION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472618531677506427.4902)
,p_name=>'P990_NEW_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4902)
,p_prompt=>'Nouvelle page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner une nouvelle page -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472618731519506431.4902)
,p_name=>'P990_NEW_SECTION_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4902)
,p_item_default=>'10'
,p_prompt=>unistr('Nouvelle s\00E9quence de section')
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>12
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472629822383607872.4902)
,p_name=>'P990_CURRENT_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4902)
,p_prompt=>'Page en cours'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472637000004610810.4902)
,p_name=>'P990_SECTION_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4902)
,p_prompt=>'Nom de section'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472637709354613527.4902)
,p_name=>'P990_SECTION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472638716626615588.4902)
,p_name=>'P990_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472654616505681784.4902)
,p_computation_sequence=>10
,p_computation_item=>'P990_SECTION_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_section_name(p_section_id=>:P990_SECTION_ID);'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472658613219718662.4902)
,p_computation_sequence=>20
,p_computation_item=>'P990_CURRENT_PAGE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from WWV_FLOW_WS_WEBPAGES where id = :P990_PAGE_ID and security_group_id = :flow_security_group_id and ws_app_id = :WS_APP_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20100408365271591.4902)
,p_validation_name=>'P990_NEW_PAGE not null'
,p_validation_sequence=>10
,p_validation=>'P990_NEW_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_when_button_pressed=>wwv_flow_api.id(472617129806492026.4902)
,p_associated_item=>wwv_flow_api.id(472618531677506427.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20100715291273609.4902)
,p_validation_name=>'P990_NEW_SECTION_SEQUENCE not null'
,p_validation_sequence=>20
,p_validation=>'P990_NEW_SECTION_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_when_button_pressed=>wwv_flow_api.id(472617129806492026.4902)
,p_associated_item=>wwv_flow_api.id(472618731519506431.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472661824909740980.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'move section to new page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.move_section_to_existing_page (',
'  p_ws_app_id => :ws_app_id,',
'  p_section_id  => :P990_SECTION_ID,',
'  p_old_page_id => :P990_PAGE_ID,',
'  p_new_page_id => :P990_NEW_PAGE,',
'  p_new_section_sequence=>:P990_NEW_SECTION_SEQUENCE);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(472617129806492026.4902)
,p_process_success_message=>unistr('Section d\00E9plac\00E9e')
);
end;
/
prompt --application/pages/page_00991
begin
wwv_flow_api.create_page(
 p_id=>991.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('D\00E9placer la section vers une nouvelle page')
,p_step_title=>unistr('D\00E9placer la section vers une nouvelle page')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(15627530893704526.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18815809050077970.4902)
,p_plug_name=>'Boutons de barre d''outils'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031126421605017.4902)
,p_plug_name=>unistr('D\00E9placer la section vers une nouvelle page')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031301964607440.4902)
,p_plug_name=>'Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031706120608594.4902)
,p_plug_name=>'Sections Controls Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(17118702088912337.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031915470611275.4902)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20032228976615200.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472663102924772522.4902)
,p_plug_name=>unistr('D\00E9placer la section vers une nouvelle page')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472663410196774634.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18815809050077970.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472663610174774635.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(18815809050077970.4902)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('D\00E9placer la section')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20031524843607443.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(20031301964607440.4902)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4902)
,p_button_image_alt=>'Masquer/Afficher'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20041810500676093.4902)
,p_branch_action=>'f?p=&APP_ID.:&P991_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P991_NEXT_SECTION_PAGE_ID.:&P991_NEXT_SECTION_ITEM_NAME.:&P991_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(472666825134807286.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20041322143670008.4902)
,p_name=>'P991_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20041528723671915.4902)
,p_name=>'P991_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20041701496673521.4902)
,p_name=>'P991_NEXT_SECTION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472663908942783653.4902)
,p_name=>'P991_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4902)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664123317783654.4902)
,p_name=>'P991_SECTION_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4902)
,p_prompt=>'Section'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664332264783654.4902)
,p_name=>'P991_NEW_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4902)
,p_prompt=>'Nouveau nom de page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664523251783655.4902)
,p_name=>'P991_NEW_PAGE_PARENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4902)
,p_prompt=>'Nouveau parent de page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEETS - PICK PARENT -- SHOW ALL PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID ',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Choisir la page parent -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664716950783655.4902)
,p_name=>'P991_SECTION_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4902)
,p_prompt=>unistr('Section \00E0 d\00E9placer')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664903271783656.4902)
,p_name=>'P991_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4902)
,p_prompt=>'Page en cours'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472665119121783656.4902)
,p_name=>'P991_NEW_PAGE_ALIAS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4902)
,p_prompt=>'Nouvel alias de page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472668229767818084.4902)
,p_computation_sequence=>10
,p_computation_item=>'P991_PAGE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from WWV_FLOW_WS_WEBPAGES where id = :P990_PAGE_ID and security_group_id = :flow_security_group_id and ws_app_id = :WS_APP_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472668025611816879.4902)
,p_computation_sequence=>20
,p_computation_item=>'P991_SECTION_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_section_name(p_section_id=>:P991_SECTION_ID);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20038415086658550.4902)
,p_validation_name=>'P991_NEW_PAGE_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P991_NEW_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_when_button_pressed=>wwv_flow_api.id(472663610174774635.4902)
,p_associated_item=>wwv_flow_api.id(472664332264783654.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472666620286805919.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'move section to new page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_parent number := null;',
'begin',
'  if nvl(:P991_NEW_PAGE_PARENT,0) != 0 then',
'     l_parent := :P991_NEW_PAGE_PARENT;',
'   end if;',
'wwv_flow_ws_api.move_section_to_new_page (',
'  p_ws_app_id => :WS_APP_ID,',
'  p_section_id => :P991_SECTION_ID,',
'  p_old_page_id => :P991_PAGE_ID,',
'  p_new_page_name => :P991_NEW_PAGE_NAME,',
'  p_new_page_alias => :P991_NEW_PAGE_ALIAS,',
'  p_new_parent_page_id => l_parent);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(472663610174774635.4902)
,p_process_success_message=>unistr('Section d\00E9plac\00E9e vers une nouvelle page')
);
end;
/
prompt --application/pages/page_00999
begin
wwv_flow_api.create_page(
 p_id=>999.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Page introuvable'
,p_step_title=>'Page introuvable'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(53193408981633671.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466990113840764981.4902)
,p_plug_name=>'Page introuvable'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('La page que vous avez demand\00E9e est introuvable.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_api.create_page(
 p_id=>1000.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('R\00E9pertoire de pages')
,p_step_title=>unistr('R\00E9pertoire de pages')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="pg1000_init()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4881207741750467)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script>',
'function pg1000_init(){',
'removeMessageTimeout()',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9947808697145849.4902)
,p_plug_name=>'Page Directory'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(a.home_page_id,p.id,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-home.png'',',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-page.png'') icon,',
'       ''Text Websheet'' doc_type,',
'       p.name, ',
'       ''ws?p=''||p.ws_app_id||'':''||p.PAGE_ALIAS||'':''||:APP_SESSION id, ',
'       p.name name_alt,       ',
'       p.status,',
'       ''No'' shared_with_project,',
'       ''No'' is_private,       ',
'       lower(p.owner) owner,             ',
'       p.created_on,',
'       p.created_by,',
'       nvl(p.updated_on,p.created_on) updated_on,',
'       p.updated_by,',
'       decode(PARENT_PAGE_ID ,null,null,(select pp.name from wwv_flow_ws_webpages pp where p.PARENT_PAGE_ID  = pp.id)) parent_page,',
'       decode(PARENT_PAGE_ID ,null,null,(select ppp.name from wwv_flow_ws_webpages ppp where ppp.id = (select pp.parent_page_id from wwv_flow_ws_webpages pp where p.PARENT_PAGE_ID  = pp.id))) grandparent_page',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :ws_app_id',
'and a.id = p.ws_app_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9947931622145849.4902)
,p_name=>'Icon View'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'NONE'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ID'
,p_icon_view_img_src_column=>'ICON'
,p_icon_view_label_column=>'NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948518906145865.4902)
,p_db_column_name=>'OWNER'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>unistr('Propri\00E9taire')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948118097145863.4902)
,p_db_column_name=>'ICON'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>unistr('Ic\00F4ne')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948428296145865.4902)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom'
,p_column_link=>'#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948328798145865.4902)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'ID'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9951205657193026.4902)
,p_db_column_name=>'NAME_ALT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Nom avec propri\00E9taire')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9951305209193027.4902)
,p_db_column_name=>'STATUS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9958821858292308.4902)
,p_db_column_name=>'SHARED_WITH_PROJECT'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Partag\00E9(e)')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9960022336301949.4902)
,p_db_column_name=>'IS_PRIVATE'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Est priv\00E9(e)')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(25599908155176976.4902)
,p_db_column_name=>'DOC_TYPE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Type de document'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955630831990613.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955704257990615.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955801169990615.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>unistr('Mis \00E0 jour le')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955923796990615.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(636282405544863583.4902)
,p_db_column_name=>'PARENT_PAGE'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Page parent'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(636283427623888880.4902)
,p_db_column_name=>'GRANDPARENT_PAGE'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Page grand-parent'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48530111301258073.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilisez le r\00E9pertoire de pages pour visualiser toutes les pages dans la feuille Web en cours. Chaque feuille Web peut comporter un nombre ind\00E9fini de pages. Une page est con\00E7ue comme \00E9tant la page d''accueil ; il s''agit de la page de d\00E9marrage qui')
||unistr(' appara\00EEt lorsque vous ex\00E9cutez la feuille Web.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176569810015341629.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457462212977187649.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461347808155446630.4902)
,p_plug_name=>'Page Directory Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(461346705230446581.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(445328818813619998.4902)
,p_button_sequence=>8
,p_button_plug_id=>wwv_flow_api.id(9947808697145849.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:1000,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78354923758038667.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(9947808697145849.4902)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4902)
,p_button_image_alt=>unistr('Cr\00E9er une page')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200::'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78292528897585996.4902)
,p_branch_action=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32787425522167701.4902)
,p_branch_action=>'f?p=4350:1000:&SESSION.'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'FUNCTION_BODY'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_ws_setup.setup_exists then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174672826985929595.4902)
,p_name=>'P1000_WS_APP_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(176569810015341629.4902)
,p_prompt=>'Ws App Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176569602397339451.4902)
,p_name=>'P1000_RUN_LINK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(176569810015341629.4902)
,p_prompt=>'Run Link'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(176576007348473330.4902)
,p_computation_sequence=>10
,p_computation_item=>'P1000_RUN_LINK'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''f?p=4900:900:''||:app_session||''::::WS_APP_ID,P900_ID:''||',
'          :WS_APP_ID||'',''||home_page_id',
'  from WWV_FLOW_WS_APPLICATIONS',
' where SECURITY_GROUP_ID = :flow_security_group_id and',
'       id = :WS_APP_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(177428717099068169.4902)
,p_computation_sequence=>20
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1000'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174673313956935306.4902)
,p_computation_sequence=>30
,p_computation_item=>'P1000_WS_APP_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_ws_applications',
'where id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(176531710830925561.4902)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'log websheet activity'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_webdb_logging = ''YES'' then',
'    wwv_flow_log.g_websheet_id := :WS_APP_ID; ',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01001
begin
wwv_flow_api.create_page(
 p_id=>1001.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('R\00E9pertoire de feuilles Web')
,p_step_title=>unistr('R\00E9pertoire de feuilles Web')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/core/AppCards.css',
'#IMAGE_PREFIX#apex_ui/css/core/AppBlock.css',
'#IMAGE_PREFIX#apex_ui/css/util/u-Color.css'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.app-websheet-any-co { background-image: url(''data:image/svg+xml;charset=US-ASCII,%3C%3Fxml%20version%3D%221.0%22%20encoding%3D%22utf-8%22%3F%3E%3C!DOCTYPE%20svg%20PUBLIC%20%22-%2F%2FW3C%2F%2FDTD%20SVG%201.1%2F%2FEN%22%20%22http%3A%2F%2Fwww.w3.org%2F'
||'Graphics%2FSVG%2F1.1%2FDTD%2Fsvg11.dtd%22%3E%3Csvg%20version%3D%221.1%22%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%20x%3D%220px%22%20y%3D%220px%22%20%20viewBox%3D%220%200%2064%'
||'2064%22%20enable-background%3D%22new%200%200%2064%2064%22%20xml%3Aspace%3D%22preserve%22%3E%3Csymbol%20%20id%3D%22gauge-blank%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28%2'
||'C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-28z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-24%'
||'2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%22%'
||'2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%22M0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-23'
||'.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.326%'
||'2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-11.'
||'899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808%2'
||'C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.368%2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11.9'
||'29l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20C-15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.32'
||'1%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L-14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95v1'
||'C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2C2'
||'0%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.396%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C0.'
||'695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5.216%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.20'
||'9-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0.599C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.883C'
||'12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2C17.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%2C'
||'9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.997z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h-6'
||'c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2V-18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%3C'
||'%2Fsymbol%3E%3Csymbol%20%20id%3D%22gauge-blank_2%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28%2C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-28z'
||'%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-24%2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22'
||'%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%22M'
||'0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-23.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%'
||'3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.326%2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%2'
||'0%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-11.899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%20%'
||'3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.368%'
||'2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11.929l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20C-'
||'15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.321%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L-1'
||'4.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95v1C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%20%'
||'3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2C20%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.396'
||'%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C0.695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5.2'
||'16%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.209-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0.5'
||'99C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.883C12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2C1'
||'7.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%2C9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.997'
||'z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h-6c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2V-'
||'18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%3C%2Fsymbol%3E%3Cg%20id%3D%22bkgd%22%20display%3D%22none%22%3E%20%3Crect%20disp'
||'lay%3D%22inline%22%20fill%3D%22%234AA4EC%22%20width%3D%2264%22%20height%3D%2264%22%2F%3E%3C%2Fg%3E%3Cg%20id%3D%22icons%22%3E%20%3Cg%20opacity%3D%220.1%22%3E%20%20%3Cpath%20d%3D%22M48%2C52H16v-8c0-1.105%2C0.895-2%2C2-2h28c1.105%2C0%2C2%2C0.895%2C2%2C2'
||'V52z%22%2F%3E%20%20%3Cpath%20d%3D%22M44%2C52H20V24c0-1.105%2C0.895-2%2C2-2h20c1.105%2C0%2C2%2C0.895%2C2%2C2V52z%22%2F%3E%20%20%3Cpath%20d%3D%22M40%2C39.294H24V19.061c0-0.912%2C0.466-1.76%2C1.235-2.25l5.333-3.394c0.874-0.556%2C1.99-0.556%2C2.863%2C0l5'
||'.333%2C3.394%20%20%20C39.534%2C17.3%2C40%2C18.149%2C40%2C19.061V39.294z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M48%2C51H16v-8c0-1.105%2C0.895-2%2C2-2h28c1.105%2C0%2C2%2C0.895%2C2%2C2V51z%22%2F%3E%20%20%3Cpath%2'
||'0fill%3D%22%23FFFFFF%22%20d%3D%22M44%2C51H20V23c0-1.105%2C0.895-2%2C2-2h20c1.105%2C0%2C2%2C0.895%2C2%2C2V51z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M40%2C38.294H24V18.061c0-0.912%2C0.466-1.76%2C1.235-2.25l5.333-3.394c0.874-0.556%2C1.'
||'99-0.556%2C2.863%2C0%20%20%20l5.333%2C3.394C39.534%2C16.3%2C40%2C17.149%2C40%2C18.061V38.294z%22%2F%3E%20%3C%2Fg%3E%20%3Crect%20x%3D%2224%22%20y%3D%2225%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%2'
||'0y%3D%2225%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2230%22%20y%3D%2225%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2224%22%20y%3D%2231%22%20fill%3D%22%23CACFD'
||'2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%20y%3D%2231%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2230%22%20y%3D%2231%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D'
||'%224%22%2F%3E%20%3Crect%20x%3D%2224%22%20y%3D%2237%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%20y%3D%2237%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%223'
||'0%22%20y%3D%2237%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2224%22%20y%3D%2243%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%20y%3D%2243%22%20fill%3D%22%2'
||'3CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2230%22%20y%3D%2243%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%228%22%2F%3E%20%3Cpath%20fill%3D%22%23CACFD2%22%20d%3D%22M28%2C21c0-2.209%2C1.791-4%2C4-4s4%2C1.791%2'
||'C4%2C4H28z%22%2F%3E%3C%2Fg%3E%3C%2Fsvg%3E''); background-repeat: no-repeat; }',
'',
'.app-websheet-big-cats { background-image: url(''data:image/svg+xml;charset=US-ASCII,%3C%3Fxml%20version%3D%221.0%22%20encoding%3D%22utf-8%22%3F%3E%3C!DOCTYPE%20svg%20PUBLIC%20%22-%2F%2FW3C%2F%2FDTD%20SVG%201.1%2F%2FEN%22%20%22http%3A%2F%2Fwww.w3.org%'
||'2FGraphics%2FSVG%2F1.1%2FDTD%2Fsvg11.dtd%22%3E%3Csvg%20version%3D%221.1%22%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%20x%3D%220px%22%20y%3D%220px%22%20%20viewBox%3D%220%200%206'
||'4%2064%22%20enable-background%3D%22new%200%200%2064%2064%22%20xml%3Aspace%3D%22preserve%22%3E%3Csymbol%20%20id%3D%22gauge-blank%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28'
||'%2C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-28z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-2'
||'4%2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%2'
||'2%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%22M0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-'
||'23.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.32'
||'6%2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-1'
||'1.899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808'
||'%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.368%2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11'
||'.929l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20C-15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.'
||'321%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L-14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95'
||'v1C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2'
||'C20%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.396%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C'
||'0.695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5.216%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.'
||'209-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0.599C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.88'
||'3C12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2C17.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%'
||'2C9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.997z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h'
||'-6c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2V-18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%'
||'3C%2Fsymbol%3E%3Csymbol%20%20id%3D%22gauge-blank_2%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28%2C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-2'
||'8z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-24%2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%'
||'22%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%2'
||'2M0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-23.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3C'
||'g%3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.326%2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20'
||'%20%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-11.899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%2'
||'0%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.36'
||'8%2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11.929l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20'
||'C-15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.321%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L'
||'-14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95v1C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%2'
||'0%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2C20%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.3'
||'96%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C0.695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5'
||'.216%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.209-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0'
||'.599C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.883C12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2'
||'C17.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%2C9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.9'
||'97z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h-6c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2'
||'V-18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%3C%2Fsymbol%3E%3Cg%20id%3D%22bkgd%22%20display%3D%22none%22%3E%20%3Crect%20di'
||'splay%3D%22inline%22%20fill%3D%22%23F9422A%22%20width%3D%2264%22%20height%3D%2264%22%2F%3E%3C%2Fg%3E%3Cg%20id%3D%22icons%22%3E%20%3Cg%20opacity%3D%220.1%22%3E%20%20%3Cpath%20d%3D%22M32%2C29.723c2.881%2C0%2C5.308%2C1.931%2C6.072%2C4.566c0.605%2C2.055%'
||'2C2.223%2C3.671%2C4.278%2C4.276c2.709%2C0.716%2C4.71%2C3.174%2C4.71%2C6.108%20%20%20c0%2C3.494-2.833%2C6.327-6.327%2C6.327c-1.404%2C0-2.702-0.456-3.751-1.23c-1.428-0.977-3.141-1.546-4.982-1.546%20%20%20c-1.841%2C0-3.554%2C0.568-4.982%2C1.546c-1.05%2C'
||'0.774-2.347%2C1.23-3.751%2C1.23c-3.494%2C0-6.327-2.833-6.327-6.327%20%20%20c0-2.934%2C2-5.392%2C4.71-6.108c2.055-0.605%2C3.673-2.221%2C4.278-4.276C26.692%2C31.654%2C29.119%2C29.723%2C32%2C29.723z%22%2F%3E%20%20%3Cpath%20d%3D%22M21.924%2C29.018c1.116%'
||'2C2.924%2C0.109%2C5.959-2.251%2C6.777c-2.36%2C0.819-5.178-0.888-6.294-3.813s-0.109-5.959%2C2.251-6.777%20%20%20S20.808%2C26.093%2C21.924%2C29.018z%22%2F%3E%20%20%3Cpath%20d%3D%22M30.818%2C20.597c0.306%2C3.306-1.629%2C6.167-4.323%2C6.389c-2.694%2C0.22'
||'2-5.126-2.277-5.433-5.583%20%20%20c-0.306-3.306%2C1.629-6.167%2C4.323-6.389C28.079%2C14.791%2C30.512%2C17.291%2C30.818%2C20.597z%22%2F%3E%20%20%3Cpath%20d%3D%22M42.076%2C29.018c-1.116%2C2.924-0.109%2C5.959%2C2.251%2C6.777c2.36%2C0.819%2C5.178-0.888%2'
||'C6.294-3.813%20%20%20c1.116-2.924%2C0.109-5.959-2.251-6.777S43.192%2C26.093%2C42.076%2C29.018z%22%2F%3E%20%20%3Cpath%20d%3D%22M33.182%2C20.597c-0.306%2C3.306%2C1.629%2C6.167%2C4.323%2C6.389c2.694%2C0.222%2C5.126-2.277%2C5.433-5.583s-1.629-6.167-4.323'
||'-6.389%20%20%20C35.921%2C14.791%2C33.488%2C17.291%2C33.182%2C20.597z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M32%2C28.723c2.881%2C0%2C5.308%2C1.931%2C6.072%2C4.566c0.605%2C2.055%2C2.223%2C3.671%2C4.278%2C4.276%2'
||'0%20%20c2.709%2C0.716%2C4.71%2C3.174%2C4.71%2C6.108c0%2C3.494-2.833%2C6.327-6.327%2C6.327c-1.404%2C0-2.702-0.456-3.751-1.23%20%20%20c-1.428-0.977-3.141-1.546-4.982-1.546c-1.841%2C0-3.554%2C0.568-4.982%2C1.546c-1.05%2C0.774-2.347%2C1.23-3.751%2C1.23%2'
||'0%20%20c-3.494%2C0-6.327-2.833-6.327-6.327c0-2.934%2C2-5.392%2C4.71-6.108c2.055-0.605%2C3.673-2.221%2C4.278-4.276%20%20%20C26.692%2C30.654%2C29.119%2C28.723%2C32%2C28.723z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M21.924%2C28.018c1.116'
||'%2C2.924%2C0.109%2C5.959-2.251%2C6.777c-2.36%2C0.819-5.178-0.888-6.294-3.813%20%20%20s-0.109-5.959%2C2.251-6.777S20.808%2C25.093%2C21.924%2C28.018z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M30.818%2C19.597c0.306%2C3.306-1.629%2C6.167-4'
||'.323%2C6.389c-2.694%2C0.222-5.126-2.277-5.433-5.583%20%20%20c-0.306-3.306%2C1.629-6.167%2C4.323-6.389C28.079%2C13.791%2C30.512%2C16.291%2C30.818%2C19.597z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M42.076%2C28.018c-1.116%2C2.924-0.109%2'
||'C5.959%2C2.251%2C6.777c2.36%2C0.819%2C5.178-0.888%2C6.294-3.813%20%20%20c1.116-2.924%2C0.109-5.959-2.251-6.777S43.192%2C25.093%2C42.076%2C28.018z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M33.182%2C19.597c-0.306%2C3.306%2C1.629%2C6.167%'
||'2C4.323%2C6.389c2.694%2C0.222%2C5.126-2.277%2C5.433-5.583%20%20%20s-1.629-6.167-4.323-6.389C35.921%2C13.791%2C33.488%2C16.291%2C33.182%2C19.597z%22%2F%3E%20%3C%2Fg%3E%3C%2Fg%3E%3C%2Fsvg%3E''); background-repeat: no-repeat; }',
'',
'body .a-IRR-iconViewTable td {',
'  display: block;',
'  float: left;',
'  padding: 0;',
'  width: 25%;',
'  text-align: left; ',
'}',
'body .a-IRR-iconViewTable td:hover {',
'  background-color: transparent;;',
'  border-radius: 0; ',
'}',
''))
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(407513514732948752.4902)
,p_plug_name=>'DEL ME'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461348414728450100.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461351914627477627.4902)
,p_plug_name=>'Websheet Directory Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(461346705230446581.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461357027599505945.4902)
,p_plug_name=>unistr('R\00E9pertoire de feuilles Web')
,p_region_css_classes=>'a-IRR-region--responsiveIconViewWide a-IRR-region--showTopBorder a-AppCards a-AppCards--slim a-AppCards--irr'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1332151043262185426.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    id,',
'    wwv_flow_4000_ui.get_app_initials( name, id ) as app_initials,',
'    ''u-ColorBG--'' || to_char( ora_hash( name, 29 ) + 1 ) as app_color,',
'    name name,',
'    name app_name,',
'    owner,',
'    status build_status,',
'    (select count(*) from wwv_flow_ws_webpages where ws_app_id = f.id) page_count,',
'    updated_on updated,',
'    lower(updated_by) last_updated_by,',
'    created_on created,',
'    lower(created_by) created_by,',
'    ''<a  href="ws?p=''||f.id||'':home:''||:app_session||''" class="a-button"><span class="a-icon  icon-run-page" title="''||wwv_flow_lang.system_message(''run_application_id'', f.id)||''"></span></a>'' actions,',
'    ''f?p=4900:900:''||:app_session||''::::ws_app_id,p900_id:''||f.id||'',''||f.home_page_id home_link,',
'    description application_comments',
'from  wwv_flow_ws_applications f',
'where f.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(461357118845505945.4902)
,p_name=>'Application Directory'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357330691505949.4902)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357621686505950.4902)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357701542505950.4902)
,p_db_column_name=>'APP_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Nom'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357820513505950.4902)
,p_db_column_name=>'OWNER'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Propri\00E9taire')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357930815505950.4902)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Statut de construction'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358011949505950.4902)
,p_db_column_name=>'PAGE_COUNT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Nombre de pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358110612505951.4902)
,p_db_column_name=>'UPDATED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358212071505951.4902)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358402276505951.4902)
,p_db_column_name=>'CREATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358531407505951.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358629185505951.4902)
,p_db_column_name=>'ACTIONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Ex\00E9cuter')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
end;
/
begin
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358701197505952.4902)
,p_db_column_name=>'HOME_LINK'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Lien de page d''accueil'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358804759505952.4902)
,p_db_column_name=>'APPLICATION_COMMENTS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Commentaires d''application'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1284870871845082002.4902)
,p_db_column_name=>'APP_INITIALS'
,p_display_order=>26
,p_column_identifier=>'Q'
,p_column_label=>'Initiales d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1284870943158082003.4902)
,p_db_column_name=>'APP_COLOR'
,p_display_order=>36
,p_column_identifier=>'R'
,p_column_label=>'Couleur d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461367500138577575.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilisez le r\00E9pertoire de la feuille Web pour acc\00E9der \00E0 une autre feuille Web dans l''espace de travail.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461362925802537651.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(461357027599505945.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.:1001,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(292888520005892928.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(461357027599505945.4902)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4902)
,p_button_image_alt=>unistr('Cr\00E9er une feuille Web')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7,8,32::'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/pages/page_01250
begin
wwv_flow_api.create_page(
 p_id=>1250.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Propri\00E9t\00E9s de feuille Web')
,p_step_title=>unistr('Propri\00E9t\00E9s de feuille Web')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176487503903203838.4902)
,p_plug_name=>'Feuille Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4902)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176493105421233409.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176594331242830295.4902)
,p_plug_name=>'Top Bar'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-bottom: 10px;min-height:40px;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_translate_title=>'N'
,p_plug_footer=>'<div class="clear"></div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176595526871838481.4902)
,p_plug_name=>'Authentification'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177429502470082830.4902)
,p_plug_name=>unistr('D\00E9tails')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177457130856065502.4902)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette page pour g\00E9rer les propri\00E9t\00E9s d''application Web. La page d''accueil identifie la page, la grille de donn\00E9es ou l''\00E9tat vers lequel les utilisateurs seront achemin\00E9s par d\00E9faut. Le nom de l''application appara\00EEt dans le chemin de navig')
||'ation.</p>',
'',
unistr('<p>Pour supprimer cette application, modifiez le mod\00E8le d''authentification ou les objets disponibles. Vous devez modifier les propri\00E9t\00E9s \00E0 partir de l''environnement de d\00E9veloppement.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(450939102309511257.4902)
,p_plug_name=>'Autorisation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461458711650262011.4902)
,p_plug_name=>'Logo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471188429983598197.4902)
,p_plug_name=>unistr('Pr\00E9f\00E9rences')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472166009883150979.4902)
,p_plug_name=>'Style'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487243419558654247.4902)
,p_plug_name=>'Authentification'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491767807981294755.4902)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(487244921683683240.4902)
,p_name=>unistr('Objets sugg\00E9r\00E9s')
,p_parent_plug_id=>wwv_flow_api.id(491767807981294755.4902)
,p_template=>wwv_flow_api.id(47316730240795884.4902)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name, object_comment',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id and ',
'       ws_app_id = :P1250_ID',
' order by 1'))
,p_header=>unistr('<p>Le code SQL peut \00EAtre utilis\00E9 dans les \00E9tats et les balises SQL. Voici une liste d''outils sugg\00E9r\00E9s qui peuvent \00EAtre utiles pour votre application.</p>')
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(129228711620465473.4902)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Acc\00E8s \00E0 la table non autoris\00E9.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(487245230514683283.4902)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom d''objet'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492622021349323665.4902)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_COMMENT'
,p_column_display_sequence=>2
,p_column_heading=>'Commentaire'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(487247100221752781.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(487243419558654247.4902)
,p_button_name=>'EDIT_AUTH'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Modifier l''authentification'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=4000:933:&BUILDER_SESSION_ID.::::P933_ID:&P1250_ID.#AUTH'
,p_button_execute_validations=>'N'
,p_button_cattributes=>'style="float: right;"'
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488229223702763799.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(450939102309511257.4902)
,p_button_name=>'EDIT_ACL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('Modifier la liste de contr\00F4le d''acc\00E8s (ACL)')
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'style="float: right;"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488035229167843216.4902)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(491767807981294755.4902)
,p_button_name=>'EDIT_AVAIL_OBJ'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('Modifier l''acc\00E8s SQL et les objets sugg\00E9r\00E9s')
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=4000:933:&BUILDER_SESSION_ID.::::P933_ID:&P1250_ID.#SQL'
,p_button_execute_validations=>'N'
,p_button_cattributes=>'style="float: right;"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(176488014475203914.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(176594331242830295.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(302930804915799942.4902)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(176594331242830295.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:4:P4_ID:&WS_APP_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(176487811236203914.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(176594331242830295.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'P1250_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(176488823089203918.4902)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27512507876659750.4902)
,p_name=>'P1250_EMAIL_FROM'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Adresse \00E9lectronique d''exp\00E9dition de la feuille Web')
,p_source=>'EMAIL_FROM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9termine l''adresse \00E9lectronique \00E0 utiliser comme adresse d''exp\00E9dition dans la feuille Web. Cette adresse \00E9lectronique d''exp\00E9dition est utilis\00E9e pour l''envoi de courriels \00E0 partir de la grille de donn\00E9es ou le t\00E9l\00E9chargement de courriels d''\00E9tat da')
||'ns la feuille Web.</p>',
'Exemple :',
'<ul>',
'<li><code>john.doe@example.com</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176489018827203924.4902)
,p_name=>'P1250_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Feuille Web :'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identificateur unique de l''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176489225311203942.4902)
,p_name=>'P1250_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifie le nom de l''application. Ce nom sera affich\00E9 dans le chemin de navigation.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176489614428203951.4902)
,p_name=>'P1250_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(177429502470082830.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Propri\00E9taire')
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifie l''utilisateur qui est propri\00E9taire de l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176490009162203952.4902)
,p_name=>'P1250_DESCRIPTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(177429502470082830.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Description facultative de l''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176490204285203953.4902)
,p_name=>'P1250_STATUS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Statut'
,p_source=>'STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEET APPLICATION STATUS'
,p_lov=>'.'||wwv_flow_api.id(471867429070174759.4902)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifie le statut de l''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176490605195203957.4902)
,p_name=>'P1250_AUTHENTICATION'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(487243419558654247.4902)
,p_item_default=>'0'
,p_prompt=>'Authentification'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WEBSHEET AUTHENTICATION'
,p_lov=>'.'||wwv_flow_api.id(444727703759035884.4902)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifie la m\00E9thode d''authentification des utilisateurs de l''application.'),
'<p>',
'<ul>',
'<li>',
unistr('Comptes Application Express : authentification \00E0 l''aide du nom utilisateur et du mot de passe du compte de d\00E9veloppeur.'),
'<li>',
unistr('Single Sign-On : authentification \00E0 l''aide d''Oracle AS Single Sign-On. Doit \00EAtre configur\00E9 pour l''instance &PRODUCT_NAME..'),
'<li>',
unistr('LDAP : authentification \00E0 l''aide d''un annuaire LDAP. Indiquez des param\00E8tres suppl\00E9mentaires sur cette page pour configurer cette m\00E9thode.'),
'<li>',
unistr('Personnalis\00E9 : indiquez votre propre code pour l''authentification et certaines t\00E2ches de gestion de session.'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177428201730054272.4902)
,p_name=>'P1250_HOME_PAGE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page d''accueil'
,p_source=>'HOME_PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEET HOME PAGE SELECTOR (P 1250)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :P1250_ID and',
'      security_group_id = :flow_security_group_id',
'order by 1'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie la page d''accueil de l''application. La page d''accueil est la page de d\00E9marrage par d\00E9faut.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(325631522619352012.4902)
,p_name=>'P1250_SHOW_RESET_PASSWD_YN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Afficher le mot de passe r\00E9initialis\00E9')
,p_source=>'SHOW_RESET_PASSWD_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'wwv_flow_ws_security.ws_auth_type(p_websheet_application_id=>:WS_APP_ID) = ''1'' '
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Contr\00F4le l''affichage du lien de r\00E9initialisation de mot de passe sur la page de connexion. Ce lien permet aux utilisateurs de r\00E9initialiser leur mot de passe. Cette option ne fonctionne que lorsque l''application utilise l''authentification de compte &')
||'PRODUCT_NAME..'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484206252704730.4902)
,p_name=>'P1250_LDAP_HOST'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>unistr('H\00F4te LDAP')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nom d''h\00F4te du serveur d''annuaire LDAP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484413608704731.4902)
,p_name=>'P1250_LDAP_PORT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>'Port LDAP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Num\00E9ro de port de l''h\00F4te d''annuaire LDAP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484630785704732.4902)
,p_name=>'P1250_LDAP_STRING'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>unistr('Cha\00EEne LDAP')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Mod\00E8le servant \00E0 construire l''argument de nom distinctif (DN) pour DBMS_LDAP.SIMPLE_BIND_S.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484825274704732.4902)
,p_name=>'P1250_PAGE_SENTRY_FUNCTION'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>'Fonction de sentinelle de page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cette fonction est ex\00E9cut\00E9e par le moteur &PRODUCT_NAME. avant l''affichage ou le traitement de chaque page. Lorsqu''elle renvoie la valeur False (peut-\00EAtre parce que l''utilisateur n''est pas connect\00E9), le moteur effectue un r\00E9acheminement sur une page ')
||'de connexion.',
'<br>',
unistr('Si la valeur ''-DATABASE-'' est attribu\00E9e \00E0 ce champ, aucune fonction n''est \00E9valu\00E9e. La session est consid\00E9r\00E9e comme valide et le nom utilisateur est obtenu \00E0 partir du nom utilisateur de session de base de donn\00E9es connect\00E9, tel qu''indiqu\00E9 par la confi')
||'guration DAD.',
'<p>',
'Indiquez un corps de fonction PL/SQL sous l''une des formes suivantes :',
'<ul>',
'<li>',
'return function-name;',
'<li>',
'return package.function-name;',
'<li>',
'return schema.package.function-name;',
'<li>',
'return true; /* always return true: maybe while you are testing */',
'<li>',
'return false; /* always return false: maybe while you are testing */',
'<li>',
'begin',
'&nbsp;&nbsp;if condition then return true;',
'&nbsp;&nbsp;else return false;',
'&nbsp;&nbsp;end if;',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485008671704733.4902)
,p_name=>'P1250_SESS_VERIFY_FUNCTION'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>unistr('Fonction de v\00E9rification de session')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cette fonction d\00E9termine s''il existe une session valide.'),
'<p>',
'Indiquez un corps de fonction PL/SQL sous l''une des formes suivantes :',
'<ul>',
'<li>',
'return function-name;',
'<li>',
'return package.function-name;',
'<li>',
'return schema.package.function-name;',
'<li>',
'return true; /* always return true: maybe while you are testing */',
'<li>',
'return false; /* always return false: maybe while you are testing */',
'<li>',
'begin',
'&nbsp;&nbsp;if condition then return true;',
'&nbsp;&nbsp;else return false;',
'&nbsp;&nbsp;end if;',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485225599704733.4902)
,p_name=>'P1250_PRE_AUTH_PROCESS'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>unistr('Processus de pr\00E9authentification')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez un bloc PL/SQL \00E0 ex\00E9cuter apr\00E8s soumission de la page de connexion et juste avant v\00E9rification des informations d''identification.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485420073704733.4902)
,p_name=>'P1250_AUTH_FUNCTION'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>'Fonction d''authentification'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez la fonction qui v\00E9rifiera les informations d''identification de l''utilisateur.'),
'<p>',
unistr('Appelez une fonction PL/SQL qui v\00E9rifiera la combinaison nom utilisateur/mot de passe et renverra une valeur bool\00E9enne. '),
unistr('Indiquez un nom de fonction comme ceci : return fn, o\00F9 fn est le nom de la fonction, qualifi\00E9 par le nom de sch\00E9ma et le nom de package, si n\00E9cessaire. '),
unistr('Cette fonction doit renvoyer la signature (p_username in varchar2, p_password in varchar2) sous forme bool\00E9enne. '),
unistr('Les valeurs des champs de nom utilisateur et de mot de passe entr\00E9es sur la page de connexion seront transmises \00E0 votre fonction.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485608358704734.4902)
,p_name=>'P1250_POST_AUTH_PROCESS'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>'Processus de postauthentification'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez un bloc PL/SQL \00E0 ex\00E9cuter apr\00E8s l''\00E9tape d''authentification (v\00E9rification des informations d''identification).'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485815622704734.4902)
,p_name=>'P1250_LOGOUT_URL'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>unistr('URL de d\00E9connexion')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'0'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez l''URL qui deviendra l''attribut URL de d\00E9connexion de cette application. '),
unistr('Cet attribut est r\00E9f\00E9renc\00E9 par &amp;LOGOUT_URL. dans les liens de d\00E9connexion.'),
unistr('<br>Si l''application utilise la v\00E9rification de session int\00E9gr\00E9e, vous pouvez vous servir de "wwv_flow_custom_auth_std.ws_logout?p_websheet_app_id=&amp;WS_APP_ID.&amp;p_next_url=ws?p=&amp;WS_APP_ID.:home" pour appeler une proc\00E9dure de d\00E9connexion int')
||unistr('\00E9gr\00E9e. ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450487210595819510.4902)
,p_name=>'P1250_EDIT_FUNCTION'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>'Fonction de modification de nom utilisateur LDAP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez indiquer du code suppl\00E9mentaire \00E0 ex\00E9cuter pour transformer le nom utilisateur et lui donner un format parfaitement adapt\00E9 \00E0 une entr\00E9e d''annuaire LDAP ou \00E0 un nom utilisateur LDAP. Par exemple, le code suivant appelle une fonction qui re')
||unistr('mplace tous les caract\00E8res "." par des caract\00E8res "_" dans la cha\00EEne de nom distinctif (DN) :<br /><br />'),
'return apex_custom_auth.ldap_dnprep;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450537626101318811.4902)
,p_name=>'P1250_INVALID_SESSION_URL'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_prompt=>'URL de session non valide'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>150
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indiquez une URL vers laquelle &PRODUCT_NAME. doit vous r\00E9acheminer s''il n''existe aucune session valide.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450939413784542940.4902)
,p_name=>'P1250_ACL_TYPE'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(450939102309511257.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Type de liste de contr\00F4le d''acc\00E8s (ACL)')
,p_source=>'ACL_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_APP_ACL_TYPE'
,p_lov=>'.'||wwv_flow_api.id(450940100671567605.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Si l''authentification est d\00E9finie sur les comptes &PRODUCT_NAME., choisissez si l''autorisation est d\00E9termin\00E9e par le r\00F4le dans l''espace de travail &PRODUCT_NAME. ou par la liste de contr\00F4le d''acc\00E8s (ACL). Pour tous les types d''authentification autres')
||unistr(' que les comptes &PRODUCT_NAME., l''autorisation sera toujours d\00E9termin\00E9e par la liste de contr\00F4le d''acc\00E8s (ACL).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460137926534229858.4902)
,p_name=>'P1250_DATE_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format de date d''application'
,p_source=>'DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATE_FORMAT_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9termine le format de date \00E0 utiliser dans l''application.</p>'),
unistr('<p>Ce format de date permettra de modifier le param\00E8tre de session de base de donn\00E9es <code>NLS_DATE_FORMAT</code> avant d''afficher ou de soumettre une page dans l''application. Cette valeur peut \00EAtre une cha\00EEne litt\00E9rale incluant un masque de format ')
||unistr('de date Oracle valide ou une r\00E9f\00E9rence d''\00E9l\00E9ment via une syntaxe de substitution. En l''absence de valeur, le format de date par d\00E9faut sera d\00E9riv\00E9 de la session de base de donn\00E9es \00E0 l''ex\00E9cution.</p>'),
'Exemples ',
'<ul>',
'<li><code>Month DD, YYYY</code></li>',
'<li><code>&amp;MY_DATE_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460224522939269560.4902)
,p_name=>'P1250_ORIG_AUTHENTICATION'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4902)
,p_use_cache_before_default=>'NO'
,p_source=>'P1250_AUTHENTICATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461458902408262014.4902)
,p_name=>'P1250_LOGO_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Type de logo'
,p_source=>'LOGO_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_LOGO_TYPE'
,p_lov=>'.'||wwv_flow_api.id(461278502171499627.4902)||'.'
,p_cSize=>60
,p_cMaxlength=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le type de logo utilis\00E9 pour l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461459505800262016.4902)
,p_name=>'P1250_LOGO_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo'
,p_source=>'LOGO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>500
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez une cha\00EEne de texte compl\00E8te \00E0 utiliser en tant que logo d''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461460131393262018.4902)
,p_name=>'P1250_LOGO_TEXT_ATTRIBUTES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributs de logo :'
,p_source=>'LOGO_TEXT_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LOGO ATTRIBUTES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Attributs de logo. Exemple :',
'<pre>style="font-family:Arial; color:#000000; font-size:18; white-space:nowrap; font-weight:bold;"</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461460730859262020.4902)
,p_name=>'P1250_LOGO_IMAGE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo'
,p_source=>'LOGO_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('T\00E9l\00E9chargez une image \00E0 utiliser en tant que logo de l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DB_COLUMN'
,p_attribute_02=>'LOGO_IMAGE_MIMETYPE'
,p_attribute_03=>'LOGO_IMAGE_FILENAME'
,p_attribute_04=>'LOGO_IMAGE_CHARSET'
,p_attribute_05=>'LOGO_IMAGE_LAST_UPDATE'
,p_attribute_06=>'Y'
,p_attribute_07=>unistr('T\00E9l\00E9charger')
,p_attribute_08=>'inline'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461461303598262021.4902)
,p_name=>'P1250_LOGO_IMAGE_ATTRIBUTES'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributs de logo :'
,p_source=>'LOGO_IMAGE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Attributs de logo. Exemple :',
unistr('<pre>width="100" height="20" alt="Logo de la soci\00E9t\00E9"</pre>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461461903438262023.4902)
,p_name=>'P1250_LOGO_FILEPATH'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo'
,p_source=>'LOGO_FILEPATH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Entrez le nom complet de l''image, y compris l''extension du fichier. Exemple :',
'<pre>/i/oracle.gif</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461462532105262026.4902)
,p_name=>'P1250_LOGO_FILEPATH_ATTRIBUTES'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributs de logo :'
,p_source=>'LOGO_FILEPATH_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Attributs de logo. Exemple :',
unistr('<pre>width="100" height="20" alt="Logo de la soci\00E9t\00E9"</pre>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471188815054641201.4902)
,p_name=>'P1250_SHOW_PEER_NAVIGATION_YN'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(471188429983598197.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Afficher la navigation homologue'
,p_source=>'SHOW_PEER_NAVIGATION_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Contr\00F4le l''affichage d''un param\00E8tre de navigation qui permet de naviguer entre des pages homologues.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471189024928641209.4902)
,p_name=>'P1250_SHOW_CHILD_NAVIGATION_YN'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(471188429983598197.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Afficher la navigation enfant'
,p_source=>'SHOW_CHILD_NAVIGATION_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Contr\00F4le l''affichage d''un param\00E8tre de navigation pour des pages subordonn\00E9es (enfant).  ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(477856118555259924.4902)
,p_name=>'P1250_PAGE_STYLE'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(472166009883150979.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Style d''application'
,p_source=>'PAGE_STYLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEET PAGE STYLE'
,p_lov=>'.'||wwv_flow_api.id(478186020350840371.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Utilisez cette option pour remplacer le style d''application par d\00E9faut et utiliser une feuille de style CSS personnalis\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(477856305873265712.4902)
,p_name=>'P1250_CUSTOM_CSS'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(472166009883150979.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Feuille de style CSS personnalis\00E9e')
,p_source=>'CUSTOM_CSS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indiquez une feuille de style CSS personnalis\00E9e pour le style d''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(478235906953144957.4902)
,p_name=>'P1250_SHOW_ANNOTATIONS_CONTROL_YN'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(471188429983598197.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Afficher le contr\00F4le des annotations')
,p_source=>'SHOW_ANNOTATIONS_CONTROL_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Contr\00F4le la possibilit\00E9 d''ajouter des annotations sur n''importe quelle page (les annotations incluent les fichiers, les balises et les remarques).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484542908371747530.4902)
,p_name=>'P1250_ALLOW_PUBLIC_ACCESS_YN'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(450939102309511257.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Autoriser l''acc\00E8s public')
,p_source=>'ALLOW_PUBLIC_ACCESS_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Lorsque vous s\00E9lectionnez Oui, les utilisateurs peuvent ex\00E9cuter l''application en mode de lecture seule sans avoir \00E0 se connecter. Si vous s\00E9lectionnez Non, tous les utilisateurs doivent se connecter pour ex\00E9cuter l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488052808977755011.4902)
,p_name=>'P1250_LOGIN_PAGE_MESSAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(177429502470082830.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Message de connexion'
,p_source=>'LOGIN_PAGE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Affichez ce message sur la page de connexion.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(491768318155307093.4902)
,p_name=>'P1250_ALLOW_SQL_YN'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(491767807981294755.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Autoriser SQL'
,p_source=>'ALLOW_SQL_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES NO RETURNING Y N'
,p_lov=>'.'||wwv_flow_api.id(159003224636178271.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Autorisez l''utilisation des balises SQL et des \00E9tats SQL dans cette application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502779631210331431.4902)
,p_name=>'P1250_LANGUAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.get_g_session_lang'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Langue par d\00E9faut de l''application')
,p_source=>'LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGES_INSTALLED'
,p_lov=>'.'||wwv_flow_api.id(631691002719703351.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifie la langue par d\00E9faut de l''application. Les utilisateurs peuvent la modifier directement \00E0 partir de cette derni\00E8re. La liste de langues d\00E9pend des versions traduites de &PRODUCT_NAME. install\00E9es.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502984816637800262.4902)
,p_name=>'P1250_TERRITORY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_territory varchar2(255);',
'begin',
'    l_territory := wwv_flow_lang.get_g_session_territory;',
'    if l_territory is null then',
'        for c1 in (select nls_territory',
'                     from wwv_flow_languages',
'                    where lang_id = nvl(wwv_flow_lang.get_g_session_lang,''en'')) loop',
'            l_territory := c1.nls_territory;',
'            exit;',
'        end loop;',
'    end if;',
'    if l_territory is null then',
'        l_territory := ''AMERICA'';',
'    end if;',
'    return l_territory;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Territoire par d\00E9faut de l''application')
,p_source=>'TERRITORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_TERRITORIES'
,p_lov=>'.'||wwv_flow_api.id(634728210841234369.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifie le territoire par d\00E9faut de l''application. Celui-ci contr\00F4le des attributs tels que les caract\00E8res num\00E9riques et la langue de la date. Les utilisateurs peuvent le modifier directement \00E0 partir de l''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(450490025504975234.4902)
,p_computation_sequence=>10
,p_computation_item=>'P1250_AUTHENTICATION'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_security.ws_auth_type(',
'  p_websheet_application_id => :P1250_ID);'))
,p_computation_error_message=>'Impossible d''obtenir le type d''authentification.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(450943619689696013.4902)
,p_computation_sequence=>20
,p_computation_item=>'P1250_ACL_TYPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'CUSTOM'
,p_compute_when=>'P1250_ACL_TYPE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(487242203095536025.4902)
,p_computation_sequence=>30
,p_computation_item=>'P1250_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'ltrim(rtrim(:P1250_NAME))'
,p_compute_when=>'SAVE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(176489402369203945.4902)
,p_validation_name=>'P1250_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1250_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le nom doit comporter une valeur.'
,p_associated_item=>wwv_flow_api.id(176489225311203942.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(176489804897203952.4902)
,p_validation_name=>'P1250_OWNER not null'
,p_validation_sequence=>20
,p_validation=>'P1250_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le propri\00E9taire doit avoir une valeur.')
,p_associated_item=>wwv_flow_api.id(176489614428203951.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(456286403615138645.4902)
,p_validation_name=>'Must be admin in ACL'
,p_validation_sequence=>30
,p_validation=>'return wwv_flow_ws_security.admin_exists(p_username=>:APP_USER,p_websheet_app_id=>:P1250_ID);'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Pour pouvoir passer \00E0 une liste de contr\00F4le d''acc\00E8s (ACL) personnalis\00E9e, vous devez \00EAtre un administrateur de la liste de contr\00F4le d''acc\00E8s.')
,p_validation_condition=>'P1250_ACL_TYPE'
,p_validation_condition2=>'CUSTOM'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(176487811236203914.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(27519532463666832.4902)
,p_validation_name=>'P1250_EMAIL_FROM is valid'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at   number;',
'  l_dot  number;',
'begin',
'  l_at := instr(:P1250_EMAIL_FROM,''@'');',
'  l_dot := instr(:P1250_EMAIL_FROM,''.'',l_at);',
'  if l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1 then',
'      return true;',
'  end if;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Adresse \00E9lectronique non valide')
,p_validation_condition=>'P1250_EMAIL_FROM'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(27512507876659750.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(450941414963628450.4902)
,p_name=>'Set ACL Type to Custom'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_AUTHENTICATION'
,p_condition_element=>'P1250_AUTHENTICATION'
,p_triggering_condition_type=>'NOT_IN_LIST'
,p_triggering_expression=>'1,5'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(450941711017628453.4902)
,p_event_id=>wwv_flow_api.id(450941414963628450.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_ACL_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'CUSTOM'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(450943524968678675.4902)
,p_event_id=>wwv_flow_api.id(450941414963628450.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_ACL_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(450943310077674328.4902)
,p_event_id=>wwv_flow_api.id(450941414963628450.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_ACL_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461466701962334929.4902)
,p_name=>'HIDE ALL LOGO'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461467009032334931.4902)
,p_event_id=>wwv_flow_api.id(461466701962334929.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_TEXT,P1250_LOGO_TEXT_ATTRIBUTES,P1250_LOGO_IMAGE,P1250_LOGO_IMAGE_ATTRIBUTES,P1250_LOGO_FILEPATH,P1250_LOGO_FILEPATH_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461467322394340801.4902)
,p_name=>'SHOW LOGO TEXT'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_condition_element=>'P1250_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TEXT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461467629076340802.4902)
,p_event_id=>wwv_flow_api.id(461467322394340801.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_TEXT,P1250_LOGO_TEXT_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461467702786344625.4902)
,p_name=>'SHOW LOGO IMAGE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_condition_element=>'P1250_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'IMAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461468020881344625.4902)
,p_event_id=>wwv_flow_api.id(461467702786344625.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_IMAGE,P1250_LOGO_IMAGE_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461468216984348770.4902)
,p_name=>'SHOW LOGO FILEPATH'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_condition_element=>'P1250_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILEPATH'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461468512039348770.4902)
,p_event_id=>wwv_flow_api.id(461468216984348770.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_FILEPATH,P1250_LOGO_FILEPATH_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(477892828691319686.4902)
,p_name=>'show hide Custom CSS'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_PAGE_STYLE'
,p_condition_element=>'P1250_PAGE_STYLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'99'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(477893127654319689.4902)
,p_event_id=>wwv_flow_api.id(477892828691319686.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_CUSTOM_CSS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(477893331070319692.4902)
,p_event_id=>wwv_flow_api.id(477892828691319686.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_CUSTOM_CSS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(491770901494349628.4902)
,p_name=>'Hide Suggested Objects'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_ALLOW_SQL_YN'
,p_condition_element=>'P1250_ALLOW_SQL_YN'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'Yes'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(491778019175506114.4902)
,p_event_id=>wwv_flow_api.id(491770901494349628.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(487244921683683240.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(176490818593203958.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WS_APPLICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APPLICATIONS'
,p_attribute_03=>'P1250_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and id = :WS_APP_ID'))
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(176491030602203966.4902)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WS_APPLICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APPLICATIONS'
,p_attribute_03=>'P1250_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and id = :WS_APP_ID'))
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Impossible de traiter la ligne de la table WWV_FLOW_WS_APPLICATIONS.'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(458562012835219617.4902)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update HOME_PAGE_ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select HOME_PAGE_ID',
'     from WWV_FLOW_WS_APPLICATIONS',
'    where id = :WS_APP_ID',
'    and security_group_id = :WORKSPACE_ID )',
'loop',
'   :HOME_PAGE_ID := c1.home_page_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(176487811236203914.4902)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471231206393089068.4902)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set logo'
,p_process_sql_clob=>':F4900_LOGO := wwv_flow_ws_api.get_logo( p_ws_app_id=>:ws_app_id, p_security_group_id=>:flow_security_group_id);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01310
begin
wwv_flow_api.create_page(
 p_id=>1310.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er un \00E9tat')
,p_step_title=>unistr('Cr\00E9er un \00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20806403503994187.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181186531071637307.4902)
,p_plug_name=>unistr('Cr\00E9er un \00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181261824581154451.4902)
,p_plug_name=>'create report progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181250307256073810.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181263221726172554.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181262107050158898.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20806403503994187.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181271124244230065.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20806403503994187.4902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4902)
,p_button_image_alt=>'Suivant'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181262427136164696.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20806403503994187.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(181271305836230066.4902)
,p_branch_action=>'f?p=&FLOW_ID.:1320:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(181271124244230065.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181186714571637309.4902)
,p_name=>'P1310_REPORT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4902)
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez le nom de l''\00E9tat.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181186914960637313.4902)
,p_name=>'P1310_REPORT_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4902)
,p_item_default=>'TABLE'
,p_prompt=>unistr('Source de l''\00E9tat')
,p_source=>'TABLE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(181139517862367299.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez la fa\00E7on dont vous voulez d\00E9velopper votre requ\00EAte, en identifiant une table ou en entrant du code SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181266012291188798.4902)
,p_name=>'P1310_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4902)
,p_prompt=>'Nom de table ou de vue'
,p_post_element_text=>'<a href="javascript:popupURL(''f?p=4900:90:&SESSION.:::90,RIR:P90_SCHEMA:&P1310_SCHEMA.'');"><img src="#IMAGE_PREFIX#htmldb/icons/view_small.gif" width="18" height="18" valign="middle"/></a>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifiez le nom de la table sur laquelle l''\00E9tat sera bas\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181266401687195146.4902)
,p_name=>'P1310_QUERY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4902)
,p_prompt=>unistr('Requ\00EAte')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez la requ\00EAte SQL qui d\00E9finit l''\00E9tat.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458479923768361791.4902)
,p_name=>'P1310_REPORT_ALIAS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4902)
,p_prompt=>unistr('Alias d''\00E9tat')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Un alias d''\00E9tat permet de cr\00E9er des liens vers cet \00E9tat dans les sections d''une page. Chaque alias d''\00E9tat doit \00EAtre unique dans une application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492930302074769112.4902)
,p_name=>'P1310_SCHEMA'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sch\00E9ma')
,p_source=>'wwv_flow_ws_setup.get_apex$_schema(p_workspace_id=>:flow_security_group_id);'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifie le sch\00E9ma de feuille Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181273103727243002.4902)
,p_validation_name=>'P1310_TABLE_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1310_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom de table doit \00EAtre indiqu\00E9.')
,p_validation_condition=>'P1310_REPORT_SOURCE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(181266012291188798.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181273619311247515.4902)
,p_validation_name=>'P1310_QUERY not null'
,p_validation_sequence=>20
,p_validation=>'P1310_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La requ\00EAte doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'P1310_REPORT_SOURCE'
,p_validation_condition2=>'QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(181266401687195146.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181296117710606612.4902)
,p_validation_name=>'P1310_TABLE_NAME valid'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_match varchar2(30);',
'begin',
'    if :P1310_TABLE_NAME is not null then',
'        l_match := wwv_flow_builder.is_valid_table_or_view',
'          (:P1310_SCHEMA, :P1310_TABLE_NAME);',
'        if l_match = ''E'' then',
'          return true;',
'        elsif l_match = ''U'' then',
'          :P1310_TABLE_NAME := upper(:P1310_TABLE_NAME);',
'          return true;',
'        else    ',
'          return false;',
'        end if;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'&P1310_TABLE_NAME. n''est pas un nom de table valide.'
,p_validation_condition=>':P1310_TABLE_NAME is not null and :P1310_REPORT_SOURCE = ''TABLE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(181266012291188798.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181296300657620562.4902)
,p_validation_name=>'P1310_QUERY valid'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.is_valid_report_query (',
'  p_plug_source      => :P1310_QUERY,',
'  p_plug_source_type => ''SQL_QUERY'',',
'  p_owner            => :P1310_SCHEMA',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition_type=>'NEVER'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(181266401687195146.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(188187709408926344.4902)
,p_validation_name=>'P1310_REPORT_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P1310_REPORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom d''\00E9tat doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(181186714571637309.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458504504243696704.4902)
,p_validation_name=>'P1310_REPORT_ALIAS must be unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1310_REPORT_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P1310_REPORT_ALIAS,',
'    p_alias_type   => ''REPORT'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('L''alias d''\00E9tat existe d\00E9j\00E0. Saisissez-en un autre.')
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(458479923768361791.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488324302680240232.4902)
,p_validation_name=>'is valid sql'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_security.is_valid_sql (',
'    p_ws_app_id  => :WS_APP_ID,',
'    p_type       => :P1310_REPORT_SOURCE, ',
'    p_sql        => :P1310_QUERY,',
'    p_schema     => :P1310_SCHEMA,',
'    p_table_name => :P1310_TABLE_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1310_QUERY is not null or ',
':P1310_TABLE_NAME is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(689014210768200618.4902)
,p_validation_name=>'P1310_REPORT_NAME must be unique'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1310_REPORT_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists  (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P1310_REPORT_NAME,',
'    p_type         => ''REPORT'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nom d''\00E9tat existe d\00E9j\00E0. Saisissez un nom diff\00E9rent.')
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(181186714571637309.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513750411309137615.4902)
,p_validation_name=>'P1310_REPORT_ALIAS is valid'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1310_REPORT_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P1310_REPORT_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4902)
,p_associated_item=>wwv_flow_api.id(458479923768361791.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(181266700087204166.4902)
,p_name=>'display query'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_REPORT_SOURCE'
,p_condition_element=>'P1310_REPORT_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181267028924204168.4902)
,p_event_id=>wwv_flow_api.id(181266700087204166.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_QUERY'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181267212037204170.4902)
,p_event_id=>wwv_flow_api.id(181266700087204166.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_QUERY'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(181268910260216555.4902)
,p_name=>'display table'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_REPORT_SOURCE'
,p_condition_element=>'P1310_REPORT_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181269202182216557.4902)
,p_event_id=>wwv_flow_api.id(181268910260216555.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TABLE_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181269414181216558.4902)
,p_event_id=>wwv_flow_api.id(181268910260216555.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TABLE_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430278609659879937.4902)
,p_name=>'set report name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TABLE_NAME'
,p_condition_element=>'P1310_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'focusin'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430278917502879938.4902)
,p_event_id=>wwv_flow_api.id(430278609659879937.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_REPORT_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P1310_TABLE_NAME'')'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_01320
begin
wwv_flow_api.create_page(
 p_id=>1320.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Cr\00E9er un \00E9tat')
,p_step_title=>unistr('Cr\00E9er un \00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20812329177030021.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20815714679054203.4902)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181297307705626802.4902)
,p_plug_name=>unistr('Cr\00E9er un \00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Vous avez demand\00E9 la cr\00E9ation d''un \00E9tat avec les attributs suivants. Confirmez vos s\00E9lections.<br /><br />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181298124906626804.4902)
,p_plug_name=>'create report progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181250307256073810.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181299030786629328.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181297503760626803.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20812329177030021.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181297711481626803.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20812329177030021.4902)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>unistr('Cr\00E9er un \00E9tat')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181300227716656783.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20812329177030021.4902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4902)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(181298718190626810.4902)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.::WS_APP_ID,IR_ID,WS_ID:&WS_APP_ID.,&P1320_WORKSHEET_ID.,&P1320_WEBSHEET_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(181297711481626803.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181297919436626804.4902)
,p_name=>'P1320_REPORT_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sch\00E9ma')
,p_source=>'P1310_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181303817766710711.4902)
,p_name=>'P1320_REPORT_SOURCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Source de l''\00E9tat')
,p_source=>'P1310_REPORT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(181139517862367299.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181304108547717462.4902)
,p_name=>'P1320_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom de table'
,p_source=>'P1310_TABLE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P1310_REPORT_SOURCE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181305506946726463.4902)
,p_name=>'P1320_QUERY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Requ\00EAte')
,p_source=>'P1310_QUERY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P1310_REPORT_SOURCE'
,p_display_when2=>'QUERY'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181530212990431902.4902)
,p_name=>'P1320_REPORT_NAME'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_source=>'P1310_REPORT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459472219918508284.4902)
,p_name=>'P1320_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20815714679054203.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459472414932508288.4902)
,p_name=>'P1320_WEBSHEET_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20815714679054203.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181500204595098271.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create websheet report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_ws_report (',
'    p_ws_app_id      => :WS_APP_ID,        ',
'    p_flow_id        => :APP_ID,',
'    p_schema         => :P1310_SCHEMA,',
'    p_source_type    => :P1310_REPORT_SOURCE,',
'    p_report_name    => :P1310_REPORT_NAME,',
'    p_report_alias   => :P1310_REPORT_ALIAS,',
'    p_table_name     => :P1310_TABLE_NAME,',
'    p_query          => :P1310_QUERY,',
'    p_worksheet_id   => :P1320_WORKSHEET_ID,',
'    p_websheet_id    => :P1320_WEBSHEET_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de cr\00E9er l''\00E9tat.')
,p_process_when_button_id=>wwv_flow_api.id(181297711481626803.4902)
,p_process_success_message=>unistr('Etat cr\00E9\00E9.')
);
end;
/
prompt --application/pages/page_03000
begin
wwv_flow_api.create_page(
 p_id=>3000.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Etat'
,p_step_title=>'Etat'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(492214905335570870)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20912104119139293.4902)
,p_plug_name=>'Boutons droits de la barre d''outil'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20912629053146493.4902)
,p_plug_name=>'Hidden Region'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279128488493601.4902)
,p_plug_name=>'Layout 1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'<table border="0" cellpadding="0" cellspacing="0" width="100%" ><tr><td valign="top">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279310594493602.4902)
,p_plug_name=>'Layout 2'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td><td width="100%" valign="top" style="padding:0 0 0 15px;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279512150493603.4902)
,p_plug_name=>'Layout 3'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td></tr></table>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279910830493605.4902)
,p_plug_name=>'name'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183285705297524279.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631044792201195017.4902)
,p_plug_name=>unistr('afficher l''\00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DATA_GRID'
,p_attribute_01=>'IR_ID'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(183283719060493621.4902)
,p_branch_action=>'f?p=&FLOW_ID.:3000:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183280332465493606.4902)
,p_name=>'P3000_SHOW_CHECKBOX'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20912629053146493.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183281906745493610.4902)
,p_name=>'P3000_SHOW_TOOLBAR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20912629053146493.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184278725572053777.4902)
,p_name=>'P3000_REPORT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20912629053146493.4902)
,p_prompt=>'Report Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(183282303574493611.4902)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'2'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(184279327435063745.4902)
,p_computation_sequence=>20
,p_computation_item=>'P3000_REPORT_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_websheet_name(p_worksheet_id => :IR_ID);'
,p_computation_error_message=>unistr('Impossible d''obtenir le nom de l''\00E9tat.')
);
end;
/
prompt --application/pages/page_03010
begin
wwv_flow_api.create_page(
 p_id=>3010.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Modifier un \00E9tat')
,p_step_title=>unistr('Modifier un \00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"''; ',
' ',
' function apex_p3010_showImage(img_id){',
'  var lImg = $x(''edit_image'');',
'	var lSrc =''''',
'	switch(img_id){',
'    case 0:lSrc="#IMAGE_PREFIX#ws/small_page.gif";break;',
'	case 1:lSrc="#IMAGE_PREFIX#magnifying_glass_white_bg.gif";break;',
'	case 2:lSrc="#IMAGE_PREFIX#edit_big.gif";break;',
'	case 3:lSrc="#IMAGE_PREFIX#edit.gif";break;',
'	case 4:lSrc="#IMAGE_PREFIX#e2.gif";break;',
'	default:lSrc="#IMAGE_PREFIX#1px_white.gif";break',
'	}',
'	lImg.src = lSrc;',
'    return true;',
'  }',
'',
'  function apex_p3010_hideImage(){',
'    var lImg = $x(''edit_image'').src = "#IMAGE_PREFIX#1px_white.gif";',
'    return true;',
'  }',
'  ',
'  function apex_p3010_setColumnIDandSubmit(columnID){',
'    $x(''P3010_COLUMN_ID'').value=columnID;  ',
'    doSubmit(''SAVE_COLUMN'');',
'  }',
'  ',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183771819334108915.4902)
,p_plug_name=>'Colonne de lien'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186338205876681460.4902)
,p_plug_name=>'sous-vue monoligne'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186338516958684607.4902)
,p_plug_name=>'colonne de sous-liens'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4902)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186338828386687900.4902)
,p_plug_name=>'sous-URL'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4902)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186339511679702056.4902)
,p_plug_name=>unistr('ic\00F4ne de sous-lien')
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4902)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186352431129811698.4902)
,p_plug_name=>unistr('sous-\00E9tat ou URL')
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4902)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(183789730499443251.4902)
,p_name=>'Attributs de colonne'
,p_template=>wwv_flow_api.id(27071223638280295.4902)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'db_column_name,',
'wwv_flow_item.hidden(1,id)||',
'wwv_flow_item.text(2,display_order, 16, 255, ''class="orderby" style="display:none;" '')||',
'wwv_flow_item.text(5,report_label,16,255) report_label,',
'decode(nvl(column_link,''NOLINK''),',
'    ''NOLINK'',''&nbsp;'',',
'    ''<img src="#IMAGE_PREFIX#check_small_black.gif" width="15" height="15" alt="''||wwv_flow_lang.system_message(''F4000.LINK_COLUMN'')||''" />'') column_link,',
'column_type,',
'wwv_flow_item.select_list_from_lov(6,display_text_as,''IR_DISPLAY_TYPES'',null,''NO'') display_text_as',
'from wwv_flow_worksheet_columns c',
'where worksheet_id = :P3010_WORKSHEET_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by display_order'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46784125242633572.4902)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucun attribut de colonne trouv\00E9.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790030967443254.4902)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_column_link=>'javascript:apex_p3010_setColumnIDandSubmit(''#ID#'');'
,p_column_linktext=>unistr('<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" border="0" height="16" width="16" alt="Modifier des attributs de colonne suppl\00E9mentaires, ajouter des liens de colonne.">')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790123422443254.4902)
,p_query_column_id=>2
,p_column_alias=>'DB_COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790219053443254.4902)
,p_query_column_id=>3
,p_column_alias=>'REPORT_LABEL'
,p_column_display_sequence=>3
,p_column_heading=>unistr('En-t\00EAte')
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790312249443254.4902)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LINK'
,p_column_display_sequence=>5
,p_column_heading=>'Lien'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790416608443254.4902)
,p_query_column_id=>5
,p_column_alias=>'COLUMN_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790521735443254.4902)
,p_query_column_id=>6
,p_column_alias=>'DISPLAY_TEXT_AS'
,p_column_display_sequence=>6
,p_column_heading=>'Afficher le texte comme'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183860828861849647.4902)
,p_plug_name=>'Pagination'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436574504853227182.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457388232071871567.4902)
,p_plug_name=>unistr('Attributs d''\00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4902)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491742014533069516.4902)
,p_plug_name=>'navigation par onglets'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183777904236189775.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491742014533069516.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183778330556197286.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(491742014533069516.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183778121205194643.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491742014533069516.4902)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(187542503123392563.4902)
,p_branch_action=>'f?p=&APP_ID.:3020:&SESSION.::&DEBUG.:3020:P3020_COLUMN_ID,P3020_WORKSHEET_ID,P3020_WEBSHEET_ID:&P3010_COLUMN_ID.,&P3010_WORKSHEET_ID.,&P3010_WEBSHEET_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_COLUMN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491763709741172242.4902)
,p_branch_action=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>15
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_QUERY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(183778505753199625.4902)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(183778330556197286.4902)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188346821700508574.4902)
,p_branch_action=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:REPORT&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(183778121205194643.4902)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183782818613231757.4902)
,p_name=>'P3010_WEBSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(183789730499443251.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183784714560363003.4902)
,p_name=>'P3010_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(183789730499443251.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Worksheet Id'
,p_source=>'IR_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183987530329531247.4902)
,p_name=>'P3010_PAGINATION_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Type de pagination'
,p_source=>'PAGINATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_PAGINATION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(183988226651539622.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Aucune pagination s\00E9lectionn\00E9e -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Tr\00E8s souvent, seul un certain nombre de lignes d''un \00E9tat appara\00EEt sur une page. Pour obtenir les autres lignes, l''utilisateur de l''application doit passer \00E0 la page suivante de l''\00E9tat.<p />'),
unistr('La pagination renseigne l''utilisateur sur le nombre de lignes et sur la position en cours dans l''ensemble de r\00E9sultats.<p />'),
unistr('Elle peut figurer en haut ou en bas de l''\00E9tat (ou les deux), \00E0 gauche ou \00E0 droite. Les options de pagination disponibles sont les suivantes :'),
'<ul> ',
unistr('<li>Plages de lignes X \00E0 Y</li>  '),
unistr('<li>Plages de lignes X \00E0 Y sur Z</li></ul>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184005701211645859.4902)
,p_name=>'P3010_SHOW_NULLS_AS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Afficher les valeurs NULL comme'
,p_source=>'SHOW_NULLS_AS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>16
,p_cMaxlength=>255
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le texte \00E0 afficher pour les colonnes NULL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184006916973688202.4902)
,p_name=>'P3010_MAX_ROW_COUNT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre maximal de lignes'
,p_source=>'MAX_ROW_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>7
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9finit le nombre maximal de lignes \00E0 interroger. Cet attribut a une incidence sur les performances. R\00E9duire le nombre de lignes peut am\00E9liorer les performances. A l''inverse, interroger plusieurs milliers de lignes peut les alt\00E9rer.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184008821737708516.4902)
,p_name=>'P3010_MAX_ROW_COUNT_MESSAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Message personnalis\00E9 sur le nombre maximal de lignes')
,p_source=>'MAX_ROW_COUNT_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9finit le message texte qui appara\00EEt lorsque le nombre de lignes existantes est sup\00E9rieur au maximum. S''il est NULL, un message g\00E9n\00E9r\00E9 par le syst\00E8me sera affich\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184009529833720278.4902)
,p_name=>'P3010_NO_DATA_FOUND_MSG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Message personnalis\00E9 lorsque aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_source=>'NO_DATA_FOUND_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9finit le message texte qui appara\00EEt lorsque la requ\00EAte ne renvoie aucune ligne. S''il est NULL, un message g\00E9n\00E9r\00E9 par le syst\00E8me sera affich\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184013922261746508.4902)
,p_name=>'P3010_SHOW_DETAIL_LINK'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(183771819334108915.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Colonne de lien'
,p_source=>'SHOW_DETAIL_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_COLUMN'
,p_lov=>'.'||wwv_flow_api.id(184013026632738314.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La colonne de lien est incluse comme premi\00E8re colonne dans l''\00E9tat, et ne peut pas \00EAtre masqu\00E9e par l''utilisateur. Cette colonne permet d''acc\00E9der \00E0 une vue d\00E9taill\00E9e monoligne de la ligne s\00E9lectionn\00E9e, \00E0 une page de l''application ou \00E0 l''URL fournie.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184016323908765912.4902)
,p_name=>'P3010_DETAIL_F'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4902)
,p_prompt=>'Vue monoligne'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_DETAIL_PAGE_FUNCTIONALITY'
,p_lov=>'.'||wwv_flow_api.id(184015632435758855.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les options suivantes apparaissent dans la vue monoligne d''un \00E9tat. S\00E9lectionnez celles que vous souhaitez afficher.'),
'<ul>',
'<li>Autoriser l''exclusion des valeurs NULL : l''option Exclure les valeurs NULL permet d''exclure les colonnes incluant des valeurs NULL.</li>',
unistr('<li>Autoriser les colonnes affich\00E9es : cette option n''affiche que les colonnes apparaissant dans l''\00E9tat.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184019207548780090.4902)
,p_name=>'P3010_USE_PK'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4902)
,p_prompt=>unistr('Identifier les lignes de fa\00E7on unique par')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_ROWID_OR_COLS'
,p_lov=>'.'||wwv_flow_api.id(184017715035772751.4902)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Par d\00E9faut, ROWID permet d''identifier de fa\00E7on unique les lignes d''un \00E9tat. Vous pouvez \00E9galement entrer la colonne \00E0 utiliser.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184020125902785352.4902)
,p_name=>'P3010_PK1'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Colonne unique'
,p_source=>'BASE_PK1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Entrez la colonne permettant d''identifier de mani\00E8re unique les lignes de l''\00E9tat.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184020902961797735.4902)
,p_name=>'P3010_DETAIL_LINK_TEXT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return ''<img src="#''||''IMAGE_PREFIX''||''#ws/small_page.gif" alt="" />'';'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Ic\00F4ne de lien')
,p_post_element_text=>'"PICK_CURR_WS_RPT_COL"'
,p_source=>'DETAIL_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le texte HTML \00E0 utiliser pour le lien. Pour afficher une image, utilisez une balise d''image ou faites votre choix dans la liste des images par d\00E9faut. Si aucune valeur n''est d\00E9finie, <strong>#IMAGE_PREFIX#ws/small_page.gif</strong> sera uti')
||unistr('lis\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184021505301817255.4902)
,p_name=>'P3010_PREVIEW'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4902)
,p_source=>'<div style="height:30px;width:60px;font-size:small;border:1px #cccccc solid;background:#ffffff"><img src="#IMAGE_PREFIX#1px_white.gif" id="edit_image" alt="" name="edit_image" /></div>'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184021731274824760.4902)
,p_name=>'P3010_DETAIL_LINK_IMAGE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4902)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_itemlink varchar2(32767) := null;',
'begin  ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''ws/small_page.gif" alt="">'')||'''''');" onmouseover="apex_p'
||'3010_showImage(0)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',1)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''magnifying_glass_white_bg.gif" alt="">'')||'''''');" onmouse'
||'over="apex_p3010_showImage(1)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',2)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit_big.gif" alt="">'')||'''''');"onmouseover="apex_p3010_s'
||'howImage(2)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',3)||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit.gif" alt="">'')||'''''');" onmouseover="apex_p3010_show'
||'Image(3)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',4)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''e2.gif" alt="">'')||'''''');" onmouseover="apex_p3010_showIm'
||'age(4)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',5)||'']</a>''; ',
'  return l_itemlink;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184022826473851811.4902)
,p_name=>'P3010_DETAIL_LINK_ATTR'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributs de lien'
,p_source=>'DETAIL_LINK_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>62
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez des attributs de lien d\00E9tail suppl\00E9mentaires \00E0 inclure dans la balise &lt;a href=...&gt;, tels qu''une cible de lien, des classes ou des styles. '),
'',
'<p>target="_blank"</p>',
'<p>title="Cliquez ici pour modifier la valeur"</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184025109682884777.4902)
,p_name=>'P3010_URL_OR_REPORT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(186352431129811698.4902)
,p_item_default=>'REPORT'
,p_prompt=>'Cible'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_REPORT'
,p_lov=>'.'||wwv_flow_api.id(184024419940878266.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indiquez une cible d''URL. Vous pouvez viser un \00E9tat de l''application en cours ou une URL pointant sur d''autres applications ou sur des sites externes.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184029505900110722.4902)
,p_name=>'P3010_LB_WS_ID'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_REPORTS_IN_CURRENT_APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un \00E9tat -')
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le nom d''\00E9tat pour un lien.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184090023945418730.4902)
,p_name=>'P3010_LB_RESET_IR'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_RESET'
,p_lov=>'.'||wwv_flow_api.id(184090310224424164.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184097928016438807.4902)
,p_name=>'P3010_LB_COL1'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>'Colonne'
,p_post_element_text=>'"PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9finissez le filtre pour la colonne sp\00E9cifi\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184098110617452740.4902)
,p_name=>'P3010_LB_OPR1'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>unistr('Op\00E9rateur')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un op\00E9rateur -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez l''op\00E9rateur du filtre de colonne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184098301398459459.4902)
,p_name=>'P3010_LB_VALUE1'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>'Expression'
,p_post_element_text=>'"PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez l''expression de filtre.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184113301014506673.4902)
,p_name=>'P3010_X4'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184142204402602240.4902)
,p_name=>'P3010_LB_CLEAR_IR'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_CLEAR_SETTINGS'
,p_lov=>'.'||wwv_flow_api.id(184141723318598286.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184150705703621532.4902)
,p_name=>'P3010_LB_COL2'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>'Colonne'
,p_post_element_text=>'"PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151011936623336.4902)
,p_name=>'P3010_LB_OPR2'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>unistr('Op\00E9rateur')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un op\00E9rateur -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151218170625182.4902)
,p_name=>'P3010_LB_VALUE2'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>'Valeur'
,p_post_element_text=>'"PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151423711626784.4902)
,p_name=>'P3010_LB_COL3'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>'Colonne'
,p_post_element_text=>'"PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151730290628632.4902)
,p_name=>'P3010_LB_OPR3'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>unistr('Op\00E9rateur')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un op\00E9rateur -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151903756630505.4902)
,p_name=>'P3010_LB_VALUE3'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4902)
,p_prompt=>'Valeur'
,p_post_element_text=>'"PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184152315315643256.4902)
,p_name=>'P3010_LB_URL'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(186338828386687900.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'DETAIL_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>92
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez l''URL pointant vers d''autres applications ou sites externes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185506411845254149.4902)
,p_name=>'P3010_ALLOW_EXCLUDE_NULL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Exclude Null Values'
,p_source=>'ALLOW_EXCLUDE_NULL_VALUES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185506621541256939.4902)
,p_name=>'P3010_ALLOW_HIDE_EXTRA_COLS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Hide Extra Columns'
,p_source=>'ALLOW_HIDE_EXTRA_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187542007448355954.4902)
,p_name=>'P3010_COLUMN_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(183789730499443251.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(457389308784883762.4902)
,p_name=>'P3010_REPORT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(457388232071871567.4902)
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifiez le nom de l''\00E9tat. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(457389632118899915.4902)
,p_name=>'P3010_REPORT_ALIAS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(457388232071871567.4902)
,p_prompt=>unistr('Alias d''\00E9tat')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Un alias d''\00E9tat permet de cr\00E9er des liens vers cet \00E9tat dans les sections d''une page. Chaque alias d''\00E9tat doit \00EAtre unique dans une application. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(185285814372809981.4902)
,p_computation_sequence=>10
,p_computation_item=>'P3010_LB_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.build_ws_rpt_link_url (  ',
'    p_ws_app_id         => :ws_app_id,  ',
'    p_websheet_id       => :P3010_LB_WS_ID,',
'    p_reset_ir          => :P3010_LB_RESET_IR,',
'    p_clear_ir          => :P3010_LB_CLEAR_IR,',
'    p_column1           => :P3010_LB_COL1,',
'    p_operator1         => :P3010_LB_OPR1,',
'    p_value1            => :P3010_LB_VALUE1,    ',
'    p_column2           => :P3010_LB_COL2,',
'    p_operator2         => :P3010_LB_OPR2,',
'    p_value2            => :P3010_LB_VALUE2,    ',
'    p_column3           => :P3010_LB_COL3,',
'    p_operator3         => :P3010_LB_OPR3,',
'    p_value3            => :P3010_LB_VALUE3',
'    );'))
,p_compute_when=>'P3010_URL_OR_REPORT'
,p_compute_when_text=>'REPORT'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(617311407479937225.4902)
,p_computation_sequence=>20
,p_computation_item=>'P3010_PK1'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P3010_USE_PK'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187844217876488819.4902)
,p_computation_sequence=>20
,p_computation_item=>'P3010_WEBSHEET_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_ws_websheet_attr',
'where worksheet_id = :P3010_WORKSHEET_ID',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(617311372674937224.4902)
,p_computation_sequence=>30
,p_computation_item=>'P3010_USE_PK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_grid in (select null',
'               from wwv_flow_worksheets',
'               where id = :P3010_WORKSHEET_ID',
'               and security_group_id = :flow_security_group_id',
'               and base_pk1 is not null)',
'loop',
'    -- if based pk defined, it''s not using ROWID',
'    return ''N'';',
'end loop;',
'return ''Y'';'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185286425238822581.4902)
,p_validation_name=>'P3010_MAX_ROW_COUNT must be number'
,p_validation_sequence=>10
,p_validation=>'P3010_MAX_ROW_COUNT'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('Le nombre maximal de lignes doit \00EAtre num\00E9rique.')
,p_validation_condition=>'P3010_MAX_ROW_COUNT'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(184006916973688202.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185286614288828883.4902)
,p_validation_name=>'P3010_PK1not null'
,p_validation_sequence=>20
,p_validation=>'P3010_PK1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Une colonne unique doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'(:P3010_SHOW_DETAIL_LINK = ''Y'') and (:P3010_USE_PK = ''N'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(184020125902785352.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185286806800836129.4902)
,p_validation_name=>'P3010_DETAIL_LINK_TEXT not null'
,p_validation_sequence=>30
,p_validation=>'P3010_DETAIL_LINK_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''ic\00F4ne de lien doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'P3010_SHOW_DETAIL_LINK'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(184020902961797735.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457454703093071343.4902)
,p_validation_name=>'P3010_REPORT_NAME not null'
,p_validation_sequence=>40
,p_validation=>'P3010_REPORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(457389308784883762.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457455920408076283.4902)
,p_validation_name=>'P3010_REPORT_ALIAS not null'
,p_validation_sequence=>50
,p_validation=>'P3010_REPORT_ALIAS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(457389632118899915.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457462725444191308.4902)
,p_validation_name=>'P3010_REPORT_ALIAS must be unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3010_REPORT_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists(',
'     p_ws_app_id=>:WS_APP_ID,',
'     p_alias=>:P3010_REPORT_ALIAS,',
'     p_alias_type=>''REPORT'',',
'     p_worksheet_id=>:P3010_WORKSHEET_ID) then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('L''alias d''\00E9tat existe d\00E9j\00E0. Saisissez-en un autre.')
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(457389632118899915.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(711664422399287229.4902)
,p_validation_name=>'P3010_REPORT_NAME must be unique'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3010_REPORT_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists  (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P3010_REPORT_NAME,',
'    p_type         => ''REPORT'',',
'    p_worksheet_id => :P3010_WORKSHEET_ID) then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nom d''\00E9tat existe d\00E9j\00E0. Saisissez un nom diff\00E9rent.')
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(457389308784883762.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513767814649272788.4902)
,p_validation_name=>'P3010_REPORT_ALIAS is valid'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3010_REPORT_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P3010_REPORT_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4902)
,p_associated_item=>wwv_flow_api.id(457389632118899915.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186342221292723689.4902)
,p_name=>'hide all'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186342516454723689.4902)
,p_event_id=>wwv_flow_api.id(186342221292723689.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338205876681460.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186342809648729836.4902)
,p_event_id=>wwv_flow_api.id(186342221292723689.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186343016228731695.4902)
,p_event_id=>wwv_flow_api.id(186342221292723689.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186343220037732813.4902)
,p_event_id=>wwv_flow_api.id(186342221292723689.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186353531044830587.4902)
,p_event_id=>wwv_flow_api.id(186342221292723689.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186352431129811698.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184768518625717500.4902)
,p_name=>'link column = Y'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_condition_element=>'P3010_SHOW_DETAIL_LINK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186343609087739123.4902)
,p_event_id=>wwv_flow_api.id(184768518625717500.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338205876681460.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186351709396786481.4902)
,p_event_id=>wwv_flow_api.id(184768518625717500.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186366918633931095.4902)
,p_name=>'link column = C'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_condition_element=>'P3010_SHOW_DETAIL_LINK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'C'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186367227927931096.4902)
,p_event_id=>wwv_flow_api.id(186366918633931095.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186367400756935337.4902)
,p_event_id=>wwv_flow_api.id(186366918633931095.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186352431129811698.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184770806121761252.4902)
,p_name=>'link column = N'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_condition_element=>'P3010_SHOW_DETAIL_LINK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(184771126910761253.4902)
,p_event_id=>wwv_flow_api.id(184770806121761252.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338205876681460.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186345318222751244.4902)
,p_event_id=>wwv_flow_api.id(184770806121761252.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186345522377752412.4902)
,p_event_id=>wwv_flow_api.id(184770806121761252.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186345827918754056.4902)
,p_event_id=>wwv_flow_api.id(184770806121761252.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184774706822837085.4902)
,p_name=>'hide unique column'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK,P3010_USE_PK'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$v(''P3010_SHOW_DETAIL_LINK'')===''Y'' &&',
'$v(''P3010_USE_PK'')===''N'''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(184775027064837086.4902)
,p_event_id=>wwv_flow_api.id(184774706822837085.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3010_PK1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(184775212671837086.4902)
,p_event_id=>wwv_flow_api.id(184774706822837085.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3010_PK1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184364122641216529.4902)
,p_name=>'link column = C and REPORT'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK,P3010_URL_OR_REPORT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$v(''P3010_SHOW_DETAIL_LINK'')===''C'' &&',
'$v(''P3010_URL_OR_REPORT'')===''REPORT'''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186366010406909809.4902)
,p_event_id=>wwv_flow_api.id(184364122641216529.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186371311679052039.4902)
,p_event_id=>wwv_flow_api.id(184364122641216529.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(185690710345795759.4902)
,p_name=>'link column = C and URL'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK,P3010_URL_OR_REPORT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$v(''P3010_SHOW_DETAIL_LINK'')===''C'' &&',
'$v(''P3010_URL_OR_REPORT'')===''URL'''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186366709845919130.4902)
,p_event_id=>wwv_flow_api.id(185690710345795759.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186371103021049577.4902)
,p_event_id=>wwv_flow_api.id(185690710345795759.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185507407951271929.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set detail view option item value'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_detail_f varchar2(32767) := null;',
'begin',
'  l_detail_f := '':''||:P3010_DETAIL_F||'':'';  ',
' ',
'  if instr(l_detail_f,'':EXCLUDE_NULL:'',1) > 0 then',
'    :P3010_ALLOW_EXCLUDE_NULL := ''Y'';',
'  else',
'    :P3010_ALLOW_EXCLUDE_NULL := ''N'';',
'  end if;',
'  if instr(l_detail_f,'':HIDE_EXTR_COL:'',1) > 0 then',
'    :P3010_ALLOW_HIDE_EXTRA_COLS := ''Y'';',
'  else',
'    :P3010_ALLOW_HIDE_EXTRA_COLS := ''N'';',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de d\00E9finir les valeurs de la fonctionnalit\00E9 de vue monoligne.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185287112472847246.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update column attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  n number;',
'  r number;',
'  g number;  ',
'begin',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  n := wwv_flow.g_f01(i);',
'  r := wwv_flow.g_f02(i);',
'  ',
'  -- update report label, display text as',
'  update wwv_flow_worksheet_columns',
'  set report_label = wwv_flow.g_f05(i),',
'      display_text_as = wwv_flow.g_f06(i)',
'  where id = n and',
'     flow_id = :app_id and',
'     security_group_id = :flow_security_group_id;',
'  ',
'  -- update column seq',
'  update wwv_flow_worksheet_columns',
'  set display_order = r',
'  where id = n and',
'     flow_id = :app_id and',
'     display_order != r and',
'     security_group_id = :flow_security_group_id;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de modifier les attributs de colonne.'
,p_process_when=>'APPLY_CHANGES,SAVE_COLUMN,SAVE_QUERY'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185287907408855274.4902)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update ir'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.edit_ws_report_attr (',
'    p_worksheet_id              => :P3010_WORKSHEET_ID,',
'    p_websheet_id               => :P3010_WEBSHEET_ID,',
'    p_websheet_name             => :P3010_REPORT_NAME,',
'    p_websheet_alias            => :P3010_REPORT_ALIAS,',
'    p_max_row_count             => :P3010_MAX_ROW_COUNT,',
'    p_max_row_count_message     => :P3010_MAX_ROW_COUNT_MESSAGE,',
'    p_no_data_found_message     => :P3010_NO_DATA_FOUND_MSG,    ',
'    p_base_pk1                  => :P3010_PK1,',
'    p_show_nulls_as             => :P3010_SHOW_NULLS_AS,',
'    p_pagination_type           => :P3010_PAGINATION_TYPE,',
'    p_show_detail_link          => :P3010_SHOW_DETAIL_LINK,',
'    p_detail_link               => :P3010_LB_URL,',
'    p_detail_link_text          => :P3010_DETAIL_LINK_TEXT,',
'    p_detail_link_attr          => :P3010_DETAIL_LINK_ATTR,',
'    p_allow_exclude_null_values => :P3010_ALLOW_EXCLUDE_NULL,',
'    p_allow_hide_extra_columns  => :P3010_ALLOW_HIDE_EXTRA_COLS',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de modifier l''\00E9tat.')
,p_process_when=>'APPLY_CHANGES,SAVE_COLUMN,SAVE_QUERY'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185288529618890083.4902)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete ir '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_validation_error varchar2(4000) := null;',
'begin',
'    wwv_flow_ws_api.delete_websheet (',
'        p_worksheet_id     => :P3010_WORKSHEET_ID,',
'        p_websheet_id      => :P3010_WEBSHEET_ID,',
'        p_websheet_type    => ''REPORT'',',
'        p_confirm          => ''Y'',',
'        p_validation_error => l_validation_error);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de supprimer l''\00E9tat.')
,p_process_when_button_id=>wwv_flow_api.id(183778121205194643.4902)
,p_process_success_message=>unistr('Etat supprim\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185037826832987670.4902)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'fetch row from wwv_flow_worksheets'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WORKSHEETS'
,p_attribute_03=>'P3010_WORKSHEET_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185534723853399474.4902)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set detail view functionaltiy options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_detail_f varchar2(32767) := null;  ',
'begin  ',
'  if :P3010_ALLOW_EXCLUDE_NULL = ''Y'' then',
'    l_detail_f := ''EXCLUDE_NULL'';',
'  end if;',
'  if :P3010_ALLOW_HIDE_EXTRA_COLS = ''Y'' then',
'    l_detail_f := l_detail_f||wwv_flow_utilities.ite(l_detail_f is not null,'':HIDE_EXTR_COL'',''HIDE_EXTR_COL'');',
'  end if;',
'',
'  :P3010_DETAIL_F := l_detail_f;  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de d\00E9finir les options de la fonctionnalit\00E9 de vue monoligne.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(457454022655039086.4902)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get ws report attr'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_ws_report_attr (',
'    p_websheet_id  => :P3010_WEBSHEET_ID,',
'    p_name         => :P3010_REPORT_NAME,',
'    p_alias        => :P3010_REPORT_ALIAS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''obtenir les attributs d''\00E9tat.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185283314353658618.4902)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'split url'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select detail_link',
'           from   wwv_flow_worksheets',
'           where  id = :P3010_WORKSHEET_ID',
'           and    security_group_id = :flow_security_group_id)',
'loop         ',
'  wwv_flow_ws_api.split_ws_rpt_link_url (',
'    p_url               => c1.detail_link,',
'    --',
'    p_websheet_id       => :P3010_LB_WS_ID,',
'    p_reset_ir          => :P3010_LB_RESET_IR,',
'    p_clear_ir          => :P3010_LB_CLEAR_IR,',
'    p_column1           => :P3010_LB_COL1,',
'    p_operator1         => :P3010_LB_OPR1,',
'    p_value1            => :P3010_LB_VALUE1,    ',
'    p_column2           => :P3010_LB_COL2,',
'    p_operator2         => :P3010_LB_OPR2,',
'    p_value2            => :P3010_LB_VALUE2,    ',
'    p_column3           => :P3010_LB_COL3,',
'    p_operator3         => :P3010_LB_OPR3,',
'    p_value3            => :P3010_LB_VALUE3',
'    );',
'    ',
'  ',
'  if :P3010_LB_WS_ID is not null then',
'    :P3010_URL_OR_REPORT := ''REPORT'';',
'  end if;',
'  if c1.detail_link is null then',
'    :P3010_URL_OR_REPORT := ''REPORT'';',
'  end if;   ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de fractionner l''URL.'
);
end;
/
prompt --application/pages/page_03020
begin
wwv_flow_api.create_page(
 p_id=>3020.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Modifier une colonne d''\00E9tat')
,p_step_title=>unistr('Modifier une colonne d''\00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
' function apex_p3020_showImage(img_id){',
'  var lImg = $x(''edit_image'');',
'	var lSrc =''''',
'	switch(img_id){',
'        case 0:lSrc="#IMAGE_PREFIX#ws/small_page.gif";break;',
'	case 1:lSrc="#IMAGE_PREFIX#magnifying_glass_white_bg.gif";break;',
'	case 2:lSrc="#IMAGE_PREFIX#edit_big.gif";break;',
'	case 3:lSrc="#IMAGE_PREFIX#edit.gif";break;',
'	case 4:lSrc="#IMAGE_PREFIX#e2.gif";break;',
'	default:lSrc="#IMAGE_PREFIX#1px_white.gif";break',
'	}',
'	lImg.src = lSrc;',
'    return true;',
'  }',
'',
' function apex_p3020_popUpBlobFormat(){      ',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=dummy'', $v(''pFlowStepId''));',
'    get.add(''P3020_FORMAT_MASK'',$v(''P3020_FORMAT_MASK''));    ',
'    gReturn = get.get();',
'    get = null;',
'             ',
'    popUp2(''f?p=''+$v(''pFlowId'')+'':33:''+$v(''pInstance'')+'':::33'',600,550); ',
'  }',
'//-->',
'</script>  '))
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108407904321468301.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184267326302006596.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184268917430013579.4902)
,p_plug_name=>unistr('D\00E9finition de colonne')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4902)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184269528511016767.4902)
,p_plug_name=>'Liste de valeurs (LOV)'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186213200242556131.4902)
,p_plug_name=>'Colonne de lien'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4902)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186236905427831971.4902)
,p_plug_name=>'lien de colonne'
,p_parent_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4902)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186237113739834405.4902)
,p_plug_name=>'URL du lien'
,p_parent_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4902)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491765700914207563.4902)
,p_plug_name=>'navigation par onglets'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184261124819995612.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491765700914207563.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184261314395995613.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491765700914207563.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491766130004215935.4902)
,p_branch_action=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_QUERY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491766304855218074.4902)
,p_branch_action=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_REPORT_ATTR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(187437909753856015.4902)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3701399101377.4902)
,p_name=>'P3020_ALLOW_PIVOT'
,p_item_sequence=>520
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Pivot'
,p_source=>'ALLOW_PIVOT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185532815972378290.4902)
,p_name=>'P3020_REPORT_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name from wwv_flow_ws_websheet_attr',
'where id = :P3010_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186201028331516947.4902)
,p_name=>'P3020_COLUMN_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_prompt=>'Column Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186201305605519802.4902)
,p_name=>'P3020_WORKSHEET_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214032729556135.4902)
,p_name=>'P3020_LINK_TEXT'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ic\00F4ne de lien')
,p_post_element_text=>'"P3020_PICK_CURR_WS_RPT_COL"'
,p_source=>'COLUMN_LINKTEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214226510556136.4902)
,p_name=>'P3020_X3'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214407327556137.4902)
,p_name=>'P3020_LB_RESET_IR'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_RESET'
,p_lov=>'.'||wwv_flow_api.id(184090310224424164.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214604669556137.4902)
,p_name=>'P3020_LB_VALUE1'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>'Valeur'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214832124556138.4902)
,p_name=>'P3020_LB_OPR2'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>unistr('Op\00E9rateur')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un op\00E9rateur -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186215011346556139.4902)
,p_name=>'P3020_LB_OPR3'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>unistr('Op\00E9rateur')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un op\00E9rateur -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186215416542556140.4902)
,p_name=>'P3020_LINK_ATTR'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributs de lien'
,p_source=>'COLUMN_LINK_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>62
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez des attributs de lien d\00E9tail suppl\00E9mentaires \00E0 inclure dans la balise &lt;a href=...&gt;, tels qu''une cible de lien, des classes ou des styles. '),
'',
'<p>target="_blank"</p>',
'<p>title="Cliquez ici pour modifier la valeur"</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216019958556141.4902)
,p_name=>'P3020_LB_COL1'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>'Colonne'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216214026556142.4902)
,p_name=>'P3020_LB_CLEAR_IR'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_CLEAR_SETTINGS'
,p_lov=>'.'||wwv_flow_api.id(184141723318598286.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216528181556142.4902)
,p_name=>'P3020_LB_COL2'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>'Colonne'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216720198556143.4902)
,p_name=>'P3020_LB_VALUE3'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>'Valeur'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216912689556143.4902)
,p_name=>'P3020_LINK_IMAGE'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_itemlink varchar2(32767) := null;',
'begin  ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''ws/small_page.gif" alt="">'')||'''''');" onmouseover="apex_p3020_sh'
||'owImage(0)" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',1)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''magnifying_glass_white_bg.gif" alt="">'')||'''''');" onmouseover="a'
||'pex_p3020_showImage(1)" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',2)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit_big.gif" alt="">'')||'''''');"onmouseover="apex_p3020_showImag'
||'e(2)" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',3)||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit.gif" alt="">'')||'''''');" onmouseover="apex_p3020_showImage(3'
||')" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',4)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''e2.gif" alt="">'')||'''''');" onmouseover="apex_p3020_showImage(4)"'
||' onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',5)||'']</a>''; ',
'  return l_itemlink;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186217126218556144.4902)
,p_name=>'P3020_URL_OR_REPORT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_item_default=>'REPORT'
,p_prompt=>'Cible'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_REPORT'
,p_lov=>'.'||wwv_flow_api.id(184024419940878266.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186217301834556144.4902)
,p_name=>'P3020_LB_WS_ID'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_REPORTS_IN_CURRENT_APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un \00E9tat -')
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186217510592556145.4902)
,p_name=>'P3020_LB_OPR1'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>unistr('Op\00E9rateur')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4902)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un op\00E9rateur -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218132124556146.4902)
,p_name=>'P3020_PREVIEW'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4902)
,p_source=>'<div style="height:30px;width:60px;font-size:small;border:1px #cccccc solid;background:#ffffff"><img src="#IMAGE_PREFIX#1px_white.gif" id="edit_image" alt="" name="edit_image" /></div>'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218307991556147.4902)
,p_name=>'P3020_LB_COL3'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>'Colonne'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218526547556147.4902)
,p_name=>'P3020_LB_URL'
,p_item_sequence=>510
,p_item_plug_id=>wwv_flow_api.id(186237113739834405.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'COLUMN_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>92
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218724545556148.4902)
,p_name=>'P3020_X4'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186219322440556149.4902)
,p_name=>'P3020_LB_VALUE2'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4902)
,p_prompt=>'Valeur'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187438930475856034.4902)
,p_name=>'P3020_DB_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom de colonne'
,p_source=>'DB_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>128
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le nom de la colonne de requ\00EAte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187440305826856038.4902)
,p_name=>'P3020_COLUMN_LABEL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Libell\00E9 de vue monoligne')
,p_source=>'COLUMN_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Entrez le libell\00E9 de colonne \00E0 utiliser dans la vue monoligne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187440723465856039.4902)
,p_name=>'P3020_REPORT_LABEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('En-t\00EAte de colonne')
,p_source=>'REPORT_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le texte d''en-t\00EAte de colonne de l''\00E9tat.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187441102743856040.4902)
,p_name=>'P3020_SYNC_FORM_LABEL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Utiliser le m\00EAme texte pour la vue monoligne')
,p_source=>'SYNC_FORM_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_SAME_LABEL_FOR_DETAIL_VIEW'
,p_lov=>'.'||wwv_flow_api.id(187510818230037360.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Cochez cette option si vous souhaitez utiliser le texte d''en-t\00EAte de colonne comme libell\00E9 dans la vue d\00E9tail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187441706603856041.4902)
,p_name=>'P3020_ALLOW_SORTING'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Sorting'
,p_source=>'ALLOW_SORTING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187442128281856042.4902)
,p_name=>'P3020_ALLOW_FILTERING'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Filtering'
,p_source=>'ALLOW_FILTERING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187442528157856043.4902)
,p_name=>'P3020_ALLOW_CTRL_BREAKS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Ctrl Breaks'
,p_source=>'ALLOW_CTRL_BREAKS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187442923839856044.4902)
,p_name=>'P3020_ALLOW_AGGREGATIONS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Aggregations'
,p_source=>'ALLOW_AGGREGATIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187443317324856045.4902)
,p_name=>'P3020_ALLOW_COMPUTATIONS'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Computations'
,p_source=>'ALLOW_COMPUTATIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187443720910856046.4902)
,p_name=>'P3020_ALLOW_CHARTING'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Charting'
,p_source=>'ALLOW_CHARTING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187444129680856047.4902)
,p_name=>'P3020_ALLOW_GROUP_BY'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Group By'
,p_source=>'ALLOW_GROUP_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187445122268856049.4902)
,p_name=>'P3020_ALLOW_FILTERS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Filters'
,p_source=>'ALLOW_FILTERS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187445703344856051.4902)
,p_name=>'P3020_COLUMN_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Type de colonne'
,p_source=>'COLUMN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le type de la colonne de requ\00EAte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187446512466856053.4902)
,p_name=>'P3020_DISPLAY_TEXT_AS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Afficher le texte comme'
,p_source=>'DISPLAY_TEXT_AS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_DISPLAY_TYPES'
,p_lov=>'.'||wwv_flow_api.id(183810312847513834.4902)||'.'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Utilisez cette option pour d\00E9finir le mode d''affichage des valeurs de colonne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187446916751856054.4902)
,p_name=>'P3020_HEADING_ALIGNMENT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Alignement d''en-t\00EAte')
,p_source=>'HEADING_ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ALIGNMENT_L_C_R'
,p_lov=>'.'||wwv_flow_api.id(187517603302080409.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Contr\00F4le l''alignement des en-t\00EAtes. Votre s\00E9lection d''alignement doit \00EAtre prise en charge par le mod\00E8le d''\00E9tat s\00E9lectionn\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187447308656856055.4902)
,p_name=>'P3020_COLUMN_ALIGNMENT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alignement de colonne'
,p_source=>'COLUMN_ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ALIGNMENT_L_C_R'
,p_lov=>'.'||wwv_flow_api.id(187517603302080409.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez l''alignement de colonne. Votre s\00E9lection d''alignement doit \00EAtre prise en charge par le mod\00E8le d''\00E9tat s\00E9lectionn\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187448529502856058.4902)
,p_name=>'P3020_FORMAT_MASK'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format nombre/date'
,p_source=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT MASK DYNAMIC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from wwv_flow_format_masks'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Applique des masques de format num\00E9rique aux colonnes num\00E9riques et des masques de format de date aux colonnes de date. Pour s\00E9lectionner un type pr\00E9d\00E9fini et voir des exemples, faites votre choix dans la liste.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187449106912856059.4902)
,p_name=>'P3020_RPT_LOV'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(184269528511016767.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('D\00E9finition de liste de valeurs (LOV) (saisissez une requ\00EAte SQL renvoyant une colonne)')
,p_source=>'RPT_LOV'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez une requ\00EAte SQL \00E0 utiliser \00E0 la place d''une requ\00EAte g\00E9n\00E9r\00E9e automatiquement qui s\00E9lectionne les diff\00E9rentes valeurs de colonne. En saisissant une requ\00EAte SQL, vous pouvez am\00E9liorer les performances dans certains \00E9tats. Cette liste de valeur')
||unistr('s sera affich\00E9e lorsqu''un utilisateur cliquera sur un en-t\00EAte de colonne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187449532432856060.4902)
,p_name=>'P3020_RPT_SHOW_FILTER_LOV'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(184269528511016767.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Liste de valeurs (LOV) de filtre de colonne'
,p_source=>'RPT_SHOW_FILTER_LOV'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_COLUMN_FILTER_LOV'
,p_lov=>'.'||wwv_flow_api.id(187536631811296748.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez comment d\00E9river la liste de valeurs (LOV) comme filtre sur la liste d\00E9roulante de la colonne d''\00E9tat.'),
'<ul>',
unistr('<li>Aucun : d\00E9sactive les filtres pour la liste de valeurs.</li>'),
unistr('<li>Valeur par d\00E9faut bas\00E9e sur le type de colonne : les colonnes STRING et NUMBER d\00E9riveront la liste de valeurs des valeurs distinctes de colonne. Les colonnes DATE d\00E9riveront la liste de valeurs des plages de dates pr\00E9d\00E9finies.</li>'),
unistr('<li>Utiliser la liste de valeurs d\00E9finie : d\00E9rive la liste de valeurs de la requ\00EAte SQL de la liste de valeurs d\00E9finie.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187451707339856066.4902)
,p_name=>'P3020_ALLOW_HIGHLIGHTING'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Highlighting'
,p_source=>'ALLOW_HIGHLIGHTING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187512930828050488.4902)
,p_name=>'P3020_X2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187515801785070450.4902)
,p_name=>'P3020_X5'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187523430014116498.4902)
,p_name=>'P3020_COLUMN_F'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_prompt=>unistr('Autoriser les utilisateurs \00E0')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_COLUMN_FUNCTIONALITY'
,p_lov=>'.'||wwv_flow_api.id(187521603695108878.4902)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les op\00E9rations suivantes peuvent \00EAtre r\00E9alis\00E9es dans cette colonne. S\00E9lectionnez celles que vous souhaitez exposer aux utilisateurs.'),
'<ul>',
'<li>Trier : trie sur la base de la colonne.</li>',
unistr('<li>Filtrer : cr\00E9e des filtres sur la colonne.</li>'),
unistr('<li>Mise en \00E9vidence : cr\00E9e des mises en \00E9vidence sur la colonne.</li>'),
unistr('<li>Commande BREAK : g\00E9n\00E8re une commande BREAK sur la colonne.</li>'),
unistr('<li>Agr\00E9gat : ajoute des calculs agr\00E9g\00E9s \00E0 la colonne.</li>'),
unistr('<li>Calculer : ajoute des calculs bas\00E9s sur la colonne.</li>'),
unistr('<li>Graphique : cr\00E9e un graphique bas\00E9 sur les donn\00E9es de la colonne.</li>'),
unistr('<li>Grouper par : cr\00E9e un groupe par vue bas\00E9 sur les donn\00E9es de colonne.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'10'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187527415862140834.4902)
,p_name=>'P3020_X6'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187539908870309033.4902)
,p_name=>'P3020_X7'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(184269528511016767.4902)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187887632681262198.4902)
,p_name=>'P3020_WEBSHEET_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261251003866848945.4902)
,p_name=>'P3020_ALLOW_HIDE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Hide'
,p_source=>'ALLOW_HIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(382707909604008992.4902)
,p_name=>'P3020_DOWNLOAD_FORMAT_MASK'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Fen\00EAtre instantan\00E9e de masque de format BLOB')
,p_source=>'''<a href="javascript:apex_p3020_popUpBlobFormat();"><span class="tiny">''||wwv_flow_lang.system_message(''BLOB_FORMAT_MASK'')||''</span></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187880521141700728.4902)
,p_computation_sequence=>10
,p_computation_item=>'P3020_LB_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.build_ws_rpt_link_url (',
'    p_ws_app_id         => :ws_app_id,    ',
'    p_websheet_id       => :P3020_LB_WS_ID,',
'    p_reset_ir          => :P3020_LB_RESET_IR,',
'    p_clear_ir          => :P3020_LB_CLEAR_IR,',
'    p_column1           => :P3020_LB_COL1,',
'    p_operator1         => :P3020_LB_OPR1,',
'    p_value1            => :P3020_LB_VALUE1,    ',
'    p_column2           => :P3020_LB_COL2,',
'    p_operator2         => :P3020_LB_OPR2,',
'    p_value2            => :P3020_LB_VALUE2,    ',
'    p_column3           => :P3020_LB_COL3,',
'    p_operator3         => :P3020_LB_OPR3,',
'    p_value3            => :P3020_LB_VALUE3',
'    );'))
,p_compute_when=>'P3020_URL_OR_REPORT'
,p_compute_when_text=>'REPORT'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187880704088714745.4902)
,p_computation_sequence=>20
,p_computation_item=>'P3020_SYNC_FORM_LABEL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P3020_SYNC_FORM_LABEL'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187888117228267229.4902)
,p_computation_sequence=>30
,p_computation_item=>'P3020_WORKSHEET_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3010_WORKSHEET_ID'
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187888427617270233.4902)
,p_computation_sequence=>40
,p_computation_item=>'P3020_WEBSHEET_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_ws_websheet_attr',
'where worksheet_id = :P3010_WORKSHEET_ID',
'and security_group_id = :flow_security_group_id'))
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187440922214856039.4902)
,p_validation_name=>'P3020_REPORT_LABEL not null'
,p_validation_sequence=>10
,p_validation=>'P3020_REPORT_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le libell\00E9 d''\00E9tat doit avoir une valeur.')
,p_associated_item=>wwv_flow_api.id(187440723465856039.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187446724043856054.4902)
,p_validation_name=>'P3020_DISPLAY_TEXT_AS not null'
,p_validation_sequence=>20
,p_validation=>'P3020_DISPLAY_TEXT_AS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer une valeur pour l''option Afficher le texte comme.'
,p_associated_item=>wwv_flow_api.id(187446512466856053.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187880908159734780.4902)
,p_validation_name=>'P3020_COLUMN_LABEL not null'
,p_validation_sequence=>30
,p_validation=>'P3020_COLUMN_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Vous devez indiquer une valeur pour le libell\00E9 de vue monoligne.')
,p_validation_condition=>'P3020_SYNC_FORM_LABEL'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(187440305826856038.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187881107036753454.4902)
,p_validation_name=>'P3020_RPT_LOV not null'
,p_validation_sequence=>40
,p_validation=>'P3020_RPT_LOV'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La d\00E9finition de la liste de valeurs (LOV) doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>'P3020_RPT_SHOW_FILTER_LOV'
,p_validation_condition2=>'S:C'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(187449106912856059.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186335828424640602.4902)
,p_name=>'hide all'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_URL_OR_REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186336131828640604.4902)
,p_event_id=>wwv_flow_api.id(186335828424640602.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186236905427831971.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186336309508644645.4902)
,p_event_id=>wwv_flow_api.id(186335828424640602.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186237113739834405.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186238626468856985.4902)
,p_name=>'display column link'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_URL_OR_REPORT'
,p_condition_element=>'P3020_URL_OR_REPORT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186238905948856986.4902)
,p_event_id=>wwv_flow_api.id(186238626468856985.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186236905427831971.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186337022452657792.4902)
,p_name=>'display url'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_URL_OR_REPORT'
,p_condition_element=>'P3020_URL_OR_REPORT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186337327503657793.4902)
,p_event_id=>wwv_flow_api.id(186337022452657792.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186237113739834405.4902)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(187540218352321302.4902)
,p_name=>'diable single row view label'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_SYNC_FORM_LABEL'
,p_condition_element=>'P3020_SYNC_FORM_LABEL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187540516413321302.4902)
,p_event_id=>wwv_flow_api.id(187540218352321302.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_COLUMN_LABEL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187540731891321303.4902)
,p_event_id=>wwv_flow_api.id(187540218352321302.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_COLUMN_LABEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(187541007878337176.4902)
,p_name=>'disable lov'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_RPT_SHOW_FILTER_LOV'
,p_condition_element=>'P3020_RPT_SHOW_FILTER_LOV'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'N,D'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187541314891337177.4902)
,p_event_id=>wwv_flow_api.id(187541007878337176.4902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_RPT_LOV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187541520635337177.4902)
,p_event_id=>wwv_flow_api.id(187541007878337176.4902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_RPT_LOV'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187452102590856076.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WORKSHEET_COLUMNS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_attribute_03=>'P3020_COLUMN_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187877614936575937.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set functionality options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_column_f    varchar2(32767) := null;',
'begin',
'  -- search bar functionality',
'  if :P3020_ALLOW_HIDE = ''Y'' then',
'    l_column_f := ''HIDE'';',
'  end if;',
'  if :P3020_ALLOW_SORTING = ''Y'' then',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':SORT'',''SORT'');',
'  end if;',
'  if :P3020_ALLOW_FILTERING = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':FILTER'',''FILTER'');',
'  end if;',
'  if :P3020_ALLOW_HIGHLIGHTING = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':HIGHLIGHT'',''HIGHLIGHT'');',
'  end if;',
'  if :P3020_ALLOW_CTRL_BREAKS = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':BREAK'',''BREAK'');',
'  end if;',
'  if :P3020_ALLOW_AGGREGATIONS = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':AGGREGATE'',''AGGREGATE'');',
'  end if;',
'  if :P3020_ALLOW_COMPUTATIONS = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':COMPUTE'',''COMPUTE'');',
'  end if;',
'  if :P3020_ALLOW_CHARTING = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':CHART'',''CHART'');',
'  end if;',
'  if :P3020_ALLOW_GROUP_BY = ''Y'' then',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':GROUP_BY'',''GROUP_BY'');',
'  end if;',
'  if :P3020_ALLOW_PIVOT = ''Y'' then',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':PIVOT'',''PIVOT'');',
'  end if;',
'',
'  :P3020_COLUMN_F := l_column_f;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187878605071610930.4902)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'  select column_link',
'  from wwv_flow_worksheet_columns',
'  where id = :P3020_COLUMN_ID',
'  and security_group_id = :flow_security_group_id)',
'loop        ',
'  wwv_flow_ws_api.split_ws_rpt_link_url (',
'    p_url               => c1.column_link,',
'    --',
'    p_websheet_id       => :P3020_LB_WS_ID,',
'    p_reset_ir          => :P3020_LB_RESET_IR,',
'    p_clear_ir          => :P3020_LB_CLEAR_IR,',
'    p_column1           => :P3020_LB_COL1,',
'    p_operator1         => :P3020_LB_OPR1,',
'    p_value1            => :P3020_LB_VALUE1,    ',
'    p_column2           => :P3020_LB_COL2,',
'    p_operator2         => :P3020_LB_OPR2,',
'    p_value2            => :P3020_LB_VALUE2,    ',
'    p_column3           => :P3020_LB_COL3,',
'    p_operator3         => :P3020_LB_OPR3,',
'    p_value3            => :P3020_LB_VALUE3',
'    );',
'    ',
'  ',
'  if :P3020_LB_WS_ID is not null then',
'    :P3020_URL_OR_REPORT := ''REPORT'';',
'  end if;',
'  if c1.column_link is null then',
'    :P3020_URL_OR_REPORT := ''REPORT'';',
'  end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187882301869979000.4902)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set functionality option item value'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_column_f    varchar2(32767) := null; ',
'begin',
'  l_column_f := '':''||:P3020_COLUMN_F||'':'';',
'  ',
'  if instr(l_column_f,'':HIDE:'',1) > 0 then',
'	  :P3020_ALLOW_HIDE := ''Y'';',
'  else',
'	  :P3020_ALLOW_HIDE := ''N'';',
'  end if;  ',
'  if instr(l_column_f,'':SORT:'',1) > 0 then',
'	  :P3020_ALLOW_SORTING := ''Y'';',
'  else',
'	  :P3020_ALLOW_SORTING := ''N'';',
'  end if;',
'  if instr(l_column_f,'':FILTER:'',1) > 0 then',
'	  :P3020_ALLOW_FILTERING := ''Y'';',
'  else',
'	  :P3020_ALLOW_FILTERING := ''N'';',
'  end if;  ',
'  if instr(l_column_f,'':HIGHLIGHT:'',1) > 0 then',
'	  :P3020_ALLOW_HIGHLIGHTING := ''Y'';',
'  else',
'	  :P3020_ALLOW_HIGHLIGHTING := ''N'';',
'  end if;  ',
'  if instr(l_column_f,'':BREAK:'',1) > 0 then',
'	  :P3020_ALLOW_CTRL_BREAKS := ''Y'';',
'  else',
'	  :P3020_ALLOW_CTRL_BREAKS := ''N'';',
'  end if;',
'  if instr(l_column_f,'':AGGREGATE:'',1) > 0 then',
'	  :P3020_ALLOW_AGGREGATIONS := ''Y'';',
'  else',
'	  :P3020_ALLOW_AGGREGATIONS := ''N'';',
'  end if;',
'  if instr(l_column_f,'':COMPUTE:'',1) > 0 then',
'	  :P3020_ALLOW_COMPUTATIONS := ''Y'';',
'  else',
'	  :P3020_ALLOW_COMPUTATIONS := ''N'';',
'  end if;',
'  if instr(l_column_f,'':CHART:'',1) > 0 then',
'	  :P3020_ALLOW_CHARTING := ''Y'';',
'  else',
'	  :P3020_ALLOW_CHARTING := ''N'';',
'  end if;',
'  if instr(l_column_f,'':GROUP_BY:'',1) > 0 then',
'      :P3020_ALLOW_GROUP_BY := ''Y'';',
'  else',
'      :P3020_ALLOW_GROUP_BY := ''N'';',
'  end if;',
'  if instr(l_column_f,'':PIVOT:'',1) > 0 then',
'      :P3020_ALLOW_PIVOT := ''Y'';',
'  else',
'      :P3020_ALLOW_PIVOT := ''N'';',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de d\00E9finir des valeurs de fonctionnalit\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187884007644122543.4902)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save column attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.edit_ws_rpt_column_attr (',
'    p_worksheet_id           => :P3010_WORKSHEET_ID,',
'    p_column_id              => :P3020_COLUMN_ID,',
'    p_display_text_as        => :P3020_DISPLAY_TEXT_AS, ',
'    p_column_label           => :P3020_COLUMN_LABEL,',
'    p_report_label           => :P3020_REPORT_LABEL,',
'    p_sync_form_label        => :P3020_SYNC_FORM_LABEL,',
'    p_format_mask            => :P3020_FORMAT_MASK,    ',
'    p_heading_alignment      => :P3020_HEADING_ALIGNMENT,',
'    p_column_alignment       => :P3020_COLUMN_ALIGNMENT,',
'    p_allow_hide             => :P3020_ALLOW_HIDE,',
'    p_allow_sorting          => :P3020_ALLOW_SORTING,',
'    p_allow_filtering        => :P3020_ALLOW_FILTERING,',
'    p_allow_ctrl_breaks      => :P3020_ALLOW_CTRL_BREAKS,',
'    p_allow_aggregations     => :P3020_ALLOW_AGGREGATIONS,',
'    p_allow_computations     => :P3020_ALLOW_COMPUTATIONS,',
'    p_allow_charting         => :P3020_ALLOW_CHARTING,',
'    p_allow_group_by         => :P3020_ALLOW_GROUP_BY,',
'    p_allow_pivot            => :P3020_ALLOW_PIVOT,',
'    p_allow_filters          => :P3020_ALLOW_FILTERS,',
'    p_allow_highlighting     => :P3020_ALLOW_HIGHLIGHTING,       ',
'    p_rpt_show_filter_lov    => :P3020_RPT_SHOW_FILTER_LOV,',
'    p_rpt_lov                => :P3020_RPT_LOV,',
'    p_column_link            => :P3020_LB_URL,',
'    p_column_linktext        => :P3020_LINK_TEXT,',
'    p_column_link_attr       => :P3020_LINK_ATTR);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''enregistrer les attributs de colonne.'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
end;
/
prompt --application/pages/page_03030
begin
wwv_flow_api.create_page(
 p_id=>3030.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Modifier une requ\00EAte d''\00E9tat')
,p_step_title=>unistr('Modifier une requ\00EAte d''\00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185415003750542184.4902)
,p_plug_name=>unistr('Requ\00EAte d''\00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185429930518682413.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491760717181136541.4902)
,p_plug_name=>'navigation par onglets'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185410831167532672.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491760717181136541.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185411030124532674.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491760717181136541.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491761918136155704.4902)
,p_branch_action=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_REPORT_ATTR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185411408957532677.4902)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188059413528574599.4902)
,p_branch_action=>'f?p=&APP_ID.:3060:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'FUNCTION_BODY'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.ws_rpt_src_changed (',
'    p_worksheet_id    => :P3030_WORKSHEET_ID,',
'    p_websheet_id     => :P3030_WEBSHEET_ID,',
'    p_new_owner       => :P3030_REPORT_OWNER,',
'    p_new_source      => :P3030_REPORT_QUERY',
'    );'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185415320372547002.4902)
,p_name=>'P3030_REPORT_QUERY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4902)
,p_prompt=>unistr('Requ\00EAte d''\00E9tat')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>20
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="codeTextarea"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez la requ\00EAte SQL qui d\00E9finit l''\00E9tat. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185533329824382303.4902)
,p_name=>'P3030_REPORT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4902)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de l''\00E9tat')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name from wwv_flow_ws_websheet_attr',
'where id = :P3030_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le nom de l''\00E9tat. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186188208919359914.4902)
,p_name=>'P3030_WEBSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4902)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186188516191362067.4902)
,p_name=>'P3030_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4902)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488424611149529319.4902)
,p_name=>'P3030_REPORT_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186192317492381358.4902)
,p_validation_name=>'P3030_REPORT_QUERY not null'
,p_validation_sequence=>10
,p_validation=>'P3030_REPORT_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La requ\00EAte d''\00E9tat doit \00EAtre indiqu\00E9e.')
,p_when_button_pressed=>wwv_flow_api.id(185411030124532674.4902)
,p_associated_item=>wwv_flow_api.id(185415320372547002.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488433109829708717.4902)
,p_validation_name=>'P3030_REPORT_QUERY valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_security.is_valid_sql (',
'    p_ws_app_id  => :WS_APP_ID,',
'    p_type       => ''QUERY'', ',
'    p_sql        => :P3030_REPORT_QUERY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'P3030_REPORT_QUERY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(185411030124532674.4902)
,p_associated_item=>wwv_flow_api.id(185415320372547002.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488417406806414517.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save report query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_ws_rpt_query (',
'    p_flow_id        => :app_id,',
'    p_worksheet_id   => :P3030_WORKSHEET_ID,',
'    p_websheet_id    => :P3030_WEBSHEET_ID,',
'    p_owner          => :P3030_REPORT_OWNER,',
'    p_query          => :P3030_REPORT_QUERY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(185411030124532674.4902)
,p_process_when=>'SAVE_QUERY'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488425920068550834.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get report attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select sql_query',
'from wwv_flow_worksheets',
'where id = :p3030_worksheet_id',
'and security_group_id = :flow_security_group_id)',
'loop',
'    :P3030_REPORT_QUERY := c1.sql_query;',
'end loop;',
'',
'for c1 in (select id, ws_report_owner, websheet_name',
'           from wwv_flow_ws_websheet_attr',
'           where worksheet_id = :P3030_WORKSHEET_ID',
'           and security_group_id = :flow_security_group_id)',
'loop',
'    :P3030_WEBSHEET_ID := c1.id;',
'    :P3030_REPORT_OWNER := c1.ws_report_owner;',
'    :P3030_REPORT_NAME := c1.websheet_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_03040
begin
wwv_flow_api.create_page(
 p_id=>3040.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('S\00E9lectionner des colonnes d''\00E9tat')
,p_step_title=>unistr('S\00E9lectionner des colonnes d''\00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function apex_p3040_passBack(x){$v_PopupReturn(x,$v(''P3040_CALLING_ITEM''));}',
'</script>'))
,p_step_template=>wwv_flow_api.id(134255203486851095.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185537424894504064.4902)
,p_plug_name=>unistr('S\00E9lectionner une valeur de colonne')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3040_WEBSHEET_ID != ''0'' then',
'  sys.htp.p(''<table>'');',
'  for c1 in (select c.db_column_name',
'            from wwv_flow_worksheet_columns c,',
'                 wwv_flow_worksheets ir,',
'                 wwv_flow_ws_websheet_attr ws',
'            where c.worksheet_id = ir.id',
'            and ir.id = ws.worksheet_id ',
'            and ws.id = :P3040_WEBSHEET_ID           ',
'            and c.security_group_id = :flow_security_group_id)',
'  loop',
'   sys.htp.prn(''<tr><td>'');',
'   sys.htp.prn(''<a href="javascript:apex_p3040_passBack(''||wwv_flow_escape.js_literal(''#''||c1.db_column_name||''#'')||',
'               '');">#''||',
'               wwv_flow_escape.html(c1.db_column_name)||',
'               ''#</a>'');',
'   sys.htp.prn(''</td></tr>'');',
'  end loop;',
'  sys.htp.p(''</table>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185538127157514025.4902)
,p_name=>'P3040_CALLING_ITEM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(185537424894504064.4902)
,p_prompt=>'Calling Item'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185541005003583271.4902)
,p_name=>'P3040_WEBSHEET_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(185537424894504064.4902)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_03050
begin
wwv_flow_api.create_page(
 p_id=>3050.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Choisir le nom de colonne d''\00E9tat')
,p_step_title=>unistr('Choisir le nom de colonne d''\00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function apex_p3050_passBack(x){$v_PopupReturn(x,$v(''P3050_CALLING_ITEM''));}',
'</script>'))
,p_step_template=>wwv_flow_api.id(134255203486851095.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185594710007975364.4902)
,p_plug_name=>'Pick Column Name'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3050_WEBSHEET_ID != ''0'' then',
'  sys.htp.p(''<table>'');',
'  for c1 in (select c.db_column_name',
'            from wwv_flow_worksheet_columns c,',
'                 wwv_flow_worksheets ir,',
'                 wwv_flow_ws_websheet_attr ws',
'            where c.worksheet_id = ir.id',
'            and ir.id = ws.worksheet_id ',
'            and ws.id = :P3050_WEBSHEET_ID           ',
'            and c.security_group_id = :flow_security_group_id)',
'  loop',
'   sys.htp.prn(''<tr><td>'');',
'   sys.htp.prn(''<a href="javascript:apex_p3050_passBack(''||wwv_flow_escape.js_literal(c1.db_column_name)||'');">''||',
'               wwv_flow_escape.html(c1.db_column_name)||''</a>'');',
'   sys.htp.prn(''</td></tr>'');',
'  end loop;',
'  sys.htp.p(''</table>'');',
'else',
'  sys.htp.p(wwv_flow_lang.system_message(''WS_SELECT_RPT_NAME''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185594125688975362.4902)
,p_name=>'P3050_CALLING_ITEM'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Calling Item'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185594321763975362.4902)
,p_name=>'P3050_WEBSHEET_ID'
,p_item_sequence=>30
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_03060
begin
wwv_flow_api.create_page(
 p_id=>3060.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Confirmer le changement de requ\00EAte d''\00E9tat')
,p_step_title=>unistr('Confirmer le changement de requ\00EAte d''\00E9tat')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110987702383902978.4902)
,p_plug_name=>'navigation par onglets'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4902)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4902)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188054305544420912.4902)
,p_plug_name=>unistr('Confirmer le changement de requ\00EAte d''\00E9tat')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.change_ws_rpt_query (',
'    p_worksheet_id    => :P3030_WORKSHEET_ID,',
'    p_websheet_id     => :P3030_WEBSHEET_ID,',
'    p_new_owner       => :P3030_REPORT_OWNER,',
'    p_new_source      => :P3030_REPORT_QUERY',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188056301183504793.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188055415681480642.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(110987702383902978.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188055631264485071.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(110987702383902978.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188055831101485071.4902)
,p_branch_action=>'f?p=&FLOW_ID.:3000:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(188055631264485071.4902)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(188057931143551345.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process query change'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_ws_rpt_query (',
'    p_flow_id        => :app_id,',
'    p_worksheet_id   => :P3030_WORKSHEET_ID,',
'    p_websheet_id    => :P3030_WEBSHEET_ID,',
'    p_owner          => :P3030_REPORT_OWNER,',
'    p_query          => :P3030_REPORT_QUERY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de modifier la requ\00EAte d''\00E9tat.')
,p_process_success_message=>unistr('Requ\00EAte d''\00E9tat modifi\00E9e.')
);
end;
/
prompt --application/pages/page_04020
begin
wwv_flow_api.create_page(
 p_id=>4020.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>unistr('Ajouter une pi\00E8ce jointe')
,p_step_title=>unistr('Ajouter une pi\00E8ce jointe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_error_handling_function=>'wwv_flow_ws_api.ws_error_handling'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20790717309619678.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20878803839618770.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_ADD_FILE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251393723239865407.4902)
,p_plug_name=>'Ajouter un fichier'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251393904618865407.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20790717309619678.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473453311118850995.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20790717309619678.4902)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>unistr('Ajouter un fichier et ajouter \00E0 nouveau')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251394102592865409.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20790717309619678.4902)
,p_button_name=>'APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Ajouter un fichier'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(473453720468853665.4902)
,p_branch_action=>'f?p=&APP_ID.:4020:&SESSION.::&DEBUG.:4020::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(473453311118850995.4902)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(251395308079865414.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251395932504876897.4902)
,p_name=>'P4020_FILE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(251393723239865407.4902)
,p_prompt=>'Fichier'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Cliquez sur Parcourir pour localiser le fichier \00E0 t\00E9l\00E9charger. Une fois t\00E9l\00E9charg\00E9, il est associ\00E9 \00E0 la page en cours. Vous pouvez r\00E9f\00E9rencer un fichier t\00E9l\00E9charg\00E9 dans n''importe quelle page \00E0 l''aide de l''image ou de la syntaxe du fichier. Reportez-v')
||unistr('ous \00E0 Aide, Syntaxe de balisage.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251396113242880805.4902)
,p_name=>'P4020_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(251393723239865407.4902)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_colspan=>2
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Texte d\00E9crivant le fichier.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(456475900674575808.4902)
,p_name=>'P4020_ALIAS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(251393723239865407.4902)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Un alias de fichier permet d''imbriquer des liens de t\00E9l\00E9chargement ou d''image dans les sections d''une page. Chaque alias de fichier doit \00EAtre unique dans une application. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2076978944040014529.4902)
,p_validation_name=>'P4020_ALIAS is valid'
,p_validation_sequence=>10
,p_validation=>'P4020_ALIAS'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('L''alias doit \00EAtre alphanum\00E9rique.')
,p_validation_condition=>'P4020_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(456475900674575808.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2077293492808609127.4902)
,p_validation_name=>'P4020_ALIAS must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P4020_ALIAS,',
'    p_alias_type   => ''FILE'') then',
'    return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Cet alias existe d\00E9j\00E0. Entrez-en un autre.')
,p_validation_condition=>'P4020_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(456475900674575808.4902)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(251395126307865413.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add attachment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_attachment.add_doc (',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_webpage_id      => :p900_id,   ',
'    p_image_alias     => :P4020_ALIAS,',
'    p_component_level => ''WEBPAGE'',',
'    p_file_name       => :P4020_FILE,',
'    p_desc            => :P4020_DESCRIPTION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Fichier ajout\00E9.')
);
end;
/
prompt --application/pages/page_04030
begin
wwv_flow_api.create_page(
 p_id=>4030.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Ajouter une remarque'
,p_step_title=>'Ajouter une remarque'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20882615492688428.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_ADD_NOTE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20883724281700421.4902)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20884309521705583.4902)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251516429483720502.4902)
,p_plug_name=>'Ajouter une remarque'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251516617287720504.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251516819982720505.4902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4902)
,p_button_name=>'ADD_NOTE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Ajouter une remarque'
,p_button_position=>'CREATE'
,p_button_condition=>'P4030_NOTE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(214982205129183371.4902)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4902)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
,p_button_condition=>'P4030_NOTE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(214904430494171722.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4902)
,p_button_name=>'DELETE_NOTE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4902)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'DELETE'
,p_button_condition=>'P4030_NOTE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(251518406893720511.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251517232428720506.4902)
,p_name=>'P4030_NOTE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(251516429483720502.4902)
,p_prompt=>'Remarque'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>7
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Entrez une remarque pour cette page. Les remarques apparaissent \00E0 droite de la page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253723108268462838.4902)
,p_name=>'P4030_NOTE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20884309521705583.4902)
,p_prompt=>'Note Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(251518217690720510.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_note (',
'    p_ws_app_id        => :ws_app_id,        ',
'    p_webpage_id       => :p900_id,',
'    p_note_id          => :P4030_NOTE_ID,',
'    p_component_level  => ''WEBPAGE'',',
'    p_content          => :P4030_NOTE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''ajouter une remarque.'
,p_process_when=>'ADD_NOTE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(215084317035196189.4902)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_note (',
'    p_note_id   => :P4030_NOTE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de supprimer la remarque.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(214904430494171722.4902)
,p_process_success_message=>unistr('Remarque supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253737509634661968.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_note (',
'    p_note_id     => :P4030_NOTE_ID,',
'    p_content     => :P4030_NOTE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''extraire la remarque.'
,p_process_when=>'P4030_NOTE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_04040
begin
wwv_flow_api.create_page(
 p_id=>4040.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'Ajouter une balise'
,p_step_title=>'Ajouter une balise'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4902)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20868614519517826.4902)
,p_plug_name=>'Boutons de barre d''outils'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4902)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20877305655600370.4902)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_ADD_TAGS''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251519704381725094.4902)
,p_plug_name=>'Balises'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251519921019725094.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20868614519517826.4902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4902)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6745321058737106.4902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20868614519517826.4902)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'EDIT'
,p_button_condition=>'P4040_TAGS'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251520114489725096.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20868614519517826.4902)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4902)
,p_button_image_alt=>'Ajouter des balises'
,p_button_position=>'NEXT'
,p_button_condition=>'P4040_TAGS'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(251521725759725101.4902)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251520522894725097.4902)
,p_name=>'P4040_TAGS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(251519704381725094.4902)
,p_prompt=>'Balises'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Entrez une liste de balises s\00E9par\00E9es par des virgules pour d\00E9crire le contenu de la page.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(251521511042725100.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add tags'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_tags (   ',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id       => :p900_id,    ',
'    p_component_level => ''WEBPAGE'',',
'    p_tag             => :P4040_TAGS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''ajouter des balises.'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253748202165170647.4902)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch tags'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_tag (',
'    p_webpage_id  => :p900_id,',
'    --',
'    p_tags        => :P4040_TAGS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''extraire les balises.'
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_api.create_page(
 p_id=>8000.4902
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4902)
,p_name=>'rechercher'
,p_step_title=>'Rechercher'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function loadSearchResultsField () {',
'    searchVal = apex.item( "P8000_SEARCH" ).getValue() ;',
'    apex.item( "searchResultField" ).setValue( searchVal );',
'	}',
'',
'function setSearchField () {',
'    searchVal = apex.item( "searchResultField" ).getValue();',
'    apex.item( "P8000_SEARCH" ).setValue( searchVal );',
'    apex.submit();',
'}'))
,p_javascript_code_onload=>'loadSearchResultsField();'
,p_step_template=>wwv_flow_api.id(9297021464956579.4902)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178724809760390978.4902)
,p_plug_name=>'Action Bar'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4902)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="searchField">',
'	<span class="searchIcon">',
'		<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'	</span>',
'	<input type="text" id="searchResultField" style="width: 320px" />',
'	<a href="javascript:setSearchField()" class="wsSmallButton">Rechercher</a>',
'</div>'))
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178725914740401832.4902)
,p_plug_name=>'Rechercher'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4902)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Recherche sans distinction entre les majuscules et les minuscules du contenu de l''application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(82394800610655307.4902)
,p_plug_name=>unistr('Conteneur de r\00E9gion du panneau de recherche')
,p_parent_plug_id=>wwv_flow_api.id(178725914740401832.4902)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4902)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178835419032288635.4902)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4902)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4902)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468391404114503393.4902)
,p_plug_name=>'Search Results'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid=>true
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       d001 updated_on,',
'       d002 created_on,',
'       c001 foundin, ',
'       c002 page_title, ',
'       c003 section, ',
'       c004 context, ',
'       c005 view_link,',
'       lower(c006) updated_by,',
'       lower(c007) created_by',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_SEARCH'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(468391524383503393.4902)
,p_name=>'Search Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_search_bar=>'N'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468391711981503406.4902)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468391829105503408.4902)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392001076503409.4902)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom de contenu'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392131811503409.4902)
,p_db_column_name=>'SECTION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Section'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392202634503409.4902)
,p_db_column_name=>'CONTEXT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Contexte'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392314796503410.4902)
,p_db_column_name=>'VIEW_LINK'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Lien inter-vues'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468397610140582784.4902)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468397729488582785.4902)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472218111753286824.4902)
,p_db_column_name=>'FOUNDIN'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Trouv\00E9 dans')
,p_column_link=>'#VIEW_LINK#'
,p_column_linktext=>'#FOUNDIN#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178725326383395767.4902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(178724809760390978.4902)
,p_button_name=>'P8000_GO'
,p_button_static_id=>'P8000_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4902)
,p_button_image_alt=>'Rechercher'
,p_button_alignment=>'LEFT'
,p_button_condition_type=>'NEVER'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(468398002091599375.4902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(178724809760390978.4902)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4902)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:8000,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178725512447395769.4902)
,p_branch_action=>'f?p=&FLOW_ID.:8000:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178725118764393563.4902)
,p_name=>'P8000_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178724809760390978.4902)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(468377826791114568.4902)
,p_name=>'P8000_SEARCHABLE_COMPONENTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(82394800610655307.4902)
,p_item_default=>'Page name:Page alias:Page description:Section title:Section content:File:Tags:Notes:Data grid'
,p_prompt=>'Contenu pouvant faire l''objet d''une recherche'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SEARCHABLE COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(468375932547106712.4902)||'.'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4902)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le contenu qui sera recherch\00E9')
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(468388807388383301.4902)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create search result collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_search_collection (',
'    p_search  => :P8000_SEARCH,',
'    p_security_group_id=>:flow_security_group_id,',
'    p_ws_app_id=>:WS_APP_ID,',
'    p_max_row_count=>1000,',
'    p_searchable_components=>:P8000_SEARCHABLE_COMPONENTS,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
