prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4542
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4542 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4542
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102125633403585')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'he'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'Y'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4542)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113350'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4542)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4542)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4542)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4542)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4542)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4542)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4542)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4542)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4542)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4542)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4542)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4542)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4542)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.he'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4542
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4542)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4542)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4542)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4542)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4542)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4542)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4542)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.he'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4542
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4542)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4542)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4542)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4542)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4542)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4542)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4542)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.he'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4542
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4542)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4542)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4542)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.he'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4542
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4542)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4542)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4542)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4542)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4542)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4542)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4542)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4542)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4542)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4542)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4542)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4542)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4542)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4542)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4542)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.he'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4542
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4542)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4542)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4542)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4542)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4542)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4542)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4542)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4542)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4542)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4542)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4542)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4542)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4542)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4542)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4542)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.he'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4542
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4542)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4542)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4542)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4542)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4542)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4542)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4542)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4542)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4542)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4542)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4542)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4542)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4542)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4542)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4542)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.he'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4542
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4542)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4542)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4542)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4542)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4542)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4542)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4542)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4542)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4542)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4542)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4542)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4542)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4542)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4542)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4542)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4542
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4542)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4542
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4542)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4542
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4542)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4542
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4542)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4542
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4542)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4542
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4542
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4542)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4542)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4542)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4542)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4542)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4542)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4542)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4542)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4542)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4542)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4542)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4542)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4542)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4542)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4542)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4542)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4542)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4542)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4542)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4542)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4542)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4542)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4542)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4542)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4542)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4542)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4542)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4542)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4542)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4542
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4542)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4542)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4542)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4542)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4542)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4542
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4542)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4542
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4542)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4542
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4542)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4542
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4542)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4542
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4542)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4542
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4542)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4542)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4542)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4542)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4542)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4542)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4542)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4542)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4542)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4542
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4542)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4542)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4542)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4542)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4542)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4542)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4542)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4542
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4542)
,p_page_name=>'winlov'
,p_page_title=>unistr('\05D3\05D5-\05E9\05D9\05D7 ''\05D7\05D9\05E4\05D5\05E9''')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\05D7\05E4\05E9')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\05E1\05D2\05D5\05E8')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\05D4\05D1\05D0 &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \05D4\05E7\05D5\05D3\05DD')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\05E9\05D5\05E8\05D5\05EA #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4542
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4542)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4542
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4542)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4542)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4542)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4542)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4542)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4542)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4542)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4542)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4542)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4542)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4542)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4542)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4542)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4542)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4542)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4542)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4542)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4542)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4542)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4542)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4542)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4542)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4542)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4542)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4542)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4542)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4542)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4542)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4542)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4542)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4542)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4542)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4542)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4542)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4542)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4542)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4542)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4542)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4542)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4542)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4542)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4542)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4542)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4542)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4542)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4542)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4542)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4542)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4542)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4542)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4542)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4542)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4542)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4542)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4542)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4542)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4542)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4542)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4542)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4542)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4542)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4542)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4542)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4542)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4542)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4542)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4542)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4542)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4542)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4542)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4542)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4542)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4542)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4542)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4542)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4542)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4542)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4542)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4542)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4542)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4542)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4542)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4542)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4542)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4542)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4542)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4542)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4542)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4542)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4542)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4542)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4542)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4542)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4542)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4542)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4542)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4542)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4542)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4542)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4542)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4542)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4542)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4542)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4542)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4542)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4542)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4542)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4542)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4542)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4542)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4542)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4542)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4542)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4542)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4542)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4542)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4542)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4542)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4542)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4542)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4542)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4542)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4542)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4542)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4542)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4542)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4542)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4542)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4542)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4542)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4542)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4542)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4542)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4542)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4542)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4542)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4542)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4542)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4542)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4542)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4542)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4542)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4542)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4542)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4542)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4542)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4542)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4542)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4542)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4542)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4542)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4542)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4542)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4542)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4542)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4542)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4542)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4542)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4542)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4542)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4542)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4542)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4542)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4542)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4542)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4542)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4542)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4542)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4542)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4542)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4542)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4542)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4542)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4542)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4542)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4542)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4542)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4542)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4542)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4542)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4542)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4542)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4542)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4542)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4542)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4542)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173663880399957)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160751216399947)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E0\05D4\05DC\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160691393399947)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05DE\05E9\05EA\05DE\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217917884399989)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D9\05E9\05D4 \05E0\05D3\05D7\05EA\05D4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177692487399959)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E9\05D1\05D5\05DF %0 \05E9\05DC\05DA \05E0\05D5\05E6\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163296952399949)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05E9\05D1\05D5\05DF \05E0\05E2\05D5\05DC.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153100760399941)
,p_name=>'AM_PM'
,p_message_language=>'he'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287544872400039)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC\05E4\05EA \05DE\05E6\05D1 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295660264400045)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'he'
,p_message_text=>unistr('(\05E4\05E2\05D9\05DC)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265198710400023)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05E8\05D9\05D0\05D4 \05DC-Ajax \05D4\05D7\05D6\05D9\05E8\05D4 \05E9\05D2\05D9\05D0\05EA \05E9\05E8\05EA %0 \05DC-%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195949274399973)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05EA \05DB\05D9\05E0\05D5\05D9 \05D4\05D9\05D9\05E9\05D5\05DD "%0" \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05DE\05D9\05E8 \05DC\05DE\05D6\05D4\05D4 \05D9\05D9\05D7\05D5\05D3\05D9 \05E9\05DC \05D9\05D9\05E9\05D5\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196033112399973)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D9\05E9\05D5\05DD \05E2\05DD \05DB\05D9\05E0\05D5\05D9 "%0" \05DC\05D0 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185682218399965)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1816 \05E9\05D2\05D9\05D0\05D4 \05D1\05DC\05EA\05D9 \05E6\05E4\05D5\05D9\05D4 \05D1\05D4\05DE\05E8\05EA \05DB\05D9\05E0\05D5\05D9 \05D4\05D9\05D9\05E9\05D5\05DD alias p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278599102400032)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05E1\05D9\05DB\05D5\05DD \05D4\05D1\05D9\05E0\05D9\05D9\05DD (checksum) \05E9\05DC \05D4\05D9\05D9\05E9\05D5\05DD \05DE\05E2\05E0\05D9\05E7 \05D3\05E8\05DA \05E7\05DC\05D4 \05DC\05E7\05D1\05D5\05E2 \05D0\05DD \05D0\05D5\05EA\05D5 \05D9\05D9\05E9\05D5\05DD \05E0\05E4\05E8\05E1 \05E2\05DC \05E4\05E0\05D9 \05DE\05E8\05D7\05D1\05D9 \05E2\05D1\05D5\05D3\05D4. \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05D4\05E9\05D5\05D5\05EA \05E2\05E8\05DA \05D6\05D4 \05DB\05D3\05D9 \05DC\05E7\05D1\05D5\05E2 \05D0\05DD \05D9\05E9 \05D4\05EA\05D0\05DE\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171466161399955)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05E4\05D5\05E0\05E7\05E6\05D9\05EA \05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156814968399944)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05E4\05D5\05E0\05E7\05E6\05D9\05EA \05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320397528400063)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05D3\05D9\05D9\05E8 \05E9\05D4\05D5\05D7\05D6\05E8 \05E2\05DC \05D9\05D3\05D9 Oracle Cloud Identity Management \05D0\05D9\05E0\05D5 \05DE\05D5\05E8\05E9\05D4 \05DC\05D3\05D5\05DE\05D9\05D9\05DF!<br/><a href="&LOGOUT_URL.">\05D4\05EA\05D7\05D1\05E8 \05E9\05D5\05D1</a> \05D5\05E6\05D9\05D9\05DF \05E9\05DD \05E9\05DC \05D3\05D9\05D9\05E8 \05DE\05D5\05E8\05E9\05D4 \05D0\05D5 \05E9\05E0\05D4 \05D0\05EA \05D4-URL \05E9\05DC\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154594785399943)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D7\05E9\05D1\05D5\05E0\05DA "%0" \05D0\05D9\05DF \05D4\05E8\05E9\05D0\05D5\05EA \05D4\05E4\05D9\05EA\05D5\05D7 \05D4\05D3\05E8\05D5\05E9\05D5\05EA (DB_DEVELOPER \05D0\05D5 DB_ADMINISTRATOR)<br/>\05DC\05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4 "%1"! <a href="&LOGOUT_URL.">\05D4\05EA\05D7\05D1\05E8 \05E9\05D5\05D1</a> \05D0\05D7\05E8\05D9 \05E7\05D1\05DC\05EA \05D4\05D4\05E8\05E9\05D0\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153605476399942)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05D3\05D9\05D9\05E8 \05E9\05D4\05D5\05D7\05D6\05E8 \05E2\05DC \05D9\05D3\05D9 Oracle Cloud Identity Management \05D0\05D9\05E0\05D5 \05DE\05D5\05E8\05E9\05D4 \05DC\05DE\05E8\05D7\05D1 \05D4\05E2\05D1\05D5\05D3\05D4 \05D4\05E0\05D5\05DB\05D7\05D9!<br/><a href="&LOGOUT_URL.">\05D4\05EA\05D7\05D1\05E8 \05E9\05D5\05D1</a> \05D5\05E6\05D9\05D9\05DF \05E9\05DD \05E9\05DC \05D3\05D9\05D9\05E8 \05DE\05D5\05E8\05E9\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154624445399943)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05D9\05E7\05D5\05DC\05D9 \05D0\05D1\05D8\05D7\05D4, \05D4\05E8\05E6\05EA \05D9\05D9\05E9\05D5\05DE\05D9\05DD \05E9\05DC \05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4 \05D6\05D4 \05D3\05E8\05DA \05D4\05D3\05D5\05DE\05D9\05D9\05DF \05D1\05DB\05EA\05D5\05D1\05EA \05D4-URL \05D0\05E1\05D5\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171189819399955)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E7\05E9 \05DE\05D4-DBA (\05DE\05E0\05D4\05DC\05DF \05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD) \05E9\05DC\05DA \05DC\05D4\05E8\05D9\05E5 \05D0\05EA $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171037848399955)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05D0\05E8\05D6 SYS.DBMS_LDAP \05DC\05D0 \05E7\05D9\05D9\05DD \05D0\05D5 \05DC\05D0 \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170959113399955)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05E4\05D5\05E0\05E7\05E6\05D9\05EA \05DE\05E9\05EA\05DE\05E9 \05E9\05DC \05E2\05E8\05D9\05DB\05EA LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171263946399955)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA \05E9\05DC LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172093793399955)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05D0\05E8\05D2\05D5\05DE\05E0\05D8 p_flow_page \05E0\05D5\05D4\05DC login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171684389399955)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'he'
,p_message_text=>unistr('p_session \05D1\05DC\05EA\05D9 \05EA\05E7\05E3 \05D1-wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219585143399990)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E8\05D2\05D5\05DE\05E0\05D8 \05D1\05DE\05D1\05E0\05D4 \05E9\05D2\05D5\05D9 \05D0\05DC wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171766125399955)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05DE\05E9\05EA\05DE\05E9 Null \05D4\05D5\05E2\05D1\05E8 \05DC\05E0\05D5\05D4\05DC \05D4\05D4\05EA\05D7\05D1\05E8\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160562822399947)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05EA\05DF<span id="apex_login_throttle_sec">%0</span> \05E9\05E0\05D9\05D5\05EA \05DC\05E4\05E0\05D9 \05E9\05D0\05EA\05D4 \05DE\05EA\05D7\05D1\05E8 \05E9\05D5\05D1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161890202399948)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05E1\05D9\05D5\05DF \05D4\05D4\05EA\05D7\05D1\05E8\05D5\05EA \05E0\05D7\05E1\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217365995399988)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA "%0" \05DC\05D0 \05E0\05DE\05E6\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162181158399948)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05E7\05D1\05D5\05E6\05EA \05D4\05D0\05D1\05D8\05D7\05D4 \05D4\05D5\05D0 null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171569632399955)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05D4\05E8\05E6\05EA \05EA\05D4\05DC\05D9\05DA \05D0\05D7\05E8\05D9 \05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171356075399955)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05EA\05D4\05DC\05D9\05DA \05E7\05D3\05DD-\05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172523307399956)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05EA\05D7 \05D0\05EA \05DB\05EA\05D5\05D1\05EA \05D4-URL \05D1\05D0\05D5\05EA\05D5 \05D3\05E4\05D3\05E4\05DF \05E9\05D1\05D5 \05D0\05EA\05D7\05DC\05EA \05D0\05EA \05D4\05D1\05E7\05E9\05D4 ''\05D0\05D9\05E4\05D5\05E1 \05E1\05D9\05E1\05DE\05D4''. \05D0\05DD \05D0\05EA\05D4 \05DC\05D5\05D7\05E5 \05E2\05DC \05D4-URL \05E9\05DC \05D0\05D9\05E4\05D5\05E1 \05E1\05D9\05E1\05DE\05D4 \05D5\05D0\05EA\05D4 \05DE\05E0\05D5\05EA\05D1 \05DC\05D3\05E3 \05D4\05D4\05EA\05D7\05D1\05E8\05D5\05EA, \05D0\05EA\05D7\05DC \05E9\05D5\05D1 \05D0\05EA ''\05D0\05D9\05E4\05D5\05E1 \05E1\05D9\05E1\05DE\05D4'' \05D5\05D4\05E9\05D0\05E8 \05D0\05EA \05D4\05D3\05E4\05D3\05E4\05DF \05E4\05EA\05D5\05D7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317847943400061)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E1 \05D0\05EA \05D4-URL \05E9\05DC \05E1\05D9\05E1\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154882564399943)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D1\05D5\05E6\05EA \05E6\05E8\05DB\05E0\05D9 \05DE\05E0\05D4\05DC \05D4\05DE\05E9\05D0\05D1\05D9\05DD %0 \05DC\05D0 \05D4\05D5\05E2\05E0\05E7\05D4 \05DC-%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154941962399943)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05EA\05DE\05E9 \05D1-DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \05DB\05D3\05D9 \05DC\05D4\05E2\05E0\05D9\05E7 \05D4\05D4\05E8\05E9\05D0\05D4 \05D4\05D7\05E1\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182975598399963)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05E4\05D5\05E0\05E7\05E6\05D9\05EA \05D6\05E7\05D9\05E3 \05E9\05DC \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183067714399963)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05E4\05D5\05E0\05E7\05E6\05D9\05EA \05D0\05D9\05DE\05D5\05EA \05E9\05DC \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183222247399963)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E7\05E9 \05DE\05DE\05E0\05D4\05DC\05DF %0 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05EA\05E6\05D5\05E8\05EA \05D4\05DE\05E0\05D5\05E2 \05D1\05E9\05D1\05D9\05DC Oracle Application Server Single Sign-On.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192751579399970)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DC\05D0 \05D7\05D5\05E7\05D9 \05D1\05D0\05E1\05D9\05DE\05D5\05DF %1 \05D4\05D5\05D7\05D6\05E8 \05E2\05DC \05D9\05D3\05D9 sso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171980722399955)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05D0\05EA \05EA\05D5\05DB\05E0\05D9\05EA \05D0\05D9\05DE\05D5\05EA \05D4\05D6\05D4\05D5\05EA \05D5\05D4\05D5\05E1\05E3 \05D0\05EA \05E9\05DD \05D4\05D9\05D9\05E9\05D5\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192461079399970)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5\05E8\05D0 \05DC\05D0 \05D7\05D5\05E7\05D9 \05E9\05DC \05E4\05E8\05D5\05E6\05D3\05D5\05E8\05D4 %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192683707399970)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E9\05D1 \05D9\05D9\05E9\05D5\05DD \05DC\05D0 \05EA\05E7\05E3 \05D1\05D0\05E1\05D9\05DE\05D5\05DF urlc : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192294142399970)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1-portal_sso_redirect: \05D7\05E1\05E8\05D9\05DD \05E4\05E8\05D8\05D9\05DD \05E2\05DC \05E8\05D9\05E9\05D5\05DD \05D4\05D9\05D9\05E9\05D5\05DD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183196719399963)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05D0\05E8\05D6 WWSEC_SSO_ENABLER_PRIVATE \05DC\05D0 \05E7\05D9\05D9\05DD \05D0\05D5 \05DC\05D0 \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112171853546399955)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05D9\05D9\05E9\05D5\05DD \05E9\05DC \05E9\05D5\05EA\05E3 \05E8\05E9\05D5\05DD \05DC\05D0 \05E0\05DE\05E6\05D0 \05D1\05EA\05D5\05DB\05E0\05D9\05EA \05D0\05D9\05DE\05D5\05EA \05D4\05D6\05D4\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192380935399970)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D5\05DD \05D9\05D9\05E9\05D5\05DD \05D6\05D4 \05DB\05E4\05D9 \05E9\05DE\05EA\05D5\05D0\05E8 \05D1\05DE\05D3\05E8\05D9\05DA \05D4\05D4\05EA\05E7\05E0\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183353174399964)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA \05E9\05DC SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292758274400043)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'he'
,p_message_text=>unistr('URL \05DC\05D0 \05DE\05D5\05E8\05E9\05D4:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182798323399963)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154777469399943)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4 "%0" \05D0\05D9\05E0\05D5 \05E4\05E2\05D9\05DC. \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155139181399943)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'he'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161507331399948)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D9\05E9\05D4 \05E0\05D3\05D7\05EA\05D4 \05E2\05DC \05D9\05D3\05D9 \05D1\05D3\05D9\05E7\05EA \05D0\05D1\05D8\05D7\05EA \05D9\05D9\05E9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161666497399948)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D9\05E9\05D4 \05E0\05D3\05D7\05EA\05D4 \05E2\05DC \05D9\05D3\05D9 \05D1\05D3\05D9\05E7\05EA \05D0\05D1\05D8\05D7\05EA \05D3\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161783914399948)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05D4\05E8\05E9\05D0\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225109776399994)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E0\05D5\05D9 \05E2\05DD %0 \05D1\05D0\05DE\05E6\05E2\05D5\05EA %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225297814399994)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'he'
,p_message_text=>'Love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283083725400036)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D9\05D0\05D5\05E8 \05D0\05D9\05E8\05D5\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282893523400035)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA \05E1\05D9\05D5\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283144573400036)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05D0\05D9\05E8\05D5\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282700891400035)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA \05D4\05EA\05D7\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282988795400036)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA \05D0\05D9\05E8\05D5\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173520581399956)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05EA\05D5\05DB\05DF \05E2\05E8\05DA \05E1\05D9\05DB\05D5\05DD \05D4\05D1\05D9\05E7\05D5\05E8\05EA (Checksum)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173472547399956)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E4\05D5\05E8\05DE\05D8 \05E2\05E8\05DA \05E1\05D9\05DB\05D5\05DD \05D4\05D1\05D9\05E7\05D5\05E8\05EA (Checksum)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237407648400003)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E2\05EA\05E7 \05DC\05DC\05D5\05D7 \05D2\05D6\05D9\05E8\05D9\05DD.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237188373400003)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E4\05D3\05E4\05DF \05D6\05D4 \05D0\05D9\05E0\05D5 \05EA\05D5\05DE\05DA \05D1\05D4\05E2\05EA\05E7\05D4 \05DE\05DC\05D7\05E6\05DF \05D0\05D5 \05EA\05E4\05E8\05D9\05D8. \05E0\05E1\05D4 Ctrl+C or \05E4\05E7\05D5\05D3\05D4+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225629242399994)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D2\05D5\05E8 \05D4\05D5\05D3\05E2\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281643428400035)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05D2\05D5\05D3\05D9\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276168669400031)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D5\05DB\05D7\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276058655400031)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D0\05E9\05D5\05E0\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280208218400034)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05E6\05D1\05E2 \05EA\05E7\05E3. \05DC\05D3\05D5\05D2\05DE\05D4: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275919867400031)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E6\05D1\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276216531400031)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D9\05E0\05D5\05D9 \05E4\05D5\05E8\05DE\05D8 \05E6\05D1\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315486709400059)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315553793400059)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05EA\05D7 \05E8\05E9\05D9\05DE\05D4 \05D1\05E9\05D1\05D9\05DC: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295722675400045)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'he'
,p_message_text=>unistr('(\05D4\05D5\05E9\05DC\05DD)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188085842399967)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF \05D4\05D9\05D9\05E9\05D5\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202418132399977)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF \05D4\05D9\05D9\05E9\05D5\05DD.'),
unistr(' \05E4\05E8\05D8\05D9\05DD \05E2\05DC \05EA\05E7\05E8\05D9\05EA \05D6\05D5 \05D6\05DE\05D9\05E0\05D9\05DD \05D3\05E8\05DA \05DE\05D6\05D4\05D4 \05E0\05D9\05E4\05D5\05D9 \05D1\05D0\05D2\05D9\05DD "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280597243400034)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E7\05DF \05E9\05D2\05D9\05D0\05D5\05EA \05DC\05E4\05E0\05D9 \05D4\05E9\05DE\05D9\05E8\05D4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226592085399995)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05EA\05D0\05DE\05D5\05EA \05E0\05DE\05E6\05D0\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226440679399995)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05D4\05EA\05D0\05DE\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296296335400045)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05E7\05D3\05DE\05D5\05EA \05E0\05D5\05DB\05D7\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280959442400034)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D1\05E5 \05D4\05DE\05E6\05D5\05D9\05DF \05D1\05E4\05E8\05D9\05D8 %0 \05DC\05D0 \05E7\05D9\05D9\05DD \05D1-APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269444825400026)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05E8\05E1\05D4 \05D4\05E0\05D5\05DB\05D7\05D9\05EA \05E9\05DC \05E0\05EA\05D5\05E0\05D9\05DD \05D1\05DE\05E1\05D3 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E9\05EA\05E0\05EA\05D4 \05DE\05D0\05D6 \05E9\05D4\05DE\05E9\05EA\05DE\05E9 \05D0\05EA\05D7\05DC \05EA\05D4\05DC\05D9\05DA \05E2\05D3\05DB\05D5\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238525950400004)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05DC\05D8\05E2\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285560576400037)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05EA \05E7\05D3\05DD-\05E2\05D9\05D1\05D5\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285312140400037)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E9\05D5\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299498436400047)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E6\05E3: \05E4\05E2\05D5\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285482675400037)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D3\05DB\05DF \05E9\05D5\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226912426399995)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D5\05D7 \05E9\05E0\05D4 \05E6\05E5: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149501502399939)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149603712399939)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285753817400038)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05E2\05DD \05E2\05E8\05DA \05DB\05DC\05E9\05D4\05D5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285635379400037)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05EA\05D0\05E8\05D9\05DA \05EA\05E7\05E3. \05DC\05D3\05D5\05D2\05DE\05D4: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153243740399942)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05D1\05D9\05DF %0 \05DC\05D1\05D9\05DF %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153399788399942)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05D1-%0 \05D0\05D5 \05D0\05D7\05E8\05D9\05D5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153430572399942)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05D1-%0 \05D0\05D5 \05DC\05E4\05E0\05D9\05D5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230458831399998)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05DE\05D0\05D5\05D7\05E8 \05DE\05D4\05EA\05D0\05E8\05D9\05DA \05D4\05DE\05E8\05D1\05D9 \05D4\05DE\05E6\05D5\05D9\05DF %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230879495399998)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05DC\05D0 \05DE\05EA\05D0\05D9\05DD \05DC\05E4\05D5\05E8\05DE\05D8 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230381423399998)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05DE\05D5\05E7\05D3\05DD \05DE\05D4\05EA\05D0\05E8\05D9\05DA \05D4\05DE\05D6\05E2\05E8\05D9 \05D4\05DE\05E6\05D5\05D9\05DF %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230592904399998)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05D0\05D9\05E0\05D5 \05D1\05D8\05D5\05D5\05D7 \05D4\05EA\05E7\05E3 \05E9\05DC %0 \05E2\05D3 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230728633399998)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05D0\05D9\05E0\05D5 \05D1\05EA\05D5\05DA \05D8\05D5\05D5\05D7 \05D4\05E9\05E0\05D9\05DD \05D4\05EA\05E7\05E3 \05E9\05DC %0 \05D5-%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280883987400034)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D8\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308012034400054)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D2\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310064167400055)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280688736400034)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E7\05D9\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280756847400034)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186977998399966)
,p_name=>'APEX.ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154364818399942)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05D2\05D9\05D0\05D4 \05D4\05D1\05D0\05D4 \05D0\05D9\05E8\05E2\05D4 \05D1\05D6\05DE\05DF \05D4\05E8\05E6\05EA \05D4\05E4\05E0\05D9\05D9\05D4 \05D4\05D7\05D5\05D6\05E8\05EA \05DC\05D8\05D9\05E4\05D5\05DC \05D1\05E9\05D2\05D9\05D0\05D5\05EA. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163091418399949)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E8\05E2\05D4 \05E9\05D2\05D9\05D0\05D4 \05D1\05D6\05DE\05DF \05E6\05D1\05D9\05E2\05EA \05D3\05E3 \05D4\05E9\05D2\05D9\05D0\05D5\05EA: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155096499399943)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05E4\05E0\05D9\05DE\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294863472400044)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF \05E9\05DC\05DA. \05E4\05E8\05D8\05D9\05DD \05E2\05DC \05EA\05E7\05E8\05D9\05EA \05D6\05D5 \05D6\05DE\05D9\05E0\05D9\05DD \05D3\05E8\05DA \05DE\05D6\05D4\05D4 \05E0\05D9\05E4\05D5\05D9 \05D1\05D0\05D2\05D9\05DD "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289186677400040)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05D3 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05E4\05EA\05D5\05D7 \05DC\05D2\05D9\05E9\05EA \05E7\05E8\05D9\05D0\05D4 \05D1\05DC\05D1\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319707074400062)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'he'
,p_message_text=>unistr('ORA-28353: \05E4\05EA\05D9\05D7\05EA \05D4\05D0\05E8\05E0\05E7 \05E0\05DB\05E9\05DC\05D4. \05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D2\05E9\05EA \05DB\05E8\05D2\05E2 \05DC\05E0\05EA\05D5\05E0\05D9 \05D4\05D9\05D9\05E9\05D5\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289229796400040)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 \05D6\05D4 \05D0\05D9\05E0\05D5 \05D6\05DE\05D9\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156725026399944)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D3\05E2 \05D8\05DB\05E0\05D9 (\05D2\05DC\05D5\05D9 \05DC\05DE\05E4\05EA\05D7\05D9\05DD \05D1\05DC\05D1\05D3)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252888461400014)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05EA \05E9\05D2\05D9\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266724358400024)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E8\05DE\05D8 \05E6\05E4\05D5\05D9: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233452830400000)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05E9\05EA\05DE\05E9 \05DB\05D1\05E8 \05E0\05DE\05E6\05D0 \05D1\05E8\05E9\05D9\05DE\05EA \05D1\05E7\05E8\05EA \05D2\05D9\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233363250400000)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05E9 \05DC\05D0\05E9\05E8 \05D4\05D5\05E1\05E4\05EA %0 \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D4\05D1\05D0\05D9\05DD \05DC\05E8\05E9\05D9\05DE\05EA \05D1\05E7\05E8\05EA \05D4\05D2\05D9\05E9\05D4 <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233890490400000)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D9\05D9\05DD \05DE\05E9\05EA\05DE\05E9 \05DB\05E4\05D5\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233507856400000)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E1\05E8\05D4 \05DB\05E8\05D5\05DB\05D9\05EA (@) \05D1\05DB\05EA\05D5\05D1\05EA \05D4\05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233634592400000)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E1\05E8\05D4 \05E0\05E7\05D5\05D3\05D4 (.) \05D1\05DB\05EA\05D5\05D1\05EA \05D4\05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233730123400000)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05DE\05E9\05EA\05DE\05E9 \05D0\05E8\05D5\05DA \05DE\05D3\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234091218400000)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E7 \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05E9\05D4\05D5\05D2\05D3\05E8\05D5 \05D1\05E8\05E9\05D9\05DE\05EA \05D1\05E7\05E8\05EA \05D4\05D2\05D9\05E9\05D4 \05E9\05DC \05D4\05D9\05D9\05E9\05D5\05DD, \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05D2\05E9\05EA \05DC\05D9\05D9\05E9\05D5\05DD \05D6\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234132461400000)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05D4\05D2\05D3\05E8\05EA \05D1\05E7\05E8\05EA \05D2\05D9\05E9\05D4 \05DC\05D0 \05E6\05E4\05D5\05D9: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233983307400000)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD \05E9\05D0\05D5\05DE\05EA\05D5 \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05D2\05E9\05EA \05DC\05D9\05D9\05E9\05D5\05DD \05D6\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276743631400031)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E1\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276654785400031)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276946949400031)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'he'
,p_message_text=>unistr('%0: \05D7\05E1\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276845552400031)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'he'
,p_message_text=>unistr('%0: \05D0\05E4\05E9\05E8\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276520264400031)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 \05DE\05D6\05D5\05D4\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269648939400026)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E8\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226108311399995)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05DF \05E9\05D4\05D5\05D7\05DC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267271532400024)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152192723399941)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E8\05E9\05D9\05DD \05E2\05DE\05D5\05D3\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279992550400033)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05E8\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152269325399941)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E8\05E9\05D9\05DD \05E2\05D5\05D2\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278669332400032)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151965028399941)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267741492400025)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267827334400025)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D4 \05D4\05DB\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267933915400025)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D4 \05D0\05EA %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285116802400037)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4 %1, \05E9\05D0\05DC\05D9\05D4 \05DE\05E4\05E0\05D4 \05D4\05D9\05D1\05D8 %0, \05D0\05D9\05E0\05D4 \05D6\05DE\05D9\05E0\05D4 \05D0\05D5 \05D0\05D9\05E0\05D4 \05DE\05D5\05E8\05E9\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142385779399933)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05DE\05E1\05E0\05E0\05D9\05DD \05DC\05D4\05E6\05D2\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224323475399993)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05EA\05D5\05E6\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224404431399994)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E0\05D1\05D7\05E8\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227053770399995)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05E0\05D9\05DD \05E0\05D5\05DB\05D7\05D9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143859479399935)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05EA \05DE\05E1\05E0\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283665661400036)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E8\05D9\05D2\05D4 \05DE\05D2\05D1\05D5\05DC \05D4\05E2\05E8\05DB\05D9\05DD \05D4\05E0\05D1\05D3\05DC\05D9\05DD (%0) \05D1\05E9\05D1\05D9\05DC \05D4\05D9\05D1\05D8 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269200888400026)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D1\05D8 %0 \05DC\05D0 \05E0\05EA\05DE\05DA \05DC\05E2\05DE\05D5\05D3\05D5\05EA ''\05EA\05D0\05E8\05D9\05DA'' \05D0\05D5 ''\05D7\05D5\05EA\05DE\05EA \05D6\05DE\05DF''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267313198400024)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05DF %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267470944400024)
,p_name=>'APEX.FS.GO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05E6\05D5\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268804163400025)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05D5\05D4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152925105399941)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DB\05D9\05DC \05D0\05EA %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152647696399941)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D3\05D5\05DC \05DE-%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152711809399941)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D3\05D5\05DC \05D0\05D5 \05E9\05D5\05D5\05D4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152415995399941)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D8\05DF \05DE-%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152578560399941)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D8\05DF \05D0\05D5 \05E9\05D5\05D5\05D4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152815362399941)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05D7\05D9\05DC \05D1-%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155351790399943)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD %0 (%1) \05DC\05D0 \05E0\05EA\05DE\05DA \05DC\05D4\05D9\05D1\05D8 \05E9\05D3\05D4 \05D4\05E7\05DC\05D8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145531955399936)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D1\05D8\05D9\05DD \05DE\05E8\05D5\05D1\05D9 \05E2\05E8\05DB\05D9\05DD \05D6\05E7\05D5\05E7\05D9\05DD \05DC\05DE\05E1\05D3\05D9 \05E0\05EA\05D5\05E0\05D9\05DD 12.2 \05D0\05D5 \05D2\05E8\05E1\05D4 \05DE\05D0\05D5\05D7\05E8\05EA \05D9\05D5\05EA\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269072298400026)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E6\05D5\05D9\05E0\05D5 \05E2\05DE\05D5\05D3\05D5\05EA \05D7\05D9\05E4\05D5\05E9 \05DC\05D4\05D9\05D1\05D8 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142470674399933)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05E0\05D9\05DD \05E0\05D5\05E1\05E4\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224546156399994)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D7\05DC\05EA \05D4\05D8\05D5\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268501652400025)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E2\05D3 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268642276400025)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E2\05DC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268720981400025)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05D7\05EA \05DC-%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224618549399994)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05E3 \05D4\05D8\05D5\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287465333400039)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D9\05D8 \05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD #%2 ("%1") \05DC\05D4\05D9\05D1\05D8 \05D8\05D5\05D5\05D7 %0 \05D1\05DC\05EA\05D9 \05EA\05E7\05E3 (\05DE\05E4\05E8\05D9\05D3 "|" \05D7\05E1\05E8).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268989391400025)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05DC\05D8 \05D9\05D3\05E0\05D9 \05DC\05D4\05D9\05D1\05D8 \05D8\05D5\05D5\05D7 %0 \05DC\05D0 \05E0\05EA\05DE\05DA \05DB\05E8\05D2\05E2 \05DB\05D9\05D5\05D5\05DF \05E9\05D4\05E2\05DE\05D5\05D3\05D4 \05D4\05D9\05D0 ''\05EA\05D0\05E8\05D9\05DA'' \05D0\05D5 ''\05D7\05D5\05EA\05DE\05EA \05D6\05DE\05DF''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268298091400025)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152028749399941)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221127639399991)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267670162400025)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267510630400024)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268431329400025)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'he'
,p_message_text=>unistr('- \05D1\05D7\05E8 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151830415399941)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2\05EA \05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268064708400025)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05E4\05D7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268133461400025)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05E2\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112268364714400025)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DB\05D5\05DB\05D1\05D9\05DD \05D5\05DE\05E2\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226072326399995)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05E2\05D5\05EA \05E1\05D9\05E0\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269154278400026)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D1\05D8 \05E9\05D3\05D4 \05D8\05E7\05E1\05D8 %0 \05E0\05EA\05DE\05DA \05DB\05E8\05D2\05E2 \05E8\05E7 \05DC\05E2\05DE\05D5\05D3\05D5\05EA ''\05DE\05E1\05E4\05E8''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142230256399933)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D4"\05DB \05DE\05E1\05E4\05E8 \05E9\05D5\05E8\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285202297400037)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD %0 (%1) \05DC\05D0 \05E0\05EA\05DE\05DA \05DC\05D7\05D9\05E4\05D5\05E9 \05DC\05E4\05D9 \05D4\05D9\05D1\05D8\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277130436400031)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D1\05D5\05E8 \05DC\05E9\05D2\05D9\05D0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234703540400001)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D9\05DE\05D4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242361895400006)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05D5\05E5 Control Break')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234832368400001)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'he'
,p_message_text=>'Control break.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242216581400006)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05D7\05D1 Control Break')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320952909400063)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4  %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242014756400006)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05D7\05E7\05D5 %0 \05E9\05D5\05E8\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312417105400057)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'he'
,p_message_text=>unistr('\05D6\05D4\05D5\05EA \05DB\05E4\05D5\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231761076399999)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D0\05E9\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235074884400001)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA \05E7\05D1\05D5\05E6\05D4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234969365400001)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231833150399999)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251836105400013)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05DF \05E9\05D5\05E8\05D5\05EA \05E0\05D5\05E1\05E4\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231593014399999)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235169724400001)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D5\05EA \05D3\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231908206399999)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'he'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232069213399999)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'he'
,p_message_text=>unistr('%0 - %1 \05DE\05EA\05D5\05DA %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288078608400039)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D9\05E8\05EA \05D3\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231651448399999)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312273888400057)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D5\05E1\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312395878400057)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05EA\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320772507400063)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 %0, \05E2\05DE\05D5\05D3\05D4 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320840156400063)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312141298400057)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05D7\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235376347400001)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA \05E9\05D5\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230954971399998)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05EA\05D0\05D9\05DD \05E0\05D1\05D7\05E8\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232120305399999)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05D5\05E8\05D5\05EA \05E0\05D1\05D7\05E8\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272465055400028)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05D4\05DB\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242119834400006)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235290701400001)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E9\05D5\05E8\05D4 ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235409850400001)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D3\05E8 \05E2\05D5\05DC\05D4 \05DE\05DE\05D5\05D9\05DF %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235576366400001)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D3\05E8 \05D9\05D5\05E8\05D3 \05DE\05DE\05D5\05D9\05DF %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231073640399998)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231334374399998)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231130338399998)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231457051399999)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112231258318399998)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05DC\05DE\05D9\05D9\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241973711400006)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D4"\05DB %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168368707399953)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E7\05E9\05EA HTTP \05DC-"%0" \05E0\05DB\05E9\05DC\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309639348400055)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05D4 \05DC\05D1\05D7\05D9\05E8\05EA \05E1\05E8\05D9\05D2 %0 \05E2\05DE\05D5\05D3\05D5\05EA %1 \05E9\05D5\05E8\05D5\05EA. \05D4\05E9\05EA\05DE\05E9 \05D1\05DE\05E7\05E9\05D9 \05D4\05D7\05E6\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241807404400006)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 %0 \05E9\05D5\05E8\05D5\05EA \05D1\05E8\05E9\05D9\05DE\05D4. \05D4\05E9\05EA\05DE\05E9 \05D1\05DE\05E7\05E9\05D9 \05D4\05D7\05E6\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320545796400063)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228675743399997)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E2\05D5\05DC\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229650148399997)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229535005399997)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E9\05D5\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314098838400058)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D9\05DE\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299549214400047)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D9\05DE\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301285128400049)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DB\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257605508400017)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC \05E2\05DE\05D5\05D3\05D5\05EA \05D4\05D8\05E7\05E1\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258837773400018)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05DC\05D5\05E4\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259998323400019)
,p_name=>'APEX.IG.AND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D5\05D2\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279376104400033)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05EA \05E0\05D1\05D3\05DC\05D9\05DD \05D1\05E7\05D9\05E8\05D5\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315049467400059)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05EA \05E0\05D1\05D3\05DC\05D9\05DD \05D1\05E7\05D9\05E8\05D5\05D1 \05DB\05D5\05DC\05DC\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298165377400046)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D8\05D7')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300081322400048)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258997472400018)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05E9\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314125531400058)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05D8\05D5\05DE\05D8\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279785484400033)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DE\05D5\05E6\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314732315400059)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DE\05D5\05E6\05E2 \05DB\05D5\05DC\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297627374400046)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05EA\05D5\05D5\05D9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297816025400046)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E7\05D5\05DE\05D5\05EA \05E2\05E9\05E8\05D5\05E0\05D9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297726300400046)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05E2\05E8\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303848091400051)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D1\05E2 \05E8\05E7\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298259617400047)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254239188400015)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305039562400052)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D9\05D4\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298355060400047)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E8\05E9\05D9\05DD \05D1\05D5\05E2\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229826980399997)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D8\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259869706400019)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D2\05D9\05E9 \05DC\05D0\05D5\05EA\05D9\05D5\05EA \05E8\05D9\05E9\05D9\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315618531400059)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'he'
,p_message_text=>unistr('(\05E8\05D2\05D9\05E9 \05DC\05D0\05D5\05EA\05D9\05D5\05EA \05E8\05D9\05E9\05D9\05D5\05EA)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286533443400038)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05D9\05E0\05D5\05D9\05D9\05DD \05E0\05E9\05DE\05E8\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230268146399998)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC\05E3 \05EA\05E6\05D5\05D2\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260967428400020)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257453920400017)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05D0\05D9\05DC\05EA\05D0 \05D7\05D5\05E8\05D2\05EA \05DE\05D4\05DE\05E1\05E4\05E8 \05D4\05DE\05E8\05D1\05D9 \05E9\05DC %0 \05E0\05E7\05D5\05D3\05D5\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05DC\05DB\05DC \05EA\05E8\05E9\05D9\05DD. \05D4\05D7\05DC \05DE\05E1\05E0\05DF \05DB\05D3\05D9 \05DC\05E6\05DE\05E6\05DD \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05E9\05DC\05DA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228524814399996)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05EA \05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235883892400002)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297177481400046)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D2\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304099019400051)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D1\05E2\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280160386400034)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05D4 \05DE\05E7\05D3\05D9\05DE\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259236696400019)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228773882399997)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305871215400052)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D8\05E8\05EA \05E2\05DE\05D5\05D3\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259305978400019)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E8\05DB\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228917439399997)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E9\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254878806400015)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DB\05D9\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261164327400020)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'he'
,p_message_text=>'Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235614462400002)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05EA\05E7\05D4 \05DC\05DC\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235799886400002)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05EA\05E7 \05DC\05DE\05D8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279177575400033)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279277995400033)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05EA \05E0\05D1\05D3\05DC\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314980911400059)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05EA \05E0\05D1\05D3\05DC\05D9\05DD \05DB\05D5\05DC\05DC\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314808041400059)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05D4 \05DB\05D5\05DC\05DC\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312539555400057)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D5\05E8 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257876512400017)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05EA\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305673353400052)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05E0\05EA\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305212864400052)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286339154400038)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05EA\05D0\05E8\05D9\05DA \05DC\05D0 \05EA\05E7\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255546264400016)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05DE\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258552808400018)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D5\05EA \05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258372568400018)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229717307399997)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306880748400053)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D0\05DD \05D1\05D8\05D5\05D7 \05E9\05EA\05E8\05E6\05D4 \05DC\05DE\05D7\05D5\05E7 \05D3\05D5\05D7 \05D6\05D4?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262941853400021)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05E7 \05E9\05D5\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261723422400020)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05D9\05E7\05EA \05E9\05D5\05E8\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300192067400048)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260694922400019)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D9\05E8\05D5\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228277455399996)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D1\05D8 \05E4\05D9\05E8\05D5\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288861695400040)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D9\05D5\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260313122400019)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E1\05D5\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254920010400015)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 \05DE\05DB\05D9\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255139895400016)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 \05DE\05EA\05D7\05D9\05DC \05D1:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298456522400047)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05D1\05E2\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261382497400020)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E8\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160075655399947)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05EA\05D5\05E0\05D9\05DD \05D1\05DC\05D1\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307833254400054)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E4\05D5\05E8\05DE\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172634086399956)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E8\05DE\05D8 \05D4\05D4\05D5\05E8\05D3\05D4 %0 \05D0\05D9\05E0\05D5 \05DE\05D0\05D5\05E4\05E9\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300815768400048)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D9\05DE\05D4 \05DB\05E4\05D5\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300909197400049)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'he'
,p_message_text=>unistr('Control Break \05DB\05E4\05D5\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262860355400021)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 \05DB\05E4\05D5\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261668063400020)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D5\05EA \05DB\05E4\05D5\05DC\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229374220399997)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299988163400048)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311403966400056)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05E7\05D1\05D5\05E6\05D4 \05DC\05E4\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307438200400053)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D5\05EA\05E7 \05E1\05DE\05D5\05D9 (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307681590400053)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307355189400053)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05EA\05E7 (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307037962400053)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05EA \05D3\05D5\05D0"\05DC \05E0\05E9\05DC\05D7\05D4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307571055400053)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E0\05D5\05E9\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307277186400053)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05E2\05DF (\05D0\05DC)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260058725400019)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253236597400014)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05D5\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306457909400053)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D2\05DE\05D4 ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260150221400019)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306389605400053)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272395909400028)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D1\05E5 \05DE\05D5\05DB\05DF. \05DE\05EA\05D7\05D9\05DC \05D1\05D4\05D5\05E8\05D3\05D4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112235964271400002)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05DC\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237083982400003)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D9\05E8\05EA \05DE\05D9\05DC\05D5\05D9 \05E2\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236921938400002)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D9\05E8\05EA \05DE\05D9\05DC\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228875188399997)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E0\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259414861400019)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314476414400058)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05DF...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300320234400048)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D0\05E9\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229022000399997)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05DC\05D0\05E9\05D1\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257936465400018)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E8\05DE\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304901012400052)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05DB\05EA \05EA\05D1\05E0\05D9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306748695400053)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'he'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306638172400053)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'he'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219498781399990)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'he'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158763168399946)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'he'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262557948400021)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05E4\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260275716400019)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E0\05E7\05E6\05D9\05D5\05EA \05D5\05D0\05D5\05E4\05E8\05D8\05D5\05E8\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298545084400047)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05E4\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279079031400033)
,p_name=>'APEX.IG.GO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05E6\05D5\05E2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253830404400015)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D3\05D5\05DC \05DE-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253988321400015)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D3\05D5\05DC \05D0\05D5 \05E9\05D5\05D5\05D4 \05DC-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260514780400019)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E8\05D9\05D2 \05E0\05EA\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228093533399996)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05EA \05E8\05E9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301139638400049)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D1\05D5\05E6\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260748294400020)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D1\05E5 \05DC\05E4\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228343247399996)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305550638400052)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05EA\05E0\05D0\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304469787400051)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304677686400051)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D9\05E9\05D5\05E8 \05DB\05D5\05EA\05E8\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314344841400058)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309814634400055)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05D4\05D5\05E1\05D9\05E3, \05DC\05E2\05D3\05DB\05DF \05D5\05DC\05DE\05D7\05D5\05E7 \05E0\05EA\05D5\05E0\05D9\05DD \05D9\05E9\05D9\05E8\05D5\05EA \05D1\05EA\05D5\05DA \05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05D6\05D5.</p>'),
'',
unistr('<p>\05D4\05D5\05E1\05E3 \05E9\05D5\05E8\05D4 \05D7\05D3\05E9\05D4 \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05D4\05DC\05D7\05E6\05DF ''\05D4\05D5\05E1\05E3 \05E9\05D5\05E8\05D4''.</p>'),
'',
unistr('<p>\05E2\05E8\05D5\05DA \05E0\05EA\05D5\05E0\05D9\05DD \05E7\05D9\05D9\05DE\05D9\05DD \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05DB\05E4\05D5\05DC\05D4 \05E2\05DC \05EA\05D0 \05E1\05E4\05E6\05D9\05E4\05D9. \05DC\05E2\05D1\05D5\05D3\05EA \05E2\05E8\05D9\05DB\05D4 \05D2\05D3\05D5\05DC\05D4 \05D9\05D5\05EA\05E8, \05DC\05D7\05E5 \05E2\05DC ''\05E2\05E8\05D5\05DA'' \05DB\05D3\05D9 \05DC\05D4\05D9\05DB\05E0\05E1 \05DC\05DE\05E6\05D1 \05E2\05E8\05D9\05DB\05D4. \05D1\05DE\05E6\05D1 \05E2\05E8\05D9\05DB\05D4, \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05DC\05D7\05D5\05E5 \05DC\05D7\05D9\05E6\05D4 \05D9\05D7\05D9\05D3\05D4 \05D0\05D5 \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05DE\05E7\05DC\05D3\05EA \05DB\05D3\05D9 \05DC\05E2\05E8\05D5\05DA \05EA\05D0\05D9\05DD \05E1\05E4\05E6\05D9\05E4\05D9\05D9\05DD.</p>'),
'',
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05E4\05E8\05D9\05D8 ''\05E9\05E0\05D4'' \05DB\05D3\05D9 \05DC\05E9\05DB\05E4\05DC \05D5\05DC\05DE\05D7\05D5\05E7 \05E9\05D5\05E8\05D5\05EA. \05DB\05D3\05D9 \05DC\05D0\05E4\05E9\05E8 \05D0\05EA \05D4\05EA\05E4\05E8\05D9\05D8 ''\05E9\05E0\05D4'', \05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05D5\05EA \05D4\05EA\05D9\05D5\05D2 \05DC\05D1\05D7\05D9\05E8\05EA \05E9\05D5\05E8\05D4 \05D0\05D7\05EA \05D0\05D5 \05D9\05D5\05EA\05E8.</p>'),
'',
unistr('<p>\05E9\05DB\05E4\05DC \05E9\05D5\05E8\05D4 \05E9\05E0\05D1\05D7\05E8\05D4 \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05D4\05EA\05E4\05E8\05D9\05D8 ''\05E9\05E0\05D4'' \05D5\05D1\05D7\05D9\05E8\05EA ''\05E9\05DB\05E4\05DC \05E9\05D5\05E8\05D5\05EA''. \05DE\05D7\05E7 \05E9\05D5\05E8\05D4 \05E9\05E0\05D1\05D7\05E8\05D4 \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05EA\05E4\05E8\05D9\05D8 ''\05E9\05E0\05D4'' \05D5\05D1\05D7\05D9\05E8\05D4 \05D1''\05DE\05D7\05E7 \05E9\05D5\05E8\05D4''.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311903726400057)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05DB\05D5\05DC\05D5\05EA \05E2\05E8\05D9\05DB\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312083941400057)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05DE\05E6\05D9\05D2\05D4 \05E1\05DC \05E0\05EA\05D5\05E0\05D9\05DD \05D1\05D3\05D5\05D7 \05E0\05D9\05EA\05DF \05DC\05D7\05D9\05E4\05D5\05E9 \05D5\05DC\05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA. \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05D1\05E6\05E2 \05E4\05E2\05D5\05DC\05D5\05EA \05E8\05D1\05D5\05EA \05DB\05D3\05D9 \05DC\05D4\05D2\05D1\05D9\05DC \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D4\05DE\05D5\05D7\05D6\05E8\05D5\05EA \05D5\05DC\05E9\05E0\05D5\05EA \05D0\05EA \05D4\05D0\05D5\05E4\05DF \05E9\05D1\05D5 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DE\05D5\05E6\05D2\05D9\05DD.</p>'),
'',
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05E9\05D3\05D4 ''\05D7\05D9\05E4\05D5\05E9'' \05DB\05D3\05D9 \05DC\05E1\05E0\05DF \05D0\05EA \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D4\05DE\05D5\05D7\05D6\05E8\05D5\05EA. \05DC\05D7\05E5 \05E2\05DC ''\05E4\05E2\05D5\05DC\05D5\05EA'' \05DB\05D3\05D9 \05DC\05D2\05E9\05EA \05DC\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05E8\05D1\05D5\05EA \05DC\05E9\05D9\05E0\05D5\05D9 \05DE\05EA\05D5\05D5\05D4 \05D4\05D3\05D5\05D7, \05D0\05D5 \05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05E4\05E8\05D9\05D8\05D9 ''\05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4'' \05E2\05DC \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA.</p>'),
'',
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1''\05D4\05D2\05D3\05E8\05D5\05EA \05D3\05D5\05D7'' \05DB\05D3\05D9 \05DC\05E9\05DE\05D5\05E8 \05D0\05EA \05D4\05D4\05EA\05D0\05DE\05D5\05EA \05D4\05D0\05D9\05E9\05D9\05D5\05EA \05E9\05DC\05DA \05DC\05D3\05D5\05D7. \05D0\05EA\05D4 \05D2\05DD \05D9\05DB\05D5\05DC \05DC\05D4\05D5\05E8\05D9\05D3 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DE\05D4\05D3\05D5\05D7 \05DC\05E7\05D5\05D1\05E5 \05D7\05D9\05E6\05D5\05E0\05D9 \05D0\05D5 \05DC\05E9\05DC\05D5\05D7 \05D0\05D5\05EA\05DD \05D1\05D3\05D5\05D0"\05DC \05DC\05E2\05E6\05DE\05DA \05D0\05D5 \05DC\05D0\05D7\05E8\05D9\05DD.</p>'),
'',
unistr('<p>\05DC\05DE\05D9\05D3\05E2 \05E0\05D5\05E1\05E3, \05E8\05D0\05D4 ''\05E9\05D9\05DE\05D5\05E9 \05D1\05E8\05E9\05EA\05D5\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05D5\05EA'' \05D1-<em>Oracle Application Express End User''s Guide</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311715718400056)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D1\05D8 \05DB\05DC\05DC\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309710616400055)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05D4\05EA\05D0\05D9\05DD \05D0\05D9\05E9\05D9\05EA \05D0\05EA \05D4\05E8\05E9\05EA \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05DB\05D3\05D9 \05E9\05EA\05E6\05D9\05D2 \05E0\05EA\05D5\05E0\05D9\05DD \05D1\05DE\05E1\05E4\05E8 \05D3\05E8\05DB\05D9\05DD \05E9\05D5\05E0\05D5\05EA \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05D9\05DB\05D5\05DC\05D5\05EA \05D4\05DE\05D5\05D1\05E0\05D5\05EA.</p>'),
'',
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05E4\05E8\05D9\05D8\05D9 ''\05DB\05D5\05EA\05E8\05D5\05EA \05E2\05DE\05D5\05D3\05D5\05EA'' \05D0\05D5 \05D1\05EA\05E4\05E8\05D9\05D8 ''\05E4\05E2\05D5\05DC\05D5\05EA'' \05DB\05D3\05D9 \05DC\05E7\05D1\05D5\05E2 \05D0\05D9\05D6\05D4 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05D4\05E6\05D9\05D2, \05D1\05D0\05D9\05D6\05D4 \05E1\05D3\05E8, \05D5\05DC\05D4\05E7\05E4\05D9\05D0 \05E2\05DE\05D5\05D3\05D5\05EA. \05D0\05EA\05D4 \05D2\05DD \05D9\05DB\05D5\05DC \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05E1\05E0\05E0\05D9 \05E0\05EA\05D5\05E0\05D9\05DD \05E9\05D5\05E0\05D9\05DD \05D5\05DC\05DE\05D9\05D9\05DF \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D4\05DE\05D5\05D7\05D6\05E8\05D9\05DD.</p>'),
'',
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05DC\05D7\05E6\05DF ''\05D4\05E6\05D2'' (\05D4\05E1\05DE\05D5\05DA \05DC\05E9\05D3\05D4 \05D4\05D7\05D9\05E4\05D5\05E9) \05DB\05D3\05D9 \05DC\05D2\05E9\05EA \05DC\05EA\05E6\05D5\05D2\05D5\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05D0\05D7\05E8\05D5\05EA \05E9\05D0\05D5\05DC\05D9 \05D4\05D5\05D2\05D3\05E8\05D5 \05E2\05DC \05D9\05D3\05D9 \05DE\05E4\05EA\05D7 \05D4\05D9\05D9\05E9\05D5\05DD. \05D0\05EA\05D4 \05D2\05DD \05D9\05DB\05D5\05DC \05DC\05D9\05E6\05D5\05E8 \05EA\05E8\05E9\05D9\05DD \05D0\05D5 \05DC\05D4\05E6\05D9\05D2 \05EA\05E8\05E9\05D9\05DD \05E7\05D9\05D9\05DD.</p>  '),
'',
unistr('<p><em>\05D4\05E2\05E8\05D4: \05DC\05D7\05E5 \05E2\05DC <strong>\05E2\05D6\05E8\05D4</strong> \05D1\05EA\05D9\05D1\05D5\05EA \05D4\05D3\05D5-\05E9\05D9\05D7 \05E9\05DC \05D4\05E8\05E9\05EA \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05DB\05D3\05D9 \05DC\05E7\05D1\05DC \05DE\05D9\05D3\05E2 \05DE\05E4\05D5\05E8\05D8 \05D9\05D5\05EA\05E8 \05E2\05DC \05D4\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05E9\05E0\05D1\05D7\05E8\05D4.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311877804400057)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05DB\05D5\05DC\05D5\05EA \05D3\05D9\05D5\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261515520400020)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05E1\05E8\05D9\05D2 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308683998400054)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05E1\05DB\05DD \05E2\05DE\05D5\05D3\05D5\05EA. \05E2\05E8\05DB\05D9\05DD \05DE\05E1\05D5\05DB\05DE\05D9\05DD \05DE\05D5\05E6\05D2\05D9\05DD \05D1\05EA\05D7\05EA\05D9\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD, \05D0\05D5 \05D1\05EA\05D7\05EA\05D9\05EA \05E9\05DC \05DB\05DC break \05D0\05DD \05DE\05D5\05D2\05D3\05E8\05D9\05DD Control Breaks.</p>'),
'',
unistr('<p><strong>\05E8\05E9\05D9\05DE\05EA \05E1\05DB\05D9\05DE\05D4</strong><br>'),
unistr('\05E8\05E9\05D9\05DE\05EA \05D4\05E1\05DB\05D9\05DE\05D4 \05DE\05E6\05D9\05D2\05D4 \05E1\05DB\05D9\05DE\05D5\05EA \05DE\05D5\05D2\05D3\05E8\05D5\05EA. \05D7\05E1\05D5\05DD \05E1\05DB\05D9\05DE\05D4 \05E7\05D9\05D9\05DE\05EA \05E2\05DC \05D9\05D3\05D9 \05D1\05D9\05D8\05D5\05DC \05D4\05D1\05D7\05D9\05E8\05D4 \05D1\05D4.<br>'),
unistr('\05DC\05D7\05E5 \05E2\05DC \05D4\05D5\05E1\05E3 ( &plus; ) \05DB\05D3\05D9 \05DC\05D9\05E6\05D5\05E8 \05E1\05DB\05D9\05DE\05D4 \05D7\05D3\05E9\05D4, \05D0\05D5 \05E2\05DC \05DE\05D7\05E7 ( &minus; ) \05DB\05D3\05D9 \05DC\05D4\05E1\05D9\05E8 \05E1\05DB\05D9\05DE\05D4 \05E7\05D9\05D9\05DE\05EA.</p>'),
'',
unistr('<p><strong>\05D4\05D2\05D3\05E8\05D5\05EA \05E1\05DB\05D9\05DE\05D4</strong><br>'),
unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D8\05D5\05E4\05E1 \05D1\05E6\05D3 \05E9\05DE\05D0\05DC \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05D4\05E1\05DB\05D9\05DE\05D4.<br>'),
unistr('\05D1\05D7\05E8 \05D0\05EA \05E9\05DD \05D4\05E2\05DE\05D5\05D3\05D4 \05D5\05D0\05EA \05E1\05D5\05D2 \05D4\05E1\05DB\05D9\05DE\05D4.<br>'),
unistr('\05DB\05D0\05D5\05E4\05E6\05D9\05D4, \05D4\05D6\05DF \05E8\05DE\05D6 \05E6\05E5 \05D1\05E9\05D1\05D9\05DC \05D4\05E1\05DB\05D9\05DE\05D4.<br>'),
unistr('\05D0\05DD \05D4\05D2\05D3\05E8\05EA Control Break, \05D1\05D7\05D9\05E8\05D4 \05D1<strong>\05D4\05E6\05D2 \05E2\05E8\05DA \05DB\05D5\05DC\05DC</strong> \05DE\05E6\05D9\05D2\05D4 \05D4\05DE\05DE\05D5\05E6\05E2 \05D4\05DB\05D5\05DC\05DC, \05D4\05E1\05D4"\05DB \05D4\05DB\05D5\05DC\05DC \05D0\05D5 \05E2\05E8\05DA \05DB\05D5\05DC\05DC \05D3\05D5\05DE\05D4 \05D1\05EA\05D7\05EA\05D9\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD.</p>'),
'',
unistr('<p><em>\05D4\05E2\05E8\05D4: \05E2\05D1\05D5\05E8 \05DC\05EA\05D9\05D1\05EA \05D4\05D3\05D5-\05E9\05D9\05D7 ''\05E1\05DB\05D9\05DE\05D4'' \05D1\05EA\05E4\05E8\05D9\05D8 ''\05E4\05E2\05D5\05DC\05D5\05EA'' \05D0\05D5 \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05DB\05D5\05EA\05E8\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05D5\05E1\05DB\05DD ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310853989400056)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05E1\05DB\05D9\05DE\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309338869400055)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05EA\05E8\05E9\05D9\05DD \05D4\05DE\05D5\05E6\05D2 \05DB\05EA\05E6\05D5\05D2\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05E0\05E4\05E8\05D3\05EA.<br>'),
unistr('\05D1\05D7\05E8 \05E1\05D5\05D2 \05EA\05E8\05E9\05D9\05DD \05D5\05EA\05DB\05D5\05E0\05D5\05EA \05EA\05E8\05E9\05D9\05DD.</p>'),
unistr('<p><strong>\05EA\05DB\05D5\05E0\05D5\05EA \05EA\05E8\05E9\05D9\05DD</strong></br>'),
unistr('\05EA\05DB\05D5\05E0\05D5\05EA \05D4\05EA\05E8\05E9\05D9\05DD \05D4\05D6\05DE\05D9\05E0\05D5\05EA \05DE\05E9\05EA\05E0\05D5\05EA \05D1\05D4\05EA\05D0\05DD \05DC\05E1\05D5\05D2 \05D4\05EA\05E8\05E9\05D9\05DD.</p>'),
'<p>',
'<ul>',
unistr('  <li>\05D1\05D7\05E8 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05D4\05DE\05DB\05D9\05DC\05D4 \05D0\05EA \05D4\05E2\05E8\05DA \05DC\05EA\05DB\05D5\05E0\05D4:'),
'    <ul>',
unistr('      <li>\05EA\05D5\05D5\05D9\05EA - \05D4\05D8\05E7\05E1\05D8 \05DC\05DB\05DC \05E0\05E7\05D5\05D3\05EA \05E0\05EA\05D5\05E0\05D9\05DD.</li>'),
unistr('      <li>\05E2\05E8\05DA - \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05E9\05D9\05E9 \05DC\05E9\05E8\05D8\05D8.</li>'),
unistr('      <li>\05E1\05D3\05E8\05D4 - \05DC\05D4\05D2\05D3\05E8\05EA \05D4\05E9\05D0\05D9\05DC\05EA\05D0 \05D4\05D3\05D9\05E0\05DE\05D9\05EA \05E2\05DD \05E8\05D9\05D1\05D5\05D9 \05D4\05E1\05D3\05E8\05D5\05EA \05E9\05DC\05DA.</li>'),
unistr('      <li>\05E4\05EA\05D5\05D7 - \05DE\05D7\05D9\05E8 \05E4\05EA\05D9\05D7\05EA \05D4\05DE\05DC\05D0\05D9 \05D4\05D9\05D5\05DE\05D9 (\05DE\05DC\05D0\05D9 \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>\05E1\05D2\05D5\05E8 - \05DE\05D7\05D9\05E8 \05E1\05D2\05D9\05E8\05EA \05D4\05DE\05DC\05D0\05D9 \05D4\05D9\05D5\05DE\05D9 (\05DE\05DC\05D0\05D9 \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>\05D2\05D1\05D5\05D4 - \05D4\05E2\05E8\05DA \05D4\05D2\05D1\05D5\05D4 (\05D8\05D5\05D5\05D7 \05D5\05DE\05DC\05D0\05D9 \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>\05E0\05DE\05D5\05DA - \05D4\05E2\05E8\05DA \05D4\05E0\05DE\05D5\05DA (\05D8\05D5\05D5\05D7 \05D5\05DE\05DC\05D0\05D9 \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>\05E0\05E4\05D7 - \05E0\05E4\05D7 \05D4\05DE\05DC\05D0\05D9 \05D4\05D9\05D5\05DE\05D9 (\05DE\05DC\05D0\05D9 \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>\05D9\05E2\05D3 - \05E2\05E8\05DA \05D4\05D9\05E2\05D3 (\05DE\05E9\05E4\05DA \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>X - \05E2\05E8\05DA \05E6\05D9\05E8 \05D4-x (\05EA\05E8\05E9\05D9\05DD \05D1\05D5\05E2\05D5\05EA \05D5\05D2\05E8\05E3 \05E4\05D9\05D6\05D5\05E8 \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>Y - \05E2\05E8\05DA \05E6\05D9\05E8 \05D4-y (\05EA\05E8\05E9\05D9\05DD \05D1\05D5\05E2\05D5\05EA \05D5\05D2\05E8\05E3 \05E4\05D9\05D6\05D5\05E8 \05D1\05DC\05D1\05D3).</li>'),
unistr('      <li>Z- \05E8\05D5\05D7\05D1 \05D4\05E2\05DE\05D5\05D3\05D4 \05D0\05D5 \05E8\05D3\05D9\05D5\05E1 \05EA\05E8\05E9\05D9\05DD \05D4\05D1\05D5\05E2\05D5\05EA (\05E2\05DE\05D5\05D3\05D4, \05EA\05E8\05E9\05D9\05DD \05D1\05D5\05E2\05D5\05EA \05D5\05D8\05D5\05D5\05D7 \05D1\05DC\05D1\05D3).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\05DB\05D9\05D5\05D5\05DF \05D4\05D4\05D3\05E4\05E1\05D4 - \05D0\05E0\05DB\05D9 \05D0\05D5 \05D0\05D5\05E4\05E7\05D9.</li>'),
unistr('  <li>\05E1\05DB\05D9\05DE\05D4 - \05D1\05D7\05E8 \05DB\05D9\05E6\05D3 \05DC\05E1\05DB\05D5\05DD \05D0\05EA \05E2\05E8\05DB\05D9 \05D4\05EA\05E8\05E9\05D9\05DD.</li>'),
unistr('  <li>\05E2\05E8\05D9\05DE\05D4 - \05E6\05D9\05D9\05DF \05D0\05DD \05E4\05E8\05D9\05D8\05D9 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DE\05D5\05E2\05E8\05DE\05D9\05DD.</li>'),
unistr('  <li>\05DE\05D9\05D5\05DF \05DC\05E4\05D9 \2013 \05DE\05D9\05D9\05DF \05DC\05E4\05D9 \05EA\05D5\05D5\05D9\05EA \05D0\05D5 \05E2\05E8\05DB\05D9\05DD.'),
'    <ul>',
unistr('      <li>\05DB\05D9\05D5\05D5\05DF - \05DE\05D9\05D9\05DF \05E2\05E8\05DB\05D9\05DD \05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4 \05D0\05D5 \05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3.</li>'),
unistr('      <li>\05E2\05E8\05DB\05D9 Null - \05E6\05D9\05D9\05DF \05DB\05D9\05E6\05D3 \05DC\05DE\05D9\05D9\05DF \05E8\05E9\05D5\05DE\05D5\05EA \05E2\05DD \05E2\05E8\05DB\05D9 null \05D1\05D9\05D7\05E1 \05DC\05E8\05E9\05D5\05DE\05D5\05EA \05E2\05DD \05E2\05E8\05DB\05D9\05DD \05E9\05D0\05D9\05E0\05DD null.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\05DE\05E7\05D5\05DE\05D5\05EA \05E2\05E9\05E8\05D5\05E0\05D9\05D9\05DD.</li>'),
unistr('  <li>\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05EA\05D5\05D5\05D9\05EA</li>'),
unistr('  <li>\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05E2\05E8\05DA</li>'),
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311256425400056)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308327038400054)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D1\05D7\05D5\05E8 \05D0\05D9\05D6\05D4 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05D4\05E6\05D9\05D2 \05D5\05D1\05D0\05D9\05D6\05D4 \05E1\05D3\05E8.</p>'),
'',
unistr('<p>\05D4\05E1\05EA\05E8 \05E2\05DE\05D5\05D3\05D4 \05E2\05DC \05D9\05D3\05D9 \05D1\05D9\05D8\05D5\05DC \05D4\05D1\05D7\05D9\05E8\05D4 \05D1\05D4.<br>'),
unistr('\05E9\05E0\05D4 \05D0\05EA \05E1\05D3\05E8 \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05D4\05D6\05D6 \05DE\05E2\05DC\05D4 ( &uarr; ) \05D0\05D5 \05D4\05D6\05D6 \05DE\05D8\05D4 ( &darr; ).<br>'),
unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D1\05D5\05E8\05E8 \05D4\05E8\05E9\05D9\05DE\05D4 \05D4\05E0\05E4\05EA\05D7\05EA \05DC\05E7\05D1\05DC\05EA \05E8\05E9\05D9\05DE\05D4 \05E9\05DC \05DB\05DC \05D4\05E2\05DE\05D5\05D3\05D5\05EA, \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA \05D0\05D5 \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DC\05D0-\05DE\05D5\05E6\05D2\05D5\05EA.</p>'),
'',
unistr('<p>\05DB\05D0\05D5\05E4\05E6\05D9\05D4, \05D4\05E9\05EA\05DE\05E9 \05D1\05D8\05D5\05E4\05E1 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05D4\05E8\05D5\05D7\05D1 \05D4\05DE\05D9\05E0\05D9\05DE\05DC\05D9 \05E9\05DC \05E2\05DE\05D5\05D3\05D4 \05D1\05E4\05D9\05E7\05E1\05DC\05D9\05DD.</p>'),
'',
unistr('<p><em>\05D4\05E2\05E8\05D4: \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05D2\05DD \05DC\05E9\05E0\05D5\05EA \05D0\05EA \05D4\05E1\05D3\05E8 \05E9\05DC \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05DE\05E6\05D1\05D9\05E2 \05D4\05D2\05E8\05D9\05E8\05D4 (\05D1\05EA\05D7\05D9\05DC\05EA \05DB\05D5\05EA\05E8\05EA \05D4\05E2\05DE\05D5\05D3\05D4) \05D5\05D2\05E8\05D9\05E8\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05DE\05D0\05DC\05D4 \05D0\05D5 \05D9\05DE\05D9\05E0\05D4. \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05D2\05DD \05DC\05E9\05E0\05D5\05EA \05D0\05EA \05D4\05E8\05D5\05D7\05D1 \05E9\05DC \05E2\05DE\05D5\05D3\05D5\05EA \05DE\05D5\05E6\05D2\05D5\05EA \05E2\05DC \05D9\05D3\05D9 \05D1\05D7\05D9\05E8\05D4 \05D1\05DE\05E4\05E8\05D9\05D3 \05D4\05E2\05DE\05D5\05D3\05D5\05EA, \05D1\05D9\05DF \05DB\05D5\05EA\05E8\05D5\05EA, \05D5\05D4\05D6\05D6\05EA\05D5 \05E9\05DE\05D0\05DC\05D4 \05D0\05D5 \05D9\05DE\05D9\05E0\05D4</em>')
||'</p>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311137615400056)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05E2\05DE\05D5\05D3\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308700993400054)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05E2\05DE\05D5\05D3\05D5\05EA \05E0\05D5\05E1\05E4\05D5\05EA \05E2\05DC \05D1\05E1\05D9\05E1 \05D7\05D9\05E9\05D5\05D1\05D9\05DD \05DE\05EA\05DE\05D8\05D9\05D9\05DD \05D5\05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D9\05DD \05D4\05DE\05D1\05D5\05E6\05E2\05D9\05DD \05DE\05D5\05DC \05E2\05DE\05D5\05D3\05D5\05EA \05E7\05D9\05D9\05DE\05D5\05EA.</p>'),
'',
unistr('<p><strong>\05E8\05E9\05D9\05DE\05EA \05D7\05D9\05E9\05D5\05D1\05D9\05DD</strong><br>'),
unistr('\05E8\05E9\05D9\05DE\05EA \05D4\05D7\05D9\05E9\05D5\05D1\05D9\05DD \05DE\05E6\05D9\05D2\05D4 \05D7\05D9\05E9\05D5\05D1\05D9\05DD \05DE\05D5\05D2\05D3\05E8\05D9\05DD. \05D7\05E1\05D5\05DD \05D7\05D9\05E9\05D5\05D1 \05E7\05D9\05D9\05DD \05E2\05DC \05D9\05D3\05D9 \05D1\05D9\05D8\05D5\05DC \05D4\05D1\05D7\05D9\05E8\05D4 \05D1\05D5.<br>'),
unistr('\05DC\05D7\05E5 \05E2\05DC \05D4\05D5\05E1\05E3 ( &plus; ) \05DB\05D3\05D9 \05DC\05D4\05D5\05E1\05D9\05E3 \05D7\05D9\05E9\05D5\05D1 \05D7\05D3\05E9, \05D0\05D5 \05E2\05DC \05DE\05D7\05E7 ( &minus; ) \05DB\05D3\05D9 \05DC\05D4\05E1\05D9\05E8 \05D7\05D9\05E9\05D5\05D1 \05E7\05D9\05D9\05DD.</p>'),
'',
unistr('<p><strong>\05D4\05D2\05D3\05E8\05D5\05EA \05D7\05D9\05E9\05D5\05D1</strong><br>'),
unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D8\05D5\05E4\05E1 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA\05D4\05D7\05D9\05E9\05D5\05D1.<br>'),
unistr('\05D4\05D6\05DF \05D0\05EA \05E4\05E8\05D8\05D9 \05D4\05E2\05DE\05D5\05D3\05D4 \05DB\05DE\05D5 \05DB\05D5\05EA\05E8\05EA, \05EA\05D5\05D5\05D9\05EA \05D5\05D1\05D7\05E8 \05D4\05D2\05D3\05E8\05D5\05EA \05D9\05D9\05E9\05D5\05E8.<br> '),
unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D0\05D6\05D5\05E8 \05D4\05D8\05E7\05E1\05D8 ''\05D1\05D9\05D8\05D5\05D9'' \05DB\05D3\05D9 \05DC\05D4\05D6\05D9\05DF \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D5\05E4\05D5\05E0\05E7\05E6\05D9\05D5\05EA \05E7\05E9\05D5\05E8\05D5\05EA \05D1\05E9\05D1\05D9\05DC \05D4\05D7\05D9\05E9\05D5\05D1.<br>'),
unistr('\05D1\05D7\05E8 \05D1\05E9\05D1\05D9\05DC \05D4\05E2\05DE\05D5\05D3\05D4 \05D4\05D7\05D3\05E9\05D4 \05D0\05EA \05E1\05D5\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D4\05DE\05EA\05D0\05D9\05DD \05D5\05DB\05D0\05D5\05E4\05E6\05D9\05D4 \05DE\05E1\05DB\05EA \05E4\05D5\05E8\05DE\05D8.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310748290400056)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05D7\05D9\05E9\05D5\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309013718400054)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 control break \05E2\05DC \05E2\05DE\05D5\05D3\05D4 \05D0\05D7\05EA \05D0\05D5 \05D9\05D5\05EA\05E8.</p>'),
'',
unistr('<p><strong>\05E8\05E9\05D9\05DE\05EA Control Break </strong><br>'),
unistr('\05E8\05E9\05D9\05DE\05EA Control Break \05DE\05E6\05D9\05D2\05D4 control breaks \05DE\05D5\05D2\05D3\05E8\05D9\05DD. \05D7\05E1\05D5\05DD \05E2\05DE\05D5\05D3\05EA control break \05E7\05D9\05D9\05DE\05EA \05E2\05DC \05D9\05D3\05D9 \05D1\05D9\05D8\05D5\05DC \05D4\05D1\05D7\05D9\05E8\05D4 \05D1\05D4.<br>'),
unistr('\05DC\05D7\05E5 \05E2\05DC \05D4\05D5\05E1\05E3 ( &plus; ) \05DB\05D3\05D9 \05DC\05DB\05DC\05D5\05DC \05E2\05DE\05D5\05D3\05D4 \05D7\05D3\05E9\05D4 \05D1-control break, \05D0\05D5 \05E2\05DC \05DE\05D7\05E7 ( &minus; ) \05DB\05D3\05D9 \05DC\05D4\05E1\05D9\05E8 \05E2\05DE\05D5\05D3\05D4 \05E7\05D9\05D9\05DE\05EA \05DE\05D4-control break.<br>'),
unistr('\05DC\05E9\05D9\05E0\05D5\05D9 \05E1\05D3\05E8 \05D4\05E2\05DE\05D5\05D3\05D5\05EA, \05DC\05D7\05E5 \05E2\05DC \05D4\05D6\05D6 \05DE\05E2\05DC\05D4 ( &uarr; ) \05D0\05D5 \05E2\05DC \05D4\05D6\05D6 \05DE\05D8\05D4 ( &darr; ) \05DB\05D3\05D9 \05DC\05D4\05D6\05D9\05D6 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05E0\05D1\05D7\05E8\05D4 \05DE\05E2\05DC\05D4 \05D5\05DE\05D8\05D4 \05D9\05D7\05E1\05D9\05EA \05DC\05E2\05DE\05D5\05D3\05D5\05EA \05D0\05D7\05E8\05D5\05EA.</p>'),
'',
unistr('<p><strong>\05D4\05D2\05D3\05E8\05D5\05EAControl Break</strong><br>'),
unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D8\05D5\05E4\05E1 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05E2\05DE\05D5\05D3\05EA \05D4-control break.<br>'),
unistr('\05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05EA control break, \05DB\05D9\05D5\05D5\05DF \05D4\05DE\05D9\05D5\05DF \05D5\05D0\05D9\05DA \05DC\05E1\05D3\05E8 \05E2\05DE\05D5\05D3\05D5\05EA null (\05E2\05DE\05D5\05D3\05D5\05EA \05DC\05DC\05D0 \05E2\05E8\05DA).</p>'),
'',
unistr('<p><em>\05D4\05E2\05E8\05D4: \05D1\05D6\05DE\05DF \05D4\05E6\05D2\05EA \05D4\05E8\05E9\05EA \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA, \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05D4\05D2\05D3\05D9\05E8 control break \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4 \05D5\05D1\05D7\05D9\05E8\05D4 \05D1\05E1\05DE\05DC \05E9\05DC control break.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310448794400055)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC-Control Break')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309230276400055)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05D5\05E8\05D9\05D3 \05D0\05EA \05DB\05DC \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05E0\05D5\05DB\05D7\05D9\05D5\05EA \05DC\05E7\05D5\05D1\05E5 \05D7\05D9\05E6\05D5\05E0\05D9. \05D4\05E7\05D5\05D1\05E5 \05D9\05DB\05D9\05DC \05E8\05E7 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA \05DB\05E8\05D2\05E2, \05EA\05D5\05DA \05E9\05D9\05DE\05D5\05E9 \05D1\05DB\05DC \05D4\05DE\05E1\05E0\05E0\05D9\05DD \05D5\05D4\05DE\05D9\05D5\05E0\05D9\05DD \05E9\05D4\05D5\05D7\05DC\05D5 \05E2\05DC \05D4\05E0\05EA\05D5\05E0\05D9\05DD.</p>'),
'',
unistr('<p>\05D1\05D7\05E8 \05D0\05EA \05E4\05D5\05E8\05DE\05D8 \05D4\05E7\05D5\05D1\05E5 \05D5\05DC\05D7\05E5 \05E2\05DC ''\05D4\05D5\05E8\05D3''.<br>'),
unistr('\05D4\05E2\05E8\05D4: CSV \05DC\05D0 \05D9\05DB\05DC\05D5\05DC \05E2\05D9\05E6\05D5\05D1 \05D8\05E7\05E1\05D8 \05DB\05DE\05D5 \05E1\05DB\05D9\05DE\05D5\05EA \05D5-control breaks.</p>'),
'',
unistr('<p>\05DB\05D3\05D9 \05DC\05E9\05DC\05D5\05D7 \05D0\05EA \05D4\05E7\05D5\05D1\05E5 \05D1\05D3\05D5\05D0"\05DC, \05D1\05D7\05E8 ''\05E9\05DC\05D7 \05DB\05D3\05D5\05D0"\05DC'' \05D5\05D4\05D6\05DF \05D0\05EA \05E4\05E8\05D8\05D9 \05D4\05D3\05D5\05D0"\05DC (\05E0\05DE\05E2\05DF, \05E0\05D5\05E9\05D0 \05D5\05D4\05D5\05D3\05E2\05D4).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310267118400055)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05D4\05D5\05E8\05D3\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308483128400054)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05E1\05E0\05E0\05D9 \05E0\05EA\05D5\05E0\05D9\05DD \05E9\05DE\05D2\05D1\05D9\05DC\05D9\05DD \05D0\05EA \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05D7\05D6\05E8\05D5\05EA.</p>'),
'',
unistr('<p><strong>\05E8\05E9\05D9\05DE\05EA \05DE\05E1\05E0\05E0\05D9\05DD</strong><br>'),
unistr('\05E8\05E9\05D9\05DE\05EA \05D4\05DE\05E1\05E0\05E0\05D9\05DD \05DE\05E6\05D9\05D2\05D4 \05DE\05E1\05E0\05E0\05D9\05DD \05DE\05D5\05D2\05D3\05E8\05D9\05DD. \05D7\05E1\05D5\05DD \05DE\05E1\05E0\05DF \05E7\05D9\05D9\05DD \05E2\05DC \05D9\05D3\05D9 \05D1\05D9\05D8\05D5\05DC \05D4\05D1\05D7\05D9\05E8\05D4 \05D1\05D5.<br>'),
unistr('\05DC\05D7\05E5 \05E2\05DC \05D4\05D5\05E1\05E3 ( &plus; ) \05DB\05D3\05D9 \05DC\05D9\05E6\05D5\05E8 \05DE\05E1\05E0\05DF \05D7\05D3\05E9, \05D0\05D5 \05E2\05DC \05DE\05D7\05E7 ( &minus; ) \05DB\05D3\05D9 \05DC\05D4\05E1\05D9\05E8 \05DE\05E1\05E0\05DF \05E7\05D9\05D9\05DD.</p>'),
'',
unistr('<p><strong>\05D4\05D2\05D3\05E8\05D5\05EA \05DE\05E1\05E0\05DF</strong><br>'),
unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D8\05D5\05E4\05E1 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05DE\05D0\05E4\05D9\05D9\05E0\05D9 \05D4\05DE\05E1\05E0\05DF.<br>'),
unistr('\05D1\05E8 \05D0\05EA \05E1\05D5\05D2 \05D4\05DE\05E1\05E0\05DF \05D4\05DE\05EA\05D0\05D9\05DD:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Row - \05E1\05E0\05DF \05DC\05DE\05D5\05E0\05D7 \05D1\05DB\05DC \05E2\05DE\05D5\05D3\05D4 \05D4\05E0\05D9\05EA\05E0\05EA \05DC\05E1\05D9\05E0\05D5\05DF.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Column - \05E1\05E0\05DF \05E2\05DE\05D5\05D3\05D4 \05E1\05E4\05E6\05D9\05E4\05D9\05EA \05E2\05DD \05D0\05D5\05E4\05E8\05D8\05D5\05E8 \05D5\05E2\05E8\05DA \05DE\05D5\05D2\05D3\05E8\05D9\05DD.</p>'),
'',
unistr('<p><em>\05D4\05E2\05E8\05D4: \05D1\05D6\05DE\05DF \05D4\05E6\05D2\05EA \05D4\05E8\05E9\05EA \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA, \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05E1\05E0\05E0\05D9 \05E9\05D5\05E8\05D4 \05E2\05DC \05D9\05D3\05D9 \05D4\05E7\05DC\05D3\05D4 \05D9\05E9\05D9\05E8\05D5\05EA \05D1\05E9\05D3\05D4 ''\05D7\05E4\05E9''. \05DC\05D7\05E5 \05E2\05DC ''\05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05D7\05D9\05E4\05D5\05E9'' \05DB\05D3\05D9 \05DC\05D4\05D2\05D1\05D9\05DC \05D0\05EA \05D4\05D7\05D9\05E4\05D5\05E9 \05DC\05E2\05DE\05D5\05D3\05D4 \05E1\05E4\05E6\05D9\05E4\05D9\05EA. \05DC\05D7\05DC\05D5\05E4\05D9\05DF, \05E4\05EA\05D7 \05EA\05E4\05E8\05D9\05D8 ''\05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4'' \05D5\05D1\05D7\05E8 \05E2\05E8\05DA \05DB\05D3\05D9 \05DC\05D9\05E6\05D5\05E8 \05DE\05E1\05E0\05DF \05E2\05DE\05D5\05D3\05D5\05EA.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311049466400056)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05DE\05E1\05E0\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308833349400054)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05E6\05D9\05D2 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DB\05E4\05D9 \05E9\05D4\05D9\05D5 \05E7\05D9\05D9\05DE\05D9\05DD \05D1\05E0\05E7\05D5\05D3\05EA \05D6\05DE\05DF \05E7\05D5\05D3\05DE\05EA.</p>'),
unistr('<p>\05D4\05D6\05DF \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05D3\05E7\05D5\05EA \05D1\05E2\05D1\05E8 \05DC\05D4\05E8\05E6\05EA \05D0\05EA \05E9\05D0\05D9\05DC\05EA\05EA \05D4-flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310697946400056)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05E4\05DC\05D0\05E9\05D1\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311384379400056)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC''\05E7\05D1\05E5 \05DC\05E4\05D9''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308942355400054)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05D3\05D2\05D9\05E9 \05E9\05D5\05E8\05D5\05EA \05D0\05D5 \05E2\05DE\05D5\05D3\05D5\05EA \05E9\05DC \05E0\05EA\05D5\05E0\05D9\05DD \05E2\05DC \05D1\05E1\05D9\05E1 \05D4\05EA\05E0\05D0\05D9 \05E9\05D4\05D5\05D6\05DF.</p>'),
'',
unistr('<p><strong>\05E8\05E9\05D9\05DE\05EA \05D4\05D3\05D2\05E9\05D5\05EA</strong><br>'),
unistr('\05E8\05E9\05D9\05DE\05EA \05D4\05D4\05D3\05D2\05E9\05D5\05EA \05DE\05E6\05D9\05D2\05D4 \05D4\05D3\05D2\05E9\05D5\05EA \05DE\05D5\05D2\05D3\05E8\05D5\05EA. \05D7\05E1\05D5\05DD \05D4\05D3\05D2\05E9\05D4 \05E7\05D9\05D9\05DE\05EA \05E2\05DC \05D9\05D3\05D9 \05D1\05D9\05D8\05D5\05DC \05D4\05D1\05D7\05D9\05E8\05D4 \05D1\05D4.<br>'),
unistr('\05DC\05D7\05E5 \05E2\05DC \05D4\05D5\05E1\05E3 ( &plus; ) \05DB\05D3\05D9 \05DC\05D9\05E6\05D5\05E8 \05D4\05D3\05D2\05E9\05D4 \05D7\05D3\05E9\05D4, \05D0\05D5 \05E2\05DC \05DE\05D7\05E7 ( &minus; ) \05DB\05D3\05D9 \05DC\05D4\05E1\05D9\05E8 \05D4\05D3\05D2\05E9\05D4 \05E7\05D9\05D9\05DE\05EA.</p>'),
'',
unistr('<p><strong>\05D4\05D2\05D3\05E8\05D5\05EA \05D4\05D3\05D2\05E9\05D4</strong><br>'),
unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D8\05D5\05E4\05E1 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05DE\05D0\05E4\05D9\05D9\05E0\05D9 \05D4\05D4\05D3\05D2\05E9\05D4.<br>'),
unistr('\05D4\05D6\05DF \05D0\05EA \05D4\05E9\05DD, \05D1\05D7\05E8 ''\05E9\05D5\05E8\05D4'' \05D0\05D5 ''\05E2\05DE\05D5\05D3\05D4'', \05D5\05D1\05D7\05E8 \05D0\05EA \05E7\05D5\05D3\05D9 \05E6\05D1\05E2 HTML \05D1\05E9\05D1\05D9\05DC \05D4\05E8\05E7\05E2 \05D5\05D4\05D8\05E7\05E1\05D8.<br>'),
unistr('\05D1\05D7\05E8 \05D0\05EA <strong>\05E1\05D5\05D2 \05D4\05EA\05E0\05D0\05D9</strong> \05D4\05DE\05EA\05D0\05D9\05DD \05DB\05D3\05D9 \05DC\05D4\05D3\05D2\05D9\05E9 \05E0\05EA\05D5\05E0\05D9\05DD \05E1\05E4\05E6\05D9\05E4\05D9\05D9\05DD:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Row - \05D4\05D3\05D2\05E9 \05D0\05EA \05D4\05DE\05D5\05E0\05D7 \05D1\05DB\05DC \05E2\05DE\05D5\05D3\05D4.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Column - \05D4\05D3\05D2\05E9 \05D1\05EA\05D5\05DA \05E2\05DE\05D5\05D3\05D4 \05E1\05E4\05E6\05D9\05E4\05D9\05EA \05D1\05D4\05EA\05D1\05E1\05E1 \05E2\05DC \05D4\05D0\05D5\05E4\05E8\05D8\05D5\05E8 \05D5\05E2\05E8\05DA \05E9\05E6\05D5\05D9\05E0\05D5.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310580442400056)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05D4\05D3\05D2\05E9\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309111587400055)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05E9\05DE\05D5\05E8 \05E9\05D9\05E0\05D5\05D9\05D9\05DD \05E9\05E2\05E9\05D9\05EA \05D1\05DE\05EA\05D5\05D5\05D4 \05D5\05EA\05E6\05D5\05E8\05D4 \05D4\05E0\05D5\05DB\05D7\05D9\05D9\05DD \05E9\05DC \05D4\05E8\05E9\05EA.<br>'),
unistr('\05DE\05E4\05EA\05D7\05D9 \05D9\05D9\05E9\05D5\05DE\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05E1\05E4\05E8 \05DE\05EA\05D5\05D5\05D9\05DD \05D7\05DC\05D5\05E4\05D9\05D9\05DD \05E9\05DC \05D3\05D5\05D7. \05DB\05D0\05E9\05E8 \05DE\05D5\05EA\05E8, \05D0\05EA\05D4 \05D5\05DE\05E9\05EA\05DE\05E9\05D9 \05E7\05E6\05D4 \05D0\05D7\05E8\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05E9\05DE\05D5\05E8 \05D3\05D5\05D7 \05DB\05E6\05D9\05D1\05D5\05E8\05D9, \05DE\05D4 \05E9\05D4\05D5\05E4\05DA \05D0\05D5\05EA\05D5 \05DC\05D6\05DE\05D9\05DF \05DC\05DB\05DC \05DE\05E9\05EA\05DE\05E9\05D9 \05D4\05E8\05E9\05EA \05D4\05D0\05D7\05E8\05D9\05DD. \05D0\05EA\05D4 \05D2\05DD \05D9\05DB\05D5\05DC \05DC\05E9\05DE\05D5\05E8 \05D3\05D5\05D7 \05DB\05D3\05D5\05D7 \05DB\05D3\05D5\05D7 \05E4\05E8\05D8\05D9 \05E9\05E8\05E7 \05D0\05EA\05D4 \05D9\05DB\05D5\05DC \05DC\05E6\05E4\05D5\05EA \05D1\05D5.</p>'),
unistr('<p>\05D1\05D7\05E8 \05DE\05D1\05D9\05DF \05D4\05E1\05D5\05D2\05D9\05DD \05D4\05D6\05DE\05D9\05E0\05D9\05DD \05D5\05D4\05D6\05DF \05E9\05DD \05D1\05E9\05D1\05D9\05DC \05D4\05D3\05D5\05D7 \05D4\05E9\05DE\05D5\05E8.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310352861400055)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E2\05D6\05E8\05D4 \05DC\05D3\05D5\05D7'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308580702400054)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05E1\05D3\05E8 \05D4\05D4\05E6\05D2\05D4.</p>'),
'',
unistr('<p><strong>\05E8\05E9\05D9\05DE\05EA \05DE\05D9\05D5\05DF</strong><br>'),
unistr('\05EA\05D9\05D1\05EA \05D4\05D3\05D5-\05E9\05D9\05D7 ''\05DE\05D9\05D5\05DF'' \05DE\05E6\05D9\05D2\05D4 \05E8\05E9\05D9\05DE\05D4 \05E9\05DC \05DB\05DC\05DC\05D9 \05DE\05D9\05D5\05DF \05DE\05D5\05D2\05D3\05E8\05D9\05DD.<br>'),
unistr('\05DC\05D7\05E5 \05E2\05DC \05D4\05D5\05E1\05E3 ( &plus; ) \05DB\05D3\05D9 \05DC\05D9\05E6\05D5\05E8 \05E2\05DE\05D5\05D3\05EA \05DE\05D9\05D5\05DF, \05D0\05D5 \05E2\05DC \05DE\05D7\05E7 ( &minus; ) \05DB\05D3\05D9 \05DC\05D4\05E1\05D9\05E8 \05E2\05DE\05D5\05D3\05EA \05DE\05D9\05D5\05DF.<br>'),
unistr('\05DC\05D7\05E5 \05E2\05DC \05D4\05D6\05D6 \05DE\05E2\05DC\05D4 ( &uarr; ) \05D5\05E2\05DC \05D4\05D6\05D6 \05DE\05D8\05D4 ( &darr; ) \05DB\05D3\05D9 \05DC\05D4\05E2\05D1\05D9\05E8 \05D0\05EA \05E2\05DE\05D5\05D3\05EA \05D4\05DE\05D9\05D5\05DF \05E9\05E0\05D1\05D7\05E8\05D4 \05DE\05E2\05DC\05D4 \05D5\05DE\05D8\05D4 \05D9\05D7\05E1\05D9\05EA \05DC\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D9\05D5\05DF \05D4\05D0\05D7\05E8\05D5\05EA.</p>'),
'',
unistr('<p><strong>\05D4\05D2\05D3\05E8\05D5\05EA \05DE\05D9\05D5\05DF</strong><br>'),
unistr('\05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05EA \05DE\05D9\05D5\05DF, \05DB\05D9\05D5\05D5\05DF \05D4\05DE\05D9\05D5\05DF \05D5\05D0\05D9\05DA \05DC\05E1\05D3\05E8 \05E2\05DE\05D5\05D3\05D5\05EA null (\05E2\05DE\05D5\05D3\05D5\05EA \05DC\05DC\05D0 \05E2\05E8\05DA).</p>'),
'',
unistr('<p><em>\05D4\05E2\05E8\05D4: \05D0\05E4\05E9\05E8 \05DC\05DE\05D9\05D9\05DF \05E0\05EA\05D5\05E0\05D9\05DD \05DC\05E4\05D9 \05E2\05DE\05D5\05D3\05D5\05EA \05E9\05D0\05D9\05E0\05DF \05DE\05D5\05E6\05D2\05D5\05EA, \05D0\05D1\05DC \05D9\05D9\05EA\05DB\05DF \05E9\05DC\05D0 \05DB\05DC \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E0\05D9\05EA\05E0\05D5\05EA \05DC\05DE\05D9\05D5\05DF.</em><br>'),
unistr('<em>\05E2\05DE\05D5\05D3\05D5\05EA \05DE\05D5\05E6\05D2\05D5\05EA \05D0\05E4\05E9\05E8 \05DC\05DE\05D9\05D9\05DF \05E2\05DC \05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05D7\05E5 \05DE\05E2\05DC\05D4 (\05E1\05D3\05E8 \05E2\05D5\05DC\05D4) \05D0\05D5 \05E2\05DC \05D7\05E5 \05DE\05D8\05D4 (\05E1\05D3\05E8 \05D9\05D5\05E8\05D3) \05D1\05E1\05D5\05E3 \05DB\05D5\05EA\05E8\05EA \05D4\05E2\05DE\05D5\05D3\05D4. \05DB\05D3\05D9 \05DC\05D4\05D5\05E1\05D9\05E3 \05E2\05DE\05D5\05D3\05D4 \05E2\05D5\05E7\05D1\05EA \05DC\05DE\05D9\05D5\05DF \05E7\05D9\05D9\05DD, \05D4\05D7\05D6\05E7 \05D0\05EA \05DE\05E7\05E9 Shift \05DC\05D7\05D5\05E5 \05D5\05DC\05D7\05E5 \05E2\05DC \05D7\05E5 \05DE\05E2\05DC\05D4 \05D0\05D5 \05DE\05D8\05D4.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310961782400056)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05DE\05D9\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112310134823400055)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05DE\05E0\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262473497400021)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05EA\05E8')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229279770399997)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05D2\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297245872400046)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D1\05D5\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298078054400046)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E4\05E7\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255458740400016)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E2\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260462622400019)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DE\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228112244399996)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05EA \05E1\05DE\05DC\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253691486400014)
,p_name=>'APEX.IG.IN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262044078400020)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D4 \05DC\05D0 \05E4\05E2\05D9\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262109470400021)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D5\05EA \05DC\05D0 \05E4\05E2\05D9\05DC\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269727271400026)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E8\05E2\05D4 \05E9\05D2\05D9\05D0\05D4 \05E4\05E0\05D9\05DE\05D9\05EA \05D1\05D6\05DE\05DF \05E2\05D9\05D1\05D5\05D3 \05D1\05E7\05E9\05EA \05D4\05E8\05E9\05EA \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165552407399951)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05DF \05E2\05DE\05D5\05D3\05D5\05EA \05DE\05E1\05D5\05D2 "%0" \05DC\05D0 \05E0\05EA\05DE\05DA \05DC\05E2\05DE\05D5\05D3\05D4 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309973772400055)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D1\05E0\05D9\05EA \05EA\05D0\05E8\05D9\05DA \05D1\05DC\05EA\05D9 \05EA\05E7\05E4\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284126597400036)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05DC\05D0 \05EA\05D5\05DE\05DB\05EA \05D1\05D4\05D2\05D3\05E8\05EA \05DE\05E1\05E0\05DF \05E2\05DC \05E2\05DE\05D5\05D3\05D4 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284039243400036)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05E0\05D5 \05E1\05D5\05D2 \05DE\05E1\05E0\05DF \05EA\05E7\05E3 \05DC\05D4\05D2\05D3\05E8\05EA \05DE\05E1\05E0\05DF \05E9\05DC \05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170694239399954)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D1\05E0\05D9\05EA \05DE\05E1\05E4\05E8 \05D1\05DC\05EA\05D9 \05EA\05E7\05E4\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312683238400057)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D4 \05DC\05D0 \05EA\05E7\05E4\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312780694400057)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D5\05EA \05DC\05D0 \05EA\05E7\05E4\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303788179400051)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA ''\05DE\05D9\05D9\05DF \05DC\05E4\05D9'' \05E0\05E7\05D1\05E2 \05DC-%0, \05D0\05DA \05DC\05D0 \05E0\05D1\05D7\05E8\05D4 \05D0\05E3 \05E2\05DE\05D5\05D3\05D4 \05DC-%0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301064904400049)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05DC\05D0 \05EA\05E7\05E3 ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296176818400045)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D4\05D5\05E6\05D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254404811400015)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D0\05D7\05E8\05D5\05E0\05D5\05EA/\05D1\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254638439400015)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D1\05D0\05D5\05EA/\05D1\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253532798400014)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 \05E8\05D9\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253449338400014)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D0 \05E8\05D9\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304502105400051)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D2\05D9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296516941400045)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05D5\05D9\05EA ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300489187400048)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243712113400007)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D5\05DD \05D4\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243995675400008)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05E2\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244448955400008)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05E7\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243434728400007)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D5\05D3\05E9 \05E9\05E2\05D1\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243518163400007)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E9\05D1\05D5\05E2 \05E9\05E2\05D1\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243616905400007)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D9\05DE\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243860401400007)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E2\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244518880400008)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D3\05E7\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244337827400008)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D7\05D5\05D3\05E9\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244224425400008)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05D1\05D5\05E2\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243257829400007)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E0\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243349881400007)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E9\05E0\05D4 \05E9\05E2\05D1\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304748189400051)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D9\05E9\05D5\05E8 \05EA\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304830573400051)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05E7\05D1\05D5\05E6\05D4 \05D1\05E9\05D1\05D9\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254046013400015)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D8\05DF \05DE-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254148588400015)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D8\05DF \05D0\05D5 \05E9\05D5\05D5\05D4 \05DC-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298617760400047)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298774558400047)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5 \05E2\05DD \05E9\05D8\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305162778400052)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'he'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297398731400046)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05D5\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307733782400054)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05E8\05D3 \05D1\05D9\05DF \05DE\05E1\05E4\05E8 \05DB\05EA\05D5\05D1\05D5\05EA \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05E4\05E1\05D9\05E7\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255232773400016)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05D0\05D9\05DD \05DC-Regular Expression')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279634976400033)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05D1\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315230945400059)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E7\05E1\05D9\05DE\05D5\05DD \05DB\05D5\05DC\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279887044400033)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E6\05D9\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315334846400059)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E6\05D9\05D5\05DF \05DB\05D5\05DC\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279547697400033)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05E2\05E8\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255330671400016)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280307161400034)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9  \05D3\05E7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315156015400059)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05E0\05D9\05DE\05D5\05DD \05DB\05D5\05DC\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255715687400016)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262368638400021)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DE\05DB\05D9\05DC\05D9\05DD \05D9\05D5\05EA\05E8 \05DE-%0 \05E9\05D5\05E8\05D5\05EA \05D5\05D7\05D5\05E8\05D2\05D9\05DD \05DE\05D4\05DE\05E8\05D1 \05D4\05DE\05D5\05EA\05E8. \05D4\05D7\05DC \05DE\05E1\05E0\05E0\05D9\05DD \05E0\05D5\05E1\05E4\05D9\05DD \05DB\05D3\05D9 \05DC\05D4\05E6\05D9\05D2 \05D0\05EA \05D4\05EA\05D5\05E6\05D0\05D5\05EA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289031601400040)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05DE\05D6\05D4\05D4 \05E1\05D8\05D8\05D9 \05E9\05DC \05D0\05D6\05D5\05E8 \05DB\05D9\05D5\05D5\05DF \05E9\05D4\05D3\05E3 \05DE\05DB\05D9\05DC \05DE\05E1\05E4\05E8 \05E8\05E9\05EA\05D5\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258448234400018)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258607090400018)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E9\05DE\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242637117400007)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D5\05DD \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242480640400006)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05E2\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244666211400008)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05E7\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242945159400007)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05D5\05D3\05E9 \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242850640400007)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05D1\05D5\05E2 \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242782929400007)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D9\05DE\05D9\05DD \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112242549044400007)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E2\05D5\05EA \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244759022400008)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D3\05E7\05D5\05EA \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244005518400008)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D7\05D5\05D3\05E9\05D9\05DD \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244136343400008)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05D1\05D5\05E2\05D5\05EA \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243109172400007)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E0\05D9\05DD \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112243055157400007)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05E0\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254307116400015)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0 \05D1\05D9\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253322530400014)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E9\05D5\05D5\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319578614400062)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D0\05D6\05D5\05E8 \05E2\05DD \05DE\05D6\05D4\05D4 %0 \05D0\05D9\05E0\05E0\05D5 \05D0\05D6\05D5\05E8 \05E9\05DC \05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05D0\05D5 \05DC\05D0 \05E7\05D9\05D9\05DD \05D1\05D9\05D9\05E9\05D5\05DD %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253705155400015)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 \05D1-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254557565400015)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D1\05D0\05D7\05E8\05D5\05E0\05D5\05EA/\05D1\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112254725722400015)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D1\05D1\05D0\05D5\05EA/\05D1\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262233253400021)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05E0\05EA\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300234152400048)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'he'
,p_message_text=>unistr('Nulls (\05E8\05D9\05E7\05D9\05DD)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305345004400052)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300558509400048)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D1\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300637962400048)
,p_name=>'APEX.IG.ON'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E4\05E2\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252551549400014)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 \05D3\05E7\05D4 \05D0\05D7\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308279390400054)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05EA\05D7 \05D1\05D5\05E8\05E8 \05E6\05D1\05E2: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297014525400046)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05EA\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259572483400019)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E4\05E8\05D8\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296425777400045)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D9\05D5\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298852976400047)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D5\05D2\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112260828406400020)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D9\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112228453297399996)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E6\05D9\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112308195314400054)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05E8\05D3 \05D1\05D9\05DF \05E2\05E8\05DB\05D9\05DD \05D1\05D0\05DE\05E6\05E2\05D5\05EA "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112298930520400047)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5\05D8\05D1\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304206296400051)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05DB\05D6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304396573400051)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D9\05D5\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112304185476400051)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D7\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258781782400018)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D0\05E9\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259083562400018)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E8\05D0\05E9\05D9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275574660400030)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E8\05D0\05E9\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157777797399945)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC\05D5\05DC \05EA\05D2\05D9\05D5\05EA \05E0\05D2\05D9\05E9\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156436193399944)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E8\05D5\05D7\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156564739399944)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0\05D5\05E8\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156368858399944)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D9\05D5\05D5\05DF \05D4\05D3\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156268757399944)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'he'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156103387399944)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'he'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157835433399945)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155994066399944)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'he'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155858123399944)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'he'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156002371399944)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'he'
,p_message_text=>'TABLOID'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155740834399943)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D5\05D3\05DC \05D4\05D3\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145921486399936)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8\05EA \05D8\05E7\05E1\05D8 \05E2\05E9\05D9\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299038051400047)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DB"\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299106533400047)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05D8\05D5\05D5\05D7 '),
'         '))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309479768400055)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E2\05E0\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263029894400021)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E2\05E0\05DF \05E9\05D5\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261853196400020)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E2\05E0\05DF \05E9\05D5\05E8\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267060252400024)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E7\05D9\05D9\05DD \05D0\05D6\05D5\05E8 \05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05D1\05D9\05D9\05E9\05D5\05DD %0, \05D3\05E3 %1 \05D5\05D0\05D6\05D5\05E8 %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229977391399997)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258125860400018)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318751187400061)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05D5\05D7  \05E0\05DE\05D7\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318415800400061)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05D7\05DC\05D5\05E4\05D9 \05E0\05E9\05DE\05E8 \05DC\05DB\05DC \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318330400400061)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05E9\05DC \05D3\05D5\05D7 \05E0\05E9\05DE\05E8\05D4 \05DC\05DB\05DC \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318673314400061)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E4\05E8\05D8\05D9 \05E0\05E9\05DE\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318558298400061)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E6\05D9\05D1\05D5\05E8\05D9 \05E0\05E9\05DE\05E8 \05DC\05DB\05DC \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112267105690400024)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05E9\05DE\05D5\05E8\05D4 \05D1\05E2\05DC\05EA \05E9\05DD %0 \05DC\05D0 \05E7\05D9\05D9\05DE\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252435873400014)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05EA\05D5\05E0\05D9 \05D4\05D3\05D5\05D7 \05E0\05DB\05D5\05DF \05DC\05DC\05E4\05E0\05D9 %0 \05D3\05E7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252391345400014)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05EA\05D5\05E0\05D9 \05D4\05D3\05D5\05D7 \05E0\05DB\05D5\05DF \05DC\05DC\05E4\05E0\05D9 \05D3\05E7\05D4 \05D0\05D7\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192030236399970)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05DC\05D0 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311694853400056)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 - \05E2\05E8\05D9\05DB\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266978663400024)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05E9\05DE\05D5\05E8\05D4 \05D1\05E2\05DC\05EA \05DE\05D6\05D4\05D4 %0 \05DC\05D0 \05E7\05D9\05D9\05DE\05EA.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112311560819400056)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 - \05E9\05DE\05D9\05E8\05D4 \05D1\05E9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230036861399998)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D5\05EA \05D3\05D5\05D7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319648690400062)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05EA \05E9\05DE\05D5\05E8\05D4 \05D1\05E2\05DC\05EA \05DE\05D6\05D4\05D4 \05E1\05D8\05D8\05D9 %0 \05DC\05D0 \05E7\05D9\05D9\05DE\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314518365400058)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05EA \05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229137358399997)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263139238400021)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D8\05DC \05E9\05D9\05E0\05D5\05D9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261968602400020)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05D5\05DA \05E9\05D5\05E8\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259125266400018)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258066862400018)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D5\05EA \05D1\05E2\05DE\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319272832400062)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E2\05D5\05DC\05D5\05EA \05E9\05D5\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320473813400063)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E2\05D5\05DC\05D5\05EA \05DC\05E9\05D5\05E8\05D4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112229463749399997)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272137148400028)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227681153399996)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7\05D5\05EA \05E9\05E0\05E9\05DE\05E8\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227718679399996)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202237819399977)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D1\05E8 \05E7\05D9\05D9\05DD \05D3\05D5\05D7 \05E9\05DE\05D5\05E8 \05D1\05E9\05DD %0. \05D4\05D6\05DF \05E9\05DD \05D7\05D3\05E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227894116399996)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D8\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227975078399996)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D9\05D1\05D5\05E8\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314214161400058)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8 \05D1\05E9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261233601400020)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8 \05D4\05D2\05D3\05E8\05D5\05EA \05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299220247400047)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D9\05D6\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227519487399996)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306525503400053)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D9\05E4\05D5\05E9: \05DB\05DC \05E2\05DE\05D5\05D3\05D5\05EA \05D4\05D8\05E7\05E1\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227471834399996)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D9\05E4\05D5\05E9: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305753453400052)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D9\05E4\05D5\05E9: \05D8\05E7\05E1\05D8 \05DE\05DC\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252221419400013)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9 \05D0\05EA ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295897191400045)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'he'
,p_message_text=>unistr('- \05D1\05D7\05E8 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236000951400002)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D9\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288793723400040)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E9\05D5\05E8\05D4 \05D0\05D7\05EA \05D1\05D0\05D6\05D5\05E8 \05D4\05D0\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227374396399996)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05D7\05D9\05E4\05D5\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318963880400062)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E2\05D5\05DC\05D5\05EA \05D1\05D7\05D9\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236262809400002)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D9\05E8\05EA \05EA\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236104150400002)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D9\05E8\05EA \05E9\05D5\05E8\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307175671400053)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D7 \05DB\05D3\05D5\05D0\05E8 \05D0\05DC\05E7\05D8\05E8\05D5\05E0\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299651737400048)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D3\05E8\05D4 ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225388943399994)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277985678400032)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05E2\05E8\05DA \05DB\05D5\05DC\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262713401400021)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05EA \05E9\05D5\05E8\05D4 \05D1\05D5\05D3\05D3\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261026808400020)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299775407400048)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05DC\05E4\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319327643400062)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05DB\05DC \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05D9\05D5\05DF \05D0\05D7\05D3 \05D1\05DC\05D1\05D3 \05DC\05DB\05DC \05E2\05DE\05D5\05D3\05D4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319106829400062)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E4\05E8\05D9\05D8 \05E9\05D9\05E0\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112300786599400048)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05E1\05E0\05D9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255092032400015)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05D7\05D9\05DC \05D1-')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299371419400047)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E7 \05D4\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220394960399991)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05D7 \05E8\05D5\05D7\05D1\05D9 \05E2\05DE\05D5\05D3\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112261427540400020)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E0\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112279431705400033)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D5\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320624944400063)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E8\05D9\05D2 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9. \05D3\05D5\05D7: %0, \05EA\05E6\05D5\05D2\05D4: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112314687113400058)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D9\05DB\05D5\05DD \05DB\05D5\05DC\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297520191400046)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05E2\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303976321400051)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D1\05E2 \05D8\05E7\05E1\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230123641399998)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC\05E4\05EA \05DE\05E6\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277846266400032)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D9\05D0\05D5\05E8 \05DB\05DC\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112258246233400018)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112262693093400021)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D8\05DC \05D4\05E7\05E4\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259740148400019)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D7\05D9\05D3\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306949766400053)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D9\05D9\05DE\05D9\05DD \05E9\05D9\05E0\05D5\05D9\05D9\05DD \05E9\05DC\05D0 \05E0\05E9\05DE\05E8\05D5. \05D4\05D0\05DD \05EA\05E8\05E6\05D4 \05DC\05D4\05DE\05E9\05D9\05DA?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112259699329400019)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296610484400045)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301518592400049)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D3\05E8\05E9 \05E2\05E8\05DA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286431899400038)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA (\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E9\05E0\05D5\05EA \05D0\05D6\05D5\05E8 \05D6\05DE\05DF)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305499010400052)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E7\05E1\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297923914400046)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E0\05DB\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257772520400017)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295909276400045)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E6\05D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112297485157400046)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E4\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255666754400016)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296049120400045)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D5\05D7\05D1 \05E2\05DE\05D5\05D3\05D4 \05DE\05D6\05E2\05E8\05D9 (Pixel)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246840414400010)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05D9\05DF %1 \05DC-%2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246533871400009)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05DB\05D9\05DC \05D0\05EA %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246680448400009)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05DE\05DB\05D9\05DC \05D0\05EA %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224786941399994)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05DE\05EA\05D7\05D9\05DC \05D1-%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245340289400009)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05D5\05D5\05D4 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245585683400009)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D2\05D3\05D5\05DC \05DE-%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245651213400009)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D2\05D3\05D5\05DC \05D0\05D5 \05E9\05D5\05D5\05D4 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246381333400009)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247574560400010)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05D9\05DE\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247381835400010)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05E9\05E2\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247153166400010)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05D3\05E7\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247918224400010)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05D7\05D5\05D3\05E9\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247722208400010)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05E9\05D1\05D5\05E2\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248179753400011)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05E9\05E0\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247409914400010)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05D9\05D5\05DD \05D4\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247201295400010)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05E9\05E2\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247037906400010)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05D3\05E7\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247812056400010)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05D7\05D5\05D3\05E9 \05D4\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112247651493400010)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05E9\05D1\05D5\05E2 \05D4\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248046810400010)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05E9\05E0\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249972766400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05D9\05DE\05D9\05DD \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249785999400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05E9\05E2\05D5\05EA \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249524131400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05D3\05E7\05D5\05EA \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250381274400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05D7\05D5\05D3\05E9\05D9\05DD \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250107715400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05E9\05D1\05D5\05E2\05D5\05EA \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250532449400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1-%1 \05D4\05E9\05E0\05D9\05DD \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249819186400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05D9\05D5\05DD \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249645926400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05E9\05E2\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249460163400011)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05D3\05E7\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250201479400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05D7\05D5\05D3\05E9 \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250082980400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05E9\05D1\05D5\05E2 \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250462623400012)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D1\05E9\05E0\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246033713400009)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05E8\05D9\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245913678400009)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E8\05D9\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245734384400009)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E7\05D8\05DF \05DE-%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245869079400009)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E7\05D8\05DF \05D0\05D5 \05E9\05D5\05D5\05D4 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246126943400009)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DB\05DE\05D5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246717609400010)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05EA\05D0\05D9\05DD \05DC-regular expression %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252608459400014)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05D3\05E7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246973354400010)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05D9\05DF %1 \05DC-%2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245484786400009)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DC\05D0 \05E9\05D5\05D5\05D4 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246449391400009)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248705335400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05D9\05DE\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248561064400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05E9\05E2\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248317212400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05D3\05E7\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249126882400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05D7\05D5\05D3\05E9\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248916247400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05E9\05D1\05D5\05E2\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249303941400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05E9\05E0\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248670705400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05D9\05D5\05DD \05D4\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248493683400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05E9\05E2\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248278981400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05D3\05E7\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249058835400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05D7\05D5\05D3\05E9 \05D4\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112248866727400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05E9\05D1\05D5\05E2 \05D4\05D0\05D7\05E8\05D5\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112249297992400011)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05E9\05E0\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251165111400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05D9\05DE\05D9\05DD \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250941265400012)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05E9\05E2\05D5\05EA \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250702340400012)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05D3\05E7\05D5\05EA \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251510104400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05D7\05D5\05D3\05E9\05D9\05DD \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251320427400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05E9\05D1\05D5\05E2\05D5\05EA \05D4\05D1\05D0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251766399400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1-%1 \05D4\05E9\05E0\05D9\05DD \05D4\05D1\05D0\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251060888400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05D9\05D5\05DD \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250824220400012)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05E9\05E2\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112250665166400012)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05D3\05E7\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251429474400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05D7\05D5\05D3\05E9 \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251247580400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05E9\05D1\05D5\05E2 \05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251662500400013)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05D1\05E9\05E0\05D4 \05D4\05D1\05D0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112246250319400009)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DC\05D0 \05DB\05DE\05D5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253170533400014)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05EA\05D7\05D9\05DC \05D1-%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296722571400045)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'he'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255859815400016)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296834141400046)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'he'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296903005400046)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'he'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112305956093400052)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D5\05DD \05E9\05E0\05D9, \05D4-12 \05D1\05D9\05E0\05D5\05D0\05E8, 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306035008400052)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05E0\05D5\05D0\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306171981400052)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'he'
,p_message_text=>unistr('16 \05E9\05E2\05D5\05EA \05DC\05E4\05E0\05D9 \05DB\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112306261389400052)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-16h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161257921399947)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05E7\05D5\05D1\05E5 \05DC\05D0 \05EA\05E7\05E3. \05E1\05D5\05D2\05D9 \05E7\05D5\05D1\05E5 \05E0\05EA\05DE\05DB\05D9\05DD %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288102335400039)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D9\05D9\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287819014400039)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E7\05D5\05D1\05E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287941541400039)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E7\05D1\05E6\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161090053399947)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05E8\05D5\05E8 \05D5\05E9\05DE\05D5\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161422329399948)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05E8\05D5\05E8 \05D5\05E9\05DE\05D5\05D8 \05E7\05D1\05E6\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162664962399948)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E7\05D5\05D1\05E5 \05D0\05D5 \05E9\05DE\05D5\05D8 \05D0\05D5\05EA\05D5 \05DB\05D0\05DF.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162723999399949)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E7\05D1\05E6\05D9\05DD \05D0\05D5 \05E9\05DE\05D5\05D8 \05D0\05D5\05EA\05DD \05DB\05D0\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162810976399949)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E7\05D5\05D1\05E5 \05D0\05D5 \05E9\05DE\05D5\05D8 \05D0\05D5\05EA\05D5 \05DB\05D0\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162957320399949)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E7\05D1\05E6\05D9\05DD \05D0\05D5 \05E9\05DE\05D5\05D8 \05D0\05D5\05EA\05DD \05DB\05D0\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161331386399948)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E7\05D1\05E6\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161163977399947)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D1\05E5 \05D2\05D3\05D5\05DC \05DE\05D3\05D9. \05D2\05D5\05D3\05DC \05DE\05E8\05D1\05D9 \05E9\05DC \05E7\05D5\05D1\05E5 \05D4\05D5\05D0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148930773399938)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E8\05D5\05E9\05D4 \05DB\05EA\05D5\05D1\05EA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147851428399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D9\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148298785399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5\05D3 \05D4\05D0\05E8\05E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147903714399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05D1\05D9\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148843997399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5 \05E8\05D5\05D7\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148775335399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5 \05D0\05D5\05E8\05DA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148699340399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05D1\05DE\05E4\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148363791399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05E7\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148028280399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05E7\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148100975399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D3\05D9\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147784741399938)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D7\05D5\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147627110399937)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05E6\05D0\05D5\05EA \05DE\05E2\05E8\05DB\05EA \05D2\05D9\05D0\05D5\05E7\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160274760399947)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5\05D3\05D3 \05D1\05DE\05E2\05E8\05DB\05EA \05D2\05D9\05D0\05D5\05E7\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160304355399947)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E7\05D5\05D3\05D3 \05D1\05DE\05E2\05E8\05DB\05EA \05D2\05D9\05D0\05D5\05E7\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148577160399938)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E4\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112148445061399938)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05DB\05EA\05D5\05D1\05D5\05EA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149099307399939)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E8\05D5\05E9 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318805249400062)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E7\05E1\05D8 \05E2\05D6\05E8\05D4: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212215776399985)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05D5\05DE\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212322872399985)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05DE\05E1\05D5\05DE\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158229720399945)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05D0\05D9\05E0\05D5 \05D1\05D8\05D5\05D5\05D7 \05D4\05EA\05E7\05E3 \05E9\05DC %0 \05E2\05D3 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158377277399945)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05D0\05D9\05E0\05D5 \05DB\05E4\05D5\05DC\05D4 \05E9\05DC %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157994398399945)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05E6\05E8\05D9\05DA \05DC\05D4\05EA\05D0\05D9\05DD \05DC\05E2\05E8\05DB\05D9\05DD %0 \05D5-%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158140592399945)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236437224400002)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D1\05D5\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236582824400002)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E4\05E2\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158023325399945)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DF ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141418421399933)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E8\05E9\05D5\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270602515400027)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270763239400027)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141558066399933)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D5\05DE\05D5\05EA \05E9\05E0\05D1\05D7\05E8\05D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274453762400029)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05E7\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274774469400030)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D8\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274559416400029)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05D5\05EA\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274899643400030)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05EA\05D1\05E0\05D9\05EA \05D7\05D9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275482223400030)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05D4\05EA\05D1\05E0\05D9\05EA \05D0\05D9\05E0\05DF \05D6\05DE\05D9\05E0\05D5\05EA \05DB\05D9\05D5\05D5\05DF \05E9\05E8\05DB\05D9\05D1 \05D6\05D4 \05D0\05D9\05E0\05D5 \05DE\05D5\05E6\05D2 \05D1\05D3\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274331104400029)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05EA\05D1\05E0\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274697936400030)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149969923399939)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D4 \05E2\05D9\05D2\05D5\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151765004399940)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'he'
,p_message_text=>unistr('''\05E1\05D2\05E0\05D5\05E0\05D5\05EA \05DE\05D5\05EA\05D0\05DE\05D9\05DD \05D0\05D9\05E9\05D9\05EA'' \05D0\05D9\05E0\05D5 JSON \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150259210399939)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC\05D9 \05DE\05E8\05D7\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150095007399939)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E8\05D8\05D8 \05E2\05D9\05D2\05D5\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142669887399934)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D9\05E4\05D5\05E9 \05DC\05E4\05D9 \05D4\05D9\05D1\05D8\05D9\05DD \05D3\05D5\05E8\05E9 \05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9\05DD \05D1\05E8\05DE\05EA \05D4\05D0\05D6\05D5\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145283511399936)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05E7\05D5\05DD \05E0\05D5\05DB\05D7\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146355246399937)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5\05D0\05D5\05E8\05D3\05D9\05E0\05D8\05D5\05EA \05D4\05DE\05D9\05E7\05D5\05DD \05D4\05D4\05EA\05D7\05DC\05EA\05D9 \05D0\05D9\05E0\05DF \05EA\05E7\05E4\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143788876399935)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05D9\05E7\05D5\05DD \05D4\05D4\05EA\05D7\05DC\05EA\05D9 \05E6\05E8\05D9\05DA \05DC\05D4\05D9\05D5\05EA \05D2\05D9\05D0\05D5\05DE\05D8\05E8\05D9\05D9\05EA \05E0\05E7\05D5\05D3\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146146054399936)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7"\05DE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144779122399935)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DB\05D1\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278011115400032)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DB\05D1\05D4: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149306720399939)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E4\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142598321399934)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146215185399936)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DC\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277030838400031)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DE\05DB\05D9\05DC\05D9\05DD \05D9\05D5\05EA\05E8 \05DE-%0 \05E9\05D5\05E8\05D5\05EA, \05DE\05D4 \05E9\05D7\05D5\05E8\05D2 \05DE\05D4\05DE\05E1\05E4\05E8 \05D4\05DE\05E8\05D1 \05D4\05DE\05D5\05EA\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144591774399935)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Terms</a> &nbsp;&nbsp; \05DE\05E4\05D4 \05E0\05EA\05D5\05E0\05D9 &copy; 2017 \05DB\05D0\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143478953399934)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD SDO_GEOMETRY \05D0\05D9\05E0\05D5 \05D6\05DE\05D9\05DF \05D1\05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD \05D6\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144660498399935)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; \05EA\05D5\05E8\05DE\05D9 OpenStreetMap</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144872798399935)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D5\05D3\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278131759400032)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E0\05E7\05D5\05D3\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150100957399939)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D6\05D5\05DD \05DE\05DC\05D1\05E0\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149806975399939)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145187429399936)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05E4\05D5\05DF \05EA\05DE\05D9\05D3 \05DC\05DE\05E2\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225478491399994)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC\05E3 \05DC\05DE\05E6\05D1 \05D3\05D5-\05DE\05DE\05D3\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225572552399994)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC\05E3 \05DC\05DE\05E6\05D1 \05EA\05DC\05EA-\05DE\05DE\05D3\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149748719399939)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC\05E3 \05DE\05E6\05D1 \05E9\05DC \05D4\05D5\05D3\05E2\05EA \05D6\05DB\05D5\05D9\05D5\05EA \05D9\05D5\05E6\05E8\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150382843399939)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05D7\05E7 \05DB\05D5\05DC\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144974106399936)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05E7\05E8\05D1\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145023328399936)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05E8\05D7\05E7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272574625400028)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05D3\05D2\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273415773400029)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05DE\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273077555400028)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5\05D3 \05DB\05DC\05D5\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286650471400038)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E4\05EA \05EA\05DE\05D5\05E0\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286752125400038)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E4\05EA \05E7\05D9\05E9\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272613200400028)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D8\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287324467400039)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D9\05E9\05D5\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273364207400029)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273203821400029)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05D4 \05DE\05E1\05D5\05D3\05E8\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272747092400028)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05D4 \05DE\05E7\05D3\05D9\05DE\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272886160400028)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05DE\05D4 \05DC\05D4\05E6\05D9\05D2 \05D1\05EA\05E6\05D5\05D2\05D4 \05DE\05E7\05D3\05D9\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272974511400028)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5 \05D7\05D5\05E6\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273134319400028)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05D4 \05DC\05D0 \05DE\05E1\05D5\05D3\05E8\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252049645400013)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D5\05DB\05D7\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112309566407400055)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D5\05D3...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112251960346400013)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05D5\05E2\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283746347400036)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257059139400017)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05DE\05E1\05E4\05E8 \05E7\05D8\05DF \05D0\05D5 \05E9\05D5\05D5\05D4 \05DC-%0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257125260400017)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05DE\05E1\05E4\05E8 \05EA\05E7\05E3.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257240895400017)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05D0\05D9\05E0\05D5 \05EA\05D5\05D0\05DD \05DC\05E4\05D5\05E8\05DE\05D8 \05D4\05DE\05E1\05E4\05E8 %0 (\05D3\05D5\05D2\05DE\05D4: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256993635400017)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05DE\05E1\05E4\05E8 \05D2\05D3\05D5\05DC \05D0\05D5 \05E9\05D5\05D5\05D4 \05DC-%0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256866174400017)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05DC #LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05DE\05E1\05E4\05E8 \05D1\05D9\05DF %0 \05DC\05D1\05D9\05DF %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252105461400013)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E4\05EA\05D7 \05D1\05D7\05DC\05D5\05DF \05D7\05D3\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205308570399980)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 \05D6\05D4 \05E0\05E9\05DC\05D7 \05DB\05D1\05E8 \05D5\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E9\05DC\05D5\05D7 \05D0\05D5\05EA\05D5 \05E9\05D5\05D1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187969419399967)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D9\05E9\05D5\05DD "%0" \05D3\05E3 "%1" \05DC\05D0 \05E0\05DE\05E6\05D0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221799348399992)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('#LABEL# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05E2\05DD \05E2\05E8\05DA \05DB\05DC\05E9\05D4\05D5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165072176399950)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271073546400027)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D2\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270992052400027)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271266730400027)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271145432400027)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157123372399945)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D6\05DF \05D1\05D9\05D8\05D5\05D9 \05D7\05D9\05E4\05D5\05E9 \05E9\05DC %0 \05EA\05D5\05D5\05D9\05DD \05DC\05E4\05D7\05D5\05EA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226645404399995)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD \05E6\05E6\05D4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157207081399945)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D6\05DF \05DE\05D5\05E0\05D7 \05D7\05D9\05E4\05D5\05E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157093501399944)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05EA\05D5\05E6\05D0\05D5\05EA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156993146399944)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244843451400008)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9 \05D7\05D9\05E4\05D5\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270857917400027)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281526097400034)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E2\05D1\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155512161399943)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05DC\05DE\05E1\05DA \05D3\05E3 \05D4\05D1\05D9\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151521719399940)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05E0\05E8\05D0\05D4 \05E9\05D4\05DE\05DB\05E9\05D9\05E8 \05D0\05D5 \05D4\05D3\05E4\05D3\05E4\05DF \05E9\05DC\05DA \05D0\05D9\05E0\05DD \05EA\05D5\05DE\05DB\05D9\05DD \05DB\05E8\05D2\05E2 \05D1\05D4\05EA\05E7\05E0\05D4 \05E9\05DC \05D9\05D9\05E9\05D5\05DE\05D9 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05DE\05EA\05E7\05D3\05DE\05D9\05DD (PWA).</p>'),
unistr('    <p class="a-pwaDialog-intro">\05D0\05DD \05D9\05D9\05E9\05D5\05DD \05D6\05D4 \05DB\05D1\05E8 \05DE\05D5\05EA\05E7\05DF \05D1\05DE\05DB\05E9\05D9\05E8 \05E9\05DC\05DA, \05E4\05EA\05D7 \05D0\05D5\05EA\05D5 \05DE\05D3\05E3 \05D4\05D1\05D9\05EA \05E9\05DC\05DA.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151107633399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD. \05D4\05D5\05E1\05E3 \05D0\05D5\05EA\05D4 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA \05E9\05DC\05DA \05DB\05D3\05D9 \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05D4 \05D1\05DE\05E1\05DA \05DE\05DC\05D0.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>Menu</strong> (\05EA\05E4\05E8\05D9\05D8) \05D1\05E0\05D9\05D5\05D5\05D8 \05D4\05EA\05D7\05EA\05D5\05DF</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \05D4\05E7\05E9 \05E2\05DC <strong>Install</strong></p> (\05D4\05EA\05E7\05DF)'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \05D4\05E7\05E9 \05E2\05DC <strong>Add</strong> (\05D4\05D5\05E1\05E3) \05DB\05D3\05D9 \05DC\05D0\05E9\05E8</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151205619399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD \05E9\05E0\05D9\05EA\05DF \05DC\05D7\05D5\05D5\05EA \05D0\05D5\05EA\05D4 \05D1\05DE\05D9\05D8\05D1\05D4 \05D1\05D3\05E4\05D3\05E4\05E0\05D9\05DD Chrome \05D0\05D5 Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>Menu</strong> (\05EA\05E4\05E8\05D9\05D8) \05E9\05DC\05D9\05D3 \05E9\05D5\05E8\05EA \05D4\05DB\05EA\05D5\05D1\05EA</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \05D4\05E7\05E9 \05E2\05DC <strong>Install</strong></p> (\05D4\05EA\05E7\05DF)'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150823830399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD \05E9\05E0\05D9\05EA\05DF \05DC\05D7\05D5\05D5\05EA \05D0\05D5\05EA\05D4 \05D1\05DE\05D9\05D8\05D1\05D4 \05D1\05D3\05E4\05D3\05E4\05DF Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>Share</strong> (\05E9\05EA\05E3) \05D1\05E0\05D9\05D5\05D5\05D8 \05D4\05EA\05D7\05EA\05D5\05DF</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \05D4\05E7\05E9 \05E2\05DC <strong>Open in Safari</strong></p> (\05E4\05EA\05D7 \05D1-Safari)'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150572192399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD. \05D4\05D5\05E1\05E3 \05D0\05D5\05EA\05D4 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA \05E9\05DC\05DA \05DC\05E7\05D1\05DC\05EA \05D4\05D7\05D5\05D5\05D9\05D4 \05D4\05DE\05D9\05D8\05D1\05D9\05EA.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>Share</strong> (\05E9\05EA\05E3) \05E9\05DC\05D9\05D3 \05E9\05D5\05E8\05EA \05D4\05DB\05EA\05D5\05D1\05EA</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \05D4\05E7\05E9 \05E2\05DC <strong>Add to Home Screen</strong></p> (\05D4\05D5\05E1\05E3 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA)'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \05D4\05E7\05E9 \05E2\05DC <strong style="color:#007AE1;">Add</strong> (\05D4\05D5\05E1\05E3) \05DB\05D3\05D9 \05DC\05D0\05E9\05E8</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150428345399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD. \05D4\05D5\05E1\05E3 \05D0\05D5\05EA\05D4 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA \05E9\05DC\05DA \05DC\05E7\05D1\05DC\05EA \05D4\05D7\05D5\05D5\05D9\05D4 \05D4\05DE\05D9\05D8\05D1\05D9\05EA.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>Share</strong> (\05E9\05EA\05E3) \05D1\05E0\05D9\05D5\05D5\05D8 \05D4\05EA\05D7\05EA\05D5\05DF</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \05D2\05DC\05D5\05DC \05DE\05D8\05D4 \05D5\05D4\05E7\05E9 \05E2\05DC <strong>Add to Home Screen</strong></p> (\05D4\05D5\05E1\05E3 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA)'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \05D4\05E7\05E9 \05E2\05DC <strong style="color:#007AE1;">Add</strong> (\05D4\05D5\05E1\05E3) \05DB\05D3\05D9 \05DC\05D0\05E9\05E8</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145491078399936)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD. \05D4\05D5\05E1\05E3 \05D0\05D5\05EA\05D4 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA \05E9\05DC\05DA \05DC\05E7\05D1\05DC\05EA \05D4\05D7\05D5\05D5\05D9\05D4 \05D4\05DE\05D9\05D8\05D1\05D9\05EA.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>More</strong> (\05E2\05D5\05D3) \05E9\05DC\05D9\05D3 \05E9\05D5\05E8\05EA \05D4\05DB\05EA\05D5\05D1\05EA</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \05D4\05E7\05E9 \05E2\05DC <strong>Add to Home Screen</strong></p> (\05D4\05D5\05E1\05E3 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA)'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \05D4\05E7\05E9 \05E2\05DC <strong style="color:#007AE1;">Add</strong> (\05D4\05D5\05E1\05E3) \05DB\05D3\05D9 \05DC\05D0\05E9\05E8</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150796959399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD. \05D4\05D5\05E1\05E3 \05D0\05D5\05EA\05D4 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA \05E9\05DC\05DA \05DC\05E7\05D1\05DC\05EA \05D4\05D7\05D5\05D5\05D9\05D4 \05D4\05DE\05D9\05D8\05D1\05D9\05EA.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>Share</strong> (\05E9\05EA\05E3) \05E9\05DC\05D9\05D3 \05E9\05D5\05E8\05EA \05D4\05DB\05EA\05D5\05D1\05EA</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\05D4\05E7\05E9 \05E2\05DC <strong>Open in Safari</strong></p> (\05E4\05EA\05D7 \05D1-Safari)'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150640293399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD. \05D4\05D5\05E1\05E3 \05D0\05D5\05EA\05D4 \05DC\05DE\05E1\05DA \05D4\05D1\05D9\05EA \05E9\05DC\05DA \05DC\05E7\05D1\05DC\05EA \05D4\05D7\05D5\05D5\05D9\05D4 \05D4\05DE\05D9\05D8\05D1\05D9\05EA.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\05D4\05E7\05E9 \05E2\05DC \05D4\05E1\05DE\05DC <strong>Share</strong> (\05E9\05EA\05E3) \05D1\05E0\05D9\05D5\05D5\05D8 \05D4\05EA\05D7\05EA\05D5\05DF</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\05D4\05E7\05E9 \05E2\05DC <strong>Open in Safari</strong></p> (\05E4\05EA\05D7 \05D1-Safari)'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151415875399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD \05E9\05E0\05D9\05EA\05DF \05DC\05D7\05D5\05D5\05EA \05D0\05D5\05EA\05D4 \05D1\05DE\05D9\05D8\05D1\05D4 \05D1\05D3\05E4\05D3\05E4\05DF Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \05D0\05D9\05E0\05D5 \05EA\05D5\05DE\05DA \05DB\05E8\05D2\05E2 \05D1\05D4\05EA\05E7\05E0\05D4 \05E9\05DC \05D9\05D9\05E9\05D5\05DE\05D9 \05D0\05D9\05E0\05D8\05E8\05E0\05D8.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112150938965399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD \05E9\05E0\05D9\05EA\05DF \05DC\05D7\05D5\05D5\05EA \05D0\05D5\05EA\05D4 \05D1\05DE\05D9\05D8\05D1\05D4 \05D1\05D3\05E4\05D3\05E4\05E0\05D9\05DD Chrome \05D0\05D5 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \05D0\05D9\05E0\05D5 \05EA\05D5\05DE\05DA \05DB\05E8\05D2\05E2 \05D1\05D4\05EA\05E7\05E0\05D5\05EA \05E9\05DC \05D9\05D9\05E9\05D5\05DE\05D9 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05E2\05DC macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151065206399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD \05E9\05E0\05D9\05EA\05DF \05DC\05D7\05D5\05D5\05EA \05D0\05D5\05EA\05D4 \05D1\05DE\05D9\05D8\05D1\05D4 \05D1\05D3\05E4\05D3\05E4\05E0\05D9\05DD Chrome \05D0\05D5 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari \05D0\05D9\05E0\05D5 \05EA\05D5\05DE\05DA \05DB\05E8\05D2\05E2 \05D1\05D4\05EA\05E7\05E0\05D5\05EA \05E9\05DC \05D9\05D9\05E9\05D5\05DE\05D9 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05E2\05DC macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151337422399940)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\05DC\05D0\05EA\05E8 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05D6\05D4 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05E0\05DC\05D9\05D5\05EA \05D9\05D9\05E9\05D5\05DD \05E9\05E0\05D9\05EA\05DF \05DC\05D7\05D5\05D5\05EA \05D0\05D5\05EA\05D4 \05D1\05DE\05D9\05D8\05D1\05D4 \05D1\05D3\05E4\05D3\05E4\05E0\05D9\05DD Chrome \05D0\05D5 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \05D0\05D9\05E0\05D5 \05EA\05D5\05DE\05DA \05DB\05E8\05D2\05E2 \05D1\05D4\05EA\05E7\05E0\05D4 \05E9\05DC \05D9\05D9\05E9\05D5\05DE\05D9 \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05E2\05DC Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153899962399942)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05EA\05D7\05D1\05E8</h1>'),
unistr('    <p>\05D3\05E8\05D5\05E9 \05DC\05DA \05D7\05D9\05D1\05D5\05E8 \05DC\05D0\05D9\05E0\05E8\05D8\05E0\05D8 \05DB\05D3\05D9 \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05D9\05D9\05E9\05D5\05DD \05D6\05D4.</p>'),
unistr('    <button type="button">\05E0\05E1\05D4 \05E9\05D5\05D1</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153723925399942)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05EA\05D7\05D1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293519199400043)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237920717400003)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D5\05DD \05E9\05DC\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316874614400060)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D7 \05D4\05D6\05DE\05E0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316693619400060)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239785727400005)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05D4 \05D9\05D5\05DE\05D9\05EA \05DC\05DB\05DC \05D4\05D9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239520357400004)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05D4 \05D9\05D5\05DE\05D9\05EA \05DC\05E0\05EA\05D5\05E0\05D9\05DD \05E2\05DD \05D6\05DE\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284447145400037)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278824296400033)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D9\05D0\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169411504399953)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'he'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169237471399953)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'he'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169132539399953)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'he'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169362413399953)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'he'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168849266399953)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA \05E1\05D9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169060342399953)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05D0\05D9\05E8\05D5\05E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316722066400060)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D6\05DE\05E0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284588765400037)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284228240400036)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287074072400038)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301370298400049)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05DC\05D0 \05D0\05D9\05E8\05D5\05E2\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317055714400060)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05D0\05D9\05E8\05D5\05E2 \05E7\05D9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316997023400060)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D9\05D7\05EA \05D4\05D6\05DE\05E0\05D4 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287153100400039)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295112708400044)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D7 \05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294941527400044)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D7 \05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317726750400061)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC \05D4\05E9\05D3\05D5\05EA \05D3\05E8\05D5\05E9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317662247400061)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D7 \05D4\05D6\05DE\05E0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316543384400060)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E0\05D5\05E9\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295066019400044)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168980111399953)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA \05D4\05EA\05D7\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292833481400043)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05D5\05E4\05E1 \05E2\05DC %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239365154400004)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'he'
,p_message_text=>unistr('\05D6\05DE\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287208722400039)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285050108400037)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284375973400037)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239605458400004)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05D4 \05E9\05D1\05D5\05E2\05D9\05EA \05DC\05DB\05DC \05D4\05D9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239487711400004)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05D4 \05E9\05D1\05D5\05E2\05D9\05EA \05DC\05E0\05EA\05D5\05E0\05D9\05DD \05E2\05DD \05D6\05DE\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284914580400037)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284638671400037)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284762546400037)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05DF \05E2\05D5\05D3...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216812047399988)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163173520399949)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05DF \05E2\05D5\05D3...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165289822399950)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112284816429400037)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05DF \05E2\05D5\05D3...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286917484400038)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05D0\05D6\05D5\05E8 %0 \05DC\05D0 \05E0\05DE\05E6\05D0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165173312399950)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05E0\05EA\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189296353399968)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D0\05E4\05E1 \05D0\05EA \05E2\05D9\05DE\05D5\05D3 \05D4\05D0\05D6\05D5\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157451978399945)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05D4\05D2\05D3\05E8\05EA \05E2\05D9\05DE\05D5\05D3 \05D4\05D0\05D6\05D5\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278298143400032)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286866657400038)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D0\05D6\05D5\05E8 %0 \05DC\05D0 \05E0\05EA\05DE\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157327152399945)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05D6\05DE\05DF \05D4\05E6\05D2\05EA \05D4\05D0\05D6\05D5\05E8 "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221881745399992)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('#COLUMN_HEADER# \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05E2\05DD \05E2\05E8\05DA \05DB\05DC\05E9\05D4\05D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316107645400060)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('%0, \05E2\05D5\05E8\05DA \05D8\05E7\05E1\05D8 \05E2\05E9\05D9\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223986130399993)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D2\05D9\05EA HTML \05E9\05DC \05D8\05E7\05E1\05D8 \05E2\05E9\05D9\05E8 \05D7\05D5\05E8\05D2\05EA \05DE\05D4\05D0\05D5\05E8\05DA \05D4\05DE\05E8\05D1\05D9 \05E9\05DC \05D4\05E4\05E8\05D9\05D8 (\05D1\05E4\05D5\05E2\05DC %0, \05DE\05D5\05EA\05E8 %1 \05EA\05D5\05D5\05D9\05DD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283832190400036)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275661527400030)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DB\05E4\05DC')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273967623400029)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05DE\05D5\05E6\05D2\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273883321400029)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05DC\05DB\05DC\05D5\05DC \05E2\05E8\05DB\05D9 Null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283994388400036)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237544396400003)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8 \05DC\05DE\05D8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237628565400003)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8 \05DC\05DE\05E2\05DC\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273627394400029)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274241738400029)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05D0\05D7\05E8\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273768895400029)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274001719400029)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274167477400029)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 %0 \05DE\05EA\05D5\05DA %1 ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275786384400030)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E2\05E0\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275856530400030)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D8\05DC \05E9\05D9\05E0\05D5\05D9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112273592577400029)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E4\05E8\05D9\05D8 \05D4\05D2\05D3\05E8\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234520453400001)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D3\05D5\05D2\05DE\05D4, %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142063972399933)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D7\05D1\05E8 \05E9\05D5\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141933527399933)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 \05E9\05DC\05DA \05D4\05E1\05EA\05D9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142121723399933)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05D7\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141729942399933)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E9\05D1 \05D4\05E2\05D1\05D5\05D3\05D4 \05E9\05DC\05DA \05D9\05E1\05EA\05D9\05D9\05DD \05D1-%0. \05D4\05D0\05DD \05EA\05E8\05E6\05D4 \05DC\05D4\05D0\05E8\05D9\05DA \05D0\05D5\05EA\05D5?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141871942399933)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E9\05D1 \05D4\05E2\05D1\05D5\05D3\05D4 \05E9\05DC\05DA \05D9\05E1\05EA\05D9\05D9\05DD \05D1-%0 \05D5\05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05D0\05E8\05D9\05DA \05D0\05D5\05EA\05D5. \05E9\05DE\05D5\05E8 \05D0\05EA \05DB\05DC \05D4\05E2\05D1\05D5\05D3\05D4 \05E2\05DB\05E9\05D9\05D5 \05DB\05D3\05D9 \05DC\05D4\05D9\05DE\05E0\05E2 \05DE\05D0\05D5\05D1\05D3\05DF \05E0\05EA\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294717425400044)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05E7\05D5\05D3 \05E0\05D9\05E7\05D5\05D9 \05DB\05DC\05DC\05D9 \05E9\05DC \05DE\05D5\05E9\05D1 \05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187846072399967)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05E7\05D5\05D3 \05D4\05D4\05E7\05DE\05D4 \05E9\05DC \05DE\05D5\05E9\05D1 \05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112161919293399948)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 \05E9\05DC\05DA \05D4\05E1\05EA\05D9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293691958400043)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D2\05D5\05E8 \05EA\05D9\05D1\05EA \05D3\05D5-\05E9\05D9\05D7 \05D6\05D5 \05D5\05DC\05D7\05E5 \05E2\05DC \05DC\05D7\05E6\05DF \05D4\05D8\05E2\05D9\05E0\05D4 \05D4\05D7\05D5\05D6\05E8\05EA \05E9\05DC \05D4\05D3\05E4\05D3\05E4\05DF \05E9\05DC\05DA \05DB\05D3\05D9 \05DC\05E7\05D1\05DC \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 \05D7\05D3\05E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312933773400057)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D7\05E5 \05E2\05DC <a href="%0">\05DB\05D0\05DF</a> \05DB\05D3\05D9 \05DC\05D9\05E6\05D5\05E8 \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 \05D7\05D3\05E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199568998399975)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 \05DC\05D0 \05EA\05E7\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239021100400004)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D0\05E4\05E9\05E8 \05EA\05E4\05E7\05D9\05D3\05D9\05DD \05D3\05D9\05E0\05DE\05D9\05D9\05DD \05DB\05DC\05E9\05D4\05DD \05D1\05DE\05D5\05E9\05D1 \05E9\05DC Real Application Security \05DC\05DE\05E9\05EA\05DE\05E9 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185786337399965)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-99900 \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D9\05E6\05D5\05E8 \05DE\05D6\05D4\05D4 \05D9\05D9\05D7\05D5\05D3\05D9 \05E9\05DC \05DE\05D5\05E9\05D1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202093519399977)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05E8\05EA \05D4\05D4\05D2\05E0\05D4 \05E2\05DC \05DE\05E6\05D1 \05DE\05D5\05E9\05D1 \05D4\05E2\05D1\05D5\05D3\05D4. \05D4\05E1\05D9\05D1\05D4 \05DC\05DB\05DA \05D9\05DB\05D5\05DC\05D4 \05DC\05D4\05D9\05D5\05EA \05E9\05D9\05E0\05D5\05D9 \05D9\05D3\05E0\05D9 \05E9\05DC \05E4\05E8\05D9\05D8 %0 \05E9\05DC \05D3\05E3 \05DE\05D5\05D2\05DF. \05D0\05DD \05D0\05EA\05D4 \05DC\05D0 \05D1\05D8\05D5\05D7 \05DE\05D4 \05D2\05E8\05DD \05DC\05E9\05D2\05D9\05D0\05D4 \05D6\05D5, \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF \05D4\05D9\05D9\05E9\05D5\05DD \05DC\05E2\05D6\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321158185400063)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05E8\05D4 \05E9\05DC \05D4\05D2\05E0\05EA \05D3\05E3. \05D4\05E1\05D9\05D1\05D4 \05DC\05DB\05DA \05D9\05DB\05D5\05DC\05D4 \05DC\05D4\05D9\05D5\05EA \05E9\05DC\05D9\05D7\05EA \05D3\05E3 \05E9\05D4\05D8\05E2\05D9\05E0\05D4 \05E9\05DC\05D5 \05DC\05D0 \05D4\05E1\05EA\05D9\05D9\05DE\05D4 \05D0\05D5 \05E9\05D9\05E0\05D5\05D9 \05D9\05D3\05E0\05D9 \05E9\05DC \05E4\05E8\05D9\05D8\05D9\05DD \05DE\05D5\05D2\05E0\05D9\05DD \05E9\05DC \05D4\05D3\05E3. \05DC\05E1\05D9\05D5\05E2 \05E0\05D5\05E1\05E3, \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF \05D4\05D9\05D9\05E9\05D5\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320101756400062)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05DB\05D9\05DC \05D0\05D7\05D3 \05DE\05D4\05EA\05D5\05D5\05D9\05DD \05D4\05D1\05DC\05EA\05D9 \05EA\05E7\05E4\05D9\05DD \05D4\05D1\05D0\05D9\05DD &<>"/;,*|=% \05D0\05D5 --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320221395400063)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05DB\05D9\05DC \05D0\05D7\05D3 \05DE\05D4\05EA\05D5\05D5\05D9\05DD \05D4\05D1\05DC\05EA\05D9 \05EA\05E7\05E4\05D9\05DD \05D4\05D1\05D0\05D9\05DD &<>"/;,*|=% \05D0\05D5 -- \05D0\05D5 \05E9\05D5\05E8\05D4 \05D7\05D3\05E9\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319931583400062)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05DB\05D9\05DC \05EA\05D5\05D5\05D9\05DD \05DE\05D9\05D5\05D7\05D3\05D9\05DD. \05DE\05D5\05EA\05E8\05D9\05DD \05E8\05E7 \05D4\05EA\05D5\05D5\05D9\05DD a-Z, 0-9 \05D5\05E8\05D5\05D5\05D7\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112320032007400062)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05DB\05D9\05DC <, > \05D0\05D5 " \05E9\05D4\05DD \05EA\05D5\05D5\05D9\05DD \05D1\05DC\05EA\05D9 \05EA\05E7\05E4\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164164013399950)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E1\05E8 \05E2\05E8\05DA \05E1\05D9\05DB\05D5\05DD \05D1\05D9\05E7\05D5\05E8\05EA (checksum) \05DB\05D3\05D9 \05DC\05D4\05E8\05D0\05D5\05EA \05E2\05D9\05D1\05D5\05D3 \05E9\05DC \05D3\05E3 \05E9\05D3\05D5\05E8\05E9 \05E2\05E8\05DA \05E1\05D9\05DB\05D5\05DD \05D1\05D9\05E7\05D5\05E8\05EA \05DB\05D0\05E9\05E8 \05E2\05E8\05DA \05D0\05D7\05D3 \05D0\05D5 \05D9\05D5\05EA\05E8 \05E9\05DC \05D1\05E7\05E9\05D4, \05E0\05D9\05E7\05D5\05D9 \05DE\05D8\05DE\05D5\05DF \05D0\05D5 \05D0\05E8\05D2\05D5\05DE\05E0\05D8 \05DE\05D5\05E2\05D1\05E8\05D9\05DD \05DB\05E4\05E8\05DE\05D8\05E8\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196941977399973)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05E8\05EA \05D4\05D4\05D2\05E0\05D4 \05E2\05DC \05DE\05E6\05D1 \05DE\05D5\05E9\05D1 \05D4\05E2\05D1\05D5\05D3\05D4. \05D4\05E1\05D9\05D1\05D4 \05DC\05DB\05DA \05D9\05DB\05D5\05DC\05D4 \05DC\05D4\05D9\05D5\05EA \05E9\05D9\05E0\05D5\05D9 \05D9\05D3\05E0\05D9 \05E9\05DC URL \05D4\05DE\05DB\05D9\05DC \05E2\05E8\05DA \05E1\05D9\05DB\05D5\05DD \05D1\05D9\05E7\05D5\05E8\05EA (checksum) \05D0\05D5 \05E9\05D9\05DE\05D5\05E9 \05D1\05E7\05D9\05E9\05D5\05E8 \05E2\05DD \05E2\05E8\05DA \05E1\05D9\05DB\05D5\05DD \05D1\05D9\05E7\05D5\05E8\05EA \05E9\05D2\05D5\05D9 \05D0\05D5 \05D7\05E1\05E8. \05D0\05DD \05D0\05EA\05D4 \05DC\05D0 \05D1\05D8\05D5\05D7 \05DE\05D4 \05D2\05E8\05DD \05DC\05E9\05D2\05D9\05D0\05D4 \05D6\05D5, \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF \05D4\05D9\05D9\05E9\05D5\05DD \05DC\05E2\05D6\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112274910384400030)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8 \05DE\05E6\05D1 \05E0\05D9\05D2\05D5\05D3\05D9\05D5\05EA \05D2\05D1\05D5\05D4\05D4 \05DB''\05DB\05D1\05D5\05D9''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275049506400030)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8 \05DE\05E6\05D1 \05E0\05D9\05D2\05D5\05D3\05D9\05D5\05EA \05D2\05D1\05D5\05D4\05D4 \05DB''\05DE\05D5\05E4\05E2\05DC''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193619941399971)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D7\05EA\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193885801399971)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05DE\05D8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193973709399971)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194084189399971)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8 \05D4\05DB\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194102783399971)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194272579399971)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05D4\05DB\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194395916399971)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193562693399971)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DC\05D9\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193708864399971)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05DE\05E2\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302699539400050)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'he'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303316232400050)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-%0d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302575998400050)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'he'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303485300400050)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-%0h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302370059400050)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'he'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303521909400051)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-%0m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302974913400050)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'he'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303175440400050)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-%0mo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302456475400050)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'he'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303244668400050)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-%0s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302774446400050)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'he'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303608332400051)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-%0w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302884653400050)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'he'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112303005230400050)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-%0y')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142940770399934)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'he'
,p_message_text=>unistr('[\05E9\05D5\05E8\05D4]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143383807399934)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'he'
,p_message_text=>unistr('[\05E9\05D5\05E8\05D5\05EA \05E8\05D1\05D5\05EA]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143116646399934)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'he'
,p_message_text=>unistr('[\05E0\05E7\05D5\05D3\05D5\05EA \05E8\05D1\05D5\05EA]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143546141399934)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'he'
,p_message_text=>unistr('[\05DE\05E6\05D5\05DC\05E2\05D9\05DD \05E8\05D1\05D9\05DD]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143689502399935)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'he'
,p_message_text=>unistr('[\05D0\05D5\05D1\05D9\05D9\05E7\05D8 \05D2\05D9\05D0\05D5\05DE\05D8\05E8\05D9\05D4]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142807694399934)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'he'
,p_message_text=>unistr('[\05E0\05E7\05D5\05D3\05D4 (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143053502399934)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'he'
,p_message_text=>unistr('[\05DE\05E6\05D5\05DC\05E2]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220285842399990)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05D5\05E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220123012399990)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D7\05D6\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266674285400024)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D4 \05D3\05D9\05E8\05D5\05D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256501464400017)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05E0\05D5 \05D1\05D8\05D5\05D5\05D7 \05D4\05D3\05D9\05E8\05D5\05D2 \05D4\05EA\05E7\05E3 \05E9\05DC 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256672624400017)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D0\05D9\05E0\05D5 \05DE\05E1\05E4\05E8\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252791452400014)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05EA \05D4\05E6\05DC\05D7\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315808198400059)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315789306400059)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301403844400049)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E8\05D2\05DC \05DB\05DC\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316256466400060)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05D7\05D1 / \05DB\05D5\05D5\05E5 \05E0\05D9\05D5\05D5\05D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316390567400060)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05D7\05D1 / \05DB\05D5\05D5\05E5 \05E2\05DE\05D5\05D3\05EA \05E6\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225954444399995)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05D5\05D5\05D8 \05E8\05D0\05E9\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232938925400000)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D5\05DD \05D0\05D7\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232734517399999)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E2\05D4 \05D0\05D7\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233084201400000)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D9\05DE\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232819269400000)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05E2\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232685858399999)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D3\05E7\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233281958400000)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05D1\05D5\05E2\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112233167899400000)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2 \05D0\05D7\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319450057400062)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D7\05DC\05EA \05D3\05E3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181437543399962)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155238087399943)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05D1\05E7\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234688156400001)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D3\05E8\05E9 \05E2\05E8\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317599775400061)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05EA\05DF \05DC\05D8\05E2\05D9\05E0\05D4 \05D4\05DE\05DC\05D0\05D4 \05E9\05DC \05D4\05D3\05E3 \05D5\05E0\05E1\05D4 \05E9\05D5\05D1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277793414400032)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 \05D6\05D4 \05DB\05D5\05DC\05DC \05E9\05D9\05E0\05D5\05D9\05D9\05DD \05E9\05DC\05D0 \05E0\05E9\05DE\05E8\05D5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158670266399946)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D7\05D5\05D1\05E8\05EA \05D4\05E2\05D1\05D5\05D3\05D4  \05D0\05D9\05DF \05D2\05D9\05DC\05D9\05D5\05DF \05E2\05D1\05D5\05D3\05D4 \05E4\05E2\05D9\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158591563399946)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05E8\05EA \05D4\05E2\05D1\05D5\05D3\05D4 \05DC\05D0 \05D0\05D5\05EA\05D7\05DC\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158471357399945)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E8\05E2\05D4 \05E9\05D2\05D9\05D0\05D4 \05E4\05E0\05D9\05DE\05D9\05EA \05D1\05E2\05EA \05D9\05E6\05D9\05E8\05EA \05E7\05D5\05D1\05E5 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160971859399947)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D9\05DC\05D9\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292668531400042)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E2\05D5\05DC\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210153213399983)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E4\05E8\05D9\05D8 \05E4\05E2\05D5\05DC\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205870268399980)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E4\05D5\05E0\05E7\05E6\05D9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205772599399980)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E2\05DE\05D5\05D3\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239994203400005)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E2\05DE\05D5\05D3\05EA \05E6\05D9\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240072020400005)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E1\05E3 \05E2\05DE\05D5\05D3\05EA \05E9\05D5\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180267839399961)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D9\05DE\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216334838399988)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D9\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197480146399974)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DE\05D5\05E6\05E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201764521399977)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197507124399974)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05D1\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197763720399974)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E6\05D9\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197620621399974)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05E2\05E8\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197336419399974)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D5\05DD %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198453445399974)
,p_name=>'APEXIR_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DB\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179599272399961)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC \05D4\05E2\05DE\05D5\05D3\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162021153399948)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC \05D4\05E9\05D5\05E8\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289626487400040)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05DC\05D5\05E4\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291204414400041)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05D7\05DC\05D5\05E4\05D9\05EA: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192140023399970)
,p_name=>'APEXIR_AND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D5\05D2\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181606671399962)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175384385399958)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194903171399972)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DB\05D5\05DF \05DC-%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291808241400042)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DE\05D5\05E6\05E2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283204769400036)
,p_name=>'APEXIR_BAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181095608399962)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174129729399957)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D1\05E2 \05E8\05E7\05E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176043308399958)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D7\05D5\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207703464399981)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D7\05EA\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176682844399959)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D8\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182570836399963)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D8\05D2\05D5\05E8\05D9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174093497399957)
,p_name=>'APEXIR_CELL'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198369109399974)
,p_name=>'APEXIR_CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E8\05E9\05D9\05DD')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208676292399982)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D0\05EA\05D7\05DC...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112244967205400008)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05EA\05D5\05D5\05D9\05EA \05EA\05E8\05E9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257352987400017)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05D0\05D9\05DC\05EA\05D0 \05D7\05D5\05E8\05D2\05EA \05DE\05D4\05DE\05E1\05E4\05E8 \05D4\05DE\05E8\05D1\05D9 \05E9\05DC %0 \05E0\05E7\05D5\05D3\05D5\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05DC\05DB\05DC \05EA\05E8\05E9\05D9\05DD. \05D4\05D7\05DC \05DE\05E1\05E0\05DF \05DB\05D3\05D9 \05DC\05E6\05DE\05E6\05DD \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05E9\05DC\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256250208400016)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05E8\05D1\05D9 \05DC\05E9\05D0\05D9\05DC\05EA\05EA \05EA\05E8\05E9\05D9\05DD \05DE\05D2\05D1\05D9\05DC \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1, \05D5\05DC\05D0 \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA. \05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05D7\05D5\05E8\05D2\05EA \05DE\05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05E8\05D1\05D9 \05E9\05DC %0. \05D4\05D7\05DC \05DE\05E1\05E0\05DF \05DB\05D3\05D9 \05DC\05E6\05DE\05E6\05DD \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05E9\05DC\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179631293399961)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05EA\05E8\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112252951361400014)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DE\05DF \05D4\05DB\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195391566399972)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E4\05D5\05E8\05DE\05D8 \05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202799977399978)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E7\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176575700399959)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213967222399986)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286222614400038)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05DF...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204743403399979)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E4\05E8\05D9\05D8 \05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208451917399982)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D8\05D9 \05E2\05DE\05D5\05D3\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288598271400040)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05D5\05D9\05EA \05E2\05DE\05D5\05D3\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206132888399980)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190202455399968)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05DB\05D9\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191155293399969)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 \05DE\05DB\05D9\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175094916399958)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191359402399969)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D1\05D0\05D7\05E8\05D5\05E0\05D5\05EA/\05D1\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199836492399975)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D1\05D1\05D0\05D5\05EA/\05D1\05D1\05D0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191298896399969)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D0\05D7\05E8\05D5\05E0\05D5\05EA/\05D1\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199761503399975)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D1\05D0\05D5\05EA/\05D1\05D1\05D0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174998268399957)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174851563399957)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D0 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174602697399957)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DE\05D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175121558399958)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 \05D1-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174739967399957)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05DB\05DE\05D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190503493399969)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05D0\05D9\05DD \05DC-Regular Expression')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195214285399972)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D9\05E9\05D5\05D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112255952672400016)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9 \05D7\05D9\05E9\05D5\05D1\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214278137399986)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D5\05E8 \05D7\05D9\05E9\05D5\05D1 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05DB\05D9\05E0\05D5\05D9\05D9 \05E2\05DE\05D5\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214391327399986)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'he'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214425569399986)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'he'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214593426399986)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'he'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160427473399947)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'he'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199194893399975)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E9\05D1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206707812399981)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'he'
,p_message_text=>'Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209753844399983)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'he'
,p_message_text=>'Control Breaks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294164470400044)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA Control Break')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157553305399945)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05EA \05E0\05D1\05D3\05DC\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292353850400042)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05EA \05E0\05D1\05D3\05DC\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292297780400042)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05D4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264353337400022)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D5\05DE\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319056961400062)
,p_name=>'APEXIR_DATA'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05EA\05D5\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208581256399982)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05EA\05D5\05E0\05D9 \05D4\05D3\05D5\05D7 \05E0\05DB\05D5\05DF \05DC\05DC\05E4\05E0\05D9 %0 \05D3\05E7\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282006650400035)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05E1\05E8\05D9\05D2 \05E0\05EA\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180319783399961)
,p_name=>'APEXIR_DATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212406813399985)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289407171400040)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E9\05DC \05E1\05D5\05D2 \05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176737619399959)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180681752399962)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D0\05DD \05EA\05E8\05E6\05D4 \05DC\05DE\05D7\05D5\05E7 \05D4\05D2\05D3\05E8\05D5\05EA \05D3\05D5\05D7 \05D0\05DC\05D5?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275337073400030)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D0\05DD \05DC\05DE\05D7\05D5\05E7 \05D0\05EA \05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05E9\05DC \05D3\05D5\05D7?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206407428399980)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05E7 \05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175485842399958)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182634862399963)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D9\05D0\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204631154399979)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05EA \05E9\05D5\05E8\05D4 \05D1\05D5\05D3\05D3\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212913691399985)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D9\05D5\05D5\05DF %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213828012399986)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E1\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176252919399958)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E6\05D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179427223399961)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05DE\05D5\05E6\05D2\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212870526399985)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05D1\05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207693775399981)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05DE\05D8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199275095399975)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E8\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212785623399985)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05DC\05D4\05E6\05D9\05D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278781897400033)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D1\05E8 \05E7\05D9\05D9\05DE\05EA \05D4\05D3\05D2\05E9\05D4 \05E2\05DD \05D0\05D5\05EA\05D5 \05D4\05EA\05E0\05D0\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294362047400044)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05E6\05D9\05E8 \05DB\05E4\05D5\05DC\05D4. \05E8\05E9\05D9\05DE\05EA \05E2\05DE\05D5\05D3\05D5\05EA \05D4\05E6\05D9\05E8 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05D9\05D5\05EA \05D9\05D9\05D7\05D5\05D3\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294528292400044)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208739343399982)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05D4\05D2\05D3\05E8\05D5\05EA \05EA\05E8\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215340089399987)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05EA\05E8\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215714355399987)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05DE\05E1\05E0\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270114935400026)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05E7\05D1\05D5\05E6\05D4 \05DC\05E4\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215603370399987)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05D4\05D3\05D2\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240291009400005)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA \05E6\05D9\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289745945400040)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168449486399953)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05EA\05D5\05D1\05EA \05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290044115400041)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D5\05EA\05E7 \05E0\05E1\05EA\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290271190400041)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D5\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289926776400041)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D5\05EA\05E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290738953400041)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D3\05D9\05E8\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172113535399955)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05E8\05EA \05D4\05D3\05D5\05D0"\05DC \05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D4 \05DC\05D9\05D9\05E9\05D5\05DD \05D6\05D4. \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF \05D4\05DE\05E2\05E8\05DB\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263657584400022)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05DB\05EA\05D5\05D1\05EA \05D3\05D5\05D0"\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290331003400041)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D9\05D9\05DF \05D1\05DE\05E1\05DE\05DA \05D4\05DE\05E6\05D5\05E8\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290122630400041)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E0\05D5\05E9\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264659455400022)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E0\05D5\05E9\05D0 \05D4\05D3\05D5\05D0"\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289840888400040)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173801930399957)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215586763399987)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8/\05D1\05D8\05DC \05D0\05E4\05E9\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215041594399987)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214631143399986)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D2\05DE\05D0\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215472303399987)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D2\05DE\05D0\05D5\05EA:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179305464399961)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05DC\05DB\05DC\05D5\05DC \05E2\05E8\05DB\05D9 Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216009946399987)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05D7\05D1/\05DB\05D5\05D5\05E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213675392399986)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198791437399975)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E0\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209661412399983)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219942552399990)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9 \05E1\05D9\05E0\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316420171400060)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9 \05D4\05DE\05E1\05E0\05DF \05D0\05E8\05D5\05DA \05DE\05D3\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219894660399990)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05DE\05E1\05E0\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216243712399987)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05D7\05D9\05E4\05D5\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199031149399975)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05DC\05D0\05E9\05D1\05E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213456635399985)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D0\05D9\05DC\05EA\05EA \05E4\05DC\05D0\05E9\05D1\05E7 \05DE\05D0\05E4\05E9\05E8\05EA \05DC\05DA \05DC\05D4\05E6\05D9\05D2 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DB\05E4\05D9 \05E9\05D4\05DD \05D4\05D9\05D5 \05D1\05E0\05E7\05D5\05D3\05EA \05D6\05DE\05DF \05E7\05D5\05D3\05DE\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264028115400022)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05DA \05D4\05E4\05DC\05D0\05E9\05D1\05E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265428667400023)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E8\05DE\05D8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195119854399972)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05DB\05EA \05E4\05D5\05E8\05DE\05D8 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206322161399980)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E0\05E7\05E6\05D9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214114806399986)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E0\05E7\05E6\05D9\05D5\05EA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289365291400040)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E0\05E7\05E6\05D9\05D5\05EA / \05D0\05D5\05E4\05E8\05D8\05D5\05E8\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206059534399980)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E0\05E7\05E6\05D9\05D4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198562629399975)
,p_name=>'APEXIR_GO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05E6\05D5\05E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174314389399957)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05E8\05D5\05E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112157681424399945)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D1\05E5 \05DC\05E4\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290497874400041)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'' %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245000572400008)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E2\05DE\05D5\05D3\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256179767400016)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05E8\05D1\05D9 \05DC\05E9\05D0\05D9\05DC\05EA\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'' \05DE\05D2\05D1\05D9\05DC \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1, \05D5\05DC\05D0 \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA. \05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05D7\05D5\05E8\05D2\05EA \05DE\05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05E8\05D1\05D9 \05E9\05DC %0. \05D4\05D7\05DC \05DE\05E1\05E0\05DF \05DB\05D3\05D9 \05DC\05E6\05DE\05E6\05DD \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05E9\05DC\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236769708400002)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D5\05DF \05E9\05DC ''\05E7\05D1\05E5 \05DC\05E4\05D9''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294280297400044)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D3\05E8 \05DE\05D9\05D5\05DF \05E9\05DC ''\05E7\05D1\05E5 \05DC\05E4\05D9''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179764638399961)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4 \05D0\05D5\05E4\05E7\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211398462399984)
,p_name=>'APEXIR_HELP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203165938399978)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05D3\05D5\05D7\05D5\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05D9\05DD \05DE\05D0\05E4\05E9\05E8\05D9\05DD \05DC\05DE\05E9\05EA\05DE\05E9\05D9 \05E7\05E6\05D4 \05DC\05D1\05E6\05E2 \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05E9\05DC \05D3\05D5\05D7\05D5\05EA. \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05E9\05E0\05D5\05EA \05D0\05EA \05D4\05DE\05EA\05D5\05D5\05D4 \05E9\05DC \05E0\05EA\05D5\05E0\05D9 \05D3\05D5\05D7 \05E2\05DC-\05D9\05D3\05D9 \05D1\05D7\05D9\05E8\05EA \05E2\05DE\05D5\05D3\05D5\05EA, \05D4\05D7\05DC\05EA \05DE\05E1\05E0\05E0\05D9\05DD, \05D4\05D3\05D2\05E9\05D4 \05D5\05DE\05D9\05D5\05DF. \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05D2\05DD \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05E2\05D1\05E8\05D9\05DD, \05E1\05DB\05D9\05DE\05D5\05EA, \05EA\05E8\05E9\05D9\05DE\05D9\05DD \05D5\05DE\05D9\05D5\05E0\05D9 ''\05E7\05D1\05E5 \05DC\05E4\05D9'', \05D5\05DC\05D4\05D5\05E1\05D9\05E3 \05D7\05D9\05E9\05D5\05D1\05D9\05DD \05DE\05E9\05DC \05E2\05E6\05DE\05DD.')
||unistr(' \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05D2\05DD \05DC\05D4\05E7\05D9\05DD \05DE\05E0\05D5\05D9 \05DB\05D3\05D9 \05E9\05D2\05E8\05E1\05EA HTML \05E9\05DC \05D4\05D3\05D5\05D7 \05EA\05D9\05E9\05DC\05D7 \05D0\05DC\05D9\05D4\05DD \05D1\05D3\05D5\05D0"\05DC \05D1\05DE\05E8\05D5\05D5\05D7\05D9 \05D6\05DE\05DF \05DE\05D5\05D2\05D3\05E8\05D9\05DD. \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05D9\05E6\05D5\05E8 \05DE\05E1\05E4\05E8 \05D5\05E8\05D9\05D0\05E6\05D9\05D5\05EA \05E9\05DC \05D3\05D5\05D7 \05D5\05DC\05E9\05DE\05D5\05E8 \05D0\05D5\05EA\05DF \05DB\05D3\05D5\05D7\05D5\05EA \05E9\05DE\05D9\05D9\05DD, \05DC\05E6\05D5\05E8\05DA \05D4\05E6\05D2\05D4 \05E6\05D9\05D1\05D5\05E8\05D9\05EA \05D0\05D5 \05E4\05E8\05D8\05D9\05EA. '),
'<p/>',
unistr('\05D4\05E4\05E8\05E7\05D9\05DD \05D4\05D1\05D0\05D9\05DD \05DE\05E1\05DB\05DE\05D9\05DD \05D0\05EA \05D4\05D3\05E8\05DB\05D9\05DD \05E9\05D1\05D4\05DF \05EA\05D5\05DB\05DC \05DC\05D4\05EA\05D0\05D9\05DD \05D0\05D9\05E9\05D9\05EA \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9. \05DC\05E7\05D1\05DC\05EA \05DE\05D9\05D3\05E2 \05E0\05D5\05E1\05E3 \05E2\05D9\05D9\05DF \05D1\05E4\05E8\05E7 "Using Interactive Reports" (\05E9\05D9\05DE\05D5\05E9 \05D1\05D3\05D5\05D7\05D5\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05D9\05DD) \05D1\05DE\05D3\05E8\05D9\05DA <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210200342399983)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E4\05E8\05D9\05D8 \05D4\05E4\05E2\05D5\05DC\05D5\05EA \05DE\05D5\05E4\05D9\05E2 \05DE\05E6\05D3 \05D9\05DE\05D9\05DF \05E9\05DC \05DC\05D7\05E6\05DF \05D4\05D1\05D9\05E6\05D5\05E2 \05D1\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9. \05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05E4\05E8\05D9\05D8 \05D6\05D4 \05DB\05D3\05D9 \05DC\05D4\05EA\05D0\05D9\05DD \05D0\05D9\05E9\05D9\05EA \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203976841399979)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E1\05DB\05D9\05DE\05D5\05EA \05D4\05DF \05D7\05D9\05E9\05D5\05D1\05D9\05DD \05DE\05EA\05DE\05D8\05D9\05D9\05DD \05D4\05DE\05D1\05D5\05E6\05E2\05D9\05DD \05DB\05E0\05D2\05D3 \05E2\05DE\05D5\05D3\05D4. \05E1\05DB\05D9\05DE\05D5\05EA \05DE\05D5\05E6\05D2\05D5\05EA \05DC\05D0\05D7\05E8 \05DB\05DC Control Break \05D5\05D1\05E1\05D5\05E3 \05D4\05D3\05D5\05D7 \05D1\05EA\05D5\05DA \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05D1\05D4 \05D4\05D5\05D2\05D3\05E8\05D5. \05D4\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05D4\05DF:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\05E1\05DB\05D9\05DE\05D4</strong> \05DE\05D0\05E4\05E9\05E8\05EA \05DC\05DA \05DC\05D1\05D7\05D5\05E8 \05E1\05DB\05D9\05DE\05D4'),
unistr('\05E9\05D4\05D5\05D2\05D3\05E8\05D4 \05D1\05E2\05D1\05E8 \05D5\05DC\05E2\05E8\05D5\05DA \05D0\05D5\05EA\05D4.</li>'),
unistr('<li><strong>\05E4\05D5\05E0\05E7\05E6\05D9\05D4</strong> \05D4\05D9\05D0 \05D4\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05E9\05D9\05E9 \05DC\05D1\05E6\05E2 (\05DC\05D3\05D5\05D2\05DE\05D4, SUM, MIN).</li>'),
unistr('<li><strong>\05E2\05DE\05D5\05D3\05D4</strong> \05DE\05E9\05DE\05E9\05EA \05DC\05D1\05D7\05D9\05E8\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05E2\05DC\05D9\05D4 \05EA\05D7\05D5\05DC \05D4\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05D4\05DE\05EA\05DE\05D8\05D9\05EA. \05DE\05D5\05E6\05D2\05D5\05EA'),
unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05DE\05E1\05E4\05E8\05D9\05D5\05EA \05D1\05DC\05D1\05D3.</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204058919399979)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05EA\05D5\05DB\05DC \05DC\05D4\05D2\05D3\05D9\05E8 \05EA\05E8\05E9\05D9\05DD \05D0\05D7\05D3 \05DC\05DB\05DC \05D3\05D5\05D7 \05E9\05DE\05D5\05E8. \05DC\05D0\05D7\05E8 \05E9\05D4\05D5\05D0'),
unistr('\05D4\05D5\05D2\05D3\05E8, \05EA\05D5\05DB\05DC \05DC\05D4\05D7\05DC\05D9\05E3 \05D1\05D9\05DF \05EA\05E6\05D5\05D2\05EA \05D4\05EA\05E8\05E9\05D9\05DD \05D5\05EA\05E6\05D5\05D2\05D5\05EA \05D4\05D3\05D5\05D7 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05E1\05DE\05DC\05D9 \05D4\05EA\05E6\05D5\05D2\05D4 \05D1\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9.'),
unistr('\05D4\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05D4\05DF: '),
'<p>',
'</p><ul>',
unistr('<li><strong>\05E1\05D5\05D2 \05EA\05E8\05E9\05D9\05DD</strong> \05DE\05D6\05D4\05D4 \05D0\05EA \05E1\05D5\05D2 \05D4\05EA\05E8\05E9\05D9\05DD \05E9\05D9\05E9 \05DC\05DB\05DC\05D5\05DC.'),
unistr('\05D1\05D7\05E8 \05D1\05D9\05DF \05E2\05DE\05D5\05D3\05D5\05EA \05D0\05D5\05E4\05E7\05D9\05D5\05EA, \05E2\05DE\05D5\05D3\05D5\05EA \05D0\05E0\05DB\05D9\05D5\05EA, \05EA\05E8\05E9\05D9\05DD \05E2\05D5\05D2\05D4 \05D0\05D5 \05E7\05D5.</li>'),
unistr('<li><strong>\05EA\05D5\05D5\05D9\05EA</strong> \05DE\05D0\05E4\05E9\05E8\05EA \05DC\05DA \05DC\05D1\05D7\05D5\05E8 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05EA\05E9\05DE\05E9 \05DB\05EA\05D5\05D5\05D9\05EA.</li>'),
unistr('<li><strong>\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05DC\05EA\05D5\05D5\05D9\05EA</strong> \05D4\05D9\05D0 \05D4\05DB\05D5\05EA\05E8\05EA \05D4\05DE\05D5\05E6\05D2\05EA \05E2\05DC \05D4\05E6\05D9\05E8 \05D4\05E7\05E9\05D5\05E8 \05DC\05E2\05DE\05D5\05D3\05D4 \05E9\05E0\05D1\05D7\05E8\05D4'),
unistr('\05DC\05EA\05D5\05D5\05D9\05EA. \05D6\05D4 \05DC\05D0 \05D6\05DE\05D9\05DF \05DC\05EA\05E8\05E9\05D9\05DD \05E2\05D5\05D2\05D4.</li>'),
unistr('<li><strong>\05E2\05E8\05DA</strong> \05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D1\05D7\05D5\05E8 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05EA\05E9\05DE\05E9 \05DB\05E2\05E8\05DA. \05D0\05DD \05D4\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05E9\05DC\05DA'),
unistr('\05D4\05D9\05D0 COUNT, \05D0\05D9\05DF \05E6\05D5\05E8\05DA \05DC\05D1\05D7\05D5\05E8 \05E2\05E8\05DA.</li>'),
unistr('<li><strong>\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05DC\05E2\05E8\05DA</strong> \05D4\05D9\05D0 \05D4\05DB\05D5\05EA\05E8\05EA \05D4\05DE\05D5\05E6\05D2\05EA \05E2\05DC \05D4\05E6\05D9\05E8 \05D4\05E7\05E9\05D5\05E8 \05DC\05E2\05DE\05D5\05D3\05D4 \05E9\05E0\05D1\05D7\05E8\05D4'),
unistr('\05DC\05E2\05E8\05DA. \05D6\05D4 \05DC\05D0 \05D6\05DE\05D9\05DF \05DC\05EA\05E8\05E9\05D9\05DD \05E2\05D5\05D2\05D4.</li>'),
unistr('<li><strong>\05E4\05D5\05E0\05E7\05E6\05D9\05D4</strong> \05D4\05D9\05D0 \05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05D0\05D5\05E4\05E6\05D9\05D5\05E0\05DC\05D9\05EA \05E9\05E0\05D9\05EA\05DF \05DC\05D4\05E4\05E2\05D9\05DC \05E2\05DC \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05E0\05D1\05D7\05E8\05D4 \05DC\05E2\05E8\05DA.</li>'),
unistr('<li><strong>\05DE\05D9\05D5\05DF</strong> \05DE\05D0\05E4\05E9\05E8\05EA \05DC\05DA \05DC\05DE\05D9\05D9\05DF \05D0\05EA \05E1\05DC \05D4\05EA\05D5\05E6\05D0\05D5\05EA.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203315071399978)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4 \05DB\05DC\05E9\05D4\05D9 \05D7\05D5\05E9\05E4\05EA \05EA\05E4\05E8\05D9\05D8 \05E9\05DC \05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4. \05D4\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05D4\05DF:'),
'<p></p>',
'<ul>',
unistr('<li>\05D4\05E1\05DE\05DC <strong>\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4</strong> \05DE\05DE\05D9\05D9\05DF \05D0\05EA \05D4\05D3\05D5\05D7 \05DC\05E4\05D9 \05D4\05E2\05DE\05D5\05D3\05D4 \05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4.</li>'),
unistr('<li>\05D4\05E1\05DE\05DC <strong>\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3</strong> \05DE\05DE\05D9\05D9\05DF \05D0\05EA \05D4\05D3\05D5\05D7 \05DC\05E4\05D9 \05D4\05E2\05DE\05D5\05D3\05D4 \05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3.</li>'),
unistr('<li><strong>\05D4\05E1\05EA\05E8 \05E2\05DE\05D5\05D3\05D4</strong> \05DE\05E1\05EA\05D9\05E8 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D4. \05DC\05D0 \05D0\05EA \05DB\05DC \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D0\05E4\05E9\05E8 \05DC\05D4\05E1\05EA\05D9\05E8. \05D0\05DD \05E2\05DE\05D5\05D3\05D4 \05D0\05D9\05E0\05D4 \05E0\05D9\05EA\05E0\05EA \05DC\05D4\05E1\05EA\05E8\05D4, \05DC\05D0 \05D9\05D5\05E4\05D9\05E2 \05E1\05DE\05DC ''\05D4\05E1\05EA\05E8 \05E2\05DE\05D5\05D3\05D4''.</li>'),
unistr('<li><strong>\05E2\05DE\05D5\05D3\05EA \05E9\05D1\05D9\05E8\05D4</strong> \05D9\05D5\05E6\05E8 \05E7\05D1\05D5\05E6\05EA \05E9\05D1\05D9\05E8\05D4 \05D1\05E2\05DE\05D5\05D3\05D4. \05D3\05D1\05E8 \05D6\05D4 \05DE\05D5\05E9\05DA \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05DE\05D7\05D5\05E5 \05DC\05D3\05D5\05D7 \05DB\05E8\05E9\05D5\05DE\05EA \05D0\05D1.</li>'),
unistr('<li><strong>\05E4\05E8\05D8\05D9 \05E2\05DE\05D5\05D3\05D4</strong> \05DE\05E6\05D9\05D2 \05D8\05E7\05E1\05D8 \05E2\05D6\05E8\05D4 \05E2\05DC \05D4\05E2\05DE\05D5\05D3\05D4, \05D0\05DD \05D9\05E9.</li>'),
unistr('<li><strong>\05D0\05D6\05D5\05E8 \05D8\05E7\05E1\05D8</strong> \05DE\05E9\05DE\05E9 \05DC\05D4\05D6\05E0\05EA \05E7\05E8\05D9\05D8\05E8\05D9\05D5\05E0\05D9 \05D7\05D9\05E4\05D5\05E9 \05E8\05D2\05D9\05E9\05D9\05DD \05DC\05D0\05D5\05EA\05D9\05D5\05EA \05E8\05D9\05E9\05D9\05D5\05EA'),
unistr('(\05D0\05D9\05DF \05E6\05D5\05E8\05DA \05D1\05EA\05D5\05D5\05D9\05DD \05DB\05DC\05DC\05D9\05D9\05DD). \05D4\05D6\05E0\05EA \05E2\05E8\05DA \05DE\05E6\05DE\05E6\05DE\05EA \05D0\05EA \05E8\05E9\05D9\05DE\05EA'),
unistr('\05D4\05E2\05E8\05DB\05D9\05DD \05D1\05EA\05D7\05EA\05D9\05EA \05D4\05EA\05E4\05E8\05D9\05D8. \05D0\05D6 \05EA\05D5\05DB\05DC \05DC\05D1\05D7\05D5\05E8 \05E2\05E8\05DA \05DE\05D4\05EA\05D7\05EA\05D9\05EA'),
unistr('\05D5\05D4\05E2\05E8\05DA \05E9\05D1\05D7\05E8\05EA \05D9\05D9\05D5\05D5\05E6\05E8 \05DB\05DE\05E1\05E0\05DF \05D1\05D0\05DE\05E6\05E2\05D5\05EA ''='''),
unistr('(\05DC\05D3\05D5\05D2\05DE\05D4, <code>\05E2\05DE\05D5\05D3\05D4 = ''ABC''</code>). \05DC\05D7\05DC\05D5\05E4\05D9\05DF, \05EA\05D5\05DB\05DC \05DC\05DC\05D7\05D5\05E5 \05E2\05DC \05E1\05DE\05DC \05D4\05E4\05E0\05E1 \05D5\05DC\05D4\05D6\05D9\05DF \05E2\05E8\05DA \05DB\05D3\05D9 \05DC\05D9\05E6\05D5\05E8 \05D0\05D5\05EA\05D5 \05DB\05DE\05E1\05E0\05DF \05E2\05DD \05DE\05E1\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9'),
unistr('''LIKE'' (\05DC\05D3\05D5\05D2\05DE\05D4, <code>\05E2\05DE\05D5\05D3\05D4 LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>\05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD \05D9\05D9\05D7\05D5\05D3\05D9\05D9\05DD</b> \05DE\05DB\05D9\05DC\05D4 \05D0\05EA 500 \05D4\05E2\05E8\05DB\05D9\05DD'),
unistr('\05D4\05E8\05D0\05E9\05D5\05E0\05D9\05DD \05E9\05E2\05D5\05E0\05D9\05DD \05E2\05DC \05E7\05E8\05D9\05D8\05E8\05D9\05D5\05E0\05D9 \05D4\05E1\05D9\05E0\05D5\05DF. \05D0\05DD \05D4\05E2\05DE\05D5\05D3\05D4 \05D4\05D9\05D0 \05EA\05D0\05E8\05D9\05DA, \05DE\05D5\05E6\05D2\05EA'),
unistr('\05D1\05DE\05E7\05D5\05DD \05D6\05D0\05EA \05E8\05E9\05D9\05DE\05D4 \05E9\05DC \05D8\05D5\05D5\05D7\05D9 \05EA\05D0\05E8\05D9\05DA. \05D0\05DD \05EA\05D1\05D7\05E8 \05E2\05E8\05DA, \05D9\05D9\05D5\05D5\05E6\05E8 \05DE\05E1\05E0\05DF'),
unistr('\05D1\05D0\05DE\05E6\05E2\05D5\05EA ''='' (\05DC\05D3\05D5\05D2\05DE\05D4, <code>\05E2\05DE\05D5\05D3\05D4 = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203877161399978)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D4\05D5\05E1\05D9\05E3 \05E2\05DE\05D5\05D3\05D5\05EA \05DE\05D7\05D5\05E9\05D1\05D5\05EA \05DC\05D3\05D5\05D7. \05D0\05DC\05D5 \05E2\05E9\05D5\05D9\05D9\05DD \05DC\05D4\05D9\05D5\05EA \05D7\05D9\05E9\05D5\05D1\05D9\05DD \05DE\05EA\05DE\05D8\05D9\05D9\05DD (\05DC\05D3\05D5\05D2\05DE\05D4, <code>NBR_HOURS/24</code>) \05D0\05D5 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05EA \05E1\05D8\05E0\05D3\05E8\05D8\05D9\05D5\05EA \05E9\05DC Oracle'),
unistr('\05D4\05D7\05DC\05D5\05EA \05E2\05DC \05E2\05DE\05D5\05D3\05D5\05EA \05E7\05D9\05D9\05DE\05D5\05EA. \05DB\05DE\05D4 \05DE\05D4\05DD \05DE\05D5\05E6\05D2\05D9\05DD \05DB\05D3\05D5\05D2\05DE\05D0\05D5\05EA \05D5\05E0\05D9\05EA\05DF \05DC\05D4\05E9\05EA\05DE\05E9 \05D2\05DD \05D1\05D0\05D7\05E8\05D9\05DD (\05DB\05DE\05D5 \05DC\05DE\05E9\05DC <code>TO_DATE)</code>. \05D4\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05D4\05DF:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\05D7\05D9\05E9\05D5\05D1</strong> \05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D1\05D7\05D5\05E8 \05D7\05D9\05E9\05D5\05D1 \05E9\05D4\05D5\05D2\05D3\05E8 \05D1\05E2\05D1\05E8 \05D5\05DC\05E2\05E8\05D5\05DA \05D0\05D5\05EA\05D5.</li>'),
unistr('<li><strong>\05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4</strong> \05D4\05D9\05D0 \05DB\05D5\05EA\05E8\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05DC \05D4\05E2\05DE\05D5\05D3\05D4 \05D4\05D7\05D3\05E9\05D4.</li>'),
unistr('<li><strong>\05DE\05E1\05DB\05EA \05EA\05D1\05E0\05D9\05EA</strong> \05D4\05D9\05D0 \05DE\05E1\05DB\05EA \05EA\05D1\05E0\05D9\05EA \05E9\05DC Oracle \05E9\05D9\05E9 \05DC\05D4\05D7\05D9\05DC \05E2\05DC \05D4\05E2\05DE\05D5\05D3\05D4 (\05DC\05D3\05D5\05D2\05DE\05D4,S9999).</li>'),
unistr('<li><strong>\05D7\05D9\05E9\05D5\05D1</strong> \05D4\05D5\05D0 \05D4\05D7\05D9\05E9\05D5\05D1 \05E9\05D9\05E9 \05DC\05D1\05E6\05E2. \05D1\05DE\05E1\05D2\05E8\05EA \05D4\05D7\05D9\05E9\05D5\05D1, \05D4\05D4\05E4\05E0\05D9\05D4 \05DC\05E2\05DE\05D5\05D3\05D5\05EA \05E0\05E2\05E9\05D9\05EA \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05DB\05D9\05E0\05D5\05D9\05D9\05DD \05D4\05DE\05D5\05E6\05D2\05D9\05DD.</li>'),
'</ul>',
unistr('<p>\05DE\05EA\05D7\05EA \05DC\05D7\05D9\05E9\05D5\05D1, \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05D0 \05E9\05DC\05DA \05DE\05D5\05E6\05D2\05D5\05EA \05E2\05DD'),
unistr('\05D4\05DB\05D9\05E0\05D5\05D9 \05D4\05E7\05E9\05D5\05E8 \05D0\05DC\05D9\05D4\05DF. \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05E9\05DD \05D0\05D5 \05E2\05DC \05DB\05D9\05E0\05D5\05D9 \05E9\05DC \05E2\05DE\05D5\05D3\05D4 \05D2\05D5\05E8\05DE\05EA'),
unistr('\05DC\05D4\05DB\05DC\05DC\05EA\05D4 \05D1\05D7\05D9\05E9\05D5\05D1. \05DC\05D9\05D3 \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D9\05E9 keypad. \05D4\05D5\05D0 \05E4\05D5\05E2\05DC'),
unistr('\05DB\05E7\05D9\05E6\05D5\05E8 \05D3\05E8\05DA \05DC\05DE\05E7\05E9\05D9\05DD \05D1\05E9\05D9\05DE\05D5\05E9 \05E0\05E4\05D5\05E5. \05D1\05E7\05E6\05D4 \05D4\05D9\05DE\05E0\05D9 \05D9\05E9 \05E4\05D5\05E0\05E7\05E6\05D9\05D5\05EA.</p>'),
unistr('<p>\05D3\05D5\05D2\05DE\05EA \05D4\05D7\05D9\05E9\05D5\05D1 \05D4\05D1\05D0\05D4 \05DE\05DE\05D7\05D9\05E9\05D4 \05DB\05D9\05E6\05D3 \05DC\05D4\05E6\05D9\05D2 \05E1\05D4"\05DB \05EA\05D2\05DE\05D5\05DC\05D9\05DD:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\05DB\05D0\05E9\05E8 A \05D4\05D5\05D0 \05D0\05E8\05D2\05D5\05DF, B \05D4\05D5\05D0 \05E9\05DB\05E8 \05D5\05D0\05D9\05DC\05D5 C \05D4\05D5\05D0 \05E2\05DE\05DC\05D4)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210332808399983)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05DE\05E9 \05DC\05D9\05E6\05D9\05E8\05EA \05E7\05D1\05D5\05E6\05EA \05E9\05D1\05D9\05E8\05D4 \05D1\05E2\05DE\05D5\05D3\05D4 \05D0\05D7\05EA \05D0\05D5 \05D9\05D5\05EA\05E8. \05D3\05D1\05E8 \05D6\05D4 \05DE\05D5\05E9\05DA \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D0\05DC \05DE\05D7\05D5\05E5 \05DC\05D3\05D5\05D7 \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9 \05D5\05DE\05E6\05D9\05D2 \05D0\05D5\05EA\05DF \05DB\05E8\05E9\05D5\05DE\05D4 \05D0\05D1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204556029399979)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D4\05E6\05D2\05EA \05E4\05E8\05D8\05D9 \05E9\05D5\05E8\05D4 \05D0\05D7\05EA \05D1\05DB\05DC \05E4\05E2\05DD, \05DC\05D7\05E5 \05E2\05DC \05E1\05DE\05DC \05D4\05EA\05E6\05D5\05D2\05D4 \05E9\05DC \05E9\05D5\05E8\05D4 \05D1\05D5\05D3\05D3\05EA \05D1\05E9\05D5\05E8\05D4 \05E9\05D0\05D5\05EA\05D4 \05EA\05E8\05E6\05D4 \05DC\05D4\05E6\05D9\05D2. \05D0\05DD \05D4\05E9\05D5\05E8\05D4 \05D4\05D1\05D5\05D3\05D3\05EA \05D6\05DE\05D9\05E0\05D4, \05D4\05D9\05D0 \05EA\05D5\05E6\05D2 \05EA\05DE\05D9\05D3 \05D1\05E2\05DE\05D5\05D3\05D4 \05D4\05E8\05D0\05E9\05D5\05E0\05D4. \05D1\05D4\05EA\05D0\05DD \05DC\05D4\05EA\05D0\05DE\05D4 \05D4\05D0\05D9\05E9\05D9\05EA \05E9\05DC \05D4\05D3\05D5\05D7 \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9, \05EA\05E6\05D5\05D2\05EA \05D4\05E9\05D5\05E8\05D4 \05D4\05D1\05D5\05D3\05D3\05EA \05E2\05E9\05D5\05D9\05D4 \05DC\05D4\05D9\05D5\05EA \05EA\05E6\05D5\05D2\05D4 \05E1\05D8\05E0\05D3\05E8\05D8\05D9\05EA \05D0\05D5 \05D3\05E3 \05D1\05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05E9\05DE\05E8\05E9\05D4')
||unistr(' \05E2\05D3\05DB\05D5\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204422209399979)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05DE\05D0\05E4\05E9\05E8 \05D4\05D5\05E8\05D3\05D4 \05E9\05DC \05E1\05DC \05D4\05EA\05D5\05E6\05D0\05D5\05EA \05D4\05E0\05D5\05DB\05D7\05D9. \05D4\05E4\05D5\05E8\05DE\05D8\05D9\05DD \05E9\05DC \05D4\05D4\05D5\05E8\05D3\05D4'),
unistr('\05DE\05E9\05EA\05E0\05D9\05DD \05E2\05DC \05E4\05D9 \05D4\05D4\05EA\05E7\05E0\05D4 \05D5\05D4\05D2\05D3\05E8\05EA \05D4\05D3\05D5\05D7 \05E9\05DC\05DA \05D0\05DA'),
unistr('\05E2\05E9\05D5\05D9\05D9\05DD \05DC\05DB\05DC\05D5\05DC CSV, HTML, \05D3\05D5\05D0"\05DC, XLS, PDF, \05D0\05D5 RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203568962399978)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05DE\05DE\05E7\05D3 \05D0\05EA \05D4\05D3\05D5\05D7 \05E2\05DC-\05D9\05D3\05D9 \05D4\05D5\05E1\05E4\05D4 \05D0\05D5 \05EA\05D9\05E7\05D5\05DF \05E9\05DC \05E4\05E1\05D5\05E7 <code>WHERE</code> \05D1\05E9\05D0\05D9\05DC\05EA\05D0. \05EA\05D5\05DB\05DC \05DC\05E1\05E0\05DF \05E2\05DC \05E2\05DE\05D5\05D3\05D4 \05D0\05D5 \05DC\05E4\05D9 \05E9\05D5\05E8\05D4. '),
unistr('<p>\05D0\05DD \05EA\05D1\05D7\05E8 \05DC\05E1\05E0\05DF \05DC\05E4\05D9 \05E2\05DE\05D5\05D3\05D4, \05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05D4 (\05D4\05D9\05D0 \05DC\05D0 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05D9\05D5\05EA'),
unistr('\05E2\05DE\05D5\05D3\05D4 \05DE\05D5\05E6\05D2\05EA), \05D1\05D7\05E8 \05D0\05D5\05E4\05E8\05D8\05D5\05E8 \05E1\05D8\05E0\05D3\05E8\05D8\05D9 \05E9\05DC Oracle (=, !=, \05D0\05D9\05E0\05D5 \05D1-, \05D1\05D9\05DF), \05D5\05D4\05D6\05DF \05D1\05D9\05D8\05D5\05D9 \05DB\05D3\05D9 \05DC\05D4\05E9\05D5\05D5\05EA \05E0\05D2\05D3\05D5. \05D4\05D1\05D9\05D8\05D5\05D9\05D9\05DD \05E8\05D2\05D9\05E9\05D9\05DD \05DC\05D0\05D5\05EA\05D9\05D5\05EA \05E8\05D9\05E9\05D9\05D5\05EA. \05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D5 % \05DB\05EA\05D5 \05DB\05DC\05DC\05D9 (\05DC\05D3\05D5\05D2\05DE\05D4, <code>STATE_NAME'),
unistr('\05DB\05DE\05D5 A%)</code>.</p>'),
unistr('<p>\05D0\05DD \05EA\05D1\05D7\05E8 \05DC\05E1\05E0\05DF \05DC\05E4\05D9 \05E9\05D5\05E8\05D4, \05EA\05D5\05DB\05DC \05DC\05D9\05E6\05D5\05E8 \05E4\05E1\05D5\05E7\05D9 <code>WHERE</code> \05DE\05D5\05E8\05DB\05D1\05D9\05DD \05D1\05D0\05DE\05E6\05E2\05D5\05EA'),
unistr('\05DB\05D9\05E0\05D5\05D9\05D9 \05E2\05DE\05D5\05D3\05D4 \05D5\05DB\05DC \05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05D0\05D5 \05D0\05D5\05E4\05E8\05D8\05D5\05E8 \05E9\05DC Oracle (\05DC\05D3\05D5\05D2\05DE\05D4, <code>G = ''VA'' \05D0\05D5 G = ''CT''</code>, \05DB\05D0\05E9\05E8'),
unistr('<code>G</code> \05D4\05D5\05D0 \05D4\05DB\05D9\05E0\05D5\05D9 \05E9\05DC <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204135375399979)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E9\05D0\05D9\05DC\05EA\05EA \05E4\05DC\05D0\05E9\05D1\05E7 \05DE\05D0\05E4\05E9\05E8\05EA \05DC\05DA \05DC\05D4\05E6\05D9\05D2 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DB\05E4\05D9 \05E9\05D4\05D9\05D5 \05D1\05E0\05E7\05D5\05D3\05D4 \05D4\05E7\05D5\05D3\05DE\05EA'),
unistr('\05D1\05D6\05DE\05DF. \05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05E9\05DC \05DE\05E9\05DA \05D4\05D6\05DE\05DF \05E9\05D1\05D4 \05EA\05D5\05DB\05DC \05DC\05D1\05E6\05E2 \05E4\05DC\05D0\05E9\05D1\05E7 \05D4\05D5\05D0 3 \05E9\05E2\05D5\05EA (\05D0\05D5 180'),
unistr('\05D3\05E7\05D5\05EA) \05D0\05DA \05D4\05DE\05E9\05DA \05D1\05E4\05D5\05E2\05DC \05D9\05E9\05EA\05E0\05D4 \05DC\05DB\05DC \05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265397361400023)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05E4\05D5\05E8\05DE\05D8 \05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D1\05E6\05E2 \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05E9\05DC \05EA\05E6\05D5\05D2\05EA \05D4\05D3\05D5\05D7.'),
unistr('\05E4\05D5\05E8\05DE\05D8 \05DE\05DB\05D9\05DC \05D0\05EA \05EA\05E4\05E8\05D9\05D8\05D9 \05D4\05DE\05E9\05E0\05D4 \05D4\05D1\05D0\05D9\05DD:</p>'),
unistr('<ul><li>\05DE\05D9\05D5\05DF</li>'),
'<li>Control Break</li>',
unistr('<li>\05D4\05D3\05D2\05E9\05D4</li>'),
unistr('<li>\05D7\05D9\05E9\05D5\05D1</li>'),
unistr('<li>\05E1\05DB\05D9\05DE\05D4</li>'),
unistr('<li>\05EA\05E8\05E9\05D9\05DD</li>'),
unistr('<li>\05E7\05D1\05E5 \05DC\05E4\05D9</li>'),
unistr('<li>\05E6\05D9\05E8</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263538796400022)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05EA\05D5\05DB\05DC \05DC\05D4\05D2\05D3\05D9\05E8 \05EA\05E6\05D5\05D2\05D4 \05D0\05D7\05EA \05E9\05DC ''\05E7\05D1\05E5 \05DC\05E4\05D9'' \05DC\05DB\05DC \05D3\05D5\05D7'),
unistr('\05E9\05E0\05E9\05DE\05E8. \05DC\05D0\05D7\05E8 \05E9\05D4\05D2\05D3\05E8\05EA, \05EA\05D5\05DB\05DC \05DC\05D4\05D7\05DC\05D9\05E3 \05D1\05D9\05DF \05EA\05E6\05D5\05D2\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'' \05DC\05EA\05E6\05D5\05D2\05EA'),
unistr('\05D4\05D3\05D5\05D7 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05E1\05DE\05DC\05D9 \05EA\05E6\05D5\05D2\05D4 \05D1\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9. \05DC\05D9\05E6\05D9\05E8\05EA \05EA\05E6\05D5\05D2\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'','),
unistr('\05D1\05D7\05E8 \05D0\05EA:'),
'<p></p>',
'<ul>',
unistr('<li>\05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05E2\05DC\05D9\05D4\05DF \05D9\05E9 \05DC\05E7\05D1\05E5</li>'),
unistr('<li>\05D4\05E2\05DE\05D5\05D3\05D5\05EA \05DC\05E1\05DB\05D9\05DE\05D4 \05D1\05D9\05D7\05D3 \05E2\05DD \05D4\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05E9\05D9\05E9 \05DC\05D1\05E6\05E2 (\05DE\05DE\05D5\05E6\05E2, \05E1\05D9\05DB\05D5\05DD, \05E1\05E4\05D9\05E8\05D4 \05D5\05DB\05D5'')</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203792186399978)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05E1\05E0\05DF. \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05E2\05D5\05E0\05D5\05EA \05E2\05DC \05E7\05E8\05D9\05D8\05E8\05D9\05D5\05E0\05D9 \05D4\05E1\05D9\05E0\05D5\05DF \05DE\05D5\05E6\05D2\05D5\05EA \05DB\05E9\05D4\05DF \05DE\05D5\05D3\05D2\05E9\05D5\05EA \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05DE\05D0\05E4\05D9\05D9\05E0\05D9\05DD \05D4\05E7\05E9\05D5\05E8\05D9\05DD \05DC\05DE\05E1\05E0\05DF. \05D4\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05D4\05DF:</p>'),
'<ul>',
unistr('<li><strong>\05E9\05DD</strong> \05DE\05E9\05DE\05E9 \05DC\05EA\05E6\05D5\05D2\05D4 \05D1\05DC\05D1\05D3.</li>'),
unistr('<li><strong>\05E8\05E6\05E3</strong> \05DE\05D6\05D4\05D4 \05D0\05EA \05E8\05E6\05E3 \05D4\05E2\05E8\05DB\05EA \05D4\05DB\05DC\05DC\05D9\05DD.</li>'),
unistr('<li><strong>\05D0\05E4\05E9\05E8\05D9</strong> \05DE\05D6\05D4\05D4 \05D0\05DD \05DB\05DC\05DC \05D0\05E4\05E9\05E8\05D9 \05D0\05D5 \05D7\05E1\05D5\05DD.</li>'),
unistr('<li><strong>\05E1\05D5\05D2 \05D4\05D3\05D2\05E9\05D4</strong> \05DE\05D6\05D4\05D4 \05D0\05DD \05E9\05D5\05E8\05D4 \05D0\05D5 \05EA\05D0 \05D0\05DE\05D5\05E8\05D9\05DD \05DC\05D4\05D9\05D5\05EA'),
unistr('\05DE\05D5\05D3\05D2\05E9\05D9\05DD. \05D0\05DD \05E0\05D1\05D7\05E8 \05EA\05D0, \05D0\05D6\05D9 \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05D0\05DC\05D9\05D4 \05D9\05E9 \05D4\05E4\05E0\05D9\05D4'),
unistr('\05D1\05EA\05E0\05D0\05D9 \05D4\05D4\05D3\05D2\05E9\05D4, \05D4\05D9\05D0 \05D4\05DE\05D5\05D3\05D2\05E9\05EA.</li>'),
unistr('<li><strong>\05E6\05D1\05E2 \05E8\05E7\05E2</strong> \05D4\05D5\05D0 \05D4\05E6\05D1\05E2 \05D4\05D7\05D3\05E9 \05DC\05E8\05E7\05E2 \05E9\05DC \05D4\05D0\05D6\05D5\05E8 \05D4\05DE\05D5\05D3\05D2\05E9.</li>'),
unistr('<li><strong>\05E6\05D1\05E2 \05D8\05E7\05E1\05D8</strong> \05D4\05D5\05D0 \05D4\05E6\05D1\05E2 \05E9\05DC \05D4\05D8\05E7\05E1\05D8 \05D1\05D0\05D6\05D5\05E8 \05D4\05DE\05D5\05D3\05D2\05E9.</li>'),
unistr('<li><strong>\05EA\05E0\05D0\05D9 \05D4\05D3\05D2\05E9\05D4</strong>  \05DE\05D2\05D3\05D9\05E8 \05D0\05EA \05EA\05E0\05D0\05D9 \05D4\05E1\05D9\05E0\05D5\05DF \05E9\05DC\05DA.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141367763399932)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05EA\05D5\05DB\05DC \05DC\05D4\05D2\05D3\05D9\05E8 \05EA\05E6\05D5\05D2\05EA \05E6\05D9\05E8 \05D0\05D7\05EA \05DC\05DB\05DC \05D3\05D5\05D7 \05E9\05E0\05E9\05DE\05E8. \05DC\05D0\05D7\05E8 \05E9\05D4\05D2\05D3\05E8\05EA, \05EA\05D5\05DB\05DC \05DC\05D4\05D7\05DC\05D9\05E3 \05D1\05D9\05DF \05EA\05E6\05D5\05D2\05EA \05D4\05E6\05D9\05E8 \05DC\05EA\05E6\05D5\05D2\05EA \05D4\05D3\05D5\05D7 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05E1\05DE\05DC\05D9 \05EA\05E6\05D5\05D2\05D4 \05D1\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9. \05DC\05D9\05E6\05D9\05E8\05EA \05EA\05E6\05D5\05D2\05EA \05E6\05D9\05E8, \05D1\05D7\05E8 \05D0\05EA: '),
'<p></p>',
'<ul>',
unistr('<li>\05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05E2\05DC\05D9\05D4\05DF \05D9\05E9 \05DC\05D1\05E0\05D5\05EA \05E6\05D9\05E8</li>'),
unistr('<li>\05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05D9\05E9 \05DC\05D4\05E6\05D9\05D2 \05DB\05E9\05D5\05E8\05D5\05EA</li>'),
unistr('<li>\05D4\05E2\05DE\05D5\05D3\05D5\05EA \05DC\05E1\05DB\05D9\05DE\05D4 \05D1\05D9\05D7\05D3 \05E2\05DD \05D4\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05E9\05D9\05E9 \05DC\05D1\05E6\05E2 (\05DE\05DE\05D5\05E6\05E2, \05E1\05D9\05DB\05D5\05DD, \05E1\05E4\05D9\05E8\05D4 \05D5\05DB\05D5'')</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214875077399986)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05D0\05DD \05EA\05D1\05E6\05E2 \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05E9\05DC \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9, \05D4\05D2\05D3\05E8\05D5\05EA \05D4\05D3\05D5\05D7 \05D9\05D5\05E6\05D2\05D5'),
unistr('\05DE\05EA\05D7\05EA \05DC\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9 \05D5\05DE\05E2\05DC \05D4\05D3\05D5\05D7. \05D0\05D6\05D5\05E8 \05D6\05D4 \05E0\05D9\05EA\05DF \05DC\05DB\05D9\05D5\05D5\05E5 \05D5\05DC\05D4\05E8\05D7\05D1\05D4 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05E1\05DE\05DC \05E9\05DE\05E9\05DE\05D0\05DC.'),
'<p>',
unistr('\05DC\05DB\05DC \05D4\05D2\05D3\05E8\05EA \05D3\05D5\05D7, \05EA\05D5\05DB\05DC \05DC\05E2\05E9\05D5\05EA \05D0\05EA \05D4\05D3\05D1\05E8\05D9\05DD \05D4\05D1\05D0\05D9\05DD:'),
'</p><ul>',
unistr('<li>\05DC\05E2\05E8\05D5\05DA \05D4\05D2\05D3\05E8\05D4 \05E2\05DC-\05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05D4\05E9\05DD.</li>'),
unistr('<li>\05DC\05D0\05E4\05E9\05E8 \05D0\05D5 \05DC\05D7\05E1\05D5\05DD \05D4\05D2\05D3\05E8\05D4 \05E2\05DC-\05D9\05D3\05D9 \05E1\05D9\05DE\05D5\05DF \05D0\05D5 \05D1\05D9\05D8\05D5\05DC \05D4\05E1\05D9\05DE\05D5\05DF \05D1\05EA\05D9\05D1\05EA \05D4\05EA\05D9\05D5\05D2 ''\05D0\05E4\05E9\05E8/\05D7\05E1\05D5\05DD''. \05D4\05E9\05EA\05DE\05E9 \05D1\05E4\05E7\05D3 \05D6\05D4 \05DB\05D3\05D9 \05DC\05D4\05E4\05E2\05D9\05DC \05D0\05D5 \05DC\05DB\05D1\05D5\05EA \05D4\05D2\05D3\05E8\05D4 \05D1\05D0\05D5\05E4\05DF \05D6\05DE\05E0\05D9.</li>'),
unistr('<li>\05DC\05D4\05E1\05D9\05E8 \05D4\05D2\05D3\05E8\05D4 \05E2\05DC-\05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05E1\05DE\05DC \05D4\05D4\05E1\05E8\05D4.</li>'),
'</ul>',
unistr('<p>\05D0\05DD \05D9\05E6\05E8\05EA \05EA\05E8\05E9\05D9\05DD, \05E7\05D1\05D5\05E6\05D4 \05D0\05D5 \05E6\05D9\05E8, \05EA\05D5\05DB\05DC \05DC\05D4\05D7\05DC\05D9\05E3 \05D1\05D9\05E0\05D9\05D4\05DD'),
unistr('\05DC\05D1\05D9\05DF \05D3\05D5\05D7 \05D4\05D1\05E1\05D9\05E1 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05E7\05D9\05E9\05D5\05E8\05D9\05DD \05DC\05EA\05E6\05D5\05D2\05EA \05D3\05D5\05D7, \05EA\05E6\05D5\05D2\05EA \05EA\05E8\05E9\05D9\05DD, \05EA\05E6\05D5\05D2\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'' \05D5\05EA\05E6\05D5\05D2\05EA \05E6\05D9\05E8, \05D4\05DE\05D5\05E6\05D2\05D9\05DD \05DE\05D9\05DE\05D9\05DF. \05D0\05DD \05EA\05E6\05D9\05D2 \05D0\05EA \05D4\05EA\05E8\05E9\05D9\05DD, ''\05E7\05D1\05E5 \05DC\05E4\05D9'' \05D0\05D5 \05E6\05D9\05E8,'),
unistr('\05EA\05D5\05DB\05DC \05D2\05DD \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05E7\05D9\05E9\05D5\05E8 \05D4\05E2\05E8\05D9\05DB\05D4 \05DB\05D3\05D9 \05DC\05E2\05E8\05D5\05DA \05D0\05EA \05D4\05D4\05D2\05D3\05E8\05D5\05EA.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204397216399979)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D0\05E4\05E1 \05D0\05EA \05D4\05D3\05D5\05D7 \05D7\05D6\05E8\05D4 \05DC\05D4\05D2\05D3\05E8\05D5\05EA \05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC, \05D5\05DE\05E1\05D9\05E8 \05D0\05EA \05DB\05DC \05D4\05D4\05EA\05D0\05DE\05D5\05EA \05D4\05D0\05D9\05E9\05D9\05D5\05EA \05E9\05D1\05E6\05E2\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265669856400023)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8 \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05DC\05EA\05E6\05D5\05D2\05D4 \05D1\05DB\05DC \05D3\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204209965399979)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05E9\05D5\05DE\05E8 \05D0\05EA \05D4\05D3\05D5\05D7\05D5\05EA \05D4\05DE\05D5\05EA\05D0\05DE\05D9\05DD \05D0\05D9\05E9\05D9\05EA \05DC\05E9\05D9\05DE\05D5\05E9 \05E2\05EA\05D9\05D3\05D9. \05EA\05D5\05DB\05DC \05DC\05E1\05E4\05E7 \05E9\05DD, \05DC\05E1\05E4\05E7 \05EA\05D9\05D0\05D5\05E8 \05D0\05D5\05E4\05E6\05D9\05D5\05E0\05DC\05D9, \05D5\05DC\05D4\05E4\05D5\05DA \05D0\05EA \05D4\05D3\05D5\05D7 \05DC\05E0\05D2\05D9\05E9 \05DC\05E6\05D9\05D1\05D5\05E8 (\05DB\05DC\05D5\05DE\05E8, \05DB\05DC \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05D5\05DB\05DC\05D5 \05DC\05D2\05E9\05EA \05DC\05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05D4\05E8\05D0\05E9\05D9\05EA \05E9\05DC \05D3\05D5\05D7 \05D6\05D4). \05EA\05D5\05DB\05DC \05DC\05E9\05DE\05D5\05E8 \05D0\05E8\05D1\05E2\05D4 \05E1\05D5\05D2\05D9\05DD \05E9\05DC \05D3\05D5\05D7\05D5\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05D9\05DD:</p>'),
'<ul>',
unistr('<li><strong>\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E8\05D0\05E9\05D9\05EA</strong> (\05DE\05E4\05EA\05D7 \05D1\05DC\05D1\05D3). \05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05D4\05E8\05D0\05E9\05D9\05EA \05D4\05D9\05D0 \05D4\05D3\05D5\05D7 \05D4\05DE\05D5\05E6\05D2 \05D4\05E8\05D0\05E9\05D5\05DF. \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E9\05E0\05D5\05EA \05E9\05DD \05D0\05D5 \05DC\05DE\05D7\05D5\05E7 \05D1\05E8\05D9\05E8\05D5\05EA \05DE\05D7\05D3\05DC \05E8\05D0\05E9\05D9\05D5\05EA \05E9\05DC \05D3\05D5\05D7.</li>'),
unistr('<li><strong>\05D3\05D5\05D7 \05D7\05DC\05D5\05E4\05D9</strong> (\05DE\05E4\05EA\05D7 \05D1\05DC\05D1\05D3). \05DE\05D0\05E4\05E9\05E8 \05DC\05DE\05E4\05EA\05D7\05D9\05DD \05DC\05D9\05E6\05D5\05E8 \05DE\05E1\05E4\05E8 \05DE\05EA\05D5\05D5\05D9\05DD \05E9\05DC \05D3\05D5\05D7. \05E8\05E7 \05DE\05E4\05EA\05D7\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05E9\05DE\05D5\05E8, \05DC\05E9\05E0\05D5\05EA \05E9\05DD \05D0\05D5 \05DC\05DE\05D7\05D5\05E7 \05D3\05D5\05D7 \05D7\05DC\05D5\05E4\05D9.</li>'),
unistr('<li><strong>\05D3\05D5\05D7 \05E6\05D9\05D1\05D5\05E8\05D9</strong> (\05DE\05E9\05EA\05DE\05E9 \05E7\05E6\05D4). \05DE\05E9\05EA\05DE\05E9 \05D4\05E7\05E6\05D4 \05E9\05D9\05E6\05E8 \05D0\05D5\05EA\05D5 \05D9\05DB\05D5\05DC \05DC\05E9\05DE\05D5\05E8, \05DC\05E9\05E0\05D5\05EA \05E9\05DD \05D0\05D5 \05DC\05DE\05D7\05D5\05E7 \05D0\05D5\05EA\05D5. \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D0\05D7\05E8\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05D4\05E6\05D9\05D2 \05D5\05DC\05E9\05DE\05D5\05E8 \05D0\05EA \05D4\05DE\05EA\05D5\05D5\05D4 \05DB\05D3\05D5\05D7 \05E0\05D5\05E1\05E3.</li>'),
unistr('<li><strong>\05D3\05D5\05D7 \05E4\05E8\05D8\05D9</strong> (\05DE\05E9\05EA\05DE\05E9 \05E7\05E6\05D4). \05E8\05E7 \05DE\05E9\05EA\05DE\05E9 \05D4\05E7\05E6\05D4 \05E9\05D9\05E6\05E8 \05D0\05EA \05D4\05D3\05D5\05D7 \05D9\05DB\05D5\05DC \05DC\05D4\05E6\05D9\05D2, \05DC\05E9\05DE\05D5\05E8, \05DC\05E9\05E0\05D5\05EA \05E9\05DD \05D0\05D5 \05DC\05DE\05D7\05D5\05E7 \05D0\05EA \05D4\05D3\05D5\05D7.</li>'),
'</ul>',
unistr('<p>\05D0\05DD \05EA\05E9\05DE\05D5\05E8 \05D3\05D5\05D7\05D5\05EA \05DE\05D5\05EA\05D0\05DE\05D9\05DD \05D0\05D9\05E9\05D9\05EA, \05D9\05D5\05E6\05D2 \05D1\05D5\05E8\05E8 \05D3\05D5\05D7\05D5\05EA \05D1\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9 \05E9\05DE\05E9\05DE\05D0\05DC \05DC\05D1\05D5\05E8\05E8 \05D4\05E9\05D5\05E8\05D5\05EA (\05DE\05D0\05E4\05D9\05D9\05DF \05D6\05D4 \05D0\05E4\05E9\05E8\05D9).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203260939399978)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D0\05E9 \05DB\05DC \05D3\05E3 \05E9\05DC \05D3\05D5\05D7 \05E0\05DE\05E6\05D0 \05D0\05D6\05D5\05E8 \05D7\05D9\05E4\05D5\05E9. \05D0\05D6\05D5\05E8 (\05D0\05D5 \05E1\05E8\05D2\05DC \05D7\05D9\05E4\05D5\05E9) \05D6\05D4 \05DE\05E1\05E4\05E7 \05D0\05EA \05D4\05DE\05D0\05E4\05D9\05D9\05E0\05D9\05DD \05D4\05D1\05D0\05D9\05DD:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266258525400024)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('<li><strong>\05EA\05E4\05E8\05D9\05D8 \05E4\05E2\05D5\05DC\05D5\05EA</strong> \05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D1\05E6\05E2 \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05E9\05DC \05D3\05D5\05D7. \05E2\05D9\05D9\05DF \05D1\05E4\05E8\05E7\05D9\05DD \05D4\05D1\05D0\05D9\05DD.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265777296400023)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'he'
,p_message_text=>unistr('<li><strong>\05E1\05DE\05DC \05D1\05D7\05D9\05E8\05EA \05E2\05DE\05D5\05D3\05D5\05EA</strong> \05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D6\05D4\05D5\05EA \05D1\05D0\05D9\05D6\05D5 \05E2\05DE\05D5\05D3\05D4 \05DC\05D7\05E4\05E9 (\05D0\05D5 \05DB\05D5\05DC\05DF).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266065611400023)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'he'
,p_message_text=>unistr('<li><strong>\05D3\05D5\05D7\05D5\05EA</strong> \05DE\05E6\05D9\05D2 \05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05D7\05DC\05D5\05E4\05D9\05EA \05D5\05D3\05D5\05D7\05D5\05EA \05E4\05E8\05D8\05D9\05D9\05DD \05D0\05D5 \05E6\05D9\05D1\05D5\05E8\05D9\05D9\05DD \05E9\05DE\05D5\05E8\05D9\05DD.</li>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265982174400023)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('<li><strong>\05E9\05D5\05E8\05D5\05EA</strong> \05DE\05D2\05D3\05D9\05E8 \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05DC\05EA\05E6\05D5\05D2\05D4 \05D1\05DB\05DC \05D3\05E3.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265865458400023)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\05D0\05D6\05D5\05E8 \05D8\05E7\05E1\05D8</strong> \05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05D4\05D6\05D9\05DF \05E7\05E8\05D9\05D8\05E8\05D9\05D5\05E0\05D9 \05D7\05D9\05E4\05D5\05E9 \05E8\05D2\05D9\05E9\05D9\05DD \05DC\05D0\05D5\05EA\05D9\05D5\05EA \05E8\05D9\05E9\05D9\05D5\05EA (\05EA\05D5\05D5\05D9\05DD \05DB\05DC\05DC\05D9\05D9\05DD \05D4\05DD \05DE\05E8\05D5\05DE\05D6\05D9\05DD).</li>'),
unistr('<li><strong>\05DC\05D7\05E6\05DF \05D1\05D9\05E6\05D5\05E2</strong> \05DE\05D1\05E6\05E2 \05D0\05EA \05D4\05D7\05D9\05E4\05D5\05E9. \05D2\05DD \05D4\05E7\05E9\05D4 \05E2\05DC \05DE\05E7\05E9 enter \05EA\05D1\05E6\05E2 \05D0\05EA \05D4\05D7\05D9\05E4\05D5\05E9 \05DB\05D0\05E9\05E8 \05D4\05E1\05DE\05DF \05E0\05DE\05E6\05D0 \05D1\05D0\05D6\05D5\05E8 \05D8\05E7\05E1\05D8 \05D4\05D7\05D9\05E4\05D5\05E9.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266101889400023)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('<li><strong>\05E1\05DE\05DC\05D9 \05EA\05E6\05D5\05D2\05D4</strong> \05DE\05D7\05DC\05D9\05E3 \05D1\05D9\05DF \05D4\05EA\05E6\05D5\05D2\05D5\05EA \05E9\05DC \05D4\05E1\05DE\05DC, \05D3\05D5\05D7, \05E4\05D9\05E8\05D5\05D8, \05EA\05E8\05E9\05D9\05DD, ''\05E7\05D1\05E5 \05DC\05E4\05D9'' \05D5\05E6\05D9\05E8 \05E9\05DC \05D4\05D3\05D5\05D7, \05D0\05DD \05D4\05D5\05D2\05D3\05E8\05D5.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282183406400035)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'he'
,p_message_text=>unistr('<li><strong>\05E0\05D9\05D4\05D5\05DC</strong> \05DE\05D0\05E4\05E9\05E8 \05DC\05DA \05DC\05E0\05D4\05DC \05D0\05EA \05D4\05DE\05D0\05E4\05D9\05D9\05E0\05D9\05DD, \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D5\05D4\05E9\05D5\05E8\05D5\05EA, \05D5\05DC\05D4\05E6\05D9\05D2 \05D4\05D9\05E1\05D8\05D5\05E8\05D9\05D4 \05E9\05DC \05D4\05D3\05D5\05D7 \05D0\05D5 \05E9\05DC \05E1\05E8\05D9\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203473572399978)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05DE\05E9 \05DC\05E9\05D9\05E0\05D5\05D9 \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA. \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D1\05E6\05D3 \05D9\05DE\05D9\05DF \05DE\05D5\05E6\05D2\05D5\05EA. \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D1\05E6\05D3 \05E9\05DE\05D0\05DC \05E0\05E1\05EA\05E8\05D5\05EA. \05EA\05D5\05DB\05DC \05DC\05E1\05D3\05E8 \05DE\05D7\05D3\05E9 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05D7\05E6\05D9\05DD \05D1\05E7\05E6\05D4 \05D4\05D9\05DE\05E0\05D9. \05E2\05DE\05D5\05D3\05D5\05EA \05DE\05D7\05D5\05E9\05D1\05D5\05EA \05DE\05D5\05E6\05D2\05D5\05EA \05E2\05DD \05D4\05EA\05D7\05D9\05DC\05D9\05EA <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203620267399978)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05DE\05E9\05DE\05E9 \05DC\05E9\05D9\05E0\05D5\05D9 \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05D0\05D5\05EA\05DF \05DE\05DE\05D9\05D9\05E0\05D9\05DD \05D5\05E7\05D5\05D1\05E2 \05D0\05DD'),
unistr('\05DC\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4 \05D0\05D5 \05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3. \05EA\05D5\05DB\05DC \05D2\05DD \05DC\05E6\05D9\05D9\05DF \05DB\05D9\05E6\05D3 \05DC\05D8\05E4\05DC \05D1\05E2\05E8\05DB\05D9'),
unistr('<code>NULL</code>. \05D4\05D2\05D3\05E8\05EA \05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05DE\05E6\05D9\05D2\05D4 \05E2\05E8\05DB\05D9 <code>NULL</code> \05EA\05DE\05D9\05D3 \05D0\05D7\05E8\05D5\05E0\05D9\05DD \05D0\05D5 \05EA\05DE\05D9\05D3 \05E8\05D0\05E9\05D5\05E0\05D9\05DD. \05D4\05DE\05D9\05D5\05DF \05D4\05E0\05D5\05D1\05E2 \05DE\05D5\05E6\05D2 \05D1\05E6\05D3 \05D9\05DE\05D9\05DF \05E9\05DC'),
unistr('\05DB\05D5\05EA\05E8\05D5\05EA \05D4\05E2\05DE\05D5\05D3\05D4 \05D1\05D3\05D5\05D7.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263302759400021)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05E9\05DE\05D5\05E1\05D9\05E4\05D9\05DD \05DE\05E0\05D5\05D9, \05DE\05E1\05E4\05E7\05D9\05DD \05DB\05EA\05D5\05D1\05EA \05D3\05D5\05D0"\05DC (\05D0\05D5 \05DE\05E1\05E4\05E8 \05DB\05EA\05D5\05D1\05D5\05EA \05D3\05D5\05D0"\05DC \05D4\05DE\05D5\05E4\05E8\05D3\05D5\05EA \05D1\05E4\05E1\05D9\05E7\05D9\05DD), \05E0\05D5\05E9\05D0 \05D4\05D5\05D3\05E2\05EA \05D3\05D5\05D0"\05DC, \05EA\05D3\05D9\05E8\05D5\05EA, \05D5\05EA\05D0\05E8\05D9\05DB\05D9 \05D4\05EA\05D7\05DC\05D4 \05D5\05E1\05D9\05D5\05DD. \05D4\05D5\05D3\05E2\05D5\05EA \05D4\05D3\05D5\05D0"\05DC \05D4\05E0\05D5\05D1\05E2\05D5\05EA \05DB\05D5\05DC\05DC\05D5\05EA \05D2\05E8\05E1\05EA HTML \05E9\05DC \05D4\05D3\05D5\05D7 \05D4\05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9 \05E9\05DE\05DB\05D9\05DC\05D4 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E0\05D5\05DB\05D7\05D9\05D9\05DD \05E2\05DC-\05E4\05D9 \05D4\05D2\05D3\05E8\05EA \05D4\05D3\05D5\05D7 \05E9\05D4\05D9\05D9\05EA\05D4 \05D1\05E2\05EA \05E9\05D4\05DE\05E0\05D5\05D9 \05D4\05EA\05D5\05D5\05E1')
||unistr('\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281991499400035)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05D1\05D1\05E1\05D9\05E1, \05E1\05E8\05D9\05D2\05D9 \05E0\05EA\05D5\05E0\05D9\05DD \05D4\05DD \05D3\05D5\05D7\05D5\05EA \05E0\05D9\05EA\05E0\05D9\05DD \05DC\05E2\05E8\05D9\05DB\05D4 \05D1\05E2\05DC\05D9 \05D9\05DB\05D5\05DC\05EA \05E8\05D1\05D4 \05E9\05DC \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA. \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05E9\05E0\05D5\05EA \05D0\05EA \05D4\05DE\05EA\05D5\05D5\05D4 \05E9\05DC \05E0\05EA\05D5\05E0\05D9 \05D3\05D5\05D7 \05E2\05DC-\05D9\05D3\05D9 \05D1\05D7\05D9\05E8\05EA \05E2\05DE\05D5\05D3\05D5\05EA, \05D4\05D7\05DC\05EA \05DE\05E1\05E0\05E0\05D9\05DD, \05D4\05D3\05D2\05E9\05D4 \05D5\05DE\05D9\05D5\05DF. \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05D2\05DD \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05E2\05D1\05E8\05D9\05DD, \05E1\05DB\05D9\05DE\05D5\05EA, \05EA\05E8\05E9\05D9\05DE\05D9\05DD, \05DE\05D9\05E0\05D5\05D9 ''\05E7\05D1\05E5 \05DC\05E4\05D9'', \05D5\05DC\05D4\05D5\05E1\05D9\05E3 \05D7\05D9\05E9\05D5\05D1\05D9\05DD \05DE\05E9')
||unistr('\05DC \05E2\05E6\05DE\05DD. \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05D9\05E6\05D5\05E8 \05DE\05E1\05E4\05E8 \05D5\05E8\05D9\05D0\05E6\05D9\05D5\05EA \05E9\05DC \05D3\05D5\05D7 \05D5\05DC\05E9\05DE\05D5\05E8 \05D0\05D5\05EA\05DF \05DB\05D3\05D5\05D7\05D5\05EA \05E9\05DE\05D9\05D9\05DD, \05DC\05E6\05D5\05E8\05DA \05E6\05E4\05D9\05D9\05D4 \05E4\05E8\05D8\05D9\05EA. '),
'<p/>',
unistr('\05E1\05E8\05D9\05D2 \05E0\05EA\05D5\05E0\05D9\05DD \05E0\05D9\05EA\05DF \05DC\05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9, \05EA\05E4\05E8\05D9\05D8 \05E4\05E2\05D5\05DC\05D5\05EA, \05EA\05E4\05E8\05D9\05D8 \05E0\05D9\05D4\05D5\05DC \05D0\05D5 \05EA\05E4\05E8\05D9\05D8 \05DB\05D5\05EA\05E8\05EA \05E2\05DE\05D5\05D3\05D4.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293729610400043)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E4\05E8\05D9\05D8 \05D4\05E4\05E2\05D5\05DC\05D5\05EA \05DE\05D5\05E4\05D9\05E2 \05DE\05E6\05D3 \05D9\05DE\05D9\05DF \05E9\05DC \05DC\05D7\05E6\05DF \05D4\05D1\05D9\05E6\05D5\05E2 \05D1\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9. \05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05E4\05E8\05D9\05D8 \05D6\05D4 \05DB\05D3\05D9 \05DC\05D4\05EA\05D0\05D9\05DD \05D0\05D9\05E9\05D9\05EA \05D3\05D5\05D7 \05E1\05E8\05D9\05D2 \05E0\05EA\05D5\05E0\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282422378400035)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 \05D4\05D5\05E1\05E4\05D4/\05E2\05E8\05D9\05DB\05D4 \05E9\05DC \05E9\05D5\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282585098400035)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05DC\05D4\05D5\05E1\05E4\05EA \05E9\05D5\05E8\05D4 \05DC\05E1\05E8\05D9\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DC\05D7\05E5 \05E2\05DC ''\05D4\05D5\05E1\05E3 \05E9\05D5\05E8\05D4''. \05DC\05E2\05E8\05D9\05DB\05EA \05D4\05E4\05E8\05D8\05D9\05DD \05E9\05DC \05E9\05D5\05E8\05D4 \05DC\05D7\05E5 \05E2\05DC \05E1\05DE\05DC \05E2\05E8\05D9\05DB\05EA \05D4\05E9\05D5\05E8\05D4 (\05E2\05DE\05D5\05D3\05D4 \05E8\05D0\05E9\05D5\05E0\05D4) \05D1\05E9\05D5\05E8\05D4 \05E9\05EA\05E8\05E6\05D4 \05DC\05E2\05E8\05D5\05DA. \05D4\05D3\05E3 ''\05D4\05D5\05E1\05E4\05D4/\05E2\05E8\05D9\05DB\05D4 \05E9\05DC \05E9\05D5\05E8\05D4'' \05D9\05D5\05E6\05D2 \05D5\05D9\05E8\05D0\05D4 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05DC \05E1\05E8\05D9\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD. </p>'),
'',
unistr('<p>\05D1\05E2\05EA \05E2\05E8\05D9\05DB\05EA \05E9\05D5\05E8\05D4 \05EA\05D5\05DB\05DC \05DC\05E2\05E9\05D5\05EA \05D0\05EA \05D4\05D3\05D1\05E8\05D9\05DD \05D4\05D1\05D0\05D9\05DD:</p>'),
'',
'<p><ul>',
unistr('<li><strong>\05DC\05DE\05D7\05D5\05E7</strong> \05D0\05EA \05D4\05E9\05D5\05E8\05D4.</li>'),
unistr('<li><strong>\05DC\05D4\05D7\05D9\05DC \05E9\05D9\05E0\05D5\05D9\05D9\05DD</strong> \05DB\05D3\05D9 \05DC\05E9\05DE\05D5\05E8 \05D0\05EA \05D4\05E9\05D9\05E0\05D5\05D9\05D9\05DD \05E9\05D1\05D5\05E6\05E2\05D5 \05D1\05E9\05D5\05E8\05D4.</li>'),
unistr('<li>\05D1\05DE\05E1\05D2\05E8\05EA <strong>\05E4\05E2\05D5\05DC\05D5\05EA</strong>, \05DC\05D4\05D5\05E1\05D9\05E3 \05E9\05D5\05E8\05D4, \05DC\05D4\05D5\05E1\05D9\05E3 \05E7\05D1\05E6\05D9\05DD, \05D4\05E2\05E8\05D5\05EA, \05E7\05D9\05E9\05D5\05E8\05D9\05DD \05D0\05D5 \05EA\05D2\05D9\05D5\05EA, \05D5\05DC\05E2\05D9\05D9\05DF \05D1\05D4\05D9\05E1\05D8\05D5\05E8\05D9\05D4.</li>'),
unistr('<li>\05DC\05E0\05D5\05D5\05D8 \05D0\05DC \05D4\05E9\05D5\05E8\05D5\05EA <strong>\05D4\05D1\05D0\05D4 \05D5\05D4\05E7\05D5\05D3\05DE\05EA</strong>.</li>'),
unistr('<li>\05D1\05DE\05E1\05D2\05E8\05EA <strong>\05E0\05D9\05D4\05D5\05DC</strong>, \05DC\05D4\05D2\05D3\05D9\05E8 \05DE\05D0\05E4\05D9\05D9\05E0\05D9 \05E2\05DE\05D5\05D3\05D4, \05E7\05D1\05D5\05E6\05D5\05EA \05E2\05DE\05D5\05D3\05D4, \05D1\05D3\05D9\05E7\05D5\05EA \05EA\05E7\05D9\05E0\05D5\05EA \05D5\05E8\05E9\05D9\05DE\05D5\05EA \05E2\05E8\05DB\05D9\05DD.</li>'),
'</ul></p>',
'',
unistr('<p>\05D1\05D0\05D6\05D5\05E8 \05D4\05D1\05D9\05D0\05D5\05E8\05D9\05DD \05E9\05D1\05EA\05D7\05EA\05D9\05EA \05D4\05D3\05E3 \05D9\05D5\05E6\05D2\05D5 \05E7\05D1\05E6\05D9\05DD, \05D4\05E2\05E8\05D5\05EA, \05E7\05D9\05E9\05D5\05E8\05D9\05DD \05D0\05D5 \05EA\05D2\05D9\05D5\05EA \05D4\05E7\05E9\05D5\05E8\05D9\05DD \05DC\05E9\05D5\05E8\05D4 \05D4\05E0\05D5\05DB\05D7\05D9\05EA.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293817424400043)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05DE\05E9 \05DC\05D9\05E6\05D9\05E8\05EA \05E7\05D1\05D5\05E6\05EA \05E9\05D1\05D9\05E8\05D4 \05D1\05E2\05DE\05D5\05D3\05D4 \05D0\05D7\05EA \05D0\05D5 \05D9\05D5\05EA\05E8. \05D3\05D1\05E8 \05D6\05D4 \05DE\05D5\05E9\05DA \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05D0\05DC \05DE\05D7\05D5\05E5 \05DC\05E1\05E8\05D9\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D5\05DE\05E6\05D9\05D2 \05D0\05D5\05EA\05DF \05DB\05E8\05E9\05D5\05DE\05D4 \05D0\05D1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282301999400035)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05DE\05D0\05E4\05E9\05E8 \05D4\05D5\05E8\05D3\05D4 \05E9\05DC \05E1\05DC \05D4\05EA\05D5\05E6\05D0\05D5\05EA \05D4\05E0\05D5\05DB\05D7\05D9. \05D4\05E4\05D5\05E8\05DE\05D8\05D9\05DD \05E9\05DC \05D4\05D4\05D5\05E8\05D3\05D4'),
unistr('\05D4\05DD CSV, HTML \05D0\05D5 \05D3\05D5\05D0"\05DC.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293915420400043)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05D0\05DD \05EA\05D1\05E6\05E2 \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05E9\05DC \05D3\05D5\05D7 \05E1\05E8\05D9\05D2 \05E0\05EA\05D5\05E0\05D9\05DD, \05D4\05D2\05D3\05E8\05D5\05EA \05D4\05D3\05D5\05D7 \05D9\05D5\05E6\05D2\05D5'),
unistr('\05DE\05EA\05D7\05EA \05DC\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9 \05D5\05DE\05E2\05DC \05D4\05D3\05D5\05D7. \05D0\05D6\05D5\05E8 \05D6\05D4 \05E0\05D9\05EA\05DF \05DC\05DB\05D9\05D5\05D5\05E5 \05D5\05DC\05D4\05E8\05D7\05D1\05D4 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05E1\05DE\05DC \05E9\05DE\05E9\05DE\05D0\05DC.'),
'<p>',
unistr('\05DC\05DB\05DC \05D4\05D2\05D3\05E8\05EA \05D3\05D5\05D7, \05EA\05D5\05DB\05DC \05DC\05E2\05E9\05D5\05EA \05D0\05EA \05D4\05D3\05D1\05E8\05D9\05DD \05D4\05D1\05D0\05D9\05DD:'),
'</p><ul>',
unistr('<li>\05DC\05E2\05E8\05D5\05DA \05D4\05D2\05D3\05E8\05D4 \05E2\05DC-\05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05D4\05E9\05DD.</li>'),
unistr('<li>\05DC\05D0\05E4\05E9\05E8 \05D0\05D5 \05DC\05D7\05E1\05D5\05DD \05D4\05D2\05D3\05E8\05D4 \05E2\05DC-\05D9\05D3\05D9 \05E1\05D9\05DE\05D5\05DF \05D0\05D5 \05D1\05D9\05D8\05D5\05DC \05D4\05E1\05D9\05DE\05D5\05DF \05D1\05EA\05D9\05D1\05EA \05D4\05EA\05D9\05D5\05D2 ''\05D0\05E4\05E9\05E8/\05D7\05E1\05D5\05DD''. \05D4\05E9\05EA\05DE\05E9 \05D1\05E4\05E7\05D3 \05D6\05D4 \05DB\05D3\05D9 \05DC\05D4\05E4\05E2\05D9\05DC \05D0\05D5 \05DC\05DB\05D1\05D5\05EA \05D4\05D2\05D3\05E8\05D4 \05D1\05D0\05D5\05E4\05DF \05D6\05DE\05E0\05D9.</li>'),
unistr('<li>\05DC\05D4\05E1\05D9\05E8 \05D4\05D2\05D3\05E8\05D4 \05E2\05DC-\05D9\05D3\05D9 \05DC\05D7\05D9\05E6\05D4 \05E2\05DC \05E1\05DE\05DC \05D4\05D4\05E1\05E8\05D4.</li>'),
'</ul>',
unistr('<p>\05D0\05DD \05D9\05E6\05E8\05EA \05EA\05E8\05E9\05D9\05DD \05D0\05D5 ''\05E7\05D1\05E5 \05DC\05E4\05D9'', \05EA\05D5\05DB\05DC \05DC\05D4\05D7\05DC\05D9\05E3 \05D1\05D9\05E0\05D9\05D4\05DD'),
unistr('\05DC\05D1\05D9\05DF \05D3\05D5\05D7 \05D4\05D1\05E1\05D9\05E1 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D4\05E7\05D9\05E9\05D5\05E8\05D9\05DD \05DC\05EA\05E6\05D5\05D2\05EA \05D3\05D5\05D7, \05EA\05E6\05D5\05D2\05EA \05EA\05E8\05E9\05D9\05DD \05D5\05EA\05E6\05D5\05D2\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'' \05D4\05DE\05D5\05E6\05D2\05D9\05DD \05DE\05D9\05DE\05D9\05DF. \05D0\05DD \05EA\05E6\05D9\05D2 \05D0\05EA \05D4\05EA\05E8\05E9\05D9\05DD \05D0\05D5 \05D0\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'','),
unistr('\05EA\05D5\05DB\05DC \05D2\05DD \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05E7\05D9\05E9\05D5\05E8 \05D4\05E2\05E8\05D9\05DB\05D4 \05DB\05D3\05D9 \05DC\05E2\05E8\05D5\05DA \05D0\05EA \05D4\05D4\05D2\05D3\05E8\05D5\05EA.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282231605400035)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05E9\05D5\05DE\05E8 \05D0\05EA \05DE\05EA\05D5\05D5\05D4 \05D3\05D5\05D7 \05E1\05E8\05D9\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DC\05E9\05D9\05DE\05D5\05E9 \05E2\05EA\05D9\05D3\05D9. \05EA\05D5\05DB\05DC \05DC\05E1\05E4\05E7 \05E9\05DD \05D5\05DC\05E1\05E4\05E7 \05EA\05D9\05D0\05D5\05E8 \05D0\05D5\05E4\05E6\05D9\05D5\05E0\05DC\05D9. \05EA\05D5\05DB\05DC \05DC\05E9\05DE\05D5\05E8 \05E9\05DC\05D5\05E9\05D4 \05E1\05D5\05D2\05D9\05DD \05E9\05DC \05DE\05EA\05D5\05D5\05D9 \05D3\05D5\05D7 \05E1\05E8\05D9\05D2 \05E0\05EA\05D5\05E0\05D9\05DD:</p>'),
'<ul>',
unistr('<li><strong>\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E8\05D0\05E9\05D9\05EA</strong> (\05DE\05E4\05EA\05D7 \05D1\05DC\05D1\05D3). \05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05D4\05E8\05D0\05E9\05D9\05EA \05D4\05D9\05D0 \05D4\05D3\05D5\05D7 \05D4\05DE\05D5\05E6\05D2 \05D4\05E8\05D0\05E9\05D5\05DF. \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E9\05E0\05D5\05EA \05E9\05DD \05D0\05D5 \05DC\05DE\05D7\05D5\05E7 \05D1\05E8\05D9\05E8\05D5\05EA \05DE\05D7\05D3\05DC \05E8\05D0\05E9\05D9\05D5\05EA \05E9\05DC \05D3\05D5\05D7.</li>'),
unistr('<li><strong>\05D3\05D5\05D7 \05D7\05DC\05D5\05E4\05D9</strong> (\05DE\05E4\05EA\05D7 \05D1\05DC\05D1\05D3). \05DE\05D0\05E4\05E9\05E8 \05DC\05DE\05E4\05EA\05D7\05D9\05DD \05DC\05D9\05E6\05D5\05E8 \05DE\05E1\05E4\05E8 \05DE\05EA\05D5\05D5\05D9\05DD \05E9\05DC \05D3\05D5\05D7. \05E8\05E7 \05DE\05E4\05EA\05D7\05D9\05DD \05D9\05DB\05D5\05DC\05D9\05DD \05DC\05E9\05DE\05D5\05E8, \05DC\05E9\05E0\05D5\05EA \05E9\05DD \05D0\05D5 \05DC\05DE\05D7\05D5\05E7 \05D3\05D5\05D7 \05D7\05DC\05D5\05E4\05D9.</li>'),
unistr('<li><strong>\05D3\05D5\05D7 \05E4\05E8\05D8\05D9</strong> (\05DB\05DC \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD). \05D4\05DE\05E9\05EA\05DE\05E9 \05E9\05D9\05E6\05E8 \05D0\05EA \05DE\05EA\05D5\05D5\05D4 \05D4\05D3\05D5\05D7 \05D9\05DB\05D5\05DC \05DC\05D4\05E6\05D9\05D2, \05DC\05E9\05DE\05D5\05E8, \05DC\05E9\05E0\05D5\05EA \05E9\05DD \05D0\05D5 \05DC\05DE\05D7\05D5\05E7 \05D0\05EA \05D4\05D3\05D5\05D7.</li>'),
'</ul>',
unistr('<p>\05D0\05DD \05EA\05E9\05DE\05D5\05E8 \05D3\05D5\05D7\05D5\05EA \05DE\05D5\05EA\05D0\05DE\05D9\05DD \05D0\05D9\05E9\05D9\05EA, \05D9\05D5\05E6\05D2 \05D1\05D5\05E8\05E8 \05D3\05D5\05D7\05D5\05EA \05D1\05E1\05E8\05D2\05DC \05D4\05D7\05D9\05E4\05D5\05E9 \05E9\05DE\05E9\05DE\05D0\05DC \05DC\05D1\05D5\05E8\05E8 \05D4\05E9\05D5\05E8\05D5\05EA (\05DE\05D0\05E4\05D9\05D9\05DF \05D6\05D4 \05D0\05E4\05E9\05E8\05D9).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208334061399982)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05EA\05E8 \05E2\05DE\05D5\05D3\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198902887399975)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05D2\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209839117399983)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05D2\05E9\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214934627399987)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E0\05D0\05D9 \05D4\05D3\05D2\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263963009400022)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D2\05E0\05D5\05DF \05D4\05D3\05D2\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173950895399957)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D4\05D3\05D2\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283432645400036)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E4\05E7\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313023507400057)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D4 \05DC\05D0 \05E4\05E2\05D9\05DC\05D4 \05D0\05D7\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313197286400057)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D2\05D3\05E8\05D5\05EA \05DC\05D0 \05E4\05E2\05D9\05DC\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204981326399979)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4 \05DC\05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215901563399987)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05EA\05E7\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209375704399982)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9 \05D7\05D9\05E9\05D5\05D1 \05DC\05D0 \05EA\05E7\05E3. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168760467399953)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA \05D4\05E1\05D9\05D5\05DD \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05DE\05D0\05D5\05D7\05E8 \05DE\05EA\05D0\05E8\05D9\05DA \05D4\05D4\05EA\05D7\05DC\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223644261399993)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05D8\05D5\05D9 \05E1\05D9\05E0\05D5\05DF \05DC\05D0 \05EA\05E7\05E3. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291442520400042)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D0\05D9\05DC\05EA\05EA \05DE\05E1\05E0\05DF \05DC\05D0 \05EA\05E7\05E4\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313212943400057)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D4 \05DC\05D0 \05EA\05E7\05E4\05D4 \05D0\05D7\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313375398400058)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D2\05D3\05E8\05D5\05EA \05DC\05D0 \05EA\05E7\05E4\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264185951400022)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('(\05D1\05D3\05E7\05D5\05EA)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281190323400034)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D7\05DC \05D1-%1 \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281377821400034)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D7\05DC \05D1-%1 \05D4\05D1\05D0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281227371400034)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DC\05D0 \05D7\05DC \05D1-%1 \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281426340400034)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DC\05D0 \05D7\05DC \05D1-%1 \05D4\05D1\05D0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214001405399986)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'he'
,p_message_text=>'KeyPad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180106735399961)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05D5\05D9\05EA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207989380399981)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05DC\05EA\05D5\05D5\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200444704399976)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D5\05DD \05D4\05D0\05D7\05E8\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200628806399976)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05E2\05D4 \05D4\05D0\05D7\05E8\05D5\05E0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200156831399976)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05D5\05D3\05E9 \05E9\05E2\05D1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200231715399976)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E9\05D1\05D5\05E2 \05E9\05E2\05D1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200393334399976)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D9\05DE\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200522134399976)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E2\05D5\05EA \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199928532399976)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E0\05D9\05DD \05D4\05D0\05D7\05E8\05D5\05E0\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200051537399976)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E9\05E0\05D4 \05E9\05E2\05D1\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180096168399961)
,p_name=>'APEXIR_LINE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176896407399959)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D5 \05E2\05DD \05E9\05D8\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291314877400042)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E4\05D4 \05D6\05D0\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208895448399982)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DC \05E4\05D9 \05D4\05D4\05E2\05E8\05DB\05D4, \05D4\05E9\05D0\05D9\05DC\05EA\05D0 \05EA\05D7\05E8\05D5\05D2 \05DE\05DE\05E1\05E4\05E8 \05D4\05DE\05E9\05D0\05D1\05D9\05DD \05D4\05DE\05E8\05D1\05D9 \05D4\05DE\05D5\05EA\05E8. \05EA\05E7\05DF \05D0\05EA \05D4\05D2\05D3\05E8\05D5\05EA \05D4\05D3\05D5\05D7 \05D5\05E0\05E1\05D4 \05E9\05D5\05D1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191079678399969)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05E8\05D1\05D9 \05DC\05D3\05D5\05D7 \05D6\05D4 \05D4\05D5\05D0 %0 \05E9\05D5\05E8\05D5\05EA. \05D4\05D7\05DC \05DE\05E1\05E0\05DF \05DB\05D3\05D9 \05DC\05E6\05DE\05E6\05DD \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05D0 \05E9\05DC\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291910908400042)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05D1\05D9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292127512400042)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E6\05D9\05D5\05DF %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195068372399972)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05D3\05E7\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292095424400042)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05E2\05E8\05D9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291036359400041)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264509856400022)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207169143399981)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207089699399981)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8 \05D4\05DB\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318287698400061)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05DE\05D6\05D4\05D4 \05E1\05D8\05D8\05D9 \05E9\05DC \05D0\05D6\05D5\05E8 \05DB\05D9\05D5\05D5\05DF \05E9\05D4\05D3\05E3 \05DE\05DB\05D9\05DC \05DE\05E1\05E4\05E8 \05D3\05D5\05D7\05D5\05EA \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175513122399958)
,p_name=>'APEXIR_NAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202994509399978)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05D9\05DE\05D4 \05D7\05D3\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313981572400058)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D8\05D2\05D5\05E8\05D9\05D4 \05D7\05D3\05E9\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112203001612399978)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D9\05E9\05D5\05D1 \05D7\05D3\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197893394399974)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200939460399976)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D5\05DD \05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200780338399976)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05E2\05D4 \05D4\05D1\05D0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201285222399977)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05D5\05D3\05E9 \05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201123040399976)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05D1\05D5\05E2 \05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201010451399976)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D9\05DE\05D9\05DD \05D4\05D1\05D0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112200879023399976)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E2\05D5\05EA \05D4\05D1\05D0\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201475139399977)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05E9\05E0\05D9\05DD \05D4\05D1\05D0\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201338670399977)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05E0\05D4 \05D4\05D1\05D0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175829363399958)
,p_name=>'APEXIR_NO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216185501399987)
,p_name=>'APEXIR_NONE'
,p_message_language=>'he'
,p_message_text=>unistr('- \05DC\05DC\05D0 -')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263788308400022)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D4 \05DB\05EA\05D5\05D1\05EA \05D3\05D5\05D0"\05DC \05EA\05E7\05E4\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212658633399985)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DB\05D9 Null \05EA\05DE\05D9\05D3 \05E8\05D0\05E9\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212581916399985)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DB\05D9 Null \05EA\05DE\05D9\05D3 \05D0\05D7\05E8\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213014318399985)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D5\05DF Null %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209490721399982)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'he'
,p_message_text=>unistr('\05D6\05DE\05DF \05E4\05DC\05D0\05E9\05D1\05E7 \05E6\05E8\05D9\05DA \05DC\05D4\05D9\05D5\05EA \05DE\05E1\05E4\05E8\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209056627399982)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05E6\05E3 \05E6\05E8\05D9\05DA \05DC\05D4\05D9\05D5\05EA \05DE\05E1\05E4\05E8\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213551809399986)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E4\05E8\05D8\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174422055399957)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05EA\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283355700400036)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D9\05D5\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176304629399959)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159189995399946)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D9\05D5\05D5\05DF \05D4\05D3\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159881316399947)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E8\05D5\05D7\05D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159935576399947)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0\05D5\05E8\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159017060399946)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D5\05D3\05DC \05D4\05D3\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159685546399946)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'he'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159562588399946)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'he'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159748708399946)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159382587399946)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'he'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159247943399946)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'he'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112159494123399946)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'he'
,p_message_text=>'TABLOID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292498738400042)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05D5\05D6 \05DE\05EA\05D5\05DA \05D4\05E1\05E4\05D9\05E8\05D4 \05D4\05DB\05D5\05DC\05DC\05EA (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291600829400042)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05D5\05D6 \05DE\05EA\05D5\05DA \05D4\05E1\05D9\05DB\05D5\05DD \05D4\05DB\05D5\05DC\05DC (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290696615400041)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05D5\05D6 \05DE\05EA\05D5\05DA \05E1\05E4\05D9\05E8\05EA \05DB\05D5\05DC\05DC\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290592336400041)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05D5\05D6 \05DE\05EA\05D5\05DA \05E1\05D9\05DB\05D5\05DD \05DB\05D5\05DC\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179900451399961)
,p_name=>'APEXIR_PIE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D5\05D2\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239832476400005)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D9\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241362373400006)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E1\05DB\05D9\05DE\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241538005400006)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E1\05DB\05D5\05DD \05D1\05E2\05DE\05D5\05D3\05D4 \05E9\05E0\05D1\05D7\05E8\05D4 \05DB\05E2\05DE\05D5\05D3\05EA \05E9\05D5\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240708239400005)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05E6\05D9\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240518559400005)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05E6\05D9\05E8 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241174148400006)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E2\05DE\05D5\05D3\05EA \05E6\05D9\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141233343399932)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05E8\05D1\05D9 \05DC\05E9\05D0\05D9\05DC\05EA\05EA \05E6\05D9\05E8 \05DE\05D2\05D1\05D9\05DC \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1, \05D5\05DC\05D0 \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA. \05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05D7\05D5\05E8\05D2\05EA \05DE\05DE\05E1\05E4\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05E8\05D1\05D9 \05E9\05DC %0. \05D4\05D7\05DC \05DE\05E1\05E0\05DF \05DB\05D3\05D9 \05DC\05E6\05DE\05E6\05DD \05D0\05EA \05DE\05E1\05E4\05E8 \05D4\05E8\05E9\05D5\05DE\05D5\05EA \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D1\05E1\05D9\05E1 \05E9\05DC\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241056072400006)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D5\05DF \05E6\05D9\05E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210443755399983)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05D4\05E6\05D9\05E8 \05DE\05DB\05D9\05DC\05D4 \05D9\05D5\05EA\05E8 \05DE\05D3\05D9 \05E2\05E8\05DB\05D9\05DD \05E0\05D1\05D3\05DC\05D9\05DD, \05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05E4\05D9\05E7 SQL \05E9\05DC \05E6\05D9\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263882662400022)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E6\05D5\05D2\05D4 \05DE\05E7\05D3\05D9\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197972876399974)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112289560819400040)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D0\05E9\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264802792400023)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E8\05D0\05E9\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158923670399946)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC\05D5\05DC \05EA\05D2\05D9\05D5\05EA \05E0\05D2\05D9\05E9\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145879912399936)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8\05EA \05D8\05E7\05E1\05D8 \05E2\05E9\05D9\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222600302399992)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D8\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180524317399961)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D9\05D1\05D5\05E8\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176105240399958)
,p_name=>'APEXIR_RED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D3\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318193962400061)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05E1\05D8\05D8\05D9 \05E9\05DC \05D0\05D6\05D5\05E8 ID %0 \05DC\05D0 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207217408399981)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207348209399981)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05D4\05DB\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313437124400058)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05EA\05E8\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206822479399981)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 Control Break')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206531054399980)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05DE\05E1\05E0\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206681589399980)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05E4\05DC\05D0\05E9\05D1\05E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313597803400058)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05D0\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206976381399981)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05D4\05D3\05D2\05E9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313613745400058)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05E6\05D9\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294612426400044)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05E8 \05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275221621400030)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D4 \05E9\05DD \05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E9\05DC \05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216456278399988)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D4 \05E9\05DD \05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198200490399974)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292515531400042)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172713595399956)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E7\05D9\05D9\05DD \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9 \05E9\05DE\05D5\05E8 \05E2\05DD \05D4\05DB\05D9\05E0\05D5\05D9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222990249399992)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05D5\05D7 \05D0\05D9\05E0\05D5 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172876572399956)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E7\05D9\05D9\05DD \05DE\05D6\05D4\05D4 \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9 \05E9\05DE\05D5\05E8 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112214768382399986)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D5\05EA \05D3\05D5\05D7\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195568155399972)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199486201399975)
,p_name=>'APEXIR_RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180760002399962)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D7\05D6\05E8 \05D3\05D5\05D7 \05DC\05D4\05D2\05D3\05E8\05D5\05EA \05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175971496399958)
,p_name=>'APEXIR_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288618730400040)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05E9\05EA\05DE\05E9 \05D1-ROWID \05DB\05E2\05DE\05D5\05D3\05EA \05D4\05DE\05E4\05EA\05D7 \05D4\05E8\05D0\05E9\05D9\05EA \05DC\05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9 REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205921905399980)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265512363400023)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D5\05EA \05D1\05E2\05DE\05D5\05D3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240882099400005)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05D5\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240656140400005)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05E9\05D5\05E8\05D4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241299310400006)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E2\05DE\05D5\05D3\05EA \05E9\05D5\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241467394400006)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05E9\05D5\05E8\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05D9\05D5\05EA \05E9\05D5\05E0\05D4 \05DE\05E2\05DE\05D5\05D3\05EA \05D4\05E6\05D9\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220099516399990)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05DF \05E9\05D5\05E8\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195675409399972)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 %0 \05DE\05EA\05D5\05DA %1 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199691559399975)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E7\05E1\05D8 \05E9\05D5\05E8\05D4 \05DE\05DB\05D9\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175205465399958)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210093120399983)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E9\05DE\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209951848399983)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E9\05E0\05E9\05DE\05E8 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212116079399984)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05D5\05EA \05D4\05D3\05D5\05D7 \05D4\05E0\05D5\05DB\05D7\05D9\05D5\05EA \05D9\05E9\05DE\05E9\05D5 \05DB\05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05DC\05DB\05DC \05D4\05DE\05E9\05EA\05DE\05E9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112275133112400030)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8 \05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E9\05DC \05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112199327810399975)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8 \05D3\05D5\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313863145400058)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8 \05D3\05D5\05D7 *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266578316400024)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112204877444399979)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E8\05D2\05DC \05D7\05D9\05E4\05D5\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112313766035400058)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D9\05E4\05D5\05E9: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272004516400028)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9 \05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256012265400016)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05E0\05D1\05D7\05E8\05D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176989910399959)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('- \05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05D4 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198677359399975)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180487973399961)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('- \05D1\05D7\05E8 \05E4\05D5\05E0\05E7\05E6\05D9\05D4 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205611405399980)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('- \05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05EA ''\05E7\05D1\05E5 \05DC\05E4\05D9'' -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240339974400005)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('- \05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05EA \05E6\05D9\05E8 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291518115400042)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E9\05D5\05E8\05D4 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240447812400005)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('- \05D1\05D7\05E8 \05E2\05DE\05D5\05D3\05EA \05E9\05D5\05E8\05D4 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149115329399939)
,p_name=>'APEXIR_SEND'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155422136399943)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DC\05D7 \05DB\05D3\05D5\05D0\05E8 \05D0\05DC\05E7\05D8\05E8\05D5\05E0\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175676906399958)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E6\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198873887399975)
,p_name=>'APEXIR_SORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208140878399982)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05E2\05D5\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208251514399982)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05D1\05E1\05D3\05E8 \05D9\05D5\05E8\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294017204400044)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D3\05E8 \05DE\05D9\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202652617399978)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05D5\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213722313399986)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D8\05D8\05D5\05E1 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264208083400022)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E0\05D5\05D9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290999037400041)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145367081399936)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05DC\05D2 \05E2\05DD \05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05E0\05EA\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112290829521400041)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D7\05DC \05DE-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291784725400042)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D9\05DB\05D5\05DD %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281775876400035)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D6\05D5\05E8 = %0, \05D3\05D5\05D7 = %1, \05EA\05E6\05D5\05D2\05D4 = %2, \05D4\05EA\05D7\05DC\05EA \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA = %3, \05E1\05D9\05D5\05DD \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA = %4, \05E1\05D4"\05DB \05E9\05D5\05E8\05D5\05EA = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202375157399977)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D6\05D5\05E8 = %0, \05D3\05D5\05D7 = %1, \05EA\05E6\05D5\05D2\05D4 = %2, \05D4\05EA\05D7\05DC\05EA \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA = %3, \05E1\05D9\05D5\05DD \05D4\05E9\05D5\05E8\05D5\05EA \05D4\05DE\05D5\05E6\05D2\05D5\05EA = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174521026399957)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D1\05E2 \05D8\05E7\05E1\05D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191607408399970)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05DE\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191527069399969)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E2\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191496447399969)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E7\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191805395399970)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191770900399970)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112191994315399970)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112294464071400044)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D7\05DC\05E4\05EA \05DE\05E6\05D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207452290399981)
,p_name=>'APEXIR_TOP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DC\05D9\05D5\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287664472400039)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4 \05DC\05D0 \05DE\05E7\05D5\05D1\05E6\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208960904399982)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05D3\05D2\05E9\05D4 \05E6\05E8\05D9\05DA \05DC\05D4\05D9\05D5\05EA \05D9\05D9\05D7\05D5\05D3\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179248035399961)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05E0\05EA\05D5\05E0\05D9\05DD \05DC\05D0 \05E0\05EA\05DE\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207599278399981)
,p_name=>'APEXIR_UP'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05DE\05E2\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209180126399982)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D6\05DF \05E6\05D1\05E2 \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209292749399982)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D6\05DF \05DE\05E1\05DB\05EA \05EA\05D1\05E0\05D9\05EA \05EA\05E7\05E4\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112176490770399959)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112208074652399981)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA \05E6\05D9\05E8 \05DC\05E2\05E8\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215821430399987)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D3\05E8\05E9 \05E2\05E8\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179820020399961)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4 \05D0\05E0\05DB\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112283572785400036)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E0\05DB\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215140990399987)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05EA\05E8\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270390628400026)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D8 \05DE\05D1\05D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112315914708400059)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D3\05D5\05D7 \05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D4 \05EA\05E6\05D5\05D2\05EA %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270442311400027)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 ''\05E7\05D1\05E5 \05DC\05E4\05D9''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270267925400026)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05E1\05DE\05DC\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240153725400005)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05E6\05D9\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112215217002399987)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264470987400022)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198149438399974)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7 \05E2\05D1\05D5\05D3\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293100504400043)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D9\05DE\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293036937400043)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05E2\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112292939672400043)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D3\05E7\05D5\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293394154400043)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D7\05D5\05D3\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293280698400043)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05D1\05D5\05E2\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112293488964400043)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112291116322400041)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112174217450399957)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D4\05D5\05D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112175740015399958)
,p_name=>'APEXIR_YES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DF ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112207804904399981)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05DB\05D9\05DC \05D0\05EA \05D4\05EA\05D5\05D5\05D9\05DD < \05D0\05D5 > \05E9\05D0\05D9\05E0\05DD \05EA\05E7\05E4\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112230666849399998)
,p_name=>'APEX_REGION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D6\05D5\05E8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112158843791399946)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E4\05E8 \05EA\05E0\05D0\05D9 \05DE\05D5\05E7\05D3\05DD \05E9\05DC API')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178339855399960)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E7\05D1\05DC \05E2\05E8\05DA \05DC\05D4\05D2\05D3\05E8\05EA \05D9\05D9\05E9\05D5\05DD %0 \05DB\05D9\05D5\05D5\05DF \05E9\05D0\05E4\05E9\05E8\05D5\05EA \05D4\05D1\05E0\05D9\05D9\05D4 \05D4\05E7\05E9\05D5\05E8\05D4, \05D7\05E1\05D5\05DE\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178234571399960)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E7\05D1\05D5\05E2 \05E2\05E8\05DA \05DC\05D4\05D2\05D3\05E8\05EA \05D9\05D9\05E9\05D5\05DD %0 \05DB\05D9\05D5\05D5\05DF \05E9\05D0\05E4\05E9\05E8\05D5\05EA \05D4\05D1\05E0\05D9\05D9\05D4 \05D4\05E7\05E9\05D5\05E8\05D4, \05D7\05E1\05D5\05DE\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285919616400038)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05D4\05D2\05D3\05E8\05EA \05D4\05D9\05D9\05E9\05D5\05DD %0 \05D0\05D9\05E0\05D5 \05EA\05E7\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112285848513400038)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8\05EA \05D4\05D9\05D9\05E9\05D5\05DD \05D4\05DE\05D1\05D5\05E7\05E9\05EA %0 \05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286050223400038)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E7\05D1\05D5\05E2 \05D0\05EA \05D4\05D2\05D3\05E8\05EA \05D4\05D9\05D9\05E9\05D5\05DD %0 \05DC\05E2\05E8\05DA null')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166990716399952)
,p_name=>'BACK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153954758399942)
,p_name=>'BUILDER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E0\05D9\05D9\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218096182399989)
,p_name=>'BUTTON LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05D5\05D9\05EA \05DC\05D7\05E6\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153008645399941)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05DC\05E7\05EA CSS \05E9\05DC \05DC\05D7\05E6\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182200385399963)
,p_name=>'BUTTON_ID'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05D4\05DC\05D7\05E6\05DF \05E9\05D4\05D5\05E4\05E7 \05D9\05D4\05D9\05D4 \05D4\05DE\05D6\05D4\05D4 \05D4\05E1\05D8\05D8\05D9 \05E9\05DC \05D4\05DC\05D7\05E6\05DF, \05D0\05DD \05D4\05D5\05D2\05D3\05E8; \05D0\05DD \05DC\05D0 \05D4\05D5\05D2\05D3\05E8 \05D4\05D5\05D0 \05D9\05D4\05D9\05D4 \05DE\05D6\05D4\05D4 \05E9\05D4\05D5\05E4\05E7 \05D1\05D0\05D5\05E4\05DF \05E4\05E0\05D9\05DE\05D9 \05D1\05E4\05D5\05E8\05DE\05D8 ''B'' || [Internal Button ID]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145711650399936)
,p_name=>'CANDLESTICK'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E8\05E9\05D9\05DD \05E4\05DE\05D5\05D8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227227670399996)
,p_name=>'CENTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05DB\05D6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177243096399959)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E7\05E9\05EA %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168601095399953)
,p_name=>'CHECK$'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D5\05E8\05E8 \05E9\05D5\05E8\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112287759877400039)
,p_name=>'CHECKED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05D5\05DE\05DF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263236143400021)
,p_name=>'COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223786311399993)
,p_name=>'COMMENTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05D5\05EA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205285298399979)
,p_name=>'CONTINUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05E9\05DA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167262544399952)
,p_name=>'COPYRIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D6\05DB\05D5\05D9\05D5\05EA \05D9\05D5\05E6\05E8\05D9\05DD &copy; %0, \05DB\05DC \05D4\05D6\05DB\05D5\05D9\05D5\05EA \05E9\05DE\05D5\05E8\05D5\05EA.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210983108399984)
,p_name=>'COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05E4\05D9\05E8\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217638813399989)
,p_name=>'CREATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269996669400026)
,p_name=>'CREATED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D5\05E6\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270091584400026)
,p_name=>'CREATED_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D5\05E6\05E8 \05E2\05DC-\05D9\05D3\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194878011399972)
,p_name=>'CREATED_ON'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D5\05E6\05E8 \05D1\05EA\05D0\05E8\05D9\05DA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205439571399980)
,p_name=>'CUSTOM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216621014399988)
,p_name=>'CUSTOMIZE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D0\05DD \05D0\05D9\05E9\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218247724399989)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1 \05D4\05E2\05D3\05E4\05D5\05EA \05D3\05E3 \05DC\05DE\05E9\05EA\05DE\05E9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218367039399989)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D4\05E2\05D3\05E4\05D5\05EA \05D4\05E9\05EA\05E0\05D5 \05DC\05DE\05E9\05EA\05DE\05E9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218112915399989)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1 \05D4\05E2\05D3\05E4\05D5\05EA \05D3\05E3 \05DC\05DE\05E9\05EA\05DE\05E9 %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181969902399963)
,p_name=>'DAILY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D5\05DE\05D9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112153568752399942)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D1\05E5 \05E9\05D4\05D5\05E2\05DC\05D4 \05D0\05D9\05E0\05D5 \05EA\05E7\05E3 \05D0\05D5 \05E9\05D9\05E9 \05DC\05D5 \05E1\05D9\05D5\05DE\05EA \05E9\05D2\05D5\05D9\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177423920399959)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E2\05E9\05D4 \05E9\05D9\05DE\05D5\05E9 \05D1\05D1\05D5\05E8\05E8 XML \05D0\05D5 JSON \05DC\05D0 \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146716555399937)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D5\05E4\05D9\05DC \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D5\05D4\05E7\05D5\05D1\05E5 \05E9\05D4\05D5\05E2\05DC\05D4 \05DC\05D0 \05DE\05DB\05D9\05DC\05D9\05DD \05D0\05E3 \05E2\05DE\05D5\05D3\05EA \05D8\05D1\05DC\05EA \05D9\05E2\05D3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232437831399999)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05E0\05EA\05D5\05E0\05D9\05DD \05D1\05E7\05D5\05D1\05E5 \05E9\05D4\05D5\05E2\05DC\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232506940399999)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05E0\05EA\05D5\05E0\05D9\05DD \05D1\05D2\05D9\05DC\05D9\05D5\05DF \05D4\05E2\05D1\05D5\05D3\05D4 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112152328632399941)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D1\05E5 \05E9\05E6\05D5\05D9\05DF \05D0\05D9\05E0\05D5 \05E7\05D5\05D1\05E5 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112142710437399934)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05D9\05E0\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E1\05EA\05D9\05D9\05DE\05D4: %0 \05E9\05D5\05E8\05D5\05EA \05E2\05D5\05D1\05D3\05D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143916270399935)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05D9\05E0\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E1\05EA\05D9\05D9\05DE\05D4: %0 \05E9\05D5\05E8\05D5\05EA \05E2\05D5\05D1\05D3\05D5 \05E2\05DD \05E9\05D2\05D9\05D0\05D4 \05D0\05D7\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144206765399935)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05D9\05E0\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E1\05EA\05D9\05D9\05DE\05D4: %0 \05E9\05D5\05E8\05D5\05EA \05E2\05D5\05D1\05D3\05D5 \05E2\05DD %1 \05E9\05D2\05D9\05D0\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144033314399935)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05D9\05E0\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E1\05EA\05D9\05D9\05DE\05D4: \05E9\05D5\05E8\05D4 \05D0\05D7\05EA \05E2\05D5\05D1\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147089410399937)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05D9\05E0\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E1\05EA\05D9\05D9\05DE\05D4: \05E9\05D5\05E8\05D4 \05D0\05D7\05EA \05E2\05D5\05D1\05D3\05D4 \05E2\05DD \05E9\05D2\05D9\05D0\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144145508399935)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05E2\05D9\05E0\05EA \05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E1\05EA\05D9\05D9\05DE\05D4: \05E9\05D5\05E8\05D4 \05D0\05D7\05EA \05E2\05D5\05D1\05D3\05D4 \05DC\05DC\05D0 \05E9\05D2\05D9\05D0\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237743236400003)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05D9\05E2\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237833794400003)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05DE\05E7\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238660123400004)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E8\05DE\05D8 \05EA\05D0\05E8\05D9\05DA / \05DE\05E1\05E4\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302052547400049)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05D6\05D5\05E8 \05E2\05E8\05DA lookup \05E0\05DB\05E9\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112270544672400027)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05E4\05D5\05D9 \05E0\05EA\05D5\05E0\05D9\05DD / \05D8\05D1\05DC\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238754050400004)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234299890400001)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DC\05DC \05D4\05D8\05E8\05E0\05E1\05E4\05D5\05E8\05DE\05E6\05D9\05D4 \05E0\05DB\05E9\05DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210584100399983)
,p_name=>'DATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184676698399964)
,p_name=>'DAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184758615399965)
,p_name=>'DAYS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05DE\05D9\05DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223403383399993)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05E4\05D5\05D9 \05D1\05D0\05D2\05D9\05DD \05DC\05D0 \05D0\05D5\05E4\05E9\05E8 \05DC\05D9\05D9\05E9\05D5\05DD \05D6\05D4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112272211624400028)
,p_name=>'DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185466284399965)
,p_name=>'DELETE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D7\05E7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112145661024399936)
,p_name=>'DIAL_PCT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E2\05D5\05DF \05D7\05D5\05D2\05D4 (\05D0\05D7\05D5\05D6)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160154253399947)
,p_name=>'DOWNLOAD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E8\05D3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271344555400027)
,p_name=>'DUP_USER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05DE\05E9\05EA\05DE\05E9 \05DB\05E4\05D5\05DC \05D1\05EA\05D5\05DA \05E8\05E9\05D9\05DE\05D4.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167758277399952)
,p_name=>'EDIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177103508399959)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D4 \05DB\05EA\05D5\05D1\05EA \05D4\05D3\05D5\05D0"\05DC "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162213084399948)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05EA \05D3\05D5\05D0"\05DC \05D6\05D5 \05E0\05E9\05DC\05D7\05D4 \05E2\05DC-\05D9\05D3\05D9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271518413400027)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05EA\05D5\05D1\05EA \05D4\05D3\05D5\05D0"\05DC \05D0\05E8\05D5\05DB\05D4 \05DE\05D3\05D9. \05D4\05D2\05D1\05D5\05DC \05D4\05D5\05D0 240 \05EA\05D5\05D5\05D9\05DD.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205117196399979)
,p_name=>'ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234393867400001)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05D2\05D3\05D9\05E8 \05E2\05E8\05DA \05DE\05E7\05D5\05E8 \05D3\05E3 \05DC\05D0\05D6\05D5\05E8 \05E8\05E2\05E0\05D5\05DF \05D3\05E3 \05D7\05DC\05E7\05D9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196612397399973)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D5\05E6\05E8 \05E2\05DC-\05D9\05D3\05D9 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162509634399948)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D2 \05EA\05D5\05E7\05E3 \05D4\05E1\05D9\05E1\05DE\05D4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112156694461399944)
,p_name=>'FILE_EMPTY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D1\05E5 \05E8\05D9\05E7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236883500400002)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D5\05D3\05DC \05D4\05E7\05D5\05D1\05E5 \05E9\05D4\05D5\05E2\05DC\05D4 \05D2\05D3\05D5\05DC \05DE-%0 MB. \05D4\05E2\05DC\05D4 \05E7\05D5\05D1\05E5 \05E7\05D8\05DF \05D9\05D5\05EA\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164681788399950)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA \05D4\05DE\05E9\05EA\05DE\05E9 \05E0\05DB\05E9\05DC \05D5\05E7\05D5\05D1\05E5 \05D0\05D7\05D3 \05D0\05D5 \05D9\05D5\05EA\05E8 \05DC\05D0 \05D4\05D5\05D8\05E2\05E0\05D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164737538399950)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E4\05E2 \05D6\05D4 \05D0\05D5\05E1\05E8 \05E2\05DC \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05E9\05DC\05D0 \05D0\05D5\05DE\05EA\05D5 \05DC\05D4\05E2\05DC\05D5\05EA \05E7\05D1\05E6\05D9\05DD.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217702191399989)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E8\05E2\05D4 \05E9\05D2\05D9\05D0\05D4 \05D0\05D7\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216920074399988)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E8\05E2\05D5 %0 \05E9\05D2\05D9\05D0\05D5\05EA')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167154440399952)
,p_name=>'FORM_OF'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05DE\05EA\05D5\05DA %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201863536399977)
,p_name=>'GO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D9\05E6\05D5\05E2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301684977400049)
,p_name=>'HELP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D6\05E8\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154029331399942)
,p_name=>'HOME'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 \05D4\05D1\05D9\05EA')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184431212399964)
,p_name=>'HOUR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E2\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184547927399964)
,p_name=>'HOURS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E2\05D5\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168588315399953)
,p_name=>'ICON'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DE\05DC %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218521063399989)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D8\05D9 \05D0\05D9\05DE\05D5\05EA \05DC\05D4\05EA\05D7\05D1\05E8\05D5\05EA \05DC\05D0 \05EA\05E7\05E4\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112318000523400061)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05DC\05D0 \05EA\05E7\05E3 \05DC\05E4\05E8\05DE\05D8\05E8: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213221376399985)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E9\05DC \05D4\05D2\05D3\05E8\05D5\05EA \05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213302110399985)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D3\05D5\05D7 \05E9\05DE\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195708253399972)
,p_name=>'IR_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05EA %0. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195468356399972)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D7\05E9\05D1 \05E0\05D9\05D5\05D5\05D8 \05D8\05D5\05E4\05E1. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173042225399956)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0 \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172439957399956)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E7\05D9\05D9\05DD \05D0\05D6\05D5\05E8 \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9 \05D1\05D9\05D9\05E9\05D5\05DD %0, \05D3\05E3 %1 \05D5\05D0\05D6\05D5\05E8 %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112213199271399985)
,p_name=>'IR_STAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E6\05D2 \05DC\05DE\05E4\05EA\05D7\05D9\05DD \05D1\05DC\05D1\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201508795399977)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D3\05D5\05D7 \05D3\05E8\05D5\05E9 \05DE\05E4\05EA\05D7 \05D9\05D9\05D7\05D5\05D3\05D9 \05DB\05D3\05D9 \05DC\05D6\05D4\05D5\05EA \05DB\05DC \05E9\05D5\05E8\05D4. \05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05DE\05E4\05EA\05D7 \05E9\05E1\05D5\05E4\05E7 \05DC\05E9\05D0\05D9\05DC\05EA\05D0 \05D6\05D5. \05D4\05D2\05D3\05E8 \05E2\05DE\05D5\05D3\05EA \05DE\05E4\05EA\05D7 \05D9\05D9\05D7\05D5\05D3\05D9. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201632450399977)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E9\05D0\05D9\05DC\05EA\05EA \05D4\05D3\05D5\05D7 \05D3\05E8\05D5\05E9 \05DE\05E4\05EA\05D7 \05D9\05D9\05D7\05D5\05D3\05D9 \05DB\05D3\05D9 \05DC\05D6\05D4\05D5\05EA \05DB\05DC \05E9\05D5\05E8\05D4. \05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05DE\05E4\05EA\05D7 \05E9\05E1\05D5\05E4\05E7 \05DC\05E9\05D0\05D9\05DC\05EA\05D0 \05D6\05D5. \05E2\05E8\05D5\05DA \05D0\05EA \05EA\05DB\05D5\05E0\05D5\05EA \05D4\05D3\05D5\05D7 \05DB\05D3\05D9 \05DC\05D4\05D2\05D3\05D9\05E8 \05E2\05DE\05D5\05D3\05EA \05DE\05E4\05EA\05D7 \05D9\05D9\05D7\05D5\05D3\05D9. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238993695400004)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E7\05D5\05D1\05E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238880385400004)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05E8\05D5\05E8 \05D5\05E9\05DE\05D5\05D8 \05E7\05D5\05D1\05E5 \05DB\05D0\05DF \05D0\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167449742399952)
,p_name=>'ITEMS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D9\05D8\05D9\05DD\00A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196843971399973)
,p_name=>'ITEM_VALUE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05E4\05E8\05D9\05D8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211237640399984)
,p_name=>'LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05D5\05D9\05EA ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223321915399993)
,p_name=>'LANGUAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E4\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185156230399965)
,p_name=>'LAST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05E8\05D5\05DF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164598916399950)
,p_name=>'LENGTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E8\05DA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217871521399989)
,p_name=>'LOGIN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D7\05D1\05E8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256442053400016)
,p_name=>'MANAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05D4\05D5\05DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321084987400063)
,p_name=>'MAXIMIZE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05DC')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184266881399964)
,p_name=>'MINUTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E7\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184311467399964)
,p_name=>'MINUTES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E7\05D5\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271790831400027)
,p_name=>'MISSING_AT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E1\05E8 \05D4\05EA\05D5 "@" \05D1\05DB\05EA\05D5\05D1\05EA \05D4\05D3\05D5\05D0"\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271972166400028)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D6\05D4\05E8\05D4: \05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D4 \05EA\05D1\05E0\05D9\05EA \05E9\05DC \05D3\05E3 \05D3\05D5-\05E9\05D9\05D7 \05DC\05D3\05E3 %0 \05D1\05D9\05D9\05E9\05D5\05DD %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271643486400027)
,p_name=>'MISSING_DOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E1\05E8 \05D4\05EA\05D5 "." \05D1\05D3\05D5\05DE\05D9\05D9\05DF \05E9\05DC \05DB\05EA\05D5\05D1\05EA \05D4\05D3\05D5\05D0"\05DC.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220809863399991)
,p_name=>'MODULE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05D3\05D5\05DC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177939476399960)
,p_name=>'MONTH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181763052399962)
,p_name=>'MONTHLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178084381399960)
,p_name=>'MONTHS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D3\05E9\05D9\05DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210877205399983)
,p_name=>'MOVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278364770400032)
,p_name=>'MOVE_FROM'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8 \05DE-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278464791400032)
,p_name=>'MOVE_TO'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D1\05E8\05D4 \05D0\05DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112198020367399974)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E4\05E2\05D5\05DC\05EA \05DE\05D7\05D9\05E7\05D4 \05E9\05DC \05DE\05E1\05E4\05E8 \05E9\05D5\05E8\05D5\05EA: \05E9\05D5\05E8\05D4 = %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197089619399973)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E1\05D5\05E8 \05E9\05D9\05D4\05D9\05D4 \05DE\05E9\05EA\05DE\05E9 \05E6\05D9\05D1\05D5\05E8\05D9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154233081399942)
,p_name=>'NAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211038360399984)
,p_name=>'NEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D3\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177739152399959)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05DB\05DC \05DC\05D4\05EA\05D7\05D1\05E8 \05D0\05DC %0 \05E2\05DC-\05D9\05D3\05D9 \05DE\05E2\05D1\05E8 \05D0\05DC:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177871244399960)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05D4 \05E2\05DC \05D7\05E9\05D1\05D5\05DF %0 \05D7\05D3\05E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301883315400049)
,p_name=>'NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220735442399991)
,p_name=>'NO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112316025111400059)
,p_name=>'NOBODY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E3 \05D0\05D7\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185567854399965)
,p_name=>'NOT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226358316399995)
,p_name=>'NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0-''Null''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197187368399974)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D5 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216787596399988)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05E0\05EA\05D5\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225883015399995)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0 \05D3\05D5\05D7 \05E0\05D9\05EA\05DF \05DC\05E2\05D3\05DB\05D5\05DF. \05E0\05D9\05EA\05DF \05DC\05D1\05E6\05E2 \05E4\05E2\05D5\05DC\05D5\05EA \05E9\05DC \05E2\05D3\05DB\05D5\05DF \05D5\05DE\05D7\05D9\05E7\05D4 \05DC\05DE\05E1\05E4\05E8 \05E9\05D5\05E8\05D5\05EA \05E8\05E7 \05D1\05D8\05E4\05E1\05D9\05DD \05D8\05D1\05DC\05D0\05D9\05D9\05DD \05DE\05E1\05D5\05D2 ''\05D3\05D5\05D7 \05E0\05D9\05EA\05DF \05DC\05E2\05D3\05DB\05D5\05DF''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226751251399995)
,p_name=>'OK'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E7\05D9\05D9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222494314399992)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'he'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112319886916400062)
,p_name=>'ORA_06550'
,p_message_language=>'he'
,p_message_text=>unistr('ORA-06550: \05E9\05D5\05E8\05D4 %0, \05E2\05DE\05D5\05D3\05D4 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269357944400026)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05EA\05D4 \05DE\05E9\05EA\05DE\05E9 \05D1\05D3\05E4\05D3\05E4\05DF \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05DE\05D9\05D5\05E9\05DF. \05DC\05E7\05D1\05DC\05EA \05E8\05E9\05D9\05DE\05D4 \05E9\05DC \05D3\05E4\05D3\05E4\05E0\05D9\05DD \05E0\05EA\05DE\05DB\05D9\05DD, \05E2\05D9\05D9\05DF \05D1\05DE\05D3\05E8\05D9\05DA Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170707936399954)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D1\05D5\05E7\05E9 \05E1\05DC \05E9\05D5\05E8\05D5\05EA \05DC\05D0 \05EA\05E7\05E3; \05E0\05EA\05D5\05E0\05D9 \05D4\05DE\05E7\05D5\05E8 \05E9\05DC \05D4\05D3\05D5\05D7 \05D4\05E9\05EA\05E0\05D5.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190835797399969)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05DE\05E1\05E4\05E8 \05D3\05E3 \05EA\05E7\05E3, \05DC\05D3\05D5\05D2\05DE\05D4 p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194480053399972)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194523645399972)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05DC \05D4\05D1\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194646623399972)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112194707512399972)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05DC \05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301783881400049)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E2\05D9\05DE\05D5\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232333628399999)
,p_name=>'PASSWORD'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D9\05E1\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177061293399959)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D9\05E1\05DE\05EA\05DA \05DC-%0 \05D4\05E9\05EA\05E0\05EA\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166867413399952)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05D0\05D9\05E0\05D4 \05EA\05D5\05D0\05DE\05EA \05DC\05DB\05DC\05DC\05D9 \05DE\05D5\05E8\05DB\05D1\05D5\05EA \05D4\05E1\05D9\05E1\05DE\05D4 \05E9\05DC \05D0\05EA\05E8 \05D6\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165984619399951)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05D4\05D7\05D3\05E9\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05D9\05D5\05EA \05E9\05D5\05E0\05D4 \05DE\05D4\05E1\05D9\05E1\05DE\05D4 \05D4\05D9\05E9\05E0\05D4 \05D1-%0 \05EA\05D5\05D5\05D9\05DD \05DC\05E4\05D7\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166563117399951)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E1\05D5\05E8 \05E9\05D4\05E1\05D9\05E1\05DE\05D4 \05EA\05DB\05D9\05DC \05E9\05DD \05DE\05E9\05EA\05DE\05E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166794053399951)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05DE\05DB\05D9\05DC\05D4 \05DE\05D9\05DC\05D4 \05E4\05E9\05D5\05D8\05D4 \05D0\05E1\05D5\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166610542399951)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E1\05D5\05E8 \05E9\05D4\05E1\05D9\05E1\05DE\05D4 \05EA\05DB\05D9\05DC \05E9\05DD \05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165850345399951)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D9\05E1\05DE\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05DB\05D9\05DC \05DC\05E4\05D7\05D5\05EA %0 \05EA\05D5\05D5\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166095465399951)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05DB\05D9\05DC \05DC\05E4\05D7\05D5\05EA \05EA\05D5 \05D0\05DC\05E4\05D0\05D1\05D9\05EA\05D9 \05D0\05D7\05D3 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166473223399951)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05DB\05D9\05DC \05DC\05E4\05D7\05D5\05EA \05EA\05D5 \05D0\05DC\05E4\05D0\05D1\05D9\05EA\05D9 \05D0\05D7\05D3 \05D1\05D0\05D5\05EA \05E7\05D8\05E0\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166189125399951)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05DB\05D9\05DC \05DC\05E4\05D7\05D5\05EA \05EA\05D5 \05DE\05E1\05E4\05E8\05D9 \05D0\05D7\05D3 (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166217954399951)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05DB\05D9\05DC \05DC\05E4\05D7\05D5\05EA \05EA\05D5 \05E4\05D9\05E1\05D5\05E7 \05D0\05D7\05D3 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112166347331399951)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05D9\05E1\05DE\05D4 \05D7\05D9\05D9\05D1\05EA \05DC\05D4\05DB\05D9\05DC \05DC\05E4\05D7\05D5\05EA \05EA\05D5 \05D0\05DC\05E4\05D0\05D1\05D9\05EA\05D9 \05D0\05D7\05D3 \05D1\05D0\05D5\05EA \05E8\05D9\05E9\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177591790399959)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05D3\05E2\05EA \05D0\05D9\05E4\05D5\05E1 \05E1\05D9\05E1\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164810953399950)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E1\05D5\05E8 \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05E1\05D9\05E1\05DE\05D4 \05DB\05D9\05D5\05D5\05DF \05E9\05E0\05E2\05E9\05D4 \05D1\05D4 \05E9\05D9\05DE\05D5\05E9 \05D1\05DE\05D4\05DC\05DA %0 \05D4\05D9\05DE\05D9\05DD \05D4\05E7\05D5\05D3\05DE\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245161346400008)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D9\05D8\05D9\05DD\00A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112245237745400008)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E8\05D9\05D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222230001399992)
,p_name=>'PERCENT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D7\05D5\05D6\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192516263399970)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112301960991400049)
,p_name=>'PREVIOUS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E7\05D5\05D3\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237392153400003)
,p_name=>'PRINT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D3\05E4\05E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221016558399991)
,p_name=>'PRIVILEGES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05E9\05D0\05D5\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190930855399969)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05E0\05D9\05D5\05EA \05DC\05D0\05D6\05D5\05E8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211137863399984)
,p_name=>'REPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220994462399991)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E7\05D5\05E4\05EA \05D3\05D9\05D5\05D5\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302119716400049)
,p_name=>'REPORT_LABEL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D7: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221682274399992)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D4"\05DB \05DC\05D3\05D5\05D7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170839799399954)
,p_name=>'RESET'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1 \05E2\05D9\05DE\05D5\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196769104399973)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1 \05E2\05D9\05DE\05D5\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225784960399994)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E4\05D5\05E1 \05E1\05D9\05E1\05DE\05D4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202552881399977)
,p_name=>'RESTORE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D7\05D6\05E8')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112234452134400001)
,p_name=>'RESULTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05E6\05D0\05D5\05EA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226823378399995)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D6\05E8\05D4 \05DC\05D9\05D9\05E9\05D5\05DD.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112227195856399995)
,p_name=>'RIGHT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05DE\05D9\05DF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256795112400017)
,p_name=>'ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210752185399983)
,p_name=>'ROW_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05E9\05D5\05E8\05D5\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112226272951399995)
,p_name=>'SAVE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DE\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222833569399992)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05D7\05DC\05D5\05E4\05D9\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223223701399993)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D9\05D0\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222731639399992)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E8\05D0\05E9\05D9\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223505287399993)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05E9 \05D9\05D5\05EA\05E8 \05DE-%0 \05E9\05D5\05E8\05D5\05EA \05D6\05DE\05D9\05E0\05D5\05EA. \05D4\05D2\05D3\05DC \05D0\05EA \05D1\05D5\05E8\05E8 \05D4\05E9\05D5\05E8\05D5\05EA \05DB\05D3\05D9 \05DC\05D4\05E6\05D9\05D2 \05E2\05D5\05D3 \05E9\05D5\05E8\05D5\05EA.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288963301400040)
,p_name=>'SEARCH'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E4\05E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184104456399964)
,p_name=>'SECONDS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D9\05D5\05EA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222318642399992)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D9\05D9\05DF \05D1\05DE\05E1\05DE\05DA \05D4\05DE\05E6\05D5\05E8\05E3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280076126400033)
,p_name=>'SELECT_ROW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D7\05E8 \05E9\05D5\05E8\05D4 ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222020810399992)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8 \05DE\05E6\05D1 ''\05DB\05D1\05D5\05D9'' \05E9\05DC \05E7\05D5\05E8\05D0 \05D4\05DE\05E1\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222156524399992)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8 \05DE\05E6\05D1 ''\05DE\05D5\05E4\05E2\05DC'' \05E9\05DC \05E7\05D5\05E8\05D0 \05D4\05DE\05E1\05DA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218420194399989)
,p_name=>'SHOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281893901400035)
,p_name=>'SHOW_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05D4\05DB\05DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112307989380400054)
,p_name=>'SIGN_IN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D7\05D1\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112257502311400017)
,p_name=>'SIGN_OUT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05E0\05EA\05E7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211751591399984)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05D9\05DE\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218932709399989)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D9\05DE\05D9\05DD \05DE\05E2\05DB\05E9\05D9\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211686203399984)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05E9\05E2\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218802244399989)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05E2\05D5\05EA \05DE\05E2\05DB\05E9\05D9\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211514590399984)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05D3\05E7\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218780825399989)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D3\05E7\05D5\05EA \05DE\05E2\05DB\05E9\05D9\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211980703399984)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05D7\05D5\05D3\05E9\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219129137399990)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D7\05D5\05D3\05E9\05D9\05DD \05DE\05E2\05DB\05E9\05D9\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219302765399990)
,p_name=>'SINCE_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05E2\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211433320399984)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05E9\05E0\05D9\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112218614486399989)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05E0\05D9\05D5\05EA \05DE\05E2\05DB\05E9\05D9\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112211806132399984)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05E9\05D1\05D5\05E2\05D5\05EA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219056007399990)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05D1\05D5\05E2\05D5\05EA \05DE\05E2\05DB\05E9\05D9\05D5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112212092816399984)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E0\05D9 %0 \05E9\05E0\05D9\05DD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219298611399990)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05E9\05E0\05D9\05DD \05DE\05E2\05DB\05E9\05D9\05D5')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205544230399980)
,p_name=>'STANDARD'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D8\05E0\05D3\05E8\05D8\05D9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221976047399992)
,p_name=>'START_DATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D0\05E8\05D9\05DA \05D4\05EA\05D7\05DC\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162454268399948)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05D9\05D1\05DC\05EA \05D4\05D5\05D3\05E2\05EA \05D3\05D5\05D0"\05DC \05D6\05D5 \05DE\05DE\05E0\05D5\05D9 \05D3\05D5\05D7 \05D0\05D9\05E0\05D8\05E8\05D0\05E7\05D8\05D9\05D1\05D9 \05E9\05E0\05D5\05E6\05E8 \05E2\05DC-\05D9\05D3\05D9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317183714400060)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E0\05D5\05D9\05D9\05DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265205682400023)
,p_name=>'TAB'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05E8\05D8\05D9\05E1\05D9\05D9\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184010974399964)
,p_name=>'TITLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05EA\05E8\05EA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167028311399952)
,p_name=>'TODAY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D5\05DD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221592277399991)
,p_name=>'TOTAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D4"\05DB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168072623399952)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8 \05DC\05D1\05D7\05D5\05E8 %0 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05DB\05DC \05D4\05D9\05D5\05EA\05E8.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146581086399937)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05D5\05E5 \05D4\05DB\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146888822399937)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05D5\05D5\05E5 \05DB\05DC \05DE\05D4 \05E9\05DC\05DE\05D8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146414233399937)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05D7\05D1 \05D4\05DB\05DC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146622781399937)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05D7\05D1 \05DB\05DC \05DE\05D4 \05E9\05DC\05DE\05D8\05D4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146934145399937)
,p_name=>'TREE.REPARENT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D3\05E8 \05D0\05D1 \05DE\05D7\05D3\05E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239113585400004)
,p_name=>'TREES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E6\05D9\05DD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112282630225400035)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E8\05D5\05E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112206243972399980)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05DE\05D5\05E8\05E9\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112253051736400014)
,p_name=>'UNAVAILABLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D6\05DE\05D9\05DF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219715689399990)
,p_name=>'UNKNOWN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D9\05D3\05D5\05E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163368333399949)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E8\05E2\05D4 \05E9\05D2\05D9\05D0\05EA \05D0\05D9\05DE\05D5\05EA \05DC\05D0 \05DE\05D6\05D5\05D4\05D4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165394459399950)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05DD \05D0\05D9\05E0\05DA \05DE\05E2\05D5\05E0\05D9\05D9\05DF \05DC\05E7\05D1\05DC \05E2\05D5\05D3 \05D4\05D5\05D3\05E2\05D5\05EA \05D3\05D5\05D0"\05DC, \05DC\05D7\05E5 \05E2\05DC <a href="%0">\05D1\05D9\05D8\05D5\05DC \05DE\05E0\05D5\05D9</a> \05DB\05D3\05D9 \05DC\05E0\05D4\05DC \05D0\05EA \05D4\05DE\05E0\05D5\05D9 \05E9\05DC\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112162373379399948)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05DD \05D0\05D9\05E0\05DA \05DE\05E2\05D5\05E0\05D9\05D9\05DF \05DC\05E7\05D1\05DC \05E2\05D5\05D3 \05D4\05D5\05D3\05E2\05D5\05EA \05D3\05D5\05D0"\05DC, \05E2\05D1\05D5\05E8 \05D0\05DC \05DB\05EA\05D5\05D1\05EA \05D4-URL \05D4\05D1\05D0\05D4 \05DB\05D3\05D9 \05DC\05E0\05D4\05DC \05D0\05EA \05D4\05DE\05E0\05D5\05D9 \05E9\05DC\05DA:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112197298124399974)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05E0\05EA\05D5\05E0\05D9\05DD \05DC\05D0 \05E0\05EA\05DE\05DA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185352414399965)
,p_name=>'UPDATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D3\05DB\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183941237399964)
,p_name=>'UPDATED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05D5\05D3\05DB\05DF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190617476399969)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05EA\05D5\05D1\05EA \05D4-URL \05D4\05DE\05D1\05D5\05E7\05E9\05EA \05D0\05E1\05D5\05E8\05D4. \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112210646576399983)
,p_name=>'USER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05EA\05DE\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112232264279399999)
,p_name=>'USERNAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05DE\05E9\05EA\05DE\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271834481400028)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05DE\05E9\05EA\05DE\05E9 \05D0\05E8\05D5\05DA \05DE\05D3\05D9. \05D4\05D2\05D1\05D5\05DC \05D4\05D5\05D0 %0 \05EA\05D5\05D5\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217440923399988)
,p_name=>'USERS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E9\05EA\05DE\05E9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112271444490400027)
,p_name=>'USER_EXISTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05DE\05E9\05EA\05DE\05E9 \05DB\05D1\05E8 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112286166318400038)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05DE\05D5\05E0\05EA \05E4\05E8\05D5\05E4\05D9\05DC \05DC\05DE\05E9\05EA\05DE\05E9 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173716852399957)
,p_name=>'VALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05E7\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167376973399952)
,p_name=>'VALIDATIONS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D3\05D9\05E7\05D5\05EA \05EA\05E7\05D9\05E0\05D5\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223056153399993)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E2\05E8\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266491253400024)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E2\05E8\05DA \05DC-%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192951332399970)
,p_name=>'VERTICAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E0\05DB\05D9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185295154399965)
,p_name=>'VIEW'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217557989399988)
,p_name=>'VIEWS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D1\05D8\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223813884399993)
,p_name=>'VIEW_ALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2 \05D4\05DB\05DC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112205083492399979)
,p_name=>'WARNING'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D6\05D4\05E8\05D4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184850040399965)
,p_name=>'WEEK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181849926399962)
,p_name=>'WEEKLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2\05D9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112184977036399965)
,p_name=>'WEEKS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D1\05D5\05E2\05D5\05EA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112223187666399993)
,p_name=>'WELCOME_USER'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D5\05DB\05D9\05DD \05D4\05D1\05D0: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221360398399991)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05E6\05D0 \05E2\05E8\05DA \05DE\05E1\05E4\05E8 \05DC\05D0 \05EA\05E7\05E3. \05D9\05E9 \05DC\05D5\05D5\05D3\05D0 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05E9\05D4\05D5\05D6\05E0\05D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221432101399991)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05E6\05D0 \05E2\05E8\05DA \05DE\05E1\05E4\05E8 \05DC\05D0 \05EA\05E7\05E3. \05D9\05E9 \05DC\05D5\05D5\05D3\05D0 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05E9\05D4\05D5\05D6\05E0\05D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164479841399950)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05E6\05D0 \05E2\05E8\05DA \05EA\05D0\05E8\05D9\05DA \05DC\05D0 \05EA\05E7\05E3. \05D9\05E9 \05DC\05D5\05D5\05D3\05D0 \05D0\05EA \05E4\05D5\05E8\05DE\05D8 \05D4\05EA\05D0\05E8\05D9\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112221245323399991)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05E6\05D0 \05E2\05E8\05DA \05DE\05E1\05E4\05E8 \05DC\05D0 \05EA\05E7\05E3. \05D9\05E9 \05DC\05D5\05D5\05D3\05D0 \05D0\05EA \05E4\05D5\05E8\05DE\05D8 \05D4\05DE\05E1\05E4\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173368623399956)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05E6\05D0 \05E2\05E8\05DA \05DC\05D0 \05EA\05E7\05E3 \05E9\05DC \05D7\05D5\05EA\05DE\05EA \05D6\05DE\05DF. \05D9\05E9 \05DC\05D5\05D5\05D3\05D0 \05D0\05EA \05E4\05D5\05E8\05DE\05D8 \05D7\05D5\05EA\05DE\05EA \05D4\05D6\05DE\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112195892708399973)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05DB\05E8\05D5\05DA \05D0\05EA "%0". \05D4\05E9\05EA\05DE\05E9 \05D1\05DE\05D9\05E8\05DB\05D0\05D5\05EA \05DB\05E4\05D5\05DC\05D5\05EA \05DC\05E4\05E8\05D9\05D8\05D9\05DD \05DE\05E8\05D5\05D1\05D9 \05D1\05D9\05D9\05D8\05D9\05DD, \05D0\05D5 \05D5\05D3\05D0 \05E9\05D0\05D5\05E8\05DA \05E4\05E8\05D9\05D8 \05D4\05D5\05D0 30 \05D1\05D9\05D9\05D8\05D9\05DD \05D0\05D5 \05E4\05D7\05D5\05EA. \05D4\05E9\05EA\05DE\05E9 \05D1\05EA\05D7\05D1\05D9\05E8 v() \05DB\05D3\05D9 \05DC\05D4\05E4\05E0\05D5\05EA \05DC\05E4\05E8\05D9\05D8\05D9\05DD \05D0\05E8\05D5\05DB\05D9\05DD \05DE-30 \05D1\05D9\05D9\05D8\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186376382399966)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D9\05E9\05D4 \05E0\05D3\05D7\05EA\05D4 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05D1\05D3\05D9\05E7\05EA \05D0\05D1\05D8\05D7\05EA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188891548399967)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D9\05E9\05D5\05DD \05DC\05D0 \05D6\05DE\05D9\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187201732399966)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1014 \05D4\05D9\05D9\05E9\05D5\05DD \05DC\05D0 \05E0\05DE\05E6\05D0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187304322399966)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D9\05E9\05D5\05DD = %0 \05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187775465399967)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D9\05E9\05D4 \05DC\05D9\05D9\05E9\05D5\05DD \05D6\05D4 \05DE\05D5\05D2\05D1\05DC\05EA. \05E0\05E1\05D4 \05E9\05D5\05D1 \05D9\05D5\05EA\05E8 \05DE\05D0\05D5\05D7\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187696526399967)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05D9\05E9\05D4 \05DC\05D9\05D9\05E9\05D5\05DD \05D6\05D4 \05DE\05D5\05D2\05D1\05DC\05EA \05DC\05DE\05E4\05EA\05D7\05D9 \05D9\05D9\05E9\05D5\05DE\05D9\05DD. \05E0\05E1\05D4 \05E9\05D5\05D1 \05D9\05D5\05EA\05E8 \05DE\05D0\05D5\05D7\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186821427399966)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-7744 \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E2\05D1\05D3 \05D4\05E1\05EA\05E2\05E4\05D5\05EA \05DC\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05E9\05DE\05D7\05D6\05D9\05E8\05D4 \05DB\05EA\05D5\05D1\05EA URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186795261399966)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-7744 \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E2\05D1\05D3 \05D4\05E1\05EA\05E2\05E4\05D5\05EA \05DC\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05E9\05DE\05D7\05D6\05D9\05E8\05D4 \05D3\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187038128399966)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1430 \05E7\05E8\05D9\05D0\05D4 \05DC\05D4\05E6\05D2\05D4 \05DE\05E2\05D9\05D1\05D5\05D3 \05D3\05E3, \05D0\05D9\05E0\05D4 \05E0\05EA\05DE\05DB\05EA: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188175721399967)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1018 \05E9\05D2\05D9\05D0\05D4 \05D1\05E0\05D9\05E7\05D5\05D9 \05DE\05D8\05DE\05D5\05DF \05E9\05DC\05D1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186573158399966)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1005 \05E1\05D5\05D2 \05D7\05D9\05E9\05D5\05D1 \05DC\05D0 \05D9\05D3\05D5\05E2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187485902399967)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1201 \05DC\05D0 \05D4\05D5\05D2\05D3\05E8 \05DE\05D6\05D4\05D4 \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 \05D1\05D0\05D9\05DE\05D5\05EA \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187547679399967)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 = %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112187135645399966)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-7620 \05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05E7\05D1\05D5\05E2 \05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4 \05DC\05D9\05D9\05E9\05D5\05DD (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169547424399954)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05D5\05DA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186245388399966)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1802 \05DC\05D0 \05E0\05DE\05E6\05D0 \05DE\05D6\05D4\05D4 \05D4\05E4\05E8\05D9\05D8 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185919078399965)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1002 \05DC\05D0 \05E0\05DE\05E6\05D0 \05DE\05D6\05D4\05D4 \05E4\05E8\05D9\05D8 \05DC\05E4\05E8\05D9\05D8 "%0" \05D1\05D9\05D9\05E9\05D5\05DD "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186075537399965)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05DC\05EA\05D9 \05E6\05E4\05D5\05D9\05D4, \05DC\05D0 \05E0\05DE\05E6\05D0 \05E9\05DD \05E4\05E8\05D9\05D8 \05D1\05E8\05DE\05EA \05D4\05D9\05D9\05E9\05D5\05DD \05D0\05D5 \05D4\05D3\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186436087399966)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05EA\05D4 \05E0\05DE\05E6\05D0 \05DB\05D1\05E8 \05D1\05D3\05E3 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E8\05D0\05E9\05D5\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112201940440399977)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05D4\05E4\05E8\05D9\05D8 (%0) \05D0\05D9\05E0\05D5 \05E4\05E8\05D9\05D8 \05E9\05D4\05D5\05D2\05D3\05E8 \05D1\05D3\05E3 \05D4\05E0\05D5\05DB\05D7\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164078800399950)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05D4\05E4\05E8\05D9\05D8 \05E2\05DC-\05D9\05D3\05D9 \05D4\05E2\05D1\05E8\05EA \05D0\05E8\05D2\05D5\05DE\05E0\05D8\05D9\05DD \05DC\05D9\05D9\05E9\05D5\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164386066399950)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'he'
,p_message_text=>unistr('(\05DC\05D0 \05E1\05D5\05E4\05E7 checksum)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163823863399949)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05EA\05DF \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05D4\05E4\05E8\05D9\05D8 \05DB\05E9\05D4\05D5\05D0 \05DE\05DC\05D5\05D5\05D4 \05D1-checksum "user-level bookmark".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163731316399949)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05EA\05DF \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05D4\05E4\05E8\05D9\05D8 \05DB\05E9\05D4\05D5\05D0 \05DE\05DC\05D5\05D5\05D4 \05D1-checksum "application-level bookmark".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163979809399949)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05EA\05DF \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05D4\05E4\05E8\05D9\05D8 \05DB\05E9\05D4\05D5\05D0 \05DE\05DC\05D5\05D5\05D4 \05D1-checksum "session".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163682080399949)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E4\05E8\05D9\05D8 \05D0\05D9\05DF \05D4\05D2\05E0\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188270658399967)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05E2\05D6\05E8\05D4 \05D6\05DE\05D9\05E0\05D4 \05DC\05D3\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112177352580399959)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05DE\05E8\05D7\05D1 \05D4\05E2\05D1\05D5\05D3\05D4 %0 \05D0\05D9\05DF \05D4\05E8\05E9\05D0\05D5\05EA \05DC\05E4\05D9\05E8\05D5\05E7 \05DB\05E1\05DB\05DE\05D4 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186655183399966)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1010 \05D7\05E8\05D9\05D2\05D4 \05DE\05D2\05D1\05D5\05DC \05D4\05E8\05E7\05D5\05E8\05E1\05D9\05D4 \05E9\05DC \05E2\05D9\05D1\05D5\05D3 \05E7\05D1\05DC\05EA ''\05D4\05E1\05EA\05E2\05E4\05D5\05EA \05DC\05D3\05E3''. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164270253399950)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05E4\05E2\05D9\05DC \05D3\05E3 \05D6\05D4 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05DB\05EA\05D5\05D1\05EA URL \05D0\05D5 \05D1\05D0\05DE\05E6\05E2\05D5\05EA GET \05D0\05D5 POST \05DC\05E4\05E8\05D5\05E6\05D3\05D5\05E8\05EA \05D4\05D4\05E6\05D2\05D4; \05D9\05E9 \05DC\05E7\05E8\05D5\05D0 \05DC\05D5 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05E1\05D5\05D2 \05D4\05D4\05E1\05EA\05E2\05E4\05D5\05EA ''\05D4\05E1\05EA\05E2\05E4\05D5\05EA \05DC\05D3\05E3''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112240951424400005)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E0\05D9\05E1\05D9\05D5\05DF \05DC\05E9\05DE\05D5\05E8 \05E2\05E8\05DA \05DC\05D0 \05E0\05D5\05DE\05E8\05D9 \05D1\05E4\05E8\05D9\05D8 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179085552399960)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05DB\05DE\05EA \05E4\05D9\05E8\05D5\05E7 \05D4\05D9\05D9\05E9\05D5\05DD "%0" \05DC\05D0 \05E7\05D9\05D9\05DE\05EA \05D1\05DE\05E1\05D3 \05D4\05E0\05EA\05D5\05E0\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112179143417399961)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05D9\05EA\05DF \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05D7\05E9\05D1\05D5\05E0\05D5\05EA \05D1\05DE\05E8\05D7\05D1 \05D4\05E2\05D1\05D5\05D3\05D4 \05D4''\05E4\05E0\05D9\05DE\05D9'' \05E8\05E7 \05DC\05E6\05D5\05E8\05DA \05D2\05D9\05E9\05D4 \05D0\05DC &PRODUCT_NAME. <a href="%0">Administration Services</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185821336399965)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-1029 \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D0\05D7\05E1\05DF \05E4\05E8\05D8\05D9 \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4. \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 = %0 \05E4\05E8\05D9\05D8 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188966812399968)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E2\05E6\05D5\05E8 \05DE\05E2\05E7\05D1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112186155791399966)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05DC\05EA\05D9 \05E6\05E4\05D5\05D9\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196113264399973)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D3\05DB\05D5\05DF \05DE\05D8\05DE\05D5\05DF \05D4\05D7\05DC\05E4\05D5\05EA: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189058502399968)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E1\05E4\05E7 \05D9\05D9\05E9\05D5\05DD \05D5\05D3\05E3 \05DB\05D3\05D9 \05DC\05D4\05E6\05D9\05D2 \05D0\05EA \05D4\05E2\05D6\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112209540002399983)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D4 \05D0\05D5\05D8\05D5\05DE\05E6\05D9\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190153226399968)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05DC\05E7\05D5 %0 \05DE\05D5\05E9\05D1\05D9 \05E2\05D1\05D5\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149436867399939)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D1\05E6\05E2 \05E7\05D5\05D3 %0! \05D9\05D9\05EA\05DB\05DF \05E9\05D6\05D4 \05DC\05D0 \05E0\05EA\05DE\05DA \05E2\05DC-\05D9\05D3\05D9 \05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD \05D0\05D5 \05E9\05DC\05D0 \05D0\05D5\05E4\05E9\05E8 \05D1\05D0\05DE\05E6\05E2\05D5\05EA \05E4\05E8\05DE\05D8\05E8 \05D4\05DE\05D5\05E4\05E2 MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112149236522399939)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05E0\05D5\05E2 \05D4\05E8\05D1-\05DC\05E9\05D5\05E0\05D9 \05D0\05D9\05E0\05D5 \05D6\05DE\05D9\05DF \05D1\05D2\05E8\05E1\05D4 \05D6\05D5 \05E9\05DC \05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170006064399954)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E2\05E8\05DA \05D0\05D5\05E1\05E3 \05E0\05EA\05D5\05E0\05D9 \05D4\05D9\05D9\05E9\05D5\05DD \05D0\05D9\05E0\05D5 \05D9\05DB\05D5\05DC \05DC\05D4\05D9\05D5\05EA null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169868825399954)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05EA\05DB\05D5\05E0\05EA \05D4\05D0\05D9\05D1\05E8 \05E9\05E6\05D5\05D9\05DF %0 \05D0\05D9\05E0\05D5 \05EA\05E7\05E3. \05DE\05E1\05E4\05E8 \05EA\05DB\05D5\05E0\05D4 \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05D1\05D9\05DF 1 \05DC-%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170375963399954)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E1\05E3 \05E0\05EA\05D5\05E0\05D9 \05D9\05D9\05E9\05D5\05DD \05E7\05D9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170168265399954)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D0\05D5\05E1\05E3 \05E0\05EA\05D5\05E0\05D9\05DD \05DC\05D0 \05D9\05DB\05D5\05DC \05DC\05D4\05D9\05D5\05EA null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170274220399954)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D0\05D5\05E1\05E3 \05E0\05EA\05D5\05E0\05D9\05DD \05DC\05D0 \05D9\05DB\05D5\05DC \05DC\05D4\05D9\05D5\05EA \05D2\05D3\05D5\05DC \05DE-255 \05EA\05D5\05D5\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169610825399954)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D5\05E1\05E3 \05E0\05EA\05D5\05E0\05D9 \05D4\05D9\05D9\05E9\05D5\05DD %0 \05DC\05D0 \05E7\05D9\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170420300399954)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E1\05DE\05DF \05D8\05E8\05DD \05E0\05E4\05EA\05D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169749090399954)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E8\05E6\05E3 \05D4\05D0\05D9\05D1\05E8\05D9\05DD %0 \05DC\05D0 \05E7\05D9\05D9\05DD \05D1\05D0\05D5\05E1\05E3 \05E0\05EA\05D5\05E0\05D9 \05D4\05D9\05D9\05E9\05D5\05DD %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112169940132399954)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E6\05E3 \05D4\05D0\05D9\05D1\05E8\05D9\05DD %0 \05DC\05D0 \05E7\05D9\05D9\05DD \05D1\05D0\05D5\05E1\05E3 \05E0\05EA\05D5\05E0\05D9 \05D4\05D9\05D9\05E9\05D5\05DD "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241741440400006)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA \05D4\05D4\05E6\05E4\05E0\05D4 "%0" \05D0\05D9\05E0\05D4 \05E0\05EA\05DE\05DB\05EA \05D1\05DE\05E2\05E8\05DB\05EA \05D6\05D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295279095400044)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E0\05D2\05D9\05E9\05D5\05EA \05E0\05D1\05D3\05E7\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189631796399968)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D2\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189725809399968)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05E4\05E9\05E8\05D5\05D9\05D5\05EA \05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA \05E9\05DC \05D3\05E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189853800399968)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189945077399968)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D5\05E6\05D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190080078399968)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E1\05EA\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189441055399968)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'he'
,p_message_text=>unistr('\05D1\05D3\05D5\05E7 \05D0\05EA \05D4\05D0\05D6\05D5\05E8\05D9\05DD \05E9\05E8\05E6\05D9\05EA \05DC\05DB\05DC\05D5\05DC \05D1\05D3\05E3 \05D6\05D4. \05D9\05D9\05EA\05DB\05DF \05E9\05D4\05D0\05D6\05D5\05E8\05D9\05DD \05D4\05E0\05D1\05D3\05E7\05D9\05DD \05DC\05D0 \05D9\05D5\05E6\05D2\05D5 \05D0\05DD \05D0\05D9\05E0\05DA \05D1\05D4\05E7\05E9\05E8 \05D4\05D9\05D9\05E9\05D5\05DD \05D4\05E0\05DB\05D5\05DF \05D0\05D5 \05D0\05DD \05D0\05D9\05DF \05DC\05DA \05D4\05E8\05E9\05D0\05D5\05EA \05E0\05DB\05D5\05E0\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189527000399968)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05E3 \05D6\05D4 \05D0\05D9\05E0\05D5 \05E0\05D9\05EA\05DF \05DC\05D4\05EA\05D0\05DE\05D4 \05D0\05D9\05E9\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295501021400045)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05DB\05DC \05DC\05D4\05EA\05D0\05D9\05DD \05D0\05D9\05E9\05D9\05EA \05D0\05EA \05D4\05DE\05E8\05D0\05D4 \05E9\05DC \05D9\05D9\05E9\05D5\05DD \05D6\05D4 \05E2\05DC-\05D9\05D3\05D9 \05E9\05D9\05E0\05D5\05D9 \05E1\05D2\05E0\05D5\05DF \05DE\05D5\05D8\05D9\05D1 \05D4\05E2\05D9\05E6\05D5\05D1. \05D1\05D7\05E8 \05E1\05D2\05E0\05D5\05DF \05DE\05D5\05D8\05D9\05D1 \05E2\05D9\05E6\05D5\05D1 \05DE\05D4\05E8\05E9\05D9\05DE\05D4 \05DC\05DE\05D8\05D4 \05D5\05DC\05D7\05E5 \05E2\05DC ''\05D4\05D7\05DC \05E9\05D9\05E0\05D5\05D9\05D9\05DD''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112296326160400045)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E6\05D2\05EA \05D0\05D6\05D5\05E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295414707400045)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05EA\05DE\05E9 \05D1\05D1\05E8\05D9\05E8\05EA \05D4\05DE\05D7\05D3\05DC \05E9\05DC \05E1\05D2\05E0\05D5\05DF \05D4\05D9\05D9\05E9\05D5\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112295368514400044)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E4\05E2\05D4 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238376561400004)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D3\05E7\05E1 \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05D9\05E9 \05D0\05DC\05D9\05D5 \05D4\05E4\05E0\05D9\05D4 \05D1\05E1\05DB\05D9\05DE\05D4 %0 \05DC\05D0 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141651038399933)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05E6\05D0\05EA CLOB \05D0\05D9\05E0\05D4 \05EA\05D5\05DE\05DB\05EA \05D1\05E4\05D5\05E8\05DE\05D8 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238011036400003)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E2\05D1\05E8 \05D4\05E2\05DE\05D5\05D3\05D4 \05E6\05E8\05D9\05DA \05DC\05D4\05D9\05D5\05EA \05D1\05EA\05D7\05D9\05DC\05EA \05DE\05E2\05E8\05DA \05D4\05E2\05DE\05D5\05D3\05D5\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238141969400003)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D3\05E7\05E1 \05E7\05D1\05D5\05E6\05EA \05D4\05E2\05DE\05D5\05D3\05D5\05EA \05E9\05D9\05E9 \05D0\05DC\05D9\05D5 \05D4\05E4\05E0\05D9\05D4 \05D1-%0 \05DC\05D0 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112155659472399943)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05E6\05D5\05D0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112160888042399947)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E8\05DE\05D8 \05D4\05D9\05E6\05D5\05D0 \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA XML \05E9\05E2\05D5\05E9\05D4 \05E9\05D9\05DE\05D5\05E9 \05D1-ORDS \05DB\05E9\05E8\05EA \05D4\05D3\05E4\05E1\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238475031400004)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D3\05E7\05E1 \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05D9\05E9 \05D0\05DC\05D9\05D5 \05D4\05E4\05E0\05D9\05D4 \05D1\05D4\05D3\05D2\05E9\05D4 %0 \05DC\05D0 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154101671399942)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'he'
,p_message_text=>unistr('\05E4\05D5\05E8\05DE\05D8 \05D9\05E6\05D5\05D0 \05DC\05D0 \05EA\05E7\05E3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112238204865400003)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05E0\05D3\05E7\05E1 \05D4\05E7\05D1\05D5\05E6\05D4 \05D4\05D0\05D1 \05E9\05D9\05E9 \05D0\05DC\05D9\05D5 \05D4\05E4\05E0\05D9\05D4 \05D1-%0 \05DC\05D0 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112263403479400021)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05DE\05D5\05D3\05D4 %1 \05E9\05DC \05D4\05D8\05D1\05DC\05D4 %0 \05D4\05D9\05D0 \05E2\05DE\05D5\05D3\05EA \05D6\05D4\05D5\05EA "GENERATED ALWAYS". \05D5\05D3\05D0 \05E9\05D0\05E3 \05E2\05DE\05D5\05D3\05EA \05DE\05E7\05D5\05E8 \05DC\05D0 \05DE\05D5\05E4\05EA\05D4 \05D0\05DC \05D4\05E2\05DE\05D5\05D3\05D4 %1 \05D1\05EA\05D9\05D1\05EA \05D4\05D3\05D5-\05E9\05D9\05D7 ''\05D4\05D2\05D3\05E8 \05EA\05E6\05D5\05E8\05D4''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180820471399962)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E8\05D5\05D5\05D7 \05D4-commit \05E9\05E6\05D5\05D9\05DF \05E7\05D8\05DF \05DE\05D3\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112180990311399962)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E1\05D5\05E4\05E7\05D5 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05D8\05E2\05D9\05E0\05EA \05E0\05EA\05D5\05E0\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182146468399963)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05E2\05DE\05D5\05D3\05D5\05EA \05DC\05D1\05D5\05E8\05E8 \05D4\05E9\05D5\05E8\05D5\05EA "%0". \05E0\05E1\05D4 \05DC\05D1\05E6\05E2 \05D2\05D9\05DC\05D5\05D9 \05D0\05D5\05D8\05D5\05DE\05D8\05D9 \05D0\05D5 \05DC\05D1\05D3\05D5\05E7 \05D0\05EA \05DE\05D1\05E0\05D4 \05D4-JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190450003399969)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05DE\05E6\05D0\05D5 \05D2\05D9\05DC\05D9\05D5\05E0\05D5\05EA \05E2\05D1\05D5\05D3\05D4 \05D1\05E7\05D5\05D1\05E5 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190351369399969)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D9\05DC\05D9\05D5\05DF \05D4\05E2\05D1\05D5\05D3\05D4 \05E9\05E6\05D5\05D9\05DF \05DC\05D0 \05E7\05D9\05D9\05DD \05D1\05E7\05D5\05D1\05E5 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112170585769399954)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D2\05E8\05E1\05D4 \05D4\05E0\05D5\05DB\05D7\05D9\05EA \05E9\05DC \05E0\05EA\05D5\05E0\05D9\05DD \05D1\05DE\05E1\05D3 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05D4\05E9\05EA\05E0\05EA\05D4 \05DE\05D0\05D6 \05E9\05D4\05DE\05E9\05EA\05DE\05E9 \05D0\05EA\05D7\05DC \05EA\05D4\05DC\05D9\05DA \05E2\05D3\05DB\05D5\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172963700399956)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D3\05DB\05D5\05DF \05E2\05DE\05D5\05D3\05D5\05EA \05D3\05D5\05D7: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277664003400032)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05DE\05D9\05E8 \05D0\05EA %0 \05DC-SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217129965399988)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05DE\05D9\05E8 \05D0\05EA \05D4\05E2\05DE\05D5\05D3\05D4 %0 \05DE\05E1\05D5\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD %1 \05DC-VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224119093399993)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05DE\05D5\05D3\05D4 "%0" \05E9\05E6\05D5\05D9\05E0\05D4 \05DC\05EA\05DB\05D5\05E0\05D4 "%1" \05DC\05D0 \05E0\05DE\05E6\05D0\05D4 \05D1\05DE\05E7\05D5\05E8 \05D4\05E0\05EA\05D5\05E0\05D9\05DD!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165402868399951)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D4\05DE\05E1\05E0\05DF %0 \05D0\05D9\05E0\05D5 \05EA\05D5\05DE\05DA \05D1\05E2\05DE\05D5\05D3\05D5\05EA \05DE\05E8\05D5\05D1\05D5\05EA \05E2\05E8\05DB\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112281027437400034)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E0\05DF "\05D1\05D9\05DF" \05DC\05D0 \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147506282399937)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E6\05D5\05D9\05DF \05E1\05D5\05D2 \05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD \05DC\05D0 \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147473947399937)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05E9\05D0\05D9\05DC\05EA\05D0 \05DC\05D0 \05EA\05E7\05E3. \05E1\05D5\05D2 \05E9\05D0\05D9\05DC\05EA\05D0 \05D7\05D9\05D9\05D1 \05DC\05D4\05D9\05D5\05EA \05D8\05D1\05DC\05D4, \05E9\05D0\05D9\05DC\05EA\05EA SQL, \05D0\05D5 \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA PL/SQL \05E9\05DE\05D0\05D7\05D6\05E8\05EA \05E9\05D0\05D9\05DC\05EA\05EA SQL.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217288422399988)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E0\05DB\05E9\05DC \05D1\05E4\05D9\05E8\05D5\05E7 \05E9\05D0\05D9\05DC\05EA\05EA SQL!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224291981399993)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05E7\05D5\05DD \05D4\05E2\05DE\05D5\05D3\05D4 \05E9\05E6\05D5\05D9\05DF %0 \05DC\05EA\05DB\05D5\05E0\05D4 "%1" \05DC\05D0 \05E0\05DE\05E6\05D0 \05D1\05DE\05E9\05E4\05D8 \05D4-SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112146061765399936)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05E2\05E9\05D4 \05E9\05D9\05DE\05D5\05E9 \05D1\05D9\05D5\05EA\05E8 \05DE\05D3\05D9 \05E4\05E8\05D9\05D8\05D9\05DD \05D1\05DE\05E1\05E0\05DF \05E8\05D1-\05E2\05E8\05DB\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224099224399993)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E6\05D5\05D9\05E0\05D4 \05E2\05DE\05D5\05D3\05D4 \05DC\05EA\05DB\05D5\05E0\05D4 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147302428399937)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D5\05E3 \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA PL/SQL \05DC\05D0 \05D0\05D7\05D6\05E8 \05E2\05E8\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112237210446400003)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9 REST \05D0\05D9\05E0\05D5 \05DE\05DB\05D9\05DC ''\05E4\05E2\05D5\05DC\05D4'' \05DC\05D8\05D9\05E4\05D5\05DC \05D1\05E4\05E2\05D5\05DC\05EA DML \05D4\05DE\05D1\05D5\05E7\05E9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112143239346399934)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05E8\05D4 \05DE-GeoJSON \05DC-SDO_GEOMETRY (\05E2\05DE\05D5\05D3\05D4 %0) \05D0\05D9\05E0\05D4 \05D6\05DE\05D9\05E0\05D4 \05D1\05DE\05E1\05D3 \05E0\05EA\05D5\05E0\05D9\05DD \05D6\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144330356399935)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05E8\05EA SDO_GEOMETRY (\05E2\05DE\05D5\05D3\05D4 %0) \05D0\05D9\05E0\05D4 \05EA\05D5\05DE\05DB\05EA \05D1\05DE\05E7\05D5\05E8\05D5\05EA \05E0\05EA\05D5\05E0\05D9 XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112151681272399940)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D5 %0 \05D0\05D9\05E0\05D5 \05E0\05EA\05DE\05DA \05DB\05DE\05E4\05E8\05D9\05D3 \05E8\05D1-\05E2\05E8\05DB\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112278985297400033)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05E4\05D5\05E0\05E7\05E6\05D9\05D4 \05D6\05D5 \05D1\05D4\05E7\05E9\05E8 \05E9\05D0\05D9\05DC\05EA\05D0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112144496885399935)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05E1\05E8 \05D4\05EA\05D0\05DE\05D4 \05E9\05DC \05E1\05D5\05D2 \05E0\05EA\05D5\05E0\05D9 \05E2\05DE\05D5\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147265381399937)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E8\05D9\05D2\05D4 \05DE\05D2\05D1\05D5\05DC\05D5\05EA \05DB\05E8\05D9\05DB\05D4 \05E4\05E0\05D9\05DE\05D9\05EA \05E9\05DC ORDS OUT. \05E6\05DE\05E6\05DD \05D0\05EA \05DB\05DE\05D5\05EA \05E9\05D5\05E8\05D5\05EA \05D4-DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112225088536399994)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05E4\05E8\05E7 \05D0\05EA \05EA\05D2\05D5\05D1\05D5\05EA \05D4-JSON \05DE\05D4\05E9\05E8\05EA \05D4\05DE\05E8\05D5\05D7\05E7: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112147134064399937)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D4\05E7\05E9\05E8 \05DC\05D0 \05D9\05D3\05D5\05E2 \05D0\05D5 \05E9\05D2\05D5\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112241698422400006)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05D2 \05D4\05E7\05D5\05D1\05E5 \05D0\05D9\05E0\05D5 \05E0\05EA\05DE\05DA \05E2"\05D9 \05D4-parser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196294214399973)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D9\05E9\05D4 \05DC\05D0 \05DE\05D5\05E8\05E9\05D9\05EA (\05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D5 wwv_flow_api.set_credentials).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173200846399956)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05D5\05E6\05E8 \05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4 \05DB\05D9\05D5\05D5\05DF \05E9\05D4\05D5\05D0 \05DB\05D1\05E8 \05E7\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112173132602399956)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05D5\05E6\05E8\05D4 \05E7\05D1\05D5\05E6\05EA \05DE\05E9\05EA\05DE\05E9\05D9\05DD \05DB\05D9\05D5\05D5\05DF \05E9\05D4\05D9\05D0 \05DB\05D1\05E8 \05E7\05D9\05D9\05DE\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183418799399964)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05DE\05E6\05D0 \05E9\05DD \05DE\05E9\05EA\05DE\05E9 \05DB\05E4\05D5\05DC \05DC-%0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183537030399964)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05D8\05E2\05D9\05E0\05EA \05DE\05E9\05EA\05DE\05E9\05D9\05DD. \05E0\05DB\05E9\05DC \05D1\05DE\05E9\05EA\05DE\05E9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193432702399971)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D9\05D5 \05E0\05D8\05E2\05E0\05D9\05DD %0 \05DE\05E9\05EA\05DE\05E9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193279006399971)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D9\05E1\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193348504399971)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E8\05E9\05D0\05D5\05EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193080141399971)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05DD \05D4\05DE\05E9\05EA\05DE\05E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269563521400026)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05EA\05DE\05D5\05E0\05D4 \05E9\05DC \05E4\05E8\05D9\05D8 \05D4\05D3\05E3 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189175266399968)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05E6\05D9\05D2 \05E4\05E8\05D9\05D8 \05D3\05E3 \05DB\05D9\05D5\05D5\05DF \05E9\05D8\05D5\05E4\05E1 \05D4-HTML \05D8\05E8\05DD \05E0\05E4\05EA\05D7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112154469820399942)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05EA \05D7\05D9\05E9\05D5\05D1 \05E2\05E8\05DA \05D1\05E8\05D9\05E8\05EA \05DE\05D7\05D3\05DC \05E9\05DC \05E4\05E8\05D9\05D8 \05DC\05E4\05E8\05D9\05D8 \05D4\05D3\05E3 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188474222399967)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05D9\05D1\05D5\05D3 \05DC\05D0\05D7\05E8 \05D7\05D9\05E9\05D5\05D1 \05E4\05E8\05D9\05D8 \05DC\05E4\05E8\05D9\05D8 \05D4\05D3\05E3 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188309422399967)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E2\05EA \05D7\05D9\05E9\05D5\05D1 \05E2\05E8\05DA \05DE\05E7\05D5\05E8 \05E4\05E8\05D9\05D8 \05DC\05E4\05E8\05D9\05D8 \05D4\05D3\05E3 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168102385399952)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D2\05D9\05E9\05D4 \05DC\05D0 \05DE\05D5\05E8\05E9\05D9\05EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188621800399967)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'he'
,p_message_text=>unistr('JavaScript \05DC\05D0 \05E0\05EA\05DE\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188785025399967)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'he'
,p_message_text=>unistr('\05E8\05E9\05D9\05DE\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112189326085399968)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D0\05EA\05D7\05DC \05E9\05D0\05D9\05DC\05EA\05D0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196511081399973)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05D3\05DB\05D5\05DF \05E9\05DC %0 \05DC\05D0 \05E0\05EA\05DE\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112190794619399969)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05E4\05E8\05D9\05D8 \05DC\05D0 \05EA\05E7\05E3: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112217064183399988)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DF \05E2\05D6\05E8\05D4 \05DC\05E4\05E8\05D9\05D8 \05D6\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181589493399962)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E4\05E7\05EA \05E9\05D0\05D9\05DC\05EA\05EA \05EA\05E8\05E9\05D9\05DD \05E0\05DB\05E9\05DC\05D4. \05D1\05D3\05D5\05E7 \05D0\05EA \05D4\05D2\05D3\05E8\05D5\05EA \05D4\05DE\05D9\05E4\05D5\05D9 \05E9\05DC \05DE\05E7\05D5\05E8 \05D5\05E2\05DE\05D5\05D3\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276302030400031)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05DE\05E1\05DE\05DA \05D4\05DE\05E6\05D5\05E8\05E3 \05D1\05D2\05D5\05D3\05DC %0 MB \05D7\05D5\05E8\05D2 \05DE\05D4\05D2\05D5\05D3\05DC \05D4\05DE\05E8\05D1\05D9 \05E9\05DC %1 MB \05DC\05DE\05E1\05DE\05DA \05DE\05E6\05D5\05E8\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182421580399963)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05E8\05DA \05DC\05D0 \05EA\05E7\05E3 \05DC\05E4\05E8\05DE\05D8\05E8 p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112299829421400048)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E8\05D2\05EA \05DE\05D4\05DE\05E1\05E4\05E8 \05D4\05DE\05E8\05D1\05D9 \05E9\05DC \05D4\05D5\05D3\05E2\05D5\05EA \05D3\05D5\05D0"\05DC \05DC\05DB\05DC \05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4. \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163431300399949)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05D4\05E4\05E2\05D9\05DC \05E4\05E8\05D5\05E6\05D3\05D5\05E8\05D4 \05D6\05D5 \05DE\05EA\05D5\05DA \05DE\05D5\05E9\05D1 \05E2\05D1\05D5\05D3\05D4 \05E9\05DC \05D9\05D9\05E9\05D5\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182329995399963)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E1\05D5\05E4\05E7 \05E2\05E8\05DA Null \05DC\05E4\05E8\05DE\05D8\05E8 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236395479400002)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D1\05E0\05D9\05EA \05D4\05D3\05D5\05D0"\05DC "%0" \05DC\05D0 \05E0\05DE\05E6\05D0\05D4 \05D1\05D9\05D9\05E9\05D5\05DD %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112312809021400057)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05D4\05D2\05D3\05D9\05E8 \05D0\05EA \05E4\05E8\05DE\05D8\05E8 \05D4\05DE\05D5\05E4\05E2 \05E9\05DC SMTP_HOST_ADDRESS \05DB\05D3\05D9 \05DC\05E9\05DC\05D5\05D7 \05D4\05D5\05D3\05E2\05D5\05EA \05D3\05D5\05D0"\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182090551399963)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DC\05D9\05DA \05DC\05E1\05E4\05E7 \05E0\05DE\05E2\05DF \05D4\05D5\05D3\05E2\05D4 \05DB\05D3\05D9 \05DC\05E9\05DC\05D5\05D7 \05D3\05D5\05D0\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112302282044400050)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05E7\05D9\05DD \05D7\05D9\05D1\05D5\05E8 SMTP \05DC\05E9\05E8\05EA \05D4\05D3\05D5\05D0"\05DC \05E9\05D4\05D5\05D2\05D3\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112276465878400031)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E7\05E8\05D9\05D0\05EA Ajax \05DC\05D0 \05EA\05E7\05E4\05D4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167800926399952)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D4 \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA Ajax \05DC\05EA\05D5\05E1\05E3 \05D1-%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266834527400024)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D4 \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA \05D1\05D9\05E6\05D5\05E2 \05DC\05EA\05D5\05E1\05E3 \05D1-%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167934826399952)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05D4\05D5\05D2\05D3\05E8\05D4 \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA \05D4\05E6\05D2\05D4 \05DC\05EA\05D5\05E1\05E3 \05D1-%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277320308400032)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05E1\05E3 \05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9 REST "%0" \05DC\05D0 \05DE\05DB\05D9\05DC \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA "Capabilities".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277260964400031)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05E1\05E3 \05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9 REST "%0" \05DC\05D0 \05DE\05DB\05D9\05DC \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277442160400032)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05E1\05E3 \05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9 REST "%0" \05DC\05D0 \05DE\05DB\05D9\05DC \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA \05D1\05D9\05E6\05D5\05E2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112277562152400032)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05E1\05E3 \05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9 REST "%0" \05DC\05D0 \05DE\05DB\05D9\05DC \05E4\05D5\05E0\05E7\05E6\05D9\05D9\05EA \05E9\05DC\05D9\05E4\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165633629399951)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05D5\05E2\05DC\05EA\05D4 \05E9\05D2\05D9\05D0\05D4 \05D1\05E7\05D5\05D3 PLSQL \05D1\05DE\05D4\05DC\05DA \05E2\05D9\05D1\05D5\05D3 \05E9\05DC \05EA\05D5\05E1\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172292670399956)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E2\05E8\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202831230399978)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05DE\05D9\05E8 \05D0\05EA \05E1\05D5\05D2 \05D4\05E0\05EA\05D5\05E0\05D9\05DD %0 \05DC-VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288410312400039)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05DE\05D5\05D3\05D4 "%0" \05E9\05E6\05D5\05D9\05E0\05D4 \05DC\05EA\05DB\05D5\05E0\05D4 "%1" \05DC\05D0 \05E0\05DE\05E6\05D0\05D4 \05D1\05DE\05E9\05E4\05D8 SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264721089400022)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05D5\05D1\05D4 \05DC\05E6\05D9\05D9\05DF \05E9\05D0\05D9\05DC\05EA\05EA \05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD \05D0\05D5 \05E8\05E9\05D9\05DE\05D4 \05E9\05DE\05D9\05EA \05E9\05DC \05E2\05E8\05DB\05D9\05DD \05DC-%0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112266305466400024)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05E9\05D2\05D5\05D9 \05E9\05DC \05E2\05DE\05D5\05D3\05D5\05EA \05E0\05D1\05D7\05E8\05D5 \05D1\05E9\05D0\05D9\05DC\05EA\05EA \05D4-SQL \05E9\05DC \05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD, \05D1\05E9\05D1\05D9\05DC %0. \05E2\05D9\05D9\05DF \05D1\05D3\05D5\05D2\05DE\05D0\05D5\05EA \05E9\05DC \05DE\05E9\05E4\05D8\05D9\05DD \05EA\05E7\05E4\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288252750400039)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E6\05D5\05D9\05E0\05D4 \05E2\05DE\05D5\05D3\05D4 \05DC\05EA\05DB\05D5\05E0\05D4 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317944862400061)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05E8\05DA \05E9\05D4\05D5\05D6\05DF %0 \05DC\05EA\05DB\05D5\05E0\05D4 "%1" \05D0\05D9\05E0\05D5 \05DE\05E1\05E4\05E8\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112269862414400026)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('%0 \05D4\05D5\05D0 \05DE\05E1\05D5\05D2 \05E0\05EA\05D5\05E0\05D9\05DD \05E9\05D2\05D5\05D9 \05D1\05DE\05E9\05E4\05D8 SQL. \05DE\05E1'' \05D4\05E2\05DE\05D5\05D3\05D4 %1 \05D4\05D5\05D0 %2 \05D0\05DA \05E6\05E4\05D5\05D9 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112288368182400039)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E2\05DE\05D5\05D3\05D4 "%0" \05E9\05E6\05D5\05D9\05E0\05D4 \05DC\05EA\05DB\05D5\05E0\05D4 "%1" \05DE\05DB\05D9\05DC\05D4 \05E1\05D5\05D2 \05E0\05EA\05D5\05E0\05D9\05DD %2 \05D0\05DA \05D0\05DE\05D5\05E8\05D4 \05DC\05D4\05DB\05D9\05DC %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112164911873399950)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05EA\05D5\05D5\05D4 \05D4\05D3\05D5\05D7 \05DC\05D0 \05E0\05DE\05E6\05D0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224936485399994)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05D0 \05E0\05D9\05EA\05DF \05DC\05D4\05E9\05EA\05DE\05E9 \05D1\05DE\05D0\05E4\05D9\05D9\05DF ''\05D7\05D9\05E9\05D5\05D1 \05E1\05DB\05D5\05DD'' \05DC\05D3\05D5\05D7\05D5\05EA \05D4\05DE\05D1\05D5\05E1\05E1\05D9\05DD \05E2\05DC \05DE\05E7\05D5\05E8 \05E0\05EA\05D5\05E0\05D9 REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112188522874399967)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('ERR-2904 \05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05D4\05D2\05D3\05D9\05E8 \05E2\05E8\05DA \05E7\05D9\05E6\05D5\05E8 \05D3\05E8\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112192845154399970)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4: \05E1\05D5\05D2 \05E7\05D9\05E6\05D5\05E8 \05D3\05E8\05DA \05DC\05D0 \05D9\05D3\05D5\05E2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112182805479399963)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E9\05DC\05D5\05E3 \05EA\05D5\05DB\05E0\05D9\05EA \05D0\05D9\05DE\05D5\05EA \05D6\05D4\05D5\05EA \05D1\05D9\05D9\05E9\05D5\05DD %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112256343301400016)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D6\05D4\05D4 \05D4\05D3\05D9\05D9\05E8 \05DB\05D1\05E8 \05E7\05D9\05D9\05DD \05DC\05DE\05D5\05E9\05D1 \05D4\05E2\05D1\05D5\05D3\05D4 \05D4\05E0\05D5\05DB\05D7\05D9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112193190372399971)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'he'
,p_message_text=>unistr('\05D3\05D5\05D0"\05DC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317315877400060)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9\05DE\05D5\05EA \05D4\05D6\05D4\05D5\05EA \05E0\05DB\05E9\05DC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112219605623399990)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'he'
,p_message_text=>unistr('cookie \05D0\05D7\05D3 \05D0\05D5 \05D9\05D5\05EA\05E8 \05E9\05D4\05D5\05D2\05D3\05E8\05D5 \05D1-apex_util.g_request_cookies \05DE\05DB\05D9\05DC\05D9\05DD \05E2\05E8\05DA \05DC\05D0 \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112202141151399977)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D2\05D5\05D1\05D4 \05DE-UDDI registry \05D4\05D9\05D9\05EA\05D4 \05DC\05D0 \05EA\05E7\05E4\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112165779024399951)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05EA\05D5\05D1\05EA \05D4-URL \05E9\05E1\05D5\05E4\05E7\05D4 \05DC\05D0 \05D4\05D7\05D6\05D9\05E8\05D4 \05DE\05E1\05DE\05DA WSDL \05EA\05E7\05E3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112168243108399953)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05DE\05DA \05D4-WSDL \05DE\05DB\05D9\05DC \05DE\05E1\05E4\05E8 \05DB\05E8\05D9\05DB\05D5\05EA SOAP. \05D4\05DE\05D5\05E6\05E8 &PRODUCT_NAME. \05EA\05D5\05DE\05DA \05E8\05E7 \05D1-WSDL''s \05E2\05DD \05DB\05E8\05D9\05DB\05EA SOAP \05D0\05D7\05EA. \05DC\05D7\05E5 \05E2\05DC ''\05E6\05D5\05E8 \05D4\05E4\05E0\05D9\05D4 \05DC\05E9\05D9\05E8\05D5\05EA \05E8\05E9\05EA \05D1\05D0\05D5\05E4\05DF \05D9\05D3\05E0\05D9'' \05DB\05D3\05D9 \05DC\05D4\05DE\05E9\05D9\05DA \05DC\05D9\05E6\05D5\05E8 \05D4\05E4\05E0\05D9\05D4 \05DC\05E9\05D9\05E8\05D5\05EA \05D6\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112236622957400002)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05EA\05D2\05D5\05D1\05D4 \05DE\05D4\05E9\05D9\05E8\05D5\05EA \05DC\05D0 \05D4\05D9\05D9\05EA\05D4 XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317259954400060)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D9\05D9\05EA\05DB\05DF \05E9\05D0\05E1\05D9\05DE\05D5\05DF \05D4\05D2\05D9\05E9\05D4 \05DC-OAuth \05D0\05D9\05E0\05D5 \05D6\05DE\05D9\05DF \05D0\05D5 \05E9\05E4\05D2 \05EA\05D5\05E7\05E4\05D5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112280439754400034)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'he'
,p_message_text=>unistr('\05D7\05E8\05D2\05EA \05DE\05D4\05DE\05E1\05E4\05E8 \05D4\05DE\05E8\05D1\05D9 \05E9\05DC \05D1\05E7\05E9\05D5\05EA \05E9\05D9\05E8\05D5\05EA \05D0\05D9\05E0\05D8\05E8\05E0\05D8 \05DC\05DB\05DC \05DE\05E8\05D7\05D1 \05E2\05D1\05D5\05D3\05D4. \05E4\05E0\05D4 \05DC\05DE\05E0\05D4\05DC\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112317427292400061)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'he'
,p_message_text=>unistr('\05D4\05E9\05E8\05EA \05D4\05D2\05D9\05D1 \05E2\05DD \05E1\05D5\05D2 \05D0\05E1\05D9\05DE\05D5\05DF OAuth \05E9\05D0\05D9\05E0\05D5 \05E0\05EA\05DE\05DA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167613681399952)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05DE\05DA \05D4-WSDL \05DC\05D0 \05D4\05DB\05D9\05DC \05DB\05E8\05D9\05DB\05D4 \05DC-SOAP, \05D4\05D3\05E8\05D5\05E9\05D4 \05DB\05D3\05D9 \05DC\05D4\05D5\05E1\05D9\05E3 \05D0\05EA \05D4\05D4\05E4\05E0\05D9\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112163554542399949)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'he'
,p_message_text=>unistr('WSDL \05DE\05D7\05D9\05D9\05D1 \05E4\05E8\05D8\05D9 \05D0\05D9\05DE\05D5\05EA. \05E1\05E4\05E7 \05D0\05EA \05E9\05DD \05D4\05DE\05E9\05EA\05DE\05E9 \05D5\05D4\05E1\05D9\05E1\05DE\05D4 \05DC\05D4\05DC\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112172347337399956)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E0\05D5\05E2 \05E2\05D9\05D1\05D5\05D3 \05D4\05EA\05DE\05D5\05E0\05D4 \05DC\05D0 \05D4\05E6\05DC\05D9\05D7 \05DC\05D4\05D1\05D9\05DF \05D0\05EA \05DE\05E1\05DE\05DA WSDL \05D6\05D4. \05DC\05D7\05E5 \05E2\05DC ''\05E6\05D5\05E8 \05D4\05E4\05E0\05D9\05D4 \05DC\05E9\05D9\05E8\05D5\05EA \05E8\05E9\05EA \05D1\05D0\05D5\05E4\05DF \05D9\05D3\05E0\05D9'' \05DB\05D3\05D9 \05DC\05D4\05DE\05E9\05D9\05DA \05DC\05D9\05E6\05D5\05E8 \05D4\05E4\05E0\05D9\05D4 \05DC\05E9\05D9\05E8\05D5\05EA \05D6\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112239283478400004)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'he'
,p_message_text=>unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E2\05D1\05D3 \05D0\05EA \05D4\05E2\05D3\05DB\05D5\05DF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112265015442400023)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05D5\05EA \05D4\05D4\05D7\05D6\05E8\05D4 \05D5\05D4\05EA\05E6\05D5\05D2\05D4 \05E9\05DC \05E8\05E9\05D9\05DE\05EA \05E2\05E8\05DB\05D9\05DD \05D4\05DF \05D6\05D4\05D5\05EA!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112264959941400023)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DC\05E8\05E9\05D9\05DE\05EA \05D4\05E2\05E8\05DB\05D9\05DD \05D0\05D9\05DF \05E2\05DE\05D5\05D3\05EA \05D4\05D7\05D6\05E8\05D4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196400760399973)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E9\05DC\05D9\05E4\05EA \05E2\05E8\05DA \05E2\05DE\05D5\05D3\05D4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220480939399991)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'he'
,p_message_text=>unistr('\05E0\05EA\05D5\05E0\05D9 \05D4\05D8\05D5\05E4\05E1 \05D4\05D8\05D1\05DC\05D0\05D9 \05D4\05E0\05D5\05DB\05D7\05D9 \05D9\05E9\05E0\05D9\05DD \05DE\05D3\05D9; \05E0\05EA\05D5\05E0\05D9 \05D4\05DE\05E7\05D5\05E8 \05D4\05E9\05EA\05E0\05D5.<br/> \05DC\05D7\05E5 <strong><a href="%0">\05DB\05D0\05DF</a></strong> \05DB\05D3\05D9 \05DC\05E0\05D8\05D5\05E9 \05D0\05EA \05D4\05E9\05D9\05E0\05D5\05D9\05D9\05DD \05D5\05DC\05D8\05E2\05D5\05DF \05DE\05D7\05D3\05E9 \05D0\05EA \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05DE\05DE\05E1\05D3 \05D4\05E0\05EA\05D5\05E0\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178535956399960)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E7\05D1\05D9\05E2\05EA \05DE\05D7\05E8\05D5\05D6\05EA \05E2\05D9\05DE\05D5\05D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178474871399960)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E7\05D1\05D5\05E2 \05DB\05D5\05EA\05E8\05D5\05EA \05E9\05D0\05D9\05DC\05EA\05D0:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178644541399960)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05D1\05D9\05E6\05D5\05E2 \05D4\05D7\05DC\05E4\05D5\05EA \05DC\05DB\05D5\05EA\05E8\05EA \05EA\05D7\05EA\05D5\05E0\05D4 \05E9\05DC \05D3\05D5\05D7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178712387399960)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E0\05DB\05E9\05DC \05D1\05E4\05D9\05E8\05D5\05E7 \05E9\05D0\05D9\05DC\05EA\05EA SQL:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183738429399964)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05E1\05E4\05E8 \05DE\05D6\05E2\05E8\05D9 \05DE\05D1\05D5\05E7\05E9 \05E9\05DC \05E9\05D5\05E8\05D5\05EA: %0; \05E9\05D5\05E8\05D5\05EA \05E9\05E0\05DE\05E6\05D0\05D5 \05D0\05DA \05DC\05D0 \05D4\05D5\05E6\05D2\05D5: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181268729399962)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05D4\05E9\05D0\05D9\05DC\05EA\05D0 #%0 (%1) \05D0\05D9\05E0\05D4 \05EA\05E7\05E4\05D4. \05E2\05DE\05D5\05D3\05D5\05EA \05D4\05DE\05D1\05D5\05E1\05E1\05D5\05EA \05E2\05DC HTML \05D6\05E7\05D5\05E7\05D5\05EA \05DC\05E9\05DE\05D5\05EA \05DB\05D9\05E0\05D5\05D9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112196369922399973)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D2\05D9\05D0\05D4 \05D1\05E7\05D1\05DC\05EA \05DB\05D5\05EA\05E8\05D5\05EA \05E9\05D0\05D9\05DC\05EA\05D0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178806116399960)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\05E9\05D2\05D9\05D0\05EA \05D3\05D5\05D7:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112216576283399988)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'he'
,p_message_text=>unistr('\05DE\05D9\05D9\05DF \05DC\05E4\05D9 \05E2\05DE\05D5\05D3\05D4 \05D6\05D5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181319186399962)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'he'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\05D0\05D9 \05D0\05E4\05E9\05E8 \05DC\05E4\05E8\05E7 \05D0\05EA \05D4\05E9\05D0\05D9\05DC\05EA\05D0, \05D1\05D3\05D5\05E7 \05D0\05EA \05EA\05D7\05D1\05D9\05E8 \05D4\05E9\05D0\05D9\05DC\05EA\05D0 \05E9\05DC\05DA.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220533012399991)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'he'
,p_message_text=>unistr('\05D8\05D5\05E4\05E1 \05D6\05D4 \05DE\05DB\05D9\05DC \05E9\05D9\05E0\05D5\05D9\05D9\05DD \05E9\05DC\05D0 \05E0\05E9\05DE\05E8\05D5. \05DC\05D7\05E5 \05E2\05DC ''\05D0\05D5\05E7\05D9\05D9'' \05DB\05D3\05D9 \05DC\05D4\05DE\05E9\05D9\05DA \05D1\05DC\05D9 \05DC\05E9\05DE\05D5\05E8 \05D0\05EA \05D4\05E9\05D9\05E0\05D5\05D9\05D9\05DD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112224834840399994)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'he'
,p_message_text=>unistr('\05EA\05D5\05DB\05E0\05D9\05EA \05E2\05D9\05DE\05D5\05D3 \05D4\05D3\05D5\05D7 (%0) \05D0\05D9\05E0\05D4 \05E0\05EA\05DE\05DB\05EA \05E2\05DD \05DE\05E7\05D5\05E8 \05D4\05E0\05EA\05D5\05E0\05D9\05DD \05E9\05E0\05D1\05D7\05E8.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112181108040399962)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E2\05DE\05D5\05D3\05EA \05D4\05E9\05D0\05D9\05DC\05EA\05D0 #%0 (%1) \05D0\05D9\05E0\05D4 \05EA\05E7\05E4\05D4, \05D4\05E9\05EA\05DE\05E9 \05D1\05DB\05D9\05E0\05D5\05D9 \05E2\05DE\05D5\05D3\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183830972399964)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D5\05EA %0 - %1 \05DE\05EA\05D5\05DA \05DE\05E2\05DC %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112222595303399992)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'he'
,p_message_text=>unistr('%0 - %1 \05DE\05EA\05D5\05DA \05D9\05D5\05EA\05E8 \05DE-%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112183673712399964)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05D5\05E8\05D5\05EA %0 - %1 of %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112167541992399952)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'he'
,p_message_text=>unistr('%0 - %1 \05DE\05EA\05D5\05DA %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178972613399960)
,p_name=>'Y'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112185016203399965)
,p_name=>'YEAR'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112178182848399960)
,p_name=>'YEARS'
,p_message_language=>'he'
,p_message_text=>unistr('\05E9\05E0\05D9\05DD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112220678669399991)
,p_name=>'YES'
,p_message_language=>'he'
,p_message_text=>unistr('\05DB\05DF ')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4542)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4542)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\05E9\05D5\05DC\05D7\05DF \05E2\05D1\05D5\05D3\05D4')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4542
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4542)
,p_name=>unistr('\05D4\05D5\05D3\05E2\05D5\05EA')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\05D4\05D5\05D3\05E2\05D5\05EA')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
