prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4481
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4481 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4481
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102267363403602')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'hr'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4481)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113351'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4481)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4481)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4481)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4481)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4481)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4481)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4481)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4481)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4481)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4481)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4481)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4481)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4481)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.hr'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4481
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4481)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4481)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4481)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4481)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4481)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4481)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4481)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.hr'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4481
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4481)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4481)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4481)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4481)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4481)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4481)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4481)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.hr'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4481
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4481)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4481)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4481)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.hr'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4481
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4481)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4481)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4481)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4481)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4481)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4481)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4481)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4481)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4481)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4481)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4481)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4481)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4481)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4481)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4481)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.hr'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4481
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4481)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4481)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4481)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4481)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4481)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4481)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4481)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4481)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4481)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4481)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4481)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4481)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4481)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4481)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4481)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.hr'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4481
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4481)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4481)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4481)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4481)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4481)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4481)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4481)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4481)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4481)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4481)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4481)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4481)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4481)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4481)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4481)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.hr'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4481
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4481)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4481)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4481)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4481)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4481)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4481)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4481)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4481)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4481)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4481)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4481)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4481)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4481)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4481)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4481)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4481
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4481)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4481
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4481)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4481
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4481)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4481
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4481)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4481
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4481)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4481
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4481
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4481)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4481)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4481)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4481)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4481)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4481)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4481)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4481)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4481)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4481)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4481)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4481)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4481)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4481)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4481)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4481)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4481)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4481)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4481)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4481)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4481)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4481)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4481)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4481)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4481)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4481)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4481)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4481)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4481)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4481
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4481)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4481)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4481)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4481)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4481)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4481
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4481)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4481
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4481)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4481
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4481)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4481
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4481)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4481
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4481)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4481
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4481)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4481)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4481)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4481)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4481)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4481)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4481)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4481)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4481)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4481
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4481)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4481)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4481)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4481)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4481)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4481)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4481)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4481
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4481)
,p_page_name=>'winlov'
,p_page_title=>unistr('Dijalo\0161ki okvir za pretra\017Eivanje')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('Pretra\017Eivanje')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Zatvori'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('Sljede\0107e &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Prethodno'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Redci #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4481
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4481)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4481
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4481)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4481)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4481)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4481)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4481)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4481)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4481)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4481)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4481)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4481)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4481)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4481)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4481)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4481)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4481)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4481)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4481)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4481)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4481)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4481)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4481)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4481)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4481)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4481)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4481)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4481)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4481)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4481)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4481)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4481)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4481)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4481)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4481)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4481)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4481)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4481)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4481)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4481)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4481)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4481)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4481)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4481)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4481)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4481)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4481)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4481)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4481)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4481)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4481)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4481)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4481)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4481)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4481)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4481)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4481)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4481)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4481)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4481)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4481)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4481)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4481)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4481)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4481)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4481)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4481)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4481)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4481)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4481)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4481)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4481)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4481)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4481)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4481)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4481)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4481)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4481)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4481)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4481)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4481)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4481)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4481)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4481)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4481)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4481)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4481)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4481)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4481)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4481)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4481)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4481)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4481)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4481)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4481)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4481)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4481)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4481)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4481)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4481)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4481)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4481)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4481)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4481)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4481)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4481)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4481)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4481)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4481)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4481)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4481)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4481)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4481)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4481)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4481)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4481)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4481)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4481)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4481)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4481)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4481)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4481)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4481)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4481)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4481)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4481)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4481)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4481)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4481)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4481)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4481)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4481)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4481)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4481)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4481)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4481)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4481)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4481)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4481)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4481)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4481)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4481)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4481)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4481)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4481)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4481)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4481)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4481)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4481)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4481)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4481)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4481)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4481)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4481)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4481)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4481)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4481)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4481)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4481)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4481)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4481)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4481)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4481)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4481)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4481)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4481)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4481)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4481)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4481)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4481)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4481)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4481)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4481)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4481)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4481)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4481)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4481)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4481)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4481)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4481)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4481)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4481)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4481)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4481)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4481)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4481)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4481)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4481)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353624604400096)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'hr'
,p_message_text=>'Stupac %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340704441400085)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'hr'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340619043400085)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisni\010Dko ime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397921587400131)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'hr'
,p_message_text=>'Pristup je odbijen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357612150400100)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'hr'
,p_message_text=>unistr('Stvoren je va\0161 %0 ra\010Dun.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343222031400087)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'hr'
,p_message_text=>unistr('Ra\010Dun je zaklju\010Dan.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333187216400079)
,p_name=>'AM_PM'
,p_message_language=>'hr'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467558282400184)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'hr'
,p_message_text=>'Prebacivanje %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475666329400190)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'hr'
,p_message_text=>'(Aktivno)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445155741400168)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ajax poziv vratio je pogre\0161ku poslu\017Eitelja %0 za %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375919367400114)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'hr'
,p_message_text=>unistr('Drugi naziv aplikacije "%0" ne mo\017Ee se pretvoriti u jedinstveni ID aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376029916400114)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>'Aplikacija s drugim nazivom "%0" ne postoji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365617919400106)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1816 Neo\010Dekivana pogre\0161ka pri pretvaranju drugog naziva aplikacije p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458566156400178)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Kontrolni broj aplikacije omogu\0107uje jednostavan na\010Din za utvr\0111ivanje implementira li se ista aplikacija u vi\0161e radnih prostora. Usporedite taj kontrolni zbroj kako biste utvrdili postoji li podudaranje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351466232400094)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi funkcije provjere autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336835699400082)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi funkcije provjere autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500390746400208)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'hr'
,p_message_text=>'Naziv klijenta %0 koji je vratio Oracle Cloud Identity Management nije odobren za domenu %1!<br/><a href="&LOGOUT_URL.">Ponovite prijavu</a> i navedite odobreni naziv klijenta ili promijenite URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334512804400080)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'hr'
,p_message_text=>unistr('Va\0161 ra\010Dun "%0" nema potrebne razvojne povlastice (DB_DEVELOPER ili DB_ADMINISTRATOR)<br/>za radni prostor "%1"! <a href="&LOGOUT_URL.">Ponovo se prijavite</a> nakon \0161to dobijete povlastice.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333692231400079)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'hr'
,p_message_text=>'Naziv klijenta koji je vratio Oracle Cloud Identity Management nije odobren za trenutni radni prostor!<br/><a href="&LOGOUT_URL.">Ponovite prijavu</a> i navedite odobreni naziv klijenta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334630239400080)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Iz sigurnosnih razloga pokretanje aplikacija u ovom radnom prostoru preko domene u URL-u nije dopu\0161teno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351194145400094)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Zatra\017Eite da DBA pokrene $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351013175400094)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'hr'
,p_message_text=>'SYS.DBMS_LDAP paket ne postoji ili nije valjan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350964389400094)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi funkcije LDAP korisnika.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351268469400094)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi LDAP provjere autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352053660400095)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka u p_flow_page argumentu za login_page postupak.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351627446400095)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'hr'
,p_message_text=>'p_session koji nije valjan u wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399572775400132)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'hr'
,p_message_text=>'Nepravilno oblikovan argument za wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351745850400095)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisni\010Dko ime koje je null proslije\0111eno u postupak prijave.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340508762400085)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'hr'
,p_message_text=>unistr('Za ponovnu prijavu pri\010Dekajte <span id="apex_login_throttle_sec">%0</span> s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341867878400086)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Blokiran je poku\0161aj prijave.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397300619400131)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Provjera autenti\010Dnosti "%0" nije prona\0111ena')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342187425400086)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'hr'
,p_message_text=>'ID sigurnosne grupe je null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351541119400095)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri izvr\0161avanju procesa naknadne provjere autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351379678400094)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi procesa pretprovjere autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352512945400095)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Otvorite URL u istom pregledniku u kojem ste inicirali zahtjev za ponovno postavljanje lozinke. Ako pritisnete URL za ponovno postavljanje lozinke i preusmjeri vas se na',
'stanicu za prijavu, ponovno inicirajte ponovno postavljanje lozinke i ostavite',
'preglednik otvoren.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497841691400206)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'hr'
,p_message_text=>'Ponovo postavi URL lozinke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334828250400080)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'hr'
,p_message_text=>unistr('Grupa potro\0161a\010Da upravitelja resursa %0 nije odobrena za %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334937363400080)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'hr'
,p_message_text=>'Upotrijebite DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP za dodjelu povlastice koja nedostaje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362943358400104)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi sentry funkcije sesije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363055642400104)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi funkcije provjere valjanosti sesije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363277865400104)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Zatra\017Eite od %0 administratora da konfigurira modul za jedinstvenu prijavu za Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372781000400111)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'hr'
,p_message_text=>unistr('SSO je vratio nedopu\0161teni %0 u %1 tokenu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351990294400095)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'hr'
,p_message_text=>unistr('Uredite shemu za provjeru autenti\010Dnosti i dodajte naziv aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372494590400111)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'hr'
,p_message_text=>unistr('Nedopu\0161teni pozivatelj %0 postupka:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372646439400111)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'hr'
,p_message_text=>'Sesija aplikacije koja nije valjana u URLC tokenu: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372253519400111)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka u portal_sso_redirect: nedostaju informacije o registraciji aplikacije: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363114006400104)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'hr'
,p_message_text=>'WWSEC_SSO_ENABLER_PRIVATE paket ne postoji ili nije valjan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112351898567400095)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'hr'
,p_message_text=>unistr('U shemi za provjeru autenti\010Dnosti ne mo\017Ee se prona\0107i naziv aplikacije registriranog partnera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372312501400111)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'hr'
,p_message_text=>unistr('Registrirajte ovu aplikaciju kako je opisano u instalacijskom vodi\010Du.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363369917400104)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi SSO provjere autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472760523400188)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'hr'
,p_message_text=>'Neodobreni URL:  %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362719963400104)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi provjere autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334764168400080)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'hr'
,p_message_text=>'Radni prostor "%0" nije aktivan. Obratite se administratoru.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335105265400081)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'hr'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341575935400086)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'hr'
,p_message_text=>'Pristup je odbila provjera sigurnosti aplikacije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341634761400086)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'hr'
,p_message_text=>'Pristup je odbila provjera sigurnosti stranice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341726710400086)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi odobrenja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405179048400137)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'hr'
,p_message_text=>unistr('Izra\0111eno s %0 upotrebom alata %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405208077400137)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'hr'
,p_message_text=>'ljubavlju'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463087979400181)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Opis doga\0111aja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462801777400181)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'hr'
,p_message_text=>unistr('Datum zavr\0161etka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463113117400181)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'hr'
,p_message_text=>unistr('ID doga\0111aja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462782195400181)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'hr'
,p_message_text=>unistr('Datum po\010Detka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462958594400181)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Naslov doga\0111aja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353533912400096)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka u sadr\017Eaju kontrolnog broja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353447574400096)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka u formatu kontrolnog broja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417447754400147)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'hr'
,p_message_text=>unistr('Kopirano u me\0111uspremnik.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417108717400147)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'hr'
,p_message_text=>unistr('Ovaj preglednik ne podr\017Eava kopiranje upotrebom gumba ili izbornika. Poku\0161ajte s Ctrl+C ili Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405637090400137)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'hr'
,p_message_text=>'Zatvori obavijest'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461617775400180)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'hr'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456136805400176)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'hr'
,p_message_text=>'Trenutno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456015345400176)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\010Detno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460212484400179)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora biti valjana boja. Primjer: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455918612400176)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'hr'
,p_message_text=>'Odaberite boju'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456220772400176)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Promijeni format boje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495461765400205)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'hr'
,p_message_text=>'Popis vrijednosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495590099400205)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'hr'
,p_message_text=>'Otvori popis za: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475759278400190)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'hr'
,p_message_text=>unistr('(Dovr\0161eno)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368081105400108)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'hr'
,p_message_text=>'Obrati se administratoru aplikacije.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382458020400119)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Obratite se administratoru aplikacije.',
unistr('Pojedinosti o ovom incidentu dostupne su putem ID-a ispravljanja pogre\0161ke "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460518866400179)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'hr'
,p_message_text=>unistr('Ispravite pogre\0161ke prije spremanja.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406593692400138)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111eno odgovaraju\0107ih rezultata: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406408744400138)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'hr'
,p_message_text=>unistr('Nije prona\0111en nijedan rezultat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476207811400191)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'hr'
,p_message_text=>unistr('Teku\0107i napredak')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460913366400180)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>'Datoteka navedena u stavki %0 ne postoji u APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449403572400171)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'hr'
,p_message_text=>unistr('Trenutna verzija podataka u bazi podataka promijenila se otkad je korisnik pokrenuo proces a\017Euriranja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418582808400148)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'hr'
,p_message_text=>unistr('Nemoj u\010Ditati')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465574005400183)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka predobrade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465307444400183)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'hr'
,p_message_text=>'Umetni redak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479474497400193)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'hr'
,p_message_text=>'Slijed: akcija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465497328400183)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'hr'
,p_message_text=>unistr('A\017Euriraj redak')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406900652400138)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sko\010Dni kalendar: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329543286400076)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329690831400076)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465746198400183)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora imati neku vrijednost.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465613163400183)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora biti valjani datum, primjerice %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333283604400079)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'hr'
,p_message_text=>unistr('#LABEL# mora biti izme\0111u %0 i %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333357686400079)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora biti %0 ili nakon.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333400741400079)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'hr'
,p_message_text=>'#LABEL#  mora biti %0 ili prije.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410425027400141)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'hr'
,p_message_text=>unistr('#LABEL# je ve\0107i od navedenog maksimalnog datuma %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410853934400142)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# ne odgovara formatu %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410346142400141)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# je manji od navedenog minimalnog datuma %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410554692400141)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# nije u valjanom rasponu od %0 do %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410778060400141)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# nije u valjanom rasponu godina od %0 do %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460804374400179)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'hr'
,p_message_text=>'Odustani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488073336400199)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'hr'
,p_message_text=>'Zatvori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490053714400201)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460630787400179)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'hr'
,p_message_text=>'U redu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460730708400179)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'hr'
,p_message_text=>'Spremi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366947086400107)
,p_name=>'APEX.ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334340626400080)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'hr'
,p_message_text=>unistr('Do\0161lo je do sljede\0107e pogre\0161ke pri izvr\0161avanju povratnog pozivanja postupanja s pogre\0161kama: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343068148400087)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Do\0161lo je do pogre\0161ke pri bojenju stranice pogre\0161ke: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335064349400081)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'hr'
,p_message_text=>unistr('Interna pogre\0161ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474814267400190)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Obratite se administratoru.',
unistr('Pojedinosti o ovom incidentu dostupne su putem ID-a ispravljanja pogre\0161ke "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469158300400186)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'hr'
,p_message_text=>unistr('Baza podataka otvorena je za pristup samo za \010Ditanje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499745009400208)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'hr'
,p_message_text=>'ORA-28353: Otvaranje walleta nije uspjelo. Podaci aplikacije trenutno nisu dostupni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469203974400186)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Na\017Ealost, ta stranica nije dostupna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336755607400082)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'hr'
,p_message_text=>unistr('Tehni\010Dke informacije (vidljivo samo razvojnim programerima)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432806948400159)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'hr'
,p_message_text=>unistr('Poruka o pogre\0161ci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446797429400169)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'hr'
,p_message_text=>unistr('O\010Dekivani format: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413453114400144)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisnik se ve\0107 nalazi na popisu za kontrolu pristupa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413332059400144)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'hr'
,p_message_text=>unistr('Potvrdite dodavanje sljede\0107eg broja korisnika: %0 na popis za kontrolu pristupa <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413838473400144)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'hr'
,p_message_text=>'Postoji duplicirani korisnik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413541739400144)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'hr'
,p_message_text=>unistr('U adresi e-po\0161te nedostaje znak at (@)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413612916400144)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'hr'
,p_message_text=>unistr('U adresi e-po\0161te nedostaje to\010Dka (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413712258400144)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisni\010Dko ime preduga\010Dko')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414094246400144)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'hr'
,p_message_text=>'Ovoj aplikaciji mogu pristupiti samo korisnici definirani na popisu za kontrolu pristupa aplikaciji'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414102433400144)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'hr'
,p_message_text=>unistr('Neo\010Dekivana vrijednost postavke kontrole pristupa: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413927833400144)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'hr'
,p_message_text=>unistr('Ovoj aplikaciji mogu pristupiti svi korisnici \010Dija je autenti\010Dnost provjerena')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456736252400177)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Onemogu\0107eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456684488400176)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Omogu\0107eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456912849400177)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('%0: onemogu\0107eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456859757400177)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('%0: omogu\0107eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456596721400176)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'hr'
,p_message_text=>'nije identificirano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449611041400171)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'hr'
,p_message_text=>'Preuzmi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406107645400138)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'hr'
,p_message_text=>'Primijenjeni filtar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447236410400170)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'hr'
,p_message_text=>'Primijeni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332127313400078)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'hr'
,p_message_text=>'Trakasti grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459969149400179)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'hr'
,p_message_text=>'Ostalo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332292380400078)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'hr'
,p_message_text=>'Tortni grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458686898400178)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331989807400078)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Broj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447739522400170)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('O\010Disti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447827771400170)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'hr'
,p_message_text=>unistr('O\010Disti sve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447906676400170)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'hr'
,p_message_text=>unistr('O\010Disti %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465142918400183)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'hr'
,p_message_text=>'Stupac %1, koji referencira facet %0, nije dostupan ili nije odobren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322395627400071)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Odaberite filtre za prikaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404370412400136)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'hr'
,p_message_text=>'Broj rezultata: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404499733400136)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'hr'
,p_message_text=>'Odabrano: %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407094569400138)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'hr'
,p_message_text=>'Trenutni filtri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323840489400072)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'hr'
,p_message_text=>'Popis filtara'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463675699400182)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'hr'
,p_message_text=>unistr('Ograni\010Denje zasebne vrijednosti (%0) prekora\010Deno za facet %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449253940400171)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>unistr('Facet %0 nije podr\017Ean za stupce DATE ili TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447362839400170)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'hr'
,p_message_text=>'Filtar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447463494400170)
,p_name=>'APEX.FS.GO'
,p_message_language=>'hr'
,p_message_text=>'Idi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448873315400171)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'hr'
,p_message_text=>'jednako %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332917622400079)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'hr'
,p_message_text=>unistr('sadr\017Ei %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332648739400079)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'hr'
,p_message_text=>unistr('ve\0107e od %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332735628400079)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'hr'
,p_message_text=>unistr('ve\0107e od ili jednako %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332464994400078)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'hr'
,p_message_text=>'manje od %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332511513400079)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'hr'
,p_message_text=>'manje od ili jednako %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332800939400079)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'hr'
,p_message_text=>unistr('zapo\010Dinje s %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335365608400081)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta podataka %0 (%1) nije podr\017Eana za facet polja unosa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325553638400073)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'hr'
,p_message_text=>unistr('Za facete s vi\0161e vrijednosti obavezne su baze podataka 12.2 ili novije verzije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449001750400171)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'hr'
,p_message_text=>unistr('Stupci pretra\017Eivanja nisu navedeni za facet %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322414334400071)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'hr'
,p_message_text=>unistr('Vi\0161e filtara')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404578288400136)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\010Detak raspona')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448596163400171)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'hr'
,p_message_text=>'%0 do %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448602205400171)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'hr'
,p_message_text=>'Iznad %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448784485400171)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'hr'
,p_message_text=>'Ispod %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404624221400136)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'hr'
,p_message_text=>'Kraj raspona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467496994400184)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'hr'
,p_message_text=>'Stavka popisa vrijednosti #%2 ("%1") za facet raspona %0 nije valjana (nedostaje razdjelnik "|").'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448941895400171)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'hr'
,p_message_text=>unistr('Ru\010Dni unos za facet raspona %0 trenutno nije podr\017Ean jer je stupac DATE ili TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448269705400170)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'hr'
,p_message_text=>'do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332054999400078)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'hr'
,p_message_text=>'Ukloni grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401191735400134)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'hr'
,p_message_text=>'Ponovo postavi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447635928400170)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447538374400170)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448431173400171)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'hr'
,p_message_text=>'- Odabir -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331863834400078)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei grafikon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448086778400170)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei manje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448177533400170)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei vi\0161e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112448340752400171)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i broj zvjezdica: %0 i vi\0161e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406054988400138)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'hr'
,p_message_text=>'Prijedlozi filtra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449149052400171)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>unistr('Facet tekstnog polja %0 trenutno je samo podr\017Ean za stupce NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322292353400071)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Ukupni broj redaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465255292400183)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta podataka %0 (%1) nije podr\017Eana za facetno pretra\017Eivanje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457195362400177)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Idi na pogre\0161ku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414798802400145)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Agregiranje.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422306294400151)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'hr'
,p_message_text=>unistr('Sa\017Emi kontrolno razdvajanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414863534400145)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Kontrolno razdvajanje.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422203990400151)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161iri kontrolno razdvajanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500983362400209)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Stupac %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422048598400151)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbrisan sljede\0107i broj redaka: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492458548400203)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'hr'
,p_message_text=>'Duplicirani identitet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411761994400142)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'hr'
,p_message_text=>'Prvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415046134400145)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Zaglavlje grupe.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414917603400145)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Zaglavlje.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411802661400142)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'hr'
,p_message_text=>'Zadnje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431898231400159)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditaj jo\0161 redaka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411521114400142)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415117294400145)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'hr'
,p_message_text=>'Redci na stranici'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411972976400142)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'hr'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412077549400142)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'hr'
,p_message_text=>'%0 - %1 od %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468075930400185)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'hr'
,p_message_text=>'Odabir stranica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411634638400142)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492236085400202)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'hr'
,p_message_text=>'Dodano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492304168400203)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'hr'
,p_message_text=>'Promijenjeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500753924400209)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Redak %0, stupac %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500813773400209)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Redak %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492134751400202)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'hr'
,p_message_text=>'Izbrisano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415374109400145)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'hr'
,p_message_text=>'Zaglavlje retka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410994328400142)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Odabran sljede\0107i broj \0107elija: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412131528400143)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Odabran sljede\0107i broj redaka: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452488148400173)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'hr'
,p_message_text=>'Odaberi sve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422183459400151)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'hr'
,p_message_text=>'Stranica %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415250718400145)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'hr'
,p_message_text=>'Odaberi redak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415436903400145)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'hr'
,p_message_text=>'Uzlazno sortirano %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415520278400145)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'hr'
,p_message_text=>'Silazno sortirano %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411090260400142)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'hr'
,p_message_text=>'Uzlazno sortiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411379011400142)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'hr'
,p_message_text=>'Uzlazno sortiranje %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411141944400142)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'hr'
,p_message_text=>'Silazno sortiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411471748400142)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'hr'
,p_message_text=>'Silazno sortiranje %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112411250110400142)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'hr'
,p_message_text=>'Nemoj sortirati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421946308400151)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'hr'
,p_message_text=>'Ukupno %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348304272400092)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'hr'
,p_message_text=>'HTTP zahtjev za "%0" nije uspio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489663623400201)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'hr'
,p_message_text=>unistr('Popis za odabir re\0161etke, broj stupaca: %0, broj redaka: %1. Upotrijebite tipke sa strelicom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421857502400151)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'hr'
,p_message_text=>unistr('Popis za odabir, sljede\0107i broj redaka: %0. Upotrijebite tipke sa strelicom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500597654400208)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Interaktivna re\0161etka %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408653449400140)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'hr'
,p_message_text=>'Akcije'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409659947400141)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'hr'
,p_message_text=>'Dodaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409586471400141)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'hr'
,p_message_text=>'Dodaj redak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494016912400204)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'hr'
,p_message_text=>'Agregiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479505567400193)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'hr'
,p_message_text=>'Agregiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481224655400194)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'hr'
,p_message_text=>'Sve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437647614400163)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Svi stupci s tekstom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438892231400164)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'hr'
,p_message_text=>'Alternativno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439990668400165)
,p_name=>'APEX.IG.AND'
,p_message_language=>'hr'
,p_message_text=>'i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459385572400178)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'hr'
,p_message_text=>unistr('Pribli\017Ean broj razli\010Ditih')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495057980400204)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'hr'
,p_message_text=>unistr('Ukupni pribli\017Ean broj razli\010Ditih')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478185178400192)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'hr'
,p_message_text=>unistr('Podru\010Dje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480068147400194)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'hr'
,p_message_text=>'Uzlazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438986217400164)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'hr'
,p_message_text=>'Odobrenje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494181163400204)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'hr'
,p_message_text=>'Automatski'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459779638400179)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'hr'
,p_message_text=>'Prosjek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494719495400204)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'hr'
,p_message_text=>'Ukupni prosjek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477699920400192)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Naslov osi oznake'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477853895400192)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'hr'
,p_message_text=>'Decimalna mjesta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477787585400192)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Naslov osi vrijednosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483827266400196)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'hr'
,p_message_text=>'Boja pozadine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478275497400192)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'hr'
,p_message_text=>'Trakasti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434201201400160)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'hr'
,p_message_text=>unistr('izme\0111u')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485006634400197)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'hr'
,p_message_text=>'Oboje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478319686400192)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Mjehuri\0107asti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409895891400141)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'hr'
,p_message_text=>'Odustani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439889538400164)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'hr'
,p_message_text=>'Razlikovanje malih i velikih slova'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495682073400205)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'hr'
,p_message_text=>'(razlikovanje malih i velikih slova)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466592021400184)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'hr'
,p_message_text=>'Promjene su spremljene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410258640400141)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Promjena prikaza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440915157400165)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'hr'
,p_message_text=>'Grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437426518400163)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Upit prekora\010Duje sljede\0107i maksimalni broj podatkovnih to\010Daka po grafikonu: %0. Primijenite filtar kako biste smanjili broj zapisa u osnovnom upitu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408502746400140)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz grafikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415870763400146)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('O\010Disti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477179320400191)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Zatvori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484084372400196)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'hr'
,p_message_text=>'Boje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460166466400179)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'hr'
,p_message_text=>'Pregled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439219041400164)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Stupac'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408754092400140)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Stupci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485816553400198)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Svrha stupca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439370095400164)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'hr'
,p_message_text=>unistr('Slo\017Eeno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408967578400140)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'hr'
,p_message_text=>unistr('Izra\010Dun')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434892547400161)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'hr'
,p_message_text=>unistr('sadr\017Ei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441145015400165)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'hr'
,p_message_text=>'Kontrolno razdvajanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415655450400145)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'hr'
,p_message_text=>unistr('Kopiraj u me\0111uspremnik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415761522400146)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'hr'
,p_message_text=>'Kopiraj ispod'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459197599400178)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'hr'
,p_message_text=>'Broj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459277041400178)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbroji razli\010Dite')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494973224400204)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'hr'
,p_message_text=>unistr('Ukupni broj razli\010Ditih')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494886601400204)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'hr'
,p_message_text=>'Ukupni broj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492527871400203)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'hr'
,p_message_text=>'Stvori %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437810233400163)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'hr'
,p_message_text=>'Podaci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485663185400198)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Vrsta podataka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485209481400197)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'hr'
,p_message_text=>'Datum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466344952400184)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost datuma nije valjana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435580766400161)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'hr'
,p_message_text=>'dana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438563229400163)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>'Zadane postavke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438319684400163)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Zadana vrsta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409759880400141)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486849462400198)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'hr'
,p_message_text=>unistr('Jeste li sigurni da \017Eelite izbrisati to izvje\0161\0107e?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442950569400167)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i redak')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441731103400166)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i retke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480105950400194)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'hr'
,p_message_text=>'Silazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440685123400165)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'hr'
,p_message_text=>'Pojedinosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408262069400139)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz pojedinosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468867687400185)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'hr'
,p_message_text=>'Smjer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440376830400165)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Onemogu\0107eno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434980265400161)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'hr'
,p_message_text=>unistr('ne sadr\017Ei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435115761400161)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'hr'
,p_message_text=>unistr('ne po\010Dinje s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478408157400192)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'hr'
,p_message_text=>'Prstenasti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441397701400165)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'hr'
,p_message_text=>'Preuzmi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340007086400084)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'hr'
,p_message_text=>'Samo podaci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487861275400199)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Odabir formata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352685779400095)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Format preuzimanja %0 nije omogu\0107en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480832743400194)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'hr'
,p_message_text=>'Duplicirano agregiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480944419400194)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'hr'
,p_message_text=>'Duplicirano kontrolno razdvajanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442848176400167)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'hr'
,p_message_text=>'Duplicirani redak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441657225400166)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'hr'
,p_message_text=>'Duplicirani redci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409322814400140)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'hr'
,p_message_text=>'Uredi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479950916400193)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'hr'
,p_message_text=>'Uredi grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491474166400202)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'hr'
,p_message_text=>'Uredi grupiranje po'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487433145400199)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'hr'
,p_message_text=>'Skriveni primatelji (bcc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487651773400199)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'hr'
,p_message_text=>'Poruka'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487315072400199)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'hr'
,p_message_text=>'Primatelj kopije (cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487031254400199)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'hr'
,p_message_text=>unistr('Poruka e-po\0161te poslana.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487534386400199)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'hr'
,p_message_text=>'Predmet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487217727400199)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'hr'
,p_message_text=>'Primatelj (za)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440026192400165)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Omogu\0107eno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433286752400160)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'hr'
,p_message_text=>'jednako'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486472999400198)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'hr'
,p_message_text=>'Primjer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440167051400165)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'hr'
,p_message_text=>'Izraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486365395400198)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Vrsta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452392362400173)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'hr'
,p_message_text=>unistr('Datoteka pripremljena. Preuzimanje zapo\010Dinje.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112415955061400146)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'hr'
,p_message_text=>'Ispuni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417068934400147)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Ispuni odabir s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416928323400147)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Ispuni odabir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408871609400140)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'hr'
,p_message_text=>'Filtar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439441047400164)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'hr'
,p_message_text=>'Filtri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494471676400204)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'hr'
,p_message_text=>'Filtriranje...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480372616400194)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'hr'
,p_message_text=>'Prvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409042960400140)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'hr'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437983043400163)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484915895400197)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'hr'
,p_message_text=>'Maska formata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486762595400198)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'hr'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486669305400198)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'hr'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399438174400132)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'hr'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338730888400083)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'hr'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442500734400166)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'hr'
,p_message_text=>'Zamrzni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440239546400165)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'hr'
,p_message_text=>'Funkcije i operatori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478521377400192)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'hr'
,p_message_text=>'Ljevkasti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459051421400178)
,p_name=>'APEX.IG.GO'
,p_message_language=>'hr'
,p_message_text=>'Idi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433886189400160)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'hr'
,p_message_text=>unistr('ve\0107e od')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433990007400160)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'hr'
,p_message_text=>unistr('ve\0107e od ili jednako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440584785400165)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'hr'
,p_message_text=>unistr('Re\0161etka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408042192400139)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Rasterski pregled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481130739400194)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'hr'
,p_message_text=>'Grupiraj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440735580400165)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'hr'
,p_message_text=>'Grupiraj prema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408378495400140)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz grupiranja po'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485579039400198)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Vrsta uvjeta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484456611400197)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'hr'
,p_message_text=>'Zaglavlje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484602541400197)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'hr'
,p_message_text=>'Poravnanje zaglavlja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494370070400204)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489802792400201)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>U ovoj interaktivnoj re\0161etki izravno mo\017Eete umetnuti, a\017Eurirati i brisati podatke.</p>'),
'',
'<p>Umetnite novi redak tak da pritisnete gumb Dodaj redak.</p>',
'',
unistr('<p>Uredite postoje\0107e podatke tako da dvaput pritisnete odre\0111enu \0107eliju. Za ure\0111ivanje ve\0107eg opsega pritisnite Uredi kako biste u\0161li u na\010Din ure\0111ivanja. U na\010Dinu ure\0111ivanja mo\017Eete jednom pritisnuti odre\0111ene \0107elije ili ih ure\0111ivati tipkovnicom.</p>'),
'',
unistr('<p>Pomo\0107u izbornika za promjene duplicirajte i bri\0161ite retke. Kako biste omogu\0107ili izbornik za promjene, upotrijebite potvrdne okvire za odabir jednog ili vi\0161e redaka.</p>'),
'',
unistr('<p>Duplicirajte odabrani redak pritiskom na izbornik za promjene i odabirom Dupliciraj retke. Izbri\0161ite odabrani redak tako da pritisnete izbornik za promjene i odaberete Izbri\0161i redak.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491972912400202)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'hr'
,p_message_text=>unistr('Mogu\0107nosti ure\0111ivanja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492066222400202)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interaktivna re\0161etka predstavlja skup podataka u pretra\017Eivom i prilagodljivom izvje\0161\0107u. Mo\017Eete izvesti razne operacije kako biste ograni\010Dili broj vra\0107enih zapisa i promijenili na\010Din prikaza podataka.</p>'),
'',
unistr('<p>Pomo\0107u polja za pretra\017Eivanje filtrirajte vra\0107ene zapise. Pritisnite Akcije za pristup raznim opcijama za mijenjanje izgleda izvje\0161\0107a ili upotrijebite izbornike zaglavlja stupca na prikazanim stupcima.</p>'),
'',
unistr('<p>Upotrijebite postavke izvje\0161\0107a kako biste spremili prilagodbe u izvje\0161\0107e. Mo\017Eete i preuzeti podatke iz izvje\0161\0107a u vanjsku datoteku ili e-po\0161tom poslati podatke sebi ili drugima.</p>'),
'',
unistr('<p> Pogledajte "Upotreba interaktivnih izvje\0161\0107a" u <em>Priru\010Dniku za krajnjeg korisnika platforme Oracle Application Express</em> kako biste saznali vi\0161e.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491758132400202)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'hr'
,p_message_text=>'Pregled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489759289400201)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mo\017Eete prilagoditi interaktivnu mre\017Eu tako da prikazuje podatke na razne na\010Dine pomo\0107u ugra\0111enih mogu\0107nosti.</p>'),
'',
unistr('<p>Pomo\0107u izbornika zaglavlja stupaca ili izbornika akcija odredite koji \0107e se stupci prikazati, kojim redoslijedom te zamrznite stupce. Mo\017Eete i definirati razne podatkovne filtre i sortirati vra\0107ene podatke.</p>'),
'',
unistr('<p>Pomo\0107u gumba za prikaz (uz polje za pretra\017Eivanje) pristupite drugim prikazima podataka koje je definirao programer aplikacije. Mo\017Eete i stvoriti grafikon ili prikazati postoje\0107i grafikon.</p>  '),
'',
unistr('<p><em>Napomena: Pritisnite <strong>Pomo\0107</strong> u dijalo\0161kom prozoru interaktivne re\0161etke kako biste dobili detaljnije informacije o odabranoj funkciji.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491803701400202)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'hr'
,p_message_text=>unistr('Mogu\0107nosti izvje\0161\0107ivanja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441562180400166)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za interaktivnu re\0161etku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488697089400200)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Upotrijebite ovaj dijalo\0161ki okvir za agregiranje stupaca. Agregirane vrijednosti prikazuju se u dnu podataka ili, ako se definiraju kontrolna razdvajanja, u dnu svakog razdvajanja.</p>'),
'',
'<p><strong>Popis agregiranja</strong><br>',
'Na popisu agregiranja prikazuju se definirana agregiranja.<br>',
unistr('Pritisnite Dodaj ( &plus; ) kako biste stvorili novo agregiranje ili Izbri\0161i ( &minus; ) kako biste uklonili postoje\0107e agregiranje.</p>'),
'',
'<p><strong>Postavke agregiranja</strong><br>',
'Upotrijebite obrazac s desne strane kako biste definirali agregiranje.<br>',
'Odaberite naziv stupca i vrstu agregiranja.<br>',
'Po izboru unesite zaslonski opis za agregiranje.<br>',
unistr('Ako ste definirali kontrolno razdvajanje, <strong>Prika\017Ei ukupnu vrijednost</strong> prikazuje sveukupnu prosje\010Dnu, ukupnu ili sli\010Dnu vrijednost u dnu podataka.</p>'),
'',
unistr('<p><em>Napomena: Pristupite dijalo\0161kom okviru Agregiranje u izborniku akcija ili pritiskom na zaglavlje stupca i zbroj ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490844166400201)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za agregiranje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489323751400200)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomo\0107u ovog dijalo\0161kog okvira definirajte grafikon koji se prikazuje kao zasebni prikaz podataka.<br>'),
'Odaberite vrstu i atribute grafikona.</p>',
'<p><strong>Atributi grafikona</strong></br>',
'Dostupni atributi grafikona razlikuju se ovisno o vrsti grafikona.</p>',
'<p>',
'<ul>',
'  <li>Odaberite stupac s vrijednosti za atribut:',
'    <ul>',
unistr('      <li>Oznaka - tekst za svaku podatkovnu to\010Dku.</li>'),
'      <li>Vrijednost - podaci za iscrtavanje.</li>',
unistr('      <li>Serija - za definiranje vi\0161eserijskog dinami\010Dkog upita.</li>'),
'      <li>Otvaranje - cijena pri otvaranju burze u danu (samo burzovni grafikon).</li>',
unistr('      <li>Zaklju\010Dno - zaklju\010Dna burzovna cijena u danu (samo burzovni grafikon).</li>'),
'      <li>Visoko - visoka vrijednost (samo rasponski i burzovni grafikon).</li>',
'      <li>Nisko - niska vrijednost (samo rasponski i burzovni grafikon).</li>',
'      <li>Obujam - dnevni obujam trgovanja (samo burzovni grafikon).</li>',
unistr('      <li>Odredi\0161te - odredi\0161na vrijednost (samo ljevkasti grafikon).</li>'),
unistr('      <li>X - vrijednost x-osi (samo mjehuri\0107asti i raspr\0161eni grafikon).</li>'),
unistr('      <li>Y - vrijednost y-osi (samo mjehuri\0107asti i raspr\0161eni grafikon).</li>'),
unistr('      <li>Z - \0161irina trake ili polumjer mjehuri\0107a (samo trakasti, mjehuri\0107asti i rasponski grafikon).</li>'),
'    </ul>',
'  </li>',
'  <li>Orijentacija - vodoravna ili okomita.</li>',
unistr('  <li>Agregiranje -  odaberite na\010Din agregiranja vrijednosti grafikona.</li>'),
unistr('  <li>Slaganje- navedite sla\017Eu li se podatkovne stavke.</li>'),
'  <li>Sortiranje prema - sortirajte prema oznaci ili vrijednostima.',
'    <ul>',
'      <li>Smjer - sortiranje po uzlaznim ili silaznim vrijednostima.</li>',
unistr('      <li>Nulls - navedite kako \017Eelite sortirati zapise s null vrijednostima u odnosu na zapise bez null vrijednosti.</li>'),
'    </ul>',
'  </li>',
'  <li>Decimalna mjesta</li>',
'  <li>Naslov osi oznake</li>',
'  <li>Naslov osi vrijednosti</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491271266400202)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za grafikone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488306498400200)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomo\0107u ovog dijalo\0161kog prozora odaberite koji \0107e se stupci prikazati i kojim redoslijedom.</p>'),
'',
unistr('<p>Sakrijte stupac tako da poni\0161tite njegov odabir.<br>'),
'Ponovo sortirajte stupce tako da pritisnete Premjesti gore ( &uarr; ) ili Premjesti dolje ( &darr; ).<br>',
unistr('Pomo\0107u padaju\0107eg izbornika generirajte popis Svih stupaca, Prikazanih stupaca ili Neprikazanih stupaca .</p>'),
'',
unistr('<p>Po izboru upotrijebite obrazac kako biste naveli minimalnu \0161irinu stupca u pikselima.</p>'),
'',
unistr('<p><em>Napomena: Mo\017Eete i ponovo sortirati prikazane stupce tako da pritisnete i povu\010Dete pokaziva\010D (na po\010Detku zaglavlja stupca) te povu\010Dete stupac slijeva nadesno. Mo\017Eete i promijeniti \0161irinu prikazanih stupaca tako da odaberete razdjelnik stupaca,')
||unistr(' izme\0111u zaglavlja, te ga pomaknete ulijevo ili udesno.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491135851400202)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za stupce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488769769400200)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomo\0107u ovog dijalo\0161kog okvira definirajte dodatne stupce na temelju matemati\010Dkih i funkcijskih izra\010Duna izvedenih na postoje\0107im stupcima.</p>'),
'',
unistr('<p><strong>Popis izra\010Duna</strong><br>'),
unistr('Na popisu izra\010Duna prikazuju se definirani izra\010Duni. Onemogu\0107ite postoje\0107i izra\010Dun tako da poni\0161tite njegov odabir.<br>'),
unistr('Pritisnite Dodaj ( &plus; ) kako biste dodali novi izra\010Dun ili Izbri\0161i ( &minus; ) kako biste uklonili postoje\0107i izra\010Dun.</p>'),
'',
unistr('<p><strong>Postavke izra\010Duna</strong><br>'),
unistr('Upotrijebite obrazac za definirane izra\010Duna.<br>'),
unistr('Unesite pojedinosti stupca kao \0161to su zaglavlje, oznaka i odabir postavki poravnanja.<br> '),
unistr('Pomo\0107u tekstnog podru\010Dja izraza unesite stupce i povezane funkcije za izra\010Dun.<br>'),
unistr('Odaberite odgovaraju\0107u vrstu podataka i, po izboru, masku formata za novi stupac.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490790526400201)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za izra\010Dun')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489087383400200)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Upotrijebite ovaj dijalo\0161ki okvir za definiranje kontrolnog razdvajanje u jednom ili vi\0161e stupaca.</p>'),
'',
'<p><strong>Popis kontrolnih razdvajanja</strong><br>',
unistr('Na popisu kontrolnih razdvajanja prikazuju se definirana kontrolna razdvajanja. Postoje\0107e kontrolno razdvajanje mo\017Eete onemogu\0107iti tako da poni\0161tite njegov odabir.<br>'),
unistr('Pritisnite Dodaj ( &plus; ) kako biste uklju\010Dili novi stupac u kontrolno razdvajanje ili Izbri\0161i ( &minus; ) kako biste uklonili postoje\0107i stupac iz kontrolnog razdvajanja.<br>'),
'Kako biste promijenili redoslijed stupaca, pritisnite Premjesti gore ( &uarr; ) ili Premjesti dolje ( &darr; ) kako biste premjestili odabrani stupac gore ili dolje u odnosu na druge stupce.</p>',
'',
'<p><strong>Postavke kontrolnog razdvajanja</strong><br>',
unistr('Pomo\0107u obrasca definirajte stupac kontrolnog razdvajanja.<br>'),
unistr('Odaberite stupac kontrolnog razdvajanja, smjer sortiranja i na\010Din raspore\0111ivanja null stupaca (stupci bez vrijednosti).</p>'),
'',
unistr('<p><em>Napomena: Kod prikaza interaktivne re\0161etke mo\017Eete definirati kontrolno razdvajanje pritiskom na zaglavlje stupca i odabirom ikone kontrolnog razdvajanja.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490450432400201)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za kontrolno razdvajanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489231001400200)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Upotrijebite ovaj dijalo\0161ki okvir za preuzimanje svih trenutnih redaka u vanjsku datoteku. Datoteka \0107e sadr\017Eavati samo trenutno prikazane stupce uz upotrebu filtara i sortiranja primijenjenih na podatke.</p>'),
'',
'<p>Odaberite format datoteke i pritisnite Preuzmi.<br>',
unistr('Napomena: CSV ne\0107e uklju\010Divati formatiranje teksta poput agregiranja i kontrolnih razdvajanja.</p>'),
'',
unistr('<p>Kako biste datoteku poslali e-po\0161tom, odaberite Po\0161alji kao e-po\0161tu i unesite pojedinosti e-po\0161te (Primatelj, Predmet i Poruka).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490213019400201)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za preuzimanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488440315400200)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomo\0107u ovog dijalo\0161kog okvira konfigurirajte filtre podataka koji ograni\010Davaju vra\0107ene retke.</p>'),
'',
'<p><strong>Popis filtara</strong><br>',
unistr('Na popisu filtara prikazuju se definirani filtri. Onemogu\0107ite postoje\0107i filtar tako da poni\0161tite njegov odabir.<br>'),
unistr('Pritisnite Dodaj ( &plus; ) kako biste stvorili novi filtar ili Izbri\0161i ( &minus; ) kako biste uklonili postoje\0107i filtar.</p>'),
'',
'<p><strong>Postavke filtra</strong><br>',
unistr('Pomo\0107u obrasca definirajte svojstva filtra.<br>'),
unistr('Odaberite odgovaraju\0107u vrstu filtra:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Redak - filtrirajte pojam u bilo kojem stupcu s mogu\0107nosti filtriranja.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Stupac - filtrirajte odre\0111eni stupac s odre\0111enim operatorom i vrijednosti.</p>'),
'',
unistr('<p><em>Napomena: . Kod prikaza interaktivne re\0161etke mo\017Eete definirati filtre redaka izravnim upisivanjem u polje za pretra\017Eivanje. Pritisnite Odabir stupaca za pretra\017Eivanje kako biste ograni\010Dili pretra\017Eivanje na odre\0111eni stupac. Umjesto toga mo\017Eete ')
||'otvoriti izbornik zaglavlja stupca i odabrati vrijednost za stvaranje filtra stupca.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491052843400202)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za filtriranje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488856845400200)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Upotrijebite ovaj dijalo\0161ki okvir za prikaz podataka u stanju u kojem su bili u prethodnoj vremenskoj to\010Dki.</p>'),
unistr('<p>Unesite broj proteklih minuta za izvr\0161enje upita Flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490641828400201)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za Flashback')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491305423400202)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za grupiranje po')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488994255400200)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomo\0107u ovog dijalo\0161kog okvira istaknite retke ili stupce podataka na temelju unesenog uvjeta.</p>'),
'',
'<p><strong>Popis isticanja</strong><br>',
unistr('Na popisu isticanja prikazuju se definirana isticanja. Onemogu\0107ite postoje\0107e isticanje tako da poni\0161tite njegov odabir.<br>'),
unistr('Pritisnite Dodaj ( &plus; ) kako biste stvorili novo isticanje ili Izbri\0161i ( &minus; ) kako biste uklonili postoje\0107e isticanje.</p>'),
'',
'<p><strong>Postavke isticanja</strong><br>',
unistr('Pomo\0107u obrasca definirajte svojstva isticanja.<br>'),
unistr('Unesite naziv, odaberite Redak ili Stupac i odaberite HTML \0161ifre boja za pozadinu i tekst.<br>'),
unistr('Odaberite odgovaraju\0107u <strong>vrstu uvjeta</strong> za isticanje odre\0111enih podataka:<br>'),
'&nbsp;&nbsp;&nbsp;Redak - istaknite pojam u bilo kojem stupcu.<br>',
unistr('&nbsp;&nbsp;&nbsp;Stupac - izvr\0161ite isticanje u odre\0111enom stupcu na temelju odre\0111enog operatora i vrijednosti.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490538410400201)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za isticanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489107120400200)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomo\0107u ovog dijalo\0161kog okvira spremite promjene trenutnog izgleda i konfiguracije izgleda re\0161etke.<br>'),
unistr('Programeri aplikacija mogu definirati vi\0161e promjenjivih izgleda izvje\0161\0107a. Kada je to dopu\0161teno, vi i ostali krajnji korisnici mo\017Eete spremiti izvje\0161\0107e kao javno, \010Dime izvje\0161\0107e postaje dostupno svim korisnicima re\0161etke. Izvje\0161\0107e mo\017Eete spremiti kao pr')
||unistr('ivatno izvje\0161\0107e koje samo vi mo\017Eete vidjeti.</p>'),
unistr('<p>Birajte me\0111u dostupnim vrstama i unesite naziv za spremljeno izvje\0161\0107e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490338303400201)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pomo\0107 za izvje\0161\0107e'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488559875400200)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomo\0107u ovog dijalo\0161kog okvira postavite redoslijed prikaza.</p>'),
'',
'<p><strong>Popis sortiranja</strong><br>',
unistr('Dijalo\0161ki okvir za sortiranje prikazuje popis konfiguriranih pravila sortiranja.<br>'),
unistr('Pritisnite Dodaj ( &plus; ) kako biste stvorili stupac sortiranja ili Izbri\0161i ( &minus; ) kako biste uklonili stupac sortiranja.<br>'),
'Pritisnite Premjesti gore ( &uarr; ) i Premjesti dolje ( &darr; ) kako biste odabrani stupac sortiranja premjestili prema gore i dolje u odnosu na druge stupce sortiranja.</p>',
'',
'<p><strong>Postavke sortiranja</strong><br>',
unistr('Odaberite stupac sortiranja, smjer sortiranja i na\010Din raspore\0111ivanja null stupaca (stupci bez vrijednosti).</p>'),
'',
unistr('<p><em>Napomena: Podaci se mogu sortirati po stupcima koji nisu prikazani; no nemaju svi stupci mogu\0107nost sortiranja.</em><br>'),
unistr('<em>Prikazani stupci mogu se sortirati tako da pritisnete strelice za gore (uzlazno) ili dolje (silazno) na kraju zaglavlja stupaca. Kako biste dodali naknadni stupac postoje\0107em sortiranju, dr\017Eite tipku Shift i pritisnite strelicu za gore ili dolje.<')
||'/em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490964943400202)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za sortiranje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112490131826400201)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za pretplatu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442442654400166)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'hr'
,p_message_text=>'Sakrij'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409293947400140)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'hr'
,p_message_text=>'Istakni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477260483400192)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Visoko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478047011400192)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'hr'
,p_message_text=>'Vodoravno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435496060400161)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'hr'
,p_message_text=>'h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440440327400165)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'hr'
,p_message_text=>'Ikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408143925400139)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz ikone'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433688017400160)
,p_name=>'APEX.IG.IN'
,p_message_language=>'hr'
,p_message_text=>'u'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442086059400166)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'hr'
,p_message_text=>'Neaktivna postavka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442144185400166)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>'Neaktivne postavke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449709169400172)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pri obradi zahtjeva interaktivne re\0161etke do\0161lo je do interne pogre\0161ke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345520728400090)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta filtra stupca "%0" nije podr\017Eana za stupac "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489972247400201)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Format datuma nije valjan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464152520400182)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'hr'
,p_message_text=>unistr('Interaktivna re\0161etka ne podr\017Eava definiranje filtra na stupcu %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464049871400182)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije valjana vrsta filtra za definiranje filtra interaktivne re\0161etke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350674149400094)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Format broja nije valjan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492639368400203)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'hr'
,p_message_text=>'Postavka nije valjana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492722517400203)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>'Postavke nisu valjane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483742507400196)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'hr'
,p_message_text=>'Sortiranje po postavljeno je na %0, ali za %0 nije odabran stupac.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481036634400194)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost nije valjana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476186821400191)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'hr'
,p_message_text=>'Nije prikazano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434446822400161)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'hr'
,p_message_text=>'je u zadnjem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434626873400161)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('u sljede\0107em')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433564934400160)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'nije prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433440010400160)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'hr'
,p_message_text=>'je prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484593659400197)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'hr'
,p_message_text=>'Oznaka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476533248400191)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Oznaka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480417331400194)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423750480400152)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'hr'
,p_message_text=>'Zadnji dan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423904799400152)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'hr'
,p_message_text=>'Zadnji sat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424425496400153)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'hr'
,p_message_text=>'Prethodna minuta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423438582400152)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161li mjesec')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423548061400152)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161li tjedan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423687914400152)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih dana: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423834093400152)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih sati: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424525115400153)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih minuta: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424309813400153)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih mjeseci: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424219480400153)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih tjedana: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423273465400152)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih godina: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423311817400152)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161la godina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484757817400197)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'hr'
,p_message_text=>unistr('Poravnanje \0107elija')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484877092400197)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'hr'
,p_message_text=>'Upotrijebi grupu za'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434081588400160)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'hr'
,p_message_text=>'manje od'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434115651400160)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'hr'
,p_message_text=>'manje od ili jednako'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478665683400193)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'hr'
,p_message_text=>'Linijski'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478763203400193)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'hr'
,p_message_text=>unistr('Redak s povr\0161inom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485188539400197)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'hr'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477349600400192)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Nisko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487742309400199)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'hr'
,p_message_text=>unistr('Odvojite vi\0161e adresa zarezima')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435208094400161)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'hr'
,p_message_text=>'odgovara regularnom izrazu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459619407400179)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'hr'
,p_message_text=>'Maksimalno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495269120400205)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'hr'
,p_message_text=>'Ukupni maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459879286400179)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'hr'
,p_message_text=>'Sredina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495361855400205)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'hr'
,p_message_text=>'Ukupna sredina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459536762400179)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'hr'
,p_message_text=>'Minimalno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435327033400161)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'hr'
,p_message_text=>'min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460374750400179)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'hr'
,p_message_text=>'Min ranije'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495103269400205)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'hr'
,p_message_text=>'Ukupni minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435764153400161)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'hr'
,p_message_text=>'mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442364040400166)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Podaci sadr\017Ee vi\0161e od sljede\0107eg broja redaka: %0, a to je vi\0161e od maksimalno dopu\0161tenog broja. Primijenite dodatne filtre kako biste prikazali rezultate.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469093334400186)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Mora se navesti stati\010Dni ID podru\010Dja jer stranica sadr\017Ei vi\0161e interaktivnih re\0161etki.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438449457400163)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'hr'
,p_message_text=>'Naziv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438620892400164)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e s nazivom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422687895400151)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i dan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422435711400151)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i sat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424634225400153)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107a minuta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422944508400152)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i mjesec')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422838117400151)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i tjedan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422787617400151)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih dana: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112422526931400151)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih sati: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424747591400153)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih minuta: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424056753400152)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih mjeseci: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424142498400153)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih tjedana: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423113014400152)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih godina: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112423012903400152)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107a godina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434326128400160)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'hr'
,p_message_text=>unistr('nije izme\0111u')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433339064400160)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'hr'
,p_message_text=>'nije jednako'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499539567400208)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Regija s ID-om %0 nije podru\010Dje interaktivne re\0161etke ili ne postoji u aplikaciji  %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433796599400160)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'hr'
,p_message_text=>'nije u'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434573774400161)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'hr'
,p_message_text=>'nije u zadnjem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112434757310400161)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('nije u sljede\0107em')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442218019400166)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Podaci nisu prona\0111eni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480210392400194)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'hr'
,p_message_text=>'Vrijednosti null'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485334006400197)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'hr'
,p_message_text=>unistr('Numeri\010Dka vrijednost')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480506018400194)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'hr'
,p_message_text=>unistr('Isklju\010Deno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480665304400194)
,p_name=>'APEX.IG.ON'
,p_message_language=>'hr'
,p_message_text=>unistr('Uklju\010Deno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432563435400159)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije 1 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488237031400200)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'hr'
,p_message_text=>'Otvori izbornik boje: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477073953400191)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Otvori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439596042400164)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'hr'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476436616400191)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'hr'
,p_message_text=>'Orijentacija'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478876309400193)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'hr'
,p_message_text=>'Tortni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112440860548400165)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'hr'
,p_message_text=>'Zaokretanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112408485996400140)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Zaokretni prikaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112488111053400199)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'hr'
,p_message_text=>'Vrijednosti odvojite upotrebom "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112478945826400193)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'hr'
,p_message_text=>'Polarni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484244388400197)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'hr'
,p_message_text=>'Sredina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484322556400197)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'hr'
,p_message_text=>'Kraj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112484138681400197)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\010Detak')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438719876400164)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'hr'
,p_message_text=>'Primarno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439001517400164)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'hr'
,p_message_text=>'Primarno zadano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455570171400176)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Primarno izvje\0161\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337793048400083)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'hr'
,p_message_text=>unistr('Uklju\010Di oznake pristupa\010Dnosti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336421896400082)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'hr'
,p_message_text=>'Vodoravno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336585948400082)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'hr'
,p_message_text=>'Okomito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336366837400082)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'hr'
,p_message_text=>'Orijentacija stranice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336201810400081)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'hr'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336171046400081)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'hr'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337870902400083)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'hr'
,p_message_text=>unistr('Prilago\0111eno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335973219400081)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'hr'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335895466400081)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'hr'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336015982400081)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'hr'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335721870400081)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'hr'
,p_message_text=>unistr('Veli\010Dina stranice')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325920412400073)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'hr'
,p_message_text=>unistr('Ukloni oboga\0107eni tekst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479067288400193)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'hr'
,p_message_text=>'Radarski'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479174650400193)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'hr'
,p_message_text=>'Rasponski'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489480478400200)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'hr'
,p_message_text=>unistr('Osvje\017Ei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443008885400167)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'hr'
,p_message_text=>unistr('Osvje\017Ei redak')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441826211400166)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'hr'
,p_message_text=>unistr('Osvje\017Ei retke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447092552400170)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Podru\010Dje interaktivne re\0161etke ne postoji u aplikaciji %0, stranici %1 ni podru\010Dju %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409976555400141)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'hr'
,p_message_text=>'Ukloni %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438113895400163)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498752667400207)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e izbrisano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498449034400207)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'hr'
,p_message_text=>unistr('Alternativno izvje\0161\0107e spremljeno za sve korisnike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498332055400207)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'hr'
,p_message_text=>unistr('Zadano izvje\0161\0107e spremljeno za sve korisnike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498688173400207)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'hr'
,p_message_text=>unistr('Privatno izvje\0161\0107e spremljeno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498509429400207)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'hr'
,p_message_text=>unistr('Javno izvje\0161\0107e spremljeno za sve korisnike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112447167907400170)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljena interaktivna re\0161etka s nazivom %0 ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432426648400159)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei podatke od prije %0 min')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432346557400159)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei podatke od prije 1 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372019799400111)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e u interaktivnoj re\0161etki ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491636701400202)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e - uredi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446954434400169)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljena interaktivna re\0161etka s ID-om %0 ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112491537205400202)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e - spremi kao')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410029581400141)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>unistr('Postavke izvje\0161\0107a')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499624748400208)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljena interaktivna re\0161etka sa stati\010Dkim ID-om %0 ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494535116400204)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'hr'
,p_message_text=>unistr('Prikaz izvje\0161\0107a')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409105560400140)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'hr'
,p_message_text=>'Ponovo postavi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443147890400167)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'hr'
,p_message_text=>'Vrati promjene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441994532400166)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'hr'
,p_message_text=>'Vrati retke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439101218400164)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'hr'
,p_message_text=>'Redak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438003159400163)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'hr'
,p_message_text=>'Redaka po stranici'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499271279400207)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'hr'
,p_message_text=>'Akcije redaka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500424816400208)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'hr'
,p_message_text=>'Akcije za redak %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112409436600400140)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'hr'
,p_message_text=>'Spremi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452162279400173)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'hr'
,p_message_text=>'spremljeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407655568400139)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljeni izvje\0161taji')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407780188400139)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'hr'
,p_message_text=>'Zadano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382259298400119)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljeno izvje\0161\0107e naziva %0 ve\0107 postoji. Unesite novi naziv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407896012400139)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'hr'
,p_message_text=>'Privatno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407970792400139)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'hr'
,p_message_text=>'Javno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494263056400204)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'hr'
,p_message_text=>'Spremi kao'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441294447400165)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremi postavke izvje\0161\0107a')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479273838400193)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'hr'
,p_message_text=>unistr('Raspr\0161eni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407561304400139)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486505286400198)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje: svi stupci s tekstom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407400467400139)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485716601400198)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje: cijeli tekst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432231585400159)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Ei  ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475895604400191)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'hr'
,p_message_text=>'- Odabir -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416024397400146)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'hr'
,p_message_text=>'Odabir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468766965400185)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'hr'
,p_message_text=>unistr('Odaberite 1 redak u glavnom podru\010Dju')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407345019400139)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Odaberite stupce za pretra\017Eivanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498970943400207)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'hr'
,p_message_text=>'Akcije odabira'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416235984400146)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'hr'
,p_message_text=>unistr('Odabir \0107elija')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416105456400146)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'hr'
,p_message_text=>'Odabir redaka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487195124400199)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161alji kao poruku e-po\0161te')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479685681400193)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Serija'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405352987400137)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457932953400177)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei ukupnu vrijednost')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442708586400166)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz jednog retka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441040314400165)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'hr'
,p_message_text=>'Sortiraj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479723912400193)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'hr'
,p_message_text=>unistr('Na\010Din sortiranja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499365579400207)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'hr'
,p_message_text=>unistr('Mo\017Eete definirati samo jedno sortiranje po stupcu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499138017400207)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'hr'
,p_message_text=>'Izbornik za promjenu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112480743086400194)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'hr'
,p_message_text=>'Stog'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435086333400161)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'hr'
,p_message_text=>unistr('zapo\010Dinje s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479304712400193)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'hr'
,p_message_text=>'Burzovni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400348173400133)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>unistr('Rastegni \0161irinu stupca')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112441421724400166)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'hr'
,p_message_text=>'Pretplata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112459429425400178)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'hr'
,p_message_text=>'Zbroj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500694936400208)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'hr'
,p_message_text=>unistr('Interaktivna re\0161etka. Izvje\0161\0107e: %0, prikaz: %1.')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112494641027400204)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'hr'
,p_message_text=>'Ukupni zbroj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477513160400192)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Cilj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483997018400196)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'hr'
,p_message_text=>'Boja teksta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410163961400141)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'hr'
,p_message_text=>'Prebacivanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457831514400177)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'hr'
,p_message_text=>'Opis alata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112438254948400163)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'hr'
,p_message_text=>'Vrsta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112442681178400166)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'hr'
,p_message_text=>'Odmrzni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439704527400164)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'hr'
,p_message_text=>'Jedinica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486985268400199)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'hr'
,p_message_text=>unistr('Postoje promjene koje nisu spremljene. \017Delite li nastaviti?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112439605594400164)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476629089400191)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481539514400195)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost je obavezna.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466425805400184)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrijednost (vremenska zona ne mo\017Ee se promijeniti)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485418941400197)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'hr'
,p_message_text=>'Tekst'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477950628400192)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'hr'
,p_message_text=>'Okomito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437781495400163)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475978551400191)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'hr'
,p_message_text=>'Prikazano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112477457662400192)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Opseg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435683321400161)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'hr'
,p_message_text=>'tj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476045579400191)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'hr'
,p_message_text=>unistr('Minimalna \0161irina stupca (pikseli)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426889827400155)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 izme\0111u %1 i %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426516221400155)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 sadr\017Ei %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426673106400155)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 ne sadr\017Ei %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404729891400137)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 ne zapo\010Dinje s %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425307452400154)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 jednako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425528473400154)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 ve\0107e od %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425620552400154)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'hr'
,p_message_text=>unistr('% ve\0107e od ili jednako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426307669400154)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 u %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427568930400155)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom intervalu od %1 dana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427347473400155)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom intervalu od %1 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427193144400155)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom intervalu od %1 min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427999639400156)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom intervalu od %1 mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427705922400156)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom intervalu od %1 tj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428123125400156)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom intervalu od %1 god.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427475541400155)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom danu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427297484400155)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom satu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427024429400155)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnoj minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427894187400156)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom mjesecu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112427600298400155)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom tjednu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428037058400156)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnoj godini'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429901052400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em intervalu od %1 dana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429788869400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em intervalu od %1 h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429516967400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em intervalu od %1 min')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430383446400158)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em intervalu od %1 mj.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430102966400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em intervalu od %1 tj.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430583953400158)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em intervalu od %1 god.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429870831400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em danu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429679532400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em satu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429429900400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107oj minuti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430236572400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em mjesecu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430041290400157)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em tjednu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430449087400158)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107oj godini')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426021547400154)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'%0 nije prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425955778400154)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'hr'
,p_message_text=>'%0 je prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425734103400154)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 manje od %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425882040400154)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 manje od ili jednako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426160103400154)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 poput %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426745399400155)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 odgovara regularnom izrazu %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432627790400159)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426965486400155)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije izme\0111u %1 i %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425434661400154)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 nije jednako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426478480400154)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 nije %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428786853400156)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom intervalu od %1 dana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428533252400156)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom intervalu od %1 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428385820400156)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom intervalu od %1 min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429179419400157)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom intervalu od %1 mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428990221400157)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom intervalu od %1 tj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429355465400157)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom intervalu od %1 god.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428618188400156)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom danu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428433182400156)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodom satu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428225826400156)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnoj minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429015269400157)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom mjesecu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112428834060400156)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom tjednu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112429227673400157)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnoj godini'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431133911400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em intervalu od %1 dana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430998346400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em intervalu od %1 h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430765390400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em intervalu od %1 min')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431510946400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em intervalu od %1 mjeseci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431318362400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em intervalu od %1 tj.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431797487400159)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em intervalu od %1 god.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431038650400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em danu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430827195400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em satu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112430684245400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107oj minuti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431497836400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em mjesecu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431249227400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em tjednu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431683825400158)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107oj godini')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112426231866400154)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'hr'
,p_message_text=>'%0 nije poput %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433100646400160)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 zapo\010Dinje s %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476771853400191)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435843606400162)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'hr'
,p_message_text=>'godine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476842422400191)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476905609400191)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112485997131400198)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'hr'
,p_message_text=>unistr('Ponedjeljak, 12. sije\010Dnja 2016.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486001119400198)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'hr'
,p_message_text=>unistr('Sije\010Danj')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486144786400198)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'hr'
,p_message_text=>'Prije 16 sati'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112486203743400198)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'hr'
,p_message_text=>'za 16 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341292308400086)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta datoteke nije valjana. Podr\017Eane vrste datoteke: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468145167400185)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'hr'
,p_message_text=>'Pregled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467805032400185)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'hr'
,p_message_text=>'Odabir datoteke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467980546400185)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'hr'
,p_message_text=>'Odabir datoteka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341098284400085)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'hr'
,p_message_text=>'Povuci i ispusti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341458879400086)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'hr'
,p_message_text=>'Povuci i ispusti datoteke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342664887400087)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'hr'
,p_message_text=>'Odaberite datoteku ili je ovdje ispustite.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342736261400087)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'hr'
,p_message_text=>'Odaberite datoteke ili ih ovdje ispustite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342874811400087)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'hr'
,p_message_text=>'Odaberite datoteku ili je ovdje ispustite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342913881400087)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'hr'
,p_message_text=>'Odaberite datoteke ili ih ovdje ispustite.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341311843400086)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'hr'
,p_message_text=>'%0 datoteke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341111777400085)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'hr'
,p_message_text=>unistr('Datoteka je prevelika. Maksimalna veli\010Dina datoteke iznosi %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328919255400076)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Adresa je obavezna.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327861805400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'hr'
,p_message_text=>'Grad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328222110400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'hr'
,p_message_text=>unistr('\0160ifra dr\017Eave')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327932435400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'hr'
,p_message_text=>unistr('Ku\0107ni broj')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328837905400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'hr'
,p_message_text=>unistr('\0160irina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328726599400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'hr'
,p_message_text=>unistr('Du\017Eina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328673514400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei na karti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328325394400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'hr'
,p_message_text=>'Rezultat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328008157400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161tanski broj')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328188786400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'hr'
,p_message_text=>'Stanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327705584400075)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'hr'
,p_message_text=>'Ulica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327692173400075)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Rezultati geokodiranja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340274906400085)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'hr'
,p_message_text=>'Geokodirano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340308176400085)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'hr'
,p_message_text=>'Nije geokodirano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328541287400075)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Mapiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112328481189400075)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Adresa nije prona\0111ena.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329092270400076)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'%0 je obavezna vrijednost.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498895829400207)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Tekst pomo\0107i: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392231987400127)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'hr'
,p_message_text=>unistr('Ozna\010Deno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392348845400127)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'hr'
,p_message_text=>unistr('Neozna\010Deno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338271163400083)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# nije u valjanom rasponu od %0 do %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338340286400083)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'hr'
,p_message_text=>unistr('#LABEL# nije vi\0161ekratnik %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337934083400083)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora odgovarati vrijednostima %0 i %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338186935400083)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416416646400146)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Isklju\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416591443400146)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Uklju\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338001846400083)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321438768400070)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'hr'
,p_message_text=>'Dodaj unos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450691849400172)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'hr'
,p_message_text=>'Dodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450701929400172)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'hr'
,p_message_text=>'Ukloni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321537076400070)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'hr'
,p_message_text=>'Odabrani unosi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454459851400175)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'hr'
,p_message_text=>'Napredno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454762504400175)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'hr'
,p_message_text=>'Odustani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454505097400175)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'hr'
,p_message_text=>unistr('Uobi\010Dajeno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454840917400175)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'hr'
,p_message_text=>unistr('Aktivne opcije predlo\0161ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455466093400176)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Opcije predlo\0161ka nisu dostupne jer se ta komponenta ne prikazuje na stranici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454323406400175)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Opcije predlo\0161ka nisu prona\0111ene.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454650775400175)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'hr'
,p_message_text=>'Spremi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329959848400076)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'hr'
,p_message_text=>unistr('O\010Disti krug')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331780484400078)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'hr'
,p_message_text=>unistr('Prilago\0111eni stilovi nisu valjani JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330294164400077)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'hr'
,p_message_text=>'Alat za udaljenost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330018089400077)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'hr'
,p_message_text=>'Nacrtaj krug'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322696602400071)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'hr'
,p_message_text=>unistr('Za facetno pretra\017Eivanje obavezan je izvor podataka na razini regije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325253495400073)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'hr'
,p_message_text=>'Trenutna lokacija'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326374428400074)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'hr'
,p_message_text=>unistr('Koordinate po\010Detnog polo\017Eaja nisu valjane.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323729645400072)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\010Detni polo\017Eaj mora biti geometrija to\010Dke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326166740400074)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'hr'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324716345400073)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'hr'
,p_message_text=>'Sloj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458021437400177)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'hr'
,p_message_text=>'Sloj: %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329353979400076)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'hr'
,p_message_text=>'Mapiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322586750400071)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'hr'
,p_message_text=>'Poruke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326213169400074)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'hr'
,p_message_text=>'milje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457089496400177)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Podaci sadr\017Ee vi\0161e od sljede\0107eg broj redaka: %0, \0161to je vi\0161e od dopu\0161tenog maksimalnog broja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324526278400072)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'hr'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Uvjeti</a> &nbsp;&nbsp; Kartografski podaci &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323497882400072)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'hr'
,p_message_text=>'SDO_GEOMETRY vrsta podataka nije dostupna u ovoj bazi podataka.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324681637400073)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'hr'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap suradnici </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324840551400073)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'hr'
,p_message_text=>unistr('To\010Dke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458163694400178)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 - to\010Dke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330191797400077)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'hr'
,p_message_text=>'Pravokutno zumiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329880857400076)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'hr'
,p_message_text=>'Ukloni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325184990400073)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'hr'
,p_message_text=>'Ponovo postavi smjer na Sjever'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405467990400137)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'hr'
,p_message_text=>unistr('Uklju\010Di 2D na\010Din rada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405500113400137)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'hr'
,p_message_text=>unistr('Uklju\010Di 3D na\010Din rada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329721772400076)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'hr'
,p_message_text=>'Promjena obavijesti o autorskim pravima'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330383863400077)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'hr'
,p_message_text=>'Ukupna udaljenost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324994386400073)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'hr'
,p_message_text=>unistr('Pove\0107aj')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325020708400073)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'hr'
,p_message_text=>'Smanji'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452517897400174)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'hr'
,p_message_text=>'Podebljano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453479883400174)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'hr'
,p_message_text=>'Slika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453004031400174)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'hr'
,p_message_text=>'Inline kod'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466645525400184)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'hr'
,p_message_text=>'Umetni sliku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466741815400184)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'hr'
,p_message_text=>'Umetni vezu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452615778400174)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'hr'
,p_message_text=>'Kurziv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467322966400184)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'hr'
,p_message_text=>'Veza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453354733400174)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'hr'
,p_message_text=>'Popis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453261806400174)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'hr'
,p_message_text=>'Razvrstani popis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452750966400174)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'hr'
,p_message_text=>'Pregled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452884652400174)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'hr'
,p_message_text=>unistr('Ni\0161ta za pregled')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452948110400174)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'hr'
,p_message_text=>'Precrtano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453187820400174)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'hr'
,p_message_text=>'Nerazvrstani popis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432036292400159)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'hr'
,p_message_text=>'trenutno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112489537717400200)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Vi\0161e...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112431977827400159)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditavanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463761703400182)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'hr'
,p_message_text=>'Poruka obavijesti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437080230400162)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora biti broj manji od ili jednak %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437112011400162)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora biti valjani broj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437282013400163)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# ne odgovara formatu broja %0 (primjer: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436949567400162)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'hr'
,p_message_text=>unistr('#LABEL# mora biti broj ve\0107i od ili jednak %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436855783400162)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'hr'
,p_message_text=>unistr('#LABEL# mora biti broj izme\0111u %0 i %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432199624400159)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'hr'
,p_message_text=>'otvara se u novom prozoru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385316314400121)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'hr'
,p_message_text=>unistr('Stranica je ve\0107 poslana i ne mo\017Ee se ponovo poslati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367964827400107)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Aplikacija "%0" - stranica "%1" nije prona\0111ena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401773664400134)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'#LABEL# mora imati vrijednost.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345064207400089)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451055540400172)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'hr'
,p_message_text=>'Zatvori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450940728400172)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111i%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451295082400173)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451105515400173)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337172136400082)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'hr'
,p_message_text=>unistr('Unesite pojam za pretra\017Eivanje s najmanje sljede\0107im brojem znakova: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406624069400138)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sko\010Dni popis vrijednosti: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337245965400082)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'hr'
,p_message_text=>unistr('Unesite pojam za pretra\017Eivanje.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337028423400082)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Rezultati nisu prona\0111eni.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336951155400082)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'hr'
,p_message_text=>'Ukloni %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424889840400153)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Uvjet pretra\017Eivanja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450831087400172)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461508356400180)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'hr'
,p_message_text=>'Obrada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335513769400081)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Dodaj na po\010Detni zaslon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331515445400078)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\010Cini se da ure\0111aj ili preglednik trenutno ne podr\017Eavaju instalaciju progresivnih web-aplikacija.</p>'),
unistr('    <p class="a-pwaDialog-intro">Ako je aplikacija ve\0107 instalirana na ure\0111aj, otvorite je s po\010Detnog zaslona.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331109489400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije. Dodajte ga na po\010Detni zaslon kako biste ga upotrebljavali preko cijelog  zaslona.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Dodirnite ikonu <strong>Izbornik</strong> u donjem dijelu navigacije</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Dodirnite <strong>Instaliraj</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Dodirnite <strong>Dodaj</strong> za potvrdu</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331288485400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije \010Dije mogu\0107nosti najbolje mo\017Eete iskoristiti u pregledniku Chrome ili Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Dodirnite ikonu <strong>Izbornik</strong> uz adresnu traku</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Dodirnite <strong>Instaliraj</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330888404400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije \010Dije mogu\0107nosti najbolje mo\017Eete iskoristiti u pregledniku Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Dodirnite ikonu <strong>Podijeli</strong> u donjem dijelu navigacije</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Dodirnite <strong>Otvori u pregledniku Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330504889400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije. Kako biste najbolje iskoristili njegove mogu\0107nosti, dodajte ga na po\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Dodirnite ikonu <strong>Vi\0161e</strong> uz adresnu traku    </div>'),
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Dodirnite <strong>Dodaj na po\010Detni zaslon</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Dodirnite <strong style="color:#007AE1;">Dodaj</strong> za potvrdu</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330434190400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije. Kako biste najbolje iskoristili njegove mogu\0107nosti, dodajte ga na po\010Detni zaslon</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Dodirnite ikonu <strong>Dijeli</strong> u donjem dijelu navigacije</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Pomaknite se prema dolje i pritisnite <strong>Dodaj na po\010Detni zaslon</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Dodirnite <strong style="color:#007AE1;">Dodaj</strong> za potvrdu</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325453875400073)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije. Kako biste najbolje iskoristili njegove mogu\0107nosti, dodajte ga na po\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Dodirnite ikonu <strong>Vi\0161e</strong> uz adresnu traku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Dodirnite <strong>Dodaj na po\010Detni zaslon</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Dodirnite <strong style="color:#007AE1;">Dodaj</strong> za potvrdu</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330721797400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije. Kako biste najbolje iskoristili njegove mogu\0107nosti, dodajte ga na po\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Dodirnite ikonu <strong>Podijeli</strong> uz adresnu traku</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Dodirnite <strong>Otvori u pregledniku Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330656282400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije. Kako biste najbolje iskoristili njegove mogu\0107nosti, dodajte ga na po\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Dodirnite ikonu <strong>Podijeli</strong> u donjem dijelu navigacije</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Dodirnite <strong>Otvori u pregledniku Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331473610400078)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije \010Dije mogu\0107nosti najbolje mo\017Eete iskoristiti u pregledniku Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox trenutno ne podr\017Eava instalaciju web-aplikacija.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112330936568400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije \010Dije mogu\0107nosti najbolje mo\017Eete iskoristiti u pregledniku Chrome ili Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox trenutno ne podr\017Eava instalaciju web-aplikacija na sustavu macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331019852400077)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije \010Dije mogu\0107nosti najbolje mo\017Eete iskoristiti u pregledniku Chrome ili Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari trenutno ne podr\017Eava instalaciju web-aplikacija na sustavu macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331392612400078)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ovo web-mjesto ima funkcionalnost aplikacije \010Dije mogu\0107nosti najbolje mo\017Eete iskoristiti u pregledniku Chrome ili Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox trenutno ne podr\017Eava instalaciju web-aplikacija na sustavu Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333821954400080)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Ne mo\017Ee se povezati</h1>'),
'    <p>Za upotrebu ove aplikacije treba vam internetska veza.</p>',
'    <button type="button">Ponovi</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333786878400079)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se povezati')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473536284400189)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'hr'
,p_message_text=>'Dodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417959498400147)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'hr'
,p_message_text=>'Cijeli dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496898216400206)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161alji pozivnicu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496664498400206)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'hr'
,p_message_text=>'Opcije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419755238400149)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'hr'
,p_message_text=>'Dnevni prikaz za cijeli dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419519586400149)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'hr'
,p_message_text=>'Dnevni prikaz za podatke s vremenom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464444218400182)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'hr'
,p_message_text=>'Dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458894812400178)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'hr'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349452774400093)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'hr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349224611400093)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'hr'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349101174400093)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'hr'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349379284400093)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'hr'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348809314400092)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'hr'
,p_message_text=>unistr('Datum zavr\0161etka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349038705400093)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'hr'
,p_message_text=>unistr('Naziv doga\0111aja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496758560400206)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'hr'
,p_message_text=>'Pozivnica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464507721400182)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'hr'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464287891400182)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'hr'
,p_message_text=>'Mjesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467017659400184)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481356915400194)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Nema doga\0111aja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497045268400206)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'hr'
,p_message_text=>unistr('Uredite postoje\0107i doga\0111aj.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496903359400206)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'hr'
,p_message_text=>unistr('Slanje pozivnice e-po\0161tom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467127190400184)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475157898400190)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161alji poruku e-po\0161te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474964504400190)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161alji poruku e-po\0161te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497780149400206)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Sva su polja obavezna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497614236400206)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161alji pozivnicu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496525497400206)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'hr'
,p_message_text=>'Predmet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475008612400190)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'hr'
,p_message_text=>'Primatelj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348917411400092)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'hr'
,p_message_text=>unistr('Datum po\010Detka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472837437400188)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'hr'
,p_message_text=>'Obrazac na %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419335345400149)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'hr'
,p_message_text=>'Vrijeme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467259330400184)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'hr'
,p_message_text=>'Danas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465004595400183)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464388591400182)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'hr'
,p_message_text=>'Tjedan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419628419400149)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'hr'
,p_message_text=>'Tjedni prikaz za cijeli dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419496268400149)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'hr'
,p_message_text=>'Tjedni prikaz za podatke s vremenom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464990306400183)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'hr'
,p_message_text=>'Godina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464612077400182)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Stupci...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464795688400182)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditaj jo\0161...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396822734400130)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'hr'
,p_message_text=>'Natrag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343117486400087)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditaj jo\0161...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345272061400089)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112464857073400183)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditaj jo\0161...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466959480400184)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('ID podru\010Dja %0 nije prona\0111en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345147520400089)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'hr'
,p_message_text=>unistr('Podaci nisu prona\0111eni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369263842400108)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se postaviti numeriranje stranica podru\010Dja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337476282400082)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri postavljanju podru\010Dja numeriranja stranica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458273012400178)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Stupci...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466857643400184)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta podru\010Dja %0 nije podr\017Eana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337365399400082)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri prikazu podru\010Dja "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401872291400134)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'#COLUMN_HEADER# mora imati vrijednost.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496168459400205)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('%0, ure\0111iva\010D oboga\0107enog teksta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403951920400136)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'hr'
,p_message_text=>unistr('HTML oznake oboga\0107enog teksta prekora\010Duju maksimalnu dopu\0161tenu duljinu (stvarni broj znakova: %0, dopu\0161teni broj znakova: %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463896656400182)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455624170400176)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'hr'
,p_message_text=>'Dupliciraj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453998263400175)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'hr'
,p_message_text=>'Prikazani stupci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453876215400174)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'hr'
,p_message_text=>unistr('Isklju\010Di Null vrijednosti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463987710400182)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'hr'
,p_message_text=>'Dodaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417593797400147)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'hr'
,p_message_text=>'Premjesti dolje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417690234400147)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'hr'
,p_message_text=>'Premjesti gore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453660257400174)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454208293400175)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Ostali stupci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453719496400174)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454015064400175)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'hr'
,p_message_text=>'Redak %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454141285400175)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'hr'
,p_message_text=>'Redak %0 od %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455781015400176)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'hr'
,p_message_text=>unistr('Osvje\017Ei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455874885400176)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'hr'
,p_message_text=>'Vrati promjene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112453529215400174)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'hr'
,p_message_text=>'Izbornik postavki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414519229400145)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Na primjer, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322000692400071)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'hr'
,p_message_text=>'Ponovna prijava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321950996400071)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Sesija je zavr\0161ena')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322190997400071)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161iri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321762592400070)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'hr'
,p_message_text=>unistr('Sesija zavr\0161ava u %0. \017Delite li je produljiti?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321817523400071)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'hr'
,p_message_text=>unistr('Sesija \0107e zavr\0161iti u %0 i ne mo\017Ee je se produ\017Eiti. Spremite izmjene odmah kako ne biste izgubili podatke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474753613400190)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi \0161ifre \010Di\0161\0107enja sesije baze podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367895017400107)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi \0161ifre postavljanja sesije baze podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112341975911400086)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Sesija je zavr\0161ena')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473624377400189)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'hr'
,p_message_text=>unistr('Zatvorite ovaj dijalo\0161ki okvir i pritisnite gumb za ponovno u\010Ditavanje preglednika kako biste dobili novu sesiju.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492991564400203)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'hr'
,p_message_text=>'Pritisnite <a href="%0">ovdje</a> za stvaranje nove sesije.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379589163400117)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'hr'
,p_message_text=>'Sesija nije valjana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419002639400148)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'hr'
,p_message_text=>unistr('Za korisnika "%0" ne mogu se omogu\0107iti dinami\010Dne uloge u sesiji stvarne sigurnosti za aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365779115400106)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-99900 Ne mo\017Ee se stvoriti jedinstveni ID sesije: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382063315400119)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Kr\0161enje za\0161tite stanja sesije: uzrok mo\017Ee biti ru\010Dno mijenjanje za\0161ti\0107ene stavke na stranici %0. Ako niste sigurni koji je uzrok pogre\0161ke, za pomo\0107 se obratite administratoru aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501196522400209)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Kr\0161enje za\0161tite stranice: uzrok mo\017Ee biti podno\0161enje stranice koja se jo\0161 nije u\010Ditala ili ru\010Dno mijenjanje za\0161ti\0107enih stavki na stranici. Dodatnu pomo\0107 zatra\017Eite od administratora aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500143816400208)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 sadr\017Ei jedan od sljede\0107ih znakova koji nisu valjani: &<>"/;,*|=% ili --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500266576400208)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 sadr\017Ei jedan od sljede\0107ih znakova koji nisu valjani: &<>"/;,*|=% ili -- ili novi redak.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499980989400208)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 sadr\017Ei posebne znakova. Dopu\0161teni su samo znakovi-Z, 0-9 i razmaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112500088662400208)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 sadr\017Ei znakove <, > ili " koji nisu valjani.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344191685400088)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'hr'
,p_message_text=>unistr('Kontrolni zbroj nije naveden za prikaz obrade za stranicu koja zahtijeva kontrolni zbroj kad se kao parametri proslijede jedna ili vi\0161e vrijednosti zahtjeva, \010Di\0161\0107enja cache memorije ili argumenata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376994219400115)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Kr\0161enje za\0161tite stanja sesije: uzrok mo\017Ee biti ru\010Dno mijenjanje URL-a s kontrolnim zbrojem ili upotreba veze s neto\010Dnim kontrolim zbrojem ili bez kontrolnog broja. Ako niste sigurni koji je uzrok pogre\0161ke, za pomo\0107 se obratite administratoru aplikaci')
||'je.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112454935335400175)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'hr'
,p_message_text=>unistr('Postavi na\010Din visokog kontrasta na isklju\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455037108400175)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'hr'
,p_message_text=>unistr('Postavi na\010Din visokog kontrasta na uklju\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373688734400112)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'hr'
,p_message_text=>'Dno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373856194400112)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'hr'
,p_message_text=>'Dolje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373981237400112)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'hr'
,p_message_text=>'Premjesti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374015909400112)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'hr'
,p_message_text=>'Premjesti sve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374104350400112)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'hr'
,p_message_text=>'Ukloni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374260986400112)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'hr'
,p_message_text=>'Ukloni sve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374305213400112)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'hr'
,p_message_text=>'Ponovo postavi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373583774400112)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'hr'
,p_message_text=>'Vrh'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373700729400112)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'hr'
,p_message_text=>'Gore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482653762400195)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'hr'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483383928400196)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'za %0 d.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482511462400195)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'hr'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483438895400196)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'za %0 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482327286400195)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'hr'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483597370400196)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'za %0 mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482964756400196)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'hr'
,p_message_text=>'%0 mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483146043400196)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'za %0 mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482434619400195)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'hr'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483248919400196)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'za %0 s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482774397400195)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'hr'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483602878400196)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'za %0 tj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482825616400196)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'hr'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112483006401400196)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'za %0 god.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322986861400071)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'hr'
,p_message_text=>'[Linija]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323383658400072)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'hr'
,p_message_text=>unistr('[Vi\0161e linija]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323105547400071)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'hr'
,p_message_text=>unistr('[Vi\0161e to\010Daka]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323517576400072)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'hr'
,p_message_text=>unistr('[Vi\0161e poligona]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323617359400072)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'hr'
,p_message_text=>'[Geometrijski objekt]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322818272400071)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'hr'
,p_message_text=>unistr('[To\010Dka (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323013459400071)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'hr'
,p_message_text=>'[Poligon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400200446400133)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sa\017Emi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400108196400133)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'hr'
,p_message_text=>'Vrati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446648190400169)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i ocjenu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436531464400162)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u valjanom rasponu ocjena od 1 - %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436654771400162)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'hr'
,p_message_text=>'%0 nije broj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432794338400159)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'hr'
,p_message_text=>'Poruka o uspjehu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495819175400205)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495782929400205)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481414296400195)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'hr'
,p_message_text=>'Alatna traka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496232223400205)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161iri/sa\017Emi navigaciju')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496373615400205)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161iri/sa\017Emi bo\010Dni stupac')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405949604400138)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Glavna navigacija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412914355400143)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'hr'
,p_message_text=>'1 dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412756845400143)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'hr'
,p_message_text=>'1 sat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413050977400143)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'hr'
,p_message_text=>'%0 dana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412858864400143)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'hr'
,p_message_text=>'%0 h'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412673744400143)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'hr'
,p_message_text=>'%0 min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413297110400143)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'hr'
,p_message_text=>'%0 tj.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112413101115400143)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'hr'
,p_message_text=>'1 tjedan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499443767400208)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\010Detak stranice')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361400380400102)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Omogu\0107eno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335285470400081)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri obradi zahtjeva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414624035400145)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Obavezna vrijednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497512281400206)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'hr'
,p_message_text=>unistr('Pri\010Dekajte da se stranica u\010Dita do kraja i poku\0161ajte ponovo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457745282400177)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'hr'
,p_message_text=>unistr('Ova stranica sadr\017Ei nespremljene promjene.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338604828400083)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'hr'
,p_message_text=>'Radna knjiga nema aktivni radni list.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338564907400083)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'hr'
,p_message_text=>'Radna knjiga nije inicijalizirana.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338474843400083)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pri stvaranju XLSX datoteke do\0161lo je do interne pogre\0161ke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340940965400085)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'hr'
,p_message_text=>'List'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472621634400188)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'hr'
,p_message_text=>'Akcije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390137926400125)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'hr'
,p_message_text=>'Izbornik akcija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385810152400122)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>'Dodaj funkciju'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385706103400121)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Dodaj Grupiraj po stupcu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419926912400149)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Dodaj zaokretni stupac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420071919400149)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Dodaj stupac retka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360213185400102)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'hr'
,p_message_text=>'Agregiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396322553400130)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'hr'
,p_message_text=>'Agregiranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377488142400115)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'hr'
,p_message_text=>'Prosjek'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381794492400118)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'hr'
,p_message_text=>'Broj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377522652400115)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'hr'
,p_message_text=>'Maksimalno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377749943400115)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'hr'
,p_message_text=>'Sredina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377634096400115)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'hr'
,p_message_text=>'Minimalno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377315233400115)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'hr'
,p_message_text=>'Zbroj %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378462368400116)
,p_name=>'APEXIR_ALL'
,p_message_language=>'hr'
,p_message_text=>'Sve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359579375400101)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Svi stupci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342089834400086)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'hr'
,p_message_text=>'Svi redci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469629807400186)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'hr'
,p_message_text=>'Alternativno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471285713400187)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'hr'
,p_message_text=>'Alternativno zadano:  %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372153295400111)
,p_name=>'APEXIR_AND'
,p_message_language=>'hr'
,p_message_text=>'i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361690441400103)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'hr'
,p_message_text=>'Primijeni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355395243400098)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'hr'
,p_message_text=>'Uzlazno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374924641400113)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'hr'
,p_message_text=>'Na dan%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471815236400188)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'hr'
,p_message_text=>'Prosjek %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463228473400181)
,p_name=>'APEXIR_BAR'
,p_message_language=>'hr'
,p_message_text=>'Traka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361056272400102)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'hr'
,p_message_text=>unistr('izme\0111u')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354101585400097)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'hr'
,p_message_text=>'Boja pozadine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356077779400098)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'hr'
,p_message_text=>'plava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387732578400123)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'hr'
,p_message_text=>'Dno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356635201400099)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'hr'
,p_message_text=>'Odustani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362556735400103)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'hr'
,p_message_text=>'Kategorija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354051147400097)
,p_name=>'APEXIR_CELL'
,p_message_language=>'hr'
,p_message_text=>unistr('\0106elija')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378338985400116)
,p_name=>'APEXIR_CHART'
,p_message_language=>'hr'
,p_message_text=>'Grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388682215400124)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'hr'
,p_message_text=>'Inicijalizacija...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112424945941400153)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Mora se navesti oznaka grafikona.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437341475400163)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Upit prekora\010Duje sljede\0107i maksimalni broj podatkovnih to\010Daka po grafikonu: %0. Primijenite filtar kako biste smanjili broj zapisa u osnovnom upitu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436246707400162)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Maksimalni broj redaka za upit grafikona ograni\010Dava broj redaka u osnovnom upitu, a ne prikazani broj redaka.'),
unistr('Osnovni upit prekora\010Duje maksimalni broj redaka koji iznosi %0. Primijenite filtar kako biste smanjili broj zapisa u osnovnom upitu.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359645337400101)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Vrsta grafikona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112432927626400159)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'hr'
,p_message_text=>unistr('Ozna\010Di sve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375335180400113)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'hr'
,p_message_text=>unistr('Odabir formata izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382770201400119)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('o\010Disti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356593178400099)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Stupac'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393958676400128)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Stupci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466210829400184)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'hr'
,p_message_text=>'Filtriranje...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384760947400121)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'hr'
,p_message_text=>'Izbornik zaglavlja stupca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388495742400124)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'hr'
,p_message_text=>'Informacije iz stupca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468580018400185)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Oznaka stupca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386144112400122)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'hr'
,p_message_text=>'Stupac %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370201166400109)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'hr'
,p_message_text=>unistr('sadr\017Ei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371131633400110)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'hr'
,p_message_text=>unistr('ne sadr\017Ei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355001332400097)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'hr'
,p_message_text=>'in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371382243400110)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'hr'
,p_message_text=>'nije u zadnjem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379850212400117)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('nije u sljede\0107em')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371236812400110)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'hr'
,p_message_text=>'je u zadnjem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379784484400117)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('je u sljede\0107em')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354958515400097)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'is not null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354861602400097)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'hr'
,p_message_text=>'is null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354678084400097)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'hr'
,p_message_text=>'like'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355126161400098)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'hr'
,p_message_text=>'not in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354791869400097)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'hr'
,p_message_text=>'not like'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370572975400110)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'hr'
,p_message_text=>'odgovara regularnom izrazu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375205550400113)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Izra\010Dun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112435987550400162)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'hr'
,p_message_text=>unistr('Izraz izra\010Duna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394244128400128)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'hr'
,p_message_text=>unistr('Stvorite izra\010Dun pomo\0107u drugih naziva stupca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394311940400128)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'hr'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394419913400128)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'hr'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394516615400128)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'hr'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340411252400085)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'hr'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379129835400116)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'hr'
,p_message_text=>unistr('Izra\010Dun')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386778397400122)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'hr'
,p_message_text=>'Kontrolno razdvajanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389737763400125)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'hr'
,p_message_text=>'Kontrolna razdvajanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474180325400189)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Stupci kontrolnih razdvajanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337588201400082)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbroji razli\010Dite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472383007400188)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbroji razli\010Dite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472267585400188)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'hr'
,p_message_text=>'Broj %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444332055400168)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'hr'
,p_message_text=>'Dnevno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499004525400207)
,p_name=>'APEXIR_DATA'
,p_message_language=>'hr'
,p_message_text=>'Podaci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388558324400124)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei podatke od prije %0 min.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462088576400180)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za podatkovnu re\0161etku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360326789400102)
,p_name=>'APEXIR_DATE'
,p_message_language=>'hr'
,p_message_text=>'Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392474244400127)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'hr'
,p_message_text=>'Zadano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469433403400186)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Zadana vrsta izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356742793400099)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360632936400102)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'hr'
,p_message_text=>unistr('\017Delite li izbrisati ove postavke izvje\0161\0107a?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455393950400176)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i zadano izvje\0161\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386459991400122)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbri\0161i izvje\0161\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355401690400098)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'hr'
,p_message_text=>'Silazno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362610753400103)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'hr'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384660235400121)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'hr'
,p_message_text=>'Prikaz jednog retka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392944167400127)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'hr'
,p_message_text=>'Smjer %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393831540400128)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Onemogu\0107eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356245863400098)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'hr'
,p_message_text=>'Prikazano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359401671400101)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Prikazani stupci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392838328400127)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei u izvje\0161\0107u')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387605605400123)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'hr'
,p_message_text=>'Dolje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379257469400116)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'hr'
,p_message_text=>'Preuzmi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392737520400127)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'hr'
,p_message_text=>'Nemoj prikazivati'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458750744400178)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'hr'
,p_message_text=>unistr('Isticanje s istim uvjetom ve\0107 postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474335222400189)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Duplicirani zaokretni stupac. Popis zaokretnih stupaca mora biti jedinstven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474514882400190)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'hr'
,p_message_text=>'Uredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388796248400124)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'hr'
,p_message_text=>'Uredi postavke grafikona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395367222400129)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'hr'
,p_message_text=>'Uredi grafikon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395721688400129)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'hr'
,p_message_text=>'Uredi filtar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450186817400172)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'hr'
,p_message_text=>'Uredi grupiranje po'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395663099400129)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'hr'
,p_message_text=>'Uredi isticanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420258487400149)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'hr'
,p_message_text=>unistr('Ure\0111ivanje zaokretanja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469716079400186)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'hr'
,p_message_text=>unistr('E-po\0161ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348444213400092)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'hr'
,p_message_text=>unistr('Adresa e-po\0161te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470040953400186)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'hr'
,p_message_text=>'Skriveni primatelji'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470286907400186)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'hr'
,p_message_text=>'Glavni dio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469991002400186)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'hr'
,p_message_text=>'Primatelj kopije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470777631400187)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Destalost')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352137202400095)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'hr'
,p_message_text=>unistr('E-po\0161ta nije konfigurirana za ovu aplikaciju. Obratite se administratoru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443649829400167)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Morate navesti adresu e-po\0161te.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470309596400187)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei prilo\017Eeno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470130081400186)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'hr'
,p_message_text=>'Predmet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444609652400168)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Morate navesti predmet e-po\0161te.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469830046400186)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'hr'
,p_message_text=>'Primatelj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353899552400097)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Omogu\0107eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395553792400129)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'hr'
,p_message_text=>unistr('Omogu\0107i/onemogu\0107i')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395024688400129)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394692342400129)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'hr'
,p_message_text=>'Primjeri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395450655400129)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'hr'
,p_message_text=>'Primjeri:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359336925400101)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'hr'
,p_message_text=>unistr('Isklju\010Di Null vrijednosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396085995400130)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161iri/sa\017Emi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393671179400128)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'hr'
,p_message_text=>'Izraz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378716955400116)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'hr'
,p_message_text=>'Filtar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389679294400125)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'hr'
,p_message_text=>'Filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399936420400133)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'hr'
,p_message_text=>'Izraz filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496493906400205)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'hr'
,p_message_text=>unistr('Izraz filtra je preduga\010Dak.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399835712400133)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Vrsta filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396285972400130)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'hr'
,p_message_text=>unistr('Odaberite stupce za pretra\017Eivanje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379019898400116)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'hr'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393473132400128)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Upit Flashback omogu\0107uje vam prikaz podataka u stanju u kojem su bili u prethodnoj vremenskoj to\010Dki.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444039774400167)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Flashback - trajanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445429301400168)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375135284400113)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'hr'
,p_message_text=>'Maska formata %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386307443400122)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>'Funkcija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394174689400128)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'hr'
,p_message_text=>'Funkcije %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469382591400186)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'hr'
,p_message_text=>'Funkcije/operatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386021477400122)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'hr'
,p_message_text=>'Funkcija %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378570609400116)
,p_name=>'APEXIR_GO'
,p_message_language=>'hr'
,p_message_text=>'Idi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354321209400097)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'hr'
,p_message_text=>'zelena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112337636384400083)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'hr'
,p_message_text=>'Grupiraj prema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470425622400187)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Grupiranje po stupcu %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425038201400153)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Mora se navesti grupiranje po stupcu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436176191400162)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Maksimalni broj redaka za upit Grupiraj po ograni\010Dava broj redaka u osnovnom upitu, a ne prikazani broj redaka. Osnovni upit prekora\010Duje maksimalni broj redaka koji iznosi %0. Primijenite filtar kako biste smanjili broj zapisa u osnovnom upitu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416727816400146)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'hr'
,p_message_text=>'Sortiranje grupiranja po'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474298432400189)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'hr'
,p_message_text=>'Grupiranje po redoslijedu sortiranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359752409400101)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'hr'
,p_message_text=>'Vodoravni stupac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391333313400126)
,p_name=>'APEXIR_HELP'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383112237400119)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Interaktivna izvje\0161\0107a omogu\0107uju krajnjim korisnicima prilago\0111avanje izvje\0161\0107a. Korisnici mogu izmijeniti izgled podataka izvje\0161\0107a odabirom stupaca, primjenom filtara, isticanjem i sortiranjem. Korisnici mogu i definirati razdvajanja, agregiranja, graf')
||unistr('ikone i na\010Dine grupiranja te dodavati vlastite izra\010Dune. Korisnici mogu i postaviti pretplatu kako bi e-po\0161tom primali HTML verziju izvje\0161\0107a u odre\0111enom intervalu. Korisnici mogu stvoriti vi\0161e verzija izvje\0161\0107a i spremati ih pod razli\010Ditim nazivima za')
||' javni ili privatni pregled. ',
'<p/>',
unistr('U sljede\0107im odjeljcima sa\017Eeto su opisani na\010Dini na koje mo\017Eete prilagoditi interaktivno izvje\0161\0107e. Pogledajte "Upotreba interaktivnih izvje\0161\0107a" u <i>Priru\010Dniku za krajnjeg korisnika platforme Oracle Application Express</i></a> kako biste saznali vi\0161e.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390237985400125)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbornik akcija pojavljuje se desno od gumba Idi na traci za pretra\017Eivanje. Pomo\0107u tog izbornika mo\017Eete prilagoditi interaktivno izvje\0161\0107e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383909698400120)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agregiranja su matemati\010Dki izra\010Duni koji se izvr\0161avaju na stupcima. Agregiranja se prikazuju nakon svakog kontrolnog razdvajanja i na kraju izvje\0161\0107a u stupcu koji definiraju. Opcije obuhva\0107aju:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agregiranje</strong> vam omogu\0107uje odabir prethodno definiranog'),
unistr('agregiranja za ure\0111ivanje.</li>'),
unistr('<li><strong>Funkcija</strong> je funkcija koja \0107e se izvr\0161iti (primjerice, SUM, MIN).</li>'),
unistr('<li><strong>Stupac</strong> se upotrebljava za odabir stupca na koji \0107e se primijeniti matemati\010Dka funkcija. Prikazuju se samo'),
unistr('numeri\010Dki stupci.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384091519400120)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mo\017Eete definirati jedan grafikon po spremljenom izvje\0161\0107u. Nakon'),
unistr('\0161to ga definirate, mo\017Eete prelaziti s prikaza grafikona na prikaz izvje\0161\0107a i obratno pomo\0107u ikona prikaza na traci za pretra\017Eivanje.'),
unistr('Opcije obuhva\0107aju:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>Vrsta grafikona</strong> identificira vrstu grafikona koju \0107e se uklju\010Diti.'),
unistr('Birajte izme\0111u vodoravnog trakastog, okomitog trakastog, tortnog ili linijskog grafikona.</li>'),
unistr('<li><strong>Oznaka</strong> vam omogu\0107uje biranje stupca koji \0107e se upotrijebiti kao oznaka.</li>'),
'<li><strong>Naslov osi za oznaku</strong> naslov je koji se prikazuje na osi povezanoj sa stupcem odabranim za',
'oznaku. To nije dostupno za tortni grafikon.</li>',
unistr('<li><strong>Vrijednost</strong> vam omogu\0107uje odabir stupca koji \0107e se upotrijebiti kao vrijednost. Ako je va\0161a funkcija COUNT, vrijednost se ne mora odabrati.</li>'),
'<li><strong>Naslov osi za vrijednost</strong> naslov je koji se prikazuje na osi povezanoj sa stupcem odabranim za',
'vrijednost. To nije dostupno za tortni grafikon.</li>',
unistr('<li><strong>Funkcija</strong> je neobavezna funkcija koja \0107e se izvr\0161iti na stupcu odabranom za vrijednost.</li>'),
unistr('<li><strong>Sortiranje</strong> vam omogu\0107uje sortiranje skupa rezultata.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383367312400120)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pritiskom na bilo koje zaglavlje stupca otkriva se izbornik zaglavlja stupca. Opcije obuhva\0107aju:'),
'<p></p>',
'<ul>',
'Ikona <li><strong>Uzlazno sortiranje</strong> sortira podatke u stupcu uzlaznim redoslijedom.</li>',
'Ikona <li><strong>Silazno sortiranje</strong> sortira podatke u stupcu silaznim redoslijedom.</li>',
unistr('<li><strong>Sakrij stupac</strong> skriva stupac. Ne mo\017Ee se sakriti sve stupce. Ako se stupac ne mo\017Ee sakriti, ne\0107e postojati ikona Sakrij stupac.</li>'),
unistr('<li><strong>Grupiraju\0107i stupac</strong> stvara grupu razdvajanja na stupcu. Time se stupac izvla\010Di iz izvje\0161\0107a kao glavni zapis.</li>'),
unistr('<li><strong>Informacije o stupcu</strong> prikazuju tekst pomo\0107i o stupcu, ako je dostupan.</li>'),
unistr('<li><strong>Podru\010Dje teksta</strong> upotrebljava se za uno\0161enje kriterija pretra\017Eivanja bez razlikovanja velikih i malih slova'),
'(bez potrebe za zamjenskim znakovima). Unos vrijednosti smanjuje popis',
unistr('vrijednosti u dnu izbornika. Zatim mo\017Eete odabrati vrijednost s dna'),
unistr('i odabrana vrijednost stvorit \0107e se kao filtar pomo\0107u ''='''),
unistr('(primjerice, <code>column = ''ABC''</code>). Umjesto toga mo\017Eete pritisnuti ikonu lampice i unijeti vrijednost koja \0107e se stvoriti kao filtar s modifikatorom ''LIKE'''),
'(primjerice, <code>column LIKE ''%ABC%''</code>).</li>',
unistr('<li><b>Popis jedinstvenih vrijednosti</b> sadr\017Ei prvih 500 jedinstvenih'),
'vrijednosti koje ispunjavaju kriterije filtriranja. Ako je stupac datum, umjesto njega prikazuje se popis raspona',
unistr('datuma. Ako odaberete vrijednost, stvorit \0107e se filtar'),
unistr('pomo\0107u ''='' (primjerice, <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383849899400120)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Omogu\0107uje vam dodavanje izra\010Dunatih stupaca u izvje\0161\0107e. To mogu biti matemati\010Dki izra\010Duni (primjerice, <code>NBR_HOURS/24</code>) ili standardne Oracle'),
unistr('funkcije primijenjene na postoje\0107e stupce. Neki se prikazuju kao primjeri, a mogu se upotrebljavati i drugi (poput <code>TO_DATE)</code>. Opcije obuhva\0107aju:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Izra\010Dun</strong> vam omogu\0107ava odabir prethodno definiranog izra\010Duna za ure\0111ivanje.</li>'),
'<li><strong>Zaglavlje stupca</strong> zaglavlje je stupca za novi stupac.</li>',
'<li><strong>Maska formata</strong> odnosi se na Oracle masku formata koja se primjenjuje na stupac (primjerice, S9999).</li>',
unistr('<li><strong>Izra\010Dun</strong> je izra\010Dun koji se izvr\0161ava. Unutar izra\010Duna stupci se referenciraju pomo\0107u prikazanih drugih naziva.</li>'),
'</ul>',
unistr('<p>Ispod izra\010Duna stupci u upitu prikazuju se s povezanim'),
unistr('drugim nazivima. Pritiskom na naziv stupca ili drugi naziv uklju\010Duje ih se'),
unistr('u izra\010Dun. Uz stupce se nalazi tipkovnica. Ta tipkovnica funkcionira'),
unistr('kao pre\010Dac za \010Desto upotrebljavane tipke. Krajnje desno nalaze se funkcije.</p>'),
unistr('<p>Sljede\0107i primjer izra\010Duna pokazuje kako prikazati ukupnu naknadu:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(pri \010Demu je A ORGANIZACIJA, B PLA\0106A, a C PROVIZIJA)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390397077400125)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'hr'
,p_message_text=>unistr('Upotrebljava se za stvaranje grupe razdvajanja u jednom ili vi\0161e stupaca. Time se stupci izvla\010De iz interaktivnog izvje\0161\0107a i prikazuju kao glavni zapis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384583121400121)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'hr'
,p_message_text=>unistr('Za prikaz pojedinosti svakog pojedina\010Dnog retka pritisnite ikonu prikaza pojedina\010Dnog retka na retku koji \017Eelite prikazati. Ako je dostupan, prikaz pojedina\010Dnog retka uvijek \0107e biti u prvom stupcu. Ovisno o prilago\0111avanju interaktivnog izvje\0161\0107a prika')
||unistr('z pojedina\010Dnog retka mo\017Ee biti standardni prikaz ili prilago\0111ena stranica s mogu\0107im dopu\0161tenjem a\017Euriranja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384429728400120)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Omogu\0107uje preuzimanje trenutnog skupa rezultata. Formati preuzimanja razlikuju se'),
unistr('ovisno o instalaciji i definiciji izvje\0161\0107a, ali'),
unistr('mogu obuhva\0107ati CSV, HTML, Email, XLS, PDF ili RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383527759400120)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fokusira izvje\0161\0107e dodavanjem ili mijenjanjem uvjeta <code>WHERE</code> u upitu. Mo\017Eete filtrirati po stupcu ili retku.  '),
'<p>Ako filtrirate po stupcu, odaberite stupac (ne mora biti onaj koji se prikazuje), odaberite standardni Oracle operator (=, !=, not in, between) i unesite izraz za usporedbu. Izrazi razlikuju veliko i malo slovo. Upotrijebite % kao zamjenski znak ('
||'primjerice, <code>STATE_NAME',
'like A%)</code>.</p>',
unistr('<p>Ako filtrirate po retku, mo\017Eete stvoriti slo\017Eene uvjete <code>WHERE</code> pomo\0107u'),
'drugih naziva stupca i bilo kojih Oracle funkcija i operatora (primjerice, <code>G = ''VA'' or G = ''CT''</code>, gdje je',
'<code>G</code> drugi naziv za <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384187573400120)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Upit Flashback omogu\0107uje vam prikaz podataka u obliku u kojem su postojali u prethodnoj vremenskoj'),
unistr('to\010Dki. Zadana koli\010Dina vremena za koju mo\017Eete izvr\0161iti flashback iznosi 3 sata (ili 180'),
unistr('minuta), ali stvarno \0107e se vrijeme razlikovati za svaku bazu podataka.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445329983400168)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Format vam omogu\0107uje prilagodbu prikaza izvje\0161\0107a.'),
unistr('Format sadr\017Ei sljede\0107e podizbornike:</p>'),
'<ul><li>Sortiranje</li>',
'<li>Kontrolno razdvajanje</li>',
'<li>Isticanje</li>',
unistr('<li>Izra\010Dun</li>'),
'<li>Agregiranje</li>',
'<li>Grafikon</li>',
'<li>Grupiranje po</li>',
'<li>Zaokretanje</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443563775400167)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mo\017Eete definirati jedan prikaz na\010Dina grupiranja po spremljenom'),
unistr('izvje\0161\0107u. Nakon definiranja mo\017Eete prebacivati sa prikaza grupiranja po na prikaz izvje\0161\0107a i obratno pomo\0107u ikona prikaza na traci za pretra\017Eivanje. Kako biste stvorili prikaz grupiranja po, odaberite:'),
'<p></p><ul>',
unistr('<li>stupce na koje \0107e se grupiranje primijeniti</li>'),
unistr('<li>stupce za za agregiranje uz funkciju koja se izvodi (prosje\010Dno, zbroj, broj itd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383746855400120)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Omogu\0107uje vam definiranje filtra. Redci koji ispunjavaju kriterije filtriranja prikazuju se kao istaknuti upotrebom zna\010Dajki povezanih s filtrom. Opcije obuhva\0107aju:</p>'),
'<ul>',
'<li><strong>Naziv</strong> se upotrebljava samo za prikaz.</li>',
'<li><strong>Slijed</strong> identificira slijed ocjenjivanja pravila.</li>',
unistr('<li><strong>Omogu\0107eno</strong> identificira je li pravilo omogu\0107eno ili onemogu\0107eno.</li>'),
'<li><strong>Vrsta isticanja</strong> identificira treba li se istaknuti redak ili',
unistr('\0107elija. Ako se odabere \0107elija, isti\010De se stupac naveden u'),
'uvjetu isticanja.</li>',
unistr('<li><strong>Boja pozadine</strong> odnosi se na novu boju pozadine istaknutog podru\010Dja.</li>'),
unistr('<li><strong>Boja teksta</strong> nova je boja teksta istaknutog podru\010Dja.</li>'),
'<li><strong>Uvjet isticanja</strong> definira uvjet filtriranja.</li>',
'</ul>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321399184400070)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mo\017Eete definirati jedan zaokretni prikaz po spremljenom izvje\0161\0107u. Nakon definiranja mo\017Eete prebacivati sa zaokretnog prikaza na prikaz izvje\0161\0107a i obratno pomo\0107u ikona prikaza na traci za pretra\017Eivanje. Kako biste stvorili prikaz zaokretanja, odaberit')
||'e: ',
'<p></p>',
'<ul>',
unistr('<li>stupce na koje \0107e se zaokretanje primijeniti</li>'),
'<li>stupce za prikaz kao retke</li>',
unistr('<li>stupce za agregiranje uz funkciju koja se izvodi (prosje\010Dno, zbroj, broj itd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394871484400129)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ako prilagodite interaktivno izvje\0161\0107e, postavke izvje\0161\0107a prikazuju se'),
unistr('ispod trake za pretra\017Eivanje i iznad izvje\0161\0107a. To se podru\010Dje mo\017Ee sa\017Eeti i pro\0161iriti uz pomo\0107 ikone s lijeve strane.'),
'<p>',
unistr('Za svaku postavku izvje\0161\0107a mo\017Eete napraviti sljede\0107e:'),
'</p><ul>',
'<li>Urediti postavku tako da pritisnete njezin naziv.</li>',
unistr('<li>Onemogu\0107iti/omogu\0107iti postavku tako da poni\0161tite oznaku / ozna\010Dite potvrdni okvir Omogu\0107i/Onemogu\0107i. Upotrebom te kontrole privremeno uklju\010Dite i isklju\010Dite postavku.</li>'),
'<li>Ukloniti postavku tako da pritisnete ikonu Ukloni.</li>',
'</ul>',
unistr('<p>Ako ste stvorili grafikon, grupiranje po ili zaokretanje, mo\017Eete se prebacivati izme\0111u tih opcija i osnovnog izvje\0161\0107a upotrebom veza na prikaz izvje\0161\0107a, prikaz grafikona, prikaz grupiranja po i zaokretni prikaz'),
unistr('koje se nalaze s desne strane. Ako prika\017Eete grafikon, grupiranje po ili zaokretanje,'),
unistr('mo\017Eete upotrijebiti i vezu za ure\0111ivanje kako biste uredili postavke.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384350894400120)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'hr'
,p_message_text=>unistr('Ponovno postavlja izvje\0161\0107e na zadane postavke i uklanja sve prilagodbe koje ste napravili.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445622212400169)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'hr'
,p_message_text=>'Postavite broj zapisa za prikaz po stranici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384234223400120)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sprema prilago\0111eno izvje\0161\0107e za budu\0107u upotrebu. Navedite naziv i neobavezni opis, a mo\017Eete ga u\010Diniti i javno dostupnim (odnosno, dostupnim svim korisnicima koji mogu pristupiti primarnom zadanom izvje\0161\0107u). Mogu se spremiti \010Detiri vrste interaktiv')
||unistr('nih izvje\0161\0107a:</p>'),
'<ul>',
unistr('<li><strong>Primarno zadano</strong> (samo za razvojne programere). Primarno zadano izvje\0161\0107e ono je koje se inicijalno prikazuje. Naziv primarnih zadanih izvje\0161\0107a ne mo\017Ee se mijenjati niti ga se mo\017Ee izbrisati.</li>'),
unistr('<li><strong>Alternativno izvje\0161\0107e</strong> (samo za razvojne programere). Omogu\0107uje razvojnim programerima stvaranje vi\0161e izgleda izvje\0161\0107a. Samo razvojni programeri mogu spremati, mijenjati naziv izvje\0161\0107a ili izbrisati alternativno izvje\0161\0107e.</li>'),
unistr('<li><strong>Javno izvje\0161\0107e</strong> (krajni korisnik). Mo\017Ee ga spremiti, promijeniti mu naziv ili izbrisati krajnji korisnik koji ga je stvorio. Ostali korisnici mogu prikazati i spremiti izgled kao drugo izvje\0161\0107e.</li>'),
unistr('<li><strong>Privatno izvje\0161\0107e</strong> (krajnji korisnik). Samo krajnji korisnik koji je stvorio izvje\0161\0107e mo\017Ee prikazati, spremiti, promijeniti naziv izvje\0161\0107a ili izbrisati izvje\0161\0107e.</li>'),
'</ul>',
unistr('<p>Ako spremate prilago\0111ena izvje\0161\0107a, u traci za pretra\017Eivanje lijevo od alata za odabir redaka prikazat \0107e se alat za odabir izvje\0161\0107a (ako je ta zna\010Dajka omogu\0107ena).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383296941400119)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'hr'
,p_message_text=>unistr('U vrhu svake stranice izvje\0161\0107a nalazi se podru\010Dje za pretra\017Eivanje. To podru\010Dje (ili traka za pretra\017Eivanje) sadr\017Ei sljede\0107e zna\010Dajke:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446283160400169)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'hr'
,p_message_text=>unistr('<li><strong>Izbornik akcija</strong> omogu\0107uje vam prilago\0111avanje izvje\0161\0107a. Pogledajte odjeljke u nastavku.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445708456400169)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'hr'
,p_message_text=>unistr('<li><strong>Ikona za odabir stupaca</strong> omogu\0107uje vam identificiranje stupaca za pretra\017Eivanje (ili odabir svih).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446008046400169)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'hr'
,p_message_text=>unistr('<li><strong>Izvje\0161\0107a</strong> prikazuju alternativna zadana i spremljena privatna ili javna izvje\0161\0107a.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445913748400169)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'hr'
,p_message_text=>'<li><strong>Redci</strong> postavljaju broj zapisa za prikaz po stranici.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445803069400169)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Podru\010Dje teksta</strong> omogu\0107uje vam unos kriterija pretra\017Eivanja bez razlikovanja malog i velikog slova (zamjenski znakovi su implicirani).</li>'),
unistr('<li><strong>Gumb Idi</strong> izvr\0161ava pretra\017Eivanje. Pritiskom na tipku enter tako\0111er \0107e se izvr\0161iti pretra\017Eivanje kada je pokaziva\010D u podru\010Dju teksta za pretra\017Eivanje.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446139129400169)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'hr'
,p_message_text=>unistr('<li><strong>Ikone prikaza</strong> slu\017Ee za prebacivanje izme\0111u prikaza ikona, izvje\0161\0107a, pojedinosti, grafikona, grupiranja po i zaokretanja za izvje\0161\0107e, ako su definirani.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462151827400181)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'hr'
,p_message_text=>unistr('<li><strong>Upravljanje</strong> vam omogu\0107uje upravljanje prethodnim svojstvima, stupcima, redcima i prikazima za izvje\0161\0107e ili podatkovnu re\0161etku.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383480315400120)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>unistr('Upotrebljava se za izmjenu prikazanih stupaca. Prikazuju se desni stupci. Lijevi stupci ostaju sakriveni. Redoslijed prikazanih stupaca mo\017Eete promijeniti upotrebom strelica koje se nalaze krajnje desno. Izra\010Dunati stupci imaju prefiks <strong>**</st')
||'rong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383618157400120)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Upotrebljava se za mijenjanje stupaca za sortiranje i odre\0111uje ho\0107e li se'),
unistr('sortiranje vr\0161iti uzlazno ili silazno. Mo\017Eete i navesti kako \0107e se obra\0111ivati vrijednosti'),
unistr('<code>NULLs</code>. Prema zadanoj postavci vrijednosti <code>NULLs</code> uvijek se prikazuju posljednje ili ih se mo\017Ee prikazati prve. Rezultiraju\0107e sortiranje prikazuje se desno od'),
unistr('zaglavlja stupca u izvje\0161\0107u.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443333359400167)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Kada dodate pretplatu, trebate navesti adresu e-po\0161te (ili vi\0161e adresa e-po\0161te odvojenih zarezom), predmet e-po\0161te, u\010Destalost te datum po\010Detka i zavr\0161etka. Rezultiraju\0107a e-po\0161ta sadr\017Ei HTML verziju interaktivnog izvje\0161\0107a s trenutnim podacima s posta')
||unistr('vkama izvje\0161\0107a prisutnim kada je pretplata dodana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461995679400180)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Podatkovne re\0161etke zapravo su izvje\0161\0107a s mogu\0107nosti ure\0111ivanja koja su iznimno prilagodljiva. Korisnici mogu izmijeniti izgled podataka izvje\0161\0107a odabirom stupaca, primjenom filtara, isticanjem i sortiranjem. Korisnici mogu i definirati razdvajanja, a')
||unistr('gregiranja, grafikone i na\010Dine grupiranja te dodavati vlastite izra\010Dune. Korisnici mogu stvoriti vi\0161e verzija izvje\0161\0107a i spremati ih pod razli\010Ditim nazivima za privatni pregled. '),
'<p/>',
unistr('Podatkovna re\0161etka mo\017Ee se prilagoditi pomo\0107u trake za pretra\017Eivanje, izbornika akcija, izbornika za upravljanje ili izbornika naslova stupca.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473785077400189)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'hr'
,p_message_text=>unistr('Izbornik akcija pojavljuje se desno od gumba Idi na traci za pretra\017Eivanje. Pomo\0107u tog izbornika mo\017Eete prilagoditi izvje\0161\0107e u podatkovnoj re\0161etki.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462407105400181)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'hr'
,p_message_text=>unistr('Stranica Dodavanje/ure\0111ivanje redaka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462586916400181)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Kako biste dodali redak u podatkovnu re\0161etku, pritisnite Dodaj redak. Kako biste uredili pojedinosti retka, pritisnite ikonu za ure\0111ivanje retka (prvi stupac) na retku koji \017Eelite urediti. Prikazuje se stranica za dodavanje/ure\0111ivanje retka i u nj')
||unistr('oj se prikazuju stupci podatkovne re\0161etke. </p>'),
'',
unistr('<p>Pri ure\0111ivanju retka mo\017Eete sljede\0107e:</p>'),
'',
'<p><ul>',
'<li><strong>Izbrisati</strong> redak.</li>i',
'<li><strong>Primijeniti promjene</strong> za spremanje promjena redaka.</li>',
'<li>U <strong>Akcijama</strong> dodati redak, dodati datoteke, napomene, veze ili oznake ili pregledati prethodno.</li>',
unistr('<li>Prije\0107i na retke <strong>Sljede\0107e i prethodno</strong>.</li>'),
'<li>U <strong>Upravljanju</strong> postaviti svojstva stupaca, grupe stupaca, provjere valjanosti i popise vrijednosti.</li>',
'</ul></p>',
'',
unistr('<p>U podru\010Dju s opaskama u dnu stranice prikazat \0107e se sve datoteke, napomene, veze ili oznake povezane s trenutnim retkom.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473808431400189)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'hr'
,p_message_text=>unistr('Upotrebljava se za stvaranje grupe razdvajanja u jednom ili vi\0161e stupaca. Time se stupci izvla\010De iz podatkovne re\0161etke i prikazuju kao glavni zapis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462322219400181)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'hr'
,p_message_text=>unistr('Omogu\0107uje preuzimanje trenutnog skupa rezultata. Formati preuzimanja uklju\010Duju CSV, HTML ili Email.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473908279400189)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ako prilagodite izvje\0161\0107e u podatkovnoj re\0161etki, postavke izvje\0161\0107a prikazuju se'),
unistr('ispod trake za pretra\017Eivanje i iznad izvje\0161\0107a. To se podru\010Dje mo\017Ee sa\017Eeti i pro\0161iriti uz pomo\0107 ikone s lijeve strane.'),
'<p>',
unistr('Za svaku postavku izvje\0161\0107a mo\017Eete napraviti sljede\0107e:'),
'</p><ul>',
'<li>Urediti postavku tako da pritisnete njezin naziv.</li>',
unistr('<li>Onemogu\0107iti/omogu\0107iti postavku tako da poni\0161tite oznaku / ozna\010Dite potvrdni okvir Omogu\0107i/Onemogu\0107i. Upotrebom te kontrole privremeno uklju\010Dite i isklju\010Dite postavku.</li>'),
'<li>Ukloniti postavku tako da pritisnete ikonu Ukloni.</li>',
'</ul>',
unistr('<p>Ako ste stvorili grafikon ili grupiranje po, mo\017Eete se prebacivati izme\0111u tih opcija i osnovnog izvje\0161\0107a upotrebom veza na prikaz izvje\0161\0107a, prikaz grafikona i prikaz grupiranja po'),
unistr('koje se nalaze s desne strane. Ako prika\017Eete grafikon ili grupiranje po,'),
unistr('mo\017Eete upotrijebiti i vezu za ure\0111ivanje kako biste uredili postavke.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462267538400181)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sprema prilago\0111eni izgled izvje\0161\0107a u podatkovnoj re\0161etki za budu\0107u upotrebu. Navedite naziv i neobavezni opis. Mogu se spremiti tri vrste izgleda izvje\0161\0107a u podatkovnoj re\0161etki:</p>'),
'<ul>',
unistr('<li><strong>Primarno zadano</strong> (samo za administratore). Primarno zadano izgled je koji se inicijalno prikazuje. Naziv primarnih zadanih izvje\0161\0107a ne mo\017Ee se mijenjati niti ga se mo\017Ee izbrisati.</li>'),
unistr('<li><strong>Alternativno izvje\0161\0107e</strong> (samo za administratore). Omogu\0107uje administratorima stvaranje vi\0161e izgleda izvje\0161\0107a. Samo administratori mogu spremiti i izbrisati alternativno izvje\0161\0107e ili mu promijeniti naziv.</li>'),
unistr('<li><strong>Privatno izvje\0161\0107e</strong> (svi korisnici). Korisnik koji je stvorio izgled izvje\0161\0107a mo\017Ee prikazati izvje\0161\0107e, spremiti ga, promijeniti mu naziv ili ga izbrisati.</li>'),
'</ul>',
unistr('<p>Ako spremate prilago\0111ena izvje\0161\0107a, u traci za pretra\017Eivanje lijevo od alata za odabir redaka prikazat \0107e se alat za odabir izvje\0161\0107a (ako je ta zna\010Dajka omogu\0107ena).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388398225400124)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Sakrij stupac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378991370400116)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'hr'
,p_message_text=>'Istakni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389852572400125)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'hr'
,p_message_text=>'Isticanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394938232400129)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'hr'
,p_message_text=>'Uvjet isticanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443960491400167)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'hr'
,p_message_text=>'Stil isticanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353976946400097)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'hr'
,p_message_text=>'Vrsta isticanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463454295400181)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'hr'
,p_message_text=>'Vodoravno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493018783400203)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'hr'
,p_message_text=>'1 neaktivna postavka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493188918400203)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>'Broj neaktivnih postavki: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384904076400121)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107 za interaktivno izvje\0161\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395943179400130)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'hr'
,p_message_text=>'Nije valjano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389346542400124)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Izraz izra\010Duna nije valjan. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348796545400092)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'hr'
,p_message_text=>unistr('Datum zavr\0161etka mora biti ve\0107i od datuma po\010Detka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403651572400136)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'hr'
,p_message_text=>'Izraz filtra nije valjan. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471489931400187)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'hr'
,p_message_text=>'Upit filtra nije valjan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493285617400203)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'hr'
,p_message_text=>'1 postavka koja nije valjana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493377494400203)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>'Broj postavki koje nisu valjane: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444111568400167)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'hr'
,p_message_text=>'(u minutama)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461194594400180)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'hr'
,p_message_text=>'%0 u prethodnom je intervalu od %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461333055400180)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 u sljede\0107em je intervalu od %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461220863400180)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'hr'
,p_message_text=>'%0 nije u prethodnom intervalu od %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461475802400180)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 nije u sljede\0107em intervalu od %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394041504400128)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'hr'
,p_message_text=>'Tipkovnica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360170636400101)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Oznaka %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387970946400123)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Naslov osi za oznaku'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380468918400117)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'hr'
,p_message_text=>'Zadnji dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380677445400117)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'hr'
,p_message_text=>'Zadnji sat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380108955400117)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161li mjesec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380274604400117)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161li tjedan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380365970400117)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih dana: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380535689400117)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih sati: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379977341400117)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'hr'
,p_message_text=>'Broj prethodnih godina: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380055458400117)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161la godina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360037372400101)
,p_name=>'APEXIR_LINE'
,p_message_language=>'hr'
,p_message_text=>'Linijski'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356822445400099)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'hr'
,p_message_text=>unistr('Redak s povr\0161inom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471349987400187)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'hr'
,p_message_text=>'Mapiraj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388836609400124)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'hr'
,p_message_text=>unistr('Procjenjuje se da \0107e upit prekora\010Diti maksimalni broj dopu\0161tenih resursa. Izmijenite postavke izvje\0161\0107a i poku\0161ajte ponovo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371062651400110)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Maksimalni je broj redaka za ovo izvje\0161\0107e %0. Primijenite filtar kako biste smanjili broj zapisa u upitu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471993402400188)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'hr'
,p_message_text=>'Maksimalno %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472168394400188)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'hr'
,p_message_text=>'Sredina: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375005988400113)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 min.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472052448400188)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'hr'
,p_message_text=>'Minimalno %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471025854400187)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'hr'
,p_message_text=>'Mjesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444582232400168)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'hr'
,p_message_text=>unistr('Mjese\010Dno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387122349400123)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'hr'
,p_message_text=>'Premjesti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387096441400122)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'hr'
,p_message_text=>'Premjesti sve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498249568400207)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Mora se navesti stati\010Dni ID podru\010Dja jer stranica sadr\017Ei vi\0161e interaktivnih izvje\0161\0107a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355505211400098)
,p_name=>'APEXIR_NAME'
,p_message_language=>'hr'
,p_message_text=>'Naziv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382996703400119)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'hr'
,p_message_text=>'Novo agregiranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493972084400204)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'hr'
,p_message_text=>'Nova kategorija'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112383062925400119)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Novi izra\010Dun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377854882400115)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380911385400118)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i dan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380759710400117)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i sat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381247154400118)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i mjesec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381188064400118)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i tjedan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381067944400118)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih dana: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112380820265400118)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih sati: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381403735400118)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj sljede\0107ih godina: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381398216400118)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107a godina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355897123400098)
,p_name=>'APEXIR_NO'
,p_message_language=>'hr'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396136381400130)
,p_name=>'APEXIR_NONE'
,p_message_language=>'hr'
,p_message_text=>unistr('- Ni\0161ta -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443763852400167)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'hr'
,p_message_text=>unistr('Nije valjana adresa e-po\0161te.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392698563400127)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'hr'
,p_message_text=>'Vrijednosti Null uvijek na prvom mjestu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392510422400127)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'hr'
,p_message_text=>'Vrijednosti Null uvijek na zadnjem mjestu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393069703400127)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'hr'
,p_message_text=>'Sortiranje vrijednosti Null %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389415433400124)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrijeme za Flashback mora biti numeri\010Dko.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389008678400124)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'hr'
,p_message_text=>unistr('Slijed mora biti numeri\010Dki.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393570861400128)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'hr'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354457793400097)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'hr'
,p_message_text=>unistr('naran\010Dasta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463318951400181)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'hr'
,p_message_text=>'Orijentacija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356351829400099)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'hr'
,p_message_text=>'Ostalo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339151009400084)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'hr'
,p_message_text=>'Orijentacija stranice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339840287400084)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'hr'
,p_message_text=>'Vodoravno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339994639400084)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'hr'
,p_message_text=>'Okomito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339077489400084)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'hr'
,p_message_text=>unistr('Veli\010Dina stranice')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339653037400084)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'hr'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339589957400084)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'hr'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339786087400084)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'hr'
,p_message_text=>unistr('Prilago\0111eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339335847400084)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'hr'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339242519400084)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'hr'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112339466537400084)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'hr'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472405799400188)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'hr'
,p_message_text=>'Postotak ukupnog broja %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471680015400187)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'hr'
,p_message_text=>'Postotak ukupnog zbroja %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470633050400187)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'hr'
,p_message_text=>'Postotak ukupnog broja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470500878400187)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'hr'
,p_message_text=>'Postotak ukupnog zbroja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359991292400101)
,p_name=>'APEXIR_PIE'
,p_message_language=>'hr'
,p_message_text=>'Tortni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419815817400149)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'hr'
,p_message_text=>'Zaokretanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421384730400150)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Treba se navesti agregiranje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421579311400150)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'hr'
,p_message_text=>unistr('Agregiranje se ne mo\017Ee izvr\0161iti na stupcu koji je odabran kao stupac retka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420786631400150)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Zaokretni stupci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420562006400150)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'hr'
,p_message_text=>'Zaokretni stupac %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421152293400150)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Mora se navesti zaokretni stupac.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321226782400070)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'hr'
,p_message_text=>unistr('Maksimalni broj redaka za pivot upit ograni\010Dava broj redaka u osnovnom upitu, a ne prikazani broj redaka. Osnovni upit prekora\010Duje maksimalni broj redaka koji iznosi %0. Primijenite filtar kako biste smanjili broj zapisa u osnovnom upitu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421019942400150)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'hr'
,p_message_text=>'Zaokretno sortiranje'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390414994400125)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'hr'
,p_message_text=>unistr('Zaokretni stupac sadr\017Ei previ\0161e zasebnih vrijednosti - SQL pivot  ne mo\017Ee se generirati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443810879400167)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'hr'
,p_message_text=>'Pregled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377934474400115)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112469566759400186)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'hr'
,p_message_text=>'Primarno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444898083400168)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Primarno izvje\0161\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338952168400084)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Uklju\010Di oznake pristupa\010Dnosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325809384400073)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Ukloni oboga\0107eni tekst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402690738400135)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'hr'
,p_message_text=>'Privatno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360541820400102)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'hr'
,p_message_text=>'Javno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356143085400098)
,p_name=>'APEXIR_RED'
,p_message_language=>'hr'
,p_message_text=>'crvena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498102280400207)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Stati\010Dni ID podru\010Dja %0 ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387245069400123)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'hr'
,p_message_text=>'Ukloni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387389920400123)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'hr'
,p_message_text=>'Ukloni sve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493484369400203)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'hr'
,p_message_text=>'Ukloni grafikon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386803711400122)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'hr'
,p_message_text=>'Ukloni kontrolno razdvajanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386508702400122)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'hr'
,p_message_text=>'Ukloni filtar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386665622400122)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'hr'
,p_message_text=>'Ukloni Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493583328400203)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'hr'
,p_message_text=>'Ukloni grupiranje po'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386987712400122)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'hr'
,p_message_text=>'Ukloni isticanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493621938400203)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'hr'
,p_message_text=>'Ukloni zaokretanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474683781400190)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Ukloni izvje\0161\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455229392400175)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Promijeni naziv zadanog izvje\0161\0107a')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396417053400130)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Promijeni naziv izvje\0161\0107a')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378216001400116)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472542906400188)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352717989400096)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljeno interaktivno izvje\0161\0107e s drugim nazivom %0 ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402941802400135)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352881966400096)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('ID spremljenog interaktivnog izvje\0161\0107a ID %0 ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112394770686400129)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'hr'
,p_message_text=>unistr('Postavke izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375535800400113)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'hr'
,p_message_text=>unistr('Prikaz izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379441404400116)
,p_name=>'APEXIR_RESET'
,p_message_language=>'hr'
,p_message_text=>'Ponovo postavi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360726248400102)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrati izvje\0161\0107e na zadane postavke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355968614400098)
,p_name=>'APEXIR_ROW'
,p_message_language=>'hr'
,p_message_text=>'Redak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468610729400185)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Eete upotrijebiti ROWID kao stupac primarnog klju\010Da za REST izvor podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385984282400122)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'hr'
,p_message_text=>'Redci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445539036400169)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'hr'
,p_message_text=>'Redaka po stranici'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420832527400150)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Stupci retka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420669649400150)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'hr'
,p_message_text=>'Stupac retka %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421217236400150)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Treba se navesti stupac retka.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421457641400150)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'hr'
,p_message_text=>'Stupac retka mora se razlikovati od zaokretnog stupca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400066196400133)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'hr'
,p_message_text=>'Filtar redaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375609448400113)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'hr'
,p_message_text=>'Redak %0 od %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379632446400117)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'hr'
,p_message_text=>unistr('Tekst retka sadr\017Ei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355255222400098)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'hr'
,p_message_text=>'Spremi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390002320400125)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljeno izvje\0161\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389948778400125)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremljeno izvje\0161\0107e = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392131097400127)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'hr'
,p_message_text=>unistr('Trenutne postavke izvje\0161\0107a upotrijebit \0107e se kao zadane za sve korisnike.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112455138204400175)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremi zadano izvje\0161\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112379326261400116)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremi izvje\0161\0107e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493874438400204)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'hr'
,p_message_text=>unistr('Spremi izvje\0161\0107e *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446512250400169)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Ei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112384854874400121)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'hr'
,p_message_text=>unistr('Traka pretra\017E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112493719242400204)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452067242400173)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Ei izvje\0161\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436039700400162)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Odabrani stupci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356923296400099)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'- Odabir stupca -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378687366400116)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>'Odabir stupaca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360473546400102)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>'- Odabir funkcije -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385620497400121)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'- Odaberite Grupiraj po stupcu -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420378724400149)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'- Odabir zaokretnog stupca -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471547797400187)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'hr'
,p_message_text=>'Odaberi redak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420475007400150)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'- Odabir stupca retka -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329164017400076)
,p_name=>'APEXIR_SEND'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161alji')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335478913400081)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161alji kao poruku e-po\0161te')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355673819400098)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'hr'
,p_message_text=>'Slijed'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378876873400116)
,p_name=>'APEXIR_SORT'
,p_message_language=>'hr'
,p_message_text=>'Sortiraj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388104319400123)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'hr'
,p_message_text=>'Uzlazno sortiranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388210168400123)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'hr'
,p_message_text=>'Silazno sortiranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474099210400189)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'hr'
,p_message_text=>'Redoslijed sortiranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382673618400119)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'hr'
,p_message_text=>'razmak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393738707400128)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'hr'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444244701400168)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'hr'
,p_message_text=>'Pretplata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470939582400187)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'hr'
,p_message_text=>unistr('Zavr\0161ava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325361501400073)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'hr'
,p_message_text=>unistr('Presko\010Di ako se podaci ne prona\0111u')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112470830315400187)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'hr'
,p_message_text=>unistr('Zapo\010Dinje od')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471743183400188)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'hr'
,p_message_text=>'Zbroj %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461785379400180)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'hr'
,p_message_text=>unistr('Podru\010Dje = %0, izvje\0161\0107e = %1, prikaz = %2, po\010Detak prikazanih redaka = %3, kraj prikazanih redaka = %4, ukupni broj redaka = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382326134400119)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'hr'
,p_message_text=>unistr('Podru\010Dje = %0, izvje\0161\0107e = %1, prikaz = %2, po\010Detak prikazanih redaka = %3, kraj prikazanih redaka = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354518466400097)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'hr'
,p_message_text=>'Boja teksta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371669153400110)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'hr'
,p_message_text=>'dana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371593414400110)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'hr'
,p_message_text=>'h'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371417331400110)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'hr'
,p_message_text=>'min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371850695400110)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'hr'
,p_message_text=>'mj.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371775105400110)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'hr'
,p_message_text=>'tj.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112371960137400111)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'hr'
,p_message_text=>'god.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112474467937400190)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'hr'
,p_message_text=>'Prebacivanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387495938400123)
,p_name=>'APEXIR_TOP'
,p_message_language=>'hr'
,p_message_text=>'Vrh'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467615366400185)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Negrupirani stupac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388911494400124)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'hr'
,p_message_text=>'Naziv isticanja mora biti jedinstven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359225793400101)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('nepodr\017Eana vrsta podataka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387584096400123)
,p_name=>'APEXIR_UP'
,p_message_language=>'hr'
,p_message_text=>'Gore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389144361400124)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'hr'
,p_message_text=>'Unesite valjanu boju.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389260597400124)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'hr'
,p_message_text=>'Unesite valjanu masku formata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112356462753400099)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112388071465400123)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'hr'
,p_message_text=>'Naslov osi za vrijednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395825909400129)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Obavezna vrijednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359847945400101)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'hr'
,p_message_text=>'Okomiti stupac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112463595483400182)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'hr'
,p_message_text=>'Okomito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395122079400129)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'hr'
,p_message_text=>'Prikaz grafikona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450345379400172)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'hr'
,p_message_text=>'Prikaz pojedinosti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112495936949400205)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e nema definiran %0 prikaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450405028400172)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'hr'
,p_message_text=>'Prikaz grupiranja po'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450222825400172)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'hr'
,p_message_text=>'Prikaz ikona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420117438400149)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'hr'
,p_message_text=>'Prikaz zaokretanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112395231013400129)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Prikaz izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444495559400168)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'hr'
,p_message_text=>'Tjedno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378179995400115)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Radno izvje\0161\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473144654400189)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'hr'
,p_message_text=>'%0 dana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473022008400188)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'hr'
,p_message_text=>'%0 h'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112472953639400188)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'hr'
,p_message_text=>'%0 min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473360190400189)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'hr'
,p_message_text=>'%0 mj.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473276124400189)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'hr'
,p_message_text=>'%0 tj.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112473436488400189)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'hr'
,p_message_text=>'%0 god.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112471130285400187)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'hr'
,p_message_text=>'Godina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112354230992400097)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'hr'
,p_message_text=>unistr('\017Euta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112355709391400098)
,p_name=>'APEXIR_YES'
,p_message_language=>'hr'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112387888406400123)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 sadr\017Ei znakove < ili > koji nisu valjani.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112410626205400141)
,p_name=>'APEX_REGION'
,p_message_language=>'hr'
,p_message_text=>unistr('Podru\010Dje')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112338827965400084)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'hr'
,p_message_text=>unistr('API preduvjet prekr\0161en')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358351875400100)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se dohvatiti vrijednost za postavku aplikacije %0 jer je povezana opcija izrade onemogu\0107ena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358254794400100)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se postaviti vrijednost za postavku aplikacije %0 jer je povezana opcija izrade onemogu\0107ena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465979099400183)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost aplikacije %0 nije valjana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112465896997400183)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'hr'
,p_message_text=>'Obavezna postavka aplikacije %0 nije definirana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466007921400183)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost aplikacije %0 ne smije se postaviti na null'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346923406400091)
,p_name=>'BACK'
,p_message_language=>'hr'
,p_message_text=>'Natrag'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333977446400080)
,p_name=>'BUILDER'
,p_message_language=>'hr'
,p_message_text=>'Alat za izradu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398028849400131)
,p_name=>'BUTTON LABEL'
,p_message_language=>'hr'
,p_message_text=>'Oznaka gumba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333045939400079)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'hr'
,p_message_text=>'Gumb - CSS klase'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362283361400103)
,p_name=>'BUTTON_ID'
,p_message_language=>'hr'
,p_message_text=>unistr('Generirani ID gumba bit \0107e stati\010Dni ID gumba, ako je definiran, a ako nije definiran, bit \0107e interno generirani ID u formatu ''B'' || [interni ID gumba]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325797368400073)
,p_name=>'CANDLESTICK'
,p_message_language=>'hr'
,p_message_text=>unistr('Svije\0107njak')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407294614400139)
,p_name=>'CENTER'
,p_message_language=>'hr'
,p_message_text=>'Sredina'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357248883400099)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'hr'
,p_message_text=>'%0 - zahtjev'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348633615400092)
,p_name=>'CHECK$'
,p_message_language=>'hr'
,p_message_text=>'alat za odabir retka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112467757180400185)
,p_name=>'CHECKED'
,p_message_language=>'hr'
,p_message_text=>unistr('ozna\010Deno')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443207147400167)
,p_name=>'COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Stupac'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403749992400136)
,p_name=>'COMMENTS'
,p_message_language=>'hr'
,p_message_text=>'Komentari'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385298979400121)
,p_name=>'CONTINUE'
,p_message_language=>'hr'
,p_message_text=>'Nastavak'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347298103400091)
,p_name=>'COPYRIGHT'
,p_message_language=>'hr'
,p_message_text=>unistr('Copyright &copy; %0, Sva prava pridr\017Eana.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390941767400126)
,p_name=>'COUNT'
,p_message_language=>'hr'
,p_message_text=>'Broj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397609267400131)
,p_name=>'CREATE'
,p_message_language=>'hr'
,p_message_text=>'Stvori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449943926400172)
,p_name=>'CREATED'
,p_message_language=>'hr'
,p_message_text=>'Stvoreno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450085855400172)
,p_name=>'CREATED_BY'
,p_message_language=>'hr'
,p_message_text=>'Autor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374850087400113)
,p_name=>'CREATED_ON'
,p_message_language=>'hr'
,p_message_text=>'Datum izrade'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385434425400121)
,p_name=>'CUSTOM'
,p_message_language=>'hr'
,p_message_text=>unistr('Prilago\0111eno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396624896400130)
,p_name=>'CUSTOMIZE'
,p_message_language=>'hr'
,p_message_text=>'Prilagodi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398211919400131)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'hr'
,p_message_text=>'Preference stranice ponovo su postavljene za korisnika %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398362380400131)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'hr'
,p_message_text=>'Preference su promijenjene za korisnika %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398104348400131)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'hr'
,p_message_text=>'Preference stranice ponovo su postavljene za korisnika %0.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361976644400103)
,p_name=>'DAILY'
,p_message_language=>'hr'
,p_message_text=>'Dnevno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112333578127400079)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'hr'
,p_message_text=>unistr('Prenesena datoteka nije valjana ili ima pogre\0161no pro\0161irenje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357492893400099)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'hr'
,p_message_text=>'Upotrijebljen je XML ili JSON alat za odabir koji nije valjan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326718930400074)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'hr'
,p_message_text=>unistr('Podatkovni profil i prenesena datoteka ne sadr\017Ee odredi\0161ni stupac tablice.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412456417400143)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'hr'
,p_message_text=>unistr('U prenesenoj datoteci nisu prona\0111eni podaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412599203400143)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'hr'
,p_message_text=>unistr('U radnom listu "%0" nisu prona\0111eni podaci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112332307426400078)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'hr'
,p_message_text=>'Navedena datoteka nije XLSX datoteka.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112322799189400071)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditavanje podataka zavr\0161eno: obra\0111en je sljede\0107i broj redaka: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323901830400072)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditavanje podataka zavr\0161eno: uz 1 pogre\0161ku obra\0111en je sljede\0107i broj redaka: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324240047400072)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditavanje podataka zavr\0161eno: uz vi\0161e pogre\0161aka (%1) obra\0111en je sljede\0107i broj redaka: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324080002400072)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditavanje podataka zavr\0161eno: 1 redak obra\0111en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327074515400074)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditavanje podataka zavr\0161eno: 1 redak obra\0111en je s pogre\0161kom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324135462400072)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditavanje podataka zavr\0161eno: 1 redak obra\0111en je bez pogre\0161ke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417731522400147)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'hr'
,p_message_text=>unistr('Odredi\0161ni stupac')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417810242400147)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'hr'
,p_message_text=>'Izvorni stupac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418686540400148)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Format datuma/broja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482011799400195)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'hr'
,p_message_text=>unistr('Dohva\0107anje vrijednosti tra\017Eenja nije uspjelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112450509331400172)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'hr'
,p_message_text=>'Mapiranje podataka/tablice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418707527400148)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'hr'
,p_message_text=>'Redak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414285257400144)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'hr'
,p_message_text=>'Pravilo transformacije nije uspjelo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390515897400125)
,p_name=>'DATE'
,p_message_language=>'hr'
,p_message_text=>'Datum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364656550400105)
,p_name=>'DAY'
,p_message_language=>'hr'
,p_message_text=>'dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364759262400105)
,p_name=>'DAYS'
,p_message_language=>'hr'
,p_message_text=>'dana'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403439609400135)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'hr'
,p_message_text=>unistr('Ispravljanje pogre\0161aka nije omogu\0107eno za ovu aplikaciju.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112452273573400173)
,p_name=>'DEFAULT'
,p_message_language=>'hr'
,p_message_text=>'Zadano'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365480415400106)
,p_name=>'DELETE'
,p_message_language=>'hr'
,p_message_text=>unistr('izbri\0161i')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112325656794400073)
,p_name=>'DIAL_PCT'
,p_message_language=>'hr'
,p_message_text=>unistr('Broj\010Danik (postotak)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340187849400085)
,p_name=>'DOWNLOAD'
,p_message_language=>'hr'
,p_message_text=>'Preuzmi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451340797400173)
,p_name=>'DUP_USER'
,p_message_language=>'hr'
,p_message_text=>unistr('Duplicirano korisni\010Dko ime na popisu.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347702901400091)
,p_name=>'EDIT'
,p_message_language=>'hr'
,p_message_text=>'Uredi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357171679400099)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Adresa e-po\0161te "%0" nije prona\0111ena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342201045400086)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\0161iljatelj ove poruke e-po\0161te je %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451535567400173)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'hr'
,p_message_text=>unistr('Adresa e-po\0161te je preduga\010Dka. Ograni\010Denje je 240 znakova.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385182417400121)
,p_name=>'ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414371913400144)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se postaviti vrijednost izvora stavke stranice za podru\010Dje djelomi\010Dnog osvje\017Eavanja stranice')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376651508400114)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'hr'
,p_message_text=>'Autor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342530308400087)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'hr'
,p_message_text=>'Lozinka je istekla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112336616857400082)
,p_name=>'FILE_EMPTY'
,p_message_language=>'hr'
,p_message_text=>'Datoteka je prazna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416815109400146)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'hr'
,p_message_text=>unistr('Veli\010Dina prenesene datoteke iznad je %0 MB. Prenesite manju datoteku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344610378400089)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Provjera autenti\010Dnosti korisnika nije uspjela i nije prenesena jedna ili vi\0161e datoteka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344784839400089)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ova instanca ne dopu\0161ta prijenos datoteka korisnicima \010Dija autenti\010Dnost nije provjerena.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397778235400131)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Do\0161lo je do 1 pogre\0161ke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396977821400130)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Do\0161lo je do sljede\0107eg broja pogre\0161aka: %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347170659400091)
,p_name=>'FORM_OF'
,p_message_language=>'hr'
,p_message_text=>'%0 od %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381878167400118)
,p_name=>'GO'
,p_message_language=>'hr'
,p_message_text=>'Idi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481689405400195)
,p_name=>'HELP'
,p_message_language=>'hr'
,p_message_text=>unistr('Pomo\0107')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334037269400080)
,p_name=>'HOME'
,p_message_language=>'hr'
,p_message_text=>unistr('Po\010Detna stranica')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364431681400105)
,p_name=>'HOUR'
,p_message_language=>'hr'
,p_message_text=>'h'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364589421400105)
,p_name=>'HOURS'
,p_message_language=>'hr'
,p_message_text=>'h'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348577580400092)
,p_name=>'ICON'
,p_message_language=>'hr'
,p_message_text=>'Ikona %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398503460400132)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'hr'
,p_message_text=>'Sigurnosni podaci za prijavu nisu valjani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112498008336400207)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost parametra  nije valjana: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393201221400127)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'hr'
,p_message_text=>unistr('Kao zadane postavke izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393344131400127)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Kao izvje\0161\0107e s nazivom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375750484400114)
,p_name=>'IR_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 pogre\0161ka. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375461828400113)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se izra\010Dunati navigacija kroz obrazac. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353093321400096)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Interaktivno izvje\0161\0107e nije prona\0111eno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352447910400095)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Podru\010Dje interaktivnog izvje\0161\0107a ne postoji u aplikaciji %0, stranici %1 ni podru\010Dju %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112393188328400127)
,p_name=>'IR_STAR'
,p_message_language=>'hr'
,p_message_text=>'Prikazuje se samo za razvojne programere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381524663400118)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Za upit izvje\0161\0107a potreban je jedinstveni klju\010D za identifikaciju svakog retka. Navedeni klju\010D ne mo\017Ee se upotrijebiti za ovaj upit. Definirajte stupac s jedinstvenim klju\010Dem. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381617288400118)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'hr'
,p_message_text=>unistr('Za upit izvje\0161\0107a potreban je jedinstveni klju\010D za identifikaciju svakog retka. Navedeni klju\010D ne mo\017Ee se upotrijebiti za ovaj upit. Uredite atribute izvje\0161\0107a kako biste definirali stupac s jedinstvenim klju\010Dem. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418915875400148)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'hr'
,p_message_text=>'Odabir datoteke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418890271400148)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'hr'
,p_message_text=>'Povucite i ispustite datoteku ovdje ili'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347439019400091)
,p_name=>'ITEMS'
,p_message_language=>'hr'
,p_message_text=>'Stavke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376870786400114)
,p_name=>'ITEM_VALUE'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost stavke'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391229797400126)
,p_name=>'LABEL'
,p_message_language=>'hr'
,p_message_text=>'Oznaka'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403382070400135)
,p_name=>'LANGUAGE'
,p_message_language=>'hr'
,p_message_text=>'Jezik'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365142417400105)
,p_name=>'LAST'
,p_message_language=>'hr'
,p_message_text=>'zadnje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344512722400089)
,p_name=>'LENGTH'
,p_message_language=>'hr'
,p_message_text=>'Duljina'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397866289400131)
,p_name=>'LOGIN'
,p_message_language=>'hr'
,p_message_text=>'Prijava'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436477522400162)
,p_name=>'MANAGE'
,p_message_language=>'hr'
,p_message_text=>'Upravljanje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501072397400209)
,p_name=>'MAXIMIZE'
,p_message_language=>'hr'
,p_message_text=>'Maksimiziraj'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364239023400105)
,p_name=>'MINUTE'
,p_message_language=>'hr'
,p_message_text=>'min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364316535400105)
,p_name=>'MINUTES'
,p_message_language=>'hr'
,p_message_text=>'min'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451761147400173)
,p_name=>'MISSING_AT'
,p_message_language=>'hr'
,p_message_text=>unistr('U adresi e-po\0161te nedostaje "@".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451901972400173)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'hr'
,p_message_text=>unistr('Upozorenje: Za stranicu dijaloga %0 u aplikaciji %1 nije definiran predlo\017Eak stranice dijaloga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451663734400173)
,p_name=>'MISSING_DOT'
,p_message_language=>'hr'
,p_message_text=>unistr('U domeni adrese e-po\0161te nedostaje ".".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400868108400133)
,p_name=>'MODULE'
,p_message_language=>'hr'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357962836400100)
,p_name=>'MONTH'
,p_message_language=>'hr'
,p_message_text=>'Mjesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361767172400103)
,p_name=>'MONTHLY'
,p_message_language=>'hr'
,p_message_text=>unistr('Mjese\010Dno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358014764400100)
,p_name=>'MONTHS'
,p_message_language=>'hr'
,p_message_text=>'mjeseci'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390880433400126)
,p_name=>'MOVE'
,p_message_language=>'hr'
,p_message_text=>'Premjesti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458385017400178)
,p_name=>'MOVE_FROM'
,p_message_language=>'hr'
,p_message_text=>'Premjesti iz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458464140400178)
,p_name=>'MOVE_TO'
,p_message_language=>'hr'
,p_message_text=>'Premjesti u'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112378081912400115)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka operacije brisanja vi\0161e redaka: redak= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377073810400115)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'hr'
,p_message_text=>'Ne smije biti javni korisnik'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334209143400080)
,p_name=>'NAME'
,p_message_language=>'hr'
,p_message_text=>'Naziv'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391077155400126)
,p_name=>'NEW'
,p_message_language=>'hr'
,p_message_text=>'Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357793532400100)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'hr'
,p_message_text=>unistr('Mo\017Eete se prijaviti u %0 odlaskom na:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357800171400100)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Obavijest o novom %0 ra\010Dunu')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481850021400195)
,p_name=>'NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400713716400133)
,p_name=>'NO'
,p_message_language=>'hr'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112496068048400205)
,p_name=>'NOBODY'
,p_message_language=>'hr'
,p_message_text=>'nitko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365592650400106)
,p_name=>'NOT'
,p_message_language=>'hr'
,p_message_text=>'Nije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406321348400138)
,p_name=>'NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Nije Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377120169400115)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'hr'
,p_message_text=>'Nije %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396734503400130)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('podaci nisu prona\0111eni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405820361400137)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Nisu prona\0111ena izvje\0161\0107a koja se mogu a\017Eurirati. Operacije a\017Euriranja vi\0161e redaka i brisanja mogu se izvr\0161iti samo u tabli\010Dnim obrascima vrste ''Izvje\0161\0107e koje se mo\017Ee a\017Eurirati''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406769542400138)
,p_name=>'OK'
,p_message_language=>'hr'
,p_message_text=>'U redu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402491901400135)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'hr'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112499886143400208)
,p_name=>'ORA_06550'
,p_message_language=>'hr'
,p_message_text=>'ORA-06550: linija %0, stupac %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449391290400171)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'hr'
,p_message_text=>unistr('Upotrebljavate zastarjeli internetski preglednik. Popis podr\017Eanih preglednika potra\017Eite u priru\010Dniku za instalaciju platforme Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350716200400094)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'hr'
,p_message_text=>unistr('Zatra\017Een je skup redaka koji nije valjan, izmijenjeni su izvorni podaci izvje\0161\0107a.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370815037400110)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'hr'
,p_message_text=>'Mora se navesti valjani broj stranice, primjerice p?n=1234.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374491788400113)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374510906400113)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'hr'
,p_message_text=>unistr('Sljede\0107i skup')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374645568400113)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112374709098400113)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'hr'
,p_message_text=>'Prethodni skup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481789821400195)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'hr'
,p_message_text=>'Odabir numeriranja stranica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412300224400143)
,p_name=>'PASSWORD'
,p_message_language=>'hr'
,p_message_text=>'Lozinka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357054198400099)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'hr'
,p_message_text=>unistr('Promijenjena je va\0161a lozinka za %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346830223400091)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka nije u skladu s pravilima o slo\017Eenosti lozinke web-mjesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345908509400090)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Nova lozinka mora se razlikovati od stare u najmanje sljede\0107em broju znakova: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346573700400090)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka ne smije sadr\017Eavati korisni\010Dko ime.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346753054400091)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka sadr\017Ei zabranjenu jednostavnu rije\010D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346672902400091)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka ne smije sadr\017Eavati naziv radnog prostora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345808387400090)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka mora sadr\017Eavati najmanje sljede\0107i broj znakova: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346044053400090)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka mora sadr\017Eavati najmanje jedno slovo (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346473615400090)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka mora sadr\017Eavati najmanje jedno malo slovo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346197713400090)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka mora sadr\017Eavati najmanje jedan broj (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346233958400090)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka mora sadr\017Eavati najmanje jedan interpunkcijski znak (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112346361145400090)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka mora sadr\017Eavati najmanje jedno veliko slovo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357508326400099)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'hr'
,p_message_text=>'Obavijest o ponovnom postavljanju lozinke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344814833400089)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Lozinka se ne mo\017Ee upotrijebiti jer je upotrijebljena unutar sljede\0107eg broja proteklih dana: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425115913400153)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'hr'
,p_message_text=>'Stavke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112425267796400153)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'hr'
,p_message_text=>'Stavka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402287031400135)
,p_name=>'PERCENT'
,p_message_language=>'hr'
,p_message_text=>'Postotak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372541561400111)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'hr'
,p_message_text=>'Obratite se administratoru.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112481940755400195)
,p_name=>'PREVIOUS'
,p_message_language=>'hr'
,p_message_text=>'Prethodno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417362207400147)
,p_name=>'PRINT'
,p_message_language=>'hr'
,p_message_text=>'Ispis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401061986400134)
,p_name=>'PRIVILEGES'
,p_message_language=>'hr'
,p_message_text=>'Povlastice'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370902816400110)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'hr'
,p_message_text=>unistr('Reference podru\010Dja')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391132892400126)
,p_name=>'REPORT'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400946778400134)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'hr'
,p_message_text=>unistr('Razdoblje izvje\0161\0107ivanja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482136525400195)
,p_name=>'REPORT_LABEL'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401613194400134)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'hr'
,p_message_text=>unistr('Izvje\0161\0107e - ukupno')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350879257400094)
,p_name=>'RESET'
,p_message_language=>'hr'
,p_message_text=>'Ponovno postavljanje numeriranja stranica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376746197400114)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'hr'
,p_message_text=>'Ponovno postavljanje numeriranja stranica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405709936400137)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'hr'
,p_message_text=>'Ponovo postavi lozinku'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382502657400119)
,p_name=>'RESTORE'
,p_message_language=>'hr'
,p_message_text=>'Vrati'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112414454427400144)
,p_name=>'RESULTS'
,p_message_language=>'hr'
,p_message_text=>'Rezultati'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406865400400138)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'hr'
,p_message_text=>'Povratak na aplikaciju.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112407121140400139)
,p_name=>'RIGHT'
,p_message_language=>'hr'
,p_message_text=>'Desno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436754044400162)
,p_name=>'ROW'
,p_message_language=>'hr'
,p_message_text=>'Redak %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390795473400125)
,p_name=>'ROW_COUNT'
,p_message_language=>'hr'
,p_message_text=>'Broj redaka'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112406231433400138)
,p_name=>'SAVE'
,p_message_language=>'hr'
,p_message_text=>'Spremi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402870305400135)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'hr'
,p_message_text=>'Alternativno zadano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403264207400135)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'hr'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402742598400135)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'hr'
,p_message_text=>'Primarno zadano'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403560850400136)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'hr'
,p_message_text=>unistr('Dostupno je vi\0161e od sljede\0107eg broja redaka: %0. Pove\0107ajte odabir redaka kako biste prikazali vi\0161e redaka.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468931669400185)
,p_name=>'SEARCH'
,p_message_language=>'hr'
,p_message_text=>unistr('Pretra\017Eivanje')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364128182400105)
,p_name=>'SECONDS'
,p_message_language=>'hr'
,p_message_text=>'sekunde'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402340878400135)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei prilo\017Eeno')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460021956400179)
,p_name=>'SELECT_ROW'
,p_message_language=>'hr'
,p_message_text=>'Odaberi redak'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402023958400134)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'hr'
,p_message_text=>unistr('Isklju\010Di na\010Din \010Dita\010Da zaslona')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402129830400134)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'hr'
,p_message_text=>unistr('Uklju\010Di na\010Din \010Dita\010Da zaslona')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398420208400132)
,p_name=>'SHOW'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461836582400180)
,p_name=>'SHOW_ALL'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei sve')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112487982932400199)
,p_name=>'SIGN_IN'
,p_message_language=>'hr'
,p_message_text=>'Prijava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112437569798400163)
,p_name=>'SIGN_OUT'
,p_message_language=>'hr'
,p_message_text=>'Odjavi se'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391727131400126)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 dana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398931585400132)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'Za %0 dana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391658849400126)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398831270400132)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'Za %0 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391553990400126)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398730805400132)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'Za %0 min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391965404400126)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399130427400132)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'Za %0 mj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399376225400132)
,p_name=>'SINCE_NOW'
,p_message_language=>'hr'
,p_message_text=>'Sad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391430095400126)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112398639393400132)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'Za %0 s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112391818288400126)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 tj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399087385400132)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'Za %0 tj.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112392038351400126)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'hr'
,p_message_text=>'Prije %0 god.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399238460400132)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'hr'
,p_message_text=>'Za %0 god.'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385560241400121)
,p_name=>'STANDARD'
,p_message_language=>'hr'
,p_message_text=>'Standardno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401946045400134)
,p_name=>'START_DATE'
,p_message_language=>'hr'
,p_message_text=>unistr('Datum po\010Detka')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342450711400087)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'hr'
,p_message_text=>unistr('Primili ste ovu poruku e-po\0161te iz pretplate na interaktivno izvje\0161\0107e \010Diji je autor %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497194277400206)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'hr'
,p_message_text=>'Pretplate'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445253277400168)
,p_name=>'TAB'
,p_message_language=>'hr'
,p_message_text=>'Kartica'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364055019400105)
,p_name=>'TITLE'
,p_message_language=>'hr'
,p_message_text=>'Naslov'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347074029400091)
,p_name=>'TODAY'
,p_message_language=>'hr'
,p_message_text=>'Danas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401593259400134)
,p_name=>'TOTAL'
,p_message_language=>'hr'
,p_message_text=>'Ukupno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348052949400092)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'hr'
,p_message_text=>unistr('Mo\017Ee se odabrati najvi\0161e sljede\0107i broj stupaca: %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326588176400074)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'hr'
,p_message_text=>unistr('Sa\017Emi sve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326872092400074)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'hr'
,p_message_text=>'Sakrij sve ispod'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326410679400074)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161iri sve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326663909400074)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'hr'
,p_message_text=>unistr('Pro\0161iri sve ispod')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326933887400074)
,p_name=>'TREE.REPARENT'
,p_message_language=>'hr'
,p_message_text=>unistr('Ponovo dodijeli nadre\0111eni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419150595400148)
,p_name=>'TREES'
,p_message_language=>'hr'
,p_message_text=>'Stabla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112462635866400181)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Obavezno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112386258515400122)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'hr'
,p_message_text=>unistr('Neovla\0161teno')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112433062882400160)
,p_name=>'UNAVAILABLE'
,p_message_language=>'hr'
,p_message_text=>'Nije dostupno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399790050400133)
,p_name=>'UNKNOWN'
,p_message_language=>'hr'
,p_message_text=>'Nepoznato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343374541400088)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Do\0161lo je do neprepoznate pogre\0161ke pri provjeri autenti\010Dnosti.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345319913400089)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'hr'
,p_message_text=>unistr('Ako vi\0161e ne \017Eelite primati e-po\0161tu, pritisnite <a href="%0">Otkazivanje pretplate</a> kako biste upravljali pretplatom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112342339476400086)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'hr'
,p_message_text=>unistr('Ako vi\0161e ne \017Eelite primati e-po\0161tu, idite na sljede\0107i URL za upravljanje pretplatom:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112377263836400115)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('nepodr\017Eana vrsta podataka')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365300876400106)
,p_name=>'UPDATE'
,p_message_language=>'hr'
,p_message_text=>unistr('a\017Euriraj')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363933173400105)
,p_name=>'UPDATED'
,p_message_language=>'hr'
,p_message_text=>unistr('A\017Eurirano')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370639462400110)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'hr'
,p_message_text=>unistr('Zabranjen je zatra\017Eeni URL. Obratite se administratoru.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112390669712400125)
,p_name=>'USER'
,p_message_language=>'hr'
,p_message_text=>'Korisnik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112412235105400143)
,p_name=>'USERNAME'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisni\010Dko ime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451888214400173)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisni\010Dko ime je preduga\010Dko. Ograni\010Deno je na sljede\0107i broj znakova: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397429195400131)
,p_name=>'USERS'
,p_message_language=>'hr'
,p_message_text=>'korisnici'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112451404164400173)
,p_name=>'USER_EXISTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisni\010Dko ime ve\0107 postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112466184120400183)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'hr'
,p_message_text=>'Profilna slika za korisnika %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353797736400096)
,p_name=>'VALID'
,p_message_language=>'hr'
,p_message_text=>'Valjano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347394994400091)
,p_name=>'VALIDATIONS'
,p_message_language=>'hr'
,p_message_text=>'Provjere valjanosti'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403020443400135)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost se mora navesti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446499846400169)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'hr'
,p_message_text=>'Obavezno se mora navesti vrijednost za %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372904898400111)
,p_name=>'VERTICAL'
,p_message_language=>'hr'
,p_message_text=>'okomito'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365289877400106)
,p_name=>'VIEW'
,p_message_language=>'hr'
,p_message_text=>'prikaz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397521445400131)
,p_name=>'VIEWS'
,p_message_language=>'hr'
,p_message_text=>'prikazi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403853186400136)
,p_name=>'VIEW_ALL'
,p_message_language=>'hr'
,p_message_text=>unistr('Prika\017Ei sve')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112385083040400121)
,p_name=>'WARNING'
,p_message_language=>'hr'
,p_message_text=>'Upozorenje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364872561400105)
,p_name=>'WEEK'
,p_message_language=>'hr'
,p_message_text=>'tj.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361820795400103)
,p_name=>'WEEKLY'
,p_message_language=>'hr'
,p_message_text=>'Tjedno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112364929419400105)
,p_name=>'WEEKS'
,p_message_language=>'hr'
,p_message_text=>'tj.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112403177584400135)
,p_name=>'WELCOME_USER'
,p_message_language=>'hr'
,p_message_text=>unistr('Dobro do\0161li: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401350800400134)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111ena vrijednost koja nije valjana, provjerite unesene podatke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401467637400134)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111ena vrijednost koja nije valjana, provjerite unesene podatke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344430989400089)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111ena je vrijednost datuma koja nije valjana, provjerite format datuma.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112401278583400134)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111ena vrijednost broja koja nije valjana, provjerite format broja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353381608400096)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111ena vrijednost vremenske oznake koja nije valjana, provjerite format vremenske oznake.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112375864901400114)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se vezati "%0". Upotrijebite dvostruke navodnike za vi\0161ebajtne stavke ili potvrdite je li duljina stavke 30 bajtova ili manje. Upotrijebite v() sintaksu za referencu na stavke dulje od 30 bajtova.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366342050400106)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'hr'
,p_message_text=>'Pristup je odbila sigurnosna provjera %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368810515400108)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'hr'
,p_message_text=>'Aplikacija nije dostupna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367251059400107)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1014 Aplikacija nije prona\0111ena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367346256400107)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'hr'
,p_message_text=>'aplikacija=%0  radni prostor=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367786708400107)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'hr'
,p_message_text=>unistr('Pristup ovoj aplikaciji ograni\010Den je, poku\0161ajte ponovo kasnije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367644082400107)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'hr'
,p_message_text=>unistr('Pristup ovoj aplikaciji ograni\010Den je na razvojne programere aplikacije, poku\0161ajte ponovo kasnije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366892038400107)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-7744 Ne mo\017Ee se obraditi grananje na URL vra\0107anja funkcija.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366730941400107)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-7744 Ne mo\017Ee se obraditi grananje na stranicu vra\0107anja funkcija.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367026259400107)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1430 Poziv za prikaz iz procesa stranice nije podr\017Ean: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368130998400108)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1018 Pogre\0161ka pri \010Di\0161\0107enju cache memorije koraka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366593985400106)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1005 Nepoznata vrsta izra\010Duna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367417874400107)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1201 ID sesije nije postavljen na prilago\0111enu provjeru autenti\010Dnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367535320400107)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'hr'
,p_message_text=>'stranica=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112367198213400107)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-7620 Ne mo\017Ee se odrediti radni prostor za aplikaciju (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349585836400093)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'hr'
,p_message_text=>'Uredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366270561400106)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1802 Ne mo\017Ee se prona\0107i ID stavke "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365950112400106)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1002 ID stavke "%0" ne mo\017Ee se prona\0107i u aplikaciji "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366003371400106)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'hr'
,p_message_text=>unistr('Neo\010Dekivana pogre\0161ka, ne mo\017Ee se prona\0107i naziv stavke na razini aplikacije ili stranice.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366446226400106)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ve\0107 se nalazite na prvoj stranici podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112381911669400118)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'hr'
,p_message_text=>'Stavka s ID-om (%0) nije stavka definirana na trenutnoj stranici.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344034328400088)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'hr'
,p_message_text=>unistr('Stavka se ne mo\017Ee postaviti proslje\0111ivanjem argumenata aplikaciji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344344172400089)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'hr'
,p_message_text=>'(Nije naveden kontrolni zbroj)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343880470400088)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'hr'
,p_message_text=>unistr('Stavka se mo\017Ee postaviti kada je s njom povezan kontrolni zbroj za "oznaku na razini korisnika".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343729834400088)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'hr'
,p_message_text=>unistr('Stavka se mo\017Ee postaviti kada je s njom povezan kontrolni zbroj za "oznaku na razini aplikacije".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343986784400088)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'hr'
,p_message_text=>unistr('Stavka se mo\017Ee postaviti kada je s njom povezan kontrolni zbroj za "sesiju".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343659791400088)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'hr'
,p_message_text=>unistr('Stavka nema za\0161titu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368248973400108)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'hr'
,p_message_text=>unistr('Nije dostupna pomo\0107 za stranicu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112357344656400099)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'hr'
,p_message_text=>'Radni prostor %0 nema povlastice za parsiranje kao shemu %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366691958400107)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-1010 Prekora\010Deno je ograni\010Denje rekurzije obrade prihvata grananja na stranicu. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344249244400089)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'hr'
,p_message_text=>unistr('Ova se stranica ne mo\017Ee pozvati pomo\0107u URL-a ili upotrebom GET ili POST za prikaz postupka, mora se pozvati pomo\0107u vrste ogranka "Grananje na stranicu".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112420990665400150)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri spremanju vrijednosti koja nije numeri\010Dka u stavku %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359085280400101)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'hr'
,p_message_text=>'Shema za parsiranje aplikacije "%0" ne postoji u bazi podataka.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112359184925400101)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'hr'
,p_message_text=>unistr('Ra\010Duni u INTERNAL radnom prostoru mogu se upotrijebiti samo za pristup elementu &PRODUCT_NAME. <a href="%0">Administrativne usluge</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365875600400106)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'hr'
,p_message_text=>'ERR-1029 Informacije o sesiji ne mogu se spremiti.  sesija=%0 stavka=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368987843400108)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se zaustaviti pra\0107enje: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112366198790400106)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Neo\010Dekivana pogre\0161ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376149536400114)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka u update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369046705400108)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Za prikaz pomo\0107i moraju se navesti aplikacija i stranica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112389556251400125)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Automatizacija nije prona\0111ena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370109034400109)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'hr'
,p_message_text=>unistr('O\010Di\0161\0107en sljede\0107i broj sesija: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329474022400076)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se izvr\0161iti %0 kod! Ne podr\017Eava ga baza podataka ili nije omogu\0107en u parametru instance MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112329270664400076)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'hr'
,p_message_text=>'Multilingual Engine nije dostupan za ovu verziju baze podataka!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350079482400093)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Polje zbirke aplikacija ne smije biti null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349852954400093)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'hr'
,p_message_text=>unistr('Navedeni broj atributa elementa %0 nije valjan. Broj atributa mora biti izme\0111u 1 i %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350311476400094)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'hr'
,p_message_text=>'Zbirka aplikacija postoji'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350184264400093)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'hr'
,p_message_text=>'Naziv zbirke ne smije biti null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350269046400094)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'hr'
,p_message_text=>unistr('Naziv zbirke ne smije biti ve\0107i od 255 znakova')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349630081400093)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>'Zbirka aplikacija %0 ne postoji'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350492468400094)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'hr'
,p_message_text=>unistr('Pokaziva\010D jo\0161 nije otvoren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349707015400093)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Slijed elemenata %0 ne postoji u zbirci aplikacija %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112349996831400093)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'hr'
,p_message_text=>'Slijed elemenata %0 ne postoji u zbirci aplikacija "%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421738611400151)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Kriptografska funkcija "%0" nije podr\017Eana u sustavu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475215872400190)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'hr'
,p_message_text=>unistr('Ispitana pristupa\010Dnost')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369666191400109)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'hr'
,p_message_text=>'Zatvori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369750934400109)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'hr'
,p_message_text=>unistr('Opcije prilago\0111avanja stranice')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369802257400109)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'hr'
,p_message_text=>'Zadano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369956311400109)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'hr'
,p_message_text=>'Prikazano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370003884400109)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'hr'
,p_message_text=>'Skriveno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369446748400109)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'hr'
,p_message_text=>unistr('Ozna\010Dite podru\010Dja koja \017Eelite dodati na stranicu. Ozna\010Dena podru\010Dja mo\017Eda se ne\0107e prikazati ako niste u odgovaraju\0107em kontekstu aplikacije ili ako nemate odgovaraju\0107e povlastice.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369577487400109)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'hr'
,p_message_text=>unistr('Ovu stranicu ne mo\017Ee se prilago\0111avati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475530902400190)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'hr'
,p_message_text=>unistr('Izgled aplikacije mo\017Eete prilagoditi tako da promijenite stil teme. Odaberite stil teme s donjeg popisa i pritisnite Primijeni promjene.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112476395244400191)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'hr'
,p_message_text=>unistr('Prikaz podru\010Dja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475415043400190)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'hr'
,p_message_text=>'Upotrijebi zadani stil aplikacije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112475380923400190)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'hr'
,p_message_text=>'Izgled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418325506400148)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>'Indeks stupca referenciran u agregiranju %0 ne postoji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112321667938400070)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'hr'
,p_message_text=>unistr('CLOB izlaz nije podr\017Ean za format %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418001861400147)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'hr'
,p_message_text=>unistr('Razdvajanje stupca mora biti na po\010Detku polja stupca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418100291400148)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>'Indeks grupe stupaca referenciran u %0 ne postoji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112335619236400081)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'hr'
,p_message_text=>'izvoz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112340871660400085)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'hr'
,p_message_text=>unistr('Format za izvoz mora biti XML uz upotrebu ORDS-a kao poslu\017Eitelja ispisa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418421254400148)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>'Indeks stupca referenciran u isticanju %0 ne postoji.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334177309400080)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'hr'
,p_message_text=>'Format izvoza nije valjan: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112418217545400148)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>unistr('Indeks nadre\0111ene grupe referenciran u %0 ne postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112443467470400167)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'hr'
,p_message_text=>unistr('Stupac %1 tablice %0 stupac je identiteta "GENERATED ALWAYS". Provjerite da izvorni stupci nisu mapirani u stupac %1 u dijalo\0161kom okviru konfiguriranja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360821006400102)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'hr'
,p_message_text=>'Navedeni je interval spremanja prenizak.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112360937461400102)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'hr'
,p_message_text=>unistr('Za u\010Ditavanje podataka nisu navedeni stupci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362165810400103)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Nije prona\0111en nijedan stupac za alat za odabir redaka "%0". Poku\0161ajte s automatskim prepoznavanjem ili pregledom JSON strukture.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370413859400109)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Nijedan radni list nije prona\0111en u XLSX datoteci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370310397400109)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'hr'
,p_message_text=>'Navedeni radni list ne postoji u XLSX datoteci.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112350581245400094)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'hr'
,p_message_text=>unistr('Trenutna verzija podataka u bazi podataka promijenila se otkad je korisnik pokrenuo proces a\017Euriranja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352992145400096)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri a\017Euriranju stupaca izvje\0161\0107a: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457683583400177)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 se ne mo\017Ee konvertirati u SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397123991400130)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'hr'
,p_message_text=>unistr('Stupac %0 s vrstom podataka %1 ne mo\017Ee se pretvoriti u VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404166852400136)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Stupac "%0" naveden za atribut "%1" nije prona\0111en u izvoru podataka!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345434091400089)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta filtra %0 nije podr\017Eana za stupce s vi\0161e vrijednosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112461093023400180)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'hr'
,p_message_text=>unistr('Filtar "izme\0111u" nije valjan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327547846400075)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'hr'
,p_message_text=>'Navedena vrsta popisa vrijednosti nije valjana.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327490326400075)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta upita nije valjana. Vrsta upita mora biti Tablica, SQL upit ili PL/SQL funkcija koja vra\0107a SQL upit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397211072400131)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Nije uspjelo parsiranje SQL upita!',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404275236400136)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Navedeni polo\017Eaj stupca %0 za atribut "%1" nije prona\0111en u SQL naredbi!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112326057266400074)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'hr'
,p_message_text=>unistr('Previ\0161e stavki upotrijebljeno u filtru s vi\0161e vrijednosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404077373400136)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'hr'
,p_message_text=>'Za atribut "%0" nije naveden stupac.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327385155400074)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>'Glavni dio PL/SQL funkcije nije vratio vrijednost.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112417226904400147)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'hr'
,p_message_text=>unistr('REST izvor podataka ne sadr\017Ei operaciju za obradu zatra\017Eene DML akcije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112323293920400072)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'hr'
,p_message_text=>'Konverzija GeoJSON u SDO_GEOMETRY (stupac %0) nije dostupna u ovoj bazi podataka.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324357489400072)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'hr'
,p_message_text=>unistr('Konverzija SDO_GEOMETRY (stupac %0) nije podr\017Eana za XML izvore podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112331623620400078)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'hr'
,p_message_text=>unistr('Znak %0 nije podr\017Ean kao separator vi\0161e vrijednosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112458911694400178)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Ova funkcija ne mo\017Ee se upotrijebiti s kontekstom upita.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112324495671400072)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrste podataka stupca nisu uskla\0111ene.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327249373400074)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'hr'
,p_message_text=>unistr('Prekora\010Dena interna ograni\010Denja ORDS OUT vezivanja. Smanjite koli\010Dinu DML redaka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112405002137400137)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('JSON odgovor od udaljenog poslu\017Eitelja ne mo\017Ee se parsirati: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112327131134400074)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Nepoznata ili pogre\0161na vrsta konteksta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112421641122400150)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Parser ne podr\017Eava ovu vrstu datoteke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376229451400114)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Neovla\0161teni pristup (nije postavljen wwv_flow_api.set_credentials).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353254631400096)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'hr'
,p_message_text=>unistr('Radni prostor nije se stvorio jer ve\0107 postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112353107062400096)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'hr'
,p_message_text=>unistr('Grupa korisnika nije se stvorila jer ve\0107 postoji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363416039400104)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'hr'
,p_message_text=>unistr('Prona\0111eno je duplicirano korisni\010Dko ime za %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363520801400104)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri u\010Ditavanju korisnika. Nije uspjelo kod korisnika %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373495776400112)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'hr'
,p_message_text=>unistr('U\010Ditao bi se sljede\0107i broj korisnika: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373230896400112)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'hr'
,p_message_text=>'Lozinka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373397426400112)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'hr'
,p_message_text=>'Povlastice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373013777400111)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'hr'
,p_message_text=>unistr('Korisni\010Dko ime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449571572400171)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri prikazu stavke stranice #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369138831400108)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Stavka stranice ne mo\017Ee se prikazati jer HTML obrazac jo\0161 nije otvoren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112334453352400080)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri izra\010Dunu zadane vrijednosti stavke za stavku stranice #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368482801400108)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri naknadnom izra\010Dunu stavke za stavku stranice #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368368868400108)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri izra\010Dunu vrijednosti izvora stavke za stavku stranice #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348108226400092)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'hr'
,p_message_text=>unistr('Neovla\0161teni pristup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368624305400108)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'hr'
,p_message_text=>unistr('JavaScript nije podr\017Ean.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368792716400108)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'hr'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112369332677400108)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se inicijalizirati upit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376513359400114)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 - a\017Euriranje nije podr\017Eano.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112370768370400110)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'hr'
,p_message_text=>'ID stavke: %0 nije valjan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112397041167400130)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Za ovu stavku ne postoji pomo\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361534042400103)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'hr'
,p_message_text=>'Generiranje upita grafikona nije uspjelo. Provjerite postavke mapiranja izvora i stupaca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456324921400176)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'hr'
,p_message_text=>unistr('Privitak veli\010Dine %0 MB prekora\010Duje maksimalni privitak veli\010Dine %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362498718400103)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost nije valjana za parametar p_mail_id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112479857339400193)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'hr'
,p_message_text=>unistr('Prekora\010Dili ste maksimalan broj poruka e-po\0161te po radnom prostoru. Obratite se administratoru za pomo\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343495807400088)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'hr'
,p_message_text=>'Ovaj se postupak mora pozvati iz sesije aplikacije.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362333995400103)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'hr'
,p_message_text=>'Za parametar %0 navedena je null vrijednost.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416371062400146)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Predlo\017Eak e-po\0161te "%0" nije prona\0111en u aplikaciji %1.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112492815385400203)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Za slanje po\0161te mora se postaviti SMTP_HOST_ADDRESS parametar instance.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362078440400103)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>unistr('Za slanje po\0161te morate navesti primatelja poruke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112482244601400195)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se uspostaviti SMTP veza s konfiguriranim poslu\017Eiteljem e-po\0161te.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112456453731400176)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'hr'
,p_message_text=>'Ajax poziv nije valjan!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347884092400092)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Za priklju\010Dak %0 nije definirana Ajax funkcija')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446850759400169)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Za priklju\010Dak %0 nije definirana funkcija izvr\0161avanja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347929632400092)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Za priklju\010Dak %0 nije definirana funkcija generiranja prikaza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457394694400177)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Priklju\010Dak REST izvora podataka "%0" ne sadr\017Ei funkciju "Mogu\0107nosti".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457219958400177)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Priklju\010Dak REST izvora podataka "%0" ne sadr\017Ei DML funkciju.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457475079400177)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Priklju\010Dak REST izvora podataka "%0" ne sadr\017Ei funkciju Izvr\0161i.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112457502900400177)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'hr'
,p_message_text=>unistr('Priklju\010Dak REST izvora podataka "%0" ne sadr\017Ei funkciju Dohvat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345643580400090)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka PLSQL \0161ifre stvorena tijekom obrade priklju\010Dka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352237593400095)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Vrijednost se mora navesti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382847464400119)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'hr'
,p_message_text=>unistr('Vrsta podataka %0 ne mo\017Ee se pretvoriti u VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468436995400185)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Stupac "%0" naveden za atribut "%1" nije prona\0111en u SQL naredbi!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444727406400168)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'hr'
,p_message_text=>'Upit za popis vrijednosti (LOV) ili popis vrijednosti s nazivom mora se navesti za %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112446358796400169)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'hr'
,p_message_text=>unistr('U SQL upitu popisa vrijednosti za %0 odabran je pogre\0161an broj stupaca. Pogledajte primjere valjanih naredbi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468207666400185)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'hr'
,p_message_text=>'Za atribut "%0" nije naveden stupac.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497920636400207)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'hr'
,p_message_text=>'Unesena vrijednost %0 za atribut "%1" nije broj.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112449893699400172)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 sadr\017Ei pogre\0161nu vrstu podataka u SQL naredbi. Column# %1 je %2, a o\010Dekuje se %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112468311718400185)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'hr'
,p_message_text=>unistr('Stupac "%0" naveden za atribut "%1" sadr\017Ei vrstu podataka %2, a trebao bi sadr\017Eavati vrstu podataka %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112344952186400089)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'hr'
,p_message_text=>unistr('Nije prona\0111en izgled izvje\0161\0107a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404986676400137)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'hr'
,p_message_text=>unistr('Zna\010Dajka Izra\010Dun zbroja ne mo\017Ee se upotrijebiti za izvje\0161\0107a na temelju REST izvora podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112368572581400108)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('ERR-2904 Ne mo\017Ee se postaviti vrijednost pre\010Daca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112372803920400111)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka: Nepoznata vrsta pre\010Daca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112362866877400104)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se dohvatiti authentication_scheme u aplikaciji %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112436366665400162)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'hr'
,p_message_text=>unistr('Za trenutnu sesiju ve\0107 postoji ID klijenta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112373179603400112)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'hr'
,p_message_text=>unistr('E-po\0161ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497328427400206)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'hr'
,p_message_text=>unistr('Provjera autenti\010Dnosti nije uspjela.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112399630332400132)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'hr'
,p_message_text=>unistr('Jedan ili vi\0161e kola\010Di\0107a postavljenih u apex_util.g_request_cookies sadr\017Ee vrijednost koja nije valjana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112382136925400119)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'hr'
,p_message_text=>'Odgovor iz UDDI registra nije bio valjan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112345776906400090)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'hr'
,p_message_text=>'Navedeni URL nije vratio valjani WSDL dokument.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112348217812400092)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'hr'
,p_message_text=>unistr('WSDL dokument sadr\017Ei vi\0161e SOAP vezivanja. &PRODUCT_NAME. podr\017Eava samo WSDL-ove s jednim SOAP vezivanjem. Pritisnite Ru\010Dno stvaranje reference web-servisa kako biste nastavili sa stvaranjem reference za ovaj servis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112416607334400146)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'hr'
,p_message_text=>'Odgovor od servisa nije XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497214174400206)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'hr'
,p_message_text=>'OAuth pristupni token nije dostupan ili je istekao.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112460423664400179)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'hr'
,p_message_text=>unistr('Prekora\010Dili ste maksimalan broj zahtjeva web-servisa po radnom prostoru. Obratite se administratoru za pomo\0107.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112497415868400206)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'hr'
,p_message_text=>unistr('Poslu\017Eitelj je odgovorio nepodr\017Eanom vrstom OAuth tokena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347616063400091)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'hr'
,p_message_text=>unistr('WSDL dokument nije sadr\017Eavao vezivanje za SOAP obavezno za dodavanje reference.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112343547316400088)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'hr'
,p_message_text=>unistr('Za ovaj WSDL obavezni su sigurnosni podaci za provjeru autenti\010Dnosti. U nastavku navedite korisni\010Dko ime i lozinku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112352318290400095)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'hr'
,p_message_text=>unistr('Modul za generiranje prikaza nije razumio WSDL dokument. Pritisnite Ru\010Dno stvaranje reference web-servisa kako biste nastavili sa stvaranjem reference za ovaj servis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112419292053400148)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'hr'
,p_message_text=>unistr('Ne mo\017Ee se obraditi a\017Euriranje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112445051562400168)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'hr'
,p_message_text=>'Stupac za povrat i prikaz na popisu vrijednosti su jednaki!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112444947676400168)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'hr'
,p_message_text=>unistr('Popis vrijednosti ne sadr\017Ei stupac za povrat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376427436400114)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri dohvatu vrijednosti stupca: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400493762400133)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'hr'
,p_message_text=>unistr('Trenutni su podaci u tabli\010Dnom formatu prestari; izmijenjeni su izvorni podaci.<br/> Pritisnite <strong><a href="%0">ovdje</a></strong> kako biste odbacili promjene i ponovo u\010Ditajte podatke iz baze podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358593337400100)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri odre\0111ivanju niza numeracije stranica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358420449400100)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ne mogu se odrediti zaglavlja upita:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358698437400100)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'hr'
,p_message_text=>unistr('pogre\0161ka pri izvr\0161avanju zamjena podno\017Eja izvje\0161\0107a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358722467400100)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'parsiranje SQL upita nije uspjelo:',
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363798865400104)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'hr'
,p_message_text=>unistr('Minimalni broj zatra\017Eenih redaka: %0, redci koji su prona\0111eni, ali nisu prikazani: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361231154400102)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'hr'
,p_message_text=>'stupac upita #%0 (%1) nije valjan, za stupce koji upotrebljavaju HTML obavezni su drugi nazivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112376332096400114)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'hr'
,p_message_text=>unistr('Pogre\0161ka pri dohva\0107anju zaglavlja upita: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358846243400100)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('pogre\0161ka izvje\0161\0107a:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112396576697400130)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'hr'
,p_message_text=>'Sortiraj prema ovom stupcu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361316351400102)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'hr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Upit se ne mo\017Ee parsirati, provjerite sintaksu upita.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400571970400133)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'hr'
,p_message_text=>unistr('Ovaj obrazac sadr\017Ei nespremljene promjene. Pritisnite "U redu" kako biste nastavili bez spremanja promjena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112404837890400137)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'hr'
,p_message_text=>unistr('Shema numeriranja stranica izvje\0161\0107a (%0) nije podr\017Eana za odabrani izvor podataka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112361145098400102)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'hr'
,p_message_text=>'stupac upita #%0 (%1) nije valjan, upotrijebite drugi naziv stupca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363845747400104)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'hr'
,p_message_text=>unistr('redci %0 - %1 od vi\0161e od %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112402535915400135)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'hr'
,p_message_text=>unistr('%0 - %1 od vi\0161e od %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112363695594400104)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'hr'
,p_message_text=>'redci %0 - %1 od %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112347564016400091)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'hr'
,p_message_text=>'%0 - %1 od %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358958511400101)
,p_name=>'Y'
,p_message_language=>'hr'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112365092938400105)
,p_name=>'YEAR'
,p_message_language=>'hr'
,p_message_text=>'god.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112358156401400100)
,p_name=>'YEARS'
,p_message_language=>'hr'
,p_message_text=>'godine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112400608878400133)
,p_name=>'YES'
,p_message_language=>'hr'
,p_message_text=>'Da'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4481)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4481)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('Radna povr\0161ina')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4481
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4481)
,p_name=>'Poruke'
,p_alias=>'MESSAGES'
,p_step_title=>'Poruke'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
