prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4482
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4482 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4482
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102372307403620')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'hu'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4482)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113351'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4482)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4482)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4482)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4482)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4482)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4482)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4482)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4482)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4482)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4482)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4482)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4482)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4482)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.hu'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4482
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4482)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4482)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4482)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4482)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4482)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4482)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4482)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.hu'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4482
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4482)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4482)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4482)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4482)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4482)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4482)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4482)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.hu'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4482
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4482)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4482)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4482)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.hu'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4482
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4482)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4482)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4482)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4482)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4482)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4482)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4482)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4482)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4482)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4482)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4482)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4482)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4482)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4482)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4482)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.hu'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4482
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4482)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4482)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4482)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4482)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4482)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4482)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4482)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4482)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4482)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4482)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4482)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4482)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4482)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4482)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4482)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.hu'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4482
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4482)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4482)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4482)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4482)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4482)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4482)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4482)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4482)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4482)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4482)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4482)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4482)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4482)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4482)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4482)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.hu'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4482
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4482)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4482)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4482)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4482)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4482)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4482)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4482)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4482)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4482)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4482)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4482)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4482)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4482)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4482)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4482)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4482
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4482)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4482
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4482)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4482
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4482)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4482
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4482)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4482
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4482)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4482
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4482
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4482)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4482)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4482)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4482)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4482)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4482)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4482)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4482)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4482)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4482)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4482)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4482)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4482)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4482)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4482)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4482)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4482)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4482)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4482)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4482)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4482)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4482)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4482)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4482)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4482
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4482)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4482)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4482)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4482)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4482)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4482
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4482)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4482
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4482)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4482
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4482)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4482
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4482)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4482
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4482)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4482
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4482)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4482)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4482)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4482)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4482)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4482)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4482)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4482)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4482)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4482
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4482)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4482)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4482)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4482)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4482)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4482)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4482)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4482
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4482)
,p_page_name=>'winlov'
,p_page_title=>unistr('Keres\00E9si p\00E1rbesz\00E9dpanel')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('Keres\00E9s')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('Bez\00E1r\00E1s')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('Tov\00E1bb &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Vissza'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">#FIRST_ROW# - #LAST_ROW# sor</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4482
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4482)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4482
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4482)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4482)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4482)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4482)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4482)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4482)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4482)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4482)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4482)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4482)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4482)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4482)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4482)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4482)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4482)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4482)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4482)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4482)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4482)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4482)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4482)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4482)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4482)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4482)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4482)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4482)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4482)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4482)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4482)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4482)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4482)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4482)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4482)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4482)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4482)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4482)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4482)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4482)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4482)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4482)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4482)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4482)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4482)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4482)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4482)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4482)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4482)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4482)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4482)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4482)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4482)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4482)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4482)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4482)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4482)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4482)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4482)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4482)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4482)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4482)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4482)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4482)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4482)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4482)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4482)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4482)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4482)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4482)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4482)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4482)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4482)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4482)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4482)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4482)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4482)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4482)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4482)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4482)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4482)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4482)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4482)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4482)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4482)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4482)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4482)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4482)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4482)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4482)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4482)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4482)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4482)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4482)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4482)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4482)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4482)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4482)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4482)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4482)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4482)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4482)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4482)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4482)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4482)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4482)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4482)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4482)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4482)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4482)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4482)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4482)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4482)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4482)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4482)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4482)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4482)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4482)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4482)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4482)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4482)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4482)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4482)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4482)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4482)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4482)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4482)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4482)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4482)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4482)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4482)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4482)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4482)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4482)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4482)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4482)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4482)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4482)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4482)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4482)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4482)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4482)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4482)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4482)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4482)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4482)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4482)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4482)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4482)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4482)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4482)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4482)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4482)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4482)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4482)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4482)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4482)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4482)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4482)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4482)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4482)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4482)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4482)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4482)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4482)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4482)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4482)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4482)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4482)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4482)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4482)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4482)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4482)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4482)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4482)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4482)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4482)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4482)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4482)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4482)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4482)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4482)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4482)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4482)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4482)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4482)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4482)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4482)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533633919400240)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'hu'
,p_message_text=>'Oszlop %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520704522400230)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'hu'
,p_message_text=>'Rendszergazda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520644023400230)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'hu'
,p_message_text=>unistr('Felhaszn\00E1l\00F3n\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577967566400272)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1f\00E9r\00E9s megtagadva')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537641681400242)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'hu'
,p_message_text=>unistr('Elk\00E9sz\00FClt az \00D6n %0 fi\00F3kja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523296383400232)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'hu'
,p_message_text=>unistr('A fi\00F3k z\00E1rolva van.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513155741400224)
,p_name=>'AM_PM'
,p_message_language=>'hu'
,p_message_text=>'de. / du.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647568481400322)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 v\00E1lt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655605969400328)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'hu'
,p_message_text=>unistr('(Akt\00EDv)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625110641400306)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Az Ajax h\00EDv\00E1sa %0 kiszolg\00E1l\00F3i hib\00E1val t\00E9rt vissza %1 r\00E9sz\00E9re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555944040400256)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alkalmaz\00E1s "%0" m\00E1sodlagos neve nem alak\00EDthat\00F3 \00E1t az alkalmaz\00E1s egyedi azonos\00EDt\00F3j\00E1ra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556074543400256)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) "%0" m\00E1sodlagos nev\0171 alkalmaz\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545680372400248)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1816 V\00E1ratlan hiba a p_flow_alias_or_id (%0) alkalmaz\00E1si alias \00E1talak\00EDt\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638589898400316)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alkalmaz\00E1s ellen\0151rz\0151 \00F6sszege egyszer\0171 m\00F3dszert k\00EDn\00E1l annak meg\00E1llap\00EDt\00E1s\00E1hoz, hogy ugyanaz az alkalmaz\00E1s lett telep\00EDtve minden munkater\00FCletre. Az ellen\0151rz\0151 \00F6sszegek \00F6sszehasonl\00EDt\00E1s\00E1val lehet meg\00E1llap\00EDtani, hogy van-e egyez\00E9s. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531473341400238)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a hiteles\00EDt\00E9si funkci\00F3 feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516825728400227)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba t\00F6rt\00E9nt a hiteles\00EDt\00E9si funkci\00F3 feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680359113400346)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Az Oracle Cloud Identity Management \00E1ltal visszaadott %0 b\00E9rl\0151n\00E9v nincs hiteles\00EDtve a(z) %1 tartom\00E1nyhoz!<br/>K\00E9rj\00FCk, <a href="&LOGOUT_URL.">jelentkezzen be \00FAjra</a>, \00E9s adjon meg egy hiteles\00EDtett b\00E9rl\0151nevet, vagy m\00F3dos\00EDtsa az URL-c\00EDmet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514503242400225)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" fi\00F3k a(z) "%1" munkater\00FCletn\00E9l nem rendelkezik a sz\00FCks\00E9ges <br/>fejleszt\0151i jogosults\00E1ggal (DB_DEVELOPER vagy DB_ADMINISTRATOR)! K\00E9rj\00FCk, <a href="&LOGOUT_URL.">jelentkezzen be \00FAjra</a> a jogosults\00E1gok megszerz\00E9se ut\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513638845400225)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'hu'
,p_message_text=>unistr('Az Oracle Cloud Identity Management \00E1ltal visszaadott b\00E9rl\0151n\00E9v nincs hiteles\00EDtve az aktu\00E1lis munkater\00FCletre!<br/>K\00E9rj\00FCk, <a href="&LOGOUT_URL.">jelentkezzen be \00FAjra</a>, \00E9s adjon meg egy hiteles\00EDtett b\00E9rl\0151nevet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514608389400225)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Biztons\00E1gi okok miatt a jelen munkater\00FClet alkalmaz\00E1sainak az URL-c\00EDmben l\00E9v\0151 tartom\00E1ny \00E1ltali futtat\00E1sa nem megengedett.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531164532400238)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00E9rje meg az adatb\00E1zis rendszergazd\00E1j\00E1t a $OH/rdbms/admin/catldap.sql futtat\00E1s\00E1ra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531097709400238)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'hu'
,p_message_text=>unistr('A SYS.DBMS_LDAP csomag nem l\00E9tezik vagy \00E9rv\00E9nytelen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530929359400237)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba t\00F6rt\00E9nt az LDAP felhaszn\00E1l\00F3i funkci\00F3 feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531221180400238)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az LDAP hiteles\00EDt\00E9s feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532062059400238)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a login_page elj\00E1r\00E1snak \00E1tadand\00F3 p_flow_page argumentumban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531683179400238)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'hu'
,p_message_text=>unistr('A p_session \00E9rv\00E9nytelen itt: wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579584207400273)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'hu'
,p_message_text=>unistr('Helytelen form\00E1tum\00FA argumentum a wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2 r\00E9sz\00E9re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531715473400238)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'hu'
,p_message_text=>unistr('Null \00E9rt\00E9k\0171 felhaszn\00E1l\00F3n\00E9v lett \00E1tadva a bejelentkez\00E9si elj\00E1r\00E1s r\00E9sz\00E9re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520560310400230)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00FAjb\00F3li bejelentkez\00E9shez v\00E1rjon <span id="apex_login_throttle_sec">%0</span> m\00E1sodpercet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521894801400231)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Blokkolva lett a bejelentkez\00E9si k\00EDs\00E9rlet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577343895400271)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 a(z) "%0" hiteles\00EDt\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522105248400231)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'hu'
,p_message_text=>unistr('Null \00E9rt\00E9k\0171 a biztons\00E1gi csoport azonos\00EDt\00F3ja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531509610400238)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az ut\00F3hiteles\00EDt\00E9si elj\00E1r\00E1s v\00E9grehajt\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531300016400238)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az el\0151hiteles\00EDt\00E9si elj\00E1r\00E1s feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532569633400239)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nyissa meg az URL-c\00EDmet ugyanabban a b\00F6ng\00E9sz\0151ben, mint ahol kezdem\00E9nyezte a Jelsz\00F3-vissza\00E1ll\00EDt\00E1si k\00E9relmet.  Ha a Jelsz\00F3-vissza\00E1ll\00EDt\00E1si URL-c\00EDmre kattint,'),
unistr('vissza lesz ir\00E1ny\00EDtva a bejelentkez\00E9si oldalra.'),
unistr('Pr\00F3b\00E1lja \00FAjra a Jelsz\00F3-vissza\00E1ll\00EDt\00E1st, \00E9s hagyja nyitva a b\00F6ng\00E9sz\0151t.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677807236400344)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'hu'
,p_message_text=>unistr('Jelsz\00F3 URL-c\00EDm\00E9nek vissza\00E1ll\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514817123400226)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az Er\0151forr\00E1skezel\0151i %0 fogyaszt\00F3i csoportnak nincs %1 jogosults\00E1ga')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514933521400226)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'hu'
,p_message_text=>unistr('A hi\00E1nyz\00F3 jogosults\00E1g megszerz\00E9s\00E9hez haszn\00E1lja a k\00F6vetkez\0151t: DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542919387400246)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a feldolgoz\00E1si munkamenet sentry funkci\00F3j\00E1ban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543076181400246)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a feldolgoz\00E1si munkamenet ellen\0151rz\00E9si funkci\00F3j\00E1ban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543291529400246)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00E9rje meg a(z) %0 rendszergazd\00E1j\00E1t, hogy konfigur\00E1lja az Oracle Application Server Single Sign-On (SSO) funkci\00F3j\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552701797400253)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %1 tokenben szab\00E1lytalan %0 lett visszaadva az egyszeri bejelentkez\00E9s \00E1ltal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531903932400238)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00F3dos\00EDtsa a hiteles\00EDt\00E9si s\00E9m\00E1t, \00E9s adja meg az alkalmaz\00E1s nev\00E9t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552415650400253)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 elj\00E1r\00E1s szab\00E1lytalan megh\00EDv\00F3ja:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552618096400253)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen alkalmaz\00E1si munkamenet az urlc tokenben: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552254355400253)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a portal_sso_redirect elj\00E1r\00E1sban: hi\00E1nyzik az alkalmaz\00E1s-regisztr\00E1l\00E1si adat: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543102228400246)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik vagy \00E9rv\00E9nytelen a WWSEC_SSO_ENABLER_PRIVATE csomag.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112531826740400238)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('A hiteles\00EDt\00E9si s\00E9m\00E1ban nem tal\00E1lhat\00F3 a regisztr\00E1lt partneralkalmaz\00E1s neve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552369790400253)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'hu'
,p_message_text=>unistr('Regisztr\00E1lja ezt az alkalmaz\00E1st a telep\00EDt\00E9si \00FAtmutat\00F3 szerint.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543326283400246)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az SSO hiteles\00EDt\00E9s feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652730737400326)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'hu'
,p_message_text=>unistr('Jogosulatlan URL-c\00EDm: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542742010400246)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a hiteles\00EDt\00E9s feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514737151400226)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" munkater\00FClet nem akt\00EDv. Forduljon a rendszergazd\00E1hoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515102631400226)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'hu'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521512645400231)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1f\00E9r\00E9s megtagadva az alkalmaz\00E1s-biztons\00E1gi ellen\0151rz\00E9s \00E1ltal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521689086400231)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1f\00E9r\00E9s megtagadva az oldalbiztons\00E1gi ellen\0151rz\00E9s \00E1ltal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521714975400231)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a hiteles\00EDt\00E9s feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585133692400277)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 k\00E9sz\00FClt a(z) %1 haszn\00E1lat\00E1val')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585290439400277)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Szak\00E9rtelemmel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643049723400319)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Esem\00E9ny le\00EDr\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642892207400319)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'hu'
,p_message_text=>unistr('Z\00E1r\00F3 d\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643130443400319)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'hu'
,p_message_text=>unistr('Esem\00E9ny azonos\00EDt\00F3ja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642779287400319)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'hu'
,p_message_text=>unistr('Kezd\0151 d\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642981745400319)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Esem\00E9ny megnevez\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533506652400240)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hib\00E1s az ellen\0151rz\0151 \00F6sszeg tartalma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533473445400239)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hib\00E1s az ellen\0151rz\0151 \00F6sszeg form\00E1tuma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597451361400286)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'hu'
,p_message_text=>unistr('A v\00E1g\00F3lapra m\00E1solva.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597151776400286)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez a b\00F6ng\00E9sz\0151 nem t\00E1mogatja a v\00E1g\00F3lapra t\00F6rt\00E9n\0151 m\00E1sol\00E1st gombr\00F3l \00E9s men\00FCb\0151l. Pr\00F3b\00E1lja a Ctrl+C vagy Command+C billenty\0171kombin\00E1ci\00F3val.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585628493400277)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rtes\00EDt\00E9s lez\00E1r\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641698526400318)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'hu'
,p_message_text=>'Kontraszt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636191201400314)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'hu'
,p_message_text=>unistr('Aktu\00E1lis')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636066122400314)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'hu'
,p_message_text=>unistr('Kezd\0151bet\0171')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640272921400317)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# \00E9rt\00E9ke csak \00E9rv\00E9nyes sz\00EDn lehet. P\00E9ld\00E1ul: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635937726400314)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00EDnv\00E1laszt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636254798400314)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00EDnform\00E1tum megv\00E1ltoztat\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675426703400343)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9klista')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675533034400343)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'hu'
,p_message_text=>unistr('Lista megnyit\00E1sa ehhez: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655786444400328)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'hu'
,p_message_text=>'(Befejezve)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548075377400250)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'hu'
,p_message_text=>unistr('Forduljon az alkalmaz\00E1s adminisztr\00E1tor\00E1hoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562496075400260)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00E9pjen kapcsolatba az alkalmaz\00E1s adminisztr\00E1tor\00E1val.'),
unistr('Az esem\00E9nyre vonatkoz\00F3 r\00E9szletek a(z) "%0" hibakeres\00E9si azonos\00EDt\00F3 haszn\00E1lat\00E1val tal\00E1lhat\00F3k meg.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640581143400317)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'hu'
,p_message_text=>unistr('A ment\00E9s el\0151tt jav\00EDtsa ki a hib\00E1kat.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586557082400278)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 egyez\00E9s tal\00E1lhat\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586451031400278)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs egyez\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656235313400328)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'hu'
,p_message_text=>unistr('Aktu\00E1lis folyamat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640917795400317)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 elemben megadott f\00E1jl nem l\00E9tezik az APEX_APPLICATION_TEMP_FILES \00E1ltal megadottak k\00F6z\00F6tt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629425402400309)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatb\00E1zisban megv\00E1ltozott az adatok aktu\00E1lis verzi\00F3ja, ami\00F3ta valamelyik felhaszn\00E1l\00F3 friss\00EDt\00E9si elj\00E1r\00E1st kezdem\00E9nyezett.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598565657400287)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'hu'
,p_message_text=>unistr('Ne t\00F6ltse be')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645556360400321)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151feldolgoz\00E1si hiba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645395961400320)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor besz\00FAr\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659466657400331)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorrend : M\0171velet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645452358400321)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor m\00F3dos\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586932829400278)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Felbukkan\00F3 napt\00E1r: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509559967400222)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509638497400222)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645725087400321)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('#LABEL# \00E9rt\00E9ket kell tartalmazzon.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645606470400321)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# \00E9rt\00E9ke csak \00E9rv\00E9nyes d\00E1tum lehet, p\00E9ld\00E1ul: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513209233400224)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'hu'
,p_message_text=>unistr('#LABEL# csak %0 \00E9s %1 k\00F6z\00F6tti lehet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513316952400224)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'hu'
,p_message_text=>unistr('#LABEL# csak aznapi vagy k\00E9s\0151bbi lehet, mint %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513418037400224)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'hu'
,p_message_text=>unistr('#LABEL# csak aznapi vagy kor\00E1bbi lehet, mint %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590446039400281)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# k\00E9s\0151bbi, mint a megadott legk\00E9s\0151bbi %0 d\00E1tum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590869411400281)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('#LABEL# nem a megfelel\0151 %0 form\00E1tum\00FA.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590382223400281)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# kor\00E1bbi, mint a megadott legkor\00E1bbi %0 d\00E1tum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590578707400281)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# nincs a(z) %0 \00E9s %1 \00E9rv\00E9nyes tartom\00E1ny\00E1ban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590709832400281)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# nincs a(z) %0 \00E9s %1 k\00F6z\00F6tti \00E9vek tartom\00E1ny\00E1ban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640818332400317)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E9gse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668009997400337)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'hu'
,p_message_text=>unistr('Bez\00E1r\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670096510400339)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640668065400317)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'hu'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640718068400317)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ment\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546913907400249)
,p_name=>'APEX.ERROR'
,p_message_language=>'hu'
,p_message_text=>'Hiba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514354174400225)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'hu'
,p_message_text=>unistr('A hibakezel\00E9si visszah\00EDv\00E1s v\00E9grehajt\00E1sakor a k\00F6vetkez\0151 hiba t\00F6rt\00E9nt: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523052157400232)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba t\00F6rt\00E9nt a(z) %0 hibalap kirajzol\00E1sakor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515083531400226)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'hu'
,p_message_text=>unistr('Bels\0151 hiba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654854685400327)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00E9pjen kapcsolatba a rendszergazd\00E1val.'),
unistr('Az esem\00E9nyre vonatkoz\00F3 r\00E9szletek a(z) "%0" hibakeres\00E9si azonos\00EDt\00F3 haszn\00E1lat\00E1val tal\00E1lhat\00F3k meg.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649198548400323)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatb\00E1zis \00EDr\00E1sv\00E9detten van megnyitva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679704902400346)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'hu'
,p_message_text=>unistr('ORA-28353: Nem siker\00FClt megnyitni a t\00E1rc\00E1t. Az alkalmaz\00E1s adatai jelenleg nem \00E9rhet\0151k el.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649295346400323)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Sajnos ez az oldal nem \00E9rhet\0151 el')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516720506400227)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'hu'
,p_message_text=>unistr('Technikai inform\00E1ci\00F3 (csak a fejleszt\0151k l\00E1tj\00E1k)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612843516400297)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba\00FCzenet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626757031400307)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('A v\00E1rt form\00E1tum: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593466174400283)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'hu'
,p_message_text=>unistr('A felhaszn\00E1l\00F3 m\00E1r a Hozz\00E1f\00E9r\00E9s-vez\00E9rl\00E9si list\00E1ban van')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593383194400283)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'hu'
,p_message_text=>unistr('Er\0151s\00EDtse meg a k\00F6vetkez\0151 %0 felhaszn\00E1l\00F3 felv\00E9tel\00E9t a(z) <strong>%1</strong> hozz\00E1f\00E9r\00E9s-vez\00E9rl\00E9si list\00E1ba.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593885382400283)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 felhaszn\00E1l\00F3 tal\00E1lhat\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593547454400283)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'hu'
,p_message_text=>unistr('Hi\00E1nyzik a kukac (@) az e-mail-c\00EDmben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593650965400283)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'hu'
,p_message_text=>unistr('Hi\00E1nyzik a pont (.) az e-mail-c\00EDmben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593763474400283)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00FAl hossz\00FA a felhaszn\00E1l\00F3n\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594032068400283)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'hu'
,p_message_text=>unistr('Csak az alkalmaz\00E1s hozz\00E1f\00E9r\00E9s-vez\00E9rl\00E9si list\00E1j\00E1ban megadott felhaszn\00E1l\00F3k \00E9rhetik el')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594153508400283)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1ratlan a hozz\00E1f\00E9r\00E9s-vez\00E9rl\00E9si lista \00E9rt\00E9ke: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593987104400283)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ezt az alkalmaz\00E1st el\00E9ri minden hiteles\00EDtett felhaszn\00E1l\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636791532400314)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'hu'
,p_message_text=>'Letiltva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636616527400314)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'hu'
,p_message_text=>unistr('Enged\00E9lyezve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636922273400314)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'hu'
,p_message_text=>'%0: Letiltva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636802599400314)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'hu'
,p_message_text=>unistr('%0: Enged\00E9lyezve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636565270400314)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'hu'
,p_message_text=>unistr('azonos\00EDtatlan')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629671972400309)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Let\00F6lt\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586100892400278)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'hu'
,p_message_text=>unistr('Alkalmazott sz\0171r\0151: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627221613400308)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'hu'
,p_message_text=>'Alkalmaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512168612400224)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00E1vdiagram')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639950921400317)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'hu'
,p_message_text=>'Egyebek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512248013400224)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6rdiagram')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638637468400316)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'hu'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511955654400223)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mennyis\00E9g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627740068400308)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6rl\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627851503400308)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes t\00F6rl\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627993788400308)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 t\00F6rl\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645191199400320)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 ism\00E9rv \00E1ltal hivatkozott %1 oszlop nem \00E9rhet\0151 el, vagy nem jogosult.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502375642400217)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lassza ki a megjelen\00EDtend\0151 sz\0171r\0151ket')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584328108400276)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 tal\00E1lat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584478674400276)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 kiv\00E1lasztva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587039829400278)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'hu'
,p_message_text=>unistr('Aktu\00E1lis sz\0171r\0151k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503850114400218)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151k list\00E1ja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643651224400319)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'hu'
,p_message_text=>unistr('A megk\00FCl\00F6nb\00F6ztet\00E9s \00E9rt\00E9kkorl\00E1tja (%0) t\00FAll\00E9pve a(z) %1 ism\00E9rvn\00E9l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629282777400309)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 ism\00E9rv nem t\00E1mogatott sem a DATE, sem a TIMESTAMP form\00E1tum\00FA oszlopokn\00E1l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627341090400308)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 sz\0171r\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627490055400308)
,p_name=>'APEX.FS.GO'
,p_message_language=>'hu'
,p_message_text=>unistr('Ind\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628894612400309)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('egyenl\0151 ezzel: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512919804400224)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'hu'
,p_message_text=>'tartalmazza ezt: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512601045400224)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'hu'
,p_message_text=>'nagyobb, mint %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512704657400224)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'hu'
,p_message_text=>unistr('nagyobb, mint %0 vagy egyenl\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512470063400224)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'hu'
,p_message_text=>'kevesebb, mint %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512538588400224)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'hu'
,p_message_text=>unistr('kevesebb, mint %0 vagy egyenl\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512802129400224)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'hu'
,p_message_text=>unistr('ezzel kezd\0151dik: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515359262400226)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('A Beviteli mez\0151 ism\00E9rv\00E9n\00E9l nem t\00E1mogatott a(z) %0 adatt\00EDpusa (%1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505546714400219)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'hu'
,p_message_text=>unistr('A t\00F6bb\00E9rt\00E9k\0171 ism\00E9rvek 12.2 vagy magasabb verzi\00F3j\00FA adatb\00E1zisokat ig\00E9nyelnek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629087766400309)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 ism\00E9rv r\00E9sz\00E9re nem lett biztos\00EDtva keres\00E9si oszlop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502450906400217)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'hu'
,p_message_text=>unistr('Tov\00E1bbi sz\0171r\0151k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584521877400276)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'hu'
,p_message_text=>unistr('Tartom\00E1ny kezdete')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628525239400308)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'hu'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628691237400309)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'hu'
,p_message_text=>'%0 felett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628708226400309)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'hu'
,p_message_text=>'%0 alatt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584634466400276)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'hu'
,p_message_text=>unistr('Tartom\00E1ny v\00E9ge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647414059400322)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 ism\00E9rvn\00E9l \00E9rv\00E9nytelen az \00E9rt\00E9klista #%2 ("%1") eleme (hi\00E1nyzik a "|" elv\00E1laszt\00F3).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628981146400309)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'hu'
,p_message_text=>unistr('Jelenleg a(z) %0 tartom\00E1nyi ism\00E9rvhez nem t\00E1mogatott a manu\00E1lis adatbevitel, mivel az oszlop DATE vagy TIMESTAMP form\00E1tum\00FA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628205173400308)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'hu'
,p_message_text=>'eddig:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512065956400224)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagram elt\00E1vol\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581172916400274)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Vissza\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627675789400308)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627559689400308)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628402354400308)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'hu'
,p_message_text=>unistr('- Kijel\00F6l\00E9s -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511843173400223)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagram megjelen\00EDt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628036502400308)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kevesebb megjelen\00EDt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628134066400308)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6bb megjelen\00EDt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112628324199400308)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 csillag vagy t\00F6bb')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586098714400278)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\00E9si javaslatok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629187302400309)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('A sz\00F6vegmez\0151 %0 ism\00E9rve jelenleg csak NUMBER form\00E1tum\00FA oszlopokn\00E1l t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502298732400217)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorok teljes sz\00E1ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645236297400320)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 adatt\00EDpusa (%1) az ir\00E1ny\00EDtott keres\00E9sn\00E9l nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637155957400315)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Ugr\00E1s a hib\00E1hoz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594717391400284)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes\00EDt\00E9s.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602349398400290)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9spont becsuk\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594854255400284)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9spont.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602281201400290)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9spont kibont\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680994867400347)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>'%0. oszlop.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602009916400289)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 sor t\00F6r\00F6lve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672462961400341)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 azonos\00EDt\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591711519400282)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595090479400284)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportfejl\00E9c.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594961913400284)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Fejl\00E9c.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591847615400282)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Utols\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611888391400296)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tov\00E1bbi sorok bet\00F6lt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591596453400281)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595183170400284)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'hu'
,p_message_text=>'Oldal sorai'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591929490400282)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'hu'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592088851400282)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'hu'
,p_message_text=>'%0 - %1 / %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648026768400323)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldal kijel\00F6l\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591687115400282)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672262209400340)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1adva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672385853400340)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00F3dos\00EDtva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680706118400347)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>'%0. sor, %1 oszlop.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680870311400347)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>'%0. sor,'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672179423400340)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6r\00F6lve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595360909400284)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor fejl\00E9ce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590964494400281)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 cella kijel\00F6lve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592126473400282)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 sor kijel\00F6lve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632456653400311)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mind kijel\00F6l\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602144869400290)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'hu'
,p_message_text=>'%0. oldal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595258407400284)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor kijel\00F6l\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595415861400284)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00F6vekv\0151 sorrend %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595502954400285)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('Cs\00F6kken\0151 sorrend %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591060136400281)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00F6vekv\0151 sorrend')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591365677400281)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9s n\00F6vekv\0151 sorrendben %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591181912400281)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('Cs\00F6kken\0151 sorrend')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591423723400281)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9s cs\00F6kken\0151 sorrendben %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112591229095400281)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9s n\00E9lk\00FCl')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601945898400289)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszesen %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528387456400236)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem siker\00FClt a(z) "%0" vonatkoz\00E1s\00FA HTTP k\00E9relem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669634821400338)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'hu'
,p_message_text=>unistr('A r\00E1cs v\00E1laszt\00E9klist\00E1ja %0 oszlop \00E9s %1 sor. Haszn\00E1lja a ny\00EDlbillenty\0171ket')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601876054400289)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1laszt\00E1si lista %0 sora. Haszn\00E1lja a ny\00EDlbillenty\0171ket')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680539875400346)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 interakt\00EDv r\00E1cs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588640973400279)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('M\0171veletek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589609609400280)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1ad\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589554569400280)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor hozz\00E1ad\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674022460400342)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659553390400331)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661286715400332)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'hu'
,p_message_text=>'Mind'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617637626400301)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Minden sz\00F6vegoszlop')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618800869400301)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Alternat\00EDva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619941754400302)
,p_name=>'APEX.IG.AND'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639395698400316)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCl\00F6nb\00F6z\0151k sz\00E1ma k\00F6r\00FClbel\00FCl')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675043375400342)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCl\00F6nb\00F6z\0151k \00E1ltal\00E1nos sz\00E1ma megk\00F6zel\00EDt\0151leg')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658167709400330)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'hu'
,p_message_text=>unistr('Ter\00FClet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660052940400331)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00F6vekv\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618952679400302)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Enged\00E9lyez\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674180158400342)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'hu'
,p_message_text=>'Automatikus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639714094400316)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1tlag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674754278400342)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ltal\00E1nos \00E1tlag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657646584400330)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('A feliratok tengely\00E9nek c\00EDme')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657889301400330)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'hu'
,p_message_text=>'Tizedesjegyek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657774286400330)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00E9rt\00E9kek tengely\00E9nek c\00EDme')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663837044400334)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'hu'
,p_message_text=>unistr('H\00E1tt\00E9rsz\00EDn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658246164400330)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00E1v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614253488400298)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'hu'
,p_message_text=>unistr('ezek k\00F6z\00F6tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665064936400335)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'hu'
,p_message_text=>unistr('Mindkett\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658372352400330)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Bubor\00E9k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589807573400280)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E9gse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619807094400302)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Kis- \00E9s nagybet\0171 megk\00FCl\00F6nb\00F6ztet\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675695003400343)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'hu'
,p_message_text=>unistr('(Kis- \00E9s nagybet\0171k megk\00FCl\00F6nb\00F6ztet\00E9se)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646503478400321)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00F3dos\00EDt\00E1sok mentve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590250873400281)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00E9zet megv\00E1ltoztat\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620934994400303)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'hu'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617486345400300)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'hu'
,p_message_text=>unistr('A lek\00E9rdez\00E9sben a diagramonk\00E9nti adatpontok sz\00E1ma t\00F6bb, mint a maximum: %0. Haszn\00E1ljon sz\0171r\0151t, hogy cs\00F6kkentse a rekordok sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588575543400279)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagramn\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595880172400285)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('Kit\00F6rl\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657165971400329)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Bez\00E1r\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664037069400334)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00EDnek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640122200400317)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151n\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619265739400302)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Oszlop'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588720785400280)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'hu'
,p_message_text=>'Oszlopok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665816960400336)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlop rendeltet\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619354287400302)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszetett')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588940402400280)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00E1m\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614855319400299)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'hu'
,p_message_text=>'tartalmaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621183684400303)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9spont')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595632305400285)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1sol\00E1s a v\00E1g\00F3lapra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595754609400285)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1sol\00E1s lefel\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639199683400316)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('Mennyis\00E9g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639256441400316)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCl\00F6nb\00F6z\0151k sz\00E1ma')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674926259400342)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCl\00F6nb\00F6z\0151k \00E1ltal\00E1nos sz\00E1ma')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674848990400342)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ltal\00E1nos mennyis\00E9g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672544405400341)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 l\00E9trehoz\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617899117400301)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'hu'
,p_message_text=>'Adatok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665670594400335)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Adatt\00EDpus')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665299923400335)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('D\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646308177400321)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen d\00E1tum \00E9rt\00E9k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615579507400299)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'hu'
,p_message_text=>'nap'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618531272400301)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett be\00E1ll\00EDt\00E1sok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618389179400301)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Alapt\00EDpus')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589700450400280)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6rl\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666840046400336)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'hu'
,p_message_text=>unistr('Biztos, hogy szeretn\00E9 t\00F6r\00F6lni ezt a kimutat\00E1st?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622946781400304)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor t\00F6rl\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621720736400304)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorok t\00F6rl\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660164495400331)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('Cs\00F6kken\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620606659400303)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9szletek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588279815400279)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9szletes n\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648846987400323)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Ir\00E1ny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620324302400303)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'hu'
,p_message_text=>'Letiltva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614913451400299)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'hu'
,p_message_text=>'nem tartalmaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615161634400299)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'hu'
,p_message_text=>unistr('nem ezzel kezd\0151dik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658426957400330)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'hu'
,p_message_text=>unistr('Gy\0171r\0171')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621324101400303)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'hu'
,p_message_text=>unistr('Let\00F6lt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520079868400230)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'hu'
,p_message_text=>'Csak adatok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667813264400337)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lasszon form\00E1tumot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532621784400239)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs enged\00E9lyezve a(z) %0 let\00F6lt\00E9si form\00E1tum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660812239400332)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 \00F6sszes\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660917957400332)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 ellen\0151rz\0151 t\00F6r\00E9spont')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622837176400304)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor m\00E1sol\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621658263400303)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 sorok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589387825400280)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Szerkeszt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659908037400331)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagram szerkeszt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671499289400340)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1si szempont szerkeszt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667480037400337)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'hu'
,p_message_text=>unistr('Titkos m\00E1solat (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667645299400337)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DCzenet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667346694400337)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1solat (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667066897400336)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'hu'
,p_message_text=>unistr('E-mail elk\00FCldve.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667560955400337)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00E1rgy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667276589400337)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDmzett (to)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620074407400302)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'hu'
,p_message_text=>unistr('Enged\00E9lyezett')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613278283400297)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'hu'
,p_message_text=>unistr('egyenl\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666499659400336)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'hu'
,p_message_text=>unistr('P\00E9lda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620184337400302)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('Kifejez\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666329999400336)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00EDpus')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632320882400311)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'hu'
,p_message_text=>unistr('A f\00E1jl el\0151k\00E9sz\00EDtve. Kezd\0151dik a let\00F6lt\00E9s.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112595914418400285)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'hu'
,p_message_text=>unistr('Kit\00F6lt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597065049400286)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Kijel\00F6l\00E9s kit\00F6lt\00E9se ezzel')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596937039400286)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Kijel\00F6l\00E9s kit\00F6lt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588873090400280)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619464759400302)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674449829400342)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660386371400331)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589027415400280)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'hu'
,p_message_text=>unistr('Visszatekint\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617974620400301)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('Form\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664901961400335)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'hu'
,p_message_text=>unistr('Form\00E1tummaszk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666719355400336)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'hu'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666638095400336)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'hu'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579413377400273)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'hu'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518724829400229)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'hu'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622533197400304)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'hu'
,p_message_text=>unistr('Befagyaszt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620255832400302)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCggv\00E9nyek \00E9s m\0171veletek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658521543400330)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6lcs\00E9r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639053211400316)
,p_name=>'APEX.IG.GO'
,p_message_language=>'hu'
,p_message_text=>unistr('Ugr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613820137400298)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'hu'
,p_message_text=>'nagyobb, mint'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613910354400298)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'hu'
,p_message_text=>unistr('nagyobb vagy egyenl\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620519529400303)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E1cs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588094596400279)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E1cs n\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661179174400332)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'hu'
,p_message_text=>'Csoport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620765732400303)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1si szempont')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588358153400279)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1s n\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665525885400335)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Felt\00E9tel t\00EDpusa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664422326400334)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDmsor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664696529400335)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDmsor igaz\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674303652400342)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669816519400339)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Adatokat k\00F6zvetlen\00FCl az interakt\00EDv adatr\00E1cson is lehet besz\00FArni, m\00F3dos\00EDtani \00E9s t\00F6r\00F6lni.</p>'),
'',
unistr('<p>\00DAj sor besz\00FAr\00E1s\00E1hoz kattintson a Sor hozz\00E1ad\00E1sa gombra.</p>'),
'',
unistr('<p>L\00E9tez\0151 adatokat a konkr\00E9t cell\00E1ra dupl\00E1n kattintva lehet szerkeszteni. Nagyobb szerkeszt\00E9si munk\00E1hoz kattintson a Szerkeszt\00E9s gombra, hogy bel\00E9pjen a szerkeszt\00E9si m\00F3dba. A szerkeszt\00E9si m\00F3dban egyszeri kattint\00E1ssal \00E9s a billenty\0171zet haszn\00E1lat\00E1val m')
||unistr('\00F3dos\00EDthatja a k\00EDv\00E1nt cell\00E1kat.</p>'),
'',
unistr('<p>A M\00F3dos\00EDt\00E1s men\00FC haszn\00E1lhat\00F3 az egyes sorok megdupl\00E1z\00E1s\00E1hoz vagy t\00F6rl\00E9s\00E9hez. A M\00F3dos\00EDt\00E1s men\00FC megjelen\00EDt\00E9s\00E9hez a jel\00F6l\0151n\00E9gyzetek bejel\00F6l\00E9s\00E9vel v\00E1laszthat ki egy vagy t\00F6bb sort.</p>'),
'',
unistr('<p>Egy kijel\00F6lt sor megdupl\00E1z\00E1s\00E1hoz kattintson a M\00F3dos\00EDt\00E1s men\00FCre, \00E9s v\00E1lassza az Ism\00E9tl\0151d\0151 sorok elemet. Egy kijel\00F6lt sor t\00F6rl\00E9s\00E9hez kattintson a M\00F3dos\00EDt\00E1s men\00FCre, \00E9s v\00E1lassza a Sor t\00F6rl\00E9se elemet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671991138400340)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'hu'
,p_message_text=>unistr('Szerkeszt\00E9si lehet\0151s\00E9gek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672085081400340)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Az interakt\00EDv r\00E1cs az adatok k\00E9szlet\00E9t kereshet\0151, testre szabhat\00F3 kimutat\00E1sk\00E9nt jelen\00EDti meg. A visszaadott rekordok korl\00E1toz\00E1sa \00E9rdek\00E9ben sz\00E1mos m\0171velet hajthat\00F3 v\00E9gre, \00E9s megv\00E1ltoztathat\00F3 az adatok megjelen\00EDt\00E9si m\00F3dja is.</p>'),
'',
unistr('<p>A Keres\00E9s mez\0151 haszn\00E1lhat\00F3 a visszaadott rekordok sz\0171r\00E9s\00E9re. A M\0171veletek men\00FCre vagy a megjelen\00EDtett oszlop Oszlopfejl\00E9c men\00FCire kattintva el\00E9rhet\0151 sz\00E1mos, a kimutat\00E1s elrendez\00E9s\00E9t m\00F3dos\00EDt\00F3 lehet\0151s\00E9g.</p>'),
'',
unistr('<p>A Kimutat\00E1s be\00E1ll\00EDt\00E1sai men\00FC haszn\00E1lhat\00F3 a kimutat\00E1son v\00E9gzett testreszab\00E1sok ment\00E9s\00E9re. A kimutat\00E1sb\00F3l sz\00E1rmaz\00F3 adatok k\00FCls\0151 f\00E1jlba is let\00F6lthet\0151k, illetve elk\00FCldhet\0151 a saj\00E1t vagy m\00E1sok e-mail-c\00EDm\00E9re.</p>'),
'',
unistr('<p>A tov\00E1bbi r\00E9szleteket l\00E1sd az <em>Oracle Application Express v\00E9gfelhaszn\00E1l\00F3i \00FAtmutat\00F3j\00E1ban</em> az " Interakt\00EDv r\00E1csok haszn\00E1lata" c\00EDm alatt.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671794382400340)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ttekint\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669764323400338)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Az interakt\00EDv r\00E1cs testre szabhat\00F3, hogy az adatokat a be\00E9p\00EDtett lehet\0151s\00E9gek haszn\00E1lat\00E1val k\00FCl\00F6nb\00F6z\0151 m\00F3don jelen\00EDtse meg.</p>'),
'',
unistr('<p>Az Oszlopfejl\00E9c men\00FC vagy a M\0171veletek men\00FC haszn\00E1lhat\00F3 annak megad\00E1s\00E1ra, hogy mely oszlopok, milyen sorrendben vagy befagyasztva jelenjenek meg. Meghat\00E1rozhat\00F3k az adatsz\0171r\0151k \00E9s a visszaadott adatok sorrendje is.</p>'),
'',
unistr('<p>A (Keres\00E9s mez\0151 melletti) Megtekint\00E9s gombbal el\00E9rhet olyan adatn\00E9zeteket is, amelyeket esetleg az alkalmaz\00E1s fejleszt\0151je defini\00E1lt. Emellett diagramot is l\00E9trehozhat, illetve megtekinthet egy megl\00E9v\0151t.</p>  '),
'',
unistr('<p><em>Megjegyz\00E9s: A kijel\00F6lt funkci\00F3ra vonatkoz\00F3 r\00E9szletesebb inform\00E1ci\00F3k\00E9rt kattintson a <strong>S\00FAg\00F3</strong> gombra az interakt\00EDv r\00E1cs p\00E1rbesz\00E9dpaneljein.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671820350400340)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1sk\00E9sz\00EDt\00E9si lehet\0151s\00E9gek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621506988400303)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 az interakt\00EDv r\00E1cshoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668683408400338)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ez a p\00E1rbesz\00E9dpanel haszn\00E1lhat\00F3 az oszlopok \00F6sszes\00EDt\00E9s\00E9hez. Az \00F6sszes\00EDtett \00E9rt\00E9kek az adatok alatt jelennek meg, illetve ha lett Ellen\0151rz\0151 t\00F6r\00E9spont defini\00E1lva, az egyes t\00F6r\00E9spontok alatt.</p>'),
'',
unistr('<p><strong>\00D6sszes\00EDt\00E9si lista</strong><br>'),
unistr('Az \00D6sszes\00EDt\00E9si lista jelen\00EDti meg a defini\00E1lt \00F6sszes\00EDt\00E9seket. L\00E9tez\0151 \00F6sszes\00EDt\00E9st a kijel\00F6l\00E9se megsz\00FCntet\00E9s\00E9vel rejthet el.<br>'),
unistr('A Hozz\00E1ad\00E1s ( &plus; ) elemre kattintva \00FAj \00F6sszes\00EDt\00E9st hozhat l\00E9tre, a T\00F6rl\00E9s ( &minus; ) elemmel pedig elt\00E1vol\00EDthat egy l\00E9tez\0151 \00F6sszes\00EDt\00E9st.</p>'),
unistr('<p><strong>\00D6sszes\00EDt\00E9si be\00E1ll\00EDt\00E1sok</strong><br>'),
unistr('A jobb oldalon l\00E9v\0151 \0171rlapon defini\00E1lhat\00F3 az \00F6sszes\00EDt\00E9s.<br>'),
unistr('V\00E1lassza ki az Oszlop nev\00E9t \00E9s az \00D6sszes\00EDt\00E9s t\00EDpus\00E1t.<br>'),
unistr('Opcion\00E1lisan elemle\00EDr\00E1st is hozz\00E1rendelhet az \00F6sszes\00EDt\00E9shez.<br>'),
unistr('Ha Ellen\0151rz\0151 t\00F6r\00E9spontot is defini\00E1lt, akkor az <strong>\00C1tfog\00F3 \00E9rt\00E9k megjelen\00EDt\00E9se</strong> bejel\00F6l\00E9se az adatok alj\00E1n megjelen\00EDti az \00E1ltal\00E1nos \00E1tlagot, az \00F6sszeg \00E9rt\00E9k\00E9t, vagy ehhez hasonl\00F3 \00E9rt\00E9ket.</p>'),
'',
unistr('<p><em>Megjegyz\00E9s: Az \00D6sszes\00EDt\00E9s p\00E1rbesz\00E9dpanel el\00E9rhet\0151 a M\0171veletek men\00FCb\0151l vagy az oszlopfejl\00E9cre kattintva \00E9s a sum ( &sum; ) m\0171veletet v\00E1lasztva.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670818449400339)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 az \00F6sszes\00EDt\00E9shez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669316080400338)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ezzel a p\00E1rbesz\00E9dpanellel lehet defini\00E1lni olyan diagramot, amelyik k\00FCl\00F6n adatn\00E9zetk\00E9nt jelenik meg.<br>'),
unistr('V\00E1lassza ki a diagram t\00EDpus\00E1t \00E9s a diagram jellemz\0151it.</p>'),
unistr('<p><strong>Diagramjellemz\0151k</strong></br>'),
unistr('A rendelkez\00E9sre \00E1ll\00F3 diagramjellemz\0151k k\00FCl\00F6nb\00F6z\0151ek a diagram t\00EDpus\00E1t\00F3l f\00FCgg\0151en.</p>'),
'<p>',
'<ul>',
unistr('  <li>Jel\00F6lje ki azt az oszlopot, amelyik a jellemz\0151 \00E9rt\00E9k\00E9t tartalmazza:'),
'    <ul>',
unistr('      <li>Felirat - Az egyes adatpontokhoz tartoz\00F3 sz\00F6veg.</li>'),
unistr('      <li>\00C9rt\00E9k - Az \00E1br\00E1zoland\00F3 adatok.</li>'),
unistr('      <li>Adatsorok - A t\00F6bb adatsoros dinamikus lek\00E9rdez\00E9s defini\00E1l\00E1s\00E1hoz.</li>'),
unistr('      <li>Nyit\00F3 - A r\00E9szv\00E9nyek napi nyit\00F3 \00E1ra (csak t\0151zsdei diagramn\00E1l).</li>'),
unistr('      <li>Z\00E1r\00F3 - A r\00E9szv\00E9nyek napi z\00E1r\00F3 \00E1ra (csak t\0151zsdei diagramn\00E1l).</li>'),
unistr('      <li>Max. - A legmagasabb \00E9rt\00E9k (csak tartom\00E1ny- \00E9s t\0151zsdei diagramn\00E1l).</li>'),
unistr('      <li>Min. - A legalacsonyabb \00E9rt\00E9k (csak tartom\00E1ny- \00E9s t\0151zsdei diagramn\00E1l).</li>'),
unistr('      <li>Volumen - A napi t\0151zsdei forgalom (csak t\0151zsdei diagramn\00E1l).</li>'),
unistr('      <li>C\00E9l\00E9rt\00E9k - A c\00E9l\00E9rt\00E9k (csak t\00F6lcs\00E9rdiagramn\00E1l).</li>'),
unistr('      <li>X - Az X tengely \00E9rt\00E9ke (csak bubor\00E9k- \00E9s pontdiagramn\00E1l).</li>'),
unistr('      <li>Y - Az Y tengely \00E9rt\00E9ke (csak bubor\00E9k- \00E9s pontdiagramn\00E1l).</li>'),
unistr('      <li>Z - A s\00E1v sz\00E9less\00E9ge vagy a bubor\00E9k sugara (csak s\00E1v-, bubor\00E9k- \00E9s tartom\00E1nydiagramn\00E1l).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>T\00E1jol\00E1s - F\00FCgg\0151leges vagy v\00EDzszintes.</li>'),
unistr('  <li>\00D6sszevon\00E1s - Itt v\00E1laszthat\00F3 ki, hogy a diagram t\00E1rs\00EDtott \00E9rt\00E9kei hogyan legyenek \00F6sszevonva.</li>'),
unistr('  <li>Halmoz\00E1s - Adja meg, hogy az adatelemek halmozottak-e.</li>'),
unistr('  <li>Rendez\00E9si szempont - Rendez\00E9s felirat vagy \00E9rt\00E9k(ek) szerint.'),
'    <ul>',
unistr('      <li>Ir\00E1ny - Az adatok rendez\00E9se az \00E9rt\00E9k\00FCk n\00F6vekv\0151 vagy cs\00F6kken\0151 sorrendj\00E9ben.</li>'),
unistr('      <li>Null \00E9rt\00E9kek - Adja meg, hogy a null \00E9rt\00E9kes rekordok hogyan legyenek rendezve a nem null \00E9rt\00E9k\0171 rekordokhoz viszony\00EDtva.</li>'),
'    </ul>',
'  </li>',
'  <li>Tizedeshelyek</li>',
unistr('  <li>Felirattengely c\00EDme</li>'),
unistr('  <li>\00C9rt\00E9ktengely c\00EDme</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671264632400340)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a diagramokhoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668396927400337)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ezzel a p\00E1rbesz\00E9dpanellel v\00E1laszthatja ki a megjelen\00EDtend\0151 oszlopokat \00E9s azok sorrendj\00E9t.</p>'),
'',
unistr('<p>Az oszlopot a kijel\00F6l\00E9se megsz\00FCntet\00E9s\00E9vel rejtheti el.<br>'),
unistr('Az oszlopok sorrendje a Feljebb ( &uarr; ) vagy a Lejjebb ( &darr; ) ny\00EDlra kattint\00E1ssal v\00E1ltoztathat\00F3 meg.<br>'),
unistr('A leny\00EDl\00F3ban v\00E1laszthat\00F3 ki, hogy mi legyen list\00E1zva: az \00D6sszes oszlop, a Megjelen\00EDtett vagy a Nem megjelen\00EDtett oszlopok.</p>'),
'',
unistr('<p>Ha sz\00FCks\00E9ges, az \0171rlap haszn\00E1lat\00E1val megadhatja k\00E9ppontban egy adott oszlop legkisebb sz\00E9less\00E9g\00E9t.</p>'),
'',
unistr('<p><em>Megjegyz\00E9s: A megjelen\00EDtett oszlopokat (az oszlopfejl\00E9c elej\00E9n l\00E9v\0151) fog\00F3pontra kattintva, majd az oszlop balra vagy jobbra h\00FAz\00E1s\00E1val rendezheti \00E1t. Megv\00E1ltoztathat\00F3 a megjelen\00EDtett oszlopok sz\00E9less\00E9ge is, ha a fejl\00E9cen kijel\00F6li az oszlopnevek')
||unistr(' k\00F6z\00F6tti f\00FCgg\0151leges elv\00E1laszt\00F3t, \00E9s azt jobbra vagy balra h\00FAzza.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671162762400339)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 az oszlopokhoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668774177400338)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Haszn\00E1lja ezt a p\00E1rbesz\00E9dpanelt, hogy defini\00E1lja azokat a tov\00E1bbi oszlopokat, amelyek alapj\00E1t a l\00E9tez\0151 oszlopokon v\00E9gzett matematikai vagy f\00FCggv\00E9ny alap\00FA sz\00E1m\00EDt\00E1sok hat\00E1rozz\00E1k meg.</p>'),
'',
unistr('<p><strong>Sz\00E1m\00EDt\00E1sok list\00E1ja</strong><br>'),
unistr('A Sz\00E1m\00EDt\00E1sok list\00E1ja jelen\00EDti meg a defini\00E1lt sz\00E1m\00EDt\00E1sokat. L\00E9tez\0151 sz\00E1m\00EDt\00E1st a kijel\00F6l\00E9se megsz\00FCntet\00E9s\00E9vel rejthet el.<br>'),
unistr('A Hozz\00E1ad\00E1s ( &plus; ) elemre kattintva \00FAj sz\00E1m\00EDt\00E1st hozhat l\00E9tre, a T\00F6rl\00E9s ( &minus; ) elemmel pedig elt\00E1vol\00EDthat egy l\00E9tez\0151 sz\00E1m\00EDt\00E1st.</p>'),
'',
unistr('<p><strong>Sz\00E1m\00EDt\00E1si be\00E1ll\00EDt\00E1sok</strong><br>'),
unistr('Az \0171rlap haszn\00E1lhat\00F3 a sz\00E1m\00EDt\00E1s defini\00E1l\00E1s\00E1hoz.<br>'),
unistr('Adja meg az oszlop olyan r\00E9szleteit, mint a fejl\00E9c \00E9s a felirat, \00E9s v\00E1lassza ki az igaz\00EDt\00E1si be\00E1ll\00EDt\00E1sokat.<br> '),
unistr('A Kifejez\00E9s sz\00F6vegter\00FCleten adja meg a sz\00E1m\00EDt\00E1shoz az oszlop(ok) \00E9s a kapcsol\00F3d\00F3 f\00FCggv\00E9nyek nev\00E9t.<br>'),
unistr('V\00E1lassza ki az \00FAj oszlop r\00E9sz\00E9re a megfelel\0151 adatt\00EDpust \00E9s az esetleg sz\00FCks\00E9ges form\00E1tummaszkot.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670749760400339)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a sz\00E1m\00EDt\00E1shoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669067968400338)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ezzel a p\00E1rbesz\00E9dpanellel lehet ellen\0151rz\0151 t\00F6r\00E9spontot defini\00E1lni egy vagy t\00F6bb oszlopon.</p>'),
'',
unistr('<p><strong>Ellen\0151rz\0151 t\00F6r\00E9spontok list\00E1ja</strong><br>'),
unistr('Az Ellen\0151rz\0151 t\00F6r\00E9spontok list\00E1ja meghat\00E1rozott ellen\0151rz\0151 t\00F6r\00E9spontokat jelen\00EDt meg. L\00E9tez\0151 ellen\0151rz\0151 t\00F6r\00E9spontokat a kijel\00F6l\00E9s\00FCk megsz\00FCntet\00E9s\00E9vel lehet letiltani.<br>'),
unistr('A Hozz\00E1ad\00E1s ( &plus; ) elemre kattintva \00FAj oszlopot vehet be a t\00F6r\00E9spontok k\00F6z\00E9, a T\00F6rl\00E9s ( &minus; ) elemmel pedig elt\00E1vol\00EDthat egy l\00E9tez\0151 oszlopot az ellen\0151rz\0151 t\00F6r\00E9spontok k\00F6z\00FCl.<br>'),
unistr('Az oszlopok egym\00E1shoz viszony\00EDtott sorrendje a Feljebb ( &uarr; ) vagy a Lejjebb ( &darr; ) ny\00EDlra kattint\00E1ssal v\00E1ltoztathat\00F3 meg.</p>'),
'',
unistr('<p><strong>Ellen\0151rz\0151 t\00F6r\00E9spont be\00E1ll\00EDt\00E1sai</strong><br>'),
unistr('Ezzel az \0171rlappal adhat\00F3 meg, hogy melyik oszlop legyen ellen\0151rz\0151 t\00F6r\00E9spont.<br>'),
unistr('Itt jel\00F6lhet\0151 ki az ellen\0151rz\0151 t\00F6r\00E9spont oszlopa, a rendez\00E9s ir\00E1nya \00E9s az, hogy hogyan rendezend\0151k a null \00E9rt\00E9k\0171 oszlopok (az \00E9rt\00E9k n\00E9lk\00FCli oszlopok).</p>'),
'',
unistr('<p><em>Megjegyz\00E9s: Interakt\00EDv r\00E1cs megtekint\00E9sekor az ellen\0151rz\0151 t\00F6r\00E9spont az Oszlopfejl\00E9c men\00FCre kattint\00E1ssal defini\00E1lhat\00F3, \00E9s az ellen\0151rz\0151 t\00F6r\00E9spont ikonj\00E1nak kiv\00E1laszt\00E1s\00E1val.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670414374400339)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 az ellen\0151rz\0151 t\00F6r\00E9sponthoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669281431400338)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ezzel a p\00E1rbesz\00E9dpanellel az \00F6sszes aktu\00E1lis sor let\00F6lthet\0151 egy k\00FCls\0151 f\00E1jlba. A f\00E1jl csak a let\00F6lt\00E9sekor az adatokra vonatkoz\00F3 sz\0171r\0151k \00E9s sorrendek haszn\00E1lat\00E1val megjelen\00EDtett oszlopokat fogja tartalmazni.</p>'),
'',
unistr('<p>Jel\00F6lje ki a f\00E1jl form\00E1tum\00E1t, \00E9s kattintson a Let\00F6lt\00E9s gombra.<br>'),
unistr('Megjegyz\00E9s: A CSV nem fogja tartalmazni az olyan form\00E1z\00E1sokat, mint az \00F6sszes\00EDt\00E9sek \00E9s az ellen\0151rz\0151 t\00F6r\00E9spontok.</p>'),
'',
unistr('<p>A f\00E1jl e-mailk\00E9nt tov\00E1bb\00EDt\00E1s\00E1hoz v\00E1lassza a K\00FCld\00E9s e-mailk\00E9nt lehet\0151s\00E9get, \00E9s adja meg a k\00FCld\00E9si adatokat (C\00EDmzett, T\00E1rgy \00E9s \00DCzenet).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670218371400339)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 let\00F6lt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668435228400337)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ez a p\00E1rbesz\00E9dpanel haszn\00E1lhat\00F3 olyan adatsz\0171r\0151k konfigur\00E1l\00E1s\00E1hoz, amelyek cs\00F6kkentik a visszaadott sorok sz\00E1m\00E1t.</p>'),
'',
unistr('<p><strong>Sz\0171r\0151lista</strong><br>'),
unistr('A Sz\0171r\0151lista sorolja fel a defini\00E1lt sz\0171r\0151ket. Adott l\00E9tez\0151 sz\0171r\0151 letilthat\00F3, ha megsz\00FCnteti a kijel\00F6l\00E9s\00E9t.<br>'),
unistr('A Hozz\00E1ad\00E1s ( &plus; ) elemre kattintva \00FAj sz\0171r\0151t hozhat l\00E9tre, a T\00F6rl\00E9s ( &minus; ) elemmel pedig elt\00E1vol\00EDthat egy megl\00E9v\0151 sz\0171r\0151t.</p>'),
'',
unistr('<p><strong>Sz\0171r\0151be\00E1ll\00EDt\00E1sok</strong><br>'),
unistr('Ezen az \0171rlapon hat\00E1rozhat\00F3k meg a sz\0171r\0151 be\00E1ll\00EDt\00E1sai.<br>'),
unistr('A megfelel\0151 sz\0171r\00E9si t\00EDpus kiv\00E1laszt\00E1sa:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sor - elv\00E9gzi a kifejez\00E9s szerinti sz\0171r\00E9st minden sz\0171rhet\0151 oszlopban.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Oszlop - konkr\00E9t oszlopra sz\0171r a megadott oper\00E1tor \00E9s \00E9rt\00E9k alapj\00E1n.</p>'),
'',
unistr('<p><em>Megjegyz\00E9s: Interakt\00EDv r\00E1cs megtekint\00E9sekor a sorsz\0171r\00E9sek k\00F6zvetlen\00FCl a Keres\00E9s mez\0151be \00EDr\00E1ssal defini\00E1lhat\00F3k. Kattintson az Oszlopok kijel\00F6l\00E9se keres\00E9shez lehet\0151s\00E9gre, hogy a keres\00E9st korl\00E1tozza egy konkr\00E9t oszlopra. M\00E1sik m\00F3d lehet, hogy megn')
||unistr('yitja az Oszlopfejl\00E9c men\00FCt, \00E9s kiv\00E1laszt egy \00E9rt\00E9ket, hogy az legyen az oszlop sz\0171r\0151je.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671089542400339)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a sz\0171r\0151kh\00F6z')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668877632400338)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ezzel a p\00E1rbesz\00E9dpanellel \00FAgy tekintheti meg az adatokat, ahogy azok egy kor\00E1bbi id\0151pontban l\00E9teztek.</p>'),
unistr('<p>A visszatekint\0151 (flashback) lek\00E9rdez\00E9s v\00E9grehajt\00E1s\00E1hoz adja meg az elm\00FAlt percek sz\00E1m\00E1t.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670671016400339)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a visszatekint\00E9shez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671331227400340)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a csoportos\00EDt\00E1shoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668955249400338)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ez a p\00E1rbesz\00E9dpanel haszn\00E1lhat\00F3 a megadott felt\00E9telen alapul\00F3 sorok \00E9s oszlopok kiemel\00E9s\00E9re.</p>'),
'',
unistr('<p><strong>Kiemel\00E9si lista</strong><br>'),
unistr('A Kiemel\00E9si lista jelen\00EDti meg a megadott kiemel\00E9seket. Megl\00E9v\0151 kiemel\00E9st a kijel\00F6l\00E9se megsz\00FCntet\00E9s\00E9vel rejthet el.<br>'),
unistr('\00DAj kiemel\00E9s l\00E9trehoz\00E1s\00E1hoz kattintson a Hozz\00E1ad\00E1s ( &plus; ), a megl\00E9v\0151 t\00F6rl\00E9s\00E9hez pedig a T\00F6rl\00E9s ( &minus; ) gombra.</p>'),
'',
unistr('<p><strong>Kiemel\00E9si be\00E1ll\00EDt\00E1sok</strong><br>'),
unistr('A kiemel\00E9si tulajdons\00E1gok meghat\00E1roz\00E1s\00E1hoz ez az \0171rlap haszn\00E1lhat\00F3.<br>'),
unistr('Adja meg a nevet, jel\00F6lje ki a Sort vagy Oszlopot, \00E9s v\00E1lassza ki a h\00E1tt\00E9r \00E9s a sz\00F6veg HTML sz\00EDnk\00F3dj\00E1t.<br>'),
unistr('A <strong>Felt\00E9tel t\00EDpusa</strong> kiv\00E1laszt\00E1s\00E1val adhat\00F3k meg a kiemelend\0151 konkr\00E9t adatok:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sor - a kifejez\00E9st emeli ki az oszlopban.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Oszlop - konkr\00E9t oszlopban a megadott oper\00E1tor \00E9s \00E9rt\00E9k alapj\00E1n v\00E9gzi el a kiemel\00E9st.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670576917400339)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a kiemel\00E9shez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669170372400338)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ez a p\00E1rbesz\00E9dpanel haszn\00E1lhat\00F3 a r\00E1cs aktu\00E1lis elrendez\00E9s\00E9nek \00E9s konfigur\00E1l\00E1s\00E1nak ment\00E9s\00E9hez.<br>'),
unistr('Az alkalmaz\00E1sfejleszt\0151k t\00F6bb k\00FCl\00F6nb\00F6z\0151 kimutat\00E1s-elrendez\00E9st is kialak\00EDthatnak. Ahol megengedett, \00D6n vagy m\00E1s v\00E9gfelhaszn\00E1l\00F3k menthetnek egy kimutat\00E1st Nyilv\00E1nosk\00E9nt is, ami azt jelenti, hogy a kimutat\00E1s a r\00E1cs t\00F6bbi felhaszn\00E1l\00F3ja sz\00E1m\00E1ra is el\00E9rhet\0151')
||unistr('. A kimutat\00E1s menthet\0151 olyan priv\00E1t, bels\0151 haszn\00E1lat\00FA kimutat\00E1sk\00E9nt is, amelyiket csak \00D6n l\00E1t.</p>'),
unistr('<p>V\00E1lasszon az el\00E9rhet\0151 t\00EDpusok k\00F6z\00FCl, \00E9s adja meg a menteni k\00EDv\00E1nt kimutat\00E1s nev\00E9t.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670307623400339)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a kimutat\00E1shoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668552826400338)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ez a p\00E1rbesz\00E9dpanel haszn\00E1lhat\00F3 a megjelen\00EDt\00E9si sorrend be\00E1ll\00EDt\00E1s\00E1hoz.</p>'),
'',
unistr('<p><strong>Rendez\00E9si lista</strong><br>'),
unistr('A rendez\00E9si lista jelen\00EDti meg a konfigur\00E1lt rendez\00E9si szab\00E1lyokat.<br>'),
unistr('Rendez\00E9si oszlop list\00E1ba helyez\00E9s\00E9hez kattintson a Hozz\00E1ad\00E1s ( &plus; ), a list\00E1b\00F3l t\00F6rl\00E9shez pedig a T\00F6rl\00E9s ( &minus; ) gombra.<br>'),
unistr('Kattintson a Feljebb ( &uarr; ) vagy a Lejjebb ( &darr; ) ny\00EDlra hogy a kijel\00F6lt rendez\00E9si oszlopot a list\00E1ban a t\00F6bbihez k\00E9pest feljebb vagy lejjebb helyezze el.</p>'),
'',
unistr('<p><strong>Rendez\00E9si be\00E1ll\00EDt\00E1sok</strong><br>'),
unistr('Itt jel\00F6lhet\0151 ki a rendez\00E9s oszlopa, ir\00E1nya \00E9s az, hogy hogyan rendezend\0151k a null \00E9rt\00E9k\0171 oszlopok (az \00E9rt\00E9k n\00E9lk\00FCli oszlopok).</p>'),
'',
unistr('<p><em>Megjegyz\00E9s: Az adatok a nem megjelen\00EDtett oszlopok szerint is sorba rendezhet\0151k; azonban nem minden oszlop rendezhet\0151 sorba.</em><br>'),
unistr('<em>A megjelen\00EDtett oszlopok az oszlopfejl\00E9c v\00E9g\00E9n l\00E9v\0151 felfel\00E9 ny\00EDllal (n\00F6vekv\0151) vagy a lefel\00E9 ny\00EDllal (cs\00F6kken\0151) sorrendbe rakhat\00F3k. Amikor egy l\00E9tez\0151 rendez\00E9shez k\00F6vetkez\0151 oszlopot ad hozz\00E1, tartsa lenyomva a Shift billenty\0171t \00E9s kattintson a felfe')
||unistr('l\00E9 vagy a lefel\00E9 mutat\00F3 ny\00EDlra.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670952099400339)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 a sorba rendez\00E9shez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112670156348400339)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 az el\0151fizet\00E9shez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622492698400304)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'hu'
,p_message_text=>unistr('Elrejt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589286175400280)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kiemel\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657229401400329)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Max.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658047298400330)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00EDzszintes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615474276400299)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00F3ra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620404275400303)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'hu'
,p_message_text=>'Ikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588137486400279)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Ikon n\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613609345400298)
,p_name=>'APEX.IG.IN'
,p_message_language=>'hu'
,p_message_text=>'ebben'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622034273400304)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'hu'
,p_message_text=>unistr('Inakt\00EDv be\00E1ll\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622144752400304)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('Inakt\00EDv be\00E1ll\00EDt\00E1sok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629714987400309)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Az Interakt\00EDv r\00E1cs k\00E9relm\00E9nek feldolgoz\00E1sakor bels\0151 hiba t\00F6rt\00E9nt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525578247400234)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" sz\0171r\0151t\00EDpus a(z) "%1" oszlophoz nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669901759400339)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen d\00E1tumform\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644132915400320)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Az Interakt\00EDv r\00E1cs nem t\00E1mogatja a(z) %0 oszlopra vonatkoz\00F3 sz\0171r\0151 defini\00E1l\00E1s\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644068405400320)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 nem megfelel\0151 sz\0171r\0151t\00EDpus az Interakt\00EDv r\00E1cs sz\0171r\0151j\00E9nek defini\00E1l\00E1s\00E1hoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530652762400237)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen sz\00E1mform\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672668503400341)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen be\00E1ll\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672760398400341)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen be\00E1ll\00EDt\00E1sok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663702140400334)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('A Rendez\00E9si szempont be\00E1ll\00EDt\00E1sa %0, de a(z) %0 r\00E9sz\00E9re nem lett kijel\00F6lve oszlop.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661057406400332)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen \00E9rt\00E9k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656182701400328)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'hu'
,p_message_text=>'Nem jelenik meg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614458103400298)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('az utols\00F3ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614621605400298)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('a k\00F6vetkez\0151ben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613537100400298)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('nem \00FCres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613463216400298)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00FCres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664553693400335)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'hu'
,p_message_text=>'Felirat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656510632400329)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Felirat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660487342400332)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('Utols\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603788090400291)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603985742400291)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 \00F3ra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604449019400291)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 perc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603431028400290)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 h\00F3nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603526180400291)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 h\00E9t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603640495400291)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603856799400291)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 \00F3ra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604534427400291)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 perc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604301823400291)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 h\00F3nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604291862400291)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 h\00E9t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603236948400290)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 \00E9v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603304077400290)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 \00E9v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664778562400335)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'hu'
,p_message_text=>unistr('Cella igaz\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664857487400335)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoport haszn\00E1lata ehhez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614040609400298)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'hu'
,p_message_text=>'kisebb, mint'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614157203400298)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'hu'
,p_message_text=>unistr('kisebb vagy egyenl\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658694989400330)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'hu'
,p_message_text=>'Vonaldiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658741796400330)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'hu'
,p_message_text=>unistr('Grafikon \00E9s ter\00FCletdiagram')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665160106400335)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'hu'
,p_message_text=>unistr('Lista\00F6ssz.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657369826400329)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Min.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667794592400337)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'hu'
,p_message_text=>unistr('A c\00EDmeket pontosvessz\0151vel v\00E1lassza el')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615256515400299)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('egyezik a regul\00E1ris kifejez\00E9ssel')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639611583400316)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'hu'
,p_message_text=>'Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675241337400343)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ltal\00E1nos maximum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639845322400317)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6z\00E9p\00E9rt\00E9k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675318375400343)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ltal\00E1nos k\00F6z\00E9p\00E9rt\00E9k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639538163400316)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'hu'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615393518400299)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'hu'
,p_message_text=>'perc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640380944400317)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('Perccel ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675100863400342)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ltal\00E1nos minimum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615728053400299)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('h\00F3nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622353398400304)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adat t\00F6bb, mint %0 sort tartalmaz, ezzel t\00FAl l\00E9pte a megengedett maximumot. Haszn\00E1ljon tov\00E1bbi sz\0171r\0151ket, hogy megtekinthesse az eredm\00E9nyeket.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649053318400323)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('A r\00E9gi\00F3 statikus azonos\00EDt\00F3j\00E1t meg kell adni, mivel az oldal t\00F6bb interakt\00EDv r\00E1csot tartalmaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618401943400301)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00E9v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618681412400301)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Megnevezett kimutat\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602645145400290)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602447699400290)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 \00F3ra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604671907400291)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 perc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602900445400290)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 h\00F3nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602879938400290)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 h\00E9t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602713945400290)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112602577324400290)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 \00F3ra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604789772400291)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 perc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604076865400291)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 h\00F3nap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604188858400291)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 h\00E9t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603174009400290)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 \00E9v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112603017442400290)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 \00E9v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614395008400298)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'hu'
,p_message_text=>unistr('nem ezek k\00F6z\00F6tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613388913400298)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'hu'
,p_message_text=>unistr('nem egyenl\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679500895400346)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 azonos\00EDt\00F3j\00FA r\00E9gi\00F3 nem interakt\00EDv r\00E1csos r\00E9gi\00F3, vagy nem l\00E9tezik a(z) %1 alkalmaz\00E1sban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613778711400298)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'hu'
,p_message_text=>'nem ebben'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614528137400298)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('nem az utols\00F3ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112614769162400299)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('nem a k\00F6vetkez\0151ben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622210701400304)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 adat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660235614400331)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'hu'
,p_message_text=>unistr('Null \00E9rt\00E9k\0171ek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665308153400335)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'hu'
,p_message_text=>'Numerikus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660506075400332)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'hu'
,p_message_text=>'Ki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660643662400332)
,p_name=>'APEX.IG.ON'
,p_message_language=>'hu'
,p_message_text=>'Be'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612561475400297)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('1 perccel ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668268067400337)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00EDnv\00E1laszt\00F3 megnyit\00E1sa: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657044720400329)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Megnyit\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619565436400302)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'hu'
,p_message_text=>unistr('Oper\00E1tor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656455916400329)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00E1jol\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658835889400330)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6rdiagram')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112620884830400303)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'hu'
,p_message_text=>unistr('Elforgat\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112588470252400279)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Megtekint\00E9s kimutat\00E1sk\00E9nt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112668191444400337)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00E9rt\00E9keket egym\00E1st\00F3l "%0" karakterrel v\00E1lassza el.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112658954452400330)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'hu'
,p_message_text=>unistr('Pol\00E1r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664246582400334)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6zepe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664311284400334)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E9ge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112664190965400334)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'hu'
,p_message_text=>'Eleje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618773320400301)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151dleges')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619055244400302)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151dleges alap\00E9rtelmez\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635541721400313)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151dleges kimutat\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517754603400228)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'hu'
,p_message_text=>unistr('El\00E9rhet\0151s\00E9gi c\00EDmk\00E9kkel egy\00FCtt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516417968400227)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'hu'
,p_message_text=>unistr('Fekv\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516540616400227)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ll\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516387983400227)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldal t\00E1jol\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516261611400227)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'hu'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516164838400227)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'hu'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517814668400228)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'hu'
,p_message_text=>unistr('Egy\00E9ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515929889400226)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'hu'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515821304400226)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'hu'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516007321400226)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'hu'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515777917400226)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldalm\00E9ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505946137400219)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'hu'
,p_message_text=>unistr('Rich Text lefejt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659065487400331)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'hu'
,p_message_text=>unistr('Sug\00E1r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659132732400331)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tartom\00E1ny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669498517400338)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'hu'
,p_message_text=>unistr('Friss\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623083748400304)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor friss\00EDt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621882892400304)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorok friss\00EDt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627001499400307)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 alkalmaz\00E1s, %1 lapj\00E1n \00E9s %2 r\00E9gi\00F3j\00E1ban nem l\00E9tezik az interakt\00EDv r\00E1csos r\00E9gi\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589902451400280)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 elt\00E1vol\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618191395400301)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678760662400345)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s t\00F6r\00F6lve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678471734400345)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alternat\00EDv kimutat\00E1s mentve lett az \00F6sszes felhaszn\00E1l\00F3 sz\00E1m\00E1ra')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678345333400345)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alap\00E9rtelmezett kimutat\00E1s mentve lett az \00F6sszes felhaszn\00E1l\00F3 sz\00E1m\00E1ra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678648273400345)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Nyilv\00E1nos kimutat\00E1s mentve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678543015400345)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'hu'
,p_message_text=>unistr('A nyilv\00E1nos kimutat\00E1s mentve lett az \00F6sszes felhaszn\00E1l\00F3 sz\00E1m\00E1ra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112627174973400307)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 nev\0171 mentett interakt\00EDv r\00E1cs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612484607400297)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 perccel kor\00E1bbi kimutat\00E1sadatok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612351800400297)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('1 perccel kor\00E1bbi kimutat\00E1sadatok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552056063400253)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik interakt\00EDv r\00E1csos kimutat\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671693373400340)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s - Szerkeszt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626986467400307)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 azonos\00EDt\00F3j\00FA mentett interakt\00EDv r\00E1cs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112671584768400340)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s - Ment\00E9s m\00E1sk\00E9nt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590039089400280)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s be\00E1ll\00EDt\00E1sai')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679692123400346)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 statikus azonos\00EDt\00F3j\00FA mentett interakt\00EDv r\00E1cs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674522432400342)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1sn\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589160046400280)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Vissza\00E1ll\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623170199400305)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00F3dos\00EDt\00E1sok vissza\00E1ll\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621907130400304)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorok vissza\00E1ll\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619164536400302)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'hu'
,p_message_text=>'Sor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618092856400301)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'hu'
,p_message_text=>'Sor/oldal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679214458400345)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorm\0171veletek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680436499400346)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'hu'
,p_message_text=>unistr('M\0171veletek a(z) %0. sorhoz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112589420535400280)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ment\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632193524400311)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'hu'
,p_message_text=>'mentve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587695339400279)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Mentett kimutat\00E1sok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587769453400279)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562294755400260)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1r l\00E9tezik %0 nev\0171 mentett kimutat\00E1s. Adjon meg egy \00FAj nevet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587850379400279)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Szem\00E9lyes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587925359400279)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'hu'
,p_message_text=>unistr('Nyilv\00E1nos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674296694400342)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ment\00E9s m\00E1sk\00E9nt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621255953400303)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1si be\00E1ll\00EDt\00E1sok ment\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659227824400331)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'hu'
,p_message_text=>'Pontdiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587504026400279)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666549027400336)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s: Minden sz\00F6vegoszlop')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587468325400279)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665725110400335)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Teljes sz\00F6veges keres\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612271849400297)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'hu'
,p_message_text=>unistr('''%0'' keres\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655835211400328)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'hu'
,p_message_text=>unistr('- Kijel\00F6l\00E9s -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596040762400285)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Kijel\00F6l\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648702640400323)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Jel\00F6lj\00F6n ki 1 sort a f\0151 r\00E9gi\00F3ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587357152400278)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Jel\00F6lj\00F6n ki oszlopokat a keres\00E9shez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678945717400345)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kijel\00F6l\00E9si m\0171veletek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596237983400285)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'hu'
,p_message_text=>unistr('Cellakijel\00F6l\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596166768400285)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorkijel\00F6l\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667179985400336)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCld\00E9s e-mailk\00E9nt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659601940400331)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Adatsor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585307850400277)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637964765400315)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1tfog\00F3 \00E9rt\00E9k megjelen\00EDt\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622745685400304)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Egysoros megtekint\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621062554400303)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659767176400331)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9si szempont')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679382979400346)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszloponk\00E9nt csak egy sorrend defini\00E1lhat\00F3.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679117844400345)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00F3dos\00EDt\00E1s men\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112660711537400332)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'hu'
,p_message_text=>'Verem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615088996400299)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'hu'
,p_message_text=>unistr('ezzel kezd\0151dik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659303923400331)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'hu'
,p_message_text=>unistr('T\0151zsdei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580308676400273)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlopsz\00E9less\00E9g ny\00FAjt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112621481137400303)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151fizet\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112639447364400316)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszesen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680679148400346)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'hu'
,p_message_text=>unistr('Interakt\00EDv r\00E1cs. Kimutat\00E1s: %0, N\00E9zet: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112674603694400342)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ltal\00E1nos \00F6sszesen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657595043400329)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00E9l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663906518400334)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00F6vegsz\00EDn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590127400400281)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637810732400315)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'hu'
,p_message_text=>unistr('Elemle\00EDr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112618233151400301)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00EDpus')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112622638287400304)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'hu'
,p_message_text=>unistr('Felold\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619771127400302)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Egys\00E9g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666997097400336)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'hu'
,p_message_text=>unistr('Vannak nem mentett v\00E1ltoztat\00E1sok. Folytatja?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112619690840400302)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656600709400329)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661549947400332)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9ket k\00F6telez\0151 megadni.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646414444400321)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9k (az id\0151z\00F3na nem v\00E1ltoztathat\00F3 meg)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665464446400335)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00F6veg')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657974172400330)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCgg\0151leges')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617700463400301)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Megtekint\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655915032400328)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDtve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112657469340400329)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6tet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615697009400299)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('h\00E9t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656061164400328)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'hu'
,p_message_text=>unistr('Minim\00E1lis oszlopsz\00E9less\00E9g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606835847400293)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 %1 \00E9s %2 k\00F6z\00F6tti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606568988400293)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 ezt tartalmazza: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606657397400293)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 nem tartalmazza ezt: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584705015400277)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem ezzel kezd\0151dik: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605363224400292)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 egyenl\0151 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605526188400292)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 nagyobb, mint %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605693266400292)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nagyobb vagy egyenl\0151 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606300941400293)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 ebben: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607570680400293)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt %1 napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607325008400293)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 elm\00FAlt %1 \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607193435400293)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt %1 percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607928856400294)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt %1 h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607780712400294)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt %1 h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608127426400294)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt %1 \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607481101400293)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607287557400293)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 elm\00FAlt \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607066705400293)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607897277400294)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112607638271400293)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608063566400294)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 az elm\00FAlt \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609935298400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 %1 napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609719036400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 %1 \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609559141400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 %1 percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610382436400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 %1 h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610194530400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 %1 h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610532933400296)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 %1 \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609803780400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609697875400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609462938400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610254113400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610072112400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610460900400295)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606004589400292)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem \00FCres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605942617400292)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00FCres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605753899400292)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 kisebb, mint %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605838876400292)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 kisebb vagy egyenl\0151 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606117215400292)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 olyan, mint %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606713629400293)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 egyezik a regul\00E1ris kifejez\00E9ssel: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612649644400297)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 perccel ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606923279400293)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem %1 \00E9s %2 k\00F6z\00F6tti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605460306400292)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem egyenl\0151 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606438037400293)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 nem ebben: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608784520400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt %1 napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608578181400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt %1 \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608336927400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt %1 percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609160467400295)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt %1 h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608994515400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt %1 h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609334848400295)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt %1 \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608699320400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608462390400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608229725400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609049829400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112608850208400294)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112609244298400295)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem az elm\00FAlt \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611199757400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 %1 napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610953534400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 %1 \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610733149400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 %1 percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611542058400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 %1 h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611397385400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 %1 h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611798228400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 %1 \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611023179400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 napon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610817955400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 \00F3r\00E1ban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112610682995400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151 percben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611464265400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 h\00F3napban')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611246141400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 h\00E9ten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611668384400296)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151 \00E9vben')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112606295027400292)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'hu'
,p_message_text=>'%0 nem olyan, mint %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613111564400297)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 ezzel kezd\0151dik: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656722631400329)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615860365400299)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9v')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656842921400329)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Y'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656926479400329)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112665995424400336)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'hu'
,p_message_text=>unistr('2016. janu\00E1r 12., h\00E9tf\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666095514400336)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'hu'
,p_message_text=>unistr('Janu\00E1r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666147940400336)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'hu'
,p_message_text=>unistr('16 \00F3r\00E1val ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112666239780400336)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'hu'
,p_message_text=>unistr('16 \00F3r\00E1n bel\00FCl')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521202608400230)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen f\00E1jlt\00EDpus. A t\00E1mogatott f\00E1jlt\00EDpusok: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648115556400323)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tall\00F3z\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647871613400322)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00E1jl kiv\00E1laszt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647922364400322)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00E1jlok kiv\00E1laszt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521068907400230)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1thelyez\00E9s h\00FAz\00E1ssal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521420039400231)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00E1jlok \00E1th\00FAz\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522699288400231)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lassza ki a f\00E1jlt, vagy h\00FAzza \00E1t ide.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522752669400232)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lassza ki a f\00E1jlokat, vagy h\00FAzza \00E1t ide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522894711400232)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lassza ki a f\00E1jlt, vagy h\00FAzza \00E1t ide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522965699400232)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lassza ki a f\00E1jlokat, vagy h\00FAzza \00E1t ide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521386882400231)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 f\00E1jl')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521106975400230)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00FAl nagy a f\00E1jl. A megengedett maxim\00E1lis m\00E9ret %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508949371400221)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDm sz\00FCks\00E9ges.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507821682400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'hu'
,p_message_text=>unistr('Telep\00FCl\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508258965400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'hu'
,p_message_text=>unistr('Orsz\00E1gk\00F3d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507965893400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'hu'
,p_message_text=>unistr('H\00E1zsz\00E1m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508837047400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00F6ldrajzi sz\00E9less\00E9g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508702204400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00F6ldrajzi hossz\00FAs\00E1g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508638929400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDt\00E9s t\00E9rk\00E9pen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508339870400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'hu'
,p_message_text=>unistr('Pontsz\00E1m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508078718400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ir\00E1ny\00EDt\00F3sz\00E1m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508181383400221)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1llapot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507716751400220)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'hu'
,p_message_text=>'Utca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507633636400220)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Geok\00F3dol\00E1si eredm\00E9nyek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520241977400230)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00F6ldrajzi k\00F3d megadva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520327096400230)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs megadva f\00F6ldrajzi k\00F3d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508543884400221)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00E9rk\00E9p')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112508472059400221)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 c\00EDm.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509078769400221)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 megad\00E1sa k\00F6telez\0151.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678859248400345)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3sz\00F6veg: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572295760400268)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'hu'
,p_message_text=>unistr('Bejel\00F6lve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572395922400268)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs bejel\00F6lve')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518263168400228)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# nincs a(z) %0 \00E9s %1 \00E9rv\00E9nyes tartom\00E1ny\00E1ban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518308504400228)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# nem a(z) %0 t\00F6bbsz\00F6r\00F6se.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517906224400228)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# csak a(z) %0 \00E9s %1 \00E9rt\00E9keinek megfelel\0151 lehet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518105601400228)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'hu'
,p_message_text=>'Nem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596451794400285)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'hu'
,p_message_text=>'Ki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596557176400285)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'hu'
,p_message_text=>'Be'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518065955400228)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'hu'
,p_message_text=>'Igen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501411116400216)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'hu'
,p_message_text=>unistr('Bejegyz\00E9s hozz\00E1ad\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630629993400310)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1ad\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630753632400310)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Elt\00E1vol\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501552390400216)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'hu'
,p_message_text=>unistr('Kiv\00E1lasztott bejegyz\00E9sek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634428809400313)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'hu'
,p_message_text=>unistr('Speci\00E1lis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634761304400313)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E9gse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634511572400313)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ltal\00E1nos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634890063400313)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9l\0151 sablon be\00E1ll\00EDt\00E1sai')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635454196400313)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem \00E9rhet\0151k el a sablonm\0171veletek, mert ez az \00F6sszetev\0151 nincs megjelen\00EDtve az oldalon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634362987400313)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 sablonbe\00E1ll\00EDt\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634631885400313)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ment\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509902632400222)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6r t\00F6rl\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511799802400223)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'hu'
,p_message_text=>unistr('Az Egy\00E9ni st\00EDlusok nem \00E9rv\00E9nyes JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510296005400222)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00E1vols\00E1g eszk\00F6z')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510035849400222)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6r rajzol\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502659919400217)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'hu'
,p_message_text=>unistr('Az ir\00E1ny\00EDtott keres\00E9shez sz\00FCks\00E9ges, hogy az adatforr\00E1s r\00E9gi\00F3 szint\0171 legyen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505205939400219)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'hu'
,p_message_text=>'Jelenlegi hely'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506384212400219)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelenek a kiindul\00E1si poz\00EDci\00F3 koordin\00E1t\00E1i.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503739936400218)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('A kezd\0151 poz\00EDci\00F3 csak pontgeometriai lehet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506145086400219)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'hu'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504775181400218)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9teg')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638067540400315)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9teg: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509352888400222)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'hu'
,p_message_text=>unistr('Lek\00E9pez\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502549771400217)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DCzenetek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506252369400219)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'hu'
,p_message_text=>unistr('m\00E9rf\00F6ld')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637050674400315)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adat t\00F6bb, mint %0 sort tartalmaz, ezzel t\00FAll\00E9pte a megengedett maximumot. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504587940400218)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'hu'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Felt\00E9telek</a> &nbsp;&nbsp; T\00E9rk\00E9padatok &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503474968400217)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ebben az adatb\00E1zisban az SDO_GEOMETRY adatt\00EDpus nem \00E9rhet\0151 el.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504608579400218)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'hu'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap k\00F6zrem\0171k\00F6d\0151k </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504848704400218)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'hu'
,p_message_text=>'Pontok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638161767400315)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'hu'
,p_message_text=>'%0 pont'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510185413400222)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00E9gyzetes nagy\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509846750400222)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Elt\00E1vol\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505119184400219)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9szak szerinti t\00E1jol\00E1s vissza\00E1ll\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585459968400277)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lt\00E1s 2-dimenzi\00F3s m\00F3dra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585580500400277)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lt\00E1s 3-dimenzi\00F3s m\00F3dra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509733398400222)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'hu'
,p_message_text=>unistr('Szerz\0151i jogi nyilatkozat v\00E1lt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510339064400222)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes t\00E1vols\00E1g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504999647400218)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'hu'
,p_message_text=>unistr('Nagy\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505034527400219)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kicsiny\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632534308400311)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00E9lk\00F6v\00E9r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633496463400312)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00E9p')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633024242400312)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'hu'
,p_message_text=>unistr('Soron bel\00FCli k\00F3d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646693275400321)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00E9p besz\00FAr\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646779438400322)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'hu'
,p_message_text=>unistr('Hivatkoz\00E1s besz\00FAr\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632648286400311)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'hu'
,p_message_text=>unistr('D\0151lt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647306615400322)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'hu'
,p_message_text=>unistr('Hivatkoz\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633320371400312)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'hu'
,p_message_text=>'Lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633264161400312)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'hu'
,p_message_text=>'Rendezett lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632700424400311)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151n\00E9zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632867711400311)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs elem az el\0151n\00E9zethez')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632902765400312)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1th\00FAz\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633172465400312)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9s n\00E9lk\00FCli lista')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612028387400297)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('aktu\00E1lis')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112669596599400338)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'hu'
,p_message_text=>'Egyebek...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112611943704400297)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'hu'
,p_message_text=>unistr('Bet\00F6lt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643742926400319)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rtes\00EDt\0151 \00FCzenet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617038772400300)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %#LABEL# \00E9rt\00E9ke csak %0 vagy kisebb lehet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617132239400300)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# \00E9rt\00E9ke csak \00E9rv\00E9nyes sz\00E1m lehet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617292040400300)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) #LABEL# nem felel meg a(z) %0 sz\00E1mform\00E1tumnak (P\00E9lda: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616901539400300)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %#LABEL# \00E9rt\00E9ke csak %0 vagy nagyobb lehet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616855740400300)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %#LABEL# \00E9rt\00E9ke csak %0 \00E9s %1 k\00F6z\00F6tti sz\00E1m lehet.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612174429400297)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'hu'
,p_message_text=>unistr('\00FAj ablakban ny\00EDlik meg')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565377830400263)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez az oldal m\00E1r be lett k\00FCldve, \00E9s nem k\00FCldhet\0151 be \00FAjra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547961947400250)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 a(z) "%0" alkalmaz\00E1s "%1". oldala.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581745447400274)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('#LABEL# \00E9rt\00E9ket kell tartalmazzon.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525091936400233)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631019687400310)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'hu'
,p_message_text=>unistr('Bez\00E1r\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630901618400310)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631202945400310)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631105436400310)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517169763400227)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9si kifejez\00E9sk\00E9nt legal\00E1bb %0 karaktert kell be\00EDrni.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586612122400278)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151ugr\00F3 \00E9rt\00E9klista: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517297223400227)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'hu'
,p_message_text=>unistr('Adjon meg keres\0151kifejez\00E9st.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517010091400227)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs tal\00E1lat.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516959709400227)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 elt\00E1vol\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604891372400291)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\0151kifejez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630855313400310)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641590364400318)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'hu'
,p_message_text=>unistr('Feldolgoz\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515538221400226)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Felv\00E9tel a Kezd\0151k\00E9perny\0151re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511591370400223)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\00DAgy n\00E9z ki, hogy az \00D6n eszk\00F6ze vagy b\00F6ng\00E9sz\0151je most \00E9ppen nem t\00E1mogatja a Progressz\00EDv webes alkalmaz\00E1sok telep\00EDt\00E9s\00E9t.</p>'),
unistr('    <p class="a-pwaDialog-intro">Ha ez az alkalmaz\00E1s m\00E1r telep\00EDtve lett az eszk\00F6z\00E9re, nyissa meg a kezd\0151k\00E9perny\0151j\00E9r\0151l.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511125319400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. Vegye fel a kezd\0151k\00E9perny\0151j\00E9re, hogy a teljes k\00E9perny\0151n haszn\00E1lhassa.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Koppintson a lenti v\00E1laszt\00E9kban a <strong>Men\00FC</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Koppintson a <strong>Telep\00EDt\00E9s</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. A meger\0151s\00EDt\00E9shez koppintson a <strong>Hozz\00E1ad\00E1s</strong> gombra</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511226666400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. A legjobb felhaszn\00E1l\00F3i \00E9lm\00E9ny a Chrome vagy az Edge b\00F6ng\00E9sz\0151ben \00E9rhet\0151 el.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Koppintson a c\00EDms\00E1v melletti <strong>Men\00FC</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Koppintson a <strong>Telep\00EDt\00E9s</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510834876400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. A legjobb felhaszn\00E1l\00F3i \00E9lm\00E9ny a Safari b\00F6ng\00E9sz\0151ben \00E9rhet\0151 el.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Koppintson a lenti v\00E1laszt\00E9kban a <strong>Megoszt\00E1s</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Koppintson a <strong>Megnyit\00E1s Safariban</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510540783400222)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. A legjobb felhaszn\00E1l\00F3i \00E9lm\00E9ny \00E9rdek\00E9ben vegye fel a kezd\0151k\00E9perny\0151j\00E9re.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Koppintson a c\00EDms\00E1v melletti <strong>Megoszt\00E1s</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Koppintson a <strong>Hozz\00E1ad\00E1s a kezd\0151k\00E9perny\0151h\00F6z</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. A meger\0151s\00EDt\00E9shez koppintson a <strong style="color:#007AE1;">Hozz\00E1ad\00E1s</strong> gombra</p>'),
'    </div>',
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510477710400222)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. A legjobb felhaszn\00E1l\00F3i \00E9lm\00E9ny \00E9rdek\00E9ben vegye fel a kezd\0151k\00E9perny\0151j\00E9re.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Koppintson a lenti v\00E1laszt\00E9kban a <strong>Megoszt\00E1s</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. G\00F6rgessen lefel\00E9, \00E9s koppintson a <strong>Hozz\00E1ad\00E1s a kezd\0151k\00E9perny\0151h\00F6z</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. A meger\0151s\00EDt\00E9shez koppintson a <strong style="color:#007AE1;">Hozz\00E1ad\00E1s</strong> gombra</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505449144400219)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. A legjobb felhaszn\00E1l\00F3i \00E9lm\00E9ny \00E9rdek\00E9ben vegye fel a kezd\0151k\00E9perny\0151j\00E9re.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Koppintson a c\00EDms\00E1v melletti <strong>Egy\00E9b</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Koppintson a <strong>Hozz\00E1ad\00E1s a kezd\0151k\00E9perny\0151h\00F6z</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. A meger\0151s\00EDt\00E9shez koppintson a <strong style="color:#007AE1;">Hozz\00E1ad\00E1s</strong> gombra</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510795592400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. A legjobb felhaszn\00E1l\00F3i \00E9lm\00E9ny \00E9rdek\00E9ben vegye fel a kezd\0151k\00E9perny\0151j\00E9re.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Koppintson a c\00EDms\00E1v melletti <strong>Megoszt\00E1s</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Koppintson a <strong>Megnyit\00E1s Safariban</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510637306400222)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes alkalmaz\00E1sk\00E9nt m\0171k\00F6dni. A legjobb felhaszn\00E1l\00F3i \00E9lm\00E9ny \00E9rdek\00E9ben vegye fel a kezd\0151k\00E9perny\0151j\00E9re.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Koppintson a lenti v\00E1laszt\00E9kban a <strong>Megoszt\00E1s</strong> ikonra</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Koppintson a <strong>Megnyit\00E1s Safariban</strong> lehet\0151s\00E9gre</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511406678400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes olyan alkalmaz\00E1sk\00E9nt m\0171k\00F6dni, amelyik a legjobb \00E9lm\00E9nyt a Chrome b\00F6ng\00E9sz\0151ben ny\00FAjtja.</p>'),
unistr('    <p class="a-pwaDialog-intro">A Firefox jelenleg nem t\00E1mogatja a webes alkalmaz\00E1sok telep\00EDt\00E9s\00E9t.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112510987394400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes olyan alkalmaz\00E1sk\00E9nt m\0171k\00F6dni, amelyik a legjobb \00E9lm\00E9nyt a Chrome vagy az Edge b\00F6ng\00E9sz\0151ben ny\00FAjtja.</p>'),
unistr('    <p class="a-pwaDialog-intro">A Firefox jelenleg nem t\00E1mogatja a webes alkalmaz\00E1sok macOS rendszerre telep\00EDt\00E9s\00E9t.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511061623400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes olyan alkalmaz\00E1sk\00E9nt m\0171k\00F6dni, amelyik a legjobb \00E9lm\00E9nyt a Chrome vagy az Edge b\00F6ng\00E9sz\0151ben ny\00FAjtja.</p>'),
unistr('    <p class="a-pwaDialog-intro">A Safari jelenleg nem t\00E1mogatja a webes alkalmaz\00E1sok macOS rendszerre telep\00EDt\00E9s\00E9t.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511344791400223)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ez a webhely k\00E9pes olyan alkalmaz\00E1sk\00E9nt m\0171k\00F6dni, amelyik a legjobb \00E9lm\00E9nyt a Chrome vagy az Edge b\00F6ng\00E9sz\0151ben ny\00FAjtja.</p>'),
unistr('    <p class="a-pwaDialog-intro">A Firefox jelenleg nem t\00E1mogatja a webes alkalmaz\00E1sok Windows rendszerre telep\00EDt\00E9s\00E9t.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513840919400225)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Nem lehet kapcsol\00F3dni</h1>'),
unistr('    <p>Ennek az alkalmaz\00E1snak a haszn\00E1lat\00E1hoz internetkapcsolat sz\00FCks\00E9ges.</p>'),
unistr('    <button type="button">\00DAjra</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513775868400225)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lehet kapcsol\00F3dni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653581139400327)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1ad\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597988252400286)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('Eg\00E9sz napos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676832170400344)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'hu'
,p_message_text=>unistr('Megh\00EDv\00F3 k\00FCld\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676691962400344)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Be\00E1ll\00EDt\00E1sok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599703245400288)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00F6sszes nap napi megtekint\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599517364400288)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'hu'
,p_message_text=>unistr('Adatok napi megtekint\00E9se az id\0151adattal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644476447400320)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'hu'
,p_message_text=>'Nap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638843346400316)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Le\00EDr\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529460671400236)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'hu'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529247726400236)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'hu'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529115514400236)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'hu'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529374435400236)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'hu'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528879730400236)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Z\00E1r\00F3 d\00E1tum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529030018400236)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'hu'
,p_message_text=>unistr('Esem\00E9ny neve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676735922400344)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Megh\00EDv\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644525949400320)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'hu'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644247396400320)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('H\00F3nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647009219400322)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661323719400332)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs esem\00E9ny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677056502400344)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E9tez\0151 esem\00E9ny szerkeszt\00E9se.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676975787400344)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'hu'
,p_message_text=>unistr('Megh\00EDv\00F3 k\00FCld\00E9se e-mailben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647180491400322)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655155363400328)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'hu'
,p_message_text=>unistr('E-mail k\00FCld\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654949663400328)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'hu'
,p_message_text=>unistr('E-mail k\00FCld\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677736783400344)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Minden mez\0151t k\00F6telez\0151 kit\00F6lteni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677695315400344)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Megh\00EDv\00F3 k\00FCld\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676568412400344)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00E1rgy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655044791400328)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDmzett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528957493400236)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Kezd\0151 d\00E1tum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652875637400326)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'hu'
,p_message_text=>unistr('\0170rlap ezen: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599346305400287)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'hu'
,p_message_text=>unistr('Id\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647234591400322)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'hu'
,p_message_text=>'Ma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645042810400320)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Megtekint\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644326389400320)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('H\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599663076400288)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00F6sszes nap heti megtekint\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599427063400288)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'hu'
,p_message_text=>unistr('Adatok heti megtekint\00E9se az id\0151adattal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644962853400320)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644692819400320)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'hu'
,p_message_text=>'Oszlopok...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644777214400320)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tov\00E1bbiak bet\00F6lt\00E9se...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576885893400271)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'hu'
,p_message_text=>'Vissza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523195070400232)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tov\00E1bbiak bet\00F6lt\00E9se...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525266287400233)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112644891196400320)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tov\00E1bbiak bet\00F6lt\00E9se...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646979364400322)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 r\00E9gi\00F3azonos\00EDt\00F3 nem tal\00E1lhat\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525155714400233)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 adat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549246749400251)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a r\00E9gi\00F3 oldalra t\00F6rdel\00E9s\00E9nek vissza\00E1ll\00EDt\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517491267400228)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a r\00E9gi\00F3 oldalra t\00F6rdel\00E9s\00E9nek be\00E1ll\00EDt\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638255002400315)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'hu'
,p_message_text=>'Oszlopok...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646850108400322)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 r\00E9gi\00F3t\00EDpus nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517333753400227)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a(z) "#COMPONENT_NAME#" r\00E9gi\00F3 megjelen\00EDt\00E9se sor\00E1n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581877714400274)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('#COLUMN_HEADER# \00E9rt\00E9ket kell tartalmazzon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676193478400343)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('%0, rich text szerkeszt\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583963929400276)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'hu'
,p_message_text=>unistr('A Rich Text form\00E1tum\00FA HTML-jel\00F6l\00E9s t\00FAll\00E9pte az elem r\00E9sz\00E9re enged\00E9lyezett hossz\00FAs\00E1got (a t\00E9nyleges %0, a megengedett pedig %1 karakter)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643878644400319)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6rl\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635699441400313)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633927577400312)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDtett oszlopok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633855514400312)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Null \00E9rt\00E9kek kiz\00E1r\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643962228400320)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1ad\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597523206400286)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'hu'
,p_message_text=>'Lejjebb'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597673269400286)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'hu'
,p_message_text=>'Feljebb'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633655496400312)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634236477400312)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Egy\00E9b oszlopok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633717929400312)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634041354400312)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'hu'
,p_message_text=>'%0. sor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634134567400312)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'hu'
,p_message_text=>unistr('%0. sor, \00F6sszesen %1 sor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635737837400314)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'hu'
,p_message_text=>unistr('Friss\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635825318400314)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00F3dos\00EDt\00E1sok vissza\00E1ll\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112633576278400312)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('Be\00E1ll\00EDt\00E1sok men\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594521495400284)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('P\00E9ld\00E1ul: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502090267400216)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Bejelentkez\00E9s \00FAjra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501951483400216)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('A munkamenet v\00E9get \00E9rt.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502103651400217)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'hu'
,p_message_text=>unistr('Kiterjeszt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501733893400216)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00D6n munkamenete ekkor lej\00E1r: %0. Szeretn\00E9 meghosszabb\00EDtani?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501890207400216)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'hu'
,p_message_text=>unistr('Munkamenete lej\00E1r ekkor: %0, \00E9s nem hosszabb\00EDthat\00F3 meg. Mentse minden munk\00E1j\00E1t, hogy elker\00FClje az adatveszt\00E9st.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654789972400327)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az adatb\00E1zisi munkamenet t\00F6rl\00E9si k\00F3dj\00E1nak feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547833356400250)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az adatb\00E1zisi munkamenet be\00E1ll\00EDt\00E1si k\00F3dj\00E1nak feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112521966491400231)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('A munkamenet v\00E9get \00E9rt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653673428400327)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'hu'
,p_message_text=>unistr('Z\00E1rja be a p\00E1rbesz\00E9dpanelt, \00E9s nyomja meg a b\00F6ng\00E9sz\0151 friss\00EDt\00E9si gombj\00E1t, hogy \00FAj munkamenetet nyisson.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672904571400341)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DAj munkamenet l\00E9trehoz\00E1s\00E1hoz kattintson <a href="%0">ide</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559579615400258)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'hu'
,p_message_text=>unistr('A munkamenet nem \00E9rv\00E9nyes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599067988400287)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'hu'
,p_message_text=>unistr('"%0" felhaszn\00E1l\00F3 r\00E9sz\00E9re nem lehetett Dinamikus szerepk\00F6r\00F6ket enged\00E9lyezni a Real Application Security munkamenet\00E9ben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545723897400248)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-99900 Nem lehetett l\00E9trehozni egyedi munkamenet-azonos\00EDt\00F3t: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562098114400260)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A munkameneti \00E1llapot v\00E9delm\00E9nek megs\00E9r\00FCl\00E9se: Ezt okozhatta a v\00E9dett %0 oldalelem manu\00E1lis megv\00E1ltoztat\00E1sa. Ha nem biztos benne, hogy mi okozta ezt a hib\00E1t, k\00E9rjen seg\00EDts\00E9get az alkalmaz\00E1s adminisztr\00E1tor\00E1t\00F3l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681176382400347)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Az oldalv\00E9delem megs\00E9rt\00E9se: Ennek oka lehet olyan oldal beny\00FAjt\00E1sa, amelyik bet\00F6lt\00E9se m\00E9g nem fejez\0151d\00F6tt be, vagy manu\00E1lisan m\00F3dos\00EDtva lettek a v\00E9dett oldalelemek. Tov\00E1bbi seg\00EDts\00E9g\00E9rt forduljon az alkalmaz\00E1s rendszergazd\00E1j\00E1hoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680146938400346)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 tartalmazza a k\00F6vetkez\0151 \00E9rv\00E9nytelen karakterek valamelyik\00E9t: &<>"/;,*|=% vagy --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680224077400346)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 tartalmazza a k\00F6vetkez\0151 \00E9rv\00E9nytelen karakterek valamelyik\00E9t: &<>"/;,*|=% vagy -- vagy az \00FAj sor karakter\00E9t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679914082400346)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 k\00FCl\00F6nleges karaktereket tartalmaz. Csak az a-Z, 0-9 k\00F6z\00F6tti karakterek \00E9s a sz\00F3k\00F6z\00F6k megengedettek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112680008295400346)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 tartalmaz <, > vagy " karaktert, melyek \00E9rv\00E9nytelenek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524119155400233)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lett megadva ellen\0151rz\0151\00F6sszeg annak az oldalnak a megjelen\00EDt\00E9s\00E9hez, amelyiknek ellen\0151rz\0151 \00F6sszegre van sz\00FCks\00E9ge, amikor egy vagy t\00F6bb k\00E9relem, gyors\00EDt\00F3t\00E1ri t\00F6rl\00E9s vagy argumentum \00E9rt\00E9k\00E9t param\00E9terk\00E9nt tov\00E1bb\00EDtja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556962830400256)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'hu'
,p_message_text=>unistr('A munkameneti \00E1llapot v\00E9delm\00E9nek megs\00E9r\00FCl\00E9se: Ezt okozhatta az ellen\0151rz\0151 \00F6sszeget tartalmaz\00F3 URL-c\00EDm manu\00E1lis megv\00E1ltoztat\00E1sa, illetve helytelen vagy hi\00E1nyz\00F3 ellen\0151rz\0151 \00F6sszeget tartalmaz\00F3 hivatkoz\00E1s haszn\00E1lata. Ha nem biztos benne, hogy mi okozta ezt')
||unistr(' a hib\00E1t, k\00E9rjen seg\00EDts\00E9get az alkalmaz\00E1s adminisztr\00E1tor\00E1t\00F3l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112634944701400313)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'hu'
,p_message_text=>unistr('Kontrasztos sz\00EDnek \00FCzemm\00F3d kikapcsol\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635089865400313)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'hu'
,p_message_text=>unistr('Kontrasztos sz\00EDnek \00FCzemm\00F3d bekapcsol\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553637742400254)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'hu'
,p_message_text=>'Alulra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553810015400254)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'hu'
,p_message_text=>'Lejjebb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553955028400254)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1thelyez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554017252400254)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mind \00E1thelyez\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554159906400254)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Elt\00E1vol\00EDt\00E1s')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554203868400254)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mind elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554399607400255)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Vissza\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553587067400254)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'hu'
,p_message_text=>unistr('Fel\00FClre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553795025400254)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'hu'
,p_message_text=>'Feljebb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662694471400333)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'hu'
,p_message_text=>'%0n'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663318310400334)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('ezen bel\00FCl: %0n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662501694400333)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'hu'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663482419400334)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('ezen bel\00FCl: %0h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662344238400333)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'hu'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663565721400334)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('ezen bel\00FCl: %0m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662928977400333)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0h\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663159036400334)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('ezen bel\00FCl: %0h\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662487994400333)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'hu'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663215186400334)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('ezen bel\00FCl: %0s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662733660400333)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0h\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663678509400334)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('ezen bel\00FCl: %0h\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662832460400333)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112663039850400333)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('ezen bel\00FCl: %0\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502948754400217)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'hu'
,p_message_text=>'[Vonal]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503357504400217)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'hu'
,p_message_text=>'[Sok vonal]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503137841400217)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'hu'
,p_message_text=>'[Sok pont]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503537276400217)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'hu'
,p_message_text=>unistr('[Sok soksz\00F6g]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503694821400218)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'hu'
,p_message_text=>'[Geometriai objektum]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502808792400217)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'hu'
,p_message_text=>'[Pont (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503056680400217)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'hu'
,p_message_text=>unistr('[Soksz\00F6g]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580264457400273)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Becsuk\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580187563400273)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Helyre\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626625606400307)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9kel\00E9s t\00F6rl\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616513974400300)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nincs az 1 \00E9s %1 k\00F6z\00F6tti \00E9rv\00E9nyes \00E9rt\00E9kel\00E9si tartom\00E1nyban')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616639796400300)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'hu'
,p_message_text=>'%0 nem numerikus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612722797400297)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'hu'
,p_message_text=>unistr('Sikeres m\0171veletr\0151l \00E9rtes\00EDt\0151 \00FCzenet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675849950400343)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675780166400343)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661421127400332)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'hu'
,p_message_text=>unistr('Eszk\00F6zt\00E1r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676252380400343)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Navig\00E1l\00E1s kibont\00E1sa/becsuk\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676355119400343)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldals\00F3 oszlop kibont\00E1sa/becsuk\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585940942400277)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('F\0151 navig\00E1ci\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592978865400282)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'hu'
,p_message_text=>'1 nap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592743112400282)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('1 \00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593066470400283)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'hu'
,p_message_text=>'%0 nap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592834460400282)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592604597400282)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'hu'
,p_message_text=>'%0 perc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593270105400283)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 h\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112593155718400283)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('1 h\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679472202400346)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'hu'
,p_message_text=>'Oldal kezdete'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541470885400245)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'hu'
,p_message_text=>unistr('Enged\00E9lyezett')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515249753400226)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba t\00F6rt\00E9nt a k\00E9relem feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594632313400284)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9ket kell megadni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677568609400344)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1rja meg az oldal teljes bet\00F6lt\00E9s\00E9t, majd pr\00F3b\00E1lja meg \00FAjra.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637780551400315)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'hu'
,p_message_text=>unistr('Ezen az oldalon nem mentett m\00F3dos\00EDt\00E1sok tal\00E1lhat\00F3k.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518684891400228)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs akt\00EDv munkalapja a munkaf\00FCzetnek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518565205400228)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lett inicializ\00E1lva a munkaf\00FCzet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518402863400228)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Bels\0151 hiba t\00F6rt\00E9nt az XLSX f\00E1jl l\00E9trehoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520944938400230)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'hu'
,p_message_text=>'Munkalap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652602242400326)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('M\0171veletek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570136956400266)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('M\0171veletek men\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565880708400263)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCggv\00E9ny hozz\00E1ad\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565773313400263)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlop alap\00FA csoportos\00EDt\00E1s hozz\00E1ad\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599959750400288)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1soszlop hozz\00E1ad\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600047453400288)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor oszlop\00E1nak hozz\00E1ad\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540212683400244)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes\00EDt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576383150400270)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes\00EDt\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557493695400257)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1tlag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561757288400260)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('Mennyis\00E9g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557581788400257)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'hu'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557784480400257)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6z\00E9p\00E9rt\00E9k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557608592400257)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'hu'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557332753400257)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszesen %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558420093400258)
,p_name=>'APEXIR_ALL'
,p_message_language=>'hu'
,p_message_text=>'Mind'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539588996400244)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>'Minden oszlop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522036626400231)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'hu'
,p_message_text=>'Minden sor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649631808400324)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Alternat\00EDva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651229631400325)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1sodlagos alap\00E9rtelmez\00E9s: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552187322400253)
,p_name=>'APEXIR_AND'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541641930400245)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'hu'
,p_message_text=>'Alkalmaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535396064400241)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00F6vekv\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554963836400255)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'hu'
,p_message_text=>unistr('Ett\0151l kezdve: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651874893400325)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1tlag: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643295577400319)
,p_name=>'APEXIR_BAR'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00E1v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541033757400245)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'hu'
,p_message_text=>unistr('ezek k\00F6z\00F6tt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534169083400240)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'hu'
,p_message_text=>unistr('H\00E1tt\00E9rsz\00EDn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536077474400241)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'hu'
,p_message_text=>unistr('k\00E9k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567721470400264)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'hu'
,p_message_text=>'Alulra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536609045400242)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E9gse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542547415400246)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'hu'
,p_message_text=>unistr('Kateg\00F3ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534077038400240)
,p_name=>'APEXIR_CELL'
,p_message_language=>'hu'
,p_message_text=>'Cella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558385260400258)
,p_name=>'APEXIR_CHART'
,p_message_language=>'hu'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568674017400265)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'hu'
,p_message_text=>unistr('Inicializ\00E1l\00E1s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112604986687400292)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Meg kell adni a diagram felirat\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617334312400300)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'hu'
,p_message_text=>unistr('A lek\00E9rdez\00E9sben a diagramonk\00E9nti adatpontok sz\00E1ma t\00F6bb, mint a maximum: %0. Haszn\00E1ljon sz\0171r\0151t, hogy cs\00F6kkentse a rekordok sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616259564400300)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagram t\00EDpus\00FA lek\00E9rdez\00E9shez a sorok maxim\00E1lis sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben l\00E9v\0151 sorok sz\00E1ma korl\00E1tozza, nem a megjelen\00EDtett sorok sz\00E1ma. Ez az alap lek\00E9rdez\00E9s t\00FAll\00E9pi a sorok megengedett sz\00E1m\00E1t, ami %0. Haszn\00E1ljon sz\0171r\0151t, hogy cs\00F6kkentse a rekordok ')
||unistr('sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539655685400244)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagramt\00EDpus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112612974969400297)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes bejel\00F6l\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555384915400255)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lasszon kimutat\00E1sform\00E1tumot')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562745945400261)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('t\00F6rl\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536555756400242)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Oszlop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573917318400269)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>'Oszlopok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646245309400321)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564791926400262)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlopfejl\00E9c men\00FCje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568412344400265)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlopinform\00E1ci\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648571587400323)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'hu'
,p_message_text=>'Oszlopfelirat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566169033400263)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'hu'
,p_message_text=>'Oszlop %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550283931400252)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'hu'
,p_message_text=>'tartalmaz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551101308400252)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'hu'
,p_message_text=>'nem tartalmaz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535075574400241)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'hu'
,p_message_text=>'tartalmazza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551360572400252)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('nem az utols\00F3ban')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559867692400259)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('nem a k\00F6vetkez\0151ben van')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551220136400252)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('az utols\00F3ban')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559750523400259)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('a k\00F6vetkez\0151ben van')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534965562400241)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('nem null \00E9rt\00E9k\0171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534863777400240)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('null \00E9rt\00E9k\0171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534650391400240)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'hu'
,p_message_text=>unistr('ehhez hasonl\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535116233400241)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'hu'
,p_message_text=>'nem tartalmazza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534712902400240)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'hu'
,p_message_text=>unistr('nem ehhez hasonl\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550559718400252)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'hu'
,p_message_text=>unistr('egyezik a regul\00E1ris kifejez\00E9ssel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555208691400255)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00E1m\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112615917333400299)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00E1m\00EDt\00E1si kifejez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574250215400269)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00E1m\00EDt\00E1s l\00E9trehoz\00E1sa m\00E1sodlagos oszlopnevek haszn\00E1lat\00E1val.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574384846400269)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'hu'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574458935400269)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'hu'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574554593400269)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'hu'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520449815400230)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'hu'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559198623400258)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00E1m\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566754320400264)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9spont')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569706801400266)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9spont')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654153257400327)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9sponti oszlopok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517517857400228)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCl\00F6nb\00F6z\0151k sz\00E1ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652364010400326)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCl\00F6nb\00F6z\0151k sz\00E1ma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652262025400326)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'hu'
,p_message_text=>unistr('Mennyis\00E9g: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624374462400305)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'hu'
,p_message_text=>'Naponta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679021717400345)
,p_name=>'APEXIR_DATA'
,p_message_language=>'hu'
,p_message_text=>'Adatok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568507931400265)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 perccel kor\00E1bbi kimutat\00E1sadatok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642022973400318)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3 az adatr\00E1cshoz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540307192400244)
,p_name=>'APEXIR_DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('D\00E1tum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572437241400268)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649475115400324)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett kimutat\00E1st\00EDpus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536711652400242)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6rl\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540698226400245)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'hu'
,p_message_text=>unistr('Szeretn\00E9 t\00F6r\00F6lni ezeket a kimutat\00E1sbe\00E1ll\00EDt\00E1sokat?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635373846400313)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett kimutat\00E1s t\00F6rl\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566471493400263)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s t\00F6rl\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535421288400241)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('Cs\00F6kken\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542606419400246)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Le\00EDr\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564605539400262)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Egysoros megtekint\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572931379400268)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Ir\00E1ny: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573843902400269)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'hu'
,p_message_text=>'Letiltva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536216464400241)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDtett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539473565400244)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDtett oszlopok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572824396400268)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDt\00E9s kimutat\00E1sban')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567673306400264)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'hu'
,p_message_text=>'Lejjebb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559290840400258)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'hu'
,p_message_text=>unistr('Let\00F6lt\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572725673400268)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'hu'
,p_message_text=>'Ne jelenjen meg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638776434400316)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1r l\00E9tezik kiemel\00E9s ilyen felt\00E9telekkel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654381619400327)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 kimutat\00E1soszlop. A kimutat\00E1soszlopi lista csak egyedi lehet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654523084400327)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Szerkeszt\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568774789400265)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagrambe\00E1ll\00EDt\00E1sok szerkeszt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575325540400270)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagram szerkeszt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575774055400270)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151 szerkeszt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630131533400310)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1si szempont szerkeszt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575677481400270)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kiemel\00E9s szerkeszt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600204564400288)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1st\00E1bla szerkeszt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649794280400324)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'hu'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528437076400236)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'hu'
,p_message_text=>unistr('E-mail-c\00EDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650078868400324)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'hu'
,p_message_text=>unistr('Titkos m\00E1solat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650216062400324)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6rzs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649929768400324)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1solatot kap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650730892400325)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'hu'
,p_message_text=>unistr('Gyakoris\00E1g')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532199347400238)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs konfigur\00E1lva e-mail-c\00EDm ehhez az alkalmaz\00E1shoz. Forduljon a rendszergazd\00E1hoz.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623629415400305)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Meg kell adnia az e-mail-c\00EDmet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650330423400324)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E1sd a mell\00E9kletet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650193139400324)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00E1rgy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624691116400306)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Meg kell adni az e-mail-c\00EDmet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649840279400324)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDmzett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533847177400240)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'hu'
,p_message_text=>unistr('Enged\00E9lyezett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575502257400270)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'hu'
,p_message_text=>unistr('Enged\00E9lyez\00E9s/Letilt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575085498400270)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'hu'
,p_message_text=>'Hiba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574646680400269)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'hu'
,p_message_text=>unistr('P\00E9ld\00E1k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575443701400270)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'hu'
,p_message_text=>unistr('P\00E9ld\00E1k:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539336480400244)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Null \00E9rt\00E9kek kiz\00E1r\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576060280400270)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kibont\00E1s/Becsuk\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573662140400269)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('Kifejez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558714410400258)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569643191400266)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579968809400273)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151kifejez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676451756400343)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00FAl hossz\00FA a sz\0171r\0151kifejez\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579838492400273)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151t\00EDpus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576201439400270)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlopok kijel\00F6l\00E9se keres\00E9shez')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559097886400258)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'hu'
,p_message_text=>unistr('Visszatekint\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573439598400268)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A visszatekint\0151 (flashback) lek\00E9rdez\00E9s lehet\0151v\00E9 teszi az adatok megtekint\00E9s\00E9t \00FAgy, mint egy kor\00E1bbi id\0151pontban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624006657400305)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Visszatekint\00E9s id\0151tartama')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625420511400306)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('Form\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555176382400255)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'hu'
,p_message_text=>unistr('Form\00E1tummaszk %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566365790400263)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCggv\00E9ny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574131069400269)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCggv\00E9nyek %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649373253400323)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCggv\00E9nyek / M\0171veletek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566057891400263)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCggv\00E9ny %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558541266400258)
,p_name=>'APEXIR_GO'
,p_message_language=>'hu'
,p_message_text=>unistr('Ugr\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534312145400240)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'hu'
,p_message_text=>unistr('z\00F6ld')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112517658748400228)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1si szempont')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650415135400324)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1s %0 szerint')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605016168400292)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Meg kell adni a csoportos\00EDt\00E1s oszlop\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616113352400300)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1s t\00EDpus\00FA lek\00E9rdez\00E9shez a sorok maxim\00E1lis sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben l\00E9v\0151 sorok sz\00E1ma korl\00E1tozza, nem a megjelen\00EDtett sorok sz\00E1ma. Ez az alap lek\00E9rdez\00E9s t\00FAll\00E9pi a sorok megengedett sz\00E1m\00E1t, ami %0. Haszn\00E1ljon sz\0171r\0151t, hogy cs\00F6kkentse a rek')
||unistr('ordok sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596751731400285)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1s sorba rendez\00E9ssel')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654213300400327)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1s sorrendje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539748161400244)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00EDzszintes oszlop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571382425400267)
,p_name=>'APEXIR_HELP'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563146162400261)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Az interakt\00EDv kimutat\00E1sok r\00E9v\00E9n a felhaszn\00E1l\00F3k testre szabhatnak kimutat\00E1sokat. A felhaszn\00E1l\00F3k megv\00E1ltoztathatj\00E1k a kimutat\00E1s elrendez\00E9s\00E9t, ha oszlopokat jel\00F6lnek ki, sz\0171r\0151ket haszn\00E1lnak, kiemelnek \00E9s sorba rendeznek. A felhaszn\00E1l\00F3k megadhatnak t\00F6r\00E9s')
||unistr('eket, \00F6sszes\00EDt\00E9seket, diagramokat, csoportos\00EDt\00E1sokat \00E9s egy\00E9b saj\00E1t sz\00E1m\00EDt\00E1sokat. A felhaszn\00E1l\00F3knak feliratkoz\00E1si lehet\0151s\00E9ge is van, hogy e-mail-\00FCzenetben rendszeres id\0151k\00F6z\00F6nk\00E9nt megkapj\00E1k a kimutat\00E1s HTML-verzi\00F3j\00E1t. A felhaszn\00E1l\00F3k l\00E9trehozhatnak t\00F6b')
||unistr('b v\00E1ltozatot is a kimutat\00E1sb\00F3l, \00E9s azokat n\00E9vvel ell\00E1tva menthetik ak\00E1r nyilv\00E1nos, ak\00E1r saj\00E1t megtekint\00E9sre. '),
'<p/>',
unistr('A k\00F6vetkez\0151 szakaszok \00F6sszefoglalj\00E1k azokat a m\00F3dokat, amelyekkel testre szabhatnak egy interakt\00EDv kimutat\00E1st. A tov\00E1bbi tudnival\00F3kat l\00E1sd: "Interakt\00EDv kimutat\00E1sok haszn\00E1lata" az <i>Oracle Application Express v\00E9gfelhaszn\00E1l\00F3i k\00E9zik\00F6nyv\00E9ben</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570236816400266)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('A M\0171veletek men\00FC az Ugr\00E1s gombt\00F3l jobbra jelenik meg a Keres\00E9si s\00E1von. Ez a men\00FC haszn\00E1lhat\00F3 az interakt\00EDv kimutat\00E1shoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563921266400262)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Az \00F6sszes\00EDt\00E9sek olyan matematikai sz\00E1m\00EDt\00E1sok, amelyek oszlopokon v\00E9gezhet\0151k. Az \00F6sszes\00EDt\00E9sek az egyes ellen\0151rz\0151 t\00F6r\00E9spontok ut\00E1n \00E9s a kimutat\00E1s v\00E9g\00E9n jelennek meg az erre defini\00E1lt oszlopban. A be\00E1ll\00EDt\00E1sok a k\00F6vetkez\0151k lehetnek:'),
'<p>',
'</p><ul>',
unistr('<li>Az <strong>\00D6sszes\00EDt\00E9s</strong>lehet\0151v\00E9 teszi egy el\0151z\0151leg defini\00E1lt'),
unistr('\00F6sszes\00EDt\00E9s szerkeszt\00E9s\00E9t.</li>'),
unistr('<li>A <strong>F\00FCggv\00E9ny</strong> a v\00E9grehajtand\00F3 f\00FCggv\00E9ny (p\00E9ld\00E1ul SUM, MIN).</li>'),
unistr('<li>Az <strong>Oszlop</strong> haszn\00E1lhat\00F3 annak az oszlopnak a kiv\00E1laszt\00E1s\00E1ra, amelyiken v\00E9grehajt\00F3dik a matematikai f\00FCggv\00E9ny. Csak a sz\00E1m'),
'oszlopok jelennek meg.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564041769400262)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mentett kimutat\00E1sonk\00E9nt csak egy diagram defini\00E1lhat\00F3. Ha defini\00E1lva lett,'),
unistr('a Keres\00E9s eszk\00F6zt\00E1r megjelen\00EDt\00E9si ikonj\00E1val v\00E1ltogathat a diagramos \00E9s a kimutat\00E1sos n\00E9zet k\00F6z\00F6tt.'),
unistr('A be\00E1ll\00EDt\00E1sok a k\00F6vetkez\0151k lehetnek: '),
'<p>',
'</p><ul>',
unistr('<li>A <strong>Diagramt\00EDpus</strong> hat\00E1rozza meg a beker\00FCl\0151 diagram t\00EDpus\00E1t.'),
unistr('V\00E1laszthat\00F3 v\00EDzszintes s\00E1v, f\00FCgg\0151leges s\00E1v, k\00F6rdiagram \00E9s grafikon.</li>'),
unistr('<li>A <strong>Felirat</strong> haszn\00E1lat\00E1val adhat\00F3 meg, hogy melyik oszlop legyen haszn\00E1lva feliratk\00E9nt.</li>'),
unistr('<li>A <strong>Tengelyc\00EDm a felirathoz</strong> az a c\00EDm, amelyik a Felirathoz v\00E1lasztott oszlophoz kapcsol\00F3d\00F3 tengely mellett'),
unistr('jelenik meg. K\00F6rdiagramn\00E1l ez nem el\00E9rhet\0151.</li>'),
unistr('<li>Az <strong>\00C9rt\00E9k</strong> teszi lehet\0151v\00E9 az \00E9rt\00E9kk\00E9nt haszn\00E1lt oszlop kijel\00F6l\00E9s\00E9t. Ha a'),
unistr('f\00FCggv\00E9ny a COUNT, az \00C9rt\00E9k kijel\00F6l\00E9se nem sz\00FCks\00E9ges.</li>'),
unistr('<li>A <strong>Tengelyc\00EDm az \00E9rt\00E9khez</strong> az a c\00EDm, amelyik az \00C9rt\00E9khez v\00E1lasztott oszlophoz kapcsol\00F3d\00F3 tengelyen jelenik meg.'),
unistr('K\00F6rdiagramn\00E1l ez nem el\00E9rhet\0151.</li>'),
unistr('<li>A <strong>F\00FCggv\00E9ny</strong> az \00C9rt\00E9khez v\00E1lasztott oszlopon esetleg v\00E9grehajthat\00F3 f\00FCggv\00E9ny.</li>'),
unistr('<li>A <strong>Rendez\00E9s</strong> teszi lehet\0151v\00E9 az eredm\00E9nyhalmaz elemeinek a sorrendj\00E9t.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563329592400261)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Az oszlopfejl\00E9cre kattint\00E1s megjelen\00EDt egy oszlopfejl\00E9c men\00FCt. A lehets\00E9ges be\00E1ll\00EDt\00E1sok:'),
'<p></p>',
'<ul>',
unistr('<li>A <strong>N\00F6vekv\0151 sorrend</strong> ikon a kimutat\00E1st a n\00F6vekv\0151 sorrend\0171 oszlop szerint rendezi sorba.</li>'),
unistr('<li>A <strong>Cs\00F6kken\0151 sorrend</strong> ikon a kimutat\00E1st a cs\00F6kken\0151 sorrend\0171 oszlop szerint rendezi sorba.</li>'),
unistr('<li>Az <strong>Oszlop elrejt\00E9se</strong> elrejti az oszlopot. Nem minden oszlop rejthet\0151 el. Ha nem rejthet\0151 el egy oszlop, ott nem jelenik meg Oszlop elrejt\00E9se ikon.</li>'),
unistr('<li>A <strong>Csoportt\00F6r\0151 oszlop</strong> csoportt\00F6r\0151v\00E9 teszi az oszlopot. Ez mint t\00F6rzsrekordot kiveszi a kimutat\00E1sb\00F3l.</li>'),
unistr('<li>Az <strong>Oszlopinform\00E1ci\00F3</strong> megjelen\00EDti az oszlopra vonatkoz\00F3 s\00FAg\00F3t, ha van.</li>'),
unistr('<li>A <strong>Sz\00F6vegter\00FClet</strong> haszn\00E1lhat\00F3 olyan keresend\0151 sz\00F6veg be\00EDr\00E1s\00E1ra, ahol a nagy- \00E9s kisbet\0171k azonosnak sz\00E1m\00EDtanak (nincs sz\00FCks\00E9g helyettes\00EDt\0151 karakterekre).'),
unistr('Egy \00E9rt\00E9k be\00EDr\00E1sa r\00F6vid\00EDti a men\00FC alj\00E1n az \00E9rt\00E9kek list\00E1j\00E1t. Ezut\00E1n v\00E1laszthat lentr\0151l \00E9rt\00E9ket, \00E9s a v\00E1lasztott \00E9rt\00E9k az ''='' egyenl\0151s\00E9gjelet haszn\00E1l\00F3 sz\0171r\0151k\00E9nt j\00F6n l\00E9tre'),
unistr('(p\00E9ld\00E1ul <code>oszlop = ''ABC''</code>). M\00E1sik m\00F3dk\00E9nt kattinthat a Zsebl\00E1mpa ikonra \00E9s be\00EDrhatja a sz\0171r\0151 \00E9rt\00E9k\00E9t egy\00FCtt a ''LIKE'' m\00F3dos\00EDt\00F3val '),
unistr('(p\00E9ld\00E1ul <code>oszlop LIKE ''%ABC%''</code>).</li>'),
unistr('<li>Az <b>Egyedi \00E9rt\00E9kek list\00E1ja</b> tartalmazza az els\0151 500 olyan'),
unistr('egyedi \00E9rt\00E9ket, amelyik megfelel a sz\0171r\00E9si felt\00E9teleknek. Ha az '),
unistr('oszlop d\00E1tum, akkor a lista ink\00E1bb a d\00E1tumtartom\00E1nyokat jelen\00EDti meg. '),
unistr('Ha \00E9rt\00E9ket jel\00F6l ki, a sz\0171r\0151 l\00E9trehoz\00E1sa az ''='' haszn\00E1lat\00E1val t\00F6rt\00E9nik '),
unistr('(p\00E9ld\00E1ul <code>oszlop = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563863009400262)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lehet\0151v\00E9 teszi, hogy a kimutat\00E1sba felvegyen sz\00E1m\00EDtott oszlopokat. Ezek lehetnek matematikai sz\00E1m\00EDt\00E1sok (p\00E9ld\00E1ul <code>NBR_HOURS/24</code>) vagy l\00E9tez\0151 oszlopokra'),
unistr('alkalmazott szabv\00E1nyos Oracle f\00FCggv\00E9nyek. N\00E9h\00E1nyan p\00E9ldak\00E9nt jelennek meg, illetve a t\00F6bbi (p\00E9ld\00E1ul a <code>TO_DATE)</code>) is haszn\00E1lhat\00F3. A be\00E1ll\00EDt\00E1sok a k\00F6vetkez\0151k lehetnek:'),
'<p></p>',
'<ul>',
unistr('<li>A <strong>Sz\00E1m\00EDt\00E1s</strong> lehet\0151v\00E9 teszi, hogy szerkeszt\00E9sre kiv\00E1lasszon egy el\0151zetesen defini\00E1lt sz\00E1m\00EDt\00E1st.</li>'),
unistr('<li>Az <strong>Oszlopfejl\00E9c</strong> az \00FAj oszlop oszlopfejl\00E9ce.</li>'),
unistr('<li>A <strong>Form\00E1tummaszk</strong> az az Oracle form\00E1tummaszk, amelyik \00E9rv\00E9nyes\00EDtve lesz az oszlopra (p\00E9ld\00E1ul S9999).</li>'),
unistr('<li>A <strong>Sz\00E1m\00EDt\00E1s</strong> a v\00E9grehajtand\00F3 sz\00E1m\00EDt\00E1s. A sz\00E1m\00EDt\00E1sban az oszlopokra hivatkoz\00E1s a megjelen\00EDtett aliasok haszn\00E1lat\00E1val t\00F6rt\00E9nik.</li>'),
'</ul>',
unistr('<p>A sz\00E1m\00EDt\00E1s alatt a lek\00E9rdez\00E9sben l\00E9v\0151 oszlopokra a hivatkoz\00E1s a kapcsol\00F3d\00F3'),
unistr('alias haszn\00E1lat\00E1val t\00F6rt\00E9nik. Ha r\00E1kattint az oszlopn\00E9vre vagy az aliasra, akkor az'),
unistr('beker\00FCl a Sz\00E1m\00EDt\00E1sba. Az Oszlopok mellett billenty\0171zet l\00E1that\00F3. Ez a billenty\0171zet'),
unistr('a rendszeresen haszn\00E1lt billenty\0171k "parancsikonjak\00E9nt" m\0171k\00F6dik. A jobb sz\00E9len vannak a F\00FCggv\00E9nyek.</p>'),
unistr('<p>A k\00F6vetkez\0151 sz\00E1m\00EDt\00E1si p\00E9lda szeml\00E9lteti a teljes d\00EDjaz\00E1st:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(ahol A a SZERVEZET, B a B\00C9R, a C pedig a JUTAL\00C9K)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570324055400266)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez haszn\00E1lhat\00F3 egy vagy t\00F6bb oszlop ut\00E1n egy t\00F6r\00E9si csoport elk\00FCl\00F6n\00EDt\00E9s\00E9re. Ez kiveszi az oszlopokat az interakt\00EDv kimutat\00E1sb\00F3l, \00E9s azokat k\00FCl\00F6n t\00F6rzsrekordokk\00E9nt jelen\00EDti meg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564519978400262)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('A r\00E9szletek vagy egyszerre egy sor megtekint\00E9s\00E9hez kattintson a megtekinteni k\00EDv\00E1nt sorban az egysoros megtekint\00E9s ikonj\00E1ra. Ha van, az egysoros megtekint\00E9sben mindig az els\0151 oszlop lesz. Az interakt\00EDv kimutat\00E1s testreszab\00E1s\00E1t\00F3l f\00FCgg\0151en, az egysoros ')
||unistr('megtekint\00E9s lehet a szabv\00E1nyos megtekint\00E9s vagy az az egy\00E9ni oldal, amelyik lehet\0151v\00E9 teszi a m\00F3dos\00EDt\00E1st.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564414811400262)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lehet\0151v\00E9 teszi az aktu\00E1lis eredm\00E9nyhalmaz let\00F6lt\00E9s\00E9t. A let\00F6lt\00F6tt form\00E1tumok'),
unistr('elt\00E9rnek az \00D6n\00F6k telep\00EDt\00E9s\00E9t\0151l \00E9s kimutat\00E1s-defini\00E1l\00E1sukt\00F3l f\00FCgg\0151en, de'),
unistr('tartalmazhatnak CSV, HTML, Email, XLS, PDF \00E9s RTF form\00E1tumot is.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563541508400261)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A kimutat\00E1sban f\00F3kusz\00E1lni a lek\00E9rdez\00E9s <code>WHERE</code> utas\00EDt\00E1sr\00E9sz\00E9nek megad\00E1s\00E1val vagy m\00F3dos\00EDt\00E1s\00E1val lehet. Sz\0171rni oszlopra vagy sorra lehet.'),
unistr('<p>Ha oszlopra sz\0171r, jel\00F6lj\00F6n ki egy oszlopot (nem sz\00FCks\00E9ges, hogy ez megjelenjen), v\00E1lasszon egy szabv\00E1nyos Oracle m\0171veletet (=, !=, not in, between), \00E9s adja meg az \00F6sszehasonl\00EDtand\00F3 kifejez\00E9st. A kifejez\00E9s a kis- \00E9s a nagybet\0171ket megk\00FCl\00F6nb\00F6zteti. ')
||unistr('Helyettes\00EDt\0151 karakterk\00E9nt haszn\00E1lja a % jelet (p\00E9ld\00E1ul <code>STATE_NAME like A%)</code>.</p>'),
unistr('<p>Ha soronk\00E9nt sz\0171r, l\00E9trehozhat egy \00F6sszetett <code>WHERE</code> utas\00EDt\00E1sr\00E9szt az oszlop-p\00F3tnevek \00E9s b\00E1rmilyen Oracle f\00FCggv\00E9ny vagy m\0171velet haszn\00E1lat\00E1val (p\00E9ld\00E1ul <code>G = ''VA'' or G = ''CT''</code>, ahol a'),
'<code>G</code> a <code>CUSTOMER_STATE</code> aliasneve).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564151190400262)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A flashback t\00EDpus\00FA lek\00E9rdez\00E9s lehet\0151v\00E9 teszi, hogy \00FAgy tekintse meg az adatokat, ahogy azok'),
unistr('egy kor\00E1bbi id\0151pontban voltak. Alap\00E9rtelmezetten az ilyen visszatekint\00E9s legfeljebb 3 \00F3r\00E1ra'),
unistr('(vagy 180 percre) korl\00E1tozott, de az egyes adatb\00E1zisokn\00E1l a t\00E9nyleges id\0151hossz elt\00E9r\0151 lehet.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625313580400306)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A Form\00E1tum teszi lehet\0151v\00E9, hogy testre szabja a kimutat\00E1s megjelen\00E9s\00E9t.'),
unistr('A Form\00E1tum a k\00F6vetkez\0151 almen\00FCt tartalmazza:</p>'),
unistr('<ul><li>Rendez\00E9s</li>'),
unistr('<li>Ellen\0151rz\0151 t\00F6r\00E9spont</li>'),
unistr('<li>Kiemel\00E9s</li>'),
unistr('<li>Sz\00E1m\00EDt\00E1s</li>'),
unistr('<li>\00D6sszes\00EDt\00E9s</li>'),
'<li>Diagram</li>',
unistr('<li>Csoportos\00EDt\00E1si szempont</li>'),
unistr('<li>Kimutat\00E1st\00E1bla</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623589629400305)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mentett jelent\00E9senk\00E9nt egy Csoportos\00EDt\00E1s n\00E9zet defini\00E1lhat\00F3. Ha m\00E1r defini\00E1lva lett, a Keres\00E9s eszk\00F6zt\00E1ron a megfelel\0151 ikonokkal v\00E1ltogathat a csoportos\00EDt\00E1s \00E9s a jelent\00E9s t\00EDpus\00FA megjelen\00EDt\00E9s k\00F6z\00F6tt. A Csoportos\00EDt\00E1s \00FAjabb n\00E9zet\00E9nek l\00E9trehoz\00E1s\00E1hoz v\00E1la')
||'sszon: ',
'<p></p><ul>',
unistr('<li>oszlopokat, amelyek a csoportos\00EDt\00E1s alapj\00E1t k\00E9pezik</li>'),
unistr('<li>oszlopokat, amelyeken az \00F6sszes\00EDt\0151 f\00FCggv\00E9nyek (average, sum, count stb.) elv\00E9gzik a sz\00E1m\00EDt\00E1saikat</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563786769400261)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ez lehet\0151v\00E9 teszi a sz\0171r\0151 defini\00E1l\00E1s\00E1t. A sz\0171r\0151felt\00E9telnek megfelel\0151 sorok kiemeltek lesznek azon jellemz\0151k haszn\00E1lat\00E1val, amelyek a sz\0171r\0151h\00F6z kapcsol\00F3dnak. A lehets\00E9ges be\00E1ll\00EDt\00E1sok:</p>'),
'<ul>',
unistr('<li>A <strong>N\00E9v</strong> csak a megjelen\00EDt\00E9shez haszn\00E1lhat\00F3.</li>'),
unistr('<li>A <strong>Sorrend</strong> azt a sorrendet azonos\00EDtja, amelyikben a szab\00E1lyok ki\00E9rt\00E9kel\0151dnek.</li>'),
unistr('<li>Az <strong>Enged\00E9lyezett</strong> jelzi, hogy a szab\00E1ly enged\00E9lyezett vagy letiltott.</li>'),
unistr('<li>A <strong>Kiemel\00E9s t\00EDpusa</strong> azt jelzi, hogy a sor vagy a cella legyen'),
unistr('kiemelve. Ha a Cella van kijel\00F6lve, a Kiemel\00E9si felt\00E9telben hivatkozott oszlop lesz'),
'kiemelve.</li>',
unistr('<li>A <strong>H\00E1tt\00E9rsz\00EDn</strong> a kijel\00F6lt ter\00FClet h\00E1tter\00E9nek \00FAj sz\00EDne.</li>'),
unistr('<li>A <strong>Sz\00F6vegsz\00EDn</strong> a kijel\00F6lt ter\00FCleten l\00E9v\0151 sz\00F6veg \00FAj sz\00EDne.</li>'),
unistr('<li>A <strong>Kiemel\00E9si felt\00E9tel</strong> hat\00E1rozza meg a sz\0171r\00E9si felt\00E9telt.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501399798400216)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Mentett jelent\00E9senk\00E9nt egy Kimutat\00E1s n\00E9zet defini\00E1lhat\00F3. Ha m\00E1r defini\00E1lva lett, a Keres\00E9s eszk\00F6zt\00E1ron a megfelel\0151 ikonokkal v\00E1ltogathat a kimutat\00E1s \00E9s a jelent\00E9s t\00EDpus\00FA megjelen\00EDt\00E9s k\00F6z\00F6tt. A Kimutat\00E1s \00FAjabb n\00E9zet\00E9nek l\00E9trehoz\00E1s\00E1hoz v\00E1lasszon: '),
'<p></p>',
'<ul>',
unistr('<li>oszlopokat, amelyeken \00E1tfordul a kimutat\00E1s</li>'),
unistr('<li>oszlopokat, amelyek sork\00E9nt jelennek meg</li>'),
unistr('<li>oszlopokat, amelyeken az \00F6sszes\00EDt\0151 f\00FCggv\00E9nyek (average, sum, count stb.) elv\00E9gzik a sz\00E1m\00EDt\00E1saikat</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574841141400269)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ha testre szab egy interakt\00EDv kimutat\00E1st, a kimutat\00E1s be\00E1ll\00EDt\00E1sai a'),
unistr('Keres\00E9s eszk\00F6zt\00E1r alatt \00E9s a kimutat\00E1s f\00F6l\00F6tt jelennek meg. Ez a ter\00FClet'),
unistr('a balra tal\00E1lhat\00F3 ikonnal becsukhat\00F3 \00E9s kibonthat\00F3.'),
'<p>',
unistr('Az egyes kimutat\00E1s-be\00E1ll\00EDt\00E1sokn\00E1l a k\00F6vetkez\0151ket teheti:'),
'</>< ul>',
unistr('<li>A n\00E9vre kattintva szerkesztheti a be\00E1ll\00EDt\00E1st.</li>'),
unistr('<li>A be\00E1ll\00EDt\00E1s letilt\00E1s\00E1hoz/enged\00E9lyez\00E9s\00E9hez az Enged\00E9lyez\00E9s/Letilt\00E1s jel\00F6l\0151n\00E9gyzet haszn\00E1lhat\00F3. A be\00E1ll\00EDt\00E1s ideiglenesen is ezzel kapcsolhat\00F3 be \00E9s ki.</li>'),
unistr('<li>Be\00E1ll\00EDt\00E1st az Elt\00E1vol\00EDt\00E1s ikonnal t\00E1vol\00EDthat el.</li>'),
'</ul>',
unistr('<p>Ha diagramot vagy csoportos\00EDt\00E1st hozott l\00E9tre, v\00E1ltogathat k\00F6z\00F6tt\00FCk \00E9s az'),
unistr('alapkimutat\00E1s k\00F6z\00F6tt a Jelent\00E9s, a Diagram vagy a Csoportos\00EDt\00E1s n\00E9zet jobbra'),
unistr('l\00E1that\00F3 hivatkoz\00E1s\00E1val. A diagram vagy a csoportos\00EDt\00E1s megtekint\00E9sekor \00D6n'),
unistr('m\00F3dos\00EDthatja a be\00E1ll\00EDt\00E1sokat a Szerkeszt\00E9s hivatkoz\00E1s haszn\00E1lat\00E1val.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564304068400262)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Vissza\00E1ll\00EDtja a kimutat\00E1st az alap\00E9rtelmezett be\00E1ll\00EDt\00E1sokra, elt\00E1vol\00EDtva azokat a testreszab\00E1sokat, amelyeket \00D6n m\00E1r elv\00E9gzett.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625662054400306)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Be\00E1ll\00EDtja az oldalank\00E9nt megjelen\00EDteni k\00EDv\00E1nt rekordok sz\00E1m\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564299106400262)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Menti a testre szabott kimutat\00E1st a j\00F6v\0151beli haszn\00E1lathoz. \00D6nnek meg kell adni a nevet, opcion\00E1lisan a le\00EDr\00E1st, \00E9s nyilv\00E1nosan el\00E9rhet\0151v\00E9 kell tenni (azaz azok r\00E9sz\00E9re, akik hozz\00E1f\00E9rhetnek az els\0151dleges kimutat\00E1shoz). Az interakt\00EDv kimutat\00E1sok n\00E9g')
||unistr('y t\00EDpusa menthet\0151:</p>'),
'<ul>',
unistr('<li><strong>Els\0151dleges alap\00E9rtelmez\00E9s</strong> (Csak fejleszt\0151knek). Az Els\0151dleges alap\00E9rtelmez\00E9s az a kimutat\00E1s, amelyik a kezdetkor jelenik meg. Az Els\0151dleges alap\00E9rtelmez\00E9s nem nevezhet\0151 \00E1t, \00E9s nem is t\00F6r\00F6lhet\0151.</li>'),
unistr('<li><strong>Alternat\00EDv kimutat\00E1s</strong> (Csak fejleszt\0151knek). Lehet\0151v\00E9 teszi, hogy a fejleszt\0151 t\00F6bb kimutat\00E1s-elrendez\00E9st is l\00E9trehozzon. Alternat\00EDv kimutat\00E1st csak a fejleszt\0151k nevezhetnek \00E1t, illetve csak \0151k t\00F6r\00F6lhetik.</li>'),
unistr('<li><strong>Nyilv\00E1nos kimutat\00E1s</strong> (V\00E9gfelhaszn\00E1l\00F3i). Csak a l\00E9trehoz\00F3 v\00E9gfelhaszn\00E1l\00F3 mentheti, nevezheti \00E1t, illetve t\00F6r\00F6lheti. M\00E1s felhaszn\00E1l\00F3k csak megtekinthetik, illetve az elrendez\00E9s\00E9t menthetik m\00E1sik k\00FCl\00F6n kimutat\00E1sk\00E9nt.</li>'),
unistr('<li><strong>Priv\00E1t kimutat\00E1s</strong> (V\00E9gfelhaszn\00E1l\00F3i). Csak a l\00E9trehoz\00F3 v\00E9gfelhaszn\00E1l\00F3 tekintheti meg, mentheti, nevezheti \00E1t, illetve t\00F6r\00F6lheti.</li>'),
'</ul>',
unistr('<p>Ha testre szabott kimutat\00E1sokat ment, a Kimutat\00E1sv\00E1laszt\00F3 a Keres\00E9s s\00E1von a Sorv\00E1laszt\00F3 (ha ez be van kapcsolva) bal oldal\00E1n jelenik meg.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563245368400261)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'hu'
,p_message_text=>unistr('Az egyes kimutat\00E1soldalak tetej\00E9n keres\00E9si ter\00FClet is van. Ez a ter\00FClet (illetve Keres\00E9s s\00E1v) a k\00F6vetkez\0151 funkci\00F3kat biztos\00EDtja:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626279301400307)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('<li>A <strong>M\0171veletek men\00FC</strong> teszi lehet\0151v\00E9 a kimutat\00E1st\00E1bla testreszab\00E1s\00E1t. L\00E1sd a k\00F6vetkez\0151 szakaszokat.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625796010400306)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'hu'
,p_message_text=>unistr('<li>Az <strong>Oszlopok kijel\00F6l\00E9se ikon</strong> teszi lehet\0151v\00E9, hogy azonos\00EDtsa, a keres\00E9s melyik (vagy mindegyik) oszlopban t\00F6rt\00E9njen.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626058796400307)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'hu'
,p_message_text=>unistr('<li>A <strong>Kimutat\00E1sok</strong> megjelen\00EDti az alternat\00EDv alap\00E9rtelmez\00E9st, \00E9s a mentett szem\00E9lyes vagy nyilv\00E1nos kimutat\00E1sokat.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625958173400307)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('<li>A <strong>Sorok</strong> \00E1ll\00EDtja be az oldalank\00E9nt megjelen\00EDtend\0151 sorok sz\00E1m\00E1t.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625867196400306)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>A <strong>Sz\00F6vegter\00FClet</strong> teszi lehet\0151v\00E9 olyan keres\00E9si felt\00E9tel be\00EDr\00E1s\00E1t, amelyikn\00E9l a kisbet\0171 \00E9s a nagybet\0171 azonosnak tekintend\0151 (a helyettes\00EDt\0151 karaktereket is bele\00E9rtve).</li>'),
unistr('<li>Az <strong>Ind\00EDt\00E1s gomb</strong> v\00E9grehajtja a keres\00E9st. Az Enter billenty\0171 lenyom\00E1sa akkor is v\00E9grehajtja a keres\00E9st, amikor a kurzor m\00E9g a keresend\0151 sz\00F6veg mez\0151j\00E9ben van.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626129489400307)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('<li>A <strong>Megtekint\00E9si ikonok</strong> v\00E1ltogat a kimutat\00E1s k\00F6vetkez\0151 n\00E9zetei k\00F6z\00F6tt, ha azok defini\00E1lva lettek: ikon, kimutat\00E1s, r\00E9szlet, diagram, csoportos\00EDt\00E1s \00E9s kimutat\00E1st\00E1bla.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642176109400318)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('A <li><strong>Kezel\00E9s</strong> lehet\0151v\00E9 teszi a tulajdons\00E1gok, az oszlopok, a sorok \00E9s a kimutat\00E1s vagy az adatr\00E1cs megtekint\00E9si el\0151zm\00E9nyeinek kezel\00E9s\00E9t.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563483743400261)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez haszn\00E1lhat\00F3 a megjelen\00EDtett oszlopok m\00F3dos\00EDt\00E1s\00E1ra. A jobbra l\00E9v\0151 oszlopok jelennek meg. A balra l\00E9v\0151 oszlopok rejtettek. A megjelen\00EDtett oszlopok sorrendj\00E9t a jobb sz\00E9len l\00E9v\0151 nyilakkal rendezheti \00E1t. A sz\00E1m\00EDtott oszlopok jel\00F6l\00E9se ez: <strong>**</')
||'strong>.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563679770400261)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ezzel v\00E1ltoztathat\00F3 meg, hogy melyik oszlop legyen rendezve, \00E9s azt is meghat\00E1rozza,'),
unistr('hogy az n\00F6vekv\0151 vagy cs\00F6kken\0151 sorrend\0171 legyen. \00D6n azt is meghat\00E1rozhatja, hogy hogyan kezelend\0151k a'),
unistr('<code>NULL</code> \00E9rt\00E9kek. Az alap\00E9rtelmezett be\00E1ll\00EDt\00E1s szerint a <code>NULL</code> mindig az utols\00F3, vagy mindig az els\0151. '),
unistr('A sorba rendez\00E9s eredm\00E9nye az oszlopfejl\00E9ct\0151l jobbra jelenik meg a kimutat\00E1sban.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623380550400305)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Al\00E1\00EDr\00E1s hozz\00E1ad\00E1sakor \00D6nnek meg kell adni az e-mail-c\00EDmet (vagy t\00F6bb e-mail-c\00EDmet vessz\0151vel elv\00E1lasztva), a lev\00E9l t\00E1rgy\00E1t, gyakoris\00E1g\00E1t,valamint a kezd\0151 \00E9s befejez\0151 d\00E1tumot. Az eredm\00E9ny\00FCl kapott e-mailek tartalmazz\00E1k az aktu\00E1lis interakt\00EDv kimutat\00E1s ')
||unistr('HTML-verzi\00F3j\00E1t annak a kimutat\00E1si be\00E1ll\00EDt\00E1snak a haszn\00E1lat\00E1val, amelyik jelen volt az al\00E1\00EDr\00E1s hozz\00E1ad\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641955025400318)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Az adatr\00E1csok l\00E9nyeg\00E9ben olyan m\00F3dos\00EDthat\00F3 kimutat\00E1sok, amelyek fokozottan testre szabhat\00F3k. A felhaszn\00E1l\00F3k megv\00E1ltoztathatj\00E1k a kimutat\00E1s elrendez\00E9s\00E9t, ha oszlopokat jel\00F6lnek ki, sz\0171r\0151ket haszn\00E1lnak, kiemelnek \00E9s sorba rendeznek. A felhaszn\00E1l\00F3k mega')
||unistr('dhatnak t\00F6r\00E9seket, \00F6sszes\00EDt\00E9seket, diagramokat, csoportos\00EDt\00E1sokat \00E9s egy\00E9b saj\00E1t sz\00E1m\00EDt\00E1sokat. A felhaszn\00E1l\00F3k l\00E9trehozhatnak t\00F6bb v\00E1ltozatot is a kimutat\00E1sb\00F3l, \00E9s azokat n\00E9vvel ell\00E1tva menthetik ak\00E1r nyilv\00E1nos, ak\00E1r saj\00E1t megtekint\00E9sre. '),
'<p/>',
unistr('Az Adatr\00E1cs a Keres\00E9s eszk\00F6zt\00E1r, a M\0171veletek men\00FC, a Kezel\00E9s men\00FC, illetve az Oszlopfejl\00E9c men\00FC haszn\00E1lat\00E1val testre szabhat\00F3.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653764234400327)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'hu'
,p_message_text=>unistr('A M\0171veletek men\00FC az Ugr\00E1s gombt\00F3l jobbra jelenik meg a Keres\00E9si s\00E1von. Ez a men\00FC haszn\00E1lhat\00F3 az adatr\00E1cs-kimutat\00E1shoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642408848400318)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor hozz\00E1ad\00E1sa/szerkeszt\00E9se lap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642501456400318)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sor adatr\00E1csra felv\00E9tel\00E9hez kattintson a Sor hozz\00E1ad\00E1sa ikonra. A sor r\00E9szleteinek szerkeszt\00E9s\00E9hez kattintson a szerkeszteni k\00EDv\00E1nt sorban a Sor szerkeszt\00E9se ikonra (els\0151 oszlop). Megjelenik a Sor hozz\00E1ad\00E1sa/szerkeszt\00E9se lap, megjelen\00EDtve az adatr')
||unistr('\00E1cs oszlopait. </p>'),
'',
unistr('<p>Sor szerkeszt\00E9sekor a k\00F6vetkez\0151 m\0171veletek v\00E9gezhet\0151k:</p>'),
'',
'<p><ul>',
unistr('<li>A <strong>T\00F6rl\00E9s</strong> t\00F6rli a sort.</li>'),
unistr('<li>A <strong>V\00E1ltoztat\00E1sok \00E9rv\00E9nyes\00EDt\00E9se</strong> menti a soron v\00E9gzett \00F6sszes m\00F3dos\00EDt\00E1st.</li>'),
unistr('<li>A <strong>M\0171veletek</strong> k\00F6z\00F6tt megtal\00E1lhat\00F3 a sor hozz\00E1ad\00E1sa, a f\00E1jlok, jegyzetek, hivatkoz\00E1sok vagy c\00EDmk\00E9k hozz\00E1ad\00E1sa \00E9s az el\0151zm\00E9nyek t\00F6rl\00E9se.</li>'),
unistr('<li>L\00E9ptet\00E9s a <strong>K\00F6vetkez\0151 vagy az El\0151z\0151</strong> sorokra.</li>'),
unistr('<li>A <strong>Kezel\00E9s</strong> teszi lehet\0151v\00E9 az oszlop tulajdons\00E1gainak, az oszlopcsoportoknak, \00E9rv\00E9nyes\00EDt\00E9seknek \00E9s \00E9rt\00E9klist\00E1knak a be\00E1ll\00EDt\00E1s\00E1t.</li>'),
'</ul></p>',
'',
unistr('<p>A lap alj\00E1n a Sz\00E9ljegyzetek jelennek meg (ha vannak) a f\00E1jlok, megjegyz\00E9sek, a hivatkoz\00E1sok, illetve olyan c\00EDmk\00E9k, amelyek az aktu\00E1lis sorhoz kapcsol\00F3dnak.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653888547400327)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez haszn\00E1lhat\00F3 egy vagy t\00F6bb oszlop ut\00E1n egy t\00F6r\00E9si csoport elk\00FCl\00F6n\00EDt\00E9s\00E9re. Ez kiveszi az oszlopokat az adatr\00E1cs-kimutat\00E1sb\00F3l, \00E9s k\00FCl\00F6n t\00F6rzsrekordk\00E9nt jelen\00EDti meg azokat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642356292400318)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lehet\0151v\00E9 teszi az aktu\00E1lis eredm\00E9nyhalmaz let\00F6lt\00E9s\00E9t. A let\00F6lthet\0151 form\00E1tumok'),
unistr('a CSV, a HTML \00E9s az E-mail.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653906854400327)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ha testre szab egy adatr\00E1csos kimutat\00E1st, a kimutat\00E1s be\00E1ll\00EDt\00E1sai a'),
unistr('Keres\00E9s eszk\00F6zt\00E1r alatt \00E9s a kimutat\00E1s f\00F6l\00F6tt jelennek meg. Ez a ter\00FClet'),
unistr('a balra tal\00E1lhat\00F3 ikonnal becsukhat\00F3 \00E9s kibonthat\00F3.'),
'<p>',
unistr('Az egyes kimutat\00E1s-be\00E1ll\00EDt\00E1sokn\00E1l a k\00F6vetkez\0151ket teheti:'),
'</>< ul>',
unistr('<li>A n\00E9vre kattintva szerkesztheti a be\00E1ll\00EDt\00E1st.</li>'),
unistr('<li>A be\00E1ll\00EDt\00E1s letilt\00E1s\00E1hoz/enged\00E9lyez\00E9s\00E9hez az Enged\00E9lyez\00E9s/Letilt\00E1s jel\00F6l\0151n\00E9gyzet haszn\00E1lhat\00F3. A be\00E1ll\00EDt\00E1s ideiglenesen is ezzel kapcsolhat\00F3 be \00E9s ki.</li>'),
unistr('<li>Be\00E1ll\00EDt\00E1st az Elt\00E1vol\00EDt\00E1s ikonnal t\00E1vol\00EDthat el.</li>'),
'</ul>',
unistr('<p>Ha diagramot vagy csoportos\00EDt\00E1st hozott l\00E9tre, v\00E1ltogathat k\00F6z\00F6tt\00FCk \00E9s az'),
unistr('alapkimutat\00E1s k\00F6z\00F6tt a Jelent\00E9s, a Diagram vagy a Csoportos\00EDt\00E1s n\00E9zet jobbra'),
unistr('l\00E1that\00F3 hivatkoz\00E1s\00E1val. A diagram vagy a csoportos\00EDt\00E1s megtekint\00E9sekor \00D6n'),
unistr('m\00F3dos\00EDthatja be\00E1ll\00EDt\00E1sokat a Szerkeszt\00E9s hivatkoz\00E1s haszn\00E1lat\00E1val.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642244039400318)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Menti a testre szabott adatr\00E1cs kimutat\00E1s\00E1nak elrendez\00E9s\00E9t a j\00F6v\0151beli haszn\00E1lathoz. \00D6nnek meg kell adni az adatr\00E1cs kimutat\00E1s-elrendez\00E9s\00E9nek nev\00E9t \00E9s opcion\00E1lisan a le\00EDr\00E1st. Az adatr\00E1cs kimutat\00E1s-elrendez\00E9s\00E9nek h\00E1rom t\00EDpusa menthet\0151:</p>'),
'<ul>',
unistr('<li><strong>Els\0151dleges alap\00E9rtelmez\00E9s</strong> (Csak rendszergazd\00E1knak). Az Els\0151dleges alap\00E9rtelmez\00E9s az az elrendez\00E9s, amelyik a kezdetkor jelenik meg. Az Els\0151dleges alap\00E9rtelmez\00E9s nem nevezhet\0151 \00E1t, \00E9s nem is t\00F6r\00F6lhet\0151.</li>'),
unistr('<li><strong>Alternat\00EDv kimutat\00E1s</strong> (Csak rendszergazd\00E1knak). Lehet\0151v\00E9 teszi, hogy a rendszergazd\00E1k t\00F6bb kimutat\00E1s-elrendez\00E9st is l\00E9trehozzanak. Alternat\00EDv kimutat\00E1st csak a rendszergazd\00E1k nevezhetnek \00E1t, illetve csak \0151k t\00F6r\00F6lhetik.</li>'),
unistr('<li><strong>Priv\00E1t kimutat\00E1s</strong> (Minden felhaszn\00E1l\00F3). Csak a kimutat\00E1s-elrendez\00E9st l\00E9trehoz\00F3 felhaszn\00E1l\00F3 tekintheti meg, mentheti, nevezheti \00E1t, illetve t\00F6r\00F6lheti a kimutat\00E1st.</li>'),
'</ul>',
unistr('<p>Ha testre szabott kimutat\00E1sokat ment, a Kimutat\00E1sv\00E1laszt\00F3 a Keres\00E9s s\00E1von a Sorv\00E1laszt\00F3 (ha ez be van kapcsolva) bal oldal\00E1n jelenik meg.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568362043400265)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlop elrejt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558910040400258)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kiemel\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569865295400266)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kiemel\00E9sek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574915379400269)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'hu'
,p_message_text=>unistr('Felt\00E9tel kiemel\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623916616400305)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'hu'
,p_message_text=>unistr('St\00EDlus kiemel\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533988961400240)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00EDpus kiemel\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643406951400319)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00EDzszintes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673056240400341)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'hu'
,p_message_text=>unistr('1 inakt\00EDv be\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673138925400341)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 inakt\00EDv be\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564984773400262)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'hu'
,p_message_text=>unistr('Interakt\00EDv kimutat\00E1s s\00FAg\00F3ja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575912775400270)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569359942400265)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen sz\00E1m\00EDt\00E1si kifejez\00E9s. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528737270400236)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('A z\00E1r\00F3 d\00E1tumnak k\00E9s\0151bbinek kell lennie a kezd\0151 d\00E1tumn\00E1l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583604755400276)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen sz\0171r\00E9si kifejez\00E9s. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651444446400325)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen sz\0171r\0151lek\00E9rdez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673240053400341)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'hu'
,p_message_text=>unistr('1 \00E9rv\00E9nytelen be\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673393960400341)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00E9rv\00E9nytelen be\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624126084400305)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'hu'
,p_message_text=>'(percben)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641100824400317)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a legut\00F3bbiban: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641347558400318)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 a k\00F6vetkez\0151ben: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641254762400318)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a legut\00F3bbiban: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641417422400318)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nem a k\00F6vetkez\0151ben: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574089754400269)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'hu'
,p_message_text=>unistr('Billenty\0171zet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540119511400244)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDmke %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567945541400264)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tengelyc\00EDm a felirathoz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560438265400259)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560669908400259)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 \00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560144749400259)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 h\00F3nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560201522400259)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 h\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560363374400259)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560505993400259)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 \00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559917466400259)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 %0 \00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560040333400259)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 \00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540043035400244)
,p_name=>'APEXIR_LINE'
,p_message_language=>'hu'
,p_message_text=>'Vonaldiagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536806988400242)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'hu'
,p_message_text=>unistr('Grafikon \00E9s ter\00FCletdiagram')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651366633400325)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00E9pezze le ezt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568816107400265)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'hu'
,p_message_text=>unistr('Becsl\00E9s szerint a lek\00E9rdez\00E9s t\00FAl fogja l\00E9pni az er\0151forr\00E1sok megengedett korl\00E1tj\00E1t. M\00F3dos\00EDtsa a kimutat\00E1s be\00E1ll\00EDt\00E1sait \00E9s pr\00F3b\00E1lja meg \00FAjra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551089533400252)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'hu'
,p_message_text=>unistr('A kimutat\00E1sban a sorok maxim\00E1lis sz\00E1ma %0. Adjon meg megfelel\0151 sz\0171r\0151felt\00E9teleket, hogy korl\00E1tozza a rekordok sz\00E1m\00E1t a lek\00E9rdez\00E9sben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651903452400325)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'hu'
,p_message_text=>'Maximum: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652158774400326)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6z\00E9p\00E9rt\00E9k: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555065594400255)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 perccel ezel\0151tt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652096102400325)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'hu'
,p_message_text=>'Minimum: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651080930400325)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('H\00F3nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624589865400306)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'hu'
,p_message_text=>'Havonta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567167975400264)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1thelyez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567079723400264)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mind \00E1thelyez\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678287249400345)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('A r\00E9gi\00F3 statikus azonos\00EDt\00F3j\00E1t meg kell adni, mivel az oldal t\00F6bb interakt\00EDv kimutat\00E1st tartalmaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535582699400241)
,p_name=>'APEXIR_NAME'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562930612400261)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DAj \00F6sszevon\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673977046400342)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DAj kateg\00F3ria')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112563027266400261)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DAj sz\00E1m\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557872579400257)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560907205400259)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560780472400259)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 \00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561267422400260)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 h\00F3nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561131901400260)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 h\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561017406400259)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112560807367400259)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 \00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561419751400260)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 %0 \00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561346342400260)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 \00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535832170400241)
,p_name=>'APEXIR_NO'
,p_message_language=>'hu'
,p_message_text=>'Nem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576152187400270)
,p_name=>'APEXIR_NONE'
,p_message_language=>'hu'
,p_message_text=>unistr('- \00DCres -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623702022400305)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen e-mail-c\00EDm.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572691505400268)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'hu'
,p_message_text=>unistr('A null \00E9rt\00E9kek mindig az els\0151k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572552453400268)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('A null \00E9rt\00E9kek mindig az utols\00F3k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573054392400268)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'hu'
,p_message_text=>unistr('Null \00E9rt\00E9k rendez\00E9se: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569447364400266)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'hu'
,p_message_text=>unistr('A visszatekint\00E9si id\0151 csak sz\00E1m lehet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569082931400265)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'hu'
,p_message_text=>unistr('A sorrend csak sz\00E1m alap\00FA lehet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573580555400268)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'hu'
,p_message_text=>unistr('Oper\00E1tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534490132400240)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'hu'
,p_message_text=>unistr('narancss\00E1rga')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643377916400319)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00E1jol\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536399132400242)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'hu'
,p_message_text=>unistr('Egy\00E9b')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519149339400229)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldalt\00E1jol\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519899815400229)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'hu'
,p_message_text=>unistr('Fekv\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519909238400229)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1ll\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519035145400229)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldalm\00E9ret')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519647408400229)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'hu'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519503444400229)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'hu'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519709304400229)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'hu'
,p_message_text=>unistr('Egy\00E9ni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519368545400229)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'hu'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519261672400229)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'hu'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112519422469400229)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'hu'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652433786400326)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'hu'
,p_message_text=>unistr('A teljes %0 mennyis\00E9g sz\00E1zal\00E9ka (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651679000400325)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'hu'
,p_message_text=>unistr('A teljes %0 \00F6sszeg sz\00E1zal\00E9ka (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650662508400324)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('A teljes mennyis\00E9g sz\00E1zal\00E9ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650527410400324)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'hu'
,p_message_text=>unistr('A teljes \00F6sszeg sz\00E1zal\00E9ka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539905156400244)
,p_name=>'APEXIR_PIE'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6rdiagram')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599802183400288)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1st\00E1bla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601372388400289)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Meg kell adni az \00F6sszes\00EDt\00E9st.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601536061400289)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'hu'
,p_message_text=>unistr('Soroszlopk\00E9nt kijel\00F6lt oszlopon nem lehet \00F6sszes\00EDteni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600767620400289)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1soszlopok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600506105400288)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1soszlop %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601146697400289)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Meg kell adni a forgat\00E1si oszlopot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501232029400216)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s t\00EDpus\00FA lek\00E9rdez\00E9shez a sorok maxim\00E1lis sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben l\00E9v\0151 sorok sz\00E1ma korl\00E1tozza, nem a megjelen\00EDtett sorok sz\00E1ma. Ez az alap lek\00E9rdez\00E9s t\00FAll\00E9pi a sorok megengedett sz\00E1m\00E1t, ami %0. Haszn\00E1ljon sz\0171r\0151t, hogy cs\00F6kkentse a rekordo')
||unistr('k sz\00E1m\00E1t az alap lek\00E9rdez\00E9sben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601024407400289)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s sorba rendez\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570436251400266)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'hu'
,p_message_text=>unistr('A kimutat\00E1soszlop t\00FAl sok elt\00E9r\0151 \00E9rt\00E9ket tartalmaz - nem \00E1ll\00EDthat\00F3 el\0151 a kimutat\00E1s SQL utas\00EDt\00E1sa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623836371400305)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151n\00E9zet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557940870400257)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112649560718400324)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151dleges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624805068400306)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151dleges kimutat\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518954725400229)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'hu'
,p_message_text=>unistr('El\00E9rhet\0151s\00E9gi c\00EDmk\00E9kkel egy\00FCtt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505843467400219)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Rich Text lefejt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582666396400275)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Szem\00E9lyes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540573861400245)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'hu'
,p_message_text=>unistr('Nyilv\00E1nos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536141220400241)
,p_name=>'APEXIR_RED'
,p_message_language=>'hu'
,p_message_text=>'piros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678154440400345)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 r\00E9gi\00F3 statikus azonos\00EDt\00F3ja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567200623400264)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Elt\00E1vol\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567359278400264)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mind elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673437195400341)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagram elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566819273400264)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\0151 t\00F6r\00E9spont elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566555437400263)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\0171r\0151 elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566695852400264)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'hu'
,p_message_text=>unistr('Visszatekint\00E9s elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673501894400341)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1si szempont elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566975678400264)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kiemel\00E9s elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673679835400341)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654609715400327)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s elt\00E1vol\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635257035400313)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett kimutat\00E1s \00E1tnevez\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576421430400271)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s \00E1tnevez\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558205487400257)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652500088400326)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1sok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532730114400239)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik %0 m\00E1sodlagos nev\0171 mentett interakt\00EDv kimutat\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582976739400275)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A kimutat\00E1s nem l\00E9tezik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532874319400239)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik %0 azonos\00EDt\00F3j\00FA mentett interakt\00EDv kimutat\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112574786524400269)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s be\00E1ll\00EDt\00E1sai')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555583628400255)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1sn\00E9zet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559488303400258)
,p_name=>'APEXIR_RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Vissza\00E1ll\00EDt\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540727984400245)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s vissza\00E1ll\00EDt\00E1sa az alap\00E9rtelmezett be\00E1ll\00EDt\00E1sokra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535988763400241)
,p_name=>'APEXIR_ROW'
,p_message_language=>'hu'
,p_message_text=>'Sor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648688290400323)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'hu'
,p_message_text=>unistr('A ROWID nem haszn\00E1lhat\00F3, mivel az a REST adatforr\00E1s els\0151dleges kulcsoszlopa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565907922400263)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'hu'
,p_message_text=>'Sorok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625543244400306)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'hu'
,p_message_text=>'Sor/oldal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600884450400289)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>'Soroszlopok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600631424400288)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'hu'
,p_message_text=>'Soroszlop %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601258037400289)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Meg kell adni a sorok oszlop\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601459439400289)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'hu'
,p_message_text=>unistr('A soroszlop nem lehet azonos a kimutat\00E1soszloppal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580072181400273)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorsz\0171r\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555686392400256)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'hu'
,p_message_text=>unistr('%0. sor, \00F6sszesen %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559635633400258)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'hu'
,p_message_text=>unistr('A sor sz\00F6vege tartalmazza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535264323400241)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ment\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570095835400266)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Mentett kimutat\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569994675400266)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'hu'
,p_message_text=>unistr('Mentett kimutat\00E1s = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572174705400267)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelenlegi be\00E1ll\00EDt\00E1sok lesznek alap\00E9rtelmezettk\00E9nt haszn\00E1lva minden felhaszn\00E1l\00F3n\00E1l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112635136006400313)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett kimutat\00E1s ment\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112559328829400258)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s ment\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673875956400342)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s ment\00E9se*')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626588608400307)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112564830823400262)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s s\00E1v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112673727738400341)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632059293400311)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s keres\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616011114400299)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Kijel\00F6lt oszlopok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536994405400242)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('- Oszlop kijel\00F6l\00E9se -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558657322400258)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Oszlopok kijel\00F6l\00E9se')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540413249400244)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('- F\00FCggv\00E9ny kiv\00E1laszt\00E1sa -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565679956400263)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('- Oszlop alap\00FA csoportos\00EDt\00E1s v\00E1laszt\00E1sa -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600343646400288)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('- Kimutat\00E1soszlop kijel\00F6l\00E9se -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651532795400325)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor kijel\00F6l\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600402070400288)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('- Kimutat\00E1ssor kijel\00F6l\00E9se -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509173087400221)
,p_name=>'APEXIR_SEND'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCld\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515416599400226)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00FCld\00E9s e-mailk\00E9nt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535665717400241)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'hu'
,p_message_text=>'Sorrend'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558827897400258)
,p_name=>'APEXIR_SORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568166637400265)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00F6vekv\0151 sorrend')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568235891400265)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('Cs\00F6kken\0151 sorrend')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654017824400327)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'hu'
,p_message_text=>unistr('Rendez\00E9si sorrend')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562606947400261)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'hu'
,p_message_text=>unistr('sz\00F3k\00F6z')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573713306400269)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1llapot: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624216598400305)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151fizet\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650987323400325)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'hu'
,p_message_text=>unistr('Befejez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505307436400219)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'hu'
,p_message_text=>unistr('Kihagy\00E1s, ha nincs adat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112650880680400325)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'hu'
,p_message_text=>unistr('Kezd\00E9s innen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651768885400325)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszesen: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641703476400318)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9gi\00F3 = %0, Kimutat\00E1s = %1, N\00E9zet = %2, Megjelen\00EDtett sorok kezdete = %3, Megjelen\00EDtett sorok v\00E9ge = %4, \00D6sszes sor = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562372224400260)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9gi\00F3 = %0, Kimutat\00E1s = %1, N\00E9zet = %2, Megjelen\00EDtett sorok kezdete = %3, Megjelen\00EDtett sorok v\00E9ge = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534541326400240)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00F6vegsz\00EDn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551621966400253)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'hu'
,p_message_text=>'nap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551521141400252)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551443551400252)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'hu'
,p_message_text=>'perc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551833685400253)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('h\00F3nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551784741400253)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('h\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112551946574400253)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112654471778400327)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1lt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567491597400264)
,p_name=>'APEXIR_TOP'
,p_message_language=>'hu'
,p_message_text=>unistr('Fel\00FClre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647619265400322)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem csoportos\00EDtott oszlop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568985040400265)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'hu'
,p_message_text=>unistr('A kiemel\00E9s neve csak egyedi lehet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539245713400244)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('nem t\00E1mogatott adatt\00EDpus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567595028400264)
,p_name=>'APEXIR_UP'
,p_message_language=>'hu'
,p_message_text=>'Feljebb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569100593400265)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'hu'
,p_message_text=>unistr('Adjon meg egy \00E9rv\00E9nyes sz\00EDnt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569258200400265)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'hu'
,p_message_text=>unistr('Adjon meg egy \00E9rv\00E9nyes form\00E1tummaszkot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112536420073400242)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112568086158400265)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Tengelyc\00EDm az \00E9rt\00E9khez')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575812977400270)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rt\00E9ket kell megadni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539821563400244)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCgg\0151leges oszlop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112643547720400319)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00FCgg\0151leges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575152407400270)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'hu'
,p_message_text=>unistr('Diagram megtekint\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630318157400310)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9szletek megtekint\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112675934479400343)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A kimutat\00E1shoz nincs defini\00E1lva %0 n\00E9zet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630448717400310)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Csoportos\00EDt\00E1si szempont megtekint\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630283768400310)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'hu'
,p_message_text=>unistr('Megtekint\00E9si ikonok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600134705400288)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1st\00E1bla megtekint\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112575237891400270)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s megtekint\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624413043400305)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'hu'
,p_message_text=>'Hetente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558168755400257)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Akt\00EDv kimutat\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653156737400326)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'hu'
,p_message_text=>'%0 nap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653090049400326)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112652903634400326)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'hu'
,p_message_text=>'%0 perc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653395396400326)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 h\00F3nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653231999400326)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 h\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112653433063400326)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112651128171400325)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112534226152400240)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'hu'
,p_message_text=>unistr('s\00E1rga')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112535776781400241)
,p_name=>'APEXIR_YES'
,p_message_language=>'hu'
,p_message_text=>'Igen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112567871883400264)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 tartalmaz < vagy > karaktert, melyek \00E9rv\00E9nytelenek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112590686747400281)
,p_name=>'APEX_REGION'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9gi\00F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112518842062400229)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'hu'
,p_message_text=>unistr('API el\0151felt\00E9tel megs\00E9rt\00E9se')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538340812400243)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lehet \00E9rt\00E9ket beolvasni a(z) %0 alkalmaz\00E1sbe\00E1ll\00EDt\00E1shoz, mert a kapcsol\00F3d\00F3 build be\00E1ll\00EDt\00E1sa letiltott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538205880400243)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lehet \00E9rt\00E9ket be\00E1ll\00EDtani (z) %0 alkalmaz\00E1sbe\00E1ll\00EDt\00E1shoz, mert a kapcsol\00F3d\00F3 build be\00E1ll\00EDt\00E1sa letiltott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645935161400321)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen az alkalmaz\00E1si be\00E1ll\00EDt\00E1s %0 \00E9rt\00E9ke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112645891714400321)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lett defini\00E1lva a lek\00E9rt %0 alkalmaz\00E1si be\00E1ll\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646086623400321)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 alkalmaz\00E1si be\00E1ll\00EDt\00E1s nem \00E1ll\00EDthat\00F3 be null \00E9rt\00E9kre')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526992130400235)
,p_name=>'BACK'
,p_message_language=>'hu'
,p_message_text=>'Vissza'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513914665400225)
,p_name=>'BUILDER'
,p_message_language=>'hu'
,p_message_text=>unistr('Szerkeszt\0151')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578072736400272)
,p_name=>'BUTTON LABEL'
,p_message_language=>'hu'
,p_message_text=>'Gomb felirata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513054452400224)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'hu'
,p_message_text=>unistr('Gomb CSS-oszt\00E1lyai')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542228381400246)
,p_name=>'BUTTON_ID'
,p_message_language=>'hu'
,p_message_text=>unistr('A gener\00E1lt gombazonos\00EDt\00F3 a gomb statikus azonos\00EDt\00F3ja lesz, ha lett defini\00E1lva, vagy ha nem, akkor pedig egy bels\0151leg el\0151\00E1ll\00EDtott, ''B'' || [Internal Button ID] form\00E1tum\00FA azonos\00EDt\00F3 lesz')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505772521400219)
,p_name=>'CANDLESTICK'
,p_message_language=>'hu'
,p_message_text=>unistr('Gyertyatart\00F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587244937400278)
,p_name=>'CENTER'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6z\00E9pre')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537204051400242)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 k\00E9relem')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528625245400236)
,p_name=>'CHECK$'
,p_message_language=>'hu'
,p_message_text=>unistr('sorv\00E1laszt\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112647763500400322)
,p_name=>'CHECKED'
,p_message_language=>'hu'
,p_message_text=>unistr('bejel\00F6lve')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623212720400305)
,p_name=>'COLUMN'
,p_message_language=>'hu'
,p_message_text=>'Oszlop'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583746765400276)
,p_name=>'COMMENTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjegyz\00E9sek')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565223088400263)
,p_name=>'CONTINUE'
,p_message_language=>'hu'
,p_message_text=>unistr('Folytat\00E1s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527220898400235)
,p_name=>'COPYRIGHT'
,p_message_language=>'hu'
,p_message_text=>'Copyright &copy; %0. Minden jog fenntartva.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570983198400267)
,p_name=>'COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('Mennyis\00E9g')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577603037400271)
,p_name=>'CREATE'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E9trehoz\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629969525400309)
,p_name=>'CREATED'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E9trehozva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630021648400310)
,p_name=>'CREATED_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E9trehozta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554881140400255)
,p_name=>'CREATED_ON'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E9trehoz\00E1s d\00E1tuma')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565497273400263)
,p_name=>'CUSTOM'
,p_message_language=>'hu'
,p_message_text=>unistr('Egy\00E9ni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576615938400271)
,p_name=>'CUSTOMIZE'
,p_message_language=>'hu'
,p_message_text=>unistr('Testreszab\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578216123400272)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Az oldalbe\00E1ll\00EDt\00E1sok vissza\00E1ll\00EDt\00E1sa %0 felhaszn\00E1l\00F3 r\00E9sz\00E9re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578311040400272)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 felhaszn\00E1l\00F3 r\00E9sz\00E9re megv\00E1ltoztak a be\00E1ll\00EDt\00E1sok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578127932400272)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Az oldalbe\00E1ll\00EDt\00E1sok vissza\00E1ll\00EDt\00E1sa %0 felhaszn\00E1l\00F3 r\00E9sz\00E9re.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541954489400246)
,p_name=>'DAILY'
,p_message_language=>'hu'
,p_message_text=>'Naponta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112513524320400225)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'hu'
,p_message_text=>unistr('A felt\00F6lt\00F6tt f\00E1jl \00E9rv\00E9nytelen vagy rossz a kiterjeszt\00E9se.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537495927400242)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen XML vagy JSON kijel\00F6l\0151 van haszn\00E1latban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506764228400220)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatprofil \00E9s a felt\00F6lt\00F6tt f\00E1jl nem tartalmaz c\00E9lk\00E9nt megjel\00F6lt t\00E1bl\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592441919400282)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 adat a felt\00F6lt\00F6tt f\00E1jlban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592554997400282)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 adat a(z) "%0" munkalapon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112512337659400224)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'hu'
,p_message_text=>unistr('A megadott f\00E1jl nem XLSX f\00E1jl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112502779547400217)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatbet\00F6lt\00E9s befejez\0151d\00F6tt: %0 sor lett feldolgozva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503919811400218)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatbet\00F6lt\00E9s befejez\0151d\00F6tt: %0 sor lett feldolgozva, 1 hib\00E1val.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504234580400218)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatbet\00F6lt\00E9s befejez\0151d\00F6tt: %0 sor lett feldolgozva, %1 hib\00E1val.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504016906400218)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatbet\00F6lt\00E9s befejez\0151d\00F6tt: 1 sor lett feldolgozva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507092984400220)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatbet\00F6lt\00E9s befejez\0151d\00F6tt: 1 sor lett feldolgozva, hib\00E1val.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504112612400218)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatbet\00F6lt\00E9s befejez\0151d\00F6tt: 1 sor lett feldolgozva, hiba n\00E9lk\00FCl.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597759234400286)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00E9loszlop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597847419400286)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'hu'
,p_message_text=>unistr('Forr\00E1soszlop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598652313400287)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('D\00E1tum-/Sz\00E1mform\00E1tum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662098838400333)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem siker\00FClt beolvasni az \00E9rt\00E9klista \00E9rt\00E9k\00E9t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112630572469400310)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'hu'
,p_message_text=>unistr('Adatok / T\00E1bla lek\00E9pez\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598752082400287)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'hu'
,p_message_text=>'Sor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594290808400283)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'hu'
,p_message_text=>unistr('Sikertelen az \00E1talak\00EDt\00E1s szab\00E1ly v\00E9grehajt\00E1sa')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570520222400266)
,p_name=>'DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('D\00E1tum')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544606713400247)
,p_name=>'DAY'
,p_message_language=>'hu'
,p_message_text=>'nap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544733907400248)
,p_name=>'DAYS'
,p_message_language=>'hu'
,p_message_text=>'nap'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583457852400276)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'hu'
,p_message_text=>unistr('A hibakeres\00E9s nem enged\00E9lyezett enn\00E9l az alkalmaz\00E1sn\00E1l.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112632229929400311)
,p_name=>'DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545473520400248)
,p_name=>'DELETE'
,p_message_language=>'hu'
,p_message_text=>unistr('t\00F6rl\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112505616275400219)
,p_name=>'DIAL_PCT'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00E1mt\00E1rcsa (sz\00E1zal\00E9kos)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520138974400230)
,p_name=>'DOWNLOAD'
,p_message_language=>'hu'
,p_message_text=>unistr('Let\00F6lt\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631330385400310)
,p_name=>'DUP_USER'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 felhaszn\00E1l\00F3n\00E9v tal\00E1lhat\00F3 a list\00E1ban.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527770458400235)
,p_name=>'EDIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Szerkeszt\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537175880400242)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" e-mail-c\00EDm nem tal\00E1lhat\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522240277400231)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Az e-mail felad\00F3ja: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631560659400311)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'hu'
,p_message_text=>unistr('Az e-mail-c\00EDm t\00FAl hossz\00FA. A korl\00E1t 240 karakter.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565171460400262)
,p_name=>'ERROR'
,p_message_language=>'hu'
,p_message_text=>'Hiba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594371239400284)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lehet be\00E1ll\00EDtani az oldalelem forr\00E1s\00E9rt\00E9k\00E9t a r\00E9szleges oldalfriss\00EDt\00E9si r\00E9gi\00F3ban')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556635267400256)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E9trehozta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522563383400231)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Lej\00E1rt a jelsz\00F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112516677913400227)
,p_name=>'FILE_EMPTY'
,p_message_language=>'hu'
,p_message_text=>unistr('A f\00E1jl \00FCres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596853820400286)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'hu'
,p_message_text=>unistr('A felt\00F6lt\00F6tt f\00E1jl m\00E9rete t\00F6bb, mint %0 MB volt. Kisebb f\00E1jlt t\00F6lts\00F6n fel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524669527400233)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem siker\00FClt a felhaszn\00E1l\00F3-hiteles\00EDt\00E9s, \00E9s egy vagy t\00F6bb f\00E1jl nem lett felt\00F6ltve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524724246400233)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez a p\00E9ld\00E1ny nem engedi meg, hogy hiteles\00EDt\00E9s n\00E9lk\00FCli felhaszn\00E1l\00F3k f\00E1jlokat t\00F6ltsenek fel.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577775209400271)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('1 hiba t\00F6rt\00E9nt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576906025400271)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 hiba t\00F6rt\00E9nt')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527130847400235)
,p_name=>'FORM_OF'
,p_message_language=>'hu'
,p_message_text=>'%1/%0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561822397400260)
,p_name=>'GO'
,p_message_language=>'hu'
,p_message_text=>unistr('Ugr\00E1s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661688356400332)
,p_name=>'HELP'
,p_message_language=>'hu'
,p_message_text=>unistr('S\00FAg\00F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514076756400225)
,p_name=>'HOME'
,p_message_language=>'hu'
,p_message_text=>unistr('Kezd\0151lap')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544454701400247)
,p_name=>'HOUR'
,p_message_language=>'hu'
,p_message_text=>unistr('\00F3ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544581266400247)
,p_name=>'HOURS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00F3ra')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528578643400236)
,p_name=>'ICON'
,p_message_language=>'hu'
,p_message_text=>'%0 ikon'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578576376400272)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen bejelentkez\00E9si hiteles\00EDt\0151 adatok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112678047246400345)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen \00E9rt\00E9k a param\00E9ter sz\00E1m\00E1ra: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573267522400268)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett kimutat\00E1si be\00E1ll\00EDt\00E1sok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573346676400268)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Megnevezett kimutat\00E1sk\00E9nt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555744536400256)
,p_name=>'IR_ERROR'
,p_message_language=>'hu'
,p_message_text=>'%0 hiba. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555415942400255)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem sz\00E1molhat\00F3 ki a navig\00E1l\00E1s az \0171rlapon. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533040487400239)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 interakt\00EDv kimutat\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532425074400239)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 alkalmaz\00E1s, %1 lapj\00E1n \00E9s %2 r\00E9gi\00F3j\00E1ban nem l\00E9tezik interakt\00EDv kimutat\00E1si r\00E9gi\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112573135951400268)
,p_name=>'IR_STAR'
,p_message_language=>'hu'
,p_message_text=>unistr('Csak a fejleszt\0151k l\00E1thatj\00E1k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561542418400260)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('A kimutat\00E1s lek\00E9rdez\00E9s\00E9hez az egyes sorok azonos\00EDt\00E1s\00E1hoz egyedi kulcs sz\00FCks\00E9ges. A megadott kulcs nem haszn\00E1lhat\00F3 ehhez a lek\00E9rdez\00E9shez. Adja meg az egyedi kulcs oszlop\00E1t. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561640229400260)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'hu'
,p_message_text=>unistr('A kimutat\00E1s lek\00E9rdez\00E9s\00E9hez az egyes sorok azonos\00EDt\00E1s\00E1hoz egyedi kulcs sz\00FCks\00E9ges. A megadott kulcs nem haszn\00E1lhat\00F3 ehhez a lek\00E9rdez\00E9shez. M\00F3dos\00EDtsa a kimutat\00E1s attrib\00FAtumait, hogy megadja az egyedi kulcs oszlop\00E1t. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598907575400287)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00E1jl kiv\00E1laszt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598863958400287)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00E1jl \00E1th\00FAz\00E1sa ide vagy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527486312400235)
,p_name=>'ITEMS'
,p_message_language=>'hu'
,p_message_text=>'Elemek'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556875885400256)
,p_name=>'ITEM_VALUE'
,p_message_language=>'hu'
,p_message_text=>unistr('Elem \00E9rt\00E9ke')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571287752400267)
,p_name=>'LABEL'
,p_message_language=>'hu'
,p_message_text=>'Felirat'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583389409400276)
,p_name=>'LANGUAGE'
,p_message_language=>'hu'
,p_message_text=>'Nyelv'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545147315400248)
,p_name=>'LAST'
,p_message_language=>'hu'
,p_message_text=>unistr('utols\00F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524506239400233)
,p_name=>'LENGTH'
,p_message_language=>'hu'
,p_message_text=>'Hossz'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577838533400272)
,p_name=>'LOGIN'
,p_message_language=>'hu'
,p_message_text=>unistr('Bejelentkez\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616483265400300)
,p_name=>'MANAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Kezel\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112681037088400347)
,p_name=>'MAXIMIZE'
,p_message_language=>'hu'
,p_message_text=>unistr('Teljes m\00E9ret')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544259104400247)
,p_name=>'MINUTE'
,p_message_language=>'hu'
,p_message_text=>'perc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544337892400247)
,p_name=>'MINUTES'
,p_message_language=>'hu'
,p_message_text=>'perc'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631730223400311)
,p_name=>'MISSING_AT'
,p_message_language=>'hu'
,p_message_text=>unistr('Hi\00E1nyzik a kukac (@) az e-mail-c\00EDmben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631948604400311)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'hu'
,p_message_text=>unistr('Figyelmeztet\00E9s: A(z) %1 alkalmaz\00E1sban a(z) %0 p\00E1rbesz\00E9dpanel-laphoz nincs defini\00E1lva p\00E1rbesz\00E9dpanel-lapi sablon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631670280400311)
,p_name=>'MISSING_DOT'
,p_message_language=>'hu'
,p_message_text=>unistr('Hi\00E1nyzik a pont (.) az e-mail-c\00EDm tartom\00E1ny\00E1ban.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580880785400274)
,p_name=>'MODULE'
,p_message_language=>'hu'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537941223400243)
,p_name=>'MONTH'
,p_message_language=>'hu'
,p_message_text=>unistr('H\00F3nap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541763761400245)
,p_name=>'MONTHLY'
,p_message_language=>'hu'
,p_message_text=>'Havonta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538018147400243)
,p_name=>'MONTHS'
,p_message_language=>'hu'
,p_message_text=>unistr('h\00F3nap')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570891314400267)
,p_name=>'MOVE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1thelyez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638316494400315)
,p_name=>'MOVE_FROM'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1thelyez\00E9s innen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638411154400316)
,p_name=>'MOVE_TO'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C1thelyez\00E9s ide')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112558012572400257)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a t\00F6bbsoros t\00F6rl\00E9si m\0171veletben: sor= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557079590400257)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lehet nyilv\00E1nos felhaszn\00E1l\00F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514218759400225)
,p_name=>'NAME'
,p_message_language=>'hu'
,p_message_text=>unistr('N\00E9v')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571036726400267)
,p_name=>'NEW'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DAj')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537765494400243)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 fi\00F3kba bejelentkez\00E9shez l\00E9pjen ide:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537831920400243)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rtes\00EDt\00E9s az \00FAj %0 fi\00F3kr\00F3l')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661807170400333)
,p_name=>'NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580712065400274)
,p_name=>'NO'
,p_message_language=>'hu'
,p_message_text=>'Nem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112676025425400343)
,p_name=>'NOBODY'
,p_message_language=>'hu'
,p_message_text=>'senki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545556237400248)
,p_name=>'NOT'
,p_message_language=>'hu'
,p_message_text=>'Nem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586343102400278)
,p_name=>'NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>'Nem Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557123617400257)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'hu'
,p_message_text=>'Nem %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576724027400271)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'hu'
,p_message_text=>'nincs adat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585899147400277)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 m\00F3dos\00EDthat\00F3 kimutat\00E1s. A t\00F6bb sort m\00F3dos\00EDt\00F3 \00E9s t\00F6rl\0151 m\0171velet csak a ''M\00F3dos\00EDthat\00F3 kimutat\00E1s'' t\00EDpus\00FA t\00E1bl\00E1zatos form\00E1tumokon v\00E9gezhet\0151.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586744231400278)
,p_name=>'OK'
,p_message_language=>'hu'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582407021400275)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'hu'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112679815386400346)
,p_name=>'ORA_06550'
,p_message_language=>'hu'
,p_message_text=>'ORA-06550: %0. sor, %1. oszlop'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629382580400309)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6n elavult webb\00F6ng\00E9sz\0151t haszn\00E1l. A t\00E1mogatott b\00F6ng\00E9sz\0151k list\00E1j\00E1t n\00E9zze meg az Oracle Application Express telep\00EDt\00E9si \00FAtmutat\00F3j\00E1ban.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530710498400237)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen sork\00E9szlet lett lek\00E9rve, a kimutat\00E1s forr\00E1sadata megv\00E1ltozott.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550832296400252)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nyes oldalsz\00E1mot kell megadni, p\00E9ld\00E1ul: p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554497106400255)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554562699400255)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6vetkez\0151 csoport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554663111400255)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112554770989400255)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151 csoport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661757871400333)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldalt\00F6rdel\00E9s kiv\00E1laszt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592381276400282)
,p_name=>'PASSWORD'
,p_message_language=>'hu'
,p_message_text=>unistr('Jelsz\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537002759400242)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 jelszava megv\00E1ltozott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526814457400235)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3 nem felel meg az enn\00E9l a webhelyn\00E9l \00E9rv\00E9nyes jelsz\00F3bonyolults\00E1gi szab\00E1lyoknak.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525927889400234)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00FAj jelsz\00F3nak legal\00E1bb %0 karakterben k\00FCl\00F6nb\00F6znie kell a r\00E9gi jelsz\00F3t\00F3l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526576648400234)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3 nem tartalmazhatja a felhaszn\00E1l\00F3nevet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526761383400234)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3 nem tartalmazhat egyszer\0171 tiltott szavakat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526602397400234)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3 nem tartalmazhatja a munkahely nev\00E9t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525856542400234)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3nak legal\00E1bb %0 karaktert kell tartalmaznia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526087952400234)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3nak legal\00E1bb egy bet\0171karaktert (%0) kell tartalmaznia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526423553400234)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3nak legal\00E1bb egy kisbet\0171s karaktert kell tartalmaznia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526176737400234)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3nak legal\00E1bb egy numerikus karaktert (0123456789) kell tartalmaznia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526209232400234)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3nak legal\00E1bb egy \00EDr\00E1sjelet (%0) kell tartalmaznia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112526306388400234)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A jelsz\00F3nak legal\00E1bb egy nagybet\0171s karaktert kell tartalmaznia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537594400400242)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rtes\00EDt\00E9s a jelsz\00F3 vissza\00E1ll\00EDt\00E1s\00E1r\00F3l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524894706400233)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Lehet, hogy nem haszn\00E1lhat\00F3 a jelsz\00F3, mert haszn\00E1latban volt a legut\00F3bbi %0 napon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605120633400292)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'hu'
,p_message_text=>'Elemek'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112605274475400292)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'hu'
,p_message_text=>'Elem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582284719400275)
,p_name=>'PERCENT'
,p_message_language=>'hu'
,p_message_text=>unistr('Sz\00E1zal\00E9k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552535094400253)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'hu'
,p_message_text=>unistr('Forduljon a rendszergazd\00E1hoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112661959592400333)
,p_name=>'PREVIOUS'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151z\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597346792400286)
,p_name=>'PRINT'
,p_message_language=>'hu'
,p_message_text=>unistr('Nyomtat\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581074586400274)
,p_name=>'PRIVILEGES'
,p_message_language=>'hu'
,p_message_text=>unistr('Jogosults\00E1gok')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550969174400252)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9gi\00F3hivatkoz\00E1sok')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571186438400267)
,p_name=>'REPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580946006400274)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1si id\0151szak')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662177912400333)
,p_name=>'REPORT_LABEL'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581659208400274)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'hu'
,p_message_text=>unistr('Kimutat\00E1s \00F6sszesen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530845423400237)
,p_name=>'RESET'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldalt\00F6rdel\00E9s vissza\00E1ll\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556783263400256)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldalt\00F6rdel\00E9s vissza\00E1ll\00EDt\00E1sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585767563400277)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'hu'
,p_message_text=>unistr('Jelsz\00F3 vissza\00E1ll\00EDt\00E1sa')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562552414400261)
,p_name=>'RESTORE'
,p_message_language=>'hu'
,p_message_text=>unistr('Helyre\00E1ll\00EDt\00E1s')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112594413399400284)
,p_name=>'RESULTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Eredm\00E9nyek')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586889210400278)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Vissza az alkalmaz\00E1shoz.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112587181974400278)
,p_name=>'RIGHT'
,p_message_language=>'hu'
,p_message_text=>'Jobbra'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616715944400300)
,p_name=>'ROW'
,p_message_language=>'hu'
,p_message_text=>'%0. sor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570789582400266)
,p_name=>'ROW_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorok sz\00E1ma')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112586220782400278)
,p_name=>'SAVE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ment\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582886512400275)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1sodlagos alap\00E9rtelmez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583281616400275)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Le\00EDr\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582794394400275)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Els\0151dleges alap\00E9rtelmez\00E9s')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583534141400276)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6bb mint %0 sor \00E9rhet\0151 el. N\00F6velje a sorv\00E1laszt\00F3ban a megtekinthet\0151 sorok sz\00E1m\00E1t.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648995181400323)
,p_name=>'SEARCH'
,p_message_language=>'hu'
,p_message_text=>unistr('Keres\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544150139400247)
,p_name=>'SECONDS'
,p_message_language=>'hu'
,p_message_text=>unistr('m\00E1sodperc')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582330581400275)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'hu'
,p_message_text=>unistr('L\00E1sd a mell\00E9kletet')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640095718400317)
,p_name=>'SELECT_ROW'
,p_message_language=>'hu'
,p_message_text=>unistr('Sor kijel\00F6l\00E9se')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582093140400275)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00E9perny\0151olvas\00F3 m\00F3d KI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582137235400275)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00E9perny\0151olvas\00F3 m\00F3d BE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578403827400272)
,p_name=>'SHOW'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDt\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641879652400318)
,p_name=>'SHOW_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mind megjelen\00EDt\00E9se')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112667996940400337)
,p_name=>'SIGN_IN'
,p_message_language=>'hu'
,p_message_text=>unistr('Bejelentkez\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112617544892400301)
,p_name=>'SIGN_OUT'
,p_message_language=>'hu'
,p_message_text=>unistr('Kijelentkez\00E9s')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571765778400267)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nappal ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578932444400272)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 nap mostant\00F3l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571632683400267)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00F3r\00E1val ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578883586400272)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00F3ra mostant\00F3l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571529059400267)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 perccel ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578749695400272)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 perc mostant\00F3l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571996695400267)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 h\00F3nappal ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579115370400273)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 h\00F3nap mostant\00F3l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579393574400273)
,p_name=>'SINCE_NOW'
,p_message_language=>'hu'
,p_message_text=>'Most'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571480125400267)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 m\00E1sodperccel ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112578607298400272)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 m\00E1sodperc mostant\00F3l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112571892883400267)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 h\00E9ttel ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579012614400272)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 h\00E9t mostant\00F3l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112572079079400267)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00E9vvel ezel\0151tt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579206141400273)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00E9v mostant\00F3l')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565597538400263)
,p_name=>'STANDARD'
,p_message_language=>'hu'
,p_message_text=>unistr('Szok\00E1sos')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581967769400275)
,p_name=>'START_DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('Kezd\0151 d\00E1tum')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522421019400231)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'hu'
,p_message_text=>unistr('Ezt az e-mailt a(z) %0 \00E1ltal l\00E9trehozott interakt\00EDv feliratkoz\00E1s-kezel\0151 k\00FCldte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677186492400344)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'hu'
,p_message_text=>unistr('El\0151fizet\00E9sek')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625286181400306)
,p_name=>'TAB'
,p_message_language=>'hu'
,p_message_text=>'Lap'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544013498400247)
,p_name=>'TITLE'
,p_message_language=>'hu'
,p_message_text=>unistr('C\00EDm')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527026922400235)
,p_name=>'TODAY'
,p_message_language=>'hu'
,p_message_text=>'Ma'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581539166400274)
,p_name=>'TOTAL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszesen')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528053256400235)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'hu'
,p_message_text=>unistr('Legfeljebb %0 oszlopot v\00E1laszthat ki.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506592917400220)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('Mind becsuk\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506821729400220)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'hu'
,p_message_text=>unistr('Minden al\00E1bbi becsuk\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506407628400220)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes kibont\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506688414400220)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'hu'
,p_message_text=>unistr('Az al\00E1bbiak kibont\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506972937400220)
,p_name=>'TREE.REPARENT'
,p_message_language=>'hu'
,p_message_text=>unistr('F\00F6l\00E9rendel\00E9s m\00F3dos\00EDt\00E1sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599116822400287)
,p_name=>'TREES'
,p_message_language=>'hu'
,p_message_text=>unistr('Fastrukt\00FAr\00E1k')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112642606281400319)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('K\00F6telez\0151')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112566268785400263)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'hu'
,p_message_text=>'Jogosulatlan'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112613090139400297)
,p_name=>'UNAVAILABLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem \00E9rhet\0151 el')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579759758400273)
,p_name=>'UNKNOWN'
,p_message_language=>'hu'
,p_message_text=>'Ismeretlen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523394620400232)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Ismeretlen hiteles\00EDt\00E9si hiba t\00F6rt\00E9nt.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525309231400234)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'hu'
,p_message_text=>unistr('Ha a tov\00E1bbiakban nem szeretne e-maileket kapni, a leiratkoz\00E1shoz kattintson a <a href="%0">leiratkoz\00E1s</a> lehet\0151s\00E9gre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112522318636400231)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Ha a tov\00E1bbiakban nem szeretne e-maileket kapni, a leiratkoz\00E1shoz nyissa meg a k\00F6vetkez\0151 URL-c\00EDmet:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112557244383400257)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('nem t\00E1mogatott adatt\00EDpus')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545350788400248)
,p_name=>'UPDATE'
,p_message_language=>'hu'
,p_message_text=>unistr('m\00F3dos\00EDt\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543974218400247)
,p_name=>'UPDATED'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00F3dos\00EDtva')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550667560400252)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'hu'
,p_message_text=>unistr('A k\00E9rt URL-c\00EDm tiltott. L\00E9pjen kapcsolatba a rendszergazd\00E1val.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112570621990400266)
,p_name=>'USER'
,p_message_language=>'hu'
,p_message_text=>unistr('Felhaszn\00E1l\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112592256068400282)
,p_name=>'USERNAME'
,p_message_language=>'hu'
,p_message_text=>unistr('Felhaszn\00E1l\00F3n\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631812570400311)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'hu'
,p_message_text=>unistr('Az e-mail-c\00EDm t\00FAl hossz\00FA. A korl\00E1t %0 karakter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577494380400271)
,p_name=>'USERS'
,p_message_language=>'hu'
,p_message_text=>unistr('felhaszn\00E1l\00F3k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112631412725400311)
,p_name=>'USER_EXISTS'
,p_message_language=>'hu'
,p_message_text=>unistr('A felhaszn\00E1l\00F3n\00E9v m\00E1r l\00E9tezik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112646168929400321)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Profilk\00E9p %0 r\00E9sz\00E9re')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533784398400240)
,p_name=>'VALID'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nyes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527383364400235)
,p_name=>'VALIDATIONS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ellen\0151rz\00E9sek')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583070242400275)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00E9rt\00E9k megad\00E1sa k\00F6telez\0151')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626417358400307)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 r\00E9sz\00E9re az \00E9rt\00E9k megad\00E1sa k\00F6telez\0151.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552973527400254)
,p_name=>'VERTICAL'
,p_message_language=>'hu'
,p_message_text=>unistr('f\00FCgg\0151leges')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545269996400248)
,p_name=>'VIEW'
,p_message_language=>'hu'
,p_message_text=>unistr('n\00E9zet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577591468400271)
,p_name=>'VIEWS'
,p_message_language=>'hu'
,p_message_text=>unistr('n\00E9zetek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583853628400276)
,p_name=>'VIEW_ALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00D6sszes megtekint\00E9se')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112565077919400262)
,p_name=>'WARNING'
,p_message_language=>'hu'
,p_message_text=>unistr('Figyelmeztet\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544862406400248)
,p_name=>'WEEK'
,p_message_language=>'hu'
,p_message_text=>unistr('h\00E9t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541818047400245)
,p_name=>'WEEKLY'
,p_message_language=>'hu'
,p_message_text=>'Hetente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112544954831400248)
,p_name=>'WEEKS'
,p_message_language=>'hu'
,p_message_text=>unistr('h\00E9t')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112583147655400275)
,p_name=>'WELCOME_USER'
,p_message_language=>'hu'
,p_message_text=>unistr('\00DCdv\00F6z\00F6lj\00FCk: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581340119400274)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen \00E9rt\00E9k tal\00E1lhat\00F3, ellen\0151rizze a be\00EDrt adatot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581410482400274)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen \00E9rt\00E9k tal\00E1lhat\00F3, ellen\0151rizze a be\00EDrt adatot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524436453400233)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen d\00E1tum\00E9rt\00E9k tal\00E1lhat\00F3, ellen\0151rizze a d\00E1tum form\00E1tum\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112581227911400274)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen sz\00E1m\00E9rt\00E9k tal\00E1lhat\00F3, ellen\0151rizze a sz\00E1m form\00E1tum\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533364912400239)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen id\0151b\00E9lyeg\00E9rt\00E9k tal\00E1lhat\00F3, ellen\0151rizze az id\0151b\00E9lyeg form\00E1tum\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112555807750400256)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" nem rendelhet\0151 hozz\00E1. T\00F6bb-b\00E1jtos t\00E9telekn\00E9l haszn\00E1ljon kett\0151s id\00E9z\0151jelet, vagy ellen\0151rizze, hogy az elem hossza 30 vagy kevesebb b\00E1jt. A 30 b\00E1jtn\00E1l hosszabb elemekre hivatkoz\00E1shoz haszn\00E1lja a v() szintaxist.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546346471400249)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'hu'
,p_message_text=>unistr('Hozz\00E1f\00E9r\00E9s megtagadva %0 biztons\00E1gi ellen\0151rz\00E9s \00E1ltal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548872638400250)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alkalmaz\00E1s nem \00E9rhet\0151 el')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547205654400249)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1014 Az alkalmaz\00E1s nem tal\00E1lhat\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547353433400249)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('alkalmaz\00E1s=%0 munkater\00FClet=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547764593400250)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez az alkalmaz\00E1s korl\00E1tozott el\00E9r\00E9s\0171, pr\00F3b\00E1lja meg k\00E9s\0151bb.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547635251400250)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'hu'
,p_message_text=>unistr('Ennek az alkalmaz\00E1snak az el\00E9r\00E9se az alkalmaz\00E1sfejleszt\0151kre korl\00E1tozott, pr\00F3b\00E1lja meg k\00E9s\0151bb.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546806237400249)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-7744 Nem lehet feldolgozni az el\00E1gaztat\00E1si f\00FCggv\00E9ny \00E1ltal visszat\00E9r\00EDtett URL-c\00EDmet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546704791400249)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-7744 Nem lehet feldolgozni az el\00E1gaztat\00E1si f\00FCggv\00E9ny \00E1ltal visszat\00E9r\00EDtett oldalt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547092609400249)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1430 Nem t\00E1mogatott a kezd\0151oldal megjelen\00EDt\00E9s\00E9re vonatkoz\00F3 elj\00E1r\00E1s h\00EDv\00E1sa: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548137905400250)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1018 Hiba a l\00E9p\00E9s gyors\00EDt\00F3t\00E1r\00E1nak ki\00FCr\00EDt\00E9sekor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546599936400249)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1005 Ismeretlen sz\00E1m\00EDt\00E1si t\00EDpus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547477295400249)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1201 Nem lett be\00E1ll\00EDtva munkamenet-azonos\00EDt\00F3 az egy\00E9ni hiteles\00EDt\00E9skor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547561170400250)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'hu'
,p_message_text=>'oldal=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112547160334400249)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-7620 Nem hat\00E1rozhat\00F3 meg az alkalmaz\00E1s (%0) munkater\00FClete.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529537602400236)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'hu'
,p_message_text=>unistr('Szerkeszt\00E9s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546285394400249)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1802 Nem tal\00E1lhat\00F3 a(z) "%0" elem azonos\00EDt\00F3ja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545963581400248)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1002 Nem tal\00E1lhat\00F3 a(z) "%0" elem elemazonos\00EDt\00F3ja a(z) "%1" alkalmaz\00E1sban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546059417400248)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem v\00E1rt hiba, alkalmaz\00E1s vagy oldal szintj\00E9n nem lehet megtal\00E1lni az elem nev\00E9t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546464142400249)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('M\00E1r az adatok els\0151 oldal\00E1n\00E1l tart.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112561972948400260)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Az elemazonos\00EDt\00F3 (%0) nincs defini\00E1lva az aktu\00E1lis oldalon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524098358400233)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'hu'
,p_message_text=>unistr('Lehet, hogy az elem nem lett be\00E1ll\00EDtva az argumentumoknak az alkalmaz\00E1shoz tov\00E1bb\00EDt\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524380899400233)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'hu'
,p_message_text=>unistr('(Nincs megadva az ellen\0151rz\0151 \00F6sszeg)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523858039400232)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'hu'
,p_message_text=>unistr('Az elem akkor \00E1ll\00EDthat\00F3 be, ha tartozik hozz\00E1 egy "felhaszn\00E1l\00F3 szint\0171 k\00F6nyvjelz\0151" funkci\00F3j\00FA ellen\0151rz\0151 \00F6sszeg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523746593400232)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'hu'
,p_message_text=>unistr('Az elem akkor \00E1ll\00EDthat\00F3 be, ha tartozik hozz\00E1 egy "alkalmaz\00E1s szint\0171 k\00F6nyvjelz\0151" funkci\00F3j\00FA ellen\0151rz\0151 \00F6sszeg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523916284400232)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('Az elem akkor \00E1ll\00EDthat\00F3 be, ha azt "munkamenet" ellen\0151rz\0151 \00F6sszeg k\00EDs\00E9ri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523620893400232)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez az elem nem v\00E9dett.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548235558400250)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs oldal szint\0171 s\00FAg\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112537392909400242)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 munkater\00FCletnek nincs el\00E9g jogosults\00E1ga, hogy %1 s\00E9mak\00E9nt elemezzen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546608468400249)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1010 Az "El\00E1gaztat\00E1s oldalra" t\00EDpusn\00E1l a feldolgoz\00E1si ism\00E9tl\00E9sek fogad\00E1s\00E1nak sz\00E1ma t\00FAll\00E9pte a korl\00E1tot. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524246085400233)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez az oldal nem h\00EDvhat\00F3 meg URL-c\00EDmmel, illetve GET vagy POST utas\00EDt\00E1ssal a megjelen\00EDt\00E9si elj\00E1r\00E1shoz, mert az csak az "El\00E1gaztat\00E1s oldalra" \00E1gt\00EDpus haszn\00E1lat\00E1val h\00EDvhat\00F3 meg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112600933867400289)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba t\00F6rt\00E9nt a nem sz\00E1m\00E9rt\00E9k %0 elembe val\00F3 ment\00E9s\00E9nek megk\00EDs\00E9rl\00E9sekor. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539002848400243)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" alkalmaz\00E1s-elemz\00E9si s\00E9ma nem l\00E9tezik az adatb\00E1zisban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112539151986400244)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'hu'
,p_message_text=>unistr('Az INTERNAL munkater\00FCleten l\00E9v\0151 fi\00F3kok csak a(z) &PRODUCT_NAME. term\00E9k el\00E9r\00E9s\00E9hez haszn\00E1lhat\00F3k. <a href="%0">Adminisztr\00E1ci\00F3s szolg\00E1ltat\00E1sok</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545885693400248)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-1029 Nem lehet t\00E1rolni a munkameneti inform\00E1ci\00F3t. munkamenet=%0 elem=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548981902400251)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 nyomk\00F6vet\00E9s nem \00E1ll\00EDthat\00F3 le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112546178214400249)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('V\00E1ratlan hiba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556188160400256)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az update_substitution_cache gyors\00EDt\00F3t\00E1rban: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549011288400251)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A s\00FAg\00F3 megjelen\00EDt\00E9s\00E9hez meg kell adni az alkalmaz\00E1st \00E9s az oldalt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112569516325400266)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 automatiz\00E1l\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550180731400251)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 munkamenet t\00F6r\00F6lve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509486537400222)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem hajthat\00F3 v\00E9gre a(z) %0 programk\00F3d! Nem t\00E1mogatja az adatb\00E1zis, vagy nem enged\00E9lyezi a p\00E9ld\00E1ny MLE_LANGUAGES param\00E9tere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112509282677400221)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'hu'
,p_message_text=>unistr('Enn\00E9l az adatb\00E1zis-verzi\00F3n\00E1l nem t\00E1mogatott a nyelveket kezel\0151 vez\00E9rl\0151 (MLE)!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530041390400237)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alkalmaz\00E1sgy\0171jtem\00E9ny t\00F6mbje nem lehet null \00E9rt\00E9k\0171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529856582400237)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'hu'
,p_message_text=>unistr('A megadott %0 tagattrib\00FAtumi sz\00E1m \00E9rv\00E9nytelen. Az attrib\00FAtumsz\00E1m csak 1 \00E9s %1 k\00F6z\00F6tti lehet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530387840400237)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alkalmaz\00E1sgy\0171jtem\00E9ny m\00E1r l\00E9tezik')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530158587400237)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('A gy\0171jtem\00E9ny neve nem lehet null \00E9rt\00E9k\0171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530206594400237)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'hu'
,p_message_text=>unistr('A gy\0171jtem\00E9ny neve nem lehet 255 karaktern\00E9l hosszabb')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529693041400237)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 alkalmaz\00E1sgy\0171jtem\00E9ny nem l\00E9tezik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530459092400237)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'hu'
,p_message_text=>unistr('A kurzor m\00E9g nincs megnyitva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529707108400237)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A(z) %0 tagsorrend nem l\00E9tezik a(z) %1 alkalmaz\00E1sgy\0171jtem\00E9nyben'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112529971342400237)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 tagsorrend nem l\00E9tezik a(z) "%1" alkalmaz\00E1sgy\0171jtem\00E9nyben')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601710651400289)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Ezen a rendszeren nem t\00E1mogatott a(z) "%0" titkos\00EDt\00E1si f\00FCggv\00E9ny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655250212400328)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'hu'
,p_message_text=>unistr('El\00E9rhet\0151s\00E9g tesztelve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549652201400251)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'hu'
,p_message_text=>unistr('Bez\00E1r\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549727441400251)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'hu'
,p_message_text=>unistr('Oldal testreszab\00E1si be\00E1ll\00EDt\00E1sai')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549845559400251)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'hu'
,p_message_text=>unistr('Alap\00E9rtelmezett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549948461400251)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00EDtett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550065798400251)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'hu'
,p_message_text=>'Rejtett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549447000400251)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'hu'
,p_message_text=>unistr('Jel\00F6lje be az ehhez az oldalhoz hozz\00E1adand\00F3 r\00E9gi\00F3kat. A bejel\00F6lt oldalak nem jelennek meg, ha \00D6n nem a megfelel\0151 alkalmaz\00E1si k\00F6rnyezetben van, vagy \00D6nnek nincs megfelel\0151 jogosults\00E1ga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549563357400251)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez az oldal nem testre szabhat\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655535508400328)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'hu'
,p_message_text=>unistr('A t\00E9ma st\00EDlus\00E1nak megv\00E1ltoztat\00E1s\00E1val szem\00E9lyess\00E9 teheti ennek az alkalmaz\00E1snak a megjelen\00E9s\00E9t. Az al\00E1bbi list\00E1ban v\00E1lassza a T\00E9ma st\00EDlusa elemet, \00E9s kattintson a V\00E1ltoztat\00E1sok alkalmaz\00E1sa elemre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112656342570400329)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'hu'
,p_message_text=>unistr('R\00E9gi\00F3 megjelen\00EDt\00E9se')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655429303400328)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Az alkalmaz\00E1s alap\00E9rtelmezett st\00EDlus\00E1nak haszn\00E1lata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112655363308400328)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Megjelen\00E9s ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598359842400287)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 \00F6sszes\00EDt\00E9sben hivatkozott oszlopindex.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112501652026400216)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 form\00E1tum eset\00E9n a CLOB kimeneti form\00E1tum nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598087324400286)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'hu'
,p_message_text=>unistr('Az oszlopt\00F6r\00E9snek az oszlopt\00F6mb\00F6k ter\00FClet\00E9nek elej\00E9n kell lenni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598115844400287)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 \00E1ltal hivatkozott oszlopcsoportos\00EDt\00E1si index.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112515616316400226)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'hu'
,p_message_text=>unistr('export\00E1l\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112520834146400230)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'hu'
,p_message_text=>unistr('Az export\00E1l\00E1s form\00E1tuma csak olyan XML lehet, amelyik megfelel az ORDS nyomtat\00F3kiszolg\00E1l\00F3 form\00E1tum\00E1nak.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598400537400287)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 kiemel\00E9sben hivatkozott oszlopindex.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514146160400225)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen export\00E1l\00E1si form\00E1tum: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112598278384400287)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tezik a(z) %0 \00E1ltal hivatkozott f\00F6l\00E9rendelt csoport indexe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112623438197400305)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 t\00E1bl\00E1zat %1 oszlopa "GENERATED ALWAYS" azonos\00EDt\00E1s\00FA oszlop. Ellen\0151rizze, hogy nincs-e lek\00E9pezve oszlop a Konfigur\00E1l\00E1s p\00E1rbesz\00E9dpanelen a(z) %1 oszlop r\00E9sz\00E9re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540883721400245)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00FAl kev\00E9s a megadott v\00E9grehajt\00E1si id\0151k\00F6z.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112540994997400245)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatbet\00F6lt\00E9shez nem lett oszlop megadva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542189202400246)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 oszlop a(z) "%0" sorv\00E1laszt\00F3hoz. Pr\00F3b\00E1lkozzon az automatikus felismer\00E9ssel, vagy ellen\0151rizze a JSON strukt\00FAr\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550440942400252)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nincs munkalap az XLSX f\00E1jlban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550364182400252)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'hu'
,p_message_text=>unistr('A megadott munkalap nincs az XLSX f\00E1jlban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112530550338400237)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az adatb\00E1zisban megv\00E1ltozott az adatok aktu\00E1lis verzi\00F3ja, ami\00F3ta valamelyik felhaszn\00E1l\00F3 friss\00EDt\00E9si elj\00E1r\00E1st kezdem\00E9nyezett.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532944961400239)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba t\00F6rt\00E9n a kimutat\00E1s %0 oszlopainak m\00F3dos\00EDt\00E1sakor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637622997400315)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 nem alak\00EDthat\00F3 \00E1t SDO_GEOMETRY \00E9rt\00E9kk\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577176651400271)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %1 adatt\00EDpus\00FA %0 oszlop nem alak\00EDthat\00F3 \00E1t VARCHAR2 t\00EDpuss\00E1!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584107567400276)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%1" attrib\00FAtumhoz megadott "%0" oszlop nem tal\00E1lhat\00F3 az adatforr\00E1sban!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525407044400234)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6bb\00E9rt\00E9kes oszlopokhoz a(z) %0 sz\0171r\0151t\00EDpus nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112641079003400317)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen a "k\00F6z\00F6tt" sz\0171r\0151.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507521235400220)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen a megadott \00E9rt\00E9klista t\00EDpusa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507445624400220)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen lek\00E9rdez\00E9st\00EDpus. A lek\00E9rdez\00E9st\00EDpus csak T\00E1bla, SQL-lek\00E9rdez\00E9s \00E9s SQL-lek\00E9rdez\00E9st visszat\00E9r\00EDt\0151 PL/SQL f\00FCggv\00E9ny lehet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577238839400271)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nem siker\00FClt elemezni az SQL-lek\00E9rdez\00E9st!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584215278400276)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%1" attrib\00FAtumhoz megadott %0 oszloppoz\00EDci\00F3 nem tal\00E1lhat\00F3 az SQL utas\00EDt\00E1sban!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112506000059400219)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00FAl sok t\00E9tel van a t\00F6bb\00E9rt\00E9kes sz\0171r\0151ben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584013533400276)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" attrib\00FAtumhoz nem adtak meg \00E9rt\00E9ket.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507303507400220)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A PL/SQL f\00FCggv\00E9nyt\00F6rzse nem ad vissza \00E9rt\00E9ket.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112597249815400286)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'hu'
,p_message_text=>unistr('A REST adatforr\00E1s nem tartalmaz M\0171veletet a k\00E9rt DML m\0171velet kezel\00E9s\00E9hez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112503246231400217)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ebben az adatb\00E1zisban nem \00E9rhet\0151 el a GeoJSON form\00E1tumr\00F3l az SDO_GEOMETRY (oszlop: %0) form\00E1tum\00E1ra val\00F3 \00E1talak\00EDt\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504343966400218)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'hu'
,p_message_text=>unistr('XML adatforr\00E1sokban nem t\00E1mogatott az SDO_GEOMETRY (oszlop: %0) \00E1talak\00EDt\00E1sa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112511645977400223)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00F6bb \00E9rt\00E9k k\00F6z\00F6tti tagol\00F3k\00E9nt a(z) %0 karakter nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112638951467400316)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez a f\00FCggv\00E9ny nem haszn\00E1lhat\00F3 lek\00E9rdez\00E9si k\00F6rnyezetben.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112504444254400218)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem egyez\0151 adatt\00EDpus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507291425400220)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00FAll\00E9pte a bels\0151 ORDS OUT k\00F6t\00E9si korl\00E1tj\00E1t. Cs\00F6kkentse a DML sorok mennyis\00E9g\00E9t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112585009588400277)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nem lehetett elemezni a t\00E1voli kiszolg\00E1l\00F3t\00F3l kapott JSON v\00E1laszt: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112507106348400220)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Ismeretlen vagy rossz a k\00F6rnyezet t\00EDpusa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112601698028400289)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Ezt a f\00E1jlt\00EDpust az elemz\0151 nem t\00E1mogatja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556249192400256)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Jogosulatlan hozz\00E1f\00E9r\00E9s (a wwv_flow_api.set_credentials nincs be\00E1ll\00EDtva).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533265736400239)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'hu'
,p_message_text=>unistr('A munkater\00FClet nem lett l\00E9trehozva, mert m\00E1r l\00E9tezik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112533185941400239)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'hu'
,p_message_text=>unistr('A felhaszn\00E1l\00F3i csoport nem lett l\00E9trehozva, mert m\00E1r l\00E9tezik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543409494400247)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'hu'
,p_message_text=>unistr('Ism\00E9tl\0151d\0151 felhaszn\00E1l\00F3n\00E9v tal\00E1lhat\00F3 ehhez: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543513097400247)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a felhaszn\00E1l\00F3k bet\00F6lt\00E9sekor. Nem siker\00FClt a(z) %0 felhaszn\00E1l\00F3n\00E1l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553420481400254)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 felhaszn\00E1l\00F3t kellett volna bet\00F6lteni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553220207400254)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'hu'
,p_message_text=>unistr('Jelsz\00F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553333128400254)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'hu'
,p_message_text=>unistr('Jogosults\00E1gok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553094873400254)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'hu'
,p_message_text=>unistr('Felhaszn\00E1l\00F3n\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629522156400309)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a(z) #COMPONENT_NAME# oldalelem megjelen\00EDt\00E9sekor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549168369400251)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem jelen\00EDthet\0151 meg az oldal, mert m\00E9g nem lett megnyitva a HTML \0171rlap.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112514463821400225)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a(z) #COMPONENT_NAME# oldalelem\00E9hez val\00F3 elem alap\00E9rtelmezett \00E9rt\00E9k\00E9nek kisz\00E1m\00EDt\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548458332400250)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a(z) #COMPONENT_NAME# oldalelem\00E9hez val\00F3 elem ut\00F3sz\00E1m\00EDt\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548372418400250)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a(z) #COMPONENT_NAME# oldalelem\00E9hez val\00F3 elem forr\00E1s\00E9rt\00E9k\00E9nek kisz\00E1m\00EDt\00E1sakor.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528160055400235)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'hu'
,p_message_text=>unistr('Jogosulatlan hozz\00E1f\00E9r\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548614857400250)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'hu'
,p_message_text=>unistr('A JavaScript nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548793955400250)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'hu'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112549355819400251)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lehet lek\00E9rdez\00E9st inicializ\00E1lni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556519593400256)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0m\00F3dos\00EDt\00E1sa nem t\00E1mogatott.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112550720439400252)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen elemazonos\00EDt\00F3 : %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112577007301400271)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Ehhez az elemhez nincs s\00FAg\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541510454400245)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem siker\00FClt a diagram lek\00E9rdez\00E9s\00E9nek el\0151\00E1ll\00EDt\00E1sa. Ellen\0151rizze a forr\00E1s \00E9s az oszlop lek\00E9pez\00E9si be\00E1ll\00EDt\00E1sait.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636339393400314)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 MB m\00E9ret\0171 mell\00E9klet t\00FAll\00E9pte a mell\00E9kletre megengedett %1 MB m\00E9retkorl\00E1tot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542485900400246)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen \00E9rt\00E9k a p_mail_id param\00E9tern\00E9l: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112659879310400331)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'hu'
,p_message_text=>unistr('Meghaladta a munkater\00FCletenk\00E9nti e-mail-\00FCzenetek maxim\00E1lis sz\00E1m\00E1t. Forduljon a rendszergazd\00E1hoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523423768400232)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'hu'
,p_message_text=>unistr('Ezt az elj\00E1r\00E1st csak egy alkalmaz\00E1si munkamenetb\0151l lehet megh\00EDvni.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542391655400246)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 param\00E9tern\00E9l null \00E9rt\00E9k van megadva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596360832400285)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" e-mail-sablon nem tal\00E1lhat\00F3 a(z) %1 alkalmaz\00E1sban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112672814905400341)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az SMTP_HOST_ADDRESS p\00E9ld\00E1ny param\00E9ter\00E9t be kell \00E1ll\00EDtani elektronikus levelek k\00FCld\00E9s\00E9re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542019276400246)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az e-mail elk\00FCld\00E9s\00E9hez meg kell adni az \00FCzenet c\00EDmzettj\00E9t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112662251951400333)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem l\00E9tes\00EDthet\0151 SMTP kapcsolat a konfigur\00E1lt levelez\00E9si kiszolg\00E1l\00F3val.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112636437657400314)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen Ajax h\00EDv\00E1s!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527883160400235)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lett defini\00E1lva Ajax f\00FCggv\00E9ny a(z) %0 be\00E9p\00FCl\0151 modulhoz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626821655400307)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 be\00E9p\00FCl\0151 modul r\00E9sz\00E9re nem nem lett defini\00E1lva v\00E9grehajt\00E1si f\00FCggv\00E9ny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527945520400235)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem lett defini\00E1lva megjelen\00EDt\00E9si f\00FCggv\00E9ny a(z) %0 be\00E9p\00FCl\0151 modulhoz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637332869400315)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A REST adatforr\00E1si "%0" be\00E9p\00FCl\0151 modul nem tartalmaz "Capabilities" f\00FCggv\00E9nyt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637253647400315)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A REST adatforr\00E1si "%0" be\00E9p\00FCl\0151 modul nem tartalmaz DML f\00FCggv\00E9nyt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637400779400315)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A REST adatforr\00E1si "%0" be\00E9p\00FCl\0151 modul nem tartalmaz v\00E9grehajt\00E1si f\00FCggv\00E9nyt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112637579252400315)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'hu'
,p_message_text=>unistr('A REST adatforr\00E1si "%0" be\00E9p\00FCl\0151 modul nem tartalmaz gyors beolvas\00F3 f\00FCggv\00E9nyt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525649459400234)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('A PLSQL k\00F3dban hiba jelentkezett a be\00E9p\00FCl\0151 modul feldolgoz\00E1sakor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532250956400239)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00E9rt\00E9k megad\00E1sa k\00F6telez\0151.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562879097400261)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) %0 adatt\00EDpus nem alak\00EDthat\00F3 \00E1t VARCHAR2 t\00EDpus\00FAra!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648421032400323)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%1" attrib\00FAtumhoz megadott "%0" oszlop nem tal\00E1lhat\00F3 az SQL-utas\00EDt\00E1sban!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624733790400306)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00E9rt\00E9klista (LOV) lek\00E9rdez\00E9s\00E9t vagy az \00E9rt\00E9kek Megnevezett list\00E1j\00E1t meg kell adni %0 r\00E9sz\00E9re.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112626389789400307)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 \00E9rt\00E9klist\00E1j\00E1nak SQL-lek\00E9rdez\00E9s\00E9ben az oszlopok rossz sz\00E1ma lett kiv\00E1lasztva. N\00E9zze meg a p\00E9ld\00E1ban, hogy melyek az \00E9rv\00E9nyes SQL-utas\00EDt\00E1sok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648298433400323)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%0" attrib\00FAtumhoz nem adtak meg oszlopot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677959145400345)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%1" attrib\00FAtum r\00E9sz\00E9re be\00EDrt %0 \00E9rt\00E9k nem sz\00E1m.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112629883721400309)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('Az SQL utas\00EDt\00E1sban rossz a(z) %0 adatt\00EDpusa. A(z) %1 oszlopsz\00E1ma %2, pedig a v\00E1rt %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112648320963400323)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'hu'
,p_message_text=>unistr('A(z) "%1" attrib\00FAtumhoz megadott "%0" oszlopnak %2 adatt\00EDpusa van, pedig %3 kellene.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112524902255400233)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem tal\00E1lhat\00F3 a kimutat\00E1s elrendez\00E9se.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584902948400277)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00D6sszesen (Sum) \00E9rt\00E9k\00E9t sz\00E1m\00EDt\00F3 funkci\00F3 nem haszn\00E1lhat\00F3 olyan kimutat\00E1sokhoz, amelyek alapja REST adatforr\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112548594264400250)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('ERR-2904 Nem \00E1ll\00EDthat\00F3 be a billenty\0171parancs \00E9rt\00E9ke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112552805743400253)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba: Ismeretlen billenty\0171parancs-t\00EDpus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112542852945400246)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem olvashat\00F3 be a hiteles\00EDt\00E9si s\00E9ma a(z) %0 alkalmaz\00E1sban.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112616377159400300)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'hu'
,p_message_text=>unistr('Az aktu\00E1lis munkamenethez m\00E1r l\00E9tezik a b\00E9rl\0151azonos\00EDt\00F3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112553117141400254)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'hu'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677328304400344)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'hu'
,p_message_text=>unistr('A hiteles\00EDt\00E9s sikertelen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112579697501400273)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'hu'
,p_message_text=>unistr('Az apex_util.g_request_cookies be\00E1ll\00EDt\00E1s\00E1ban egy vagy t\00F6bb cookie \00E9rv\00E9nytelen \00E9rt\00E9ket tartalmaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112562117501400260)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'hu'
,p_message_text=>unistr('\00C9rv\00E9nytelen volt az UDDI regiszter v\00E1lasza.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112525753828400234)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'hu'
,p_message_text=>unistr('A megadott URL-c\00EDm nem adott vissza \00E9rv\00E9nyes WSDL dokumentumot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112528237253400236)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'hu'
,p_message_text=>unistr('A WSDL dokumentum t\00F6bb SOAP k\00F6t\00E9st tartalmaz. A(z) &PRODUCT_NAME. csak az egy SOAP k\00F6t\00E9s\0171 WSDL dokumentumokat t\00E1mogatja. Kattintson a Webszolg\00E1ltat\00E1s-referencia manu\00E1lis l\00E9trehoz\00E1sa lehet\0151s\00E9gre, hogy folytassa a szolg\00E1ltat\00E1s hivatkoz\00E1sainak l\00E9trehoz\00E1')
||unistr('s\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112596617667400285)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'hu'
,p_message_text=>unistr('A szolg\00E1ltat\00E1st\00F3l \00E9rkezett v\00E1lasz nem XML volt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677265519400344)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'hu'
,p_message_text=>unistr('Az OAuth hozz\00E1f\00E9r\00E9si token nem \00E9rhet\0151 el vagy lej\00E1rt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112640474467400317)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'hu'
,p_message_text=>unistr('Meghaladta a munkater\00FCletenk\00E9nti webszolg\00E1ltat\00E1si lek\00E9r\00E9sek maxim\00E1lis sz\00E1m\00E1t. Forduljon a rendszergazd\00E1hoz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112677491990400344)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'hu'
,p_message_text=>unistr('A kiszolg\00E1l\00F3 nem t\00E1mogatott OAuth token t\00EDpussal v\00E1laszolt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527611158400235)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'hu'
,p_message_text=>unistr('A WSDL dokumentum nem tartalmaz k\00F6t\00E9st ahhoz a SOAP dokumentumhoz, amely a hivatkoz\00E1s hozz\00E1ad\00E1s\00E1hoz sz\00FCks\00E9ges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112523582145400232)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'hu'
,p_message_text=>unistr('E WSDL el\00E9r\00E9s\00E9hez hiteles\00EDt\00E9si jogosults\00E1g sz\00FCks\00E9ges. Adja meg al\00E1bb a felhaszn\00E1l\00F3nevet \00E9s a jelsz\00F3t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112532301954400239)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'hu'
,p_message_text=>unistr('A megjelen\00EDt\00E9si vez\00E9rl\0151program nem tudta \00E9rtelmezni a WSDL dokumentumot. Kattintson a Webszolg\00E1ltat\00E1s-referencia manu\00E1lis l\00E9trehoz\00E1sa lehet\0151s\00E9gre, hogy folytassa a szolg\00E1ltat\00E1s hivatkoz\00E1s\00E1nak l\00E9trehoz\00E1s\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112599295535400287)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'hu'
,p_message_text=>unistr('Nem hajhat\00F3 v\00E9gre a friss\00EDt\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112625027944400306)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00E9rt\00E9klist\00E1nak ugyanaz a visszat\00E9r\00E9si \00E9s a megjelen\00EDt\00E9si oszlopa!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112624970843400306)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Az \00E9rt\00E9klista nem rendelkezik visszat\00E9r\00E9si oszloppal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556492939400256)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az oszlop\00E9rt\00E9k beolvas\00E1sakor: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580466957400273)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'hu'
,p_message_text=>unistr('T\00FAl r\00E9giek ezek a t\00E1bl\00E1zatos adatok; a forr\00E1sadatok m\00F3dos\00EDtva lettek.<br/> Kattintson <strong><a href="%0">ide</a></strong>, hogy elvesse a m\00F3dos\00EDt\00E1sokat, \00E9s t\00F6ltse be \00FAjb\00F3l az adatokat az adatb\00E1zisb\00F3l.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538553433400243)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba az oldalt\00F6rdel\00E9si karakterl\00E1nc \00E9rtelmez\00E9sekor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538421688400243)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('nem \00E1llap\00EDthat\00F3k meg a lek\00E9rdez\00E9s fejl\00E9cei:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538623430400243)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'hu'
,p_message_text=>unistr('hiba a kimutat\00E1s l\00E1bl\00E9c\00E9nek lecser\00E9l\00E9sekor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538749210400243)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('nem siker\00FClt elemezni az SQL-lek\00E9rdez\00E9st:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543779071400247)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'hu'
,p_message_text=>unistr('Legal\00E1bb %0 sor lek\00E9rve, a tal\00E1lt, de nem megjelen\00EDtett sorok: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541235427400245)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9rv\00E9nytelen a lek\00E9rdez\00E9s #%0 (%1) oszlopa, haszn\00E1ljon m\00E1sodlagos nevet a HTML-t haszn\00E1l\00F3 oszlopokhoz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112556344208400256)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'hu'
,p_message_text=>unistr('Hiba a lek\00E9rdez\00E9s fejl\00E9ceinek beolvas\00E1sakor: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538866976400243)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kimutat\00E1si hiba:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112576517088400271)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'hu'
,p_message_text=>unistr('Sorok rendez\00E9se ezen oszlop alapj\00E1n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541329860400245)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'hu'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nem elemezhet\0151 a lek\00E9rdez\00E9s, ellen\0151rizze a lek\00E9rdez\00E9s szintaktikai helyess\00E9g\00E9t.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580506993400274)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'hu'
,p_message_text=>unistr('Ez a formalap nem mentett m\00F3dos\00EDt\00E1sokat tartalmaz. Nyomja meg az "OK" gombot, hogy folytassa a v\00E1ltoz\00E1sok ment\00E9se n\00E9lk\00FCl. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112584899897400277)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'hu'
,p_message_text=>unistr('A v\00E1lasztott adatforr\00E1ssal nem t\00E1mogatott a kimutat\00E1s oldalakra bont\00E1sa (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112541118575400245)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9rv\00E9nytelen a lek\00E9rdez\00E9s #%0 (%1) oszlopa, haszn\00E1ljon m\00E1sodlagos oszlopnevet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543871789400247)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 - %1 sor / \00F6sszesen t\00F6bb, mint %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112582569613400275)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 - %1 / t\00F6bb, mint %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112543660535400247)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'hu'
,p_message_text=>unistr('%0 - %1 sor / \00F6sszesen %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112527575425400235)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'hu'
,p_message_text=>'%0 - %1 / %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538949392400243)
,p_name=>'Y'
,p_message_language=>'hu'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112545089332400248)
,p_name=>'YEAR'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112538147787400243)
,p_name=>'YEARS'
,p_message_language=>'hu'
,p_message_text=>unistr('\00E9v')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112580612212400274)
,p_name=>'YES'
,p_message_language=>'hu'
,p_message_text=>'Igen'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4482)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4482)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Asztal'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4482
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4482)
,p_name=>unistr('\00DCzenetek')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\00DCzenetek')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
